package it.asterisk.fastagi.internal;

import it.asterisk.fastagi.AgiChannel;
import it.asterisk.fastagi.AgiChannelFactory;
import it.asterisk.fastagi.AgiReader;
import it.asterisk.fastagi.AgiRequest;
import it.asterisk.fastagi.AgiWriter;

/**
 * If no other factory  is passed to DefaultAgiServer's constructor,
 * an instance of this one will be used. The DefaultAgiChannelFactory
 * creates AgiChannelImpl instances, that are passed to the agi scripts.
 */
public class DefaultAgiChannelFactory implements AgiChannelFactory
{
    @Override
    public AgiChannel createAgiChannel(AgiRequest request, AgiWriter agiWriter, AgiReader agiReader)
    {
        return new AgiChannelImpl(request, agiWriter, agiReader);
    }
}
