package it.asterisk.pbx.agi;

import java.util.concurrent.CountDownLatch;

import it.asterisk.fastagi.AgiChannel;
import it.asterisk.fastagi.AgiException;
import it.asterisk.fastagi.AgiHangupException;
import it.asterisk.pbx.AgiChannelActivityAction;
import it.asterisk.pbx.Channel;
import it.callite.log.AsteriskLog;

public class AgiChannelActivityBridge implements AgiChannelActivityAction
{

    private Channel target;

    CountDownLatch latch = new CountDownLatch(1);

    public AgiChannelActivityBridge(Channel target)
    {
        this.target = target;
    }

    @Override
    public void execute(AgiChannel channel, Channel ichannel) throws AgiException, InterruptedException
    {
        try
        {
            // TODO: this should probably pass the 'F' option to allow the
            // bridgee
            // to go back to dialplan.
            // I'm not currently prepared to do it as it is called from a number
            // of places, and
            // I can't currently see it causing problems.
            channel.bridge(target.getChannelName(), "");
            channel.hangup();
        }
        catch (AgiHangupException e)
        {
            AsteriskLog.warn(e);
        }
        finally
        {
            latch.countDown();
        }
    }

    @Override
    public boolean isDisconnect(ActivityAgi activityAgi)
    {
        return false;
    }

    @Override
    public void cancel()
    {
        latch.countDown();

    }
    // Logger logger = LogManager.getLogger();

    public void sleepWhileBridged() throws InterruptedException
    {
        latch.await();

    }
}
