package it.asterisk.pbx.agi;

import java.util.concurrent.CountDownLatch;

import it.asterisk.fastagi.AgiChannel;
import it.asterisk.fastagi.AgiException;
import it.asterisk.fastagi.AgiHangupException;
import it.asterisk.pbx.AgiChannelActivityAction;
import it.asterisk.pbx.Channel;
import it.callite.log.AsteriskLog;

public class AgiChannelActivityHangup implements AgiChannelActivityAction
{

    CountDownLatch latch = new CountDownLatch(1);

    @Override
    public void execute(AgiChannel channel, Channel ichannel) throws AgiException, InterruptedException
    {
        try
        {

            channel.hangup();
            AsteriskLog.info("Hungup");
        }
        catch (AgiHangupException e)
        {
            // don't care
        }

    }

    @Override
    public boolean isDisconnect(ActivityAgi activityAgi)
    {
        return false;
    }

    @Override
    public void cancel()
    {
        latch.countDown();

    }
}
