package it.asterisk.pbx.agi;

import it.asterisk.fastagi.AgiChannel;
import it.asterisk.fastagi.AgiException;
import it.asterisk.fastagi.AgiHangupException;
import it.asterisk.pbx.AgiChannelActivityAction;
import it.asterisk.pbx.Channel;
import it.callite.log.AsteriskLog;

public class AgiChannelActivityHoldForBridge implements AgiChannelActivityAction
{
    private AgiChannelActivityBridge bridgeActivity;
    private volatile boolean hangup = true;

    public AgiChannelActivityHoldForBridge(AgiChannelActivityBridge bridgeActivity)
    {
        this.bridgeActivity = bridgeActivity;
    }

    @Override
    public void execute(AgiChannel channel, Channel ichannel) throws AgiException, InterruptedException
    {
        try
        {
            channel.playMusicOnHold();
            bridgeActivity.sleepWhileBridged();

            if (hangup)
            {
                channel.hangup();
            }
        }
        catch (AgiHangupException e)
        {
            AsteriskLog.warn(e.getMessage() + " " + channel.getName());
        }

    }

    @Override
    public boolean isDisconnect(ActivityAgi activityAgi)
    {
        return false;
    }

    @Override
    public void cancel()
    {
        // this seems a bit strange, but the logic here is that if you cancel
        // this action you want to invoke a new action. We can't end the bridge
        // from here, but not hanging up when it does collapse is
        // important.
        hangup = false;

    }

    public void hangupAfterBridge(boolean b)
    {
        hangup = b;
    }

}
