package it.asterisk.pbx.asterisk.wrap.events;

import it.asterisk.pbx.InvalidChannelName;

public abstract class AbstractChannelStateEvent extends ChannelEventHelper
{

    private static final long serialVersionUID = 1L;


    private final ChannelState channelState;
    private final String channelStateDesc;

    AbstractChannelStateEvent(final it.asterisk.manager.event.AbstractChannelStateEvent event) throws InvalidChannelName
    {
        super(event);
        this.channelState = ChannelState.valueOfDesc(event.getChannelStateDesc());
        this.channelStateDesc = event.getChannelStateDesc();
    }

    public ChannelState getChannelState()
    {
        return this.channelState;
    }

    public String getChannelStateDesc()
    {
        return this.channelStateDesc;
    }

}
