package it.asterisk.pbx.asterisk.wrap.events;

import it.asterisk.pbx.CallerID;
import it.asterisk.pbx.InvalidChannelName;
import it.asterisk.pbx.PBX;
import it.asterisk.pbx.PBXFactory;

public class MeetMeLeaveEvent extends AbstractMeetMeEvent
{
    private static final long serialVersionUID = 1L;

    private final CallerID callerID;
    private final Long duration;

    public MeetMeLeaveEvent(final it.asterisk.manager.event.MeetMeLeaveEvent event) throws InvalidChannelName
    {
        super(event);

        final PBX pbx = PBXFactory.getActivePBX();

        this.callerID = pbx.buildCallerID(event.getCallerIdNum(), event.getCallerIdName());
        this.duration = event.getDuration();
    }

    public CallerID getCallerID()
    {
        return this.callerID;
    }

    public Long getDuration()
    {
        return this.duration;
    }

}
