package it.asterisk.pbx.asterisk.wrap.userEvents;

import it.asterisk.pbx.Channel;
import it.asterisk.pbx.InvalidChannelName;
import it.asterisk.pbx.PBXFactory;
import it.asterisk.pbx.asterisk.wrap.events.ManagerEvent;
import it.asterisk.pbx.internal.core.AsteriskPBX;

public class UserEvent extends ManagerEvent
{
    private static final long serialVersionUID = 1L;

    private Channel channel;

    public UserEvent(it.asterisk.manager.event.UserEvent source, Channel channel)
    {
        super(source);
        this.channel = channel;
    }

    public UserEvent(it.asterisk.manager.event.UserEvent event) throws InvalidChannelName
    {
        super(event);

        AsteriskPBX pbx = (AsteriskPBX) PBXFactory.getActivePBX();
        this.channel = pbx.internalRegisterChannel(event.getChannel(), event.getUniqueId());
    }

    public Channel getChannel()
    {
        return this.channel;
    }
}
