package it.asterisk.pbx.internal.eventQueue;

import it.asterisk.pbx.util.LogTime;
import it.callite.log.AsteriskLog;

public class EventLifeMonitor<T>
{
    /*
     * this class is used to hold an event while its in the queue and calculate
     * how long it spent in the que before being processed.
     */

    private final T theEvent;

    private final LogTime age;

    public EventLifeMonitor(final T event)
    {
        this.theEvent = event;
        this.age = new LogTime();
    }

    public void assessAge()
    {
        if (this.age.timeTaken() > 2000)
        {
            AsteriskLog.warn("event age : " + this.age.timeTaken()); //$NON-NLS-1$
        }

    }

    public T getEvent()
    {
        return this.theEvent;
    }
}
