package it.asterisk.pbx.internal.managerAPI;

import java.util.concurrent.atomic.AtomicLong;

import it.asterisk.pbx.Call;
import it.asterisk.pbx.PBXFactory;
import it.asterisk.pbx.asterisk.wrap.actions.MonitorAction;
import it.asterisk.pbx.internal.core.AsteriskPBX;
import it.callite.log.AsteriskLog;

public class MonitorCall
{

    private static final AtomicLong id = new AtomicLong();

    private String file = null;

    public MonitorCall(final Call call)
    {
        super();

        try
        {
            this.setFile();
            final MonitorAction monitorAction = new MonitorAction(call.getRemoteParty(), this.file, "gsm", true);

            AsteriskPBX pbx = (AsteriskPBX) PBXFactory.getActivePBX();

            pbx.sendAction(monitorAction, 1000);

        }
        catch (final Exception e)
        {
        	AsteriskLog.error(e, e);
        }
    }

    public String getFilename()
    {
        return this.file + ".gsm";
    }

    private void setFile()
    {
        long no = System.currentTimeMillis();
        no = no / 1000;
        final String unq = Long.toHexString(no);

        this.file = "njr" + unq + "-" + MonitorCall.id.incrementAndGet();

    }

}
