package it.callite.action;
import java.io.Serializable;
import java.util.Iterator;
import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;

import it.callite.column.generic.GenericColumn;
import it.callite.constants.ConstantsGlobal;
import it.callite.dao.DataDao;
import it.callite.model.Colonna;
import it.callite.model.Utente;
import it.callite.utility.ApplicationUtil;

@SuppressWarnings("serial")
public class ColonnaBean implements Serializable {

	private GenericColumn categoria;
	private Colonna selezionato;
	private Utente utente;
	@Autowired
	private DataDao dataDao;


	public void deleteColonna() {
		if(selezionato != null) {
			dataDao.cancellaAggiorna(selezionato);
		}
	}

	public void eliminaTutti() {
		List<Colonna> colonne = dataDao.getColonna(utente.getId(), ApplicationUtil.uncapitalize(categoria.getClass().getSimpleName()), false);
		dataDao.cancellaLista(colonne);
	}

	public GenericColumn getCategoria() {
		return categoria;
	}


	public List<Colonna> getListColonna() {
		return dataDao.getColonna(utente.getId(), ApplicationUtil.uncapitalize(categoria.getClass().getSimpleName()), true);
	}


	public Colonna getNuovo() {
		return new Colonna();
	}

	public Colonna getSelezionato() {
		return selezionato;
	}

	public Utente getUtente() {
		return utente;
	}

	public String impostaColonna() {
		String actionB = null;
		if(selezionato != null) {
			GenericColumn c = (GenericColumn) ApplicationUtil.getDao(selezionato.getCategoria());
			if(c != null) {
				c.doImposta((GenericColumn) ApplicationUtil.deserialize(selezionato.getSeriale()));
			}
			actionB = c.getAction();
		}
		return ApplicationUtil.trimToEmpty(actionB);
	}

	public void loadColonne() {
		List<Colonna> colonne = dataDao.loadColonnePredefinite(utente.getId());
		if(ApplicationUtil.notEmpty(colonne)) {
			for (Colonna crto : colonne) {
				GenericColumn c = (GenericColumn) ApplicationUtil.getDao(crto.getCategoria());
				if(c != null) {
					c.doImposta((GenericColumn) ApplicationUtil.deserialize(crto.getSeriale()));
				}
			}
		}
	}

	public void saveColonna() {
		if(selezionato == null) {
			selezionato = getNuovo();
		}
		if(selezionato.getId() == null) {
			selezionato.setUtente(utente);
			selezionato.setCategoria(ApplicationUtil.uncapitalize(categoria.getClass().getSimpleName()));
			selezionato.setSeriale(ApplicationUtil.serialize(categoria));
		}
		if(ApplicationUtil.gtZero(selezionato.getTipo()) && selezionato.getTipo().equals(ConstantsGlobal.predefinito) ) {
			List<Colonna> colonne = dataDao.getColonnePredefinite(selezionato);
			if(ApplicationUtil.notEmpty(colonne)) {
				Iterator<Colonna> objIter = colonne.iterator();
				while(objIter.hasNext()) {
					Colonna colonna = objIter.next();
					colonna.setTipo(ConstantsGlobal.normale);
					dataDao.salvaAggiorna(colonna);
				}
			}
		}
		dataDao.salvaAggiorna(selezionato);
	}

	public void setCategoria(GenericColumn categoria) {
		this.categoria = categoria;
	}


	public void setSelezionato(Colonna selezionato) {
		this.selezionato = selezionato;
	}

	public void setUtente(Utente utente) {
		this.utente = utente;
	}

}