package it.callite.action;
import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.Serializable;
import java.util.Collection;

import javax.faces.context.ExternalContext;
import javax.faces.context.FacesContext;
import javax.servlet.ServletOutputStream;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.springframework.beans.factory.annotation.Autowired;

import it.callite.dao.ImpostazioneDao;
import it.callite.log.ErrorLog;
import it.callite.utility.ApplicationUtil;
@SuppressWarnings("serial")
public class DownloadBean implements Serializable {
	
	private String action;
	private boolean ajax = false;
	private ByteArrayOutputStream bos;
	private String filename;
	private Integer elementi = 0;
	@Autowired
	private ImpostazioneDao impostazioneDao;

	public void close() throws Exception {
		if(!ajax) {
			response();
		}
		ajax = false;
		if(bos != null) {
			bos.close();
		}
	}
	public String execute() {
		return action;
	}
	public void filename(String filename, Collection<?> ... elementi) {
		this.filename = filename;
		this.elementi = ApplicationUtil.sizeC(elementi);
	}
	
	public String getAction() {
		return action;
	}
	public String getFilename() {
		return ApplicationUtil.getNameN(filename);
	}

	public boolean isAjax() {
		return ajax;
	}
	public ByteArrayOutputStream outputStream() {
		bos = new ByteArrayOutputStream();
		return bos;
	}

	public void response() {
		if(bos != null && filename != null) {
			try {
				byte [] b = bos.toByteArray();
				if(b != null  && b.length > 0 ) {
					FacesContext fc = ApplicationUtil.getFacesContext();
					ExternalContext ec = ApplicationUtil.getExternalContext(fc);
					HttpServletResponse response = ApplicationUtil.getResponse(ec);
					HttpServletRequest request = ApplicationUtil.getRequest(ec);
					ApplicationUtil.setResponse(elementi, impostazioneDao.getDownloadLogType(), false, null, request, response, filename);
					ServletOutputStream out = response.getOutputStream();
					out.write(b);
					//bos.flush();
					//bos.close();
					out.flush();
					out.close();
					fc.responseComplete();
				}
			} catch (IOException e) {
				ErrorLog.log(null, getClass(), e);
			}
		}
	}

	public void setAction(String action) {
		this.action = action;
	}

	public void setAjax(boolean ajax) {
		this.ajax = ajax;
	}
	
	
}