package it.callite.action;

import java.io.Serializable;
import java.util.Locale;

import javax.faces.component.UIViewRoot;

import org.springframework.beans.factory.annotation.Autowired;

import it.callite.constants.ConstantsGlobal;
import it.callite.dao.TemaDao;
import it.callite.utility.ApplicationUtil;

@SuppressWarnings("serial")
public class LocaleBean implements Serializable{
	
	@Autowired
	private TemaDao temaDao;
	
	
	private String locale;
	
	public LocaleBean(){
		
	}

	
	public String getLocale() {
		if(locale == null) {
			locale = temaDao.getTema().getLingua();
		}
		return locale;
	}

	public void localeChanged(){
		if(ApplicationUtil.isNotEmpty(locale)) {
			Locale l = new Locale(locale);
			UIViewRoot ui = ApplicationUtil.getViewRoot();
			if(ui != null) {
				ui.setLocale(l);       
			}
			ConstantsGlobal.LANGUAGE = ApplicationUtil.lingua(locale);
			ConstantsGlobal.COUNTRY = ApplicationUtil.paese(locale);
			Locale.setDefault(l);
		}
	}
	
	public String getLanguage() {
		String l = getLocale();
		return ApplicationUtil.lingua(l);
	}
	
	
	public String getCountry() {
		String l = getLocale();
		return ApplicationUtil.paese(l);
	}

	public void setLocale(String locale) {
		this.locale = locale;
	}

}