package it.callite.action;
import java.io.File;
import java.io.FileInputStream;
import java.io.InputStream;
import java.io.OutputStream;
import java.io.Serializable;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Iterator;
import java.util.List;

import org.richfaces.component.UITree;
import org.richfaces.component.state.TreeStateAdvisor;
import org.richfaces.event.NodeSelectedEvent;
import org.richfaces.model.TreeRowKey;

import it.callite.constants.ConstantsGlobal;
import it.callite.constants.ConstantsMap;
import it.callite.log.ErrorLog;
import it.callite.utility.ApplicationUtil;
import it.callite.utility.ZipPassword;
import it.callite.utility.ZipUtils;
import it.callite.utility.item.FileSI;

@SuppressWarnings("serial")
public class PathStorageBean implements TreeStateAdvisor, Serializable {

	private List<FileSI> files = new ArrayList<FileSI>();
	private String path;

	@SuppressWarnings("unchecked")
	public Boolean adviseNodeOpened(UITree tree) {
		Object key = tree.getRowKey();
		TreeRowKey<FileSI> treeRowKey = (TreeRowKey<FileSI>) key;
		if (treeRowKey == null || treeRowKey.depth() <= 0) {
			return Boolean.TRUE;
		}
		return null;
	}

	public Boolean adviseNodeSelected(UITree tree) {
		FileSI file = (FileSI) tree.getRowData();
		File ls = new File(file.getPath());
		List<FileSI> list = getChildren(ls.listFiles(), file.isEliminabile(), file.getColor());
		file.setNodes(list);
		return null;
	}

	public void onSelect(final NodeSelectedEvent event) {
		//		HtmlTree theTree = (HtmlTree) event.getComponent();
		//		if (null == theTree) {
		//			return;
		//		}
		//		FileSI file = (FileSI) theTree.getRowData();
	}

	public void reset() {
		files.clear();
	}
	public List<FileSI> getRoots() {
		if(ApplicationUtil.empty(files)) {
			files.add(new FileSI(path, false, "blue"));
		}
		return files;
	}

	public void setRoots(List<FileSI> roots) {
	}

	public List<FileSI> getChildren(File [] fileArrays, boolean eliminabile, String color) {
		List<FileSI> filesSI = new ArrayList<FileSI>();
		if(ApplicationUtil.notEmpty(fileArrays)) {
			List <File> fileList = new ArrayList<File>(Arrays.asList(fileArrays));
			Iterator<File> it = fileList.iterator();
			while (it.hasNext()) {
				File file = (File) it.next();
				FileSI fs = new FileSI(file, eliminabile, color);
				filesSI.add(fs);
			}
		}
		return filesSI; 
	}

	public void delete(FileSI file) {
		File f = new File(file.getPath());
		ApplicationUtil.deleteAll(f);
	}

	public void scarica(FileSI file, DownloadBean downloadBean)  {
		try {
			File f = new File(file.getPath());
			if(file.isType()) {
				OutputStream out = downloadBean.outputStream();
				downloadBean.filename(file.getNome());
				InputStream istream = new FileInputStream(f);
				ApplicationUtil.copy(istream, out);
				downloadBean.close();
				istream.close();

			} else {
				OutputStream out = downloadBean.outputStream();
				downloadBean.filename(file.getNome() + "." + ConstantsMap.zip);
				String s = ConstantsGlobal.secretZ;
				if(s != null) {
					ZipPassword.zipIt(null, f.getAbsolutePath(), out, s);
				} else {
					ZipUtils.zipIt(null, f.getAbsolutePath(), out);
				}
				downloadBean.close();
			}
		} catch (Exception e) {
			ErrorLog.log(null, getClass(), e);
		}
	}

	public String getPath() {
		return path;
	}

	public void setPath(String path) {
		this.path = path;
	}



}