package it.callite.action;
import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

import org.richfaces.component.UITree;
import org.richfaces.component.state.TreeStateAdvisor;
import org.richfaces.event.NodeSelectedEvent;
import org.richfaces.model.TreeRowKey;
import org.springframework.beans.factory.annotation.Autowired;

import it.callite.dao.UserDao;
import it.callite.utility.ApplicationUtil;
import it.callite.utility.item.AgenteSI;

@SuppressWarnings("serial")
public class ReteAgenteBean implements TreeStateAdvisor, Serializable {
	
	private Long agenteId;
	private List<AgenteSI> agenti = new ArrayList<AgenteSI>();

	@Autowired
	private UserDao userDao;

	@SuppressWarnings("unchecked")
	public Boolean adviseNodeOpened(UITree tree) {
		Object key = tree.getRowKey();
		TreeRowKey<AgenteSI> treeRowKey = (TreeRowKey<AgenteSI>) key;
		if (treeRowKey == null || treeRowKey.depth() <= 0) {
			return Boolean.TRUE;
		}
		return null;
	}


	public Boolean adviseNodeSelected(UITree tree) {
		AgenteSI agente = (AgenteSI) tree.getRowData();
		agente.setNodes(userDao.getAgentiFigli(agente.getId()));
		return null;
	}

	public Long getAgenteId() {
		return agenteId;
	}

	public List<AgenteSI> getRoots() {
		if(ApplicationUtil.empty(agenti)) {
			agenti.addAll(userDao.getAgentiFigli(agenteId));
		}
		return agenti;
	}

	public void onSelect(final NodeSelectedEvent event) {
		//		HtmlTree theTree = (HtmlTree) event.getComponent();
		//		if (null == theTree) {
		//			return;
		//		}
		//		Agente agente = (Agente) theTree.getRowData();
	}


	public void reset() {
		agenteId = null;
		agenti.clear();
	}

	public void setAgenteId(Long agenteId) {
		this.agenteId = agenteId;
	}

}