package it.callite.action;
import java.io.File;
import java.io.IOException;
import java.io.Serializable;
import java.util.ArrayList;
import java.util.Collections;
import java.util.LinkedList;
import java.util.List;

import javax.faces.model.SelectItem;
import javax.faces.model.SelectItemGroup;

import it.callite.chiamate.Chiamate;
import it.callite.constants.ConstantsGlobal;
import it.callite.constants.ConstantsLanguage;
import it.callite.constants.ConstantsMap;
import it.callite.message.Message;
import it.callite.utility.ApplicationUtil;
import it.callite.utility.thread.ConsoleThread;
@SuppressWarnings("serial")
public class SistemaBean implements Serializable {
	private String command;
	private List<String> lines = new LinkedList<String>();
	private ConsoleThread lt;
	private Process processo;
	private boolean type = false;
	private boolean esegui = false;
	
	public SistemaBean() {
	}
	public void clear() {
		stop();
		start();
	}
	public List<SelectItem> getCommandList() {
		List<String> LOG1 = new ArrayList<String>();
		List<String> LOG2 = new ArrayList<String>();
		List<String> IP = new ArrayList<String>();
		List<String> commands0 = new ArrayList<String>();
		List<String> commands1 = new ArrayList<String>();
		List<String> commands2 = new ArrayList<String>();
		List<String> commands3 = new ArrayList<String>();
		if(ApplicationUtil.isWindows()) {
			commands0.add("ping -t");
			commands0.add("tracert");
		} else {
			commands0.add("ping");
			commands0.add("traceroute -n");
			commands0.add("nmap -PN");
			commands0.add("mtr --report --report-cycles 10");
			commands1.add("tail -f -n200");
			commands1.add("cat");
			commands2.add("zcat");
			commands3.add("top -b n1");
			commands3.add("ps fx");
			commands3.add("free -mtho");
			commands3.add("netstat -punta");
			commands3.add("iptables -L -n");
			commands3.add("sysbench --test=cpu --cpu-max-prime=5000 run");
			commands3.add("service --status-all");
			commands3.add("systemctl list-units --type=service --no-legend");
			commands3.add("who -H");
			
		}
		String [] logs = ConstantsGlobal.LOG;
		for(String l : logs) {
			File fs = new File(l);
			if(fs.exists()) {
				List<File> files = new ArrayList<File>();
				ApplicationUtil.listFile(l, files);
				for(File dd : files) {
					if(dd.isFile() && dd.canRead()) {
						String f = dd.getAbsolutePath();
						boolean valid = !ApplicationUtil.getExtensionLower(f).equalsIgnoreCase(ConstantsMap.lck);
						if(valid) {
							boolean ext = ApplicationUtil.getExtensionLower(f).equalsIgnoreCase(ConstantsMap.gz);
							if(!ext) {
								LOG1.add(f);
							} else {
								LOG2.add(f);
							}
						}
					}
				}
			}
		}
		IP.add("8.8.8.8");
		IP.addAll(Chiamate.getCodaOperatori().getIP(false));
		Collections.sort(LOG1);
		Collections.sort(LOG2);
		List<SelectItem> valore = new ArrayList<SelectItem>();
		valore.add(0, new SelectItem(null, ConstantsLanguage.TRATTINI.stampa()));
		if(ApplicationUtil.notEmpty(commands0)) {
			for(String command : commands0) {
				List<SelectItem> groups = new ArrayList<SelectItem>();
				int index = command.indexOf(" ");
				String base = ApplicationUtil.trimToEmpty((index > -1) ? command.substring(0, index) : command);
				for(String fi : IP) {
					groups.add(new SelectItem(command + " " + fi, base + ": " + fi));
				}
				SelectItemGroup pingG = new SelectItemGroup(ApplicationUtil.capitalize(base)); 
				pingG.setSelectItems(groups.toArray(new SelectItem[groups.size()]));
				valore.add(pingG);
			}
		}
		if(ApplicationUtil.notEmpty(commands1) && ApplicationUtil.notEmpty(LOG1)) {
			for(String command : commands1) {
				List<SelectItem> groups = new ArrayList<SelectItem>();
				int index = command.indexOf(" ");
				String base = ApplicationUtil.trimToEmpty((index > -1) ? command.substring(0, index) : command);
				for(String fi : LOG1) {
					groups.add(new SelectItem(command + " " + fi, base + ": " + fi));
				}
				SelectItemGroup pingG = new SelectItemGroup(ApplicationUtil.capitalize(base)); 
				pingG.setSelectItems(groups.toArray(new SelectItem[groups.size()]));
				valore.add(pingG);
			}
		}
		if(ApplicationUtil.notEmpty(commands2) && ApplicationUtil.notEmpty(LOG2)) {
			for(String command : commands2) {
				List<SelectItem> groups = new ArrayList<SelectItem>();
				int index = command.indexOf(" ");
				String base = ApplicationUtil.trimToEmpty((index > -1) ? command.substring(0, index) : command);
				for(String fi : LOG2) {
					groups.add(new SelectItem(command + " " + fi, base + ": " + fi));
				}
				SelectItemGroup pingG = new SelectItemGroup(ApplicationUtil.capitalize(base)); 
				pingG.setSelectItems(groups.toArray(new SelectItem[groups.size()]));
				valore.add(pingG);
			}
		}
		if(ApplicationUtil.notEmpty(commands3)) {
			List<SelectItem> groups = new ArrayList<SelectItem>();
			for(String command : commands3) {
				int index = command.indexOf(" ");
				String base = ApplicationUtil.trimToEmpty((index > -1) ? command.substring(0, index) : command);
				groups.add(new SelectItem(command, base));
			}
			SelectItemGroup pingG = new SelectItemGroup(Message.addCatalogText("altro")); 
			pingG.setSelectItems(groups.toArray(new SelectItem[groups.size()]));
			valore.add(pingG);
		}
		return valore;
	}
	public void start(){
		lines.clear();
		if(ApplicationUtil.isNotBlank(command) && (!type || (type && esegui))) {
			String[] commandS = null;
			if(!ApplicationUtil.isWindows()) {
				commandS = new String[] {ConstantsGlobal.path_shell, "-c", ApplicationUtil.cleanText(command)};
			} else {
				commandS = ApplicationUtil.token(ApplicationUtil.cleanText(command), " ").toArray(new String[0]);
			}
			if(ApplicationUtil.notEmpty(commandS)) {
				try {
					boolean builder = true;
					if(builder) {
						ProcessBuilder procBuilder = new ProcessBuilder(commandS);
						procBuilder.redirectErrorStream(true);
						processo = procBuilder.start();
					} else {
						Runtime rt = Runtime.getRuntime();
						processo = rt.exec(commandS);
					}
				} catch (IOException e) {
					lines.add(e.getMessage());
				}
				if(processo != null) {
					lt = new ConsoleThread(processo, lines);
					lt.setSospeso(false);
					lt.start();
				}
			}
		}
	}
	public void stop() {
		if(processo != null) {
			processo.destroyForcibly();
		}
		if(lt != null) {
			lt.setSospeso(true);
			lt.interrupt();
		}
		lines.clear();
	}
	public void setCommand(String command) {
		this.command = command;
	}
	public String getCommand() {
		return command;
	}
	public List<String> getLines() {
		return lines;
	}
	public void setLines(List<String> lines) {
		this.lines = lines;
	}
	public boolean isType() {
		return type;
	}
	public void setType(boolean type) {
		this.type = type;
	}
	public boolean isEsegui() {
		return esegui;
	}
	public void setEsegui(boolean esegui) {
		this.esegui = esegui;
	}
}