package it.callite.action;

import java.io.Serializable;

import org.springframework.beans.factory.annotation.Autowired;

import it.callite.constants.ConstantsMap;
import it.callite.dao.TemaDao;
import it.callite.model.Tema;
import it.callite.utility.Allegato;
import it.callite.utility.ApplicationUtil;

@SuppressWarnings("serial")
public class TemaBean implements Serializable {

	private boolean reload = false;
	private String skin;
	private Tema tema;
	@Autowired
	private TemaDao temaDao;

	public String getSkin() {
		if(skin == null) {
			Tema tm = getTema();
			if(tm != null) {
				skin = tm.getSkin(); 
			}
		}
		if(ApplicationUtil.isEmpty(skin)) {
			skin = ConstantsMap.tema_A;
		}
		return skin;
	}

	public Tema getTema() {
		if(tema == null || reload) {
			tema = temaDao.getTema();
		}
		reload = false;
		return tema;
	}
	
	public Allegato getLogo() {
		Tema tema = getTema();
		if(tema != null) {
			return tema.getAllegato();
		} else {
			return null;
		}
	}

	public void reload() {
		reload = true;
	}


	public void setSkin(String skin) {
		this.skin = skin;
	}


	public void setTema(Tema tema) {
		this.tema = tema;
	}


}