package it.callite.audit;

import java.io.Serializable;
import java.util.Iterator;

import org.hibernate.CallbackException;
import org.hibernate.EmptyInterceptor;
import org.hibernate.Transaction;
import org.hibernate.type.Type;

import it.callite.dao.ImpostazioneDao;
import it.callite.utility.ApplicationUtil;

@SuppressWarnings("serial")
public class AuditInterceptor extends EmptyInterceptor {


	private ImpostazioneDao impostazioneDao;

	public void setImpostazioneDao(ImpostazioneDao impostazioneDao) {
		this.impostazioneDao = impostazioneDao;
	}
	
	public AuditInterceptor() {

	} 

	public void afterTransactionBegin(Transaction tx) {
		super.afterTransactionBegin(tx);
	}

	public void afterTransactionCompletion(Transaction tx) {
		super.afterTransactionCompletion(tx);
	}

	public void beforeTransactionCompletion(Transaction tx) {
		super.beforeTransactionCompletion(tx);
	}

	public Object getEntity(String entityName, Serializable id) throws CallbackException {
		return super.getEntity(entityName, id);
	}

	public String getEntityName(Object object) throws CallbackException {
		return super.getEntityName(object);
	}

	public Boolean isTransient(Object entity) {
		return super.isTransient(entity);
	}

	public String onPrepareStatement(String sql) {
		return super.onPrepareStatement(sql);
	}
	@SuppressWarnings("rawtypes")
	public void postFlush(Iterator entities) throws CallbackException {
		super.postFlush(entities);
	}

	@SuppressWarnings("rawtypes")
	public void preFlush(Iterator entities) throws CallbackException {
		super.preFlush(entities);
	}

	public int[] findDirty(Object entity, Serializable id, Object[] currentState, Object[] previousState, String[] propertyNames, Type[] types) {
		return super.findDirty(entity, id, currentState, previousState, propertyNames, types);
	}

	public void onCollectionRecreate(Object collection, Serializable key) throws CallbackException {
		//if(collection instanceof PersistentSet || collection instanceof PersistentBag) {}
		super.onCollectionRecreate(collection, key);
	}

	public void onCollectionRemove(Object collection, Serializable key) throws CallbackException {
		//if(collection instanceof PersistentSet || collection instanceof PersistentBag) {}
		super.onCollectionRemove(collection, key);
	}

	public void onCollectionUpdate(Object collection, Serializable key) throws CallbackException {
		//if(collection instanceof PersistentSet || collection instanceof PersistentBag) {}
		super.onCollectionUpdate(collection, key);
	}

	public boolean onLoad(Object entity, Serializable id, Object[] state, String[] propertyNames, Type[] types) throws CallbackException {
		return super.onLoad(entity, id, state, propertyNames, types);
	}

	public void onDelete(Object entity, Serializable id, Object[] state, String[] propertyNames, Type[] types) throws CallbackException {
		ApplicationUtil.stampa(impostazioneDao, "delete", entity, id, state, propertyNames);
		super.onDelete(entity, id, state, propertyNames, types);
	}

	public boolean onSave(Object entity, Serializable id, Object[] state, String[] propertyNames, Type[] types) throws CallbackException {
		ApplicationUtil.stampa(impostazioneDao, "insert", entity, id, state, propertyNames);
		return super.onSave(entity, id, state, propertyNames, types);
	}

	public boolean onFlushDirty(Object entity, Serializable id, Object[] currentState, Object[] previousState, String[] propertyNames, Type[] types) throws CallbackException {
		ApplicationUtil.stampa(impostazioneDao, "update", entity, id, currentState, propertyNames);
		return super.onFlushDirty(entity, id, currentState, previousState, propertyNames, types);
	}


}