package it.callite.autodialer.autodial;

import java.util.Date;
import java.util.Map;

import it.asterisk.fastagi.AgiChannel;
import it.asterisk.fastagi.AgiRequest;
import it.asterisk.fastagi.AgiScript;
import it.asterisk.fastagi.BaseAgiScript;
import it.callite.autodialer.controllo.CodaManager;
import it.callite.autodialer.controllo.CodaStatic;
import it.callite.chiamate.Chiamate;
import it.callite.constants.ConstantsGlobal;
import it.callite.constants.ConstantsLanguage;
import it.callite.constants.ConstantsMap;
import it.callite.dao.AutodialerDao;
import it.callite.model.AutoContatto;
import it.callite.model.Autodialer;
import it.callite.model.Contatto;
import it.callite.model.Utente;
import it.callite.utility.ApplicationUtil;
import it.callite.utility.CallUtil;
import it.callite.utility.DatoAggiuntivo;
import it.callite.utility.InfoUtente;
import it.callite.utility.ParameterAutodialer;

public class AgiManager extends BaseAgiScript implements AgiScript {

	private AutodialerDao autodialerDao;

	public AgiManager(AutodialerDao autodialerDao) {
		super();
		this.autodialerDao = autodialerDao;
	}

	public void service(AgiRequest request, AgiChannel chanel)  {  
		try {
			String [] args = request.getArguments();
			String ids = ApplicationUtil.trimToNull(args[0]);
			Long id = ApplicationUtil.contatto(ids);
			if(id != null) {
				AutoContatto auto = CodaStatic.getChiamateInCorso().get(id);
				if(auto!=null) {
					if(auto.getData_risposta() == null) {
						auto.setData_risposta(ApplicationUtil.date());
					}
					auto.setHangup(true);
					auto.impostaCU(chanel.getUniqueId(), null);
					Contatto contatto = auto.getContatto();
					CodaManager codaManager = Chiamate.getCodaProcessi().get(contatto.getCampagna());
					if(codaManager != null) {
						boolean statico = autodialerDao.isStatico();
						boolean agganciata = false;
						Autodialer aa = auto.getAutodialer();
						ParameterAutodialer ra = new ParameterAutodialer(aa.getTrunk(), null, null);
						String mc = ra.getMusicclass();
						String telefono = auto.getTelefono();
						String utente = null;
						String userfield = contatto.getUserfield();
						Boolean monitor = ra.getRegistrazione();
						Boolean inbound = contatto.getInbound();
						ApplicationUtil.ascolto(chanel, mc);
						String chiamante = contatto.getId().toString();
						boolean contenuto = false;
						boolean human = true;
						if(aa.getAmd()) {
							String amd = ApplicationUtil.creaLista(0, null, aa.getInitialSilence(), aa.getGreeting(), aa.getAfterGreetingSilence(), aa.getTotalAnalysisTime(), aa.getMinimumWordLength(), aa.getBetweenWordsSilence(), aa.getMaximumNumberOfWords(), aa.getSilenceThreshold(), aa.getMaximumWordLength());
							chanel.exec("AMD", amd);
							//chanel.exec("WaitForSilence", "1000,2,15");
							String machine = ApplicationUtil.getVariable(chanel, "AMDSTATUS");
							if(machine != null) {
								//chanel.verbose(machine, 3);
								boolean v1 = ApplicationUtil.isTrue(aa.getAmdType()) && !(machine.equalsIgnoreCase(ConstantsGlobal.HUMAN) || machine.equalsIgnoreCase(ConstantsGlobal.NOTSURE));
								boolean v2 = !ApplicationUtil.isTrue(aa.getAmdType()) && !(machine.equalsIgnoreCase(ConstantsGlobal.HUMAN));
								if(v1 || v2) {
									auto.addCause(machine);
									human = false;
								}
							}
						}
						if(human) {
							boolean a = autodialerDao.getSip();
							boolean richiama = true;
							if(aa.getPreambolo()) {
								String repeat = ApplicationUtil.forDigit(aa.getRepeat_key());
								String exit  = ApplicationUtil.forDigit(aa.getExit_key()); 
								String hangup = ApplicationUtil.forDigit(aa.getHangup_key()); 
								String prenota = ApplicationUtil.forDigit(aa.getPrenota_key()); 
								String registra = ApplicationUtil.forDigit(aa.getRegistra_key()); 
								String contatta = ApplicationUtil.forDigit(aa.getContatta_key()); 
								String stoprec = ApplicationUtil.forDigit(aa.getStoprec_key()); 

								int r = 0;
								String premuto = repeat + exit + hangup + prenota + registra + contatta;
								Character escape = null;
								while(ApplicationUtil.equalsC(escape,repeat) || (r < aa.getRipetizioni())) {
									contenuto = codaManager.getChiamateInCorso().contains(contatto.getId());
									if(!contenuto) {
										richiama = false;
										break;
									}
									if(ApplicationUtil.isTrue(aa.getTts())) {
										escape = ApplicationUtil.riproduciPhonetic(chanel, aa.getTesto(), premuto);
									} else {
										escape = ApplicationUtil.riproduciSuono(chanel, autodialerDao.getHome(), ApplicationUtil.getBaseNameN(aa.getSuono()), premuto); 
									}
									r++;

									if(ApplicationUtil.equalsC(escape,exit) || ApplicationUtil.equalsC(escape,hangup) || ApplicationUtil.equalsC(escape,prenota) || ApplicationUtil.equalsC(escape,registra) || ApplicationUtil.equalsC(escape,contatta)) {
										break;
									} else {
										ApplicationUtil.sleep(autodialerDao.sleepSuono());
									}
								}
								contenuto = codaManager.getChiamateInCorso().contains(contatto.getId());
								if(contenuto) {
									if(ApplicationUtil.validate(escape, exit,hangup,prenota,registra,contatta)) {
										auto.addCause(ConstantsLanguage.PREMUTO.stampa() +": " + ApplicationUtil.convertC(escape));
										if(!ApplicationUtil.equalsC(escape,exit) && (ApplicationUtil.equalsC(escape,hangup) || ApplicationUtil.equalsC(escape,prenota) || ApplicationUtil.equalsC(escape,registra) || ApplicationUtil.equalsC(escape,contatta))) {
											Map<String, DatoAggiuntivo> valori = autodialerDao.loadValori(contatto);
											if(autodialerDao.isVariabile()) {
												ApplicationUtil.impostaVariabili(chanel, valori);
											}
											Date data = ApplicationUtil.date();
											codaManager.getAutodialerStatistiche().incPrenotato(data);
											codaManager.getAutodialerContatti().incPrenotato(auto, data);
											CodaStatic.getAutodialerStatistiche().incPrenotato(data);
											CodaStatic.getAutodialerContatti().incPrenotato(auto, data);
											String touch = ApplicationUtil.impostaCDR(chanel, null, null, null, null, null, telefono, utente, chiamante, userfield, inbound);
											if(ApplicationUtil.equalsC(escape,hangup)) {
												chanel.streamFile(ConstantsGlobal.path_sondaggio + ConstantsGlobal.path_audio_1);
												autodialerDao.chiudiContatto(auto, ConstantsMap.AGI_AGGANCIATA, aa.getEsitoAgganciata());
												chanel.streamFile(ConstantsGlobal.path_sondaggio + ConstantsGlobal.path_audio_3);
											}
											if(ApplicationUtil.equalsC(escape,prenota)) {
												chanel.streamFile(ConstantsGlobal.path_sondaggio + ConstantsGlobal.path_audio_1);
												autodialerDao.chiudiContatto(auto, ConstantsMap.AGI_PRENOTA, aa.getEsitoPrenotazione());
												chanel.streamFile(ConstantsGlobal.path_sondaggio + ConstantsGlobal.path_audio_3);
											}	
											if(ApplicationUtil.equalsC(escape,registra)) {
												chanel.streamFile(ConstantsGlobal.path_sondaggio + ConstantsGlobal.path_audio_1);
												autodialerDao.chiudiContatto(auto, ConstantsMap.AGI_PRENOTA, aa.getEsitoPrenotazione());
												chanel.streamFile(ConstantsGlobal.path_sondaggio + ConstantsGlobal.path_audio_4);
												long time = System.currentTimeMillis() / ConstantsGlobal.millis;
												String file =  ConstantsGlobal.preamboloA + "-" + time + "-" + touch;
												chanel.recordFile(autodialerDao.getHome() +  ConstantsGlobal.path_monitor + "/" + file, ConstantsMap.wav, stoprec, -1, 0, true, aa.getTimeoutrec());
												chanel.streamFile(ConstantsGlobal.path_sondaggio + ConstantsGlobal.path_audio_3);
											}
											if(ApplicationUtil.equalsC(escape,contatta)) {
												chanel.streamFile(ConstantsGlobal.path_sondaggio + ConstantsGlobal.path_audio_1);

												autodialerDao.chiudiContatto(auto, ConstantsMap.AGI_PRENOTA, aa.getEsitoPrenotazione());
												chanel.streamFile(ConstantsGlobal.path_sondaggio + ConstantsGlobal.path_audio_5);
												String app = aa.getApp();
												String callers = ApplicationUtil.replaceValori(chanel, aa.getCallers(), valori);
												String pre = ApplicationUtil.replaceValori(chanel, aa.getPre_caller(), valori);
												String post = ApplicationUtil.replaceValori(chanel, aa.getPost_caller(), valori);
												String numero = ApplicationUtil.replaceValori(chanel, aa.getNumero(), valori);
												CallUtil ca = new CallUtil(app, callers, pre, post, numero, telefono);
												auto.impostaCD2(ca.getChiamanteN(), ca.getChiamatoN());
												ApplicationUtil.impostaREC(chanel, touch, monitor);
												chanel.setCallerId(ca.getChiamanteN());
												chanel.exec(ca.getAppN(), ca.getOptionN());
												chanel.streamFile(ConstantsGlobal.path_sondaggio + ConstantsGlobal.path_audio_3);
											}
											if(!agganciata) {
												agganciata = true;
												chanel.hangup();
											}
											richiama = false;
										} 
									} else {
										autodialerDao.chiudiContatto(auto, ConstantsMap.AGI_AGGANCIATA, aa.getEsitoUscita());
										if(!agganciata) {
											agganciata = true;
											chanel.hangup();
										}
										richiama = false;
									}
								} else {
									autodialerDao.chiudiContatto(auto, ConstantsMap.AGI_AGGANCIATA, aa.getEsitoUscita());
									if(!agganciata) {
										agganciata = true;
										chanel.hangup();
									}
									richiama = false;
								}
							}
							if(richiama) {
								InfoUtente iu = null;
								auto.setData_gestione(ApplicationUtil.date());
								boolean seleziona_liste = ApplicationUtil.isTrue(contatto.getCampagna().getSeleziona_liste());
								do {
									contenuto = codaManager.getChiamateInCorso().contains(contatto.getId());
									if(contenuto) {
											iu = seleziona_liste ? autodialerDao.getInternoDaChiamare2(contatto) : autodialerDao.getInternoDaChiamare1(contatto);
										if(iu == null) {
											ApplicationUtil.sleep(autodialerDao.sleepAbbattuta());
											Date data = ApplicationUtil.date();
											auto.setData_attesa(data);
											codaManager.getChiamateInAttesa().put(auto);
											if(ApplicationUtil.abbatti(auto.getData_attesa(), auto.getData_gestione(), aa.getAbbattimento())) {
												autodialerDao.chiudiContatto(auto,  ConstantsMap.AGI_ABBATTUTA, aa.getEsitoAbbattuta());
												if(!agganciata) {
													agganciata = true;
													chanel.hangup();
												}
												codaManager.getAutodialerStatistiche().incAbbattute(data);
												codaManager.getAutodialerContatti().incAbbattute(auto, data);
												CodaStatic.getAutodialerStatistiche().incAbbattute(data);
												CodaStatic.getAutodialerContatti().incAbbattute(auto, data);
											} 
										}
									}
								} while (iu == null && contenuto);
								codaManager.getChiamateInAttesa().remove(contatto.getId());
								contenuto = codaManager.getChiamateInCorso().contains(contatto.getId()); 
								if(contenuto) {
									if(iu != null) {
										//chanel.stopMusicOnHold();
										Utente op = iu.getOperatore();
										String chiamato = op.getInternoString();
										utente = op.getId().toString();
										monitor = ra.getRegistrazione() || op.getRegistrazione();
										auto.setUtente(op);
										String chiamanteN = (ApplicationUtil.isTrue(inbound) ? ConstantsGlobal.inboundSMB : ConstantsGlobal.autodialerSMB) + chiamante;
										chanel.setCallerId(chiamanteN);
										auto.impostaCD2(chiamanteN, chiamato);
										ApplicationUtil.setVariable(true, chanel, ConstantsGlobal.OPPOSIZIONE, ApplicationUtil.evalZero(ra.getOpposizione() || op.getOpposizione()));
										ApplicationUtil.setVariable(true, chanel, ConstantsGlobal.PREFISSO, op.getPrefisso() + ra.getPrefisso());
										ApplicationUtil.setVariable(true, chanel, ConstantsGlobal.UTENTE, utente);
										ApplicationUtil.setVariable(true, chanel, ConstantsGlobal.MONITOR, ApplicationUtil.evalZero(monitor));
										ApplicationUtil.setVariable(true, chanel, ConstantsGlobal.NUMERO, statico ? chiamato : "0");
										String touch = ApplicationUtil.impostaCDR(chanel, null, null, null, null, null, telefono, utente, chiamante, userfield, inbound);
										if(!statico) {
											ApplicationUtil.impostaREC(chanel, touch, monitor);
											int i = chanel.exec(ConstantsGlobal.appData, ApplicationUtil.formatCallee(a, "", chiamato) + "," + ConstantsGlobal.timeoutSip + "," + ConstantsGlobal.optionsSip);
											if(i < -1){ 
												autodialerDao.chiudiContatto(auto, ConstantsMap.AGI_FALLITA, aa.getEsitoHangup());
												if(!agganciata) {
													agganciata = true;
													chanel.hangup();
												}
											}
										}
									} else {
										autodialerDao.chiudiContatto(auto, ConstantsMap.AGI_SALTATA, aa.getEsitoHangup());
										if(!agganciata) {
											agganciata = true;
											chanel.hangup();
										}
									}
								} else {
									if(iu != null && !iu.isReady()) {
										iu.setReady(true);
									}
								}

							}
						} else {
							Date data = ApplicationUtil.date();
							autodialerDao.chiudiContatto(auto, ConstantsMap.AGI_MACCHINA, aa.getEsitoMacchina());
							if(!agganciata) {
								agganciata = true;
								chanel.hangup();
							}
							codaManager.getAutodialerStatistiche().incMacchina(data);
							codaManager.getAutodialerContatti().incMacchina(auto, data);
							CodaStatic.getAutodialerStatistiche().incMacchina(data);
							CodaStatic.getAutodialerContatti().incMacchina(auto, data);
						}
					}
				}
			}
		} catch (Exception e) {	}
	}
}  