package it.callite.autodialer.autodial;

import java.util.Map;

import it.asterisk.fastagi.AgiChannel;
import it.asterisk.fastagi.AgiRequest;
import it.asterisk.fastagi.AgiScript;
import it.asterisk.fastagi.BaseAgiScript;
import it.callite.constants.ConstantsGlobal;
import it.callite.dao.AutodialerDao;
import it.callite.model.Contatto;
import it.callite.utility.ApplicationUtil;
import it.callite.utility.DatoAggiuntivo;

public class AnagraficaManager extends BaseAgiScript implements AgiScript {

	private AutodialerDao autodialerDao;

	public AnagraficaManager(AutodialerDao autodialerDao) {
		super();
		this.autodialerDao = autodialerDao;
	}

	public void service(AgiRequest request, AgiChannel chanel)  {
		if(autodialerDao.isVariabile()) {
			try {
				//String [] args = request.getArguments();
				String c = ApplicationUtil.getVariable(chanel, ConstantsGlobal.CONTATTO);
				if(ApplicationUtil.notZero(c)) {
					Long id = ApplicationUtil.toLong(c);
					if(id != null) {
						Contatto contatto = autodialerDao.getContatto(id);
						Map<String, DatoAggiuntivo> valori = autodialerDao.loadValori(contatto);
						ApplicationUtil.impostaVariabili(chanel, valori);
					}
				}
			} catch (Exception e) {	
			}
		}
	}



}  
