package it.callite.autodialer.autodial;
import java.io.IOException;
import java.io.Serializable;
import it.asterisk.fastagi.DefaultAgiServer;
import it.callite.constants.ConstantsGlobal;
import it.callite.dao.AutodialerDao;
@SuppressWarnings("serial")
public class IVRServer extends Thread implements Serializable  {
	private final DefaultAgiServer agiServer;
	
	public IVRServer(AutodialerDao autodialerDao) {
		IVRManager manager = new IVRManager(autodialerDao);
		this.agiServer = new DefaultAgiServer(manager);
		this.agiServer.setPort(ConstantsGlobal.ivr_porta);
		//this.agiServer.setMappingStrategy(mappingStrategy);
	}
	
	public void setPoolSize(Integer numCanali) {
		this.agiServer.setPoolSize(numCanali);
		this.agiServer.setMaximumPoolSize(numCanali * ConstantsGlobal.poolSize);
	}
	
	public void run() {
		try {
			this.agiServer.startup();
		} catch (IllegalStateException e) {
		} catch (IOException e) {}
	}
	public void spegni() {
		if ( this.isAlive() )
			this.agiServer.shutdown();
	}
}