package it.callite.autodialer.autodial;

import java.util.Date;
import java.util.List;
import java.util.Map;
import java.util.Random;

import it.asterisk.fastagi.AgiChannel;
import it.asterisk.fastagi.AgiRequest;
import it.asterisk.fastagi.AgiScript;
import it.asterisk.fastagi.BaseAgiScript;
import it.callite.autodialer.controllo.CodaManager;
import it.callite.autodialer.controllo.CodaStatic;
import it.callite.chiamate.Chiamate;
import it.callite.constants.ConstantsGlobal;
import it.callite.constants.ConstantsMap;
import it.callite.dao.AutodialerDao;
import it.callite.model.AutoContatto;
import it.callite.model.Autodialer;
import it.callite.model.Campagna;
import it.callite.model.Contatto;
import it.callite.model.Inbound;
import it.callite.utility.AiutoCampagna;
import it.callite.utility.ApplicationUtil;
import it.callite.utility.CallerUtil;
import it.callite.utility.DatoAggiuntivo;
import it.callite.utility.IntervalloInbound;
import it.callite.utility.IntervalloInboundUtil;
import it.callite.utility.ParameterAutodialer;

public class InboundManager extends BaseAgiScript implements AgiScript {

	private AutodialerDao autodialerDao;

	public InboundManager(AutodialerDao autodialerDao) {
		super();
		this.autodialerDao = autodialerDao;
	}

	public void service(AgiRequest request, AgiChannel chanel){
		try {
			String [] args = request.getArguments();
			//${CLIENTE}#url
			String chP = ApplicationUtil.trimToNull(args[0]);
			String chDC = ApplicationUtil.trimToNull(args[1]);
			CallerUtil ca = new CallerUtil(chP);
			String chSC = ca.getPre();
			if(chDC != null && chSC != null) {
				String chD = "";
				String chS = "";
				String chiamante = null;
				String userfield = null;
				String cmp = null;
				String musicclass = null;
				String contextI = null;
				String contextA = null;
				String utente = null;
				String recall_callers = null;
				String recall_musicclass = null;
				Integer soloNumero = null;
				Boolean soloAttive = null;
				Boolean soloPubbliche = null;
				Boolean soloAperte = null;
				Boolean soloNuova = null;
				Boolean soloSquillo = null;
				Boolean soloHangup = null;
				Boolean soloUpdate = null;
				AiutoCampagna script = null;
				Autodialer autodialer = null;
				AutoContatto auto = null;
				Contatto contatto = null;
				ParameterAutodialer pa = new ParameterAutodialer(null, null, null);
				Inbound inbound = autodialerDao.getInbound(chDC);
				if(inbound != null) {
					chD = ApplicationUtil.clearChiamante(inbound.getExtension());
					chS = ApplicationUtil.clearChiamante(ApplicationUtil.uniforma(chSC, inbound.getRem_prefisso(), inbound.getAdd_prefisso()));
					soloAttive = ApplicationUtil.isTrue(inbound.getSoloAttive());
					soloPubbliche = ApplicationUtil.isTrue(inbound.getSoloPubbliche());
					soloAperte = ApplicationUtil.isTrue(inbound.getSoloAperte());
					soloNuova = ApplicationUtil.isTrue(inbound.getSoloNuova());
					soloSquillo = ApplicationUtil.isTrue(inbound.getSoloSquillo());
					soloHangup =  ApplicationUtil.isTrue(inbound.getSoloHangup());
					soloUpdate = ApplicationUtil.isTrue(inbound.getSoloUpdate());
					soloNumero = inbound.getSoloNumero();
					musicclass = inbound.getMusicclass();
					recall_callers = inbound.getRecall_callers();
					recall_musicclass = inbound.getRecall_musicclass();
					contextI = inbound.getContext();
					script = ApplicationUtil.isTrue(inbound.getEnabledScript()) ? new AiutoCampagna(inbound.getScript(), inbound.getScript_velocita(), inbound.getModulo(), inbound.getPdf()) : null;
				} else {
					chD = ApplicationUtil.clearChiamante(chDC);
					chS = ApplicationUtil.clearChiamante(chSC);
					soloAttive = Boolean.FALSE;
					soloPubbliche = Boolean.FALSE;
					soloAperte = Boolean.FALSE;
					soloNuova = Boolean.FALSE;
					soloSquillo = Boolean.FALSE;
					soloHangup =  Boolean.FALSE;
					soloUpdate =  Boolean.FALSE;
					soloNumero = 1;
					musicclass = null;
					recall_callers = null;
					recall_musicclass = null;
					contextI = null;
					script = null;
				}
				CodaManager codaManager = null;
				do {
					List<Campagna> ls = soloAttive ? autodialerDao.getProcessiInbound1(chD) : autodialerDao.getProcessiInbound2(chD);
					if(ApplicationUtil.notEmpty(ls)) {
						Campagna campagna = ls.get(new Random().nextInt(ls.size()));
						if(campagna != null ) {
							codaManager = Chiamate.getCodaProcessi().get(campagna);
							if(codaManager != null) {
								String tipo = ApplicationUtil.soloNumero(soloNumero);
								contatto = autodialerDao.getContatto(chS, campagna.getId(), soloPubbliche, soloAperte, tipo);
								if(contatto == null) {
									contatto = autodialerDao.salvaContatto(tipo, soloNuova, chS, campagna.getId(), campagna.getAutodialer().getEsitoInbound(), ca.getUrl());
								} else {
									if(ApplicationUtil.isTrue(soloUpdate)) {
										contatto = autodialerDao.updateContatto(contatto, null, campagna.getAutodialer().getEsitoInbound());
									}
								}
							}
						}
						if(codaManager != null && campagna != null && contatto != null) {
							autodialer = campagna.getAutodialer();
							cmp = campagna.getId().toString();
							autodialerDao.preparaContatto(contatto, chS, chD, recall_callers, recall_musicclass, script);

							auto = new AutoContatto(contatto, ConstantsMap.CHIAMATA_INBOUND, chS, true);
							auto.impostaUserfield();
							auto.incTentativi();
							Date data = ApplicationUtil.date();
							auto.setData_chiamata(data);
							auto.setHangup(true);
							auto.impostaCD1(chS, chD);
							auto.impostaCU(chanel.getUniqueId(), null);

							auto.setAutodialer(autodialer);
							Chiamate.getCodaAutodialer().put(contatto);
							codaManager.getChiamateInCorso().put(auto);
							CodaStatic.getChiamateInCorso().put(auto);

							codaManager.getAutodialerStatistiche().incInbound(data);
							codaManager.getAutodialerContatti().incInbound(auto, data);
							CodaStatic.getAutodialerStatistiche().incInbound(data);
							CodaStatic.getAutodialerContatti().incInbound(auto, data);

							codaManager.getAutodialerStatistiche().incTentate(data);
							codaManager.getAutodialerContatti().incTentate(auto, data);
							CodaStatic.getAutodialerStatistiche().incTentate(data);
							CodaStatic.getAutodialerContatti().incTentate(auto, data);

							chiamante = contatto.getId().toString();
							userfield = contatto.getUserfield();
							contextA = autodialer.getContext();
							pa = new ParameterAutodialer(autodialer.getTrunk(), contatto.getCallers(), contatto.getMusicclass());
						} 
					}
				} while (codaManager == null && soloSquillo);	
				chanel.setCallerId(chiamante != null ? (ConstantsGlobal.ingressoSMB + chiamante) : chS);
				String vtx = pa.getVtx().toString(); 
				String vrx = pa.getVrx().toString(); 
				String mc =  musicclass != null ? musicclass : pa.getMusicclass();
				ApplicationUtil.ascolto(chanel, mc);
				Boolean monitor = pa.getRegistrazione();
				boolean a = autodialerDao.getSip();
				ApplicationUtil.setVariable(true, chanel, ConstantsGlobal.CLIENTE, chS);
				ApplicationUtil.setVariable(true, chanel, ConstantsGlobal.CAMPAGNA, ApplicationUtil.toZero(cmp));
				ApplicationUtil.setVariable(true, chanel, ConstantsGlobal.ESTENSIONE, chD);
				ApplicationUtil.setVariable(true, chanel, ConstantsGlobal.UTENTE, ApplicationUtil.toZero(utente));
				ApplicationUtil.setVariable(true, chanel, ConstantsGlobal.VTX, vtx);
				ApplicationUtil.setVariable(true, chanel, ConstantsGlobal.VRX, vrx);
				ApplicationUtil.setVariable(true, chanel, ConstantsGlobal.MONITOR, ApplicationUtil.evalZero(monitor));
				ApplicationUtil.setVariable(true, chanel, ConstantsGlobal.OPPOSIZIONE, ApplicationUtil.evalZero(pa.getOpposizione()));
				ApplicationUtil.setVariable(true, chanel, ConstantsGlobal.TRUNKS, ApplicationUtil.formatTrunk(a, pa.getTrunk(), ""));
				ApplicationUtil.setVariable(true, chanel, ConstantsGlobal.PREFISSO, pa.getPrefisso());
				ApplicationUtil.setVariable(true, chanel, ConstantsGlobal.CONTATTO, ApplicationUtil.toZero(chiamante));
				ApplicationUtil.setVariable(true, chanel, ConstantsGlobal.MUSICA, mc);
				ApplicationUtil.setVariable(true, chanel, ConstantsGlobal.USERFIELD, ApplicationUtil.toZero(userfield));
				ApplicationUtil.setVariable(true, chanel, ConstantsGlobal.CALLERS,pa.getAntecall() + pa.getCallerId());
				ApplicationUtil.setVariable(true, chanel, ConstantsGlobal.NUMERO, "0");
				String touch = ApplicationUtil.impostaCDR(chanel, mc, vtx, vrx, chS, chD, chS, utente, chiamante, userfield, true);
				ApplicationUtil.impostaREC(chanel, touch, monitor);
				if(contextI != null || contextA != null) {
					if(contextI != null) {
						chanel.setContext(contextI);
					} else {
						chanel.setContext(contextA);
					}
					chanel.setExtension(ConstantsGlobal.extensionS);
					chanel.setPriority(ConstantsGlobal.priority + "");
				}
				if(inbound != null) {
					inbound.load();
					IntervalloInboundUtil util = inbound.getUtil();
					if(util != null) {
						List<IntervalloInbound> rules = util.getIntervallo();
						if(ApplicationUtil.notEmpty(rules)) {
							Map<String, DatoAggiuntivo> valori = autodialerDao.loadValori(contatto);
							if(autodialerDao.isVariabile()) {
								ApplicationUtil.impostaVariabili(chanel, valori);
							}
							if(contatto != null) {
								Chiamate.getCodaRisposta().put(contatto);
							}
							autodialerDao.intervalloInbound(chanel, rules, valori, auto, chS, chD);
							if(auto != null) {
								autodialerDao.chiudiContatto(auto, ConstantsMap.AGI_INBOUND, autodialer.getEsitoHangup());
							}
							if(soloHangup) {
								chanel.hangup();
							}
						}
					}
				}
			}
		} catch (Exception e) {	}
	}
}