package it.callite.autodialer.autodial;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.Random;

import it.asterisk.fastagi.AgiChannel;
import it.asterisk.fastagi.AgiRequest;
import it.asterisk.fastagi.AgiScript;
import it.asterisk.fastagi.BaseAgiScript;
import it.callite.chiamate.Chiamate;
import it.callite.constants.ConstantsGlobal;
import it.callite.dao.AutodialerDao;
import it.callite.model.Campagna;
import it.callite.model.Contatto;
import it.callite.model.EsitoChiamata;
import it.callite.model.Risposta;
import it.callite.model.sip.SipBuddies;
import it.callite.utility.ApplicationUtil;
import it.callite.utility.CallerUtil;
import it.callite.utility.DatoAggiuntivo;
import it.callite.utility.IntervalloInbound;
import it.callite.utility.IntervalloInboundUtil;
import it.callite.utility.ParameterAutodialer;

public class RispostaManager extends BaseAgiScript implements AgiScript {

	private AutodialerDao autodialerDao;

	public RispostaManager(AutodialerDao autodialerDao) {
		super();
		this.autodialerDao = autodialerDao;
	}

	public void service(AgiRequest request, AgiChannel chanel){
		try {
			String [] args = request.getArguments();
			//${CLIENTE}#url
			String chP = ApplicationUtil.trimToNull(args[0]);
			String chDC = ApplicationUtil.trimToNull(args[1]);
			CallerUtil ca = new CallerUtil(chP);
			String chSC = ca.getPre();
			if(chDC != null && chSC != null) {
				String chD = "";
				String chS = "";
				String musicclass = null;
				String contextI = null;
				String chiamante = null;
				String userfield = null;
				String cmp = null;
				String utente = null;
				Integer soloNumero = null;
				Boolean soloNuova = null;
				Boolean soloPubbliche = null;
				Boolean soloAperte = null;
				Boolean soloHangup = null;
				Boolean soloUpdate = null;
				SipBuddies trunk = null;
				Contatto contatto = null;
				List<Campagna> campagne = null;
				Risposta risposta = autodialerDao.getRisposta(chDC, true);
				if(risposta != null) {
					chD = ApplicationUtil.clearChiamante(risposta.getExtension());
					chS = ApplicationUtil.clearChiamante(ApplicationUtil.uniforma(chSC, risposta.getRem_prefisso(), risposta.getAdd_prefisso()));
					musicclass = risposta.getMusicclass();
					contextI = risposta.getContext();
					trunk = risposta.getTrunk();
					soloNumero = risposta.getSoloNumero();
					soloPubbliche = ApplicationUtil.isTrue(risposta.getSoloPubbliche());
					soloAperte = ApplicationUtil.isTrue(risposta.getSoloAperte());
					soloNuova = ApplicationUtil.isTrue(risposta.getSoloNuova());
					soloHangup =  ApplicationUtil.isTrue(risposta.getSoloHangup());
					soloUpdate =  ApplicationUtil.isTrue(risposta.getSoloUpdate());
					campagne = risposta.getCampagne();
				} else {
					chD = ApplicationUtil.clearChiamante(chDC);
					chS = ApplicationUtil.clearChiamante(chSC);
					musicclass = null;
					contextI = null;
					trunk = null;
					soloNumero = 1;
					soloNuova = Boolean.FALSE;
					soloPubbliche = Boolean.FALSE;
					soloAperte = Boolean.FALSE;
					soloHangup =  Boolean.FALSE;
					soloUpdate =  Boolean.FALSE;
					campagne = new ArrayList<Campagna>();
				}
				if(ApplicationUtil.notEmpty(campagne)) {
					Campagna campagna = campagne.get(new Random().nextInt(campagne.size()));
					if(campagna != null) {
						String tipo = ApplicationUtil.soloNumero(soloNumero);
						contatto = autodialerDao.getContatto(chS, campagna.getId(), soloPubbliche, soloAperte, tipo);
						EsitoChiamata esito = ApplicationUtil.esitoPredefinito(campagna);
						if(contatto == null) {
							contatto = autodialerDao.salvaContatto(tipo, soloNuova, chS, campagna.getId(), esito, ca.getUrl());
						} else {
							if(ApplicationUtil.isTrue(soloUpdate)) {
								contatto = autodialerDao.updateContatto(contatto, null, esito);
							}
						}
						if(contatto != null) {
							chiamante = contatto.getId().toString();
							cmp = contatto.getCampagna().getId().toString();
							userfield = contatto.getUserfield();
							autodialerDao.preparaContatto(contatto, chS, chD, null, null, null);
							Chiamate.getCodaRisposta().put(contatto);
						}
					}
				}
				ParameterAutodialer pa = new ParameterAutodialer(trunk, null, musicclass);
				chanel.setCallerId(chiamante != null ? (ConstantsGlobal.ingressoSMB + chiamante) : chS);
				String vtx = pa.getVtx().toString(); 
				String vrx = pa.getVrx().toString(); 
				String mc =  musicclass != null ? musicclass : pa.getMusicclass();
				ApplicationUtil.ascolto(chanel, mc);
				Boolean monitor = pa.getRegistrazione();
				boolean a = autodialerDao.getSip();
				ApplicationUtil.setVariable(true, chanel, ConstantsGlobal.CLIENTE, chS);
				ApplicationUtil.setVariable(true, chanel, ConstantsGlobal.CAMPAGNA, ApplicationUtil.toZero(cmp));
				ApplicationUtil.setVariable(true, chanel, ConstantsGlobal.ESTENSIONE, chD);
				ApplicationUtil.setVariable(true, chanel, ConstantsGlobal.UTENTE, ApplicationUtil.toZero(utente));
				ApplicationUtil.setVariable(true, chanel, ConstantsGlobal.VTX, vtx);
				ApplicationUtil.setVariable(true, chanel, ConstantsGlobal.VRX, vrx);
				ApplicationUtil.setVariable(true, chanel, ConstantsGlobal.MONITOR, ApplicationUtil.evalZero(monitor));
				ApplicationUtil.setVariable(true, chanel, ConstantsGlobal.OPPOSIZIONE, ApplicationUtil.evalZero(pa.getOpposizione()));
				ApplicationUtil.setVariable(true, chanel, ConstantsGlobal.TRUNKS, ApplicationUtil.formatTrunk(a, pa.getTrunk(), ""));
				ApplicationUtil.setVariable(true, chanel, ConstantsGlobal.PREFISSO, pa.getPrefisso());
				ApplicationUtil.setVariable(true, chanel, ConstantsGlobal.CONTATTO, ApplicationUtil.toZero(chiamante));
				ApplicationUtil.setVariable(true, chanel, ConstantsGlobal.MUSICA, mc);
				ApplicationUtil.setVariable(true, chanel, ConstantsGlobal.USERFIELD, ApplicationUtil.toZero(userfield));
				ApplicationUtil.setVariable(true, chanel, ConstantsGlobal.CALLERS,pa.getAntecall() + pa.getCallerId());
				ApplicationUtil.setVariable(true, chanel, ConstantsGlobal.NUMERO, "0");
				String touch = ApplicationUtil.impostaCDR(chanel, mc, vtx, vrx, chS, chD, chS, utente, chiamante, userfield, true);
				ApplicationUtil.impostaREC(chanel, touch, monitor);
				if(contextI != null) {
					chanel.setContext(contextI);
					chanel.setExtension(ConstantsGlobal.extensionS);
					chanel.setPriority(ConstantsGlobal.priority + "");
				}
				if(risposta != null) {
					risposta.load();
					IntervalloInboundUtil util = risposta.getUtil();
					if(util != null) {
						List<IntervalloInbound> rules = util.getIntervallo();
						if(ApplicationUtil.notEmpty(rules)) {
							Map<String, DatoAggiuntivo> valori = autodialerDao.loadValori(contatto);
							if(autodialerDao.isVariabile()) {
								ApplicationUtil.impostaVariabili(chanel, valori);
							}
							autodialerDao.intervalloInbound(chanel, rules, valori, null, chS, chD);
							if(soloHangup) {
								chanel.hangup();
							}
						}
					}
				}
			}
		} catch (Exception e) {	}
	}
}