package it.callite.autodialer.autodial;

import it.asterisk.fastagi.AgiChannel;
import it.asterisk.fastagi.AgiRequest;
import it.asterisk.fastagi.AgiScript;
import it.asterisk.fastagi.BaseAgiScript;
import it.callite.constants.ConstantsGlobal;
import it.callite.dao.AutodialerDao;
import it.callite.utility.ApplicationUtil;

public class SondaggioManager extends BaseAgiScript implements AgiScript {



	private AutodialerDao autodialerDao;

	public SondaggioManager(AutodialerDao autodialerDao) {
		super();
		this.autodialerDao = autodialerDao;
	}

	public void service(AgiRequest request, AgiChannel chanel)  {  
		try {
			String [] args = request.getArguments();
			String s = ApplicationUtil.trimToNull(args[0]);
			String u = ApplicationUtil.getVariable(chanel, ConstantsGlobal.UTENTE);
			String c = ApplicationUtil.getVariable(chanel, ConstantsGlobal.CONTATTO);
			String d = ApplicationUtil.getVariable(chanel, ConstantsGlobal.USERFIELD);
			if(u != null && ApplicationUtil.notZero(s) && ApplicationUtil.notZero(c)) {
				int ripetizioni = 3;
				String premuto = ConstantsGlobal.a_numeri;
				for(int i = 0; i < ripetizioni; i++) {
					Character e1 = ApplicationUtil.riproduciSuono(chanel, autodialerDao.getHome(), s, premuto);
					String exit1 = ApplicationUtil.convertC(e1);
					if(ApplicationUtil.isNotBlank(exit1) && premuto.contains(exit1)) {
						chanel.streamFile(ConstantsGlobal.path_sondaggio + ConstantsGlobal.path_audio_1);
						autodialerDao.sondaggio(c, u, exit1, d);
						chanel.streamFile(ConstantsGlobal.path_sondaggio + ConstantsGlobal.path_audio_3);
						break;
					} else {
						Character e2 = chanel.streamFile(ConstantsGlobal.path_sondaggio + ConstantsGlobal.path_audio_2, premuto);
						String exit2 = ApplicationUtil.convertC(e2);
						if(ApplicationUtil.isNotBlank(exit2) && premuto.contains(exit2)) {
							chanel.streamFile(ConstantsGlobal.path_sondaggio + ConstantsGlobal.path_audio_1);
							autodialerDao.sondaggio(c, u, exit2, d);
							chanel.streamFile(ConstantsGlobal.path_sondaggio + ConstantsGlobal.path_audio_3);
							break;
						}
					}
					ApplicationUtil.sleep(autodialerDao.sleepSuono());
				}
				chanel.hangup();
			}
		} catch (Exception e) {	
		}
	}



}  
