package it.callite.autodialer.coda;



import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Set;

import it.callite.model.AutoContatto;
import it.callite.model.Contatto;
import it.callite.utility.ApplicationUtil;


public class ChiamateAttive {

	private Map<Long, AutoContatto> data;
	private int capacity;


	public ChiamateAttive() {
		data = new HashMap<Long, AutoContatto>();
		capacity = 0;
	}

	public synchronized void clear() {
		data.clear();
		capacity = 0;
	}


	public synchronized AutoContatto get(Long id){
		return data.get(id);
	}

	public synchronized AutoContatto remove(Long id) {
		return data.remove(id);
	}

	public synchronized AutoContatto remove() {
		if(ApplicationUtil.notEmpty(data)) {
			return data.remove(data.keySet().iterator().next());
		}
		return null;
	}
	
	public synchronized void put(AutoContatto auto) {
		if(auto!=null) {
			data.put(auto.getContatto().getId(), auto);
		}
	}

	public synchronized void setCapacity(int cap) {
		capacity = cap;
	}

	public synchronized int getSize() {
		return data.size();
	}

	public synchronized int getCapacity() {
		return capacity;
	}

	public synchronized boolean isEmpty() {
		return data.size() == 0;
	}

	public synchronized boolean isFull() {
		return data.size() >= capacity;
	}
	
	public synchronized int getFree() {
		return capacity -  data.size();
	}

	public synchronized List<AutoContatto> list(){
		return new ArrayList<AutoContatto>(data.values());
	}

	public synchronized void removeContatti(List<Contatto> contatti) {
		if(ApplicationUtil.notEmpty(data) && ApplicationUtil.notEmpty(contatti)) {
			Set<Long> lngList = data.keySet();
			Set<Long> removeList = new HashSet<Long>();
			Iterator<Contatto> lnt = contatti.iterator();
			while (lnt.hasNext()) {
				Contatto tmp = lnt.next();
				if(lngList.contains(tmp.getId())) {
					removeList.add(tmp.getId());
				}
			}
			if(ApplicationUtil.notEmpty(removeList)) {
				data.keySet().removeAll(removeList);
			}
		}
	}
	
	public synchronized void remove(List<AutoContatto> contatti) {
		if(ApplicationUtil.notEmpty(data) && ApplicationUtil.notEmpty(contatti)) {
			Set<Long> lngList = data.keySet();
			Set<Long> removeList = new HashSet<Long>();
			Iterator<AutoContatto> lnt = contatti.iterator();
			while (lnt.hasNext()) {
				AutoContatto tmp = lnt.next();
				if(lngList.contains(tmp.getContatto().getId())) {
					removeList.add(tmp.getContatto().getId());
				}
			}
			if(ApplicationUtil.notEmpty(removeList)) {
				data.keySet().removeAll(removeList);
			}
		}
	}
}