package it.callite.autodialer.controllo;


import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

import it.callite.model.Campagna;
import it.callite.model.Utente;
import it.callite.utility.ApplicationUtil;
import it.callite.utility.UtenteLista;
import it.callite.utility.item.ListaSI;


public class CodaLista {
	private Map<Long, UtenteLista> data;

	public CodaLista() {
		data = new HashMap<Long, UtenteLista>();
	}

	public synchronized void clear() {
		data.clear();
	}
	
	private synchronized UtenteLista get(Long campagnaId) {
		UtenteLista mappa = data.get(campagnaId);
		if(mappa == null) {
			mappa = new UtenteLista();
		}
		return mappa;
	}
	
	private synchronized void put(Long campagnaId, UtenteLista mappa) {
		if(mappa == null) {
			mappa = new UtenteLista();
		}
		data.put(campagnaId, mappa);
	}

	public synchronized void addData(Campagna campagna, Utente utente, List<ListaSI> liste) {
		if(campagna != null && utente != null) {
			UtenteLista mappa = get(campagna.getId());
			mappa.put(utente.getId(), liste);
			put(campagna.getId(), mappa);
		}
	}

	public synchronized List<ListaSI> getData(Campagna campagna, Utente utente) {
		if(campagna != null && utente != null) {
			UtenteLista mappa = get(campagna.getId());
			return mappa.get(utente.getId());
		}
		return new ArrayList<ListaSI>();
	}

	public synchronized List<Long> getDataL(Campagna campagna, Utente utente) {
		List<ListaSI> lst = getData(campagna, utente);
		return ApplicationUtil.prendiIdListaSI(lst);
	}

	public synchronized List<Long> getDataL(Campagna campagna) {
		List<Long> liste = new ArrayList<Long>();
		List<Utente> utenti = CodaStatic.getCodaTeam().getUtenti(campagna);
		if(ApplicationUtil.notEmpty(utenti)) {
			Iterator<Utente> lnt = utenti.iterator();
			while (lnt.hasNext()) {
				List<Long> ls = getDataL(campagna, lnt.next());
				if(ApplicationUtil.empty(ls)) {
					return new ArrayList<Long>();
				} else {
					liste.addAll(ls);
				}
			}
		}
		return liste;
	}
}