package it.callite.autodialer.pubblico;

import it.callite.autodialer.controllo.CodaManager;
import it.callite.chiamate.Chiamate;
import it.callite.dao.AutodialerDao;
import it.callite.model.Campagna;


public class PubblicoAvvioProcesso extends Thread {

	private Campagna campagna;
	private AutodialerDao autodialerDao;
	private CodaManager codaManager;
	private Integer numCanali;

	public PubblicoAvvioProcesso(AutodialerDao autodialerDao, Campagna campagna, Integer numCanali) {
		this.campagna = campagna;
		this.autodialerDao = autodialerDao;
		this.numCanali = numCanali;
		this.codaManager = new CodaManager(campagna);
		Chiamate.getCodaProcessi().put(campagna, codaManager);
	}

	public void run() {
		if(campagna.getAutodialer() != null) {
			codaManager.setCaricato(true);
			codaManager.setEsaurito(false);
			new PubblicoSospendi(codaManager, autodialerDao, numCanali).start();
			new PubblicoConsumatoreContatto(codaManager, autodialerDao).start();
			new PubblicoProduttoreContattoSchedulato(codaManager, autodialerDao).start();
			new PubblicoProduttoreContattoRichiamo(codaManager, autodialerDao).start();
		}
	}

	public CodaManager getCodaManager(){
		return codaManager;
	}

}
