package it.callite.autodialer.pubblico;

import java.util.concurrent.Semaphore;

import it.callite.autodialer.controllo.CodaManager;
import it.callite.autodialer.controllo.CodaStatic;
import it.callite.constants.ConstantsGlobal;
import it.callite.constants.ConstantsMap;
import it.callite.dao.AutodialerDao;
import it.callite.model.Campagna;
import it.callite.utility.ApplicationUtil;

public class PubblicoConsumatoreContatto extends Thread {


	private Semaphore mutex = new Semaphore(1);
	private CodaManager codaManager;
	private AutodialerDao autodialerDao;


	public PubblicoConsumatoreContatto(CodaManager codaManager, AutodialerDao autodialerDao) {
		this.codaManager = codaManager;
		this.autodialerDao = autodialerDao;
	}

	public void run() {
		while(true) {
			try {
				if(ConstantsGlobal.semaforo) {
					mutex.acquire();
				}
				boolean test = autodialerDao.getAmiLogged() && !codaManager.isSospeso() && codaManager.isAvviato() && !codaManager.getChiamateAttive().isEmpty() && !CodaStatic.getChiamateInCorso().isFull() && !codaManager.getChiamateInCorso().isFull();
				if(test) {
					boolean attive = true;
					Campagna campagna = codaManager.getCampagna();
					if(campagna != null) {
						Integer crt = campagna.getAutodialer().getConsumer_modalita();
						if(ApplicationUtil.gtZero(crt)) {
							if(crt.equals(ConstantsMap.autodialer_modalita1)) {
								attive = CodaStatic.getCodaTeam().get(campagna).size() > codaManager.getChiamateInAttesa().getSize();
							} 
							if(crt.equals(ConstantsMap.autodialer_modalita2)) {
								attive = codaManager.getChiamateInAttesa().isEmpty();
							}
							if(crt.equals(ConstantsMap.autodialer_modalita3)) {
								attive = !CodaStatic.getCodaTeam().get(campagna).isEmpty();
							}
						}
						if(attive) {
							Integer v = campagna.getAutodialer().getConsumer_profondita();
							if(ApplicationUtil.gtZero(v)) {
								int free = codaManager.getChiamateInCorso().getFree();
								int a = (free > v) ? v : free;
								for (int i = 0; i < a; i++) {
									boolean b = autodialerDao.lanciaChiamata(codaManager);
									if(!b) {
										break;
									}
								}
							} else {
								autodialerDao.lanciaChiamata(codaManager);
							}
						}
					}
				} 
				sleep(autodialerDao.sleepConsumatore());
			} catch (Exception e) {
			} finally {
				if(ConstantsGlobal.semaforo) {
					mutex.release();
				}
			}
		}
	}


}


