package it.callite.autodialer.pubblico;

import java.util.concurrent.Semaphore;

import it.callite.autodialer.controllo.CodaManager;
import it.callite.constants.ConstantsGlobal;
import it.callite.constants.ConstantsMap;
import it.callite.dao.AutodialerDao;
import it.callite.model.AutoContatto;


public class PubblicoProduttoreContattoSchedulato extends Thread {


	private Semaphore mutex = new Semaphore(1);
	private CodaManager codaManager;
	private AutodialerDao autodialerDao;


	public PubblicoProduttoreContattoSchedulato(CodaManager codaManager, AutodialerDao autodialerDao) {
		this.codaManager = codaManager;
		this.autodialerDao = autodialerDao;
	}

	public void run() {

		while(true) {
			try {
				if(ConstantsGlobal.semaforo) {
					mutex.acquire();
				}
				boolean test = !codaManager.isSospeso() && codaManager.isAvviato() && !codaManager.getChiamateSchedulate().isEmpty() && !codaManager.getChiamateAttive().isFull();
				if(test) {
					AutoContatto auto = codaManager.getChiamateSchedulate().remove();
					if(auto!=null) {
						auto.setStato(ConstantsMap.CHIAMATA_ATTIVA);
						auto.clear();
						codaManager.getChiamateAttive().put(auto);
					}
				} 
				codaManager.setStarted2(true);
				sleep(autodialerDao.sleepSchedulato());

			} catch (Exception e) {
			} finally {
				if(ConstantsGlobal.semaforo) {
					mutex.release();
				}
			}
		}
	}

}
