package it.callite.autoinvio.email;

import it.callite.autoinvio.coda.CodaManagerContatti;
import it.callite.constants.ConstantsGlobal;
import it.callite.dao.AutoInvioDao;
import it.callite.model.AutoProcessEmail;
import it.callite.model.Contatto;
import it.callite.utility.ApplicationUtil;

import java.util.concurrent.Semaphore;

public class EmailConsumatoreContatto extends Thread {


	private Semaphore mutex = new Semaphore(1);
	private CodaManagerContatti codaManagerContatti;
	private AutoInvioDao autoInvioDao;
	private AutoProcessEmail ape;


	public EmailConsumatoreContatto(CodaManagerContatti codaManagerContatti, AutoInvioDao autoInvioDao, AutoProcessEmail ape){
		this.codaManagerContatti = codaManagerContatti;
		this.autoInvioDao = autoInvioDao;
		this.ape = ape;
	}

	public void run() {
		while(true) {
			boolean s = autoInvioDao.sleepEmailSemaforo();
			try {
				if(s) {
					mutex.acquire();
				}
				boolean test = !codaManagerContatti.isSospeso() && !codaManagerContatti.getCodaContattiTotali().isEmpty();
				if(test) {
					Contatto contatto = codaManagerContatti.getCodaContattiTotali().remove();
					if(contatto!=null) {
						Integer auto = autoInvioDao.inviaEmail(contatto, ape.getEmailTemplate(), codaManagerContatti.getMailSupport());
						if(ApplicationUtil.eq(auto, ConstantsGlobal.INVIATA)) {
							codaManagerContatti.getCodaContattiRiusciti().put(contatto);
						} else {
							codaManagerContatti.getCodaContattiFalliti().put(contatto);
						}
					}
				} 
			} catch (Exception e) {
			} finally {
				if(s) {
					mutex.release();
				}
			}
		}
	}

}


