package it.callite.autoinvio.email;

import java.util.concurrent.Semaphore;

import it.callite.autoinvio.coda.CodaManagerContatti;
import it.callite.dao.AutoInvioDao;
import it.callite.model.AutoProcessEmail;
import it.callite.model.Contatto;
import it.callite.utility.ApplicationUtil;


public class EmailProduttoreContatto extends Thread {


	private Semaphore mutex = new Semaphore(1);
	private CodaManagerContatti codaManagerContatti;
	private AutoProcessEmail ape;
	private AutoInvioDao autoInvioDao;


	public EmailProduttoreContatto(CodaManagerContatti codaManagerContatti, AutoInvioDao autoInvioDao, AutoProcessEmail ape){
		this.codaManagerContatti = codaManagerContatti;
		this.autoInvioDao = autoInvioDao;
		this.ape = ape;
	}

	public void run() {

		while(true) {
			boolean s = autoInvioDao.sleepEmailSemaforo();
			try {
				if(s) {
					mutex.acquire();
				}
				boolean test = !codaManagerContatti.isSospeso();
				if(test && ApplicationUtil.isTrue(ape.getStatoAttiva())) {
					Contatto contatto = autoInvioDao.getContattoEmail(ape.getCampagna());
					if(contatto!=null) {
						codaManagerContatti.getCodaContattiTotali().put(contatto);
					} 
				}
			} catch (Exception e) {
			} finally {
				if(s) {
					mutex.release();
				}
			}
		}
	}
}
