package it.callite.autoinvio.telecom;

import it.callite.autoinvio.coda.CodaManagerContatti;
import it.callite.dao.AutoInvioDao;
import it.callite.model.AutoProcessTelecom;


public class ContattoAvvioProcessoTelecom extends Thread {


	private AutoProcessTelecom ape;
	private AutoInvioDao autoInvioDao;
	private CodaManagerContatti codaManagerContatti;

	public AutoProcessTelecom getAutoProcessTelecom() {
		return ape;
	}

	public ContattoAvvioProcessoTelecom(AutoInvioDao autoInvioDao, AutoProcessTelecom ape) {
		this.ape = ape;
		this.autoInvioDao = autoInvioDao;
		this.codaManagerContatti = new CodaManagerContatti();
	}

	public void run() {
		
		codaManagerContatti.caricato();

		new TelecomConsumatoreContatto(codaManagerContatti, autoInvioDao, ape).start();
		new TelecomProduttoreContatto(codaManagerContatti, autoInvioDao, ape).start();
	}

	public CodaManagerContatti getCodaManagerContatti(){
		return codaManagerContatti;
	}

	public void sospendi(){
		this.ape.setAttivo(false);
		this.codaManagerContatti.sospendi();
	}

	public void avvia(AutoProcessTelecom apeN){
		if(apeN != null) {
			this.ape = apeN;
		}
		this.ape.setAttivo(true);
		this.codaManagerContatti.avvia();
	}

	public void ricarica(AutoProcessTelecom apeN){
		this.ape = apeN;
		this.ape.setAttivo(false);
		this.codaManagerContatti.sospendi();
		this.ape.setAttivo(true);
		this.codaManagerContatti.avvia();
	}
	
	public void replace(AutoProcessTelecom apeN){
		this.ape = apeN;
	}
}
