package it.callite.chiamate;



import java.util.ArrayList;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.Set;

import it.callite.model.Contatto;
import it.callite.model.Utente;
import it.callite.model.report.ElencoEsitoReport;
import it.callite.utility.ApplicationUtil;
import it.callite.utility.ElencoEsito;


public class CodaEsiti {


	private List<ElencoEsito> data;

	public CodaEsiti() {
		data = new ArrayList<ElencoEsito>();
	}

	public synchronized void clear() {
		data.clear();
	}

	public synchronized void add(Utente utente, Contatto contatto){
		ElencoEsito e = new ElencoEsito(utente, contatto);
		int i = data.indexOf(e);
		if(i > -1) {
			ElencoEsito a = data.get(i);
			a.incConteggio();
		} else {
			data.add(e);
		}
	}


	public synchronized List<ElencoEsitoReport> get(boolean operatore, List<Long> campagne) {	
		List<ElencoEsitoReport> lsch = new ArrayList<ElencoEsitoReport>();
		if(ApplicationUtil.notEmpty(data)) {
			Iterator<ElencoEsito> lnt = data.iterator();
			while (lnt.hasNext()) {
				ElencoEsito e = lnt.next();
				if(e.getOperatore().booleanValue() == operatore) {
					if(campagne != null && campagne.contains(e.getCampagna().getId())) {
						ElencoEsitoReport c = new ElencoEsitoReport(e);
						if(!lsch.contains(c)) {
							lsch.add(c);
						} else {
							int i = lsch.indexOf(c);
							if(i > -1) {
								ElencoEsitoReport a = lsch.get(i);
								a.setConteggio(a.getConteggio() + c.getConteggio());
							}
						}
					}
				}
			}		
		}
		return lsch;
	}


	public synchronized List<ElencoEsitoReport> get(List<Long> campagne) {	
		List<ElencoEsitoReport> lsch = new ArrayList<ElencoEsitoReport>();
		if(ApplicationUtil.notEmpty(data)) {
			Iterator<ElencoEsito> lnt = data.iterator();
			while (lnt.hasNext()) {
				ElencoEsito e = lnt.next();
				if(campagne != null && campagne.contains(e.getCampagna().getId())) {
					ElencoEsitoReport c = new ElencoEsitoReport(e);
					if(!lsch.contains(c)) {
						lsch.add(c);
					} else {
						int i = lsch.indexOf(c);
						if(i > -1) {
							ElencoEsitoReport a = lsch.get(i);
							a.setConteggio(a.getConteggio() + c.getConteggio());
						}
					}
				}
			}		
		}
		return lsch;
	}


	public synchronized void reset(boolean operatore, List<Long> campagne) {
		if(ApplicationUtil.notEmpty(data)) {
			Set<ElencoEsito> removeList = new HashSet<ElencoEsito>();
			Iterator<ElencoEsito> lnt = data.iterator();
			while (lnt.hasNext()) {
				ElencoEsito e = lnt.next();
				if(e.getOperatore().booleanValue() == operatore) {
					if(campagne != null && campagne.contains(e.getCampagna().getId())) {
						removeList.add(e);
					}
				}
			}
			if(ApplicationUtil.notEmpty(removeList)) {
				data.removeAll(removeList);
			}
		}
	}



	public synchronized void reset(List<Long> campagne) {
		if(ApplicationUtil.notEmpty(data)) {
			Set<ElencoEsito> removeList = new HashSet<ElencoEsito>();
			Iterator<ElencoEsito> lnt = data.iterator();
			while (lnt.hasNext()) {
				ElencoEsito e = lnt.next();
				if(campagne != null && campagne.contains(e.getCampagna().getId())) {
					removeList.add(e);
				}
			}
			if(ApplicationUtil.notEmpty(removeList)) {
				data.removeAll(removeList);
			}
		}
	}

	public synchronized List<ElencoEsito> list(){
		return data;
	}

}