package it.callite.chiamate;



import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import it.callite.utility.ApplicationUtil;
import it.callite.utility.Firewall;


public class CodaIP {

	private List<Firewall> rules;

	public CodaIP() {
		rules = new ArrayList<Firewall>();
	}
	
	public synchronized boolean contains(Firewall fw) {
		return rules.contains(fw);
	}
	
	public synchronized void put(Firewall fw) {
		rules.add(fw);
	}
	
	public synchronized void remove(Firewall fw) {
		rules.remove(fw);
	}

	public synchronized List<Firewall> list() {
		return rules;
	}
	
	public synchronized void clear() {
		rules.clear();
	}
	
	public synchronized List<Firewall> utente() {
		List<Firewall> list = new ArrayList<Firewall>();
		if(ApplicationUtil.notEmpty(rules)) {
			Iterator<Firewall> lnt = rules.iterator();
			while (lnt.hasNext()) {
				Firewall tmp = lnt.next();
				if(tmp.isUtente()) {
					list.add(tmp);
				}
			}
		}
		return list;
	}
	
}