package it.callite.chiamate;



import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Set;

import it.callite.utility.ApplicationUtil;
import it.callite.utility.LoggerLogin;


public class CodaLogin {

	private Map<LoggerLogin, List<LoggerLogin>> data;

	public CodaLogin() {
		data = new HashMap<LoggerLogin, List<LoggerLogin>>();
	}

	public synchronized void clear() {
		data.clear();
	}


	public synchronized void remove(LoggerLogin ld) {
		LoggerLogin ll = new LoggerLogin(ld.getUsername(), ld.getIp());
		List<LoggerLogin> o =	data.get(ll);
		if(o == null) {
			o = new ArrayList<LoggerLogin>();
		}
		o.remove(new LoggerLogin(ld.getMotivo(), ld.getData()));
	}

	public synchronized void loginSuccess(String username, String ip) {
		LoggerLogin ll = new LoggerLogin(username, ip);
		data.remove(ll);
	}

	public synchronized int get(String ip) {
		int c = 0;
		if(ApplicationUtil.notEmpty(data)) {
			Set<LoggerLogin> lngList = data.keySet();
			Iterator<LoggerLogin> lnt = lngList.iterator();
			while (lnt.hasNext()) {
				LoggerLogin tmp = lnt.next();
				if(tmp != null && tmp.getIp().equals(ip)) {
					List<LoggerLogin> o = data.get(tmp);
					if(o != null) {
						c += o.size();
					}
				}
			}
		}
		return c;
	}

	public synchronized void loginFailure(String username, String ip, String motivo) {
		LoggerLogin ll = new LoggerLogin(username, ip);
		List<LoggerLogin> o =	data.get(ll);
		if(o == null) {
			o = new ArrayList<LoggerLogin>();
		}
		o.add(new LoggerLogin(motivo, ApplicationUtil.date()));
		data.put(ll, o);
	}


	public synchronized int getSize() {
		return data.size();
	}

	public synchronized Set<LoggerLogin> keySet() {
		return data.keySet();
	}

	public synchronized List<LoggerLogin> table() {
		List<LoggerLogin> table = new ArrayList<LoggerLogin>();
		if(ApplicationUtil.notEmpty(data)) {
			Set<LoggerLogin> dataList = data.keySet();
			Iterator<LoggerLogin> dataIt = dataList.iterator();
			while (dataIt.hasNext()) {
				LoggerLogin tmp = dataIt.next();
				List<LoggerLogin> o = data.get(tmp);
				if(ApplicationUtil.notEmpty(o)) {
					Iterator<LoggerLogin> userIt = o.iterator();
					while (userIt.hasNext()) {
						LoggerLogin llg = userIt.next();
						table.add(new LoggerLogin(tmp.getUsername(), tmp.getIp(), llg.getMotivo(), llg.getData()));
					}
				}
			}
		}
		return table;
	}

}