package it.callite.chiamate;


import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Set;

import it.callite.utility.InfoQueue;
import it.callite.utility.QueueChiamata;
import it.callite.utility.QueueUtente;


public class CodaQueue {

	private Map<String, InfoQueue> data;

	public CodaQueue() {
		data = new HashMap<String, InfoQueue>();
	}

	public synchronized void clear() {
		data.clear();
	}

	public synchronized Map<String, InfoQueue> getData() {
		return data;
	}

	public void setData(Map<String, InfoQueue> data) {
		this.data = data;
	}
	
	public void putC(String coda, String uniqueId, QueueChiamata chiamata){
		InfoQueue info = data.get(coda);
		if(info ==  null) {
			info = new InfoQueue();
			data.put(coda, info);
		} 
		info.putC(uniqueId, chiamata);
	}
	
	public void putU(String coda, String interno, QueueUtente utente){
		InfoQueue info = data.get(coda);
		if(info ==  null) {
			info = new InfoQueue();
			data.put(coda, info);
		} 
		info.putU(interno, utente);
	}

	public synchronized QueueChiamata removeC(String coda, String uniqueId){
		InfoQueue info = data.get(coda);
		if(info !=  null) {
			return info.removeC(uniqueId);
		} 
		return null;
	}
	
	public synchronized QueueUtente removeU(String coda, String interno){
		InfoQueue info = data.get(coda);
		if(info !=  null) {
			return info.removeU(interno);
		} 
		return null;
	}

	public synchronized int getSize() {
		return data.size();
	}
	
	public synchronized Set<String> getKey() {
		return data.keySet();
	}

	public synchronized boolean isEmpty() {
		return data.size() == 0;
	}

	public synchronized List<InfoQueue> list(){
		return new ArrayList<InfoQueue>(data.values());
	}

	


}