package it.callite.chiamate;


import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Set;

import it.callite.utility.ApplicationUtil;
import it.callite.utility.InfoSpia;


public class CodaSpia {

	private Map<String, InfoSpia> data;

	public CodaSpia() {
		data = new HashMap<String, InfoSpia>();
	}

	public synchronized void clear() {
		data.clear();
	}

	public synchronized InfoSpia get(String uniqueId){
		return data.get(uniqueId);
	}

	public void put(String uniqueId, InfoSpia utente){
		data.put(uniqueId, utente);
	}

	public synchronized void remove(String uniqueId){
		data.remove(uniqueId);
	}

	public synchronized int getSize() {
		return data.size();
	}

	public synchronized boolean isEmpty() {
		return data.size() == 0;
	}

	public synchronized List<InfoSpia> list(){
		return new ArrayList<InfoSpia>(data.values());
	}

	public synchronized boolean spiato(String spiato)  {
		if(ApplicationUtil.notEmpty(data)) {
			Set<String> lngList = data.keySet();
			Iterator<String> lnt = lngList.iterator();
			while (lnt.hasNext()) {
				String uniqueId = lnt.next();
				InfoSpia is =  data.get(uniqueId);
				if(is != null && is.getIntervento().equals(spiato)) {
					return true;
				}
			}
		}
		return false;
	}
	
	public synchronized void rimuovi(String interno)  {
		Set<String> removeList = new HashSet<String>();
		if(ApplicationUtil.notEmpty(data)) {
			Set<String> lngList = data.keySet();
			Iterator<String> lnt = lngList.iterator();
			while (lnt.hasNext()) {
				String uniqueId = lnt.next();
				InfoSpia is =  data.get(uniqueId);
				if(is != null && (is.getInterno().equals(interno) || is.getIntervento().equals(interno))) {
					removeList.add(uniqueId);
				}
			}
			if(ApplicationUtil.notEmpty(removeList)) {
				data.keySet().removeAll(removeList);
			}
		}
	}

}