package it.callite.chiamate.sincronizzazione;



import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Set;

import it.callite.constants.ConstantsGlobal;
import it.callite.model.Contratto;
import it.callite.model.Utente;
import it.callite.utility.ApplicationUtil;
import it.callite.utility.sincronizzazione.InfoContratto;


public class CodaSincroniaContratti {

	private Map<Long, InfoContratto> data;

	public CodaSincroniaContratti() {
		data = new HashMap<Long, InfoContratto>();
	}

	public void clear() {
		data.clear();
	}

	public void remove(Long id) {
		data.remove(id);
	}

	public InfoContratto get(Long id) {
		return	data.get(id);
	}

	public void put(Long id, InfoContratto ic) {
		data.put(id, ic);
	}

	public int getSize() {
		return data.size();
	}

	public Set<Long> keySet() {
		return data.keySet();
	}

	public void timeout(Long t) {
		if (ApplicationUtil.notEmpty(data) && ApplicationUtil.gtZero(t)) {
			long time = System.currentTimeMillis();
			Set<Long> lngList = data.keySet();
			Set<Long> removeList = new HashSet<Long>();
			Iterator<Long> lnt = lngList.iterator();
			while (lnt.hasNext()) {
				InfoContratto info = data.get(lnt.next());
				if (info!= null && info.getTempoApertura() != null && ((time - info.getTempoApertura().longValue()) > (t.longValue() + ConstantsGlobal.timeoutSincronia))) {
					removeList.add(info.getItem().getId());
				}
			}
			if(ApplicationUtil.notEmpty(removeList)) {
				data.keySet().removeAll(removeList);
			}
		}
	}
	
	public List<InfoContratto> list(Utente t) {
		List<InfoContratto> ls = new ArrayList<InfoContratto>();
		if (ApplicationUtil.notEmpty(data) && t != null) {
			Set<Long> lngList = data.keySet();
			Iterator<Long> lnt = lngList.iterator();
			while (lnt.hasNext()) {
				InfoContratto info = data.get(lnt.next());
				if (info!= null && !ls.contains(info) && info.getUtente().equals(t)) {
					ls.add(info);
				}
			}
		}
		return ls;
	}
	
	public boolean contains(Long contratto){
		if (ApplicationUtil.notEmpty(data) && ApplicationUtil.gtZero(contratto)) {
			return data.containsKey(contratto);
		}
		return false;
	}

	public void removeContratti(List<Contratto> contratti) {
		if(ApplicationUtil.notEmpty(data) && ApplicationUtil.notEmpty(contratti)) {
			Set<Long> lngList = data.keySet();
			Set<Long> removeList = new HashSet<Long>();
			Iterator<Contratto> lnt = contratti.iterator();
			while (lnt.hasNext()) {
				Contratto tmp = lnt.next();
				if(lngList.contains(tmp.getId())) {
					removeList.add(tmp.getId());
				}
			}
			if(ApplicationUtil.notEmpty(removeList)) {
				data.keySet().removeAll(removeList);
			}
		}
	}



	public List<InfoContratto> list(){
		return new ArrayList<InfoContratto>(data.values());
	}

	public void update(Long id) {
		InfoContratto ic = data.get(id);
		if (ic != null) {
			long time = System.currentTimeMillis();
			ic.setTempoApertura(time);
			//ic.setOperatore(user);
			//put(id, ic);
		} 
	}

	

}