package it.callite.column;

import java.io.Serializable;
import java.util.Iterator;
import java.util.Set;

import it.callite.column.generic.GenericColumn;
import it.callite.constants.ConstantsColumn;
import it.callite.constants.ConstantsMap;

public class AnagraficaColumn extends GenericColumn implements Serializable {
	
	private static final long serialVersionUID = 1L;

	
	public AnagraficaColumn() {
		doReset();
	}
	
	public Set<String> getKeyIndirizzoLegale() {
		return ConstantsMap.mapIndirizzoLegale;
	}
	
	public Set<String> getKeyIndirizzoOperativo() {
		return ConstantsMap.mapIndirizzoOperativo;
	}
	public Set<String> getKeyConsenso() {
		return ConstantsMap.mapConsenso;
	}
	public String doReset(){
		reset();
		
		Iterator<String> indirizzoLegaleIter = getKeyIndirizzoLegale().iterator();
		while(indirizzoLegaleIter.hasNext()) {
			add(ConstantsMap.indirizzo_legale, indirizzoLegaleIter.next(), false);
		}
		
		Iterator<String> indirizzoOperativoIter = getKeyIndirizzoOperativo().iterator();
		while(indirizzoOperativoIter.hasNext()) {
			add(ConstantsMap.indirizzo_operativo, indirizzoOperativoIter.next(), false);
		}
		
		Iterator<String> consensoIter = getKeyConsenso().iterator();
		while(consensoIter.hasNext()) {
			add(ConstantsMap.consenso, consensoIter.next(), false);
		}
		
		add(ConstantsColumn.id,						true);
		add(ConstantsColumn.data_creazione, 		false);
		add(ConstantsColumn.sorgente,			false);
		add(ConstantsColumn.denominazione, 			true);
		add(ConstantsColumn.nome_completo, 			true);
		add(ConstantsColumn.ragione_sociale, 		true);
		add(ConstantsColumn.cognome, 				false);
		add(ConstantsColumn.nome, 					false);
		add(ConstantsColumn.telefono_fisso, 		false);
		add(ConstantsColumn.telefono_mobile, 		false);
		add(ConstantsColumn.telefono_fax, 			false);
		add(ConstantsColumn.telefono_altro, 		false);
		add(ConstantsColumn.email, 					false);
		add(ConstantsColumn.codice_fiscale,			false);
		add(ConstantsColumn.partita_iva, 			false);
		add(ConstantsColumn.luogo_nascita,			false);
		add(ConstantsColumn.date_nascita,			false);
		add(ConstantsColumn.link,					false);
		add(ConstantsColumn.pf,						false);
		add(ConstantsColumn.maschio, 				false);
		add(ConstantsColumn.settore,				false);
		add(ConstantsColumn.nota, 					false);
		addSeparatore("1");
		add(ConstantsColumn.allegati, 				false);
		
		
		ordinamento(ConstantsColumn.id);
		ordinamento(ConstantsColumn.data_creazione);
		ordinamento(ConstantsColumn.sorgente);
		ordinamento(ConstantsColumn.nome_completo);
		ordinamento(ConstantsColumn.ragione_sociale);
		ordinamento(ConstantsColumn.cognome);
		ordinamento(ConstantsColumn.nome);
		ordinamento(ConstantsColumn.telefono_fisso);
		ordinamento(ConstantsColumn.telefono_mobile);
		ordinamento(ConstantsColumn.telefono_fax);
		ordinamento(ConstantsColumn.telefono_altro);
		ordinamento(ConstantsColumn.email);
		ordinamento(ConstantsColumn.codice_fiscale);
		ordinamento(ConstantsColumn.partita_iva);
		ordinamento(ConstantsColumn.luogo_nascita);
		ordinamento(ConstantsColumn.date_nascita);
		ordinamento(ConstantsColumn.link);
		ordinamento(ConstantsColumn.pf);
		ordinamento(ConstantsColumn.maschio);
		ordinamento(ConstantsColumn.settore);
		ordinamento(ConstantsColumn.consenso_tfisso);
		ordinamento(ConstantsColumn.consenso_tmobile);
		ordinamento(ConstantsColumn.consenso_tfax);
		ordinamento(ConstantsColumn.consenso_taltro);
		ordinamento(ConstantsColumn.consenso_email);
		ordinamento(ConstantsColumn.consenso_rmail);
		return getAction();
	}
	
	
}
