package it.callite.column;

import java.io.Serializable;
import java.util.Iterator;
import java.util.Set;

import it.callite.column.generic.GenericColumn;
import it.callite.constants.ConstantsColumn;
import it.callite.constants.ConstantsMap;

public class AppuntamentoColumn  extends GenericColumn implements Serializable {
	
	private static final long serialVersionUID = 1L;

	
	public AppuntamentoColumn() {
		doReset();
	}
	
	public Set<String> getKeyContatto() {
		return ConstantsMap.mapContatto;
	}
	public Set<String> getKeyAnagrafica() {
		return ConstantsMap.mapAnagrafica;
	}
	
	public Set<String> getKeyIndirizzoLegale() {
		return ConstantsMap.mapIndirizzoLegale;
	}
	
	public Set<String> getKeyIndirizzoOperativo() {
		return ConstantsMap.mapIndirizzoOperativo;
	}
	public Set<String> getKeyConsenso() {
		return ConstantsMap.mapConsenso;
	}
	
	public String doReset(){
		reset();
		
		Iterator<String> contattoIter = getKeyContatto().iterator();
		while(contattoIter.hasNext()) {
			add(ConstantsMap.contatto, contattoIter.next(), false);
		}
		
		
		Iterator<String> anagraficaIter = getKeyAnagrafica().iterator();
		while(anagraficaIter.hasNext()) {
			add(ConstantsMap.anagrafica, anagraficaIter.next(), false);
		}
		
		Iterator<String> indirizzoLegaleIter = getKeyIndirizzoLegale().iterator();
		while(indirizzoLegaleIter.hasNext()) {
			add(ConstantsMap.indirizzo_legale, indirizzoLegaleIter.next(), false);
		}
		
		Iterator<String> indirizzoOperativoIter = getKeyIndirizzoOperativo().iterator();
		while(indirizzoOperativoIter.hasNext()) {
			add(ConstantsMap.indirizzo_operativo, indirizzoOperativoIter.next(), false);
		}
		
		Iterator<String> consensoIter = getKeyConsenso().iterator();
		while(consensoIter.hasNext()) {
			add(ConstantsMap.consenso, consensoIter.next(), false);
		}
		
		add(ConstantsColumn.id,					true);
		add(ConstantsColumn.data_creazione,		true);
		add(ConstantsColumn.bloccato,			true);
		add(ConstantsColumn.indirizzo,			true);
		add(ConstantsColumn.localizzazione,  	false);
		add(ConstantsColumn.nota, 				false);
		add(ConstantsColumn.anagrafica,			true);
		add(ConstantsColumn.telefono, 			false);
		add(ConstantsColumn.email, 				false);
		add(ConstantsColumn.link, 				false);
		add(ConstantsColumn.dati_base,			false);
		add(ConstantsColumn.dati_fiscali,		false);
		add(ConstantsColumn.agente, 			true);
		add(ConstantsColumn.operatore,			true);
		add(ConstantsColumn.utente,				false);
		add(ConstantsColumn.esito, 				true);
		add(ConstantsColumn.stato, 				false);
		add(ConstantsColumn.data_conferma, 		false);
		add(ConstantsColumn.data_esito, 		false);
		add(ConstantsColumn.data_stato, 		false);
		add(ConstantsColumn.data_lavorazione,   false);
		add(ConstantsColumn.data_appuntamento, 	true);
		add(ConstantsColumn.ora_inizio, 		true);
		add(ConstantsColumn.ora_fine, 			true);
		addSeparatore("1");
		add(ConstantsColumn.storia, 			false);
		add(ConstantsColumn.allegati, 			false);

		
		ordinamento(ConstantsColumn.id);
		ordinamento(ConstantsColumn.data_creazione);
		ordinamento(ConstantsColumn.bloccato);
		ordinamento(ConstantsColumn.stato);
		ordinamento(ConstantsColumn.localizzazione);
		ordinamento(ConstantsColumn.data_inizio);
		ordinamento(ConstantsColumn.data_fine);
		ordinamento(ConstantsColumn.data_conferma);
		ordinamento(ConstantsColumn.data_esito);
		ordinamento(ConstantsColumn.data_stato);
		ordinamento(ConstantsColumn.data_lavorazione);
		return getAction();
	}

}
