package it.callite.column;

import java.io.Serializable;
import java.util.Iterator;
import java.util.Set;

import it.callite.column.generic.GenericColumn;
import it.callite.constants.ConstantsColumn;
import it.callite.constants.ConstantsMap;

public class ContattoColumn  extends GenericColumn implements Serializable {

	private static final long serialVersionUID = 1L;


	public ContattoColumn() {
		doReset();
	}
	
	public Set<String> getKeyAnagrafica() {
		return ConstantsMap.mapAnagrafica;
	}
	
	public Set<String> getKeyIndirizzoLegale() {
		return ConstantsMap.mapIndirizzoLegale;
	}
	
	public Set<String> getKeyIndirizzoOperativo() {
		return ConstantsMap.mapIndirizzoOperativo;
	}
	public Set<String> getKeyConsenso() {
		return ConstantsMap.mapConsenso;
	}
	
	public String doReset(){
		reset();
		
		Iterator<String> anagraficaIter = getKeyAnagrafica().iterator();
		while(anagraficaIter.hasNext()) {
			add(ConstantsMap.anagrafica, anagraficaIter.next(), false);
		}
		
		Iterator<String> indirizzoLegaleIter = getKeyIndirizzoLegale().iterator();
		while(indirizzoLegaleIter.hasNext()) {
			add(ConstantsMap.indirizzo_legale, indirizzoLegaleIter.next(), false);
		}
		
		Iterator<String> indirizzoOperativoIter = getKeyIndirizzoOperativo().iterator();
		while(indirizzoOperativoIter.hasNext()) {
			add(ConstantsMap.indirizzo_operativo, indirizzoOperativoIter.next(), false);
		}
		
		Iterator<String> consensoIter = getKeyConsenso().iterator();
		while(consensoIter.hasNext()) {
			add(ConstantsMap.consenso, consensoIter.next(), false);
		}
		
		add(ConstantsColumn.id,						true);
		add(ConstantsColumn.data_creazione, 		true);
		add(ConstantsColumn.bloccato, 				true);
		add(ConstantsColumn.campagna, 				true);
		add(ConstantsColumn.lista, 					true);
		add(ConstantsColumn.anagrafica, 			true);
		add(ConstantsColumn.nota, 					false);
		add(ConstantsColumn.tipo, 					false);
		add(ConstantsColumn.utile, 					false);
		add(ConstantsColumn.positivo, 				false);
		add(ConstantsColumn.chiuso, 				false);
		add(ConstantsColumn.data_archiviazione, 	false);
		add(ConstantsColumn.data_presentazione, 	true);
		add(ConstantsColumn.data_lavorazione, 		false);
		add(ConstantsColumn.esito_chiamata, 		true);
		add(ConstantsColumn.esito_archiviazione, 	true);
		add(ConstantsColumn.esito_generale, 		false);
		add(ConstantsColumn.telefono, 				false);
		add(ConstantsColumn.email, 					false);
		add(ConstantsColumn.link, 					false);
		add(ConstantsColumn.dati_base,				false);
		add(ConstantsColumn.dati_fiscali,			false);
		add(ConstantsColumn.agente, 				false);
		add(ConstantsColumn.proprietario, 			true);
		add(ConstantsColumn.operatore, 				false);
		add(ConstantsColumn.indirizzo, 				false);
		addSeparatore("1");
		add(ConstantsColumn.storia, 				false);
		add(ConstantsColumn.appuntamenti, 			false);
		add(ConstantsColumn.contratti, 				false);
		add(ConstantsColumn.allegati, 				false);


		ordinamento(ConstantsColumn.id);
		ordinamento(ConstantsColumn.data_creazione);
		ordinamento(ConstantsColumn.bloccato);
		ordinamento(ConstantsColumn.tipo);
		ordinamento(ConstantsColumn.chiuso);
		ordinamento(ConstantsColumn.data_archiviazione);
		ordinamento(ConstantsColumn.data_presentazione);
		ordinamento(ConstantsColumn.data_lavorazione);
		return getAction();
	}
	

}
