package it.callite.column;

import java.io.Serializable;
import java.util.Iterator;
import java.util.Set;

import it.callite.column.generic.GenericColumn;
import it.callite.constants.ConstantsColumn;
import it.callite.constants.ConstantsMap;

public class StoriaContrattoColumn  extends GenericColumn implements Serializable {

	private static final long serialVersionUID = 1L;

	public StoriaContrattoColumn() {
		doReset();
	}
	public Set<String> getKeyContratto() {
		return ConstantsMap.mapContratto;
	}
	public Set<String> getKeyContatto() {
		return ConstantsMap.mapContatto;
	}

	public Set<String> getKeyAnagrafica() {
		return ConstantsMap.mapAnagrafica;
	}
	
	public Set<String> getKeyIndirizzoLegale() {
		return ConstantsMap.mapIndirizzoLegale;
	}
	
	public Set<String> getKeyIndirizzoOperativo() {
		return ConstantsMap.mapIndirizzoOperativo;
	}
	public Set<String> getKeyConsenso() {
		return ConstantsMap.mapConsenso;
	}
	
	public String doReset(){
		reset();
		
		Iterator<String> contrattoIter = getKeyContratto().iterator();
		while(contrattoIter.hasNext()) {
			add(ConstantsMap.contratto, contrattoIter.next(), false);
		}
		
		Iterator<String> contattoIter = getKeyContatto().iterator();
		while(contattoIter.hasNext()) {
			add(ConstantsMap.contatto, contattoIter.next(), false);
		}
		
		Iterator<String> anagraficaIter = getKeyAnagrafica().iterator();
		while(anagraficaIter.hasNext()) {
			add(ConstantsMap.anagrafica, anagraficaIter.next(), false);
		}
		
		Iterator<String> indirizzoLegaleIter = getKeyIndirizzoLegale().iterator();
		while(indirizzoLegaleIter.hasNext()) {
			add(ConstantsMap.indirizzo_legale, indirizzoLegaleIter.next(), false);
		}
		
		Iterator<String> indirizzoOperativoIter = getKeyIndirizzoOperativo().iterator();
		while(indirizzoOperativoIter.hasNext()) {
			add(ConstantsMap.indirizzo_operativo, indirizzoOperativoIter.next(), false);
		}
		
		Iterator<String> consensoIter = getKeyConsenso().iterator();
		while(consensoIter.hasNext()) {
			add(ConstantsMap.consenso, consensoIter.next(), false);
		}
		
		add(ConstantsColumn.id,					true);
		add(ConstantsColumn.data, 				true);
		add(ConstantsColumn.bloccato,			true);
		add(ConstantsColumn.seriale,			false);
		add(ConstantsColumn.anagrafica,			true);
		add(ConstantsColumn.telefono, 			false);
		add(ConstantsColumn.email,	 			false);
		add(ConstantsColumn.link, 				false);
		add(ConstantsColumn.dati_base,			false);
		add(ConstantsColumn.dati_fiscali,		false);
		add(ConstantsColumn.agente, 			false);
		add(ConstantsColumn.operatore,			false);
		add(ConstantsColumn.utente,				true);
		add(ConstantsColumn.esito, 				true);
		add(ConstantsColumn.categoria,			false);
		add(ConstantsColumn.prodotto,			false);
		add(ConstantsColumn.quantita,			false);
		add(ConstantsColumn.importo,			false);
		add(ConstantsColumn.nota, 				false);
		add(ConstantsColumn.data_contabile,		false);
		add(ConstantsColumn.data_stipula, 		true);
		add(ConstantsColumn.data_attivazione, 	false);
		add(ConstantsColumn.data_caricamento, 	false);
		add(ConstantsColumn.data_esito, 		false);
		add(ConstantsColumn.data_stato, 		false);
		add(ConstantsColumn.stato, 				false);
		
		
		ordinamento(ConstantsColumn.id);
		ordinamento(ConstantsColumn.data);
		ordinamento(ConstantsColumn.bloccato);
		ordinamento(ConstantsColumn.stato);
		ordinamento(ConstantsColumn.data_contabile);
		ordinamento(ConstantsColumn.data_stipula);
		ordinamento(ConstantsColumn.data_attivazione);
		ordinamento(ConstantsColumn.data_caricamento);
		ordinamento(ConstantsColumn.data_esito);
		ordinamento(ConstantsColumn.data_stato);
		return getAction();
	}
	
	
}
