package it.callite.comparator;

import java.util.Comparator;

import it.callite.model.Agente;
import it.callite.model.Contatto;
import it.callite.utility.ApplicationUtil;

public class AgenteComparator implements Comparator<Agente> {
	private boolean ascendente = false;
	private Contatto c;

	public AgenteComparator(Contatto c, boolean ascendente) {
		this.ascendente = ascendente;
		this.c = c;
	}

	@SuppressWarnings({ "rawtypes", "unchecked" })
	@Override
	public int compare(Agente o1, Agente o2) {
		Comparable a1 = ascendente ? ApplicationUtil.compara(o2, c) :  ApplicationUtil.compara(o1, c);
		Comparable a2 = ascendente ? ApplicationUtil.compara(o1, c) :  ApplicationUtil.compara(o2, c);
		if(a1 != null && a2 != null) {
			return a1.compareTo(a2);
		} else if(a1 != null && a2 == null) {
			return -1;
		} else if(a1 == null && a2 != null) {
			return 1;
		} else {
			return 0;
		}
	}
}
