package it.callite.comparator;

import java.util.Comparator;

import it.callite.utility.item.ContattoSI;

public class ContattoSIComparator implements Comparator<ContattoSI> {
	private boolean discendente = false;

	public ContattoSIComparator(boolean discendente) {
		this.discendente = discendente;
	}

	@SuppressWarnings({ "unchecked", "rawtypes" })
	@Override
	public int compare(ContattoSI o1, ContattoSI o2) {
		Comparable a1 = discendente ? o2.getId() :  o1.getId();
		Comparable a2 = discendente ? o1.getId() :  o2.getId();
		if(a1 != null && a2 != null) {
			return a1.compareTo(a2);
		} else if(a1 != null && a2 == null) {
			return -1;
		} else if(a1 == null && a2 != null) {
			return 1;
		} else {
			return 0;
		}
	}

}
