package it.callite.comparator;

import java.util.Comparator;

import it.callite.model.StoriaAppuntamento;
import it.callite.utility.ApplicationUtil;

public class StoriaAppuntamentoComparator implements Comparator<StoriaAppuntamento> {
	private boolean discendente = false;
	private String metodo;

	public StoriaAppuntamentoComparator(boolean discendente, String metodo) {
		this.discendente = discendente;
		this.metodo = metodo;
	}

	@SuppressWarnings({ "rawtypes", "unchecked" })
	@Override
	public int compare(StoriaAppuntamento o1, StoriaAppuntamento o2) {
		Comparable a1 = discendente ? ApplicationUtil.metodoC(o2, metodo) :  ApplicationUtil.metodoC(o1, metodo);
		Comparable a2 = discendente ? ApplicationUtil.metodoC(o1, metodo) :  ApplicationUtil.metodoC(o2, metodo);
		if(a1 != null && a2 != null) {
			return a1.compareTo(a2);
		} else if(a1 != null && a2 == null) {
			return -1;
		} else if(a1 == null && a2 != null) {
			return 1;
		} else {
			return 0;
		}
	}
}
