package it.callite.constants.config;
import java.util.Collections;
import java.util.HashMap;
import java.util.Map;

import it.callite.constants.ConstantsGlobal;
import it.callite.constants.ConstantsMap;
import it.callite.model.config.ConfigAutodialer;
import it.callite.utility.Configurazione;
public class DefaultsAutodialer {
	
	public static final String KEY_PREDICTIVE_AMI_REALTIME = "predictive.ami.realtime";
	public static final String KEY_PREDICTIVE_AMI_IP_CENTRALINO = "predictive.ami.ip.centralino";
	public static final String KEY_PREDICTIVE_AMI_PORT = "predictive.ami.port";
	public static final String KEY_PREDICTIVE_AMI_USERNAME = "predictive.ami.username";
	public static final String KEY_PREDICTIVE_AMI_PASSWORD = "predictive.ami.password";
	public static final String KEY_PREDICTIVE_AMI_DIALPLAN = "predictive.ami.statico";
	public static final String KEY_PREDICTIVE_AMI_CONTROLLA = "predictive.ami.controlla";
	public static final String KEY_PREDICTIVE_AMI_TIMEOUT = "predictive.ami.timeout";
	public static final String KEY_PREDICTIVE_AMI_VARIABILE = "predictive.ami.variabile";
	
	public static final Map<String, ConfigAutodialer> DEFAULTS;
	
	static {
		Map<String, ConfigAutodialer> aMap = new HashMap<String, ConfigAutodialer>();
		aMap.put(KEY_PREDICTIVE_AMI_REALTIME, new ConfigAutodialer(KEY_PREDICTIVE_AMI_REALTIME, Configurazione.getVariabile(KEY_PREDICTIVE_AMI_REALTIME), ConstantsMap.getRealtime(), ConstantsGlobal.lista, false, true));
		aMap.put(KEY_PREDICTIVE_AMI_IP_CENTRALINO, new ConfigAutodialer(KEY_PREDICTIVE_AMI_IP_CENTRALINO, Configurazione.getVariabile(KEY_PREDICTIVE_AMI_IP_CENTRALINO), ".+" , ConstantsGlobal.stringa, true, true));
		aMap.put(KEY_PREDICTIVE_AMI_PORT, new ConfigAutodialer(KEY_PREDICTIVE_AMI_PORT, Configurazione.getVariabile(KEY_PREDICTIVE_AMI_PORT),  "[0-9]+", ConstantsGlobal.stringa, true, true));
		aMap.put(KEY_PREDICTIVE_AMI_USERNAME, new ConfigAutodialer(KEY_PREDICTIVE_AMI_USERNAME, Configurazione.getVariabile(KEY_PREDICTIVE_AMI_USERNAME), ".+" , ConstantsGlobal.stringa, true, true));
		aMap.put(KEY_PREDICTIVE_AMI_PASSWORD, new ConfigAutodialer(KEY_PREDICTIVE_AMI_PASSWORD,  Configurazione.getVariabile(KEY_PREDICTIVE_AMI_PASSWORD), ".+" , ConstantsGlobal.password, true, true));
		aMap.put(KEY_PREDICTIVE_AMI_DIALPLAN, new ConfigAutodialer(KEY_PREDICTIVE_AMI_DIALPLAN, ConstantsMap.TRUE, ConstantsMap.getBoolean(), ConstantsGlobal.scelta, false, true));
		aMap.put(KEY_PREDICTIVE_AMI_CONTROLLA, new ConfigAutodialer(KEY_PREDICTIVE_AMI_CONTROLLA, ConstantsMap.FALSE, ConstantsMap.getBoolean(), ConstantsGlobal.scelta, false, true));
		aMap.put(KEY_PREDICTIVE_AMI_VARIABILE, new ConfigAutodialer(KEY_PREDICTIVE_AMI_VARIABILE, ConstantsMap.FALSE, ConstantsMap.getBoolean(), ConstantsGlobal.scelta, false, true));
		aMap.put(KEY_PREDICTIVE_AMI_TIMEOUT, new ConfigAutodialer(KEY_PREDICTIVE_AMI_TIMEOUT, "60",  "[0-9]+", ConstantsGlobal.stringa, true, true));
		DEFAULTS = Collections.unmodifiableMap(aMap);
	};
}