package it.callite.constants.config;
import java.util.Collections;
import java.util.HashMap;
import java.util.Map;

import it.callite.constants.ConstantsGlobal;
import it.callite.constants.ConstantsMap;
import it.callite.model.config.ConfigChat;
import it.callite.utility.Configurazione;
public class DefaultsChat {
	public static final String KEY_CHAT_ABILITATO = "chat.abilitato";
	public static final String KEY_CHAT_SERVER_IP = "chat.server.ip";
	public static final String KEY_CHAT_SERVER_PORT = "chat.server.port";
	public static final String KEY_CHAT_ADMIN_USERNAME = "chat.admin.username";
	public static final String KEY_CHAT_ADMIN_PASSWORD = "chat.admin.password";
	public static final Map<String, ConfigChat> DEFAULTS;
	static {
		Map<String, ConfigChat> aMap = new HashMap<String, ConfigChat>();
		aMap.put(KEY_CHAT_ABILITATO, new ConfigChat(KEY_CHAT_ABILITATO, Configurazione.getVariabile(KEY_CHAT_ABILITATO), ConstantsMap.getChat(), ConstantsGlobal.lista, false, true));
		aMap.put(KEY_CHAT_SERVER_IP, new ConfigChat(KEY_CHAT_SERVER_IP, Configurazione.getVariabile(KEY_CHAT_SERVER_IP), ".+" , ConstantsGlobal.stringa, true, true));
		aMap.put(KEY_CHAT_SERVER_PORT, new ConfigChat(KEY_CHAT_SERVER_PORT,Configurazione.getVariabile(KEY_CHAT_SERVER_PORT),  "[0-9]+", ConstantsGlobal.stringa, true, true));
		aMap.put(KEY_CHAT_ADMIN_USERNAME, new ConfigChat(KEY_CHAT_ADMIN_USERNAME, Configurazione.getVariabile(KEY_CHAT_ADMIN_USERNAME),  ".+" , ConstantsGlobal.stringa, true, true));
		aMap.put(KEY_CHAT_ADMIN_PASSWORD, new ConfigChat(KEY_CHAT_ADMIN_PASSWORD, Configurazione.getVariabile(KEY_CHAT_ADMIN_PASSWORD),  ".+" , ConstantsGlobal.password,  true, true));
		DEFAULTS = Collections.unmodifiableMap(aMap);
	};
}