package it.callite.constants.config;
import java.util.Collections;
import java.util.HashMap;
import java.util.Map;

import it.callite.constants.ConstantsGlobal;
import it.callite.constants.ConstantsMap;
import it.callite.model.config.ConfigFtp;
import it.callite.utility.Configurazione;
public class DefaultsFtp {
	public static final String KEY_FTP_REGISTRAZIONI_HOST = "ftp.host";
	public static final String KEY_FTP_REGISTRAZIONI_USERNAME = "ftp.username";
	public static final String KEY_FTP_REGISTRAZIONI_PASSWORD = "ftp.password";
	public static final String KEY_FTP_REGISTRAZIONI_PORT = "ftp.port";
	public static final String KEY_FTP_LOCAL_USER = "ftp.local_user";
	public static final String KEY_FTP_ABILITA_FTP = "ftp.abilita_ftp";
	
	public static final Map<String, ConfigFtp> DEFAULTS;
	static {
		Map<String, ConfigFtp> aMap = new HashMap<String, ConfigFtp>();
		aMap.put(KEY_FTP_REGISTRAZIONI_HOST, new ConfigFtp(KEY_FTP_REGISTRAZIONI_HOST, Configurazione.getVariabile(KEY_FTP_REGISTRAZIONI_HOST),  ".+" , ConstantsGlobal.stringa, true, true));
		aMap.put(KEY_FTP_REGISTRAZIONI_USERNAME, new ConfigFtp(KEY_FTP_REGISTRAZIONI_USERNAME, Configurazione.getVariabile(KEY_FTP_REGISTRAZIONI_USERNAME),  ".+" , ConstantsGlobal.stringa, true, true));
		aMap.put(KEY_FTP_REGISTRAZIONI_PASSWORD, new ConfigFtp(KEY_FTP_REGISTRAZIONI_PASSWORD, Configurazione.getVariabile(KEY_FTP_REGISTRAZIONI_PASSWORD),  ".+" , ConstantsGlobal.password, true, true));
		aMap.put(KEY_FTP_REGISTRAZIONI_PORT, new ConfigFtp(KEY_FTP_REGISTRAZIONI_PORT, Configurazione.getVariabile(KEY_FTP_REGISTRAZIONI_PORT),  "[0-9]+", ConstantsGlobal.stringa, true, true));
		aMap.put(KEY_FTP_LOCAL_USER, new ConfigFtp(KEY_FTP_LOCAL_USER, Configurazione.getVariabile(KEY_FTP_LOCAL_USER),  ".+" , ConstantsGlobal.stringa, true, true));
		aMap.put(KEY_FTP_ABILITA_FTP, new ConfigFtp(KEY_FTP_ABILITA_FTP, ConstantsMap.FALSE, ConstantsMap.getBoolean(), ConstantsGlobal.scelta, false, true));
		DEFAULTS = Collections.unmodifiableMap(aMap);
	};
}