package it.callite.constants.config;
import java.util.Collections;
import java.util.HashMap;
import java.util.Map;

import it.callite.constants.ConstantsGlobal;
import it.callite.constants.ConstantsMap;
import it.callite.model.config.ConfigSmtp;
import it.callite.utility.Configurazione;
public class DefaultsSmtp {
	
	public static final String KEY_SMTP_PROTOCOL = "smtp.smtp_protocol";
	public static final String KEY_SMTP_MITTENTE = "smtp.smtp_mittente";
	public static final String KEY_SMTP_HOST = "smtp.smtp_host";
	public static final String KEY_SMTP_FROM = "smtp.smtp_from";
	public static final String KEY_SMTP_ENCRYPTION = "smtp.smtp_encryption";
	public static final String KEY_SMTP_USER = "smtp.smtp_user";
	public static final String KEY_SMTP_PASSWORD = "smtp.smtp_password";
	public static final String KEY_SMTP_PORT = "smtp.smtp_port";
	public static final String KEY_SMTP_AUTH = "smtp.smtp_auth";
	public static final String KEY_SMTP_DEBUG = "smtp.smtp_debug";
	public static final String KEY_SMTP_PEC = "smtp.smtp_pec";
	
	public static final Map<String, ConfigSmtp> DEFAULTS;
	static {
		Map<String, ConfigSmtp> aMap = new HashMap<String, ConfigSmtp>();
		aMap.put(KEY_SMTP_PROTOCOL, new ConfigSmtp(KEY_SMTP_PROTOCOL, Configurazione.getVariabile(KEY_SMTP_PROTOCOL),  ConstantsMap.getProtocol(), ConstantsGlobal.lista, false, true));
		aMap.put(KEY_SMTP_MITTENTE, new ConfigSmtp(KEY_SMTP_MITTENTE, Configurazione.getVariabile(KEY_SMTP_MITTENTE),  ".+" , ConstantsGlobal.stringa, true, true));
		aMap.put(KEY_SMTP_HOST, new ConfigSmtp(KEY_SMTP_HOST, Configurazione.getVariabile(KEY_SMTP_HOST),  ".+" , ConstantsGlobal.stringa, true, true));
		aMap.put(KEY_SMTP_FROM, new ConfigSmtp(KEY_SMTP_FROM, Configurazione.getVariabile(KEY_SMTP_FROM), ".+" , ConstantsGlobal.stringa, true, true));
		aMap.put(KEY_SMTP_ENCRYPTION, new ConfigSmtp(KEY_SMTP_ENCRYPTION, Configurazione.getVariabile(KEY_SMTP_ENCRYPTION),  ConstantsMap.getEncryption(), ConstantsGlobal.lista, false, true));
		aMap.put(KEY_SMTP_USER, new ConfigSmtp(KEY_SMTP_USER, Configurazione.getVariabile(KEY_SMTP_USER),  ".+" , ConstantsGlobal.stringa, true, true));
		aMap.put(KEY_SMTP_PASSWORD, new ConfigSmtp(KEY_SMTP_PASSWORD, Configurazione.getVariabile(KEY_SMTP_PASSWORD),  ".+", ConstantsGlobal.password ,true, true));
		aMap.put(KEY_SMTP_PORT, new ConfigSmtp(KEY_SMTP_PORT, Configurazione.getVariabile(KEY_SMTP_PORT),  "[0-9]+", ConstantsGlobal.stringa, true, true));
		aMap.put(KEY_SMTP_AUTH, new ConfigSmtp(KEY_SMTP_AUTH, Configurazione.getVariabile(KEY_SMTP_AUTH), ConstantsMap.getBoolean(), ConstantsGlobal.scelta, false, true));
		aMap.put(KEY_SMTP_PEC, new ConfigSmtp(KEY_SMTP_PEC, ConstantsMap.FALSE, ConstantsMap.getBoolean(), ConstantsGlobal.scelta, false, true));
		aMap.put(KEY_SMTP_DEBUG, new ConfigSmtp(KEY_SMTP_DEBUG, ConstantsMap.FALSE, ConstantsMap.getBoolean(), ConstantsGlobal.scelta, false, true));
		DEFAULTS = Collections.unmodifiableMap(aMap);
	};
}