package it.callite.controller;
import java.io.Serializable;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.json.JSONObject;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;

import it.callite.constants.ConstantsGlobal;
import it.callite.dao.AutodialerDao;
import it.callite.dao.DownloadDao;
import it.callite.dao.ImpostazioneDao;
import it.callite.dao.TemaDao;
import it.callite.log.ErrorLog;
import it.callite.model.Tema;
import it.callite.utility.ApplicationUtil;
@SuppressWarnings("serial")
@Controller
public class AliveController implements Serializable {
	@Autowired
	public ImpostazioneDao impostazioneDao;
	@Autowired
	public AutodialerDao autodialerDao;
	@Autowired
	public TemaDao temaDao;
	@Autowired
	public DownloadDao downloadDao;

	//https://BASE_PATH/rinnova/data/password
	@RequestMapping(value = ConstantsGlobal.path_web_rinnova + "/{date}" + "/{password}")
	public void rinnova(HttpServletRequest request, HttpServletResponse response, @PathVariable final String date, @PathVariable final String password) {
		if(impostazioneDao.comparePassword(password)) {
			String o = ApplicationUtil.trimToNull(date);
			if(o != null) {
				Date nuova = ApplicationUtil.date(o);
				if(nuova != null) {
					Tema t = temaDao.getTema();
					if(t != null) {
						t.setScadenza(nuova);
						temaDao.salvaTema(t);
					}
				}
			}
		}
	}

	//https://BASE_PATH/controlla/password
	@RequestMapping(value = ConstantsGlobal.path_web_controlla + "/{password}")
	public void controlla(HttpServletRequest request, HttpServletResponse response, @PathVariable final String password) throws Exception{
		JSONObject jso = new JSONObject();
		if(impostazioneDao.comparePassword(password)) {
			ApplicationUtil.formatJson(jso, autodialerDao.getAmiLogged(), autodialerDao.getAgiLogged(), impostazioneDao.getServer(), impostazioneDao.checkSystem(), temaDao.getTema());
		}
		ApplicationUtil.writeBody(response, jso.toString());
	}

	//https://BASE_PATH/update/0/password
	@RequestMapping(value = ConstantsGlobal.path_web_update + "/{type}/{password}")
	public void update(HttpServletRequest request, HttpServletResponse response, @PathVariable final Integer type, @PathVariable final String password) {
		if(impostazioneDao.comparePassword(password)) {
			if(ApplicationUtil.eq(type, 0)) {
				impostazioneDao.aggiornamento();
			}
			if(ApplicationUtil.eq(type, 1)) {
				impostazioneDao.restart();
			}
			if(ApplicationUtil.eq(type, 2)) {
				impostazioneDao.riavvia();
			}
		}
	}



	//https://BASE_PATH/controlla
	@RequestMapping(value = ConstantsGlobal.path_web_controlla)
	public void controlla(HttpServletRequest request, HttpServletResponse response) throws Exception{
		response.setHeader("Access-Control-Allow-Origin", "*");
		try {
			Map<String, Object> model = new HashMap<String, Object>();
			ApplicationUtil.formatMap(model, autodialerDao.getAmiLogged(), autodialerDao.getAgiLogged(), impostazioneDao.getServer(), impostazioneDao.checkSystem(), temaDao.getTema());
			ApplicationUtil.writeBody(response, downloadDao.mergeVelocityTemplate("alive", model));
		} catch (Exception e) {
			ErrorLog.log(null, getClass(), e);
		}
	}

}