package it.callite.controller;
import java.io.Serializable;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;

import it.callite.constants.ConstantsGlobal;
import it.callite.dao.UserDao;
import it.callite.model.Utente;
import it.callite.utility.ApplicationUtil;
@SuppressWarnings("serial")
@Controller
public class ChiamataController  implements Serializable  {
	@Autowired
	public UserDao userDao;

	//https://BASE_PATH/chiama/telefono
	@RequestMapping(value = ConstantsGlobal.path_web_chiama + "/{telefono}")
	public void getFile(HttpServletRequest request, HttpServletResponse response, @PathVariable final String telefono)  {
		Utente u = ApplicationUtil.getUsernameLoggato();
		if(u != null && u.getRegistrato()) {
			String richiama  = ApplicationUtil.trimToEmpty((String) request.getParameter("richiama"));
			String contatto  = ApplicationUtil.trimToEmpty((String) request.getParameter("contatto"));
			String context   = ApplicationUtil.trimToEmpty((String) request.getParameter("context"));
			String ingresso  = ApplicationUtil.trimToEmpty((String) request.getParameter("ingresso"));
			userDao.chiama(u, telefono, richiama, contatto, ingresso, context);
		}
	}

	//https://BASE_PATH/chiama/utente/telefono
	@RequestMapping(value = ConstantsGlobal.path_web_chiama + "/{utente}/{telefono}")
	public void getFile(HttpServletRequest request, HttpServletResponse response, @PathVariable final Long utente, @PathVariable final String telefono)  {
		if(utente != null) {
			Utente u = userDao.getUser(utente);
			if(u != null && u.getRegistrato()) {
				String richiama  = ApplicationUtil.trimToEmpty((String) request.getParameter("richiama"));
				String contatto  = ApplicationUtil.trimToEmpty((String) request.getParameter("contatto"));
				String context   = ApplicationUtil.trimToEmpty((String) request.getParameter("context"));
				String ingresso  = ApplicationUtil.trimToEmpty((String) request.getParameter("ingresso"));
				userDao.chiama(u, telefono, richiama, contatto, ingresso, context);
			}
		}
	}

	//https://BASE_PATH/chiama/utente/telefono/richiama
	@RequestMapping(value = ConstantsGlobal.path_web_chiama + "/{utente}/{telefono}/{richiama}")
	public void getFile(HttpServletRequest request, HttpServletResponse response, @PathVariable final Long utente, @PathVariable final String telefono, @PathVariable final String richiama)  {
		if(utente != null) {
			Utente u = userDao.getUser(utente);
			if(u != null) {
				String contatto  = ApplicationUtil.trimToEmpty((String) request.getParameter("contatto"));
				String context   = ApplicationUtil.trimToEmpty((String) request.getParameter("context"));
				String ingresso  = ApplicationUtil.trimToEmpty((String) request.getParameter("ingresso"));
				userDao.chiama(u, telefono, richiama, contatto, ingresso, context);
			}
		}
	}
}