package it.callite.controller;
import java.io.Serializable;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;

import it.callite.constants.ConstantsGlobal;
import it.callite.dao.DownloadDao;
import it.callite.dao.ImpostazioneDao;
import it.callite.model.Appuntamento;
import it.callite.model.Indirizzo;
import it.callite.model.Utente;
import it.callite.utility.ApplicationUtil;
import it.callite.utility.Coordinata;
@SuppressWarnings("serial")
@Controller
public class MapController implements Serializable {
	
	@Autowired
	public ImpostazioneDao impostazioneDao;
	@Autowired
	public DownloadDao downloadDao;

	//https://BASE_PATH/map/appuntamento
	@RequestMapping(value = ConstantsGlobal.path_web_map + "/{appuntamento}")
	public void map(HttpServletRequest request, HttpServletResponse response, @PathVariable final String appuntamento) throws Exception{
		response.setHeader("Access-Control-Allow-Origin", "*");
		String xx = ApplicationUtil.trimToNull(appuntamento);
		Utente u = ApplicationUtil.getUsernameLoggato();
		List<Coordinata> coordinate = new ArrayList<Coordinata>();
		String chiave = impostazioneDao.getKeyGeocodificaMap();
		if (u != null && xx != null) {
			int i = 1;
			List<Long> aa = ApplicationUtil.tokenL(xx, ConstantsGlobal.pipeSeparator);
			if(ApplicationUtil.notEmpty(aa)) {
				Iterator<Long> aIter = aa.iterator();
				while (aIter.hasNext()) {
					Appuntamento apt = (Appuntamento) impostazioneDao.get(Appuntamento.class, aIter.next());
					if(apt != null) {
						Indirizzo a = null;
						if(apt.getLocalizzazione()) {
							a = apt.getContatto().getAnagrafica().getIndirizzo_operativo();
						} else {
							a = apt.getContatto().getAnagrafica().getIndirizzo_legale();
						}
						if(a != null && a.getValidoMap()) {
							Coordinata coordinata = a.addressMap(chiave);
							if(coordinata == null) {
								coordinata = new Coordinata();
							}
							if(coordinata.getValido() && !coordinate.contains(coordinata)) {
								coordinata.setId(i++);
								coordinate.add(coordinata);
							}

						}
					}
				}
			}

		} 
		Map<String, Object> model = new HashMap<String, Object>();
		model.put("chiave", chiave);
		model.put("coordinate", coordinate);
		ApplicationUtil.writeBody(response, downloadDao.mergeVelocityTemplate("maps", model));
	}


	//https://BASE_PATH/address/indirizzo
	@RequestMapping(value = ConstantsGlobal.path_web_address + "/{indirizzo}")
	public void address(HttpServletRequest request, HttpServletResponse response, @PathVariable final String indirizzo) throws Exception{
		response.setHeader("Access-Control-Allow-Origin", "*");
		String xx = ApplicationUtil.trimToNull(indirizzo);
		Utente u = ApplicationUtil.getUsernameLoggato();
		List<Coordinata> coordinate = new ArrayList<Coordinata>();
		String chiave = impostazioneDao.getKeyGeocodificaMap();
		if (u != null && xx != null) {
			int i = 1;
			List<Long> aa = ApplicationUtil.tokenL(xx, ConstantsGlobal.pipeSeparator);
			if(ApplicationUtil.notEmpty(aa)) {
				Iterator<Long> aIter = aa.iterator();
				while (aIter.hasNext()) {
					Indirizzo a = (Indirizzo) impostazioneDao.get(Indirizzo.class, aIter.next());
					if(a != null && a.getValidoMap()) {
						Coordinata coordinata = a.addressMap(chiave);
						if(coordinata == null) {
							coordinata = new Coordinata();
						}
						if(coordinata.getValido() && !coordinate.contains(coordinata)) {
							coordinata.setId(i++);
							coordinate.add(coordinata);
						}

					}
				}
			}
		} 
		Map<String, Object> model = new HashMap<String, Object>();
		model.put("chiave", chiave);
		model.put("coordinate", coordinate);
		ApplicationUtil.writeBody(response, downloadDao.mergeVelocityTemplate("maps", model));
	}

}