package it.callite.controller;
import java.io.Serializable;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import it.callite.constants.ConstantsGlobal;
import it.callite.dao.ImpostazioneDao;
import it.callite.dao.PannelloDao;
import it.callite.utility.ApplicationUtil;
@SuppressWarnings("serial")
@Controller
public class OpposizioneController implements Serializable {
	@Autowired
	public PannelloDao pannelloDao;
	@Autowired
	public ImpostazioneDao impostazioneDao;

	//https://BASE_PATH/opposizione/numero/password
	@RequestMapping(value = ConstantsGlobal.path_web_opposizione + "/{numero}" + "/{password}")
	public void handleRequest(HttpServletRequest request, HttpServletResponse response, @PathVariable final String numero,  @PathVariable final String password) {
		if(impostazioneDao.comparePassword(password)) {
			String o = ApplicationUtil.trimToNull(numero);
			if(o != null) {
				pannelloDao.settaOpposizione(o);
			}
		}
	}
}