package it.callite.controller;
import java.io.FileInputStream;
import java.io.InputStream;
import java.io.Serializable;

import javax.servlet.ServletOutputStream;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.net.ftp.FTPClient;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.ResponseBody;

import it.callite.constants.ConstantsGlobal;
import it.callite.constants.ConstantsMap;
import it.callite.dao.ImpostazioneDao;
import it.callite.log.ErrorLog;
import it.callite.model.Utente;
import it.callite.utility.ApplicationUtil;
import it.callite.utility.UtilFTP;
@SuppressWarnings("serial")
@Controller
public class StreamController  implements Serializable  {
	@Autowired
	public ImpostazioneDao impostazioneDao;

	//https://BASE_PATH/audio/type/filename64.ext
	@RequestMapping(value = ConstantsGlobal.path_web_audio + "/{type}/{file}.{ext}",  method = RequestMethod.GET)
	@ResponseBody 
	public void getFile(HttpServletRequest request, HttpServletResponse response, @PathVariable final String type, @PathVariable final String file, @PathVariable final String ext)  {
		String t = ApplicationUtil.trimToNull(type);
		Utente u = ApplicationUtil.getUsernameLoggato();
		if((u != null || ApplicationUtil.isTrue(impostazioneDao.getPermitDownload())) && t != null) {
			String pathk = null;
			if(t.equals("63")) {
				pathk = ConstantsGlobal.path_monitor;
			}
			if(t.equals("64")) {
				pathk = ConstantsGlobal.path_sounds;
			}
			if(t.equals("65")) {
				pathk = ConstantsGlobal.path_attesa;
			}
			if(t.equals("66")) {
				pathk = ConstantsGlobal.path_musica;
			}
			if(t.equals("67")) {
				String interno = u != null ? u.getInternoString() : "";
				if(ApplicationUtil.isNotBlank(interno)) {
					pathk = ConstantsGlobal.path_voicemail + "/default/" + interno;
				}
			}
			String fileD = ApplicationUtil.base64Decoder(file);
			if(pathk != null) {
				String fileName = ApplicationUtil.getBaseNameN(fileD) + "." + ext;
				ApplicationUtil.setResponse(null, impostazioneDao.getDownloadLogType(), true, null, request, response, fileName);
				if(ApplicationUtil.isNotTrue(impostazioneDao.getFTPEnabled())) {
					try {
						ServletOutputStream out = response.getOutputStream();
						String home = impostazioneDao.getHome();
						String nome = home + pathk +"/"+ fileD + "." + ext;
						InputStream istream = new FileInputStream(nome);
						ApplicationUtil.copy(istream, out);
						istream.close();
						out.close();
					} catch (Exception e) {
						ErrorLog.log(null, getClass(), e);
					}
				} else {
					UtilFTP ut = impostazioneDao.getUtilFTP();
					FTPClient vmftp = ApplicationUtil.createClient();
					if (ApplicationUtil.connect(vmftp, ut)) {
						try {
							ServletOutputStream out = response.getOutputStream();
							String path = pathk + "/" + fileD + "." + ext;
							ApplicationUtil.scaricaFile(vmftp, out, path);
							out.close();
						} catch (Exception ec) {
							ErrorLog.log(null, getClass(), ec);
						} finally {
							ApplicationUtil.disconnect(vmftp);
						}
					}	
				}
				try {
					response.flushBuffer();
				} catch (Exception ec) {
					ErrorLog.log(null, getClass(), ec);
				}
			}
		}
	}
	//https://BASE_PATH/audio/type/format/filename64.ext
	@RequestMapping(value = ConstantsGlobal.path_web_audio + "/{type}/{format}/{file}.{ext}",  method = RequestMethod.GET)
	@ResponseBody 
	public void getFromat(HttpServletRequest request, HttpServletResponse response, @PathVariable final String type,  @PathVariable final String format, @PathVariable final String file, @PathVariable final String ext)  {
		String t = ApplicationUtil.trimToNull(type);
		Utente u = ApplicationUtil.getUsernameLoggato();
		if((u != null || ApplicationUtil.isTrue(impostazioneDao.getPermitDownload())) && t != null) {
			boolean exist = false;
			if(ApplicationUtil.getPath(ConstantsGlobal.path_ffmpeg, true) && ConstantsMap.audioSupportatoL().contains(format)) {
				exist = true;
			}
			String pathk = null;
			if(t.equals("63")) {
				pathk = ConstantsGlobal.path_monitor;
			}
			if(t.equals("64")) {
				pathk = ConstantsGlobal.path_sounds;
			}
			if(t.equals("65")) {
				pathk = ConstantsGlobal.path_attesa;
			}
			if(t.equals("66")) {
				pathk = ConstantsGlobal.path_musica;
			}
			if(t.equals("67")) {
				String interno = u != null ? u.getInternoString() : "";
				if(ApplicationUtil.isNotBlank(interno)) {
					pathk = ConstantsGlobal.path_voicemail + "/default/" + interno;
				}
			}
			String fileD = ApplicationUtil.base64Decoder(file);
			if(pathk != null) {
				if(ApplicationUtil.isNotTrue(impostazioneDao.getFTPEnabled())) {
					try {
						ServletOutputStream out = response.getOutputStream();
						String home = impostazioneDao.getHome();
						String nome = home + pathk +"/"+ fileD + "." + ext;
						if(exist) {
							String n_name = ApplicationUtil.outFileRCodec(null, out, nome, format);
							ApplicationUtil.setResponse(null, impostazioneDao.getDownloadLogType(), true, null, request, response, n_name);
						} else {
							ApplicationUtil.setResponse(null, impostazioneDao.getDownloadLogType(), true, null, request, response, nome);
							InputStream istream = new FileInputStream(nome);
							ApplicationUtil.copy(istream, out);
							istream.close();
						}
						out.close();
					} catch (Exception e) {
						ErrorLog.log(null, getClass(), e);
					}
				} else {
					UtilFTP ut = impostazioneDao.getUtilFTP();
					FTPClient vmftp = ApplicationUtil.createClient();
					if (ApplicationUtil.connect(vmftp, ut)) {
						try {
							ServletOutputStream out = response.getOutputStream();
							String path = pathk +"/"+ fileD + "." + ext;
							if(exist) {
								String n_name = ApplicationUtil.outFileRCodec(vmftp, null, out, ConstantsGlobal.path_monitor + "/" + path, format);
								ApplicationUtil.setResponse(null, impostazioneDao.getDownloadLogType(), true, null, request, response, n_name);
							} else {
								ApplicationUtil.scaricaFile(vmftp, out, path);
								ApplicationUtil.setResponse(null, impostazioneDao.getDownloadLogType(), true, null, request, response, path);
							}
							out.close();
						} catch (Exception ec) {
							ErrorLog.log(null, getClass(), ec);
						} finally {
							ApplicationUtil.disconnect(vmftp);
						}
					}	
				}
				try {
					response.flushBuffer();
				} catch (Exception ec) {
					ErrorLog.log(null, getClass(), ec);
				}
			}
		}
	}

}