package it.callite.controller;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import it.callite.constants.ConstantsGlobal;
import it.callite.dao.ComunicazioneDao;
import it.callite.dao.ImpostazioneDao;
import it.callite.dao.UserDao;
import it.callite.log.ErrorLog;
import it.callite.model.Webhook;
import it.callite.model.WebhookTemplate;
import it.callite.utility.ApplicationUtil;
@RestController
@RequestMapping(value = ConstantsGlobal.path_web_webhook)
public class WebhookController {

	@Autowired
	public ImpostazioneDao impostazioneDao;

	@Autowired
	public UserDao userDao;

	@Autowired
	public ComunicazioneDao comunicazioneDao;

	//https://BASE_PATH/webhook/nome/password
	@RequestMapping(value= "/{nome}/{password}", produces = "text/plain") 
	public void webhook(HttpServletRequest request, HttpServletResponse response, @PathVariable final String nome, @PathVariable final String password){
		try {
			String name = ApplicationUtil.trimToNull(nome);
			if(name != null && impostazioneDao.comparePassword(password)) {

				WebhookTemplate wb = comunicazioneDao.getWebhookTemplateByName(name);
				String b = ApplicationUtil.readBody(request);
				String t = wb != null ? wb.getOutputs() : null;
				String body = (t != null) ? ApplicationUtil.replaceOutputs(t, b) : b;
				String param = ApplicationUtil.readParameter(request);
				comunicazioneDao.salvaWebhook(new Webhook(wb, name, body, param));
				String rr = null;
				if(wb != null) {
					if(wb.getCallback() != null) {
						ApplicationUtil.writeBody(response, request.getParameter(wb.getCallback()));
					}
					if(wb.getEmail() != null) {
						userDao.mailSender(name, body, param, wb.getEmail());
					}
					if(wb.getLink() != null) {
						rr = userDao.linkSender(wb.getLink());
					}
				}
				ApplicationUtil.ricezione(name, body, rr);
			}
		} catch (Exception e) {
			ErrorLog.log(null, getClass(), e);
		}
	}



}