package it.callite.converter;  

import java.io.Serializable;

import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.convert.Converter;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import it.callite.dao.RiprogrammaDao;
import it.callite.model.Campagna;
import it.callite.utility.ApplicationUtil;
import it.callite.utility.item.CampagnaSI;

@Service("campagnaConverter")
@SuppressWarnings("serial")
public class CampagnaConverter implements Converter, Serializable { 
	
	@Autowired
	private RiprogrammaDao riprogrammaDao;

	public Object getAsObject(FacesContext facesContext, UIComponent component, String submittedValue) {  
		String valore = ApplicationUtil.trimToNull(submittedValue);
		if (valore != null) {  
			Campagna ec = (Campagna) riprogrammaDao.get(Campagna.class, Long.parseLong(valore));
			return new CampagnaSI(ec);
		}
		return null;
	}  

	public String getAsString(FacesContext facesContext, UIComponent component, Object value) {  
		if (value != null) {
			return ((CampagnaSI) value).getId().toString();  
		} else {
			return null;
		}
	}  
}  