package it.callite.converter;  

import java.io.Serializable;

import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.convert.Converter;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import it.callite.dao.SipDao;
import it.callite.model.sip.Coda;
import it.callite.utility.ApplicationUtil;

@Service("codaConverter")
@SuppressWarnings("serial")
public class CodaConverter implements Converter, Serializable {  
	
	@Autowired
	private SipDao sipDao;

	public Object getAsObject(FacesContext facesContext, UIComponent component, String submittedValue) {  
		String valore = ApplicationUtil.trimToNull(submittedValue);
		if (valore != null) {  
			return (Coda) sipDao.get(Coda.class, Long.parseLong(valore));

		}
		return null;
	}  

	public String getAsString(FacesContext facesContext, UIComponent component, Object value) {  
		if (value != null) {
			return ((Coda) value).getId().toString();  
		} else {
			return null;
		}
	}  
}  