package it.callite.criteria;

import java.io.Serializable;

import it.callite.constants.ConstantsColumn;
import it.callite.criteria.generic.RicercaAnagraficaCriteria;
import it.callite.utility.ApplicationUtil;

public class AnagraficaCriteria extends RicercaAnagraficaCriteria implements Serializable {

	private static final long serialVersionUID = 1L;

	
	private String email;
	private String numero;

	private String sorgente;
	private String ricerca_denominazione;
	private String ricerca_fiscale;
	private Boolean sesso = null;
	private Boolean tipo = null;
	private String settore;


	public AnagraficaCriteria() {
		String date1 [] = {ConstantsColumn.data_creazione};
		String date2 [] = {ConstantsColumn.id};
		String date3 [] = null;
		String date4 [] = null;
		String date5 [] = null;
		addAll(date1, date2, date3, date4, date5);
	}

	

	public String getEmail() {
		return ApplicationUtil.trimToNull(email);
	}

	public String getNumero() {
		return ApplicationUtil.trimToNull(numero);
	}

	public String getSorgente() {
		return ApplicationUtil.trimToNull(sorgente);
	}


	public String getRicerca_denominazione() {
		return ApplicationUtil.trimToNull(ricerca_denominazione);
	}


	public String getRicerca_fiscale() {
		return ApplicationUtil.trimToNull(ricerca_fiscale);
	}


	public Boolean getSesso() {
		return sesso;
	}

	public String getSettore() {
		return ApplicationUtil.trimToNull(settore);
	}

	public Boolean getTipo() {
		return tipo;
	}

	public AnagraficaCriteria resetCriteria() {
		AnagraficaCriteria c = new AnagraficaCriteria();
		c.setSerialize(this.getSerialize());
		return c;
	}

	public AnagraficaCriteria resetCriteria(String b) {
		AnagraficaCriteria c = resetCriteria();
		c.setCriteria(b);
		return c;
	}

	public void setCriteria(String b) {
		replace(ConstantsColumn.data_creazione, b);
	}

	public void setEmail(String email) {
		this.email = ApplicationUtil.trimToNull(email);
	}

	public void setNumero(String numero) {
		this.numero = ApplicationUtil.trimToNull(numero);
	}

	public void setSorgente(String sorgente) {
		this.sorgente = ApplicationUtil.trimToNull(sorgente);
	}

	public void setRicerca_denominazione(String ricerca_denominazione) {
		this.ricerca_denominazione = ApplicationUtil.trimToNull(ricerca_denominazione);
	}

	public void setRicerca_fiscale(String ricerca_fiscale) {
		this.ricerca_fiscale = ApplicationUtil.trimToNull(ricerca_fiscale);
	}

	public void setSesso(Boolean sesso) {
		this.sesso = sesso;
	}

	public void setSettore(String settore) {
		this.settore = ApplicationUtil.trimToNull(settore);
	}

	public void setTipo(Boolean tipo) {
		this.tipo = tipo;
	}


}
