package it.callite.criteria;

import java.io.Serializable;

import it.callite.constants.ConstantsColumn;
import it.callite.criteria.generic.GenericAllCriteria;
import it.callite.utility.ApplicationUtil;

public class AvvioCriteria extends GenericAllCriteria implements Serializable {
	
	private static final long serialVersionUID = 1L;

	private String command;
	private Integer attivo;
	
	
	public AvvioCriteria() {
		String date1 [] = {ConstantsColumn.data_creazione};
		String date2 [] = {ConstantsColumn.id};
		String date3 [] = null;
		String date4 [] = null;
		String date5 [] = null;
		addAll(date1, date2, date3, date4, date5);
	}
	
	public String getCommand() {
		return ApplicationUtil.trimToNull(command);
	}

	public AvvioCriteria resetCriteria() {
		AvvioCriteria c = new AvvioCriteria();
		c.setSerialize(this.getSerialize());
		return c;
	}
	public AvvioCriteria resetCriteria(String b) {
		AvvioCriteria c = resetCriteria();
		c.setCriteria(b);
		return c;
	}
	
	public void setCriteria(String b) {
		replace(ConstantsColumn.data_creazione, b);
	}

	public void setCommand(String command) {
		this.command = ApplicationUtil.trimToNull(command);
	}

	
	public Integer getAttivo() {
		return attivo;
	}

	public void setAttivo(Integer attivo) {
		this.attivo = attivo;
	}


}
