package it.callite.criteria;

import java.io.Serializable;

import it.callite.constants.ConstantsColumn;
import it.callite.criteria.generic.GenericAllCriteria;
import it.callite.utility.ApplicationUtil;

public class ComuneCriteria extends GenericAllCriteria implements Serializable {
	
	private static final long serialVersionUID = 1L;

	private String nome;
	
	public ComuneCriteria() {
		String date1 [] = {ConstantsColumn.data_creazione};
		String date2 [] = {ConstantsColumn.id};
		String date3 [] = null;
		String date4 [] = null;
		String date5 [] = null;
		addAll(date1, date2, date3, date4, date5);
	}

	public String getNome() {
		return ApplicationUtil.trimToNull(nome);
	}
	
	public ComuneCriteria resetCriteria() {
		ComuneCriteria c = new ComuneCriteria();
		c.setSerialize(this.getSerialize());
		return c;
	}
	public ComuneCriteria resetCriteria(String b) {
		ComuneCriteria c = resetCriteria();
		c.setCriteria(b);
		return c;
	}
	public void setCriteria(String b) {
		replace(ConstantsColumn.data_creazione, b);
	}


	public void setNome(String nome) {
		this.nome = ApplicationUtil.trimToNull(nome);
	}
	
}