package it.callite.criteria;

import java.io.Serializable;

import it.callite.constants.ConstantsColumn;
import it.callite.criteria.generic.GenericAllCriteria;
import it.callite.utility.ApplicationUtil;

public class ComunicazioneCriteria extends GenericAllCriteria implements Serializable {
	
	private static final long serialVersionUID = 1L;

	private Integer codice;
	private String testo;
	private String destinatario;

	public ComunicazioneCriteria() {
		String date1 [] = {ConstantsColumn.data_creazione, ConstantsColumn.data_invio};
		String date2 [] = {ConstantsColumn.id};
		String date3 [] = null;
		String date4 [] = null;
		String date5 [] = null;
		addAll(date1, date2, date3, date4, date5);
	}
	
	public Integer getCodice() {
		return codice;
	}

	
	public String getDestinatario() {
		return ApplicationUtil.trimToNull(destinatario);
	}

	public void setDestinatario(String destinatario) {
		this.destinatario = ApplicationUtil.trimToNull(destinatario);
	}

	public String getTesto() {
		return ApplicationUtil.trimToNull(testo);
	}

	public ComunicazioneCriteria resetCriteria() {
		ComunicazioneCriteria c = new ComunicazioneCriteria();
		c.setSerialize(this.getSerialize());
		return c;
	}
	public ComunicazioneCriteria resetCriteria(String b) {
		ComunicazioneCriteria c = resetCriteria();
		c.setCriteria(b);
		return c;
	}
	public void setCodice(Integer codice) {
		this.codice = codice;
	}
	public void setCriteria(String b) {
		replace(ConstantsColumn.data_creazione, b);
	}

	public void setTesto(String testo) {
		this.testo = ApplicationUtil.trimToNull(testo);
	}
	
	

}
