package it.callite.criteria;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

import it.callite.constants.ConstantsColumn;
import it.callite.constants.ConstantsGlobal;
import it.callite.criteria.generic.RicercaStoricoCriteria;
import it.callite.utility.ApplicationUtil;
import it.callite.utility.StatoIntervallo;

public class ContattoCriteria  extends RicercaStoricoCriteria implements Serializable {
	
	private static final long serialVersionUID = 1L;

	private Long agenteId;
	private Long campagnaId;
	private Long esitoArchiviazioneId;
	private Long esitoChiamataId;
	private Long lista;
	private String operatore;
	private Long operatoreId;
	private String positivo;
	private String proprietario;
	private Long proprietarioId;
	private Integer rete = 0;
	private StatoIntervallo statoIntervallo = new StatoIntervallo();
	private String ricerca_anagrafica;
	private Integer tipo;
	private String utile;
	private List<String> ricerca_anagraficaV = ApplicationUtil.getAnagraficaDefault();
	private List<String> esitoArchiviazioneIds = new ArrayList<String>();
	private List<String> esitoChiamataIds = new ArrayList<String>();
	private List<String> tipos = new ArrayList<String>();
	private List<String> listas = new ArrayList<String>();
	
	public Long getLista() {
		return lista;
	}
	public void setLista(Long lista) {
		this.lista = lista;
	}
	public List<String> getListas() {
		return listas;
	}
	public void setListas(List<String> listas) {
		this.listas = listas;
	}
	public List<String> getTipos() {
		return tipos;
	}

	public void setTipos(List<String> tipos) {
		this.tipos = tipos;
	}

	public void resetAnagraficaV() {
		ricerca_anagraficaV = ApplicationUtil.getAnagraficaDefault();
	}

	public List<String> getEsitoArchiviazioneIds() {
		return esitoArchiviazioneIds;
	}
	public void setEsitoArchiviazioneIds(List<String> esitoArchiviazioneIds) {
		this.esitoArchiviazioneIds = esitoArchiviazioneIds;
	}
	public List<String> getEsitoChiamataIds() {
		return esitoChiamataIds;
	}
	public void setEsitoChiamataIds(List<String> esitoChiamataIds) {
		this.esitoChiamataIds = esitoChiamataIds;
	}
	public List<String> getRicerca_anagraficaV() {
		return ricerca_anagraficaV;
	}

	public void setRicerca_anagraficaV(List<String> ricerca_anagraficaV) {
		this.ricerca_anagraficaV = ricerca_anagraficaV;
	}


	
	public StatoIntervallo getStatoIntervallo() {
		return statoIntervallo;
	}

	public void setStatoIntervallo(StatoIntervallo statoIntervallo) {
		this.statoIntervallo = statoIntervallo;
	}

	public ContattoCriteria() {
		String date1 [] = {ConstantsColumn.data_creazione, ConstantsColumn.data_archiviazione, ConstantsColumn.data_presentazione, ConstantsColumn.data_lavorazione};
		String date2 [] = {ConstantsColumn.id};
		String date3 [] = null;
		String date4 [] = null;
		String date5 [] = null;
		addAll(date1, date2, date3, date4, date5);
	}

	public void setRicerca_anagrafica(String ricerca_anagrafica) {
		this.ricerca_anagrafica = ApplicationUtil.trimToNull(ricerca_anagrafica);
	}
	public String getRicerca_anagrafica() {
		return ApplicationUtil.trimToNull(ricerca_anagrafica);
	}

	public Long getAgenteId() {
		return agenteId;
	}

	public Long getCampagnaId() {
		return campagnaId;
	}

	public Long getEsitoArchiviazioneId() {
		return esitoArchiviazioneId;
	}


	public Long getEsitoChiamataId() {
		return esitoChiamataId;
	}

	public String getOperatore() {
		return ApplicationUtil.trimToNull(operatore);
	}
	public Long getOperatoreId() {
		return operatoreId;
	}

	public String getPositivo() {
		return ApplicationUtil.trimToNull(positivo);
	}

	public String getProprietario() {
		return ApplicationUtil.trimToNull(proprietario);
	}

	public Long getProprietarioId() {
		return proprietarioId;
	}

	public Integer getRete() {
		return rete;
	}

	

	public Integer getTipo() {
		return tipo;
	}

	public String getUtile() {
		return ApplicationUtil.trimToNull(utile);
	}
	public ContattoCriteria resetCriteria() {
		ContattoCriteria c = new ContattoCriteria();
		c.setSerialize(this.getSerialize());
		return c;
	}
	public ContattoCriteria resetCriteria(String b) {
		ContattoCriteria c = resetCriteria();
		c.setCriteria(b);
		return c;
	}
	public void setAgenteId(Long agenteId) {
		this.agenteId = agenteId;
	}
	public void setCampagnaId(Long campagnaId) {
		this.campagnaId = campagnaId;
	}

	public void setCriteria(String b) {
		statoIntervallo = new StatoIntervallo(ConstantsGlobal.stato_attivo, ConstantsGlobal.stato_attivo, null, null);
		replace(ConstantsColumn.data_creazione, b);
	}
	public void setEsitoArchiviazioneId(Long esitoArchiviazioneId) {
		this.esitoArchiviazioneId = esitoArchiviazioneId;
	}
	public void setEsitoChiamataId(Long esitoChiamataId) {
		this.esitoChiamataId = esitoChiamataId;
	}

	public void setOperatore(String operatore) {
		this.operatore = ApplicationUtil.trimToNull(operatore);
	}



	public void setOperatoreId(Long operatoreId) {
		this.operatoreId = operatoreId;
	}

	public void setPositivo(String positivo) {
		this.positivo = ApplicationUtil.trimToNull(positivo);
	}

	public void setProprietario(String proprietario) {
		this.proprietario = ApplicationUtil.trimToNull(proprietario);
	}

	public void setProprietarioId(Long proprietarioId) {
		this.proprietarioId = proprietarioId;
	}

	public void setRete(Integer rete) {
		this.rete = rete;
	}


	public void setTipo(Integer tipo) {
		this.tipo = tipo;
	}

	public void setUtile(String utile) {
		this.utile = ApplicationUtil.trimToNull(utile);
	}

}