package it.callite.criteria;

import java.io.Serializable;

import it.callite.constants.ConstantsColumn;
import it.callite.criteria.generic.GenericAllCriteria;
import it.callite.utility.ApplicationUtil;

public class CriterioCriteria extends GenericAllCriteria implements Serializable {
	
	private static final long serialVersionUID = 1L;

	private String categoria;
	private String nome;
	private Integer tipo;
	private Long utente;

	public CriterioCriteria() {
		String date1 [] = {ConstantsColumn.data_creazione};
		String date2 [] = {ConstantsColumn.id};
		String date3 [] = null;
		String date4 [] = null;
		String date5 [] = null;
		addAll(date1, date2, date3, date4, date5);
	}

	public String getCategoria() {
		return ApplicationUtil.trimToNull(categoria);
	}


	public String getNome() {
		return ApplicationUtil.trimToNull(nome);
	}

	public Integer getTipo() {
		return tipo;
	}

	public Long getUtente() {
		return utente;
	}

	public CriterioCriteria resetCriteria() {
		CriterioCriteria c = new CriterioCriteria();
		c.setSerialize(this.getSerialize());
		return c;
	}
	public CriterioCriteria resetCriteria(String b) {
		CriterioCriteria c = resetCriteria();
		c.setCriteria(b);
		return c;
	}

	public void setCategoria(String categoria) {
		this.categoria = ApplicationUtil.trimToNull(categoria);
	}
	

	public void setCriteria(String b) {
		replace(ConstantsColumn.data_creazione, b);
	}

	public void setNome(String nome) {
		this.nome = ApplicationUtil.trimToNull(nome);
	}

	public void setTipo(Integer tipo) {
		this.tipo = tipo;
	}

	public void setUtente(Long utente) {
		this.utente = utente;
	}


}
