package it.callite.criteria;

import java.io.Serializable;

import it.callite.criteria.generic.BaseCriteria;
import it.callite.utility.ApplicationUtil;

public class DecoderCriteria extends BaseCriteria implements Serializable {
	
	private static final long serialVersionUID = 1L;

	private String domanda;
	private Boolean html = false;
	private String risposta;
	private Boolean tipo = false;
	
	public DecoderCriteria() {
	}
	
	public void clearCampi() {
		domanda = null;
		risposta = null;
	}
	

	public String getDomanda() {
		return ApplicationUtil.trimToNull(domanda);
	}

	public Boolean getHtml() {
		return html;
	}
	
	public String getRisposta() {
		return ApplicationUtil.trimToNull(risposta);
	}
	

	public Boolean getTipo() {
		return tipo;
	}

	public DecoderCriteria resetCriteria() {
		DecoderCriteria c = new DecoderCriteria();
		c.setSerialize(this.getSerialize());
		return c;
	}
	public DecoderCriteria resetCriteria(String b) {
		DecoderCriteria c = resetCriteria();
		c.setCriteria(b);
		return c;
	}
	public void setCriteria(String b) {
	}


	public void setDomanda(String domanda) {
		this.domanda = ApplicationUtil.trimToNull(domanda);
	}

	public void setHtml(Boolean html) {
		this.html = html;
	}

	public void setRisposta(String risposta) {
		this.risposta = ApplicationUtil.trimToNull(risposta);
	}

	public void setTipo(Boolean tipo) {
		this.tipo = tipo;
	}

	

}
