package it.callite.criteria;

import java.io.Serializable;

import it.callite.constants.ConstantsColumn;
import it.callite.criteria.generic.GenericAllCriteria;
import it.callite.utility.ApplicationUtil;



public class DomandaContrattoCriteria extends GenericAllCriteria implements Serializable {
	
	private static final long serialVersionUID = 1L;

	private String campo;
	private String chiave;
	private String gruppo;
	private Long sondaggio;
	private Integer tipo;
	
	public DomandaContrattoCriteria() {
		String date1 [] = {ConstantsColumn.data_creazione};
		String date2 [] = {ConstantsColumn.id};
		String date3 [] = null;
		String date4 [] = null;
		String date5 [] = null;
		addAll(date1, date2, date3, date4, date5);
	}

	public String getCampo() {
		return ApplicationUtil.trimToNull(campo);
	}
	
	public Integer getTipo() {
		return tipo;
	}
	public String getChiave() {
		return ApplicationUtil.trimToNull(chiave);
	}

	public void setChiave(String chiave) {
		this.chiave = ApplicationUtil.trimToNull(chiave);
	}
	public DomandaContrattoCriteria resetCriteria() {
		DomandaContrattoCriteria c = new DomandaContrattoCriteria();
		c.setSerialize(this.getSerialize());
		return c;
	}
	public DomandaContrattoCriteria resetCriteria(String b) {
		DomandaContrattoCriteria c = resetCriteria();
		c.setCriteria(b);
		return c;
	}
	
	public void setCampo(String campo) {
		this.campo = ApplicationUtil.trimToNull(campo);
	}

	public void setCriteria(String b) {
		replace(ConstantsColumn.data_creazione, b);
	}

	public void setTipo(Integer tipo) {
		this.tipo = tipo;
	}

	public Long getSondaggio() {
		return sondaggio;
	}

	public void setSondaggio(Long sondaggio) {
		this.sondaggio = sondaggio;
	}

	public String getGruppo() {
		return ApplicationUtil.trimToNull(gruppo);
	}

	public void setGruppo(String gruppo) {
		this.gruppo = ApplicationUtil.trimToNull(gruppo);
	}
	
	
}