package it.callite.criteria;

import java.io.Serializable;

import it.callite.constants.ConstantsColumn;
import it.callite.criteria.generic.GenericAllCriteria;
import it.callite.utility.ApplicationUtil;

public class EsitoArchiviazioneCriteria extends GenericAllCriteria implements Serializable {

	
	private static final long serialVersionUID = 1L;

	private String oggetto;
	private Integer positivo;
	private Integer utile;
	
	
	public EsitoArchiviazioneCriteria() {
		String date1 [] = {ConstantsColumn.data_creazione};
		String date2 [] = {ConstantsColumn.id, ConstantsColumn.codice, ConstantsColumn.ordinamento};
		String date3 [] = null;
		String date4 [] = null;
		String date5 [] = null;
		addAll(date1, date2, date3, date4, date5);
	}
	public String getOggetto() {
		return ApplicationUtil.trimToNull(oggetto);
	}


	public Integer getPositivo() {
		return positivo;
	}

	public Integer getUtile() {
		return utile;
	}
	public EsitoArchiviazioneCriteria resetCriteria() {
		EsitoArchiviazioneCriteria c = new EsitoArchiviazioneCriteria();
		c.setSerialize(this.getSerialize());
		return c;
	}
	public EsitoArchiviazioneCriteria resetCriteria(String b) {
		EsitoArchiviazioneCriteria c = resetCriteria();
		c.setCriteria(b);
		return c;
	}
	public void setCriteria(String b) {
		replace(ConstantsColumn.data_creazione, b);
	}

	public void setOggetto(String oggetto) {
		this.oggetto = ApplicationUtil.trimToNull(oggetto);
	}

	public void setPositivo(Integer positivo) {
		this.positivo = positivo;
	}

	public void setUtile(Integer utile) {
		this.utile = utile;
	}

}
