package it.callite.criteria;

import java.io.Serializable;

import it.callite.constants.ConstantsColumn;
import it.callite.criteria.generic.GenericAllCriteria;
import it.callite.utility.ApplicationUtil;

public class EstrattoCriteria extends GenericAllCriteria implements Serializable {
	
	private static final long serialVersionUID = 1L;


	private String descrizione;
	private String user;
	
	public EstrattoCriteria() {
		String date1 [] = {ConstantsColumn.data_creazione, ConstantsColumn.data_estratto};
		String date2 [] = {ConstantsColumn.id};
		String date3 [] = null;
		String date4 [] = null;
		String date5 [] = null;
		addAll(date1, date2, date3, date4, date5);
	}
	public String getDescrizione() {
		return ApplicationUtil.trimToNull(descrizione);
	}

	
	public String getUser() {
		return ApplicationUtil.trimToNull(user);
	}

	public EstrattoCriteria resetCriteria() {
		EstrattoCriteria c = new EstrattoCriteria();
		c.setSerialize(this.getSerialize());
		return c;
	}
	public EstrattoCriteria resetCriteria(String b) {
		EstrattoCriteria c = resetCriteria();
		c.setCriteria(b);
		return c;
	}

	public void setCriteria(String b) {
		replace(ConstantsColumn.data_creazione, b);
	}
	

	public void setDescrizione(String descrizione) {
		this.descrizione = ApplicationUtil.trimToNull(descrizione);
	}


	public void setUser(String user) {
		this.user = ApplicationUtil.trimToNull(user);
	}


}
