package it.callite.criteria;

import java.io.Serializable;

import it.callite.constants.ConstantsColumn;
import it.callite.criteria.generic.GenericAllCriteria;
import it.callite.utility.ApplicationUtil;

public class ListaCriteria  extends GenericAllCriteria implements Serializable {
	
	private static final long serialVersionUID = 1L;

	private Long campagna;
	private String nome_descrizione;
	private Integer stato_id;
	private Integer attivo_id;
	private String callers;

	public ListaCriteria() {
		String date1 [] = {ConstantsColumn.data_creazione, ConstantsColumn.data_inizio, ConstantsColumn.data_fine};
		String date2 [] = {ConstantsColumn.id};
		String date3 [] = null;
		String date4 [] = {ConstantsColumn.ora_inizio, ConstantsColumn.ora_fine};
		String date5 [] = {ConstantsColumn.week_inizio, ConstantsColumn.week_fine};
		addAll(date1, date2, date3, date4, date5);
	}

	public Long getCampagna() {
		return campagna;
	}
	public String getNome_descrizione() {
		return ApplicationUtil.trimToNull(nome_descrizione);
	}

	public Integer getStato_id() {
		return stato_id;
	}

	public ListaCriteria resetCriteria() {
		ListaCriteria c = new ListaCriteria();
		c.setSerialize(this.getSerialize());
		return c;
	}
	public ListaCriteria resetCriteria(String b) {
		ListaCriteria c = resetCriteria();
		c.setCriteria(b);
		return c;
	}

	public Integer getAttivo_id() {
		return attivo_id;
	}

	public void setAttivo_id(Integer attivo_id) {
		this.attivo_id = attivo_id;
	}

	public void setCampagna(Long campagna) {
		this.campagna = campagna;
	}
	

	public void setCriteria(String b) {
		replace(ConstantsColumn.data_creazione, b);
	}
	

	public void setNome_descrizione(String nome_descrizione) {
		this.nome_descrizione = ApplicationUtil.trimToNull(nome_descrizione);
	}


	public void setStato_id(Integer stato_id) {
		this.stato_id = stato_id;
	}

	public String getCallers() {
		return ApplicationUtil.trimToNull(callers);
	}

	public void setCallers(String callers) {
		this.callers = ApplicationUtil.trimToNull(callers);
	}
	
}
