package it.callite.criteria;

import java.io.Serializable;

import it.callite.constants.ConstantsGlobal;
import it.callite.criteria.generic.GenericFileCriteria;
import it.callite.utility.ApplicationUtil;

public class LoggerCriteria extends GenericFileCriteria implements Serializable {
	
	private static final long serialVersionUID = 1L;

	private String ricerca;
	private String fullText;
	private Integer before = 0;
	private Integer after = 0;
	
	public String getFullText() {
		return ApplicationUtil.trimToNull(fullText);
	}
	public void setFullText(String fullText) {
		this.fullText = ApplicationUtil.trimToNull(fullText);
	}

	public LoggerCriteria() {
	}
	
	public String getRicerca() {
		return ApplicationUtil.trimToNull(ricerca);
	}
	
	public boolean isRicerca(String file, long lunghezza, long modifica) {
		boolean a = true;
		if(ApplicationUtil.isNotBlank(getRicerca())) {
			a = ApplicationUtil.ricercaFile(ConstantsGlobal.colonSeparator, true, ApplicationUtil.getNameN(file), getRicerca());
		}
		boolean b = impostaRicercaDate(lunghezza, modifica);
		return a && b;
	}
	public LoggerCriteria resetCriteria() {
		LoggerCriteria c = new LoggerCriteria();
		c.setSerialize(this.getSerialize());
		return c;
	}
	public LoggerCriteria resetCriteria(String b) {
		LoggerCriteria c = resetCriteria();
		c.setCriteria(b);
		return c;
	}
	public void setCriteria(String b) {
		replace(b);
	}
	
	public void setRicerca(String ricerca) {
		this.ricerca = ApplicationUtil.trimToNull(ricerca);
	}
	public Integer getBefore() {
		return before;
	}
	public void setBefore(Integer before) {
		this.before = before;
	}
	public Integer getAfter() {
		return after;
	}
	public void setAfter(Integer after) {
		this.after = after;
	}
}
