package it.callite.criteria;
import java.io.Serializable;

import it.callite.constants.ConstantsColumn;
import it.callite.criteria.generic.GenericAllCriteria;
import it.callite.utility.ApplicationUtil;
public class MessaggioCestinoInUscitaCriteria  extends GenericAllCriteria implements Serializable  {

	private static final long serialVersionUID = 1L;

	private String destinatario;  
	private String mittente;
	private String testo;

	public MessaggioCestinoInUscitaCriteria() {
		String date1 [] = {ConstantsColumn.data_creazione, ConstantsColumn.data_invio};
		String date2 [] = {ConstantsColumn.id};
		String date3 [] = null;
		String date4 [] = null;
		String date5 [] = null;
		addAll(date1, date2, date3, date4, date5);
	}

	public String getDestinatario() {
		return ApplicationUtil.trimToNull(destinatario);
	}
	public String getMittente() {
		return ApplicationUtil.trimToNull(mittente);
	}
	public String getTesto() {
		return ApplicationUtil.trimToNull(testo);
	}
	public MessaggioCestinoInUscitaCriteria resetCriteria() {
		MessaggioCestinoInUscitaCriteria c = new MessaggioCestinoInUscitaCriteria();
		c.setSerialize(this.getSerialize());
		return c;
	}
	public MessaggioCestinoInUscitaCriteria resetCriteria(String b) {
		MessaggioCestinoInUscitaCriteria c = resetCriteria();
		c.setCriteria(b);
		return c;
	}
	public void setCriteria(String b) {
		replace(ConstantsColumn.data_creazione, b);
	}
	public void setDestinatario(String destinatario) {
		this.destinatario = ApplicationUtil.trimToNull(destinatario);
	}
	public void setMittente(String mittente) {
		this.mittente = ApplicationUtil.trimToNull(mittente);
	}
	public void setTesto(String testo) {
		this.testo = ApplicationUtil.trimToNull(testo);
	}


}