package it.callite.criteria;

import java.io.Serializable;

import it.callite.constants.ConstantsColumn;
import it.callite.criteria.generic.GenericAllCriteria;
import it.callite.utility.ApplicationUtil;

public class NotiziaCriteria extends GenericAllCriteria implements Serializable {

	private static final long serialVersionUID = 1L;

	private Integer attivo;
	private String oggetto;
	
	public NotiziaCriteria() {
		String date1 [] = {ConstantsColumn.data_creazione, ConstantsColumn.data_inizio, ConstantsColumn.data_fine};
		String date2 [] = {ConstantsColumn.id};
		String date3 [] = null;
		String date4 [] = {ConstantsColumn.ora_inizio, ConstantsColumn.ora_fine};
		String date5 [] = {ConstantsColumn.week_inizio, ConstantsColumn.week_fine};
		addAll(date1, date2, date3, date4, date5);
	}

	public Integer getAttivo() {
		return attivo;
	}

	public String getOggetto() {
		return ApplicationUtil.trimToNull(oggetto);
	}

	public NotiziaCriteria resetCriteria() {
		NotiziaCriteria c = new NotiziaCriteria();
		c.setSerialize(this.getSerialize());
		return c;
	}
	public NotiziaCriteria resetCriteria(String b) {
		NotiziaCriteria c = resetCriteria();
		c.setCriteria(b);
		return c;
	}
	public void setAttivo(Integer attivo) {
		this.attivo = attivo;
	}

	public void setCriteria(String b) {
		replace(ConstantsColumn.data_creazione, b);
	}

	public void setOggetto(String oggetto) {
		this.oggetto = ApplicationUtil.trimToNull(oggetto);
	}

}
