package it.callite.criteria;

import java.io.Serializable;

import it.callite.constants.ConstantsColumn;
import it.callite.criteria.generic.GenericAllCriteria;
import it.callite.utility.ApplicationUtil;

public class OperazioneCriteria extends GenericAllCriteria implements Serializable {

	private static final long serialVersionUID = 1L;

	private String operatore;
	private Short stato;
	private String descrizione;
	
	public OperazioneCriteria() {
		String date1 [] = {ConstantsColumn.data_creazione};
		String date2 [] = {ConstantsColumn.id};
		String date3 [] = null;
		String date4 [] = null;
		String date5 [] = null;
		addAll(date1, date2, date3, date4, date5);
	}

	public String getOperatore() {
		return ApplicationUtil.trimToNull(operatore);
	}
	
	public Short getStato() {
		return stato;
	}
	public OperazioneCriteria resetCriteria() {
		OperazioneCriteria c = new OperazioneCriteria();
		c.setSerialize(this.getSerialize());
		return c;
	}
	public OperazioneCriteria resetCriteria(String b) {
		OperazioneCriteria c = resetCriteria();
		c.setCriteria(b);
		return c;
	}
	public void setCriteria(String b) {
		replace(ConstantsColumn.data_creazione, b);
	}

	public void setOperatore(String operatore) {
		this.operatore = ApplicationUtil.trimToNull(operatore);
	}

	public void setStato(Short stato) {
		this.stato = stato;
	}

	public String getDescrizione() {
		return ApplicationUtil.trimToNull(descrizione);
	}

	public void setDescrizione(String descrizione) {
		this.descrizione = ApplicationUtil.trimToNull(descrizione);
	}

}
