package it.callite.criteria;

import java.io.Serializable;

import it.callite.constants.ConstantsColumn;
import it.callite.criteria.generic.GenericAllCriteria;
import it.callite.utility.ApplicationUtil;

public class OpposizioneCriteria extends GenericAllCriteria implements Serializable {

	private static final long serialVersionUID = 1L;

	private Long campagna;
	private String numero;
	private String ricerca_denominazione;
	private Integer utente;

	public OpposizioneCriteria() {
		String date1 [] = {ConstantsColumn.data_creazione};
		String date2 [] = {ConstantsColumn.id};
		String date3 [] = null;
		String date4 [] = null;
		String date5 [] = null;
		addAll(date1, date2, date3, date4, date5);
	}

	public Long getCampagna() {
		return campagna;
	}

	public String getNumero() {
		return ApplicationUtil.trimToNull(numero);
	}
	public String getRicerca_denominazione() {
		return ApplicationUtil.trimToNull(ricerca_denominazione);
	}
	public Integer getUtente() {
		return utente;
	}
	
	public OpposizioneCriteria resetCriteria() {
		OpposizioneCriteria c = new OpposizioneCriteria();
		c.setSerialize(this.getSerialize());
		return c;
	}
	public OpposizioneCriteria resetCriteria(String b) {
		OpposizioneCriteria c = resetCriteria();
		c.setCriteria(b);
		return c;
	}

	public void setCampagna(Long campagna) {
		this.campagna = campagna;
	}

	public void setCriteria(String b) {
		replace(ConstantsColumn.data_creazione, b);
	}

	public void setNumero(String numero) {
		this.numero = ApplicationUtil.trimToNull(numero);
	}

	public void setRicerca_denominazione(String ricerca_denominazione) {
		this.ricerca_denominazione = ApplicationUtil.trimToNull(ricerca_denominazione);
	}

	public void setUtente(Integer utente) {
		this.utente = utente;
	}


}
