package it.callite.criteria;

import java.io.Serializable;

import it.callite.constants.ConstantsColumn;
import it.callite.criteria.generic.GenericAllCriteria;
import it.callite.utility.ApplicationUtil;

public class PausaCriteria extends GenericAllCriteria implements Serializable {

	private static final long serialVersionUID = 1L;

	
	private String descrizione;
	private Long operatore;
	private Integer positivo;
	private Long team;

	
	public PausaCriteria() {
		String date1 [] = {ConstantsColumn.data_creazione, ConstantsColumn.data_inizio, ConstantsColumn.data_fine};
		String date2 [] = {ConstantsColumn.id};
		String date3 [] = null;
		String date4 [] = null;
		String date5 [] = null;
		addAll(date1, date2, date3, date4, date5);
	}

	public String getDescrizione() {
		return ApplicationUtil.trimToNull(descrizione);
	}

	public Long getOperatore() {
		return operatore;
	}
	public Integer getPositivo() {
		return positivo;
	}

	public Long getTeam() {
		return team;
	}

	public PausaCriteria resetCriteria() {
		PausaCriteria c = new PausaCriteria();
		c.setSerialize(this.getSerialize());
		return c;
	}
	public PausaCriteria resetCriteria(String b) {
		PausaCriteria c = resetCriteria();
		c.setCriteria(b);
		return c;
	}
	public void setCriteria(String b) {
		replace(ConstantsColumn.data_creazione, b);
	}

	public void setDescrizione(String descrizione) {
		this.descrizione = ApplicationUtil.trimToNull(descrizione);
	}

	public void setOperatore(Long operatore) {
		this.operatore = operatore;
	}

	public void setPositivo(Integer positivo) {
		this.positivo = positivo;
	}

	public void setTeam(Long team) {
		this.team = team;
	}

	


}
