package it.callite.criteria;

import java.io.Serializable;

import it.callite.constants.ConstantsColumn;
import it.callite.criteria.generic.GenericAllCriteria;
import it.callite.utility.ApplicationUtil;

public class PrenotazioneCriteria extends GenericAllCriteria implements Serializable {

	private static final long serialVersionUID = 1L;

	private String agente;
	private Long agenteId;
	private Boolean azione = Boolean.FALSE;
	
	private Long operatoreId;

	private Long campagnaId;
	private Integer rete = 0;
	private Integer stato;

	private String telefono;

	private String utente;

	public PrenotazioneCriteria() {
		String date1 [] = {ConstantsColumn.data_creazione};
		String date2 [] = {ConstantsColumn.id};
		String date3 [] = null;
		String date4 [] = null;
		String date5 [] = null;
		addAll(date1, date2, date3, date4, date5);
	}

	public String getAgente() {
		return ApplicationUtil.trimToNull(agente);
	}
	public Long getAgenteId() {
		return agenteId;
	}
	public Boolean getAzione() {
		return azione;
	}
	public Long getCampagnaId() {
		return campagnaId;
	}
	public Integer getRete() {
		return rete;
	}


	public Long getOperatoreId() {
		return operatoreId;
	}

	public void setOperatoreId(Long operatoreId) {
		this.operatoreId = operatoreId;
	}

	public Integer getStato() {
		return stato;
	}

	public String getTelefono() {
		return ApplicationUtil.trimToNull(telefono);
	}
	public String getUtente() {
		return ApplicationUtil.trimToNull(utente);
	}

	public PrenotazioneCriteria resetCriteria() {
		PrenotazioneCriteria c = new PrenotazioneCriteria();
		c.setSerialize(this.getSerialize());
		return c;
	}
	public PrenotazioneCriteria resetCriteria(String b) {
		PrenotazioneCriteria c = resetCriteria();
		c.setCriteria(b);
		return c;
	}

	public void setAgente(String agente) {
		this.agente = ApplicationUtil.trimToNull(agente);
	}

	public void setAgenteId(Long agenteId) {
		this.agenteId = agenteId;
	}

	public void setAzione(Boolean azione) {
		this.azione = azione;
	}

	public void setCampagnaId(Long campagnaId) {
		this.campagnaId = campagnaId;
	}
	public void setCriteria(String b) {
		replace(ConstantsColumn.data_creazione, b);
	}

	public void setRete(Integer rete) {
		this.rete = rete;
	}

	public void setStato(Integer stato) {
		this.stato = stato;
	}

	public void setTelefono(String telefono) {
		this.telefono = ApplicationUtil.trimToNull(telefono);
	}

	public void setUtente(String utente) {
		this.utente = ApplicationUtil.trimToNull(utente);
	}





}
