package it.callite.criteria;

import java.io.Serializable;

import it.callite.constants.ConstantsColumn;
import it.callite.criteria.generic.GenericAllCriteria;
import it.callite.utility.ApplicationUtil;

public class ProdottoCriteria extends GenericAllCriteria implements Serializable {

	private static final long serialVersionUID = 1L;

	private Long categoria;
	private String descrizione;
	private String nome;

	
	public ProdottoCriteria() {
		String date1 [] = {ConstantsColumn.data_creazione};
		String date2 [] = {ConstantsColumn.id};
		String date3 [] = null;
		String date4 [] = null;
		String date5 [] = null;
		addAll(date1, date2, date3, date4, date5);
	}

	public Long getCategoria() {
		return categoria;
	}
	public String getDescrizione() {
		return ApplicationUtil.trimToNull(descrizione);
	}

	public String getNome() {
		return ApplicationUtil.trimToNull(nome);
	}

	public ProdottoCriteria resetCriteria() {
		ProdottoCriteria c = new ProdottoCriteria();
		c.setSerialize(this.getSerialize());
		return c;
	}
	public ProdottoCriteria resetCriteria(String b) {
		ProdottoCriteria c = resetCriteria();
		c.setCriteria(b);
		return c;
	}
	public void setCategoria(Long categoria) {
		this.categoria = categoria;
	}

	public void setCriteria(String b) {
		replace(ConstantsColumn.data_creazione, b);
	}

	public void setDescrizione(String descrizione) {
		this.descrizione = ApplicationUtil.trimToNull(descrizione);
	}

	public void setNome(String nome) {
		this.nome = ApplicationUtil.trimToNull(nome);
	}
}
