package it.callite.criteria;

import java.io.Serializable;

import it.callite.constants.ConstantsColumn;
import it.callite.criteria.generic.GenericAllCriteria;
import it.callite.utility.ApplicationUtil;

public class QualificaCriteria extends GenericAllCriteria implements Serializable {

	private static final long serialVersionUID = 1L;

	private String testo;
	
	public QualificaCriteria() {
		String date1 [] = {ConstantsColumn.data_creazione};
		String date2 [] = {ConstantsColumn.id};
		String date3 [] = null;
		String date4 [] = null;
		String date5 [] = null;
		addAll(date1, date2, date3, date4, date5);
	}

	public String getTesto() {
		return ApplicationUtil.trimToNull(testo);
	}

	public QualificaCriteria resetCriteria() {
		QualificaCriteria c = new QualificaCriteria();
		c.setSerialize(this.getSerialize());
		return c;
	}
	public QualificaCriteria resetCriteria(String b) {
		QualificaCriteria c = resetCriteria();
		c.setCriteria(b);
		return c;
	}


	public void setCriteria(String b) {
		replace(ConstantsColumn.data_creazione, b);
	}


	public void setTesto(String testo) {
		this.testo = ApplicationUtil.trimToNull(testo);
	}


}
