package it.callite.criteria;

import java.io.Serializable;
import java.util.List;

import it.callite.constants.ConstantsGlobal;
import it.callite.criteria.generic.GenericFileCriteria;
import it.callite.utility.ApplicationUtil;

public class RegistrazioneReportCriteria  extends GenericFileCriteria implements Serializable {

	private static final long serialVersionUID = 1L;

	private Long campagnaId;
	private Long esitoChiamataId;
	private String ricerca;
	private String ricerca_anagrafica;
	private List<String> ricerca_anagraficaV = ApplicationUtil.getAnagraficaDefault();

	public void resetAnagraficaV() {
		ricerca_anagraficaV = ApplicationUtil.getAnagraficaDefault();
	}
	public List<String> getRicerca_anagraficaV() {
		return ricerca_anagraficaV;
	}

	public void setRicerca_anagraficaV(List<String> ricerca_anagraficaV) {
		this.ricerca_anagraficaV = ricerca_anagraficaV;
	}

	public RegistrazioneReportCriteria() {
		
	}
	
	public void setRicerca_anagrafica(String ricerca_anagrafica) {
		this.ricerca_anagrafica = ApplicationUtil.trimToNull(ricerca_anagrafica);
	}
	public String getRicerca_anagrafica() {
		return ApplicationUtil.trimToNull(ricerca_anagrafica);
	}
	public Long getCampagnaId() {
		return campagnaId;
	}
	public Long getEsitoChiamataId() {
		return esitoChiamataId;
	}
	public String getRicerca() {
		return ApplicationUtil.trimToNull(ricerca);
	}


	public boolean isRicerca(String file, long lunghezza, long modifica) {
		boolean a = true;
		if(ApplicationUtil.isNotBlank(getRicerca())) {
			a = ApplicationUtil.ricercaFile(ConstantsGlobal.colonSeparator, true, ApplicationUtil.getNameN(file), getRicerca());
		}
		boolean b = impostaRicercaDate(lunghezza, modifica);
		return a && b;
	}
	public RegistrazioneReportCriteria resetCriteria() {
		RegistrazioneReportCriteria c = new RegistrazioneReportCriteria();
		c.setSerialize(this.getSerialize());
		return c;
	}

	public RegistrazioneReportCriteria resetCriteria(String b) {
		RegistrazioneReportCriteria c = resetCriteria();
		c.setCriteria(b);
		return c;
	}
	public void setCampagnaId(Long campagnaId) {
		this.campagnaId = campagnaId;
	}
	public void setCriteria(String b) {
		replace(b);
	}
	public void setEsitoChiamataId(Long esitoChiamataId) {
		this.esitoChiamataId = esitoChiamataId;
	}
	public void setRicerca(String ricerca) {
		this.ricerca = ApplicationUtil.trimToNull(ricerca);
	}

}