package it.callite.criteria;

import java.io.Serializable;

import it.callite.constants.ConstantsColumn;
import it.callite.criteria.generic.GenericAllCriteria;
import it.callite.utility.ApplicationUtil;

public class RicezioneCriteria extends GenericAllCriteria implements Serializable {

	private static final long serialVersionUID = 1L;

	private String mittente;
	private String oggetto;
	private Integer archiviato = 0;
	private Integer letto = 0;
	
	
	public RicezioneCriteria() {
		String date1 [] = {ConstantsColumn.data_creazione,ConstantsColumn.data_invio, ConstantsColumn.data_ricezione};
		String date2 [] = {ConstantsColumn.id};
		String date3 [] = null;
		String date4 [] = null;
		String date5 [] = null;
		addAll(date1, date2, date3, date4, date5);
	}
	
	public RicezioneCriteria resetCriteria() {
		RicezioneCriteria c = new RicezioneCriteria();
		c.setSerialize(this.getSerialize());
		return c;
	}
	public RicezioneCriteria resetCriteria(String b) {
		RicezioneCriteria c = resetCriteria();
		c.setCriteria(b);
		return c;
	}
	
	public void setCriteria(String b) {
		replace(ConstantsColumn.data_creazione, b);
	}

	public String getMittente() {
		return ApplicationUtil.trimToNull(mittente);
	}

	public void setMittente(String mittente) {
		this.mittente = ApplicationUtil.trimToNull(mittente);
	}

	public String getOggetto() {
		return ApplicationUtil.trimToNull(oggetto);
	}

	public void setOggetto(String oggetto) {
		this.oggetto = ApplicationUtil.trimToNull(oggetto);
	}

	public Integer getArchiviato() {
		return archiviato;
	}

	public void setArchiviato(Integer archiviato) {
		this.archiviato = archiviato;
	}

	public Integer getLetto() {
		return letto;
	}

	public void setLetto(Integer letto) {
		this.letto = letto;
	}



}
