package it.callite.criteria;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

import it.callite.criteria.generic.BaseCriteria;
import it.callite.utility.ApplicationUtil;
import it.callite.utility.EsitoGenerico;
import it.callite.utility.item.CampagnaSI;
import it.callite.utility.item.ListaSI;

public class RiprogrammaContattoCriteria  extends BaseCriteria implements Serializable {

	private static final long serialVersionUID = 1L;

	private List<CampagnaSI> campagne;
	private List<CampagnaSI> campagneSI;
	private List<EsitoGenerico> esiti;
	private List<EsitoGenerico> esitiSI;
	private Boolean inserimento = true;
	private List<ListaSI> liste;
	private List<ListaSI> listeSI;
	private Integer operazione = 1;


	private String ricerca_anagrafica;
	private List<String> ricerca_anagraficaV = ApplicationUtil.getAnagraficaDefault();

	public void resetAnagraficaV() {
		ricerca_anagraficaV = ApplicationUtil.getAnagraficaDefault();
	}


	public RiprogrammaContattoCriteria() {
	}

	public List<CampagnaSI> getCampagne() {
		if(ApplicationUtil.empty(campagne)) {
			campagne = new ArrayList<CampagnaSI>();
		}
		return campagne;
	}


	public List<CampagnaSI> getCampagneSI() {
		if(ApplicationUtil.empty(campagneSI)) {
			campagneSI = new ArrayList<CampagnaSI>();
		}
		return campagneSI;
	}

	public List<EsitoGenerico> getEsiti() {
		if(ApplicationUtil.empty(esiti)) {
			esiti = new ArrayList<EsitoGenerico>();
		}
		return esiti;
	}

	public List<EsitoGenerico> getEsitiSI() {
		if(ApplicationUtil.empty(esitiSI)) {
			esitiSI = new ArrayList<EsitoGenerico>();
		}
		return esitiSI;
	}

	public Boolean getInserimento() {
		return inserimento;
	}
	public List<ListaSI> getListe() {
		if(ApplicationUtil.empty(liste)) {
			liste = new ArrayList<ListaSI>();
		}
		return liste;
	}

	public List<ListaSI> getListeSI() {
		if(ApplicationUtil.empty(listeSI)) {
			listeSI = new ArrayList<ListaSI>();
		}
		return listeSI;
	}


	public Integer getOperazione() {
		if(ApplicationUtil.ltZero(operazione)) {
			operazione = 1;
		}
		return operazione;
	}

	public RiprogrammaContattoCriteria resetCriteria() {
		RiprogrammaContattoCriteria c = new RiprogrammaContattoCriteria();
		c.setSerialize(this.getSerialize());
		return c;
	}
	public RiprogrammaContattoCriteria resetCriteria(String b) {
		RiprogrammaContattoCriteria c = resetCriteria();
		c.setCriteria(b);
		return c;
	}
	public void setCampagne(List<CampagnaSI> campagne) {
		this.campagne = campagne;
	}

	public void setCampagneSI(List<CampagnaSI> campagneSI) {
		this.campagneSI = campagneSI;
	}

	public void setCriteria(String b) {
		replace(b);
	}

	public void setEsiti(List<EsitoGenerico> esiti) {
		this.esiti = esiti;
	}

	public void setEsitiSI(List<EsitoGenerico> esitiSI) {
		this.esitiSI = esitiSI;
	}

	public void setInserimento(Boolean inserimento) {
		this.inserimento = inserimento;
	}

	public void setListe(List<ListaSI> liste) {
		this.liste = liste;
	}
	public void setListeSI(List<ListaSI> listeSI) {
		this.listeSI = listeSI;
	}
	public void setOperazione(Integer operazione) {
		this.operazione = operazione;
	}


	public String getRicerca_anagrafica() {
		return ApplicationUtil.trimToNull(ricerca_anagrafica);
	}

	public void setRicerca_anagrafica(String ricerca_anagrafica) {
		this.ricerca_anagrafica = ApplicationUtil.trimToNull(ricerca_anagrafica);
	}


	public List<String> getRicerca_anagraficaV() {
		return ricerca_anagraficaV;
	}


	public void setRicerca_anagraficaV(List<String> ricerca_anagraficaV) {
		this.ricerca_anagraficaV = ricerca_anagraficaV;
	}

}