package it.callite.criteria;

import java.io.Serializable;

import it.callite.constants.ConstantsColumn;
import it.callite.criteria.generic.GenericAllCriteria;
import it.callite.utility.ApplicationUtil;

public class SchedulerCriteria extends GenericAllCriteria implements Serializable {

	private static final long serialVersionUID = 1L;

	private String nome;
	private Boolean avviato = null;
	private Integer tipo;
	
	public SchedulerCriteria() {
		String date1 [] = {ConstantsColumn.data_creazione, ConstantsColumn.data_schedulata};
		String date2 [] = {ConstantsColumn.id};
		String date3 [] = null;
		String date4 [] = null;
		String date5 [] = null;
		addAll(date1, date2, date3, date4, date5);
	}
	
	public void setCriteria(String b) {
		replace(ConstantsColumn.orario, b);
	}
	
	public Integer getTipo() {
		return tipo;
	}

	public void setTipo(Integer tipo) {
		this.tipo = tipo;
	}
	
	public SchedulerCriteria resetCriteria() {
		SchedulerCriteria c = new SchedulerCriteria();
		c.setSerialize(this.getSerialize());
		return c;
	}
	public SchedulerCriteria resetCriteria(String b) {
		SchedulerCriteria c = resetCriteria();
		c.setCriteria(b);
		return c;
	}

	public String getNome() {
		return ApplicationUtil.trimToNull(nome);
	}

	public void setNome(String nome) {
		this.nome = ApplicationUtil.trimToNull(nome);
	}

	public Boolean getAvviato() {
		return avviato;
	}

	public void setAvviato(Boolean avviato) {
		this.avviato = avviato;
	}

	
}
