package it.callite.criteria;

import java.io.Serializable;

import it.callite.constants.ConstantsColumn;
import it.callite.criteria.generic.GenericAllCriteria;
import it.callite.utility.ApplicationUtil;

public class SondaggioContrattoCriteria  extends GenericAllCriteria implements Serializable {

	private static final long serialVersionUID = 1L;

	private String nome;
	private Long prodottoId;
	
	public SondaggioContrattoCriteria() {
		String date1 [] = {ConstantsColumn.data_creazione};
		String date2 [] = {ConstantsColumn.id};
		String date3 [] = null;
		String date4 [] = null;
		String date5 [] = null;
		addAll(date1, date2, date3, date4, date5);
	}

	public String getNome() {
		return ApplicationUtil.trimToNull(nome);
	}	
	public Long getProdottoId() {
		return prodottoId;
	}
	
	public SondaggioContrattoCriteria resetCriteria() {
		SondaggioContrattoCriteria c = new SondaggioContrattoCriteria();
		c.setSerialize(this.getSerialize());
		return c;
	}
	public SondaggioContrattoCriteria resetCriteria(String b) {
		SondaggioContrattoCriteria c = resetCriteria();
		c.setCriteria(b);
		return c;
	}
	public void setCriteria(String b) {
		replace(ConstantsColumn.data_creazione, b);
	}

	public void setNome(String nome) {
		this.nome = ApplicationUtil.trimToNull(nome);
	}
	

	public void setProdottoId(Long prodottoId) {
		this.prodottoId = prodottoId;
	}


	
}