package it.callite.criteria;

import java.io.Serializable;
import java.util.List;

import it.callite.constants.ConstantsColumn;
import it.callite.criteria.generic.GenericAllCriteria;
import it.callite.utility.ApplicationUtil;

public class SondaggioCriteria extends GenericAllCriteria implements Serializable {

	private static final long serialVersionUID = 1L;

	private String ricerca_anagrafica;
	private List<String> ricerca_anagraficaV = ApplicationUtil.getAnagraficaDefault();
	private Long campagna;
	private String operatore;
	
	public Long getCampagna() {
		return campagna;
	}
	public String getOperatore() {
		return ApplicationUtil.trimToNull(operatore);
	}
	public void setOperatore(String operatore) {
		this.operatore = ApplicationUtil.trimToNull(operatore);
	}
	public void setCampagna(Long campagna) {
		this.campagna = campagna;
	}

	public void resetAnagraficaV() {
		ricerca_anagraficaV = ApplicationUtil.getAnagraficaDefault();
	}
	public List<String> getRicerca_anagraficaV() {
		return ricerca_anagraficaV;
	}

	public void setRicerca_anagraficaV(List<String> ricerca_anagraficaV) {
		this.ricerca_anagraficaV = ricerca_anagraficaV;
	}
	
	
	public SondaggioCriteria() {
		String date1 [] = {ConstantsColumn.data_creazione};
		String date2 [] = {ConstantsColumn.id};
		String date3 [] = {ConstantsColumn.voto};
		String date4 [] = null;
		String date5 [] = null;
		addAll(date1, date2, date3, date4, date5);
	}
	
	public void setRicerca_anagrafica(String ricerca_anagrafica) {
		this.ricerca_anagrafica = ApplicationUtil.trimToNull(ricerca_anagrafica);
	}
	public String getRicerca_anagrafica() {
		return ApplicationUtil.trimToNull(ricerca_anagrafica);
	}

	
	
	public SondaggioCriteria resetCriteria() {
		SondaggioCriteria c = new SondaggioCriteria();
		c.setSerialize(this.getSerialize());
		return c;
	}
	public SondaggioCriteria resetCriteria(String b) {
		SondaggioCriteria c = resetCriteria();
		c.setCriteria(b);
		return c;
	}
	
	public void setCriteria(String b) {
		replace(ConstantsColumn.data_creazione, b);
	}


	
	

}
