package it.callite.criteria;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

import it.callite.constants.ConstantsColumn;
import it.callite.criteria.generic.RicercaStoricoCriteria;
import it.callite.utility.ApplicationUtil;


public class StoriaAppuntamentoCriteria  extends RicercaStoricoCriteria  implements Serializable {

	private static final long serialVersionUID = 1L;

	private Long agenteId;
	private Long campagnaId;
	private Long esito;
	private String ricerca_anagrafica;
	private String utente;
	private Long utenteId;
	private List<String> ricerca_anagraficaV = ApplicationUtil.getAnagraficaDefault();
	private List<String> esitos = new ArrayList<String>();
	private Long operatoreId;
	
	public Long getOperatoreId() {
		return operatoreId;
	}
	public void setOperatoreId(Long operatoreId) {
		this.operatoreId = operatoreId;
	}
	public void resetAnagraficaV() {
		ricerca_anagraficaV = ApplicationUtil.getAnagraficaDefault();
	}
	public List<String> getEsitos() {
		return esitos;
	}

	public void setEsitos(List<String> esitos) {
		this.esitos = esitos;
	}

	public List<String> getRicerca_anagraficaV() {
		return ricerca_anagraficaV;
	}

	public void setRicerca_anagraficaV(List<String> ricerca_anagraficaV) {
		this.ricerca_anagraficaV = ricerca_anagraficaV;
	}


	public StoriaAppuntamentoCriteria() {
		String date1 [] = {ConstantsColumn.data, ConstantsColumn.data_inizio, ConstantsColumn.data_fine, ConstantsColumn.data_esito, ConstantsColumn.data_stato, ConstantsColumn.data_conferma};
		String date2 [] = {ConstantsColumn.id};
		String date3 [] = null;
		String date4 [] = null;
		String date5 [] = null;
		addAll(date1, date2, date3, date4, date5);
	}

	public void setRicerca_anagrafica(String ricerca_anagrafica) {
		this.ricerca_anagrafica = ApplicationUtil.trimToNull(ricerca_anagrafica);
	}
	public String getRicerca_anagrafica() {
		return ApplicationUtil.trimToNull(ricerca_anagrafica);
	}

	public Long getAgenteId() {
		return agenteId;
	}
	public Long getCampagnaId() {
		return campagnaId;
	}


	public String getUtente() {
		return ApplicationUtil.trimToNull(utente);
	}

	public Long getUtenteId() {
		return utenteId;
	}

	public StoriaAppuntamentoCriteria resetCriteria() {
		StoriaAppuntamentoCriteria c = new StoriaAppuntamentoCriteria();
		c.setSerialize(this.getSerialize());
		return c;
	}
	public StoriaAppuntamentoCriteria resetCriteria(String b) {
		StoriaAppuntamentoCriteria c = resetCriteria();
		c.setCriteria(b);
		return c;
	}
	public void setAgenteId(Long agenteId) {
		this.agenteId = agenteId;
	}

	public void setCampagnaId(Long campagnaId) {
		this.campagnaId = campagnaId;
	}

	public void setCriteria(String b) {
		replace(ConstantsColumn.data, b);
	}



	public void setUtente(String utente) {
		this.utente = ApplicationUtil.trimToNull(utente);
	}

	public void setUtenteId(Long utenteId) {
		this.utenteId = utenteId;
	}

	public Long getEsito() {
		return esito;
	}

	public void setEsito(Long esito) {
		this.esito = esito;
	}




}