package it.callite.criteria;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

import it.callite.constants.ConstantsColumn;
import it.callite.constants.ConstantsGlobal;
import it.callite.criteria.generic.RicercaStoricoCriteria;
import it.callite.utility.ApplicationUtil;
import it.callite.utility.StatoIntervallo;

public class StoriaContattoCriteria  extends RicercaStoricoCriteria implements Serializable {

	private static final long serialVersionUID = 1L;

	private Long campagnaId;
	private Long esitoChiamataId;
	private Long esitoArchiviazioneId;
	private Integer pannello = 0;
	private Long operatoreId;
	private String operatore;
	private String ricerca_anagrafica;
	private Long agenteId;
	
	private List<String> ricerca_anagraficaV = ApplicationUtil.getAnagraficaDefault();
	private List<String> esitoArchiviazioneIds = new ArrayList<String>();
	private List<String> esitoChiamataIds = new ArrayList<String>();

	public void resetAnagraficaV() {
		ricerca_anagraficaV = ApplicationUtil.getAnagraficaDefault();
	}
	private StatoIntervallo statoIntervallo = new StatoIntervallo();
	public StatoIntervallo getStatoIntervallo() {
		return statoIntervallo;
	}

	public void setStatoIntervallo(StatoIntervallo statoIntervallo) {
		this.statoIntervallo = statoIntervallo;
	}

	public List<String> getEsitoArchiviazioneIds() {
		return esitoArchiviazioneIds;
	}
	public void setEsitoArchiviazioneIds(List<String> esitoArchiviazioneIds) {
		this.esitoArchiviazioneIds = esitoArchiviazioneIds;
	}
	public List<String> getEsitoChiamataIds() {
		return esitoChiamataIds;
	}
	public void setEsitoChiamataIds(List<String> esitoChiamataIds) {
		this.esitoChiamataIds = esitoChiamataIds;
	}
	public List<String> getRicerca_anagraficaV() {
		return ricerca_anagraficaV;
	}

	public void setRicerca_anagraficaV(List<String> ricerca_anagraficaV) {
		this.ricerca_anagraficaV = ricerca_anagraficaV;
	}


	public StoriaContattoCriteria() {
		String date1 [] = {ConstantsColumn.data, ConstantsColumn.data_presentazione, ConstantsColumn.data_archiviazione, ConstantsColumn.date_apertura, ConstantsColumn.date_chiamata, ConstantsColumn.date_risposta, ConstantsColumn.date_rec_inizio, ConstantsColumn.date_rec_fine, ConstantsColumn.date_fine, ConstantsColumn.date_esito, ConstantsColumn.date_attesa_inizio, ConstantsColumn.date_attesa_fine};
		String date2 [] = {ConstantsColumn.id};
		String date3 [] = {ConstantsColumn.secondi_tot,  ConstantsColumn.secondi_conv_eff,  ConstantsColumn.secondi_conv_tot, ConstantsColumn.secondi_post, ConstantsColumn.secondi_pre,ConstantsColumn.secondi_rec, ConstantsColumn.secondi_attesa };
		String date4 [] = null;
		String date5 [] = null;
		addAll(date1, date2, date3, date4, date5);
	}

	public Long getAgenteId() {
		return agenteId;
	}

	public void setAgenteId(Long agenteId) {
		this.agenteId = agenteId;
	}
	public void setRicerca_anagrafica(String ricerca_anagrafica) {
		this.ricerca_anagrafica = ApplicationUtil.trimToNull(ricerca_anagrafica);
	}
	public String getRicerca_anagrafica() {
		return ApplicationUtil.trimToNull(ricerca_anagrafica);
	}

	public void setCriteria(String b) {
		statoIntervallo = new StatoIntervallo(ConstantsGlobal.stato_attivo, ConstantsGlobal.stato_attivo, null, null);
		replace(ConstantsColumn.data, b);
	}
	public Long getCampagnaId() {
		return campagnaId;
	}

	public Long getEsitoArchiviazioneId() {
		return esitoArchiviazioneId;
	}

	public Long getEsitoChiamataId() {
		return esitoChiamataId;
	}



	public Long getOperatoreId() {
		return operatoreId;
	}

	public void setOperatoreId(Long operatoreId) {
		this.operatoreId = operatoreId;
	}
	public StoriaContattoCriteria resetCriteria() {
		StoriaContattoCriteria c = new StoriaContattoCriteria();
		c.setSerialize(this.getSerialize());
		return c;
	}
	public StoriaContattoCriteria resetCriteria(String b) {
		StoriaContattoCriteria c = resetCriteria();
		c.setCriteria(b);
		return c;
	}
	public void setCampagnaId(Long campagnaId) {
		this.campagnaId = campagnaId;
	}

	public void setEsitoArchiviazioneId(Long esitoArchiviazioneId) {
		this.esitoArchiviazioneId = esitoArchiviazioneId;
	}
	public void setEsitoChiamataId(Long esitoChiamataId) {
		this.esitoChiamataId = esitoChiamataId;
	}
	public String getOperatore() {
		return ApplicationUtil.trimToNull(operatore);
	}

	public void setOperatore(String operatore) {
		this.operatore = ApplicationUtil.trimToNull(operatore);
	}

	public Integer getPannello() {
		return pannello;
	}

	public void setPannello(Integer pannello) {
		this.pannello = pannello;
	}



}