package it.callite.criteria;

import java.io.Serializable;

import it.callite.constants.ConstantsColumn;
import it.callite.criteria.generic.GenericAllCriteria;

public class WorkflowCriteria extends GenericAllCriteria implements Serializable {

	private static final long serialVersionUID = 1L;

	private Integer attivo;
	private Long destinazione;
	private Long sorgente;


	public WorkflowCriteria() {
		String date1 [] = {ConstantsColumn.data_creazione};
		String date2 [] = {ConstantsColumn.id};
		String date3 [] = null;
		String date4 [] = null;
		String date5 [] = null;
		addAll(date1, date2, date3, date4, date5);
	}

	public Integer getAttivo() {
		return attivo;
	}
	public Long getDestinazione() {
		return destinazione;
	}


	public Long getSorgente() {
		return sorgente;
	}

	public WorkflowCriteria resetCriteria() {
		WorkflowCriteria c = new WorkflowCriteria();
		c.setSerialize(this.getSerialize());
		return c;
	}
	public WorkflowCriteria resetCriteria(String b) {
		WorkflowCriteria c = resetCriteria();
		c.setCriteria(b);
		return c;
	}

	public void setAttivo(Integer attivo) {
		this.attivo = attivo;
	}

	public void setCriteria(String b) {
		replace(ConstantsColumn.data_creazione, b);
	}

	public void setDestinazione(Long destinazione) {
		this.destinazione = destinazione;
	}

	public void setSorgente(Long sorgente) {
		this.sorgente = sorgente;
	}



}
