package it.callite.criteria.base;

import java.io.Serializable;
import java.util.List;

import org.hibernate.criterion.DetachedCriteria;

import it.callite.criteria.generic.UnitedCriteria;
import it.callite.utility.ApplicationUtil;
import it.callite.utility.LoggerRicerca;
import it.callite.utility.RicercaUtils;

public class ExtendedCriteria implements Serializable {
	
	private static final long serialVersionUID = 1L;
	
	private DetachedCriteria criteria;
	private Boolean ricerca = true;
	private LoggerRicerca loggerRicerca;
	private UnitedCriteria filtro;
	
	public void log(List<?> ls, Object size, Object sum) {
		loggerRicerca.log(criteria, ls, size, sum, filtro);
	}

	public UnitedCriteria getFiltro() {
		return filtro;
	}

	public DetachedCriteria getCriteria() {
		return criteria;
	}

	public Boolean getRicerca() {
		return ricerca;
	}

	public ExtendedCriteria(RicercaUtils ru, DetachedCriteria criteria, UnitedCriteria r) {
		setTimeout(criteria, ru.getTimeout());
		this.criteria = criteria;
		this.filtro = r;
		loggerRicerca = new LoggerRicerca(ru.isStampa());
		if(r != null) {
			this.ricerca = r.getCerca();
		}
	}
	
	public void setTimeout(DetachedCriteria criteria, Integer timeout) {
		if(ApplicationUtil.gtZero(timeout)) {
			criteria.setTimeout(timeout);
		}
	}
}
