package it.callite.criteria.report;

import java.io.Serializable;

import it.callite.constants.ConstantsGlobal;
import it.callite.criteria.generic.BaseCriteria;

public class ClassificaCriteria extends BaseCriteria implements Serializable {
	
	private static final long serialVersionUID = 1L;
	
	
	private Integer limiteAgente =  ConstantsGlobal.defLimiteAgente;
	private Integer limiteCampagna =  ConstantsGlobal.defLimiteCampagna;
	private Integer limiteOperatore = ConstantsGlobal.defLimiteOperatore;
	private Integer limiteQualifica =  ConstantsGlobal.defLimiteQualifica;
	private Integer limiteTeam = ConstantsGlobal.defLimiteTeam;
	private Integer limiteUfficio = ConstantsGlobal.defLimiteUfficio;
	private Integer limiteZona = ConstantsGlobal.defLimiteZona;
	private Integer tipoClassifica = 1;
	private Integer tipologia = 1;
	private Long campagnaId;
	private Long qualificaId;
	private Long teamId;
	private Long ufficioId;
	private Long zonaId;
	
	public ClassificaCriteria() {

	}

	public Long getCampagnaId() {
		return campagnaId;
	}



	public Integer getLimiteAgente() {
		return limiteAgente;
	}



	public Integer getLimiteCampagna() {
		return limiteCampagna;
	}



	public Integer getLimiteOperatore() {
		return limiteOperatore;
	}



	public Integer getLimiteQualifica() {
		return limiteQualifica;
	}



	public Integer getLimiteTeam() {
		return limiteTeam;
	}



	public Integer getLimiteUfficio() {
		return limiteUfficio;
	}



	public Integer getLimiteZona() {
		return limiteZona;
	}



	public Long getQualificaId() {
		return qualificaId;
	}



	public Long getTeamId() {
		return teamId;
	}



	public Integer getTipoClassifica() {
		return tipoClassifica;
	}



	public Integer getTipologia() {
		return tipologia;
	}



	public Long getUfficioId() {
		return ufficioId;
	}



	public Long getZonaId() {
		return zonaId;
	}



	public ClassificaCriteria resetCriteria() {
		ClassificaCriteria c = new ClassificaCriteria();
		c.setSerialize(this.getSerialize());
		return c;
	}

	public ClassificaCriteria resetCriteria(String b) {
		ClassificaCriteria c = resetCriteria();
		c.setCriteria(b);
		return c;
	}

	public void setCampagnaId(Long campagnaId) {
		this.campagnaId = campagnaId;
	}



	public void setCriteria(String b) {
	}



	public void setLimiteAgente(Integer limiteAgente) {
		this.limiteAgente = limiteAgente;
	}



	public void setLimiteCampagna(Integer limiteCampagna) {
		this.limiteCampagna = limiteCampagna;
	}
	
	public void setLimiteOperatore(Integer limiteOperatore) {
		this.limiteOperatore = limiteOperatore;
	}



	public void setLimiteQualifica(Integer limiteQualifica) {
		this.limiteQualifica = limiteQualifica;
	}



	public void setLimiteTeam(Integer limiteTeam) {
		this.limiteTeam = limiteTeam;
	}
	public void setLimiteUfficio(Integer limiteUfficio) {
		this.limiteUfficio = limiteUfficio;
	}
	public void setLimiteZona(Integer limiteZona) {
		this.limiteZona = limiteZona;
	}
	public void setQualificaId(Long qualificaId) {
		this.qualificaId = qualificaId;
	}
	public void setTeamId(Long teamId) {
		this.teamId = teamId;
	}
	public void setTipoClassifica(Integer tipoClassifica) {
		this.tipoClassifica = tipoClassifica;
	}
	public void setTipologia(Integer tipologia) {
		this.tipologia = tipologia;
	}
	public void setUfficioId(Long ufficioId) {
		this.ufficioId = ufficioId;
	}
	


	public void setZonaId(Long zonaId) {
		this.zonaId = zonaId;
	}
	
}
