package it.callite.dao;
import java.util.ArrayList;
import java.util.Date;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Set;
import java.util.TreeMap;

import javax.faces.model.SelectItem;

import org.hibernate.criterion.DetachedCriteria;
import org.hibernate.criterion.ProjectionList;
import org.hibernate.criterion.Projections;
import org.hibernate.criterion.Restrictions;
import org.hibernate.type.LongType;
import org.hibernate.type.Type;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Repository;

import it.callite.autodialer.controllo.CodaManager;
import it.callite.autodialer.controllo.CodaStatic;
import it.callite.chiamate.Chiamate;
import it.callite.constants.ConstantsEsito;
import it.callite.constants.ConstantsGlobal;
import it.callite.constants.ConstantsLanguage;
import it.callite.criteria.report.DashboardCriteria;
import it.callite.dao.generic.GenericDao;
import it.callite.model.Campagna;
import it.callite.model.Contatto;
import it.callite.model.Utente;
import it.callite.model.report.AutodialerContatti;
import it.callite.model.report.AutodialerStatistiche;
import it.callite.model.report.DashboardPannelloReport;
import it.callite.model.report.DashboardPannelloReportList;
import it.callite.model.report.DashboardReport;
import it.callite.model.report.ElencoCampagnaReport;
import it.callite.model.report.ElencoEsitoReportList;
import it.callite.model.report.MonitorOperatore;
import it.callite.model.report.OperatoriStatistiche;
import it.callite.model.report.ReportLavorazioneDashboard;
import it.callite.model.report.RiepilogoDashboard;
import it.callite.utility.ApplicationUtil;
import it.callite.utility.AutodialerList;
import it.callite.utility.AutodialerMap;
import it.callite.utility.MonitorChiamate;
import it.callite.utility.StatoLista;
import it.callite.utility.StatoOperatore;
import it.callite.utility.item.CampagnaSI;
@SuppressWarnings("serial")
@Repository("dashboardDao")
public class DashboardDao extends GenericDao {
	@Autowired
	private ImpostazioneDao impostazioneDao;
	private RiepilogoDashboard getRichiami(DashboardPannelloReport d, boolean esegui, boolean pubbliche, List<Long> campagne) {
		if(esegui) {
			Date data = ApplicationUtil.date();
			Boolean ts = impostazioneDao.getEstrazioneStato();
			DetachedCriteria criteria = DetachedCriteria.forClass(Contatto.class);
			criteria.add(Restrictions.eq("tipo", ConstantsGlobal.inviato));
			DetachedCriteria campagnaC = criteria.createCriteria("campagna");
			campagnaC.add(Restrictions.in("id",campagne));
			ApplicationUtil.criteriaStato(campagnaC, pubbliche, ApplicationUtil.isTrue(ts));
			Boolean s = impostazioneDao.getEstrazioneListe();
			if(ApplicationUtil.isTrue(s)) {
				DetachedCriteria listaC = criteria.createCriteria("lista");
				ApplicationUtil.criteriaStato(listaC, pubbliche, ApplicationUtil.isTrue(ts));
			}
			if(ApplicationUtil.isNotBlank(d.getTipo())) {
				criteria.createCriteria("anagrafica").add(ApplicationUtil.isNotNull(d.getTipo()));
			}
			if(pubbliche) {
				criteria.add(Restrictions.isNull("proprietario.id"));
				if(!d.getArchiviazione()) {
					criteria.add(Restrictions.eq("archiviato", Boolean.FALSE));
				}
			} else {
				criteria.add(Restrictions.isNotNull("proprietario.id"));
			}
			if(d.getDisponibili() && !d.getProssimi()) {
				criteria.add(Restrictions.le("data_presentazione", data));
			}
			if(d.getProssimi() && !d.getDisponibili()) {
				criteria.add(Restrictions.gt("data_presentazione", data));
			}
			ProjectionList p = Projections.projectionList();
			if(pubbliche) {
				if(d.getArchiviazione()) {
					p.add(Projections.sqlProjection("sum(if(archiviato is true, 1, 0)) as archiviati", new String [] {"archiviati"}, new Type []{LongType.INSTANCE}));
				}
				if(d.getDisponibili()) {
					p.add(Projections.sqlProjection("sum(if(archiviato is false and data_presentazione <= now() and esitoChiamata_id = "+ConstantsEsito.ID_DA_CHIAMARE+", 1, 0)) as richiami1", new String [] {"richiami1"}, new Type []{LongType.INSTANCE}));
					p.add(Projections.sqlProjection("sum(if(archiviato is false and data_presentazione <= now() and esitoChiamata_id <> "+ConstantsEsito.ID_DA_CHIAMARE+", 1, 0)) as richiami2", new String [] {"richiami2"}, new Type []{LongType.INSTANCE}));
				}
				if(d.getProssimi()) {
					p.add(Projections.sqlProjection("sum(if(archiviato is false and data_presentazione > now() and esitoChiamata_id = "+ConstantsEsito.ID_DA_CHIAMARE+", 1, 0)) as richiami3", new String [] {"richiami3"}, new Type []{LongType.INSTANCE}));
					p.add(Projections.sqlProjection("sum(if(archiviato is false and data_presentazione > now() and esitoChiamata_id <> "+ConstantsEsito.ID_DA_CHIAMARE+", 1, 0)) as richiami4", new String [] {"richiami4"}, new Type []{LongType.INSTANCE}));
				}
			} else { 
				if(d.getDisponibili()) {
					p.add(Projections.sqlProjection("sum(if(archiviato is false and data_presentazione <= now(), 1, 0)) as richiami1", new String [] {"richiami1"}, new Type []{LongType.INSTANCE}));
					p.add(Projections.sqlProjection("sum(if(archiviato is true and data_presentazione <= now(), 1, 0)) as richiami2", new String [] {"richiami2"}, new Type []{LongType.INSTANCE}));
				}
				if(d.getProssimi()) {
					p.add(Projections.sqlProjection("sum(if(archiviato is false and data_presentazione > now(), 1, 0)) as richiami3", new String [] {"richiami3"}, new Type []{LongType.INSTANCE}));
					p.add(Projections.sqlProjection("sum(if(archiviato is true and data_presentazione > now(), 1, 0)) as richiami4", new String [] {"richiami4"}, new Type []{LongType.INSTANCE}));
				}
			}
			criteria.setProjection(p);
			return (RiepilogoDashboard) getUniqueResult(criteria, RiepilogoDashboard.class);
		}
		return new RiepilogoDashboard();
	}
	public DashboardPannelloReport reportisticaCampagnaTutte(DashboardCriteria rc, List<Long> campagne) {
		DashboardPannelloReport d = new DashboardPannelloReport(rc.getContatti(), rc.getTipo());
		if(d.getOk()) {
			List<DashboardPannelloReportList> report = new ArrayList<DashboardPannelloReportList>();
			DashboardPannelloReportList a1 = new DashboardPannelloReportList(ConstantsLanguage.DISPONIBILI.stampa(), false);
			DashboardPannelloReportList a2 = new DashboardPannelloReportList(ConstantsLanguage.PROSSIMI.stampa(), false);
			DashboardPannelloReportList a3 = new DashboardPannelloReportList(ConstantsLanguage.TOTALE.stampa(), true);
			if(ApplicationUtil.notEmpty(campagne)) {
				RiepilogoDashboard pu = getRichiami(d, d.getPubbliche(), true, campagne);
				RiepilogoDashboard pr = getRichiami(d,  d.getPersonali(), false, campagne);
				a1.setContatti_totali(pu.getRichiami1()+pu.getRichiami2()+pr.getRichiami1()+pr.getRichiami2());
				a1.setContatti_pubbliche(pu.getRichiami1()+pu.getRichiami2());
				a1.setContatti_personali(pr.getRichiami1()+pr.getRichiami2());
				a1.setContatti_nuovi(pu.getRichiami1());
				a1.setContatti_richiami(pu.getRichiami2());
				a1.setContatti_private(pr.getRichiami1());
				a1.setContatti_archiviate(pr.getRichiami2());
				a2.setContatti_totali(pu.getRichiami3()+pu.getRichiami4()+pr.getRichiami3()+pr.getRichiami4());
				a2.setContatti_pubbliche(pu.getRichiami3()+pu.getRichiami4());
				a2.setContatti_personali(pr.getRichiami3()+pr.getRichiami4());
				a2.setContatti_nuovi(pu.getRichiami3());
				a2.setContatti_richiami(pu.getRichiami4());
				a2.setContatti_private(pr.getRichiami3());
				a2.setContatti_archiviate(pr.getRichiami4());
				a3.setContatti_totali(a1.getContatti_totali()+a2.getContatti_totali());
				a3.setContatti_pubbliche(a1.getContatti_pubbliche()+a2.getContatti_pubbliche());
				a3.setContatti_personali(a1.getContatti_personali()+a2.getContatti_personali());
				a3.setContatti_nuovi(a1.getContatti_nuovi()+a2.getContatti_nuovi());
				a3.setContatti_richiami(a1.getContatti_richiami()+a2.getContatti_richiami());
				a3.setContatti_private(a1.getContatti_private()+a2.getContatti_private());
				a3.setContatti_archiviate(a1.getContatti_archiviate()+a2.getContatti_archiviate());
				d.setArchiviati(pr.getArchiviati() + pu.getArchiviati());
				d.setTotali(a3.getContatti_pubbliche());
			}
			if(d.getDisponibili()) {
				report.add(a1);
			}
			if(d.getProssimi()) {
				report.add(a2);
			}
			if(d.getTutti()) {
				report.add(a3);
			}
			d.setLista(report);
		}
		return d;
	}
	public ElencoEsitoReportList elencoEsiti(List<Long> campagne) {
		ElencoEsitoReportList list = new ElencoEsitoReportList();
		list.setAutodialer(Chiamate.getCodaEsiti().get(false, campagne));
		list.setManuali(Chiamate.getCodaEsiti().get(true, campagne));
		list.elabora1();
		list.elabora2();
		return list;
	}
	public ElencoEsitoReportList elencoEsitiTutti(List<Long> campagne) {
		ElencoEsitoReportList list = new ElencoEsitoReportList();
		list.setAutodialer(Chiamate.getCodaEsiti().get(false, campagne));
		list.setManuali(Chiamate.getCodaEsiti().get(true, campagne));
		list.setTotali(Chiamate.getCodaEsiti().get(campagne));
		list.elabora1();
		list.elabora2();
		list.elabora3();
		return list;
	}
	public List<ElencoCampagnaReport> getElencoCampagneTotali(List<Long> campagne) {
		return Chiamate.getCodaCampagne().get(campagne);
	}
	public void resetAutodialer(List<Long> campagne) {
		Chiamate.getCodaEsiti().reset(false, campagne);
	}
	public void resetManuali(List<Long> campagne) {
		Chiamate.getCodaEsiti().reset(true, campagne);
	}
	public void resetTotali(List<Long> campagne) {
		Chiamate.getCodaEsiti().reset(campagne);
	}
	public void resetCampagne(List<Long> campagne) {
		Chiamate.getCodaCampagne().reset(campagne);
	}
	public void resetLavorazione(List<Long> campagne) {
		Set<Campagna> lngList = Chiamate.getCodaStatistiche().keySet();
		if(ApplicationUtil.notEmpty(lngList)) {
			Iterator<Campagna> lnt = lngList.iterator();
			while (lnt.hasNext()) {
				Campagna campagna = lnt.next();
				if(campagne != null && campagne.contains(campagna.getId())) {
					OperatoriStatistiche os = Chiamate.getCodaStatistiche().get(campagna);
					if(os!=null) {
						os.resetAll();
					}
				}
			}
		}
	}
	public List<StatoLista> getMonitorLista(List<Long> campagne) {
		StatoOperatore monop = new StatoOperatore();
		Map<Utente, MonitorOperatore> operatori = Chiamate.getCodaOperatori().getData();
		if(ApplicationUtil.notEmpty(operatori) && ApplicationUtil.notEmpty(campagne)) {
			Iterator<Utente> objRIter = operatori.keySet().iterator();
			while(objRIter.hasNext()) {
				Utente user = objRIter.next();
				MonitorOperatore mo = operatori.get(user);
				if(mo != null && mo.getCampagna() != null && campagne.contains(mo.getCampagna().getId())) {
					if(mo.getOperatore().isLocale() && mo.getOnline() && mo.getOperatore().getLoggato() && mo.getVisibile()) {
						monop.add(mo);
					}
				}
			}
		}
		return monop.getList();
	}
	public synchronized DashboardReport contaContatti(List<Long> campagne)  {
		DashboardReport ad = new DashboardReport();
		Integer chiamateAttive = 0;
		Integer chiamateAttiveMax = 0;
		Integer chiamateInAttesa = 0;
		Integer chiamateSchedulate = 0;
		Integer chiamateInCorso = 0;
		Integer chiamateInCorsoMax = 0;
		Integer chiamateAutodialer = 0;
		Integer chiamateManualiPrivate = 0;
		Integer chiamateManualiPubbliche = 0;
		Integer chiamateManualitutte = 0;
		Integer chiamateTeam = 0;
		if(ApplicationUtil.notEmpty(campagne)) {
			Iterator<Long> lnt = campagne.iterator();
			while (lnt.hasNext()) {
				Long campagna = lnt.next();
				chiamateManualiPrivate += Chiamate.getCodaContatti().get(campagna, 1).size();
				chiamateManualiPubbliche += Chiamate.getCodaContatti().get(campagna, 2).size();
				chiamateManualitutte += Chiamate.getCodaContatti().get(campagna, 0).size();
			}
		}
		Set<Campagna> lngList = Chiamate.getCodaProcessi().keySet();
		if(ApplicationUtil.notEmpty(lngList)) {
			Iterator<Campagna> lnt = lngList.iterator();
			while (lnt.hasNext()) {
				Campagna campagna = lnt.next();
				if(campagna != null) {
					if(campagne != null && campagne.contains(campagna.getId())) {
						CodaManager codaManager = Chiamate.getCodaProcessi().get(campagna);
						if(codaManager != null) {
							chiamateInAttesa += codaManager.getChiamateInAttesa().getSize();
							chiamateAttive += codaManager.getChiamateAttive().getSize();
							chiamateAttiveMax += codaManager.getChiamateAttive().getCapacity();
							chiamateSchedulate += codaManager.getChiamateSchedulate().getSize();
							chiamateInCorso += codaManager.getChiamateInCorso().getSize();
							chiamateInCorsoMax += codaManager.getChiamateInCorso().getCapacity();
							chiamateAutodialer += Chiamate.getCodaAutodialer().get(campagna).size();
							chiamateTeam += CodaStatic.getCodaTeam().get(campagna).size();
							if(ApplicationUtil.eq(campagne.size(), 1)) {
								codaManager.updateReport(ad, codaManager);
								ad.setCampagna(campagna);
								ad.setSospeso(codaManager.isSospeso());
								ad.setAvviato(codaManager.isAvviato());
								ad.setCaricato(codaManager.isCaricato());
								ad.setEsaurito(codaManager.isEsaurito());
								ad.setStarted(codaManager.isStarted());
								ad.setFinito(codaManager.isFinito());
								ad.setCriterio(codaManager.getCriterio());
								ad.setCorrezione(codaManager.getCorrezione());
							}
						}
					}
				}
			}
		}
		ad.setChiamateInAttesa(chiamateInAttesa);
		ad.setChiamateAttive(chiamateAttive);
		ad.setChiamateAttiveMax(chiamateAttiveMax);
		ad.setChiamateInCorso(chiamateInCorso);
		ad.setChiamateInCorsoMax(chiamateInCorsoMax);
		ad.setChiamateSchedulate(chiamateSchedulate);
		ad.setChiamateAutodialer(chiamateAutodialer);
		ad.setChiamateManualiPrivate(chiamateManualiPrivate);
		ad.setChiamateManualiPubbliche(chiamateManualiPubbliche);
		ad.setChiamateManualiTutte(chiamateManualitutte);
		ad.setCodaTeamCampagna(chiamateTeam);
		return ad;
	}
	public synchronized AutodialerStatistiche contaContattiStatistiche1(List<Long> campagne)  {
		AutodialerStatistiche as = new AutodialerStatistiche();
		Long timeAttesa = Long.valueOf(0);
		Long timeChiamata = Long.valueOf(0);
		Long timeGestione = Long.valueOf(0);
		Integer a_rimosse = 0;
		Integer a_saltate = 0;
		Integer a_fallite = 0;
		AutodialerMap statistiche = new AutodialerMap();
		Map<String, AutodialerMap> mappa = new TreeMap<String, AutodialerMap>();
		Set<Campagna> lngList = Chiamate.getCodaProcessi().keySet();
		if(ApplicationUtil.notEmpty(lngList)) {
			Iterator<Campagna> lnt = lngList.iterator();
			while (lnt.hasNext()) {
				Campagna campagna = lnt.next();
				if(campagne != null && campagne.contains(campagna.getId())) {
					CodaManager codaManager =  Chiamate.getCodaProcessi().get(campagna);
					if(codaManager != null) {
						AutodialerStatistiche ad = codaManager.getAutodialerStatistiche();
						timeAttesa += ad.getTimeAttesa();
						timeChiamata += ad.getTimeChiamata();
						timeGestione += ad.getTimeGestione();
						a_rimosse += ad.getA_rimosse();
						a_saltate += ad.getA_saltate();
						a_fallite += ad.getA_fallite();
						statistiche.update(ad.getStatistiche());
						mappa.putAll(ad.getMappa());
					}
				}
			}
		}
		as.setTimeAttesa(timeAttesa);
		as.setTimeChiamata(timeChiamata);
		as.setTimeGestione(timeGestione);
		as.setA_rimosse(a_rimosse);
		as.setA_saltate(a_saltate);
		as.setA_fallite(a_fallite);
		as.setStatistiche(statistiche);
		as.setMappa(mappa);
		return as;
	}
	public synchronized AutodialerContatti contaContattiStatistiche2(List<Long> campagne)  {
		AutodialerContatti as = new AutodialerContatti();
		AutodialerList list = new AutodialerList();
		Set<Campagna> lngList = Chiamate.getCodaProcessi().keySet();
		if(ApplicationUtil.notEmpty(lngList)) {
			Iterator<Campagna> lnt = lngList.iterator();
			while (lnt.hasNext()) {
				Campagna campagna = lnt.next();
				if(campagne != null && campagne.contains(campagna.getId())) {
					CodaManager codaManager =  Chiamate.getCodaProcessi().get(campagna);
					if(codaManager != null) {
						AutodialerContatti ad = codaManager.getAutodialerContatti();
						list.update(ad.getList());
					}
				}
			}
		}
		as.setList(list);
		return as;
	}
	public ReportLavorazioneDashboard reportLavorazioneDashboard(List<Long> campagne) {
		ReportLavorazioneDashboard as = new ReportLavorazioneDashboard();
		Integer appuntamenti = 0;
		Integer archiviazioni = 0;
		Integer contatti = 0;
		Integer contratti = 0;
		Integer conversazioni = 0;
		Set<Campagna> lngList = Chiamate.getCodaStatistiche().keySet();
		if(ApplicationUtil.notEmpty(lngList)) {
			Iterator<Campagna> lnt = lngList.iterator();
			while (lnt.hasNext()) {
				Campagna campagna = lnt.next();
				if(campagne != null && campagne.contains(campagna.getId())) {
					OperatoriStatistiche os = Chiamate.getCodaStatistiche().get(campagna);
					if(os!=null) {
						contatti += os.getContatti();
						conversazioni+= os.getConversazioni();
						archiviazioni+= os.getArchiviazioni();
						appuntamenti+= os.getAppuntamenti();
						contratti+= os.getContratti();
					}
				}
			}
		}
		as.setContatti(contatti);
		as.setContratti(contratti);
		as.setAppuntamenti(appuntamenti);
		as.setConversazioni(conversazioni);
		as.setArchiviazioni(archiviazioni);
		return as;
	}
	public List<CampagnaSI> getCampagne(Utente utente) {
		DetachedCriteria criteria = DetachedCriteria.forClass(Campagna.class);
		//criteria.add(Restrictions.ne("stato", ConstantsGlobal.stato_chiuso));
		if(utente != null) {
			criteria.createCriteria("team").createCriteria("supervisore").add(Restrictions.idEq(utente.getId()));
		}
		return getCampagnaSI(criteria);
	}
	public List<SelectItem> getCampagneSI(List<CampagnaSI> lis) {
		return impostazioneDao.getCampagna(lis, true, false, false, null);
	}
	public List<Long> getCampagne(List<CampagnaSI> campagneSI, Long cId) {
		List<Long> campagneId = new ArrayList<Long>();
		if (ApplicationUtil.gtZero(cId)) {
			campagneId.add(cId);
		} else {
			if(ApplicationUtil.notEmpty(campagneSI)) {
				Iterator<CampagnaSI> objIter = campagneSI.iterator();
				while(objIter.hasNext()) {
					CampagnaSI si = objIter.next();
					Long c = (Long) si.getId();
					if (ApplicationUtil.gtZero(c)) {
						campagneId.add(c);
					}
				}
			}
		}
		return campagneId;
	}
	

	public synchronized MonitorChiamate contaChiamateTutte(Campagna campagna, List<Long> campagne)  {
		MonitorChiamate m = new MonitorChiamate();
		m.setContatti(Chiamate.getCodaAutodialer().monitor(campagna, campagne));
		m.setOperatori(Chiamate.getCodaOperatori().monitor(campagna, campagne, false));
		m.setChiamate(Chiamate.getCodaContatti().monitor(campagna, campagne, 0));
		return m;
	}
}
