package it.callite.dao;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.InputStream;
import java.io.OutputStream;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import org.springframework.stereotype.Repository;

import it.callite.action.DownloadBean;
import it.callite.constants.ConstantsGlobal;
import it.callite.constants.ConstantsLanguage;
import it.callite.constants.ConstantsMap;
import it.callite.criteria.FileCriteria;
import it.callite.dao.generic.GenericDao;
import it.callite.log.ErrorLog;
import it.callite.utility.Allegato;
import it.callite.utility.ApplicationUtil;
import it.callite.utility.FileUpload;
import it.callite.utility.MyFile;
import it.callite.utility.PathUtility;
import it.callite.utility.ZipPassword;
import it.callite.utility.ZipUtils;
@SuppressWarnings("serial")
@Repository("designerDao")
public class DesignerDao extends GenericDao {

	public boolean isExist() {
		return ApplicationUtil.getDirectory(ConstantsGlobal.path_birt);
	}

	public String getRoot() {
		return ConstantsGlobal.path_birt + "/report";
	}
	public String editFile(PathUtility p, MyFile att) {
		if(att.isFolder()) {
			return att.getName();
		} else {
			return att.getBaseName();
		}
	}

	public void copyFile(PathUtility p, MyFile att, String perc, String rinomina) {
		String percorso = ApplicationUtil.normalizeNoEndSeparator(ApplicationUtil.trimToEmpty(perc));
		boolean abs = percorso.startsWith("/"); 
		String percorsoNuovo = ApplicationUtil.normalizeNoEndSeparator((abs ? p.getRoot() : p.getPath()) + "/" + percorso);
		File source = new File( p.getPath() + "/" + att.getName());
		String nex = (att.isFolder() ? "" : "." + att.getExtension());
		File nuovo = new File(percorsoNuovo + "/" + rinomina + nex);
		File dest = new File(percorsoNuovo);
		ApplicationUtil.creaFile(true, dest);
		if(!ApplicationUtil.equals(p.getPath() + "/" + att.getName(), percorsoNuovo + "/" + rinomina + nex)) {
			ApplicationUtil.copyFile(source, nuovo);
		}
	}

	public void moveFile(PathUtility p, MyFile att, String perc, String rinomina) {
		String percorso = ApplicationUtil.normalizeNoEndSeparator(ApplicationUtil.trimToEmpty(perc));
		boolean abs = percorso.startsWith("/"); 
		String percorsoNuovo = ApplicationUtil.normalizeNoEndSeparator((abs ? p.getRoot() : p.getPath()) + "/" + percorso);
		File source = new File(p.getPath() + "/" + att.getName());
		String nex = (att.isFolder() ? "" : "." + att.getExtension());
		if(!ApplicationUtil.equals(p.getPath() + "/" + att.getName(), percorsoNuovo + "/" + rinomina + nex)) {
			File nuovo = new File(percorsoNuovo + "/" + rinomina + nex);
			File dest = new File(percorsoNuovo);
			ApplicationUtil.creaFile(true, dest);
			source.renameTo(nuovo);
		}

	}

	public boolean renameFile(PathUtility p, MyFile att, String n) {
		boolean exist = false;
		if(ApplicationUtil.isNotBlank(n)) {
			String ps =  ConstantsGlobal.validatore_folder2;
			Pattern pp = Pattern.compile(ps);
			Matcher mm = pp.matcher(n);
			boolean b = mm.matches();	  		 
			if(!b){
				exist = true;
			}
			String ext = (att.isFolder() ? "" : "." + att.getExtension());

			File perc = new File(p.getPath() + "/" + att.getName());
			File nuovo = new File(p.getPath() + "/" + n + ext);
			if(!nuovo.exists() || ApplicationUtil.equals(att.getName(), n + ext)) {
				perc.renameTo(nuovo);
			} else {
				exist = true;
			}

		} else {
			exist = true;
		}
		if(exist) {
			return false;
		} 
		return true;
	}
	public boolean newFolder(PathUtility p, String perc) {
		if(ApplicationUtil.isNotBlank(perc)) {
			String m = ApplicationUtil.normalizeNoEndSeparator(ApplicationUtil.trimToEmpty(perc));
			boolean abs = m.startsWith("/"); 
			String ps =  ConstantsGlobal.validatore_path;
			Pattern pp = Pattern.compile(ps);
			Matcher mm = pp.matcher(m);
			boolean b = mm.matches();	  		 
			if(!b){
				return false;
			}
			String nn = ApplicationUtil.normalizeNoEndSeparator((abs ? p.getRoot() : p.getPath()) + "/" + m);
			File percD = new File(nn);
			if(!percD.exists()) {
				percD.mkdirs();
			}  else {
				return false;
			}
		} else {
			return false;
		}
		return true;
	}
	public void closeRoot(PathUtility p) {
		p.reset();
	}
	public String openRoot(PathUtility p) {
		return p.getPath();
	}

	public String openRoot(PathUtility p, MyFile m) {
		return p.getPath() + "/" + m.getName();
	}
	public void openFolder(PathUtility p, MyFile m) {
		String n = p.getPath( ) + "/" + m.getName();
		p.setPath(n);
	}
	public void closeFolder(PathUtility p) {
		String n = ApplicationUtil.substringBeforeLast(p.getPath(), "/");
		p.setPath(n);
	}
	public List<MyFile> listaFile(FileCriteria mm, PathUtility p) {
		if(mm != null)  mm = (FileCriteria) mm.loadCriteria();
		List<MyFile> ff = new ArrayList<MyFile>();
		if(mm != null && mm.getCerca()) {
			File perc = new File(p.getPath());
			ApplicationUtil.creaFile(true, perc);
			File [] files = perc.listFiles();
			if(ApplicationUtil.notEmpty(files)) {
				for(File file : files) {
					if(mm.isRicerca(file.getName(), file.length(), file.lastModified())) {
						MyFile f = new MyFile(file);
						f.setParent(ApplicationUtil.removeStart(p.getPath(), p.getRoot()));
						f.setName(file.getName());
						f.setModified(file.lastModified());
						ff.add(f);
					}
				}
			}
		}
		return ff;
	}
	public void eliminaFile(MyFile att, PathUtility p) {

		File perc = new File(p.getPath() + "/" + att.getName());
		ApplicationUtil.deleteAll(perc);
	}
	public void eliminaFile(List<MyFile> atts,  PathUtility p) {
		if(ApplicationUtil.notEmpty(atts)) {

			Iterator<MyFile> aIt = atts.iterator();
			while (aIt.hasNext()) {
				MyFile att = (MyFile) aIt.next();
				File perc = new File(p.getPath() + "/" + att.getName());
				ApplicationUtil.deleteAll(perc);
			}
		}
	}
	public void salvaFile(FileUpload fileUpload,  PathUtility p) {

		try {
			List<MyFile> fls = fileUpload.getFiles();
			if(ApplicationUtil.notEmpty(fls)) {
				Iterator<MyFile> flsIt = fls.iterator();
				while (flsIt.hasNext()) {
					MyFile ff = (MyFile) flsIt.next();
					FileOutputStream fi = new FileOutputStream( p.getPath() + "/" + ff.getName());
					fi.write(ff.getData());
					fi.flush();
					fi.close();
				}
			}
		} catch (Exception e) {
			ErrorLog.log(null, getClass(), e);
		}

	}
	public void salvaZip(FileUpload fileUpload,  PathUtility p) {
		List<MyFile> scompattati = new ArrayList<MyFile>();
		try {
			List<MyFile> fls = fileUpload.getFiles();
			if(ApplicationUtil.notEmpty(fls)) {
				Iterator<MyFile> flsIt = fls.iterator();
				while (flsIt.hasNext()) {
					MyFile dd = (MyFile) flsIt.next();
					scompattati.addAll(ApplicationUtil.unzip(dd));
				}
			}

			if(ApplicationUtil.notEmpty(scompattati)) {

				Iterator<MyFile> flsIt = scompattati.iterator();
				while (flsIt.hasNext()) {
					MyFile ff = (MyFile) flsIt.next();
					String base =  p.getPath();
					File n = new File(base + "/" + ApplicationUtil.getPathN(ff.getName()));
					ApplicationUtil.creaFile(true, n);
					File fileOut = new File(base + "/" + ff.getName());
					if(fileOut.isFile() && ApplicationUtil.getExtensionLower(ff.getName()).equalsIgnoreCase(ConstantsMap.rptdesign)) {
						FileOutputStream fi = new FileOutputStream(fileOut);
						fi.write(ff.getData());
						fi.flush();
						fi.close();
					}
				}
			}
		} catch (Exception e) {
			ErrorLog.log(null, getClass(), e);
		}
	}
	public void scaricaFile(List<MyFile> fils,  PathUtility p, DownloadBean downloadBean) {
		List<Allegato> files = new ArrayList<Allegato>();
		if (ApplicationUtil.notEmpty(fils)) {

			Iterator<MyFile> itS = fils.iterator();
			while (itS.hasNext()) {
				MyFile file = (MyFile) itS.next();
				String root = p.getRoot();
				if(file.isFolder()) {
					String base = p.getPath() + "/" + file.getName();
					ApplicationUtil.generateMyFileList(files, new File(base), root);
				} else {
					String base = p.getPath();
					ApplicationUtil.generateMyFileList(files, new File(base + "/" + file.getName()), root);
				}
			}
		}
		try {
			if (ApplicationUtil.notEmpty(files)) {
				String file_header = ApplicationUtil.reportFile(ApplicationUtil.date(), ConstantsLanguage.FILE.stampa()) + "." + ConstantsMap.zip;
				OutputStream out = downloadBean.outputStream();
				downloadBean.filename(file_header, files);
				String g = ConstantsGlobal.secretZ;
				ApplicationUtil.zip(null,files, out, g);
				downloadBean.close();
			}
		} catch (Exception e) {
			ErrorLog.log(null, getClass(), e);
		}
	}

	public void scaricaFile(MyFile att,  PathUtility p, DownloadBean downloadBean) {
		try {

			if(att.isFolder()) {
				OutputStream out = downloadBean.outputStream();
				downloadBean.filename(att.getName() + "." + ConstantsMap.zip);
				String g = ConstantsGlobal.secretZ;
				String ppath =  p.getPath() + "/" + att.getName();
				File ff = new File(ppath);
				if(g != null) {
					ZipPassword.zipIt(null, ff.getAbsolutePath(), out, g);
				} else {
					ZipUtils.zipIt(null, ff.getAbsolutePath(), out);
				}
				downloadBean.close();
			} else {
				OutputStream out = downloadBean.outputStream();
				downloadBean.filename(att.getName());
				String nome = p.getPath() +"/"+ att.getName();
				InputStream istream = new FileInputStream(nome);
				ApplicationUtil.copy(istream, out);
				istream.close();
				downloadBean.close();
			}
		} catch (Exception e) {
			ErrorLog.log(null, getClass(), e);
		}

	}
}