package it.callite.dao;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.Set;

import org.hibernate.criterion.DetachedCriteria;
import org.hibernate.criterion.Restrictions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Repository;

import it.callite.constants.ConstantsGlobal;
import it.callite.constants.ConstantsMap;
import it.callite.dao.generic.GenericDao;
import it.callite.model.Campagna;
import it.callite.model.Contatto;
import it.callite.utility.ApplicationUtil;
import it.callite.utility.Parameter;
import it.callite.utility.item.ContattoSI;
@SuppressWarnings("serial")
@Repository("duplicatoDao")
public class DuplicatoDao extends GenericDao{
	@Autowired
	private ImpostazioneDao impostazioneDao;
	public List<ContattoSI> getContattiDuplicati(String property, Campagna campagna) {
		String p = ApplicationUtil.trimToNull(property);
		if(p == null || ApplicationUtil.equals(property, ConstantsMap.identificativo)) {
			return getContattiDuplicatiF(campagna, "id");
		} else {
			return getContattiDuplicatiF(campagna, p);
		}
	}
	public List<ContattoSI> getContattiOpposizioni(String property, Campagna campagna) {
		String p = ApplicationUtil.trimToNull(property);
		if(p == null || ApplicationUtil.equals(property, ConstantsMap.identificativo)) {
			return getContattiOpposizioniF(campagna);
		} else {
			return getContattiOpposizioniF(campagna, p);
		}
	}
	public List<ContattoSI> getContattiVuoti(String property, Campagna campagna) {
		String p = ApplicationUtil.trimToNull(property);
		if(p == null || ApplicationUtil.equals(property, ConstantsMap.identificativo)) {
			return getContattiVuotiF(campagna);
		} else {
			return getContattiVuotiF(campagna, p);
		}
	}
	public List<ContattoSI> getContattiDuplicati(String property, List<Campagna> campagne) {
		String p = ApplicationUtil.trimToNull(property);
		if(p == null || ApplicationUtil.equals(property, ConstantsMap.identificativo)) {
			return getContattiDuplicatiF(campagne, "id");
		} else {
			return getContattiDuplicatiF(campagne, p);
		}
	}
	public List<ContattoSI> getContattiOpposizioni(String property, List<Campagna> campagne) {
		String p = ApplicationUtil.trimToNull(property);
		if(p == null || ApplicationUtil.equals(property, ConstantsMap.identificativo)) {
			return getContattiOpposizioniF(campagne);
		} else {
			return getContattiOpposizioniF(campagne, p);
		}
	}
	public List<ContattoSI> getContattiVuoti(String property, List<Campagna> campagne) {
		String p = ApplicationUtil.trimToNull(property);
		if(p == null || ApplicationUtil.equals(property, ConstantsMap.identificativo)) {
			return getContattiVuotiF(campagne);
		} else {
			return getContattiVuotiF(campagne, p);
		}
	}
	public List<ContattoSI> getContattiErratiTotale(Campagna campagna) {
		Set<ContattoSI> a = new HashSet<ContattoSI>();
		a.addAll(getContattiDuplicatiF(campagna, "id"));
		Integer d = impostazioneDao.getRicercaDuplicatiVuoti();
		if(ApplicationUtil.eq(d, 1)) {
			a.addAll(getContattiDuplicatiF(campagna, "telefono_fisso"));
			a.addAll(getContattiDuplicatiF(campagna, "telefono_mobile"));
			a.addAll(getContattiDuplicatiF(campagna, "telefono_fax"));
			a.addAll(getContattiDuplicatiF(campagna, "telefono_altro"));
			a.addAll(getContattiDuplicatiF(campagna, "email"));
			a.addAll(getContattiDuplicatiF(campagna, "link"));
			a.addAll(getContattiDuplicatiF(campagna, "codice_fiscale"));
			a.addAll(getContattiDuplicatiF(campagna, "partita_iva"));
		}
		if(ApplicationUtil.eq(d, 2)) {
			a.addAll(getContattiDuplicatiF(campagna, "telefono_fisso"));
			a.addAll(getContattiDuplicatiF(campagna, "telefono_mobile"));
			a.addAll(getContattiDuplicatiF(campagna, "telefono_fax"));
			a.addAll(getContattiDuplicatiF(campagna, "telefono_altro"));
			a.addAll(getContattiDuplicatiF(campagna, "email"));
		}
		if(ApplicationUtil.eq(d, 3)) {
			a.addAll(getContattiDuplicatiF(campagna, "telefono_fisso"));
			a.addAll(getContattiDuplicatiF(campagna, "telefono_mobile"));
			a.addAll(getContattiDuplicatiF(campagna, "telefono_fax"));
			a.addAll(getContattiDuplicatiF(campagna, "telefono_altro"));
		}
		a.addAll(getContattiOpposizioniF(campagna));
		a.addAll(getContattiVuotiF(campagna));
		return new ArrayList<ContattoSI>(a);
	}
	public List<ContattoSI> getContattiErratiTotale(List<Campagna> campagne) {
		Set<ContattoSI> a = new HashSet<ContattoSI>();
		a.addAll(getContattiDuplicatiF(campagne, "id"));
		Integer d = impostazioneDao.getRicercaDuplicatiVuoti();
		if(ApplicationUtil.eq(d, 1)) {
			a.addAll(getContattiDuplicatiF(campagne, "telefono_fisso"));
			a.addAll(getContattiDuplicatiF(campagne, "telefono_mobile"));
			a.addAll(getContattiDuplicatiF(campagne, "telefono_fax"));
			a.addAll(getContattiDuplicatiF(campagne, "telefono_altro"));
			a.addAll(getContattiDuplicatiF(campagne, "email"));
			a.addAll(getContattiDuplicatiF(campagne, "link"));
			a.addAll(getContattiDuplicatiF(campagne, "codice_fiscale"));
			a.addAll(getContattiDuplicatiF(campagne, "partita_iva"));
		}
		if(ApplicationUtil.eq(d, 2)) {
			a.addAll(getContattiDuplicatiF(campagne, "telefono_fisso"));
			a.addAll(getContattiDuplicatiF(campagne, "telefono_mobile"));
			a.addAll(getContattiDuplicatiF(campagne, "telefono_fax"));
			a.addAll(getContattiDuplicatiF(campagne, "telefono_altro"));
			a.addAll(getContattiDuplicatiF(campagne, "email"));
		}
		if(ApplicationUtil.eq(d, 3)) {
			a.addAll(getContattiDuplicatiF(campagne, "telefono_fisso"));
			a.addAll(getContattiDuplicatiF(campagne, "telefono_mobile"));
			a.addAll(getContattiDuplicatiF(campagne, "telefono_fax"));
			a.addAll(getContattiDuplicatiF(campagne, "telefono_altro"));
		}
		a.addAll(getContattiOpposizioniF(campagne));
		a.addAll(getContattiVuotiF(campagne));
		return new ArrayList<ContattoSI>(a);
	}
	@SuppressWarnings({ "unchecked", "unused" })
	private List<ContattoSI> getContattiDuplicatiF(Campagna campagna, String property) {
		List<ContattoSI> contatti =  new ArrayList<ContattoSI>();
		if(campagna != null && ApplicationUtil.gtZero(campagna.getId())) {
			String hql = ConstantsGlobal.select + " distinct " + "anagrafica."+property+" from Contatto where campagna.id = :campagna and anagrafica."+property+" is not null group by anagrafica."+property+" having count(anagrafica."+property+") > 1";
			List<String> duplicatiEx = list(false, hql, new Parameter("campagna", campagna.getId()));
			if(ApplicationUtil.notEmpty(duplicatiEx)) {
				duplicatiEx.removeAll(ApplicationUtil.asList("", null));
			}
			if(ApplicationUtil.notEmpty(duplicatiEx)) {
				DetachedCriteria criteria = DetachedCriteria.forClass(Contatto.class, "c");
				DetachedCriteria criteriaA = criteria.createCriteria("anagrafica", "an");
				DetachedCriteria criteriaL = criteria.createCriteria("lista", "li");
				DetachedCriteria criteriaC = criteria.createCriteria("campagna", "ca");
				Integer dsc = impostazioneDao.getDuplicatiStatoCampagna();
				Integer dac = impostazioneDao.getDuplicatiAttivoCampagna();
				Integer dsl = impostazioneDao.getDuplicatiStatoLista();
				Integer dal = impostazioneDao.getDuplicatiAttivoLista();
				ApplicationUtil.statoLC(dsc, dac, criteriaC);
				ApplicationUtil.statoLC(dsl, dal, criteriaL);
				DetachedCriteria criteriaEc = criteria.createCriteria("esitoChiamata", "ec");
				DetachedCriteria criteriaEa = criteria.createCriteria("esitoArchiviazione", "ea", ApplicationUtil.leftJoin());
				criteriaC.add(Restrictions.eq("id", campagna.getId()));
				criteriaA.add(Restrictions.in(property, duplicatiEx));
				contatti.addAll(getContattoSI(criteria, criteriaA, property));
			}
		}
		return contatti;
	}
	@SuppressWarnings({ "unchecked", "unused" })
	private List<ContattoSI> getContattiDuplicatiF(List<Campagna> campagne, String property) {
		List<ContattoSI> contatti =  new ArrayList<ContattoSI>();
		List<Long> campagneId = ApplicationUtil.prendiIdCampagna(campagne);
		if(ApplicationUtil.notEmpty(campagneId)) {
			String join = ApplicationUtil.detoken(campagneId, ConstantsGlobal.commaSeparator);
			String hqlCamp = "and campagna.id in ("+join+")";
			String hql = ConstantsGlobal.select + " distinct " + "anagrafica."+property+" from Contatto where anagrafica."+property+" is not null " + hqlCamp + " group by anagrafica."+property+" having count(anagrafica."+property+") > 1";
			List<String> duplicatiEx = list(false, hql);
			if(ApplicationUtil.notEmpty(duplicatiEx)) {
				duplicatiEx.removeAll(ApplicationUtil.asList("", null));
			}
			if(ApplicationUtil.notEmpty(duplicatiEx) && ApplicationUtil.notEmpty(campagneId)) {
				DetachedCriteria criteria = DetachedCriteria.forClass(Contatto.class, "c");
				DetachedCriteria criteriaA = criteria.createCriteria("anagrafica", "an");
				DetachedCriteria criteriaL = criteria.createCriteria("lista", "li");
				DetachedCriteria criteriaC = criteria.createCriteria("campagna", "ca");
				Integer dsc = impostazioneDao.getDuplicatiStatoCampagna();
				Integer dac = impostazioneDao.getDuplicatiAttivoCampagna();
				Integer dsl = impostazioneDao.getDuplicatiStatoLista();
				Integer dal = impostazioneDao.getDuplicatiAttivoLista();
				ApplicationUtil.statoLC(dsc, dac, criteriaC);
				ApplicationUtil.statoLC(dsl, dal, criteriaL);
				DetachedCriteria criteriaEc = criteria.createCriteria("esitoChiamata", "ec");
				DetachedCriteria criteriaEa = criteria.createCriteria("esitoArchiviazione", "ea", ApplicationUtil.leftJoin());
				criteriaC.add(Restrictions.in("id", campagneId));
				criteriaA.add(Restrictions.in(property, duplicatiEx));
				contatti.addAll(getContattoSI(criteria, criteriaA, property));
			}
		}
		return contatti;
	}
	@SuppressWarnings("unused")
	private List<ContattoSI> getContattiOpposizioniF(Campagna campagna) {
		List<ContattoSI> contatti =  new ArrayList<ContattoSI>();
		if(campagna != null && ApplicationUtil.gtZero(campagna.getId())) {
			List<String> duplicatiEx = new ArrayList<String>();
			duplicatiEx.addAll(impostazioneDao.trovaOpposizioni(campagna.getId()));
			duplicatiEx.addAll(impostazioneDao.trovaOpposizioni(null));
			if(ApplicationUtil.notEmpty(duplicatiEx)) {
				duplicatiEx.removeAll(ApplicationUtil.asList("", null));
			}
			if(ApplicationUtil.notEmpty(duplicatiEx)) {
				DetachedCriteria criteria = DetachedCriteria.forClass(Contatto.class, "c");
				DetachedCriteria criteriaA = criteria.createCriteria("anagrafica", "an");
				DetachedCriteria criteriaL = criteria.createCriteria("lista", "li");
				DetachedCriteria criteriaC = criteria.createCriteria("campagna", "ca");
				Integer dsc = impostazioneDao.getDuplicatiStatoCampagna();
				Integer dac = impostazioneDao.getDuplicatiAttivoCampagna();
				Integer dsl = impostazioneDao.getDuplicatiStatoLista();
				Integer dal = impostazioneDao.getDuplicatiAttivoLista();
				ApplicationUtil.statoLC(dsc, dac, criteriaC);
				ApplicationUtil.statoLC(dsl, dal, criteriaL);
				DetachedCriteria criteriaEc = criteria.createCriteria("esitoChiamata", "ec");
				DetachedCriteria criteriaEa = criteria.createCriteria("esitoArchiviazione", "ea", ApplicationUtil.leftJoin());
				criteriaC.add(Restrictions.eq("id", campagna.getId()));
				Integer d = impostazioneDao.getRicercaDuplicatiVuoti();
				if(ApplicationUtil.eq(d, 1)) {
					criteriaA.add(Restrictions.or(Restrictions.in("telefono_fisso", duplicatiEx), Restrictions.in("telefono_mobile", duplicatiEx), Restrictions.in("telefono_fax", duplicatiEx), Restrictions.in("telefono_altro", duplicatiEx), Restrictions.in("email", duplicatiEx), Restrictions.in("link", duplicatiEx), Restrictions.in("codice_fiscale", duplicatiEx), Restrictions.in("partita_iva", duplicatiEx)));
				}
				if(ApplicationUtil.eq(d, 2)) {
					criteriaA.add(Restrictions.or(Restrictions.in("telefono_fisso", duplicatiEx), Restrictions.in("telefono_mobile", duplicatiEx), Restrictions.in("telefono_fax", duplicatiEx), Restrictions.in("telefono_altro", duplicatiEx), Restrictions.in("email", duplicatiEx)));
				}
				if(ApplicationUtil.eq(d, 3)) {
					criteriaA.add(Restrictions.or(Restrictions.in("telefono_fisso", duplicatiEx), Restrictions.in("telefono_mobile", duplicatiEx), Restrictions.in("telefono_fax", duplicatiEx), Restrictions.in("telefono_altro", duplicatiEx)));
				}
				contatti.addAll(getContattoSI(criteria, criteriaA, "id"));
			} 
		}
		return contatti;
	}
	@SuppressWarnings("unused")
	private List<ContattoSI> getContattiOpposizioniF(Campagna campagna, String property) {
		List<ContattoSI> contatti =  new ArrayList<ContattoSI>();
		if(campagna != null && ApplicationUtil.gtZero(campagna.getId())) {
			List<String> duplicatiEx = new ArrayList<String>();
			duplicatiEx.addAll(impostazioneDao.trovaOpposizioni(campagna.getId()));
			duplicatiEx.addAll(impostazioneDao.trovaOpposizioni(null));
			if(ApplicationUtil.notEmpty(duplicatiEx)) {
				duplicatiEx.removeAll(ApplicationUtil.asList("", null));
			}
			if(ApplicationUtil.notEmpty(duplicatiEx)) {
				DetachedCriteria criteria = DetachedCriteria.forClass(Contatto.class, "c");
				DetachedCriteria criteriaA = criteria.createCriteria("anagrafica", "an");
				DetachedCriteria criteriaL = criteria.createCriteria("lista", "li");
				DetachedCriteria criteriaC = criteria.createCriteria("campagna", "ca");
				Integer dsc = impostazioneDao.getDuplicatiStatoCampagna();
				Integer dac = impostazioneDao.getDuplicatiAttivoCampagna();
				Integer dsl = impostazioneDao.getDuplicatiStatoLista();
				Integer dal = impostazioneDao.getDuplicatiAttivoLista();
				ApplicationUtil.statoLC(dsc, dac, criteriaC);
				ApplicationUtil.statoLC(dsl, dal, criteriaL);
				DetachedCriteria criteriaEc = criteria.createCriteria("esitoChiamata", "ec");
				DetachedCriteria criteriaEa = criteria.createCriteria("esitoArchiviazione", "ea", ApplicationUtil.leftJoin());
				criteriaC.add(Restrictions.eq("id", campagna.getId()));
				criteriaA.add(Restrictions.in(property, duplicatiEx));
				contatti.addAll(getContattoSI(criteria, criteriaA, property));
			}
		}
		return contatti;
	}
	@SuppressWarnings("unused")
	private List<ContattoSI> getContattiOpposizioniF(List<Campagna> campagne) {
		List<ContattoSI> contatti =  new ArrayList<ContattoSI>();
		List<Long> campagneId = ApplicationUtil.prendiIdCampagna(campagne);
		if(ApplicationUtil.notEmpty(campagneId)) {
			List<String> duplicatiEx = impostazioneDao.trovaOpposizioni(null);
			if(ApplicationUtil.notEmpty(duplicatiEx)) {
				duplicatiEx.removeAll(ApplicationUtil.asList("", null));
			}
			if(ApplicationUtil.notEmpty(duplicatiEx)) {
				DetachedCriteria criteria = DetachedCriteria.forClass(Contatto.class, "c");
				DetachedCriteria criteriaA = criteria.createCriteria("anagrafica", "an");
				DetachedCriteria criteriaL = criteria.createCriteria("lista", "li");
				DetachedCriteria criteriaC = criteria.createCriteria("campagna", "ca");
				Integer dsc = impostazioneDao.getDuplicatiStatoCampagna();
				Integer dac = impostazioneDao.getDuplicatiAttivoCampagna();
				Integer dsl = impostazioneDao.getDuplicatiStatoLista();
				Integer dal = impostazioneDao.getDuplicatiAttivoLista();
				ApplicationUtil.statoLC(dsc, dac, criteriaC);
				ApplicationUtil.statoLC(dsl, dal, criteriaL);
				DetachedCriteria criteriaEc = criteria.createCriteria("esitoChiamata", "ec");
				DetachedCriteria criteriaEa = criteria.createCriteria("esitoArchiviazione", "ea", ApplicationUtil.leftJoin());
				criteriaC.add(Restrictions.in("id", campagneId));
				Integer d = impostazioneDao.getRicercaDuplicatiVuoti();
				if(ApplicationUtil.eq(d, 1)) {
					criteriaA.add(Restrictions.or(Restrictions.in("telefono_fisso", duplicatiEx), Restrictions.in("telefono_mobile", duplicatiEx), Restrictions.in("telefono_fax", duplicatiEx), Restrictions.in("telefono_altro", duplicatiEx), Restrictions.in("email", duplicatiEx), Restrictions.in("link", duplicatiEx), Restrictions.in("codice_fiscale", duplicatiEx), Restrictions.in("partita_iva", duplicatiEx)));
				}
				if(ApplicationUtil.eq(d, 2)) {
					criteriaA.add(Restrictions.or(Restrictions.in("telefono_fisso", duplicatiEx), Restrictions.in("telefono_mobile", duplicatiEx), Restrictions.in("telefono_fax", duplicatiEx), Restrictions.in("telefono_altro", duplicatiEx), Restrictions.in("email", duplicatiEx)));
				}
				if(ApplicationUtil.eq(d, 3)) {
					criteriaA.add(Restrictions.or(Restrictions.in("telefono_fisso", duplicatiEx), Restrictions.in("telefono_mobile", duplicatiEx), Restrictions.in("telefono_fax", duplicatiEx), Restrictions.in("telefono_altro", duplicatiEx)));
				}
				contatti.addAll(getContattoSI(criteria, criteriaA, "id"));
			}
			Iterator<Long> objIter = campagneId.iterator();
			while(objIter.hasNext()) {
				Long campagnaId = objIter.next();
				List<String> duplicatiExC = impostazioneDao.trovaOpposizioni(campagnaId);
				if(ApplicationUtil.notEmpty(duplicatiExC)) {
					duplicatiExC.removeAll(ApplicationUtil.asList("", null));
				}
				if(ApplicationUtil.notEmpty(duplicatiExC)) {
					DetachedCriteria criteria = DetachedCriteria.forClass(Contatto.class, "c");
					DetachedCriteria criteriaA = criteria.createCriteria("anagrafica", "an");
					DetachedCriteria criteriaL = criteria.createCriteria("lista", "li");
					DetachedCriteria criteriaC = criteria.createCriteria("campagna", "ca");
					Integer dsc = impostazioneDao.getDuplicatiStatoCampagna();
					Integer dac = impostazioneDao.getDuplicatiAttivoCampagna();
					Integer dsl = impostazioneDao.getDuplicatiStatoLista();
					Integer dal = impostazioneDao.getDuplicatiAttivoLista();
					ApplicationUtil.statoLC(dsc, dac, criteriaC);
					ApplicationUtil.statoLC(dsl, dal, criteriaL);
					DetachedCriteria criteriaEc = criteria.createCriteria("esitoChiamata", "ec");
					DetachedCriteria criteriaEa = criteria.createCriteria("esitoArchiviazione", "ea", ApplicationUtil.leftJoin());
					criteriaC.add(Restrictions.eq("id", campagnaId));
					Integer d = impostazioneDao.getRicercaDuplicatiVuoti();
					if(ApplicationUtil.eq(d, 1)) {
						criteriaA.add(Restrictions.or(Restrictions.in("telefono_fisso", duplicatiEx), Restrictions.in("telefono_mobile", duplicatiEx), Restrictions.in("telefono_fax", duplicatiEx), Restrictions.in("telefono_altro", duplicatiEx), Restrictions.in("email", duplicatiEx), Restrictions.in("link", duplicatiEx), Restrictions.in("codice_fiscale", duplicatiEx), Restrictions.in("partita_iva", duplicatiEx)));
					}
					if(ApplicationUtil.eq(d, 2)) {
						criteriaA.add(Restrictions.or(Restrictions.in("telefono_fisso", duplicatiEx), Restrictions.in("telefono_mobile", duplicatiEx), Restrictions.in("telefono_fax", duplicatiEx), Restrictions.in("telefono_altro", duplicatiEx), Restrictions.in("email", duplicatiEx)));
					}
					if(ApplicationUtil.eq(d, 3)) {
						criteriaA.add(Restrictions.or(Restrictions.in("telefono_fisso", duplicatiEx), Restrictions.in("telefono_mobile", duplicatiEx), Restrictions.in("telefono_fax", duplicatiEx), Restrictions.in("telefono_altro", duplicatiEx)));
					}
					contatti.addAll(getContattoSI(criteria, criteriaA, "id"));
				}
			}
		}
		return contatti;
	}
	@SuppressWarnings("unused")
	private List<ContattoSI> getContattiOpposizioniF(List<Campagna> campagne, String property) {
		List<ContattoSI> contatti =  new ArrayList<ContattoSI>();
		List<Long> campagneId = ApplicationUtil.prendiIdCampagna(campagne);
		if(ApplicationUtil.notEmpty(campagneId)) {
			List<String> duplicatiEx = impostazioneDao.trovaOpposizioni(null);
			if(ApplicationUtil.notEmpty(duplicatiEx)) {
				duplicatiEx.removeAll(ApplicationUtil.asList("", null));
			}
			if(ApplicationUtil.notEmpty(duplicatiEx)) {
				DetachedCriteria criteria = DetachedCriteria.forClass(Contatto.class, "c");
				DetachedCriteria criteriaA = criteria.createCriteria("anagrafica", "an");
				DetachedCriteria criteriaL = criteria.createCriteria("lista", "li");
				DetachedCriteria criteriaC = criteria.createCriteria("campagna", "ca");
				Integer dsc = impostazioneDao.getDuplicatiStatoCampagna();
				Integer dac = impostazioneDao.getDuplicatiAttivoCampagna();
				Integer dsl = impostazioneDao.getDuplicatiStatoLista();
				Integer dal = impostazioneDao.getDuplicatiAttivoLista();
				ApplicationUtil.statoLC(dsc, dac, criteriaC);
				ApplicationUtil.statoLC(dsl, dal, criteriaL);
				DetachedCriteria criteriaEc = criteria.createCriteria("esitoChiamata", "ec");
				DetachedCriteria criteriaEa = criteria.createCriteria("esitoArchiviazione", "ea", ApplicationUtil.leftJoin());
				criteriaC.add(Restrictions.in("id", campagneId));
				criteriaA.add(Restrictions.in(property, duplicatiEx));
				contatti.addAll(getContattoSI(criteria, criteriaA, property));
			}
			Iterator<Long> objIter = campagneId.iterator();
			while(objIter.hasNext()) {
				Long campagnaId = objIter.next();
				List<String> duplicatiExC = impostazioneDao.trovaOpposizioni(campagnaId);
				if(ApplicationUtil.notEmpty(duplicatiExC)) {
					duplicatiExC.removeAll(ApplicationUtil.asList("", null));
				}
				if(ApplicationUtil.notEmpty(duplicatiExC)) {
					DetachedCriteria criteria = DetachedCriteria.forClass(Contatto.class, "c");
					DetachedCriteria criteriaA = criteria.createCriteria("anagrafica", "an");
					DetachedCriteria criteriaL = criteria.createCriteria("lista", "li");
					DetachedCriteria criteriaC = criteria.createCriteria("campagna", "ca");
					Integer dsc = impostazioneDao.getDuplicatiStatoCampagna();
					Integer dac = impostazioneDao.getDuplicatiAttivoCampagna();
					Integer dsl = impostazioneDao.getDuplicatiStatoLista();
					Integer dal = impostazioneDao.getDuplicatiAttivoLista();
					ApplicationUtil.statoLC(dsc, dac, criteriaC);
					ApplicationUtil.statoLC(dsl, dal, criteriaL);
					DetachedCriteria criteriaEc = criteria.createCriteria("esitoChiamata", "ec");
					DetachedCriteria criteriaEa = criteria.createCriteria("esitoArchiviazione", "ea", ApplicationUtil.leftJoin());
					criteriaC.add(Restrictions.eq("id", campagnaId));
					criteriaA.add(Restrictions.in(property, duplicatiExC));
					contatti.addAll(getContattoSI(criteria, criteriaA, property));
				}
			}
		}
		return contatti;
	}
	@SuppressWarnings("unused")
	private List<ContattoSI> getContattiVuotiF(Campagna campagna) {
		List<ContattoSI> contatti =  new ArrayList<ContattoSI>();
		if(campagna != null && ApplicationUtil.gtZero(campagna.getId())) {
			DetachedCriteria criteria = DetachedCriteria.forClass(Contatto.class, "c");
			DetachedCriteria criteriaA = criteria.createCriteria("anagrafica", "an");
			DetachedCriteria criteriaL = criteria.createCriteria("lista", "li");
			DetachedCriteria criteriaC = criteria.createCriteria("campagna", "ca");
			Integer dsc = impostazioneDao.getDuplicatiStatoCampagna();
			Integer dac = impostazioneDao.getDuplicatiAttivoCampagna();
			Integer dsl = impostazioneDao.getDuplicatiStatoLista();
			Integer dal = impostazioneDao.getDuplicatiAttivoLista();
			ApplicationUtil.statoLC(dsc, dac, criteriaC);
			ApplicationUtil.statoLC(dsl, dal, criteriaL);
			DetachedCriteria criteriaEc = criteria.createCriteria("esitoChiamata", "ec");
			DetachedCriteria criteriaEa = criteria.createCriteria("esitoArchiviazione", "ea", ApplicationUtil.leftJoin());
			criteriaC.add(Restrictions.eq("id", campagna.getId()));
			Integer d = impostazioneDao.getRicercaDuplicatiVuoti();
			if(ApplicationUtil.eq(d, 1)) {
				criteriaA.add(ApplicationUtil.isNull("telefono_fisso"));
				criteriaA.add(ApplicationUtil.isNull("telefono_mobile"));
				criteriaA.add(ApplicationUtil.isNull("telefono_fax"));
				criteriaA.add(ApplicationUtil.isNull("telefono_altro"));
				criteriaA.add(ApplicationUtil.isNull("email"));
				criteriaA.add(ApplicationUtil.isNull("link"));
				criteriaA.add(ApplicationUtil.isNull("codice_fiscale"));
				criteriaA.add(ApplicationUtil.isNull("partita_iva"));
			}
			if(ApplicationUtil.eq(d, 2)) {
				criteriaA.add(ApplicationUtil.isNull("telefono_fisso"));
				criteriaA.add(ApplicationUtil.isNull("telefono_mobile"));
				criteriaA.add(ApplicationUtil.isNull("telefono_fax"));
				criteriaA.add(ApplicationUtil.isNull("telefono_altro"));
				criteriaA.add(ApplicationUtil.isNull("email"));
			}
			if(ApplicationUtil.eq(d, 3)) {
				criteriaA.add(ApplicationUtil.isNull("telefono_fisso"));
				criteriaA.add(ApplicationUtil.isNull("telefono_mobile"));
				criteriaA.add(ApplicationUtil.isNull("telefono_fax"));
				criteriaA.add(ApplicationUtil.isNull("telefono_altro"));
			}
			contatti.addAll(getContattoSI(criteria, criteriaA, "id"));
		}
		return contatti;
	}
	@SuppressWarnings("unused")
	private List<ContattoSI> getContattiVuotiF(Campagna campagna, String property) {
		List<ContattoSI> contatti =  new ArrayList<ContattoSI>();
		if(campagna != null && ApplicationUtil.gtZero(campagna.getId())) {
			DetachedCriteria criteria = DetachedCriteria.forClass(Contatto.class, "c");
			DetachedCriteria criteriaA = criteria.createCriteria("anagrafica", "an");
			DetachedCriteria criteriaL = criteria.createCriteria("lista", "li");
			DetachedCriteria criteriaC = criteria.createCriteria("campagna", "ca");
			Integer dsc = impostazioneDao.getDuplicatiStatoCampagna();
			Integer dac = impostazioneDao.getDuplicatiAttivoCampagna();
			Integer dsl = impostazioneDao.getDuplicatiStatoLista();
			Integer dal = impostazioneDao.getDuplicatiAttivoLista();
			ApplicationUtil.statoLC(dsc, dac, criteriaC);
			ApplicationUtil.statoLC(dsl, dal, criteriaL);
			DetachedCriteria criteriaEc = criteria.createCriteria("esitoChiamata", "ec");
			DetachedCriteria criteriaEa = criteria.createCriteria("esitoArchiviazione", "ea", ApplicationUtil.leftJoin());
			criteriaC.add(Restrictions.eq("id", campagna.getId()));
			criteriaA.add(ApplicationUtil.isNull(property));
			contatti.addAll(getContattoSI(criteria, criteriaA, property));
		}
		return contatti;
	}
	@SuppressWarnings("unused")
	private List<ContattoSI> getContattiVuotiF(List<Campagna> campagne) {
		List<ContattoSI> contatti =  new ArrayList<ContattoSI>();
		List<Long> campagneId = ApplicationUtil.prendiIdCampagna(campagne);
		if(ApplicationUtil.notEmpty(campagneId)) {
			DetachedCriteria criteria = DetachedCriteria.forClass(Contatto.class, "c");
			DetachedCriteria criteriaA = criteria.createCriteria("anagrafica", "an");
			DetachedCriteria criteriaL = criteria.createCriteria("lista", "li");
			DetachedCriteria criteriaC = criteria.createCriteria("campagna", "ca");
			Integer dsc = impostazioneDao.getDuplicatiStatoCampagna();
			Integer dac = impostazioneDao.getDuplicatiAttivoCampagna();
			Integer dsl = impostazioneDao.getDuplicatiStatoLista();
			Integer dal = impostazioneDao.getDuplicatiAttivoLista();
			ApplicationUtil.statoLC(dsc, dac, criteriaC);
			ApplicationUtil.statoLC(dsl, dal, criteriaL);
			DetachedCriteria criteriaEc = criteria.createCriteria("esitoChiamata", "ec");
			DetachedCriteria criteriaEa = criteria.createCriteria("esitoArchiviazione", "ea", ApplicationUtil.leftJoin());
			criteriaC.add(Restrictions.in("id", campagneId));
			Integer d = impostazioneDao.getRicercaDuplicatiVuoti();
			if(ApplicationUtil.eq(d, 1)) {
				criteriaA.add(ApplicationUtil.isNull("telefono_fisso"));
				criteriaA.add(ApplicationUtil.isNull("telefono_mobile"));
				criteriaA.add(ApplicationUtil.isNull("telefono_fax"));
				criteriaA.add(ApplicationUtil.isNull("telefono_altro"));
				criteriaA.add(ApplicationUtil.isNull("email"));
				criteriaA.add(ApplicationUtil.isNull("link"));
				criteriaA.add(ApplicationUtil.isNull("codice_fiscale"));
				criteriaA.add(ApplicationUtil.isNull("partita_iva"));
			}
			if(ApplicationUtil.eq(d, 2)) {
				criteriaA.add(ApplicationUtil.isNull("telefono_fisso"));
				criteriaA.add(ApplicationUtil.isNull("telefono_mobile"));
				criteriaA.add(ApplicationUtil.isNull("telefono_fax"));
				criteriaA.add(ApplicationUtil.isNull("telefono_altro"));
				criteriaA.add(ApplicationUtil.isNull("email"));
			}
			if(ApplicationUtil.eq(d, 3)) {
				criteriaA.add(ApplicationUtil.isNull("telefono_fisso"));
				criteriaA.add(ApplicationUtil.isNull("telefono_mobile"));
				criteriaA.add(ApplicationUtil.isNull("telefono_fax"));
				criteriaA.add(ApplicationUtil.isNull("telefono_altro"));
			}
			contatti.addAll(getContattoSI(criteria, criteriaA, "id"));
		}
		return contatti;
	}
	@SuppressWarnings("unused")
	private List<ContattoSI> getContattiVuotiF(List<Campagna> campagne, String property) {
		List<ContattoSI> contatti =  new ArrayList<ContattoSI>();
		List<Long> campagneId = ApplicationUtil.prendiIdCampagna(campagne);
		if(ApplicationUtil.notEmpty(campagneId)) {
			DetachedCriteria criteria = DetachedCriteria.forClass(Contatto.class, "c");
			DetachedCriteria criteriaA = criteria.createCriteria("anagrafica", "an");
			DetachedCriteria criteriaL = criteria.createCriteria("lista", "li");
			DetachedCriteria criteriaC = criteria.createCriteria("campagna", "ca");
			Integer dsc = impostazioneDao.getDuplicatiStatoCampagna();
			Integer dac = impostazioneDao.getDuplicatiAttivoCampagna();
			Integer dsl = impostazioneDao.getDuplicatiStatoLista();
			Integer dal = impostazioneDao.getDuplicatiAttivoLista();
			ApplicationUtil.statoLC(dsc, dac, criteriaC);
			ApplicationUtil.statoLC(dsl, dal, criteriaL);
			DetachedCriteria criteriaEc = criteria.createCriteria("esitoChiamata", "ec");
			DetachedCriteria criteriaEa = criteria.createCriteria("esitoArchiviazione", "ea", ApplicationUtil.leftJoin());
			criteriaC.add(Restrictions.in("id", campagneId));
			criteriaA.add(ApplicationUtil.isNull(property));
			contatti.addAll(getContattoSI(criteria, criteriaA, property));
		}
		return contatti;
	}
}