package it.callite.dao;
import java.io.ByteArrayInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.URL;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import org.apache.commons.net.ftp.FTPClient;
import org.apache.commons.net.ftp.FTPFile;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Repository;

import it.callite.action.DownloadBean;
import it.callite.constants.ConstantsGlobal;
import it.callite.constants.ConstantsLanguage;
import it.callite.constants.ConstantsMap;
import it.callite.criteria.FileCriteria;
import it.callite.dao.generic.GenericDao;
import it.callite.log.ErrorLog;
import it.callite.utility.Allegato;
import it.callite.utility.ApplicationUtil;
import it.callite.utility.FileUpload;
import it.callite.utility.MyFile;
import it.callite.utility.PathUtility;
import it.callite.utility.UtilFTP;
import it.callite.utility.ZipPassword;
import it.callite.utility.ZipUtils;
@SuppressWarnings("serial")
@Repository("fileDao")
public class FileDao extends GenericDao {
	@Autowired
	private ImpostazioneDao impostazioneDao;
	public String getRoot() {
		return ConstantsGlobal.path_file;
	}
	public String editFile(PathUtility p, MyFile att) {
		if(att.isFolder()) {
			return att.getName();
		} else {
			return att.getBaseName();
		}
	}
	public void copyFile(PathUtility p, MyFile att, String perc, String rinomina) {
		String percorso = ApplicationUtil.normalizeNoEndSeparator(ApplicationUtil.trimToEmpty(perc));
		boolean abs = percorso.startsWith("/"); 
		if(getEnabledFTP()) {
			String home = impostazioneDao.getHome();
			String percorsoNuovo = ApplicationUtil.normalizeNoEndSeparator(home + (abs ? p.getRoot() : p.getPath()) + "/" + percorso);
			File source = new File(home + p.getPath() + "/" + att.getName());
			String nex = (att.isFolder() ? "" : "." + att.getExtension());
			File nuovo = new File(percorsoNuovo + "/" + rinomina + nex);
			File dest = new File(percorsoNuovo);
			ApplicationUtil.creaFile(true, dest);
			if(!ApplicationUtil.equals(home + p.getPath() + "/" + att.getName(), percorsoNuovo + "/" + rinomina + nex)) {
				ApplicationUtil.copyFile(source, nuovo);
			}
		} else {
			UtilFTP ut = impostazioneDao.getUtilFTP();
			FTPClient vmftp = ApplicationUtil.createClient();
			if (ApplicationUtil.connect(vmftp, ut)) {
				try {
					String nex = (att.isFolder() ? "" : "." + att.getExtension());
					String percorsoNuovo = ApplicationUtil.normalizeNoEndSeparator((abs ? p.getRoot() : p.getPath()) + "/"  + percorso);
					if(!ApplicationUtil.equals(p.getPath() + "/" + att.getName(), percorsoNuovo + "/" + rinomina + nex)) {
						if(att.isFolder()) {
							List<Allegato> mFile = new ArrayList<Allegato>();
							ApplicationUtil.readDirectory(vmftp, mFile, p.getPath() + "/" + att.getName(), p.getPath() + "/" + att.getName());
							if(ApplicationUtil.notEmpty(mFile)) {
								ApplicationUtil.makeDirectories(vmftp, percorsoNuovo);
								Iterator<Allegato> mIt = mFile.iterator();
								while (mIt.hasNext()) {
									Allegato all = (Allegato) mIt.next();
									String sub_path = ApplicationUtil.getPathN(all.getNome());
									ApplicationUtil.makeDirectories(vmftp, percorsoNuovo + "/" + rinomina + nex + "/" + sub_path);
									InputStream  fis = new ByteArrayInputStream(all.getFile());
									ApplicationUtil.storeFile(vmftp, percorsoNuovo + "/" + rinomina + nex + "/" + all.getNome(), fis);
									fis.close();
								}
							}
						} else {
							List<Allegato> mFile = new ArrayList<Allegato>();
							ApplicationUtil.addFile(vmftp, mFile, p.getPath() + "/" + att.getName(), null);
							if(ApplicationUtil.notEmpty(mFile)) {
								ApplicationUtil.makeDirectories(vmftp, percorsoNuovo);
								Iterator<Allegato> mIt = mFile.iterator();
								while (mIt.hasNext()) {
									Allegato all = (Allegato) mIt.next();
									InputStream  fis = new ByteArrayInputStream(all.getFile());
									ApplicationUtil.storeFile(vmftp, percorsoNuovo + "/" + rinomina + nex, fis);
									fis.close();
								}
							}
						}
					}
				} catch (Exception e) {
					ErrorLog.log(null, getClass(), e);
				} finally {
					ApplicationUtil.disconnect(vmftp);
				}
			}
		}
	}
	public void moveFile(PathUtility p, MyFile att, String perc, String rinomina) {
		String percorso = ApplicationUtil.normalizeNoEndSeparator(ApplicationUtil.trimToEmpty(perc));
		boolean abs = percorso.startsWith("/"); 
		if(getEnabledFTP()) {
			String home = impostazioneDao.getHome();
			String percorsoNuovo = ApplicationUtil.normalizeNoEndSeparator(home + (abs ? p.getRoot() : p.getPath()) + "/" + percorso);
			File source = new File(home + p.getPath() + "/" + att.getName());
			String nex = (att.isFolder() ? "" : "." + att.getExtension());
			if(!ApplicationUtil.equals(home + p.getPath() + "/" + att.getName(), percorsoNuovo + "/" + rinomina + nex)) {
				File nuovo = new File(percorsoNuovo + "/" + rinomina + nex);
				File dest = new File(percorsoNuovo);
				ApplicationUtil.creaFile(true, dest);
				source.renameTo(nuovo);
			}
		} else {
			UtilFTP ut = impostazioneDao.getUtilFTP();
			FTPClient vmftp = ApplicationUtil.createClient();
			if (ApplicationUtil.connect(vmftp, ut)) {
				try {
					String nex = (att.isFolder() ? "" : "." + att.getExtension());
					String percorsoNuovo = ApplicationUtil.normalizeNoEndSeparator((abs ? p.getRoot() : p.getPath()) + "/"  + percorso);
					if(!ApplicationUtil.equals(p.getPath() + "/" + att.getName(), percorsoNuovo + "/" + rinomina + nex)) {
						ApplicationUtil.makeDirectories(vmftp, percorsoNuovo);
						ApplicationUtil.renameFile(vmftp, p.getPath() + "/" + att.getName(), percorsoNuovo + "/" + rinomina + nex);
					}
				} catch (Exception e) {
					ErrorLog.log(null, getClass(), e);
				} finally {
					ApplicationUtil.disconnect(vmftp);
				}
			}
		}
	}
	public boolean salvaFileInternet(String url,  PathUtility p) {
		String fileName = ApplicationUtil.getNameN(url);
		if(getEnabledFTP()) {
			String home = impostazioneDao.getHome();
			try {
				String path = home + p.getPath() + "/" + fileName;
				InputStream stream = new URL(url).openStream();
				byte [] b = ApplicationUtil.toByteArray(stream);
				stream.close();
				FileOutputStream fi = new FileOutputStream(path);
				fi.write(b);
				fi.flush();
				fi.close();
			} catch (Exception e) {
				ErrorLog.log(null, getClass(), e);
				return false;
			}
		} else {
			UtilFTP ut = impostazioneDao.getUtilFTP();
			FTPClient vmftp = ApplicationUtil.createClient();
			if (ApplicationUtil.connect(vmftp, ut)) {
				try {
					InputStream stream = new URL(url).openStream();
					byte [] b = ApplicationUtil.toByteArray(stream);
					stream.close();
					InputStream  fis = new ByteArrayInputStream(b);
					ApplicationUtil.storeFile(vmftp, p.getPath() + "/" + fileName, fis);
					fis.close();
				} catch (Exception e) {
					ErrorLog.log(null, getClass(), e);
					return false;
				} finally {
					ApplicationUtil.disconnect(vmftp);
				}
			}	
		}
		return true;
	}
	public boolean salvaZipInternet(String url,  PathUtility p) {
		List<MyFile> scompattati = new ArrayList<MyFile>();
		try {
			InputStream stream = new URL(url).openStream();
			byte [] b = ApplicationUtil.toByteArray(stream);
			stream.close();
			scompattati.addAll(ApplicationUtil.unzip(b));
		} catch (Exception e) {
			ErrorLog.log(null, getClass(), e);
			return false;
		}
		if(ApplicationUtil.notEmpty(scompattati)) {
			if(getEnabledFTP()) {
				String home = impostazioneDao.getHome();
				try {
					Iterator<MyFile> flsIt = scompattati.iterator();
					while (flsIt.hasNext()) {
						MyFile ff = (MyFile) flsIt.next();
						String base = home +  p.getPath();
						File n = new File(base + "/" + ApplicationUtil.getPathN(ff.getName()));
						ApplicationUtil.creaFile(true, n);
						File fileOut = new File(base + "/" + ff.getName());
						if(fileOut.isFile()) {
							FileOutputStream fi = new FileOutputStream(fileOut);
							fi.write(ff.getData());
							fi.flush();
							fi.close();
						}
					}
				} catch (Exception e) {
					ErrorLog.log(null, getClass(), e);
					return false;
				}
			} else {
				UtilFTP ut = impostazioneDao.getUtilFTP();
				FTPClient vmftp = ApplicationUtil.createClient();
				if (ApplicationUtil.connect(vmftp, ut)) {
					try {
						Iterator<MyFile> flsIt = scompattati.iterator();
						while (flsIt.hasNext()) {
							MyFile ff = (MyFile) flsIt.next();
							String dir = ApplicationUtil.normalizeNoEndSeparator(p.getPath() + "/" + ApplicationUtil.getPathN(ff.getName()));
							String file = ApplicationUtil.normalizeNoEndSeparator(p.getPath() + "/" + ff.getName());
							ApplicationUtil.makeDirectories(vmftp, dir);
							InputStream  fis = new ByteArrayInputStream(ff.getData());
							ApplicationUtil.storeFile(vmftp, file, fis);
							fis.close();
						}
					} catch (Exception e) {
						ErrorLog.log(null, getClass(), e);
						return false;
					} finally {
						ApplicationUtil.disconnect(vmftp);
					}
				}	
			}
		}
		return true;
	}
	public boolean renameFile(PathUtility p, MyFile att, String n) {
		boolean exist = false;
		if(ApplicationUtil.isNotBlank(n)) {
			String ps =  ConstantsGlobal.validatore_folder2;
			Pattern pp = Pattern.compile(ps);
			Matcher mm = pp.matcher(n);
			boolean b = mm.matches();	  		 
			if(!b){
				exist = true;
			}
			String ext = (att.isFolder() ? "" : "." + att.getExtension());
			if(getEnabledFTP()) {
				String home = impostazioneDao.getHome();
				File perc = new File(home + p.getPath() + "/" + att.getName());
				File nuovo = new File(home + p.getPath() + "/" + n + ext);
				if(!nuovo.exists() || ApplicationUtil.equals(att.getName(), n + ext)) {
					perc.renameTo(nuovo);
				} else {
					exist = true;
				}
			} else {
				UtilFTP ut = impostazioneDao.getUtilFTP();
				FTPClient vmftp = ApplicationUtil.createClient();
				if (ApplicationUtil.connect(vmftp, ut)) {
					try {
						if(att.isFolder()) {
							boolean directoryExists = ApplicationUtil.changeWorkingDirectory(vmftp, p.getPath() + "/"  + n + ext);
							if(!directoryExists || ApplicationUtil.equals(att.getName(), n + ext)) {
								ApplicationUtil.renameFile(vmftp, p.getPath() + "/" + att.getName(), p.getPath() + "/" + n + ext);
							} else {
								exist = true;
							}
						} else {
							String [] fl = ApplicationUtil.listNames(vmftp, p.getPath() + "/" + n + ext);
							if(ApplicationUtil.empty(fl) || ApplicationUtil.equals(att.getName(), n + ext)) {
								ApplicationUtil.renameFile(vmftp, p.getPath() + "/" + att.getName(), p.getPath() + "/" + n + ext);
							} else {
								exist = true;
							}
						}
					} catch (Exception e) {
						ErrorLog.log(null, getClass(), e);
					} finally {
						ApplicationUtil.disconnect(vmftp);
					}
				}
			}
		} else {
			exist = true;
		}
		if(exist) {
			return false;
		} 
		return true;
	}
	public boolean newFolder(PathUtility p, String perc) {
		if(ApplicationUtil.isNotBlank(perc)) {
			String m = ApplicationUtil.normalizeNoEndSeparator(ApplicationUtil.trimToEmpty(perc));
			boolean abs = m.startsWith("/"); 
			String ps =  ConstantsGlobal.validatore_path;
			Pattern pp = Pattern.compile(ps);
			Matcher mm = pp.matcher(m);
			boolean b = mm.matches();	  		 
			if(!b){
				return false;
			}
			if(getEnabledFTP()) {
				String home = impostazioneDao.getHome();
				String nn = ApplicationUtil.normalizeNoEndSeparator(home + (abs ? p.getRoot() : p.getPath()) + "/" + m);
				File percD = new File(nn);
				if(!percD.exists()) {
					percD.mkdirs();
				}  else {
					return false;
				}
			} else {
				UtilFTP ut = impostazioneDao.getUtilFTP();
				FTPClient vmftp = ApplicationUtil.createClient();
				if (ApplicationUtil.connect(vmftp, ut)) {
					try {
						String nn = ApplicationUtil.normalizeNoEndSeparator((abs ? p.getRoot() : p.getPath())  + "/"  + m);
						boolean directoryExists = ApplicationUtil.changeWorkingDirectory(vmftp, nn);
						if(!directoryExists) {
							ApplicationUtil.makeDirectories(vmftp, nn);
						} else {
							return false;
						}
					} catch (Exception e) {
						ErrorLog.log(null, getClass(), e);
					} finally {
						ApplicationUtil.disconnect(vmftp);
					}
				}
			}
		} else {
			return false;
		}
		return true;
	}
	public void closeRoot(PathUtility p) {
		p.reset();
	}
	public String openRoot(PathUtility p) {
		if(getEnabledFTP()) {
			String home = impostazioneDao.getHome();
			return home + p.getPath();
		} else {
			return p.getPath();
		}
	}
	public String openRoot(PathUtility p, MyFile m) {
		if(getEnabledFTP()) {
			String home = impostazioneDao.getHome();
			return home + p.getPath() + "/" + m.getName();
		} else {
			return p.getPath() + "/" + m.getName();
		}
	}
	public void openFolder(PathUtility p, MyFile m) {
		String n = p.getPath( ) + "/" + m.getName();
		p.setPath(n);
	}
	public void closeFolder(PathUtility p) {
		String n = ApplicationUtil.substringBeforeLast(p.getPath(), "/");
		p.setPath(n);
	}
	public List<MyFile> listaFile(FileCriteria mm, PathUtility p) {
		if(mm != null)  mm = (FileCriteria) mm.loadCriteria();
		List<MyFile> ff = new ArrayList<MyFile>();
		if(mm != null && mm.getCerca()) {
			if(getEnabledFTP()) {
				String home = impostazioneDao.getHome();
				File perc = new File(home + p.getPath());
				ApplicationUtil.creaFile(true, perc);
				File [] files = perc.listFiles();
				if(ApplicationUtil.notEmpty(files)) {
					for(File file : files) {
						if(mm.isRicerca(file.getName(), file.length(), file.lastModified())) {
							MyFile f = new MyFile(file);
							f.setParent(ApplicationUtil.removeStart(p.getPath(), p.getRoot()));
							f.setName(file.getName());
							f.setModified(file.lastModified());
							ff.add(f);
						}
					}
				}
			} else {
				UtilFTP ut = impostazioneDao.getUtilFTP();
				FTPClient vmftp = ApplicationUtil.createClient();
				if (ApplicationUtil.connect(vmftp, ut)) {
					try {
						FTPFile[] wavFiles = ApplicationUtil.listFiles(vmftp, p.getPath() + "/");
						if (ApplicationUtil.notEmpty(wavFiles)) {
							for(FTPFile file : wavFiles) {
								Long time = ApplicationUtil.time(file.getTimestamp());
								if(mm.isRicerca(file.getName(), file.getSize(), time)) {
									MyFile f = new MyFile(file);
									f.setParent(ApplicationUtil.removeStart(p.getPath(), p.getRoot()));
									f.setName(file.getName());
									f.setModified(time);
									ff.add(f);
								}
							}
						}
					} catch (Exception e) {
						ErrorLog.log(null, getClass(), e);
					} finally {
						ApplicationUtil.disconnect(vmftp);
					}
				}	
			}
		}
		return ff;
	}
	public void eliminaFile(MyFile att, PathUtility p) {
		if(getEnabledFTP()) {
			String home = impostazioneDao.getHome();
			File perc = new File(home + p.getPath() + "/" + att.getName());
			ApplicationUtil.deleteAll(perc);
		} else {
			UtilFTP ut = impostazioneDao.getUtilFTP();
			FTPClient vmftp = ApplicationUtil.createClient();
			if (ApplicationUtil.connect(vmftp, ut)) {
				try {
					if(att.isFolder()) {
						ApplicationUtil.removeDirectory(vmftp, p.getPath() + "/" + att.getName());
					} else {
						ApplicationUtil.deleteFile(vmftp, p.getPath() + "/" + att.getName());
					}
				} catch (Exception e) {
					ErrorLog.log(null, getClass(), e);
				} finally {
					ApplicationUtil.disconnect(vmftp);
				}
			}	
		}
	}
	public void eliminaFile(List<MyFile> atts,  PathUtility p) {
		if(getEnabledFTP()) {
			if(ApplicationUtil.notEmpty(atts)) {
				String home = impostazioneDao.getHome();
				Iterator<MyFile> aIt = atts.iterator();
				while (aIt.hasNext()) {
					MyFile att = (MyFile) aIt.next();
					File perc = new File(home + p.getPath() + "/" + att.getName());
					ApplicationUtil.deleteAll(perc);
				}
			}
		} else {
			UtilFTP ut = impostazioneDao.getUtilFTP();
			FTPClient vmftp = ApplicationUtil.createClient();
			if (ApplicationUtil.connect(vmftp, ut)) {
				try {
					if(ApplicationUtil.notEmpty(atts)) {
						Iterator<MyFile> aIt = atts.iterator();
						while (aIt.hasNext()) {
							MyFile att = (MyFile) aIt.next();
							if(att.isFolder()) {
								ApplicationUtil.removeDirectory(vmftp, p.getPath() + "/" + att.getName());
							} else {
								ApplicationUtil.deleteFile(vmftp, p.getPath() + "/" + att.getName());
							}
						}
					}
				} catch (Exception e) {
					ErrorLog.log(null, getClass(), e);
				} finally {
					ApplicationUtil.disconnect(vmftp);
				}
			}	
		}
	}
	public void salvaFile(FileUpload fileUpload,  PathUtility p) {
		if(getEnabledFTP()) {
			
			try {
				List<MyFile> fls = fileUpload.getFiles();
				if(ApplicationUtil.notEmpty(fls)) {
					String home = impostazioneDao.getHome();
					Iterator<MyFile> flsIt = fls.iterator();
					while (flsIt.hasNext()) {
						MyFile ff = (MyFile) flsIt.next();
						FileOutputStream fi = new FileOutputStream(home +  p.getPath() + "/" + ff.getName());
						fi.write(ff.getData());
						fi.flush();
						fi.close();
					}
				}
			} catch (Exception e) {
				ErrorLog.log(null, getClass(), e);
			}
		} else {
			UtilFTP ut = impostazioneDao.getUtilFTP();
			FTPClient vmftp = ApplicationUtil.createClient();
			if (ApplicationUtil.connect(vmftp, ut)) {
				try {
					List<MyFile> fls = fileUpload.getFiles();
					if(ApplicationUtil.notEmpty(fls)) {
						Iterator<MyFile> flsIt = fls.iterator();
						while (flsIt.hasNext()) {
							MyFile ff = (MyFile) flsIt.next();
							InputStream  fis = new ByteArrayInputStream(ff.getData());
							ApplicationUtil.storeFile(vmftp, p.getPath() + "/" + ff.getName(), fis);
							fis.close();
						}
					}
				} catch (Exception e) {
					ErrorLog.log(null, getClass(), e);
				} finally {
					ApplicationUtil.disconnect(vmftp);
				}
			}	
		}
	}
	public void salvaZip(FileUpload fileUpload,  PathUtility p) {
		List<MyFile> scompattati = new ArrayList<MyFile>();
		try {
			List<MyFile> fls = fileUpload.getFiles();
			if(ApplicationUtil.notEmpty(fls)) {
				Iterator<MyFile> flsIt = fls.iterator();
				while (flsIt.hasNext()) {
					MyFile dd = (MyFile) flsIt.next();
					scompattati.addAll(ApplicationUtil.unzip(dd));
				}
			}
		} catch (Exception e) {
			ErrorLog.log(null, getClass(), e);
		}
		if(ApplicationUtil.notEmpty(scompattati)) {
			if(getEnabledFTP()) {
				String home = impostazioneDao.getHome();
				try {
					Iterator<MyFile> flsIt = scompattati.iterator();
					while (flsIt.hasNext()) {
						MyFile ff = (MyFile) flsIt.next();
						String base = home +  p.getPath();
						File n = new File(base + "/" + ApplicationUtil.getPathN(ff.getName()));
						ApplicationUtil.creaFile(true, n);
						File fileOut = new File(base + "/" + ff.getName());
						if(fileOut.isFile()) {
							FileOutputStream fi = new FileOutputStream(fileOut);
							fi.write(ff.getData());
							fi.flush();
							fi.close();
						}
					}
				} catch (Exception e) {
					ErrorLog.log(null, getClass(), e);
				}
			} else {
				UtilFTP ut = impostazioneDao.getUtilFTP();
				FTPClient vmftp = ApplicationUtil.createClient();
				if (ApplicationUtil.connect(vmftp, ut)) {
					try {
						Iterator<MyFile> flsIt = scompattati.iterator();
						while (flsIt.hasNext()) {
							MyFile ff = (MyFile) flsIt.next();
							String dir = ApplicationUtil.normalizeNoEndSeparator(p.getPath() + "/" + ApplicationUtil.getPathN(ff.getName()));
							String file = ApplicationUtil.normalizeNoEndSeparator(p.getPath() + "/" + ff.getName());
							ApplicationUtil.makeDirectories(vmftp, dir);
							InputStream  fis = new ByteArrayInputStream(ff.getData());
							ApplicationUtil.storeFile(vmftp, file, fis);
							fis.close();
						}
					} catch (Exception e) {
						ErrorLog.log(null, getClass(), e);
					} finally {
						ApplicationUtil.disconnect(vmftp);
					}
				}	
			}
		}
	}
	public void scaricaFile(List<MyFile> fils,  PathUtility p, DownloadBean downloadBean) {
		List<Allegato> files = new ArrayList<Allegato>();
		if(getEnabledFTP()) {
			if (ApplicationUtil.notEmpty(fils)) {
				String home = impostazioneDao.getHome();
				Iterator<MyFile> itS = fils.iterator();
				while (itS.hasNext()) {
					MyFile file = (MyFile) itS.next();
					String root = home + p.getRoot();
					if(file.isFolder()) {
						String base = home + p.getPath() + "/" + file.getName();
						ApplicationUtil.generateMyFileList(files, new File(base), root);
					} else {
						String base = home + p.getPath();
						ApplicationUtil.generateMyFileList(files, new File(base + "/" + file.getName()), root);
					}
				}
			}
		} else {
			UtilFTP ut = impostazioneDao.getUtilFTP();
			FTPClient vmftp = ApplicationUtil.createClient();
			if (ApplicationUtil.connect(vmftp, ut)) {
				try {
					if(ApplicationUtil.notEmpty(fils)) {
						Iterator<MyFile> fIt = fils.iterator();
						while (fIt.hasNext()) {
							MyFile myFile = (MyFile) fIt.next();
							if(myFile.isFolder()) {
								ApplicationUtil.readDirectory(vmftp, files, p.getPath() + "/" + myFile.getName(), p.getRoot() + "/");
							} else {
								ApplicationUtil.addFile(vmftp, files, p.getPath() + "/" + myFile.getName(), myFile.getModified());
							}
						}
					}
				} catch (Exception e) {
					ErrorLog.log(null, getClass(), e);
				} finally {
					ApplicationUtil.disconnect(vmftp);
				}
			}
		}
		try {
			if (ApplicationUtil.notEmpty(files)) {
				String file_header = ApplicationUtil.reportFile(ApplicationUtil.date(), ConstantsLanguage.FILE.stampa()) + "." + ConstantsMap.zip;
				OutputStream out = downloadBean.outputStream();
				downloadBean.filename(file_header, files);
				String g = ConstantsGlobal.secretZ;
				ApplicationUtil.zip(null,files, out, g);
				downloadBean.close();
			}
		} catch (Exception e) {
			ErrorLog.log(null, getClass(), e);
		}
	}
	public Boolean getEnabledFTP() {
		return ApplicationUtil.isNotTrue(impostazioneDao.getFTPEnabled());
	}
	public void scaricaFile(MyFile att,  PathUtility p, DownloadBean downloadBean) {
		if(getEnabledFTP()) {
			try {
				String home = impostazioneDao.getHome();
				if(att.isFolder()) {
					OutputStream out = downloadBean.outputStream();
					downloadBean.filename(att.getName() + "." + ConstantsMap.zip);
					String g = ConstantsGlobal.secretZ;
					String ppath = home +  p.getPath() + "/" + att.getName();
					File ff = new File(ppath);
					if(g != null) {
						ZipPassword.zipIt(null, ff.getAbsolutePath(), out, g);
					} else {
						ZipUtils.zipIt(null, ff.getAbsolutePath(), out);
					}
					downloadBean.close();
				} else {
					OutputStream out = downloadBean.outputStream();
					downloadBean.filename(att.getName());
					String nome = home + p.getPath() +"/"+ att.getName();
					InputStream istream = new FileInputStream(nome);
					ApplicationUtil.copy(istream, out);
					istream.close();
					downloadBean.close();
				}
			} catch (Exception e) {
				ErrorLog.log(null, getClass(), e);
			}
		} else {
			UtilFTP ut = impostazioneDao.getUtilFTP();
			FTPClient vmftp = ApplicationUtil.createClient();
			if (ApplicationUtil.connect(vmftp, ut)) {
				try {
					if(att.isFolder()) {
						OutputStream out = downloadBean.outputStream();
						downloadBean.filename(att.getName() + "." + ConstantsMap.zip);
						List<Allegato> mFile = new ArrayList<Allegato>();
						ApplicationUtil.readDirectory(vmftp, mFile, p.getPath() + "/" + att.getName(), p.getRoot() + "/");
						String g = ConstantsGlobal.secretZ;
						ApplicationUtil.zip(null,mFile, out, g);
						downloadBean.close();
					} else {
						OutputStream out = downloadBean.outputStream();
						downloadBean.filename(att.getName());
						String path = p.getPath() + "/" + att.getName();
						ApplicationUtil.scaricaFile(vmftp, out, path);
						downloadBean.close();
					}
				} catch (Exception e) {
					ErrorLog.log(null, getClass(), e);
				} finally {
					ApplicationUtil.disconnect(vmftp);
				}
			}	
		}
	}
	
	
	public boolean salvaController(String fileName, byte[] url) {
		if(getEnabledFTP()) {
			String home = impostazioneDao.getHome();
			try {
				String path = home + getRoot() + "/" + fileName;
				InputStream stream = new ByteArrayInputStream(url);
				byte [] b = ApplicationUtil.toByteArray(stream);
				stream.close();
				FileOutputStream fi = new FileOutputStream(path);
				fi.write(b);
				fi.flush();
				fi.close();
			} catch (Exception e) {
				ErrorLog.log(null, getClass(), e);
				return false;
			}
		} else {
			UtilFTP ut = impostazioneDao.getUtilFTP();
			FTPClient vmftp = ApplicationUtil.createClient();
			if (ApplicationUtil.connect(vmftp, ut)) {
				try {
					InputStream stream = new ByteArrayInputStream(url);
					byte [] b = ApplicationUtil.toByteArray(stream);
					stream.close();
					InputStream  fis = new ByteArrayInputStream(b);
					ApplicationUtil.storeFile(vmftp, getRoot() + "/" + fileName, fis);
					fis.close();
				} catch (Exception e) {
					ErrorLog.log(null, getClass(), e);
					return false;
				} finally {
					ApplicationUtil.disconnect(vmftp);
				}
			}	
		}
		return true;
	}
}