package it.callite.dao;
import java.io.BufferedReader;
import java.io.ByteArrayInputStream;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.Statement;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import org.springframework.stereotype.Repository;

import it.callite.constants.ConstantsGlobal;
import it.callite.criteria.DecoderCriteria;
import it.callite.criteria.QueryCriteria;
import it.callite.dao.generic.GenericDao;
import it.callite.utility.ApplicationUtil;
import it.callite.utility.FileUpload;
import it.callite.utility.MyFile;
import it.callite.utility.QueryKey;
@SuppressWarnings("serial")
@Repository("queryDao")
public class QueryDao extends GenericDao {
	
	
	public List<QueryKey> queryL(FileUpload fileUpload) throws Exception {
		List<QueryKey> qkl = new ArrayList<QueryKey>();
		List<MyFile> fls = fileUpload.getFiles();
		if(ApplicationUtil.notEmpty(fls)) {
			StringBuffer queries = new StringBuffer();
			for(MyFile ff : fls) {
				InputStream inputStream = new ByteArrayInputStream(ff.getData());
				BufferedReader reader = new BufferedReader(new InputStreamReader(inputStream));
				String lineS;
				while ((lineS = reader.readLine()) != null) {
					String line = ApplicationUtil.trimToNull(lineS);
					if(line != null) {
						queries.append(ApplicationUtil.trimToEmpty(line) + " ");
					}
				}
				reader.close();
				inputStream.close();        
			}
			List<String> ql = ApplicationUtil.splitV(queries.toString(), ConstantsGlobal.qsp);
			if(ApplicationUtil.notEmpty(ql)) {
				int i = 1;
				Connection conn = getJdbcTemplate().getDataSource().getConnection();
				conn.setAutoCommit(true);
				Statement st = conn.createStatement(ResultSet.TYPE_SCROLL_INSENSITIVE, ResultSet.CONCUR_READ_ONLY);
				for(String q : ql) {
					QueryKey qk = ApplicationUtil.queryExecute(st, q);
					qk.setId(i++);
					qk.setQuery(q);
					qkl.add(qk);
				}
				st.close();
				conn.close();
			}
		}
		return qkl;
	}
	public List<QueryKey> queryL(QueryCriteria qs) throws Exception {
		if(qs != null)  qs = (QueryCriteria) qs.loadCriteria();
		List<QueryKey> qkl = new ArrayList<QueryKey>();
		if(qs != null && qs.getCerca()) {
			String  cl = ApplicationUtil.cleanText(qs.getNome());
			List<String> ql = ApplicationUtil.splitV(cl, ConstantsGlobal.qsp);
			if(ApplicationUtil.notEmpty(ql)) {
				int i = 1;
				Connection conn = getJdbcTemplate().getDataSource().getConnection();
				conn.setAutoCommit(true);
				Statement st = conn.createStatement(ResultSet.TYPE_SCROLL_INSENSITIVE, ResultSet.CONCUR_READ_ONLY);
				for(String q : ql) {
					QueryKey qk = ApplicationUtil.queryExecute(st, q);
					qk.setId(i++);
					qk.setQuery(q);
					qkl.add(qk);
				}
				st.close();
				conn.close();
			}
		}
		return qkl;
	}
	public List<QueryKey> export(List<QueryKey> ql) {
		List<QueryKey> query = new ArrayList<QueryKey>();
		if(ApplicationUtil.notEmpty(ql)){
			Iterator<QueryKey> it = ql.iterator();
			while (it.hasNext()) {
				QueryKey qk = (QueryKey) it.next();
				if(qk.isValido()) {
					query.add(qk);
				}
			}
		}
		return query;
	}
	public String decode(DecoderCriteria d) {
		if(d != null)  d = (DecoderCriteria) d.loadCriteria();
		if(d != null && d.getCerca()) {
			return ApplicationUtil.base64Decoder(d.getDomanda());
		} else {
			return null;
		}
	}
	public String encode(DecoderCriteria d) {
		if(d != null)  d = (DecoderCriteria) d.loadCriteria();
		if(d != null && d.getCerca()) {
			return ApplicationUtil.base64Encoder(d.getDomanda());
		} else {
			return null;
		}
	}
}