package it.callite.dao;
import java.io.ByteArrayOutputStream;
import java.io.File;
import java.nio.file.DirectoryStream;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Date;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

import org.apache.commons.net.ftp.FTPClient;
import org.apache.commons.net.ftp.FTPFile;
import org.hibernate.FetchMode;
import org.hibernate.criterion.Criterion;
import org.hibernate.criterion.DetachedCriteria;
import org.hibernate.criterion.Order;
import org.hibernate.criterion.Projections;
import org.hibernate.criterion.Restrictions;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.ApplicationContext;
import org.springframework.context.ApplicationContextAware;
import org.springframework.stereotype.Repository;

import it.callite.constants.ConstantsFormat;
import it.callite.constants.ConstantsGlobal;
import it.callite.constants.ConstantsLanguage;
import it.callite.constants.ConstantsMap;
import it.callite.constants.config.DefaultsGeneric;
import it.callite.criteria.SchedulerCriteria;
import it.callite.criteria.base.ExtendedCriteria;
import it.callite.dao.generic.GenericDao;
import it.callite.log.ErrorLog;
import it.callite.message.Message;
import it.callite.model.Accesso;
import it.callite.model.Agente;
import it.callite.model.Anagrafica;
import it.callite.model.Appuntamento;
import it.callite.model.Campagna;
import it.callite.model.Contratto;
import it.callite.model.Email;
import it.callite.model.Marcatura;
import it.callite.model.Nota;
import it.callite.model.Operazione;
import it.callite.model.Pausa;
import it.callite.model.Prenotazione;
import it.callite.model.Prodotto;
import it.callite.model.Rmail;
import it.callite.model.Schedulatore;
import it.callite.model.StoriaAppuntamento;
import it.callite.model.StoriaContatto;
import it.callite.model.StoriaContratto;
import it.callite.model.Team;
import it.callite.model.Telecom;
import it.callite.model.Tema;
import it.callite.model.Zona;
import it.callite.model.allegato.AllegatoAgente;
import it.callite.model.allegato.AllegatoAnagrafica;
import it.callite.model.allegato.AllegatoAppuntamento;
import it.callite.model.allegato.AllegatoContatto;
import it.callite.model.allegato.AllegatoContratto;
import it.callite.model.allegato.AllegatoNotizia;
import it.callite.model.report.ReportContattiOdierniTeam;
import it.callite.model.report.ReportContattiOdierniZona;
import it.callite.service.SchedulerService;
import it.callite.service.SmtpService;
import it.callite.service.config.ConfigurazioneGenericService;
import it.callite.utility.Allegato;
import it.callite.utility.ApplicationUtil;
import it.callite.utility.MailSupport;
import it.callite.utility.MySystem;
import it.callite.utility.TemaUtil;
import it.callite.utility.UtilFTP;
import it.callite.utility.VCardUtils;
@SuppressWarnings("serial")
@Repository("schedulerDao")
public class SchedulerDao extends GenericDao implements ApplicationContextAware {
	@Autowired
	private SmtpService smtpService;
	@Autowired
	private SchedulerService schedulerService;
	@Autowired
	private ConfigurazioneGenericService configurazioneGenericService;
	@Autowired
	private AutodialerDao autodialerDao;
	@Autowired
	private ComunicazioneDao comunicazioneDao;
	@Autowired
	private AnagraficaDao anagraficaDao;
	@Autowired
	private DownloadDao downloadDao;
	@Autowired
	private ImpostazioneDao impostazioneDao;
	@Autowired
	private DataDao dataDao;
	@Autowired
	private ReportDao reportDao;
	@Autowired
	private OpposizioneDao opposizioneDao;
	@Autowired
	private OperazioneDao operazioneDao;
	@Autowired
	private TemaDao temaDao;
	public void lanciaScheduler(String nome) {

		if(nome.equals(ConstantsMap.email_giorno_appuntamenti_pdf_admin)) {		
			emailAppuntamentiPDFAdmin(ConstantsGlobal.giornaliero);	
		}
		if(nome.equals(ConstantsMap.email_giorno_appuntamenti_pdf_agente)) {		
			emailAppuntamentiPDFAgente(ConstantsGlobal.giornaliero);	
		}
		if(nome.equals(ConstantsMap.email_giorno_appuntamenti_xls_admin)) {		
			emailAppuntamentiXLSAdmin(ConstantsGlobal.giornaliero);	
		}
		if(nome.equals(ConstantsMap.email_giorno_appuntamenti_xls_agente)) {	
			emailAppuntamentiXLSAgente(ConstantsGlobal.giornaliero);		
		}
		if(nome.equals(ConstantsMap.email_giorno_appuntamenti_anagrafica)) {	
			emailReportAppuntamentiAnagrafica(ConstantsGlobal.giornaliero);		
		}
		if(nome.equals(ConstantsMap.email_giorno_calendar_anagrafica)) {	
			emailReportCalendarAnagrafica(ConstantsGlobal.giornaliero);		
		}
		if(nome.equals(ConstantsMap.email_giorno_anagrafiche_pdf)) {	
			emailAnagrafichePDF(ConstantsGlobal.giornaliero);	
		}
		if(nome.equals(ConstantsMap.email_giorno_anagrafiche_xls)) {	
			emailAnagraficheXLS(ConstantsGlobal.giornaliero);	
		}
		if(nome.equals(ConstantsMap.email_giorno_contratti_pdf_admin)) {	
			emailContrattiPDFAdmin(ConstantsGlobal.giornaliero);	
		}
		if(nome.equals(ConstantsMap.email_giorno_contratti_pdf_agente)) {		
			emailContrattiPDFAgente(ConstantsGlobal.giornaliero);
		}
		if(nome.equals(ConstantsMap.email_giorno_contratti_xls_admin)) {
			emailContrattiXLSAdmin(ConstantsGlobal.giornaliero);		
		}
		if(nome.equals(ConstantsMap.email_giorno_contratti_xls_agente)) {
			emailContrattiXLSAgente(ConstantsGlobal.giornaliero);		
		}
		if(nome.equals(ConstantsMap.email_giorno_contratti_anagrafica)) {
			emailReportContrattiAnagrafica(ConstantsGlobal.giornaliero);		
		}
		if(nome.equals(ConstantsMap.email_giorno_generale)) {
			emailGenerale(ConstantsGlobal.giornaliero);		
		}
		if(nome.equals(ConstantsMap.email_giorno_generale_storia)) {
			emailGeneraleStoria(ConstantsGlobal.giornaliero);		
		}
		if(nome.equals(ConstantsMap.email_giorno_lavorato)) {
			emailLavorato(ConstantsGlobal.giornaliero);		
		}
		if(nome.equals(ConstantsMap.email_giorno_lista)) {
			emailLista(ConstantsGlobal.giornaliero);		
		}
		if(nome.equals(ConstantsMap.email_giorno_lista_storia)) {
			emailListaStoria(ConstantsGlobal.giornaliero);		
		}
		if(nome.equals(ConstantsMap.email_giorno_liste)) {
			emailReportListaEsito(ConstantsGlobal.giornaliero);		
		}
		if(nome.equals(ConstantsMap.email_giorno_liste_storia)) {
			emailReportListaEsitoStoria(ConstantsGlobal.giornaliero);		
		}
		if(nome.equals(ConstantsMap.email_giorno_marcature_pdf)) {
			emailMarcaturePDF(ConstantsGlobal.giornaliero);		
		}
		if(nome.equals(ConstantsMap.email_giorno_marcature_xls)) {
			emailMarcatureXLS(ConstantsGlobal.giornaliero);		
		}
		if(nome.equals(ConstantsMap.email_giorno_accessi_pdf)) {
			emailAccessiPDF(ConstantsGlobal.giornaliero);		
		}
		if(nome.equals(ConstantsMap.email_giorno_accessi_xls)) {
			emailAccessiXLS(ConstantsGlobal.giornaliero);		
		}
		if(nome.equals(ConstantsMap.email_giorno_note_pdf_admin)) {
			emailNotePDFAdmin(ConstantsGlobal.giornaliero);		
		}
		if(nome.equals(ConstantsMap.email_giorno_note_pdf_agente)) {
			emailNotePDFAgente(ConstantsGlobal.giornaliero);		
		}
		if(nome.equals(ConstantsMap.email_giorno_note_xls_admin)) {
			emailNoteXLSAdmin(ConstantsGlobal.giornaliero);		
		}
		if(nome.equals(ConstantsMap.email_giorno_note_xls_agente)) {
			emailNoteXLSAgente(ConstantsGlobal.giornaliero);		
		}
		if(nome.equals(ConstantsMap.email_giorno_operatore)) {
			emailReportOperatore(ConstantsGlobal.giornaliero);		
		}
		if(nome.equals(ConstantsMap.email_giorno_operatore_storia)) {
			emailReportOperatoreStoria(ConstantsGlobal.giornaliero);		
		}
		if(nome.equals(ConstantsMap.email_giorno_operazioni_pdf)) {
			emailOperazioniPDF(ConstantsGlobal.giornaliero);		
		}
		if(nome.equals(ConstantsMap.email_giorno_operazioni_xls)) {
			emailOperazioniXLS(ConstantsGlobal.giornaliero);		
		}
		if(nome.equals(ConstantsMap.email_giorno_operazioni_xls)) {
			emailOperazioniXLS(ConstantsGlobal.giornaliero);		
		}
		if(nome.equals(ConstantsMap.email_giorno_pause_pdf)) {
			emailPausePDF(ConstantsGlobal.giornaliero);		
		}
		if(nome.equals(ConstantsMap.email_giorno_pause_xls)) {
			emailPauseXLS(ConstantsGlobal.giornaliero);		
		}
		if(nome.equals(ConstantsMap.email_giorno_prenotazioni_pdf_admin)) {
			emailPrenotazioniPDFAdmin(ConstantsGlobal.giornaliero);		
		}
		if(nome.equals(ConstantsMap.email_giorno_prenotazioni_pdf_agente)) {
			emailPrenotazioniPDFAgente(ConstantsGlobal.giornaliero);		
		}
		if(nome.equals(ConstantsMap.email_giorno_prenotazioni_xls_admin)) {
			emailPrenotazioniXLSAdmin(ConstantsGlobal.giornaliero);		
		}
		if(nome.equals(ConstantsMap.email_giorno_prenotazioni_xls_agente)) {
			emailPrenotazioniXLSAgente(ConstantsGlobal.giornaliero);		
		}
		if(nome.equals(ConstantsMap.email_giorno_storia_appuntamento_pdf)) {
			emailStoriaAppuntamentoPDFAdmin(ConstantsGlobal.giornaliero);		
		}
		if(nome.equals(ConstantsMap.email_giorno_storia_appuntamento_xls)) {
			emailStoriaAppuntamentoXLSAdmin(ConstantsGlobal.giornaliero);		
		}
		if(nome.equals(ConstantsMap.email_giorno_storia_contatto_pdf)) {
			emailStoriaContattoPDFAdmin(ConstantsGlobal.giornaliero);		
		}
		if(nome.equals(ConstantsMap.email_giorno_storia_contatto_xls)) {
			emailStoriaContattoXLSAdmin(ConstantsGlobal.giornaliero);		
		}
		if(nome.equals(ConstantsMap.email_giorno_storia_contratto_pdf)) {
			emailStoriaContrattoPDFAdmin(ConstantsGlobal.giornaliero);		
		}
		if(nome.equals(ConstantsMap.email_giorno_storia_contratto_xls)) {
			emailStoriaContrattoXLSAdmin(ConstantsGlobal.giornaliero);		
		}

		if(nome.equals(ConstantsMap.email_mese_appuntamenti_pdf_admin)) {
			emailAppuntamentiPDFAdmin(ConstantsGlobal.mensile);		
		}
		if(nome.equals(ConstantsMap.email_mese_appuntamenti_pdf_agente)) {
			emailAppuntamentiPDFAgente(ConstantsGlobal.mensile);		
		}
		if(nome.equals(ConstantsMap.email_mese_appuntamenti_xls_admin)) {
			emailAppuntamentiXLSAdmin(ConstantsGlobal.mensile);		
		}
		if(nome.equals(ConstantsMap.email_mese_appuntamenti_xls_agente)) {
			emailAppuntamentiXLSAgente(ConstantsGlobal.mensile);		
		}
		if(nome.equals(ConstantsMap.email_mese_appuntamenti_anagrafica)) {	
			emailReportAppuntamentiAnagrafica(ConstantsGlobal.mensile);		
		}
		if(nome.equals(ConstantsMap.email_mese_calendar_anagrafica)) {	
			emailReportCalendarAnagrafica(ConstantsGlobal.mensile);		
		}
		if(nome.equals(ConstantsMap.email_mese_anagrafiche_pdf)) {	
			emailAnagrafichePDF(ConstantsGlobal.mensile);	
		}
		if(nome.equals(ConstantsMap.email_mese_anagrafiche_xls)) {	
			emailAnagraficheXLS(ConstantsGlobal.mensile);	
		}
		if(nome.equals(ConstantsMap.email_mese_contratti_pdf_admin)) {
			emailContrattiPDFAdmin(ConstantsGlobal.mensile);		
		}
		if(nome.equals(ConstantsMap.email_mese_contratti_pdf_agente)) {
			emailContrattiPDFAgente(ConstantsGlobal.mensile);		
		}
		if(nome.equals(ConstantsMap.email_mese_contratti_xls_admin)) {
			emailContrattiXLSAdmin(ConstantsGlobal.mensile);		
		}
		if(nome.equals(ConstantsMap.email_mese_contratti_xls_agente)) {
			emailContrattiXLSAgente(ConstantsGlobal.mensile);		
		}
		if(nome.equals(ConstantsMap.email_mese_contratti_anagrafica)) {
			emailReportContrattiAnagrafica(ConstantsGlobal.mensile);		
		}
		if(nome.equals(ConstantsMap.email_mese_generale)) {
			emailGenerale(ConstantsGlobal.mensile);		
		}
		if(nome.equals(ConstantsMap.email_mese_generale_storia)) {
			emailGeneraleStoria(ConstantsGlobal.mensile);		
		}
		if(nome.equals(ConstantsMap.email_mese_lavorato)) {
			emailLavorato(ConstantsGlobal.mensile);		
		}
		if(nome.equals(ConstantsMap.email_mese_lista)) {
			emailLista(ConstantsGlobal.mensile);		
		}
		if(nome.equals(ConstantsMap.email_mese_lista_storia)) {
			emailListaStoria(ConstantsGlobal.mensile);		
		}
		if(nome.equals(ConstantsMap.email_mese_liste)) {
			emailReportListaEsito(ConstantsGlobal.mensile);		
		}
		if(nome.equals(ConstantsMap.email_mese_liste_storia)) {
			emailReportListaEsitoStoria(ConstantsGlobal.mensile);		
		}
		if(nome.equals(ConstantsMap.email_mese_marcature_pdf)) {
			emailMarcaturePDF(ConstantsGlobal.mensile);		
		}
		if(nome.equals(ConstantsMap.email_mese_marcature_xls)) {
			emailMarcatureXLS(ConstantsGlobal.mensile);		
		}
		if(nome.equals(ConstantsMap.email_mese_accessi_pdf)) {
			emailAccessiPDF(ConstantsGlobal.mensile);		
		}
		if(nome.equals(ConstantsMap.email_mese_accessi_xls)) {
			emailAccessiXLS(ConstantsGlobal.mensile);		
		}
		if(nome.equals(ConstantsMap.email_mese_note_pdf_admin)) {
			emailNotePDFAdmin(ConstantsGlobal.mensile);		
		}
		if(nome.equals(ConstantsMap.email_mese_note_pdf_agente)) {
			emailNotePDFAgente(ConstantsGlobal.mensile);		
		}
		if(nome.equals(ConstantsMap.email_mese_note_xls_admin)) {
			emailNoteXLSAdmin(ConstantsGlobal.mensile);		
		}
		if(nome.equals(ConstantsMap.email_mese_note_xls_agente)) {
			emailNoteXLSAgente(ConstantsGlobal.mensile);		
		}
		if(nome.equals(ConstantsMap.email_mese_operatore)) {
			emailReportOperatore(ConstantsGlobal.mensile);		
		}
		if(nome.equals(ConstantsMap.email_mese_operatore_storia)) {
			emailReportOperatoreStoria(ConstantsGlobal.mensile);		
		}
		if(nome.equals(ConstantsMap.email_mese_operazioni_pdf)) {
			emailOperazioniPDF(ConstantsGlobal.mensile);		
		}
		if(nome.equals(ConstantsMap.email_mese_operazioni_xls)) {
			emailOperazioniXLS(ConstantsGlobal.mensile);		
		}
		if(nome.equals(ConstantsMap.email_mese_operazioni_xls)) {
			emailOperazioniXLS(ConstantsGlobal.mensile);		
		}
		if(nome.equals(ConstantsMap.email_mese_pause_pdf)) {
			emailPausePDF(ConstantsGlobal.mensile);		
		}
		if(nome.equals(ConstantsMap.email_mese_pause_xls)) {
			emailPauseXLS(ConstantsGlobal.mensile);		
		}
		if(nome.equals(ConstantsMap.email_mese_prenotazioni_pdf_admin)) {
			emailPrenotazioniPDFAdmin(ConstantsGlobal.mensile);		
		}
		if(nome.equals(ConstantsMap.email_mese_prenotazioni_pdf_agente)) {
			emailPrenotazioniPDFAgente(ConstantsGlobal.mensile);		
		}
		if(nome.equals(ConstantsMap.email_mese_prenotazioni_xls_admin)) {
			emailPrenotazioniXLSAdmin(ConstantsGlobal.mensile);		
		}
		if(nome.equals(ConstantsMap.email_mese_prenotazioni_xls_agente)) {
			emailPrenotazioniXLSAgente(ConstantsGlobal.mensile);		
		}
		if(nome.equals(ConstantsMap.email_mese_storia_appuntamento_pdf)) {
			emailStoriaAppuntamentoPDFAdmin(ConstantsGlobal.mensile);		
		}
		if(nome.equals(ConstantsMap.email_mese_storia_appuntamento_xls)) {
			emailStoriaAppuntamentoXLSAdmin(ConstantsGlobal.mensile);		
		}
		if(nome.equals(ConstantsMap.email_mese_storia_contatto_pdf)) {
			emailStoriaContattoPDFAdmin(ConstantsGlobal.mensile);		
		}
		if(nome.equals(ConstantsMap.email_mese_storia_contatto_xls)) {
			emailStoriaContattoXLSAdmin(ConstantsGlobal.mensile);		
		}
		if(nome.equals(ConstantsMap.email_mese_storia_contratto_pdf)) {
			emailStoriaContrattoPDFAdmin(ConstantsGlobal.mensile);		
		}
		if(nome.equals(ConstantsMap.email_mese_storia_contratto_xls)) {
			emailStoriaContrattoXLSAdmin(ConstantsGlobal.mensile);		
		}

		if(nome.equals(ConstantsMap.email_settimana_appuntamenti_pdf_admin)) {
			emailAppuntamentiPDFAdmin(ConstantsGlobal.settimanale);		
		}
		if(nome.equals(ConstantsMap.email_settimana_appuntamenti_pdf_agente)) {
			emailAppuntamentiPDFAgente(ConstantsGlobal.settimanale);		
		}
		if(nome.equals(ConstantsMap.email_giorno_team)) {
			emailContattiOdierniOperatoriTeam(ConstantsGlobal.giornaliero);		
		}
		if(nome.equals(ConstantsMap.email_giorno_zona)) {
			emailContattiOdierniOperatoriZona(ConstantsGlobal.giornaliero);		
		}
		if(nome.equals(ConstantsMap.email_mese_team)) {
			emailContattiOdierniOperatoriTeam(ConstantsGlobal.mensile);		
		}
		if(nome.equals(ConstantsMap.email_mese_zona)) {
			emailContattiOdierniOperatoriZona(ConstantsGlobal.mensile);		
		}
		if(nome.equals(ConstantsMap.email_settimana_appuntamenti_xls_admin)) {
			emailAppuntamentiXLSAdmin(ConstantsGlobal.settimanale);		
		}
		if(nome.equals(ConstantsMap.email_settimana_appuntamenti_xls_agente)) {
			emailAppuntamentiXLSAgente(ConstantsGlobal.settimanale);		
		}
		if(nome.equals(ConstantsMap.email_settimana_appuntamenti_anagrafica)) {	
			emailReportAppuntamentiAnagrafica(ConstantsGlobal.settimanale);		
		}
		if(nome.equals(ConstantsMap.email_settimana_calendar_anagrafica)) {	
			emailReportCalendarAnagrafica(ConstantsGlobal.settimanale);		
		}
		if(nome.equals(ConstantsMap.email_settimana_anagrafiche_pdf)) {	
			emailAnagrafichePDF(ConstantsGlobal.settimanale);	
		}
		if(nome.equals(ConstantsMap.email_settimana_anagrafiche_xls)) {	
			emailAnagraficheXLS(ConstantsGlobal.settimanale);	
		}
		if(nome.equals(ConstantsMap.email_settimana_contratti_pdf_admin)) {
			emailContrattiPDFAdmin(ConstantsGlobal.settimanale);		
		}
		if(nome.equals(ConstantsMap.email_settimana_contratti_pdf_agente)) {
			emailContrattiPDFAgente(ConstantsGlobal.settimanale);		
		}
		if(nome.equals(ConstantsMap.email_anno_contratti_storia)) {
			emailContattiOdierniContrattiStoria(ConstantsGlobal.annuale);		
		}
		if(nome.equals(ConstantsMap.email_anno_appuntamenti)) {
			emailContattiOdierniAppuntamenti(ConstantsGlobal.annuale);		
		}
		if(nome.equals(ConstantsMap.email_anno_appuntamenti_storia)) {
			emailContattiOdierniAppuntamentiStoria(ConstantsGlobal.annuale);		
		}
		if(nome.equals(ConstantsMap.email_anno_contratti)) {
			emailContattiOdierniContratti(ConstantsGlobal.annuale);		
		}
		if(nome.equals(ConstantsMap.email_giorno_appuntamenti)) {		
			emailContattiOdierniAppuntamenti(ConstantsGlobal.giornaliero);		
		}
		if(nome.equals(ConstantsMap.email_giorno_appuntamenti_storia)) {		
			emailContattiOdierniAppuntamentiStoria(ConstantsGlobal.giornaliero);		
		}
		if(nome.equals(ConstantsMap.email_giorno_contratti)) {		
			emailContattiOdierniContratti(ConstantsGlobal.giornaliero);	
		}
		if(nome.equals(ConstantsMap.email_giorno_contratti_storia)) {
			emailContattiOdierniContrattiStoria(ConstantsGlobal.giornaliero);		
		}
		if(nome.equals(ConstantsMap.email_mese_appuntamenti)) {
			emailContattiOdierniAppuntamenti(ConstantsGlobal.mensile);		
		}
		if(nome.equals(ConstantsMap.email_mese_appuntamenti_storia)) {
			emailContattiOdierniAppuntamentiStoria(ConstantsGlobal.mensile);		
		}
		if(nome.equals(ConstantsMap.email_mese_contratti)) {
			emailContattiOdierniContratti(ConstantsGlobal.mensile);		
		}
		if(nome.equals(ConstantsMap.email_mese_contratti_storia)) {
			emailContattiOdierniContrattiStoria(ConstantsGlobal.mensile);		
		}
		if(nome.equals(ConstantsMap.email_settimana_appuntamenti)) {
			emailContattiOdierniAppuntamenti(ConstantsGlobal.settimanale);		
		}
		if(nome.equals(ConstantsMap.email_settimana_appuntamenti_storia)) {
			emailContattiOdierniAppuntamentiStoria(ConstantsGlobal.settimanale);		
		}
		if(nome.equals(ConstantsMap.email_settimana_contratti)) {
			emailContattiOdierniContratti(ConstantsGlobal.settimanale);		
		}
		if(nome.equals(ConstantsMap.email_settimana_contratti_storia)) {
			emailContattiOdierniContrattiStoria(ConstantsGlobal.settimanale);		
		}
		if(nome.equals(ConstantsMap.email_anno_contrattiC_storia)) {
			emailContattiOdierniContrattiCStoria(ConstantsGlobal.annuale);		
		}
		if(nome.equals(ConstantsMap.email_anno_appuntamentiC)) {
			emailContattiOdierniAppuntamentiC(ConstantsGlobal.annuale);		
		}
		if(nome.equals(ConstantsMap.email_anno_appuntamentiC_storia)) {
			emailContattiOdierniAppuntamentiCStoria(ConstantsGlobal.annuale);		
		}
		if(nome.equals(ConstantsMap.email_anno_contrattiC)) {
			emailContattiOdierniContrattiC(ConstantsGlobal.annuale);		
		}
		if(nome.equals(ConstantsMap.email_giorno_appuntamentiC)) {		
			emailContattiOdierniAppuntamentiC(ConstantsGlobal.giornaliero);		
		}
		if(nome.equals(ConstantsMap.email_giorno_appuntamentiC_storia)) {		
			emailContattiOdierniAppuntamentiCStoria(ConstantsGlobal.giornaliero);		
		}
		if(nome.equals(ConstantsMap.email_giorno_contrattiC)) {		
			emailContattiOdierniContrattiC(ConstantsGlobal.giornaliero);	
		}
		if(nome.equals(ConstantsMap.email_giorno_contrattiC_storia)) {
			emailContattiOdierniContrattiCStoria(ConstantsGlobal.giornaliero);		
		}
		if(nome.equals(ConstantsMap.email_mese_appuntamentiC)) {
			emailContattiOdierniAppuntamentiC(ConstantsGlobal.mensile);		
		}
		if(nome.equals(ConstantsMap.email_mese_appuntamentiC_storia)) {
			emailContattiOdierniAppuntamentiCStoria(ConstantsGlobal.mensile);		
		}
		if(nome.equals(ConstantsMap.email_mese_contrattiC)) {
			emailContattiOdierniContrattiC(ConstantsGlobal.mensile);		
		}
		if(nome.equals(ConstantsMap.email_mese_contrattiC_storia)) {
			emailContattiOdierniContrattiCStoria(ConstantsGlobal.mensile);		
		}
		if(nome.equals(ConstantsMap.email_settimana_appuntamentiC)) {
			emailContattiOdierniAppuntamentiC(ConstantsGlobal.settimanale);		
		}
		if(nome.equals(ConstantsMap.email_settimana_appuntamentiC_storia)) {
			emailContattiOdierniAppuntamentiCStoria(ConstantsGlobal.settimanale);		
		}
		if(nome.equals(ConstantsMap.email_settimana_contrattiC)) {
			emailContattiOdierniContrattiC(ConstantsGlobal.settimanale);		
		}
		if(nome.equals(ConstantsMap.email_settimana_contrattiC_storia)) {
			emailContattiOdierniContrattiCStoria(ConstantsGlobal.settimanale);		
		}
		if(nome.equals(ConstantsMap.email_settimana_contratti_xls_admin)) {
			emailContrattiXLSAdmin(ConstantsGlobal.settimanale);		
		}
		if(nome.equals(ConstantsMap.email_settimana_contratti_xls_agente)) {
			emailContrattiXLSAgente(ConstantsGlobal.settimanale);		
		}
		if(nome.equals(ConstantsMap.email_settimana_contratti_anagrafica)) {
			emailReportContrattiAnagrafica(ConstantsGlobal.settimanale);		
		}
		if(nome.equals(ConstantsMap.email_settimana_generale)) {
			emailGenerale(ConstantsGlobal.settimanale);		
		}
		if(nome.equals(ConstantsMap.email_settimana_generale_storia)) {
			emailGeneraleStoria(ConstantsGlobal.settimanale);		
		}
		if(nome.equals(ConstantsMap.email_settimana_lavorato)) {
			emailLavorato(ConstantsGlobal.settimanale);		
		}
		if(nome.equals(ConstantsMap.email_settimana_lista)) {
			emailLista(ConstantsGlobal.settimanale);		
		}
		if(nome.equals(ConstantsMap.email_settimana_lista_storia)) {
			emailListaStoria(ConstantsGlobal.settimanale);		
		}
		if(nome.equals(ConstantsMap.email_settimana_liste)) {
			emailReportListaEsito(ConstantsGlobal.settimanale);		
		}
		if(nome.equals(ConstantsMap.email_settimana_liste_storia)) {
			emailReportListaEsitoStoria(ConstantsGlobal.settimanale);		
		}
		if(nome.equals(ConstantsMap.email_settimana_marcature_pdf)) {
			emailMarcaturePDF(ConstantsGlobal.settimanale);		
		}
		if(nome.equals(ConstantsMap.email_settimana_marcature_xls)) {
			emailMarcatureXLS(ConstantsGlobal.settimanale);		
		}
		if(nome.equals(ConstantsMap.email_settimana_accessi_pdf)) {
			emailAccessiPDF(ConstantsGlobal.settimanale);		
		}
		if(nome.equals(ConstantsMap.email_settimana_accessi_xls)) {
			emailAccessiXLS(ConstantsGlobal.settimanale);		
		}
		if(nome.equals(ConstantsMap.email_settimana_note_pdf_admin)) {
			emailNotePDFAdmin(ConstantsGlobal.settimanale);		
		}
		if(nome.equals(ConstantsMap.email_settimana_note_pdf_agente)) {
			emailNotePDFAgente(ConstantsGlobal.settimanale);		
		}
		if(nome.equals(ConstantsMap.email_settimana_note_xls_admin)) {
			emailNoteXLSAdmin(ConstantsGlobal.settimanale);		
		}
		if(nome.equals(ConstantsMap.email_settimana_note_xls_agente)) {
			emailNoteXLSAgente(ConstantsGlobal.settimanale);		
		}
		if(nome.equals(ConstantsMap.email_settimana_operatore)) {
			emailReportOperatore(ConstantsGlobal.settimanale);		
		}
		if(nome.equals(ConstantsMap.email_settimana_operatore_storia)) {
			emailReportOperatoreStoria(ConstantsGlobal.settimanale);		
		}
		if(nome.equals(ConstantsMap.email_settimana_operazioni_pdf)) {
			emailOperazioniPDF(ConstantsGlobal.settimanale);		
		}
		if(nome.equals(ConstantsMap.email_settimana_operazioni_xls)) {
			emailOperazioniXLS(ConstantsGlobal.settimanale);		
		}
		if(nome.equals(ConstantsMap.email_settimana_operazioni_xls)) {
			emailOperazioniXLS(ConstantsGlobal.settimanale);		
		}
		if(nome.equals(ConstantsMap.email_settimana_pause_pdf)) {
			emailPausePDF(ConstantsGlobal.settimanale);		
		}
		if(nome.equals(ConstantsMap.email_settimana_pause_xls)) {
			emailPauseXLS(ConstantsGlobal.settimanale);		
		}
		if(nome.equals(ConstantsMap.email_settimana_prenotazioni_pdf_admin)) {
			emailPrenotazioniPDFAdmin(ConstantsGlobal.settimanale);		
		}
		if(nome.equals(ConstantsMap.email_settimana_prenotazioni_pdf_agente)) {
			emailPrenotazioniPDFAgente(ConstantsGlobal.settimanale);		
		}
		if(nome.equals(ConstantsMap.email_settimana_prenotazioni_xls_admin)) {
			emailPrenotazioniXLSAdmin(ConstantsGlobal.settimanale);		
		}
		if(nome.equals(ConstantsMap.email_settimana_prenotazioni_xls_agente)) {
			emailPrenotazioniXLSAgente(ConstantsGlobal.settimanale);		
		}
		if(nome.equals(ConstantsMap.email_settimana_storia_appuntamento_pdf)) {
			emailStoriaAppuntamentoPDFAdmin(ConstantsGlobal.settimanale);		
		}
		if(nome.equals(ConstantsMap.email_settimana_storia_appuntamento_xls)) {
			emailStoriaAppuntamentoXLSAdmin(ConstantsGlobal.settimanale);		
		}
		if(nome.equals(ConstantsMap.email_settimana_storia_contatto_pdf)) {
			emailStoriaContattoPDFAdmin(ConstantsGlobal.settimanale);		
		}
		if(nome.equals(ConstantsMap.email_settimana_storia_contatto_xls)) {
			emailStoriaContattoXLSAdmin(ConstantsGlobal.settimanale);		
		}
		if(nome.equals(ConstantsMap.email_settimana_storia_contratto_pdf)) {
			emailStoriaContrattoPDFAdmin(ConstantsGlobal.settimanale);		
		}
		if(nome.equals(ConstantsMap.email_settimana_storia_contratto_xls)) {
			emailStoriaContrattoXLSAdmin(ConstantsGlobal.settimanale);		
		}
		if(nome.equals(ConstantsMap.email_settimana_team)) {
			emailContattiOdierniOperatoriTeam(ConstantsGlobal.settimanale);		
		}
		if(nome.equals(ConstantsMap.email_settimana_zona)) {
			emailContattiOdierniOperatoriZona(ConstantsGlobal.settimanale);		
		}

		if(nome.equals(ConstantsMap.email_anno_appuntamenti_pdf_admin)) {
			emailAppuntamentiPDFAdmin(ConstantsGlobal.annuale);		
		}
		if(nome.equals(ConstantsMap.email_anno_appuntamenti_pdf_agente)) {
			emailAppuntamentiPDFAgente(ConstantsGlobal.annuale);		
		}
		if(nome.equals(ConstantsMap.email_anno_appuntamenti_xls_admin)) {
			emailAppuntamentiXLSAdmin(ConstantsGlobal.annuale);		
		}
		if(nome.equals(ConstantsMap.email_anno_appuntamenti_xls_agente)) {
			emailAppuntamentiXLSAgente(ConstantsGlobal.annuale);		
		}
		if(nome.equals(ConstantsMap.email_anno_appuntamenti_anagrafica)) {	
			emailReportAppuntamentiAnagrafica(ConstantsGlobal.annuale);		
		}
		if(nome.equals(ConstantsMap.email_anno_calendar_anagrafica)) {	
			emailReportCalendarAnagrafica(ConstantsGlobal.annuale);		
		}
		if(nome.equals(ConstantsMap.email_anno_anagrafiche_pdf)) {	
			emailAnagrafichePDF(ConstantsGlobal.annuale);	
		}
		if(nome.equals(ConstantsMap.email_anno_anagrafiche_xls)) {	
			emailAnagraficheXLS(ConstantsGlobal.annuale);	
		}
		if(nome.equals(ConstantsMap.email_anno_contratti_pdf_admin)) {
			emailContrattiPDFAdmin(ConstantsGlobal.annuale);		
		}
		if(nome.equals(ConstantsMap.email_anno_contratti_pdf_agente)) {
			emailContrattiPDFAgente(ConstantsGlobal.annuale);		
		}
		if(nome.equals(ConstantsMap.email_anno_contratti_xls_admin)) {
			emailContrattiXLSAdmin(ConstantsGlobal.annuale);		
		}
		if(nome.equals(ConstantsMap.email_anno_contratti_xls_agente)) {
			emailContrattiXLSAgente(ConstantsGlobal.annuale);		
		}
		if(nome.equals(ConstantsMap.email_anno_contratti_anagrafica)) {
			emailReportContrattiAnagrafica(ConstantsGlobal.annuale);		
		}
		if(nome.equals(ConstantsMap.email_anno_generale)) {
			emailGenerale(ConstantsGlobal.annuale);		
		}
		if(nome.equals(ConstantsMap.email_anno_generale_storia)) {
			emailGeneraleStoria(ConstantsGlobal.annuale);		
		}
		if(nome.equals(ConstantsMap.email_anno_lavorato)) {
			emailLavorato(ConstantsGlobal.annuale);		
		}
		if(nome.equals(ConstantsMap.email_anno_lista)) {
			emailLista(ConstantsGlobal.annuale);		
		}
		if(nome.equals(ConstantsMap.email_anno_lista_storia)) {
			emailListaStoria(ConstantsGlobal.annuale);		
		}
		if(nome.equals(ConstantsMap.email_anno_liste)) {
			emailReportListaEsito(ConstantsGlobal.annuale);		
		}
		if(nome.equals(ConstantsMap.email_anno_liste_storia)) {
			emailReportListaEsitoStoria(ConstantsGlobal.annuale);		
		}
		if(nome.equals(ConstantsMap.email_anno_marcature_pdf)) {
			emailMarcaturePDF(ConstantsGlobal.annuale);		
		}
		if(nome.equals(ConstantsMap.email_anno_marcature_xls)) {
			emailMarcatureXLS(ConstantsGlobal.annuale);		
		}
		if(nome.equals(ConstantsMap.email_anno_accessi_pdf)) {
			emailAccessiPDF(ConstantsGlobal.annuale);		
		}
		if(nome.equals(ConstantsMap.email_anno_accessi_xls)) {
			emailAccessiXLS(ConstantsGlobal.annuale);		
		}
		if(nome.equals(ConstantsMap.email_anno_note_pdf_admin)) {
			emailNotePDFAdmin(ConstantsGlobal.annuale);		
		}
		if(nome.equals(ConstantsMap.email_anno_note_pdf_agente)) {
			emailNotePDFAgente(ConstantsGlobal.annuale);		
		}
		if(nome.equals(ConstantsMap.email_anno_note_xls_admin)) {
			emailNoteXLSAdmin(ConstantsGlobal.annuale);		
		}
		if(nome.equals(ConstantsMap.email_anno_note_xls_agente)) {
			emailNoteXLSAgente(ConstantsGlobal.annuale);		
		}
		if(nome.equals(ConstantsMap.email_anno_operatore)) {
			emailReportOperatore(ConstantsGlobal.annuale);		
		}
		if(nome.equals(ConstantsMap.email_anno_operatore_storia)) {
			emailReportOperatoreStoria(ConstantsGlobal.annuale);		
		}
		if(nome.equals(ConstantsMap.email_anno_operazioni_pdf)) {
			emailOperazioniPDF(ConstantsGlobal.annuale);		
		}
		if(nome.equals(ConstantsMap.email_anno_operazioni_xls)) {
			emailOperazioniXLS(ConstantsGlobal.annuale);		
		}
		if(nome.equals(ConstantsMap.email_anno_operazioni_xls)) {
			emailOperazioniXLS(ConstantsGlobal.annuale);		
		}
		if(nome.equals(ConstantsMap.email_anno_pause_pdf)) {
			emailPausePDF(ConstantsGlobal.annuale);		
		}
		if(nome.equals(ConstantsMap.email_anno_pause_xls)) {
			emailPauseXLS(ConstantsGlobal.annuale);		
		}
		if(nome.equals(ConstantsMap.email_anno_prenotazioni_pdf_admin)) {
			emailPrenotazioniPDFAdmin(ConstantsGlobal.annuale);		
		}
		if(nome.equals(ConstantsMap.email_anno_prenotazioni_pdf_agente)) {
			emailPrenotazioniPDFAgente(ConstantsGlobal.annuale);		
		}
		if(nome.equals(ConstantsMap.email_anno_prenotazioni_xls_admin)) {
			emailPrenotazioniXLSAdmin(ConstantsGlobal.annuale);		
		}
		if(nome.equals(ConstantsMap.email_anno_prenotazioni_xls_agente)) {
			emailPrenotazioniXLSAgente(ConstantsGlobal.annuale);		
		}
		if(nome.equals(ConstantsMap.email_anno_storia_appuntamento_pdf)) {
			emailStoriaAppuntamentoPDFAdmin(ConstantsGlobal.annuale);		
		}
		if(nome.equals(ConstantsMap.email_anno_storia_appuntamento_xls)) {
			emailStoriaAppuntamentoXLSAdmin(ConstantsGlobal.annuale);		
		}
		if(nome.equals(ConstantsMap.email_anno_storia_contatto_pdf)) {
			emailStoriaContattoPDFAdmin(ConstantsGlobal.annuale);		
		}
		if(nome.equals(ConstantsMap.email_anno_storia_contatto_xls)) {
			emailStoriaContattoXLSAdmin(ConstantsGlobal.annuale);		
		}
		if(nome.equals(ConstantsMap.email_anno_storia_contratto_pdf)) {
			emailStoriaContrattoPDFAdmin(ConstantsGlobal.annuale);		
		}
		if(nome.equals(ConstantsMap.email_anno_storia_contratto_xls)) {
			emailStoriaContrattoXLSAdmin(ConstantsGlobal.annuale);		
		}
		if(nome.equals(ConstantsMap.email_anno_team)) {
			emailContattiOdierniOperatoriTeam(ConstantsGlobal.annuale);		
		}
		if(nome.equals(ConstantsMap.email_anno_zona)) {
			emailContattiOdierniOperatoriZona(ConstantsGlobal.annuale);		
		}
		if(nome.equals(ConstantsMap.invia_mail_prossimi_giorno_appuntamenti_scheda_agente)) {
			emailReportAppuntamentiAgenteScheda(ConstantsGlobal.giornaliero); 		
		}
		if(nome.equals(ConstantsMap.invia_mail_prossimi_giorno_appuntamenti_scheda_admin)) {
			emailReportAppuntamentiManagerScheda(ConstantsGlobal.giornaliero);		
		}
		if(nome.equals(ConstantsMap.invia_mail_prossimi_giorno_appuntamenti_concatena_agente)) {
			emailReportAppuntamentiAgenteConcatena(ConstantsGlobal.giornaliero); 		
		}
		if(nome.equals(ConstantsMap.invia_mail_prossimi_giorno_appuntamenti_concatena_admin)) {
			emailReportAppuntamentiManagerConcatena(ConstantsGlobal.giornaliero);		
		}
		if(nome.equals(ConstantsMap.invia_mail_prossimi_giorno_appuntamenti_xls_agente)) {
			emailReportAppuntamentiAgenteExcel(ConstantsGlobal.giornaliero);		
		}
		if(nome.equals(ConstantsMap.invia_mail_prossimi_giorno_appuntamenti_xls_admin)) {
			emailReportAppuntamentiManagerExcel(ConstantsGlobal.giornaliero);		
		}
		if(nome.equals(ConstantsMap.invia_mail_prossimi_giorno_appuntamenti_pdf_agente)) {
			emailReportAppuntamentiAgentePdf(ConstantsGlobal.giornaliero);		
		}
		if(nome.equals(ConstantsMap.invia_mail_prossimi_giorno_appuntamenti_pdf_admin)) {
			emailReportAppuntamentiManagerPdf(ConstantsGlobal.giornaliero);		
		}
		if(nome.equals(ConstantsMap.invia_mail_prossimi_giorno_appuntamenti_anagrafica)) {
			emailReportAppuntamentiProssimiAnagrafica(ConstantsGlobal.giornaliero);		
		}
		if(nome.equals(ConstantsMap.invia_mail_prossimi_giorno_calendar_anagrafica)) {
			emailReportCalendarProssimiAnagrafica(ConstantsGlobal.giornaliero);		
		}
		if(nome.equals(ConstantsMap.invia_mail_prossimi_mese_appuntamenti_scheda_agente)) {
			emailReportAppuntamentiAgenteScheda(ConstantsGlobal.mensile); 		
		}
		if(nome.equals(ConstantsMap.invia_mail_prossimi_mese_appuntamenti_scheda_admin)) {
			emailReportAppuntamentiManagerScheda(ConstantsGlobal.mensile);		
		}
		if(nome.equals(ConstantsMap.invia_mail_prossimi_mese_appuntamenti_concatena_agente)) {
			emailReportAppuntamentiAgenteConcatena(ConstantsGlobal.mensile); 		
		}
		if(nome.equals(ConstantsMap.invia_mail_prossimi_mese_appuntamenti_concatena_admin)) {
			emailReportAppuntamentiManagerConcatena(ConstantsGlobal.mensile);		
		}
		if(nome.equals(ConstantsMap.invia_mail_prossimi_mese_appuntamenti_xls_agente)) {
			emailReportAppuntamentiAgenteExcel(ConstantsGlobal.mensile);		
		}
		if(nome.equals(ConstantsMap.invia_mail_prossimi_mese_appuntamenti_xls_admin)) {
			emailReportAppuntamentiManagerExcel(ConstantsGlobal.mensile);		
		}
		if(nome.equals(ConstantsMap.invia_mail_prossimi_mese_appuntamenti_pdf_agente)) {
			emailReportAppuntamentiAgentePdf(ConstantsGlobal.mensile);		
		}
		if(nome.equals(ConstantsMap.invia_mail_prossimi_mese_appuntamenti_pdf_admin)) {
			emailReportAppuntamentiManagerPdf(ConstantsGlobal.mensile);		
		}
		if(nome.equals(ConstantsMap.invia_mail_prossimi_mese_appuntamenti_anagrafica)) {
			emailReportAppuntamentiProssimiAnagrafica(ConstantsGlobal.mensile);		
		}
		if(nome.equals(ConstantsMap.invia_mail_prossimi_mese_calendar_anagrafica)) {
			emailReportCalendarProssimiAnagrafica(ConstantsGlobal.mensile);		
		}
		if(nome.equals(ConstantsMap.invia_mail_prossimi_settimana_appuntamenti_scheda_agente)) {
			emailReportAppuntamentiAgenteScheda(ConstantsGlobal.settimanale); 		
		}
		if(nome.equals(ConstantsMap.invia_mail_prossimi_settimana_appuntamenti_scheda_admin)) {
			emailReportAppuntamentiManagerScheda(ConstantsGlobal.settimanale);		
		}
		if(nome.equals(ConstantsMap.invia_mail_prossimi_settimana_appuntamenti_concatena_agente)) {
			emailReportAppuntamentiAgenteConcatena(ConstantsGlobal.settimanale); 		
		}
		if(nome.equals(ConstantsMap.invia_mail_prossimi_settimana_appuntamenti_concatena_admin)) {
			emailReportAppuntamentiManagerConcatena(ConstantsGlobal.settimanale);		
		}
		if(nome.equals(ConstantsMap.invia_mail_prossimi_settimana_appuntamenti_xls_agente)) {
			emailReportAppuntamentiAgenteExcel(ConstantsGlobal.settimanale);		
		}
		if(nome.equals(ConstantsMap.invia_mail_prossimi_settimana_appuntamenti_xls_admin)) {
			emailReportAppuntamentiManagerExcel(ConstantsGlobal.settimanale);		
		}
		if(nome.equals(ConstantsMap.invia_mail_prossimi_settimana_appuntamenti_pdf_agente)) {
			emailReportAppuntamentiAgentePdf(ConstantsGlobal.settimanale);		
		}
		if(nome.equals(ConstantsMap.invia_mail_prossimi_settimana_appuntamenti_pdf_admin)) {
			emailReportAppuntamentiManagerPdf(ConstantsGlobal.settimanale);		
		}
		if(nome.equals(ConstantsMap.invia_mail_prossimi_settimana_appuntamenti_anagrafica)) {
			emailReportAppuntamentiProssimiAnagrafica(ConstantsGlobal.settimanale);		
		}
		if(nome.equals(ConstantsMap.invia_mail_prossimi_settimana_calendar_anagrafica)) {
			emailReportCalendarProssimiAnagrafica(ConstantsGlobal.settimanale);		
		}
		if(nome.equals(ConstantsMap.invia_mail_prossimi_anno_appuntamenti_scheda_agente)) {
			emailReportAppuntamentiAgenteScheda(ConstantsGlobal.annuale); 		
		}
		if(nome.equals(ConstantsMap.invia_mail_prossimi_anno_appuntamenti_scheda_admin)) {
			emailReportAppuntamentiManagerConcatena(ConstantsGlobal.annuale);		
		}
		if(nome.equals(ConstantsMap.invia_mail_prossimi_anno_appuntamenti_concatena_agente)) {
			emailReportAppuntamentiAgenteScheda(ConstantsGlobal.annuale); 		
		}
		if(nome.equals(ConstantsMap.invia_mail_prossimi_anno_appuntamenti_concatena_admin)) {
			emailReportAppuntamentiManagerConcatena(ConstantsGlobal.annuale);		
		}
		if(nome.equals(ConstantsMap.invia_mail_prossimi_anno_appuntamenti_xls_agente)) {
			emailReportAppuntamentiAgenteExcel(ConstantsGlobal.annuale);		
		}
		if(nome.equals(ConstantsMap.invia_mail_prossimi_anno_appuntamenti_xls_admin)) {
			emailReportAppuntamentiManagerExcel(ConstantsGlobal.annuale);		
		}
		if(nome.equals(ConstantsMap.invia_mail_prossimi_anno_appuntamenti_pdf_agente)) {
			emailReportAppuntamentiAgentePdf(ConstantsGlobal.annuale);		
		}
		if(nome.equals(ConstantsMap.invia_mail_prossimi_anno_appuntamenti_pdf_admin)) {
			emailReportAppuntamentiManagerPdf(ConstantsGlobal.annuale);		
		}
		if(nome.equals(ConstantsMap.invia_mail_prossimi_anno_appuntamenti_anagrafica)) {
			emailReportAppuntamentiProssimiAnagrafica(ConstantsGlobal.annuale);		
		}
		if(nome.equals(ConstantsMap.invia_mail_prossimi_anno_calendar_anagrafica)) {
			emailReportCalendarProssimiAnagrafica(ConstantsGlobal.annuale);		
		}
		if(nome.equals(ConstantsMap.invia_invoke_giorno)) {
			inviaInvoke(ConstantsGlobal.giornaliero);		
		}
		if(nome.equals(ConstantsMap.invia_invoke_mese)) {
			inviaInvoke(ConstantsGlobal.mensile);		
		}
		if(nome.equals(ConstantsMap.invia_invoke_settimana)) {
			inviaInvoke(ConstantsGlobal.settimanale);		
		}
		if(nome.equals(ConstantsMap.invia_invoke_anno)) {
			inviaInvoke(ConstantsGlobal.annuale);		
		}
		if(nome.equals(ConstantsMap.invia_mail_sistema_scadenza)) {
			inviaScadenza();
		}
		if(nome.equals(ConstantsMap.invia_mail_sistema_anomalia)) {
			inviaAnomalia();
		}
		if(nome.equals(ConstantsMap.genera_calendario_sistema)) {
			dataDao.ricaricaCalendar();
		}
		if(nome.equals(ConstantsMap.genera_pulizia_storage)) {
			sincronizzaStorage();
		}
		if(nome.equals(ConstantsMap.genera_pulizia_sistema)) {
			//ApplicationUtil.truncateFolder(ConstantsGlobal.path_tmp);
			dataDao.loadFW(true);
			operazioneDao.puliziaUtenti();
			autodialerDao.puliziaCampagne(true);
			ApplicationUtil.clean(true);
		}
		if(nome.equals(ConstantsMap.genera_pulizia_anagrafiche)) {
			//anagraficaDao.eliminaNotInCampagna(true);
			anagraficaDao.puliziaAnagrafiche();
		}
		if(nome.equals(ConstantsMap.genera_pulizia_liste)) {
			anagraficaDao.puliziaListe();
		}
		if(nome.equals(ConstantsMap.genera_pulizia_opposizioni)) {
			opposizioneDao.pulisciOpposizioni();
		}
		if(nome.equals(ConstantsMap.genera_elimina_pausa)) {
			Integer intervallo = impostazioneDao.intervalloPulizia();
			dataDao.deletePausa(intervallo);
		}
		if(nome.equals(ConstantsMap.genera_elimina_backup_import)) {
			Integer intervallo = impostazioneDao.intervalloPulizia();
			eliminaBackupImport(intervallo, ConstantsGlobal.path_backup_anagrafica);
			eliminaBackupImport(intervallo, ConstantsGlobal.path_backup_contatto);
			eliminaBackupImport(intervallo, ConstantsGlobal.path_backup_contratto);
			eliminaBackupImport(intervallo, ConstantsGlobal.path_backup_appuntamento);
			eliminaBackupImport(intervallo, ConstantsGlobal.path_backup_opposizione);
		}
		if(nome.equals(ConstantsMap.genera_elimina_backup_database)) {
			Integer intervallo = impostazioneDao.intervalloPulizia();
			eliminaBackupDatabase(intervallo);
		}
		if(nome.equals(ConstantsMap.genera_elimina_marcatura)) {		
			Integer intervallo = impostazioneDao.intervalloPulizia();
			dataDao.deleteMarcatura(intervallo);
		}
		if(nome.equals(ConstantsMap.genera_elimina_accesso)) {		
			Integer intervallo = impostazioneDao.intervalloPulizia();
			dataDao.deleteAccesso(intervallo);
		}
		if(nome.equals(ConstantsMap.genera_elimina_cdr)) {
			Integer intervallo = impostazioneDao.intervalloPulizia();
			dataDao.deleteCdr(intervallo);
		}
		if(nome.equals(ConstantsMap.genera_elimina_cel)) {		
			Integer intervallo = impostazioneDao.intervalloPulizia();
			dataDao.deleteCel(intervallo);
		}
		if(nome.equals(ConstantsMap.genera_elimina_autodialer)) {
			Integer intervallo = impostazioneDao.intervalloPulizia();
			dataDao.deleteAutoContatto(intervallo);
		}
		if(nome.equals(ConstantsMap.genera_elimina_comunicazione)) {
			Integer intervallo = impostazioneDao.intervalloPulizia();
			dataDao.deleteEmail(intervallo);
			dataDao.deleteRmail(intervallo);
			dataDao.deleteTelecom(intervallo);
		}
		if(nome.equals(ConstantsMap.genera_elimina_operazione)) {
			Integer intervallo = impostazioneDao.intervalloPulizia();
			dataDao.deleteOperazione(intervallo);
		}
		if(nome.equals(ConstantsMap.genera_elimina_webhook)) {
			Integer intervallo = impostazioneDao.intervalloPulizia();
			dataDao.deleteWebhook(intervallo);
		}
		if(nome.equals(ConstantsMap.genera_elimina_ricezione)) {
			Integer intervallo = impostazioneDao.intervalloPulizia();
			dataDao.deleteRicezione(intervallo);
		}
		if(nome.equals(ConstantsMap.genera_elimina_messaggio)) {
			Integer intervallo = impostazioneDao.intervalloPulizia();
			dataDao.deleteMessaggio(intervallo);
		}
		if(nome.equals(ConstantsMap.genera_elimina_notizia)) {
			Integer intervallo = impostazioneDao.intervalloPulizia();
			dataDao.deleteNotizia(intervallo);
		}
		if(nome.equals(ConstantsMap.genera_elimina_notifica)) {
			Integer intervallo = impostazioneDao.intervalloPulizia();
			dataDao.deleteNotifica(intervallo);
		}
		if(nome.equals(ConstantsMap.genera_elimina_sondaggio)) {
			Integer intervallo = impostazioneDao.intervalloPulizia();
			dataDao.deleteSondaggio(intervallo);
		}
		if(nome.equals(ConstantsMap.genera_elimina_posta)) {
			Integer intervallo = impostazioneDao.intervalloPulizia();
			dataDao.deleteComunicazione(intervallo);
		}
		if(nome.equals(ConstantsMap.genera_elimina_registrazione)) {
			Integer intervallo = impostazioneDao.intervalloPulizia();
			eliminaRegistrazioni(intervallo);
		}
		if(nome.equals(ConstantsMap.genera_elimina_pda)) {
			Integer intervallo = impostazioneDao.intervalloPulizia();
			eliminaPDA(intervallo);
		}
		if(nome.equals(ConstantsMap.genera_elimina_storia)) {
			Integer intervallo = impostazioneDao.intervalloPulizia();
			dataDao.deleteStoriaContatto(intervallo);
			dataDao.deleteStoriaContratto(intervallo);
			dataDao.deleteStoriaAppuntamento(intervallo);
			dataDao.deleteStoriaNota(intervallo);
			dataDao.deleteStoriaPrenotazione(intervallo);
		}
		if(nome.equals(ConstantsMap.genera_elimina_allegato)) {
			Integer intervallo = impostazioneDao.intervalloPulizia();
			dataDao.deleteAllegatoAnagrafica(intervallo);
			dataDao.deleteAllegatoContatto(intervallo);
			dataDao.deleteAllegatoContratto(intervallo);
			dataDao.deleteAllegatoAppuntamento(intervallo);
			dataDao.deleteAllegatoAgente(intervallo);
			dataDao.deleteAllegatoNotizia(intervallo);
		}
		if(nome.equals(ConstantsMap.genera_restart_sistema)) {
			impostazioneDao.restart();
		}
		if(nome.equals(ConstantsMap.genera_riavvia_sistema)) {
			impostazioneDao.riavvia();
		}
		if(nome.equals(ConstantsMap.genera_aggiornamento_sistema)) {
			impostazioneDao.aggiornamento();
		}
		if(nome.equals(ConstantsMap.genera_backup_sistema)) {
			impostazioneDao.backup();
		}
		if(nome.startsWith(ConstantsMap.send_message)) {
			Integer codice [] = new Integer [] {ConstantsGlobal.SCHEDULATA};
			Schedulatore sd = getSchedulatore(nome);
			if(sd != null) {
				schedulerService.invia_comunicazioni(sd, codice);
			}
		}
	}
	public void emailContattiOdierniOperatoriTeam(int tipo)  {
		List<ReportContattiOdierniTeam> lsTeam = new ArrayList<ReportContattiOdierniTeam>();
		List<Team> teams = reportDao.trovaTeamId();
		Integer pannello = 1;
		String percorsoEmail = configurazioneGenericService.getValore(DefaultsGeneric.KEY_INVIO_MAIL_REPORT_TEAM);
		if(ApplicationUtil.notEmpty(teams) && ApplicationUtil.isNotBlank(percorsoEmail)) {
			Date oggi = ApplicationUtil.date();
			Iterator<Team> itTeam = teams.iterator();
			while (itTeam.hasNext()) {
				Team team = (Team) itTeam.next();
				ReportContattiOdierniTeam rcoo = new ReportContattiOdierniTeam();
				rcoo.setTeam(team);
				rcoo.setArchiviazioni(reportDao.getArchiviazioniOdierneOperatoriTeam(pannello, team.getId(),tipo));
				rcoo.setContatti(reportDao.getContattiOdierneOperatoriTeam(pannello, team.getId(),tipo));
				rcoo.setConversazioni(reportDao.getConversazioniOdierneOperatoriTeam(pannello, team.getId(),tipo));
				rcoo.setAppuntamenti(reportDao.getAppuntamentiOdierneOperatoriTeam(team.getId(),tipo));
				rcoo.setContratti(reportDao.getContrattiOdierneOperatoriTeam(team.getId(),tipo));
				lsTeam.add(rcoo);
			}
			String report =  downloadDao.reportToHTMLStringTeam(lsTeam);
			String oggetto = ApplicationUtil.report(ConstantsLanguage.REPORT_TEAM.stampa(), tipo ,oggi);
			smtpService.invia(null, percorsoEmail, null, oggetto, report, null, null);
		}
	}
	public void inviaAnomalia() {
		String percorsoEmail = configurazioneGenericService.getValore(DefaultsGeneric.KEY_INVIO_MAIL_ANOMALIA);
		if(ApplicationUtil.isNotBlank(percorsoEmail)) {
			Date oggi = ApplicationUtil.date();
			MySystem m = impostazioneDao.checkSystem();
			if(m.getAnomalia() != null) {
				String testo =  downloadDao.reportToHTMLAnomalia(m.getAnomalia());
				String oggetto = ApplicationUtil.report(ConstantsLanguage.ANOMALIA.stampa() , ConstantsGlobal.no_periodo, oggi);
				smtpService.invia(null, percorsoEmail, null, oggetto, testo, null, null);
			}
		}
	}
	public List<ReportContattiOdierniTeam> emailContattiOdierniOperatoriTeamReport(int tipo) {
		List<ReportContattiOdierniTeam> lsTeam = new ArrayList<ReportContattiOdierniTeam>();
		List<Team> teams = reportDao.trovaTeamId();
		Integer pannello = 1;
		if(ApplicationUtil.notEmpty(teams)) {
			Iterator<Team> itTeam = teams.iterator();
			while (itTeam.hasNext()) {
				Team team = (Team) itTeam.next();
				ReportContattiOdierniTeam rcoo = new ReportContattiOdierniTeam();
				rcoo.setTeam(team);
				rcoo.setArchiviazioni(reportDao.getArchiviazioniOdierneOperatoriTeam(pannello, team.getId(),tipo));
				rcoo.setContatti(reportDao.getContattiOdierneOperatoriTeam(pannello, team.getId(),tipo));
				rcoo.setConversazioni(reportDao.getConversazioniOdierneOperatoriTeam(pannello, team.getId(),tipo));
				rcoo.setAppuntamenti(reportDao.getAppuntamentiOdierneOperatoriTeam(team.getId(),tipo));
				rcoo.setContratti(reportDao.getContrattiOdierneOperatoriTeam(team.getId(),tipo));
				lsTeam.add(rcoo);
			}
		}
		return lsTeam;
	}
	public List<ReportContattiOdierniZona> emailContattiOdierniOperatoriZonaReport(int tipo) {
		List<ReportContattiOdierniZona> lsZona = new ArrayList<ReportContattiOdierniZona>();
		List<Zona> zonas = reportDao.trovaZonaId();
		if(ApplicationUtil.notEmpty(zonas)) {
			Iterator<Zona> itZona = zonas.iterator();
			while (itZona.hasNext()) {
				Zona zona = (Zona) itZona.next();
				ReportContattiOdierniZona rcoo = new ReportContattiOdierniZona();
				rcoo.setZona(zona);
				rcoo.setContatti(reportDao.getContattiOdierneOperatoriZona(zona.getId(),tipo));
				rcoo.setAppuntamenti(reportDao.getAppuntamentiOdierneOperatoriZona(zona.getId(),tipo));
				rcoo.setContratti(reportDao.getContrattiOdierneOperatoriZona(zona.getId(),tipo));
				lsZona.add(rcoo);
			}
		}
		return lsZona;
	}
	public void emailContattiOdierniOperatoriZona(int tipo)   {
		List<ReportContattiOdierniZona> lsZona = new ArrayList<ReportContattiOdierniZona>();
		List<Zona> zonas = reportDao.trovaZonaId();
		String percorsoEmail = configurazioneGenericService.getValore(DefaultsGeneric.KEY_INVIO_MAIL_REPORT_ZONA);
		if(ApplicationUtil.notEmpty(zonas) && ApplicationUtil.isNotBlank(percorsoEmail)) {
			Date oggi = ApplicationUtil.date();
			Iterator<Zona> itZona = zonas.iterator();
			while (itZona.hasNext()) {
				Zona zona = (Zona) itZona.next();
				ReportContattiOdierniZona rcoo = new ReportContattiOdierniZona();
				rcoo.setZona(zona);
				rcoo.setContatti(reportDao.getContattiOdierneOperatoriZona(zona.getId(),tipo));
				rcoo.setAppuntamenti(reportDao.getAppuntamentiOdierneOperatoriZona(zona.getId(),tipo));
				rcoo.setContratti(reportDao.getContrattiOdierneOperatoriZona(zona.getId(),tipo));
				lsZona.add(rcoo);
			}
			String report =  downloadDao.reportToHTMLStringZona(lsZona);
			String oggetto = ApplicationUtil.report(ConstantsLanguage.REPORT_ZONA.stampa(), tipo , oggi);
			smtpService.invia(null, percorsoEmail, null, oggetto, report, null, null);
		}
	}
	@SuppressWarnings("unchecked")
	public void emailReportAppuntamentiAgenteExcel(int tipo)  {
		Date oggi = ApplicationUtil.date();
		Date domani = ApplicationUtil.addDays(oggi, 1);
		Date data_inizio = ApplicationUtil.inizioGiornata(domani);
		Date data_fine = ApplicationUtil.dataFine(tipo, domani);
		DetachedCriteria criteria = DetachedCriteria.forClass(Agente.class);
		List<Agente> agenti = getList(criteria);
		if(ApplicationUtil.notEmpty(agenti)) {
			MailSupport ms = smtpService.getMailSupport(false);
			String percorsoReply = ApplicationUtil.trimToNull(configurazioneGenericService.getValore(DefaultsGeneric.KEY_INVIO_MAIL_REPORT_APPUNTAMENTO));
			Iterator<Agente> objIter = agenti.iterator();
			while(objIter.hasNext()) {
				Agente agente = objIter.next();
				if (ApplicationUtil.isNotBlank(agente.getEmailReport())) {
					List<Appuntamento> appuntamenti = getAppuntamentiConfermatiListByAgenteId(data_inizio, data_fine, agente.getId(), "data_inizio");
					if(ApplicationUtil.notEmpty(appuntamenti)) {
						try {
							String nomeFile = ApplicationUtil.reportFile(domani, ConstantsLanguage.APPUNTAMENTO.stampa(), agente.getId()) +  "." + ConstantsMap.xlsx;
							ByteArrayOutputStream result = new ByteArrayOutputStream();
							downloadDao.esportaDatiExcelAppuntamento(appuntamenti, result);
							String oggetto = ApplicationUtil.report(ConstantsLanguage.APPUNTAMENTI.stampa(), tipo , domani);
							String testo = downloadDao.preparaTemplateEmail(ConstantsLanguage.APPUNTAMENTI_IN_ALLEGATO.stampa(), oggi);
							List<Allegato> allegati = ApplicationUtil.allegatiConvertO(result, nomeFile);
							smtpService.invia(ms, percorsoReply, agente.getEmailReport(), null, oggetto, testo, allegati, null);
						} catch (Exception e) {
							ErrorLog.log(null, getClass(), e);
						}
					}
				}
			}
			ms.close();
		}
	}
	public void emailReportAppuntamentiManagerExcel(int tipo)  {
		String percorsoEmail = ApplicationUtil.trimToNull(configurazioneGenericService.getValore(DefaultsGeneric.KEY_INVIO_MAIL_REPORT_APPUNTAMENTO));
		if (ApplicationUtil.isNotBlank(percorsoEmail)) {
			Date oggi = ApplicationUtil.date();
			Date domani = ApplicationUtil.addDays(oggi, 1);
			Date data_inizio = ApplicationUtil.inizioGiornata(domani);
			Date data_fine = ApplicationUtil.dataFine(tipo, domani);
			List<Appuntamento> appuntamenti = getAppuntamentiConfermati(data_inizio, data_fine, true);
			if(ApplicationUtil.notEmpty(appuntamenti)) {
				try {
					String nomeFile = ApplicationUtil.reportFile(domani, ConstantsLanguage.APPUNTAMENTO.stampa()) +  "." + ConstantsMap.xlsx;
					ByteArrayOutputStream result = new ByteArrayOutputStream();
					downloadDao.esportaDatiExcelAppuntamento(appuntamenti, result);
					String oggetto = ApplicationUtil.report(ConstantsLanguage.APPUNTAMENTI.stampa(), tipo , domani);
					String testo = downloadDao.preparaTemplateEmail(ConstantsLanguage.APPUNTAMENTI_IN_ALLEGATO.stampa(), oggi);
					List<Allegato> allegati = ApplicationUtil.allegatiConvertO(result, nomeFile);
					smtpService.invia(null, percorsoEmail, null, oggetto, testo , allegati, null);
				} catch (Exception e) {
					ErrorLog.log(null, getClass(), e);
				}
			}
		}
	}


	@SuppressWarnings("unchecked")
	public void emailReportAppuntamentiAgentePdf(int tipo)  {
		Date oggi = ApplicationUtil.date();
		Date domani = ApplicationUtil.addDays(oggi, 1);
		Date data_inizio = ApplicationUtil.inizioGiornata(domani);
		Date data_fine = ApplicationUtil.dataFine(tipo, domani);
		DetachedCriteria criteria = DetachedCriteria.forClass(Agente.class);
		List<Agente> agenti = getList(criteria);
		if(ApplicationUtil.notEmpty(agenti)) {
			MailSupport ms = smtpService.getMailSupport(false);
			String percorsoReply = ApplicationUtil.trimToNull(configurazioneGenericService.getValore(DefaultsGeneric.KEY_INVIO_MAIL_REPORT_APPUNTAMENTO));
			Iterator<Agente> objIter = agenti.iterator();
			while(objIter.hasNext()) {
				Agente agente = objIter.next();
				if (ApplicationUtil.isNotBlank(agente.getEmailReport())) {
					List<Appuntamento> appuntamenti = getAppuntamentiConfermatiListByAgenteId(data_inizio, data_fine, agente.getId(), "data_inizio");
					if(ApplicationUtil.notEmpty(appuntamenti)) {
						try {
							String nomeFile = ApplicationUtil.reportFile(domani, ConstantsLanguage.APPUNTAMENTO.stampa(), agente.getId()) +  "." + ConstantsMap.pdf;
							ByteArrayOutputStream result = new ByteArrayOutputStream();
							downloadDao.esportaDatiPdfAppuntamento(appuntamenti, result);
							String oggetto = ApplicationUtil.report(ConstantsLanguage.APPUNTAMENTI.stampa(), tipo , domani);
							String testo = downloadDao.preparaTemplateEmail(ConstantsLanguage.APPUNTAMENTI_IN_ALLEGATO.stampa(), oggi);
							List<Allegato> allegati = ApplicationUtil.allegatiConvertO(result, nomeFile);
							smtpService.invia(ms, percorsoReply, agente.getEmailReport(), null, oggetto, testo , allegati, null);
						} catch (Exception e) {
							ErrorLog.log(null, getClass(), e);
						}
					}
				}
			}
			ms.close();
		}
	}
	public void emailReportAppuntamentiManagerPdf(int tipo)  {
		String percorsoEmail = configurazioneGenericService.getValore(DefaultsGeneric.KEY_INVIO_MAIL_REPORT_APPUNTAMENTO);
		if (ApplicationUtil.isNotBlank(percorsoEmail)) {
			Date oggi = ApplicationUtil.date();
			Date domani = ApplicationUtil.addDays(oggi, 1);
			Date data_inizio = ApplicationUtil.inizioGiornata(domani);
			Date data_fine = ApplicationUtil.dataFine(tipo, domani);
			List<Appuntamento> appuntamenti = getAppuntamentiConfermati(data_inizio, data_fine, true);
			if(ApplicationUtil.notEmpty(appuntamenti)) {
				try {
					String nomeFile = ApplicationUtil.reportFile(domani, ConstantsLanguage.APPUNTAMENTO.stampa()) +  "." + ConstantsMap.pdf;
					ByteArrayOutputStream result = new ByteArrayOutputStream();
					downloadDao.esportaDatiPdfAppuntamento(appuntamenti, result);

					String oggetto = ApplicationUtil.report(ConstantsLanguage.APPUNTAMENTI.stampa(), tipo , domani);
					String testo = downloadDao.preparaTemplateEmail(ConstantsLanguage.APPUNTAMENTI_IN_ALLEGATO.stampa(), oggi);
					List<Allegato> allegati = ApplicationUtil.allegatiConvertO(result, nomeFile);
					smtpService.invia(null, percorsoEmail, null, oggetto, testo , allegati, null);
				} catch (Exception e) {
					ErrorLog.log(null, getClass(), e);
				}
			}
		}
	}

	public void inviaInvoke(int tipo)  {
		Date oggi = ApplicationUtil.date();
		Date ieri = ApplicationUtil.addDays(oggi, -1);
		Date data_inizio = ApplicationUtil.dataInizio(tipo, ieri);
		Date data_fine = ApplicationUtil.fineGiornata(ieri);
		List<StoriaContatto> st = getStoriaContattoInvoke(data_inizio, data_fine);
		Map<String, Integer> map = new HashMap<String, Integer>();
		if(ApplicationUtil.notEmpty(st)) {
			Iterator<StoriaContatto> objIter = st.iterator();
			while(objIter.hasNext()) {
				StoriaContatto storia = objIter.next();
				ApplicationUtil.invoke(oggi, storia, map);
			}
		}
		map.clear();
	}

	@SuppressWarnings("unchecked")
	public void emailReportAppuntamentiAgenteScheda(int tipo)  {
		Date oggi = ApplicationUtil.date();
		Date domani = ApplicationUtil.addDays(oggi, 1);
		Date data_inizio = ApplicationUtil.inizioGiornata(domani);
		Date data_fine = ApplicationUtil.dataFine(tipo, domani);
		DetachedCriteria criteria = DetachedCriteria.forClass(Agente.class);
		List<Agente> agenti = getList(criteria);
		if(ApplicationUtil.notEmpty(agenti)) {
			MailSupport ms = smtpService.getMailSupport(false);
			String html = impostazioneDao.getFormatoDocumento();
			String percorsoReply = ApplicationUtil.trimToNull(configurazioneGenericService.getValore(DefaultsGeneric.KEY_INVIO_MAIL_REPORT_APPUNTAMENTO));
			Iterator<Agente> objIter = agenti.iterator();
			String p = impostazioneDao.getPasswordZIP();
			String s = ConstantsGlobal.secretL;
			String extM = (s == null || (html.equalsIgnoreCase(ConstantsMap.pdf))) ? html : ConstantsMap.zip;
			while(objIter.hasNext()) {
				Agente agente = objIter.next();
				if (ApplicationUtil.isNotBlank(agente.getEmailReport())) {
					List<Appuntamento> appuntamenti = getAppuntamentiConfermatiListByAgenteId(data_inizio, data_fine, agente.getId(), "data_inizio");
					List<Allegato> files = new ArrayList<Allegato>();
					Iterator<Appuntamento> objAppIter = appuntamenti.iterator();
					while(objAppIter.hasNext()) {
						Appuntamento appuntamento = objAppIter.next();
						try {
							boolean vs = appuntamento.getAgente() != null && ApplicationUtil.isTrue(appuntamento.getAgente().getVisualizzaStoria());
							String nomeFile = ApplicationUtil.reportFile(appuntamento.getData_inizio(), ConstantsLanguage.APPUNTAMENTO.stampa(), appuntamento.getId(), appuntamento.getContatto().getAnagrafica().getDenominazione()) + "." + extM;
							ByteArrayOutputStream result = downloadDao.appuntamentoToHTMLString(null, appuntamento,  vs, true, html, true, false, s);
							result.close();
							ApplicationUtil.addFile(files, nomeFile, result.toByteArray(), appuntamento.getData_creazione().getTime());
						} catch (Exception e) {
							ErrorLog.log(null, getClass(), e);
						}
					}
					if (ApplicationUtil.notEmpty(files)) {
						ByteArrayOutputStream  result = new ByteArrayOutputStream();
						String nomeFile = ApplicationUtil.reportFile(domani, ConstantsLanguage.APPUNTAMENTI.stampa(), agente.getId())  + "." + ConstantsMap.zip;
						boolean b = ApplicationUtil.zip(null,files, result, p);

						String oggetto = ApplicationUtil.report(ConstantsLanguage.APPUNTAMENTI.stampa(), tipo , domani);
						String testo = downloadDao.preparaTemplateEmail(ConstantsLanguage.APPUNTAMENTI_IN_ALLEGATO.stampa(), oggi);
						List<Allegato> allegati = b ? ApplicationUtil.allegatiConvertO(result, nomeFile) : null;
						smtpService.invia(ms, percorsoReply, agente.getEmailReport(), null, oggetto, testo, allegati, null);
					}
				}
			}
			ms.close();
		}
	}

	@SuppressWarnings("unchecked")
	public void emailReportAppuntamentiAgenteConcatena(int tipo)  {
		Date oggi = ApplicationUtil.date();
		Date domani = ApplicationUtil.addDays(oggi, 1);
		Date data_inizio = ApplicationUtil.inizioGiornata(domani);
		Date data_fine = ApplicationUtil.dataFine(tipo, domani);
		DetachedCriteria criteria = DetachedCriteria.forClass(Agente.class);
		List<Agente> agenti = getList(criteria);
		if(ApplicationUtil.notEmpty(agenti)) {
			MailSupport ms = smtpService.getMailSupport(false);
			String percorsoReply = ApplicationUtil.trimToNull(configurazioneGenericService.getValore(DefaultsGeneric.KEY_INVIO_MAIL_REPORT_APPUNTAMENTO));
			Iterator<Agente> objIter = agenti.iterator();
			String html = ConstantsMap.pdf;
			String p = impostazioneDao.getPasswordLCK();
			String s = null;
			while(objIter.hasNext()) {
				Agente agente = objIter.next();
				if (ApplicationUtil.isNotBlank(agente.getEmailReport())) {
					List<Appuntamento> appuntamenti = getAppuntamentiConfermatiListByAgenteId(data_inizio, data_fine, agente.getId(), "data_inizio");
					List<Allegato> files = new ArrayList<Allegato>();
					Iterator<Appuntamento> objAppIter = appuntamenti.iterator();
					while(objAppIter.hasNext()) {
						Appuntamento appuntamento = objAppIter.next();
						try {
							boolean vs = appuntamento.getAgente() != null && ApplicationUtil.isTrue(appuntamento.getAgente().getVisualizzaStoria());
							String nomeFile = ApplicationUtil.reportFile(appuntamento.getData_inizio(), ConstantsLanguage.APPUNTAMENTO.stampa(), appuntamento.getId(), appuntamento.getContatto().getAnagrafica().getDenominazione()) + "." + html;
							ByteArrayOutputStream result = downloadDao.appuntamentoToHTMLString(null, appuntamento,  vs, true, html, true, false, s);
							result.close();
							ApplicationUtil.addFile(files, nomeFile, result.toByteArray(), appuntamento.getData_creazione().getTime());
						} catch (Exception e) {
							ErrorLog.log(null, getClass(), e);
						}
					}
					if (ApplicationUtil.notEmpty(files)) {
						ByteArrayOutputStream  result = new ByteArrayOutputStream();
						String nomeFile = ApplicationUtil.reportFile(domani, ConstantsLanguage.APPUNTAMENTI.stampa(),  agente.getId()) + "." + html;
						String w = downloadDao.getWatermark();
						ApplicationUtil.concatenaPDF(w, files, result, p);

						String oggetto = ApplicationUtil.report(ConstantsLanguage.APPUNTAMENTI.stampa(), tipo , domani);
						String testo = downloadDao.preparaTemplateEmail(ConstantsLanguage.APPUNTAMENTI_IN_ALLEGATO.stampa(), oggi);
						List<Allegato> allegati = ApplicationUtil.allegatiConvertO(result, nomeFile);
						smtpService.invia(ms, percorsoReply, agente.getEmailReport(), null, oggetto, testo, allegati, null);
					}
				}
			}
			ms.close();
		}
	}
	public void emailReportAppuntamentiManagerConcatena(int tipo)  {
		String percorsoEmail = configurazioneGenericService.getValore(DefaultsGeneric.KEY_INVIO_MAIL_REPORT_APPUNTAMENTO);
		if (ApplicationUtil.isNotBlank(percorsoEmail)) {
			Date oggi = ApplicationUtil.date();
			Date domani = ApplicationUtil.addDays(oggi, 1);
			Date data_inizio = ApplicationUtil.inizioGiornata(domani);
			Date data_fine = ApplicationUtil.dataFine(tipo, domani);
			List<Appuntamento> appuntamenti = getAppuntamentiConfermati(data_inizio, data_fine, true);
			List<Allegato> files = new ArrayList<Allegato>();
			if(ApplicationUtil.notEmpty(appuntamenti)) {
				String html = ConstantsMap.pdf;
				String p = impostazioneDao.getPasswordLCK();
				String s = null;
				Iterator<Appuntamento> objIter = appuntamenti.iterator();
				while(objIter.hasNext()) {
					Appuntamento appuntamento = objIter.next();
					try {
						String nomeFile = ApplicationUtil.reportFile(appuntamento.getData_inizio(), ConstantsLanguage.APPUNTAMENTO.stampa(), appuntamento.getId(), appuntamento.getContatto().getAnagrafica().getDenominazione())  + "." + html;
						ByteArrayOutputStream result = downloadDao.appuntamentoToHTMLString(null, appuntamento,  true, true, html, null, false, s);
						result.close();
						ApplicationUtil.addFile(files, nomeFile, result.toByteArray(), appuntamento.getData_creazione().getTime());
					} catch (Exception e) {
						ErrorLog.log(null, getClass(), e);
					}
				}
				if (ApplicationUtil.notEmpty(files)) {
					ByteArrayOutputStream  result = new ByteArrayOutputStream();
					String nomeFile = ApplicationUtil.reportFile(domani, ConstantsLanguage.APPUNTAMENTI.stampa()) + "." + html;
					String w = downloadDao.getWatermark();
					ApplicationUtil.concatenaPDF(w, files, result, p);

					String oggetto = ApplicationUtil.report(ConstantsLanguage.APPUNTAMENTI.stampa(), tipo , domani);
					String testo = downloadDao.preparaTemplateEmail(ConstantsLanguage.APPUNTAMENTI_IN_ALLEGATO.stampa(), oggi);
					List<Allegato> allegati = ApplicationUtil.allegatiConvertO(result, nomeFile);
					smtpService.invia(null, percorsoEmail, null, oggetto, testo, allegati, null);
				}
			}
		}
	}
	public void emailReportAppuntamentiManagerScheda(int tipo)  {
		String percorsoEmail = configurazioneGenericService.getValore(DefaultsGeneric.KEY_INVIO_MAIL_REPORT_APPUNTAMENTO);
		if (ApplicationUtil.isNotBlank(percorsoEmail)) {
			Date oggi = ApplicationUtil.date();
			Date domani = ApplicationUtil.addDays(oggi, 1);
			Date data_inizio = ApplicationUtil.inizioGiornata(domani);
			Date data_fine = ApplicationUtil.dataFine(tipo, domani);
			List<Appuntamento> appuntamenti = getAppuntamentiConfermati(data_inizio, data_fine, true);
			List<Allegato> files = new ArrayList<Allegato>();
			if(ApplicationUtil.notEmpty(appuntamenti)) {
				String p = impostazioneDao.getPasswordZIP();
				String s = ConstantsGlobal.secretL;
				String html = impostazioneDao.getFormatoDocumento();
				String extM = (s == null || (html.equalsIgnoreCase(ConstantsMap.pdf))) ? html : ConstantsMap.zip;
				Iterator<Appuntamento> objIter = appuntamenti.iterator();
				while(objIter.hasNext()) {
					Appuntamento appuntamento = objIter.next();
					try {
						String nomeFile = ApplicationUtil.reportFile(appuntamento.getData_inizio(), ConstantsLanguage.APPUNTAMENTO.stampa(), appuntamento.getId(), appuntamento.getContatto().getAnagrafica().getDenominazione()) + "." + extM;
						ByteArrayOutputStream result = downloadDao.appuntamentoToHTMLString(null, appuntamento,  true, true, html, null, false, s);
						result.close();
						ApplicationUtil.addFile(files, nomeFile, result.toByteArray(), appuntamento.getData_creazione().getTime());
					} catch (Exception e) {
						ErrorLog.log(null, getClass(), e);
					}
				}
				if (ApplicationUtil.notEmpty(files)) {
					ByteArrayOutputStream  result = new ByteArrayOutputStream();
					String nomeFile = ApplicationUtil.reportFile(domani, ConstantsLanguage.APPUNTAMENTI.stampa()) + "." + ConstantsMap.zip;
					boolean b = ApplicationUtil.zip(null,files, result, p);

					String oggetto = ApplicationUtil.report(ConstantsLanguage.APPUNTAMENTI.stampa(), tipo , domani);
					String testo = downloadDao.preparaTemplateEmail(ConstantsLanguage.APPUNTAMENTI_IN_ALLEGATO.stampa(), oggi);
					List<Allegato> allegati = b ? ApplicationUtil.allegatiConvertO(result, nomeFile) : null;
					smtpService.invia(null, percorsoEmail, null, oggetto, testo, allegati, null);
				}
			}
		}
	}

	@SuppressWarnings("unchecked")
	public List<Appuntamento> getAppuntamentiConfermatiListByAgenteId(Date inizio, Date fine, Long agenteId, String data) {
		DetachedCriteria criteria = DetachedCriteria.forClass(Appuntamento.class);
		criteria.createCriteria("esito").add(Restrictions.eq("confermato", Boolean.TRUE));
		criteria.add(Restrictions.eq("agente.id", agenteId));
		ApplicationUtil.dataDate(inizio, fine, data, criteria);
		criteria.addOrder(Order.asc(data));
		return getList(criteria);
	}
	@SuppressWarnings("unchecked")
	public List<Appuntamento> getAppuntamentiList(Date inizio, Date fine) {
		DetachedCriteria criteria = DetachedCriteria.forClass(Appuntamento.class);
		ApplicationUtil.dataDate(inizio, fine, "data_creazione", criteria);
		criteria.addOrder(Order.asc("data_creazione"));
		return getList(criteria);
	}
	@SuppressWarnings("unchecked")
	public List<Contratto> getContrattiConfermatiListByAgenteId(Date inizio, Date fine, Long agenteId, String data) {
		DetachedCriteria criteria = DetachedCriteria.forClass(Contratto.class);
		criteria.createCriteria("esito").add(Restrictions.eq("confermato", Boolean.TRUE));
		criteria.add(Restrictions.eq("agente.id", agenteId));
		ApplicationUtil.dataDate(inizio, fine, data, criteria);
		criteria.addOrder(Order.asc(data));
		return getList(criteria);
	}
	@SuppressWarnings("unchecked")
	public List<Nota> getNote(Date inizio, Date fine, Long agenteId, String data) {
		DetachedCriteria criteria = DetachedCriteria.forClass(Nota.class);
		criteria.add(Restrictions.eq("agente.id", agenteId));
		ApplicationUtil.dataDate(inizio, fine, data, criteria);
		criteria.addOrder(Order.asc(data));
		return getList(criteria);
	}
	@SuppressWarnings("unchecked")
	public List<Prenotazione> getPrenotazioni(Date inizio, Date fine, Long agenteId, String data) {
		DetachedCriteria criteria = DetachedCriteria.forClass(Prenotazione.class);
		criteria.add(Restrictions.eq("agente.id", agenteId));
		ApplicationUtil.dataDate(inizio, fine, data, criteria);
		criteria.addOrder(Order.asc(data));
		return getList(criteria);
	}
	@SuppressWarnings("unchecked")
	public List<Anagrafica> getAnagraficheList(Date inizio, Date fine) {
		DetachedCriteria criteria = DetachedCriteria.forClass(Anagrafica.class);
		ApplicationUtil.dataDate(inizio, fine, "data_creazione", criteria);
		criteria.addOrder(Order.asc("data_creazione"));
		return getList(criteria);
	}
	@SuppressWarnings("unchecked")
	public List<Contratto> getContrattiList(Date inizio, Date fine) {
		DetachedCriteria criteria = DetachedCriteria.forClass(Contratto.class);
		ApplicationUtil.dataDate(inizio, fine, "data_creazione", criteria);
		criteria.addOrder(Order.asc("data_creazione"));
		return getList(criteria);
	}
	@SuppressWarnings("unchecked")
	public List<Nota> getNota(Date inizio, Date fine) {
		DetachedCriteria criteria = DetachedCriteria.forClass(Nota.class);
		ApplicationUtil.dataDate(inizio, fine, "data_creazione", criteria);
		criteria.addOrder(Order.asc("data_creazione"));
		return getList(criteria);
	}
	@SuppressWarnings("unchecked")
	public List<Prenotazione> getPrenotazione(Date inizio, Date fine) {
		DetachedCriteria criteria = DetachedCriteria.forClass(Prenotazione.class);
		ApplicationUtil.dataDate(inizio, fine, "data_creazione", criteria);
		criteria.addOrder(Order.asc("data_creazione"));
		return getList(criteria);
	}
	@SuppressWarnings("unchecked")
	public List<StoriaContatto> getStoriaContatto(Date inizio, Date fine) {
		DetachedCriteria criteria = DetachedCriteria.forClass(StoriaContatto.class);
		ApplicationUtil.dataDate(inizio, fine, "data", criteria);
		criteria.setFetchMode("contatto", FetchMode.JOIN);
		criteria.addOrder(Order.asc("data"));
		return getList(criteria);
	}
	@SuppressWarnings("unchecked")
	public List<StoriaContratto> getStoriaContratto(Date inizio, Date fine) {
		DetachedCriteria criteria = DetachedCriteria.forClass(StoriaContratto.class);
		ApplicationUtil.dataDate(inizio, fine, "data", criteria);
		criteria.setFetchMode("contratto", FetchMode.JOIN);
		criteria.addOrder(Order.asc("data"));
		return getList(criteria);
	}
	@SuppressWarnings("unchecked")
	public List<StoriaAppuntamento> getStoriaAppuntamento(Date inizio, Date fine) {
		DetachedCriteria criteria = DetachedCriteria.forClass(StoriaAppuntamento.class);
		ApplicationUtil.dataDate(inizio, fine, "data", criteria);
		criteria.setFetchMode("appuntamento", FetchMode.JOIN);
		criteria.addOrder(Order.asc("data"));
		return getList(criteria);
	}

	@SuppressWarnings("unchecked")
	public List<StoriaContatto> getStoriaContattoInvoke(Date inizio, Date fine) {
		DetachedCriteria criteria = DetachedCriteria.forClass(StoriaContatto.class);
		DetachedCriteria criteriaC = criteria.createCriteria("contatto");
		DetachedCriteria criteriaA = criteriaC.createCriteria("anagrafica");
		DetachedCriteria criteriaCA = criteriaC.createCriteria("campagna");
		criteriaCA.add(Restrictions.isNotNull("invoke_link"));
		criteriaCA.add(Restrictions.isNotNull("invoke_username"));
		criteriaCA.add(Restrictions.isNotNull("invoke_password"));
		criteriaA.add(Restrictions.isNotNull("link"));
		Criterion c1 = Restrictions.and(Restrictions.isNotNull("operatore"), Restrictions.isNotNull("date_apertura"));
		Criterion c2 = Restrictions.and(Restrictions.isNull("operatore"), Restrictions.isNull("date_apertura"));
		criteria.add(Restrictions.or(c1, c2));
		criteria.add(Restrictions.eq("invisibile", Boolean.FALSE));
		ApplicationUtil.dataDate(inizio, fine, "data", criteria);
		criteria.setFetchMode("contatto", FetchMode.JOIN);
		criteria.addOrder(Order.asc("data"));
		return getList(criteria);
	}
	public Schedulatore getSchedulatore(String value) {
		DetachedCriteria criteria = DetachedCriteria.forClass(Schedulatore.class);
		criteria.add(Restrictions.eq("nome", value));
		return (Schedulatore) getUniqueResult(criteria);
	}

	public Schedulatore get(String value) {
		DetachedCriteria criteria = DetachedCriteria.forClass(Schedulatore.class);
		criteria.add(Restrictions.eq("nome", value));
		Schedulatore sk = (Schedulatore) getUniqueResult(criteria);
		if(sk == null) {
			return new Schedulatore();
		} else {
			return sk;
		}
	}

	public Schedulatore getById(Long value) {
		DetachedCriteria criteria = DetachedCriteria.forClass(Schedulatore.class);
		criteria.add(Restrictions.eq("id", value));
		Schedulatore sk = (Schedulatore) getUniqueResult(criteria);
		if(sk == null) {
			return new Schedulatore();
		} else {
			return sk;
		}
	}
	@SuppressWarnings("unchecked")
	public void eliminaNotInScheduler(List<String> nomi) {
		if(ApplicationUtil.notEmpty(nomi)) {
			DetachedCriteria criteria = DetachedCriteria.forClass(Schedulatore.class);
			criteria.add(Restrictions.not(Restrictions.in("nome", nomi)));
			criteria.add(Restrictions.le("tipo", 0));
			List<Schedulatore> c = getList(criteria);
			cancellaLista(c);
		}
	}
	@SuppressWarnings("unchecked")
	public List<Schedulatore> getDateTrigger() {
		DetachedCriteria criteria = DetachedCriteria.forClass(Schedulatore.class);
		criteria.add(Restrictions.gt("tipo", 0));
		return getList(criteria);
	}

	public Schedulatore salva(Schedulatore oggetto) {
		return (Schedulatore) salvaAggiorna(oggetto);
	}
	private ExtendedCriteria getSchedulerByCriteria(SchedulerCriteria crit) {
		if(crit != null)  crit = (SchedulerCriteria) crit.loadCriteria();
		DetachedCriteria criteria = DetachedCriteria.forClass(Schedulatore.class);
		if(ApplicationUtil.isNotBlank(crit.getNome())) {
			ApplicationUtil.chiave(ConstantsGlobal.colonSeparator, crit.getNome(), criteria, "nome");
		} 
		if(crit.getAvviato() != null) {
			criteria.add(Restrictions.eq("started", crit.getAvviato()));
		} 		
		criteria.add(Restrictions.le("tipo", 0));
		return new ExtendedCriteria(impostazioneDao.getLoggerRicerca(), criteria, crit);
	}
	@SuppressWarnings("unchecked")
	public List<Schedulatore> trova(SchedulerCriteria crit, int start, int size) {
		ExtendedCriteria criteria = getSchedulerByCriteria(crit);
		ApplicationUtil.setOrdinamento(criteria.getCriteria(), new Order [] {Order.asc("nome")});
		return getList(criteria, start, size);
	}
	public int trovaSize(SchedulerCriteria crit) {
		ExtendedCriteria criteria = getSchedulerByCriteria(crit);
		return getListSize(criteria);
	}
	private ExtendedCriteria trovaSchedulerCriteria(SchedulerCriteria crit) {
		if(crit != null)  crit = (SchedulerCriteria) crit.loadCriteria();
		DetachedCriteria criteria = DetachedCriteria.forClass(Schedulatore.class);
		if(ApplicationUtil.isNotBlank(crit.getNome())) {
			ApplicationUtil.valori(ConstantsGlobal.colonSeparator,true,  crit.getNome(), criteria, "nome");
		}
		if(crit.getAvviato() != null) {
			criteria.add(Restrictions.eq("started", crit.getAvviato()));
		} 	
		if(ApplicationUtil.gtZero(crit.getTipo())) {
			criteria.add(Restrictions.eq("tipo", crit.getTipo()));
		} 	
		criteria.add(Restrictions.gt("tipo", 0));
		crit.impostaRicercaDate(criteria);
		return new ExtendedCriteria(impostazioneDao.getLoggerRicerca(), criteria, crit);
	}
	@SuppressWarnings("unchecked")
	public List<Schedulatore> trovaScheduler(SchedulerCriteria crit, int start, int size) {
		ExtendedCriteria criteria = trovaSchedulerCriteria(crit);
		ApplicationUtil.setOrdinamento(criteria.getCriteria(), new Order [] {Order.asc("orario")});
		return getList(criteria, start, size);
	}
	public int trovaSchedulerSize(SchedulerCriteria crit) {
		ExtendedCriteria criteria = trovaSchedulerCriteria(crit);
		return getListSize(criteria);
	}
	@SuppressWarnings("unchecked")
	public List<Appuntamento> getAppuntamentiConfermati(Date inizio, Date fine, boolean confermato) {
		DetachedCriteria criteria = DetachedCriteria.forClass(Appuntamento.class);
		if(ApplicationUtil.isTrue(confermato)) {
			criteria.createCriteria("esito").add(Restrictions.eq("confermato", Boolean.TRUE));
		}
		ApplicationUtil.dataDate(inizio, fine, "data_inizio", criteria);
		criteria.addOrder(Order.asc("data_inizio"));
		return getList(criteria);
	}
	
	public void aggiorna_comunicazioni(Schedulatore sa, int motivo, Integer codice [])  {
		if (sa != null) {
			List<Object> lstS = new ArrayList<Object>();
			if(sa.isTipo_email()) {
				lstS.addAll(comunicazioneDao.getDaInviarePostList(sa, Email.class,codice));
			}
			
			if(sa.isTipo_rmail()) {
				lstS.addAll(comunicazioneDao.getDaInviarePostList(sa, Rmail.class,codice));
			}
			
			if(sa.isTipo_telecom()) {
				lstS.addAll(comunicazioneDao.getDaInviarePostList(sa, Telecom.class,codice));
			}
			if(ApplicationUtil.notEmpty(lstS)) {
				Iterator<Object> itS = lstS.iterator();
				while (itS.hasNext()) {
					Object obj = itS.next();
					if(obj instanceof Email) {
						Email o = (Email) obj;
						o.addMotivo(motivo, null);
						salvaAggiorna(o);
					}
					if(obj instanceof Rmail) {
						Rmail o = (Rmail) obj;
						o.addMotivo(motivo, null);
						salvaAggiorna(o);
					}
					if(obj instanceof Telecom) {
						Telecom o = (Telecom) obj;
						o.addMotivo(motivo, null);
						salvaAggiorna(o);
					}
				}
			}
		}
	}
	public void aggiorna_comunicazioni(Schedulatore sa, Date nuova, Integer codice [])  {
		if (sa != null) {
			List<Object> lstS = new ArrayList<Object>();
			if(sa.isTipo_email()) {
				lstS.addAll(comunicazioneDao.getDaInviarePostList(sa, Email.class,codice));
			}
			if(sa.isTipo_rmail()) {
				lstS.addAll(comunicazioneDao.getDaInviarePostList(sa, Rmail.class,codice));
			}
			if(sa.isTipo_telecom()) {
				lstS.addAll(comunicazioneDao.getDaInviarePostList(sa, Telecom.class,codice));
			}
			if(ApplicationUtil.notEmpty(lstS)) {
				Iterator<Object> itS = lstS.iterator();
				while (itS.hasNext()) {
					Object obj = itS.next();
					if(obj instanceof Email) {
						Email o = (Email) obj;
						o.setData_invio(nuova);
						salvaAggiorna(o);
					}
					if(obj instanceof Rmail) {
						Rmail o = (Rmail) obj;
						o.setData_invio(nuova);
						salvaAggiorna(o);
					}
					if(obj instanceof Telecom) {
						Telecom o = (Telecom) obj;
						o.setData_invio(nuova);
						salvaAggiorna(o);
					}
				}
			}
		}
	}

	public void emailGenerale(Integer tipo)  {
		String percorsoEmail = configurazioneGenericService.getValore(DefaultsGeneric.KEY_INVIO_MAIL_REPORT_OPERATORE);
		if (ApplicationUtil.isNotBlank(percorsoEmail)) {
			Date oggi = ApplicationUtil.date();
			try {
				String nomeFile = ApplicationUtil.reportFile(oggi, ConstantsLanguage.RIEPILOGO.stampa(), ConstantsLanguage.GENERALE.stampa()) + "." + ConstantsMap.xlsx; 
				ByteArrayOutputStream result = new ByteArrayOutputStream();
				reportDao.exportReportGenerale(tipo, result);
				String testo = downloadDao.preparaTemplateEmail(ConstantsLanguage.REPORT_IN_ALLEGATO.stampa(), oggi);
				String oggetto = ApplicationUtil.report(ConstantsLanguage.RIEPILOGO.stampa() + " " + ConstantsLanguage.GENERALE.stampa(), tipo , oggi);
				List<Allegato> allegati = ApplicationUtil.allegatiConvertO(result, nomeFile);
				smtpService.invia(null, percorsoEmail, null, oggetto, testo , allegati, null);
			} catch (Exception e) {
				ErrorLog.log(null, getClass(), e);
			}
		}
	}
	public void emailGeneraleStoria(Integer tipo)  {
		String percorsoEmail = configurazioneGenericService.getValore(DefaultsGeneric.KEY_INVIO_MAIL_REPORT_OPERATORE);
		if (ApplicationUtil.isNotBlank(percorsoEmail)) {
			Date oggi = ApplicationUtil.date();
			try {
				String nomeFile = ApplicationUtil.reportFile(oggi, ConstantsLanguage.REPORT.stampa(), ConstantsLanguage.GENERALE.stampa()) + "." + ConstantsMap.xlsx; 
				ByteArrayOutputStream result = new ByteArrayOutputStream();
				reportDao.exportReportGeneraleStoria(tipo, result);
				String testo = downloadDao.preparaTemplateEmail(ConstantsLanguage.REPORT_IN_ALLEGATO.stampa(), oggi);
				String oggetto = ApplicationUtil.report(ConstantsLanguage.REPORT.stampa() + " " + ConstantsLanguage.GENERALE.stampa(), tipo , oggi);
				List<Allegato> allegati = ApplicationUtil.allegatiConvertO(result, nomeFile);
				smtpService.invia(null, percorsoEmail, null, oggetto, testo , allegati, null);
			} catch (Exception e) {
				ErrorLog.log(null, getClass(), e);
			}
		}
	}
	public void emailLavorato(Integer tipo)  {
		String percorsoEmail = configurazioneGenericService.getValore(DefaultsGeneric.KEY_INVIO_MAIL_REPORT_REGISTRO);
		if (ApplicationUtil.isNotBlank(percorsoEmail)) {
			Date oggi = ApplicationUtil.date();
			try {
				String nomeFile = ApplicationUtil.reportFile(oggi, ConstantsLanguage.REPORT.stampa(), ConstantsLanguage.LAVORATO.stampa()) + "." + ConstantsMap.xlsx; 
				ByteArrayOutputStream result = new ByteArrayOutputStream();
				reportDao.exportReportLavorato(tipo, result);
				String testo = downloadDao.preparaTemplateEmail(ConstantsLanguage.REPORT_IN_ALLEGATO.stampa(), oggi);
				String oggetto = ApplicationUtil.report(ConstantsLanguage.REPORT.stampa() + " " + ConstantsLanguage.LAVORATO.stampa(), tipo , oggi);
				List<Allegato> allegati = ApplicationUtil.allegatiConvertO(result, nomeFile);
				smtpService.invia(null, percorsoEmail, null, oggetto, testo , allegati, null);
			} catch (Exception e) {
				ErrorLog.log(null, getClass(), e);
			}
		}
	}
	 
	@SuppressWarnings("unchecked")
	public void emailAppuntamentiXLSAgente(int tipo)  {
		Date oggi = ApplicationUtil.date();
		Date data_inizio = ApplicationUtil.dataInizio(tipo, oggi);
		Date data_fine = ApplicationUtil.fineGiornata(oggi);
		DetachedCriteria criteria = DetachedCriteria.forClass(Agente.class);
		List<Agente> agenti = getList(criteria);
		if(ApplicationUtil.notEmpty(agenti)) {
			MailSupport ms = smtpService.getMailSupport(false);
			String percorsoReply = ApplicationUtil.trimToNull(configurazioneGenericService.getValore(DefaultsGeneric.KEY_INVIO_MAIL_REPORT_APPUNTAMENTO));
			Iterator<Agente> objIter = agenti.iterator();
			while(objIter.hasNext()) {
				Agente agente = objIter.next();
				if (ApplicationUtil.isNotBlank(agente.getEmailReport())) {
					List<Appuntamento> appuntamenti = getAppuntamentiConfermatiListByAgenteId(data_inizio, data_fine, agente.getId(), "data_creazione");
					if(ApplicationUtil.notEmpty(appuntamenti)) {
						try {
							String nomeFile = ApplicationUtil.reportFile(oggi, ConstantsLanguage.APPUNTAMENTI.stampa(), agente.getId()) +  "." + ConstantsMap.xlsx;
							ByteArrayOutputStream result = new ByteArrayOutputStream();
							downloadDao.esportaDatiExcelAppuntamento(appuntamenti, result);

							String oggetto = ApplicationUtil.report(ConstantsLanguage.APPUNTAMENTI.stampa(), tipo , oggi);
							String testo = downloadDao.preparaTemplateEmail(ConstantsLanguage.APPUNTAMENTI_IN_ALLEGATO.stampa(), oggi);
							List<Allegato> allegati = ApplicationUtil.allegatiConvertO(result, nomeFile);
							smtpService.invia(ms, percorsoReply, agente.getEmailReport(), null, oggetto, testo , allegati, null);
						} catch (Exception e) {
							ErrorLog.log(null, getClass(), e);
						}
					}
				}
			}
			ms.close();
		}
	}
	@SuppressWarnings("unchecked")
	public void emailAppuntamentiPDFAgente(int tipo)  {
		Date oggi = ApplicationUtil.date();
		Date data_inizio = ApplicationUtil.dataInizio(tipo, oggi);
		Date data_fine = ApplicationUtil.fineGiornata(oggi);
		DetachedCriteria criteria = DetachedCriteria.forClass(Agente.class);
		List<Agente> agenti = getList(criteria);
		if(ApplicationUtil.notEmpty(agenti)) {
			MailSupport ms = smtpService.getMailSupport(false);
			String percorsoReply = ApplicationUtil.trimToNull(configurazioneGenericService.getValore(DefaultsGeneric.KEY_INVIO_MAIL_REPORT_APPUNTAMENTO));
			Iterator<Agente> objIter = agenti.iterator();
			while(objIter.hasNext()) {
				Agente agente = objIter.next();
				if (ApplicationUtil.isNotBlank(agente.getEmailReport())) {
					List<Appuntamento> appuntamenti = getAppuntamentiConfermatiListByAgenteId(data_inizio, data_fine, agente.getId(), "data_creazione");
					if(ApplicationUtil.notEmpty(appuntamenti)) {
						try {
							String nomeFile = ApplicationUtil.reportFile(oggi, ConstantsLanguage.APPUNTAMENTI.stampa(), agente.getId()) +  "." + ConstantsMap.pdf;
							ByteArrayOutputStream result = new ByteArrayOutputStream();
							downloadDao.esportaDatiPdfAppuntamento(appuntamenti, result);

							String oggetto = ApplicationUtil.report(ConstantsLanguage.APPUNTAMENTI.stampa(), tipo , oggi);
							String testo = downloadDao.preparaTemplateEmail(ConstantsLanguage.APPUNTAMENTI_IN_ALLEGATO.stampa(), oggi);
							List<Allegato> allegati = ApplicationUtil.allegatiConvertO(result, nomeFile);
							smtpService.invia(ms, percorsoReply, agente.getEmailReport(), null, oggetto, testo , allegati, null);
						} catch (Exception e) {
							ErrorLog.log(null, getClass(), e);
						}
					}
				}
			}
			ms.close();
		}
	}
	@SuppressWarnings("unchecked")
	public void emailContrattiXLSAgente(int tipo)  {
		Date oggi = ApplicationUtil.date();
		Date data_inizio = ApplicationUtil.dataInizio(tipo, oggi);
		Date data_fine = ApplicationUtil.fineGiornata(oggi);
		DetachedCriteria criteria = DetachedCriteria.forClass(Agente.class);
		List<Agente> agenti = getList(criteria);
		if(ApplicationUtil.notEmpty(agenti)) {
			MailSupport ms = smtpService.getMailSupport(false);
			String percorsoReply = ApplicationUtil.trimToNull(configurazioneGenericService.getValore(DefaultsGeneric.KEY_INVIO_MAIL_REPORT_CONTRATTO));
			Iterator<Agente> objIter = agenti.iterator();
			while(objIter.hasNext()) {
				Agente agente = objIter.next();
				if (ApplicationUtil.isNotBlank(agente.getEmailReport())) {
					List<Contratto> contratti = getContrattiConfermatiListByAgenteId(data_inizio, data_fine, agente.getId(), "data_creazione");
					if(ApplicationUtil.notEmpty(contratti)) {
						try {
							String nomeFile = ApplicationUtil.reportFile(oggi, ConstantsLanguage.CONTRATTI.stampa(), agente.getId()) +  "." + ConstantsMap.xlsx;
							ByteArrayOutputStream result = new ByteArrayOutputStream();
							downloadDao.esportaDatiExcelContratto(contratti, result);

							String oggetto = ApplicationUtil.report(ConstantsLanguage.CONTRATTI.stampa() , tipo, oggi);
							String testo = downloadDao.preparaTemplateEmail(ConstantsLanguage.CONTRATTI_IN_ALLEGATO.stampa(), oggi);
							List<Allegato> allegati = ApplicationUtil.allegatiConvertO(result, nomeFile);
							smtpService.invia(ms, percorsoReply, agente.getEmailReport(), null, oggetto, testo , allegati, null);
						} catch (Exception e) {
							ErrorLog.log(null, getClass(), e);
						}
					}
				}
			}
			ms.close();
		}
	}
	@SuppressWarnings("unchecked")
	public void emailNoteXLSAgente(int tipo)  {
		Date oggi = ApplicationUtil.date();
		Date data_inizio = ApplicationUtil.dataInizio(tipo, oggi);
		Date data_fine = ApplicationUtil.fineGiornata(oggi);
		DetachedCriteria criteria = DetachedCriteria.forClass(Agente.class);
		List<Agente> agenti = getList(criteria);
		if(ApplicationUtil.notEmpty(agenti)) {
			MailSupport ms = smtpService.getMailSupport(false);
			String percorsoReply = ApplicationUtil.trimToNull(configurazioneGenericService.getValore(DefaultsGeneric.KEY_INVIO_MAIL_REPORT_NOTA));
			Iterator<Agente> objIter = agenti.iterator();
			while(objIter.hasNext()) {
				Agente agente = objIter.next();
				if (ApplicationUtil.isNotBlank(agente.getEmailReport())) {
					List<Nota> note = getNote(data_inizio, data_fine, agente.getId(), "data_creazione");
					if(ApplicationUtil.notEmpty(note)) {
						try {
							String nomeFile = ApplicationUtil.reportFile(oggi, ConstantsLanguage.NOTE.stampa(), agente.getId()) +  "." + ConstantsMap.xlsx;
							ByteArrayOutputStream result = new ByteArrayOutputStream();
							downloadDao.esportaDatiExcelNota(note, result);

							String oggetto = ApplicationUtil.report(ConstantsLanguage.NOTE.stampa() , tipo, oggi);
							String testo = downloadDao.preparaTemplateEmail(ConstantsLanguage.NOTE_IN_ALLEGATO.stampa(), oggi);
							List<Allegato> allegati = ApplicationUtil.allegatiConvertO(result, nomeFile);
							smtpService.invia(ms, percorsoReply, agente.getEmailReport(), null, oggetto, testo , allegati, null);
						} catch (Exception e) {
							ErrorLog.log(null, getClass(), e);
						}
					}
				}
			}
			ms.close();
		}
	}
	@SuppressWarnings("unchecked")
	public void emailPrenotazioniXLSAgente(int tipo)  {
		Date oggi = ApplicationUtil.date();
		Date data_inizio = ApplicationUtil.dataInizio(tipo, oggi);
		Date data_fine = ApplicationUtil.fineGiornata(oggi);
		DetachedCriteria criteria = DetachedCriteria.forClass(Agente.class);
		List<Agente> agenti = getList(criteria);
		if(ApplicationUtil.notEmpty(agenti)) {
			MailSupport ms = smtpService.getMailSupport(false);
			String percorsoReply = ApplicationUtil.trimToNull(configurazioneGenericService.getValore(DefaultsGeneric.KEY_INVIO_MAIL_REPORT_PRENOTAZIONE));
			Iterator<Agente> objIter = agenti.iterator();
			while(objIter.hasNext()) {
				Agente agente = objIter.next();
				if (ApplicationUtil.isNotBlank(agente.getEmailReport())) {
					List<Prenotazione> prenotazioni = getPrenotazioni(data_inizio, data_fine, agente.getId(), "data_creazione");
					if(ApplicationUtil.notEmpty(prenotazioni)) {
						try {
							String nomeFile = ApplicationUtil.reportFile(oggi, ConstantsLanguage.PRENOTAZIONI.stampa(),  agente.getId()) +  "." + ConstantsMap.xlsx;
							ByteArrayOutputStream result = new ByteArrayOutputStream();
							downloadDao.esportaDatiExcelPrenotazione(prenotazioni, result);

							String oggetto = ApplicationUtil.report(ConstantsLanguage.PRENOTAZIONI.stampa() , tipo, oggi);
							String testo = downloadDao.preparaTemplateEmail(ConstantsLanguage.PRENOTAZIONI_IN_ALLEGATO.stampa(), oggi);
							List<Allegato> allegati = ApplicationUtil.allegatiConvertO(result, nomeFile);
							smtpService.invia(ms, percorsoReply, agente.getEmailReport(), null, oggetto, testo , allegati, null);
						} catch (Exception e) {
							ErrorLog.log(null, getClass(), e);
						}
					}
				}
			}
			ms.close();
		}
	}
	public void emailPausePDF(int tipo)  {
		Date oggi = ApplicationUtil.date();
		Date data_inizio = ApplicationUtil.dataInizio(tipo, oggi);
		Date data_fine = ApplicationUtil.fineGiornata(oggi);
		String percorsoEmail = configurazioneGenericService.getValore(DefaultsGeneric.KEY_INVIO_MAIL_REPORT_REGISTRO);
		if (ApplicationUtil.isNotBlank(percorsoEmail)) {
			List<Pausa> dati = getPauseList(data_inizio, data_fine);
			if(ApplicationUtil.notEmpty(dati)) {
				try {
					String nomeFile = ApplicationUtil.reportFile(oggi, ConstantsLanguage.PAUSE.stampa()) +  "." + ConstantsMap.pdf;
					ByteArrayOutputStream result = new ByteArrayOutputStream();
					downloadDao.esportaDatiPdfPausa(dati, result);

					String oggetto = ApplicationUtil.report(ConstantsLanguage.PAUSE.stampa() , tipo, oggi);
					String testo = downloadDao.preparaTemplateEmail(ConstantsLanguage.REPORT_IN_ALLEGATO.stampa(), oggi);
					List<Allegato> allegati = ApplicationUtil.allegatiConvertO(result, nomeFile);
					smtpService.invia(null, percorsoEmail, null, oggetto, testo , allegati, null);
				} catch (Exception e) {
					ErrorLog.log(null, getClass(), e);
				}
			}
		}
	}
	public void emailPauseXLS(int tipo)  {
		Date oggi = ApplicationUtil.date();
		Date data_inizio = ApplicationUtil.dataInizio(tipo, oggi);
		Date data_fine = ApplicationUtil.fineGiornata(oggi);
		String percorsoEmail = configurazioneGenericService.getValore(DefaultsGeneric.KEY_INVIO_MAIL_REPORT_REGISTRO);
		if (ApplicationUtil.isNotBlank(percorsoEmail)) {
			List<Pausa> dati = getPauseList(data_inizio, data_fine);
			if(ApplicationUtil.notEmpty(dati)) {
				try {
					String nomeFile = ApplicationUtil.reportFile(oggi, ConstantsLanguage.PAUSE.stampa()) +  "." + ConstantsMap.xlsx;
					ByteArrayOutputStream result = new ByteArrayOutputStream();
					downloadDao.esportaDatiExcelPausa(dati, result);

					String oggetto = ApplicationUtil.report(ConstantsLanguage.PAUSE.stampa() , tipo, oggi);
					String testo = downloadDao.preparaTemplateEmail(ConstantsLanguage.REPORT_IN_ALLEGATO.stampa(), oggi);
					List<Allegato> allegati = ApplicationUtil.allegatiConvertO(result, nomeFile);
					smtpService.invia(null, percorsoEmail, null, oggetto, testo , allegati, null);
				} catch (Exception e) {
					ErrorLog.log(null, getClass(), e);
				}
			}
		}
	}
	public void inviaScadenza()  {
		String percorsoEmail = configurazioneGenericService.getValore(DefaultsGeneric.KEY_INVIO_MAIL_SCADENZA);
		if (ApplicationUtil.isNotBlank(percorsoEmail)) {
			Integer [] gg = {10, 5 , -1}; 
			List<Integer> giorni = new ArrayList<Integer>(Arrays.asList(gg));
			Tema t = temaDao.getTema();
			if( t!= null ){
				TemaUtil tu = new TemaUtil();
				Date scadenza = ApplicationUtil.aggiustaScadenza(t.getScadenza());
				Integer preavviso = t.getPreavviso();
				tu.setScadenza(scadenza);
				tu.setPreavviso(preavviso);
				if(scadenza != null) {
					Date oggi = ApplicationUtil.date();
					tu.setScaduta(oggi.after(scadenza));
					String oggetto = null;
					if(tu.getScaduta()) {
						oggetto = tu.getPreavviso() != null ? Message.addCatalogText("demo_scaduta") : Message.addCatalogText("applicazione_scaduta");
					} else {
						oggetto = Message.addCatalogText("scadenza") +  ": " + ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), tu.getScadenza());
					}
					String report = downloadDao.scadenzaToHTMLString(oggetto);
					if(ApplicationUtil.colcolaScadenza(oggi, scadenza, preavviso)) {
						int a = ApplicationUtil.verificaScadenza(oggi, scadenza);
						if(giorni.contains(a)) {
							smtpService.invia(null, percorsoEmail, null, oggetto, report, null, null);
						}
					}
				}
			}
		}
	}
	public void emailMarcaturePDF(int tipo)  {
		Date oggi = ApplicationUtil.date();
		Date data_inizio = ApplicationUtil.dataInizio(tipo, oggi);
		Date data_fine = ApplicationUtil.fineGiornata(oggi);
		String percorsoEmail = configurazioneGenericService.getValore(DefaultsGeneric.KEY_INVIO_MAIL_REPORT_REGISTRO);
		if (ApplicationUtil.isNotBlank(percorsoEmail)) {
			List<Marcatura> dati = getMarcatureList(data_inizio, data_fine);
			if(ApplicationUtil.notEmpty(dati)) {
				try {
					String nomeFile = ApplicationUtil.reportFile(oggi, ConstantsLanguage.MARCATURE.stampa()) +  "." + ConstantsMap.pdf;
					ByteArrayOutputStream result = new ByteArrayOutputStream();
					downloadDao.esportaDatiPdfMarcatura(dati, result);

					String oggetto = ApplicationUtil.report(ConstantsLanguage.MARCATURE.stampa() , tipo, oggi);
					String testo = downloadDao.preparaTemplateEmail(ConstantsLanguage.REPORT_IN_ALLEGATO.stampa(), oggi);
					List<Allegato> allegati = ApplicationUtil.allegatiConvertO(result, nomeFile);
					smtpService.invia(null, percorsoEmail, null, oggetto, testo , allegati, null);
				} catch (Exception e) {
					ErrorLog.log(null, getClass(), e);
				}
			}
		}
	}
	public void emailMarcatureXLS(int tipo)  {
		Date oggi = ApplicationUtil.date();
		Date data_inizio = ApplicationUtil.dataInizio(tipo, oggi);
		Date data_fine = ApplicationUtil.fineGiornata(oggi);
		String percorsoEmail = configurazioneGenericService.getValore(DefaultsGeneric.KEY_INVIO_MAIL_REPORT_REGISTRO);
		if (ApplicationUtil.isNotBlank(percorsoEmail)) {
			List<Marcatura> dati = getMarcatureList(data_inizio, data_fine);
			if(ApplicationUtil.notEmpty(dati)) {
				try {
					String nomeFile = ApplicationUtil.reportFile(oggi, ConstantsLanguage.MARCATURE.stampa()) +  "." + ConstantsMap.xlsx;
					ByteArrayOutputStream result = new ByteArrayOutputStream();
					downloadDao.esportaDatiExcelMarcatura(dati, result);

					String oggetto = ApplicationUtil.report(ConstantsLanguage.MARCATURE.stampa() , tipo, oggi);
					String testo = downloadDao.preparaTemplateEmail(ConstantsLanguage.REPORT_IN_ALLEGATO.stampa(), oggi);
					List<Allegato> allegati = ApplicationUtil.allegatiConvertO(result, nomeFile);
					smtpService.invia(null, percorsoEmail, null, oggetto, testo , allegati, null);
				} catch (Exception e) {
					ErrorLog.log(null, getClass(), e);
				}
			}
		}
	}

	public void emailAccessiPDF(int tipo)  {
		Date oggi = ApplicationUtil.date();
		Date data_inizio = ApplicationUtil.dataInizio(tipo, oggi);
		Date data_fine = ApplicationUtil.fineGiornata(oggi);
		String percorsoEmail = configurazioneGenericService.getValore(DefaultsGeneric.KEY_INVIO_MAIL_REPORT_REGISTRO);
		if (ApplicationUtil.isNotBlank(percorsoEmail)) {
			List<Accesso> dati = getAccessiList(data_inizio, data_fine);
			if(ApplicationUtil.notEmpty(dati)) {
				try {
					String nomeFile = ApplicationUtil.reportFile(oggi, ConstantsLanguage.ACCESSI.stampa()) +  "." + ConstantsMap.pdf;
					ByteArrayOutputStream result = new ByteArrayOutputStream();
					downloadDao.esportaDatiPdfAccesso(dati, result);

					String oggetto = ApplicationUtil.report(ConstantsLanguage.ACCESSI.stampa() , tipo, oggi);
					String testo = downloadDao.preparaTemplateEmail(ConstantsLanguage.REPORT_IN_ALLEGATO.stampa(), oggi);
					List<Allegato> allegati = ApplicationUtil.allegatiConvertO(result, nomeFile);
					smtpService.invia(null, percorsoEmail, null, oggetto, testo , allegati, null);
				} catch (Exception e) {
					ErrorLog.log(null, getClass(), e);
				}
			}
		}
	}
	public void emailAccessiXLS(int tipo)  {
		Date oggi = ApplicationUtil.date();
		Date data_inizio = ApplicationUtil.dataInizio(tipo, oggi);
		Date data_fine = ApplicationUtil.fineGiornata(oggi);
		String percorsoEmail = configurazioneGenericService.getValore(DefaultsGeneric.KEY_INVIO_MAIL_REPORT_REGISTRO);
		if (ApplicationUtil.isNotBlank(percorsoEmail)) {
			List<Accesso> dati = getAccessiList(data_inizio, data_fine);
			if(ApplicationUtil.notEmpty(dati)) {
				try {
					String nomeFile = ApplicationUtil.reportFile(oggi, ConstantsLanguage.ACCESSI.stampa()) +  "." + ConstantsMap.xlsx;
					ByteArrayOutputStream result = new ByteArrayOutputStream();
					downloadDao.esportaDatiExcelAccesso(dati, result);

					String oggetto = ApplicationUtil.report(ConstantsLanguage.ACCESSI.stampa() , tipo, oggi);
					String testo = downloadDao.preparaTemplateEmail(ConstantsLanguage.REPORT_IN_ALLEGATO.stampa(), oggi);
					List<Allegato> allegati = ApplicationUtil.allegatiConvertO(result, nomeFile);
					smtpService.invia(null, percorsoEmail, null, oggetto, testo , allegati, null);
				} catch (Exception e) {
					ErrorLog.log(null, getClass(), e);
				}
			}
		}
	}
	public void emailOperazioniPDF(int tipo)  {
		Date oggi = ApplicationUtil.date();
		Date data_inizio = ApplicationUtil.dataInizio(tipo, oggi);
		Date data_fine = ApplicationUtil.fineGiornata(oggi);
		String percorsoEmail = configurazioneGenericService.getValore(DefaultsGeneric.KEY_INVIO_MAIL_REPORT_REGISTRO);
		if (ApplicationUtil.isNotBlank(percorsoEmail)) {
			List<Operazione> dati = getOperazioniList(data_inizio, data_fine);
			if(ApplicationUtil.notEmpty(dati)) {
				try {
					String nomeFile = ApplicationUtil.reportFile(oggi, ConstantsLanguage.OPERAZIONI.stampa()) +  "." + ConstantsMap.pdf;
					ByteArrayOutputStream result = new ByteArrayOutputStream();
					downloadDao.esportaDatiPdfOperazione(dati, result);

					String oggetto = ApplicationUtil.report(ConstantsLanguage.OPERAZIONI.stampa() , tipo, oggi);
					String testo = downloadDao.preparaTemplateEmail(ConstantsLanguage.REPORT_IN_ALLEGATO.stampa(), oggi);
					List<Allegato> allegati = ApplicationUtil.allegatiConvertO(result, nomeFile);
					smtpService.invia(null, percorsoEmail, null, oggetto, testo , allegati, null);
				} catch (Exception e) {
					ErrorLog.log(null, getClass(), e);
				}
			}
		}
	}
	public void emailOperazioniXLS(int tipo)  {
		Date oggi = ApplicationUtil.date();
		Date data_inizio = ApplicationUtil.dataInizio(tipo, oggi);
		Date data_fine = ApplicationUtil.fineGiornata(oggi);
		String percorsoEmail = configurazioneGenericService.getValore(DefaultsGeneric.KEY_INVIO_MAIL_REPORT_REGISTRO);
		if (ApplicationUtil.isNotBlank(percorsoEmail)) {
			List<Operazione> dati = getOperazioniList(data_inizio, data_fine);
			if(ApplicationUtil.notEmpty(dati)) {
				try {
					String nomeFile = ApplicationUtil.reportFile(oggi, ConstantsLanguage.OPERAZIONI.stampa()) +  "." + ConstantsMap.xlsx;
					ByteArrayOutputStream result = new ByteArrayOutputStream();
					downloadDao.esportaDatiExcelOperazione(dati, result);

					String oggetto = ApplicationUtil.report(ConstantsLanguage.OPERAZIONI.stampa() , tipo, oggi);
					String testo = downloadDao.preparaTemplateEmail(ConstantsLanguage.REPORT_IN_ALLEGATO.stampa(), oggi);
					List<Allegato> allegati = ApplicationUtil.allegatiConvertO(result, nomeFile);
					smtpService.invia(null, percorsoEmail, null, oggetto, testo , allegati, null);
				} catch (Exception e) {
					ErrorLog.log(null, getClass(), e);
				}
			}
		}
	}
	@SuppressWarnings("unchecked")
	private List<Operazione> getOperazioniList(Date inizio, Date fine) {
		DetachedCriteria criteria = DetachedCriteria.forClass(Operazione.class);
		ApplicationUtil.dataDate(inizio, fine, "data_creazione", criteria);
		criteria.addOrder(Order.asc("data_creazione"));
		return getList(criteria);
	}
	@SuppressWarnings("unchecked")
	private List<Pausa> getPauseList(Date inizio, Date fine) {
		DetachedCriteria criteria = DetachedCriteria.forClass(Pausa.class);
		ApplicationUtil.dataDate(inizio, fine, "data_inizio", criteria);
		criteria.addOrder(Order.asc("data_inizio"));
		return getList(criteria);
	}
	@SuppressWarnings("unchecked")
	private List<Marcatura> getMarcatureList(Date inizio, Date fine) {
		DetachedCriteria criteria = DetachedCriteria.forClass(Marcatura.class);
		ApplicationUtil.dataDate(inizio, fine, "data_creazione", criteria);
		criteria.addOrder(Order.asc("data_creazione"));
		return getList(criteria);
	}

	@SuppressWarnings("unchecked")
	private List<Accesso> getAccessiList(Date inizio, Date fine) {
		DetachedCriteria criteria = DetachedCriteria.forClass(Accesso.class);
		ApplicationUtil.dataDate(inizio, fine, "data_creazione", criteria);
		criteria.addOrder(Order.asc("data_creazione"));
		return getList(criteria);
	}

	@SuppressWarnings("unchecked")
	public void emailContrattiPDFAgente(int tipo)  {
		Date oggi = ApplicationUtil.date();
		Date data_inizio = ApplicationUtil.dataInizio(tipo, oggi);
		Date data_fine = ApplicationUtil.fineGiornata(oggi);
		DetachedCriteria criteria = DetachedCriteria.forClass(Agente.class);
		List<Agente> agenti = getList(criteria);
		if(ApplicationUtil.notEmpty(agenti)) {
			MailSupport ms = smtpService.getMailSupport(false);
			String percorsoReply = ApplicationUtil.trimToNull(configurazioneGenericService.getValore(DefaultsGeneric.KEY_INVIO_MAIL_REPORT_CONTRATTO));
			Iterator<Agente> objIter = agenti.iterator();
			while(objIter.hasNext()) {
				Agente agente = objIter.next();
				if (ApplicationUtil.isNotBlank(agente.getEmailReport())) {
					List<Contratto> contratti = getContrattiConfermatiListByAgenteId(data_inizio, data_fine, agente.getId(), "data_creazione");
					if(ApplicationUtil.notEmpty(contratti)) {
						try {
							String nomeFile = ApplicationUtil.reportFile(oggi, ConstantsLanguage.CONTRATTI.stampa(), agente.getId()) +  "." + ConstantsMap.pdf;
							ByteArrayOutputStream result = new ByteArrayOutputStream();
							downloadDao.esportaDatiPdfContratto(contratti, result);

							String oggetto = ApplicationUtil.report(ConstantsLanguage.CONTRATTI.stampa() , tipo, oggi);
							String testo = downloadDao.preparaTemplateEmail(ConstantsLanguage.CONTRATTI_IN_ALLEGATO.stampa(), oggi);
							List<Allegato> allegati = ApplicationUtil.allegatiConvertO(result, nomeFile);
							smtpService.invia(ms, percorsoReply, agente.getEmailReport(), null, oggetto, testo , allegati, null);
						} catch (Exception e) {
							ErrorLog.log(null, getClass(), e);
						}
					}
				}
			}
			ms.close();
		}
	}
	@SuppressWarnings("unchecked")
	public void emailNotePDFAgente(int tipo)  {
		Date oggi = ApplicationUtil.date();
		Date data_inizio = ApplicationUtil.dataInizio(tipo, oggi);
		Date data_fine = ApplicationUtil.fineGiornata(oggi);
		DetachedCriteria criteria = DetachedCriteria.forClass(Agente.class);
		List<Agente> agenti = getList(criteria);
		if(ApplicationUtil.notEmpty(agenti)) {
			MailSupport ms = smtpService.getMailSupport(false);
			String percorsoReply = ApplicationUtil.trimToNull(configurazioneGenericService.getValore(DefaultsGeneric.KEY_INVIO_MAIL_REPORT_NOTA));
			Iterator<Agente> objIter = agenti.iterator();
			while(objIter.hasNext()) {
				Agente agente = objIter.next();
				if (ApplicationUtil.isNotBlank(agente.getEmailReport())) {
					List<Nota> note = getNote(data_inizio, data_fine, agente.getId(), "data_creazione");
					if(ApplicationUtil.notEmpty(note)) {
						try {
							String nomeFile = ApplicationUtil.reportFile(oggi, ConstantsLanguage.NOTE.stampa(), agente.getId()) +  "." + ConstantsMap.pdf;
							ByteArrayOutputStream result = new ByteArrayOutputStream();
							downloadDao.esportaDatiPdfNota(note, result);

							String oggetto = ApplicationUtil.report(ConstantsLanguage.NOTE.stampa() , tipo, oggi);
							String testo = downloadDao.preparaTemplateEmail(ConstantsLanguage.NOTE_IN_ALLEGATO.stampa(), oggi);
							List<Allegato> allegati = ApplicationUtil.allegatiConvertO(result, nomeFile);
							smtpService.invia(ms, percorsoReply, agente.getEmailReport(), null, oggetto, testo , allegati, null);
						} catch (Exception e) {
							ErrorLog.log(null, getClass(), e);
						}
					}
				}
			}
			ms.close();
		}
	}
	@SuppressWarnings("unchecked")
	public void emailPrenotazioniPDFAgente(int tipo)  {
		Date oggi = ApplicationUtil.date();
		Date data_inizio = ApplicationUtil.dataInizio(tipo, oggi);
		Date data_fine = ApplicationUtil.fineGiornata(oggi);
		DetachedCriteria criteria = DetachedCriteria.forClass(Agente.class);
		List<Agente> agenti = getList(criteria);
		if(ApplicationUtil.notEmpty(agenti)) {
			MailSupport ms = smtpService.getMailSupport(false);
			String percorsoReply = ApplicationUtil.trimToNull(configurazioneGenericService.getValore(DefaultsGeneric.KEY_INVIO_MAIL_REPORT_PRENOTAZIONE));
			Iterator<Agente> objIter = agenti.iterator();
			while(objIter.hasNext()) {
				Agente agente = objIter.next();
				if (ApplicationUtil.isNotBlank(agente.getEmailReport())) {
					List<Prenotazione> prenotazioni = getPrenotazioni(data_inizio, data_fine, agente.getId(), "data_creazione");
					if(ApplicationUtil.notEmpty(prenotazioni)) {
						try {
							String nomeFile = ApplicationUtil.reportFile(oggi, ConstantsLanguage.PRENOTAZIONI.stampa(), agente.getId()) +  "." + ConstantsMap.pdf;
							ByteArrayOutputStream result = new ByteArrayOutputStream();
							downloadDao.esportaDatiPdfPrenotazione(prenotazioni, result);

							String oggetto = ApplicationUtil.report(ConstantsLanguage.PRENOTAZIONI.stampa() , tipo, oggi);
							String testo = downloadDao.preparaTemplateEmail(ConstantsLanguage.PRENOTAZIONI_IN_ALLEGATO.stampa(), oggi);
							List<Allegato> allegati = ApplicationUtil.allegatiConvertO(result, nomeFile);
							smtpService.invia(ms, percorsoReply, agente.getEmailReport(), null, oggetto, testo , allegati, null);
						} catch (Exception e) {
							ErrorLog.log(null, getClass(), e);
						}
					}
				}
			}
			ms.close();
		}
	}
	public void emailAppuntamentiXLSAdmin(int tipo)  {
		Date oggi = ApplicationUtil.date();
		Date data_inizio = ApplicationUtil.dataInizio(tipo, oggi);
		Date data_fine = ApplicationUtil.fineGiornata(oggi);
		String percorsoEmail = configurazioneGenericService.getValore(DefaultsGeneric.KEY_INVIO_MAIL_REPORT_APPUNTAMENTO);
		if (ApplicationUtil.isNotBlank(percorsoEmail)) {
			List<Appuntamento> appuntamenti = getAppuntamentiList(data_inizio, data_fine);
			if(ApplicationUtil.notEmpty(appuntamenti)) {
				try {
					String nomeFile = ApplicationUtil.reportFile(oggi, ConstantsLanguage.APPUNTAMENTI.stampa()) +  "." + ConstantsMap.xlsx;
					ByteArrayOutputStream result = new ByteArrayOutputStream();
					downloadDao.esportaDatiExcelAppuntamento(appuntamenti, result);

					String oggetto = ApplicationUtil.report(ConstantsLanguage.APPUNTAMENTI.stampa(), tipo , oggi);
					String testo = downloadDao.preparaTemplateEmail(ConstantsLanguage.APPUNTAMENTI_IN_ALLEGATO.stampa(), oggi);
					List<Allegato> allegati = ApplicationUtil.allegatiConvertO(result, nomeFile);
					smtpService.invia(null, percorsoEmail, null, oggetto, testo , allegati, null);
				} catch (Exception e) {
					ErrorLog.log(null, getClass(), e);
				}
			}
		}
	}
	public void emailContrattiXLSAdmin(int tipo)  {
		Date oggi = ApplicationUtil.date();
		Date data_inizio = ApplicationUtil.dataInizio(tipo, oggi);
		Date data_fine = ApplicationUtil.fineGiornata(oggi);
		String percorsoEmail = configurazioneGenericService.getValore(DefaultsGeneric.KEY_INVIO_MAIL_REPORT_CONTRATTO);
		if (ApplicationUtil.isNotBlank(percorsoEmail)) {
			List<Contratto> contratti = getContrattiList(data_inizio, data_fine);
			if(ApplicationUtil.notEmpty(contratti)) {
				try {
					String nomeFile = ApplicationUtil.reportFile(oggi, ConstantsLanguage.CONTRATTI.stampa()) +  "." + ConstantsMap.xlsx;
					ByteArrayOutputStream result = new ByteArrayOutputStream();
					downloadDao.esportaDatiExcelContratto(contratti, result);

					String oggetto = ApplicationUtil.report(ConstantsLanguage.CONTRATTI.stampa() , tipo, oggi);
					String testo = downloadDao.preparaTemplateEmail(ConstantsLanguage.CONTRATTI_IN_ALLEGATO.stampa(), oggi);
					List<Allegato> allegati = ApplicationUtil.allegatiConvertO(result, nomeFile);
					smtpService.invia(null, percorsoEmail, null, oggetto, testo , allegati, null);
				} catch (Exception e) {
					ErrorLog.log(null, getClass(), e);
				}
			}
		}
	}
	public void emailNoteXLSAdmin(int tipo)  {
		Date oggi = ApplicationUtil.date();
		Date data_inizio = ApplicationUtil.dataInizio(tipo, oggi);
		Date data_fine = ApplicationUtil.fineGiornata(oggi);
		String percorsoEmail = configurazioneGenericService.getValore(DefaultsGeneric.KEY_INVIO_MAIL_REPORT_NOTA);
		if (ApplicationUtil.isNotBlank(percorsoEmail)) {
			List<Nota> note = getNota(data_inizio, data_fine);
			if(ApplicationUtil.notEmpty(note)) {
				try {
					String nomeFile = ApplicationUtil.reportFile(oggi, ConstantsLanguage.NOTE.stampa()) +  "." + ConstantsMap.xlsx;
					ByteArrayOutputStream result = new ByteArrayOutputStream();
					downloadDao.esportaDatiExcelNota(note, result);

					String oggetto = ApplicationUtil.report(ConstantsLanguage.NOTE.stampa() , tipo, oggi);
					String testo = downloadDao.preparaTemplateEmail(ConstantsLanguage.NOTE_IN_ALLEGATO.stampa(), oggi);
					List<Allegato> allegati = ApplicationUtil.allegatiConvertO(result, nomeFile);
					smtpService.invia(null, percorsoEmail, null, oggetto, testo , allegati, null);
				} catch (Exception e) {
					ErrorLog.log(null, getClass(), e);
				}
			}
		}
	}
	public void emailPrenotazioniXLSAdmin(int tipo)  {
		Date oggi = ApplicationUtil.date();
		Date data_inizio = ApplicationUtil.dataInizio(tipo, oggi);
		Date data_fine = ApplicationUtil.fineGiornata(oggi);
		String percorsoEmail = configurazioneGenericService.getValore(DefaultsGeneric.KEY_INVIO_MAIL_REPORT_PRENOTAZIONE);
		if (ApplicationUtil.isNotBlank(percorsoEmail)) {
			List<Prenotazione> prenotazioni = getPrenotazione(data_inizio, data_fine);
			if(ApplicationUtil.notEmpty(prenotazioni)) {
				try {
					String nomeFile = ApplicationUtil.reportFile(oggi, ConstantsLanguage.PRENOTAZIONI.stampa()) +  "." + ConstantsMap.xlsx;
					ByteArrayOutputStream result = new ByteArrayOutputStream();
					downloadDao.esportaDatiExcelPrenotazione(prenotazioni, result);

					String oggetto = ApplicationUtil.report(ConstantsLanguage.PRENOTAZIONI.stampa() , tipo, oggi);
					String testo = downloadDao.preparaTemplateEmail(ConstantsLanguage.PRENOTAZIONI_IN_ALLEGATO.stampa(), oggi);
					List<Allegato> allegati = ApplicationUtil.allegatiConvertO(result, nomeFile);
					smtpService.invia(null, percorsoEmail, null, oggetto, testo , allegati, null);
				} catch (Exception e) {
					ErrorLog.log(null, getClass(), e);
				}
			}
		}
	}
	public void emailAppuntamentiPDFAdmin(int tipo)  {
		Date oggi = ApplicationUtil.date();
		Date data_inizio = ApplicationUtil.dataInizio(tipo, oggi);
		Date data_fine = ApplicationUtil.fineGiornata(oggi);
		String percorsoEmail = configurazioneGenericService.getValore(DefaultsGeneric.KEY_INVIO_MAIL_REPORT_APPUNTAMENTO);
		if (ApplicationUtil.isNotBlank(percorsoEmail)) {
			List<Appuntamento> appuntamenti = getAppuntamentiList(data_inizio, data_fine);
			if(ApplicationUtil.notEmpty(appuntamenti)) {
				try {
					String nomeFile = ApplicationUtil.reportFile(oggi, ConstantsLanguage.APPUNTAMENTI.stampa()) +  "." + ConstantsMap.pdf;
					ByteArrayOutputStream result = new ByteArrayOutputStream();
					downloadDao.esportaDatiPdfAppuntamento(appuntamenti, result);

					String oggetto = ApplicationUtil.report(ConstantsLanguage.APPUNTAMENTI.stampa(), tipo , oggi);
					String testo = downloadDao.preparaTemplateEmail(ConstantsLanguage.APPUNTAMENTI_IN_ALLEGATO.stampa(), oggi);
					List<Allegato> allegati = ApplicationUtil.allegatiConvertO(result, nomeFile);
					smtpService.invia(null, percorsoEmail, null, oggetto, testo , allegati, null);
				} catch (Exception e) {
					ErrorLog.log(null, getClass(), e);
				}
			}
		}
	}
	public void emailContrattiPDFAdmin(int tipo)  {
		Date oggi = ApplicationUtil.date();
		Date data_inizio = ApplicationUtil.dataInizio(tipo, oggi);
		Date data_fine = ApplicationUtil.fineGiornata(oggi);
		String percorsoEmail = configurazioneGenericService.getValore(DefaultsGeneric.KEY_INVIO_MAIL_REPORT_CONTRATTO);
		if (ApplicationUtil.isNotBlank(percorsoEmail)) {
			List<Contratto> contratti = getContrattiList(data_inizio, data_fine);
			if(ApplicationUtil.notEmpty(contratti)) {
				try {
					String nomeFile = ApplicationUtil.reportFile(oggi, ConstantsLanguage.CONTRATTI.stampa()) +  "." + ConstantsMap.pdf;
					ByteArrayOutputStream result = new ByteArrayOutputStream();
					downloadDao.esportaDatiPdfContratto(contratti, result);

					String oggetto = ApplicationUtil.report(ConstantsLanguage.CONTRATTI.stampa() , tipo, oggi);
					String testo = downloadDao.preparaTemplateEmail(ConstantsLanguage.CONTRATTI_IN_ALLEGATO.stampa(), oggi);
					List<Allegato> allegati = ApplicationUtil.allegatiConvertO(result, nomeFile);
					smtpService.invia(null, percorsoEmail, null, oggetto, testo , allegati, null);
				} catch (Exception e) {
					ErrorLog.log(null, getClass(), e);
				}
			}
		}
	}
	public void emailNotePDFAdmin(int tipo)  {
		Date oggi = ApplicationUtil.date();
		Date data_inizio = ApplicationUtil.dataInizio(tipo, oggi);
		Date data_fine = ApplicationUtil.fineGiornata(oggi);
		String percorsoEmail = configurazioneGenericService.getValore(DefaultsGeneric.KEY_INVIO_MAIL_REPORT_NOTA);
		if (ApplicationUtil.isNotBlank(percorsoEmail)) {
			List<Nota> note = getNota(data_inizio, data_fine);
			if(ApplicationUtil.notEmpty(note)) {
				try {
					String nomeFile = ApplicationUtil.reportFile(oggi, ConstantsLanguage.NOTE.stampa()) +  "." + ConstantsMap.pdf;
					ByteArrayOutputStream result = new ByteArrayOutputStream();
					downloadDao.esportaDatiPdfNota(note, result);

					String oggetto = ApplicationUtil.report(ConstantsLanguage.NOTE.stampa() , tipo, oggi);
					String testo = downloadDao.preparaTemplateEmail(ConstantsLanguage.NOTE_IN_ALLEGATO.stampa(), oggi);
					List<Allegato> allegati = ApplicationUtil.allegatiConvertO(result, nomeFile);
					smtpService.invia(null, percorsoEmail, null, oggetto, testo , allegati, null);
				} catch (Exception e) {
					ErrorLog.log(null, getClass(), e);
				}
			}
		}
	}
	public void emailPrenotazioniPDFAdmin(int tipo)  {
		Date oggi = ApplicationUtil.date();
		Date data_inizio = ApplicationUtil.dataInizio(tipo, oggi);
		Date data_fine = ApplicationUtil.fineGiornata(oggi);
		String percorsoEmail = configurazioneGenericService.getValore(DefaultsGeneric.KEY_INVIO_MAIL_REPORT_PRENOTAZIONE);
		if (ApplicationUtil.isNotBlank(percorsoEmail)) {
			List<Prenotazione> prenotazioni = getPrenotazione(data_inizio, data_fine);
			if(ApplicationUtil.notEmpty(prenotazioni)) {
				try {
					String nomeFile = ApplicationUtil.reportFile(oggi, ConstantsLanguage.PRENOTAZIONI.stampa()) +  "." + ConstantsMap.pdf;
					ByteArrayOutputStream result = new ByteArrayOutputStream();
					downloadDao.esportaDatiPdfPrenotazione(prenotazioni, result);

					String oggetto = ApplicationUtil.report(ConstantsLanguage.PRENOTAZIONI.stampa() , tipo, oggi);
					String testo = downloadDao.preparaTemplateEmail(ConstantsLanguage.PRENOTAZIONI_IN_ALLEGATO.stampa(), oggi);
					List<Allegato> allegati = ApplicationUtil.allegatiConvertO(result, nomeFile);
					smtpService.invia(null, percorsoEmail, null, oggetto, testo , allegati, null);
				} catch (Exception e) {
					ErrorLog.log(null, getClass(), e);
				}
			}
		}
	}
	public void emailStoriaContattoXLSAdmin(int tipo)  {
		Date oggi = ApplicationUtil.date();
		Date data_inizio = ApplicationUtil.dataInizio(tipo, oggi);
		Date data_fine = ApplicationUtil.fineGiornata(oggi);
		String percorsoEmail = configurazioneGenericService.getValore(DefaultsGeneric.KEY_INVIO_MAIL_REPORT_CONTATTO);
		if (ApplicationUtil.isNotBlank(percorsoEmail)) {
			List<StoriaContatto> st = getStoriaContatto(data_inizio, data_fine);
			if(ApplicationUtil.notEmpty(st)) {
				try {
					String nomeFile = ApplicationUtil.reportFile(oggi, ConstantsLanguage.STORIA.stampa(), ConstantsLanguage.CONTATTI.stampa()) +  "." + ConstantsMap.xlsx;
					ByteArrayOutputStream result = new ByteArrayOutputStream();
					downloadDao.esportaDatiExcelStoriaContatto(st, result);

					String oggetto = ApplicationUtil.report(ConstantsLanguage.STORIA.stampa() + " " + ConstantsLanguage.CONTATTI.stampa() , tipo, oggi);
					String testo = downloadDao.preparaTemplateEmail(ConstantsLanguage.CONTATTI_IN_ALLEGATO.stampa(), oggi);
					List<Allegato> allegati = ApplicationUtil.allegatiConvertO(result, nomeFile);
					smtpService.invia(null, percorsoEmail, null, oggetto, testo , allegati, null);
				} catch (Exception e) {
					ErrorLog.log(null, getClass(), e);
				}
			}
		}
	}
	public void emailStoriaContrattoXLSAdmin(int tipo)  {
		Date oggi = ApplicationUtil.date();
		Date data_inizio = ApplicationUtil.dataInizio(tipo, oggi);
		Date data_fine = ApplicationUtil.fineGiornata(oggi);
		String percorsoEmail = configurazioneGenericService.getValore(DefaultsGeneric.KEY_INVIO_MAIL_REPORT_CONTRATTO);
		if (ApplicationUtil.isNotBlank(percorsoEmail)) {
			List<StoriaContratto> st = getStoriaContratto(data_inizio, data_fine);
			if(ApplicationUtil.notEmpty(st)) {
				try {
					String nomeFile = ApplicationUtil.reportFile(oggi, ConstantsLanguage.STORIA.stampa(), ConstantsLanguage.CONTRATTI.stampa()) +  "." + ConstantsMap.xlsx;
					ByteArrayOutputStream result = new ByteArrayOutputStream();
					downloadDao.esportaDatiExcelStoriaContratto(st, result);

					String oggetto = ApplicationUtil.report(ConstantsLanguage.STORIA.stampa() + " " + ConstantsLanguage.CONTRATTI.stampa() , tipo, oggi);
					String testo = downloadDao.preparaTemplateEmail(ConstantsLanguage.CONTRATTI_IN_ALLEGATO.stampa(), oggi);
					List<Allegato> allegati = ApplicationUtil.allegatiConvertO(result, nomeFile);
					smtpService.invia(null, percorsoEmail, null, oggetto, testo , allegati, null);
				} catch (Exception e) {
					ErrorLog.log(null, getClass(), e);
				}
			}
		}
	}
	public void emailStoriaAppuntamentoXLSAdmin(int tipo)  {
		Date oggi = ApplicationUtil.date();
		Date data_inizio = ApplicationUtil.dataInizio(tipo, oggi);
		Date data_fine = ApplicationUtil.fineGiornata(oggi);
		String percorsoEmail = configurazioneGenericService.getValore(DefaultsGeneric.KEY_INVIO_MAIL_REPORT_APPUNTAMENTO);
		if (ApplicationUtil.isNotBlank(percorsoEmail)) {
			List<StoriaAppuntamento> st = getStoriaAppuntamento(data_inizio, data_fine);
			if(ApplicationUtil.notEmpty(st)) {
				try {
					String nomeFile = ApplicationUtil.reportFile(oggi, ConstantsLanguage.STORIA.stampa(), ConstantsLanguage.APPUNTAMENTI.stampa()) +  "." + ConstantsMap.xlsx;
					ByteArrayOutputStream result = new ByteArrayOutputStream();
					downloadDao.esportaDatiExcelStoriaAppuntamento(st, result);

					String oggetto = ApplicationUtil.report(ConstantsLanguage.STORIA.stampa() + " " +ConstantsLanguage.APPUNTAMENTI.stampa() , tipo, oggi);
					String testo = downloadDao.preparaTemplateEmail(ConstantsLanguage.APPUNTAMENTI_IN_ALLEGATO.stampa(), oggi);
					List<Allegato> allegati = ApplicationUtil.allegatiConvertO(result, nomeFile);
					smtpService.invia(null, percorsoEmail, null, oggetto, testo , allegati, null);
				} catch (Exception e) {
					ErrorLog.log(null, getClass(), e);
				}
			}
		}
	}
	public void emailStoriaContattoPDFAdmin(int tipo)  {
		Date oggi = ApplicationUtil.date();
		Date data_inizio = ApplicationUtil.dataInizio(tipo, oggi);
		Date data_fine = ApplicationUtil.fineGiornata(oggi);
		String percorsoEmail = configurazioneGenericService.getValore(DefaultsGeneric.KEY_INVIO_MAIL_REPORT_CONTATTO);
		if (ApplicationUtil.isNotBlank(percorsoEmail)) {
			List<StoriaContatto> st = getStoriaContatto(data_inizio, data_fine);
			if(ApplicationUtil.notEmpty(st)) {
				try {
					String nomeFile = ApplicationUtil.reportFile(oggi, ConstantsLanguage.STORIA.stampa(), ConstantsLanguage.CONTATTI.stampa()) +  "." + ConstantsMap.pdf;
					ByteArrayOutputStream result = new ByteArrayOutputStream();
					downloadDao.esportaDatiPdfStoriaContatto(st, result);

					String oggetto = ApplicationUtil.report(ConstantsLanguage.STORIA.stampa() + " " +ConstantsLanguage.CONTATTI.stampa() , tipo, oggi);
					String testo = downloadDao.preparaTemplateEmail(ConstantsLanguage.CONTATTI_IN_ALLEGATO.stampa(), oggi);
					List<Allegato> allegati = ApplicationUtil.allegatiConvertO(result, nomeFile);
					smtpService.invia(null, percorsoEmail, null, oggetto, testo , allegati, null);
				} catch (Exception e) {
					ErrorLog.log(null, getClass(), e);
				}
			}
		}
	}
	public void emailStoriaContrattoPDFAdmin(int tipo)  {
		Date oggi = ApplicationUtil.date();
		Date data_inizio = ApplicationUtil.dataInizio(tipo, oggi);
		Date data_fine = ApplicationUtil.fineGiornata(oggi);
		String percorsoEmail = configurazioneGenericService.getValore(DefaultsGeneric.KEY_INVIO_MAIL_REPORT_CONTRATTO);
		if (ApplicationUtil.isNotBlank(percorsoEmail)) {
			List<StoriaContratto> st = getStoriaContratto(data_inizio, data_fine);
			if(ApplicationUtil.notEmpty(st)) {
				try {
					String nomeFile = ApplicationUtil.reportFile(oggi, ConstantsLanguage.STORIA.stampa(), ConstantsLanguage.CONTRATTI.stampa()) +  "." + ConstantsMap.pdf;
					ByteArrayOutputStream result = new ByteArrayOutputStream();
					downloadDao.esportaDatiPdfStoriaContratto(st, result);

					String oggetto = ApplicationUtil.report(ConstantsLanguage.STORIA.stampa() + " " +ConstantsLanguage.CONTRATTI.stampa() , tipo, oggi);
					String testo = downloadDao.preparaTemplateEmail(ConstantsLanguage.CONTRATTI_IN_ALLEGATO.stampa(), oggi);
					List<Allegato> allegati = ApplicationUtil.allegatiConvertO(result, nomeFile);
					smtpService.invia(null, percorsoEmail, null, oggetto, testo , allegati, null);
				} catch (Exception e) {
					ErrorLog.log(null, getClass(), e);
				}
			}
		}
	}
	public void emailStoriaAppuntamentoPDFAdmin(int tipo)  {
		Date oggi = ApplicationUtil.date();
		Date data_inizio = ApplicationUtil.dataInizio(tipo, oggi);
		Date data_fine = ApplicationUtil.fineGiornata(oggi);
		String percorsoEmail = configurazioneGenericService.getValore(DefaultsGeneric.KEY_INVIO_MAIL_REPORT_APPUNTAMENTO);
		if (ApplicationUtil.isNotBlank(percorsoEmail)) {
			List<StoriaAppuntamento> st = getStoriaAppuntamento(data_inizio, data_fine);
			if(ApplicationUtil.notEmpty(st)) {
				try {
					String nomeFile = ApplicationUtil.reportFile(oggi, ConstantsLanguage.STORIA.stampa(), ConstantsLanguage.APPUNTAMENTI.stampa()) +  "." + ConstantsMap.pdf;
					ByteArrayOutputStream result = new ByteArrayOutputStream();
					downloadDao.esportaDatiPdfStoriaAppuntamento(st, result);

					String oggetto = ApplicationUtil.report(ConstantsLanguage.STORIA.stampa() + " " +ConstantsLanguage.APPUNTAMENTI.stampa() , tipo, oggi);
					String testo = downloadDao.preparaTemplateEmail(ConstantsLanguage.APPUNTAMENTI_IN_ALLEGATO.stampa(), oggi);
					List<Allegato> allegati = ApplicationUtil.allegatiConvertO(result, nomeFile);
					smtpService.invia(null, percorsoEmail, null, oggetto, testo , allegati, null);
				} catch (Exception e) {
					ErrorLog.log(null, getClass(), e);
				}
			}
		}
	}
	public void emailLista(Integer tipo)  {
		String percorsoEmail = configurazioneGenericService.getValore(DefaultsGeneric.KEY_INVIO_MAIL_REPORT_LISTA);
		if (ApplicationUtil.isNotBlank(percorsoEmail)) {
			Date oggi = ApplicationUtil.date();
			try {
				String nomeFile = ApplicationUtil.reportFile(oggi, ConstantsLanguage.RIEPILOGO.stampa(), ConstantsLanguage.LISTA.stampa()) + "." + ConstantsMap.xlsx; 
				ByteArrayOutputStream result = new ByteArrayOutputStream();
				reportDao.exportReportLista(tipo, result);
				String testo = downloadDao.preparaTemplateEmail(ConstantsLanguage.REPORT_IN_ALLEGATO.stampa(), oggi);

				String oggetto = ApplicationUtil.report(ConstantsLanguage.RIEPILOGO.stampa() + " " + ConstantsLanguage.LISTA.stampa()  , tipo, oggi);
				List<Allegato> allegati = ApplicationUtil.allegatiConvertO(result, nomeFile);
				smtpService.invia(null, percorsoEmail, null, oggetto, testo , allegati, null);
			} catch (Exception e) {
				ErrorLog.log(null, getClass(), e);
			}
		}
	}
	public void emailListaStoria(Integer tipo)  {
		String percorsoEmail = configurazioneGenericService.getValore(DefaultsGeneric.KEY_INVIO_MAIL_REPORT_LISTA);
		if (ApplicationUtil.isNotBlank(percorsoEmail)) {
			Date oggi = ApplicationUtil.date();
			try {
				String nomeFile = ApplicationUtil.reportFile(oggi, ConstantsLanguage.REPORT.stampa(), ConstantsLanguage.LISTA.stampa()) + "." + ConstantsMap.xlsx; 
				ByteArrayOutputStream result = new ByteArrayOutputStream();
				reportDao.exportReportListaStoria(tipo, result);
				String testo = downloadDao.preparaTemplateEmail(ConstantsLanguage.REPORT_IN_ALLEGATO.stampa(), oggi);

				String oggetto = ApplicationUtil.report(ConstantsLanguage.REPORT.stampa() + " " + ConstantsLanguage.LISTA.stampa()  , tipo, oggi);
				List<Allegato> allegati = ApplicationUtil.allegatiConvertO(result, nomeFile);
				smtpService.invia(null, percorsoEmail, null, oggetto, testo , allegati, null);
			} catch (Exception e) {
				ErrorLog.log(null, getClass(), e);
			}
		}
	}
	public void emailReportOperatoreStoria(Integer tipo)  {
		String percorsoEmail = configurazioneGenericService.getValore(DefaultsGeneric.KEY_INVIO_MAIL_REPORT_OPERATORE);
		if (ApplicationUtil.isNotBlank(percorsoEmail)) {
			Date oggi = ApplicationUtil.date();
			try {
				String nomeFile = ApplicationUtil.reportFile(oggi, ConstantsLanguage.REPORT.stampa(), ConstantsLanguage.OPERATORI.stampa()) + "." + ConstantsMap.xlsx; 
				ByteArrayOutputStream result = new ByteArrayOutputStream();
				reportDao.exportReportOperatoreStoria(tipo, result);
				String testo = downloadDao.preparaTemplateEmail(ConstantsLanguage.REPORT_IN_ALLEGATO.stampa(), oggi);

				String oggetto = ApplicationUtil.report(ConstantsLanguage.REPORT_OPERATORE.stampa() , tipo, oggi);
				List<Allegato> allegati = ApplicationUtil.allegatiConvertO(result, nomeFile);
				smtpService.invia(null, percorsoEmail, null, oggetto, testo , allegati, null);
			} catch (Exception e) {
				ErrorLog.log(null, getClass(), e);
			}
		}
	}
	public void emailReportOperatore(Integer tipo)  {
		String percorsoEmail = configurazioneGenericService.getValore(DefaultsGeneric.KEY_INVIO_MAIL_REPORT_OPERATORE);
		if (ApplicationUtil.isNotBlank(percorsoEmail)) {
			Date oggi = ApplicationUtil.date();
			try {
				String nomeFile = ApplicationUtil.reportFile(oggi, ConstantsLanguage.RIEPILOGO.stampa(), ConstantsLanguage.OPERATORI.stampa()) + "." + ConstantsMap.xlsx; 
				ByteArrayOutputStream result = new ByteArrayOutputStream();
				reportDao.exportReportOperatore(tipo, result);
				String testo = downloadDao.preparaTemplateEmail(ConstantsLanguage.REPORT_IN_ALLEGATO.stampa(), oggi);

				String oggetto = ApplicationUtil.report(ConstantsLanguage.RIEPILOGO_OPERATORE.stampa() , tipo, oggi);
				List<Allegato> allegati = ApplicationUtil.allegatiConvertO(result, nomeFile);
				smtpService.invia(null, percorsoEmail, null, oggetto, testo, allegati, null);
			} catch (Exception e) {
				ErrorLog.log(null, getClass(), e);
			}
		}
	}
	public void emailReportListaEsitoStoria(Integer tipo)  {
		String percorsoEmail = configurazioneGenericService.getValore(DefaultsGeneric.KEY_INVIO_MAIL_REPORT_LISTA);
		if (ApplicationUtil.isNotBlank(percorsoEmail)) {
			Date oggi = ApplicationUtil.date();
			try {
				String nomeFile = ApplicationUtil.reportFile(oggi, ConstantsLanguage.REPORT.stampa(), ConstantsLanguage.LISTE.stampa()) + "." + ConstantsMap.xlsx; 
				ByteArrayOutputStream result = new ByteArrayOutputStream();
				reportDao.exportReportListaEsitoStoria(tipo, result);
				String testo = downloadDao.preparaTemplateEmail(ConstantsLanguage.REPORT_IN_ALLEGATO.stampa(), oggi);

				String oggetto = ApplicationUtil.report(ConstantsLanguage.REPORT_LISTE.stampa() , tipo, oggi);
				List<Allegato> allegati = ApplicationUtil.allegatiConvertO(result, nomeFile);
				smtpService.invia(null, percorsoEmail, null, oggetto, testo , allegati, null);
			} catch (Exception e) {
				ErrorLog.log(null, getClass(), e);
			}
		}
	}
	public void emailReportListaEsito(Integer tipo)  {
		String percorsoEmail = configurazioneGenericService.getValore(DefaultsGeneric.KEY_INVIO_MAIL_REPORT_LISTA);
		if (ApplicationUtil.isNotBlank(percorsoEmail)) {
			Date oggi = ApplicationUtil.date();
			try {
				String nomeFile = ApplicationUtil.reportFile(oggi, ConstantsLanguage.RIEPILOGO.stampa(), ConstantsLanguage.LISTE.stampa()) + "." + ConstantsMap.xlsx; 
				ByteArrayOutputStream result = new ByteArrayOutputStream();
				reportDao.exportReportListaEsito(tipo, result);
				String testo = downloadDao.preparaTemplateEmail(ConstantsLanguage.REPORT_IN_ALLEGATO.stampa(), oggi);

				String oggetto = ApplicationUtil.report(ConstantsLanguage.RIEPILOGO_LISTE.stampa() , tipo, oggi);
				List<Allegato> allegati = ApplicationUtil.allegatiConvertO(result, nomeFile);
				smtpService.invia(null, percorsoEmail, null, oggetto, testo , allegati, null);
			} catch (Exception e) {
				ErrorLog.log(null, getClass(), e);
			}
		}
	}
	public void eliminaRegistrazioni(Integer intervallo) {
		Date data = ApplicationUtil.intervallo(intervallo);
		if(data != null) {
			String monitor = ConstantsGlobal.path_monitor;
			if(ApplicationUtil.isNotTrue(impostazioneDao.getFTPEnabled())) {
				String home = impostazioneDao.getHome();
				File perc = new File(home + monitor);
				if(perc.exists()) {
					Path folder = Paths.get(perc.getAbsolutePath());
					DirectoryStream<Path> stream = ApplicationUtil.streamFile(folder, "." + ConstantsMap.wav);
					if(stream != null) {
						for(Path entry : stream) {
							File file = entry.toFile();
							if(ApplicationUtil.dataIntervalD(null, data, ApplicationUtil.date(file.lastModified()))) {
								ApplicationUtil.deleteFile(file);
							}
						}
					}
				}
			} else {
				UtilFTP ut = impostazioneDao.getUtilFTP();
				FTPClient vmftp = ApplicationUtil.createClient();
				if (ApplicationUtil.connect(vmftp, ut)) {
					try {
						FTPFile[] wavFiles = ApplicationUtil.listMonitor(vmftp, monitor + "/", null, ConstantsMap.wav);
						if (ApplicationUtil.notEmpty(wavFiles)) {
							for(FTPFile file : wavFiles) {
								Long time = ApplicationUtil.time(file.getTimestamp());
								if(ApplicationUtil.dataIntervalD(null, data, ApplicationUtil.date(time))) {
									ApplicationUtil.deleteFile(vmftp, monitor + "/" + ApplicationUtil.getNameN(file.getName()));
								}
							}
						}
					} catch (Exception e) {
						ErrorLog.log(null, getClass(), e);
					} finally {
						ApplicationUtil.disconnect(vmftp);
					}
				}	
			}
		}
	}
	public void eliminaPDA(Integer intervallo) {
		Date data = ApplicationUtil.intervallo(intervallo);
		if(data != null) {
			File perc = new File(impostazioneDao.getPathBase(ConstantsGlobal.path_pda));
			if(perc.exists() && perc.isDirectory()) {
				File [] files = perc.listFiles();
				if(ApplicationUtil.notEmpty(files)) {
					for(File file : files) {
						if(ApplicationUtil.dataIntervalD(null, data, ApplicationUtil.date(file.lastModified()))) {
							ApplicationUtil.deleteFile(file);
						}
					}
				}
			}
		}
	}
	public void eliminaBackupImport(Integer intervallo, String path) {
		Date data = ApplicationUtil.intervallo(intervallo);
		if(data != null) {
			File perc = new File(impostazioneDao.getPathBase(path));
			if(perc.exists() && perc.isDirectory()) {
				File [] files = perc.listFiles();
				if(ApplicationUtil.notEmpty(files)) {
					for(File file : files) {
						if(ApplicationUtil.dataIntervalD(null, data, ApplicationUtil.date(file.lastModified()))) {
							ApplicationUtil.deleteFile(file);
						}
					}
				}
			}
		}
	}
	public 	void eliminaBackupDatabase(Integer intervallo) {
		Date data = ApplicationUtil.intervallo(intervallo);
		if(data != null) {
			String home = impostazioneDao.getHome();
			File perc = new File(home + ConstantsGlobal.path_backup + "/");
			if(perc.exists() && perc.isDirectory()) {
				File [] files = perc.listFiles();
				if(ApplicationUtil.notEmpty(files)) {
					for(File file : files) {
						if(ApplicationUtil.dataIntervalD(null, data, ApplicationUtil.date(file.lastModified()))) {
							ApplicationUtil.deleteFile(file);
						}
					}
				}
			}
		}
	}
	public void setApplicationContext(ApplicationContext applicationContext)  {
		dataDao.ricaricaPeer();
		dataDao.ricaricaCalendar();
	}

	public void sincronizzaStorage() {
		sincronizzaFile(AllegatoAgente.class, ConstantsGlobal.path_agente);
		sincronizzaFile(AllegatoAnagrafica.class, ConstantsGlobal.path_anagrafica);
		sincronizzaFile(AllegatoContatto.class, ConstantsGlobal.path_contatto);
		sincronizzaFile(AllegatoContratto.class, ConstantsGlobal.path_contratto);
		sincronizzaFile(AllegatoAppuntamento.class, ConstantsGlobal.path_appuntamento);
		sincronizzaFile(AllegatoNotizia.class, ConstantsGlobal.path_notizia);
	}
	@SuppressWarnings("unchecked")
	private void sincronizzaFile(Class<?> clazz, String path) {
		DetachedCriteria criteria = DetachedCriteria.forClass(clazz);
		criteria.add(Restrictions.isNotNull("percorso"));
		criteria.add(Restrictions.isNull("content"));
		criteria.setProjection(Projections.distinct(Projections.property("percorso")));
		List<String> esistente = getList(criteria);
		String s = impostazioneDao.getPathBaseR(path);
		File perc = new File(s);
		String [] files = perc.list();
		if(ApplicationUtil.notEmpty(files)) {
			for(String file : files) {
				if(!esistente.contains("/" + file)) {
					ApplicationUtil.deleteFile(s + "/" + file);
				}
			}
		}
	}
	public void emailAnagrafichePDF(int tipo)  {
		Date oggi = ApplicationUtil.date();
		Date data_inizio = ApplicationUtil.dataInizio(tipo, oggi);
		Date data_fine = ApplicationUtil.fineGiornata(oggi);
		String percorsoEmail = configurazioneGenericService.getValore(DefaultsGeneric.KEY_INVIO_MAIL_AMMINISTRAZIONE);
		if (ApplicationUtil.isNotBlank(percorsoEmail)) {
			List<Anagrafica> contratti = getAnagraficheList(data_inizio, data_fine);
			if(ApplicationUtil.notEmpty(contratti)) {
				try {
					String nomeFile = ApplicationUtil.reportFile(oggi, ConstantsLanguage.ANAGRAFICHE.stampa()) +  "." + ConstantsMap.pdf;
					ByteArrayOutputStream result = new ByteArrayOutputStream();
					downloadDao.esportaDatiPdfAnagrafica(contratti, result);
					String oggetto = ApplicationUtil.report(ConstantsLanguage.ANAGRAFICHE.stampa() + " " + ConstantsLanguage.LAVORATO.stampa(), tipo , oggi);
					String testo = downloadDao.preparaTemplateEmail(ConstantsLanguage.ANAGRAFICHE_IN_ALLEGATO.stampa(), oggi);
					List<Allegato> allegati = ApplicationUtil.allegatiConvertO(result, nomeFile);
					smtpService.invia(null, percorsoEmail, null, oggetto, testo , allegati, null);
				} catch (Exception e) {
					ErrorLog.log(null, getClass(), e);
				}
			}
		}
	}
	public void emailAnagraficheXLS(int tipo)  {
		Date oggi = ApplicationUtil.date();
		Date data_inizio = ApplicationUtil.dataInizio(tipo, oggi);
		Date data_fine = ApplicationUtil.fineGiornata(oggi);
		String percorsoEmail = configurazioneGenericService.getValore(DefaultsGeneric.KEY_INVIO_MAIL_AMMINISTRAZIONE);
		if (ApplicationUtil.isNotBlank(percorsoEmail)) {
			List<Anagrafica> contratti = getAnagraficheList(data_inizio, data_fine);
			if(ApplicationUtil.notEmpty(contratti)) {
				try {
					String nomeFile = ApplicationUtil.reportFile(oggi, ConstantsLanguage.ANAGRAFICHE.stampa()) +  "." + ConstantsMap.xlsx;
					ByteArrayOutputStream result = new ByteArrayOutputStream();
					downloadDao.esportaDatiExcelAnagrafica(contratti, result);
					String oggetto = ApplicationUtil.report(ConstantsLanguage.ANAGRAFICHE.stampa() + " " + ConstantsLanguage.LAVORATO.stampa(), tipo , oggi);
					String testo = downloadDao.preparaTemplateEmail(ConstantsLanguage.ANAGRAFICHE_IN_ALLEGATO.stampa(), oggi);
					List<Allegato> allegati = ApplicationUtil.allegatiConvertO(result, nomeFile);
					smtpService.invia(null, percorsoEmail, null, oggetto, testo , allegati, null);
				} catch (Exception e) {
					ErrorLog.log(null, getClass(), e);
				}
			}
		}
	}
	public void spostaDB2FILE()  {
		try {
			spostaD2F(AllegatoNotizia.class, ConstantsGlobal.path_notizia);
			spostaD2F(AllegatoAgente.class, ConstantsGlobal.path_agente);
			spostaD2F(AllegatoAnagrafica.class, ConstantsGlobal.path_anagrafica);
			spostaD2F(AllegatoContatto.class, ConstantsGlobal.path_contatto);
			spostaD2F(AllegatoAppuntamento.class, ConstantsGlobal.path_appuntamento);
			spostaD2F(AllegatoContratto.class, ConstantsGlobal.path_contratto);
		} catch (Exception e) {
			ErrorLog.log(null, getClass(), e);
		}
	}
	public void spostaFILE2DB()  {
		try {
			spostaF2D(AllegatoNotizia.class, ConstantsGlobal.path_notizia);
			spostaF2D(AllegatoAgente.class, ConstantsGlobal.path_agente);
			spostaF2D(AllegatoAnagrafica.class, ConstantsGlobal.path_anagrafica);
			spostaF2D(AllegatoContatto.class, ConstantsGlobal.path_contatto);
			spostaF2D(AllegatoAppuntamento.class, ConstantsGlobal.path_appuntamento);
			spostaF2D(AllegatoContratto.class, ConstantsGlobal.path_contratto);
		} catch (Exception e) {
			ErrorLog.log(null, getClass(), e);
		}
	}


	public void spostaDB2LOGO()  {
		try {
			spostaD2L(Campagna.class);
			spostaD2L(Prodotto.class);
			spostaD2L(Tema.class);
		} catch (Exception e) {
			ErrorLog.log(null, getClass(), e);
		}
	}
	public void spostaLOGO2DB()  {
		try {
			spostaL2D(Campagna.class);
			spostaL2D(Prodotto.class);
			spostaL2D(Tema.class);
		} catch (Exception e) {
			ErrorLog.log(null, getClass(), e);
		}
	}

	@SuppressWarnings("unchecked")
	private void spostaD2F(Class<?> c, String pathB) throws Exception  {
		List<Object> lst = new ArrayList<Object>();
		DetachedCriteria criteria = DetachedCriteria.forClass(c);
		criteria.add(Restrictions.isNotNull("content"));
		criteria.add(Restrictions.isNull("percorso"));
		lst.addAll(getList(criteria));
		String path = impostazioneDao.getPathBaseR(pathB);
		for(Object obj : lst) {
			if(obj instanceof AllegatoContratto) {
				AllegatoContratto a = (AllegatoContratto) obj;
				String percorso  = "/" +System.currentTimeMillis();
				ApplicationUtil.writeByteArrayToFile(new File(path + percorso), a.getContent());
				a.setPercorso(percorso);
				a.setContent(null);
				salvaAggiorna(a);
			}
			if(obj instanceof AllegatoContatto) {
				AllegatoContatto a = (AllegatoContatto) obj;
				String percorso  = "/" +System.currentTimeMillis();
				ApplicationUtil.writeByteArrayToFile(new File(path + percorso), a.getContent());
				a.setPercorso(percorso);
				a.setContent(null);
				salvaAggiorna(a);
			}
			if(obj instanceof AllegatoAppuntamento) {
				AllegatoAppuntamento a = (AllegatoAppuntamento) obj;
				String percorso  = "/" +System.currentTimeMillis();
				ApplicationUtil.writeByteArrayToFile(new File(path + percorso), a.getContent());
				a.setPercorso(percorso);
				a.setContent(null);
				salvaAggiorna(a);
			}
			if(obj instanceof AllegatoAgente) {
				AllegatoAgente a = (AllegatoAgente) obj;
				String percorso  = "/" +System.currentTimeMillis();
				ApplicationUtil.writeByteArrayToFile(new File(path + percorso), a.getContent());
				a.setPercorso(percorso);
				a.setContent(null);
				salvaAggiorna(a);
			}
			if(obj instanceof AllegatoAnagrafica) {
				AllegatoAnagrafica a = (AllegatoAnagrafica) obj;
				String percorso  = "/" +System.currentTimeMillis();
				ApplicationUtil.writeByteArrayToFile(new File(path + percorso), a.getContent());
				a.setPercorso(percorso);
				a.setContent(null);
				salvaAggiorna(a);
			}
			if(obj instanceof AllegatoNotizia) {
				AllegatoNotizia a = (AllegatoNotizia) obj;
				String percorso  = "/" +System.currentTimeMillis();
				ApplicationUtil.writeByteArrayToFile(new File(path + percorso), a.getContent());
				a.setPercorso(percorso);
				a.setContent(null);
				salvaAggiorna(a);
			}
		}
	}

	@SuppressWarnings("unchecked")
	private void spostaF2D(Class<?> c, String pathB) throws Exception  {
		List<Object> lst = new ArrayList<Object>();
		DetachedCriteria criteria = DetachedCriteria.forClass(c);
		criteria.add(Restrictions.isNull("content"));
		criteria.add(Restrictions.isNotNull("percorso"));
		lst.addAll(getList(criteria));
		String path = impostazioneDao.getPathBaseR(pathB);
		for(Object obj : lst) {
			if(obj instanceof AllegatoContratto) {
				AllegatoContratto a = (AllegatoContratto) obj;
				File f = new File(path + a.getPercorso());
				if(f.exists()) {
					a.setContent(ApplicationUtil.readFileToByteArray(f));
					a.setPercorso(null);
					salvaAggiorna(a);
					ApplicationUtil.deleteFile(f);
				}
			}
			if(obj instanceof AllegatoContatto) {
				AllegatoContatto a = (AllegatoContatto) obj;
				File f = new File(path + a.getPercorso());
				if(f.exists()) {
					a.setContent(ApplicationUtil.readFileToByteArray(f));
					a.setPercorso(null);
					salvaAggiorna(a);
					ApplicationUtil.deleteFile(f);
				}
			}
			if(obj instanceof AllegatoAppuntamento) {
				AllegatoAppuntamento a = (AllegatoAppuntamento) obj;
				File f = new File(path + a.getPercorso());
				if(f.exists()) {
					a.setContent(ApplicationUtil.readFileToByteArray(f));
					a.setPercorso(null);
					salvaAggiorna(a);
					ApplicationUtil.deleteFile(f);
				}
			}
			if(obj instanceof AllegatoAgente) {
				AllegatoAgente a = (AllegatoAgente) obj;
				File f = new File(path + a.getPercorso());
				if(f.exists()) {
					a.setContent(ApplicationUtil.readFileToByteArray(f));
					a.setPercorso(null);
					salvaAggiorna(a);
					ApplicationUtil.deleteFile(f);
				}
			}
			if(obj instanceof AllegatoAnagrafica) {
				AllegatoAnagrafica a = (AllegatoAnagrafica) obj;
				File f = new File(path + a.getPercorso());
				if(f.exists()) {
					a.setContent(ApplicationUtil.readFileToByteArray(f));
					a.setPercorso(null);
					salvaAggiorna(a);
					ApplicationUtil.deleteFile(f);
				}
			}
			if(obj instanceof AllegatoNotizia) {
				AllegatoNotizia a = (AllegatoNotizia) obj;
				File f = new File(path + a.getPercorso());
				if(f.exists()) {
					a.setContent(ApplicationUtil.readFileToByteArray(f));
					a.setPercorso(null);
					salvaAggiorna(a);
					ApplicationUtil.deleteFile(f);
				}
			}
		}
	}


	@SuppressWarnings("unchecked")
	private void spostaL2D(Class<?> c) throws Exception  {
		List<Object> lst = new ArrayList<Object>();
		DetachedCriteria criteria = DetachedCriteria.forClass(c);
		criteria.add(Restrictions.isNotNull("content"));
		lst.addAll(getList(criteria));
		String path = impostazioneDao.getPercorsoImmagini() + "/";
		for(Object obj : lst) {
			if(obj instanceof Campagna) {
				Campagna a = (Campagna) obj;
				File f = new File(path + new String(a.getContent(), ConstantsGlobal.CHARSET));
				if(f.exists()) {
					a.setContent(ApplicationUtil.readFileToByteArray(f));
					salvaAggiorna(a);
				}
			}
			if(obj instanceof Prodotto) {
				Prodotto a = (Prodotto) obj;
				File f = new File(path + new String(a.getContent(), ConstantsGlobal.CHARSET));
				if(f.exists()) {
					a.setContent(ApplicationUtil.readFileToByteArray(f));
					salvaAggiorna(a);
				}
			}
			if(obj instanceof Tema) {
				Tema a = (Tema) obj;
				File f = new File(path + new String(a.getContent(), ConstantsGlobal.CHARSET));
				if(f.exists()) {
					a.setContent(ApplicationUtil.readFileToByteArray(f));
					salvaAggiorna(a);
				}
			}
		}
	}

	@SuppressWarnings("unchecked")
	private void spostaD2L(Class<?> c) throws Exception  {
		List<Object> lst = new ArrayList<Object>();
		DetachedCriteria criteria = DetachedCriteria.forClass(c);
		criteria.add(Restrictions.isNotNull("content"));
		lst.addAll(getList(criteria));
		String path = impostazioneDao.getPercorsoImmagini() + "/";
		String ext = "." + ConstantsMap.png;
		for(Object obj : lst) {
			if(obj instanceof Campagna) {
				Campagna a = (Campagna) obj;
				if(!new String(a.getContent(), ConstantsGlobal.CHARSET).endsWith(ext)) {
					String percorso  = System.currentTimeMillis() + ext;
					ApplicationUtil.writeByteArrayToFile(new File(path + percorso), a.getContent());
					a.setContent(percorso.getBytes(ConstantsGlobal.CHARSET));
					salvaAggiorna(a);
				}
			}
			if(obj instanceof Prodotto) {
				Prodotto a = (Prodotto) obj;
				if(!new String(a.getContent(), ConstantsGlobal.CHARSET).endsWith(ext)) {
					String percorso  = System.currentTimeMillis() + ext;
					ApplicationUtil.writeByteArrayToFile(new File(path + percorso), a.getContent());
					a.setContent(percorso.getBytes(ConstantsGlobal.CHARSET));
					salvaAggiorna(a);
				}
			}
			if(obj instanceof Tema) {
				Tema a = (Tema) obj;
				if(!new String(a.getContent(), ConstantsGlobal.CHARSET).endsWith(ext)) {
					String percorso  = System.currentTimeMillis() + ext;
					ApplicationUtil.writeByteArrayToFile(new File(path + percorso), a.getContent());
					a.setContent(percorso.getBytes(ConstantsGlobal.CHARSET));
					salvaAggiorna(a);
				}
			}
		}
	}

	public void emailContattiOdierniAppuntamenti(Integer tipo)  {
		String percorsoEmail = configurazioneGenericService.getValore(DefaultsGeneric.KEY_INVIO_MAIL_REPORT_APPUNTAMENTO);
		if (ApplicationUtil.isNotBlank(percorsoEmail)) {
			Date oggi = ApplicationUtil.date();
			try {
				String nomeFile = ApplicationUtil.reportFile(oggi, ConstantsLanguage.RIEPILOGO.stampa(), ConstantsLanguage.APPUNTAMENTI.stampa())+ "." + ConstantsMap.xlsx; 
				ByteArrayOutputStream result = new ByteArrayOutputStream();
				reportDao.exportReportAppuntamento(tipo, result);
				String testo = downloadDao.preparaTemplateEmail(ConstantsLanguage.REPORT_IN_ALLEGATO.stampa(), oggi);

				String oggetto = ApplicationUtil.report(ConstantsLanguage.RIEPILOGO_APPUNTAMENTO.stampa() , tipo, oggi);
				List<Allegato> allegati = ApplicationUtil.allegatiConvertO(result, nomeFile);
				smtpService.invia(null, percorsoEmail, null, oggetto, testo , allegati, null);
			} catch (Exception e) {
				ErrorLog.log(null, getClass(), e);
			}
		}
	}
	public void emailContattiOdierniAppuntamentiStoria(Integer tipo)  {
		String percorsoEmail = configurazioneGenericService.getValore(DefaultsGeneric.KEY_INVIO_MAIL_REPORT_APPUNTAMENTO);
		if (ApplicationUtil.isNotBlank(percorsoEmail)) {
			Date oggi = ApplicationUtil.date();
			try {
				String nomeFile = ApplicationUtil.reportFile(oggi, ConstantsLanguage.REPORT.stampa(), ConstantsLanguage.APPUNTAMENTI.stampa())+ "." + ConstantsMap.xlsx; 
				ByteArrayOutputStream result = new ByteArrayOutputStream();
				reportDao.exportReportAppuntamentoStoria(tipo, result);
				String testo = downloadDao.preparaTemplateEmail(ConstantsLanguage.REPORT_IN_ALLEGATO.stampa(), oggi);

				String oggetto = ApplicationUtil.report(ConstantsLanguage.REPORT.stampa() + " " + ConstantsLanguage.APPUNTAMENTO.stampa() , tipo, oggi);
				List<Allegato> allegati = ApplicationUtil.allegatiConvertO(result, nomeFile);
				smtpService.invia(null, percorsoEmail, null, oggetto, testo , allegati, null);
			} catch (Exception e) {
				ErrorLog.log(null, getClass(), e);
			}
		}
	}

	public void emailContattiOdierniContratti(Integer tipo)  {
		String percorsoEmail = configurazioneGenericService.getValore(DefaultsGeneric.KEY_INVIO_MAIL_REPORT_CONTRATTO);
		if (ApplicationUtil.isNotBlank(percorsoEmail)) {
			Date oggi = ApplicationUtil.date();
			try {
				String nomeFile = ApplicationUtil.reportFile(oggi, ConstantsLanguage.RIEPILOGO.stampa(), ConstantsLanguage.CONTRATTI.stampa())+ "." + ConstantsMap.xlsx; 
				ByteArrayOutputStream result = new ByteArrayOutputStream();
				reportDao.exportReportContratto(tipo, result);
				String testo = downloadDao.preparaTemplateEmail(ConstantsLanguage.REPORT_IN_ALLEGATO.stampa(), oggi);

				String oggetto = ApplicationUtil.report(ConstantsLanguage.RIEPILOGO_CONTRATTO.stampa() , tipo, oggi);
				List<Allegato> allegati = ApplicationUtil.allegatiConvertO(result, nomeFile);
				smtpService.invia(null, percorsoEmail, null, oggetto, testo , allegati, null);
			} catch (Exception e) {
				ErrorLog.log(null, getClass(), e);
			}
		}
	}
	public void emailContattiOdierniContrattiStoria(Integer tipo)  {
		String percorsoEmail = configurazioneGenericService.getValore(DefaultsGeneric.KEY_INVIO_MAIL_REPORT_CONTRATTO);
		if (ApplicationUtil.isNotBlank(percorsoEmail)) {
			Date oggi = ApplicationUtil.date();
			try {
				String nomeFile = ApplicationUtil.reportFile(oggi, ConstantsLanguage.REPORT.stampa(), ConstantsLanguage.CONTRATTI.stampa())+ "." + ConstantsMap.xlsx; 
				ByteArrayOutputStream result = new ByteArrayOutputStream();
				reportDao.exportReportContrattoStoria(tipo, result);
				String testo = downloadDao.preparaTemplateEmail(ConstantsLanguage.REPORT_IN_ALLEGATO.stampa(), oggi);

				String oggetto = ApplicationUtil.report(ConstantsLanguage.REPORT.stampa() + " " + ConstantsLanguage.CONTRATTO.stampa() , tipo, oggi);
				List<Allegato> allegati = ApplicationUtil.allegatiConvertO(result, nomeFile);
				smtpService.invia(null, percorsoEmail, null, oggetto, testo , allegati, null);
			} catch (Exception e) {
				ErrorLog.log(null, getClass(), e);
			}
		}
	}
	public void emailContattiOdierniAppuntamentiC(Integer tipo)  {
		String percorsoEmail = configurazioneGenericService.getValore(DefaultsGeneric.KEY_INVIO_MAIL_REPORT_APPUNTAMENTO);
		if (ApplicationUtil.isNotBlank(percorsoEmail)) {
			Date oggi = ApplicationUtil.date();
			try {
				String nomeFile = ApplicationUtil.reportFile(oggi, ConstantsLanguage.RIEPILOGO.stampa(), ConstantsLanguage.APPUNTAMENTI.stampa())+ "." + ConstantsMap.xlsx; 
				ByteArrayOutputStream result = new ByteArrayOutputStream();
				reportDao.exportReportAppuntamentoC(tipo, result);
				String testo = downloadDao.preparaTemplateEmail(ConstantsLanguage.REPORT_IN_ALLEGATO.stampa(), oggi);

				String oggetto = ApplicationUtil.report(ConstantsLanguage.RIEPILOGO_APPUNTAMENTO.stampa() , tipo, oggi);
				List<Allegato> allegati = ApplicationUtil.allegatiConvertO(result, nomeFile);
				smtpService.invia(null, percorsoEmail, null, oggetto, testo , allegati, null);
			} catch (Exception e) {
				ErrorLog.log(null, getClass(), e);
			}
		}
	}
	public void emailContattiOdierniAppuntamentiCStoria(Integer tipo)  {
		String percorsoEmail = configurazioneGenericService.getValore(DefaultsGeneric.KEY_INVIO_MAIL_REPORT_APPUNTAMENTO);
		if (ApplicationUtil.isNotBlank(percorsoEmail)) {
			Date oggi = ApplicationUtil.date();
			try {
				String nomeFile = ApplicationUtil.reportFile(oggi, ConstantsLanguage.REPORT.stampa(), ConstantsLanguage.APPUNTAMENTI.stampa())+ "." + ConstantsMap.xlsx; 
				ByteArrayOutputStream result = new ByteArrayOutputStream();
				reportDao.exportReportAppuntamentoCStoria(tipo, result);
				String testo = downloadDao.preparaTemplateEmail(ConstantsLanguage.REPORT_IN_ALLEGATO.stampa(), oggi);

				String oggetto = ApplicationUtil.report(ConstantsLanguage.REPORT.stampa() + " " + ConstantsLanguage.APPUNTAMENTO.stampa() , tipo, oggi);
				List<Allegato> allegati = ApplicationUtil.allegatiConvertO(result, nomeFile);
				smtpService.invia(null, percorsoEmail, null, oggetto, testo , allegati, null);
			} catch (Exception e) {
				ErrorLog.log(null, getClass(), e);
			}
		}
	}

	public void emailContattiOdierniContrattiC(Integer tipo)  {
		String percorsoEmail = configurazioneGenericService.getValore(DefaultsGeneric.KEY_INVIO_MAIL_REPORT_CONTRATTO);
		if (ApplicationUtil.isNotBlank(percorsoEmail)) {
			Date oggi = ApplicationUtil.date();
			try {
				String nomeFile = ApplicationUtil.reportFile(oggi, ConstantsLanguage.RIEPILOGO.stampa(), ConstantsLanguage.CONTRATTI.stampa())+ "." + ConstantsMap.xlsx; 
				ByteArrayOutputStream result = new ByteArrayOutputStream();
				reportDao.exportReportContrattoC(tipo, result);
				String testo = downloadDao.preparaTemplateEmail(ConstantsLanguage.REPORT_IN_ALLEGATO.stampa(), oggi);

				String oggetto = ApplicationUtil.report(ConstantsLanguage.RIEPILOGO_CONTRATTO.stampa() , tipo, oggi);
				List<Allegato> allegati = ApplicationUtil.allegatiConvertO(result, nomeFile);
				smtpService.invia(null, percorsoEmail, null, oggetto, testo , allegati, null);
			} catch (Exception e) {
				ErrorLog.log(null, getClass(), e);
			}
		}
	}
	public void emailContattiOdierniContrattiCStoria(Integer tipo)  {
		String percorsoEmail = configurazioneGenericService.getValore(DefaultsGeneric.KEY_INVIO_MAIL_REPORT_CONTRATTO);
		if (ApplicationUtil.isNotBlank(percorsoEmail)) {
			Date oggi = ApplicationUtil.date();
			try {
				String nomeFile = ApplicationUtil.reportFile(oggi, ConstantsLanguage.REPORT.stampa(), ConstantsLanguage.CONTRATTI.stampa())+ "." + ConstantsMap.xlsx; 
				ByteArrayOutputStream result = new ByteArrayOutputStream();
				reportDao.exportReportContrattoCStoria(tipo, result);
				String testo = downloadDao.preparaTemplateEmail(ConstantsLanguage.REPORT_IN_ALLEGATO.stampa(), oggi);

				String oggetto = ApplicationUtil.report(ConstantsLanguage.REPORT.stampa() + " " + ConstantsLanguage.CONTRATTO.stampa() , tipo, oggi);
				List<Allegato> allegati = ApplicationUtil.allegatiConvertO(result, nomeFile);
				smtpService.invia(null, percorsoEmail, null, oggetto, testo , allegati, null);
			} catch (Exception e) {
				ErrorLog.log(null, getClass(), e);
			}
		}
	}

	public void emailReportAppuntamentiProssimiAnagrafica(int tipo)  {
		Date oggi = ApplicationUtil.date();
		Date domani = ApplicationUtil.addDays(oggi, 1);
		Date data_inizio = ApplicationUtil.inizioGiornata(domani);
		Date data_fine = ApplicationUtil.dataFine(tipo, domani);
		MailSupport ms = smtpService.getMailSupport(false);
		String percorsoReply = ApplicationUtil.trimToNull(configurazioneGenericService.getValore(DefaultsGeneric.KEY_INVIO_MAIL_REPORT_APPUNTAMENTO));
		List<Appuntamento> appuntamenti = getAppuntamentiConfermatiList(data_inizio, data_fine, "data_inizio");
		if (ApplicationUtil.notEmpty(appuntamenti)) {
			Iterator<Appuntamento> objAppIter = appuntamenti.iterator();
			while (objAppIter.hasNext()) {
				Appuntamento appuntamento = objAppIter.next();
				String email = appuntamento.getContatto().getAnagrafica().getEmail();
				if (ApplicationUtil.isNotBlank(email)) {
					String oggetto = ApplicationUtil.report(ConstantsLanguage.APPUNTAMENTI.stampa(), tipo , domani);
					String testo = downloadDao.preparaTemplateEmailNA(appuntamento);
					smtpService.invia(ms, percorsoReply, email, null, oggetto, testo, null, null);
				}
			}
		}
		ms.close();
	}


	public void emailReportCalendarProssimiAnagrafica(int tipo)  {
		Date oggi = ApplicationUtil.date();
		Date domani = ApplicationUtil.addDays(oggi, 1);
		Date data_inizio = ApplicationUtil.inizioGiornata(domani);
		Date data_fine = ApplicationUtil.dataFine(tipo, domani);
		MailSupport ms = smtpService.getMailSupport(false);
		String percorsoReply = ApplicationUtil.trimToNull(configurazioneGenericService.getValore(DefaultsGeneric.KEY_INVIO_MAIL_REPORT_APPUNTAMENTO));
		List<Appuntamento> appuntamenti = getAppuntamentiConfermatiList(data_inizio, data_fine, "data_inizio");
		if (ApplicationUtil.notEmpty(appuntamenti)) {
			String appname = impostazioneDao.getApplicazione();
			String link = impostazioneDao.getUrlBase();
			Iterator<Appuntamento> objAppIter = appuntamenti.iterator();
			while (objAppIter.hasNext()) {
				Appuntamento appuntamento = objAppIter.next();
				String email = appuntamento.getContatto().getAnagrafica().getEmail();
				if (ApplicationUtil.isNotBlank(email)) {
					String oggetto = ApplicationUtil.report(ConstantsLanguage.APPUNTAMENTI.stampa(), tipo , domani);
					String testo = downloadDao.preparaTemplateEmailNA(appuntamento);
					String calendar = VCardUtils.ical(Arrays.asList(appuntamento), null, null, appname, link, true);
					smtpService.invia(ms, percorsoReply, email, null, oggetto, testo, null,  calendar);
				}
			}
		}
		ms.close();
	}

	public void emailReportContrattiAnagrafica(int tipo)  {
		Date oggi = ApplicationUtil.date();
		Date data_inizio = ApplicationUtil.dataInizio(tipo, oggi);
		Date data_fine = ApplicationUtil.fineGiornata(oggi);
		MailSupport ms = smtpService.getMailSupport(false);
		String percorsoReply = ApplicationUtil.trimToNull(configurazioneGenericService.getValore(DefaultsGeneric.KEY_INVIO_MAIL_REPORT_CONTRATTO));
		List<Contratto> contratti = getContrattiConfermatiList(data_inizio, data_fine, "data_creazione");
		if (ApplicationUtil.notEmpty(contratti)) {
			Iterator<Contratto> objAppIter = contratti.iterator();
			while (objAppIter.hasNext()) {
				Contratto contratto = objAppIter.next();
				String email = contratto.getContatto().getAnagrafica().getEmail();
				if (ApplicationUtil.isNotBlank(email)) {
					String oggetto = ApplicationUtil.report(ConstantsLanguage.CONTRATTI.stampa(), tipo , oggi);
					String testo = downloadDao.preparaTemplateEmailNC(contratto);
					smtpService.invia(ms, percorsoReply, email, null, oggetto, testo, null, null);
				}
			}
		}
		ms.close();
	}

	public void emailReportAppuntamentiAnagrafica(int tipo)  {
		Date oggi = ApplicationUtil.date();
		Date data_inizio = ApplicationUtil.dataInizio(tipo, oggi);
		Date data_fine = ApplicationUtil.fineGiornata(oggi);
		MailSupport ms = smtpService.getMailSupport(false);
		String percorsoReply = ApplicationUtil.trimToNull(configurazioneGenericService.getValore(DefaultsGeneric.KEY_INVIO_MAIL_REPORT_APPUNTAMENTO));
		List<Appuntamento> appuntamenti = getAppuntamentiConfermatiList(data_inizio, data_fine, "data_creazione");
		if (ApplicationUtil.notEmpty(appuntamenti)) {
			Iterator<Appuntamento> objAppIter = appuntamenti.iterator();
			while (objAppIter.hasNext()) {
				Appuntamento appuntamento = objAppIter.next();
				String email = appuntamento.getContatto().getAnagrafica().getEmail();
				if (ApplicationUtil.isNotBlank(email)) {
					String oggetto = ApplicationUtil.report(ConstantsLanguage.APPUNTAMENTI.stampa(), tipo , oggi);
					String testo = downloadDao.preparaTemplateEmailNA(appuntamento);
					smtpService.invia(ms, percorsoReply, email, null, oggetto, testo, null, null);
				}
			}
		}
		ms.close();
	}

	public void emailReportCalendarAnagrafica(int tipo)  {
		Date oggi = ApplicationUtil.date();
		Date data_inizio = ApplicationUtil.dataInizio(tipo, oggi);
		Date data_fine = ApplicationUtil.fineGiornata(oggi);
		MailSupport ms = smtpService.getMailSupport(false);
		String percorsoReply = ApplicationUtil.trimToNull(configurazioneGenericService.getValore(DefaultsGeneric.KEY_INVIO_MAIL_REPORT_APPUNTAMENTO));
		List<Appuntamento> appuntamenti = getAppuntamentiConfermatiList(data_inizio, data_fine, "data_creazione");
		if (ApplicationUtil.notEmpty(appuntamenti)) {
			String appname = impostazioneDao.getApplicazione();
			String link = impostazioneDao.getUrlBase();
			Iterator<Appuntamento> objAppIter = appuntamenti.iterator();
			while (objAppIter.hasNext()) {
				Appuntamento appuntamento = objAppIter.next();
				String email = appuntamento.getContatto().getAnagrafica().getEmail();
				if (ApplicationUtil.isNotBlank(email)) {
					String oggetto = ApplicationUtil.report(ConstantsLanguage.APPUNTAMENTI.stampa(), tipo , oggi);
					String testo = downloadDao.preparaTemplateEmailNA(appuntamento);
					String calendar = VCardUtils.ical(Arrays.asList(appuntamento), null, null, appname, link, true);
					smtpService.invia(ms, percorsoReply, email, null, oggetto, testo, null,  calendar);
				}
			}
		}
		ms.close();
	}

	@SuppressWarnings("unchecked")
	public List<Appuntamento> getAppuntamentiConfermatiList(Date inizio, Date fine, String data) {
		DetachedCriteria criteria = DetachedCriteria.forClass(Appuntamento.class);
		criteria.createCriteria("esito").add(Restrictions.eq("confermato", Boolean.TRUE));
		ApplicationUtil.dataDate(inizio, fine, data, criteria);
		criteria.addOrder(Order.asc(data));
		return getList(criteria);
	}

	@SuppressWarnings("unchecked")
	public List<Contratto> getContrattiConfermatiList(Date inizio, Date fine, String data) {
		DetachedCriteria criteria = DetachedCriteria.forClass(Contratto.class);
		criteria.createCriteria("esito").add(Restrictions.eq("confermato", Boolean.TRUE));
		ApplicationUtil.dataDate(inizio, fine, data, criteria);
		criteria.addOrder(Order.asc(data));
		return getList(criteria);
	}

	public Date getDataInvio()  {
		return ApplicationUtil.date();
	}
}