package it.callite.dao.config;
import java.util.List;

import org.hibernate.criterion.DetachedCriteria;
import org.hibernate.criterion.Restrictions;
import org.springframework.stereotype.Repository;

import it.callite.constants.config.DefaultsStorage;
import it.callite.dao.generic.GenericDao;
import it.callite.model.config.ConfigStorage;
import it.callite.utility.ApplicationUtil;
@SuppressWarnings("serial")
@Repository("configurazioneStorageDao")
public class ConfigurazioneStorageDao extends GenericDao {
	public ConfigStorage getValue(String key) {
		ConfigStorage conf = getValoreByChiave(key);
		if (conf == null) {
			conf = DefaultsStorage.DEFAULTS.get(key);
			try {
				salva(conf);
			} catch (Exception e) {	}
		} 
		return conf;
	}
	private ConfigStorage getValoreByChiave(String chiave) {
		DetachedCriteria criteria = DetachedCriteria.forClass(ConfigStorage.class);
		criteria.add(Restrictions.eq("chiave", ApplicationUtil.trimToEmpty(chiave)));
		return (ConfigStorage) getUniqueResult(criteria);
	}
	
	public ConfigStorage salva(ConfigStorage config) {
		return (ConfigStorage) salvaAggiorna(config);
	}
	@SuppressWarnings("unchecked")
	public void eliminaNotInConfig(List<String> chiavi) {
		if(ApplicationUtil.notEmpty(chiavi)) {
			DetachedCriteria criteria = DetachedCriteria.forClass(ConfigStorage.class);
			criteria.add(Restrictions.not(Restrictions.in("chiave", chiavi)));
			List<ConfigStorage> c = getList(criteria);
			cancellaLista(c);
		}
	}
	
}