package it.callite.functions;

import java.io.File;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Set;

import javax.faces.component.UIComponent;
import javax.faces.component.UIInput;
import javax.faces.component.UIViewRoot;
import javax.faces.model.SelectItem;
import javax.faces.model.SelectItemGroup;
import javax.servlet.http.HttpServletRequest;

import org.apache.commons.collections4.ListUtils;

import it.callite.autodialer.controllo.CodaStatic;
import it.callite.chiamate.Chiamate;
import it.callite.column.generic.GenericColumn;
import it.callite.constants.ConstantsGlobal;
import it.callite.constants.ConstantsLanguage;
import it.callite.constants.ConstantsMap;
import it.callite.constants.ConstantsRole;
import it.callite.dao.DataDao;
import it.callite.dao.DownloadDao;
import it.callite.message.Message;
import it.callite.model.Anagrafica;
import it.callite.model.Appuntamento;
import it.callite.model.Campagna;
import it.callite.model.Contatto;
import it.callite.model.Contratto;
import it.callite.model.DatoAggiuntivoAnagrafica;
import it.callite.model.Indirizzo;
import it.callite.model.Opposizione;
import it.callite.model.Prodotto;
import it.callite.model.StoriaAppuntamento;
import it.callite.model.StoriaContatto;
import it.callite.model.StoriaContratto;
import it.callite.model.Tema;
import it.callite.model.Utente;
import it.callite.model.generic.SelezionatoAbstract;
import it.callite.utility.Allegato;
import it.callite.utility.ApplicationUtil;
import it.callite.utility.CampoSpeciale;
import it.callite.utility.Colonna;
import it.callite.utility.ContrattoProdotto;
import it.callite.utility.DatoAggiuntivo;
import it.callite.utility.DatoSondaggio;
import it.callite.utility.DatoSondaggioAnagrafica;
import it.callite.utility.LabelQuery;
import it.callite.utility.Logo;
import it.callite.utility.ModelExport;
import it.callite.utility.MyFile;
import it.callite.utility.QueryList;
import it.callite.utility.QueryUtils;
import it.callite.utility.ValoreMappa;
import it.callite.utility.sincronizzazione.InfoAppuntamento;
import it.callite.utility.sincronizzazione.InfoContatto;
import it.callite.utility.sincronizzazione.InfoContratto;
import it.callite.utility.sincronizzazione.InfoNota;
import it.callite.utility.sincronizzazione.InfoPrenotazione;
import it.callite.utility.utils.LanguageFileFilter;

public class Functions {

	public static String sottraiDate(Date date1, Date date2)  {
		return ApplicationUtil.format(ApplicationUtil.time(date1, date2));
	}

	public static String byteCount(Long b) {
		return ApplicationUtil.byteCount(b != null ? b.longValue() : 0);
	}

	public static Colonna importOpposizione(Opposizione opposizione, String metodo) {
		return ModelExport.importOpposizione(opposizione, metodo);
	}

	public static Colonna importContratto(Contratto contratto, String metodo) {
		return ModelExport.importContratto(contratto, metodo);
	}

	public static Colonna importContatto(Contatto contatto, String metodo) {
		return ModelExport.importContatto(contatto, metodo);
	}

	public static Colonna importAppuntamento(Appuntamento appuntamento, String metodo) {
		return ModelExport.importAppuntamento(appuntamento, metodo);
	}

	public static Colonna importAnagrafica(Anagrafica anagrafica, String metodo) {
		return ModelExport.importAnagrafica(anagrafica, metodo);
	}

	public static Colonna stampaIndirizzoOperativo(Indirizzo indirizzo, String metodo, GenericColumn c) {
		return ModelExport.stampaIndirizzoOperativo(indirizzo, metodo, c);
	}

	public static Colonna stampaIndirizzoLegale(Indirizzo indirizzo, String metodo, GenericColumn c) {
		return ModelExport.stampaIndirizzoLegale(indirizzo, metodo, c);
	}

	public static Colonna stampaConsenso(Anagrafica anagrafica, String metodo, GenericColumn c) {
		return ModelExport.stampaConsenso(anagrafica, metodo, c);
	}

	public static Colonna stampaAnagrafica(Anagrafica anagrafica, String metodo, GenericColumn c) {
		return ModelExport.stampaAnagrafica(anagrafica, metodo, c);
	}

	public static Colonna stampaContatto(Contatto contatto, String metodo, GenericColumn c) {
		return ModelExport.stampaContatto(contatto, metodo, c);
	}

	public static Colonna stampaContratto(Contratto contratto, String metodo, GenericColumn c) {
		return ModelExport.stampaContratto(contratto, metodo, c);
	}

	public static Colonna stampaAppuntamento(Appuntamento appuntamento, String metodo, GenericColumn c) {
		return ModelExport.stampaAppuntamento(appuntamento, metodo, c);
	}

	public static Colonna stampaStoriaContatto(StoriaContatto contatto, String metodo, GenericColumn c) {
		return ModelExport.stampaStoriaContatto(contatto, metodo, c);
	}

	public static Colonna stampaStoriaContratto(StoriaContratto contratto, String metodo, GenericColumn c) {
		return ModelExport.stampaStoriaContratto(contratto, metodo, c);
	}

	public static Colonna stampaStoriaAppuntamento(StoriaAppuntamento appuntamento, String metodo, GenericColumn c) {
		return ModelExport.stampaStoriaAppuntamento(appuntamento, metodo, c);
	}


	public static String catalogG(String message) {
		return ApplicationUtil.stampa(message);
	}

	public static String catalogT(String message) {
		return Message.addCatalogText(message);
	}

	public static String catalogM(String message) { 
		return Message.addCatalogMessage(message);
	}

	public static List<InfoContatto> codaSincroniaC(Utente utente) {
		return Chiamate.getCodaSincroniaContatti().list(utente);
	}

	public static List<InfoContratto> codaSincroniaM(Utente utente) {
		return Chiamate.getCodaSincroniaContratti().list(utente);
	}

	public static List<InfoAppuntamento> codaSincroniaA(Utente utente) {
		return Chiamate.getCodaSincroniaAppuntamenti().list(utente);
	}

	public static List<InfoNota> codaSincroniaN(Utente utente) {
		return Chiamate.getCodaSincroniaNote().list(utente);
	}

	public static List<InfoPrenotazione> codaSincroniaP(Utente utente) {
		return Chiamate.getCodaSincroniaPrenotazioni().list(utente);
	}


	public static String fileP(Byte[] pdf, Contatto contatto, List<DatoSondaggioAnagrafica> dS, ContrattoProdotto cp) {
		if(pdf != null && pdf.length > 0) {
			String nomeFile = "download" + "." + ConstantsMap.pdf;
			byte [] pPdf = ApplicationUtil.toPrimitive(pdf);
			Map<String, DatoAggiuntivo> valori = new HashMap<String, DatoAggiuntivo>();
			List<DatoAggiuntivoAnagrafica> dA = new ArrayList<DatoAggiuntivoAnagrafica>();
			if(contatto != null) {
				List <String> valoriValidi = new ArrayList<String>(ConstantsMap.anagraficaMap);
				valori.putAll(ApplicationUtil.convertiAnagrafica(contatto.getAnagrafica(), valoriValidi));
				if(ApplicationUtil.notEmpty(contatto.getDettagli())) {
					dA.addAll(contatto.getDettagli());
				}
			}
			if(ApplicationUtil.notEmpty(dA)) {
				valori.putAll(ApplicationUtil.convertiDatoAggiuntivoA(dA));
			}
			if(ApplicationUtil.notEmpty(dS)) {
				valori.putAll(ApplicationUtil.convertiSondaggioA(dS));
			}
			if(cp !=null && ApplicationUtil.notEmpty(cp.getDatoSondaggioContratto())) {
				valori.putAll(ApplicationUtil.convertiSondaggioC(cp.getDatoSondaggioContratto()));
			}
			String w = ApplicationUtil.trimToNull(ConstantsGlobal.watermark);
			return ApplicationUtil.codificato(ApplicationUtil.getContentType(nomeFile), ApplicationUtil.mergeDataIntoTemplate(w, valori, true, pPdf));
		}
		return null;
	}

	public static String decode(String testo, Boolean decode, Map<String, DatoAggiuntivo> campi) {
		String text = ApplicationUtil.trimToNull(testo);
		if(text != null) {
			String t = null;
			if(ApplicationUtil.isTrue(decode)) {
				t =  ApplicationUtil.base64Decoder(text);
			} else {
				t = text;
			}
			return ApplicationUtil.replaceInString(t, campi);
		} 
		return null;
	}

	public static Map<String, DatoAggiuntivo> creaMap(Contatto contatto, List<DatoSondaggioAnagrafica> dS, ContrattoProdotto cp) {
		Map<String, DatoAggiuntivo> valori = new HashMap<String, DatoAggiuntivo>();
		List<DatoAggiuntivoAnagrafica> dA = new ArrayList<DatoAggiuntivoAnagrafica>();
		if(contatto != null) {
			List <String> valoriValidi = new ArrayList<String>(ConstantsMap.anagraficaMap);
			valori.putAll(ApplicationUtil.convertiAnagrafica(contatto.getAnagrafica(), valoriValidi));
			if(ApplicationUtil.notEmpty(contatto.getDettagli())) {
				dA.addAll(contatto.getDettagli());
			}
		}
		if(ApplicationUtil.notEmpty(dA)) {
			valori.putAll(ApplicationUtil.convertiDatoAggiuntivoA(dA));
		}
		if(ApplicationUtil.notEmpty(dS)) {
			valori.putAll(ApplicationUtil.convertiSondaggioA(dS));
		}
		if(cp != null && ApplicationUtil.notEmpty(cp.getDatoSondaggioContratto())) {
			valori.putAll(ApplicationUtil.convertiSondaggioC(cp.getDatoSondaggioContratto()));
		}
		return valori;
	}

	public static boolean mostraLogin(Integer max) {
		if(ApplicationUtil.gtZero(max)) {
			HttpServletRequest request = ApplicationUtil.getRequest(null);
			String ip = ApplicationUtil.ip(request);
			int i = Chiamate.getCodaLogin().get(ip);
			if(i >= max.intValue()) {
				return false;
			}
		}
		return true;
	}

	public static String prepareList(List<SelectItem> ls, List<String> lsa, String label) {
		Set<String> esiti  = new HashSet<String>();
		if(ApplicationUtil.notEmpty(ls) && ApplicationUtil.notEmpty(lsa)) {
			for(int i = 0; i < ls.size(); i++) {
				Object o = (Object) ls.get(i);
				if(o instanceof SelectItemGroup) { 
					SelectItemGroup a = (SelectItemGroup) o;	
					if(ApplicationUtil.notEmpty(a.getSelectItems())) {
						for(SelectItem s : a.getSelectItems()) {
							if(lsa.contains(s.getValue().toString())) {
								esiti.add(s.getLabel());
							}
						}
					}
				}
				if(o instanceof SelectItem) { 
					SelectItem s = (SelectItem) o;	
					if(lsa.contains(s.getValue().toString())) {
						esiti.add(s.getLabel());
					}
				}
			}
		}
		return ApplicationUtil.trimToNull(ApplicationUtil.detoken(new ArrayList<String>(esiti), ConstantsGlobal.colonSeparator + " "));
	}

	public static String prepareID(String id) {
		String ids = ApplicationUtil.trimToNull(id);
		if(ids != null) {
			return ids; 
		} else {
			return "id_" + System.nanoTime();
		}
	}

	public static String prepareNumber(Long n) {
		return "("+ApplicationUtil.formatNumber(n)+")";
	}

	public static String prepareBase(Integer o) {
		if(ApplicationUtil.gtZero(o)) {
			return "";
		} else {
			return "border: 1px dotted black";
		}
	}

	public static List<SelectItem> prepareValori(String values) {
		return ApplicationUtil.tokenSI(values, ConstantsGlobal.colonSeparator);
	}

	public static boolean errore(String id) {
		UIViewRoot ui = ApplicationUtil.getViewRoot();
		if(ui != null) {
			UIComponent parent = ApplicationUtil.trovaComponent(ui, id);
			if(parent != null)  {
				List<UIInput> sui = new ArrayList<UIInput>();
				ApplicationUtil.listComponent(parent, sui);
				return ApplicationUtil.notEmpty(sui);
			}
		}
		return false;
	}

	public static String chiamata(String telefono, String chiamata) {
		return "text-decoration:" +  ((ApplicationUtil.isNotEmpty(telefono) &&  ApplicationUtil.isNotEmpty(chiamata) && ApplicationUtil.equals(telefono, chiamata)) ? "underline": "none") + ";"; 
	}

	public static String prepareA(Integer max, String s, Integer a) {
		if(a != null && max != 0 && a > max) {
			return ApplicationUtil.bloccaMessaggio(max, a, s);
		} else {
			return ApplicationUtil.exportMessaggio(a, s);
		}
	}
	

	public static boolean limita(Integer size, Integer limit) {
		if(size == null) {
			size = 0;
		}
		if(limit == null) {
			limit = 0;
		}
		return !(limit.intValue() > 0 && size.intValue() >= limit.intValue());
	}

	public static String confermaA(Integer max, String s, Object aa) {
		String mess = "";
		int blocca = 0;
		Long a = ApplicationUtil.toLong(aa);
		if(a == null) {
			a = 0L;
		}
		if(a != null && max != 0 && a > max) {
			mess =  ApplicationUtil.bloccaMessaggio(max, a.intValue(), s);
			blocca = 0;
		} else {
			mess = ApplicationUtil.exportMessaggio(a.intValue(), s);
			blocca = 1;
		}
		return "if (!conferma("+blocca+",'"+mess+"')) return false";
	}

	public static String confermaB(String s) {
		int blocca = 1;
		String mess = ApplicationUtil.exportMessaggio(s);
		return "if (!conferma("+blocca+",'"+mess+"')) return false";
	}

	public static CampoSpeciale autocompleteCampo(DatoSondaggio da, String ca, String values) {
		String chiave = ApplicationUtil.trimToEmpty(ca);
		CampoSpeciale c = new CampoSpeciale(chiave, da.getChiave());
		c.setValues(values);
		return c;
	}

	public static ValoreMappa prepareCampo(DatoSondaggio da, Map<String, DatoAggiuntivo> di, String descrizione, String values, String defaults, String ca, String etichetta, Boolean richiesto, String colore, Boolean mo, Boolean vo, Boolean ma, Boolean va, Boolean ac, String stile, Integer tipo) {
		String chiave = ApplicationUtil.trimToEmpty(ca);
		CampoSpeciale c = new CampoSpeciale(chiave, da.getChiave());
		c.setEtichetta(ApplicationUtil.trimToEmpty(etichetta));
		c.setTipo(tipo);
		c.setValues(values);
		c.setObbligatorio(richiesto);
		c.setColore(colore);
		c.setStile(stile);
		c.setDefaults(defaults);
		c.setDescrizione(descrizione);
		c.setModificabile_operatore(mo);
		c.setVisibile_operatore(vo);
		c.setModificabile_agente(ma);
		c.setVisibile_agente(va);
		c.setEredita(ac);
		return da.get(c, ApplicationUtil.replaceInString(defaults, di));
	}

	public static String prepareChiave(DatoSondaggio da, Boolean eredita, String chiave) {
		return ApplicationUtil.trimToEmpty(ApplicationUtil.impostaCampoS(eredita, da.getChiave(), chiave, ConstantsGlobal.ereditaChiave));
	}

	public static boolean prepareConfronto(DatoSondaggio da, Boolean negato, String ca,  String elemento) {
		return ApplicationUtil.prepareConfronto(da, negato, ca, elemento);
	}

	public static String prepareIds(String chiave, Long id) {
		return "id" + "_" + ApplicationUtil.hash(chiave + id);
	}

	public static String replica(String classe, Integer rip) {
		List<String> c = new ArrayList<String>();
		for(int i = 0; i < rip; i++) {
			c.add(classe);
		}
		return ApplicationUtil.detoken(c, ConstantsGlobal.commaSeparator);
	}


	public static String formatInteger(Integer number)  {
		return ApplicationUtil.formatNumber(number);
	}
	public static String formatLong(Long number)  {
		return ApplicationUtil.formatNumber(number);
	}

	public static String formatBigDecimal(BigDecimal number)  {
		return ApplicationUtil.formatNumber(number);
	}

	public static String formatDouble(Double number)  {
		return ApplicationUtil.formatNumber(number);
	}

	public static Boolean isNotNull(String number)  {
		return ApplicationUtil.isNotBlank(number);
	}

	public static String formatTime(Long number)  {
		return ApplicationUtil.format(number);
	}

	public static boolean isSelezionato(List<SelezionatoAbstract> selezionati, List<SelezionatoAbstract> visualizzati)  {
		return selezionati.containsAll(visualizzati);
	}

	public static boolean isVisualizzato(List<SelezionatoAbstract> selezionati, List<SelezionatoAbstract> visualizzati)  {
		List<SelezionatoAbstract> inter = ListUtils.intersection(selezionati, visualizzati);
		return inter.isEmpty();
	}

	public static String concat(String str)  {
		StringBuilder s = new StringBuilder("");
		if (ApplicationUtil.isNotBlank(str)) {
			s.append(": " + ApplicationUtil.trimToEmpty(str));
		}
		return s.toString();
	}

	public static String contaSalva(Boolean blocca, Integer number)  {
		if(ApplicationUtil.isTrue(blocca)) {
			return ": " + ApplicationUtil.formatNumber(number);
		}
		return "";
	}

	public static String prepareExcel(Integer num) {
		StringBuilder sb = new StringBuilder();
		while (num >=  0) {
			int numChar = (num % 26)  + 65;
			sb.append((char)numChar);
			num = (num  / 26) - 1;
		}
		return sb.reverse().toString();
	}

	public static String toList(String [] s)  {
		if(ApplicationUtil.notEmpty(s)) {
			String t = Message.addCatalogText("testo_unisci2");
			List<String> ok = new ArrayList<String>();
			for(String a : s) {
				ok.add(Message.addCatalogText(ApplicationUtil.uncapitalize(a)));
			}
			return t + ": " +ApplicationUtil.detoken(ok, ConstantsGlobal.commaSeparator + " ");
		}
		return Message.addCatalogText("testo_unisci1");
	}


	public static String subComponent(String s)  {
		if(ApplicationUtil.isNotBlank(s)) {
			return s.replaceAll(".component", "");
		}
		return "";
	}
	public static boolean functionArchiviazione(String pannello)  {
		if(ApplicationUtil.isNotBlank(pannello)) {
			return ConstantsMap.POPUP.contains(pannello);
		}
		return false;
	}

	public static boolean functionLoad(Boolean pannello)  {
		return ApplicationUtil.isTrue(pannello);
	}
	
	public static String chart(DataDao dao, DatoSondaggio da, Boolean legend, Boolean orientation, String gruppo, String valore, String quantita, String tabella, String cv, String tipo, String name, Boolean order, Integer limit, Integer max_width, Integer max_height) {
		List<LabelQuery> lq = new ArrayList<LabelQuery>();
		String g = ApplicationUtil.trimToNull(gruppo);
		String v = ApplicationUtil.trimToNull(valore);
		String q = ApplicationUtil.trimToNull(quantita);
		String t = ApplicationUtil.trimToNull(tabella);
		if(q != null && t != null && (g != null || v != null)) {
			QueryUtils cond = new QueryUtils();
			if(ApplicationUtil.isNotBlank(cv)) {
				cond = ApplicationUtil.evaluateInQuery(da, cv);
			}
			if(dao != null) {
				lq.addAll(dao.query(g, v, q, t, ApplicationUtil.isTrue(order), limit, cond));
			}
		}
		return ApplicationUtil.chart(tipo, name, "", "", ApplicationUtil.isTrue(legend), ApplicationUtil.isTrue(orientation), max_width, max_height, lq);
	}
	
	
	public static String pie(DataDao dao, DatoSondaggio da, Boolean legend, Boolean orientation, String gruppo, String valore, String quantita, String tabella,  String cv, String name, Boolean order, Integer limit, Integer max_width, Integer max_height) {
		List<LabelQuery> lq = new ArrayList<LabelQuery>();
		String g = ApplicationUtil.trimToNull(gruppo);
		String v = ApplicationUtil.trimToNull(valore);
		String q = ApplicationUtil.trimToNull(quantita);
		String t = ApplicationUtil.trimToNull(tabella);
		if(q != null && t != null && (g != null || v != null)) {
			QueryUtils cond = new QueryUtils();
			if(ApplicationUtil.isNotBlank(cv)) {
				cond = ApplicationUtil.evaluateInQuery(da, cv);
			}
			if(dao != null) {
				lq.addAll(dao.query(g, v, q, t, ApplicationUtil.isTrue(order), limit, cond));
			}
		}
		return ApplicationUtil.pie(name, ApplicationUtil.isTrue(legend), ApplicationUtil.isTrue(orientation), max_width, max_height, lq);
	}

	public static String paint(Logo logo, Allegato allegato, String p) {
		return ApplicationUtil.paint(logo, allegato, p);
	}

	public static String file(String valore, Integer max_width, Integer max_height) {
		return ApplicationUtil.file(valore, max_width, max_height);
	}


	public static String stampa(Logo logo, Allegato allegato, String stringa, String p) {
		return ApplicationUtil.stampa(logo, allegato, stringa, p);
	}


	public static String prepareUtente(Utente u, Utente s) {
		if(u != null && !ApplicationUtil.equals(u, s)) {
			return u.getDenominazione();
		} else {
			return null;
		}
	}

	public static Boolean compareUtente(Utente logged, Utente user, Boolean blocca) {
		boolean s = logged.isShell();
		List<String> su = logged.getSuperusers();
		user.impostaRuoloA(s, su);
		return ApplicationUtil.isTrue(blocca) ? s : (s || (!s && !user.isShell()));
	}

	public static Boolean compareTema(Tema used, MyFile file) {
		if(used.getLingua() != null) {
			return !file.getName().equals(LanguageFileFilter.start + used.getLingua() + LanguageFileFilter.end);
		}
		return true;
	}

	public static Map<String,List<Object>> prepareGruppoList(Boolean raggruppa, List<?> das) {
		return ApplicationUtil.prepareGruppoList(raggruppa, das);
	}

	public static List<SelectItem> prepareGruppoRicerca(Boolean idselect, Boolean raggruppa, List<?> das) {
		return ApplicationUtil.prepareGruppoRicerca(idselect, raggruppa, das);
	}

	public static Map<String, List<Object>> prepareGruppoMap(Boolean raggruppa, Map<Long, ?> map) {
		return ApplicationUtil.prepareGruppoMap(raggruppa, map);
	}

	public static String prendiGruppo(String gruppo, String etichetta) {
		String nogroup = ConstantsLanguage.NOGROUP.stampa();
		String g = ApplicationUtil.prendiGruppo(gruppo, nogroup);
		return etichetta = ApplicationUtil.sottraiEtichetta(etichetta, g);
	}

	public static List<LabelQuery> query(DataDao dao, DatoSondaggio da, String proprieta, String alias, String tabella, String cv, Boolean order, Integer limit) {
		List<LabelQuery> lq = new ArrayList<LabelQuery>();
		String p = ApplicationUtil.trimToNull(proprieta);
		String a = ApplicationUtil.trimToNull(alias);
		String t = ApplicationUtil.trimToNull(tabella);
		if(p != null && t != null) {
			QueryUtils cond = new QueryUtils();
			if(ApplicationUtil.isNotBlank(cv)) {
				cond = ApplicationUtil.evaluateInQuery(da, cv);
			}
			if(dao != null) {
				lq.addAll(dao.query(p, a, t, ApplicationUtil.isTrue(order), limit, cond));
			}
		}
		return lq;
	}
	
	public static List<QueryList> queryL(DataDao dao, DatoSondaggio da, String cvs) {
		List<QueryList> qkL = new ArrayList<QueryList>();
		List<String> ql = ApplicationUtil.splitV(cvs, ConstantsGlobal.qsp);
		if(ApplicationUtil.notEmpty(ql)) {
			for(String cv : ql) {
				QueryUtils cond = ApplicationUtil.evaluateInQuery(da, cv);
				if(dao != null) {
					qkL.addAll(dao.queryL(cond));
				}
			}
		}
		return qkL;
	}

	public static boolean isFile(DataDao dao, String file) {
		if(ApplicationUtil.isNotBlank(file)) {
			String f = ApplicationUtil.normalizeNoEndSeparator(dao.getPathFile().getAbsolutePath() + "/" + file + dao.getExtensionModules());
			File ff = new File(f);
			if(ff.exists()) {
				return true;
			}
		}
		return false;

	}

	public static List<String> eventList(String das) {
		String b = "change";
		List<String> a = ApplicationUtil.tokenU(das, ConstantsGlobal.colonSeparator);
		if(ApplicationUtil.empty(a) && !a.contains(b)) {
			a.add(b);
		}
		return a;
	}

	public static String ruoliScelti(String r) {
		String ruoli = ApplicationUtil.trimToEmpty(r);
		for(String s : ConstantsRole.DEFAULTS.keySet()) {
			if(ruoli.contains(s)) {
				ruoli = ruoli.replaceAll(s, Message.addCatalogText(s)) ;
			}
		}
		return ruoli;
	}


	public static String seleziona(Boolean idselect, SelezionatoAbstract s) {
		return ApplicationUtil.toString(idselect ? s.getId() : null, s.getDenominazione()); 
	}

	public static List<SelectItem> selezionaList(Boolean idselect, List<SelezionatoAbstract> ls) {
		List<SelectItem> sisGroup = new ArrayList<SelectItem>();
		if(ApplicationUtil.notEmpty(ls))
			for (SelezionatoAbstract s : ls) {
				sisGroup.add(new SelectItem(s.getId(), ApplicationUtil.toString(idselect ? s.getId() : null, s.getDenominazione()))); 
			}
		return sisGroup;
	}

	public static Integer seleziona_liste(Campagna campagna, Utente utente) {
		return ApplicationUtil.size(CodaStatic.getCodaLista().getDataL(campagna, utente));
	}

	public static String filename(String valore) {
		return ApplicationUtil.dimensione(valore);
	}
	
	public static String scheda(DownloadDao dao, DatoSondaggio dato, Map<String, DatoAggiuntivo> dati, Anagrafica a, Contatto c, Prodotto p, String modulo) {
		return dao.scheda(dato, dati, a, c, p, modulo);
	}

}