package it.callite.helper;

import java.io.Serializable;

import org.springframework.webflow.conversation.impl.SessionBindingConversationManager;
import org.springframework.webflow.execution.repository.impl.DefaultFlowExecutionRepository;
import org.springframework.webflow.executor.FlowExecutor;
import org.springframework.webflow.executor.FlowExecutorImpl;

@SuppressWarnings("serial")
public class WebFlowHelper implements Serializable  {

	private FlowExecutor flowExecutor;

	public WebFlowHelper(FlowExecutor flowExecutor) { 
		this.flowExecutor = flowExecutor; 
	}

	public FlowExecutor getFlowExecutor() { 
		return flowExecutor; 
	}

	public SessionBindingConversationManager getConversationManager() { 
		FlowExecutorImpl fi = (FlowExecutorImpl) flowExecutor;
		DefaultFlowExecutionRepository fer = (DefaultFlowExecutionRepository) fi.getExecutionRepository();
		SessionBindingConversationManager sbc = (SessionBindingConversationManager) fer.getConversationManager();
		return sbc; 
	}

	public int getLockTimeoutSeconds() { 
		return getConversationManager().getLockTimeoutSeconds(); 
	}

	public void setLockTimeoutSeconds(int lockTimeoutSeconds) { 
		getConversationManager().setLockTimeoutSeconds(lockTimeoutSeconds); 
	}
}