package it.callite.listener;

import javax.servlet.http.HttpSessionAttributeListener;
import javax.servlet.http.HttpSessionBindingEvent;

import org.springframework.security.authentication.AuthenticationTrustResolver;
import org.springframework.security.authentication.AuthenticationTrustResolverImpl;
import org.springframework.security.core.Authentication;
import org.springframework.security.core.context.SecurityContext;

import it.callite.chiamate.Chiamate;
import it.callite.constants.ConstantsGlobal;
import it.callite.model.Utente;
import it.callite.utility.ApplicationUtil;


public class UserCounterListener implements HttpSessionAttributeListener {



	public void attributeAdded(HttpSessionBindingEvent event) {
		if (event.getName().equals(ConstantsGlobal.EVENT_KEY) && !isAnonymous()) {
			SecurityContext sc = (SecurityContext) event.getValue();
			if(sc != null){
				Authentication auth = sc.getAuthentication();
				if (auth != null && auth.getPrincipal() instanceof Utente) {
					Utente user = (Utente) auth.getPrincipal();
					Chiamate.getCodaOperatori().online(user, true);
				}
			}
		}
	}

	public void attributeRemoved(HttpSessionBindingEvent event) {
		if (event.getName().equals(ConstantsGlobal.EVENT_KEY) && !isAnonymous()) {
			SecurityContext sc = (SecurityContext) event.getValue();
			if(sc != null){
				Authentication auth = sc.getAuthentication();
				if (auth != null && auth.getPrincipal() instanceof Utente) {
					Utente user = (Utente) auth.getPrincipal();
					Chiamate.getCodaOperatori().online(user, false);
				}
			}
		}
	}

	public void attributeReplaced(HttpSessionBindingEvent event) {
		if (event.getName().equals(ConstantsGlobal.EVENT_KEY) && !isAnonymous()) {
			SecurityContext sc = (SecurityContext) event.getValue();
			if(sc != null){
				Authentication auth = sc.getAuthentication();
				if (auth != null && auth.getPrincipal() instanceof Utente) {
					Utente user = (Utente) auth.getPrincipal();
					Chiamate.getCodaOperatori().online(user, true);
				}
			}
		}
	}

	private boolean isAnonymous() {
		SecurityContext ctx = ApplicationUtil.getSecurityContext();
		if (ctx != null) {
			AuthenticationTrustResolver resolver = new AuthenticationTrustResolverImpl();
			Authentication auth = ctx.getAuthentication();
			return resolver.isAnonymous(auth);
		}
		return true;
	}



}
