package it.callite.log;
import java.util.logging.FileHandler;
import java.util.logging.Formatter;
import java.util.logging.Handler;
import java.util.logging.Level;
import java.util.logging.LogManager;
import java.util.logging.LogRecord;
import java.util.logging.Logger;

import it.callite.constants.ConstantsFormat;
import it.callite.constants.ConstantsGlobal;
import it.callite.utility.ApplicationUtil;
public class SystemLog {
	
	
	private static Logger logger = Logger.getLogger(SystemLog.class.getName());
	static {
		try {
			ClassLoader classLoader = SystemLog.class.getClassLoader();
			LogManager.getLogManager().readConfiguration(classLoader.getResourceAsStream("log4j.properties"));
			Handler fileHandler = new FileHandler(ConstantsGlobal.path_log_callite + "/" + ApplicationUtil.formatDate(ConstantsFormat.calendarDate.stampa(), ApplicationUtil.date()) + "_" + "access.log",  true);
			fileHandler.setFormatter(new MyFormatter());
			logger.addHandler(fileHandler);
			logger.setLevel(Level.INFO);
		} catch (Exception e) {
			ErrorLog.log(null, logger.getClass(), e);
		}
	}
	public static void info(String l) {
		logger.info(l);
	}
}

class MyFormatter extends Formatter {
	
    @Override
    public String format(LogRecord record) {
    	String format = "[%1$s] [%2$s] [%3$s] %4$s%n";
        return String.format(format, ApplicationUtil.formatDate(ConstantsFormat.timestamp.stampa(), ApplicationUtil.date(record.getMillis())), record.getLevel().getLocalizedName(), record.getSourceClassName(), record.getMessage() );
    }
}