package it.callite.model;
import java.io.Serializable;
import java.util.Date;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.Index;
import javax.persistence.Table;
import org.hibernate.annotations.Cache;
import org.hibernate.annotations.CacheConcurrencyStrategy;
import it.callite.constants.ConstantsGlobal;
import it.callite.model.generic.SelezionatoAbstract;
import it.callite.utility.ApplicationUtil;
@SuppressWarnings("serial")
@Entity
//@Audited 
@Table(name = ConstantsGlobal.tp + "comune", indexes = { @Index(name= "comune", columnList = "data_creazione, codice_provincia, nome") })
@Cache(usage = CacheConcurrencyStrategy.READ_WRITE)
public class Comune  extends SelezionatoAbstract implements Serializable {
	@Override
	public String toString() {
		return ApplicationUtil.toString(id, getDenominazione());
	}
	public String getDenominazione() {
		return ApplicationUtil.trimToEmpty(getNome());
	}
	private Date data_creazione = ApplicationUtil.date();
	public Date getData_creazione() {
		return data_creazione;
	}
	public void setData_creazione(Date data_creazione) {
		this.data_creazione = data_creazione;
	}
	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((id == null) ? 0 : id.hashCode());
		return result;
	}
	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		Comune other = (Comune) obj;
		if (id == null) {
			if (other.id != null)
				return false;
		} else if (!id.equals(other.id))
			return false;
		return true;
	}
	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY) 
	private Long id;
	private String nome;
	private String codice_istat;
	private String codice_catastale;
	private String codice_provincia;
	public Long getId() {
		return id;
	}
	public void setId(Long id) {
		this.id = id;
	}
	public String getNome() {
		return ApplicationUtil.upperCaseEmpty(nome);
	}
	public void setNome(String nome) {
		this.nome = ApplicationUtil.normalizeToUpperNull(nome);
	}
	public String getCodice_istat() {
		return ApplicationUtil.upperCaseEmpty(codice_istat);
	}
	public void setCodice_istat(String codice_istat) {
		this.codice_istat = ApplicationUtil.normalizeToUpperNull(codice_istat);
	}
	public String getCodice_catastale() {
		return ApplicationUtil.upperCaseEmpty(codice_catastale);
	}
	public void setCodice_catastale(String codice_catastale) {
		this.codice_catastale = ApplicationUtil.normalizeToUpperNull(codice_catastale);
	}
	public String getCodice_provincia() {
		return ApplicationUtil.upperCaseEmpty(codice_provincia);
	}
	public void setCodice_provincia(String codice_provincia) {
		this.codice_provincia = ApplicationUtil.normalizeToUpperNull(codice_provincia);
	}
}