package it.callite.model;
import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.JoinTable;
import javax.persistence.ManyToMany;
import javax.persistence.Table;

import org.hibernate.annotations.Cache;
import org.hibernate.annotations.CacheConcurrencyStrategy;
import org.springframework.security.core.GrantedAuthority;

import it.callite.constants.ConstantsGlobal;
import it.callite.message.Message;
import it.callite.utility.ApplicationUtil;
@SuppressWarnings("serial")
@Entity
//@Audited 
@Table(name = ConstantsGlobal.tp + "ruolo")
@Cache(usage = CacheConcurrencyStrategy.READ_WRITE)
public class Ruolo implements Serializable, GrantedAuthority {
	
	
	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY) 
	private Long id;
	private String nome;
	
	
	public Ruolo() { }
	public Ruolo(Long id) { 
		this.setId(id);
	}
	public Ruolo(String nome) { 
		this.setNome(nome);
	}
	public Long getId() {
		return id;
	}
	public void setId(Long id) {
		this.id = id;
	}
	public String getNome() {
		return nome;
	}
	public void setNome(String nome) {
		this.nome = ApplicationUtil.normalizeToNull(nome);
	}
	public String getDescrizione() {
		return Message.addCatalogText(nome);
	}
	
	
	public String getAuthority() {
		return nome;
	}
	
	@ManyToMany(fetch=FetchType.LAZY)
	@JoinTable(name = ConstantsGlobal.tp + "user_ruolo", joinColumns=@JoinColumn(name="ruoli_id", nullable=false, updatable=true, insertable=true), inverseJoinColumns=@JoinColumn(name="user_id", nullable=false, updatable=true, insertable=true)    )
	private List<Utente> user = new ArrayList<Utente>();
	
	public List<Utente> getUser() {
		return user;
	}
	public void setUser(List<Utente> user) {
		this.user = user;
	}
	public int compareTo(Ruolo o) {
		if(nome != null && o.nome != null) {
			return nome.compareTo(o.nome);
		} else if(nome != null && o.nome == null) {
			return -1;
		} else if(nome == null && o.nome != null) {
			return 1;
		} else {
			return 0;
		}
	}
	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((nome == null) ? 0 : nome.hashCode());
		return result;
	}
	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		Ruolo other = (Ruolo) obj;
		if (nome == null) {
			if (other.nome != null)
				return false;
		} else if (!nome.equals(other.nome))
			return false;
		return true;
	}
	
}