package it.callite.model.anagrafica;
import java.io.Serializable;
import java.util.Date;

import it.callite.model.DatoAggiuntivoAnagrafica;
import it.callite.utility.ApplicationUtil;
import it.callite.utility.DatoSondaggioAnagrafica;
@SuppressWarnings("serial")
public class DatoAggiuntivoAnagraficaXML implements Serializable {
	private Long id;
	private Date data_creazione;
	private CampoAggiuntivoAnagraficaXML campo_aggiuntivo;
	private String valore;
	public DatoAggiuntivoAnagraficaXML() {
		
	}
	public DatoAggiuntivoAnagraficaXML(DatoAggiuntivoAnagrafica dato) {
		this.setId(dato.getId());
		this.setData_creazione(dato.getData_creazione());
		this.setValore(ApplicationUtil.trimToEmpty(dato.getValore()));
		this.setCampo_aggiuntivo(new CampoAggiuntivoAnagraficaXML(dato.getCampo_aggiuntivo()));
	}
	
	public DatoAggiuntivoAnagraficaXML(DatoSondaggioAnagrafica dato) {
		this.setData_creazione(ApplicationUtil.date());
		this.setValore(ApplicationUtil.trimToEmpty(dato.getValore()));
		this.setCampo_aggiuntivo(new CampoAggiuntivoAnagraficaXML(dato.getCampo()));
	}
	public CampoAggiuntivoAnagraficaXML getCampo_aggiuntivo() {
		return campo_aggiuntivo;
	}
	public Long getId() {
		return id;
	}
	public void setId(Long id) {
		this.id = id;
	}
	public Date getData_creazione() {
		return data_creazione;
	}
	public void setData_creazione(Date data_creazione) {
		this.data_creazione = data_creazione;
	}
	public String getValore() {
		return ApplicationUtil.trimToEmpty(valore);
	}
	public void setCampo_aggiuntivo(CampoAggiuntivoAnagraficaXML campo_aggiuntivo) {
		this.campo_aggiuntivo = campo_aggiuntivo;
	}
	public void setValore(String valore) {
		this.valore = ApplicationUtil.trimToEmpty(valore);
	}
	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((campo_aggiuntivo == null) ? 0 : campo_aggiuntivo.hashCode());
		result = prime * result + ((data_creazione == null) ? 0 : data_creazione.hashCode());
		result = prime * result + ((id == null) ? 0 : id.hashCode());
		result = prime * result + ((valore == null) ? 0 : valore.hashCode());
		return result;
	}
	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		DatoAggiuntivoAnagraficaXML other = (DatoAggiuntivoAnagraficaXML) obj;
		if (campo_aggiuntivo == null) {
			if (other.campo_aggiuntivo != null)
				return false;
		} else if (!campo_aggiuntivo.equals(other.campo_aggiuntivo))
			return false;
		if (data_creazione == null) {
			if (other.data_creazione != null)
				return false;
		} else if (!data_creazione.equals(other.data_creazione))
			return false;
		if (id == null) {
			if (other.id != null)
				return false;
		} else if (!id.equals(other.id))
			return false;
		if (valore == null) {
			if (other.valore != null)
				return false;
		} else if (!valore.equals(other.valore))
			return false;
		return true;
	}
	
}