package it.callite.model.anagrafica;
import java.io.Serializable;

import it.callite.model.Indirizzo;
import it.callite.utility.ApplicationUtil;
@SuppressWarnings("serial")
public class IndirizzoXML implements Serializable {
	private Long id;
	private String regione;
	private String provincia;
	private String comune;
	private String cap;
	private String strada;
	private String civico;
	private String presso;
	private String dettagli;
	private String latitudine;
	private String longitudine;
	
	public IndirizzoXML() {
	}
	public IndirizzoXML(Indirizzo indirizzo) {
		this.setId(indirizzo.getId());
		this.setRegione(ApplicationUtil.trimToEmpty(indirizzo.getRegione()));
		this.setProvincia(ApplicationUtil.trimToEmpty(indirizzo.getProvincia()));
		this.setCap(ApplicationUtil.trimToEmpty(indirizzo.getCap()));
		this.setComune(ApplicationUtil.trimToEmpty(indirizzo.getComune()));
		this.setStrada(ApplicationUtil.trimToEmpty(indirizzo.getStrada()));
		this.setPresso(ApplicationUtil.trimToEmpty(indirizzo.getPresso()));
		this.setCivico(ApplicationUtil.trimToEmpty(indirizzo.getCivico()));
		this.setDettagli(ApplicationUtil.trimToEmpty(indirizzo.getDettagli()));
		this.setLatitudine(ApplicationUtil.trimToEmpty(indirizzo.getLatitudine()));
		this.setLongitudine(ApplicationUtil.trimToEmpty(indirizzo.getLongitudine()));
	}
	public Long getId() {
		return id;
	}
	public void setId(Long id) {
		this.id = id;
	}
	
	public String getCap() {
		return cap;
	}
	public String getCivico() {
		return civico;
	}
	public String getComune() {
		return comune;
	}
	
	public String getDettagli() {
		return dettagli;
	}
	
	public String getLatitudine() {
		return latitudine;
	}
	public String getLongitudine() {
		return longitudine;
	}
	
	public String getPresso() {
		return presso;
	}
	public String getProvincia() {
		return provincia;
	}
	public String getRegione() {
		return regione;
	}
	public String getStrada() {
		return strada;
	}
	public void setCap(String cap) {
		this.cap = cap;
	}
	public void setCivico(String civico) {
		this.civico = civico;
	}
	public void setComune(String comune) {
		this.comune = comune;
	}
	public void setDettagli(String dettagli) {
		this.dettagli = dettagli;
	}
	public void setLatitudine(String latitudine) {
		this.latitudine = latitudine;
	}
	public void setLongitudine(String longitudine) {
		this.longitudine = longitudine;
	}
	public void setPresso(String presso) {
		this.presso = presso;
	}
	public void setProvincia(String provincia) {
		this.provincia = provincia;
	}
	public void setRegione(String regione) {
		this.regione = regione;
	}
	public void setStrada(String strada) {
		this.strada = strada;
	}
	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((cap == null) ? 0 : cap.hashCode());
		result = prime * result + ((civico == null) ? 0 : civico.hashCode());
		result = prime * result + ((comune == null) ? 0 : comune.hashCode());
		result = prime * result + ((dettagli == null) ? 0 : dettagli.hashCode());
		result = prime * result + ((id == null) ? 0 : id.hashCode());
		result = prime * result + ((latitudine == null) ? 0 : latitudine.hashCode());
		result = prime * result + ((longitudine == null) ? 0 : longitudine.hashCode());
		result = prime * result + ((presso == null) ? 0 : presso.hashCode());
		result = prime * result + ((provincia == null) ? 0 : provincia.hashCode());
		result = prime * result + ((regione == null) ? 0 : regione.hashCode());
		result = prime * result + ((strada == null) ? 0 : strada.hashCode());
		return result;
	}
	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		IndirizzoXML other = (IndirizzoXML) obj;
		if (cap == null) {
			if (other.cap != null)
				return false;
		} else if (!cap.equals(other.cap))
			return false;
		if (civico == null) {
			if (other.civico != null)
				return false;
		} else if (!civico.equals(other.civico))
			return false;
		if (comune == null) {
			if (other.comune != null)
				return false;
		} else if (!comune.equals(other.comune))
			return false;
		if (dettagli == null) {
			if (other.dettagli != null)
				return false;
		} else if (!dettagli.equals(other.dettagli))
			return false;
		if (id == null) {
			if (other.id != null)
				return false;
		} else if (!id.equals(other.id))
			return false;
		if (latitudine == null) {
			if (other.latitudine != null)
				return false;
		} else if (!latitudine.equals(other.latitudine))
			return false;
		if (longitudine == null) {
			if (other.longitudine != null)
				return false;
		} else if (!longitudine.equals(other.longitudine))
			return false;
		if (presso == null) {
			if (other.presso != null)
				return false;
		} else if (!presso.equals(other.presso))
			return false;
		if (provincia == null) {
			if (other.provincia != null)
				return false;
		} else if (!provincia.equals(other.provincia))
			return false;
		if (regione == null) {
			if (other.regione != null)
				return false;
		} else if (!regione.equals(other.regione))
			return false;
		if (strada == null) {
			if (other.strada != null)
				return false;
		} else if (!strada.equals(other.strada))
			return false;
		return true;
	}
	
	/*
	@XmlTransient  @JsonIgnoreProperties(ignoreUnknown = true, allowGetters = false)
	public String getStrada_completo() {
		if(ApplicationUtil.isNotBlank(getStrada())) {
			String strada = getStrada();
			String civico = (ApplicationUtil.isNotBlank(getCivico())) ? ", "+ getCivico() : "";
			return  strada+civico;
		} 
		else return "";
	}
	*/
	
}