package it.callite.model.config;
import java.io.Serializable;
import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.Index;
import javax.persistence.Table;
import javax.persistence.Transient;
import it.callite.constants.ConstantsGlobal;
import it.callite.message.Message;
import it.callite.utility.ApplicationUtil;
@SuppressWarnings("serial")
@Entity
//@Audited
@Table(name = ConstantsGlobal.tp + "config_asterisk", indexes = { @Index(name= "config_asterisk", columnList="chiave") })
public class ConfigAsterisk implements Serializable {
	private String chiave;
	@Column(columnDefinition = "text")
	private String descrizione;
	
	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY) 
	private Long id;
	private Boolean modificabile;
	private Boolean richiesto;
	@Transient
	private Boolean stato;
	private Boolean valore;
	private Boolean visibile;
	public ConfigAsterisk() {
		
	}
	
	public ConfigAsterisk(String chiave, Boolean valore, Boolean richiesto, Boolean modificabile) {
		this.setChiave(chiave);
		this.setValore(valore);
		this.setModificabile(modificabile);
		this.setVisibile(true);
		this.setRichiesto(richiesto);
	}
	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		ConfigAsterisk other = (ConfigAsterisk) obj;
		if (chiave == null) {
			if (other.chiave != null)
				return false;
		} else if (!chiave.equals(other.chiave))
			return false;
		if (id == null) {
			if (other.id != null)
				return false;
		} else if (!id.equals(other.id))
			return false;
		return true;
	}
	public String getChiave() {
		return chiave;
	}
	public String getChiaveTesto() {
		return Message.addCatalogMessage(chiave);
	}
	public String getDescrizione() {
		return descrizione;
	}
	
	public Long getId() {
		return id;
	}
	public Boolean getModificabile() {
		return modificabile;
	}
	public Boolean getRichiesto() {
		if(richiesto == null) {
			richiesto = false;
		}
		return richiesto;
	}
	public Boolean getStato() {
		return stato;
	}
	public Boolean getValore() {
		return valore;
	}
	public Boolean getVisibile() {
		return visibile;
	}
	
	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((chiave == null) ? 0 : chiave.hashCode());
		result = prime * result + ((id == null) ? 0 : id.hashCode());
		return result;
	}
	
	
	public void setChiave(String chiave) {
		this.chiave = ApplicationUtil.normalizeToNull(chiave);
	}
	public void setDescrizione(String descrizione) {
		this.descrizione = descrizione;
	}
	public void setId(Long id) {
		this.id = id;
	}
	public void setModificabile(Boolean modificabile) {
		this.modificabile = modificabile;
	}
	public void setRichiesto(Boolean richiesto) {
		this.richiesto = richiesto;
	}
	public void setStato(Boolean stato) {
		this.stato = stato;
	}
	public void setValore(Boolean valore) {
		this.valore = valore;
	}
	public void setVisibile(Boolean visibile) {
		this.visibile = visibile;
	}
	@Override
	public String toString() {
		return id != null ? id.toString() : "";
	}
	
}