package it.callite.model.report;

import it.callite.model.Contatto;
import it.callite.model.Utente;

import java.io.Serializable;
@SuppressWarnings("serial")
public class ChiamateAttive implements Serializable , Comparable<ChiamateAttive>{

	private Utente operatore;
	private Contatto contatto;
	private boolean privata = false;
	
	public ChiamateAttive() {
	}
	
	public ChiamateAttive(Utente operatore, Contatto contatto, boolean privata) {
		this.operatore = operatore;
		this.contatto = contatto;
		this.privata = privata;
	}
	
	public boolean isPrivata() {
		return privata;
	}
	public void setPrivata(boolean privata) {
		this.privata = privata;
	}
	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result	+ ((contatto == null) ? 0 : contatto.hashCode());
		return result;
	}
	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		ChiamateAttive other = (ChiamateAttive) obj;
		if (contatto == null) {
			if (other.contatto != null)
				return false;
		} else if (!contatto.equals(other.contatto))
			return false;
		return true;
	}
	public Utente getOperatore() {
		return operatore;
	}
	public void setOperatore(Utente operatore) {
		this.operatore = operatore;
	}
	public Contatto getContatto() {
		return contatto;
	}
	public void setContatto(Contatto contatto) {
		this.contatto = contatto;
	}
	public int compareTo(ChiamateAttive o) {
		if(contatto != null && o.contatto != null) {
			return contatto.compareTo(o.contatto);
		} else if(contatto != null && o.contatto == null) {
			return -1;
		} else if(contatto == null && o.contatto != null) {
			return 1;
		} else {
			return 0;
		}
	}

	
}
