package it.callite.model.report;

import java.io.Serializable;

import it.callite.constants.ConstantsEsito;
import it.callite.model.Contatto;


@SuppressWarnings("serial")
public class PannelloModel implements Serializable {

	private Long campagna_id;
	private Long contatto_id;
	private Long esito_id;

	public Long getCampagna_id() {
		return campagna_id;
	}
	public void setCampagna_id(Long campagna_id) {
		this.campagna_id = campagna_id;
	}

	public Long getEsito_id() {
		return esito_id;
	}
	public void setEsito_id(Long esito_id) {
		this.esito_id = esito_id;
	}

	public PannelloModel() {
	}

	public PannelloModel(Contatto contatto, int campagna) {
		if(campagna == 1) {
			this.campagna_id = contatto.getCampagna().getId();
		}
		if(campagna == 2) {
			this.campagna_id = contatto.getLista().getId();
		}
		this.contatto_id = contatto.getId();
		if(contatto.getProprietario() != null) {
			this.esito_id = !contatto.getArchiviato() ? 0L : 1L;
		} else {
			this.esito_id = contatto.getEsitoChiamata().getId().equals(ConstantsEsito.ID_DA_CHIAMARE) ? 0L : 1L;
		}
	}
	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result
				+ ((campagna_id == null) ? 0 : campagna_id.hashCode());
		result = prime * result
				+ ((contatto_id == null) ? 0 : contatto_id.hashCode());
		result = prime * result
				+ ((esito_id == null) ? 0 : esito_id.hashCode());
		return result;
	}
	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		PannelloModel other = (PannelloModel) obj;
		if (campagna_id == null) {
			if (other.campagna_id != null)
				return false;
		} else if (!campagna_id.equals(other.campagna_id))
			return false;
		if (contatto_id == null) {
			if (other.contatto_id != null)
				return false;
		} else if (!contatto_id.equals(other.contatto_id))
			return false;
		if (esito_id == null) {
			if (other.esito_id != null)
				return false;
		} else if (!esito_id.equals(other.esito_id))
			return false;
		return true;
	}
	public Long getContatto_id() {
		return contatto_id;
	}
	public void setContatto_id(Long contatto_id) {
		this.contatto_id = contatto_id;
	}
	public int compareTo(PannelloModel o) {
		if(contatto_id != null && o.contatto_id != null) {
			return contatto_id.compareTo(o.contatto_id);
		} else if(contatto_id != null && o.contatto_id == null) {
			return -1;
		} else if(contatto_id == null && o.contatto_id != null) {
			return 1;
		} else {
			return 0;
		}

	}

}
