package it.callite.model.report;

import java.io.Serializable;

import it.callite.utility.ApplicationUtil;
@SuppressWarnings("serial")
public class ReportLavoratoResultSet implements Serializable {

	private Long user_id;
	private String pausa;
	private Boolean positivo;
	private Long totale;
	private Long conteggio;
	
	public String getTotaleF() {
		return ApplicationUtil.format(getTotale());
	}

	public ReportLavoratoResultSet() {
	}

	public ReportLavoratoResultSet(Long user_id, String pausa, Boolean positivo) {
		this.user_id = user_id;
		this.pausa = pausa;
		this.positivo = positivo;
	}

	public Long getConteggio() {
		if(conteggio == null)
			conteggio = Long.valueOf(0);
		return conteggio;
	}

	

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((pausa == null) ? 0 : pausa.hashCode());
		result = prime * result + ((positivo == null) ? 0 : positivo.hashCode());
		result = prime * result + ((user_id == null) ? 0 : user_id.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		ReportLavoratoResultSet other = (ReportLavoratoResultSet) obj;
		if (pausa == null) {
			if (other.pausa != null)
				return false;
		} else if (!pausa.equals(other.pausa))
			return false;
		if (positivo == null) {
			if (other.positivo != null)
				return false;
		} else if (!positivo.equals(other.positivo))
			return false;
		if (user_id == null) {
			if (other.user_id != null)
				return false;
		} else if (!user_id.equals(other.user_id))
			return false;
		return true;
	}

	public String getPausaS() {
		String c = ApplicationUtil.trimToNull(pausa);
		if(c != null) {
			return c + " " + (ApplicationUtil.isTrue(positivo) ? "[+]" : "[-]");
		}
		return "";
	}


	public String getPausa() {
		return ApplicationUtil.trimToEmpty(pausa);
	}


	public void setPausa(String pausa) {
		this.pausa = pausa;
	}


	public void setConteggio(Long conteggio) {
		this.conteggio = conteggio;
	}


	public Long getTotale() {
		if(totale == null)
			totale = Long.valueOf(0);
		return totale;
	}
	public Long getUser_id() {
		return user_id;
	}



	public Boolean getPositivo() {
		return ApplicationUtil.isTrue(positivo);
	}



	public void setPositivo(Boolean positivo) {
		this.positivo = positivo;
	}



	public void setTotale(Long totale) {
		this.totale = totale;
	}


	public void setUser_id(Long userId) {
		user_id = userId;
	}

	
	
	public long getTotaleS() {
		if(ApplicationUtil.isTrue(positivo)) {
			return 0L;
		} else {
			if(totale == null) {
				totale = 0L;
			}
			return totale.longValue();
		}
	}
	
	
}