package it.callite.model.sip;

import java.io.Serializable;
import java.util.Date;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.Index;
import javax.persistence.Table;

import it.callite.constants.ConstantsGlobal;
import it.callite.model.generic.SelezionatoAbstract;
import it.callite.utility.ApplicationUtil;






@SuppressWarnings("serial")
@Entity
//@Audited 
@Table(name = ConstantsGlobal.ts + "cel", indexes = { @Index(name= "cel", columnList = "eventtime, eventtype, cid_name, cid_num")})
public class Cel extends SelezionatoAbstract implements Serializable, Comparable<Cel> {

	private String accountcode;

	private Long amaflags;

	private String appdata;

	private String appname;

	private String channame;

	private String cid_ani;

	private String cid_dnid;

	private String cid_name;

	private String cid_num;

	private String cid_rdnis;

	private String context;

	@Column(columnDefinition="datetime NOT NULL COMMENT 'data'")
	private Date eventtime;

	private String eventtype;

	private String exten;

	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY) 
	private Long id;

	private String linkedid;

	private String peer;

	private String peeraccount;

	private String uniqueid;

	private String userdeftype;


	public int compareTo(Cel o) {
		if(id != null && o.id != null) {
			return id.compareTo(o.id);
		} else if(id != null && o.id == null) {
			return -1;
		} else if(id == null && o.id != null) {
			return 1;
		} else {
			return 0;
		}
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		Cel other = (Cel) obj;
		if (id == null) {
			if (other.id != null)
				return false;
		} else if (!id.equals(other.id))
			return false;
		return true;
	}

	public String getAccountcode() {
		return accountcode;
	}

	public Long getAmaflags() {
		return amaflags;
	}

	public String getAppdata() {
		return appdata;
	}

	public String getAppname() {
		return appname;
	}

	public String getChanname() {
		return channame;
	}

	public String getCid_ani() {
		return cid_ani;
	}

	public String getCid_dnid() {
		return cid_dnid;
	}

	public String getCid_name() {
		return cid_name;
	}

	public String getCid_num() {
		return cid_num;
	}

	public String getCid_rdnis() {
		return cid_rdnis;
	}

	public String getContext() {
		return context;
	}

	public String getDenominazione() {
		return ApplicationUtil.trimToEmpty(getChanname());
	}

	public Date getEventtime() {
		return eventtime;
	}

	public String getEventtype() {
		return eventtype;
	}

	public String getExten() {
		return exten;
	}

	public Long getId() {
		return id;
	}

	public String getLinkedid() {
		return linkedid;
	}

	public String getPeer() {
		return peer;
	}

	public String getPeeraccount() {
		return peeraccount;
	}


	public String getUniqueid() {
		return uniqueid;
	}
	public String getUserdeftype() {
		return userdeftype;
	}
	
	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((id == null) ? 0 : id.hashCode());
		return result;
	}
	public void setAccountcode(String accountcode) {
		this.accountcode = accountcode;
	}
	public void setAmaflags(Long amaflags) {
		this.amaflags = amaflags;
	}
	public void setAppdata(String appdata) {
		this.appdata = appdata;
	}
	public void setAppname(String appname) {
		this.appname = appname;
	}
	public void setChanname(String channame) {
		this.channame = channame;
	}
	public void setCid_ani(String cid_ani) {
		this.cid_ani = cid_ani;
	}
	public void setCid_dnid(String cid_dnid) {
		this.cid_dnid = cid_dnid;
	}
	public void setCid_name(String cid_name) {
		this.cid_name = cid_name;
	}
	public void setCid_num(String cid_num) {
		this.cid_num = cid_num;
	}
	public void setCid_rdnis(String cid_rdnis) {
		this.cid_rdnis = cid_rdnis;
	}
	public void setContext(String context) {
		this.context = context;
	}
	public void setEventtime(Date eventtime) {
		this.eventtime = eventtime;
	}
	public void setEventtype(String eventtype) {
		this.eventtype = eventtype;
	}
	public void setExten(String exten) {
		this.exten = exten;
	}
	public void setId(Long id) {
		this.id = id;
	}
	public void setLinkedid(String linkedid) {
		this.linkedid = linkedid;
	}



	public void setPeer(String peer) {
		this.peer = peer;
	}

	public void setPeeraccount(String peeraccount) {
		this.peeraccount = peeraccount;
	}



	public void setUniqueid(String uniqueid) {
		this.uniqueid = uniqueid;
	}


	public void setUserdeftype(String userdeftype) {
		this.userdeftype = userdeftype;
	}


	@Override
	public String toString() {
		return ApplicationUtil.toString(id, getDenominazione());
	}



}
