package it.callite.model.sip;

import java.io.Serializable;
import java.util.Date;

import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.Index;
import javax.persistence.Table;

import it.callite.constants.ConstantsGlobal;
import it.callite.constants.ConstantsMap;
import it.callite.model.generic.SelezionatoAbstract;
import it.callite.utility.ApplicationUtil;






@SuppressWarnings("serial")
@Entity
//@Audited 
@Table(name = ConstantsGlobal.ts + "extensions_table", indexes = { @Index(name= "extensions_table", columnList = "data_creazione, context, exten, priority" )})
public class ExtensionsTable extends SelezionatoAbstract implements Serializable {


	private String app;

	private String appdata;

	private String context = ConstantsMap.context_u;
	private String exten = ConstantsGlobal.extenE;
	private Integer priority = 1;
	private Date data_creazione = ApplicationUtil.date();
	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY) 
	private Long id;
	public ExtensionsTable() {
	}
	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		ExtensionsTable other = (ExtensionsTable) obj;
		if (id == null) {
			if (other.id != null)
				return false;
		} else if (!id.equals(other.id))
			return false;
		return true;
	}
	
	public String getApp() {
		return ApplicationUtil.trimToEmpty(app);
	}
	public String getAppdata() {
		return ApplicationUtil.trimToEmpty(appdata);
	}

	public String getContext() {
		return ApplicationUtil.trimToEmpty(context);
	}

	public ExtensionsTable getCopia() {
		ExtensionsTable pr = new ExtensionsTable();
		pr.setExten(this.getExten());
		return pr;
	}

	public Date getData_creazione() {
		return data_creazione;
	}

	public String getDenominazione() {
		return ApplicationUtil.trimToEmpty(getExten());
	}


	public String getExten() {
		return ApplicationUtil.normalizeToEmpty(exten);
	}

	public Long getId() {
		return id;
	}


	public Integer getPriority() {
		return priority;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((id == null) ? 0 : id.hashCode());
		return result;
	}

	
	public void setApp(String app) {
		this.app = ApplicationUtil.normalizeToEmpty(app);
	}

	public void setAppdata(String appdata) {
		this.appdata = ApplicationUtil.normalizeToEmpty(appdata);
	}

	public void setContext(String context) {
		this.context = context;
	}

	public void setData_creazione(Date data_creazione) {
		this.data_creazione = data_creazione;
	}

	public void setExten(String exten) {
		this.exten =  ApplicationUtil.normalizeToEmpty(exten);
	}

	public void setId(Long id) {
		this.id = id;
	}
	
	public void setPriority(Integer priority) {
		this.priority = priority;
	}
	

	@Override
	public String toString() {
		return ApplicationUtil.toString(id, getDenominazione());
	}

}
