package it.callite.model.sip;
import java.io.Serializable;

import javax.persistence.Column;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.GenerationType;
import javax.persistence.Id;
import javax.persistence.Index;
import javax.persistence.Table;

import it.callite.constants.ConstantsGlobal;
import it.callite.model.generic.SelezionatoAbstract;
import it.callite.utility.ApplicationUtil;
@SuppressWarnings("serial")
@Entity
//@Audited 
@Table(name = ConstantsGlobal.ts + "musiconhold", indexes = { @Index(name= "musiconhold", columnList = "name" )})
public class Musiconhold  extends SelezionatoAbstract implements Serializable, Comparable<Musiconhold> {
	
	@Id
	@GeneratedValue(strategy = GenerationType.IDENTITY) 
	private Long id;
	private String name;
	@Column(columnDefinition = "text")
	private String directory;
	private String application = "";
	private String mode = "files";
	private Character digit;
	private String sort = "random";
	private String format = "";

	
	public Long getId() {
		return id;
	}
	public void setId(Long id) {
		this.id = id;
	}
	public int compareTo(Musiconhold o) {
		if(id != null && o.id != null) {
			return id.compareTo(o.id);
		} else if(id != null && o.id == null) {
			return -1;
		} else if(id == null && o.id != null) {
			return 1;
		} else {
			return 0;
		}
	}
	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		Musiconhold other = (Musiconhold) obj;
		if (id == null) {
			if (other.id != null)
				return false;
		} else if (!id.equals(other.id))
			return false;
		return true;
	}
	
	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((id == null) ? 0 : id.hashCode());
		return result;
	}
	public String getName() {
		return ApplicationUtil.normalizeToEmpty(name);
	}
	public void setName(String name) {
		this.name = ApplicationUtil.normalizeToEmpty(name);
	}
	public String getDirectory() {
		return ApplicationUtil.trimToEmpty(directory);
	}
	public void setDirectory(String directory) {
		this.directory = ApplicationUtil.trimToEmpty(directory);
	}
	public String getApplication() {
		return ApplicationUtil.trimToEmpty(application);
	}
	public void setApplication(String application) {
		this.application = ApplicationUtil.trimToEmpty(application);
	}
	public String getMode() {
		return ApplicationUtil.trimToEmpty(mode);
	}
	public void setMode(String mode) {
		this.mode = ApplicationUtil.trimToEmpty(mode);
	}
	public Character getDigit() {
		return digit;
	}
	public void setDigit(Character digit) {
		this.digit = digit;
	}
	public String getSort() {
		return ApplicationUtil.trimToEmpty(sort);
	}
	public void setSort(String sort) {
		this.sort = ApplicationUtil.trimToEmpty(sort);
	}
	public String getFormat() {
		return ApplicationUtil.trimToEmpty(format);
	}
	public void setFormat(String format) {
		this.format = ApplicationUtil.trimToEmpty(format);
	}
	
	
	
}