package it.callite.security;

import java.io.IOException;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.security.core.Authentication;
import org.springframework.security.web.authentication.SimpleUrlAuthenticationSuccessHandler;

import it.callite.constants.ConstantsGlobal;
import it.callite.dao.OperazioneDao;
import it.callite.model.Utente;
import it.callite.utility.ApplicationUtil;

public class AuthenticationLoginSuccessHandler extends SimpleUrlAuthenticationSuccessHandler {
	
	@Autowired
	private OperazioneDao operazioneDao;
	
	public void onAuthenticationSuccess(HttpServletRequest request, HttpServletResponse response, Authentication authentication) throws IOException, ServletException {
		setDefaultTargetUrl(ConstantsGlobal.path_web_index);
		if(authentication!= null && authentication.isAuthenticated()) {
			Object principal = authentication.getPrincipal();
			if (principal instanceof Utente) {
				Utente user = (Utente) principal;
				if(user != null) {
					String ip = ApplicationUtil.ip(request);  
					operazioneDao.loginSuccess(user, ip);
				}
				response.sendRedirect(request.getContextPath() + ConstantsGlobal.path_web_index);
			}
		}
		super.onAuthenticationSuccess(request, response, authentication);
	}

	
	
}