package it.callite.security;
import java.io.IOException;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.security.core.Authentication;
import org.springframework.security.web.authentication.logout.SimpleUrlLogoutSuccessHandler;

import it.callite.constants.ConstantsGlobal;
import it.callite.dao.OperazioneDao;
import it.callite.model.Utente;
import it.callite.utility.ApplicationUtil;



public class AuthenticationLogoutSuccessHandler extends SimpleUrlLogoutSuccessHandler {
	
	@Autowired
	private OperazioneDao operazioneDao;

	public void onLogoutSuccess(HttpServletRequest request, HttpServletResponse response, Authentication authentication) throws IOException, ServletException {
		if(authentication!= null && authentication.isAuthenticated()) {
			Object principal = authentication.getPrincipal();
			if (principal instanceof Utente) {
				Utente user = (Utente) principal;
				if(user != null) {
					String ipAddress = ApplicationUtil.ip(request);  
					operazioneDao.logoutSuccessR(user, ipAddress, ConstantsGlobal.logoutL);
					
				}
			}
		}
		super.onLogoutSuccess(request, response, authentication);
	}
}