package it.callite.service.config;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import org.springframework.beans.factory.InitializingBean;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import it.callite.constants.config.DefaultsAnagrafica;
import it.callite.dao.config.ConfigurazioneAnagraficaDao;
import it.callite.model.config.ConfigAnagrafica;
import it.callite.utility.ApplicationUtil;
@SuppressWarnings("serial")
@Service("configurazioneAnagraficaService")
public class ConfigurazioneAnagraficaService extends HashMap<String, String> implements  InitializingBean {
	public Map<String, String> configurazioneAnagraficaServiceMap = new HashMap<String, String>();
	@Autowired
	private ConfigurazioneAnagraficaDao configurazioneAnagraficaDao;
	public String getValore(String key) {
		if(configurazioneAnagraficaServiceMap.containsKey(key)) {
			return configurazioneAnagraficaServiceMap.get(key);
		} else { 
			ConfigAnagrafica conf = configurazioneAnagraficaDao.getValue(key);
			String valore = conf.getValore();
			configurazioneAnagraficaServiceMap.put(key, valore);
			return ApplicationUtil.trimToEmpty(valore);
		}
	}
	public ConfigAnagrafica salva(ConfigAnagrafica config) {
		String chiave = config.getChiave();
		configurazioneAnagraficaServiceMap.put(chiave, config.getValore());
		return configurazioneAnagraficaDao.salva(config);
	}
	public void elimina(ConfigAnagrafica config) {
		String chiave = config.getChiave();
		if(configurazioneAnagraficaServiceMap.containsKey(chiave)) {
			configurazioneAnagraficaServiceMap.remove(chiave);
		}
		configurazioneAnagraficaDao.elimina(config);
	}
	public void afterPropertiesSet() throws Exception {
		List<String> keyList =  new ArrayList<String>(DefaultsAnagrafica.DEFAULTS.keySet());
		if(ApplicationUtil.notEmpty(keyList)) {
			Iterator<String> iter = keyList.iterator();
			while (iter.hasNext()) {
				String key = (String) iter.next();
				getValore(key);
			}
			configurazioneAnagraficaDao.eliminaNotInConfig(keyList);
		}
	}
	@Override
	public String get(Object chiave) {
		return getValore((String) chiave);
	}
}