package it.callite.service.config;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import org.springframework.beans.factory.InitializingBean;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import it.callite.constants.config.DefaultsData;
import it.callite.dao.config.ConfigurazioneDataDao;
import it.callite.model.config.ConfigData;
import it.callite.utility.ApplicationUtil;
@SuppressWarnings("serial")
@Service("configurazioneDataService")
public class ConfigurazioneDataService extends HashMap<String, String> implements  InitializingBean {
	public Map<String, String> configurazioneDataServiceMap = new HashMap<String, String>();
	@Autowired
	private ConfigurazioneDataDao configurazioneDataDao;
	public String getValore(String key) {
		if(configurazioneDataServiceMap.containsKey(key)) {
			return configurazioneDataServiceMap.get(key);
		} else { 
			ConfigData conf = configurazioneDataDao.getValue(key);
			String valore = conf.getValore();
			configurazioneDataServiceMap.put(key, valore);
			return ApplicationUtil.trimToEmpty(valore);
		}
	}
	public ConfigData salva(ConfigData config) {
		String chiave = config.getChiave();
		configurazioneDataServiceMap.put(chiave, config.getValore());
		return configurazioneDataDao.salva(config);
	}
	public void elimina(ConfigData config) {
		String chiave = config.getChiave();
		if(configurazioneDataServiceMap.containsKey(chiave)) {
			configurazioneDataServiceMap.remove(chiave);
		}
		configurazioneDataDao.elimina(config);
	}
	public void afterPropertiesSet() throws Exception {
		List<String> keyList =  new ArrayList<String>(DefaultsData.DEFAULTS.keySet());
		if(ApplicationUtil.notEmpty(keyList)) {
			Iterator<String> iter = keyList.iterator();
			while (iter.hasNext()) {
				String key = (String) iter.next();
				getValore(key);
			}
			configurazioneDataDao.eliminaNotInConfig(keyList);
		}
	}
	@Override
	public String get(Object chiave) {
		return getValore((String) chiave);
	}
}