package it.callite.service.config;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import org.springframework.beans.factory.InitializingBean;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import it.callite.constants.config.DefaultsFtp;
import it.callite.dao.config.ConfigurazioneFtpDao;
import it.callite.model.config.ConfigFtp;
import it.callite.utility.ApplicationUtil;
@SuppressWarnings("serial")
@Service("configurazioneFtpService")
public class ConfigurazioneFtpService extends HashMap<String, String> implements  InitializingBean {
	public Map<String, String> configurazioneFtpServiceMap = new HashMap<String, String>();
	@Autowired
	private ConfigurazioneFtpDao configurazioneFtpDao;
	public String getValore(String key) {
		if(configurazioneFtpServiceMap.containsKey(key)) {
			return configurazioneFtpServiceMap.get(key);
		} else { 
			ConfigFtp conf = configurazioneFtpDao.getValue(key);
			String valore = conf.getValore();
			configurazioneFtpServiceMap.put(key, valore);
			return ApplicationUtil.trimToEmpty(valore);
		}
	}
	public ConfigFtp salva(ConfigFtp config) {
		String chiave = config.getChiave();
		configurazioneFtpServiceMap.put(chiave, config.getValore());
		return configurazioneFtpDao.salva(config);
	}
	public void elimina(ConfigFtp config) {
		String chiave = config.getChiave();
		if(configurazioneFtpServiceMap.containsKey(chiave)) {
			configurazioneFtpServiceMap.remove(chiave);
		}
		configurazioneFtpDao.elimina(config);
	}
	public void afterPropertiesSet() throws Exception {
		List<String> keyList =  new ArrayList<String>(DefaultsFtp.DEFAULTS.keySet());
		if(ApplicationUtil.notEmpty(keyList)) {
			Iterator<String> iter = keyList.iterator();
			while (iter.hasNext()) {
				String key = (String) iter.next();
				getValore(key);
			}
			configurazioneFtpDao.eliminaNotInConfig(keyList);
		}
	}
	@Override
	public String get(Object chiave) {
		return getValore((String) chiave);
	}
}