package it.callite.service.config;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import org.springframework.beans.factory.InitializingBean;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import it.callite.constants.config.DefaultsSleep;
import it.callite.dao.config.ConfigurazioneSleepDao;
import it.callite.model.config.ConfigSleep;
import it.callite.utility.ApplicationUtil;
@SuppressWarnings("serial")
@Service("configurazioneSleepService")
public class ConfigurazioneSleepService extends HashMap<String, String> implements  InitializingBean {
	public Map<String, String> configurazioneSleepServiceMap = new HashMap<String, String>();
	@Autowired
	private ConfigurazioneSleepDao configurazioneSleepDao;
	public String getValore(String key) {
		if(configurazioneSleepServiceMap.containsKey(key)) {
			return configurazioneSleepServiceMap.get(key);
		} else { 
			ConfigSleep conf = configurazioneSleepDao.getValue(key);
			String valore = conf.getValore();
			configurazioneSleepServiceMap.put(key, valore);
			return ApplicationUtil.trimToEmpty(valore);
		}
	}
	public ConfigSleep salva(ConfigSleep config) {
		String chiave = config.getChiave();
		configurazioneSleepServiceMap.put(chiave, config.getValore());
		return configurazioneSleepDao.salva(config);
	}
	public void elimina(ConfigSleep config) {
		String chiave = config.getChiave();
		if(configurazioneSleepServiceMap.containsKey(chiave)) {
			configurazioneSleepServiceMap.remove(chiave);
		}
		configurazioneSleepDao.elimina(config);
	}
	public void afterPropertiesSet() throws Exception {
		List<String> keyList =  new ArrayList<String>(DefaultsSleep.DEFAULTS.keySet());
		if(ApplicationUtil.notEmpty(keyList)) {
			Iterator<String> iter = keyList.iterator();
			while (iter.hasNext()) {
				String key = (String) iter.next();
				getValore(key);
			}
			configurazioneSleepDao.eliminaNotInConfig(keyList);
		}
	}
	@Override
	public String get(Object chiave) {
		return getValore((String) chiave);
	}
}