package it.callite.service.config;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import org.springframework.beans.factory.InitializingBean;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import it.callite.constants.config.DefaultsSmtp;
import it.callite.dao.config.ConfigurazioneSmtpDao;
import it.callite.model.config.ConfigSmtp;
import it.callite.utility.ApplicationUtil;
@SuppressWarnings("serial")
@Service("configurazioneSmtpService")
public class ConfigurazioneSmtpService extends HashMap<String, String> implements  InitializingBean {
	public Map<String, String> configurazioneSmtpServiceMap = new HashMap<String, String>();
	@Autowired
	private ConfigurazioneSmtpDao configurazioneSmtpDao;
	public String getValore(String key) {
		if(configurazioneSmtpServiceMap.containsKey(key)) {
			return configurazioneSmtpServiceMap.get(key);
		} else { 
			ConfigSmtp conf = configurazioneSmtpDao.getValue(key);
			String valore = conf.getValore();
			configurazioneSmtpServiceMap.put(key, valore);
			return ApplicationUtil.trimToEmpty(valore);
		}
	}
	public ConfigSmtp salva(ConfigSmtp config) {
		String chiave = config.getChiave();
		configurazioneSmtpServiceMap.put(chiave, config.getValore());
		return configurazioneSmtpDao.salva(config);
	}
	public void elimina(ConfigSmtp config) {
		String chiave = config.getChiave();
		if(configurazioneSmtpServiceMap.containsKey(chiave)) {
			configurazioneSmtpServiceMap.remove(chiave);
		}
		configurazioneSmtpDao.elimina(config);
	}
	public void afterPropertiesSet() throws Exception {
		List<String> keyList =  new ArrayList<String>(DefaultsSmtp.DEFAULTS.keySet());
		if(ApplicationUtil.notEmpty(keyList)) {
			Iterator<String> iter = keyList.iterator();
			while (iter.hasNext()) {
				String key = (String) iter.next();
				getValore(key);
			}
			configurazioneSmtpDao.eliminaNotInConfig(keyList);
		}
	}
	@Override
	public String get(Object chiave) {
		return getValore((String) chiave);
	}
}