package it.callite.service.config;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import org.springframework.beans.factory.InitializingBean;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import it.callite.constants.config.DefaultsStorage;
import it.callite.dao.config.ConfigurazioneStorageDao;
import it.callite.model.config.ConfigStorage;
import it.callite.utility.ApplicationUtil;
@SuppressWarnings("serial")
@Service("configurazioneStorageService")
public class ConfigurazioneStorageService extends HashMap<String, Boolean> implements  InitializingBean {
	public Map<String, Boolean> configurazioneStorageServiceMap = new HashMap<String, Boolean>();
	@Autowired
	private ConfigurazioneStorageDao configurazioneStorageDao;
	public Boolean getValore(String key) {
		if(configurazioneStorageServiceMap.containsKey(key)) {
			return configurazioneStorageServiceMap.get(key);
		} else { 
			ConfigStorage conf = configurazioneStorageDao.getValue(key);
			Boolean valore = conf.getValore();
			configurazioneStorageServiceMap.put(key, valore);
			return valore;
		}
	}
	private ConfigStorage salva(ConfigStorage config) {
		String chiave = config.getChiave();
		configurazioneStorageServiceMap.put(chiave, config.getValore());
		return configurazioneStorageDao.salva(config);
	}

	public void afterPropertiesSet() throws Exception {
		List<String> keyList =  new ArrayList<String>(DefaultsStorage.DEFAULTS.keySet());
		if(ApplicationUtil.notEmpty(keyList)) {
			Iterator<String> iter = keyList.iterator();
			while (iter.hasNext()) {
				String key = (String) iter.next();
				getValore(key);
			}
			configurazioneStorageDao.eliminaNotInConfig(keyList);
		}
	}
	@Override
	public Boolean get(Object chiave) {
		return getValore((String) chiave);
	}
	
	public void update(String chiave, Boolean valore) {
		ConfigStorage c = configurazioneStorageDao.getValue(chiave);
		c.setValore(valore);
		salva(c);
	}
}