package it.callite.service.config;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import org.springframework.beans.factory.InitializingBean;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import it.callite.constants.config.DefaultsValidatore;
import it.callite.dao.config.ConfigurazioneValidatoreDao;
import it.callite.model.config.ConfigValidatore;
import it.callite.utility.ApplicationUtil;
@SuppressWarnings("serial")
@Service("configurazioneValidatoreService")
public class ConfigurazioneValidatoreService extends HashMap<String, String> implements  InitializingBean {
	public Map<String, String> configurazioneValidatoreServiceMap = new HashMap<String, String>();
	@Autowired
	private ConfigurazioneValidatoreDao configurazioneValidatoreDao;
	public String getValore(String key) {
		if(configurazioneValidatoreServiceMap.containsKey(key)) {
			return configurazioneValidatoreServiceMap.get(key);
		} else { 
			ConfigValidatore conf = configurazioneValidatoreDao.getValue(key);
			String valore = conf.getValore();
			configurazioneValidatoreServiceMap.put(key, valore);
			return ApplicationUtil.trimToEmpty(valore);
		}
	}
	public ConfigValidatore salva(ConfigValidatore config) {
		String chiave = config.getChiave();
		configurazioneValidatoreServiceMap.put(chiave, config.getValore());
		return configurazioneValidatoreDao.salva(config);
	}
	public void elimina(ConfigValidatore config) {
		String chiave = config.getChiave();
		if(configurazioneValidatoreServiceMap.containsKey(chiave)) {
			configurazioneValidatoreServiceMap.remove(chiave);
		}
		configurazioneValidatoreDao.elimina(config);
	}
	public void afterPropertiesSet() throws Exception {
		List<String> keyList =  new ArrayList<String>(DefaultsValidatore.DEFAULTS.keySet());
		if(ApplicationUtil.notEmpty(keyList)) {
			Iterator<String> iter = keyList.iterator();
			while (iter.hasNext()) {
				String key = (String) iter.next();
				getValore(key);
			}
			configurazioneValidatoreDao.eliminaNotInConfig(keyList);
		}
	}
	@Override
	public String get(Object chiave) {
		return getValore((String) chiave);
	}
}