package it.callite.utility;

import java.io.File;
import java.io.Serializable;
import java.util.Arrays;
import java.util.Date;

public class Allegato implements Serializable {

	private static final long serialVersionUID = 1L;

	private boolean pathM = true;
	private boolean salva = true;

	public boolean isSalva() {
		return salva;
	}


	public void setSalva(boolean salva) {
		this.salva = salva;
	}


	private long dimensione;
	private Date data_modifica = ApplicationUtil.date();

	private byte[] file;

	private String nome;

	private String percorso;

	public String getPercorso() {
		return percorso;
	}

	public boolean isPercorsoE() {
		return percorso != null;
	}
	public boolean isFileE() {
		return file != null;
	}

	public void setPercorso(String percorso) {
		this.percorso = percorso;
	}


	public Allegato(boolean p, String nome) {
		if(p) {
			this.nome = nome;
		} else {
			this.percorso = nome;
		}
	}

	public Allegato(String nome, String percorsoP) {
		this.nome = nome;
		File f = new File(percorsoP);
		if(f.exists()) {
			this.percorso = f.getAbsolutePath();
		}
	}

	public Allegato(String nome, byte[] fileP) {
		this.nome = nome;
		if(fileP != null && fileP.length > 0) {
			this.file = fileP;
		}
	}

	public long getDimensione() {
		return dimensione;
	}

	public byte[] getFile() {
		return file;
	}

	public boolean isLogo() {
		return file != null && file.length > 0;
	}

	public String getNome() {
		return isPathM() ? ApplicationUtil.getNameN(nome) : nome;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((data_modifica == null) ? 0 : data_modifica.hashCode());
		result = prime * result + (int) (dimensione ^ (dimensione >>> 32));
		result = prime * result + Arrays.hashCode(file);
		result = prime * result + ((nome == null) ? 0 : nome.hashCode());
		return result;
	}


	public void setDimensione(long dimensione) {
		this.dimensione = dimensione;
	}


	public boolean isPathM() {
		return pathM;
	}


	public void setPathM(boolean pathM) {
		this.pathM = pathM;
	}


	public void setFile(byte[] file) {
		this.file = file;
	}


	public Date getData_modifica() {
		return data_modifica;
	}


	public void setData_modifica(Date data_modifica) {
		this.data_modifica = data_modifica;
	}


	public void setNome(String nome) {
		this.nome = nome;
	}


	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		Allegato other = (Allegato) obj;
		if (data_modifica == null) {
			if (other.data_modifica != null)
				return false;
		} else if (!data_modifica.equals(other.data_modifica))
			return false;
		if (dimensione != other.dimensione)
			return false;
		if (!Arrays.equals(file, other.file))
			return false;
		if (nome == null) {
			if (other.nome != null)
				return false;
		} else if (!nome.equals(other.nome))
			return false;
		return true;
	}

}