package it.callite.utility;

import java.util.ArrayList;
import java.util.List;


public class AnagraficaPagine {

	private List<String> altri = new ArrayList<String>();

	private String cap;

	private String categoria;
	private String comune;
	private String email;
	private List<String> fisso = new ArrayList<String>();

	private String indirizzo;

	private String link;
	private List<String> mobile = new ArrayList<String>();
	private String nome_completo;
	private Boolean pf;
	private String provincia;
	private String ragione_sociale;
	private String telefono_altro;
	private String telefono_fax;
	private String telefono_fisso;
	private String telefono_mobile;
	public AnagraficaPagine() {
	}
	
	public void addFisso(String fisso) {
		if(ApplicationUtil.isNotBlank(fisso) && !this.fisso.contains(fisso))
			this.fisso.add(fisso);
	}

	public void addMobile(String mobile) {
		if(ApplicationUtil.isNotBlank(mobile) && !this.mobile.contains(mobile))
			this.mobile.add(mobile);
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		AnagraficaPagine other = (AnagraficaPagine) obj;
		if (cap == null) {
			if (other.cap != null)
				return false;
		} else if (!cap.equals(other.cap))
			return false;
		if (categoria == null) {
			if (other.categoria != null)
				return false;
		} else if (!categoria.equals(other.categoria))
			return false;
		if (comune == null) {
			if (other.comune != null)
				return false;
		} else if (!comune.equals(other.comune))
			return false;
		if (email == null) {
			if (other.email != null)
				return false;
		} else if (!email.equals(other.email))
			return false;
		if (fisso == null) {
			if (other.fisso != null)
				return false;
		} else if (!fisso.equals(other.fisso))
			return false;
		if (indirizzo == null) {
			if (other.indirizzo != null)
				return false;
		} else if (!indirizzo.equals(other.indirizzo))
			return false;
		if (link == null) {
			if (other.link != null)
				return false;
		} else if (!link.equals(other.link))
			return false;
		if (mobile == null) {
			if (other.mobile != null)
				return false;
		} else if (!mobile.equals(other.mobile))
			return false;
		if (nome_completo == null) {
			if (other.nome_completo != null)
				return false;
		} else if (!nome_completo.equals(other.nome_completo))
			return false;
		if (pf == null) {
			if (other.pf != null)
				return false;
		} else if (!pf.equals(other.pf))
			return false;
		if (provincia == null) {
			if (other.provincia != null)
				return false;
		} else if (!provincia.equals(other.provincia))
			return false;
		if (ragione_sociale == null) {
			if (other.ragione_sociale != null)
				return false;
		} else if (!ragione_sociale.equals(other.ragione_sociale))
			return false;
		if (telefono_altro == null) {
			if (other.telefono_altro != null)
				return false;
		} else if (!telefono_altro.equals(other.telefono_altro))
			return false;
		if (telefono_fax == null) {
			if (other.telefono_fax != null)
				return false;
		} else if (!telefono_fax.equals(other.telefono_fax))
			return false;
		if (telefono_fisso == null) {
			if (other.telefono_fisso != null)
				return false;
		} else if (!telefono_fisso.equals(other.telefono_fisso))
			return false;
		if (telefono_mobile == null) {
			if (other.telefono_mobile != null)
				return false;
		} else if (!telefono_mobile.equals(other.telefono_mobile))
			return false;
		return true;
	}
	
	public List<String> getAltri() {
		return altri;
	}
	public String getCap() {
		return cap;
	}

	public String getCategoria() {
		return categoria;
	}
	public String getComune() {
		return comune;
	}
	public String getEmail() {
		return email;
	}
	public List<String> getFisso() {
		return fisso;
	}
	public String getIndirizzo() {
		return indirizzo;
	}
	
	
	public String getLink() {
		return link;
	}

	public List<String> getMobile() {
		return mobile;
	}
	public String getNome_completo() {
		return nome_completo;
	}

	public Boolean getPf() {
		return pf;
	}
	public String getProvincia() {
		return provincia;
	}
	public String getRagione_sociale() {
		return ragione_sociale;
	}
	public String getTelefono_altro() {
		return telefono_altro;
	}
	
	public String getTelefono_fax() {
		return telefono_fax;
	}

	public String getTelefono_fisso() {
		return telefono_fisso;
	}

	public String getTelefono_mobile() {
		return telefono_mobile;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((cap == null) ? 0 : cap.hashCode());
		result = prime * result + ((categoria == null) ? 0 : categoria.hashCode());
		result = prime * result + ((comune == null) ? 0 : comune.hashCode());
		result = prime * result + ((email == null) ? 0 : email.hashCode());
		result = prime * result + ((fisso == null) ? 0 : fisso.hashCode());
		result = prime * result + ((indirizzo == null) ? 0 : indirizzo.hashCode());
		result = prime * result + ((link == null) ? 0 : link.hashCode());
		result = prime * result + ((mobile == null) ? 0 : mobile.hashCode());
		result = prime * result + ((nome_completo == null) ? 0 : nome_completo.hashCode());
		result = prime * result + ((pf == null) ? 0 : pf.hashCode());
		result = prime * result + ((provincia == null) ? 0 : provincia.hashCode());
		result = prime * result + ((ragione_sociale == null) ? 0 : ragione_sociale.hashCode());
		result = prime * result + ((telefono_altro == null) ? 0 : telefono_altro.hashCode());
		result = prime * result + ((telefono_fax == null) ? 0 : telefono_fax.hashCode());
		result = prime * result + ((telefono_fisso == null) ? 0 : telefono_fisso.hashCode());
		result = prime * result + ((telefono_mobile == null) ? 0 : telefono_mobile.hashCode());
		return result;
	}

	public void prepareTelefono(boolean esegui) {
		if(ApplicationUtil.notEmpty(fisso)) {
			this.telefono_fisso = ApplicationUtil.trimToEmpty(fisso.remove(0));
		}
		if(ApplicationUtil.notEmpty(fisso)) {
			this.telefono_fax = ApplicationUtil.trimToEmpty(fisso.remove(0));
		}
		if(ApplicationUtil.notEmpty(mobile)) {
			this.telefono_mobile = ApplicationUtil.trimToEmpty(mobile.remove(0));
		}
		List<String> telefoni = new ArrayList<String>();
		telefoni.addAll(fisso);
		telefoni.addAll(mobile);
		if(ApplicationUtil.notEmpty(telefoni)) {
			this.telefono_altro = ApplicationUtil.trimToEmpty(telefoni.remove(0));
		}
		if(ApplicationUtil.notEmpty(telefoni)) {
			setAltri(telefoni);
		}
		pulisci(esegui);
		 
	}

	public void pulisci(boolean esegui) {
		this.indirizzo = ApplicationUtil.standartize(esegui,indirizzo);
		this.cap = ApplicationUtil.standartize(esegui,cap);
		this.comune = ApplicationUtil.standartize(esegui,comune);
		this.provincia = ApplicationUtil.standartize(esegui,provincia);
		this.categoria = ApplicationUtil.standartize(esegui,categoria);
		this.email = ApplicationUtil.standartize(esegui,email);
		this.link = ApplicationUtil.standartize(esegui,link);
		this.nome_completo = ApplicationUtil.standartize(esegui,nome_completo);
		this.ragione_sociale = ApplicationUtil.standartize(esegui,ragione_sociale);
		this.telefono_altro = ApplicationUtil.standartize(esegui,telefono_altro);
		this.telefono_fax = ApplicationUtil.standartize(esegui,telefono_fax);
		this.telefono_fisso = ApplicationUtil.standartize(esegui,telefono_fisso);
		this.telefono_mobile = ApplicationUtil.standartize(esegui,telefono_mobile);
	}

	public void setAltri(List<String> altri) {
		this.altri = altri;
	}

	public void setCap(String cap) {
		this.cap = cap;
	}
	public void setCategoria(String categoria) {
		this.categoria = categoria;
	}
	public void setComune(String comune) {
		this.comune = comune;
	}
	public void setEmail(String email) {
		this.email = email;
	}
	public void setFisso(List<String> fisso) {
		this.fisso = fisso;
	}
	public void setIndirizzo(String indirizzo) {
		this.indirizzo = indirizzo;
	}
	public void setLink(String link) {
		this.link = link;
	}
	public void setMobile(List<String> mobile) {
		this.mobile = mobile;
	}
	public void setNome_completo(String nome_completo) {
		this.nome_completo = nome_completo;
	}
	public void setPf(Boolean pf) {
		this.pf = pf;
	}
	public void setProvincia(String provincia) {
		this.provincia = provincia;
	}

	public void setRagione_sociale(String ragione_sociale) {
		this.ragione_sociale = ragione_sociale;
	}

	public void setTelefono_altro(String telefono_altro) {
		this.telefono_altro = telefono_altro;
	}

	public void setTelefono_fax(String telefono_fax) {
		this.telefono_fax = telefono_fax;
	}


	public void setTelefono_fisso(String telefono_fisso) {
		this.telefono_fisso = telefono_fisso;
	}

	public void setTelefono_mobile(String telefono_mobile) {
		this.telefono_mobile = telefono_mobile;
	}
	
}
