package it.callite.utility;
import java.io.Serializable;
@SuppressWarnings("serial")
public class AutodialerMap implements Serializable {

	private Integer abbattute = 0;
	private Integer agganciate = 0;
	private Integer congestion = 0;
	private Integer esitate = 0;
	private Integer fallito = 0;
	private Integer gestite = 0;
	private Integer hangup = 0;
	private Integer macchina = 0;
	private Integer nonRisposto = 0;
	private Integer ringing = 0;
	private Integer occupato = 0;
	private Integer rifiutato = 0;
	private Integer rimosse = 0;
	private Integer risposte = 0;
	private Integer saltate = 0;
	private Integer scartate = 0;
	private Integer tentate = 0;
	private Integer inbound = 0;
	private Integer prenotato = 0;

	public AutodialerMap() {
	}

	public AutodialerMap(AutodialerMap s) {
		this.abbattute = s.getAbbattute();
		this.agganciate = s.getAgganciate();
		this.congestion = s.getCongestion();
		this.esitate = s.getEsitate();
		this.fallito = s.getFallito();
		this.gestite = s.getGestite();
		this.hangup = s.getHangup();
		this.macchina = s.getMacchina();
		this.nonRisposto = s.getNonRisposto();
		this.ringing = s.getRinging();
		this.occupato = s.getOccupato();
		this.rifiutato = s.getRifiutato();
		this.rimosse = s.getRimosse();
		this.risposte = s.getRisposte();
		this.saltate = s.getSaltate();
		this.scartate = s.getScartate();
		this.tentate = s.getTentate();
		this.inbound = s.getInbound();
		this.prenotato = s.getPrenotato();
	}

	public Integer getAbbattute() {
		return abbattute;
	}
	public Double getAbbattuteP() {
		return ApplicationUtil.percentuale(abbattute, tentate);
	}
	public Integer getAgganciate() {
		return agganciate;
	}

	public Double getAgganciateP() {
		return ApplicationUtil.percentuale(agganciate, tentate);
	}

	public Integer getCongestion() {
		return congestion;
	}
	public Double getCongestionP() {
		return ApplicationUtil.percentuale(congestion, tentate);
	}
	public Integer getEsitate() {
		return esitate;
	}
	public Double getEsitateP() {
		return ApplicationUtil.percentuale(esitate, tentate);
	}

	public Integer getFallito() {
		return fallito;
	}

	public Double getFallitoP() {
		return ApplicationUtil.percentuale(fallito, tentate);
	}
	public Integer getGestite() {
		return gestite;
	}
	public Double getGestiteP() {
		return ApplicationUtil.percentuale(gestite, tentate);
	}
	public Integer getHangup() {
		return hangup;
	}

	public Double getHangupP() {
		return ApplicationUtil.percentuale(hangup, tentate);
	}

	public Integer getMacchina() {
		return macchina;
	}

	public Double getMacchinaP() {
		return ApplicationUtil.percentuale(macchina, tentate);
	}
	public Double getInboundP() {
		return ApplicationUtil.percentuale(inbound, tentate);
	}

	public Integer getNonRisposto() {
		return nonRisposto;
	}
	
	public Integer getRinging() {
		return ringing;
	}
	
	public Integer getPrenotato() {
		return prenotato;
	}
	public Double getPrenotatoP() {
		return ApplicationUtil.percentuale(prenotato, tentate);
	}
	public Double getNonRispostoP() {
		return ApplicationUtil.percentuale(nonRisposto, tentate);
	}
	public Double getRingingP() {
		return ApplicationUtil.percentuale(ringing, tentate);
	}
	public Integer getOccupato() {
		return occupato;
	}
	public Double getOccupatoP() {
		return ApplicationUtil.percentuale(occupato, tentate);
	}
	public Integer getRifiutato() {
		return rifiutato;
	}

	public Double getRifiutatoP() {
		return ApplicationUtil.percentuale(rifiutato, tentate);
	}

	public Integer getRimosse() {
		return rimosse;
	}

	public Double getRimosseP() {
		return ApplicationUtil.percentuale(rimosse, tentate);
	}

	public Integer getRisposte() {
		return risposte;
	}
	public Double getRisposteP() {
		return ApplicationUtil.percentuale(risposte, tentate);
	}

	public Integer getSaltate() {
		return saltate;
	}

	public Double getSaltateP() {
		return ApplicationUtil.percentuale(saltate, tentate);
	}

	public Integer getScartate() {
		return scartate;
	}

	public Double getScartateP() {
		return ApplicationUtil.percentuale(scartate, tentate);
	}
	public Integer getTentate() {
		return tentate;
	}
	

	public void incAbbattute() {
		abbattute++;
	}

	public void incAgganciate() {
		agganciate++;
	}

	public void incCongestion() {
		congestion++;
	}

	public void incEsitate() {
		esitate++;
	}

	public void incFallito() {
		fallito++;
	}
	public void incGestite() {
		gestite++;
	}

	public void incHangup() {
		hangup++;
	}
	public void incMacchina() {
		macchina++;
	}
	public void incInbound() {
		inbound++;
	}
	public void incNonRisposto() {
		nonRisposto++;
	}
	public void incRinging() {
		ringing++;
	}
	public void incPrenotato() {
		prenotato++;
	}

	public void incOccupato() {
		occupato++;
	}

	public void incRifiutato() {
		rifiutato++;
	}
	public void incRimosse() {
		rimosse++;
	}

	public void incRisposte() {
		risposte++;
	}

	public void incSaltate() {
		saltate++;
	}

	public void incScartate() {
		scartate++;
	}

	public void incTentate() {
		tentate++;
	}
	

	public void resetAll() {
		gestite = 0;
		esitate = 0;
		scartate = 0;
		abbattute = 0;
		saltate = 0;
		rimosse = 0;
		risposte = 0;
		agganciate = 0;
		tentate = 0;
		hangup = 0;
		congestion = 0;
		occupato = 0;
		nonRisposto = 0;
		ringing = 0;
		rifiutato = 0;
		fallito = 0;
		macchina = 0;
		inbound = 0;
		prenotato = 0;
	}

	public void setAbbattute(Integer abbattute) {
		this.abbattute = abbattute;
	}

	public void setAgganciate(Integer agganciate) {
		this.agganciate = agganciate;
	}

	public void setCongestion(Integer congestion) {
		this.congestion = congestion;
	}

	public void setEsitate(Integer esitate) {
		this.esitate = esitate;
	}

	public void setFallito(Integer fallito) {
		this.fallito = fallito;
	}

	public void setGestite(Integer gestite) {
		this.gestite = gestite;
	}

	public void setHangup(Integer hangup) {
		this.hangup = hangup;
	}
	public void setMacchina(Integer macchina) {
		this.macchina = macchina;
	}
	public void setNonRisposto(Integer nonRisposto) {
		this.nonRisposto = nonRisposto;
	}
	public void setRinging(Integer ringing) {
		this.ringing = ringing;
	}
	public void setPrenotato(Integer prenotato) {
		this.prenotato = prenotato;
	}
	public void setOccupato(Integer occupato) {
		this.occupato = occupato;
	}
	public void setRifiutato(Integer rifiutato) {
		this.rifiutato = rifiutato;
	}
	public void setRimosse(Integer rimosse) {
		this.rimosse = rimosse;
	}
	public void setRisposte(Integer risposte) {
		this.risposte = risposte;
	}
	public void setSaltate(Integer saltate) {
		this.saltate = saltate;
	}
	public void setScartate(Integer scartate) {
		this.scartate = scartate;
	}
	public void setTentate(Integer tentate) {
		this.tentate = tentate;
	}

	public Integer getNonRisposte() {
		return rimosse + saltate + congestion + occupato + nonRisposto + ringing + rifiutato + fallito;
	}
	public Double getNonRisposteP() {
		return ApplicationUtil.percentuale(rimosse + saltate + congestion + occupato + nonRisposto + ringing + rifiutato + fallito, tentate);
	}

	public Integer getNonGestite() {
		return macchina + abbattute + agganciate + hangup + scartate;
	}
	public Double getNonGestiteP() {
		return ApplicationUtil.percentuale(macchina + abbattute + agganciate + hangup + scartate, tentate);
	}

	public Integer getInbound() {
		return inbound;
	}

	public void setInbound(Integer inbound) {
		this.inbound = inbound;
	}
	
	

	public void update(AutodialerMap am) {
		abbattute += am.getAbbattute();
		agganciate += am.getAgganciate();
		congestion += am.getCongestion();
		esitate += am.getEsitate();
		fallito += am.getFallito();
		gestite += am.getGestite();
		hangup += am.getHangup();
		macchina += am.getMacchina();
		inbound += am.getInbound();
		nonRisposto += am.getNonRisposto();
		ringing += am.getRinging();
		prenotato += am.getPrenotato();
		occupato += am.getOccupato();
		rifiutato += am.getRifiutato();
		rimosse += am.getRimosse();
		risposte += am.getRisposte();
		saltate += am.getSaltate();
		scartate += am.getScartate();
		tentate += am.getTentate();
	}
	
}