package it.callite.utility;

import java.lang.reflect.InvocationTargetException;
import java.util.ArrayList;
import java.util.List;

import org.apache.commons.beanutils.BeanUtils;
import org.apache.commons.beanutils.BeanUtilsBean;


public class CopyUtil {

	public static <T> T combine2Objects(T destination, T a) {
		try {
			BeanUtils.copyProperties(a, destination);
		} catch (Exception e) {

		}
		return destination;
	}

	public static void copyProperties(Object dest, Object source) {
		try {
			new BeanUtilsBean() {
				@Override
				public void copyProperty(Object dest, String name, Object value) throws IllegalAccessException, InvocationTargetException {
					if(value != null) {
						super.copyProperty(dest, name, value);
					}
				}
			}.copyProperties(dest, source);
		} catch (Exception e) {

		}
	}

	public static <T> T copyPropertiesList(T dest, Object... sources){
		try {
			final List<Object> lookingAt = new ArrayList<>();
			BeanUtilsBean recursiveBeanUtils = new BeanUtilsBean() {
				private boolean isInternal(String name) {
					return name.startsWith("java.") || name.startsWith("javax.") || name.startsWith("com.sun.") || name.startsWith("org.") || name.startsWith("oracle.");
				}
				@Override
				public void copyProperties(Object dest, Object orig) throws IllegalAccessException, InvocationTargetException {
					try {
						if(lookingAt.stream().anyMatch(o->o == dest)) {
							return; 
						}
						lookingAt.add(dest);
						super.copyProperties(dest, orig);
					} finally {
						lookingAt.remove(dest);
					}
				}

				@Override
				public void copyProperty(Object dest, String name, Object value)  throws IllegalAccessException, InvocationTargetException {
					if (value != null) {
						if(!value.getClass().isPrimitive() && !value.getClass().isSynthetic() && !isInternal(value.getClass().getName())) {
							try {
								Object prop = super.getPropertyUtils().getProperty(dest, name);
								if(prop == null) {
									super.setProperty(dest, name, super.cloneBean(value));
								} else {
									copyProperties(prop, value);
								}
							} catch (NoSuchMethodException e) {
								return;
							} catch (InstantiationException e) {
								throw new RuntimeException("Nested property could not be cloned.", e);
							}
						} else {
							super.copyProperty(dest, name, value);
						}
					}
				}
			};
			for(Object source : sources) {
				recursiveBeanUtils.copyProperties(dest, source);
			}
		} catch (Exception e) {

		}
		return dest;
	}
}