package it.callite.utility;
import java.io.Serializable;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.Set;

import it.callite.constants.ConstantsGlobal;
public class DatoSondaggio implements Serializable {

	private static final long serialVersionUID = 1L;

	private Map<CampoSpeciale,ValoreMappa> mappa = new LinkedHashMap<CampoSpeciale,ValoreMappa>();
	private Map<String,Object> valoriS = new HashMap<String,Object>();
	private Map<String,List<String>> valoriM = new HashMap<String,List<String>>();
	private String chiave;
	public String getChiave() {
		return chiave;
	}
	public void setChiave(String chiave) {
		this.chiave = chiave;
	}
	public ValoreMappa get(CampoSpeciale c, String defaults) {
		if(c != null && ApplicationUtil.gtZero(c.getTipo())) {
			ValoreMappa  value = mappa.get(c);
			if(value == null) {
				value = new ValoreMappa();
				String nuovaChiave = ApplicationUtil.trimToEmpty(ApplicationUtil.impostaCampoS(c.getEredita(), chiave, c.getChiave(), ConstantsGlobal.ereditaChiave));
				if(c.getPickList() || c.getManyCheckbox() || c.getManyMenu()) {
					List<String> o  = valoriM.get(nuovaChiave);
					if(o != null) {
						value.setMultiplo(o);
					} else {
						setDefaults(c, value, defaults);
					}
				} else {
					Object o = valoriS.get(nuovaChiave);
					if(o != null) {
						value.setSingolo(o);
					} else {
						setDefaults(c, value, defaults);
					}
				}
			}
			if(!mappa.containsKey(c)) {
				mappa.put(c, value);
			}
			return value;
		} 
		return null;
	}
	public Set<CampoSpeciale> keySet() {
		return mappa.keySet();
	}
	public boolean isEmpty() {
		return mappa.isEmpty();
	}
	public Map<CampoSpeciale,ValoreMappa> getData() {
		return mappa;
	}
	public DatoSondaggio() {
	}
	public Map<CampoSpeciale,ValoreMappa> getMappa() {
		return mappa;
	}
	public CampoSpeciale getCampo(String chiave, String principale) {
		List<CampoSpeciale> ls = new ArrayList<CampoSpeciale>(mappa.keySet());
		int  i = ls.indexOf(new CampoSpeciale(chiave, principale));
		if(i > -1) {
			CampoSpeciale cc = ls.get(i);
			return cc;
		}
		return null;
	}
	public Map<String, Object> getValoriS() {
		return valoriS;
	}
	public void setValoriS(Map<String, Object> valoriS) {
		this.valoriS = valoriS;
	}
	public Map<String, List<String>> getValoriM() {
		return valoriM;
	}
	public void setValoriM(Map<String, List<String>> valoriM) {
		this.valoriM = valoriM;
	}
	public void setDefaults(CampoSpeciale c, ValoreMappa value, String defaults) {
		String o = ApplicationUtil.trimToNull(defaults);
		if(o != null) {
			if(c.getPickList() || c.getManyCheckbox() || c.getManyMenu()) {
				value.setMultiplo(ApplicationUtil.tokenU(o, ConstantsGlobal.colonSeparator));
			} else if(c.getData() || c.getDataora() || c.getOra()) {
				value.setSingolo(ApplicationUtil.parseData(c.getValuesT(), o));
			} else if(c.getBooleano()) {
				value.setSingolo(ApplicationUtil.isTrue(Boolean.valueOf(o)));
			} else {
				value.setSingolo(o);
			}
		}
	}
	public boolean uguale(String chiave, String elemento) {
		return ApplicationUtil.prepareConfronto(this, false, chiave, elemento);
	}
	public boolean diverso(String chiave, String elemento) {
		return ApplicationUtil.prepareConfronto(this, true, chiave, elemento);
	}
	public ValoreMappa valore(String chiave) {
		return ApplicationUtil.prepareValore(this, chiave);
	}
	public boolean compara(Object oggetto, String elemento) {
		return ApplicationUtil.prepareConfronto(oggetto, elemento);
	}
	
}