package it.callite.utility;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.SortedMap;
import java.util.TreeMap;

import it.callite.model.Contatto;
import it.callite.model.EsitoChiamata;


public class EsitiMappa {

	private List<EsitoChiamata> totaliT = new ArrayList<EsitoChiamata>();
	private SortedMap<String, List<EsitoChiamata>> esitiT = new TreeMap<String, List<EsitoChiamata>>();

	public EsitiMappa(List<EsitoChiamata> t, Contatto contatto, boolean normale) {
		if(contatto != null) {
			if(ApplicationUtil.notEmpty(t)) {
				Iterator<EsitoChiamata> it = t.iterator();
				while (it.hasNext()) {
					EsitoChiamata es = (EsitoChiamata) it.next();
					if(es != null && (normale && ApplicationUtil.isTrue(es.getEsitoNormale())) || (!normale && ApplicationUtil.isTrue(es.getEsitoAutodialer()))) {
						if(ApplicationUtil.isTrue(es.getEsitoVisibile())) {
							String key = "text.richiamare_" + (ApplicationUtil.isTrue(es.getRichiamare()) ? "0" : "1");
							List<EsitoChiamata> visibili = esitiT.get(key);
							if(visibili == null){
								visibili = new ArrayList<EsitoChiamata>();
								esitiT.put(key, visibili);
							}
							visibili.add(es);
						}
						if((contatto.isPubblica() && es.getRagione_pubblica() != null) || (!contatto.isPubblica() && es.getRagione_privata() != null)) {
							if(!totaliT.contains(es)) {
								es.setIdentificativo("esito_" + (contatto.isPubblica() ? es.getRagione_pubblica() :  es.getRagione_privata()) + "_" + "e" + es.getId());
								totaliT.add(es);
							}
						}
					}
				}
			}
		}
	}

	public Map<String, List<EsitoChiamata>> getEsiti() {
		return esitiT;
	}

	public List<String> getSet() {
		return new ArrayList<String>(esitiT.keySet());
	}

	public List<EsitoChiamata> getTotaliT() {
		return totaliT;
	}

}
