package it.callite.utility;
import java.io.File;
import java.math.BigDecimal;
import java.text.DecimalFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.regex.Pattern;

import org.apache.commons.lang.time.DateUtils;
import org.apache.poi.ss.usermodel.Cell;
import org.apache.poi.ss.usermodel.DateUtil;
import org.apache.poi.ss.usermodel.Row;
import org.apache.poi.ss.usermodel.Row.MissingCellPolicy;
import org.apache.poi.ss.usermodel.Sheet;
import org.apache.poi.ss.usermodel.Workbook;

import it.callite.constants.ConstantsFormat;
import it.callite.constants.ConstantsGlobal;
import it.callite.constants.ConstantsLanguage;
import it.callite.constants.ConstantsMap;
import it.callite.model.Anagrafica;
import it.callite.model.Appuntamento;
import it.callite.model.Campagna;
import it.callite.model.CampoAggiuntivoAnagrafica;
import it.callite.model.Contatto;
import it.callite.model.Contratto;
import it.callite.model.DatoAggiuntivoAnagrafica;
import it.callite.model.Indirizzo;
import it.callite.model.Opposizione;
import it.callite.model.TemplateImportAnagrafica;
import it.callite.model.TemplateImportAppuntamento;
import it.callite.model.TemplateImportContatto;
import it.callite.model.TemplateImportContratto;
import it.callite.model.TemplateImportOpposizione;
import it.callite.utility.importa.ImportModelAnagrafica;
import it.callite.utility.importa.ImportModelAppuntamento;
import it.callite.utility.importa.ImportModelConsentite;
import it.callite.utility.importa.ImportModelContatto;
import it.callite.utility.importa.ImportModelContratto;
import it.callite.utility.importa.ImportModelOpposizione;
public class ExcelImport  {

	public static List<Anagrafica> importaExcel(Integer oC, Integer lt, String invertiConsentito, String file, TemplateImportAnagrafica ti, List<String> opposizioni, List<String> duplicati_fisso, List<String> duplicati_mobile, List<String> duplicati_fax, List<String> duplicati_altro, List<String> duplicati_email, List<String> duplicati_link, List<String> duplicati_codice, List<String> duplicati_partita, ImportModelAnagrafica importModel, Map<String, String> province, Map<String, String> comuni, ImportModelConsentite c, List<CampoAggiuntivoAnagrafica> dati) throws Exception {
		List<Anagrafica> anagrafiche = new ArrayList<Anagrafica>();
		File  f = new File(file);
		if(f.exists()) {
			long i = 0;
			Date dataC = ApplicationUtil.date();
			LoggerImport l = new LoggerImport(lt, ConstantsLanguage.IMPORT_FILE.stampa() + ": " + ApplicationUtil.getBaseNameN(file), ti.getDenominazione());
			boolean esegui = ti.getEsegui_filtro();
			String n = ApplicationUtil.replaceFileName(ApplicationUtil.getBaseNameN(file));
			List<String> vc = ti.getCampo_multiplo();
			List<String> nc = new ArrayList<String>();

			Workbook wb = ApplicationUtil.workbookG(ti.getRapido_filtro(), f);
			int sheetCnt = wb.getNumberOfSheets();
			for (int ii = 0; ii < sheetCnt; ii++) {
				Sheet sheet = wb.getSheetAt(ii);
				List<String> s = ti.getValore_multiplo();
				//int rows = sheet.getLastRowNum();
				int cols = s.size();
				int salta = ApplicationUtil.aggiustaRighe(ti.getSalta_righe());
				Iterator<Row> rows = sheet.rowIterator();
				int r = 0;
				while (rows.hasNext()) {
					Row row = rows.next();
					//Row row = sheet.getRow(r);
					if(row != null && r >= salta) {
						boolean importa = ApplicationUtil.importa(row, ti.getConsidera_filtro());
						if(importa){
							Anagrafica anagrafica = new Anagrafica();
							anagrafica.setIndirizzo_legale(new Indirizzo());
							anagrafica.setIndirizzo_operativo(new Indirizzo());
							for(int colonna = 0; colonna < cols; colonna++) { 
								Cell cella = row.getCell(colonna, MissingCellPolicy.CREATE_NULL_AS_BLANK);
								if(cella != null) {
									anagrafica = dataImport(esegui, anagrafica, colonna, cella, ti, vc, dati);
								}
							}
							anagrafica = ApplicationUtil.aggiustaNumeri(oC, invertiConsentito, ti, anagrafica, importModel, opposizioni, duplicati_fisso, duplicati_mobile, duplicati_fax, duplicati_altro, duplicati_email, duplicati_link, duplicati_codice, duplicati_partita, province, comuni,  s, c, nc);
							boolean iok = ApplicationUtil.importCondition(dataC, n, anagrafica, importModel);
							if(iok) {
								anagrafica.setSeq(++i);
								anagrafiche.add(anagrafica);
							}
						}
					}
					r++;
				}
			}
			if(ti != null && ApplicationUtil.notEmpty(nc)) {
				ti.setTelefoni(nc);
			}
			wb.close();
			l.log(anagrafiche);
		}
		return anagrafiche;
	}
	private static Anagrafica dataImport(boolean esegui, Anagrafica anagrafica, int colonna, Cell cella, TemplateImportAnagrafica ti, List<String> valoreCampi, List<CampoAggiuntivoAnagrafica> dati){
		if(ti.getPosizione(ConstantsMap.anagrafica_cognome).equals(colonna)) {
			anagrafica.setCognome(cellaTypeS(esegui, cella, null));
		}
		if(ti.getPosizione(ConstantsMap.anagrafica_nome).equals(colonna)) {
			anagrafica.setNome(cellaTypeS(esegui, cella, null));
		}
		if(ti.getPosizione(ConstantsMap.anagrafica_nome_completo).equals(colonna)) {
			anagrafica.setNome_completo(cellaTypeS(esegui, cella, null));
		}
		if(ti.getPosizione(ConstantsMap.anagrafica_email).equals(colonna)) {
			anagrafica.setEmail(ApplicationUtil.lowerCaseEmpty(cellaTypeS(esegui, cella, null)));
		}
		if(ti.getPosizione(ConstantsMap.anagrafica_codice_fiscale).equals(colonna)) {
			anagrafica.setCodice_fiscale(ApplicationUtil.upperCaseEmpty(cellaTypeS(esegui, cella, null)));
		}
		if(ti.getPosizione(ConstantsMap.anagrafica_partita_iva).equals(colonna)) {
			anagrafica.setPartita_iva(ApplicationUtil.upperCaseEmpty(cellaTypeS(esegui, cella, null)));
		}
		if(ti.getPosizione(ConstantsMap.anagrafica_nota).equals(colonna)) {
			anagrafica.setNota(cellaTypeS(esegui, cella, null));
		}
		if(ti.getPosizione(ConstantsMap.anagrafica_link).equals(colonna)) {
			anagrafica.setLink(cellaTypeS(esegui, cella, null));
		}
		if(ti.getPosizione(ConstantsMap.anagrafica_luogo_nascita).equals(colonna)) {
			anagrafica.setLuogo_nascita(ApplicationUtil.upperCaseEmpty(cellaTypeS(esegui, cella, null)));
		}
		if(ti.getPosizione(ConstantsMap.anagrafica_data_nascita).equals(colonna)) {
			anagrafica.setDate_nascita(cellaTypeD(esegui, cella, ConstantsFormat.date.stampa()));
		}
		if(ti.getPosizione(ConstantsMap.anagrafica_sesso).equals(colonna)) {
			anagrafica.setMaschio(cellaTypeV(esegui, cella, ConstantsGlobal.maschio, ConstantsGlobal.femmina ));
		}
		if(ti.getPosizione(ConstantsMap.anagrafica_tipo).equals(colonna)) {
			anagrafica.setPf(cellaTypeV(esegui, cella, ConstantsGlobal.residenziale , ConstantsGlobal.business));
		}
		if(ti.getPosizione(ConstantsMap.anagrafica_ragione_sociale).equals(colonna)) {
			anagrafica.setRagione_sociale(cellaTypeS(esegui, cella, null));
		}
		if(ti.getPosizione(ConstantsMap.anagrafica_telefono_fisso).equals(colonna)) {
			anagrafica.setTelefono_fisso(cellaTypeS(esegui, cella, null));
		}
		if(ti.getPosizione(ConstantsMap.anagrafica_telefono_altro).equals(colonna)) {
			anagrafica.setTelefono_altro(cellaTypeS(esegui, cella, null));
		}
		if(ti.getPosizione(ConstantsMap.anagrafica_telefono_mobile).equals(colonna)) {
			anagrafica.setTelefono_mobile(cellaTypeS(esegui, cella, null));
		}
		if(ti.getPosizione(ConstantsMap.anagrafica_telefono_fax).equals(colonna)) {
			anagrafica.setTelefono_fax(cellaTypeS(esegui, cella, null));
		}
		if(ti.getPosizione(ConstantsMap.anagrafica_settore).equals(colonna)) {
			anagrafica.setSettore(ApplicationUtil.upperCaseEmpty(cellaTypeS(esegui, cella, null)));
		}
		if(ti.getPosizione(ConstantsMap.indirizzo_legale_strada).equals(colonna)) {
			anagrafica.getIndirizzo_legale().setStrada(ApplicationUtil.upperCaseEmpty(cellaTypeS(esegui, cella, null)));
		}
		if(ti.getPosizione(ConstantsMap.indirizzo_legale_civico).equals(colonna)) {
			anagrafica.getIndirizzo_legale().setCivico(ApplicationUtil.upperCaseEmpty(cellaTypeS(esegui, cella, null)));
		}
		if(ti.getPosizione(ConstantsMap.indirizzo_legale_cap).equals(colonna)) {
			anagrafica.getIndirizzo_legale().setCap(ApplicationUtil.upperCaseEmpty(cellaTypeS(esegui, cella, "00000")));
		}
		if(ti.getPosizione(ConstantsMap.indirizzo_legale_comune).equals(colonna)) {
			anagrafica.getIndirizzo_legale().setComune(ApplicationUtil.upperCaseEmpty(cellaTypeS(esegui, cella, null)));
		}
		if(ti.getPosizione(ConstantsMap.indirizzo_legale_provincia).equals(colonna)) {
			anagrafica.getIndirizzo_legale().setProvincia(ApplicationUtil.upperCaseEmpty(cellaTypeS(esegui, cella, null)));
		}
		if(ti.getPosizione(ConstantsMap.indirizzo_legale_regione).equals(colonna)) {
			anagrafica.getIndirizzo_legale().setRegione(ApplicationUtil.upperCaseEmpty(cellaTypeS(esegui, cella, null)));
		}
		if(ti.getPosizione(ConstantsMap.indirizzo_legale_dettagli).equals(colonna)) {
			anagrafica.getIndirizzo_legale().setDettagli(cellaTypeS(esegui, cella, null));
		} 
		if(ti.getPosizione(ConstantsMap.indirizzo_legale_latitudine).equals(colonna)) {
			anagrafica.getIndirizzo_legale().setLatitudine(cellaTypeS(esegui, cella, null));
		}
		if(ti.getPosizione(ConstantsMap.indirizzo_legale_longitudine).equals(colonna)) {
			anagrafica.getIndirizzo_legale().setLongitudine(cellaTypeS(esegui, cella, null));
		}
		if(ti.getPosizione(ConstantsMap.indirizzo_legale_presso).equals(colonna)) {
			anagrafica.getIndirizzo_legale().setPresso(ApplicationUtil.upperCaseEmpty(cellaTypeS(esegui, cella, null)));
		}
		if(ti.getPosizione(ConstantsMap.indirizzo_operativo_strada).equals(colonna)) {
			anagrafica.getIndirizzo_operativo().setStrada(ApplicationUtil.upperCaseEmpty(cellaTypeS(esegui, cella, null)));
		}
		if(ti.getPosizione(ConstantsMap.indirizzo_operativo_civico).equals(colonna)) {
			anagrafica.getIndirizzo_operativo().setCivico(ApplicationUtil.upperCaseEmpty(cellaTypeS(esegui, cella, null)));
		}
		if(ti.getPosizione(ConstantsMap.indirizzo_operativo_cap).equals(colonna)) {
			anagrafica.getIndirizzo_operativo().setCap(ApplicationUtil.upperCaseEmpty(cellaTypeS(esegui, cella, "00000")));
		}
		if(ti.getPosizione(ConstantsMap.indirizzo_operativo_comune).equals(colonna)) {
			anagrafica.getIndirizzo_operativo().setComune(ApplicationUtil.upperCaseEmpty(cellaTypeS(esegui, cella, null)));
		}
		if(ti.getPosizione(ConstantsMap.indirizzo_operativo_provincia).equals(colonna)) {
			anagrafica.getIndirizzo_operativo().setProvincia(ApplicationUtil.upperCaseEmpty(cellaTypeS(esegui, cella, null)));
		}
		if(ti.getPosizione(ConstantsMap.indirizzo_operativo_regione).equals(colonna)) {
			anagrafica.getIndirizzo_operativo().setRegione(ApplicationUtil.upperCaseEmpty(cellaTypeS(esegui, cella, null)));
		}
		if(ti.getPosizione(ConstantsMap.indirizzo_operativo_dettagli).equals(colonna)) {
			anagrafica.getIndirizzo_operativo().setDettagli(cellaTypeS(esegui, cella, null));
		} 
		if(ti.getPosizione(ConstantsMap.indirizzo_operativo_latitudine).equals(colonna)) {
			anagrafica.getIndirizzo_operativo().setLatitudine(cellaTypeS(esegui, cella, null));
		}
		if(ti.getPosizione(ConstantsMap.indirizzo_operativo_longitudine).equals(colonna)) {
			anagrafica.getIndirizzo_operativo().setLongitudine(cellaTypeS(esegui, cella, null));
		}
		if(ti.getPosizione(ConstantsMap.indirizzo_operativo_presso).equals(colonna)) {
			anagrafica.getIndirizzo_operativo().setPresso(cellaTypeS(esegui, cella, null));
		}
		if(ti.getPosizione(ConstantsMap.consenso_tfissoS).equals(colonna)) {
			anagrafica.setConsenso_tfisso(cellaTypeD(esegui, cella, ConstantsFormat.dateTime.stampa()));
		}
		if(ti.getPosizione(ConstantsMap.consenso_tmobileS).equals(colonna)) {
			anagrafica.setConsenso_tmobile(cellaTypeD(esegui, cella, ConstantsFormat.dateTime.stampa()));
		}
		if(ti.getPosizione(ConstantsMap.consenso_tfaxS).equals(colonna)) {
			anagrafica.setConsenso_tfax(cellaTypeD(esegui, cella, ConstantsFormat.dateTime.stampa()));
		}
		if(ti.getPosizione(ConstantsMap.consenso_taltroS).equals(colonna)) {
			anagrafica.setConsenso_taltro(cellaTypeD(esegui, cella, ConstantsFormat.dateTime.stampa()));
		}
		if(ti.getPosizione(ConstantsMap.consenso_emailS).equals(colonna)) {
			anagrafica.setConsenso_email(cellaTypeD(esegui, cella, ConstantsFormat.dateTime.stampa()));
		}
		if(ti.getPosizione(ConstantsMap.consenso_rmailS).equals(colonna)) {
			anagrafica.setConsenso_rmail(cellaTypeD(esegui, cella, ConstantsFormat.dateTime.stampa()));
		}
		if(ti.getPosizione(ConstantsMap.prefisso_fisso).equals(colonna)) {
			anagrafica.setPrefisso_fisso(cellaTypeS(esegui, cella, null));
		}
		if(ti.getPosizione(ConstantsMap.prefisso_altro).equals(colonna)) {
			anagrafica.setPrefisso_altro(cellaTypeS(esegui, cella, null));
		}
		if(ti.getPosizione(ConstantsMap.prefisso_mobile).equals(colonna)) {
			anagrafica.setPrefisso_mobile(cellaTypeS(esegui, cella, null));
		}
		if(ti.getPosizione(ConstantsMap.prefisso_fax).equals(colonna)) {
			anagrafica.setPrefisso_fax(cellaTypeS(esegui, cella, null));
		}
		if(ApplicationUtil.notEmpty(ti.getCampo_multiplo()) && ApplicationUtil.notEmpty(valoreCampi)) {
			Iterator<String> chiavi = valoreCampi.iterator();
			while (chiavi.hasNext()) {
				String chiave = (String) chiavi.next();
				if(ti.getPosizione(chiave).equals(colonna)) {
					CampoAggiuntivoAnagrafica ca = ApplicationUtil.getCampiByChiave(dati, chiave);
					if(ca != null) {
						DatoAggiuntivoAnagrafica da = new DatoAggiuntivoAnagrafica();
						da.setCampo_aggiuntivo(ca);
						if(ca.getData()) {
							da.setValore_data(cellaTypeD(esegui, cella, da.getCampo_aggiuntivo().getValoriT()));
						} else if(ca.getDataora()) {
							da.setValore_datatime(cellaTypeD(esegui, cella, da.getCampo_aggiuntivo().getValoriT()));
						} else if(ca.getOra()) {
							da.setValore_time(cellaTypeD(esegui, cella, ConstantsFormat.time.stampa()));
						} else if(ca.getNumero()) {
							da.setValore_numero(cellaTypeB(esegui, cella));
						} else if(ca.getSlider() || ca.getSpinner() || ca.getIntero()) {
							da.setValore_numero(cellaTypeI(esegui, cella));
						} else {
							da.setValore(cellaTypeS(esegui, cella, null));
						}
						anagrafica.addDato(chiave, da);
						ti.addCampo(chiave, ca);
					}
				}
			}
		}
		return anagrafica;
	}
	public static List<Opposizione> importaExcelOpposizione(Integer lt, boolean elimina, Campagna campagna, String file, TemplateImportOpposizione ti, List<String> db, ImportModelOpposizione importModel) throws Exception {
		List<Opposizione> anagrafiche = new ArrayList<Opposizione>();
		File  f = new File(file);
		if(f.exists()) {
			long i = 0;
			LoggerImport l = new LoggerImport(lt, ConstantsLanguage.IMPORT_FILE.stampa() + ": " + ApplicationUtil.getBaseNameN(file), ti.getDenominazione());
			boolean esegui = ti.getEsegui_filtro();
			List<String> duplicati = new ArrayList<String>(); 

			Workbook wb = ApplicationUtil.workbookG(ti.getRapido_filtro(), f);
			int sheetCnt = wb.getNumberOfSheets();
			for (int ii = 0; ii < sheetCnt; ii++) {
				Sheet sheet = wb.getSheetAt(ii);
				List<String> s = ti.getValore_multiplo();
				//int rows = sheet.getLastRowNum();
				int cols = s.size();
				int salta = ApplicationUtil.aggiustaRighe(ti.getSalta_righe());
				Iterator<Row> rows = sheet.rowIterator();
				int r = 0;
				while (rows.hasNext()) {
					Row row = rows.next();
					//Row row = sheet.getRow(r);
					if(row != null && r >= salta) {
						boolean importa = ApplicationUtil.importa(row, ti.getConsidera_filtro());
						if(importa){
							List<Opposizione> oppz = new ArrayList<Opposizione>();
							dataImport(esegui, oppz, row, ti, cols, s);
							for(Opposizione opposizione : oppz) {
								opposizione.setCampagna(campagna);
								String opp = ApplicationUtil.trimToNull(opposizione.getOpposizione());
								if(opp != null) {
									if(!elimina) {
										if(db.contains(opp)){
											opposizione.setTrovato(true);
											opposizione.setDuplicato(true);
											importModel.addEsclusa(opposizione, true);
										} else {
											opposizione.setTrovato(false);
											if(!duplicati.contains(opp)){
												duplicati.add(opp);
											} else {
												opposizione.setDuplicato(true);
												importModel.addEsclusa(opposizione, true);
											}
										}
									} else {
										if(db.contains(opp)){
											opposizione.setTrovato(true);
											if(!duplicati.contains(opp)){
												duplicati.add(opp);
											} else {
												opposizione.setDuplicato(true);
												importModel.addEsclusa(opposizione, true);
											}
										} else {
											opposizione.setTrovato(false);
											importModel.addEsclusa(opposizione, true);
										}
									}
									opposizione.setSeq(++i);
									anagrafiche.add(opposizione);
								}
							}
						}
					}
					r++;
				}
			}
			wb.close();
			l.log(anagrafiche);
		}
		return anagrafiche;
	}
	public static List<Contratto> importaExcelContratto(Integer lt, ImportModelContratto importModel, String file, TemplateImportContratto ti, List<Object> seriali, List<Object> cntrs) throws Exception {
		List<Contratto> contratti = new ArrayList<Contratto>();
		File  f = new File(file);
		if(f.exists()) {
			long i = 0;
			LoggerImport l = new LoggerImport(lt, ConstantsLanguage.IMPORT_FILE.stampa() + ": " + ApplicationUtil.getBaseNameN(file), ti.getDenominazione());
			boolean esegui = ti.getEsegui_filtro();
			if(seriali == null) {
				seriali = new ArrayList<Object>();
			}

			Workbook wb = ApplicationUtil.workbookG(ti.getRapido_filtro(), f);
			int sheetCnt = wb.getNumberOfSheets();
			for (int ii = 0; ii < sheetCnt; ii++) {
				Sheet sheet = wb.getSheetAt(ii);
				List<String> s = ti.getValore_multiplo();
				//int rows = sheet.getLastRowNum();
				int cols = s.size();
				int salta = ApplicationUtil.aggiustaRighe(ti.getSalta_righe());
				Iterator<Row> rows = sheet.rowIterator();
				int r = 0;
				while (rows.hasNext()) {
					Row row = rows.next();
					//Row row = sheet.getRow(r);
					if(row != null && r >= salta) {
						boolean importa = ApplicationUtil.importa(row, ti.getConsidera_filtro());
						if(importa){
							Contratto contratto = new Contratto();
							for(int colonna = 0; colonna < cols; colonna++) {
								Cell cella = row.getCell(colonna, MissingCellPolicy.CREATE_NULL_AS_BLANK);
								if(cella != null) {
									contratto = dataImport(esegui, contratto, colonna, cella, ti);
								}
							}
							String seriale = contratto.getChiave();
							if(ApplicationUtil.isNotBlank(seriale)) {
								Object ser = contratto.getChiaveL(ti.getTipo());
								if(ser != null && seriali.contains(ser)){
									contratto.setTrovato(true);
								} else {
									contratto.setTrovato(false);
								}
								if(!cntrs.contains(seriale)){
									cntrs.add(seriale);
								} else {
									contratto.setDuplicato(true);
								}
								if(ApplicationUtil.isTrue(contratto.getDuplicato()) || !contratto.getTrovato()) {
									importModel.addEsclusa(contratto, true);
								}
								contratto.setSeq(++i);
								contratti.add(contratto);
							}
						}
					}
					r++;
				}
			}
			wb.close();
			l.log(contratti);
		}
		return contratti;
	}
	private static void dataImport(boolean esegui, List<Opposizione> oppz,  Row row, TemplateImportOpposizione ti, int cols, List<String> s){
		Date data = ApplicationUtil.date();
		int index = ti.getPosizione(ConstantsMap.opposizione_descrizione);
		String descrizione = null;
		if(index > -1) {
			Cell cellaD = row.getCell(ti.getPosizione(ConstantsMap.opposizione_descrizione), MissingCellPolicy.CREATE_NULL_AS_BLANK);
			descrizione =  ApplicationUtil.trimToNull(cellaTypeS(esegui, cellaD, null));
		}
		for(int colonna = 0; colonna < cols; colonna++) {
			Cell cella = row.getCell(colonna, MissingCellPolicy.CREATE_NULL_AS_BLANK);
			if(cella != null) {
				for(int i = 0; i < cols; i++) {
					String a = s.get(i);
					if(i == colonna && a.equals(ConstantsMap.opposizione_segnalazione)) {
						String opps = cellaTypeS(esegui, cella, null);
						List<String> o = new ArrayList<String>();
						if(ApplicationUtil.isNotEmpty(ti.getQuote_segnalazione())) {
							o.addAll(ApplicationUtil.tokenU(opps, ti.getQuote_segnalazione()));
						} else {
							o.add(opps);
						}
						for(String opp : o) {
							Opposizione anagrafica = new Opposizione();
							anagrafica.setData_creazione(data);
							String opposizione = ApplicationUtil.uniforma(opp, ti.getRem_prefisso(), ti.getAdd_prefisso());
							anagrafica.setOpposizione(opposizione);
							anagrafica.setDescrizione(descrizione);
							oppz.add(anagrafica);
						}
					}
				}
			}
		}
	}
	private static Contratto dataImport(boolean esegui, Contratto contratto, int colonna, Cell cella, TemplateImportContratto ti){
		if(ti.getPosizione(ConstantsMap.chiave).equals(colonna)) {
			contratto.setChiave(ApplicationUtil.uniforma(cellaTypeS(esegui, cella, null), ti.getRem_prefisso(), ti.getAdd_prefisso()));
		}
		if(ti.getPosizione(ConstantsMap.contratto_nota).equals(colonna)) {
			contratto.setNota(cellaTypeS(esegui, cella, null));
		}
		if(ti.getPosizione(ConstantsMap.contratto_data_stipula).equals(colonna)) {
			contratto.setData_stipula(cellaTypeD(esegui, cella, ConstantsFormat.date.stampa()));
		}
		if(ti.getPosizione(ConstantsMap.contratto_data_contabile).equals(colonna)) {
			contratto.setData_contabile(cellaTypeD(esegui, cella, ConstantsFormat.date.stampa()));
		}
		if(ti.getPosizione(ConstantsMap.contratto_data_attivazione).equals(colonna)) {
			contratto.setData_attivazione(cellaTypeD(esegui, cella, ConstantsFormat.date.stampa()));
		}
		if(ti.getPosizione(ConstantsMap.contratto_data_caricamento).equals(colonna)) {
			contratto.setData_caricamento(cellaTypeD(esegui, cella, ConstantsFormat.date.stampa()));
		}
		if(ti.getPosizione(ConstantsMap.contratto_costo_scontato).equals(colonna)) {
			contratto.setCosto_scontato(cellaTypeB(esegui, cella));
		}
		if(ti.getPosizione(ConstantsMap.contratto_quantita).equals(colonna)) {
			contratto.setQuantita(cellaTypeI(esegui, cella));
		}
		return contratto;
	}
	public static List<Appuntamento> importaExcelAppuntamento(Integer lt, ImportModelAppuntamento importModel, String file, TemplateImportAppuntamento ti, List<Object> seriali, List<Object> cntrs) throws Exception {
		List<Appuntamento> appuntamenti = new ArrayList<Appuntamento>();
		File  f = new File(file);
		if(f.exists()) {
			long i = 0;
			LoggerImport l = new LoggerImport(lt, ConstantsLanguage.IMPORT_FILE.stampa() + ": " + ApplicationUtil.getBaseNameN(file), ti.getDenominazione());
			boolean esegui = ti.getEsegui_filtro();
			if(seriali == null) {
				seriali = new ArrayList<Object>();
			}

			Workbook wb = ApplicationUtil.workbookG(ti.getRapido_filtro(), f);
			int sheetCnt = wb.getNumberOfSheets();
			for (int ii = 0; ii < sheetCnt; ii++) {
				Sheet sheet = wb.getSheetAt(ii);
				List<String> s = ti.getValore_multiplo();
				//int rows = sheet.getLastRowNum();
				int cols = s.size();
				int salta = ApplicationUtil.aggiustaRighe(ti.getSalta_righe());
				Iterator<Row> rows = sheet.rowIterator();
				int r = 0;
				while (rows.hasNext()) {
					Row row = rows.next();
					//Row row = sheet.getRow(r);
					if(row != null && r >= salta) {
						boolean importa = ApplicationUtil.importa(row, ti.getConsidera_filtro());
						if(importa){
							Appuntamento appuntamento = new Appuntamento();
							for(int colonna = 0; colonna < cols; colonna++) {
								Cell cella = row.getCell(colonna, MissingCellPolicy.CREATE_NULL_AS_BLANK);
								if(cella != null) {
									appuntamento = dataImport(esegui, appuntamento, colonna, cella, ti);
								}
							}
							String seriale = appuntamento.getChiave();
							if(ApplicationUtil.isNotBlank(seriale)) {
								Object ser = appuntamento.getChiaveL(ti.getTipo());
								if(ser != null && seriali.contains(ser)){
									appuntamento.setTrovato(true);
								} else {
									appuntamento.setTrovato(false);
								}
								if(!cntrs.contains(seriale)){
									cntrs.add(seriale);
								} else {
									appuntamento.setDuplicato(true);
								}
								if(ApplicationUtil.isTrue(appuntamento.getDuplicato()) || !appuntamento.getTrovato()) {
									importModel.addEsclusa(appuntamento, true);
								}
								appuntamento.setSeq(++i);
								appuntamenti.add(appuntamento);
							}
						}
					}
					r++;
				}
			}
			wb.close();	
			l.log(appuntamenti);
		}
		return appuntamenti;
	}
	private static Appuntamento dataImport(boolean esegui, Appuntamento appuntamento, int colonna, Cell cella, TemplateImportAppuntamento ti){
		if(ti.getPosizione(ConstantsMap.chiave).equals(colonna)) {
			appuntamento.setChiave(ApplicationUtil.uniforma(cellaTypeS(esegui, cella, null), ti.getRem_prefisso(), ti.getAdd_prefisso()));
		}
		if(ti.getPosizione(ConstantsMap.appuntamento_nota).equals(colonna)) {
			appuntamento.setNote(cellaTypeS(esegui, cella, null));
		}
		if(ti.getPosizione(ConstantsMap.appuntamento_data_appuntamento).equals(colonna)) {
			appuntamento.setData_appuntamento(cellaTypeD(esegui, cella, ConstantsFormat.dateTime.stampa()));
		}
		return appuntamento;
	}
	public static List<Contatto> importaExcelContatto(Integer lt, ImportModelContatto importModel, String file, TemplateImportContatto ti, List<Object> seriali, List<Object> cntrs) throws Exception {
		List<Contatto> contatti = new ArrayList<Contatto>();
		File  f = new File(file);
		if(f.exists()) {
			long i = 0;
			LoggerImport l = new LoggerImport(lt, ConstantsLanguage.IMPORT_FILE.stampa() + ": " + ApplicationUtil.getBaseNameN(file), ti.getDenominazione());
			boolean esegui = ti.getEsegui_filtro();
			if(seriali == null) {
				seriali = new ArrayList<Object>();
			}

			Workbook wb = ApplicationUtil.workbookG(ti.getRapido_filtro(), f);
			int sheetCnt = wb.getNumberOfSheets();
			for (int ii = 0; ii < sheetCnt; ii++) {
				Sheet sheet = wb.getSheetAt(ii);
				List<String> s = ti.getValore_multiplo();
				//int rows = sheet.getLastRowNum();
				int cols = s.size();
				int salta = ApplicationUtil.aggiustaRighe(ti.getSalta_righe());
				Iterator<Row> rows = sheet.rowIterator();
				int r = 0;
				while (rows.hasNext()) {
					Row row = rows.next();
					//Row row = sheet.getRow(r);
					if(row != null && r >= salta) {
						boolean importa = ApplicationUtil.importa(row, ti.getConsidera_filtro());
						if(importa){
							Contatto contatto = new Contatto();
							for(int colonna = 0; colonna < cols; colonna++) {
								Cell cella = row.getCell(colonna, MissingCellPolicy.CREATE_NULL_AS_BLANK);
								if(cella != null) {
									contatto = dataImport(esegui, contatto, colonna, cella, ti);
								}
							}
							String seriale = contatto.getChiave();
							if(ApplicationUtil.isNotBlank(seriale)) {
								Object ser = contatto.getChiaveL(ti.getTipo());
								if(ser != null && seriali.contains(ser)){
									contatto.setTrovato(true);
								} else {
									contatto.setTrovato(false);
								}
								if(!cntrs.contains(seriale)){
									cntrs.add(seriale);
								} else {
									contatto.setDuplicato(true);
								}
								if(ApplicationUtil.isTrue(contatto.getDuplicato()) || !contatto.getTrovato()) {
									importModel.addEsclusa(contatto, true);
								}
								contatto.setSeq(++i);
								contatti.add(contatto);
							}
						}
					}
					r++;
				}
			}
			wb.close();
			l.log(contatti);
		}
		return contatti;
	}
	private static Contatto dataImport(boolean esegui, Contatto contatto, int colonna, Cell cella, TemplateImportContatto ti){
		if(ti.getPosizione(ConstantsMap.chiave).equals(colonna)) {
			contatto.setChiave(ApplicationUtil.uniforma(cellaTypeS(esegui, cella, null), ti.getRem_prefisso(), ti.getAdd_prefisso()));
		}
		if(ti.getPosizione(ConstantsMap.contatto_nota).equals(colonna)) {
			contatto.setNota(cellaTypeS(esegui, cella, null));
		}
		Anagrafica anagrafica = new Anagrafica();
		if(ti.getPosizione(ConstantsMap.consenso_tfissoS).equals(colonna)) {
			anagrafica.setConsenso_tfisso(cellaTypeD(esegui, cella, ConstantsFormat.dateTime.stampa()));
		}
		if(ti.getPosizione(ConstantsMap.consenso_tmobileS).equals(colonna)) {
			anagrafica.setConsenso_tmobile(cellaTypeD(esegui, cella, ConstantsFormat.dateTime.stampa()));
		}
		if(ti.getPosizione(ConstantsMap.consenso_tfaxS).equals(colonna)) {
			anagrafica.setConsenso_tfax(cellaTypeD(esegui, cella, ConstantsFormat.dateTime.stampa()));
		}
		if(ti.getPosizione(ConstantsMap.consenso_taltroS).equals(colonna)) {
			anagrafica.setConsenso_taltro(cellaTypeD(esegui, cella, ConstantsFormat.dateTime.stampa()));
		}
		if(ti.getPosizione(ConstantsMap.consenso_emailS).equals(colonna)) {
			anagrafica.setConsenso_email(cellaTypeD(esegui, cella, ConstantsFormat.dateTime.stampa()));
		}
		if(ti.getPosizione(ConstantsMap.consenso_rmailS).equals(colonna)) {
			anagrafica.setConsenso_rmail(cellaTypeD(esegui, cella, ConstantsFormat.dateTime.stampa()));
		}
		contatto.setAnagrafica(anagrafica);
		return contatto;
	}
	private static String cellaTypeS(boolean esegui, Cell cella, String d){
		String str = "";
		if(cella != null) {
			switch (cella.getCellType()) {
			case BOOLEAN:
				Boolean b1 = cella.getBooleanCellValue();
				if(b1 != null) {
					str = b1.toString();
				}
				break;
			case NUMERIC:
				if(DateUtil.isCellDateFormatted(cella)) {
					str = ApplicationUtil.trimToEmpty(ApplicationUtil.formatDate((d!= null) ? d : ConstantsFormat.stringDate.stampa(), cella.getDateCellValue()));
				} else {
					DecimalFormat df1 = ApplicationUtil.getDecimalFormat((d!= null) ? d :  ConstantsFormat.stringNumber.stampa());
					str = ApplicationUtil.trimToEmpty(df1.format(cella.getNumericCellValue()));
				}
				break;
			case STRING:
				str = ApplicationUtil.standartize(esegui, cella.getStringCellValue());
				break;
			case FORMULA:
				switch (cella.getCachedFormulaResultType()) {
				case BOOLEAN: 
					String b2 = ApplicationUtil.clearCell(cella.getStringCellValue());
					if(ApplicationUtil.isNotBlank(b2)) {
						str = (b2.equals("0") ? false : true) + "";
					}
					break;
				case NUMERIC:
					if(DateUtil.isCellDateFormatted(cella)) {
						str = ApplicationUtil.trimToEmpty(ApplicationUtil.formatDate((d!= null) ? d : ConstantsFormat.stringDate.stampa(), cella.getDateCellValue()));
					} else {
						DecimalFormat df2 = ApplicationUtil.getDecimalFormat((d!= null) ? d :  ConstantsFormat.stringNumber.stampa());
						str = ApplicationUtil.trimToEmpty(df2.format(cella.getNumericCellValue()));
					}
					break;
				case STRING: case FORMULA:
					str = ApplicationUtil.standartize(esegui, cella.getStringCellValue());
					break;
				default:
					break;
				}
				break;
			default:
				break;
			}
		}
		return str;
	}
	private static Boolean cellaTypeV(boolean esegui, Cell cella, List<String> v, List<String> f){
		boolean bb = false;
		if(cella != null) {
			switch (cella.getCellType()) {
			case BOOLEAN:
				Boolean b1 = cella.getBooleanCellValue();
				if(b1 != null) {
					bb = b1;
				}
				break;
			case NUMERIC:
				if(DateUtil.isCellDateFormatted(cella)) {
					Date dd1 = cella.getDateCellValue();
					if(dd1 != null) {
						if(ApplicationUtil.eq(dd1.getTime(), 0)) {
							bb = false;
						} else {
							bb = true;
						}
					}
				} else {
					Double dd1 = cella.getNumericCellValue();
					if(dd1 != null) {
						if(ApplicationUtil.eq(dd1.longValue(), 0)) {
							bb = false;
						} else {
							bb = true;
						}
					}
				}
				break;
			case STRING:
				String testo1 = ApplicationUtil.lowerCaseEmpty(ApplicationUtil.standartize(esegui, cella.getStringCellValue()));
				if(ApplicationUtil.vero(testo1) || (v !=null && v.contains(testo1)))
					bb = true;
				if(ApplicationUtil.falso(testo1) || (f !=null && f.contains(testo1)))
					bb = false;
				break;
			case FORMULA:
				switch (cella.getCachedFormulaResultType()) {
				case BOOLEAN: 
					String b2 = ApplicationUtil.clearCell(cella.getStringCellValue());
					if(ApplicationUtil.isNotBlank(b2)) {
						bb = (b2.equals("0") ? false : true);
					}
					break;
				case NUMERIC:
					if(DateUtil.isCellDateFormatted(cella)) {
						Date dd2 = cella.getDateCellValue();
						if(dd2 != null) {
							if(ApplicationUtil.eq(dd2.getTime(), 0)) {
								bb = false;
							} else {
								bb = true;
							}
						}
					} else {
						Double dd2 = cella.getNumericCellValue();
						if(dd2 != null) {
							if(ApplicationUtil.eq(dd2.longValue(), 0)) {
								bb = false;
							} else {
								bb = true;
							}
						}
					}
					break;
				case STRING: case FORMULA: 
					String testo2 = ApplicationUtil.lowerCaseEmpty(ApplicationUtil.standartize(esegui, cella.getStringCellValue()));
					if(ApplicationUtil.vero(testo2) || (v !=null && v.contains(testo2)))
						bb = true;
					if(ApplicationUtil.falso(testo2) || (f !=null && f.contains(testo2)))
						bb = false;
					break;
				default:
					break;
				}
				break;
			default:
				break;
			}
		}
		return bb;
	}
	private static Integer cellaTypeI(boolean esegui, Cell cella){
		Integer date = null;
		if(cella != null) {
			switch (cella.getCellType()) {
			case BOOLEAN:
				Boolean b1 = cella.getBooleanCellValue();
				if(b1 != null) {
					date = b1 ? 1 : 0;
				}
				break;
			case NUMERIC:
				if(DateUtil.isCellDateFormatted(cella)) {
					Date dd1 = cella.getDateCellValue();
					if(dd1 !=null) {
						date = (int) dd1.getTime();
					}
				} else {
					Double dd1 = cella.getNumericCellValue();
					if(dd1 !=null) {
						date = dd1.intValue();
					}
				}
				break;
			case STRING:
				date = ApplicationUtil.parseInteger(ApplicationUtil.standartize(esegui, cella.getStringCellValue()));
				break;
			case FORMULA:
				switch (cella.getCachedFormulaResultType()) {
				case BOOLEAN: 
					String b2 = ApplicationUtil.clearCell(cella.getStringCellValue());
					if(ApplicationUtil.isNotBlank(b2)) {
						date = ApplicationUtil.parseInteger(b2);
					}
					break;
				case NUMERIC:
					if(DateUtil.isCellDateFormatted(cella)) {
						Date dd2 = cella.getDateCellValue();
						if(dd2 !=null) {
							date = (int) dd2.getTime();
						}
					} else {
						Double dd2 = cella.getNumericCellValue();
						if(dd2 !=null) {
							date = dd2.intValue();
						}
					}
					break;
				case STRING: case FORMULA:
					date = ApplicationUtil.parseInteger(ApplicationUtil.standartize(esegui, cella.getStringCellValue()));
					break;
				default:
					break;
				}
				break;
			default:
				break;
			}
		}
		return date;
	}
	private static BigDecimal cellaTypeB(boolean esegui, Cell cella){
		BigDecimal date = null;
		if(cella != null) {
			switch (cella.getCellType()) {
			case BOOLEAN:
				Boolean b1 = cella.getBooleanCellValue();
				if(b1 != null) {
					date = new BigDecimal(b1 ? 1 : 0);
				}
				break;
			case NUMERIC:
				if(DateUtil.isCellDateFormatted(cella)) {
					Date dd1 = cella.getDateCellValue();
					if(dd1 !=null) {
						date = new BigDecimal(dd1.getTime());
					}
				} else {
					Double dd1 = cella.getNumericCellValue();
					if(dd1 !=null) {
						date = new BigDecimal(dd1.doubleValue());
					}
				}
				break;
			case STRING:
				date = ApplicationUtil.parseBigDecimal(ApplicationUtil.standartize(esegui, cella.getStringCellValue()));
				break;
			case FORMULA:
				switch (cella.getCachedFormulaResultType()) {
				case BOOLEAN: 
					String b2 = ApplicationUtil.clearCell(cella.getStringCellValue());
					if(ApplicationUtil.isNotBlank(b2)) {
						date = ApplicationUtil.parseBigDecimal(b2);
					}
					break;
				case NUMERIC:
					if(DateUtil.isCellDateFormatted(cella)) {
						Date dd2 = cella.getDateCellValue();
						if(dd2 !=null) {
							date = new BigDecimal(dd2.getTime());
						}
					} else {
						Double dd2 = cella.getNumericCellValue();
						if(dd2 !=null) {
							date = new BigDecimal(dd2.doubleValue());
						}
					}
					break;
				case STRING: case FORMULA: 
					date = ApplicationUtil.parseBigDecimal(ApplicationUtil.standartize(esegui, cella.getStringCellValue()));
					break;
				default:
					break;
				}
				break;
			default:
				break;
			}
		}
		return date;
	}
	private static Date cellaTypeD(boolean esegui, Cell cella, String parse){
		Date date = null;
		if(cella != null) {
			switch (cella.getCellType()) {
			case BOOLEAN:
				//cella.getBooleanCellValue();
				break;
			case NUMERIC:
				if(DateUtil.isCellDateFormatted(cella)) {
					date = cella.getDateCellValue();
				} else {
					Double dd1 = cella.getNumericCellValue();
					if(dd1 !=null) {
						date = DateUtil.getJavaDate(dd1.doubleValue(), false);
					}
				}
				if(date != null) {
					Date df = DateUtils.addYears(ApplicationUtil.date(), 3);
					if (date.after(df)) {
						date = null;
					}
				}
				
				break;
			case STRING:
				date = ApplicationUtil.parseData(parse, ApplicationUtil.standartize(esegui, cella.getStringCellValue()));
				break;
			case FORMULA:
				switch (cella.getCachedFormulaResultType()) {
				case BOOLEAN: 
					String c2 = ApplicationUtil.clearCell(cella.getStringCellValue());
					if(ApplicationUtil.isNotBlank(c2)) {
						date = ApplicationUtil.parseData(parse, c2);
					}
					break;
				case NUMERIC:
					if(DateUtil.isCellDateFormatted(cella)) {
						date = cella.getDateCellValue();
					} else {
						Double dd2 = cella.getNumericCellValue();
						if(dd2 !=null) {
							date = DateUtil.getJavaDate(dd2.doubleValue(), false);
						}
					}
					break;
				case STRING: case FORMULA:
					date = ApplicationUtil.parseData(parse, ApplicationUtil.standartize(esegui, cella.getStringCellValue()));
					break;
				default:
					break;
				}
				break;
			default:
				break;
			}
		}
		if(!ApplicationUtil.validateData(date)) {
			date = null;
		}
		return date;
	}
	public static List<String> importaExcelConsentiti(ImportModelConsentite ti, Workbook wbIn, Boolean filtro, Boolean esegui) throws Exception {
		List<String> dati = new ArrayList<String>();
		int sheetCnt = wbIn.getNumberOfSheets();
		for (int i = 0; i < sheetCnt; i++) {
			Sheet sIn = wbIn.getSheetAt(i);
			Iterator<Row> rowIt = sIn.rowIterator();
			while (rowIt.hasNext()) {
				Row rowIn = rowIt.next();
				boolean importa = ApplicationUtil.importa(rowIn, filtro);
				if(importa) {
					Iterator<Cell> cellIt = rowIn.cellIterator();
					while (cellIt.hasNext()) {
						Cell cellIn = cellIt.next();
						String data = ApplicationUtil.clearOpposizione(ApplicationUtil.trimToNull(cellaTypeS(esegui, cellIn, null)));
						if(ApplicationUtil.isNotBlank(data)) {
							if(!dati.contains(data)) {
								Pattern pfis = Pattern.compile(ti.getValidatore_fisso());
								Pattern pmob = Pattern.compile(ti.getValidatore_mobile());
								Pattern pfax = Pattern.compile(ti.getValidatore_fax());
								Pattern palt = Pattern.compile(ti.getValidatore_altro());
								Pattern pema = Pattern.compile(ti.getValidatore_email());
								Pattern ppln = Pattern.compile(ti.getValidatore_link());
								Pattern pcod = Pattern.compile(ti.getValidatore_codice());
								Pattern ppiv = Pattern.compile(ti.getValidatore_partita());
								if (pfis.matcher(data).matches() || pmob.matcher(data).matches() || pfax.matcher(data).matches() || palt.matcher(data).matches() || pema.matcher(data).matches()|| ppln.matcher(data).matches()|| pcod.matcher(data).matches()|| ppiv.matcher(data).matches()) {
									dati.add(data);
								}
							}
						}
					}
				}
			}
		}
		wbIn.close();
		return dati;
	}
}