package it.callite.utility;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

import org.richfaces.event.UploadEvent;

import it.callite.constants.ConstantsGlobal;
@SuppressWarnings("serial")
public class FileUpload implements Serializable {

	private List<MyFile> files = new ArrayList<MyFile>();
	private String message;
	
	private Integer log;
	
	

	public void initiliaze(Integer log) {
		this.log = log;
	}

	public String getMessage() {
		return message;
	}

	public void setMessage(String message) {
		this.message = message;
	}

	public FileUpload(List<MyFile> files) {
		this.files = files;
	}

	public FileUpload() {
	}

	public int getSize() {
		return ApplicationUtil.size(files);
	}
	
	public void clearUploadData() {
		files.clear();
	}
	
	public List<MyFile> getFiles() {
		return files;
	}

	public void single(UploadEvent event) {
		MyFile file = ApplicationUtil.myFile(event.getUploadItem(), ConstantsGlobal.SIZE);
		files.clear();
		if(file != null && !files.contains(file)) {
			ApplicationUtil.upload(log, file, null);
			files.add(file);
		}
		message = ApplicationUtil.sizeError(event.getUploadItem(), ConstantsGlobal.SIZE);
	}
	
	public void listener(UploadEvent event) {
		MyFile file = ApplicationUtil.myFile(event.getUploadItem(), 0);
		if(file != null && !files.contains(file)) {
			ApplicationUtil.upload(log, file, null);
			files.add(file);
		}
	}

	public void setFiles(List<MyFile> files) {
		this.files = files;
	}

}