package it.callite.utility;

import java.util.List;

import org.hibernate.Session;
import org.hibernate.criterion.DetachedCriteria;
import org.springframework.orm.hibernate5.HibernateTemplate;
import org.springframework.transaction.annotation.Transactional;

import it.callite.constants.ConstantsGlobal;

public class HibernateSupport {

	private HibernateTemplate hibernateTemplate;


	public HibernateTemplate getHibernateTemplate() {
		return hibernateTemplate;
	}
	public Session openSession(){
		return getHibernateTemplate().getSessionFactory().openSession();
	}

	public Session currentSession(){
		return getHibernateTemplate().getSessionFactory().getCurrentSession();
	}


	@Transactional(readOnly=true) @SuppressWarnings("rawtypes")
	public List findByCriteria(DetachedCriteria criteria) {
		return  getHibernateTemplate().findByCriteria(criteria);
	}


	@Transactional(readOnly=true) @SuppressWarnings("rawtypes")
	public List findByCriteria(DetachedCriteria criteria, int start, int size) {
		return getHibernateTemplate().findByCriteria(criteria, start, size);
	}


	@Transactional(readOnly=false) 
	public Object saveOrUpdate(Object oggetto) {
		getHibernateTemplate().saveOrUpdate(oggetto);
		if(ConstantsGlobal.flush) {
			getHibernateTemplate().flush();
		}
		return oggetto;
	}
	@Transactional(readOnly=false) 
	public void delete(Object oggetto) {
		getHibernateTemplate().delete(oggetto);
		if(ConstantsGlobal.flush) {
			getHibernateTemplate().flush();
		}
	}


	public void setHibernateTemplate(HibernateTemplate hibernateTemplate) {
		this.hibernateTemplate = hibernateTemplate;
	}    
}
