package it.callite.utility;

import java.io.Serializable;

public class IVRUtil implements Serializable, Comparable<IVRUtil> {
	
	private static final long serialVersionUID = 1L;

	private String tasto;
	private String app;
	private String numero;
	private String musica;
	

	public IVRUtil(String tasto) {
		this.tasto = tasto;
	}


	public String getTasto() {
		return tasto;
	}


	public void setTasto(String tasto) {
		this.tasto = tasto;
	}


	public String getApp() {
		return ApplicationUtil.trimToNull(app);
	}


	public void setApp(String app) {
		this.app = ApplicationUtil.trimToNull(app);
	}


	public String getNumero() {
		return ApplicationUtil.trimToNull(numero);
	}


	public void setNumero(String numero) {
		this.numero = ApplicationUtil.trimToNull(numero);
	}


	public String getMusica() {
		return ApplicationUtil.trimToNull(musica);
	}


	public void setMusica(String musica) {
		this.musica = ApplicationUtil.trimToNull(musica);
	}

	@Override
	public int compareTo(IVRUtil o) {
		if(tasto != null && o.tasto != null) {
			return tasto.compareTo(o.tasto);
		} else if(tasto != null && o.tasto == null) {
			return -1;
		} else if(tasto == null && o.tasto != null) {
			return 1;
		} else {
			return 0;
		}
	}


	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((tasto == null) ? 0 : tasto.hashCode());
		return result;
	}


	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		IVRUtil other = (IVRUtil) obj;
		if (tasto == null) {
			if (other.tasto != null)
				return false;
		} else if (!tasto.equals(other.tasto))
			return false;
		return true;
	}
	
	
	

}