package it.callite.utility;
import java.io.Serializable;
import it.callite.constants.ConstantsLanguage;
@SuppressWarnings("serial")
public class InfoSpia implements Serializable, Comparable<InfoSpia> {
	private String interno;
	private String operatore;
	private String uniqueId;
	private String tipo;
	private String intervento;
	
	public int compareTo(InfoSpia o) {
		if(uniqueId != null && o.uniqueId != null) {
			return uniqueId.compareTo(o.uniqueId);
		} else if(uniqueId != null && o.uniqueId == null) {
			return -1;
		} else if(uniqueId == null && o.uniqueId != null) {
			return 1;
		} else {
			return 0;
		}
	}
	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		InfoSpia other = (InfoSpia) obj;
		if (uniqueId == null) {
			if (other.uniqueId != null)
				return false;
		} else if (!uniqueId.equals(other.uniqueId))
			return false;
		return true;
	}
	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result
				+ ((uniqueId == null) ? 0 : uniqueId.hashCode());
		return result;
	}
	public InfoSpia(String uniqueId, String interno, String operatore, String estensione) {
		this.interno = interno;
		this.operatore = operatore;
		this.uniqueId = uniqueId;
		this.tipo = ApplicationUtil.trimToNull(ApplicationUtil.substring(estensione, 1, 3));
		this.intervento = ApplicationUtil.trimToEmpty(ApplicationUtil.substring(estensione, 3));
	}
	
	@Override
	public String toString() {
		return operatore;
	}
	public String getInterno() {
		return interno;
	}
	public void setInterno(String interno) {
		this.interno = interno;
	}
	public String getOperatore() {
		return operatore;
	}
	public void setOperatore(String operatore) {
		this.operatore = operatore;
	}
	public String getUniqueId() {
		return uniqueId;
	}
	public void setUniqueId(String uniqueId) {
		this.uniqueId = uniqueId;
	}
	public String getTipo() {
		return tipo;
	}
	public void setTipo(String tipo) {
		this.tipo = tipo;
	}
	public String getIntervento() {
		return intervento;
	}
	public void setIntervento(String intervento) {
		this.intervento = intervento;
	}
	public String getSpiatoS() {
		String msg = "";
		if(tipo != null) {
			if(tipo.equals("60")) {
				msg = ConstantsLanguage.ASCOLTO_INTERVENTO.stampa();
			}
			if(tipo.equals("61")) {
				msg = ConstantsLanguage.ASCOLTO_SILENZIOSO.stampa();
			}
			if(tipo.equals("62")) {
				msg = ConstantsLanguage.ASCOLTO_ATTIVO.stampa();
			}
		}
		return msg;
	}
}