package it.callite.utility;
import it.callite.model.Utente;
import java.io.Serializable;
@SuppressWarnings("serial")
public class InfoUtente implements Serializable, Comparable<InfoUtente> {
 
	@Override
	public String toString() {
		if(operatore.getInterno()!=null)
			return operatore.getInterno().getName() + "(" + ready + ")";
		else
			return null;
	}
	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result
				+ ((operatore == null) ? 0 : operatore.hashCode());
		return result;
	}
	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		InfoUtente other = (InfoUtente) obj;
		if (operatore == null) {
			if (other.operatore != null)
				return false;
		} else if (!operatore.equals(other.operatore))
			return false;
		return true;
	}
	private Long tempoApertura;
	private Utente operatore;
	private boolean ready;
	private boolean disco;
	
	public InfoUtente(Utente operatore) {
		this.tempoApertura = Long.valueOf(0);
		this.operatore = operatore;
		this.ready = false;
		this.disco = false;
	}
	public InfoUtente(Utente operatore, long tempoApertura, boolean disco) {
		this.tempoApertura = tempoApertura;
		this.operatore = operatore;
		this.ready = false;
		this.disco = disco;
	}
	public boolean isReady() {
		return ready;
	}
	public void setReady(boolean ready) {
		this.ready = ready;
	}
	public Long getTempoApertura() {
		return tempoApertura;
	}
	public void setTempoApertura(Long tempoApertura) {
		this.tempoApertura = tempoApertura;
	}
	public Utente getOperatore() {
		return operatore;
	}
	public void setOperatore(Utente operatore) {
		this.operatore = operatore;
	}
	public boolean equalsInterno(String interno) {
		return this.getOperatore().getInternoString().equals(interno);
	}
	public int compareTo(InfoUtente o) {
		if(operatore != null && o.operatore != null) {
			return operatore.compareTo(o.operatore);
		} else if(operatore != null && o.operatore == null) {
			return -1;
		} else if(operatore == null && o.operatore != null) {
			return 1;
		} else {
			return 0;
		}
	}
	public boolean isDisco() {
		return disco;
	}
	public void setDisco(boolean disco) {
		this.disco = disco;
	}
	
}