package it.callite.utility;

import java.io.Serializable;
import java.util.Date;
public class IntervalloData implements Serializable {
	
	private static final long serialVersionUID = 1L;

	private Date fine;
	private Date inizio;
	private String periodo = "";
	
	public Date getFine() {
		return ApplicationUtil.aggiustaDataT(fine, false);
	}
	public Date getInizio() {
		return ApplicationUtil.aggiustaDataT(inizio, true);
	}

	public String getPeriodo() {
		return periodo;
	}
	
	public void reset() {
		inizio = null;
		fine = null;
	}

	public void setFine(Date fine) {
		this.fine = ApplicationUtil.aggiustaDataT(fine, false);
	}

	public void setInizio(Date inizio) {
		this.inizio = ApplicationUtil.aggiustaDataT(inizio, true);
	}

	public void setPeriodo(String periodo) {
		this.periodo = periodo;
	}
	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((fine == null) ? 0 : fine.hashCode());
		result = prime * result + ((inizio == null) ? 0 : inizio.hashCode());
		result = prime * result + ((periodo == null) ? 0 : periodo.hashCode());
		return result;
	}
	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		IntervalloData other = (IntervalloData) obj;
		if (fine == null) {
			if (other.fine != null)
				return false;
		} else if (!fine.equals(other.fine))
			return false;
		if (inizio == null) {
			if (other.inizio != null)
				return false;
		} else if (!inizio.equals(other.inizio))
			return false;
		if (periodo == null) {
			if (other.periodo != null)
				return false;
		} else if (!periodo.equals(other.periodo))
			return false;
		return true;
	}

	@Override
	public String toString() {
		return ApplicationUtil.toString(this);
	}
}