package it.callite.utility;
import java.io.Serializable;
import java.sql.Time;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import it.callite.constants.ConstantsGlobal;
import it.callite.constants.ConstantsLanguage;
public class IntervalloInbound implements Serializable, Comparable<IntervalloInbound> {

	private static final long serialVersionUID = 1L;
	
	public Boolean getStatoAttiva() {
		return ApplicationUtil.calcolaIntervallo(getInverti(), getData_inizio(), getData_fine(), getWeek_inizio(), getWeek_fine(), getTime_inizio(), getTime_fine());
	}
	
	public String getStatoAttivaT() {
		return getStatoAttiva() ? ConstantsLanguage.SI.stampa() : ConstantsLanguage.NO.stampa();
	}
	private Long week_fine;
	private Long week_inizio;
	
	private Integer ordine = 1;
	
	private String musica_iniziale;
	private String musica_finale;
	private Integer ripetizioni = 0;
	private String musica_ripetuta;
	
	private String app;
	private String numero;
	private String pre_caller;
	private String post_caller;
	private String callers;
	
	
	public String getValide() {
		List<String> scelte = new ArrayList<String>();
		for(IVRUtil i : ivr) {
			String t = i.getTasto();
			if(i.getApp() != null && !t.equals("i")) {
				scelte.add(t);
			}
		}
		return ApplicationUtil.detoken(scelte, "");
	}
	
	public IVRUtil getIVR(String exit) {
		int index = ivr.indexOf(new IVRUtil(exit));
		if(index > -1) {
			return ivr.get(index);
		}
		return null;
	}
	
	private List<IVRUtil> ivr = new ArrayList<IVRUtil>();

	public IntervalloInbound() {
		for (int i = 0; i < 10; i++) {
			ivr.add(new IVRUtil(i + ""));
		}
		ivr.add(new IVRUtil("i"));
 	}

	public Long getWeek_fine() {
		return week_fine;
	}
	public void setWeek_fine(Long week_fine) {
		this.week_fine = week_fine;
	}
	public Long getWeek_inizio() {
		return week_inizio;
	}
	public void setWeek_inizio(Long week_inizio) {
		this.week_inizio = week_inizio;
	}

	private Boolean attivo = Boolean.TRUE;
	
	
	public Boolean getAttivo() {
		return attivo;
	}
	public void setAttivo(Boolean attivo) {
		this.attivo = attivo;
	}
	private Date data = ApplicationUtil.date();
	private Date data_inizio;
	private Date data_fine;
	
	public Date getData() {
		return data;
	}
	public void setData(Date data) {
		this.data = data;
	}
	public Date getData_inizio() {
		return ApplicationUtil.aggiustaDataT(data_inizio, true);
	}
	public void setData_inizio(Date data_inizio) {
		this.data_inizio = ApplicationUtil.aggiustaDataT(data_inizio, true);
	}
	private Time ora_inizio;
	private Time ora_fine;
	public Time getTime_inizio() {
		return  ora_inizio;
	}
	public Time getTime_fine() {
		return  ora_fine;
	}
	public Date getOra_inizio() {
		return  ApplicationUtil.timeToDate(ora_inizio);
	}
	public void setOra_inizio(Date ora_inizio) {
		this.ora_inizio = ApplicationUtil.dateToTime(ora_inizio);
	}
	public Date getOra_fine() {
		return ApplicationUtil.timeToDate(ora_fine);
	}
	private Boolean inverti = false;
	public Boolean getInverti() {
		if(inverti == null) {
			inverti = false;
		}
		return inverti;
	}
	public void setInverti(Boolean inverti) {
		this.inverti = inverti;
	}
	public void setOra_fine(Date ora_fine) {
		this.ora_fine = ApplicationUtil.dateToTime(ora_fine);
	}
	public Date getData_fine() {
		return ApplicationUtil.aggiustaDataT(data_fine, false);
	}
	public void setData_fine(Date data_fine) {
		this.data_fine = ApplicationUtil.aggiustaDataT(data_fine, false);
	}
	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((data == null) ? 0 : data.hashCode());
		return result;
	}
	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		IntervalloInbound other = (IntervalloInbound) obj;
		if (data == null) {
			if (other.data != null)
				return false;
		} else if (!data.equals(other.data))
			return false;
		return true;
	}
	
	public String getNumero() {
		return ApplicationUtil.trimToNull(numero);
	}
	public void setNumero(String numero) {
		this.numero = ApplicationUtil.trimToEmpty(numero);
	}

	public void setCallers(String callers) {
		this.callers = ApplicationUtil.aggiustaLista(false, ConstantsGlobal.colonSeparator, callers);
	}
	
	public String getCallers() {
		return ApplicationUtil.trimToNull(callers);
	}

	public String getPre_caller() {
		return ApplicationUtil.trimToEmpty(pre_caller);
	}

	public void setPre_caller(String pre_caller) {
		this.pre_caller = ApplicationUtil.trimToEmpty(pre_caller);
	}

	public String getPost_caller() {
		return ApplicationUtil.trimToEmpty(post_caller);
	}

	public void setPost_caller(String post_caller) {
		this.post_caller = ApplicationUtil.trimToEmpty(post_caller);
	}

	@Override
	public int compareTo(IntervalloInbound o) {
		if(ordine != null && o.ordine != null) {
			return ordine.compareTo(o.ordine);
		} else if(ordine != null && o.ordine == null) {
			return -1;
		} else if(ordine == null && o.ordine != null) {
			return 1;
		} else {
			return 0;
		}
	}

	public Integer getOrdine() {
		return ordine;
	}

	public void setOrdine(Integer ordine) {
		this.ordine = ordine;
	}

	public String getMusica_iniziale() {
		return ApplicationUtil.trimToNull(musica_iniziale);
	}

	public void setMusica_iniziale(String musica_iniziale) {
		this.musica_iniziale = ApplicationUtil.trimToNull(musica_iniziale);
	}

	public String getMusica_finale() {
		return ApplicationUtil.trimToNull(musica_finale);
	}

	public void setMusica_finale(String musica_finale) {
		this.musica_finale = ApplicationUtil.trimToNull(musica_finale);
	}

	public Integer getRipetizioni() {
		return ripetizioni;
	}

	public void setRipetizioni(Integer ripetizioni) {
		this.ripetizioni = ripetizioni;
	}

	public String getMusica_ripetuta() {
		return ApplicationUtil.trimToNull(musica_ripetuta);
	}

	public void setMusica_ripetuta(String musica_ripetuta) {
		this.musica_ripetuta = ApplicationUtil.trimToNull(musica_ripetuta);
	}

	public List<IVRUtil> getIvr() {
		return ivr;
	}

	public void setIvr(List<IVRUtil> ivr) {
		this.ivr = ivr;
	}

	public String getApp() {
		return ApplicationUtil.trimToNull(app);
	}


	public void setApp(String app) {
		this.app = ApplicationUtil.trimToNull(app);
	}
	
}