package it.callite.utility;
import java.io.Serializable;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashSet;
import java.util.List;
import java.util.Set;
public class IntervalloInboundUtil implements Serializable {

	private static final long serialVersionUID = 1L;
	
	private Set<IntervalloInbound> intervallo = new HashSet<IntervalloInbound>();

	public List<IntervalloInbound> getIntervallo() {
		List<IntervalloInbound> i = new ArrayList<IntervalloInbound>(intervallo);
		Collections.sort(i);
		return i;
	}

	public void setIntervallo(List<IntervalloInbound> intervallo) {
		this.intervallo = new HashSet<IntervalloInbound>(intervallo);
	}
	
	public void add(IntervalloInbound i) {
		if(this.intervallo.contains(i)) {
			this.intervallo.remove(i);
		}
		this.intervallo.add(i);
	}
	
	public void remove(IntervalloInbound i) {
		this.intervallo.remove(i);
	}
	
	public void clear() {
		this.intervallo.clear();
	}
	
	public int getMax() {
		int max = 0;
		for(IntervalloInbound a : intervallo) {
			if(ApplicationUtil.gt(a.getOrdine(), max))
				max = a.getOrdine().intValue();
		}
		return max;
	}
	
	public IntervalloInbound nuovo() {
		IntervalloInbound i =  new IntervalloInbound();
		int max = getMax();
		i.setOrdine(++max);
		return i;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((intervallo == null) ? 0 : intervallo.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		IntervalloInboundUtil other = (IntervalloInboundUtil) obj;
		if (intervallo == null) {
			if (other.intervallo != null)
				return false;
		} else if (!intervallo.equals(other.intervallo))
			return false;
		return true;
	}
	
}