package it.callite.utility;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

import it.callite.column.generic.GenericColumn;
import it.callite.constants.ConstantsGlobal;
import it.callite.constants.ConstantsLanguage;


public class LoggerColonna implements Serializable {
	
	private static final long serialVersionUID = 1L;

	private long inizio;
	private boolean stampa;

	public LoggerColonna(boolean stampa) {
		this.stampa = stampa;
		if(stampa) {
			this.inizio = System.currentTimeMillis();
		}
	}

	public void log(GenericColumn r) {
		if(stampa) {
			List<String> ls0 = new ArrayList<String>();
			for(String o : r.getMappa().keySet()) {
				if(ApplicationUtil.isTrue(r.getMappa().get(o))) {
					ls0.add(o);
				}
			}
			List<String> ls1 = new ArrayList<String>();
			for(String o : r.getMappaG().keySet()) {
				GruppoColonna b = r.getMappaG().get(o);
				if(b != null) {
					for(String go : b.getMappa().keySet()) {
						if(ApplicationUtil.isTrue(b.getMappa().get(go))) {
							ls1.add(go);
						}
					}
				}
			}
			List<String> ls2 = new ArrayList<String>();
			for(Long o : r.getMappaA().keySet()) {
				if(ApplicationUtil.isTrue(r.getMappaA().get(o))) {
					ls2.add(o.toString());
				}
			}
			List<String> ls3 = new ArrayList<String>();
			for(Long o : r.getMappaC().keySet()) {
				if(ApplicationUtil.isTrue(r.getMappaC().get(o))) {
					ls3.add(o.toString());
				}
			}
			List<String> lista = new ArrayList<String>();
			if(ApplicationUtil.notEmpty(ls0)) {
				lista.add(ConstantsLanguage.BASE.upper() + "[" + ApplicationUtil.detoken(ls0, ConstantsGlobal.colonSeparator)+"]");
			}
			if(ApplicationUtil.notEmpty(ls1)) {
				lista.add(ConstantsLanguage.GRUPPO.upper() + "[" + ApplicationUtil.detoken(ls1, ConstantsGlobal.colonSeparator)+"]");
			}
			if(ApplicationUtil.notEmpty(ls2)) {
				lista.add(ConstantsLanguage.ANAGRAFICA.upper() + "[" + ApplicationUtil.detoken(ls2, ConstantsGlobal.colonSeparator)+"]");
			}
			if(ApplicationUtil.notEmpty(ls3)) {
				lista.add(ConstantsLanguage.CONTRATTO.upper() + "[" + ApplicationUtil.detoken(ls3, ConstantsGlobal.colonSeparator)+"]");
			}
			long time = System.currentTimeMillis();
			StringBuilder sb = new StringBuilder(ConstantsLanguage.COLONNA.upper() + " - " + ApplicationUtil.getUsernameLoggato()  + " - " + ConstantsLanguage.TEMPO.stampa() + ": " + (time - inizio) + " " + "ms" + " - " + ApplicationUtil.evaluateAction(null) + " - ");
			if(ApplicationUtil.notEmpty(lista)) {
				sb.append(ApplicationUtil.detoken(lista, " - "));
			}
			ApplicationUtil.monitor(sb.toString());
		}
	}


}