package it.callite.utility;

import java.io.Serializable;

import it.callite.constants.ConstantsLanguage;
import it.callite.model.Contatto;
import it.callite.model.Utente;


public class LoggerContatto implements Serializable {
	
	private static final long serialVersionUID = 1L;
 
	private long inizio;
	private boolean stampa;

	public LoggerContatto(boolean stampa) {
		this.stampa = stampa;
		if(stampa) {
			this.inizio = System.currentTimeMillis();
		}
	}
	
	public void log(String lo, Utente utente, Contatto contatto) {
		if(stampa) {
			long time = System.currentTimeMillis();
			StringBuilder sb = new StringBuilder(lo);
			if(utente != null) {
				sb.append(" - " + ConstantsLanguage.OPERATORE.stampa() + ": " + utente.getId());
			}
			if(contatto != null) { 
				sb.append(" - " + ConstantsLanguage.CONTATTO.stampa() + ": " + contatto.getId());
			}
			sb.append(" - " + ConstantsLanguage.TEMPO.stampa() + ": " + (time - inizio) + " " + "ms");
			ApplicationUtil.monitor(sb.toString());
		}
	}


}