package it.callite.utility;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Enumeration;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Properties;

import it.callite.constants.ConstantsGlobal;
@SuppressWarnings("serial")
public class MySystem implements Serializable {

	private String architettura;
	private Double utilizzo;
	private String nome;
	private List<String> anomalia = new ArrayList<String>();

	public String getAnomalia() {
		if(ApplicationUtil.notEmpty(anomalia)) {
			return ApplicationUtil.detoken(anomalia, ConstantsGlobal.RETURN);
		} else return null;
	}

	public void addAnomalia(String anomalia) {
		this.anomalia.add(anomalia);
	}

	private String versione;
	private Integer processori;
	private Long totale;
	private Long libero;
	private Long usato;
	private Long disponibile;

	private List<MyStorage> storages = new ArrayList<MyStorage>();

	public List<MyStorage> getStorages() {
		return storages;
	}

	public void setStorages(List<MyStorage> storages) {
		this.storages = storages;
	}

	public Double getPercentualeU() {
		if(ApplicationUtil.gtZero(totale) && ApplicationUtil.gtZero(usato)) {
			Double parzialeT = Double.valueOf(usato);
			Double totaleT = Double.valueOf(totale);
			return Double.valueOf(parzialeT / totaleT);
		} else {
			return Double.valueOf(0);
		}
	}

	public Double getPercentualeL() {
		if(ApplicationUtil.gtZero(totale) && ApplicationUtil.gtZero(libero)) {
			Double parzialeT = Double.valueOf(libero);
			Double totaleT = Double.valueOf(totale);
			return Double.valueOf(parzialeT / totaleT);
		} else {
			return Double.valueOf(0);
		}
	}

	public Double getPercentualeD() {
		if(ApplicationUtil.gtZero(totale) && ApplicationUtil.gtZero(disponibile)) {
			Double parzialeT = Double.valueOf(disponibile);
			Double totaleT = Double.valueOf(totale);
			return Double.valueOf(parzialeT / totaleT);
		} else {
			return Double.valueOf(0);
		}
	}

	public String getArchitettura() {
		return architettura;
	}

	public void setArchitettura(String architettura) {
		this.architettura = architettura;
	}

	public Double getUtilizzo() {
		return utilizzo;
	}

	public void setUtilizzo(Double utilizzo) {
		this.utilizzo = utilizzo;
	}

	public String getNome() {
		return nome;
	}

	public void setNome(String nome) {
		this.nome = nome;
	}

	public String getVersione() {
		return versione;
	}

	public void setVersione(String versione) {
		this.versione = versione;
	}

	public Integer getProcessori() {
		return processori;
	}

	public void setProcessori(Integer processori) {
		this.processori = processori;
	}

	public Long getTotale() {
		return totale;
	}

	public void setTotale(Long totale) {
		this.totale = totale;
	}

	public Long getLibero() {
		return libero;
	}

	public void setLibero(Long libero) {
		this.libero = libero;
	}

	public Long getUsato() {
		return usato;
	}

	public void setUsato(Long usato) {
		this.usato = usato;
	}

	public Long getDisponibile() {
		return disponibile;
	}

	public void setDisponibile(Long disponibile) {
		this.disponibile = disponibile;
	}

	public List<Label> getProperties() {
		List<Label> ls = new ArrayList<Label>();
		Properties properties = System.getProperties();
		Enumeration<Object> itS = properties.keys();
		while (itS.hasMoreElements()) {
			Object o = (Object) itS.nextElement();
			Label l = new Label();
			l.setLabel((String) o);
			l.setValue((String) properties.get(o));
			ls.add(l);
		}
		Map<String, String> env = System.getenv();
		Iterator<String> itE = env.keySet().iterator();
		while (itE.hasNext()) {
			String key = (String) itE.next();
			Label l = new Label();
			l.setLabel(key);
			l.setValue((String) env.get(key));
			ls.add(l);
		}
		return ls;
	}
}