package it.callite.utility;

import java.io.IOException;

import com.itextpdf.text.DocumentException;
import com.itextpdf.text.Element;
import com.itextpdf.text.Font;
import com.itextpdf.text.Phrase;
import com.itextpdf.text.Rectangle;
import com.itextpdf.text.pdf.ColumnText;
import com.itextpdf.text.pdf.GrayColor;
import com.itextpdf.text.pdf.PdfContentByte;
import com.itextpdf.text.pdf.PdfGState;
import com.itextpdf.text.pdf.PdfReader;
import com.itextpdf.text.pdf.PdfStamper;


public class PDFUtil {
	
	public static void watermark(String watermark, PdfReader reader, PdfStamper stamper) throws IOException, DocumentException {
		if(ApplicationUtil.isNotBlank(watermark)) {
			Font FONT = new Font(Font.FontFamily.TIMES_ROMAN, 80, Font.BOLD, new GrayColor(0.5f));
			Phrase p = new Phrase(watermark, FONT);
			int n = reader.getNumberOfPages();
			for (int i = 1; i <= n; i++) {
				Rectangle pagesize = reader.getPageSizeWithRotation(i);
				float x = (pagesize.getLeft() + pagesize.getRight()) / 2;
				float y = (pagesize.getTop() + pagesize.getBottom()) / 2;
				PdfContentByte over = stamper.getOverContent(i);
				over.saveState();

				PdfGState state = new PdfGState();
				state.setFillOpacity(0.2f);
				over.setGState(state);
				ColumnText.showTextAligned(over, Element.ALIGN_CENTER, p, x, y, 50.0F);
				over.restoreState();
			}
		}
	}
	

}

