package it.callite.utility;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import javax.faces.model.SelectItem;

import org.springframework.faces.model.OneSelectionTrackingListDataModel;

import it.callite.constants.ConstantsGlobal;
import it.callite.model.generic.SelezionatoAbstract;
@SuppressWarnings("serial")
public class PaginazioneTabella implements Serializable {

	private OneSelectionTrackingListDataModel esportatiList = new OneSelectionTrackingListDataModel();
	private OneSelectionTrackingListDataModel visualizzatiList = new OneSelectionTrackingListDataModel();
	private OneSelectionTrackingListDataModel selezionatiList = new OneSelectionTrackingListDataModel();
	private int page;
	private int righePagina;
	private BigDecimal somma;
	private int totale_risultati;
	private List<?> totale_aggregati;
	private List<Integer> value = new ArrayList<Integer>();
	private List<Paginazione> valueL= new ArrayList<Paginazione>();
	private List<Paginazione> valueR= new ArrayList<Paginazione>();



	public PaginazioneTabella() {
		page = 0;
		totale_risultati = 0;
		somma = null;
		totale_aggregati = null;
		righePagina = ConstantsGlobal.righePagina;
		int record = ConstantsGlobal.recordPagina;
		int size = ConstantsGlobal.tastiPagina;
		for(int i = 0; i < record; i++) {
			value.add(i+1);
		}
		for(int i = 0; i < size; i++) {
			Paginazione r = new Paginazione(new String(new char[i+1]).replace("\0", ">"), (int) Math.pow(getSizeTotal(), i));
			Paginazione l = new Paginazione(new String(new char[size-i]).replace("\0", "<"), (int) Math.pow(getSizeTotal(), size-(i+1)));
			valueR.add(r);
			valueL.add(l);
		}
	}

	public OneSelectionTrackingListDataModel getEsportatiList() {
		return esportatiList;
	}

	public int getInizio() {
		if(ApplicationUtil.gtZero(page)) {
			int n = getNumero_pagine();
			if(page >= n) {
				page = n-1;
			}
			return (page*righePagina);
		}
		else return 0;
	}

	public int getNumero_pagine(){
		if(ApplicationUtil.gtZero(totale_risultati) && ApplicationUtil.gtZero(righePagina)) {
			return (totale_risultati/righePagina) + ((totale_risultati % righePagina > 0) ? 1 : 0);
		}
		else return 0;
	}

	public int getPage() {
		if(ApplicationUtil.gtZero(page)) {
			int n = getNumero_pagine();
			if(page >= n) {
				page = n-1;
			}
			return page;
		} else return 0;
	}

	public int getPageNext() {
		return page+1;
	}

	public List<SelectItem> getPagine() {
		int s = ConstantsGlobal.stepPagina;
		int m = ConstantsGlobal.maxPagina;
		int c = (totale_risultati/s) + ((totale_risultati % s > 0) ? 1 : 0);
		int max = c > m ? m : c;
		return ApplicationUtil.getLimite(s, max, righePagina, false);
	}

	public int getRigheDefault() {
		return ConstantsGlobal.stepPagina;
	}

	public int getRighePagina() {
		return righePagina;
	}

	public OneSelectionTrackingListDataModel getSelezionatiList() {
		return selezionatiList;
	}

	public int getSizeRecord() {
		return ConstantsGlobal.recordPagina;
	}

	public int getSizeTotal() {
		return ConstantsGlobal.recordPagina * 2;
	}

	public BigDecimal getSomma() {
		return somma;
	}

	public int getTotale_risultati() {
		return totale_risultati;
	}

	public int getTutti() {
		return ConstantsGlobal.maxElementi;
	}

	public List<Integer> getValue() {
		return value;
	}

	public List<Paginazione> getValueL() {
		return valueL;
	}


	public List<Paginazione> getValueR() {
		return valueR;
	}

	public OneSelectionTrackingListDataModel getVisualizzatiList() {
		return visualizzatiList;
	}

	public int getZero() {
		return ConstantsGlobal.minElementi;
	}

	public List<SelezionatoAbstract> pagInvertiScelti() {
		List<SelezionatoAbstract> visualizzati = toList(visualizzatiList);
		List<SelezionatoAbstract> selezionati = toList(selezionatiList);
		Iterator<SelezionatoAbstract> objIter = visualizzati.iterator();
		while(objIter.hasNext()) {
			SelezionatoAbstract selezionato = objIter.next();
			if(selezionato.getSelezionabile()) {
				if (selezionati.contains(selezionato)) {
					selezionati.remove(selezionato);
				} else {
					selezionati.add(selezionato);
				}
			}
		}
		return selezionati;
	}

	public List<SelezionatoAbstract> pagInvertiTutti() {
		List<SelezionatoAbstract> esportati = toList(esportatiList);
		List<SelezionatoAbstract> selezionati = toList(selezionatiList);
		Iterator<SelezionatoAbstract> objIter = esportati.iterator();
		while(objIter.hasNext()) {
			SelezionatoAbstract selezionato = objIter.next();
			if(selezionato.getSelezionabile()) {
				if (selezionati.contains(selezionato)) {
					selezionati.remove(selezionato);
				} else {
					selezionati.add(selezionato);
				}
			}
		}
		return selezionati;
	}

	public List<SelezionatoAbstract> pagRimuoviScelti() {
		List<SelezionatoAbstract> visualizzati = toList(visualizzatiList);
		List<SelezionatoAbstract> selezionati = toList(selezionatiList);
		Iterator<SelezionatoAbstract> objIter = visualizzati.iterator();
		while(objIter.hasNext()) {
			SelezionatoAbstract selezionato = objIter.next();
			if(selezionato.getSelezionabile()) {
				if (selezionati.contains(selezionato)) {
					selezionati.remove(selezionato);
				}
			}
		}
		return selezionati;
	}

	public List<SelezionatoAbstract> pagSelezionato() {
		SelezionatoAbstract ct = (SelezionatoAbstract) visualizzatiList.getSelectedRow();
		List<SelezionatoAbstract> selezionati = toList(selezionatiList);
		if (ct.getSelezionato()) {
			if(!selezionati.contains(ct)) {
				selezionati.add(ct);
			}
		} else {
			if(selezionati.contains(ct)) {
				selezionati.remove(ct);
			}
		}
		return selezionati;
	}

	public List<SelezionatoAbstract> pagSelezionaScelti() {
		List<SelezionatoAbstract> visualizzati = toList(visualizzatiList);
		List<SelezionatoAbstract> selezionati = toList(selezionatiList);
		Iterator<SelezionatoAbstract> objIter = visualizzati.iterator();
		while(objIter.hasNext()) {
			SelezionatoAbstract selezionato = objIter.next();
			if (!selezionati.contains(selezionato)) {
				if(selezionato.getSelezionabile()) {
					selezionati.add(selezionato);
				}
			}
		}
		return selezionati;
	}


	public List<SelezionatoAbstract> pagSelezionaTutti() {
		List<SelezionatoAbstract> esportati = toList(esportatiList);
		List<SelezionatoAbstract> selezionati = toList(selezionatiList);
		Iterator<SelezionatoAbstract> objIter = esportati.iterator();
		while(objIter.hasNext()) {
			SelezionatoAbstract selezionato = objIter.next();
			if (!selezionati.contains(selezionato)) {
				if(selezionato.getSelezionabile()) {
					selezionati.add(selezionato);
				}
			}
		}
		return selezionati;
	}

	public List<SelezionatoAbstract> pagSincronizza() {
		List<SelezionatoAbstract> visualizzati = toList(visualizzatiList);
		List<SelezionatoAbstract> selezionati = toList(selezionatiList);
		Iterator<SelezionatoAbstract> objIter = visualizzati.iterator();
		while(objIter.hasNext()) {
			SelezionatoAbstract c = objIter.next();
			if (selezionati.contains(c)) {
				c.setSelezionato(Boolean.TRUE);
			} else {
				c.setSelezionato(Boolean.FALSE);
			}
		}
		return visualizzati;
	}


	public void resetPage() {
		page = 0;
		selezionatiList = new OneSelectionTrackingListDataModel();
	}


	public void resetSelezionati() {
		page = getPage();
		selezionatiList = new OneSelectionTrackingListDataModel();
	}

	public void setEsportatiList(OneSelectionTrackingListDataModel esportatiList) {
		this.esportatiList = esportatiList;
	}
	public void setPage(int page) {
		this.page = page;
	}

	public void setPageNext(int pageNext) {
		this.page = pageNext-1;
	}


	public void setRighePagina(int righePagina) {
		this.righePagina = righePagina;
	}


	public void setSelezionatiList(OneSelectionTrackingListDataModel selezionatiList) {
		this.selezionatiList = selezionatiList;
	}

	public void setSomma(BigDecimal somma) {
		this.somma = somma;
	}

	public void setTotale_risultati(int totale_risultati) {
		this.totale_risultati = totale_risultati;
	}


	public void setVisualizzatiList(OneSelectionTrackingListDataModel visualizzatiList) {
		this.visualizzatiList = visualizzatiList;
	}

	@SuppressWarnings("unchecked")
	private List<SelezionatoAbstract> toList(OneSelectionTrackingListDataModel sel) {
		List<SelezionatoAbstract> lista = new ArrayList<SelezionatoAbstract>();
		if (sel != null) {
			Object oslist_data = sel.getWrappedData();
			if (oslist_data != null)
				lista = (List<SelezionatoAbstract>) oslist_data;
		}
		return lista;
	}


	public BigDecimal getParziale() {
		List<SelezionatoAbstract> visualizzati = toList(visualizzatiList);
		double totale = 0;
		Iterator<SelezionatoAbstract> objIter = visualizzati.iterator();
		while(objIter.hasNext()) {
			SelezionatoAbstract c = objIter.next();
			double parziale  = c.getParziale();
			totale += parziale;
		}
		return new BigDecimal(totale);
	}

	public List<?> getTotale_aggregati() {
		return totale_aggregati;
	}

	public void setTotale_aggregati(List<?> totale_aggregati) {
		this.totale_aggregati = totale_aggregati;
	}

	
}
