package it.callite.utility;
import java.io.Serializable;
import it.callite.model.Contratto;
import it.callite.model.Prodotto;
@SuppressWarnings("serial")
public class ProdottoCheckbox implements Serializable {
	private Prodotto prodotto;
	private Contratto contratto;
	private Integer quantita = 1;
	private Boolean selezionato;
	public ProdottoCheckbox(Prodotto prodotto) {
		this.prodotto = prodotto;
		this.contratto = null;
		this.selezionato = Boolean.FALSE;
		this.quantita = 1;
	}
	
	public ProdottoCheckbox(Contratto contratto) {
		this.prodotto = contratto.getProdotto();
		this.contratto = contratto;
		this.selezionato = Boolean.FALSE;
		this.quantita = 1;
	}
	
	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((contratto == null) ? 0 : contratto.hashCode());
		result = prime * result + ((prodotto == null) ? 0 : prodotto.hashCode());
		return result;
	}
	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		ProdottoCheckbox other = (ProdottoCheckbox) obj;
		if (contratto == null) {
			if (other.contratto != null)
				return false;
		} else if (!contratto.equals(other.contratto))
			return false;
		if (prodotto == null) {
			if (other.prodotto != null)
				return false;
		} else if (!prodotto.equals(other.prodotto))
			return false;
		return true;
	}
	public Prodotto getProdotto() {
		return prodotto;
	}
	public Long getProdottoId() {
		return contratto!= null ? contratto.getId() : prodotto.getId();
	}
	public Integer getQuantita() {
		if(quantita == null) {
			quantita = 1;
		}
		return quantita;
	}
	public Boolean getSelezionato() {
		return selezionato;
	}
	public void setProdotto(Prodotto prodotto) {
		this.prodotto = prodotto;
	}
	public void setQuantita(Integer quantita) {
		this.quantita = quantita;
	}
	
	
	public void setSelezionato(Boolean selezionato) {
		this.selezionato = selezionato;
	}
	public Contratto getContratto() {
		return contratto;
	}
	public void setContratto(Contratto contratto) {
		this.contratto = contratto;
	}
}