package it.callite.utility;
import it.callite.model.Contratto;
import it.callite.model.Prodotto;
import java.io.Serializable;
@SuppressWarnings("serial")
public class ProdottoSelezionato implements Serializable {
	private Prodotto prodotto;
	private Integer progressivo = 0;
	private Contratto contratto;

	private String nome;
	private String cognome;
	private String email;
	private String telefono;

	public ProdottoSelezionato(Prodotto prodotto, int i) {
		this.prodotto = prodotto;
		this.contratto = null;
		this.progressivo = i;
	}

	public ProdottoSelezionato(Contratto contratto) {
		this.prodotto = contratto.getProdotto();
		this.contratto = contratto;
		this.progressivo = 0;
	}
	public Integer getProgressivo() {
		return progressivo;
	}
	public void setProgressivo(Integer progressivo) {
		this.progressivo = progressivo;
	}
	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((contratto == null) ? 0 : contratto.hashCode());
		result = prime * result + ((prodotto == null) ? 0 : prodotto.hashCode());
		result = prime * result + ((progressivo == null) ? 0 : progressivo.hashCode());
		return result;
	}
	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		ProdottoSelezionato other = (ProdottoSelezionato) obj;
		if (contratto == null) {
			if (other.contratto != null)
				return false;
		} else if (!contratto.equals(other.contratto))
			return false;
		if (prodotto == null) {
			if (other.prodotto != null)
				return false;
		} else if (!prodotto.equals(other.prodotto))
			return false;
		if (progressivo == null) {
			if (other.progressivo != null)
				return false;
		} else if (!progressivo.equals(other.progressivo))
			return false;
		return true;
	}
	public Prodotto getProdotto() {
		return prodotto;
	}
	public void setProdotto(Prodotto prodotto) {
		this.prodotto = prodotto;
	}
	public String getProdottoDenominazione() {
		return contratto != null ?  (prodotto.getDenominazione() + " [" + contratto.getId() + "]") : (prodotto.getDenominazione() + " [" + (getProgressivo() + 1) + "]");
	}

	public String getProdottoId() {
		return contratto != null ?  contratto.getId().toString() : (prodotto.getId() + "_" +  getProgressivo());
	}
	public Contratto getContratto() {
		return contratto;
	}
	public void setContratto(Contratto contratto) {
		this.contratto = contratto;
	}

	public String getNome() {
		return nome;
	}

	public void setNome(String nome) {
		this.nome = nome;
	}

	public String getCognome() {
		return cognome;
	}

	public void setCognome(String cognome) {
		this.cognome = cognome;
	}

	public String getEmail() {
		return email;
	}

	public void setEmail(String email) {
		this.email = email;
	}

	public String getTelefono() {
		return telefono;
	}

	public void setTelefono(String telefono) {
		this.telefono = telefono;
	}
	public boolean isValidPda() {
		return ApplicationUtil.isNotBlank(telefono) && ApplicationUtil.isNotBlank(email) && ApplicationUtil.isNotBlank(nome) && ApplicationUtil.isNotBlank(cognome);
	}

}