package it.callite.utility;

import java.io.Serializable;
import java.util.Date;
import java.util.List;

import it.callite.criteria.RiprogrammaContattoCriteria;
import it.callite.utility.item.CampagnaSI;
import it.callite.utility.item.ListaSI;

@SuppressWarnings("serial")
public class RiprogrammaContatto  implements Serializable {

	private List<CampagnaSI> campagne;
	private List<ListaSI> liste;
	private List<EsitoGenerico> esiti;
	private Boolean inserimento = true;
	private IntervalloData intervallo = new IntervalloData();
	private Integer operazione;
	
	private String ricerca_anagrafica;
	private List<String> ricerca_anagraficaV = ApplicationUtil.getAnagraficaDefault();
	
	public void resetAnagraficaV() {
		ricerca_anagraficaV = ApplicationUtil.getAnagraficaDefault();
	}
	
	public RiprogrammaContatto(RiprogrammaContattoCriteria crt) {
		this.campagne = crt.getCampagne();
		this.esiti = crt.getEsiti();
		this.liste = crt.getListe();
		this.inserimento = crt.getInserimento();
		this.intervallo = crt.getIntervallo();
		this.operazione = crt.getOperazione();
		this.ricerca_anagrafica = crt.getRicerca_anagrafica();
		this.ricerca_anagraficaV = crt.getRicerca_anagraficaV();
	}
	
	public List<EsitoGenerico> getEsiti() {
		return esiti;
	}
	public void setEsiti(List<EsitoGenerico> esiti) {
		this.esiti = esiti;
	}

	public List<CampagnaSI> getCampagne() {
		return campagne;
	}

	public void setCampagne(List<CampagnaSI> campagne) {
		this.campagne = campagne;
	}

	public List<ListaSI> getListe() {
		return liste;
	}

	public void setListe(List<ListaSI> liste) {
		this.liste = liste;
	}

	public Boolean getInserimento() {
		return inserimento;
	}

	public void setInserimento(Boolean inserimento) {
		this.inserimento = inserimento;
	}

	public IntervalloData getIntervallo() {
		return intervallo;
	}

	public void setIntervallo(IntervalloData intervallo) {
		this.intervallo = intervallo;
	}
	

	public Integer getOperazione() {
		return operazione;
	}

	public void setOperazione(Integer operazione) {
		this.operazione = operazione;
	}

	public Date getFine() {
		return intervallo.getFine();
	}
	
	public Date getInizio() {
		return intervallo.getInizio();
	}

	public String getRicerca_anagrafica() {
		return ricerca_anagrafica;
	}

	public void setRicerca_anagrafica(String ricerca_anagrafica) {
		this.ricerca_anagrafica = ricerca_anagrafica;
	}

	public List<String> getRicerca_anagraficaV() {
		return ricerca_anagraficaV;
	}

	public void setRicerca_anagraficaV(List<String> ricerca_anagraficaV) {
		this.ricerca_anagraficaV = ricerca_anagraficaV;
	}

	
	
}