package it.callite.utility;


import java.io.Serializable;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Set;

import it.callite.model.report.MonitorOperatore;


@SuppressWarnings("serial")
public class StatoOperatore implements Serializable {

	private Map<Short, List<MonitorOperatore>> data;

	public StatoOperatore() {
		data = new HashMap<Short, List<MonitorOperatore>>();
	}

	public synchronized void clear() {
		data.clear();
	}

	public synchronized List<MonitorOperatore> get(Short stato){
		List<MonitorOperatore> mops =  data.get(stato);
		if(mops==null)
			mops = new ArrayList<MonitorOperatore>();
		return mops;
	}
	
	public void add(MonitorOperatore mop){
		Short stato = mop.getStato();
		List<MonitorOperatore> mops =  data.get(stato);
		if(mops==null)
			mops = new ArrayList<MonitorOperatore>();
		if(!mops.contains(mop)) {
			mops.add(mop);
		}
		data.put(stato, mops);
	}
	
	public synchronized List<StatoLista> getList() {
		List<StatoLista> ls = new ArrayList<StatoLista>();
		if(ApplicationUtil.notEmpty(data)) {
			Set<Short> lngList = data.keySet();
			Iterator<Short> lnt = lngList.iterator();
			while (lnt.hasNext()) {
				Short stato = lnt.next();
				List<MonitorOperatore> mops =  data.get(stato);
				StatoLista s = new StatoLista();
				s.setStato(stato);
				s.setOperatori(mops);
				ls.add(s);
			}
		}
		return ls;
	}


	public synchronized int getSize() {
		return data.size();
	}

	public synchronized boolean isEmpty() {
		return data.size() == 0;
	}
}