package it.callite.utility;
import java.io.Serializable;

import it.callite.constants.ConstantsGlobal;
@SuppressWarnings("serial")
public class StatoServer implements Serializable {

	private String server;
	private String service;
	private String protocol;
	private Boolean esiste = false;
	private Boolean ricaricabile = false;
	private long timeout = ConstantsGlobal.timeoutService;
	public Boolean getEsiste() {
		return esiste;
	}
	public void setEsiste(Boolean esiste) {
		this.esiste = esiste;
	}
	public String getService() {
		return service;
	}
	public void setService(String service) {
		this.service = service;
	}
	public String getProtocol() {
		return protocol;
	}
	public void setProtocol(String protocol) {
		this.protocol = protocol;
	}
	private Integer porta;
	public String getServer() {
		return server;
	}
	public void setServer(String server) {
		this.server = server;
	}
	public Integer getPorta() {
		return porta;
	}
	public void setPorta(Integer porta) {
		this.porta = porta;
	}
	
	public Boolean getOk() {
		if(ApplicationUtil.equals(protocol, ConstantsGlobal.tcp) && ApplicationUtil.gtZero(porta) && server != null) {
			return ApplicationUtil.test(server, porta, timeout);
		} 
		return false;
	}
	public Boolean getRicaricabile() {
		return ricaricabile;
	}
	public void setRicaricabile(Boolean ricaricabile) {
		this.ricaricabile = ricaricabile;
	}

	public long getTimeout() {
		return timeout;
	}
	public void setTimeout(long timeout) {
		this.timeout = timeout;
	} 

	public StatoServer(String service, String server, Integer porta, String protocol, boolean esiste) {
		this.service = service;
		this.esiste = esiste;
		this.protocol = protocol;
		this.server = esiste ? ConstantsGlobal.localhost : server;
		this.porta = porta;
		this.ricaricabile = true;
		this.timeout = ConstantsGlobal.timeoutService;
	}
}