package it.callite.utility;
import java.lang.reflect.Method;
import java.util.Map;

import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;
import com.mashape.unirest.http.exceptions.UnirestException;
import com.mashape.unirest.request.GetRequest;
import com.mashape.unirest.request.HttpRequest;
import com.mashape.unirest.request.HttpRequestWithBody;
public class UnirestAPI {
 
	public static String invoke(String metodo, String link, String headers, String fields, String parameters, String body, String username, String password) throws Exception {
		Class<UnirestAPI> c = UnirestAPI.class;
		Method m = c.getDeclaredMethod(metodo, String.class, String.class, String.class, String.class, String.class, String.class, String.class);
		return (String) m.invoke(null, new Object [] {link, headers, fields, parameters, body, username, password});
	}
	
	public static String post(String link, String headers, String fields, String parameters, String body, String username, String password) throws UnirestException {
		HttpRequestWithBody r = Unirest.post(link);
		if(username != null && password != null) {
			r.basicAuth(username, password);
		}
		Map<String, String> h = ApplicationUtil.createMapH(headers);
		if(ApplicationUtil.notEmpty(h)) {
			r.headers(h);
		}
		Map<String, Object> f = ApplicationUtil.createMapP(fields);
		if(ApplicationUtil.notEmpty(f)) {
			r.fields(f);
		}
		Map<String, Object> p = ApplicationUtil.createMapP(parameters);
		if(ApplicationUtil.notEmpty(p)) {
			r.queryString(p);
		}
		if(body != null) {
			r.body(body);
		}
		return response(r);
	}
	public static String delete(String link, String headers, String fields, String parameters, String body, String username, String password) throws UnirestException {
		HttpRequestWithBody r = Unirest.delete(link);
		if(username != null && password != null) {
			r.basicAuth(username, password);
		}
		Map<String, String> h = ApplicationUtil.createMapH(headers);
		if(ApplicationUtil.notEmpty(h)) {
			r.headers(h);
		}
		Map<String, Object> f = ApplicationUtil.createMapP(fields);
		if(ApplicationUtil.notEmpty(f)) {
			r.fields(f);
		}
		Map<String, Object> p = ApplicationUtil.createMapP(parameters);
		if(ApplicationUtil.notEmpty(p)) {
			r.queryString(p);
		}
		if(body != null) {
			r.body(body);
		}
		return response(r);
	}
	public static String options(String link, String headers, String fields, String parameters, String body, String username, String password) throws UnirestException {
		HttpRequestWithBody r = Unirest.options(link);
		if(username != null && password != null) {
			r.basicAuth(username, password);
		}
		Map<String, String> h = ApplicationUtil.createMapH(headers);
		if(ApplicationUtil.notEmpty(h)) {
			r.headers(h);
		}
		Map<String, Object> f = ApplicationUtil.createMapP(fields);
		if(ApplicationUtil.notEmpty(f)) {
			r.fields(f);
		}
		Map<String, Object> p = ApplicationUtil.createMapP(parameters);
		if(ApplicationUtil.notEmpty(p)) {
			r.queryString(p);
		}
		if(body != null) {
			r.body(body);
		}
		return response(r);
	}
	public static String patch(String link, String headers, String fields, String parameters, String body, String username, String password) throws UnirestException {
		HttpRequestWithBody r = Unirest.patch(link);
		if(username != null && password != null) {
			r.basicAuth(username, password);
		}
		Map<String, String> h = ApplicationUtil.createMapH(headers);
		if(ApplicationUtil.notEmpty(h)) {
			r.headers(h);
		}
		Map<String, Object> f = ApplicationUtil.createMapP(fields);
		if(ApplicationUtil.notEmpty(f)) {
			r.fields(f);
		}
		Map<String, Object> p = ApplicationUtil.createMapP(parameters);
		if(ApplicationUtil.notEmpty(p)) {
			r.queryString(p);
		}
		if(body != null) {
			r.body(body);
		}
		return response(r);
	}
	public static String put(String link, String headers, String fields, String parameters, String body, String username, String password) throws UnirestException {
		HttpRequestWithBody r = Unirest.put(link);
		if(username != null && password != null) {
			r.basicAuth(username, password);
		}
		Map<String, String> h = ApplicationUtil.createMapH(headers);
		if(ApplicationUtil.notEmpty(h)) {
			r.headers(h);
		}
		Map<String, Object> f = ApplicationUtil.createMapP(fields);
		if(ApplicationUtil.notEmpty(f)) {
			r.fields(f);
		}
		Map<String, Object> p = ApplicationUtil.createMapP(parameters);
		if(ApplicationUtil.notEmpty(p)) {
			r.queryString(p);
		}
		if(body != null) {
			r.body(body);
		}
		return response(r);
	}
	public static String get(String link, String headers, String fields, String parameters, String body, String username, String password) throws UnirestException {
		GetRequest r = Unirest.get(link);
		if(username != null && password != null) {
			r.basicAuth(username, password);
		}
		Map<String, String> h = ApplicationUtil.createMapH(headers);
		if(ApplicationUtil.notEmpty(h)) {
			r.headers(h);
		}
		Map<String, Object> p = ApplicationUtil.createMapP(parameters);
		if(ApplicationUtil.notEmpty(p)) {
			r.queryString(p);
		}
		return response(r);
	}
	public static String head(String link, String headers, String fields, String parameters, String body, String username, String password) throws UnirestException {
		GetRequest r = Unirest.head(link);
		if(username != null && password != null) {
			r.basicAuth(username, password);
		}
		Map<String, String> h = ApplicationUtil.createMapH(headers);
		if(ApplicationUtil.notEmpty(h)) {
			r.headers(h);
		}
		Map<String, Object> p = ApplicationUtil.createMapP(parameters);
		if(ApplicationUtil.notEmpty(p)) {
			r.queryString(p);
		}
		return response(r);
	}
	
	private static String response(HttpRequest request) throws UnirestException {
		HttpResponse<String> response = request.asString();
		if(response != null) {
			String s = ApplicationUtil.trimToNull(response.getStatusText());
			String r = ApplicationUtil.trimToEmpty(response.getBody());
			if(s != null) {
				return s + ": " + r;
			} else {
				return r;
			}
		}
		return "";
	}
}