package it.callite.utility;
import java.io.IOException;
import java.io.InputStream;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import org.apache.poi.openxml4j.exceptions.OpenXML4JException;
import org.apache.poi.openxml4j.opc.OPCPackage;
import org.apache.poi.ss.extractor.ExcelExtractor;
import org.apache.poi.ss.usermodel.Cell;
import org.apache.poi.ss.usermodel.DataFormatter;
import org.apache.poi.ss.usermodel.Row;
import org.apache.poi.ss.usermodel.Sheet;
import org.apache.poi.ss.usermodel.Workbook;
import org.apache.poi.xssf.binary.XSSFBCommentsTable;
import org.apache.poi.xssf.binary.XSSFBSharedStringsTable;
import org.apache.poi.xssf.binary.XSSFBSheetHandler;
import org.apache.poi.xssf.binary.XSSFBSheetHandler.SheetContentsHandler;
import org.apache.poi.xssf.binary.XSSFBStylesTable;
import org.apache.poi.xssf.eventusermodel.XSSFBReader;
import org.apache.poi.xssf.extractor.XSSFEventBasedExcelExtractor;
import org.apache.xmlbeans.XmlException;
import org.xml.sax.SAXException;
public class XSSFBEventBasedExcelExtractor extends XSSFEventBasedExcelExtractor implements ExcelExtractor {
	private String name;
	private Workbook wb;
	public XSSFBEventBasedExcelExtractor(String path) throws XmlException, OpenXML4JException, IOException {
		super(path);
	}
	public XSSFBEventBasedExcelExtractor(OPCPackage container) throws XmlException, OpenXML4JException, IOException {
		super(container);
	}
	@Override
	public void setFormulasNotResults(boolean formulasNotResults) {
		throw new IllegalArgumentException("Not currently supported");
	}
	public void processSheet(SheetContentsHandler sheetContentsExtractor,XSSFBStylesTable styles,XSSFBCommentsTable comments,XSSFBSharedStringsTable strings,InputStream sheetInputStream) throws IOException, SAXException {
		DataFormatter formatter = new DataFormatter();
		XSSFBSheetHandler xssfbSheetHandler = new XSSFBSheetHandler(sheetInputStream,styles, comments, strings, sheetContentsExtractor, formatter, getFormulasNotResults());
		xssfbSheetHandler.parse();
	}
	public void work() {
		try {
			if(wb == null) {
				wb = ApplicationUtil.workbookX();
			}
			XSSFBSharedStringsTable strings = new XSSFBSharedStringsTable(getPackage());
			ExcelStyle s = new ExcelStyle(wb);
			XSSFBReader xssfbReader = new XSSFBReader(getPackage());
			XSSFBStylesTable styles = xssfbReader.getXSSFBStylesTable();
			XSSFBReader.SheetIterator iter = (XSSFBReader.SheetIterator) xssfbReader.getSheetsData();
			int k = 0;
			Map<Integer, List<String>>  data = new HashMap<Integer, List<String>>();
			SheetContentsHandler sheetExtractor =  new SheetBToCSV(data);
			while (iter.hasNext()) {
				InputStream stream = iter.next();
				XSSFBCommentsTable comments = getIncludeCellComments() ? iter.getXSSFBSheetComments() : null;
				processSheet(sheetExtractor, styles, comments, strings, stream);
				if(ApplicationUtil.notEmpty(data)) {
					Sheet sheet = wb.createSheet((k++) + name);
					for(int i = 0; i < data.size(); i++) {
						List<String>  righe = data.get(i);
						if(ApplicationUtil.notEmpty(righe)) {
							Row row = sheet.createRow(i);
							ExcelFormatList lista = new ExcelFormatList();
							for(String riga : righe) {
								lista.addValore(riga);
							}
							for(int j = 0; j < righe.size(); j++) {
								ExcelFormat el = lista.get(j);
								Cell cell = row.createCell(j, el.getCellType());
								ApplicationUtil.cellStamper(s, cell, el);
							}
						}
					}
					sheet.setDefaultColumnWidth(20);
				}
				stream.close();
			}
		} catch (Exception e) {
		}
	}
	public String getName() {
		return name;
	}
	public void setName(String name) {
		this.name = name;
	}
	public Workbook getWorkbook() {
		return wb;
	}
	public void setWorkbook(Workbook wb) {
		this.wb = wb;
	}
}