package it.callite.utility;

import java.io.File;
import java.io.FileInputStream;
import java.io.OutputStream;
import java.nio.file.attribute.FileTime;
import java.util.ArrayList;
import java.util.List;
import java.util.zip.ZipEntry;
import java.util.zip.ZipOutputStream;

import it.callite.constants.ConstantsGlobal;

public class ZipUtils {

	public static void zipIt(String comment, String sourceFolder, OutputStream fos) {
		List<File> fileList = new ArrayList<File>();
		try {
			byte[] buffer = new byte[ConstantsGlobal.kb];
			ApplicationUtil.generateFileList(fileList, new File(sourceFolder));
			ZipOutputStream zos = new ZipOutputStream(fos);
			for (File f : fileList) {
				String file = ApplicationUtil.removeStart(f.getAbsolutePath(), sourceFolder + File.separator);
				ZipEntry ze = new ZipEntry(file);
				ze.setLastModifiedTime(FileTime.fromMillis(f.lastModified()));
				zos.putNextEntry(ze);
				FileInputStream in = new FileInputStream(sourceFolder + File.separator + file);
				int len;
				while ((len = in.read(buffer)) > 0) {
					zos.write(buffer, 0, len);
				}
				in.close();
			}
			if(comment != null) {
				zos.setComment(comment);
			}
			zos.closeEntry();
			zos.close();
		} catch (Exception e) {}

	}



}