package it.callite.utility.intervallo;

import java.util.Date;

import it.callite.utility.ApplicationUtil;
public class Intervallo1 implements Intervallo {
	
	private static final long serialVersionUID = 1L;

	private Date fine;
	private Date inizio;
	private String periodo = "";
	private int tipo;
	private Boolean visibile = Boolean.TRUE;

	public Date getFine() {
		return ApplicationUtil.aggiustaDataT(fine, false);
	}

	public Date getInizio() {
		return ApplicationUtil.aggiustaDataT(inizio, true);
	}

	public String getPeriodo() {
		return periodo;
	}

	public int getTipo() {
		return tipo;
	}


	public Boolean getVisibile() {
		return visibile;
	}

	public void reset() {
		inizio = null;
		fine = null;
	}

	public void setFine(Date fine) {
		this.fine = ApplicationUtil.aggiustaDataT(fine, false);
	}

	public void setInizio(Date inizio) {
		this.inizio = ApplicationUtil.aggiustaDataT(inizio, true);
	}

	public void setPeriodo(String periodo) {
		this.periodo = periodo;
	}

	public void setTipo(int tipo) {
		this.tipo = tipo;
	}

	public void setVisibile(Boolean visibile) {
		this.visibile = visibile;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((fine == null) ? 0 : fine.hashCode());
		result = prime * result + ((inizio == null) ? 0 : inizio.hashCode());
		result = prime * result + ((periodo == null) ? 0 : periodo.hashCode());
		result = prime * result + tipo;
		result = prime * result + ((visibile == null) ? 0 : visibile.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		Intervallo1 other = (Intervallo1) obj;
		if (fine == null) {
			if (other.fine != null)
				return false;
		} else if (!fine.equals(other.fine))
			return false;
		if (inizio == null) {
			if (other.inizio != null)
				return false;
		} else if (!inizio.equals(other.inizio))
			return false;
		if (periodo == null) {
			if (other.periodo != null)
				return false;
		} else if (!periodo.equals(other.periodo))
			return false;
		if (tipo != other.tipo)
			return false;
		if (visibile == null) {
			if (other.visibile != null)
				return false;
		} else if (!visibile.equals(other.visibile))
			return false;
		return true;
	}


	@Override
	public String toString() {
		return ApplicationUtil.toString(this);
	}

}