package it.callite.utility.item;
import java.io.Serializable;
import java.sql.Time;
import java.util.Date;

import it.callite.model.generic.SelezionatoAbstract;
import it.callite.utility.ApplicationUtil;
public class AutodialerSI extends SelezionatoAbstract implements Serializable {

	private static final long serialVersionUID = 1L;

	private Long id;
	private String nome;
	private Integer stato;
	
	public String getDenominazione() {
		return ApplicationUtil.trimToEmpty(getNome()) + (getStatoAttiva() ? "" : "*");
	}
	
	private Long week_fine;
	private Long week_inizio;
	
	public Long getWeek_fine() {
		return week_fine;
	}
	public void setWeek_fine(Long week_fine) {
		this.week_fine = week_fine;
	}
	public Long getWeek_inizio() {
		return week_inizio;
	}
	public void setWeek_inizio(Long week_inizio) {
		this.week_inizio = week_inizio;
	}
	public Boolean getStatoAttiva() {
		return ApplicationUtil.calcolaIntervallo(getInverti(), getData_inizio(), getData_fine(), getWeek_inizio(), getWeek_fine(), getOra_inizio(), getOra_fine());
	}
	public Integer getStato() {
		return stato;
	}
	public void setStato(Integer stato) {
		this.stato = stato;
	}
	private Date data_fine;
	private Date data_inizio;
	
	public Date getData_fine() {
		return data_fine;
	}
	public void setData_fine(Date data_fine) {
		this.data_fine = data_fine;
	}
	public Date getData_inizio() {
		return data_inizio;
	}
	public void setData_inizio(Date data_inizio) {
		this.data_inizio = data_inizio;
	}
	private Time ora_fine;
	private Time ora_inizio;
	private Boolean inverti = false;
	public Time getOra_fine() {
		return ora_fine;
	}
	public void setOra_fine(Time ora_fine) {
		this.ora_fine = ora_fine;
	}
	public Time getOra_inizio() {
		return ora_inizio;
	}
	public void setOra_inizio(Time ora_inizio) {
		this.ora_inizio = ora_inizio;
	}
	public void setInverti(Boolean inverti) {
		this.inverti = inverti;
	}
	public Boolean getInverti() {
		if(inverti == null) {
			inverti = false;
		}
		return inverti;
	}
	public Long getId() {
		return id;
	}
	public String getNome() {
		return nome;
	}
	
	public void setId(Long id) {
		this.id = id;
	}
	public void setNome(String nome) {
		this.nome = nome;
	}
	
}