package it.callite.utility.item;
import java.io.Serializable;
import java.sql.Time;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import it.callite.constants.ConstantsLanguage;
import it.callite.message.Message;
import it.callite.model.generic.SelezionatoAbstract;
import it.callite.utility.ApplicationUtil;
public class ContattoSI extends SelezionatoAbstract implements Serializable {

	private static final long serialVersionUID = 1L;

	private Long id;
	private Boolean archiviato;
	private Long anagrafica_id;
	private String anagrafica_nome;
	private String anagrafica_cognome;
	private Boolean anagrafica_pf;
	private String anagrafica_nome_completo;
	private String anagrafica_ragione_sociale;
	private String anagrafica_telefono_fisso;
	private String anagrafica_telefono_mobile;
	private String anagrafica_telefono_fax;
	private String anagrafica_telefono_altro;
	private String anagrafica_email;
	private String anagrafica_link;
	private String anagrafica_codice_fiscale;
	private String anagrafica_partita_iva;
	private Long lista_id;
	private String lista_nome;
	private Integer lista_stato;
	private Date lista_data_fine;
	private Date lista_data_inizio;
	private Long lista_week_fine;
	private Long lista_week_inizio;
	private Time lista_ora_fine;
	private Time lista_ora_inizio;
	private String lista_codice;
	private Boolean lista_inverti;
	private Long campagna_id;
	private String campagna_nome;
	private Integer campagna_tipo;
	private String campagna_codice;
	private Integer campagna_stato;
	private Date campagna_data_fine;
	private Date campagna_data_inizio;
	private Long campagna_week_fine;
	private Long campagna_week_inizio;
	private Time campagna_ora_fine;
	private Time campagna_ora_inizio;
	private Boolean campagna_inverti;
	private Long esito_chiamata_id;
	private String esito_chiamata_etichetta;
	private Boolean esito_chiamata_richiamare;
	private String esito_chiamata_codice;
	private String esito_chiamata_colore;
	private Long esito_archiviazione_id;
	private String esito_archiviazione_etichetta;
	private String esito_archiviazione_codice;
	private String esito_archiviazione_colore;
	private Boolean esito_archiviazione_utile;
	
	public String getLista_codice() {
		return lista_codice;
	}
	public void setLista_codice(String lista_codice) {
		this.lista_codice = lista_codice;
	}
	public Integer getCampagna_tipo() {
		return campagna_tipo;
	}
	public void setCampagna_tipo(Integer campagna_tipo) {
		this.campagna_tipo = campagna_tipo;
	}
	public String getCampagna_codice() {
		return campagna_codice;
	}
	public void setCampagna_codice(String campagna_codice) {
		this.campagna_codice = campagna_codice;
	}
	public Boolean getEsito_archiviazione_utile() {
		return esito_archiviazione_utile;
	}
	public void setEsito_archiviazione_utile(Boolean esito_archiviazione_utile) {
		this.esito_archiviazione_utile = esito_archiviazione_utile;
	}
	public Boolean getEsito_chiamata_richiamare() {
		return esito_chiamata_richiamare;
	}
	public void setEsito_chiamata_richiamare(Boolean esito_chiamata_richiamare) {
		this.esito_chiamata_richiamare = esito_chiamata_richiamare;
	}
	public Long getLista_week_fine() {
		return lista_week_fine;
	}
	public void setLista_week_fine(Long lista_week_fine) {
		this.lista_week_fine = lista_week_fine;
	}
	public Long getLista_week_inizio() {
		return lista_week_inizio;
	}
	public void setLista_week_inizio(Long lista_week_inizio) {
		this.lista_week_inizio = lista_week_inizio;
	}
	public Long getCampagna_week_fine() {
		return campagna_week_fine;
	}
	public void setCampagna_week_fine(Long campagna_week_fine) {
		this.campagna_week_fine = campagna_week_fine;
	}
	public Long getCampagna_week_inizio() {
		return campagna_week_inizio;
	}
	public void setCampagna_week_inizio(Long campagna_week_inizio) {
		this.campagna_week_inizio = campagna_week_inizio;
	}
	public String getEsito_chiamata_codice() {
		return esito_chiamata_codice;
	}
	public void setEsito_chiamata_codice(String esito_chiamata_codice) {
		this.esito_chiamata_codice = esito_chiamata_codice;
	}
	public String getEsito_chiamata_colore() {
		return esito_chiamata_colore;
	}
	public void setEsito_chiamata_colore(String esito_chiamata_colore) {
		this.esito_chiamata_colore = esito_chiamata_colore;
	}
	public String getEsito_archiviazione_codice() {
		return esito_archiviazione_codice;
	}
	public Boolean getLista_statoAttiva() {
		return ApplicationUtil.calcolaIntervallo(getLista_inverti(), getLista_data_inizio(), getLista_data_fine(), getLista_week_inizio(), getLista_week_fine(), getLista_ora_inizio(), getLista_ora_fine());
	}
	
	public Boolean getCampagna_statoAttiva() {
		return ApplicationUtil.calcolaIntervallo(getCampagna_inverti(), getCampagna_data_inizio(), getCampagna_data_fine(), getCampagna_week_inizio(), getCampagna_week_fine(), getCampagna_ora_inizio(), getCampagna_ora_fine());
	}
	public String getEsito_archiviazione_etichettaCodice() {
		StringBuilder sb = new StringBuilder();
		sb.append(ApplicationUtil.trimToEmpty(esito_archiviazione_etichetta));
		if(ApplicationUtil.isNotBlank(esito_archiviazione_codice)) {
			sb.append(" (" + esito_archiviazione_codice + ")");
		}
		return sb.toString();
	}
	
	public String getEsito_chiamata_etichettaCodice() {
		StringBuilder sb = new StringBuilder();
		sb.append(ApplicationUtil.trimToEmpty(esito_chiamata_etichetta));
		if(ApplicationUtil.isNotBlank(esito_chiamata_codice)) {
			sb.append(" (" + esito_chiamata_codice + ")");
		}
		return sb.toString();
	}
	public void setEsito_archiviazione_codice(String esito_archiviazione_codice) {
		this.esito_archiviazione_codice = esito_archiviazione_codice;
	}
	public String getEsito_archiviazione_colore() {
		return esito_archiviazione_colore;
	}
	public void setEsito_archiviazione_colore(String esito_archiviazione_colore) {
		this.esito_archiviazione_colore = esito_archiviazione_colore;
	}
	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((anagrafica_codice_fiscale == null) ? 0 : anagrafica_codice_fiscale.hashCode());
		result = prime * result + ((anagrafica_cognome == null) ? 0 : anagrafica_cognome.hashCode());
		result = prime * result + ((anagrafica_email == null) ? 0 : anagrafica_email.hashCode());
		result = prime * result + ((anagrafica_id == null) ? 0 : anagrafica_id.hashCode());
		result = prime * result + ((anagrafica_nome == null) ? 0 : anagrafica_nome.hashCode());
		result = prime * result + ((anagrafica_nome_completo == null) ? 0 : anagrafica_nome_completo.hashCode());
		result = prime * result + ((anagrafica_link == null) ? 0 : anagrafica_link.hashCode());
		result = prime * result + ((anagrafica_partita_iva == null) ? 0 : anagrafica_partita_iva.hashCode());
		result = prime * result + ((anagrafica_pf == null) ? 0 : anagrafica_pf.hashCode());
		result = prime * result + ((anagrafica_ragione_sociale == null) ? 0 : anagrafica_ragione_sociale.hashCode());
		result = prime * result + ((anagrafica_telefono_altro == null) ? 0 : anagrafica_telefono_altro.hashCode());
		result = prime * result + ((anagrafica_telefono_fax == null) ? 0 : anagrafica_telefono_fax.hashCode());
		result = prime * result + ((anagrafica_telefono_fisso == null) ? 0 : anagrafica_telefono_fisso.hashCode());
		result = prime * result + ((anagrafica_telefono_mobile == null) ? 0 : anagrafica_telefono_mobile.hashCode());
		result = prime * result + ((archiviato == null) ? 0 : archiviato.hashCode());
		result = prime * result + ((campagna_id == null) ? 0 : campagna_id.hashCode());
		result = prime * result + ((campagna_nome == null) ? 0 : campagna_nome.hashCode());
		result = prime * result + ((campagna_stato == null) ? 0 : campagna_stato.hashCode());
		result = prime * result + ((esito_archiviazione_codice == null) ? 0 : esito_archiviazione_codice.hashCode());
		result = prime * result + ((esito_archiviazione_colore == null) ? 0 : esito_archiviazione_colore.hashCode());
		result = prime * result
				+ ((esito_archiviazione_etichetta == null) ? 0 : esito_archiviazione_etichetta.hashCode());
		result = prime * result + ((esito_archiviazione_id == null) ? 0 : esito_archiviazione_id.hashCode());
		result = prime * result + ((esito_chiamata_codice == null) ? 0 : esito_chiamata_codice.hashCode());
		result = prime * result + ((esito_chiamata_colore == null) ? 0 : esito_chiamata_colore.hashCode());
		result = prime * result + ((esito_chiamata_etichetta == null) ? 0 : esito_chiamata_etichetta.hashCode());
		result = prime * result + ((esito_chiamata_id == null) ? 0 : esito_chiamata_id.hashCode());
		result = prime * result + ((id == null) ? 0 : id.hashCode());
		result = prime * result + ((lista_id == null) ? 0 : lista_id.hashCode());
		result = prime * result + ((lista_nome == null) ? 0 : lista_nome.hashCode());
		result = prime * result + ((lista_stato == null) ? 0 : lista_stato.hashCode());
		return result;
	}
	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		ContattoSI other = (ContattoSI) obj;
		if (anagrafica_codice_fiscale == null) {
			if (other.anagrafica_codice_fiscale != null)
				return false;
		} else if (!anagrafica_codice_fiscale.equals(other.anagrafica_codice_fiscale))
			return false;
		if (anagrafica_cognome == null) {
			if (other.anagrafica_cognome != null)
				return false;
		} else if (!anagrafica_cognome.equals(other.anagrafica_cognome))
			return false;
		if (anagrafica_email == null) {
			if (other.anagrafica_email != null)
				return false;
		} else if (!anagrafica_email.equals(other.anagrafica_email))
			return false;
		if (anagrafica_id == null) {
			if (other.anagrafica_id != null)
				return false;
		} else if (!anagrafica_id.equals(other.anagrafica_id))
			return false;
		if (anagrafica_nome == null) {
			if (other.anagrafica_nome != null)
				return false;
		} else if (!anagrafica_nome.equals(other.anagrafica_nome))
			return false;
		if (anagrafica_nome_completo == null) {
			if (other.anagrafica_nome_completo != null)
				return false;
		} else if (!anagrafica_nome_completo.equals(other.anagrafica_nome_completo))
			return false;
		if (anagrafica_link == null) {
			if (other.anagrafica_link != null)
				return false;
		} else if (!anagrafica_link.equals(other.anagrafica_link))
			return false;
		if (anagrafica_partita_iva == null) {
			if (other.anagrafica_partita_iva != null)
				return false;
		} else if (!anagrafica_partita_iva.equals(other.anagrafica_partita_iva))
			return false;
		if (anagrafica_pf == null) {
			if (other.anagrafica_pf != null)
				return false;
		} else if (!anagrafica_pf.equals(other.anagrafica_pf))
			return false;
		if (anagrafica_ragione_sociale == null) {
			if (other.anagrafica_ragione_sociale != null)
				return false;
		} else if (!anagrafica_ragione_sociale.equals(other.anagrafica_ragione_sociale))
			return false;
		if (anagrafica_telefono_altro == null) {
			if (other.anagrafica_telefono_altro != null)
				return false;
		} else if (!anagrafica_telefono_altro.equals(other.anagrafica_telefono_altro))
			return false;
		if (anagrafica_telefono_fax == null) {
			if (other.anagrafica_telefono_fax != null)
				return false;
		} else if (!anagrafica_telefono_fax.equals(other.anagrafica_telefono_fax))
			return false;
		if (anagrafica_telefono_fisso == null) {
			if (other.anagrafica_telefono_fisso != null)
				return false;
		} else if (!anagrafica_telefono_fisso.equals(other.anagrafica_telefono_fisso))
			return false;
		if (anagrafica_telefono_mobile == null) {
			if (other.anagrafica_telefono_mobile != null)
				return false;
		} else if (!anagrafica_telefono_mobile.equals(other.anagrafica_telefono_mobile))
			return false;
		if (archiviato == null) {
			if (other.archiviato != null)
				return false;
		} else if (!archiviato.equals(other.archiviato))
			return false;
		if (campagna_id == null) {
			if (other.campagna_id != null)
				return false;
		} else if (!campagna_id.equals(other.campagna_id))
			return false;
		if (campagna_nome == null) {
			if (other.campagna_nome != null)
				return false;
		} else if (!campagna_nome.equals(other.campagna_nome))
			return false;
		if (campagna_stato == null) {
			if (other.campagna_stato != null)
				return false;
		} else if (!campagna_stato.equals(other.campagna_stato))
			return false;
		if (esito_archiviazione_codice == null) {
			if (other.esito_archiviazione_codice != null)
				return false;
		} else if (!esito_archiviazione_codice.equals(other.esito_archiviazione_codice))
			return false;
		if (esito_archiviazione_colore == null) {
			if (other.esito_archiviazione_colore != null)
				return false;
		} else if (!esito_archiviazione_colore.equals(other.esito_archiviazione_colore))
			return false;
		if (esito_archiviazione_etichetta == null) {
			if (other.esito_archiviazione_etichetta != null)
				return false;
		} else if (!esito_archiviazione_etichetta.equals(other.esito_archiviazione_etichetta))
			return false;
		if (esito_archiviazione_id == null) {
			if (other.esito_archiviazione_id != null)
				return false;
		} else if (!esito_archiviazione_id.equals(other.esito_archiviazione_id))
			return false;
		if (esito_chiamata_codice == null) {
			if (other.esito_chiamata_codice != null)
				return false;
		} else if (!esito_chiamata_codice.equals(other.esito_chiamata_codice))
			return false;
		if (esito_chiamata_colore == null) {
			if (other.esito_chiamata_colore != null)
				return false;
		} else if (!esito_chiamata_colore.equals(other.esito_chiamata_colore))
			return false;
		if (esito_chiamata_etichetta == null) {
			if (other.esito_chiamata_etichetta != null)
				return false;
		} else if (!esito_chiamata_etichetta.equals(other.esito_chiamata_etichetta))
			return false;
		if (esito_chiamata_id == null) {
			if (other.esito_chiamata_id != null)
				return false;
		} else if (!esito_chiamata_id.equals(other.esito_chiamata_id))
			return false;
		if (id == null) {
			if (other.id != null)
				return false;
		} else if (!id.equals(other.id))
			return false;
		if (lista_id == null) {
			if (other.lista_id != null)
				return false;
		} else if (!lista_id.equals(other.lista_id))
			return false;
		if (lista_nome == null) {
			if (other.lista_nome != null)
				return false;
		} else if (!lista_nome.equals(other.lista_nome))
			return false;
		if (lista_stato == null) {
			if (other.lista_stato != null)
				return false;
		} else if (!lista_stato.equals(other.lista_stato))
			return false;
		return true;
	}
	public Long getId() {
		return id;
	}
	public void setId(Long id) {
		this.id = id;
	}
	public Boolean getArchiviato() {
		return archiviato;
	}
	public void setArchiviato(Boolean archiviato) {
		this.archiviato = archiviato;
	}
	public Long getAnagrafica_id() {
		return anagrafica_id;
	}
	public void setAnagrafica_id(Long anagrafica_id) {
		this.anagrafica_id = anagrafica_id;
	}
	public String getAnagrafica_nome() {
		return anagrafica_nome;
	}
	public void setAnagrafica_nome(String anagrafica_nome) {
		this.anagrafica_nome = anagrafica_nome;
	}
	public String getAnagrafica_cognome() {
		return anagrafica_cognome;
	}
	public void setAnagrafica_cognome(String anagrafica_cognome) {
		this.anagrafica_cognome = anagrafica_cognome;
	}
	public Boolean getAnagrafica_pf() {
		return anagrafica_pf;
	}
	public void setAnagrafica_pf(Boolean anagrafica_pf) {
		this.anagrafica_pf = anagrafica_pf;
	}
	public String getAnagrafica_nome_completo() {
		return anagrafica_nome_completo;
	}
	public void setAnagrafica_nome_completo(String anagrafica_nome_completo) {
		this.anagrafica_nome_completo = anagrafica_nome_completo;
	}
	public String getAnagrafica_ragione_sociale() {
		return anagrafica_ragione_sociale;
	}
	public void setAnagrafica_ragione_sociale(String anagrafica_ragione_sociale) {
		this.anagrafica_ragione_sociale = anagrafica_ragione_sociale;
	}
	public String getAnagrafica_telefono_fisso() {
		return anagrafica_telefono_fisso;
	}
	public void setAnagrafica_telefono_fisso(String anagrafica_telefono_fisso) {
		this.anagrafica_telefono_fisso = anagrafica_telefono_fisso;
	}
	public String getAnagrafica_telefono_mobile() {
		return anagrafica_telefono_mobile;
	}
	public void setAnagrafica_telefono_mobile(String anagrafica_telefono_mobile) {
		this.anagrafica_telefono_mobile = anagrafica_telefono_mobile;
	}
	public String getAnagrafica_telefono_fax() {
		return anagrafica_telefono_fax;
	}
	public void setAnagrafica_telefono_fax(String anagrafica_telefono_fax) {
		this.anagrafica_telefono_fax = anagrafica_telefono_fax;
	}
	public String getAnagrafica_telefono_altro() {
		return anagrafica_telefono_altro;
	}
	public void setAnagrafica_telefono_altro(String anagrafica_telefono_altro) {
		this.anagrafica_telefono_altro = anagrafica_telefono_altro;
	}
	public String getAnagrafica_email() {
		return anagrafica_email;
	}
	public void setAnagrafica_email(String anagrafica_email) {
		this.anagrafica_email = anagrafica_email;
	}
	public Long getLista_id() {
		return lista_id;
	}
	public void setLista_id(Long lista_id) {
		this.lista_id = lista_id;
	}
	public String getLista_nome() {
		return lista_nome;
	}
	public void setLista_nome(String lista_nome) {
		this.lista_nome = lista_nome;
	}
	public Integer getLista_stato() {
		return lista_stato;
	}
	public void setLista_stato(Integer lista_stato) {
		this.lista_stato = lista_stato;
	}
	public Long getCampagna_id() {
		return campagna_id;
	}
	public void setCampagna_id(Long campagna_id) {
		this.campagna_id = campagna_id;
	}
	public String getCampagna_nome() {
		return campagna_nome;
	}
	public void setCampagna_nome(String campagna_nome) {
		this.campagna_nome = campagna_nome;
	}
	public Integer getCampagna_stato() {
		return campagna_stato;
	}
	public void setCampagna_stato(Integer campagna_stato) {
		this.campagna_stato = campagna_stato;
	}
	public Long getEsito_chiamata_id() {
		return esito_chiamata_id;
	}
	public void setEsito_chiamata_id(Long esito_chiamata_id) {
		this.esito_chiamata_id = esito_chiamata_id;
	}
	public String getEsito_chiamata_etichetta() {
		return esito_chiamata_etichetta;
	}
	public void setEsito_chiamata_etichetta(String esito_chiamata_etichetta) {
		this.esito_chiamata_etichetta = esito_chiamata_etichetta;
	}
	public Long getEsito_archiviazione_id() {
		return esito_archiviazione_id;
	}
	public void setEsito_archiviazione_id(Long esito_archiviazione_id) {
		this.esito_archiviazione_id = esito_archiviazione_id;
	}
	public String getEsito_archiviazione_etichetta() {
		return esito_archiviazione_etichetta;
	}
	public void setEsito_archiviazione_etichetta(
			String esito_archiviazione_etichetta) {
		this.esito_archiviazione_etichetta = esito_archiviazione_etichetta;
	}
	public String getCampagna_denominazione() {
		return ApplicationUtil.trimToEmpty(campagna_nome) + " (" + getCampagnaDescrizioneStato() +(getCampagna_statoAttiva() ? "" : "*") + ")";
	}
	
	
	public String getCampagnaDescrizioneStato() {
		return Message.addCatalogText("ts_stato." + campagna_stato);
	}
	
	
	
	public String getLista_denominazione() {
		return ApplicationUtil.trimToEmpty(lista_nome) + " (" + getListaDescrizioneStato() +(getLista_statoAttiva() ? "" : "*") + ")";
	}
	
	
	public String getListaDescrizioneStato() {
		return Message.addCatalogText("ts_stato." + lista_stato);
	}
	
	public String getAnagrafica_denominazione() {
		return ApplicationUtil.denominazione(anagrafica_pf, anagrafica_nome_completo, anagrafica_ragione_sociale, anagrafica_cognome, anagrafica_nome, null);
	}
	public String getAnagrafica_codice_fiscale() {
		return anagrafica_codice_fiscale;
	}
	public void setAnagrafica_codice_fiscale(String anagrafica_codice_fiscale) {
		this.anagrafica_codice_fiscale = anagrafica_codice_fiscale;
	}
	public String getAnagrafica_partita_iva() {
		return anagrafica_partita_iva;
	}
	public void setAnagrafica_partita_iva(String anagrafica_partita_iva) {
		this.anagrafica_partita_iva = anagrafica_partita_iva;
	}
	
	public String getAnagrafica_link() {
		return anagrafica_link;
	}
	public void setAnagrafica_link(String anagrafica_link) {
		this.anagrafica_link = anagrafica_link;
	}
	public void setDuplicati(List<ContattoSI> duplicati) {
		this.duplicati = duplicati;
	}
	public String getAnagrafica_identificativo() {
		return anagrafica_id != null ? anagrafica_id.toString() : null;
	}
	
	public List<ContattoSI> getDuplicati() {
		return duplicati;
	}	
	
	private List<ContattoSI> duplicati = new ArrayList<ContattoSI>();
	
	public String getChiuso() {
		if(ApplicationUtil.isTrue(getArchiviato()))
			return ConstantsLanguage.SI.stampa();
		else
			return ConstantsLanguage.NO.stampa();
	}
	public Date getLista_data_fine() {
		return lista_data_fine;
	}
	public void setLista_data_fine(Date lista_data_fine) {
		this.lista_data_fine = lista_data_fine;
	}
	public Date getLista_data_inizio() {
		return lista_data_inizio;
	}
	public void setLista_data_inizio(Date lista_data_inizio) {
		this.lista_data_inizio = lista_data_inizio;
	}
	public Time getLista_ora_fine() {
		return lista_ora_fine;
	}
	public void setLista_ora_fine(Time lista_ora_fine) {
		this.lista_ora_fine = lista_ora_fine;
	}
	public Time getLista_ora_inizio() {
		return lista_ora_inizio;
	}
	public void setLista_ora_inizio(Time lista_ora_inizio) {
		this.lista_ora_inizio = lista_ora_inizio;
	}
	public Boolean getLista_inverti() {
		if(lista_inverti == null) {
			lista_inverti = false;
		}
		return lista_inverti;
	}
	public void setLista_inverti(Boolean lista_inverti) {
		this.lista_inverti = lista_inverti;
	}
	public Date getCampagna_data_fine() {
		return campagna_data_fine;
	}
	public void setCampagna_data_fine(Date campagna_data_fine) {
		this.campagna_data_fine = campagna_data_fine;
	}
	public Date getCampagna_data_inizio() {
		return campagna_data_inizio;
	}
	public void setCampagna_data_inizio(Date campagna_data_inizio) {
		this.campagna_data_inizio = campagna_data_inizio;
	}
	public Time getCampagna_ora_fine() {
		return campagna_ora_fine;
	}
	public void setCampagna_ora_fine(Time campagna_ora_fine) {
		this.campagna_ora_fine = campagna_ora_fine;
	}
	public Time getCampagna_ora_inizio() {
		return campagna_ora_inizio;
	}
	public void setCampagna_ora_inizio(Time campagna_ora_inizio) {
		this.campagna_ora_inizio = campagna_ora_inizio;
	}
	public Boolean getCampagna_inverti() {
		if(campagna_inverti == null) {
			campagna_inverti = false;
		}
		return campagna_inverti;
	}
	public void setCampagna_inverti(Boolean campagna_inverti) {
		this.campagna_inverti = campagna_inverti;
	}
	
}