package it.callite.utility.item;
import java.io.File;
import java.io.Serializable;
import java.util.Date;
import java.util.List;

import it.callite.model.generic.SelezionatoAbstract;
import it.callite.utility.ApplicationUtil;
public class FileSI extends SelezionatoAbstract implements Serializable {

	private static final long serialVersionUID = 1L;

	
	private String color;
	private String path;
	private boolean eliminabile;
	private boolean esecuzione;
	private boolean hidden;
	private boolean lettura;
	private Date modificato;
	private List<FileSI> nodes;
	private String nome;
	private boolean scrittura;
	private long size;
	private boolean type;
	private boolean scaricabile;
	private boolean esistente;
	private int nfile;
	private boolean vuoto;
	public FileSI(File f, boolean eliminabile, String color) {
		inizializza(f, eliminabile, color);
	}
	
	public FileSI(String path, boolean eliminabile, String color) {
		File f = new File(path);
		inizializza(f, eliminabile, color);
	}
	
	public void inizializza(File f, boolean eliminabile, String color) {
		this.eliminabile = eliminabile;
		this.color = color;
		this.nome = f.getName();
		this.path = f.getAbsolutePath();
		this.size = ApplicationUtil.fileSize(f);
		this.esistente = f.exists();
		this.modificato = ApplicationUtil.date(f.lastModified());
		this.type = !f.isDirectory();
		this.hidden = f.isHidden();
		this.nfile = ApplicationUtil.size(f.list());
		this.esecuzione = f.canExecute();
		this.lettura = f.canRead();
		this.scrittura = f.canWrite();
		this.scaricabile = esistente && (nfile > 0 || type);
		this.vuoto = (nfile <= 0);
	}
	
	public String getColor() {
		return color;
	}
	
	public boolean isEsistente() {
		return esistente;
	}
	public void setEsistente(boolean esistente) {
		this.esistente = esistente;
	}
	public Date getModificato() {
		return modificato;
	}
	public List<FileSI> getNodes() {
		return nodes;
	}
	public String getNome() {
		return nome;
	}
	public long getSize() {
		return size;
	}
	public boolean isEliminabile() {
		return eliminabile;
	}
	public boolean isEsecuzione() {
		return esecuzione;
	}
	
	public boolean isHidden() {
		return hidden;
	}
	public boolean isLettura() {
		return lettura;
	}
	public boolean isScrittura() {
		return scrittura;
	}
	public boolean isType() {
		return type;
	}
	public void setColor(String color) {
		this.color = color;
	}
	public void setEliminabile(boolean eliminabile) {
		this.eliminabile = eliminabile;
	}
	public void setEsecuzione(boolean esecuzione) {
		this.esecuzione = esecuzione;
	}
	public void setHidden(boolean hidden) {
		this.hidden = hidden;
	}
	public void setLettura(boolean lettura) {
		this.lettura = lettura;
	}
	public void setModificato(Date modificato) {
		this.modificato = modificato;
	}
	public void setNodes(List<FileSI> nodes) {
		this.nodes = nodes;
	}
	public void setNome(String nome) {
		this.nome = nome;
	}
	public void setScrittura(boolean scrittura) {
		this.scrittura = scrittura;
	}
	public void setSize(long size) {
		this.size = size;
	}
	public void setType(boolean type) {
		this.type = type;
	}
	public int getNfile() {
		return nfile;
	}
	public void setNfile(int nfile) {
		this.nfile = nfile;
	}
	public boolean isScaricabile() {
		return scaricabile;
	}
	public void setScaricabile(boolean scaricabile) {
		this.scaricabile = scaricabile;
	}
	public boolean isVuoto() {
		return vuoto;
	}
	public void setVuoto(boolean vuoto) {
		this.vuoto = vuoto;
	}
	public String getPath() {
		return path;
	}
	public void setPath(String path) {
		this.path = path;
	}
	
}