package it.callite.utility.item;
import java.io.Serializable;

import it.callite.constants.ConstantsGlobal;
import it.callite.model.generic.SelezionatoAbstract;
import it.callite.model.sip.SipBuddies;
import it.callite.utility.ApplicationUtil;
import it.callite.utility.ParameterTrunk;
public class TrunkSI extends SelezionatoAbstract implements Serializable {

	private static final long serialVersionUID = 1L;
	
	private String add_prefisso;
	private String antecall;
	private String callers;
	private String musicclass;
	private String interurbane;
	private String attivo;
	private String name;
	private String opposizione;
	private String registrazione;
	private Integer vrx;
	private Integer vtx;
	private Long id;
	
	public ParameterTrunk getParameter() {
		SipBuddies trunk = new SipBuddies(id, add_prefisso, antecall, callers, musicclass, interurbane, attivo, name, opposizione, registrazione, vrx, vtx);
		return new ParameterTrunk(trunk);
	}
	public String getAdd_prefisso() {
		return add_prefisso;
	}
	public void setAdd_prefisso(String add_prefisso) {
		this.add_prefisso = add_prefisso;
	}
	public String getCallers() {
		return callers;
	}
	public void setCallers(String callers) {
		this.callers = callers;
	}
	public String getMusicclass() {
		return musicclass;
	}
	public void setMusicclass(String musicclass) {
		this.musicclass = musicclass;
	}
	public String getInterurbane() {
		return interurbane;
	}
	public void setInterurbane(String interurbane) {
		this.interurbane = interurbane;
	}
	public String getName() {
		return name;
	}
	public void setName(String name) {
		this.name = name;
	}
	public String getOpposizione() {
		return opposizione;
	}
	public String getRegistrazione() {
		return registrazione;
	}
	public void setRegistrazione(String registrazione) {
		this.registrazione = registrazione;
	}
	public void setOpposizione(String opposizione) {
		this.opposizione = opposizione;
	}
	public Integer getVrx() {
		return vrx;
	}
	public void setVrx(Integer vrx) {
		this.vrx = vrx;
	}
	public Integer getVtx() {
		return vtx;
	}
	public void setVtx(Integer vtx) {
		this.vtx = vtx;
	}
	public Long getId() {
		return id;
	}
	public void setId(Long id) {
		this.id = id;
	}
	public String getAntecall() {
		return antecall;
	}
	public void setAntecall(String antecall) {
		this.antecall = antecall;
	}
	
	public String getAttivo() {
		return attivo;
	}
	public void setAttivo(String attivo) {
		this.attivo = attivo;
	}
	public String getTrunkContext() {
		StringBuilder sb = new StringBuilder();
		sb.append(ApplicationUtil.toString(id, getName()));
		boolean b1 = ApplicationUtil.convertSB(getInterurbane());
		boolean b2 = ApplicationUtil.convertSB(getOpposizione());
		if(b1 || b2) {
			sb.append(ConstantsGlobal.pipeSeparator);
		}
		if(b1) {
			sb.append("i");
		}
		if(b2) {
			sb.append("o");
		}
		return sb.toString();
	}

}