package it.callite.utility.massivo;
import java.io.Serializable;
import java.util.HashMap;
import java.util.Map;
import it.callite.model.Agente;
import it.callite.model.Qualifica;
import it.callite.model.Ufficio;
import it.callite.utility.ApplicationUtil;
@SuppressWarnings("serial")
public class AgenteMassivo  implements Serializable {
	private Map<String, Valore> map = new HashMap<String, Valore>();
	public AgenteMassivo() {
		set("ufficio");
		set("qualifica");
		set("autonomo");
		set("visualizzaStoria");
	}
	
	public Valore set(String chiave) {
		return map.put(chiave, new Valore());
	}
	public Valore get(String chiave) {
		return map.get(chiave);
	}
	public Map<String, Valore> getMap() {
		return map;
	}
	
	public void modifica(Agente agente, Qualifica qualifica, Ufficio ufficio) {
		if(ApplicationUtil.isTrue(map.get("autonomo").getLogico())) {
			agente.setAutonomo(map.get("autonomo").getBooleano());
		}
		if(ApplicationUtil.isTrue(map.get("visualizzaStoria").getLogico())) {
			agente.setVisualizzaStoria(map.get("visualizzaStoria").getBooleano());
		}
		if(ApplicationUtil.isTrue(map.get("qualifica").getLogico())) {
			agente.setQualifica(qualifica);
		}
		if(ApplicationUtil.isTrue(map.get("ufficio").getLogico())) {
			agente.setUfficio(ufficio);
		}
	}
	
}