package it.callite.utility.massivo;
import java.io.Serializable;
import java.util.HashMap;
import java.util.Map;
import it.callite.model.Anagrafica;
import it.callite.utility.ApplicationUtil;
@SuppressWarnings("serial")
public class AnagraficaMassivo  implements Serializable {
	private Map<String, Valore> map = new HashMap<String, Valore>();
	public AnagraficaMassivo() {
		
		set("consenso_tfisso");
		set("consenso_tmobile");
		set("consenso_tfax");
		set("consenso_taltro");
		set("consenso_email");
		set("consenso_rmail");
	}
	
	public Valore set(String chiave) {
		return map.put(chiave, new Valore());
	}
	public Valore get(String chiave) {
		return map.get(chiave);
	}
	public Map<String, Valore> getMap() {
		return map;
	}
	
	public void modifica(Anagrafica anagrafica) {
		if(ApplicationUtil.isTrue(map.get("consenso_tfisso").getLogico())) {
			anagrafica.setConsenso_tfisso(map.get("consenso_tfisso").getData());
		}
		if(ApplicationUtil.isTrue(map.get("consenso_tmobile").getLogico())) {
			anagrafica.setConsenso_tmobile(map.get("consenso_tmobile").getData());
		}
		if(ApplicationUtil.isTrue(map.get("consenso_tfax").getLogico())) {
			anagrafica.setConsenso_tfax(map.get("consenso_tfax").getData());
		}
		if(ApplicationUtil.isTrue(map.get("consenso_taltro").getLogico())) {
			anagrafica.setConsenso_taltro(map.get("consenso_taltro").getData());
		}
		
		if(ApplicationUtil.isTrue(map.get("consenso_email").getLogico())) {
			anagrafica.setConsenso_email(map.get("consenso_email").getData());
		}
		
		if(ApplicationUtil.isTrue(map.get("consenso_rmail").getLogico())) {
			anagrafica.setConsenso_rmail(map.get("consenso_rmail").getData());
		}
		
	}
	
}