package it.callite.utility.massivo;
import java.io.Serializable;
import java.util.HashMap;
import java.util.Map;
import it.callite.model.Autodialer;
import it.callite.model.Campagna;
import it.callite.model.EsitoChiamata;
import it.callite.utility.ApplicationUtil;
@SuppressWarnings("serial")
public class CampagnaMassivo implements Serializable {
	private Map<String, Valore> map = new HashMap<String, Valore>();
	public CampagnaMassivo() {
		set("autodialer");
		set("tipo");
		set("inverti");
		set("data_fine");
		set("data_inizio");
		set("week_fine");
		set("week_inizio");
		set("ora_fine");
		set("ora_inizio");
		set("callers");
		set("musicclass");
		set("inbound");
		set("ritardoT");
		set("rem_prefisso");
		set("add_prefisso");
		set("append_prefisso");
		set("consenso_telefono");
		set("stato");
		set("priorita");
		set("codice");
		set("registrazione_remota");
		set("registrazione_locale");
		set("invio_email");
		set("invio_rmail");
		set("invio_telecom");
		set("riepilogo_calendario");
		set("riepilogo_appuntamenti");
		set("riepilogo_contratti");
		set("riepilogo_registrazioni");
		set("prenotabile_esterno");
		set("prenotabile_interno");
		set("avvio_automatico");
		set("powerdialer");
		set("seleziona_liste");
		set("inserisci_dati");
		set("modifica_dati");
		set("scheda_dati");
		set("tasto_chiudi");
		set("tasto_indietro");
		set("riprogramma_privato");
		set("riprogramma_pubblico");
		set("riprogramma_team");
		set("riprogramma_esito");
		set("agente_notizia");
		set("agente_messaggio");
		set("proprietario_notizia");
		set("proprietario_messaggio");
		set("email_notifica");
		set("estrazione_lista");
		set("ordine");
		set("modalita_scelta");
		set("agenti_scelta");
		set("telefono");
		set("proprieta");
		set("limite");
		set("query_proprieta");
		set("query_valore");
		set("tempo");
		set("ferma_timer");
		set("esito");
	}
	public Valore set(String chiave) {
		return map.put(chiave, new Valore());
	}
	public Valore get(String chiave) {
		return map.get(chiave);
	}
	public Map<String, Valore> getMap() {
		return map;
	}
	public void modifica(Campagna campagna, Autodialer autodialer, EsitoChiamata esito) {
		if(ApplicationUtil.isTrue(map.get("esito").getLogico())) {
			campagna.setEsito(esito);
		}
		if(ApplicationUtil.isTrue(map.get("tempo").getLogico())) {
			campagna.setTempo(map.get("tempo").getIntero());
		}
		if(ApplicationUtil.isTrue(map.get("ferma_timer").getLogico())) {
			campagna.setFerma_timer(map.get("ferma_timer").getBooleano());
		}
		if(ApplicationUtil.isTrue(map.get("autodialer").getLogico())) {
			campagna.setAutodialer(autodialer);
		}
		if(ApplicationUtil.isTrue(map.get("data_fine").getLogico())) {
			campagna.setData_fine(map.get("data_fine").getData());
		}
		if(ApplicationUtil.isTrue(map.get("data_inizio").getLogico())) {
			campagna.setData_inizio(map.get("data_inizio").getData());
		}

		if(ApplicationUtil.isTrue(map.get("week_fine").getLogico())) {
			campagna.setWeek_fine(map.get("week_fine").getLungo());
		}
		if(ApplicationUtil.isTrue(map.get("week_inizio").getLogico())) {
			campagna.setWeek_inizio(map.get("week_inizio").getLungo());
		}
		if(ApplicationUtil.isTrue(map.get("inverti").getLogico())) {
			campagna.setInverti(map.get("inverti").getBooleano());
		}
		if(ApplicationUtil.isTrue(map.get("ora_fine").getLogico())) {
			campagna.setOra_fine(map.get("ora_fine").getData());
		}
		if(ApplicationUtil.isTrue(map.get("ora_inizio").getLogico())) {
			campagna.setOra_inizio(map.get("ora_inizio").getData());
		}
		if(ApplicationUtil.isTrue(map.get("callers").getLogico())) {
			campagna.setCallers(map.get("callers").getStringa());
		}
		if(ApplicationUtil.isTrue(map.get("musicclass").getLogico())) {
			campagna.setMusicclass(map.get("musicclass").getStringa());
		}
		if(ApplicationUtil.isTrue(map.get("inbound").getLogico())) {
			campagna.setInbound(map.get("inbound").getStringa());
		}
		if(ApplicationUtil.isTrue(map.get("ritardoT").getLogico())) {
			campagna.setRitardoT(map.get("ritardoT").getBooleano());
		}
		if(ApplicationUtil.isTrue(map.get("rem_prefisso").getLogico())) {
			campagna.setRem_prefisso(map.get("rem_prefisso").getStringa());
		}
		if(ApplicationUtil.isTrue(map.get("add_prefisso").getLogico())) {
			campagna.setAdd_prefisso(map.get("add_prefisso").getStringa());
		}
		if(ApplicationUtil.isTrue(map.get("append_prefisso").getLogico())) {
			campagna.setAppend_prefisso(map.get("append_prefisso").getStringa());
		}
		if(ApplicationUtil.isTrue(map.get("consenso_telefono").getLogico())) {
			campagna.setConsenso_telefono(map.get("consenso_telefono").getBooleano());
		}
		if(ApplicationUtil.isTrue(map.get("stato").getLogico())) {
			campagna.setStato(map.get("stato").getIntero());
		}
		if(ApplicationUtil.isTrue(map.get("priorita").getLogico())) {
			campagna.setPriorita(map.get("priorita").getIntero());
		}
		if(ApplicationUtil.isTrue(map.get("codice").getLogico())) {
			campagna.setCodice(map.get("codice").getStringa());
		}
		if(ApplicationUtil.isTrue(map.get("registrazione_remota").getLogico())) {
			campagna.setRegistrazione_remota(map.get("registrazione_remota").getIntero());
		}
		if(ApplicationUtil.isTrue(map.get("registrazione_locale").getLogico())) {
			campagna.setRegistrazione_locale(map.get("registrazione_locale").getIntero());
		}
		if(ApplicationUtil.isTrue(map.get("ordine").getLogico())) {
			campagna.setOrdine(map.get("ordine").getStringa());
		}
		if(ApplicationUtil.isTrue(map.get("invio_email").getLogico())) {
			campagna.setInvio_email(map.get("invio_email").getBooleano());
		}
		
		if(ApplicationUtil.isTrue(map.get("invio_rmail").getLogico())) {
			campagna.setInvio_rmail(map.get("invio_rmail").getBooleano());
		}
		
		if(ApplicationUtil.isTrue(map.get("invio_telecom").getLogico())) {
			campagna.setInvio_telecom(map.get("invio_telecom").getBooleano());
		}
		if(ApplicationUtil.isTrue(map.get("riepilogo_calendario").getLogico())) {
			campagna.setRiepilogo_calendario(map.get("riepilogo_calendario").getBooleano());
		}
		if(ApplicationUtil.isTrue(map.get("riepilogo_appuntamenti").getLogico())) {
			campagna.setRiepilogo_appuntamenti(map.get("riepilogo_appuntamenti").getBooleano());
		}
		if(ApplicationUtil.isTrue(map.get("riepilogo_contratti").getLogico())) {
			campagna.setRiepilogo_contratti(map.get("riepilogo_contratti").getBooleano());
		}
		if(ApplicationUtil.isTrue(map.get("riepilogo_registrazioni").getLogico())) {
			campagna.setRiepilogo_registrazioni(map.get("riepilogo_registrazioni").getBooleano());
		}
		if(ApplicationUtil.isTrue(map.get("prenotabile_esterno").getLogico())) {
			campagna.setPrenotabile_esterno(map.get("prenotabile_esterno").getBooleano());
		}
		if(ApplicationUtil.isTrue(map.get("prenotabile_interno").getLogico())) {
			campagna.setPrenotabile_interno(map.get("prenotabile_interno").getBooleano());
		}
		if(ApplicationUtil.isTrue(map.get("avvio_automatico").getLogico())) {
			campagna.setAvvio_automatico(map.get("avvio_automatico").getIntero());
		}
		if(ApplicationUtil.isTrue(map.get("powerdialer").getLogico())) {
			campagna.setPowerdialer(map.get("powerdialer").getBooleano());
		}
		if(ApplicationUtil.isTrue(map.get("seleziona_liste").getLogico())) {
			campagna.setSeleziona_liste(map.get("seleziona_liste").getBooleano());
		}
		if(ApplicationUtil.isTrue(map.get("inserisci_dati").getLogico())) {
			campagna.setInserisci_dati(map.get("inserisci_dati").getBooleano());
		}
		if(ApplicationUtil.isTrue(map.get("modifica_dati").getLogico())) {
			campagna.setModifica_dati(map.get("modifica_dati").getBooleano());
		}
		if(ApplicationUtil.isTrue(map.get("scheda_dati").getLogico())) {
			campagna.setScheda_dati(map.get("scheda_dati").getBooleano());
		}
		if(ApplicationUtil.isTrue(map.get("tasto_chiudi").getLogico())) {
			campagna.setTasto_chiudi(map.get("tasto_chiudi").getIntero());
		}
		if(ApplicationUtil.isTrue(map.get("tasto_indietro").getLogico())) {
			campagna.setTasto_indietro(map.get("tasto_indietro").getIntero());
		}
		if(ApplicationUtil.isTrue(map.get("riprogramma_privato").getLogico())) {
			campagna.setRiprogramma_privato(map.get("riprogramma_privato").getBooleano());
		}
		if(ApplicationUtil.isTrue(map.get("riprogramma_pubblico").getLogico())) {
			campagna.setRiprogramma_pubblico(map.get("riprogramma_pubblico").getBooleano());
		}
		if(ApplicationUtil.isTrue(map.get("riprogramma_team").getLogico())) {
			campagna.setRiprogramma_team(map.get("riprogramma_team").getBooleano());
		}
		if(ApplicationUtil.isTrue(map.get("riprogramma_esito").getLogico())) {
			campagna.setRiprogramma_esito(map.get("riprogramma_esito").getBooleano());
		}
		if(ApplicationUtil.isTrue(map.get("agente_notizia").getLogico())) {
			campagna.setAgente_notizia(map.get("agente_notizia").getBooleano());
		}
		if(ApplicationUtil.isTrue(map.get("agente_messaggio").getLogico())) {
			campagna.setAgente_messaggio(map.get("agente_messaggio").getBooleano());
		}
		if(ApplicationUtil.isTrue(map.get("proprietario_notizia").getLogico())) {
			campagna.setProprietario_notizia(map.get("proprietario_notizia").getBooleano());
		}
		if(ApplicationUtil.isTrue(map.get("proprietario_messaggio").getLogico())) {
			campagna.setProprietario_messaggio(map.get("proprietario_messaggio").getBooleano());
		}
		if(ApplicationUtil.isTrue(map.get("email_notifica").getLogico())) {
			campagna.setEmail_notifica(map.get("email_notifica").getBooleano());
		}
		if(ApplicationUtil.isTrue(map.get("estrazione_lista").getLogico())) {
			campagna.setEstrazione_lista(map.get("estrazione_lista").getIntero());
		}
		if(ApplicationUtil.isTrue(map.get("tipo").getLogico())) {
			campagna.setTipo(map.get("tipo").getIntero());
		}
		if(ApplicationUtil.isTrue(map.get("modalita_scelta").getLogico())) {
			campagna.setModalita_scelta(map.get("modalita_scelta").getIntero());
		}
		if(ApplicationUtil.isTrue(map.get("agenti_scelta").getLogico())) {
			campagna.setAgenti_scelta(map.get("agenti_scelta").getIntero());
		}
		if(ApplicationUtil.isTrue(map.get("telefono").getLogico())) {
			campagna.setTelefono(map.get("telefono").getCorto());
		}

		if(ApplicationUtil.isTrue(map.get("proprieta").getLogico())) {
			campagna.setProprieta(map.get("proprieta").getStringa());
		}
		if(ApplicationUtil.isTrue(map.get("limite").getLogico())) {
			campagna.setLimite(map.get("limite").getIntero());
		}

		if(ApplicationUtil.isTrue(map.get("query_proprieta").getLogico())) {
			campagna.setQuery_proprieta(map.get("query_proprieta").getStringa());
		}
		if(ApplicationUtil.isTrue(map.get("query_valore").getLogico())) {
			campagna.setQuery_valore(map.get("query_valore").getStringa());
		}
	}
}