package it.callite.utility.massivo;

import java.io.Serializable;
import java.util.HashMap;
import java.util.Map;

import it.callite.model.sip.Coda;
import it.callite.utility.ApplicationUtil;



@SuppressWarnings("serial")
public class CodaMassivo implements Serializable{


	private Map<String, Valore> map = new HashMap<String, Valore>();

	public CodaMassivo() {
		set("musiconhold");
		set("strategy");
		set("timeout");
		set("retry");
		set("announce");
		set("announce_frequency");
		set("announce_round_seconds");
		set("announce_holdtime");
		set("queue_youarenext");
		set("queue_thereare");
		set("queue_callswaiting");
		set("queue_holdtime");
		set("queue_minutes");
		set("queue_seconds");
		set("queue_lessthan");
		set("queue_thankyou");
		set("queue_reporthold");
		set("periodic_announce");
		set("periodic_announce_frequency");
	}

	public Valore set(String chiave) {
		return map.put(chiave, new Valore());
	}
	public Valore get(String chiave) {
		return map.get(chiave);
	}

	public Map<String, Valore> getMap() {
		return map;
	}

	public void modifica(Coda sp) {
		if(ApplicationUtil.isTrue(map.get("musiconhold").getLogico())) {
			sp.setMusiconhold(map.get("musiconhold").getStringa());
		}
		if(ApplicationUtil.isTrue(map.get("strategy").getLogico())) {
			sp.setStrategy(map.get("strategy").getStringa());
		}
		if(ApplicationUtil.isTrue(map.get("timeout").getLogico())) {
			sp.setTimeout(map.get("timeout").getIntero());
		}
		if(ApplicationUtil.isTrue(map.get("retry").getLogico())) {
			sp.setRetry(map.get("retry").getIntero());
		}
		if(ApplicationUtil.isTrue(map.get("announce").getLogico())) {
			sp.setAnnounce(map.get("announce").getStringa());
		}
		if(ApplicationUtil.isTrue(map.get("announce_frequency").getLogico())) {
			sp.setAnnounce_frequency(map.get("announce_frequency").getIntero());
		}
		if(ApplicationUtil.isTrue(map.get("announce_round_seconds").getLogico())) {
			sp.setAnnounce_round_seconds(map.get("announce_round_seconds").getIntero());
		}
		if(ApplicationUtil.isTrue(map.get("announce_holdtime").getLogico())) {
			sp.setAnnounce_holdtime(map.get("announce_holdtime").getBooleano());
		}
		if(ApplicationUtil.isTrue(map.get("queue_youarenext").getLogico())) {
			sp.setQueue_youarenext(map.get("queue_youarenext").getStringa());
		}
		if(ApplicationUtil.isTrue(map.get("queue_thereare").getLogico())) {
			sp.setQueue_thereare(map.get("queue_thereare").getStringa());
		}
		if(ApplicationUtil.isTrue(map.get("queue_callswaiting").getLogico())) {
			sp.setQueue_callswaiting(map.get("queue_callswaiting").getStringa());
		}
		if(ApplicationUtil.isTrue(map.get("queue_holdtime").getLogico())) {
			sp.setQueue_holdtime(map.get("queue_holdtime").getStringa());
		}
		if(ApplicationUtil.isTrue(map.get("queue_minutes").getLogico())) {
			sp.setQueue_minutes(map.get("queue_minutes").getStringa());
		}
		if(ApplicationUtil.isTrue(map.get("queue_seconds").getLogico())) {
			sp.setQueue_seconds(map.get("queue_seconds").getStringa());
		}
		if(ApplicationUtil.isTrue(map.get("queue_lessthan").getLogico())) {
			sp.setQueue_lessthan(map.get("queue_lessthan").getStringa());
		}
		if(ApplicationUtil.isTrue(map.get("queue_thankyou").getLogico())) {
			sp.setQueue_thankyou(map.get("queue_thankyou").getStringa());
		}
		if(ApplicationUtil.isTrue(map.get("queue_reporthold").getLogico())) {
			sp.setQueue_reporthold(map.get("queue_reporthold").getStringa());
		}
		if(ApplicationUtil.isTrue(map.get("periodic_announce").getLogico())) {
			sp.setPeriodic_announce(map.get("periodic_announce").getStringa());
		}
		if(ApplicationUtil.isTrue(map.get("periodic_announce_frequency").getLogico())) {
			sp.setPeriodic_announce_frequency(map.get("periodic_announce_frequency").getIntero());
		}

	}



}
