package it.callite.utility.massivo;
import java.io.Serializable;
import java.util.HashMap;
import java.util.Map;
import it.callite.model.EsitoArchiviazione;
import it.callite.utility.ApplicationUtil;
@SuppressWarnings("serial")
public class EsitoArchiviazioneMassivo implements Serializable {
	private Map<String, Valore> map = new HashMap<String, Valore>();
	public EsitoArchiviazioneMassivo() {
		set("utile");
		set("positivo");
		set("solo_archiviati");
		set("solo_backoffice");
		set("solo_operatore");
		set("solo_supervisore");
		set("colore");
		set("codice");
		set("ordinamento");
		set("workflow");
	}
	
	public Valore set(String chiave) {
		return map.put(chiave, new Valore());
	}
	public Valore get(String chiave) {
		return map.get(chiave);
	}
	public Map<String, Valore> getMap() {
		return map;
	}
	public void modifica(EsitoArchiviazione esito) {
		if(ApplicationUtil.isTrue(map.get("ordinamento").getLogico())) {
			esito.setOrdinamento(map.get("ordinamento").getLungo());
		}
		if(ApplicationUtil.isTrue(map.get("codice").getLogico())) {
			esito.setCodice(map.get("codice").getStringa());
		}
		if(ApplicationUtil.isTrue(map.get("colore").getLogico())) {
			esito.setColore(map.get("colore").getStringa());
		}
		if(ApplicationUtil.isTrue(map.get("positivo").getLogico())) {
			esito.setPositivo(map.get("positivo").getBooleano());
		}
		if(ApplicationUtil.isTrue(map.get("utile").getLogico())) {
			esito.setUtile(map.get("utile").getBooleano());
		}
		if(ApplicationUtil.isTrue(map.get("solo_archiviati").getLogico())) {
			esito.setSolo_archiviati(map.get("solo_archiviati").getBooleano());
		}
		if(ApplicationUtil.isTrue(map.get("solo_operatore").getLogico())) {
			esito.setSolo_operatore(map.get("solo_operatore").getBooleano());
		}
		if(ApplicationUtil.isTrue(map.get("solo_supervisore").getLogico())) {
			esito.setSolo_supervisore(map.get("solo_supervisore").getBooleano());
		}
		if(ApplicationUtil.isTrue(map.get("solo_backoffice").getLogico())) {
			esito.setSolo_backoffice(map.get("solo_backoffice").getBooleano());
		}
		if(ApplicationUtil.isTrue(map.get("workflow").getLogico())) {
			esito.setWorkflow(map.get("workflow").getBooleano());
		}
		
	}
}