package it.callite.utility.massivo;
import java.io.Serializable;
import java.util.HashMap;
import java.util.Map;
import it.callite.model.EsitoChiamata;
import it.callite.utility.ApplicationUtil;
@SuppressWarnings("serial")
public class EsitoChiamataMassivo implements Serializable {
	private Map<String, Valore> map = new HashMap<String, Valore>();
	public EsitoChiamataMassivo() {
		set("esitoNormale");
		set("esitoVisibile");
		set("esitoAutodialer");
		set("colore");
		set("codice");
		set("ordinamento");
		set("workflow");
	}
	public Valore set(String chiave) {
		return map.put(chiave, new Valore());
	}
	public Valore get(String chiave) {
		return map.get(chiave);
	}
	public Map<String, Valore> getMap() {
		return map;
	}
	public void modifica(EsitoChiamata esito) {
		if(ApplicationUtil.isTrue(map.get("ordinamento").getLogico())) {
			esito.setOrdinamento(map.get("ordinamento").getLungo());
		}
		if(ApplicationUtil.isTrue(map.get("codice").getLogico())) {
			esito.setCodice(map.get("codice").getStringa());
		}
		if(ApplicationUtil.isTrue(map.get("colore").getLogico())) {
			esito.setColore(map.get("colore").getStringa());
		}
		if(ApplicationUtil.isTrue(map.get("workflow").getLogico())) {
			esito.setWorkflow(map.get("workflow").getBooleano());
		}
		if(ApplicationUtil.isTrue(esito.getEditabile())) {
			if(ApplicationUtil.isTrue(map.get("esitoNormale").getLogico())) {
				esito.setEsitoNormale(map.get("esitoNormale").getBooleano());
			}
			if(ApplicationUtil.isTrue(map.get("esitoVisibile").getLogico())) {
				esito.setEsitoVisibile(map.get("esitoVisibile").getBooleano());
			}
			if(ApplicationUtil.isTrue(map.get("esitoAutodialer").getLogico())) {
				esito.setEsitoAutodialer(map.get("esitoAutodialer").getBooleano());
			}
		}
	}
}