package it.callite.utility.massivo;

import java.io.Serializable;
import java.util.HashMap;
import java.util.Map;

import it.callite.model.sip.SipBuddies;
import it.callite.utility.ApplicationUtil;



@SuppressWarnings("serial")
public class TrunkMassivo implements Serializable{
	
	private Map<String, Valore> map = new HashMap<String, Valore>();

	public TrunkMassivo() {
		set("callers");
		set("musicclass");
		set("vrx");
		set("vtx");
		set("add_prefisso");
		set("antecall");
		set("allow");
		set("interurbane");
		set("attivo");
		set("opposizione");
		set("registrazione");
	}
	
	public Valore set(String chiave) {
		return map.put(chiave, new Valore());
	}
	public Valore get(String chiave) {
		return map.get(chiave);
	}

	public Map<String, Valore> getMap() {
		return map;
	}

	public void modifica(SipBuddies sp) {
		
		if(ApplicationUtil.isTrue(map.get("callers").getLogico())) {
			sp.setCallers(map.get("callers").getStringa());
		}
		if(ApplicationUtil.isTrue(map.get("musicclass").getLogico())) {
			sp.setMusicclass(map.get("musicclass").getStringa());
		}
		if(ApplicationUtil.isTrue(map.get("vrx").getLogico())) {
			sp.setVrx(map.get("vrx").getIntero());
		}
		if(ApplicationUtil.isTrue(map.get("vtx").getLogico())) {
			sp.setVtx(map.get("vtx").getIntero());
		}
		if(ApplicationUtil.isTrue(map.get("add_prefisso").getLogico())) {
			sp.setAdd_prefisso(map.get("add_prefisso").getStringa());
		}
		if(ApplicationUtil.isTrue(map.get("antecall").getLogico())) {
			sp.setAntecall(map.get("antecall").getStringa());
		}
		if(ApplicationUtil.isTrue(map.get("allow").getLogico())) {
			sp.setAllow(map.get("allow").getStringa());
		}
		if(ApplicationUtil.isTrue(map.get("interurbane").getLogico())) {
			sp.setInterurbane(map.get("interurbane").getBooleano());
		}
		if(ApplicationUtil.isTrue(map.get("attivo").getLogico())) {
			sp.setAttivo(map.get("attivo").getBooleano());
		}
		if(ApplicationUtil.isTrue(map.get("registrazione").getLogico())) {
			sp.setRegistrazione(map.get("registrazione").getBooleano());
		}
		if(ApplicationUtil.isTrue(map.get("opposizione").getLogico())) {
			sp.setOpposizione(map.get("opposizione").getBooleano());
		}
	}
	
	
}
