package it.callite.utility.massivo;
import java.io.Serializable;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import it.callite.model.Ruolo;
import it.callite.model.Utente;
import it.callite.model.sip.SipBuddies;
import it.callite.utility.ApplicationUtil;
@SuppressWarnings("serial")
public class UtenteMassivo  implements Serializable {
	private Map<String, Valore> map = new HashMap<String, Valore>();
	public UtenteMassivo() {
		set("ruoli");
		set("ip_consentiti");
		set("ip_bloccati");
		set("cambioPassword");
		set("disattivaMessaggistica");
		set("disattivaFunzioni");
		set("enabled");
		set("generaEstratto");
		set("notificaLogin");
		set("notificaMessaggi");
		set("visualizzaStorico");
		set("folder");
		set("promemoria");
		set("trunk");
		set("inverti");
		set("data_fine");
		set("data_inizio");
		set("week_fine");
		set("week_inizio");
		set("ora_fine");
		set("ora_inizio");
		set("permessiOperatore");
		set("permessiSupervisore");
		set("permessiAgente");
		set("permessiPartner");
		set("permessiCoordinatore");
		set("pannelloOperatore");
		set("pannelloSupervisore");
		set("limitaAzioniAgente");
		set("limitaAzioniOperatore");
		set("limitaAzioniPartner");
		set("limitaAzioniSupervisore");
		set("limitaAzioniCoordinatore");
		set("limitaRicercaAgente");
		set("limitaRicercaOperatore");
		set("limitaRicercaPartner");
		set("limitaRicercaSupervisore");
		set("limitaRicercaCoordinatore");
		set("limitaDatiAgente");
		set("limitaDatiOperatore");
		set("limitaDatiPartner");
		set("limitaDatiSupervisore");
		set("limitaDatiCoordinatore");
		set("limitaModificaAgente");
		set("limitaModificaOperatore");
		set("limitaModificaSupervisore");
		set("limitaModificaCoordinatore");
		set("limitaModificaPartner");
		set("limitaCampagnaSupervisore");
		set("limitaCampagnaPartner");
		set("limitaPermessiOperatore");
	}
	public Valore set(String chiave) {
		return map.put(chiave, new Valore());
	}
	public Valore get(String chiave) {
		return map.get(chiave);
	}
	public Map<String, Valore> getMap() {
		return map;
	}
	public void modifica(Utente user, SipBuddies trunk, List<Ruolo> ruoli) {
		if(user.isLocale() && ApplicationUtil.isTrue(map.get("trunk").getLogico())) {
			user.setTrunk(trunk);
		}
		
		if(ApplicationUtil.isTrue(map.get("ruoli").getLogico())) {
			user.setRuoli(ruoli);
		}
		if(ApplicationUtil.isTrue(map.get("permessiOperatore").getLogico())) {
			user.setPannelloOperatore(map.get("pannelloOperatore").getBooleano());
			user.setPermessiOperatore(map.get("permessiOperatore").getStringa());
			if(ApplicationUtil.notEmpty(user.getPermessiOperatoreS())) {
				user.setLimitaRicercaOperatore(map.get("limitaRicercaOperatore").getBooleano());
				user.setLimitaAzioniOperatore(map.get("limitaAzioniOperatore").getBooleano());
				user.setLimitaDatiOperatore(map.get("limitaDatiOperatore").getBooleano());
				user.setLimitaModificaOperatore(map.get("limitaModificaOperatore").getBooleano());
				user.setLimitaPermessiOperatore(map.get("limitaPermessiOperatore").getStringa());
			}
		}
		if(ApplicationUtil.isTrue(map.get("permessiSupervisore").getLogico())) {
			user.setPannelloSupervisore(map.get("pannelloSupervisore").getBooleano());
			user.setPermessiSupervisore(map.get("permessiSupervisore").getStringa());
			if(ApplicationUtil.notEmpty(user.getPermessiSupervisoreS())) {
				user.setLimitaRicercaSupervisore(map.get("limitaRicercaSupervisore").getBooleano());
				user.setLimitaAzioniSupervisore(map.get("limitaAzioniSupervisore").getBooleano());
				user.setLimitaDatiSupervisore(map.get("limitaDatiSupervisore").getBooleano());
				user.setLimitaModificaSupervisore(map.get("limitaModificaSupervisore").getBooleano());
				user.setLimitaCampagnaSupervisore(map.get("limitaCampagnaSupervisore").getStringa());
			}
		}
		if(ApplicationUtil.isTrue(map.get("permessiAgente").getLogico())) {
			user.setPermessiAgente(map.get("permessiAgente").getStringa());
			if(ApplicationUtil.notEmpty(user.getPermessiAgenteS())) {
				user.setLimitaRicercaAgente(map.get("limitaRicercaAgente").getBooleano());
				user.setLimitaAzioniAgente(map.get("limitaAzioniAgente").getBooleano());
				user.setLimitaDatiAgente(map.get("limitaDatiAgente").getBooleano());
				user.setLimitaModificaAgente(map.get("limitaModificaAgente").getBooleano());
			}
		}
		if(ApplicationUtil.isTrue(map.get("permessiPartner").getLogico())) {
			user.setPermessiPartner(map.get("permessiPartner").getStringa());
			if(ApplicationUtil.notEmpty(user.getPermessiPartnerS())) {
				user.setLimitaRicercaPartner(map.get("limitaRicercaPartner").getBooleano());
				user.setLimitaAzioniPartner(map.get("limitaAzioniPartner").getBooleano());
				user.setLimitaDatiPartner(map.get("limitaDatiPartner").getBooleano());
				user.setLimitaModificaPartner(map.get("limitaModificaPartner").getBooleano());
				user.setLimitaCampagnaPartner(map.get("limitaCampagnaPartner").getStringa());
			}
		}
		if(ApplicationUtil.isTrue(map.get("permessiCoordinatore").getLogico())) {
			user.setPermessiCoordinatore(map.get("permessiCoordinatore").getStringa());
			if(ApplicationUtil.notEmpty(user.getPermessiCoordinatoreS())) {
				user.setLimitaRicercaCoordinatore(map.get("limitaRicercaCoordinatore").getBooleano());
				user.setLimitaAzioniCoordinatore(map.get("limitaAzioniCoordinatore").getBooleano());
				user.setLimitaDatiCoordinatore(map.get("limitaDatiCoordinatore").getBooleano());
				user.setLimitaModificaCoordinatore(map.get("limitaModificaCoordinatore").getBooleano());
			}
		}
		if(ApplicationUtil.isTrue(map.get("cambioPassword").getLogico())) {
			user.setCambioPassword(map.get("cambioPassword").getBooleano());
		}
		if(ApplicationUtil.isTrue(map.get("cambioPassword").getLogico())) {
			user.setCambioPassword(map.get("cambioPassword").getBooleano());
		}
		if(ApplicationUtil.isTrue(map.get("disattivaMessaggistica").getLogico())) {
			user.setDisattivaMessaggistica(map.get("disattivaMessaggistica").getIntero());
		}
		if(ApplicationUtil.isTrue(map.get("disattivaFunzioni").getLogico())) {
			user.setDisattivaFunzioni(map.get("disattivaFunzioni").getIntero());
		}
		if(ApplicationUtil.isTrue(map.get("generaEstratto").getLogico())) {
			user.setGeneraEstratto(map.get("generaEstratto").getBooleano());
			if(ApplicationUtil.isFalse(user.getGeneraEstratto())) {
				user.estratto();
			} else {
				if(user.getFattura() == null) {
					user.fattura();
				}
			}
		}
		if(ApplicationUtil.isTrue(map.get("notificaLogin").getLogico())) {
			user.setNotificaLogin(map.get("notificaLogin").getBooleano());
		}
		if(ApplicationUtil.isTrue(map.get("notificaMessaggi").getLogico())) {
			user.setNotificaMessaggi(map.get("notificaMessaggi").getBooleano());
		}
		if(ApplicationUtil.isTrue(map.get("visualizzaStorico").getLogico())) {
			user.setVisualizzaStorico(map.get("visualizzaStorico").getBooleano());
		}
		if(ApplicationUtil.isTrue(map.get("folder").getLogico())) {
			user.setFolder(map.get("folder").getStringa());
		}
		if(ApplicationUtil.isTrue(map.get("promemoria").getLogico())) {
			user.setPromemoria(map.get("promemoria").getBooleano());
		}
		if(ApplicationUtil.isTrue(map.get("enabled").getLogico())) {
			user.setEnabled(map.get("enabled").getBooleano());
		}
		if(ApplicationUtil.isTrue(map.get("ip_consentiti").getLogico())) {
			user.setIp_consentiti(map.get("ip_consentiti").getStringa());
		}
		if(ApplicationUtil.isTrue(map.get("ip_bloccati").getLogico())) {
			user.setIp_bloccati(map.get("ip_bloccati").getStringa());
		}
		if(ApplicationUtil.isTrue(map.get("inverti").getLogico())) {
			user.setInverti(map.get("inverti").getBooleano());
		}
		if(ApplicationUtil.isTrue(map.get("data_fine").getLogico())) {
			user.setData_fine(map.get("data_fine").getData());
		}
		if(ApplicationUtil.isTrue(map.get("data_inizio").getLogico())) {
			user.setData_inizio(map.get("data_inizio").getData());
		}
		if(ApplicationUtil.isTrue(map.get("week_fine").getLogico())) {
			user.setWeek_fine(map.get("week_fine").getLungo());
		}
		if(ApplicationUtil.isTrue(map.get("week_inizio").getLogico())) {
			user.setWeek_inizio(map.get("week_inizio").getLungo());
		}
		if(ApplicationUtil.isTrue(map.get("ora_fine").getLogico())) {
			user.setOra_fine(map.get("ora_fine").getData());
		}
		if(ApplicationUtil.isTrue(map.get("ora_inizio").getLogico())) {
			user.setOra_inizio(map.get("ora_inizio").getData());
		}
	}
}