package it.callite.utility.thread;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import it.callite.constants.ConstantsLanguage;
import it.callite.dao.DownloadDao;
import it.callite.dao.NotiziaDao;
import it.callite.dao.UserDao;
import it.callite.model.Agente;
import it.callite.model.Contatto;
import it.callite.model.Notizia;
import it.callite.model.Utente;
import it.callite.utility.ApplicationUtil;
public class AgenteNotiziaThread extends Thread {

	private Contatto contatto;
	private NotiziaDao  notiziaDao;
	private DownloadDao downloadDao;
	private UserDao userDao;
	private Utente user;

	public AgenteNotiziaThread(Contatto contatto, NotiziaDao notiziaDao, DownloadDao downloadDao, UserDao userDao, Utente user) {
		this.contatto = contatto;
		this.notiziaDao = notiziaDao;
		this.downloadDao = downloadDao;
		this.userDao = userDao;
		this.user = user;
	}

	public void run() {
		List<Utente> destinatari = new ArrayList<Utente>();
		Agente agente = contatto.getAgente();
		if(agente != null) {
			List<Utente> utenti = userDao.getUtentiByAgenteId(agente.getId());
			if(ApplicationUtil.notEmpty(utenti)) {
				Iterator<Utente> uIt = utenti.iterator();
				while (uIt.hasNext()) {
					Utente utente = uIt.next();
					if(utente != null && !utente.equals(user)) {
						destinatari.add(utente);
					}
				}
			}
		}
		if(ApplicationUtil.notEmpty(destinatari)) {
			Notizia notizia = new Notizia();
			String testo = downloadDao.notificaContattoToHTMLString(contatto, user);
			String oggetto = ConstantsLanguage.CONTATTO.stampa() + " - " + ConstantsLanguage.CAMPAGNA.stampa() + ": "+ contatto.getCampagna_denominazione()	+"; "+  ConstantsLanguage.CONTATTO.stampa() +": "+contatto.getId();
			notizia.setTesto(testo);
			notizia.setOggetto(oggetto);
			notizia.setUtenti(destinatari);
			//notizia.setAllegati(allegati);
			notiziaDao.salvaNotiziaNuova(notizia);
		}
	}
}