package it.callite.utility.thread;

import java.util.Date;

import it.callite.autodialer.controllo.CodaManager;
import it.callite.autodialer.controllo.CodaStatic;
import it.callite.chiamate.Chiamate;
import it.callite.constants.ConstantsGlobal;
import it.callite.constants.ConstantsMap;
import it.callite.dao.AutodialerDao;
import it.callite.dao.OperazioneDao;
import it.callite.model.AutoContatto;
import it.callite.model.Contatto;
import it.callite.model.Utente;
import it.callite.utility.ApplicationUtil;


public class ApriContattoThread extends Thread {

	private AutodialerDao autodialerDao;
	private OperazioneDao operazioneDao;
	private AutoContatto auto;
	private Utente user;
	private long time;

	public ApriContattoThread(AutodialerDao autodialerDao, OperazioneDao operazioneDao, AutoContatto auto,  Utente user, long time) {
		this.autodialerDao = autodialerDao;
		this.operazioneDao = operazioneDao;
		this.auto = auto;
		this.user = user;
		this.time = time;
	}

	public void run() {
		if (auto != null) {
			Date ai = user.getAttesa() != null ? ApplicationUtil.date(user.getAttesa()) : null;
			Date af = ApplicationUtil.date(time);
			Date data = ApplicationUtil.date();
			Chiamate.getCodaInterni().stato(user.getInternoString(), false);
			Contatto contatto = auto.getContatto();
			operazioneDao.apriContatto(ConstantsGlobal.ID_SEZIONE_PUBBLICHE, user, contatto);
			operazioneDao.chiama(user, contatto);
			operazioneDao.risponde(user, contatto);
			autodialerDao.removeUser(user, contatto.getCampagna());
			auto.setStato(ConstantsMap.CHIAMATA_APERTA);
			auto.setData_apertura(data);
			if(auto.getData_risposta() == null) {
				auto.setData_risposta(data);
			}
			Integer salva = auto.getAutodialer().getSave_autodialer();
			if(ApplicationUtil.eq(salva, 1) || ApplicationUtil.eq(salva, 2)) {
				auto.imposta();
				autodialerDao.salvaAggiorna(auto);
			}
			Chiamate.getCodaAutodialer().remove(contatto.getId());
			if(auto.getAutodialer().getEsitoApertura() != null) {
				Chiamate.getCodaEsiti().add(null, contatto);
			}
			contatto.setTimestamp_attesa_inizio(ai);
			contatto.setTimestamp_attesa_fine(af);
			CodaManager codaManager = Chiamate.getCodaProcessi().get(contatto.getCampagna());
			if(codaManager != null) {
				codaManager.getChiamateInCorso().remove(contatto.getId());
				codaManager.getAutodialerStatistiche().incGestite(data);
				codaManager.getAutodialerStatistiche().addTimeAttesa(ai, af);
				codaManager.getAutodialerContatti().incGestite(auto, data);
			}
			CodaStatic.getAutodialerStatistiche().incGestite(data);
			CodaStatic.getAutodialerStatistiche().addTimeAttesa(ai, af);
			CodaStatic.getAutodialerContatti().incGestite(auto, data);
		} else { 
			Chiamate.getCodaInterni().stato(user.getInternoString(), true);
		} 
	}

}
