package it.callite.utility.thread;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import it.callite.constants.ConstantsGlobal;
import it.callite.constants.ConstantsLanguage;
import it.callite.dao.DownloadDao;
import it.callite.dao.MessaggioDao;
import it.callite.dao.UserDao;
import it.callite.model.Contatto;
import it.callite.model.EsitoArchiviazione;
import it.callite.model.Utente;
import it.callite.model.messaggio.Destinatario;
import it.callite.model.messaggio.Messaggio;
import it.callite.utility.ApplicationUtil;
public class ContattoMessaggioThread extends Thread {
	private Contatto contatto;
	private UserDao userDao;
	private MessaggioDao  messaggioDao;
	private DownloadDao downloadDao;
	private EsitoArchiviazione esitoCliccato;
	private Utente user;
	public ContattoMessaggioThread(EsitoArchiviazione esitoCliccato, Contatto contatto, MessaggioDao messaggioDao, DownloadDao downloadDao, UserDao userDao, Utente user) {
		this.contatto = contatto;
		this.userDao = userDao;
		this.messaggioDao = messaggioDao;
		this.downloadDao = downloadDao;
		this.user = user;
		this.esitoCliccato = esitoCliccato;
	}
	public void run() {
		String emailDestinatario = ApplicationUtil.trimToEmpty(esitoCliccato.getMessaggio_notifica());
		if (ApplicationUtil.isNotBlank(emailDestinatario)) {
			List<Destinatario> destinatari = new ArrayList<Destinatario>();
			List<String> uns = ApplicationUtil.tokenU(emailDestinatario, ConstantsGlobal.colonSeparator);
			if(ApplicationUtil.notEmpty(uns)) {
				Iterator<String> uIt = uns.iterator();
				while (uIt.hasNext()) {
					String us = ApplicationUtil.subStringUtente((String) uIt.next());
					if(us != null) {
						Utente utente = userDao.getUserByUsername(us);
						if(utente != null && !utente.equals(user)) {
							destinatari.add(new Destinatario(utente));
						}
					}
				}
			}
			if(ApplicationUtil.notEmpty(destinatari)) {
				Messaggio messaggio = messaggioDao.messaggioInInvio(user);
				String testo = downloadDao.notificaContattoToHTMLString(contatto, user);
				String oggetto = ConstantsLanguage.ARCHIVIAZIONE.stampa() + " - " + ConstantsLanguage.CAMPAGNA.stampa() + ": "+ contatto.getCampagna_denominazione() + "; "+  ConstantsLanguage.CONTATTO.stampa() +": "+contatto.getId();
				messaggio.setTesto(testo);
				messaggio.setOggetto(oggetto);
				messaggio.setDestinatari(destinatari);
				//messaggio.setAllegati(allegati);
				messaggioDao.salvaMessaggioNuovoInvia(messaggio);
			}
		}
	}
}