package it.callite.utility.thread;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

import it.callite.dao.ComunicazioneDao;
import it.callite.model.Contatto;
import it.callite.model.EsitoArchiviazione;
import it.callite.model.Rmail;
import it.callite.model.RmailTemplate;
import it.callite.model.Utente;
import it.callite.utility.Allegato;
import it.callite.utility.ApplicationUtil;
import it.callite.utility.DatoAggiuntivo;
public class PannelloRmailSenderThread extends Thread {
	private Map<String, DatoAggiuntivo> valori_sondaggio;
	private List<Allegato> documentiGenerati;
	private EsitoArchiviazione esito;
	private Contatto contatto;
	private Utente utente;
	private ComunicazioneDao comunicazioneDao;
	public PannelloRmailSenderThread(Utente utente, Contatto contatto, EsitoArchiviazione esito, Map<String, DatoAggiuntivo> valori_sondaggio, List<Allegato> documentiGenerati, ComunicazioneDao comunicazioneDao) {
		this.contatto = contatto;
		this.utente = utente;
		this.esito = esito;
		this.valori_sondaggio = valori_sondaggio;
		this.documentiGenerati = documentiGenerati;
		this.comunicazioneDao = comunicazioneDao;
	}
	public void run() {
		List<RmailTemplate> templates = comunicazioneDao.getAllRmailTemplate(contatto.getCampagna().getId(), esito);
		if(ApplicationUtil.notEmpty(templates)) {
			Iterator<RmailTemplate> it = templates.iterator();
			while (it.hasNext()) {
				RmailTemplate template = (RmailTemplate) it.next();
				if (template != null && ApplicationUtil.isTrue(template.getAttivo())) {
					Rmail rmail = comunicazioneDao.creaRmailDaTemplate(template, valori_sondaggio);
					rmail.setContatto(contatto);
					rmail.imposta();
					if (ApplicationUtil.isTrue(template.getInvia_allegati())) {
						rmail.getRmailTemplate().setAllegati(documentiGenerati);
					}
					comunicazioneDao.inviaRmail(rmail, utente, null);
				}
			}
		}
	}
}