package it.callite.utility.thread;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

import it.callite.dao.ComunicazioneDao;
import it.callite.model.Contatto;
import it.callite.model.EsitoArchiviazione;
import it.callite.model.Telecom;
import it.callite.model.TelecomTemplate;
import it.callite.model.Utente;
import it.callite.utility.ApplicationUtil;
import it.callite.utility.DatoAggiuntivo;
public class PannelloTelecomSenderThread extends Thread {
	private Map<String, DatoAggiuntivo> valori_sondaggio;
	private EsitoArchiviazione esito;
	private Contatto contatto;
	private Utente utente;
	private ComunicazioneDao comunicazioneDao;
	public PannelloTelecomSenderThread(Utente utente, Contatto contatto, EsitoArchiviazione esito, Map<String, DatoAggiuntivo> valori_sondaggio, ComunicazioneDao comunicazioneDao) {
		this.contatto = contatto;
		this.utente = utente;
		this.esito = esito;
		this.valori_sondaggio = valori_sondaggio;
		this.comunicazioneDao = comunicazioneDao;
	}
	public void run() {
		List<TelecomTemplate> templates = comunicazioneDao.getAllTelecomTemplate(contatto.getCampagna().getId(), esito);
		if(ApplicationUtil.notEmpty(templates)) {
			Iterator<TelecomTemplate> it = templates.iterator();
			while (it.hasNext()) {
				TelecomTemplate template = (TelecomTemplate) it.next();
				if (template != null && ApplicationUtil.isTrue(template.getAttivo())) {
					Telecom telecom = comunicazioneDao.creaTelecomDaTemplate(template, valori_sondaggio);
					telecom.setContatto(contatto);
					comunicazioneDao.inviaTelecom(telecom, utente, false);
				}
			}
		}
	}
}