package it.callite.utility.thread;
import java.util.ArrayList;
import java.util.List;

import it.callite.constants.ConstantsGlobal;
import it.callite.constants.ConstantsLanguage;
import it.callite.dao.DownloadDao;
import it.callite.dao.NotiziaDao;
import it.callite.model.Contatto;
import it.callite.model.Notizia;
import it.callite.model.Utente;
import it.callite.utility.ApplicationUtil;
public class ProprietarioNotiziaThread extends Thread {
	
	private Contatto contatto;
	private NotiziaDao  notiziaDao;
	private DownloadDao downloadDao;
	private Utente user;
	
	public ProprietarioNotiziaThread(Contatto contatto, NotiziaDao notiziaDao, DownloadDao downloadDao, Utente user) {
		this.contatto = contatto;
		this.notiziaDao = notiziaDao;
		this.downloadDao = downloadDao;
		this.user = user;
	}
	
	public void run() {
		Utente proprietario = contatto.getProprietario();
		if(proprietario != null && ApplicationUtil.equals(contatto.getTipo(), ConstantsGlobal.inviato)) {
			List<Utente> destinatari = new ArrayList<Utente>();
			if(!proprietario.equals(user)) {
				destinatari.add(proprietario);
			}
			if(ApplicationUtil.notEmpty(destinatari)) {
				Notizia notizia = new Notizia();
				String testo = downloadDao.notificaContattoToHTMLString(contatto, user);
				String oggetto = ConstantsLanguage.PERSONALE.stampa() + " - " + ConstantsLanguage.CAMPAGNA.stampa() + ": "+ contatto.getCampagna_denominazione()	+"; "+  ConstantsLanguage.CONTATTO.stampa() +": "+contatto.getId();
				notizia.setTesto(testo);
				notizia.setOggetto(oggetto);
				notizia.setUtenti(destinatari);
				//notizia.setAllegati(allegati);
				notiziaDao.salvaNotiziaNuova(notizia);
			}
		}
	}
}