package it.callite.utility.thread;
import java.math.BigDecimal;
import java.math.RoundingMode;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import it.callite.constants.ConstantsEsito;
import it.callite.constants.ConstantsGlobal;
import it.callite.dao.AnagraficaDao;
import it.callite.dao.RiprogrammaDao;
import it.callite.message.Message;
import it.callite.model.Contatto;
import it.callite.model.EsitoArchiviazione;
import it.callite.model.EsitoChiamata;
import it.callite.model.Lista;
import it.callite.model.Utente;
import it.callite.utility.ApplicationUtil;
import it.callite.utility.RiprogrammaContatto;
public class RiprogrammaContattoThread  extends Thread {
	private String identificativo;
	private RiprogrammaDao riprogrammaDao;
	private AnagraficaDao anagraficaDao;
	private RiprogrammaContatto criterio;
	private Utente utente;
	private Utente operatore;
	private Date inizio;
	private Date data;
	private Integer totale;
	private Integer corrente;
	private Integer record;
	private Long tempoTotale;
	private EsitoChiamata esito;
	private EsitoArchiviazione archiviazione;
	private Boolean completato;
	private Boolean interrompi;
	private Boolean elimina_storia;
	private Boolean elimina_nota;
	private Boolean sposta;
	private boolean supervisore;
	private Integer step;
	private Boolean modo;
	private Long campagnaId; 
	private Long listaId;
	private Boolean esistente;
	private Lista listaM;
	public RiprogrammaContattoThread(String identificativo, Boolean esistente, Lista listaM, Boolean sposta, AnagraficaDao anagraficaDao, Long campagnaId, Long listaId, boolean supervisore, RiprogrammaDao riprogrammaDao, RiprogrammaContatto criterio, Utente utente, Utente operatore, Integer record, Boolean elimina_storia, Boolean elimina_nota, EsitoChiamata esito, EsitoArchiviazione archiviazione, Date data, Integer step, Boolean modo) {
		this.identificativo = identificativo;
		this.supervisore = supervisore;
		this.riprogrammaDao = riprogrammaDao;
		this.anagraficaDao = anagraficaDao;
		this.criterio = criterio;
		this.utente = utente;
		this.operatore = operatore;
		this.totale = 0;
		this.corrente = 0;
		this.record = record;
		this.tempoTotale = 0L;
		this.esito = esito;
		this.archiviazione = archiviazione;
		this.completato = false;
		this.interrompi = false;
		this.elimina_storia = elimina_storia;
		this.elimina_nota = elimina_nota;
		this.sposta = sposta;
		this.campagnaId = campagnaId;
		this.listaId = listaId;
		this.data = data;
		this.step = step;
		this.modo = modo;
		this.inizio = ApplicationUtil.date();
		this.esistente = esistente;
		this.listaM = listaM;
	}
	public void run() {
		List<Long> contattiId = new ArrayList<Long>();
		totale = riprogrammaDao.riprogrammaContattoSize(supervisore, contattiId, utente, criterio);
		if (ApplicationUtil.gtZero(totale)) {
			for (int j = 0; j < getSize(); j++) {
				if(interrompi ||  corrente >= totale) { 
					break;
				}
				long time1 = System.currentTimeMillis();
				//List<Contatto> contatti = riprogrammaDao.riprogrammaContatto(utente, criterio, (j * record), record);
				List<Contatto> contatti = riprogrammaDao.riprogrammaContatto(supervisore, contattiId, utente, criterio, 0, record);
				contattiId.addAll(ApplicationUtil.prendiIdContatto(contatti));
				if (ApplicationUtil.notEmpty(contatti)) {
					if(ApplicationUtil.eq(criterio.getOperazione(), 1)) {
						anagraficaDao.cambiaAnagrafiche(esistente, listaM,sposta, utente, contatti, listaId, campagnaId);
						if(esito.getId().equals(ConstantsEsito.ID_DA_CHIAMARE)) {
							riprogrammaDao.resetContatto(elimina_storia, elimina_nota, contatti, utente, data, esito);
						} 					
						if(esito.getId().equals(ConstantsEsito.ID_RICHIAMO_PUBBLICO)) {
							riprogrammaDao.riprogrammaPubblico(elimina_storia, elimina_nota, utente, contatti, data, esito);
						}
						if(esito.getId().equals(ConstantsEsito.ID_RICHIAMO_PRIVATO)) {
							riprogrammaDao.riprogrammaPrivato(elimina_storia, elimina_nota, utente, operatore, contatti, data, esito);
						}
						if(esito.getId().equals(ConstantsEsito.ID_OK)) {
							riprogrammaDao.riprogrammaArchiviato(operatore, elimina_storia, elimina_nota, utente, contatti, data, esito, archiviazione);
						}
						if(!esito.getId().equals(ConstantsEsito.ID_RICHIAMO_PUBBLICO) && !esito.getId().equals(ConstantsEsito.ID_RICHIAMO_PRIVATO) && !esito.getId().equals(ConstantsEsito.ID_OK) && !esito.getId().equals(ConstantsEsito.ID_DA_CHIAMARE)) {
							riprogrammaDao.esitaContatto(elimina_storia, elimina_nota, contatti, utente, esito);
						}
					}
					if(ApplicationUtil.eq(criterio.getOperazione(), 2)) {
						riprogrammaDao.eliminaContatto(contatti, utente);
					}
					if(ApplicationUtil.eq(criterio.getOperazione(), 3)) {
						riprogrammaDao.resetContatto(elimina_storia, elimina_nota, contatti, utente, data, esito);
					}
					if(ApplicationUtil.eq(criterio.getOperazione(), 4)) {
						riprogrammaDao.revertContatto(contatti, utente, data, step, modo);
					}
					if(ApplicationUtil.eq(criterio.getOperazione(), 5)) {
						anagraficaDao.updateAnagrafiche(esistente, listaM, sposta, utente, contatti, listaId, campagnaId);
					}
				} else {
					break;
				}
				long time2 = System.currentTimeMillis();
				corrente = (j * record);
				tempoTotale += (time2-time1) ;
			}
			if(interrompi ||  corrente >= totale) { 
				this.interrupt();
			}
		}
		completato = true;
	}
	public synchronized int getSize(){
		if(ApplicationUtil.gtZero(totale) && ApplicationUtil.gtZero(record)) {
			return (totale/record) + ((totale % record > 0) ? 1 : 0);
		}
		else return 0;
	}
	public synchronized void setInterrompi(Boolean interrompi) {
		this.interrompi = interrompi;
	}
	public synchronized Boolean getCompletato() {
		return completato;
	}
	public synchronized Integer getCorrente() {
		if(ApplicationUtil.gtZero(totale) && ApplicationUtil.gtZero(corrente) && corrente >= totale) {
			corrente = totale;
		}
		return corrente;
	}
	public synchronized Date getInizio() {
		return inizio;
	}
	public synchronized Date getFine() {
		BigDecimal num = new BigDecimal(0);
		if(ApplicationUtil.gtZero(corrente)) {
			Double correnteT = Double.valueOf(corrente);
			Double tempoTotaleT = Double.valueOf(tempoTotale);
			num = new BigDecimal(tempoTotaleT / correnteT);
		}
		BigDecimal stak = num.multiply(new BigDecimal(getTotale() - getCorrente()));
		if(!stak.equals(new BigDecimal(0))) {
			return ApplicationUtil.addMilliseconds(ApplicationUtil.date(), stak.intValue());
		} else {
			return null;
		}
	}
	public synchronized String getProcesso() {
		if(ApplicationUtil.eq(criterio.getOperazione(), 1)) {
			return Message.addCatalogText("modifica") + ": " + identificativo;
		}
		if(ApplicationUtil.eq(criterio.getOperazione(), 2)) {
			return Message.addCatalogText("elimina") + ": " + identificativo;
		}
		if(ApplicationUtil.eq(criterio.getOperazione(), 3)) {
			return Message.addCatalogText("reset") + ": " + identificativo;
		}
		if(ApplicationUtil.eq(criterio.getOperazione(), 4)) {
			return Message.addCatalogText("ripristina") + ": " + identificativo;
		}
		if(ApplicationUtil.eq(criterio.getOperazione(), 5)) {
			return Message.addCatalogText("sposta") + ": " + identificativo;
		}
		return identificativo;
	}
	public synchronized BigDecimal getPercentuale() {
		BigDecimal bg = new BigDecimal(0);
		double percentuale = 100f;
		if(ApplicationUtil.gtZero(totale) && ApplicationUtil.gtZero(corrente)) {
			Double correnteT = Double.valueOf(corrente);
			Double totaleT = Double.valueOf(totale);
			bg = new BigDecimal(correnteT / totaleT * percentuale);
		}
		return bg.setScale(2, RoundingMode.HALF_UP);
	}
	public synchronized String getTempo() {
		Double tempoTotaleT = Double.valueOf(tempoTotale / ((double) ConstantsGlobal.millis));
		return ApplicationUtil.format(tempoTotaleT);
	}
	public synchronized Long getTempoTotale() {
		return tempoTotale;
	}
	public synchronized Integer getTotale() {
		return totale;
	}
	public synchronized Utente getUtente() {
		return utente;
	}
	public String getIdentificativo() {
		return identificativo;
	}
	public void setIdentificativo(String identificativo) {
		this.identificativo = identificativo;
	}
	public Boolean getInterrompi() {
		return interrompi;
	}
}