package it.callite.utility.thread;

import java.util.Date;

import it.callite.dao.UserDao;
import it.callite.model.Marcatura;
import it.callite.model.Utente;
import it.callite.utility.ApplicationUtil;


public class SalvaMarcaturaThread extends Thread {

	private UserDao userDao;
	private Utente user;
	private boolean start;
	private boolean multiplo;

	public SalvaMarcaturaThread(UserDao userDao, Utente user, boolean start, boolean multiplo) {
		this.userDao = userDao;
		this.user = user;
		this.start = start;
		this.multiplo = multiplo;
	}

	public void run() {
		Date adesso = ApplicationUtil.date();
		Date oggi = ApplicationUtil.inizioGiornata(adesso);
		Marcatura marcatura = userDao.getMarcatura(user, oggi, multiplo);
		if(start) {
			if(marcatura == null) {
				marcatura = new Marcatura();
				marcatura.setData_creazione(oggi);
				marcatura.setUser(user);
				marcatura.setData_inizio(adesso);
			}
			marcatura.setData_fine(null);
			userDao.salvaLogin(user, adesso, true);
			userDao.salvaMarcatura(marcatura);
		} else {
			if(marcatura != null) {
				marcatura.setData_fine(adesso);
				userDao.salvaLogin(user, adesso, false);
				userDao.salvaMarcatura(marcatura);
			}
		}
	}

}
