package it.callite.utility.thread.anagrafica;
import java.util.Date;
import java.util.List;

import it.callite.constants.ConstantsGlobal;
import it.callite.dao.AnagraficaDao;
import it.callite.dao.CampagnaDao;
import it.callite.dao.OperazioneDao;
import it.callite.message.Message;
import it.callite.model.Campagna;
import it.callite.model.Lista;
import it.callite.model.TemplateImportAnagrafica;
import it.callite.model.Utente;
import it.callite.utility.ApplicationUtil;
import it.callite.utility.FileUpload;
import it.callite.utility.TemplateImportConsentite;
import it.callite.utility.importa.ImportModelAnagrafica;
import it.callite.utility.importa.ImportModelConsentite;

public class ExcelImportXLSThread extends ExcelImportBaseThread {

	private Utente utente;
	private Long campagnaNuova;
	private FileUpload fileUploadBean;
	private FileUpload fileUploadCons;
	private TemplateImportAnagrafica ti;
	private TemplateImportConsentite tc;
	private AnagraficaDao anagraficaDao;
	private CampagnaDao campagnaDao;
	private OperazioneDao operazioneDao;
	private String identificativo;
	private Date inizio;
	private Integer corrente;
	private Boolean completato;
	private Long tempoTotale;

	public ExcelImportXLSThread(AnagraficaDao anagraficaDao, CampagnaDao campagnaDao, OperazioneDao operazioneDao, Utente utente, Long campagnaNuova, FileUpload fileUploadBean, FileUpload fileUploadCons, TemplateImportAnagrafica ti, TemplateImportConsentite tc) {
		this.utente = utente;
		this.anagraficaDao = anagraficaDao;
		this.campagnaDao = campagnaDao;
		this.operazioneDao = operazioneDao;
		this.campagnaNuova = campagnaNuova;
		this.fileUploadBean = fileUploadBean;
		this.fileUploadCons = fileUploadCons;
		this.ti = ti;
		this.tc = tc;
		this.identificativo = "" + System.currentTimeMillis();
		this.corrente = 0;
		this.completato = false;
		this.inizio = ApplicationUtil.date();
		this.tempoTotale = 0L;
	}

	public void run() {
		long time1 = System.currentTimeMillis();
		corrente(0, time1);
		Date inizio = ApplicationUtil.date();
		ImportModelConsentite c = anagraficaDao.getAnagraficheConsentite(fileUploadCons, tc);
		corrente(1, time1);
		long time2 = System.currentTimeMillis();
		ImportModelAnagrafica mi = anagraficaDao.getAnagraficheByFileXLS(campagnaNuova, fileUploadBean, ti, c);
		corrente(2, time2);
		long time3 = System.currentTimeMillis();
		if(mi.isOk() && ApplicationUtil.notEmpty(mi.getAnagrafiche()) && ApplicationUtil.isTrue(mi.getSalva())) {
			List<Lista> liste = anagraficaDao.salvaAnagrafiche(mi, false);
			if(utente != null) {
				operazioneDao.salvaAnagrafiche(utente, mi);
			}
			campagnaDao.addListaToCampagnaId(campagnaNuova, liste);
		}
		corrente(3, time3);
		long time4 = System.currentTimeMillis();
		Campagna campagna = campagnaDao.getCampagna(campagnaNuova);
		anagraficaDao.inviaEscluse(inizio, c, mi, campagna);
		corrente(4, time4);
		completato = true;
		this.interrupt();
	}
	
	public void corrente(Integer corrente, long time1) {
		this.corrente = corrente;
		this.tempoTotale += (System.currentTimeMillis()-time1);
	}
	
	public String getIdentificativo() {
		return identificativo;
	}

	public void setIdentificativo(String identificativo) {
		this.identificativo = identificativo;
	}

	public Date getInizio() {
		return inizio;
	}

	public void setInizio(Date inizio) {
		this.inizio = inizio;
	}

	public Integer getCorrente() {
		return corrente;
	}

	public void setCorrente(Integer corrente) {
		this.corrente = corrente;
	}

	public Boolean getCompletato() {
		return completato;
	}

	public void setCompletato(Boolean completato) {
		this.completato = completato;
	}
	public synchronized String getTempo() {
		Double tempoTotaleT = Double.valueOf(tempoTotale / ((double) ConstantsGlobal.millis));
		return ApplicationUtil.format(tempoTotaleT);
	}
	public synchronized String getDescrizione() {
		return Message.addCatalogText("corrente." + corrente);
	}
	
}