package it.callite.utility.thread.export;
import java.math.BigDecimal;
import java.math.RoundingMode;
import java.util.Date;

import it.callite.constants.ConstantsGlobal;
import it.callite.constants.ConstantsLanguage;
import it.callite.model.Utente;
import it.callite.utility.ApplicationUtil;
public class EBaseThread  extends Thread {
	private String identificativo;
	private String tipologia;
	private Utente utente;
	private Date inizio;
	private Integer totale;
	private Integer corrente;
	private Integer record;
	private Long tempoTotale;
	private Boolean completato;
	private Boolean scrittura;
	private Boolean interrompi;
	private Boolean excel;
	
	public synchronized int getSize(){
		if(ApplicationUtil.gtZero(totale) && ApplicationUtil.gtZero(record)) {
			return (totale/record) + ((totale % record > 0) ? 1 : 0);
		}
		else return 0;
	}
	public synchronized void setInterrompi(Boolean interrompi) {
		this.interrompi = interrompi;
	}
	public synchronized Boolean getCompletato() {
		return completato;
	}
	public synchronized Integer getCorrente() {
		if(ApplicationUtil.gtZero(totale) && ApplicationUtil.gtZero(corrente) && corrente >= totale) {
			corrente = totale;
		}
		return corrente;
	}
	public synchronized Date getInizio() {
		return inizio;
	}
	public synchronized Date getFine() {
		BigDecimal num = new BigDecimal(0);
		if(ApplicationUtil.gtZero(corrente)) {
			Double correnteT = Double.valueOf(corrente);
			Double tempoTotaleT = Double.valueOf(tempoTotale);
			num = new BigDecimal(tempoTotaleT / correnteT);
		}
		BigDecimal stak = num.multiply(new BigDecimal(getTotale() - getCorrente()));
		if(!stak.equals(new BigDecimal(0))) {
			return ApplicationUtil.addMilliseconds(ApplicationUtil.date(), stak.intValue());
		} else {
			return null;
		}
	}
	public synchronized BigDecimal getPercentuale() {
		BigDecimal bg = new BigDecimal(0);
		double percentuale = 100f;
		if(ApplicationUtil.gtZero(totale) && ApplicationUtil.gtZero(corrente)) {
			Double correnteT = Double.valueOf(corrente);
			Double totaleT = Double.valueOf(totale);
			bg = new BigDecimal(correnteT / totaleT * percentuale);
		}
		return bg.setScale(2, RoundingMode.HALF_UP);
	}
	public synchronized String getTempo() {
		Double tempoTotaleT = Double.valueOf(tempoTotale / ((double) ConstantsGlobal.millis));
		return ApplicationUtil.format(tempoTotaleT);
	}
	public synchronized String getTipo() {
		return ApplicationUtil.isTrue(excel) ? ConstantsLanguage.EXCEL.stampa() : ConstantsLanguage.PDF.stampa();
	}
	public synchronized Long getTempoTotale() {
		return tempoTotale;
	}
	public synchronized Integer getTotale() {
		return totale;
	}
	public synchronized Utente getUtente() {
		return utente;
	}

	public String getIdentificativo() {
		return identificativo;
	}
	public void setIdentificativo(String identificativo) {
		this.identificativo = identificativo;
	}
	public Boolean getScrittura() {
		return scrittura;
	}
	public void setScrittura(Boolean scrittura) {
		this.scrittura = scrittura;
	}
	public Boolean getInterrompi() {
		return interrompi;
	}
	public String getTipologia() {
		return tipologia;
	}
	public void setTipologia(String tipologia) {
		this.tipologia = tipologia;
	}
	
}