package it.callite.utility.thread.invio;
import java.util.Date;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;

import it.callite.dao.ComunicazioneDao;
import it.callite.dao.PannelloDao;
import it.callite.model.Contatto;
import it.callite.model.Email;
import it.callite.model.EmailTemplate;
import it.callite.model.Utente;
import it.callite.utility.Allegato;
import it.callite.utility.ApplicationUtil;
import it.callite.utility.MailSupport;
public class MultiploEmailSenderThread  extends Thread {

	private List<Contatto> contatti;
	private Utente user;
	private EmailTemplate emailTemplate; 
	private String testo;
	private String oggetto;
	private HashMap<Allegato, String> allegati; 
	private Date dataSchedulata;
	private ComunicazioneDao comunicazioneDao;
	private PannelloDao pannelloDao;

	public MultiploEmailSenderThread(List<Contatto> contatti, Utente user, EmailTemplate emailTemplate, String testo, String oggetto, HashMap<Allegato, String> allegati, Date dataSchedulata, ComunicazioneDao comunicazioneDao, PannelloDao pannelloDao) {
		this.contatti = contatti;
		this.user = user;
		this.emailTemplate = emailTemplate;
		this.testo = testo;
		this.oggetto = oggetto;
		this.allegati = allegati;
		this.dataSchedulata = dataSchedulata;
		this.comunicazioneDao = comunicazioneDao;
		this.pannelloDao = pannelloDao;
	}
	public void run() {
		MailSupport ms = ApplicationUtil.getMailSupport(false, emailTemplate.getSmtp());
		Iterator<Contatto> itCont = contatti.iterator();
		while (itCont.hasNext()) {
			Contatto contatto = (Contatto) itCont.next();
			if (emailTemplate != null) {
				Email email = new Email();
				email.setDataSchedulata(dataSchedulata);
				email.setEmailTemplate(emailTemplate);
				email.setAllegati(allegati);
				email = pannelloDao.replaceInTemplateEmail(contatto, email, testo, oggetto);
				email.setDestinatario(contatto.getAnagrafica().getEmail());
				email.setContatto(contatto);
				comunicazioneDao.inviaEmail(email, user, ms);
			}
		}
		ms.close();
	}
}