package it.callite.utility.thread.invio;
import java.util.Date;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;

import it.callite.dao.ComunicazioneDao;
import it.callite.dao.PannelloDao;
import it.callite.model.Contatto;
import it.callite.model.Rmail;
import it.callite.model.RmailTemplate;
import it.callite.model.Utente;
import it.callite.utility.Allegato;
import it.callite.utility.ApplicationUtil;
import it.callite.utility.MailSupport;
public class MultiploRmailSenderThread  extends Thread {
	private List<Contatto> contatti;
	private Utente user;
	private RmailTemplate rmailTemplate; 
	private String testo;
	private HashMap<Allegato, String> allegati; 
	private Date dataSchedulata;
	private ComunicazioneDao comunicazioneDao;
	private PannelloDao pannelloDao;
	
	public MultiploRmailSenderThread(List<Contatto> contatti, Utente user, RmailTemplate rmailTemplate, String testo, HashMap<Allegato, String> allegati, Date dataSchedulata, ComunicazioneDao comunicazioneDao, PannelloDao pannelloDao) {
		this.contatti = contatti;
		this.user = user;
		this.rmailTemplate = rmailTemplate;
		this.testo = testo;
		this.allegati = allegati;
		this.dataSchedulata = dataSchedulata;
		this.comunicazioneDao = comunicazioneDao;
		this.pannelloDao = pannelloDao;
	}
	public void run() {
		MailSupport ms = ApplicationUtil.getMailSupport(false, rmailTemplate.getSmtp());
		Iterator<Contatto> itCont = contatti.iterator();
		while (itCont.hasNext()) {
			Contatto contatto = (Contatto) itCont.next();
			if (rmailTemplate != null) {
				Rmail rmail = new Rmail();
				rmail.setDataSchedulata(dataSchedulata);
				rmail.setRmailTemplate(rmailTemplate);
				rmail.setAllegati(allegati);
				rmail = pannelloDao.replaceInTemplateRmail(contatto, rmail, testo);
				rmail.setContatto(contatto);
				rmail.imposta();
				comunicazioneDao.inviaRmail(rmail, user, ms);
			}
		}
		ms.close();
	}
}