package it.callite.validator;
import java.util.List;
import java.util.Map;
import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.validator.Validator;
import javax.faces.validator.ValidatorException;
import it.callite.constants.ConstantsMap;
import it.callite.dao.ImpostazioneDao;
import it.callite.message.Message;
import it.callite.utility.ApplicationUtil;
public class AnagraficaPartitaValidator implements Validator {
	public AnagraficaPartitaValidator() {
	}
	public void validate(FacesContext facesContext, UIComponent uIComponent,Object object)  {
		String enteredName = ApplicationUtil.trimToNull((String) object);
		String campo = "partita_iva";
		ImpostazioneDao dao = (ImpostazioneDao) ApplicationUtil.getDao(facesContext, "impostazioneDao");
		if(enteredName != null) {
			Long campagna = null;
			Map<String,Object> mappa = uIComponent.getAttributes();
			if(ApplicationUtil.notEmpty(mappa)) {
				campagna = ApplicationUtil.toLong(mappa.get("campagna")); 
			}
			Integer oC = dao.getOpposizioneForm();
			if(ApplicationUtil.eq(oC, 3)) {
				int ctrs1 = dao.getByTelefono(null, enteredName);
				if (ctrs1 >  0) {
					throw new ValidatorException(Message.addValidatorMessage("opposizione" , null));
				}
				if(ApplicationUtil.gtZero(campagna)) {
					int ctrs2 = dao.getByTelefono(campagna, enteredName);
					if (ctrs2 >  0) {
						throw new ValidatorException(Message.addValidatorMessage("opposizione" , null));
					}
				}
			}
			if(ConstantsMap.getDuplicatoList().contains(dao.getDuplicatoPartitaForm())) {
				Long confirm = null;
				if(ApplicationUtil.notEmpty(mappa)) {
					confirm = ApplicationUtil.toLong(mappa.get("confirm")); 
				}
				List<Long> ctrs = dao.getIdAnagraficaByCampo(campo, enteredName, dao.getDuplicatoPartitaForm(), campagna, null);
				if(ApplicationUtil.notEmpty(ctrs)) {
					if(confirm == null) {
						throw new ValidatorException(Message.addValidatorMessage("duplicato" , null));
					} else {
						if (!ctrs.contains(confirm)) {
							throw new ValidatorException(Message.addValidatorMessage("duplicato" , null));
						}
					}
				}
			} 
		} else {
			if(dao.getRichiestoPartita()) {
				throw new ValidatorException(Message.addValidatorMessage("richiesto" , null));
			}
		} 
	}
}