package it.callite.validator;
import java.util.Map;
import javax.faces.component.UIComponent;
import javax.faces.component.UIInput;
import javax.faces.context.FacesContext;
import javax.faces.validator.Validator;
import javax.faces.validator.ValidatorException;
import it.callite.dao.ImpostazioneDao;
import it.callite.message.Message;
import it.callite.utility.ApplicationUtil;
public class AnagraficaTuttoValidator implements Validator {
	public AnagraficaTuttoValidator() {
	}
	public void validate(FacesContext facesContext, UIComponent uIComponent,Object object)  {
		ImpostazioneDao dao = (ImpostazioneDao) ApplicationUtil.getDao(facesContext, "impostazioneDao");
		UIInput t_fissoU = null;
		UIInput t_mobileU = null;
		UIInput t_faxU = null;
		UIInput t_altroU = null;
		UIInput t_emailU = null;
		UIInput t_codiceU = null;
		UIInput t_partitaU = null;
		UIInput t_linkU = null;
		if(ApplicationUtil.eq(dao.getFormImportCondition(), 1)) {
			Map<String,Object> mappa = uIComponent.getAttributes();
			if(ApplicationUtil.notEmpty(mappa)) {
				String t_fisso = (String) mappa.get("t_fisso"); 
				if(ApplicationUtil.isNotBlank(t_fisso))   {
					t_fissoU = ApplicationUtil.findComponent(uIComponent, t_fisso);
				}
				
				String t_mobile = (String) mappa.get("t_mobile"); 
				if(ApplicationUtil.isNotBlank(t_mobile))   {
					t_mobileU = ApplicationUtil.findComponent(uIComponent, t_mobile);
				}
				
				String t_fax = (String) mappa.get("t_fax"); 
				if(ApplicationUtil.isNotBlank(t_fax))   {
					t_faxU = ApplicationUtil.findComponent(uIComponent, t_fax);
				}
				
				String t_altro = (String) mappa.get("t_altro"); 
				if(ApplicationUtil.isNotBlank(t_altro))   {
					t_altroU = ApplicationUtil.findComponent(uIComponent, t_altro);
				}
				
				String t_email = (String) mappa.get("t_email");
				if(ApplicationUtil.isNotBlank(t_email))   {
					t_emailU = ApplicationUtil.findComponent(uIComponent, t_email);
				}
				
				String t_link = (String) mappa.get("t_link");
				if(ApplicationUtil.isNotBlank(t_link))   {
					t_linkU = ApplicationUtil.findComponent(uIComponent, t_link);
				}
				
				String t_codice = (String) mappa.get("t_codice");
				if(ApplicationUtil.isNotBlank(t_codice))   {
					t_codiceU = ApplicationUtil.findComponent(uIComponent, t_codice);
				}
				
				String t_partita = (String) mappa.get("t_partita");
				if(ApplicationUtil.isNotBlank(t_partita))   {
					t_partitaU = ApplicationUtil.findComponent(uIComponent, t_partita);
				}
				
			}
			boolean b_fisso = t_fissoU != null && t_fissoU.isValid() && ApplicationUtil.isBlank((String) t_fissoU.getValue());
			boolean b_mobile = t_mobileU != null && t_mobileU.isValid() && ApplicationUtil.isBlank((String) t_mobileU.getValue());
			boolean b_fax = t_faxU != null && t_faxU.isValid() && ApplicationUtil.isBlank((String) t_faxU.getValue());
			boolean b_altro = t_altroU != null && t_altroU.isValid() && ApplicationUtil.isBlank((String) t_altroU.getValue());
			boolean b_email = t_emailU != null && t_emailU.isValid() && ApplicationUtil.isBlank((String) t_emailU.getValue());
			boolean b_link = t_linkU != null && t_linkU.isValid() && ApplicationUtil.isBlank((String) t_linkU.getValue());
			boolean b_codice = t_codiceU != null && t_codiceU.isValid() && ApplicationUtil.isBlank((String) t_codiceU.getValue());
			boolean b_partita = t_partitaU != null && t_partitaU.isValid() && ApplicationUtil.isBlank((String) t_partitaU.getValue());
			if (b_fisso && b_mobile && b_altro && b_fax && b_email && b_link && b_codice && b_partita) {
				if(b_fisso) {
					t_fissoU.setValid(false);
				}
				if(b_mobile) {
					t_mobileU.setValid(false);
				}
				if(b_fax) {
					t_faxU.setValid(false);
				}
				if(b_altro) {
					t_altroU.setValid(false);
				}
				if(b_email) {
					t_emailU.setValid(false);
				}
				if(b_link) {
					t_linkU.setValid(false);
				}
				if(b_codice) {
					t_codiceU.setValid(false);
				}
				if(b_partita) {
					t_partitaU.setValid(false);
				}
				throw new ValidatorException(Message.addValidatorMessage("inserisci_telefono1" , null));
			}
		}
		
		
		if(ApplicationUtil.eq(dao.getFormImportCondition(), 2)) {
			Map<String,Object> mappa = uIComponent.getAttributes();
			if(ApplicationUtil.notEmpty(mappa)) {
				String t_fisso = (String) mappa.get("t_fisso"); 
				if(ApplicationUtil.isNotBlank(t_fisso))   {
					t_fissoU = ApplicationUtil.findComponent(uIComponent, t_fisso);
				}
				
				String t_mobile = (String) mappa.get("t_mobile"); 
				if(ApplicationUtil.isNotBlank(t_mobile))   {
					t_mobileU = ApplicationUtil.findComponent(uIComponent, t_mobile);
				}
				
				String t_fax = (String) mappa.get("t_fax"); 
				if(ApplicationUtil.isNotBlank(t_fax))   {
					t_faxU = ApplicationUtil.findComponent(uIComponent, t_fax);
				}
				
				String t_altro = (String) mappa.get("t_altro"); 
				if(ApplicationUtil.isNotBlank(t_altro))   {
					t_altroU = ApplicationUtil.findComponent(uIComponent, t_altro);
				}
				
				String t_email = (String) mappa.get("t_email");
				if(ApplicationUtil.isNotBlank(t_email))   {
					t_emailU = ApplicationUtil.findComponent(uIComponent, t_email);
				}
				
			}
			boolean b_fisso = t_fissoU != null && t_fissoU.isValid() && ApplicationUtil.isBlank((String) t_fissoU.getValue());
			boolean b_mobile = t_mobileU != null && t_mobileU.isValid() && ApplicationUtil.isBlank((String) t_mobileU.getValue());
			boolean b_fax = t_faxU != null && t_faxU.isValid() && ApplicationUtil.isBlank((String) t_faxU.getValue());
			boolean b_altro = t_altroU != null && t_altroU.isValid() && ApplicationUtil.isBlank((String) t_altroU.getValue());
			boolean b_email = t_emailU != null && t_emailU.isValid() && ApplicationUtil.isBlank((String) t_emailU.getValue());
			if (b_fisso && b_mobile && b_altro && b_fax && b_email) {
				if(b_fisso) {
					t_fissoU.setValid(false);
				}
				if(b_mobile) {
					t_mobileU.setValid(false);
				}
				if(b_fax) {
					t_faxU.setValid(false);
				}
				if(b_altro) {
					t_altroU.setValid(false);
				}
				if(b_email) {
					t_emailU.setValid(false);
				}
				throw new ValidatorException(Message.addValidatorMessage("inserisci_telefono2" , null));
			}
		}
		
		if(ApplicationUtil.eq(dao.getFormImportCondition(), 3)) {
			Map<String,Object> mappa = uIComponent.getAttributes();
			if(ApplicationUtil.notEmpty(mappa)) {
				String t_fisso = (String) mappa.get("t_fisso"); 
				if(ApplicationUtil.isNotBlank(t_fisso))   {
					t_fissoU = ApplicationUtil.findComponent(uIComponent, t_fisso);
				}
				
				String t_mobile = (String) mappa.get("t_mobile"); 
				if(ApplicationUtil.isNotBlank(t_mobile))   {
					t_mobileU = ApplicationUtil.findComponent(uIComponent, t_mobile);
				}
				
				String t_fax = (String) mappa.get("t_fax"); 
				if(ApplicationUtil.isNotBlank(t_fax))   {
					t_faxU = ApplicationUtil.findComponent(uIComponent, t_fax);
				}
				
				String t_altro = (String) mappa.get("t_altro"); 
				if(ApplicationUtil.isNotBlank(t_altro))   {
					t_altroU = ApplicationUtil.findComponent(uIComponent, t_altro);
				}
				
			}
			boolean b_fisso = t_fissoU != null && t_fissoU.isValid() && ApplicationUtil.isBlank((String) t_fissoU.getValue());
			boolean b_mobile = t_mobileU != null && t_mobileU.isValid() && ApplicationUtil.isBlank((String) t_mobileU.getValue());
			boolean b_fax = t_faxU != null && t_faxU.isValid() && ApplicationUtil.isBlank((String) t_faxU.getValue());
			boolean b_altro = t_altroU != null && t_altroU.isValid() && ApplicationUtil.isBlank((String) t_altroU.getValue());
			if (b_fisso && b_mobile && b_altro && b_fax) {
				if(b_fisso) {
					t_fissoU.setValid(false);
				}
				if(b_mobile) {
					t_mobileU.setValid(false);
				}
				if(b_fax) {
					t_faxU.setValid(false);
				}
				if(b_altro) {
					t_altroU.setValid(false);
				}
				throw new ValidatorException(Message.addValidatorMessage("inserisci_telefono3" , null));
			}
		}
	}
}