package it.callite.validator;
import java.util.List;
import java.util.Map;
import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.validator.Validator;
import javax.faces.validator.ValidatorException;
import it.callite.dao.ImpostazioneDao;
import it.callite.message.Message;
import it.callite.utility.ApplicationUtil;
public class DatoContrattoDuplicatoValidator implements Validator {
	public DatoContrattoDuplicatoValidator() {
	}
	public void validate(FacesContext facesContext, UIComponent uIComponent,Object object)  {
		String enteredName = ApplicationUtil.trimToNull((String) object);
		if(enteredName != null) {
			ImpostazioneDao dao = (ImpostazioneDao) ApplicationUtil.getDao(facesContext, "impostazioneDao");
			String chiave = null;
			Map<String,Object> mappa = uIComponent.getAttributes();
			if(ApplicationUtil.notEmpty(mappa)) {
				chiave = ApplicationUtil.trimToNull((String) mappa.get("chiave")); 
			}
			List<Long> ctrs = dao.getCampoContratto(chiave, enteredName);
			if(ApplicationUtil.notEmpty(ctrs)) {
				throw new ValidatorException(Message.addValidatorMessage("duplicato" , null));
			}
		} 
	}
}