package it.callite.validator;
import java.util.List;
import java.util.Map;
import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.validator.Validator;
import javax.faces.validator.ValidatorException;
import it.callite.dao.ImpostazioneDao;
import it.callite.message.Message;
import it.callite.utility.ApplicationUtil;
public class DatoDuplicatoValidator implements Validator {
	public DatoDuplicatoValidator() {
	}
	public void validate(FacesContext facesContext, UIComponent uIComponent,Object object)  {
		String enteredName = ApplicationUtil.trimToNull((String) object);
		if(enteredName != null) {
			ImpostazioneDao dao = (ImpostazioneDao) ApplicationUtil.getDao(facesContext, "impostazioneDao");
			Long campagna = null;
			String campo = null;
			String tipo = null;
			Map<String,Object> mappa = uIComponent.getAttributes();
			if(ApplicationUtil.notEmpty(mappa)) {
				campagna = ApplicationUtil.toLong(mappa.get("campagna")); 
				campo = ApplicationUtil.trimToNull((String) mappa.get("campo")); 
				tipo = ApplicationUtil.trimToNull((String) mappa.get("tipo")); 
			}
			if(campo != null) {
				List<Long> ctrs = dao.getIdAnagraficaByCampo(campo, enteredName, tipo, campagna, null);
				if(ApplicationUtil.notEmpty(ctrs)) {
					throw new ValidatorException(Message.addValidatorMessage("duplicato" , null));
				}
			} 
		} 
	}
}