package it.callite.validator;
import java.util.Map;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.validator.Validator;
import javax.faces.validator.ValidatorException;
import it.callite.dao.ImpostazioneDao;
import it.callite.message.Message;
import it.callite.utility.ApplicationUtil;
public class DatoTelefonicoValidator implements Validator {
	public DatoTelefonicoValidator() {
	}
	public void validate(FacesContext facesContext, UIComponent uIComponent,Object object)  {
		String enteredName = ApplicationUtil.trimToNull((String) object);
		if(enteredName != null) {
			String pattern = null;
			Map<String,Object> mappa = uIComponent.getAttributes();
			if(ApplicationUtil.notEmpty(mappa)) {
				pattern = ApplicationUtil.trimToNull((String) mappa.get("pattern"));
			}
			ImpostazioneDao dao = (ImpostazioneDao) ApplicationUtil.getDao(facesContext, "impostazioneDao");
			String pa = pattern != null ?   pattern : dao.validatore_tutto();
			Pattern p = Pattern.compile(pa);
			Matcher m = p.matcher(enteredName);
			boolean b = m.matches();	  		 
			if(!b){
				throw new ValidatorException(Message.addValidatorMessage("formato.errato" , pa));
			}
		} 
	}
}