package it.callite.validator;
import java.util.Map;

import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.validator.Validator;
import javax.faces.validator.ValidatorException;

import it.callite.dao.AutodialerDao;
import it.callite.message.Message;
import it.callite.model.Inbound;
import it.callite.utility.ApplicationUtil;
public class InboundValidator implements Validator {
	public InboundValidator() {
	}
	public void validate(FacesContext facesContext, UIComponent uIComponent,Object object)  {
		Long confirm = null;
		Map<String,Object> mappa = uIComponent.getAttributes();
		if(ApplicationUtil.notEmpty(mappa)) {
			confirm = ApplicationUtil.toLong(mappa.get("confirm")); 
		}
		String enteredName = ApplicationUtil.trimToNull((String) object);
		if(enteredName != null) {
			AutodialerDao dao = (AutodialerDao) ApplicationUtil.getDao(facesContext, "autodialerDao");
			Inbound ctrs = dao.getInbound(enteredName);
			if (ctrs != null) {
				if(confirm == null) {
					throw new ValidatorException(Message.addValidatorMessage("duplicato" , null));
				} else {
					if(!ApplicationUtil.eq(confirm, ctrs.getId())) {
						throw new ValidatorException(Message.addValidatorMessage("duplicato" , null));
					}
				}
			}
		} else {
			throw new ValidatorException(Message.addValidatorMessage("richiesto" , null));
		}
	} 
}