package it.callite.validator;
import java.util.Map;
import javax.faces.component.UIComponent;
import javax.faces.component.UIInput;
import javax.faces.context.FacesContext;
import javax.faces.validator.Validator;
import javax.faces.validator.ValidatorException;
import it.callite.dao.OpposizioneDao;
import it.callite.message.Message;
import it.callite.utility.ApplicationUtil;
public class OpposizioneValidator implements Validator {
	public OpposizioneValidator() {
	}
	public void validate(FacesContext facesContext, UIComponent uIComponent,Object object)  {
		Long confirm = null;
		Long campagna = null;
		Map<String,Object> mappa = uIComponent.getAttributes();
		if(ApplicationUtil.notEmpty(mappa)) {
			confirm = ApplicationUtil.toLong(mappa.get("confirm")); 
		}
		if(ApplicationUtil.notEmpty(mappa)) {
			String campagnaS = (String) mappa.get("campagna"); 
			if(ApplicationUtil.isNotBlank(campagnaS))   {
				UIInput campagnaU = ApplicationUtil.findComponent(uIComponent, campagnaS);
				if (campagnaU != null) {
					Object o = campagnaU.getValue();
					if(o != null) {
						if(o instanceof String) {
							String s = ApplicationUtil.trimToNull((String) o);
							if(s != null) {
								campagna = Long.parseLong(s);
							}
						} 
						if(o instanceof Long || o instanceof Integer || o instanceof Short) {
							campagna = (Long) o;
						}
					}
				}
			}
		}
		String enteredName = ApplicationUtil.trimToNull((String) object);
		if(enteredName != null) {
			OpposizioneDao dao = (OpposizioneDao) ApplicationUtil.getDao(facesContext, "opposizioneDao");
			Long ctrs = dao.getByOpposizione(campagna, enteredName);
			if (ctrs != null) {
				if(confirm == null) {
					throw new ValidatorException(Message.addValidatorMessage("duplicato" , null));
				} else {
					if(!ApplicationUtil.eq(confirm, ctrs)) {
						throw new ValidatorException(Message.addValidatorMessage("duplicato" , null));
					}
				}
			}
		} else {
			throw new ValidatorException(Message.addValidatorMessage("richiesto" , null));
		}
	} 
}