package it.callite.validator;

import java.util.Map;

import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.validator.Validator;
import javax.faces.validator.ValidatorException;

import it.callite.dao.ContrattoDao;
import it.callite.message.Message;
import it.callite.utility.ApplicationUtil;

public class SerialeValidator implements Validator {

	public SerialeValidator() {
	}

	public void validate(FacesContext facesContext, UIComponent uIComponent,Object object)  {
		Long confirm = null;
		Map<String,Object> mappa = uIComponent.getAttributes();
		if(ApplicationUtil.notEmpty(mappa)) {
			confirm = ApplicationUtil.toLong(mappa.get("confirm")); 
		}
		String enteredName = ApplicationUtil.trimToEmpty((String) object);
		if(ApplicationUtil.isNotBlank(enteredName)) {
			ContrattoDao dao = (ContrattoDao) ApplicationUtil.getDao(facesContext, "contrattoDao");
			Long ctrs = dao.getContrattoBySeriale(enteredName);
			if (ctrs != null) {
				if(confirm == null) {
					throw new ValidatorException(Message.addValidatorMessage("duplicato" , null));
				} else {
					if(!ApplicationUtil.eq(confirm, ctrs)) {
						throw new ValidatorException(Message.addValidatorMessage("duplicato" , null));
					}
				}
			}
		}
	} 
}