package it.callite.validator.intervallo;
import java.math.BigDecimal;
import java.util.Map;
import javax.faces.component.UIComponent;
import javax.faces.component.UIInput;
import javax.faces.context.FacesContext;
import javax.faces.validator.Validator;
import javax.faces.validator.ValidatorException;
import it.callite.message.Message;
import it.callite.utility.ApplicationUtil;
public class BigValidator2 implements Validator {
	public BigValidator2() {
	}
	@Override
	public void validate(FacesContext context, UIComponent uIComponent, Object value) throws ValidatorException {
		BigDecimal endBig = ApplicationUtil.toBigDecimal(value);
		if (endBig != null) {
			String confirm = null;
			Boolean interval = null;
			Map<String,Object> mappa = uIComponent.getAttributes();
			if(ApplicationUtil.notEmpty(mappa)) {
				confirm = ApplicationUtil.trimToNull((String) mappa.get("confirm")); 
				interval = ApplicationUtil.toBoolean(mappa.get("interval"));
			}
			if(confirm != null  && ApplicationUtil.isTrue(interval))   {
				UIInput startU = ApplicationUtil.findComponent(uIComponent, confirm);
				if (startU != null && startU.isValid()) {
					BigDecimal startBig = ApplicationUtil.toBigDecimal(startU.getValue());
					if (startBig != null) {
						if (startBig.doubleValue() > endBig.doubleValue()) {
							//ApplicationUtil.resetComponent(uIComponent, startU, false);
							throw new ValidatorException(Message.addValidatorMessage("valore_non_consentito" , null));
						}
					}
				}
				//ApplicationUtil.resetComponent(uIComponent, startU, true);
			}
		}
	}
}