package it.callite.validator.intervallo;
import java.util.Date;
import java.util.Map;
import javax.faces.component.UIComponent;
import javax.faces.component.UIInput;
import javax.faces.context.FacesContext;
import javax.faces.validator.Validator;
import javax.faces.validator.ValidatorException;
import it.callite.message.Message;
import it.callite.utility.ApplicationUtil;
public class TimeValidator1 implements Validator {
	public TimeValidator1() {
	}
	@Override
	public void validate(FacesContext context, UIComponent uIComponent, Object value) throws ValidatorException {
		Date oggi = ApplicationUtil.date();
		Date startDateP = (Date) value;
		if (startDateP != null) {
			Date startDate = ApplicationUtil.settaOrarioAData(oggi, startDateP);
			String confirm = null;
			Boolean interval = null;
			Map<String,Object> mappa = uIComponent.getAttributes();
			if(ApplicationUtil.notEmpty(mappa)) {
				confirm = ApplicationUtil.trimToNull((String) mappa.get("confirm")); 
				interval = ApplicationUtil.toBoolean(mappa.get("interval"));
			}
			if(confirm != null  && ApplicationUtil.isTrue(interval))   {
				UIInput endU = ApplicationUtil.findComponent(uIComponent, confirm);
				if (endU != null && endU.isValid()) {
					Date endDateP =  (Date) endU.getValue();
					if (endDateP != null) {
						Date endDate =  ApplicationUtil.settaOrarioAData(oggi, endDateP);
						if (endDate.before(startDate)) {
							//ApplicationUtil.resetComponent(uIComponent, endU, false);
							throw new ValidatorException(Message.addValidatorMessage("valore_non_consentito" , null));
						}
					}
				}
				//ApplicationUtil.resetComponent(uIComponent, endU, true);
			}
		}
	}
}