

const XTITLE = "CalLite CRM";
const XICON = "https://www.callite.it/favicon.png";
const XCACHE  = "chache-page";
const XPAGE = "offline.html";

self.addEventListener("message", (event) => {
	if (event.data && event.data.type === "SKIP_WAITING") {
		self.skipWaiting();
	}
});

self.addEventListener('install', async (event) => {
	event.waitUntil(
		caches.open(XCACHE).then((cache) => cache.add(XPAGE))
	);
});

self.addEventListener('fetch', (event) => {
	if (event.request.mode === 'navigate') {
		event.respondWith((async () => {
			try {
				const preloadResp = await event.preloadResponse;
				if (preloadResp) {
					return preloadResp;
				}
				return await fetch(event.request);
			} catch (error) {
				const cache = await caches.open(XCACHE);
				return await cache.match(XPAGE);
			}
		})());
	}
});

self.addEventListener('sync', (event) => {
	console.log("sync invocato");
});

self.addEventListener('notificationclick', (event) => {
    event.notification.close(); 
   	//var fullPath = self.location.origin + event.notification.data.path; 
    //clients.openWindow(fullPath); 
});

self.addEventListener('activate', (event) => {
  event.waitUntil((async () => {
    if ('navigationPreload' in self.registration) {
      await self.registration.navigationPreload.enable();
    }
  })());
  self.clients.claim();
});

self.addEventListener('push', function(event) {
	if (event.data) {
		console.log(XTITLE + ": ", event.data.text());
		showLocalNotification(XTITLE, event.data.text(), self.registration);
	} else {
		console.log(XTITLE + ": " + "no data");
	}
});

const showLocalNotification = (title, body, swRegistration) => {
	const options = { body, XICON };
	swRegistration.showNotification(XTITLE, options);
}