package event;
import java.lang.reflect.Method;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

import it.asterisk.manager.ManagerEventListener;
import it.asterisk.manager.event.DialBeginEvent;
import it.asterisk.manager.event.DialEndEvent;
import it.asterisk.manager.event.HangupEvent;
import it.asterisk.manager.event.HangupRequestEvent;
import it.asterisk.manager.event.ManagerEvent;
import it.asterisk.manager.event.NewCallerIdEvent;
import it.asterisk.manager.event.NewChannelEvent;
import it.asterisk.manager.event.NewStateEvent;
import it.asterisk.manager.event.OriginateResponseEvent;
import it.asterisk.manager.event.SoftHangupRequestEvent;
import it.callite.utility.ApplicationUtil;
public class ManagerEventResponse implements ManagerEventListener {
	private static String[] excludeC = {"internalActionId", "exten", "privilege", "context", "destContext", "linkedid", "destLinkedid", "priority", "destPriority", "language", "destlanguage", "channel", "destChannel", "dateReceived", "privilege", "source", "class", "systemHashcode"};
	private static String[] excludeE = {"VarSetEvent", "NewExtenEvent"};
	public void onManagerEvent(ManagerEvent event) {
		if (event instanceof OriginateResponseEvent) {
			OriginateResponseEvent evento = (OriginateResponseEvent) event;
			stampa(false, evento);
		} else if(event instanceof HangupEvent) {
			HangupEvent evento = (HangupEvent) event;
			stampa(false, evento);
		} else if (event instanceof HangupRequestEvent) {
			HangupRequestEvent evento = (HangupRequestEvent) event;
			stampa(false, evento);
		} else if (event instanceof SoftHangupRequestEvent) {
			SoftHangupRequestEvent evento = (SoftHangupRequestEvent) event;
			stampa(false, evento);
		} else if (event instanceof NewStateEvent) {
			NewStateEvent evento = (NewStateEvent) event;
			stampa(false, evento);
		} else if(event instanceof DialBeginEvent) {
			DialBeginEvent evento = (DialBeginEvent) event;
			stampa(false, evento);
		} else if(event instanceof DialEndEvent) {
			DialEndEvent evento = (DialEndEvent) event;
			stampa(false, evento);
		} else if(event instanceof NewChannelEvent) {
			NewChannelEvent evento = (NewChannelEvent) event;
			stampa(false, evento);
		} else if(event instanceof NewCallerIdEvent) {
			NewCallerIdEvent evento = (NewCallerIdEvent) event;
			stampa(false, evento);
		} else {
			stampa(true, event);
		}
	}
	public static void stampa(boolean alert, Object a, String ... metodi2) {
		String cName = a.getClass().getSimpleName();
		if(!ApplicationUtil.asList(excludeE).contains(cName)) {
			List<String> sb = new ArrayList<String>();
			for(Method m1 : a.getClass().getMethods()) {
				if(m1.getName().startsWith("get")) {
					try {
						String m = ApplicationUtil.uncapitalize(m1.getName().substring(3));
						if(!ApplicationUtil.asList(excludeC).contains(m) && !ApplicationUtil.asList(metodi2).contains(m)) {
							Object i = m1.invoke(a, new Object[] { } );
							String resp = m + ": " + "'" + i + "'";
							if(i!= null && !sb.contains(resp)) {
								sb.add(resp);
							}
						}
					}
					catch(Exception e) {
						System.out.println(e);
					}
				} 
			}
			if(ApplicationUtil.notEmpty(sb)) {
				Collections.sort(sb);
				String msg = ApplicationUtil.detoken(sb, "; ");
				if(alert) {
					System.err.println(cName + " *** " + msg);
				} else {
					System.out.println(cName + " *** " + msg);
				}
			}
		}
	} 
}