package it.callite.dao;
import java.io.ByteArrayInputStream;
import java.io.File;
import java.io.FileOutputStream;
import java.io.InputStream;
import java.io.OutputStream;
import java.lang.management.ManagementFactory;
import java.lang.management.OperatingSystemMXBean;
import java.util.ArrayList;
import java.util.Date;
import java.util.Iterator;
import java.util.List;
import java.util.Locale;
import java.util.Map;
import java.util.ResourceBundle;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.model.SelectItem;
import javax.faces.model.SelectItemGroup;
import javax.faces.validator.ValidatorException;
import javax.servlet.ServletContext;

import org.hibernate.criterion.Conjunction;
import org.hibernate.criterion.DetachedCriteria;
import org.hibernate.criterion.Disjunction;
import org.hibernate.criterion.MatchMode;
import org.hibernate.criterion.Projections;
import org.hibernate.criterion.Restrictions;
import org.hibernate.criterion.Subqueries;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.core.io.FileSystemResource;
import org.springframework.stereotype.Repository;

import com.sun.faces.application.ApplicationAssociate;
import com.sun.faces.application.ApplicationResourceBundle;

import it.callite.action.DownloadBean;
import it.callite.constants.ConstantsFormat;
import it.callite.constants.ConstantsGlobal;
import it.callite.constants.ConstantsLanguage;
import it.callite.constants.ConstantsMap;
import it.callite.constants.config.DefaultsAnagrafica;
import it.callite.constants.config.DefaultsAutodialer;
import it.callite.constants.config.DefaultsChat;
import it.callite.constants.config.DefaultsData;
import it.callite.constants.config.DefaultsFtp;
import it.callite.constants.config.DefaultsGeneric;
import it.callite.constants.config.DefaultsPannello;
import it.callite.constants.config.DefaultsScheda;
import it.callite.constants.config.DefaultsSleep;
import it.callite.constants.config.DefaultsSmtp;
import it.callite.constants.config.DefaultsStorage;
import it.callite.constants.config.DefaultsValidatore;
import it.callite.criteria.AppuntamentoCriteria;
import it.callite.criteria.ContrattoCriteria;
import it.callite.criteria.generic.RicercaAnagraficaCriteria;
import it.callite.criteria.generic.RicercaStoricoCriteria;
import it.callite.dao.config.ConfigurazionePausaDao;
import it.callite.dao.generic.GenericDao;
import it.callite.log.ErrorLog;
import it.callite.message.Message;
import it.callite.model.Agente;
import it.callite.model.Anagrafica;
import it.callite.model.Autodialer;
import it.callite.model.Campagna;
import it.callite.model.CampoAggiuntivoAnagrafica;
import it.callite.model.CampoAggiuntivoContratto;
import it.callite.model.Closure;
import it.callite.model.Contratto;
import it.callite.model.DatoAggiuntivoAnagrafica;
import it.callite.model.DatoAggiuntivoContratto;
import it.callite.model.EsitoAppuntamento;
import it.callite.model.EsitoArchiviazione;
import it.callite.model.EsitoChiamata;
import it.callite.model.EsitoContratto;
import it.callite.model.Indirizzo;
import it.callite.model.Lista;
import it.callite.model.Opposizione;
import it.callite.model.Prodotto;
import it.callite.model.Smtp;
import it.callite.model.StoriaAppuntamento;
import it.callite.model.StoriaContatto;
import it.callite.model.StoriaContratto;
import it.callite.model.Team;
import it.callite.model.Utente;
import it.callite.model.Zona;
import it.callite.model.config.ConfigPausa;
import it.callite.model.report.GruppoModel;
import it.callite.model.report.MonitorOperatore;
import it.callite.model.sip.SipBuddies;
import it.callite.service.config.ConfigurazioneAnagraficaService;
import it.callite.service.config.ConfigurazioneAutodialerService;
import it.callite.service.config.ConfigurazioneChatService;
import it.callite.service.config.ConfigurazioneDataService;
import it.callite.service.config.ConfigurazioneFtpService;
import it.callite.service.config.ConfigurazioneGenericService;
import it.callite.service.config.ConfigurazionePannelloService;
import it.callite.service.config.ConfigurazioneSchedaService;
import it.callite.service.config.ConfigurazioneSleepService;
import it.callite.service.config.ConfigurazioneSmtpService;
import it.callite.service.config.ConfigurazioneStorageService;
import it.callite.service.config.ConfigurazioneValidatoreService;
import it.callite.utility.ApplicationUtil;
import it.callite.utility.CaptureServer;
import it.callite.utility.DatoAggiuntivoAnagraficaRicerca;
import it.callite.utility.DatoAggiuntivoContrattoRicerca;
import it.callite.utility.FileUpload;
import it.callite.utility.Firewall;
import it.callite.utility.Label;
import it.callite.utility.Logo;
import it.callite.utility.MailSupport;
import it.callite.utility.MyFile;
import it.callite.utility.MyStorage;
import it.callite.utility.MySystem;
import it.callite.utility.RicercaUtils;
import it.callite.utility.StatoServer;
import it.callite.utility.TransizioneDuplicati;
import it.callite.utility.UtilAutodialer;
import it.callite.utility.UtilChat;
import it.callite.utility.UtilFTP;
import it.callite.utility.UtilOffice;
import it.callite.utility.item.AgenteSI;
import it.callite.utility.item.AutodialerSI;
import it.callite.utility.item.CampagnaSI;
import it.callite.utility.item.ContattoSI;
import it.callite.utility.item.EsitoAppuntamentoSI;
import it.callite.utility.item.EsitoArchiviazioneSI;
import it.callite.utility.item.EsitoChiamataSI;
import it.callite.utility.item.EsitoContrattoSI;
import it.callite.utility.item.GenericSI;
import it.callite.utility.item.InternoSI;
import it.callite.utility.item.ListaSI;
import it.callite.utility.item.ProdottoSI;
import it.callite.utility.item.RuoloSI;
import it.callite.utility.item.TeamSI;
import it.callite.utility.item.TrunkSI;
import it.callite.utility.item.UtenteSI;
import it.callite.utility.item.ZonaSI;
import it.callite.utility.utils.LanguageFileFilter;
@SuppressWarnings("serial")
@Repository("impostazioneDao")
public class ImpostazioneDao extends GenericDao {
	@Autowired
	private ConfigurazioneGenericService configurazioneGenericService;
	@Autowired
	private ConfigurazionePannelloService configurazionePannelloService;
	@Autowired
	private ConfigurazioneAnagraficaService configurazioneAnagraficaService;
	@Autowired
	private ConfigurazioneDataService configurazioneDataService;
	@Autowired
	private ConfigurazioneChatService configurazioneChatService;
	@Autowired
	private ConfigurazioneFtpService configurazioneFtpService;
	@Autowired
	private ConfigurazioneAutodialerService configurazioneAutodialerService;
	@Autowired
	private ConfigurazioneValidatoreService configurazioneValidatoreService;
	@Autowired
	private ConfigurazionePausaDao configurazionePausaDao;
	@Autowired
	private ConfigurazioneSchedaService configurazioneSchedaService;
	@Autowired
	private ConfigurazioneSmtpService configurazioneSmtpService;
	@Autowired
	private ConfigurazioneSleepService configurazioneSleepService;
	@Autowired
	private ConfigurazioneStorageService configurazioneStorageService;
	@Autowired
	private ServletContext servletContext;

	public Boolean getSelect() {
		return ApplicationUtil.isTrue(Boolean.valueOf(configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_VISUALIZZA_IDENTIFICATIVO)));
	}

	public Integer privacy() {
		Integer a = Integer.valueOf(configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_GIORNI_PRIVACY));
		return a != null ? a : 0;
	}

	public String getNormativa_privacy() {
		return ApplicationUtil.trimToNull(configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_NORMATIVA_PRIVACY));
	}

	public Boolean getVisualizza_privacy() {
		return ApplicationUtil.isTrue(Boolean.valueOf(configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_VISUALIZZA_PRIVACY)));
	}
	public Boolean getModifica_privacy() {
		return ApplicationUtil.isTrue(Boolean.valueOf(configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_MODIFICA_PRIVACY)));
	}

	public Boolean getAllegatiMassivo() {
		return ApplicationUtil.isTrue(Boolean.valueOf(configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_ALLEGATI_MASSIVO)));
	}

	public Integer getTipo_privacy() {
		String s = ApplicationUtil.trimToNull(configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_TIPO_PRIVACY));
		if(s != null) {
			if(s.equals(ConstantsMap.privacy0)) return ConstantsMap.value0;
			if(s.equals(ConstantsMap.privacy1)) return ConstantsMap.value1;
			if(s.equals(ConstantsMap.privacy2)) return ConstantsMap.value2;
			if(s.equals(ConstantsMap.privacy3)) return ConstantsMap.value3;
		}
		return ConstantsMap.value0;
	}

	public List<String> getSuperusers() {
		List<String> superusers = ApplicationUtil.token(configurazioneGenericService.getValore(DefaultsGeneric.KEY_APPLICATION_SUPERUSER), ConstantsGlobal.colonSeparator);
		if(ApplicationUtil.empty(superusers)) {
			superusers.add(ConstantsGlobal.superuser);
		}
		return superusers;
	}

	public RicercaUtils getLoggerRicerca() {
		Boolean stampa = Boolean.valueOf(configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_RICERCA_LOG));
		Integer timeout = Integer.valueOf(configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_RICERCA_TIMEOUT));
		return new RicercaUtils(ApplicationUtil.isTrue(stampa), timeout);
	}	

	public Boolean getLoggerColonne() {
		Boolean stampa = Boolean.valueOf(configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_RICERCA_COLONNA));
		return ApplicationUtil.isTrue(stampa);
	}	

	public Boolean getSubRicerca() {
		Boolean b = Boolean.valueOf(configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_RICERCA_SUBQUERY));
		return ApplicationUtil.isTrue(b);
	}	

	public Boolean getSommaRicerca() {
		Boolean b = Boolean.valueOf(configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_RICERCA_SOMMA));
		return ApplicationUtil.isTrue(b);
	}

	public Boolean telefonoProtocol() {
		return ApplicationUtil.isTrue(ConstantsGlobal.PHONE);
	}

	public Boolean getContentStorage() {
		return configurazioneStorageService.getValore(DefaultsStorage.KEY_DOCUMENTO_ALLEGATO);
	}

	public Boolean getContentLogo() {
		return configurazioneStorageService.getValore(DefaultsStorage.KEY_DOCUMENTO_LOGO);
	}

	public String getPathBaseW(String path) {
		Boolean s = getContentStorage();
		if(ApplicationUtil.isNotTrue(s)) {
			return configurazioneGenericService.getPathBase(path);
		}
		return null;
	}

	public Logo getPathImmagini() {
		Logo logo = new Logo();
		if(ApplicationUtil.isNotTrue(getContentLogo())) {
			logo.setFile(true);
			logo.setPath(getPercorsoImmagini());
		} else {
			logo.setFile(false);
			logo.setPath(null);
		}
		return logo;
	}

	public void setContentStorage(Boolean valore) {
		configurazioneStorageService.update(DefaultsStorage.KEY_DOCUMENTO_ALLEGATO, valore);
	}

	public void setContentLogo(Boolean valore) {
		configurazioneStorageService.update(DefaultsStorage.KEY_DOCUMENTO_LOGO, valore);
	}

	public String getPercorsoImmagini() {
		return getPathBase(ConstantsGlobal.path_galleria);
	}

	public Boolean cambioPassword() {
		return Boolean.valueOf(configurazioneGenericService.getValore(DefaultsGeneric.KEY_PASSWORD_OBBLIGA_CAMBIO));
	}

	public int cambioPasswordMinTotale() {
		int min = Integer.valueOf(configurazioneGenericService.getValore(DefaultsGeneric.KEY_PASSWORD_MIN_TOTALE));
		return min;
	}
	public int cambioPasswordMinLettere() {
		int min = Integer.valueOf(configurazioneGenericService.getValore(DefaultsGeneric.KEY_PASSWORD_MIN_LETTERE));
		return min;
	}
	public int cambioPasswordMinMinuscole() {
		int min = Integer.valueOf(configurazioneGenericService.getValore(DefaultsGeneric.KEY_PASSWORD_MIN_MINUSCOLE));
		return min;
	}
	public int cambioPasswordMinMaiuscole() {
		int min = Integer.valueOf(configurazioneGenericService.getValore(DefaultsGeneric.KEY_PASSWORD_MIN_MAIUSCOLE));
		return min;
	}
	public int cambioPasswordMinNumeri() {
		int min = Integer.valueOf(configurazioneGenericService.getValore(DefaultsGeneric.KEY_PASSWORD_MIN_NUMERI));
		return min;
	}
	public int cambioPasswordMinSimboli() {
		int min = Integer.valueOf(configurazioneGenericService.getValore(DefaultsGeneric.KEY_PASSWORD_MIN_SIMBOLI));
		return min;
	}

	public String getPathBase(String base) {
		return configurazioneGenericService.getPathBase(base);
	}
	public Boolean getNotificaRapida() {
		return Boolean.valueOf(configurazioneGenericService.getValore(DefaultsGeneric.KEY_MESSAGGISTICA_NOTIFICA_ISTANTANEA));
	}
	
	public Boolean getServers() {
		return Boolean.valueOf(configurazioneGenericService.getValore(DefaultsGeneric.KEY_APPLICATION_SELEZIONA_SERVER));
	}
	
	public Boolean getPaginatore() {
		return Boolean.valueOf(configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_PAGINATORE_MULTIPLO));
	}
	public String getPasswordXLS() {
		return ApplicationUtil.trimToNull(configurazioneGenericService.getValore(DefaultsGeneric.KEY_DOCUMENTO_PASSWORD_XLS));
	}
	public String getPasswordTXT() {
		return ApplicationUtil.trimToNull(configurazioneGenericService.getValore(DefaultsGeneric.KEY_DOCUMENTO_PASSWORD_TXT));
	}
	public String getPasswordPDF() {
		return ApplicationUtil.trimToNull(configurazioneGenericService.getValore(DefaultsGeneric.KEY_DOCUMENTO_PASSWORD_PDF));
	}
	public String getPasswordZIP() {
		return ApplicationUtil.trimToNull(configurazioneGenericService.getValore(DefaultsGeneric.KEY_DOCUMENTO_PASSWORD_ZIP));
	}
	public String getPasswordLCK() {
		return ApplicationUtil.trimToNull(configurazioneGenericService.getValore(DefaultsGeneric.KEY_DOCUMENTO_PASSWORD_LCK));
	}
	public String getFormatoDocumento() {
		String s = ApplicationUtil.trimToNull(configurazioneGenericService.getValore(DefaultsGeneric.KEY_DOCUMENTO_FORMATO));
		if(s == null) {
			s = ConstantsMap.pdf;
		}
		return s;
	}

	public Boolean getTastoSviluppo() {
		return Boolean.valueOf(configurazioneGenericService.getValore(DefaultsGeneric.KEY_APPLICATION_TASTO_SVILUPPO));
	}

	public Boolean getBloccaSheet() {
		return Boolean.valueOf(configurazioneGenericService.getValore(DefaultsGeneric.KEY_APPLICATION_BLOCCA_SHEET));
	}

	public Integer getDuplicatiStatoCampagna() {
		String s = ApplicationUtil.trimToNull(configurazioneAnagraficaService.getValore(DefaultsAnagrafica.KEY_TUTTO_STATO_CAMPAGNA));
		if(s != null) {
			if(s.equals(ConstantsMap.statoL0)) return ConstantsMap.value0;
			if(s.equals(ConstantsMap.statoL1)) return ConstantsMap.value1;
			if(s.equals(ConstantsMap.statoL2)) return ConstantsMap.value2;
			if(s.equals(ConstantsMap.statoL3)) return ConstantsMap.value3;
		}
		return ConstantsMap.value0;
	}

	public Integer loginAdmin() {
		String s = ApplicationUtil.trimToNull(configurazioneGenericService.getValore(DefaultsGeneric.KEY_APPLICATION_ADMIN_LOGIN));
		if(s != null) {
			if(s.equals(ConstantsMap.ulogin0)) return ConstantsMap.value0;
			if(s.equals(ConstantsMap.ulogin1)) return ConstantsMap.value1;
			if(s.equals(ConstantsMap.ulogin2)) return ConstantsMap.value2;
		}
		return ConstantsMap.value0;
	}

	public Integer getDuplicatiAttivoCampagna() {
		String s = ApplicationUtil.trimToNull(configurazioneAnagraficaService.getValore(DefaultsAnagrafica.KEY_TUTTO_ATTIVO_CAMPAGNA));
		if(s != null) {
			if(s.equals(ConstantsMap.attivoL0)) return ConstantsMap.value0;
			if(s.equals(ConstantsMap.attivoL1)) return ConstantsMap.value1;
			if(s.equals(ConstantsMap.attivoL2)) return ConstantsMap.value2;
		}
		return ConstantsMap.value0;
	}
	public Integer getDuplicatiStatoLista() {
		String s = ApplicationUtil.trimToNull(configurazioneAnagraficaService.getValore(DefaultsAnagrafica.KEY_TUTTO_STATO_LISTA));
		if(s != null) {
			if(s.equals(ConstantsMap.statoL0)) return ConstantsMap.value0;
			if(s.equals(ConstantsMap.statoL1)) return ConstantsMap.value1;
			if(s.equals(ConstantsMap.statoL2)) return ConstantsMap.value2;
			if(s.equals(ConstantsMap.statoL3)) return ConstantsMap.value3;
		}
		return ConstantsMap.value0;
	}
	public Integer getDuplicatiAttivoLista() {
		String s = ApplicationUtil.trimToNull(configurazioneAnagraficaService.getValore(DefaultsAnagrafica.KEY_TUTTO_ATTIVO_LISTA));
		if(s != null) {
			if(s.equals(ConstantsMap.attivoL0)) return ConstantsMap.value0;
			if(s.equals(ConstantsMap.attivoL1)) return ConstantsMap.value1;
			if(s.equals(ConstantsMap.attivoL2)) return ConstantsMap.value2;
		}
		return ConstantsMap.value0;
	}

	public Integer sovrascriviPDA() {
		String s = ApplicationUtil.trimToNull(configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_REWRITE_PDA));
		if(s != null) {
			if(s.equals(ConstantsMap.rewrite0)) return ConstantsMap.value0;
			if(s.equals(ConstantsMap.rewrite1)) return ConstantsMap.value1;
			if(s.equals(ConstantsMap.rewrite2)) return ConstantsMap.value2;
		}
		return ConstantsMap.value0;
	}
	public String getPreamboloOperatore() {
		String a = ApplicationUtil.trimToNull(configurazioneGenericService.getValore(DefaultsGeneric.KEY_APPLICATION_PREAMBOLO_OPERATORE));
		return (a != null) ? a : ConstantsGlobal.u_operatore;
	}
	public String getPreamboloUtente() {
		String a = ApplicationUtil.trimToNull(configurazioneGenericService.getValore(DefaultsGeneric.KEY_APPLICATION_PREAMBOLO_UTENTE));
		return (a != null) ? a : ConstantsGlobal.u_utente;
	}
	public String getPreamboloAgente() {
		String a = ApplicationUtil.trimToNull(configurazioneGenericService.getValore(DefaultsGeneric.KEY_APPLICATION_PREAMBOLO_AGENTE));
		return (a != null) ? a : ConstantsGlobal.u_utente;
	}
	public String getPreamboloFattura() {
		String a = ApplicationUtil.trimToNull(configurazioneGenericService.getValore(DefaultsGeneric.KEY_APPLICATION_PREAMBOLO_FATTURA));
		return (a != null) ? a : ConstantsGlobal.u_fattura;
	}
	public String getPreamboloEstratto() {
		String a = ApplicationUtil.trimToNull(configurazioneGenericService.getValore(DefaultsGeneric.KEY_APPLICATION_PREAMBOLO_ESTRATTO));
		return (a != null) ? a : ConstantsGlobal.u_estratto;
	}
	public Boolean getFiltroMultiplo() {
		return Boolean.valueOf(configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_FILTRO_MULTIPLO));
	}
	public Integer getUscitaAutomatica() {
		return Integer.valueOf(configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_USCITA_AUTOMATICA));
	}
	public Integer getScadenzaPassword() {
		return Integer.valueOf(configurazioneGenericService.getValore(DefaultsGeneric.KEY_APPLICATION_CAMBIO_PASSWORD));
	}
	public List<String> getDocumentoEmailNotifica() {
		String a = configurazioneSchedaService.getValore(DefaultsScheda.KEY_SCHEDA_EMAIL_NOTIFICA);
		return ApplicationUtil.token(a, ConstantsGlobal.colonSeparator);
	}
	public List<String> getDocumentoSchedaAnagrafica() {
		String a = configurazioneSchedaService.getValore(DefaultsScheda.KEY_SCHEDA_SCARICA_ANAGRAFICA);
		return ApplicationUtil.token(a, ConstantsGlobal.colonSeparator);
	}
	public List<String> getDocumentoSchedaAppuntamento() {
		String a = configurazioneSchedaService.getValore(DefaultsScheda.KEY_SCHEDA_SCARICA_APPUNTAMENTO);
		return ApplicationUtil.token(a, ConstantsGlobal.colonSeparator);
	}
	public List<String> getDocumentoSchedaContatto() {
		String a = configurazioneSchedaService.getValore(DefaultsScheda.KEY_SCHEDA_SCARICA_CONTATTO);
		return ApplicationUtil.token(a, ConstantsGlobal.colonSeparator);
	}
	public List<String> getDocumentoSchedaContratto() {
		String a = configurazioneSchedaService.getValore(DefaultsScheda.KEY_SCHEDA_SCARICA_CONTRATTO);
		return ApplicationUtil.token(a, ConstantsGlobal.colonSeparator);
	}


	public List<String> getDocumentoDettagliContratto() {
		String a = configurazioneSchedaService.getValore(DefaultsScheda.KEY_SCHEDA_SCARICA_DETTAGLI_CONTRATTO);
		return ApplicationUtil.token(a, ConstantsGlobal.colonSeparator);
	}

	public List<String> getDocumentoDettagliContatto() {
		String a = configurazioneSchedaService.getValore(DefaultsScheda.KEY_SCHEDA_SCARICA_DETTAGLI_CONTATTO);
		return ApplicationUtil.token(a, ConstantsGlobal.colonSeparator);
	}

	public List<String> getDocumentoDettagliAppuntamento() {
		String a = configurazioneSchedaService.getValore(DefaultsScheda.KEY_SCHEDA_SCARICA_DETTAGLI_APPUNTAMENTO);
		return ApplicationUtil.token(a, ConstantsGlobal.colonSeparator);
	}

	public List<String> getDocumentoDettagliAnagrafica() {
		String a = configurazioneSchedaService.getValore(DefaultsScheda.KEY_SCHEDA_SCARICA_DETTAGLI_ANAGRAFICA);
		return ApplicationUtil.token(a, ConstantsGlobal.colonSeparator);
	}

	public List<String> getDocumentoDettagliIndirizzoLegale() {
		String a = configurazioneSchedaService.getValore(DefaultsScheda.KEY_SCHEDA_SCARICA_DETTAGLI_INDIRIZZO_LEGALE);
		return ApplicationUtil.token(a, ConstantsGlobal.colonSeparator);
	}

	public List<String> getDocumentoDettagliIndirizzoOperativo() {
		String a = configurazioneSchedaService.getValore(DefaultsScheda.KEY_SCHEDA_SCARICA_DETTAGLI_INDIRIZZO_OPERATIVO);
		return ApplicationUtil.token(a, ConstantsGlobal.colonSeparator);
	}

	public List<String> getDocumentoDettagliConsenso() {
		String a = configurazioneSchedaService.getValore(DefaultsScheda.KEY_SCHEDA_SCARICA_DETTAGLI_CONSENSO);
		return ApplicationUtil.token(a, ConstantsGlobal.colonSeparator);
	}

	public List<String> getSchedaAnagrafica() {
		String a = configurazioneSchedaService.getValore(DefaultsScheda.KEY_SCHEDA_VISUALIZZA_DETTAGLI_ANAGRAFICA);
		return ApplicationUtil.token(a, ConstantsGlobal.colonSeparator);
	}

	public List<String> getSchedaIndirizzoLegale() {
		String a = configurazioneSchedaService.getValore(DefaultsScheda.KEY_SCHEDA_VISUALIZZA_DETTAGLI_INDIRIZZO_LEGALE);
		return ApplicationUtil.token(a, ConstantsGlobal.colonSeparator);
	}

	public List<String> getSchedaIndirizzoOperativo() {
		String a = configurazioneSchedaService.getValore(DefaultsScheda.KEY_SCHEDA_VISUALIZZA_DETTAGLI_INDIRIZZO_OPERATIVO);
		return ApplicationUtil.token(a, ConstantsGlobal.colonSeparator);
	}

	public List<String> getSchedaConsenso() {
		String a = configurazioneSchedaService.getValore(DefaultsScheda.KEY_SCHEDA_VISUALIZZA_DETTAGLI_CONSENSO);
		return ApplicationUtil.token(a, ConstantsGlobal.colonSeparator);
	}

	public List<String> getSchedaContratto() {
		String a = configurazioneSchedaService.getValore(DefaultsScheda.KEY_SCHEDA_VISUALIZZA_DETTAGLI_CONTRATTO);
		return ApplicationUtil.token(a, ConstantsGlobal.colonSeparator);
	}

	public List<String> getSchedaContatto() {
		String a = configurazioneSchedaService.getValore(DefaultsScheda.KEY_SCHEDA_VISUALIZZA_DETTAGLI_CONTATTO);
		return ApplicationUtil.token(a, ConstantsGlobal.colonSeparator);
	}

	public List<String> getSchedaAppuntamento() {
		String a = configurazioneSchedaService.getValore(DefaultsScheda.KEY_SCHEDA_VISUALIZZA_DETTAGLI_APPUNTAMENTO);
		return ApplicationUtil.token(a, ConstantsGlobal.colonSeparator);
	}
	public Integer getNotificaLogin() {
		String s = ApplicationUtil.trimToNull(configurazioneGenericService.getValore(DefaultsGeneric.KEY_APPLICATION_NOTIFICA_LOGIN));
		if(s != null) {
			if(s.equals(ConstantsMap.notificaL0)) return ConstantsMap.value0;
			if(s.equals(ConstantsMap.notificaL1)) return ConstantsMap.value1;
			if(s.equals(ConstantsMap.notificaL2)) return ConstantsMap.value2;
		}
		return ConstantsMap.value0;
	}
	public Integer getAccessLogType() {
		String s = ApplicationUtil.trimToNull(configurazioneGenericService.getValore(DefaultsGeneric.KEY_APPLICATION_ACCESS_LOG_TYPE));
		if(s != null) {
			if(s.equals(ConstantsMap.logType0)) return ConstantsMap.value0;
			if(s.equals(ConstantsMap.logType1)) return ConstantsMap.value1;
			if(s.equals(ConstantsMap.logType2)) return ConstantsMap.value2;
			if(s.equals(ConstantsMap.logType3)) return ConstantsMap.value3;
		}
		return ConstantsMap.value0;
	}
	public Integer getDownloadLogType() {
		String s = ApplicationUtil.trimToNull(configurazioneGenericService.getValore(DefaultsGeneric.KEY_APPLICATION_DOWNLOAD_LOG_TYPE));
		if(s != null) {
			if(s.equals(ConstantsMap.logType0)) return ConstantsMap.value0;
			if(s.equals(ConstantsMap.logType1)) return ConstantsMap.value1;
			if(s.equals(ConstantsMap.logType2)) return ConstantsMap.value2;
			if(s.equals(ConstantsMap.logType3)) return ConstantsMap.value3;
		}
		return ConstantsMap.value0;
	}

	public Integer getUploadLogType() {
		String s = ApplicationUtil.trimToNull(configurazioneGenericService.getValore(DefaultsGeneric.KEY_APPLICATION_UPLOAD_LOG_TYPE));
		if(s != null) {
			if(s.equals(ConstantsMap.logType0)) return ConstantsMap.value0;
			if(s.equals(ConstantsMap.logType1)) return ConstantsMap.value1;
			if(s.equals(ConstantsMap.logType2)) return ConstantsMap.value2;
			if(s.equals(ConstantsMap.logType3)) return ConstantsMap.value3;
		}
		return ConstantsMap.value0;
	}
	public Integer getAbilitaOTP() {
		String s = ApplicationUtil.trimToNull(configurazioneGenericService.getValore(DefaultsGeneric.KEY_APPLICATION_AUTENTICAZIONE_OTP));
		if(s != null) {
			if(s.equals(ConstantsMap.otp0)) return ConstantsMap.value0;
			if(s.equals(ConstantsMap.otp1)) return ConstantsMap.value1;
			if(s.equals(ConstantsMap.otp2)) return ConstantsMap.value2;
			if(s.equals(ConstantsMap.otp3)) return ConstantsMap.value3;
		}
		return ConstantsMap.value0;
	}

	public Boolean getAbilitaPrenotazione() {
		return Boolean.valueOf(configurazioneGenericService.getValore(DefaultsGeneric.KEY_APPLICATION_ABILITA_PRENOTAZIONE));
	}

	public Boolean getAbilitaRicercaTasto() {
		return Boolean.valueOf(configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_ABILITA_RICERCA_TASTO));
	}
	public Boolean getAbilitaRicercaManuale() {
		return Boolean.valueOf(configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_ABILITA_RICERCA_MANUALE));
	}
	public Integer getAbilitaRicercaAutomatica() {
		return Integer.valueOf(configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_ABILITA_RICERCA_AUTOMATICA));
	}
	public Boolean getAvvioRicercaAutomatica() {
		return Boolean.valueOf(configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_AVVIO_RICERCA_AUTOMATICA));
	}
	public Boolean getSincronia() {
		return Boolean.valueOf(configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_ABILITA_SINCRONIA));
	}
	public Long getSincroniaC() {
		return Long.valueOf(configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_ABILITA_SINCRONIA_C));
	}
	public Long getSincroniaA() {
		return Long.valueOf(configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_ABILITA_SINCRONIA_A));
	}
	public Long getSincroniaM() {
		return Long.valueOf(configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_ABILITA_SINCRONIA_M));
	}
	public Long getSincroniaN() {
		return Long.valueOf(configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_ABILITA_SINCRONIA_N));
	}
	public Long getSincroniaP() {
		return Long.valueOf(configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_ABILITA_SINCRONIA_P));
	}
	public Boolean recLoc() {
		Integer rec = 0;
		String s = ApplicationUtil.trimToNull(configurazioneGenericService.getValore(DefaultsGeneric.KEY_PHONE_REGISTRAZIONE_LOCALE));
		if(s != null) {
			if(s.equals(ConstantsMap.registrazione0)) rec = ConstantsMap.value0;
			if(s.equals(ConstantsMap.registrazione1)) rec = ConstantsMap.value1;
			if(s.equals(ConstantsMap.registrazione2)) rec = ConstantsMap.value2;
		}
		return rec != null ? rec.intValue() == 1 : false;
	}
	public Boolean recLocAuto() {
		Integer rec = 0;
		String s = ApplicationUtil.trimToNull(configurazioneGenericService.getValore(DefaultsGeneric.KEY_PHONE_REGISTRAZIONE_LOCALE));
		if(s != null) {
			if(s.equals(ConstantsMap.registrazione0)) rec = ConstantsMap.value0;
			if(s.equals(ConstantsMap.registrazione1)) rec = ConstantsMap.value1;
			if(s.equals(ConstantsMap.registrazione2)) rec = ConstantsMap.value2;
		}
		return rec != null ? rec.intValue() == 2 : false;
	}
	public Boolean recRem() {
		Integer rec = 0;
		String s = ApplicationUtil.trimToNull(configurazioneGenericService.getValore(DefaultsGeneric.KEY_PHONE_REGISTRAZIONE_REMOTA));
		if(s != null) {
			if(s.equals(ConstantsMap.registrazione0)) rec = ConstantsMap.value0;
			if(s.equals(ConstantsMap.registrazione1)) rec = ConstantsMap.value1;
			if(s.equals(ConstantsMap.registrazione2)) rec = ConstantsMap.value2;
		}
		return rec != null ? rec.intValue() == 1 : false;
	}
	public Boolean recRemAuto() {
		Integer rec = 0;
		String s = ApplicationUtil.trimToNull(configurazioneGenericService.getValore(DefaultsGeneric.KEY_PHONE_REGISTRAZIONE_REMOTA));
		if(s != null) {
			if(s.equals(ConstantsMap.registrazione0)) rec = ConstantsMap.value0;
			if(s.equals(ConstantsMap.registrazione1)) rec = ConstantsMap.value1;
			if(s.equals(ConstantsMap.registrazione2)) rec = ConstantsMap.value2;
		}
		return rec != null ? rec.intValue() == 2 : false;
	}
	public List<ConfigPausa> pausa() {
		return configurazionePausaDao.getValues();
	}
	public Integer intervalloPulizia() {
		return Integer.valueOf(configurazioneGenericService.getValore(DefaultsGeneric.KEY_APPLICATION_INTERVALLO_PULIZIA));
	}
	public long maxImport() {
		String a = ApplicationUtil.trimToNull(configurazioneAnagraficaService.getValore(DefaultsAnagrafica.KEY_TEMPLATE_DIMENSIONE_MASSIMA));
		return ApplicationUtil.asLong(a) * ConstantsGlobal.kb;
	}
	
	public Integer getMaxQuantity() {
		String i = ApplicationUtil.trimToNull(configurazioneAnagraficaService.getValore(DefaultsAnagrafica.KEY_TEMPLATE_MASSIMO_EXCEL));
		return ApplicationUtil.asInteger(i);
	}
	
	public Boolean getEstrazioneListe() {
		return Boolean.valueOf(configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_ESTRAZIONE_LISTE));
	}
	public Boolean getEstrazioneStato() {
		return Boolean.valueOf(configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_ESTRAZIONE_STATO));
	}
	public Boolean getEstrazioneCampagna() {
		return Boolean.valueOf(configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_ESTRAZIONE_CAMPAGNA));
	}
	public Boolean getEstrazionePrioritaria() {
		return Boolean.valueOf(configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_ESTRAZIONE_PRIORITA));
	}

	public String getEstrazioneContatti() {
		return configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_ESTRAZIONE_CONTATTI);
	}
	public Boolean getTransizioneOnOpen() {
		return Boolean.valueOf(configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_APERTURA_PULIZIA_OPEN));
	}
	public TransizioneDuplicati getTransizioneOnEntry() {
		String s = ApplicationUtil.trimToNull(configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_APERTURA_PULIZIA_ENTRY));
		if(s != null && !s.equals(ConstantsMap.NIENTE)) {
			return new TransizioneDuplicati(s);
		}
		return null;
	}
	public TransizioneDuplicati getTransizioneOnImport() {
		String s = ApplicationUtil.trimToNull(configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_APERTURA_PULIZIA_IMPORT));
		if(s != null && !s.equals(ConstantsMap.NIENTE)) {
			return new TransizioneDuplicati(s);
		}
		return null;
	}
	public TransizioneDuplicati getTransizioneOnComplete() {
		String s = ApplicationUtil.trimToNull(configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_APERTURA_PULIZIA_COMPLETE));
		if(s != null && !s.equals(ConstantsMap.NIENTE)) {
			return new TransizioneDuplicati(s);
		}
		return null;
	}
	public TransizioneDuplicati getTransizioneOnSave() {
		String s = ApplicationUtil.trimToNull(configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_APERTURA_PULIZIA_SAVE));
		if(s != null && !s.equals(ConstantsMap.NIENTE)) {
			return new TransizioneDuplicati(s);
		}
		return null;
	}
	public Boolean getEmailObbligatoria() {
		return Boolean.valueOf(configurazioneGenericService.getValore(DefaultsGeneric.KEY_APPLICATION_EMAIL_OBBLIGATORIA));
	}
	public Boolean getConsideraQualifica() {
		return Boolean.valueOf(configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_CONSIDERA_QUALIFICA));
	}

	public Boolean separaDati() {
		return Boolean.valueOf(configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_SEPARA_DATI));
	}
	public Boolean separaTZ() {
		return Boolean.valueOf(configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_SEPARA_TZ));
	}
	public Boolean getOperatoreExtra() {
		return Boolean.valueOf(configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_DATI_EXTRA_OPERATORE));
	}
	public Boolean getFormattaDomanda() {
		return Boolean.valueOf(configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_FORMATTA_CAMPO_AGGIUNTIVO));
	}
	public Boolean getBloccaImportazione() {
		return Boolean.valueOf(configurazioneAnagraficaService.getValore(DefaultsAnagrafica.KEY_TEMPLATE_BLOCCA_IMPORTAZIONE));
	}
	public Boolean getCampoAggiuntivoData() {
		return Boolean.valueOf(configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_DATA_CAMPO_AGGIUNTIVO));
	}

	public Boolean getRaggruppaCampoAggiuntivo() {
		return Boolean.valueOf(configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_RAGGRUPPA_CAMPO_AGGIUNTIVO));
	}
	public Boolean getRaggruppaCampoTemplate() {
		return Boolean.valueOf(configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_RAGGRUPPA_CAMPO_TEMPLATE));
	}
	public Boolean getCampoAggiuntivoModifica() {
		return Boolean.valueOf(configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_MODIFICA_CAMPO_AGGIUNTIVO));
	}
	public Boolean getAllegatoAppuntamento() {
		return Boolean.valueOf(configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_ALLEGATO_APPUNTAMENTO));
	}
	public Boolean getAllegatoContratto() {
		return Boolean.valueOf(configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_ALLEGATO_CONTRATTO));
	}
	public Boolean getAllegatoAnagrafica() {
		return Boolean.valueOf(configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_ALLEGATO_ANAGRAFICA));
	}
	public Boolean getAllegatoContatto() {
		return Boolean.valueOf(configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_ALLEGATO_CONTATTO));
	}
	public Boolean getSpostamentoCalendario() {
		return Boolean.valueOf(configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_SPOSTAMENTO_CALENDARIO));
	}
	public Boolean getGeocoder() {
		return Boolean.valueOf(configurazioneGenericService.getValore(DefaultsGeneric.KEY_GEOCODIFICA_AUTOMATICA));
	}
	public String getKeyGeocodificaMap() {
		String s = ApplicationUtil.trimToNull(configurazioneGenericService.getValore(DefaultsGeneric.KEY_GEOCODIFICA_MAP));
		if(s == null) {
			s = ConstantsGlobal.key_gmaps;
		}
		return s;
	}
	public String getKeyGeocodificaIP() {
		String s = ApplicationUtil.trimToNull(configurazioneGenericService.getValore(DefaultsGeneric.KEY_GEOCODIFICA_IP));
		if(s == null) {
			s = ConstantsGlobal.key_ipstack;
		}
		return s;
	}
	public String getKeyCaptcha_public() {
		String s = ApplicationUtil.trimToNull(configurazioneGenericService.getValore(DefaultsGeneric.KEY_CAPTCHA_PUBLIC));
		if(s == null) {
			s = ConstantsGlobal.key_captcha_public;
		}
		return s;
	}
	public String getKeyCaptcha_private() {
		String s = ApplicationUtil.trimToNull(configurazioneGenericService.getValore(DefaultsGeneric.KEY_CAPTCHA_PRIVATE));
		if(s == null) {
			s = ConstantsGlobal.key_captcha_private;
		}
		return s;
	}
	public Boolean getMarcaturaMultipla() {
		return Boolean.valueOf(configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_MARCATURA_MULTIPLA));
	}

	public String separatore1() {
		return ConstantsGlobal.colonSeparator;
	}
	public String separatore2() {
		return ConstantsGlobal.pipeSeparator;
	}

	public String separatore3() {
		return ConstantsGlobal.commaSeparator;
	}

	public String separatore4() {
		return ConstantsGlobal.negazioneSeparator;
	}
	public String separatoreR() {
		return ConstantsGlobal.remotaSMB;
	}
	public String separatoreA() {
		return ConstantsGlobal.autodialerSMB;
	}
	public String separatoreI() {
		return ConstantsGlobal.inboundSMB;
	}
	public String separatoreT() {
		return ConstantsGlobal.ingressoSMB;
	}
	public String separatoreM() {
		return ConstantsGlobal.messageSeparator;
	}

	public Integer getGiorniAppuntamenti() {
		String i = ApplicationUtil.trimToNull(configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_GIORNI_APPUNTAMENTO));
		return i != null ? Integer.valueOf(i) : null;
	}
	public Integer getGiorniContatti() {
		String i = ApplicationUtil.trimToNull(configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_GIORNI_CONTATTO));
		return i != null ? Integer.valueOf(i) : null;
	}
	public Integer getGiorniContratti() {
		String i = ApplicationUtil.trimToNull(configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_GIORNI_CONTRATTO));
		return i != null ? Integer.valueOf(i) : null;
	}
	public String getPathBase() {
		return configurazioneGenericService.getPathBase();
	}

	public String getPathBaseR(String path) {
		return configurazioneGenericService.getPathBase(path);
	}


	public Boolean salvaComunicazione() {
		return Boolean.valueOf(configurazioneGenericService.getValore(DefaultsGeneric.KEY_APPLICATION_REGISTRA_POSTA));
	}
	public String getApplicazione() {
		String s = ApplicationUtil.trimToNull(configurazioneGenericService.getValore(DefaultsGeneric.KEY_APPLICATION_NAME));
		if(ApplicationUtil.isBlank(s)) {
			return ConstantsLanguage.APPNAME.stampa();
		} else {
			return s;
		}
	}
	public Double getAnomalia() {
		return Double.valueOf(configurazioneGenericService.getValore(DefaultsGeneric.KEY_APPLICATION_ANOMALIA));
	}
	public String getPassword() {
		return ApplicationUtil.trimToEmpty(configurazioneGenericService.getValore(DefaultsGeneric.KEY_APPLICATION_PASSWORD));
	}

	public boolean comparePassword(String password) {
		String store = ApplicationUtil.trimToNull(configurazioneGenericService.getValore(DefaultsGeneric.KEY_APPLICATION_PASSWORD));
		String p = ApplicationUtil.trimToNull(password);
		if(p != null && store != null) {
			return ApplicationUtil.equals(p, store);
		}
		return false;
	}

	public Integer getImmediateCall() {
		String s = ApplicationUtil.trimToNull(configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_IMMEDIATE_CALL_GENERIC));
		if(s != null) {
			if(s.equals(ConstantsMap.immediate0)) return ConstantsMap.value0;
			if(s.equals(ConstantsMap.immediate1)) return ConstantsMap.value1;
			if(s.equals(ConstantsMap.immediate2)) return ConstantsMap.value2;
		}
		return ConstantsMap.value0;
	}
	public Integer getImmediateCallPannello() {
		String s = ApplicationUtil.trimToNull(configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_IMMEDIATE_CALL_PANNELLO));
		if(s != null) {
			if(s.equals(ConstantsMap.immediate0)) return ConstantsMap.value0;
			if(s.equals(ConstantsMap.immediate1)) return ConstantsMap.value1;
		}
		return ConstantsMap.value0;
	}

	public Integer getTimeoutRegistrazione() {
		return Integer.valueOf(configurazioneGenericService.getValore(DefaultsGeneric.KEY_PHONE_TIMEOUT_REGISTRAZIONE));
	}
	public Boolean getDataFineAppuntamento() {
		String s = configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_CALENDARIO_TIPO_APPUNTAMENTO);
		return s.equals(ConstantsMap.appuntamento1);
	}
	public Boolean getDataFineNota() {
		String s = configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_CALENDARIO_TIPO_NOTA);
		return s != null && s.equals(ConstantsMap.nota1);
	}
	public Boolean getStatoPresente() {
		return Boolean.valueOf(configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_STATO_PRECARICATO));
	}
	public Boolean getMostraOccupato() {
		return Boolean.valueOf(configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_MOSTRA_OCCUPATO));
	}
	public Boolean getToggleImmediateC() {
		return Boolean.valueOf(configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_TOGGLE_IMMEDIATE));
	}

	public Boolean getToggleOpenedA() {
		String s = ApplicationUtil.trimToNull(configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_TOGGLE_OPENED));
		if(s != null) {
			if(s.equals(ConstantsMap.toggle0)) return true;
			if(s.equals(ConstantsMap.toggle1)) return false;
		}
		return true;
	}
	public Boolean getToggleClosedA() {
		String s = ApplicationUtil.trimToNull(configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_TOGGLE_CLOSED));
		if(s != null) {
			if(s.equals(ConstantsMap.toggle0)) return true;
			if(s.equals(ConstantsMap.toggle1)) return false;
		}
		return false;
	}
	public Boolean getGestioneRegistrazione() {
		return Boolean.valueOf(configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_GESTIONE_REGISTRAZIONE));
	}
	public Integer getMinTimeAppuntamento() {
		return Integer.valueOf(configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_CALENDARIO_MIN_TEMPO_APPUNTAMENTO));
	}
	public Integer getMinTimeNota() {
		return Integer.valueOf(configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_CALENDARIO_MIN_TEMPO_NOTA));
	}
	
	public Boolean getFormattaTempi() {
		return Boolean.valueOf(configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_FORMATTA_TEMPI));
	}

	public String getHome(){
		String username = ApplicationUtil.trimToEmpty(configurazioneFtpService.getValore(DefaultsFtp.KEY_FTP_LOCAL_USER));
		return ConstantsGlobal.path_home + "/" + username;
	}
	public UtilFTP getUtilFTP(){
		return new UtilFTP(configurazioneFtpService);
	}
	public UtilAutodialer getUtilAutodialer(){
		return new UtilAutodialer(configurazioneAutodialerService);
	}

	public boolean autodialeStatico() {
		Boolean b = Boolean.valueOf(configurazioneAutodialerService.getValore(DefaultsAutodialer.KEY_PREDICTIVE_AMI_DIALPLAN));
		return ApplicationUtil.isTrue(b);
	}

	public boolean autodialeVariabile() {
		Boolean b = Boolean.valueOf(configurazioneAutodialerService.getValore(DefaultsAutodialer.KEY_PREDICTIVE_AMI_VARIABILE));
		return ApplicationUtil.isTrue(b);
	}

	public boolean autodialerControlla() {
		Boolean b = Boolean.valueOf(configurazioneAutodialerService.getValore(DefaultsAutodialer.KEY_PREDICTIVE_AMI_CONTROLLA));
		return ApplicationUtil.isTrue(b);
	}

	public String autodialerCentralino() {
		return ApplicationUtil.trimToNull(configurazioneAutodialerService.getValore(DefaultsAutodialer.KEY_PREDICTIVE_AMI_IP_CENTRALINO));
	}
	public String timeoutCentralino() {
		return ApplicationUtil.trimToNull(configurazioneAutodialerService.getValore(DefaultsAutodialer.KEY_PREDICTIVE_AMI_TIMEOUT));
	}

	public Integer sleepSuono() {
		return Integer.valueOf(configurazioneSleepService.getValore(DefaultsSleep.KEY_SLEEP_AUTODIALER_SUONO));
	}

	public Integer sleepAbbattuta() {
		return Integer.valueOf(configurazioneSleepService.getValore(DefaultsSleep.KEY_SLEEP_AUTODIALER_ABBATTUTA));
	}
	public Integer sleepReady() {
		return Integer.valueOf(configurazioneSleepService.getValore(DefaultsSleep.KEY_SLEEP_AUTODIALER_READY));
	}
	public Integer sleepConsumatore() {
		return Integer.valueOf(configurazioneSleepService.getValore(DefaultsSleep.KEY_SLEEP_AUTODIALER_CONSUMATORE));
	}
	public Integer sleepProduttore() {
		return Integer.valueOf(configurazioneSleepService.getValore(DefaultsSleep.KEY_SLEEP_AUTODIALER_PRODUTTORE));
	}
	public Integer sleepSchedulato() {
		return Integer.valueOf(configurazioneSleepService.getValore(DefaultsSleep.KEY_SLEEP_AUTODIALER_SCHEDULATO));
	}
	public Integer sleepSospendi() {
		return Integer.valueOf(configurazioneSleepService.getValore(DefaultsSleep.KEY_SLEEP_AUTODIALER_SOSPENDI));
	}
	public Integer sleepChiusura() {
		return Integer.valueOf(configurazioneSleepService.getValore(DefaultsSleep.KEY_SLEEP_CHIUSURA_CHIAMATA));
	}

	public UtilChat getUtilChat(){
		return new UtilChat(configurazioneChatService);
	}

	public UtilOffice getUtilOffice(){
		return new UtilOffice(configurazioneGenericService);
	}

	public Boolean getFTPEnabled(){
		return Boolean.valueOf(configurazioneFtpService.getValore(DefaultsFtp.KEY_FTP_ABILITA_FTP));
	}

	public Boolean getPermitDownload(){
		return Boolean.valueOf(configurazioneGenericService.getValore(DefaultsGeneric.KEY_DOCUMENTO_PERMIT_DOWNLOAD));
	}

	public String getUrlBase(){
		return ApplicationUtil.getUrlBase(getURL());
	}

	public String getWebUrlBase(){
		return ApplicationUtil.getWebUrlBase(getURL());
	}
	
	public String getWebUrl(){
		return ApplicationUtil.getWebUrl(getURL());
	}
	
	public String getWebCal(){
		return ApplicationUtil.getWebCal(getURL());
	}
	public String getMapUrl(){
		return ApplicationUtil.getWebUrl(getURL())+ConstantsGlobal.path_web_map;
	}
	public String getAddUrl(){
		return ApplicationUtil.getWebUrl(getURL())+ConstantsGlobal.path_web_address;
	}
	public String getURL(){
		return ApplicationUtil.trimToEmpty(configurazioneGenericService.getValore(DefaultsGeneric.KEY_APPLICATION_URL));
	}
	public Boolean getDownload() {
		return ApplicationUtil.isNotBlank(getUrlBase());
	}
	public String getLinkA(Utente utente) {
		return ConstantsGlobal.path_web_calendar + "/" + utente.getId() +"/" + ApplicationUtil.base64Encoder(utente.getPassword()) +"/" + ConstantsGlobal.events + "." + ConstantsMap.ics;
	}
	public String getLinkC(Utente utente) {
		return ConstantsGlobal.path_web_calendar + "/" + utente.getId() +"/" + ApplicationUtil.base64Encoder(utente.getPassword()) +"/" + ConstantsGlobal.contacts + "." + ConstantsMap.ics;
	}
	public String getFeed(Utente utente) {
		return ConstantsGlobal.path_web_feed + "/" + utente.getId() +"/" + ApplicationUtil.base64Encoder(utente.getPassword()) +"/" + ConstantsGlobal.feed + "." + ConstantsMap.xml;
	}
	public Boolean getSelezionaTutti() {
		return Boolean.valueOf(configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_SELEZIONA_TUTTI));
	} 
	public Boolean getValidaCalendario() {
		return Boolean.valueOf(configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_VALIDA_CALENDARIO));
	} 
	public Boolean getValidaProdotto() {
		return Boolean.valueOf(configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_VALIDA_PRODOTTO));
	}
	public Boolean getRicercaStoricoContratto() {
		return Boolean.valueOf(configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_RICERCA_STORICO_CONTRATTO));
	}
	public Boolean getRicercaStoricoContatto() {
		return Boolean.valueOf(configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_RICERCA_STORICO_CONTATTO));
	}
	public Boolean getRicercaStoricoAppuntamento() {
		return Boolean.valueOf(configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_RICERCA_STORICO_APPUNTAMENTO));
	}
	public Boolean getLog() {
		Boolean b = Boolean.valueOf(configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_STAMPA_LOG));
		return ApplicationUtil.isTrue(b);
	}
	public Boolean getVisualizzaListaPersonali() {
		return Boolean.valueOf(configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_VISUALIZZA_LISTA_PERSONALI));
	}
	public Boolean getModeCalendar() {
		return Boolean.valueOf(configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_MODE_CALENDAR));
	}

	public Integer numeroPaginaCampagne() {
		Integer righe = selezionePagineCampagne();
		if(ApplicationUtil.ltZero(righe)) {
			return ConstantsGlobal.righePagina;
		} else { 
			return righe;
		}
	}
	public Integer selezionePagineCampagne() {
		return Integer.valueOf(configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_NUMERO_PAGINA_CAMPAGNE));
	}
	public Boolean getRecuperaAccount() {
		return Boolean.valueOf(configurazioneGenericService.getValore(DefaultsGeneric.KEY_APPLICATION_RECUPERA_ACCOUNT));
	}
	public Integer getMassimoLogin1() {
		return Integer.valueOf(configurazioneGenericService.getValore(DefaultsGeneric.KEY_APPLICATION_MASSIMO_LOGIN1));
	}
	public Integer getMassimoLogin2() {
		return Integer.valueOf(configurazioneGenericService.getValore(DefaultsGeneric.KEY_APPLICATION_MASSIMO_LOGIN2));
	}
	public String getIndirizzoLogin1() {
		return ApplicationUtil.trimToNull(String.valueOf(configurazioneGenericService.getValore(DefaultsGeneric.KEY_APPLICATION_INDIRIZZO_LOGIN1)));
	}
	public String getIndirizzoLogin2() {
		return ApplicationUtil.trimToNull(String.valueOf(configurazioneGenericService.getValore(DefaultsGeneric.KEY_APPLICATION_INDIRIZZO_LOGIN2)));
	}
	public Boolean getModalitaSitter() {
		return Boolean.valueOf(configurazioneGenericService.getValore(DefaultsGeneric.KEY_APPLICATION_MODALITA_SITTER));
	}
	public Boolean getMostraTimer() {
		return Boolean.valueOf(configurazioneGenericService.getValore(DefaultsGeneric.KEY_APPLICATION_MOSTRA_TIMER));
	}

	public Boolean getMostraScreen() {
		return Boolean.valueOf(configurazioneGenericService.getValore(DefaultsGeneric.KEY_APPLICATION_MOSTRA_SCREEN));
	}
	public Boolean getResizeScreen() {
		return Boolean.valueOf(configurazioneGenericService.getValore(DefaultsGeneric.KEY_APPLICATION_RESIZE_SCREEN));
	}
	public Boolean getMenuScreen() {
		return Boolean.valueOf(configurazioneGenericService.getValore(DefaultsGeneric.KEY_APPLICATION_MENU_SCREEN));
	}
	
	public Integer getSizeScreen() {
		String s = ApplicationUtil.trimToNull(configurazioneGenericService.getValore(DefaultsGeneric.KEY_APPLICATION_SIZE_SCREEN));
		if(s != null) {
			if(s.equals(ConstantsMap.size0)) return ConstantsMap.value0;
			if(s.equals(ConstantsMap.size1)) return ConstantsMap.value1;
			if(s.equals(ConstantsMap.size2)) return ConstantsMap.value2;
			if(s.equals(ConstantsMap.size3)) return ConstantsMap.value3;
			if(s.equals(ConstantsMap.size4)) return ConstantsMap.value4;
			if(s.equals(ConstantsMap.size5)) return ConstantsMap.value5;
			if(s.equals(ConstantsMap.size6)) return ConstantsMap.value6;
			if(s.equals(ConstantsMap.size7)) return ConstantsMap.value7;
		}
		return ConstantsMap.value0;
	}
	
	public Boolean getNascondiPassword() {
		return Boolean.valueOf(configurazioneGenericService.getValore(DefaultsGeneric.KEY_APPLICATION_NASCONDI_PASSWORD));
	}
	public String getRicercaDomandaAnagrafica() {
		return configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_RICERCA_DOMANDA_ANAGRAFICA);
	}
	public String getRicercaDomandaContratto() {
		return configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_RICERCA_DOMANDA_CONTRATTO);
	}
	public Boolean getTabellaDatiAggiuntivi() {
		return Boolean.valueOf(configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_FORMATTA_TABELLA));
	}
	public Boolean getRicercaDomandaAnagraficaSingola() {
		String d = getRicercaDomandaAnagrafica();
		return d != null && d.equals(ConstantsMap.singola);
	}
	public String getRicercaIndirizzo() {
		return configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_RICERCA_INDIRIZZO);
	}
	public String getRicercaConsenso() {
		return configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_RICERCA_CONSENSO);
	}
	public Boolean getRicercaDomandaAnagraficaMultipla() {
		String d = getRicercaDomandaAnagrafica();
		return d != null && d.equals(ConstantsMap.multipla);
	}
	public Boolean getRicercaDomandaContrattoSingola() {
		String d = getRicercaDomandaContratto();
		return d != null && d.equals(ConstantsMap.singola);
	}
	public Boolean getRicercaDomandaContrattoMultipla() {
		String d = getRicercaDomandaContratto();
		return d != null && d.equals(ConstantsMap.multipla);
	}
	public Integer getRicercaIndirizzoScelta() {
		String d = getRicercaIndirizzo();
		if(d != null && d.equals(ConstantsMap.menu)) {
			return 1;
		}
		if(d != null && d.equals(ConstantsMap.aperto)) {
			return 2;
		}
		return 0;
	}

	public Integer getRicercaConsensoScelta() {
		String d = getRicercaConsenso();
		if(d != null && d.equals(ConstantsMap.telefonico)) {
			return 1;
		}
		if(d != null && d.equals(ConstantsMap.messaggistica)) {
			return 2;
		}
		if(d != null && d.equals(ConstantsMap.tutto)) {
			return 3;
		}
		return 0;
	}

	public Boolean getResetContatto() {
		return Boolean.valueOf(configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_PERMETTI_RESET_CONTATTO));
	}
	public Boolean getRevert() {
		return Boolean.valueOf(configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_PERMETTI_REVERT));
	}
	public Integer getLoginMultiplo() {
		String s = ApplicationUtil.trimToNull(configurazioneGenericService.getValore(DefaultsGeneric.KEY_APPLICATION_LOGIN));
		if(s != null) {
			if(s.equals(ConstantsMap.login0)) return ConstantsMap.value0;
			if(s.equals(ConstantsMap.login1)) return ConstantsMap.value1;
			if(s.equals(ConstantsMap.login2)) return ConstantsMap.value2;
			if(s.equals(ConstantsMap.login3)) return ConstantsMap.value3;
			if(s.equals(ConstantsMap.login4)) return ConstantsMap.value4;
		}
		return ConstantsMap.value0;
	}

	public Boolean getControlloUtente() {
		return Boolean.valueOf(configurazioneGenericService.getValore(DefaultsGeneric.KEY_APPLICATION_UTENTE));
	}

	public Boolean getForceReload() {
		return Boolean.valueOf(configurazioneGenericService.getValore(DefaultsGeneric.KEY_APPLICATION_RELOAD));
	}
	public Boolean getPermettiCambioTrunk() {
		return Boolean.valueOf(configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_PERMETTI_CAMBIO_TRUNK));
	}
	public Boolean getAjaxDownload() {
		return Boolean.valueOf(configurazioneGenericService.getValore(DefaultsGeneric.KEY_APPLICATION_DOWNLOAD));
	}
	public String audioSupportato() {
		if(ApplicationUtil.getPath(ConstantsGlobal.path_ffmpeg, true)) {
			String s = ApplicationUtil.trimToNull(configurazioneGenericService.getValore(DefaultsGeneric.KEY_APPLICATION_AUDIO_SUPPORTATO));
			if(s != null && !s.equals(ConstantsMap.VOID)) {
				return s;
			}
		}
		return null;
	}
	public Boolean getConcatenaAudio() {
		if(ApplicationUtil.getPath(ConstantsGlobal.path_ffmpeg, true)) {
			String s = ApplicationUtil.trimToNull(configurazioneGenericService.getValore(DefaultsGeneric.KEY_APPLICATION_AUDIO_SUPPORTATO));
			if(s != null && !s.equals(ConstantsMap.VOID)) {
				return ConstantsMap.audioConcatenabili().contains(s);
			}
		}
		return true;
	}

	public Boolean getConcatenaFile() {
		return Boolean.valueOf(configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_NOTIFICA_CONCATENA_FILE));
	}

	public Boolean getCredit() {
		return Boolean.valueOf(configurazioneGenericService.getValore(DefaultsGeneric.KEY_APPLICATION_CREDITI));
	}
	public Integer getPermettiPrenotazioneInterno() {
		String s = ApplicationUtil.trimToNull(configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_PERMETTI_PRENOTAZIONE_INTERNA));
		if(s != null) {
			if(s.equals(ConstantsMap.inserimento0)) return ConstantsMap.value0;
			if(s.equals(ConstantsMap.inserimento1)) return ConstantsMap.value1;
			if(s.equals(ConstantsMap.inserimento2)) return ConstantsMap.value2;
		}
		return ConstantsMap.value0;
	}
	public Integer getPermettiPrenotazioneEsterno() {
		String s = ApplicationUtil.trimToNull(configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_PERMETTI_PRENOTAZIONE_ESTERNA));
		if(s != null) {
			if(s.equals(ConstantsMap.inserimento0)) return ConstantsMap.value0;
			if(s.equals(ConstantsMap.inserimento1)) return ConstantsMap.value1;
			if(s.equals(ConstantsMap.inserimento2)) return ConstantsMap.value2;
		}
		return ConstantsMap.value0;
	}
	public Integer getPermettiContattoInterno() {
		String s = ApplicationUtil.trimToNull(configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_PERMETTI_CONTATTO_INTERNA));
		if(s != null) {
			if(s.equals(ConstantsMap.inserimento0)) return ConstantsMap.value0;
			if(s.equals(ConstantsMap.inserimento1)) return ConstantsMap.value1;
			if(s.equals(ConstantsMap.inserimento2)) return ConstantsMap.value2;
		}
		return ConstantsMap.value0;
	}
	public Integer getPermettiContattoEsterno() {
		String s = ApplicationUtil.trimToNull(configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_PERMETTI_CONTATTO_ESTERNA));
		if(s != null) {
			if(s.equals(ConstantsMap.inserimento0)) return ConstantsMap.value0;
			if(s.equals(ConstantsMap.inserimento1)) return ConstantsMap.value1;
			if(s.equals(ConstantsMap.inserimento2)) return ConstantsMap.value2;
		}
		return ConstantsMap.value0;
	}
	public Boolean getSelezionaTelefono() {
		return Boolean.valueOf(configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_SELEZIONA_TELEFONO));
	}
	public Boolean getSelezionaGenerale() {
		return Boolean.valueOf(configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_SELEZIONA_GENERALE));
	}
	public Boolean getChiamataDiretta() {
		return Boolean.valueOf(configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_CHIAMATA_DIRETTA));
	}
	public Boolean getSelezionaOrdinamento() {
		return Boolean.valueOf(configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_SELEZIONA_ORDINAMENTO));
	}
	public Boolean getEsitiInline() {
		return Boolean.valueOf(configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_MOSTRA_ESITI_INLINE));
	}
	public Boolean getCampiInline() {
		return Boolean.valueOf(configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_MOSTRA_CAMPI_INLINE));
	}
	public Boolean entraSupervisore() {
		return Boolean.valueOf(configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_ENTRA_SUPERVISORE));
	}
	public String getImpostaDate() {
		return new String(configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_RICERCA_DATE_INIZIALI));
	}
	public String getImpostaFile() {
		return null;
	}
	public Integer mostraStatisticheMessaggi() {
		String s = ApplicationUtil.trimToNull(new String(configurazioneGenericService.getValore(DefaultsGeneric.KEY_MESSAGGISTICA_MOSTRA_STATISTICHE)));
		if(s != null) {
			if(s.equals(ConstantsMap.destinatari)) return 1;
			if(s.equals(ConstantsMap.tutto)) return 2;
		}
		return 0;
	}
	public Boolean getVisualizzaNotificheHome() {
		return Boolean.valueOf(configurazioneGenericService.getValore(DefaultsGeneric.KEY_MESSAGGISTICA_NOTIFICA_HOME));
	}
	public Integer getVisualizzaNotificheRapida() {
		String s = ApplicationUtil.trimToNull(configurazioneGenericService.getValore(DefaultsGeneric.KEY_MESSAGGISTICA_NOTIFICA_RAPIDA));
		if(s != null) {
			if(s.equals(ConstantsMap.notifica0)) return ConstantsMap.value0;
			if(s.equals(ConstantsMap.notifica1)) return ConstantsMap.value1;
			if(s.equals(ConstantsMap.notifica2)) return ConstantsMap.value2;
			if(s.equals(ConstantsMap.notifica3)) return ConstantsMap.value3;
		}
		return Integer.valueOf(-1);
	}
	public Integer getVisualizzaRichiamo() {
		String s = ApplicationUtil.trimToNull(configurazioneGenericService.getValore(DefaultsGeneric.KEY_APPLICATION_NOTIFICA_RICHIAMO));
		if(s != null) {
			if(s.equals(ConstantsMap.richiamo0)) return ConstantsMap.value0;
			if(s.equals(ConstantsMap.richiamo1)) return ConstantsMap.value1;
		}
		return Integer.valueOf(-1);
	}
	public Boolean statisticheSupervisore() {
		return Boolean.valueOf(configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_STATISTICHE_SUPERVISORE));
	}
	public Boolean riepilogRegistro() {
		return Boolean.valueOf(configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_RIEPILOGO_REGISTRO));
	}
	public Boolean statisticheOperatore() {
		return Boolean.valueOf(configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_STATISTICHE_OPERATORE));
	}
	public Boolean menuRuolo() {
		return Boolean.valueOf(configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_MENU_RUOLO));
	}
	public Integer controlloTimer() {
		String s = ApplicationUtil.trimToNull(configurazioneGenericService.getValore(DefaultsGeneric.KEY_PHONE_CONTROLLO_TIMER));
		if(s != null) {
			if(s.equals(ConstantsMap.timer0)) return ConstantsMap.value0;
			if(s.equals(ConstantsMap.timer1)) return ConstantsMap.value1;
			if(s.equals(ConstantsMap.timer2)) return ConstantsMap.value2;
		}
		return 0;
	}
	public Integer controlloInterni() {
		String s = ApplicationUtil.trimToNull(configurazioneGenericService.getValore(DefaultsGeneric.KEY_PHONE_CONTROLLO_INTERNI));
		if(s != null) {
			if(s.equals(ConstantsMap.interno0)) return ConstantsMap.value0;
			if(s.equals(ConstantsMap.interno1)) return ConstantsMap.value1;
			if(s.equals(ConstantsMap.interno2)) return ConstantsMap.value2;
		}
		return 0;
	}

	public Boolean getMonitorInterni() {
		return Boolean.valueOf(configurazioneGenericService.getValore(DefaultsGeneric.KEY_PHONE_MONITOR_INTERNI));
	}
	public Boolean getInternoMultiplo() {
		return Boolean.valueOf(configurazioneGenericService.getValore(DefaultsGeneric.KEY_PHONE_INTERNO_MULTIPLO));
	}
	public Integer getMassimoUtenti() {
		return Integer.valueOf(configurazioneGenericService.getValore(DefaultsGeneric.KEY_APPLICATION_MASSIMO_UTENTI));
	}
	public Boolean visualizzaControlli() {
		return Boolean.valueOf(configurazioneGenericService.getValore(DefaultsGeneric.KEY_PHONE_VISUALIZZA_CONTROLLI));
	}
	public Integer getAttivoControl() {
		return Integer.valueOf(configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_ATTIVO_CONTROL));
	}
	public Boolean riproduciAudio() {
		return Boolean.valueOf(configurazioneGenericService.getValore(DefaultsGeneric.KEY_PHONE_RIPRODUCI_AUDIO));
	}
	
	public String sipTransport() {
		String var = configurazioneGenericService.getValore(DefaultsGeneric.KEY_PHONE_SIP_TRANSPORT);
		return ApplicationUtil.trimToEmpty(var);
	}

	public Boolean sipAEC() {
		return Boolean.valueOf(configurazioneGenericService.getValore(DefaultsGeneric.KEY_PHONE_SIP_AEC));
	}
	public Boolean sipAGC() {
		return Boolean.valueOf(configurazioneGenericService.getValore(DefaultsGeneric.KEY_PHONE_SIP_AGC));
	}
	public String licenza() {
		String licenza = configurazioneGenericService.getValore(DefaultsGeneric.KEY_PHONE_LICENZA);
		return ApplicationUtil.trimToEmpty(licenza);
	}
	public String getTopScript() {
		String a = configurazioneGenericService.getValore(DefaultsGeneric.KEY_APPLICATION_TOP_SCRIPT);
		return ApplicationUtil.trimToEmpty(a);
	}
	public String getBottomScript() {
		String a = configurazioneGenericService.getValore(DefaultsGeneric.KEY_APPLICATION_BOTTOM_SCRIPT);
		return ApplicationUtil.trimToEmpty(a);
	}
	public String server() {
		String server = configurazioneGenericService.getValore(DefaultsGeneric.KEY_PHONE_SERVER);
		return ApplicationUtil.trimToEmpty(server);
	}
	public Integer buddyPorta() {
		return Integer.valueOf(configurazioneChatService.getValore(DefaultsChat.KEY_CHAT_SERVER_PORT));
	}
	public String buddyServer() {
		String server = configurazioneChatService.getValore(DefaultsChat.KEY_CHAT_SERVER_IP);
		return ApplicationUtil.trimToEmpty(server);
	}
	public String serverSTUN() {
		String porta = configurazioneGenericService.getValore(DefaultsGeneric.KEY_PHONE_STUN_SERVER);
		return ApplicationUtil.trimToEmpty(porta);
	}
	public String portaSTUN() {
		String server = configurazioneGenericService.getValore(DefaultsGeneric.KEY_PHONE_STUN_PORT);
		return ApplicationUtil.trimToEmpty(server);
	}

	public String path() {
		String home = getHome();
		return ApplicationUtil.trimToEmpty(home);
	}
	
	public Boolean chatPopup() {
		return ApplicationUtil.eq(chatAbilitata(), 2);
	}
	
	public Boolean chatPhone() {
		return false;
	}
	
	public Boolean chatCentralino() {
		return false;
	}
	public Integer chatAbilitata() {
		if(ApplicationUtil.getService(ConstantsGlobal.service_prosody) || ApplicationUtil.getService(ConstantsGlobal.service_ejabberd) || ApplicationUtil.getService(ConstantsGlobal.service_openfire) || ApplicationUtil.getService(ConstantsGlobal.service_asterisk)) {
			String s = ApplicationUtil.trimToNull(configurazioneChatService.getValore(DefaultsChat.KEY_CHAT_ABILITATO));
			if(s != null) {
				if(s.equals(ConstantsMap.chat0)) return ConstantsMap.value0;
				if(s.equals(ConstantsMap.chat1)) return ConstantsMap.value1;
				if(s.equals(ConstantsMap.chat2)) return ConstantsMap.value2;
			}
		}
		return ConstantsMap.value0;
	}

	public Integer getRealtime() {
		String s = ApplicationUtil.trimToNull(configurazioneAutodialerService.getValore(DefaultsAutodialer.KEY_PREDICTIVE_AMI_REALTIME));
		if(s != null) {
			if(s.equals(ConstantsMap.realtime0)) return ConstantsMap.value0;
			if(s.equals(ConstantsMap.realtime1)) return ConstantsMap.value1;
			if(s.equals(ConstantsMap.realtime2)) return ConstantsMap.value2;
		}
		return ConstantsMap.value0;
	}


	public Integer messaggiPopup() {
		String s = ApplicationUtil.trimToNull(configurazioneGenericService.getValore(DefaultsGeneric.KEY_PHONE_MESSAGGI_POPUP));
		if(s != null) {
			if(s.equals(ConstantsMap.popup0)) return ConstantsMap.value0;
			if(s.equals(ConstantsMap.popup1)) return ConstantsMap.value1;
			if(s.equals(ConstantsMap.popup2)) return ConstantsMap.value2;
		}
		return ConstantsMap.value0;
	}
	
	public Integer porta() {
		return Integer.valueOf(configurazioneGenericService.getValore(DefaultsGeneric.KEY_PHONE_PORTA));
	}

	public String wss() {
		return ApplicationUtil.trimToEmpty(configurazioneGenericService.getValore(DefaultsGeneric.KEY_PHONE_WSS));
	}

	public Integer portaRTP1() {
		String p = ApplicationUtil.trimToNull(configurazioneGenericService.getValore(DefaultsGeneric.KEY_PHONE_RPTPORT1));
		if(p != null) {
			return Integer.valueOf(p);
		}
		return ConstantsGlobal.rtpPort1;
	}

	public Integer portaRTP2() {
		String p = ApplicationUtil.trimToNull(configurazioneGenericService.getValore(DefaultsGeneric.KEY_PHONE_RPTPORT2));
		if(p != null) {
			return Integer.valueOf(p);
		}
		return ConstantsGlobal.rtpPort2;
	}
	public String dominio() {
		return configurazioneGenericService.getValore(DefaultsGeneric.KEY_PHONE_DOMINIO);
	}
	public Integer mostraStoria(Utente utente) {
		boolean storico = (utente == null) || (utente != null && utente.getVisualizzaStorico());
		if(storico) {
			String s = ApplicationUtil.trimToNull(configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_MOSTRA_STORIA_PANNELLO));
			if(s != null) {
				if(s.equals(ConstantsMap.storia0)) return ConstantsMap.value0;
				if(s.equals(ConstantsMap.storia1)) return ConstantsMap.value1;
				if(s.equals(ConstantsMap.storia2)) return ConstantsMap.value2;
			}
		}
		return ConstantsMap.value0;
	}
	public Integer mostraStoriaP(Utente utente) {
		boolean storico = (utente == null) || (utente != null && utente.getVisualizzaStorico());
		if(storico) {
			String s = ApplicationUtil.trimToNull(configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_MOSTRA_STORIA_GENERIC));
			if(s != null) {
				if(s.equals(ConstantsMap.storia0)) return ConstantsMap.value0;
				if(s.equals(ConstantsMap.storia1)) return ConstantsMap.value1;
				if(s.equals(ConstantsMap.storia2)) return ConstantsMap.value2;
			}
		}
		return ConstantsMap.value0;
	}
	
	public Boolean storiaImmediata() {
		String s = ApplicationUtil.trimToNull(configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_MOSTRA_STORIA_PANNELLO));
		if(s != null && s.equals(ConstantsMap.storia1)) {
			return true;
		} else {
			return false;
		}
	}
	public Boolean rilascioChiamate() {
		return Boolean.valueOf(configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_RILASCIO_CHIAMATE));
	}
	public List<String> listaSceltaErrori() {
		return ConstantsMap.getErrori();
	}
	
	public List<String> listaSceltaSuoni() {
		return ConstantsMap.getSuoni();
	}
	public List<String> listaSceltaDtmf() {
		return ConstantsMap.getDtmf();
	}
	public Integer getPrecedenza_personali() {
		String p = ApplicationUtil.trimToNull(configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_PRECEDENZA_PERSONALI));
		if(p != null) {
			if(p.equals(ConstantsMap.campagna)) {
				return 1;
			}
			if(p.equals(ConstantsMap.tutto)) {
				return 2;
			}
		} 
		return 0;
	}

	public String validatore_interno() {
		return ConstantsGlobal.validatore_interno;
	} 

	public String extraValidator() {
		return configurazioneValidatoreService.getValore(DefaultsValidatore.KEY_VALIDATORE_EXTRA);
	} 

	public String validatore_tutto() {
		return configurazioneValidatoreService.getValore(DefaultsValidatore.KEY_VALIDATORE_TUTTO);
	}
	public String validatore_interurbana1() {
		return configurazioneValidatoreService.getValore(DefaultsValidatore.KEY_VALIDATORE_INTERURBANA1);
	} 
	public String validatore_interurbana2() {
		return configurazioneValidatoreService.getValore(DefaultsValidatore.KEY_VALIDATORE_INTERURBANA2);
	} 
	public String validatore_fisso() {
		return configurazioneValidatoreService.getValore(DefaultsValidatore.KEY_VALIDATORE_FISSO);
	} 
	public String validatore_mobile() {
		return configurazioneValidatoreService.getValore(DefaultsValidatore.KEY_VALIDATORE_MOBILE);
	} 
	public String validatore_fax() {
		return configurazioneValidatoreService.getValore(DefaultsValidatore.KEY_VALIDATORE_FAX);
	} 
	public String validatore_altro() {
		return configurazioneValidatoreService.getValore(DefaultsValidatore.KEY_VALIDATORE_ALTRO);
	} 
	public String validatore_email() {
		return configurazioneValidatoreService.getValore(DefaultsValidatore.KEY_VALIDATORE_EMAIL);
	} 
	public String validatore_link() {
		return configurazioneValidatoreService.getValore(DefaultsValidatore.KEY_VALIDATORE_LINK);
	} 
	public String validatore_codice() {
		return configurazioneValidatoreService.getValore(DefaultsValidatore.KEY_VALIDATORE_CODICE);
	} 
	public String validatore_partita() {
		return configurazioneValidatoreService.getValore(DefaultsValidatore.KEY_VALIDATORE_PARTITA);
	} 

	public String chiamataReplace() {
		return ConstantsGlobal.validatore_chiamata;
	} 

	public Integer getOpposizioneForm() {
		String s = ApplicationUtil.trimToNull(configurazioneAnagraficaService.getValore(DefaultsAnagrafica.KEY_TEMPLATE_ANAGRAFICA_OPPOSIZIONE));
		if(s != null) {
			if(s.equals(ConstantsMap.validatore0)) return ConstantsMap.value0;
			if(s.equals(ConstantsMap.validatore1)) return ConstantsMap.value1;
			if(s.equals(ConstantsMap.validatore2)) return ConstantsMap.value2;
			if(s.equals(ConstantsMap.validatore3)) return ConstantsMap.value3;
		}
		return ConstantsMap.value0;
	}
	public Integer getOpposizioneTemplate() {
		String s = ApplicationUtil.trimToNull(configurazioneAnagraficaService.getValore(DefaultsAnagrafica.KEY_TEMPLATE_ANAGRAFICA_OPPOSIZIONE));
		if(s != null) {
			if(s.equals(ConstantsMap.validatore0)) return ConstantsMap.value0;
			if(s.equals(ConstantsMap.validatore1)) return ConstantsMap.value1;
			if(s.equals(ConstantsMap.validatore2)) return ConstantsMap.value2;
			if(s.equals(ConstantsMap.validatore3)) return ConstantsMap.value3;
		}
		return ConstantsMap.value0;
	}

	public String getDuplicatoFissoForm() {
		return configurazioneAnagraficaService.getValore(DefaultsAnagrafica.KEY_FORM_ANAGRAFICA_FISSO_DUPLICATO);
	}
	public String getDuplicatoMobileForm() {
		return configurazioneAnagraficaService.getValore(DefaultsAnagrafica.KEY_FORM_ANAGRAFICA_MOBILE_DUPLICATO);
	}
	public String getDuplicatoFaxForm() {
		return configurazioneAnagraficaService.getValore(DefaultsAnagrafica.KEY_FORM_ANAGRAFICA_FAX_DUPLICATO);
	}
	public String getDuplicatoAltroForm() {
		return configurazioneAnagraficaService.getValore(DefaultsAnagrafica.KEY_FORM_ANAGRAFICA_ALTRO_DUPLICATO);
	}
	public String getDuplicatoEmailForm() {
		return configurazioneAnagraficaService.getValore(DefaultsAnagrafica.KEY_FORM_ANAGRAFICA_EMAIL_DUPLICATO);
	}
	public String getDuplicatoLinkForm() {
		return configurazioneAnagraficaService.getValore(DefaultsAnagrafica.KEY_FORM_ANAGRAFICA_LINK_DUPLICATO);
	}
	public String getDuplicatoCodiceForm() {
		return configurazioneAnagraficaService.getValore(DefaultsAnagrafica.KEY_FORM_ANAGRAFICA_CODICE_DUPLICATO);
	}
	public String getDuplicatoPartitaForm() {
		return configurazioneAnagraficaService.getValore(DefaultsAnagrafica.KEY_FORM_ANAGRAFICA_PARTITA_DUPLICATO);
	}
	public String getDuplicatoFissoTemplate() {
		return configurazioneAnagraficaService.getValore(DefaultsAnagrafica.KEY_TEMPLATE_ANAGRAFICA_FISSO_DUPLICATO);
	}
	public String getDuplicatoMobileTemplate() {
		return configurazioneAnagraficaService.getValore(DefaultsAnagrafica.KEY_TEMPLATE_ANAGRAFICA_MOBILE_DUPLICATO);
	}
	public String getDuplicatoFaxTemplate() {
		return configurazioneAnagraficaService.getValore(DefaultsAnagrafica.KEY_TEMPLATE_ANAGRAFICA_FAX_DUPLICATO);
	}
	public String getDuplicatoAltroTemplate() {
		return configurazioneAnagraficaService.getValore(DefaultsAnagrafica.KEY_TEMPLATE_ANAGRAFICA_ALTRO_DUPLICATO);
	}
	public String getDuplicatoEmailTemplate() {
		return configurazioneAnagraficaService.getValore(DefaultsAnagrafica.KEY_TEMPLATE_ANAGRAFICA_EMAIL_DUPLICATO);
	}
	public String getDuplicatoLinkTemplate() {
		return configurazioneAnagraficaService.getValore(DefaultsAnagrafica.KEY_TEMPLATE_ANAGRAFICA_LINK_DUPLICATO);
	}
	public String getDuplicatoCodiceTemplate() {
		return configurazioneAnagraficaService.getValore(DefaultsAnagrafica.KEY_TEMPLATE_ANAGRAFICA_CODICE_DUPLICATO);
	}
	public String getDuplicatoPartitaTemplate() {
		return configurazioneAnagraficaService.getValore(DefaultsAnagrafica.KEY_TEMPLATE_ANAGRAFICA_PARTITA_DUPLICATO);
	}
	public Boolean getRegulareFissoTemplate() {
		return Boolean.valueOf(configurazioneAnagraficaService.getValore(DefaultsAnagrafica.KEY_TEMPLATE_ANAGRAFICA_FISSO_REGULARE));
	}
	public Boolean getRegulareMobileTemplate() {
		return Boolean.valueOf(configurazioneAnagraficaService.getValore(DefaultsAnagrafica.KEY_TEMPLATE_ANAGRAFICA_MOBILE_REGULARE));
	}
	public Boolean getRegulareFaxTemplate() {
		return Boolean.valueOf(configurazioneAnagraficaService.getValore(DefaultsAnagrafica.KEY_TEMPLATE_ANAGRAFICA_FAX_REGULARE));
	}
	public Boolean getRegulareAltroTemplate() {
		return Boolean.valueOf(configurazioneAnagraficaService.getValore(DefaultsAnagrafica.KEY_TEMPLATE_ANAGRAFICA_ALTRO_REGULARE));
	}
	public Boolean getRegulareEmailTemplate() {
		return Boolean.valueOf(configurazioneAnagraficaService.getValore(DefaultsAnagrafica.KEY_TEMPLATE_ANAGRAFICA_EMAIL_REGULARE));
	}
	public Boolean getRegulareLinkTemplate() {
		return Boolean.valueOf(configurazioneAnagraficaService.getValore(DefaultsAnagrafica.KEY_TEMPLATE_ANAGRAFICA_LINK_REGULARE));
	}
	public Boolean getRegulareCodiceTemplate() {
		return Boolean.valueOf(configurazioneAnagraficaService.getValore(DefaultsAnagrafica.KEY_TEMPLATE_ANAGRAFICA_CODICE_REGULARE));
	}
	public Boolean getRegularePartitaTemplate() {
		return Boolean.valueOf(configurazioneAnagraficaService.getValore(DefaultsAnagrafica.KEY_TEMPLATE_ANAGRAFICA_PARTITA_REGULARE));
	}
	public Boolean getRegulareFissoForm() {
		return Boolean.valueOf(configurazioneAnagraficaService.getValore(DefaultsAnagrafica.KEY_FORM_ANAGRAFICA_FISSO_REGULARE));
	}
	public Boolean getRegulareMobileForm() {
		return Boolean.valueOf(configurazioneAnagraficaService.getValore(DefaultsAnagrafica.KEY_FORM_ANAGRAFICA_MOBILE_REGULARE));
	}
	public Boolean getRegulareFaxForm() {
		return Boolean.valueOf(configurazioneAnagraficaService.getValore(DefaultsAnagrafica.KEY_FORM_ANAGRAFICA_FAX_REGULARE));
	}
	public Boolean getRegulareAltroForm() {
		return Boolean.valueOf(configurazioneAnagraficaService.getValore(DefaultsAnagrafica.KEY_FORM_ANAGRAFICA_ALTRO_REGULARE));
	}
	public Boolean getRegulareEmailForm() {
		return Boolean.valueOf(configurazioneAnagraficaService.getValore(DefaultsAnagrafica.KEY_FORM_ANAGRAFICA_EMAIL_REGULARE));
	}
	public Boolean getRegulareLinkForm() {
		return Boolean.valueOf(configurazioneAnagraficaService.getValore(DefaultsAnagrafica.KEY_FORM_ANAGRAFICA_LINK_REGULARE));
	}
	public Boolean getRegulareCodiceForm() {
		return Boolean.valueOf(configurazioneAnagraficaService.getValore(DefaultsAnagrafica.KEY_FORM_ANAGRAFICA_CODICE_REGULARE));
	}
	public Boolean getRegularePartitaForm() {
		return Boolean.valueOf(configurazioneAnagraficaService.getValore(DefaultsAnagrafica.KEY_FORM_ANAGRAFICA_PARTITA_REGULARE));
	}
	public Boolean getRichiestoFissoTemplate() {
		return Boolean.valueOf(configurazioneAnagraficaService.getValore(DefaultsAnagrafica.KEY_TEMPLATE_ANAGRAFICA_FISSO_RICHIESTO));
	}
	public Boolean getRichiestoMobileTemplate() {
		return Boolean.valueOf(configurazioneAnagraficaService.getValore(DefaultsAnagrafica.KEY_TEMPLATE_ANAGRAFICA_MOBILE_RICHIESTO));
	}
	public Boolean getRichiestoFaxTemplate() {
		return Boolean.valueOf(configurazioneAnagraficaService.getValore(DefaultsAnagrafica.KEY_TEMPLATE_ANAGRAFICA_FAX_RICHIESTO));
	}
	public Boolean getRichiestoAltroTemplate() {
		return Boolean.valueOf(configurazioneAnagraficaService.getValore(DefaultsAnagrafica.KEY_TEMPLATE_ANAGRAFICA_ALTRO_RICHIESTO));
	}
	public Boolean getRichiestoEmailTemplate() {
		return Boolean.valueOf(configurazioneAnagraficaService.getValore(DefaultsAnagrafica.KEY_TEMPLATE_ANAGRAFICA_EMAIL_RICHIESTO));
	}
	public Boolean getRichiestoLinkTemplate() {
		return Boolean.valueOf(configurazioneAnagraficaService.getValore(DefaultsAnagrafica.KEY_TEMPLATE_ANAGRAFICA_LINK_RICHIESTO));
	}
	public Boolean getRichiestoCodiceTemplate() {
		return Boolean.valueOf(configurazioneAnagraficaService.getValore(DefaultsAnagrafica.KEY_TEMPLATE_ANAGRAFICA_CODICE_RICHIESTO));
	}
	public Boolean getRichiestoPartitaTemplate() {
		return Boolean.valueOf(configurazioneAnagraficaService.getValore(DefaultsAnagrafica.KEY_TEMPLATE_ANAGRAFICA_PARTITA_RICHIESTO));
	}
	
	public Integer getTemplateImportCondition() {
		String s = ApplicationUtil.trimToNull(configurazioneAnagraficaService.getValore(DefaultsAnagrafica.KEY_TEMPLATE_IMPORT_CONDITION));
		if(s != null) {
			if(s.equals(ConstantsMap.validatore0)) return ConstantsMap.value0;
			if(s.equals(ConstantsMap.validatore1)) return ConstantsMap.value1;
			if(s.equals(ConstantsMap.validatore2)) return ConstantsMap.value2;
			if(s.equals(ConstantsMap.validatore3)) return ConstantsMap.value3;
		}
		return ConstantsMap.value0;
	}

	public Integer getRicercaDuplicatiVuoti() {
		String s = ApplicationUtil.trimToNull(configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_RICERCA_DUPLICATI_VUOTI));
		if(s != null) {
			if(s.equals(ConstantsMap.validatore1)) return ConstantsMap.value1;
			if(s.equals(ConstantsMap.validatore2)) return ConstantsMap.value2;
			if(s.equals(ConstantsMap.validatore3)) return ConstantsMap.value3;
		}
		return ConstantsMap.value1;
	}
	public Integer getFormImportCondition() {
		String s = ApplicationUtil.trimToNull(configurazioneAnagraficaService.getValore(DefaultsAnagrafica.KEY_FORM_IMPORT_CONDITION));
		if(s != null) {
			if(s.equals(ConstantsMap.validatore0)) return ConstantsMap.value0;
			if(s.equals(ConstantsMap.validatore1)) return ConstantsMap.value1;
			if(s.equals(ConstantsMap.validatore2)) return ConstantsMap.value2;
			if(s.equals(ConstantsMap.validatore3)) return ConstantsMap.value3;
		}
		return ConstantsMap.value0;
	}

	public Integer getOpposizioneImportCondition() {
		String s = ApplicationUtil.trimToNull(configurazioneAnagraficaService.getValore(DefaultsAnagrafica.KEY_OPPOSIZIONE_IMPORT_CONDITION));
		if(s != null) {
			if(s.equals(ConstantsMap.validatore0)) return ConstantsMap.value0;
			if(s.equals(ConstantsMap.validatore1)) return ConstantsMap.value1;
			if(s.equals(ConstantsMap.validatore2)) return ConstantsMap.value2;
			if(s.equals(ConstantsMap.validatore3)) return ConstantsMap.value3;
		}
		return ConstantsMap.value0;
	}

	public Boolean getRichiestoFisso() {
		return Boolean.valueOf(configurazioneAnagraficaService.getValore(DefaultsAnagrafica.KEY_FORM_ANAGRAFICA_FISSO_RICHIESTO));
	}
	public Boolean getRichiestoMobile() {
		return Boolean.valueOf(configurazioneAnagraficaService.getValore(DefaultsAnagrafica.KEY_FORM_ANAGRAFICA_MOBILE_RICHIESTO));
	}
	public Boolean getRichiestoFax() {
		return Boolean.valueOf(configurazioneAnagraficaService.getValore(DefaultsAnagrafica.KEY_FORM_ANAGRAFICA_FAX_RICHIESTO));
	}
	public Boolean getRichiestoAltro() {
		return Boolean.valueOf(configurazioneAnagraficaService.getValore(DefaultsAnagrafica.KEY_FORM_ANAGRAFICA_ALTRO_RICHIESTO));
	}
	public Boolean getRichiestoEmail() {
		return Boolean.valueOf(configurazioneAnagraficaService.getValore(DefaultsAnagrafica.KEY_FORM_ANAGRAFICA_EMAIL_RICHIESTO));
	}
	public Boolean getRichiestoLink() {
		return Boolean.valueOf(configurazioneAnagraficaService.getValore(DefaultsAnagrafica.KEY_FORM_ANAGRAFICA_LINK_RICHIESTO));
	}
	public Boolean getRichiestoCodice() {
		return Boolean.valueOf(configurazioneAnagraficaService.getValore(DefaultsAnagrafica.KEY_FORM_ANAGRAFICA_CODICE_RICHIESTO));
	}
	public Boolean getRichiestoPartita() {
		return Boolean.valueOf(configurazioneAnagraficaService.getValore(DefaultsAnagrafica.KEY_FORM_ANAGRAFICA_PARTITA_RICHIESTO));
	}
	public Boolean getRichiestoNome() {
		return Boolean.valueOf(configurazioneDataService.getValore(DefaultsData.KEY_DATA_NOME_RICHIESTO));
	}
	public Boolean getRichiestoCognome() {
		return Boolean.valueOf(configurazioneDataService.getValore(DefaultsData.KEY_DATA_COGNOME_RICHIESTO));
	}
	public Boolean getRichiestoRagioneSociale() {
		return Boolean.valueOf(configurazioneDataService.getValore(DefaultsData.KEY_DATA_RAGIONESOCIALE_RICHIESTO));
	}
	public Boolean getRichiestoNomeCompleto() {
		return Boolean.valueOf(configurazioneDataService.getValore(DefaultsData.KEY_DATA_NOMECOMPLETO_RICHIESTO));
	}
	public Boolean getRichiestoLuogoNascita() {
		return Boolean.valueOf(configurazioneDataService.getValore(DefaultsData.KEY_DATA_LUOGONASCITA_RICHIESTO));
	}
	public Boolean getRichiestoDataNascita() {
		return Boolean.valueOf(configurazioneDataService.getValore(DefaultsData.KEY_DATA_DATANASCITA_RICHIESTO));
	}

	public Integer getIndirizzoLegale() {
		String s = ApplicationUtil.trimToNull(configurazioneDataService.getValore(DefaultsData.KEY_DATA_INDIRIZZO_LEGALE));
		if(s != null) {
			if(s.equals(ConstantsMap.indirizzo0)) return ConstantsMap.value0;
			if(s.equals(ConstantsMap.indirizzo1)) return ConstantsMap.value1;
			if(s.equals(ConstantsMap.indirizzo2)) return ConstantsMap.value2;
			if(s.equals(ConstantsMap.indirizzo3)) return ConstantsMap.value3;
		}
		return ConstantsMap.value0;
	}
	public Integer getIndirizzoOperativo() {
		String s = ApplicationUtil.trimToNull(configurazioneDataService.getValore(DefaultsData.KEY_DATA_INDIRIZZO_OPERATIVO));
		if(s != null) {
			if(s.equals(ConstantsMap.indirizzo0)) return ConstantsMap.value0;
			if(s.equals(ConstantsMap.indirizzo1)) return ConstantsMap.value1;
			if(s.equals(ConstantsMap.indirizzo2)) return ConstantsMap.value2;
			if(s.equals(ConstantsMap.indirizzo3)) return ConstantsMap.value3;
		}
		return ConstantsMap.value0;
	}
	public Boolean getVisualizzaRuoli() {
		return Boolean.valueOf(configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_VISUALIZZA_RUOLI));
	}
	public Boolean getVisualizzaCampagne() {
		return Boolean.valueOf(configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_VISUALIZZA_CAMPAGNE));
	}
	public Boolean getVisualizzaStorico() {
		return Boolean.valueOf(configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_VISUALIZZA_STORICO));
	}
	public Boolean getVisualizzaRegistrazioni() {
		return Boolean.valueOf(configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_VISUALIZZA_REGISTRAZIONI));
	}
	public Boolean getVisualizzaCronometro() {
		return Boolean.valueOf(configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_VISUALIZZA_CRONOMETRO));
	}
	public Boolean getVisualizzaTimer() {
		return Boolean.valueOf(configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_VISUALIZZA_TIMER));
	}
	public Integer getVisualizzaDettaglio() {
		String s = ApplicationUtil.trimToNull(configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_VISUALIZZA_DETTAGLIO));
		if(s != null) {
			if(s.equals(ConstantsMap.autodialer0)) return ConstantsMap.value0;
			if(s.equals(ConstantsMap.autodialer1)) return ConstantsMap.value1;
			if(s.equals(ConstantsMap.autodialer2)) return ConstantsMap.value2;
		}
		return ConstantsMap.value0;
	}
	public Boolean getVisualizzaTermina() {
		return Boolean.valueOf(configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_VISUALIZZA_TERMINA));
	}
	public Integer getVisualizzaSemaforo() {
		String s = ApplicationUtil.trimToNull(configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_VISUALIZZA_SEMAFORO));
		if(s != null) {
			if(s.equals(ConstantsMap.semaforo0)) return ConstantsMap.value0;
			if(s.equals(ConstantsMap.semaforo1)) return ConstantsMap.value1;
			if(s.equals(ConstantsMap.semaforo2)) return ConstantsMap.value2;
			if(s.equals(ConstantsMap.semaforo3)) return ConstantsMap.value3;
			if(s.equals(ConstantsMap.semaforo4)) return ConstantsMap.value4;
			if(s.equals(ConstantsMap.semaforo5)) return ConstantsMap.value5;
			if(s.equals(ConstantsMap.semaforo6)) return ConstantsMap.value6;
			if(s.equals(ConstantsMap.semaforo7)) return ConstantsMap.value7;
			if(s.equals(ConstantsMap.semaforo8)) return ConstantsMap.value8;
		}
		return ConstantsMap.value0;
	}
	public Boolean getVisualizzaDati() {
		return Boolean.valueOf(configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_VISUALIZZA_DATI));
	}
	public Boolean getVisualizzaPassword() {
		return Boolean.valueOf(configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_VISUALIZZA_PASSWORD));
	}
	public Integer getMostraRichiamiProssimi() {
		String p = ApplicationUtil.trimToNull(configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_MOSTRA_RICHIAMI_PROSSIMI));
		if(p != null) {
			if(p.equals(ConstantsMap.si)) {
				return 1;
			}
			if(p.equals(ConstantsMap.chiama)) {
				return 2;
			}
		} 
		return 0;
	}
	public Boolean getMostraLavorazioneOperatore() {
		return Boolean.valueOf(configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_MOSTRA_LAVORAZIONE_OPERATORE));
	}
	public Boolean getMostraLavorazioneSupervisore() {
		return Boolean.valueOf(configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_MOSTRA_LAVORAZIONE_SUPERVISORE));
	}
	public Boolean getAnagraficheConsentite() {
		String s = getAnagraficheConsentiteImport();
		return s != null && !s.equals(ConstantsMap.no);
	}
	public String getAnagraficheConsentiteText() {
		String s = getAnagraficheConsentiteImport();
		if(s != null) {
			if(s.equals(ConstantsMap.includi)) return Message.addCatalogText("consentite");
			if(s.equals(ConstantsMap.escludi)) return Message.addCatalogText("escluse");
		}
		return "";
	}
	public String getAnagraficheConsentiteImport() {
		return new String(configurazioneAnagraficaService.getValore(DefaultsAnagrafica.KEY_TEMPLATE_ANAGRAFICA_CONSENTITE));
	}
	public Integer getMostraPannello() {
		return Integer.valueOf(configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_MOSTRA_PANNELLO));
	}
	public void validate_date(FacesContext context, UIComponent component, Object input) {
		if(input != null) {
			Date date = (Date) input;
			if (!ApplicationUtil.validateData(date)) {
				throw new ValidatorException(Message.addValidatorMessage("formato.errato" , null));
			}
		}
	}	
	public void validate_prefisso(FacesContext context, UIComponent component, Object input) {
		String var = (String) input;
		if(ApplicationUtil.isNotBlank(var)) {
			String ps = ConstantsGlobal.validatore_prefisso;
			Pattern p = Pattern.compile(ps);
			Matcher m = p.matcher(var);
			boolean b = m.matches();	 		 
			if(!b){
				throw new ValidatorException(Message.addValidatorMessage("formato.errato" , ps));
			}
		}
	}
	
	public void validate_addprefisso(FacesContext context, UIComponent component, Object input) {
		List<String> vs = ApplicationUtil.token((String) input, ConstantsGlobal.colonSeparator);
		if(ApplicationUtil.notEmpty(vs)) {
			for(String var : vs) {
				String ps = ConstantsGlobal.validatore_addprefisso;
				Pattern p = Pattern.compile(ps);
				Matcher m = p.matcher(var);
				boolean b = m.matches();	 		 
				if(!b){
					throw new ValidatorException(Message.addValidatorMessage("formato.errato" , ps + ": " + var));
				}
			}
		}
	}
	public void validate_remprefisso(FacesContext context, UIComponent component, Object input) {
		List<String> vs = ApplicationUtil.token((String) input, ConstantsGlobal.colonSeparator);
		if(ApplicationUtil.notEmpty(vs)) {
			for(String var : vs) {
				String ps = ConstantsGlobal.validatore_remprefisso;
				Pattern p = Pattern.compile(ps);
				Matcher m = p.matcher(var);
				boolean b = m.matches();	 		 
				if(!b){
					throw new ValidatorException(Message.addValidatorMessage("formato.errato" , ps + ": " + var));
				}
			}
		}
	}
	public void avalidate_fisso(FacesContext context, UIComponent component, Object input) {
		String var = (String) input;
		if(getRegulareFissoForm() && ApplicationUtil.isNotBlank(var)) {
			String ps = validatore_fisso();
			if(ApplicationUtil.isNotBlank(ps)) {
				Pattern p = Pattern.compile(ps);
				Matcher m = p.matcher(var);
				boolean b = m.matches();	 		 
				if(!b){
					throw new ValidatorException(Message.addValidatorMessage("formato.errato" , ps));
				}
			}
		}
	}
	public void avalidate_mobile(FacesContext context, UIComponent component, Object input) {
		String var = (String) input;
		if(getRegulareMobileForm() && ApplicationUtil.isNotBlank(var)) {
			String ps = validatore_mobile();
			if(ApplicationUtil.isNotBlank(ps)) {
				Pattern p = Pattern.compile(ps);
				Matcher m = p.matcher(var);
				boolean b = m.matches();	 		 
				if(!b){
					throw new ValidatorException(Message.addValidatorMessage("formato.errato" , ps));
				}
			}
		}
	}
	public void avalidate_fax(FacesContext context, UIComponent component, Object input) {
		String var = (String) input;
		if(getRegulareFaxForm() && ApplicationUtil.isNotBlank(var)) {
			String ps = validatore_fax();
			if(ApplicationUtil.isNotBlank(ps)) {
				Pattern p = Pattern.compile(ps);
				Matcher m = p.matcher(var);
				boolean b = m.matches();	 		 
				if(!b){
					throw new ValidatorException(Message.addValidatorMessage("formato.errato" , ps));
				}
			}
		}
	}	
	public void avalidate_altro(FacesContext context, UIComponent component, Object input) {
		String var = (String) input;
		if(getRegulareAltroForm() && ApplicationUtil.isNotBlank(var)) {
			String ps = validatore_altro();
			if(ApplicationUtil.isNotBlank(ps)) {
				Pattern p = Pattern.compile(ps);
				Matcher m = p.matcher(var);
				boolean b = m.matches();	 		 
				if(!b){
					throw new ValidatorException(Message.addValidatorMessage("formato.errato" , ps));
				}
			}
		}
	}
	public void avalidate_codice(FacesContext context, UIComponent component, Object input) {
		String var = (String) input;
		if(getRegulareCodiceForm() && ApplicationUtil.isNotBlank(var)) {
			String ps = validatore_codice();
			if(ApplicationUtil.isNotBlank(ps)) {
				Pattern p = Pattern.compile(ps);
				Matcher m = p.matcher(var);
				boolean b = m.matches();	 		 
				if(!b){
					throw new ValidatorException(Message.addValidatorMessage("formato.errato" , ps));
				}
			}
		}
	}
	public void avalidate_partita(FacesContext context, UIComponent component, Object input) {
		String var = (String) input;
		if(getRegularePartitaForm() && ApplicationUtil.isNotBlank(var)) {
			String ps = validatore_partita();
			if(ApplicationUtil.isNotBlank(ps)) {
				Pattern p = Pattern.compile(ps);
				Matcher m = p.matcher(var);
				boolean b = m.matches();	 		 
				if(!b){
					throw new ValidatorException(Message.addValidatorMessage("formato.errato" , ps));
				}
			}
		}
	}

	public void avalidate_link(FacesContext context, UIComponent component, Object input) {
		String var = (String) input;
		if(getRegulareLinkForm() && ApplicationUtil.isNotBlank(var)) {
			String ps = validatore_link();
			if(ApplicationUtil.isNotBlank(ps)) {
				Pattern p = Pattern.compile(ps);
				Matcher m = p.matcher(var);
				boolean b = m.matches();	 		 
				if(!b){
					throw new ValidatorException(Message.addValidatorMessage("formato.errato" , ps));
				}
			}
		}
	}

	public void avalidate_email(FacesContext context, UIComponent component, Object input) {
		String var = (String) input;
		if(getRegulareEmailForm() && ApplicationUtil.isNotBlank(var)) {
			String ps = validatore_email();
			if(ApplicationUtil.isNotBlank(ps)) {
				Pattern p = Pattern.compile(ps);
				Matcher m = p.matcher(var);
				boolean b = m.matches();	 		 
				if(!b){
					throw new ValidatorException(Message.addValidatorMessage("formato.errato" , ps));
				}
			}
		}
	}
	public void validate_appendT(FacesContext context, UIComponent component, Object input) {
		String var = (String) input;
		if(ApplicationUtil.isNotBlank(var)) {
			String ps = ConstantsGlobal.validatore_appendT;
			Pattern p = Pattern.compile(ps);
			Matcher m = p.matcher(var);
			boolean b = m.matches();	 		 
			if(!b){
				throw new ValidatorException(Message.addValidatorMessage("formato.errato" , ps));
			}
		}
	}
	public void validate_appendL(FacesContext context, UIComponent component, Object input) {
		String var = (String) input;
		if(ApplicationUtil.isNotBlank(var)) {
			String ps = ConstantsGlobal.validatore_appendL;
			Pattern p = Pattern.compile(ps);
			Matcher m = p.matcher(var);
			boolean b = m.matches();	 		 
			if(!b){
				throw new ValidatorException(Message.addValidatorMessage("formato.errato" , ps));
			}
		}
	}
	public void validate_appendP(FacesContext context, UIComponent component, Object input) {
		String var = (String) input;
		if(ApplicationUtil.isNotBlank(var)) {
			String ps = ConstantsGlobal.validatore_appendP;
			Pattern p = Pattern.compile(ps);
			Matcher m = p.matcher(var);
			boolean b = m.matches();	 		 
			if(!b){
				throw new ValidatorException(Message.addValidatorMessage("formato.errato" , ps));
			}
		}
	}
	public void validate_appendC(FacesContext context, UIComponent component, Object input) {
		String var = (String) input;
		if(ApplicationUtil.isNotBlank(var)) {
			String ps = ConstantsGlobal.validatore_appendC;
			Pattern p = Pattern.compile(ps);
			Matcher m = p.matcher(var);
			boolean b = m.matches();	 		 
			if(!b){
				throw new ValidatorException(Message.addValidatorMessage("formato.errato" , ps));
			}
		}
	}
	public void validate_appendE(FacesContext context, UIComponent component, Object input) {
		String var = (String) input;
		if(ApplicationUtil.isNotBlank(var)) {
			String ps = ConstantsGlobal.validatore_appendE;
			Pattern p = Pattern.compile(ps);
			Matcher m = p.matcher(var);
			boolean b = m.matches();	 		 
			if(!b){
				throw new ValidatorException(Message.addValidatorMessage("formato.errato" , ps));
			}
		}
	}
	public void validate_interno(FacesContext context, UIComponent component, Object input) {
		String var = (String) input;
		if(ApplicationUtil.isNotBlank(var)) {
			String ps = validatore_interno();
			if(!ApplicationUtil.isInterno(var, ps)){
				throw new ValidatorException(Message.addValidatorMessage("formato.errato" , ps));
			}
		}
	}

	public void validate_alink(FacesContext context, UIComponent component, Object input) {
		String var = (String) input;
		if(ApplicationUtil.isNotBlank(var)) {
			String ps = ConstantsGlobal.validatore_alink;
			Pattern p = Pattern.compile(ps);
			Matcher m = p.matcher(var);
			boolean b = m.matches();	 		 
			if(!b){
				throw new ValidatorException(Message.addValidatorMessage("formato.errato" , ps));
			}
		}
	}


	public void validate_cap(FacesContext context, UIComponent component, Object input) {
		String var = (String) input;
		if(ApplicationUtil.isNotBlank(var)) {
			String ps = ConstantsGlobal.validatore_cap;
			Pattern p = Pattern.compile(ps);
			Matcher m = p.matcher(var);
			boolean b = m.matches();	 		 
			if(!b){
				throw new ValidatorException(Message.addValidatorMessage("formato.errato" , ps));
			}
		}
	}	

	public void validate_centralino(FacesContext context, UIComponent component, Object input) {
		String var = (String) input;
		if(ApplicationUtil.isNotBlank(var)) {
			String ps = ConstantsGlobal.validatore_centralino;
			Pattern p = Pattern.compile(ps);
			Matcher m = p.matcher(var);
			boolean b = m.matches();	 		 
			if(!b){
				throw new ValidatorException(Message.addValidatorMessage("formato.errato" , ps));
			}
		}
	}	
	public void validate_callers(FacesContext context, UIComponent component, Object input) {
		List<String> vs = ApplicationUtil.token((String) input, ConstantsGlobal.colonSeparator);
		if(ApplicationUtil.notEmpty(vs)) {
			for(String v : vs) {
				String var = ApplicationUtil.trimToNull(v);
				if(var != null && !var.equals(ConstantsGlobal.callerid)) {
					String ps = ConstantsGlobal.validatore_callers;
					Pattern p = Pattern.compile(ps);
					Matcher m = p.matcher(var);
					boolean b = m.matches();	 		 
					if(!b){
						throw new ValidatorException(Message.addValidatorMessage("formato.errato" , ps + ": " + var));
					}
				}
			}
		}
	}	

	public void validate_musicclass(FacesContext context, UIComponent component, Object input) {
		String var = (String) input;
		if(ApplicationUtil.isNotBlank(var)) {
			String ps = ConstantsGlobal.validatore_musicclass;
			Pattern p = Pattern.compile(ps);
			Matcher m = p.matcher(var);
			boolean b = m.matches();	 		 
			if(!b){
				throw new ValidatorException(Message.addValidatorMessage("formato.errato" , ps));
			}
		}
	}	

	public void validate_inbounds(FacesContext context, UIComponent component, Object input) {
		List<String> vs = ApplicationUtil.token((String) input, ConstantsGlobal.colonSeparator);
		if(ApplicationUtil.notEmpty(vs)) {
			for(String v : vs) {
				String var = ApplicationUtil.trimToNull(v);
				if(var != null) {
					String ps = ConstantsGlobal.validatore_inbound;
					Pattern p = Pattern.compile(ps);
					Matcher m = p.matcher(var);
					boolean b = m.matches();	 		 
					if(!b){
						throw new ValidatorException(Message.addValidatorMessage("formato.errato" , ps + ": " + var));
					}
				}
			}
		}
	}	
	public void validate_emails(FacesContext context, UIComponent component, Object input) {
		List<String> vs = ApplicationUtil.token((String) input, ConstantsGlobal.colonSeparator);
		if(ApplicationUtil.notEmpty(vs)) {
			String ps = validatore_email();
			for(String v : vs) {
				String var = ApplicationUtil.trimToNull(v);
				if(var != null) {
					Pattern p = Pattern.compile(ps);
					Matcher m = p.matcher(var);
					boolean b = m.matches();	 		 
					if(!b){
						throw new ValidatorException(Message.addValidatorMessage("formato.errato" , ps + ": " + var));
					}
				}
			}
		}
	}	
	public void validate_opposizione(FacesContext context, UIComponent component, Object input) {
		String var = (String) input;
		if(ApplicationUtil.isNotBlank(var)) {
			String ps = ConstantsGlobal.validatore_opposizione;
			Pattern p = Pattern.compile(ps);
			Matcher m = p.matcher(var);
			boolean b = m.matches();	 		 
			if(!b){
				throw new ValidatorException(Message.addValidatorMessage("formato.errato" , ps));
			}
		}
	}	
	public void validate_ips(FacesContext context, UIComponent component, Object input) {
		List<String> vs = ApplicationUtil.token((String) input, ConstantsGlobal.colonSeparator);
		if(ApplicationUtil.notEmpty(vs)) {
			for(String var : vs) {
				String ps = ConstantsGlobal.validatore_ip;
				Pattern p = Pattern.compile(ps);
				Matcher m = p.matcher(var);
				boolean b = m.matches();	 		 
				if(!b){
					throw new ValidatorException(Message.addValidatorMessage("formato.errato" , ps + ": " + var));
				}
				boolean c = ApplicationUtil.validateIP(var);
				if(!c){
					throw new ValidatorException(Message.addValidatorMessage("ip.errato" , null));
				}
			}
		}
	}

	public void validate_ip(FacesContext context, UIComponent component, Object input) {
		String var = (String) input;
		if(ApplicationUtil.isNotBlank(var)) {
			String ps = ConstantsGlobal.validatore_ip;
			Pattern p = Pattern.compile(ps);
			Matcher m = p.matcher(var);
			boolean b = m.matches();	 		 
			if(!b){
				throw new ValidatorException(Message.addValidatorMessage("formato.errato" , ps));
			}
			boolean c = ApplicationUtil.validateIP(var);
			if(!c){
				throw new ValidatorException(Message.addValidatorMessage("ip.errato" , null));
			}
		}
	}

	public void validate_nome(FacesContext context, UIComponent component, Object input) {
		String var = (String) input;
		if(ApplicationUtil.isNotBlank(var)) {
			String ps = ConstantsGlobal.validatore_nome;
			Pattern p = Pattern.compile(ps);
			Matcher m = p.matcher(var);
			boolean b = m.matches();	 		 
			if(!b){
				throw new ValidatorException(Message.addValidatorMessage("formato.errato" , ps));
			}
		}
	}	

	public void validate_context(FacesContext context, UIComponent component, Object input) {
		String var = (String) input;
		if(ApplicationUtil.isNotBlank(var)) {
			String ps = ConstantsGlobal.validatore_context;
			Pattern p = Pattern.compile(ps);
			Matcher m = p.matcher(var);
			boolean b = m.matches();	 		 
			if(!b){
				throw new ValidatorException(Message.addValidatorMessage("formato.errato" , ps));
			}
		}
	}	

	public void validate_otp(FacesContext context, UIComponent component, Object input) {
		String var = (String) input;
		if(ApplicationUtil.isNotBlank(var)) {
			String ps = ConstantsGlobal.validatore_otp;
			Pattern p = Pattern.compile(ps);
			Matcher m = p.matcher(var);
			boolean b = m.matches();	 		 
			if(!b){
				throw new ValidatorException(Message.addValidatorMessage("formato.errato" , ps));
			}
		}
	}	

	public void validate_ports(FacesContext context, UIComponent component, Object input) {
		List<String> vs = ApplicationUtil.token((String) input, ConstantsGlobal.portSeparator1);
		if(ApplicationUtil.notEmpty(vs)) {
			for(String var : vs) {
				String ps = ConstantsGlobal.validatore_port;
				Pattern p = Pattern.compile(ps);
				Matcher m = p.matcher(var);
				boolean b = m.matches();	 		 
				if(!b){
					throw new ValidatorException(Message.addValidatorMessage("formato.errato" , ps + ": " + var));
				}
			}
		}
	}	


	public void validate_folder1(FacesContext context, UIComponent component, Object input) {
		String var = (String) input;
		if(ApplicationUtil.isNotBlank(var)) {
			String ps = ConstantsGlobal.validatore_folder1;
			Pattern p = Pattern.compile(ps);
			Matcher m = p.matcher(var);
			boolean b = m.matches();	 		 
			if(!b){
				throw new ValidatorException(Message.addValidatorMessage("formato.errato" , ps));
			}
		}
	}	

	public void validate_folder2(FacesContext context, UIComponent component, Object input) {
		String var = (String) input;
		if(ApplicationUtil.isNotBlank(var)) {
			String ps = ConstantsGlobal.validatore_folder2;
			Pattern p = Pattern.compile(ps);
			Matcher m = p.matcher(var);
			boolean b = m.matches();	 		 
			if(!b){
				throw new ValidatorException(Message.addValidatorMessage("formato.errato" , ps));
			}
		}
	}	

	public void validate_file(FacesContext context, UIComponent component, Object input) {
		String var = (String) input;
		if(ApplicationUtil.isNotBlank(var)) {
			String ps = ConstantsGlobal.validatore_file;
			Pattern p = Pattern.compile(ps);
			Matcher m = p.matcher(var);
			boolean b = m.matches();	 		 
			if(!b){
				throw new ValidatorException(Message.addValidatorMessage("formato.errato" , ps));
			}
		}
	}	

	public void validate_tts(FacesContext context, UIComponent component, Object input) {
		String var = (String) input;
		if(ApplicationUtil.isNotBlank(var)) {
			String ps = ConstantsGlobal.validatore_tts;
			Pattern p = Pattern.compile(ps);
			Matcher m = p.matcher(var);
			boolean b = m.matches();	 		 
			if(!b){
				throw new ValidatorException(Message.addValidatorMessage("formato.errato" , ps));
			}
		}
	}	

	public void validate_path(FacesContext context, UIComponent component, Object input) {
		String var = (String) input;
		if(ApplicationUtil.isNotBlank(var)) {
			String ps = ConstantsGlobal.validatore_path;
			Pattern p = Pattern.compile(ps);
			Matcher m = p.matcher(var);
			boolean b = m.matches();	 		 
			if(!b){
				throw new ValidatorException(Message.addValidatorMessage("formato.errato" , ps));
			}
		}
	}	
	public void validate_ext(FacesContext context, UIComponent component, Object input) {
		String var = (String) input;
		if(ApplicationUtil.isNotBlank(var)) {
			String ps = ConstantsGlobal.validatore_ext;
			Pattern p = Pattern.compile(ps);
			Matcher m = p.matcher(var);
			boolean b = m.matches();	 		 
			if(!b){
				throw new ValidatorException(Message.addValidatorMessage("formato.errato" , ps));
			}
		}
	}

	public int getByTelefono(Long campagnaId, String valore) {
		DetachedCriteria criteria = DetachedCriteria.forClass(Opposizione.class);
		if(ApplicationUtil.gtZero(campagnaId)) {
			criteria.add(Restrictions.eq("campagna.id", campagnaId));
		} else {
			criteria.add(Restrictions.isNull("campagna.id"));
		}
		criteria.add(Restrictions.eq("opposizione", valore));
		return getListSize(criteria);
	}
	@SuppressWarnings("unchecked")
	public List<String> trovaOpposizioni(Long campagnaId) {
		DetachedCriteria criteria = DetachedCriteria.forClass(Opposizione.class);
		if(ApplicationUtil.gtZero(campagnaId)) {
			criteria.add(Restrictions.eq("campagna.id", campagnaId));
		} else {
			criteria.add(Restrictions.isNull("campagna.id"));
		}
		criteria.add(ApplicationUtil.isNotNull("opposizione"));
		criteria.setProjection(Projections.distinct(Projections.property("opposizione")));
		return getList(criteria);
	}
	@SuppressWarnings("unchecked")
	public List<String> trovaDuplicati(String tipo, String c, Long campagnaId, List<Lista> liste) {
		DetachedCriteria criteria = DetachedCriteria.forClass(Anagrafica.class);
		if(c!= null && c.equals(ConstantsMap.all_b)) {
			criteria.createCriteria("contatti", ApplicationUtil.leftJoin()).add(Restrictions.isNull("id"));
		}
		if(c!= null && c.equals(ConstantsMap.all_c)) {
			DetachedCriteria contatti = criteria.createCriteria("contatti");
			DetachedCriteria campagna = contatti.createCriteria("campagna");
			DetachedCriteria lista = contatti.createCriteria("lista");
			Integer dsc = getDuplicatiStatoCampagna();
			Integer dac = getDuplicatiAttivoCampagna();
			Integer dsl = getDuplicatiStatoLista();
			Integer dal = getDuplicatiAttivoLista();
			ApplicationUtil.statoLC(dsc, dac, campagna);
			ApplicationUtil.statoLC(dsl, dal, lista);
		}
		if(c!= null && c.equals(ConstantsMap.all_d)) {
			if(ApplicationUtil.gtZero(campagnaId)) {
				DetachedCriteria contatti = criteria.createCriteria("contatti");
				DetachedCriteria lista = contatti.createCriteria("lista");
				Integer dsl = getDuplicatiStatoLista();
				Integer dal = getDuplicatiAttivoLista();
				ApplicationUtil.statoLC(dsl, dal, lista);
				contatti.add(Restrictions.eq("campagna.id", campagnaId));
			} else {
				if(ApplicationUtil.notEmpty(liste)) {
					List<Long> ln = ApplicationUtil.prendiIdLista(liste);
					DetachedCriteria lista = criteria.createCriteria("lista");
					Integer dsl = getDuplicatiStatoLista();
					Integer dal = getDuplicatiAttivoLista();
					ApplicationUtil.statoLC(dsl, dal, lista);
					lista.add(Restrictions.in("id", ln));
				} else {
					return new ArrayList<String>();
				}
			}
		}
		criteria.add(ApplicationUtil.isNotNull(tipo));
		criteria.setProjection(Projections.distinct(Projections.property(tipo)));
		return getList(criteria);
	}
	@SuppressWarnings("unchecked")
	public List<Long> getIdAnagraficaByCampo(String chiave, String valore, String c, Long campagnaId, List<Lista> liste) {
		DetachedCriteria criteria = DetachedCriteria.forClass(Anagrafica.class);
		criteria.add(Restrictions.eq(chiave, valore));
		if(c!= null && c.equals(ConstantsMap.all_b)) {
			criteria.createCriteria("contatti", ApplicationUtil.leftJoin()).add(Restrictions.isNull("id"));
		}
		if(c!= null && c.equals(ConstantsMap.all_c)) {
			DetachedCriteria contatti = criteria.createCriteria("contatti");
			DetachedCriteria campagna = contatti.createCriteria("campagna");
			DetachedCriteria lista = contatti.createCriteria("lista");
			Integer dsc = getDuplicatiStatoCampagna();
			Integer dac = getDuplicatiAttivoCampagna();
			Integer dsl = getDuplicatiStatoLista();
			Integer dal = getDuplicatiAttivoLista();
			ApplicationUtil.statoLC(dsc, dac, campagna);
			ApplicationUtil.statoLC(dsl, dal, lista);
		}
		if(c!= null && c.equals(ConstantsMap.all_d)) {
			if(ApplicationUtil.gtZero(campagnaId)) {
				DetachedCriteria contatti = criteria.createCriteria("contatti");
				DetachedCriteria lista = contatti.createCriteria("lista");
				Integer dsl = getDuplicatiStatoLista();
				Integer dal = getDuplicatiAttivoLista();
				ApplicationUtil.statoLC(dsl, dal, lista);
				contatti.add(Restrictions.eq("campagna.id", campagnaId));
			} else {
				if(ApplicationUtil.notEmpty(liste)) {
					List<Long> ln = ApplicationUtil.prendiIdLista(liste);
					DetachedCriteria lista = criteria.createCriteria("lista");
					Integer dsl = getDuplicatiStatoLista();
					Integer dal = getDuplicatiAttivoLista();
					ApplicationUtil.statoLC(dsl, dal, lista);
					lista.add(Restrictions.in("id", ln));
				} else {
					return new ArrayList<Long>();
				}
			}
		}
		criteria.setProjection(Projections.distinct(Projections.property("id")));
		return getList(criteria);
	}
	@SuppressWarnings("unchecked")
	public List<String> trovaDuplicatiLista(String tipo, Long listaId) {
		if(ApplicationUtil.gtZero(listaId)) {
			DetachedCriteria criteria = DetachedCriteria.forClass(Anagrafica.class);
			criteria.createCriteria("lista").add(Restrictions.eq("id", listaId));
			criteria.add(ApplicationUtil.isNotNull(tipo));
			criteria.setProjection(Projections.distinct(Projections.property(tipo)));
			return getList(criteria);
		} else {
			return new ArrayList<String>();
		}
	}

	@SuppressWarnings("unchecked")
	public List<String> trovaDuplicatiLista(String tipo, String c, Long listaId) {
		DetachedCriteria criteria = DetachedCriteria.forClass(Anagrafica.class);
		if(c!= null && c.equals(ConstantsMap.all_b)) {
			criteria.createCriteria("contatti", ApplicationUtil.leftJoin()).add(Restrictions.isNull("id"));
		}
		if(c!= null && c.equals(ConstantsMap.all_c)) {
			DetachedCriteria contatti = criteria.createCriteria("contatti");
			DetachedCriteria campagna = contatti.createCriteria("campagna");
			DetachedCriteria lista = contatti.createCriteria("lista");
			Integer dsc = getDuplicatiStatoCampagna();
			Integer dac = getDuplicatiAttivoCampagna();
			Integer dsl = getDuplicatiStatoLista();
			Integer dal = getDuplicatiAttivoLista();
			ApplicationUtil.statoLC(dsc, dac, campagna);
			ApplicationUtil.statoLC(dsl, dal, lista);
		}
		if(c!= null && c.equals(ConstantsMap.all_d)) {
			//criteria.createCriteria("lista").add(Restrictions.eq("id", listaId));
			return new ArrayList<String>();
		}
		criteria.add(ApplicationUtil.isNotNull(tipo));
		criteria.setProjection(Projections.distinct(Projections.property(tipo)));
		return getList(criteria);

	}
	public void validate_tutto(FacesContext context, UIComponent component, Object input) {
		String var = (String) input;
		if(ApplicationUtil.isNotBlank(var)) {
			String ps = validatore_tutto();
			if(ApplicationUtil.isNotBlank(ps)) {
				Pattern p = Pattern.compile(ps);
				Matcher m = p.matcher(var);
				boolean b = m.matches();	 	
				if(!b){
					throw new ValidatorException(Message.addValidatorMessage("formato.errato" , ps));
				}
			}
		}
	}
	public void validate_numero(FacesContext context, UIComponent component, Object input) {
		String var = (String) input;
		if(ApplicationUtil.isNotBlank(var)) {
			String ps = ConstantsGlobal.validatore_numero;
			Pattern p = Pattern.compile(ps);
			Matcher m = p.matcher(var);
			boolean b = m.matches();	 		 
			if(!b){
				throw new ValidatorException(Message.addValidatorMessage("formato.errato" , ps));
			}
		}
	}
	
	public void validate_intero(FacesContext context, UIComponent component, Object input) {
		String var = (String) input;
		if(ApplicationUtil.isNotBlank(var)) {
			String ps = ConstantsGlobal.validatore_intero;
			Pattern p = Pattern.compile(ps);
			Matcher m = p.matcher(var);
			boolean b = m.matches();	 		 
			if(!b){
				throw new ValidatorException(Message.addValidatorMessage("formato.errato" , ps));
			}
		}
	}
	public void validate_fisso(FacesContext context, UIComponent component, Object input) {
		String var = (String) input;
		if(ApplicationUtil.isNotBlank(var)) {
			String ps = validatore_fisso();
			if(ApplicationUtil.isNotBlank(ps)) {
				Pattern p = Pattern.compile(ps);
				Matcher m = p.matcher(var);
				boolean b = m.matches();	 		 
				if(!b){
					throw new ValidatorException(Message.addValidatorMessage("formato.errato" , ps));
				}
			}
		}
	}
	public void validate_mobile(FacesContext context, UIComponent component, Object input) {
		String var = (String) input;
		if(ApplicationUtil.isNotBlank(var)) {
			String ps = validatore_mobile();
			if(ApplicationUtil.isNotBlank(ps)) {
				Pattern p = Pattern.compile(ps);
				Matcher m = p.matcher(var);
				boolean b = m.matches();	 		 
				if(!b){
					throw new ValidatorException(Message.addValidatorMessage("formato.errato" , ps));
				}
			}
		}
	}
	public void validate_fax(FacesContext context, UIComponent component, Object input) {
		String var = (String) input;
		if(ApplicationUtil.isNotBlank(var)) {
			String ps = validatore_fax();
			if(ApplicationUtil.isNotBlank(ps)) {
				Pattern p = Pattern.compile(ps);
				Matcher m = p.matcher(var);
				boolean b = m.matches();	 		 
				if(!b){
					throw new ValidatorException(Message.addValidatorMessage("formato.errato" , ps));
				}
			}
		}
	}	
	public void validate_altro(FacesContext context, UIComponent component, Object input) {
		String var = (String) input;
		if(ApplicationUtil.isNotBlank(var)) {
			String ps = validatore_altro();
			if(ApplicationUtil.isNotBlank(ps)) {
				Pattern p = Pattern.compile(ps);
				Matcher m = p.matcher(var);
				boolean b = m.matches();	 		 
				if(!b){
					throw new ValidatorException(Message.addValidatorMessage("formato.errato" , ps));
				}
			}
		}
	}
	public void validate_codice(FacesContext context, UIComponent component, Object input) {
		String var = (String) input;
		if(ApplicationUtil.isNotBlank(var)) {
			String ps = validatore_codice();
			if(ApplicationUtil.isNotBlank(ps)) {
				Pattern p = Pattern.compile(ps);
				Matcher m = p.matcher(var);
				boolean b = m.matches();	 		 
				if(!b){
					throw new ValidatorException(Message.addValidatorMessage("formato.errato" , ps));
				}
			}
		}
	}
	public void validate_partita(FacesContext context, UIComponent component, Object input) {
		String var = (String) input;
		if(ApplicationUtil.isNotBlank(var)) {
			String ps = validatore_partita();
			if(ApplicationUtil.isNotBlank(ps)) {
				Pattern p = Pattern.compile(ps);
				Matcher m = p.matcher(var);
				boolean b = m.matches();	 		 
				if(!b){
					throw new ValidatorException(Message.addValidatorMessage("formato.errato" , ps));
				}
			}
		}
	}
	public void validate_link(FacesContext context, UIComponent component, Object input) {
		String var = (String) input;
		if(ApplicationUtil.isNotBlank(var)) {
			String ps = validatore_link();
			if(ApplicationUtil.isNotBlank(ps)) {
				Pattern p = Pattern.compile(ps);
				Matcher m = p.matcher(var);
				boolean b = m.matches();	 		 
				if(!b){
					throw new ValidatorException(Message.addValidatorMessage("formato.errato" , ps));
				}
			}
		}
	}
	public void validate_email(FacesContext context, UIComponent component, Object input) {
		String var = (String) input;
		if(ApplicationUtil.isNotBlank(var)) {
			String ps = validatore_email();
			if(ApplicationUtil.isNotBlank(ps)) {
				Pattern p = Pattern.compile(ps);
				Matcher m = p.matcher(var);
				boolean b = m.matches();	 		 
				if(!b){
					throw new ValidatorException(Message.addValidatorMessage("formato.errato" , ps));
				}
			}
		}
	}

	public void validate_pin(FacesContext context, UIComponent component, Object input) {
		String var = (String) input;
		if(ApplicationUtil.isNotBlank(var)) {
			String ps = ConstantsGlobal.validatore_pin;
			Pattern p = Pattern.compile(ps);
			Matcher m = p.matcher(var);
			boolean b = m.matches();	 		 
			if(!b){
				throw new ValidatorException(Message.addValidatorMessage("formato.errato" , ps));
			}
		}
	}	
	public List<StatoServer> getServer() {
		List<StatoServer> ls = new ArrayList<StatoServer>();
		for(String service : ConstantsGlobal.SERVICE) {
			List<StatoServer> fws = getService(service);
			if(ApplicationUtil.notEmpty(fws)) {
				for(StatoServer fw : fws) {
					if(ApplicationUtil.gtZero(fw.getPorta())) {
						ls.add(fw);
					}
				}
			}
		}
		return ls;
	}

	public boolean isShell() {
		if(ApplicationUtil.getService(ConstantsGlobal.service_shell)) {
			return ApplicationUtil.gtZero(shellPorta());
		}
		return false;
	}

	public boolean isFirewall() {
		return ApplicationUtil.getPath(ConstantsGlobal.path_firewall, false);
	}

	public void ricarica(StatoServer s, String azione) {
		if(ApplicationUtil.getService(s.getService())) {
			ApplicationUtil.executeRuntime(new String[]{ConstantsGlobal.path_shell, "-c", "systemctl" + " " + azione + " " + s.getService()});
		}
	}
	public List<SelectItem> getRuoliValori1() {
		List<SelectItem> list = new ArrayList<SelectItem>();
		for(String s : ApplicationUtil.ruoliValori1()) {
			list.add(new SelectItem(s, Message.addCatalogText("ruolo." + s)));
		}
		return list;
	}
	public List<SelectItem> getRuoliValori2() {
		List<SelectItem> list = new ArrayList<SelectItem>();
		for(String s : ApplicationUtil.ruoliValori2()) {
			list.add(new SelectItem(s, Message.addCatalogText("ruolo." + s)));
		}
		return list;
	}
	public boolean valuta(List<ContattoSI> c) {
		if(ApplicationUtil.isTrue(getTransizioneOnOpen())) {
			return ApplicationUtil.notEmpty(c);
		}
		return true;
	}
	public String getDefaultCodec() {
		String s = ApplicationUtil.trimToNull(configurazioneGenericService.getValore(DefaultsGeneric.KEY_PHONE_CODEC));
		if(s != null && !s.equals(ConstantsMap.VOID)) {
			return s;
		}
		return "";
	}
	@SuppressWarnings("unchecked")
	public List<Long> getCampoAnagrafica(String chiave, String valore) {
		DetachedCriteria criteria = DetachedCriteria.forClass(DatoAggiuntivoAnagrafica.class);
		if(chiave != null) {
			criteria.createCriteria("campo_aggiuntivo").add(Restrictions.eq("chiave", chiave));
		}
		criteria.add(Restrictions.eq("valore", valore));
		criteria.setProjection(Projections.distinct(Projections.property("id")));
		return getList(criteria);
	}
	@SuppressWarnings("unchecked")
	public List<Long> getCampoContratto(String chiave, String valore) {
		DetachedCriteria criteria = DetachedCriteria.forClass(DatoAggiuntivoContratto.class);
		if(chiave != null) {
			criteria.createCriteria("campo_aggiuntivo").add(Restrictions.eq("chiave", chiave));
		}
		criteria.add(Restrictions.eq("valore", valore));
		criteria.setProjection(Projections.distinct(Projections.property("id")));
		return getList(criteria);
	}
	public Boolean getBloccaEliminazione() {
		return Boolean.valueOf(configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_BLOCCA_ELIMINAZIONE));
	}
	public Boolean getLimitaAzioniBackoffice() {
		return Boolean.valueOf(configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_LIMITA_AZIONI_BACKOFFICE));
	}
	public Boolean getLimitaAzioniManager() {
		return Boolean.valueOf(configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_LIMITA_AZIONI_MANAGER));
	}
	public Boolean getLimitaRicercaBackoffice() {
		return Boolean.valueOf(configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_LIMITA_RICERCA_BACKOFFICE));
	}
	public Boolean getLimitaRicercaManager() {
		return Boolean.valueOf(configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_LIMITA_RICERCA_MANAGER));
	}
	public Boolean getLimitaDatiBackoffice() {
		return Boolean.valueOf(configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_LIMITA_DATI_BACKOFFICE));
	}
	public Boolean getLimitaDatiManager() {
		return Boolean.valueOf(configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_LIMITA_DATI_MANAGER));
	}
	public Boolean getLimitaModificaBackoffice() {
		return Boolean.valueOf(configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_LIMITA_MODIFICA_BACKOFFICE));
	}
	public Boolean getLimitaModificaManager() {
		return Boolean.valueOf(configurazionePannelloService.getValore(DefaultsPannello.KEY_PANNELLO_LIMITA_MODIFICA_MANAGER));
	}
	public List<SelectItem> getLimitaCampagnaSI() {
		List<SelectItem> list = new ArrayList<SelectItem>();
		list.add(new SelectItem(ConstantsMap.campagna0, Message.addCatalogText(ConstantsMap.campagna0)));
		list.add(new SelectItem(ConstantsMap.campagna1, Message.addCatalogText(ConstantsMap.campagna1)));
		list.add(new SelectItem(ConstantsMap.campagna2, Message.addCatalogText(ConstantsMap.campagna2)));
		list.add(new SelectItem(ConstantsMap.campagna3, Message.addCatalogText(ConstantsMap.campagna3)));
		return list;
	}

	public List<SelectItem> getLimitaPermessiSI() {
		List<SelectItem> list = new ArrayList<SelectItem>();
		list.add(new SelectItem(ConstantsMap.team0, Message.addCatalogText(ConstantsMap.team0)));
		list.add(new SelectItem(ConstantsMap.team1, Message.addCatalogText(ConstantsMap.team1)));
		list.add(new SelectItem(ConstantsMap.team2, Message.addCatalogText(ConstantsMap.team2)));
		return list;
	}

	public Integer shellPorta() {
		String p = ApplicationUtil.trimToNull(configurazioneGenericService.getValore(DefaultsGeneric.KEY_APPLICATION_SHELL));
		if(p != null) {
			return Integer.valueOf(p);
		}
		return 0;
	}

	public MailSupport getMailSupport(boolean single) {
		String mail_protocol = ApplicationUtil.trimToNull(configurazioneSmtpService.getValore(DefaultsSmtp.KEY_SMTP_PROTOCOL));
		String mail_host = ApplicationUtil.trimToNull(configurazioneSmtpService.getValore(DefaultsSmtp.KEY_SMTP_HOST));
		String mail_encryption = ApplicationUtil.trimToNull(configurazioneSmtpService.getValore(DefaultsSmtp.KEY_SMTP_ENCRYPTION));
		String mail_user = ApplicationUtil.trimToNull(configurazioneSmtpService.getValore(DefaultsSmtp.KEY_SMTP_USER));
		String mail_password = ApplicationUtil.trimToNull(configurazioneSmtpService.getValore(DefaultsSmtp.KEY_SMTP_PASSWORD));
		String mail_mittente = ApplicationUtil.trimToNull(configurazioneSmtpService.getValore(DefaultsSmtp.KEY_SMTP_MITTENTE));
		String mail_from = ApplicationUtil.trimToNull(configurazioneSmtpService.getValore(DefaultsSmtp.KEY_SMTP_FROM));
		Boolean mail_auth = Boolean.valueOf(configurazioneSmtpService.getValore(DefaultsSmtp.KEY_SMTP_AUTH));
		Integer mail_port = Integer.valueOf(configurazioneSmtpService.getValore(DefaultsSmtp.KEY_SMTP_PORT));
		Boolean mail_pec = Boolean.valueOf(configurazioneSmtpService.getValore(DefaultsSmtp.KEY_SMTP_PEC));
		Boolean mail_debug = Boolean.valueOf(configurazioneSmtpService.getValore(DefaultsSmtp.KEY_SMTP_DEBUG));
		return new MailSupport(single, mail_pec, mail_protocol, mail_host, mail_encryption, mail_user, mail_password, mail_port, mail_auth, mail_debug, mail_from, mail_mittente);
	}

	public Smtp copiaSmtp(Smtp smtp) {
		if(smtp == null) {
			smtp = new Smtp();
		}
		smtp.setSmtp_protocol(ApplicationUtil.trimToNull(configurazioneSmtpService.getValore(DefaultsSmtp.KEY_SMTP_PROTOCOL)));
		smtp.setSmtp_host(ApplicationUtil.trimToNull(configurazioneSmtpService.getValore(DefaultsSmtp.KEY_SMTP_HOST)));
		smtp.setSmtp_encryption(ApplicationUtil.trimToNull(configurazioneSmtpService.getValore(DefaultsSmtp.KEY_SMTP_ENCRYPTION)));
		smtp.setSmtp_user(ApplicationUtil.trimToNull(configurazioneSmtpService.getValore(DefaultsSmtp.KEY_SMTP_USER)));
		smtp.setSmtp_password(ApplicationUtil.trimToNull(configurazioneSmtpService.getValore(DefaultsSmtp.KEY_SMTP_PASSWORD)));
		smtp.setSmtp_mittente(ApplicationUtil.trimToNull(configurazioneSmtpService.getValore(DefaultsSmtp.KEY_SMTP_MITTENTE)));
		smtp.setSmtp_from(ApplicationUtil.trimToNull(configurazioneSmtpService.getValore(DefaultsSmtp.KEY_SMTP_FROM)));
		smtp.setSmtp_auth(Boolean.valueOf(configurazioneSmtpService.getValore(DefaultsSmtp.KEY_SMTP_AUTH)));
		smtp.setSmtp_port(Integer.valueOf(configurazioneSmtpService.getValore(DefaultsSmtp.KEY_SMTP_PORT)));
		smtp.setSmtp_pec(Boolean.valueOf(configurazioneSmtpService.getValore(DefaultsSmtp.KEY_SMTP_PEC)));
		smtp.setSmtp_debug(Boolean.valueOf(configurazioneSmtpService.getValore(DefaultsSmtp.KEY_SMTP_DEBUG)));
		return smtp;
	}

	public List<Firewall> getFirewall(String service) {
		List<Firewall> lsf = new ArrayList<Firewall>();
		if(ApplicationUtil.equals(ConstantsGlobal.service_asterisk, service) && ApplicationUtil.getService(service)) {
			String pA = ApplicationUtil.trimToNull(configurazioneGenericService.getValore(DefaultsGeneric.KEY_PHONE_PORTA));
			if(pA != null) {
				lsf.add(new Firewall("", pA, service, ConstantsGlobal.udp, false));
			}
			String pB = ApplicationUtil.trimToNull(configurazioneGenericService.getValore(DefaultsGeneric.KEY_PHONE_WSS));
			if(pB != null) {
				lsf.add(new Firewall("", pB, service, ConstantsGlobal.tcp, false));
			}
			String p1 = ApplicationUtil.trimToNull(configurazioneGenericService.getValore(DefaultsGeneric.KEY_PHONE_RPTPORT1));
			String p2 = ApplicationUtil.trimToNull(configurazioneGenericService.getValore(DefaultsGeneric.KEY_PHONE_RPTPORT2));
			if(p1 != null && p2 != null) {
				lsf.add(new Firewall("", p1 + ConstantsGlobal.portSeparator1 + p2, service, ConstantsGlobal.udp, false));
			}
		}
		if(ApplicationUtil.equals(ConstantsGlobal.service_ftp, service) && ApplicationUtil.getService(service)) {
			String p = ApplicationUtil.trimToNull(configurazioneFtpService.getValore(DefaultsFtp.KEY_FTP_REGISTRAZIONI_PORT));
			if(p != null) {
				lsf.add(new Firewall("", p, service, ConstantsGlobal.tcp, false));
			}
		}
		if(ApplicationUtil.equals(ConstantsGlobal.service_prosody, service) && ApplicationUtil.getService(service)) {
			String p = ApplicationUtil.trimToNull(configurazioneChatService.getValore(DefaultsChat.KEY_CHAT_SERVER_PORT));
			if(p != null) {
				lsf.add(new Firewall("", p, service, ConstantsGlobal.tcp, false));
			}
		}
		if(ApplicationUtil.equals(ConstantsGlobal.service_ejabberd, service) && ApplicationUtil.getService(service)) {
			String p = ApplicationUtil.trimToNull(configurazioneChatService.getValore(DefaultsChat.KEY_CHAT_SERVER_PORT));
			if(p != null) {
				lsf.add(new Firewall("", p, service, ConstantsGlobal.tcp, false));
			}
		}
		if(ApplicationUtil.equals(ConstantsGlobal.service_openfire, service) && ApplicationUtil.getService(service)) {
			String p = ApplicationUtil.trimToNull(configurazioneChatService.getValore(DefaultsChat.KEY_CHAT_SERVER_PORT));
			if(p != null) {
				lsf.add(new Firewall("", p, service, ConstantsGlobal.tcp, false));
			}
		}
		if(ApplicationUtil.equals(ConstantsGlobal.service_office, service) && ApplicationUtil.getService(service)) {
			String p = ApplicationUtil.trimToNull(configurazioneGenericService.getValore(DefaultsGeneric.KEY_OPENOFFICE_PORT));
			if(p != null) {
				lsf.add(new Firewall("", p, service, ConstantsGlobal.tcp, false));
			}
		}
		if(ApplicationUtil.equals(ConstantsGlobal.service_vpn, service) && ApplicationUtil.getService(service)) {
			String p = ApplicationUtil.trimToNull(configurazioneGenericService.getValore(DefaultsGeneric.KEY_APPLICATION_VPN));
			if(p != null) {
				lsf.add(new Firewall("", p, service, ConstantsGlobal.tcp, false));
			}
		}
		if(ApplicationUtil.equals(ConstantsGlobal.service_voipmonitor, service) && ApplicationUtil.getService(service)) {
			String p = ApplicationUtil.trimToNull(configurazioneGenericService.getValore(DefaultsGeneric.KEY_APPLICATION_VOIPMONITOR));
			if(p != null) {
				lsf.add(new Firewall("", p, service, ConstantsGlobal.tcp, false));
			}
		}
		if(ApplicationUtil.equals(ConstantsGlobal.service_cache, service) && ApplicationUtil.getService(service)) {
			String p = ApplicationUtil.trimToNull(configurazioneGenericService.getValore(DefaultsGeneric.KEY_APPLICATION_CACHE));
			if(p != null) {
				lsf.add(new Firewall("", p, service, ConstantsGlobal.tcp, false));
			}
		}
		if(ApplicationUtil.equals(ConstantsGlobal.service_smb, service) && ApplicationUtil.getService(service)) {
			String p = ApplicationUtil.trimToNull(configurazioneGenericService.getValore(DefaultsGeneric.KEY_APPLICATION_SMB));
			if(p != null) {
				lsf.add(new Firewall("", p, service, ConstantsGlobal.tcp, false));
			}
		}
		if(ApplicationUtil.equals(ConstantsGlobal.service_postfix, service) && ApplicationUtil.getService(service)) {
			String p = ApplicationUtil.trimToNull(configurazioneGenericService.getValore(DefaultsGeneric.KEY_APPLICATION_POSTFIX));
			if(p != null) {
				lsf.add(new Firewall("", p, service, ConstantsGlobal.tcp, false));
			}
		}
		if(ApplicationUtil.equals(ConstantsGlobal.service_dovecot, service) && ApplicationUtil.getService(service)) {
			String p = ApplicationUtil.trimToNull(configurazioneGenericService.getValore(DefaultsGeneric.KEY_APPLICATION_DOVECOT));
			if(p != null) {
				lsf.add(new Firewall("", p, service, ConstantsGlobal.tcp, false));
			}
		}
		if(ApplicationUtil.equals(ConstantsGlobal.service_munin, service) && ApplicationUtil.getService(service)) {
			String p = ApplicationUtil.trimToNull(configurazioneGenericService.getValore(DefaultsGeneric.KEY_APPLICATION_MUNIN));
			if(p != null) {
				lsf.add(new Firewall("", p, service, ConstantsGlobal.tcp, false));
			}
		}
		if(ApplicationUtil.equals(ConstantsGlobal.service_monit, service) && ApplicationUtil.getService(service)) {
			String p = ApplicationUtil.trimToNull(configurazioneGenericService.getValore(DefaultsGeneric.KEY_APPLICATION_MONIT));
			if(p != null) {
				lsf.add(new Firewall("", p, service, ConstantsGlobal.tcp, false));
			}
		}
		if(ApplicationUtil.equals(ConstantsGlobal.service_zabbix, service) && ApplicationUtil.getService(service)) {
			String p = ApplicationUtil.trimToNull(configurazioneGenericService.getValore(DefaultsGeneric.KEY_APPLICATION_ZABBIX));
			if(p != null) {
				lsf.add(new Firewall("", p, service, ConstantsGlobal.tcp, false));
			}
		}
		if(ApplicationUtil.equals(ConstantsGlobal.service_webmin, service) && ApplicationUtil.getService(service)) {
			String p = ApplicationUtil.trimToNull(configurazioneGenericService.getValore(DefaultsGeneric.KEY_APPLICATION_WEBMIN));
			if(p != null) {
				lsf.add(new Firewall("", p, service, ConstantsGlobal.tcp, false));
			}
		}
		if(ApplicationUtil.equals(ConstantsGlobal.service_usermin, service) && ApplicationUtil.getService(service)) {
			String p = ApplicationUtil.trimToNull(configurazioneGenericService.getValore(DefaultsGeneric.KEY_APPLICATION_USERMIN));
			if(p != null) {
				lsf.add(new Firewall("", p, service, ConstantsGlobal.tcp, false));
			}
		}
		if(ApplicationUtil.equals(ConstantsGlobal.service_shell, service) && ApplicationUtil.getService(service)) {
			String p = ApplicationUtil.trimToNull(configurazioneGenericService.getValore(DefaultsGeneric.KEY_APPLICATION_SHELL));
			if(p != null) {
				lsf.add(new Firewall("", p, service, ConstantsGlobal.tcp, false));
			}
		}
		if(ApplicationUtil.equals(ConstantsGlobal.service_ssh, service) && ApplicationUtil.getService(service)) {
			String p = ApplicationUtil.trimToNull(configurazioneGenericService.getValore(DefaultsGeneric.KEY_APPLICATION_SSH));
			if(p != null) {
				lsf.add(new Firewall("", p, service, ConstantsGlobal.tcp, false));
			}
		}
		if(ApplicationUtil.equals(ConstantsGlobal.service_db, service) && ApplicationUtil.getService(service)) {
			String p = ApplicationUtil.trimToNull(configurazioneGenericService.getValore(DefaultsGeneric.KEY_APPLICATION_DB));
			if(p != null) {
				lsf.add(new Firewall("", p, service, ConstantsGlobal.tcp, false));
			}
		}
		if(ApplicationUtil.equals(ConstantsGlobal.service_sql, service) && ApplicationUtil.getService(service)) {
			String p = ApplicationUtil.trimToNull(configurazioneGenericService.getValore(DefaultsGeneric.KEY_APPLICATION_SQL));
			if(p != null) {
				lsf.add(new Firewall("", p, service, ConstantsGlobal.tcp, false));
			}
		}
		return lsf;
	}
	
	public boolean checkService(String name) {
		List<StatoServer> fws = getService(name);
		if(ApplicationUtil.notEmpty(fws)) {
			for(StatoServer st : fws) {
				if(ApplicationUtil.getService(st.getService()) && !st.getOk()) {
					return false;
				}
			}
		}
		return true;
	}


	public List<StatoServer> getService(String service) {
		List<StatoServer> lsf = new ArrayList<StatoServer>();
		if(ApplicationUtil.equals(ConstantsGlobal.service_asterisk, service) && ApplicationUtil.getService(service)) {
			String p = ApplicationUtil.trimToNull(configurazioneAutodialerService.getValore(DefaultsAutodialer.KEY_PREDICTIVE_AMI_PORT));
			if(p != null) {
				Integer porta = ApplicationUtil.parseNumber(p);
				if(ApplicationUtil.gtZero(porta)) {
					String host = configurazioneAutodialerService.getValore(DefaultsAutodialer.KEY_PREDICTIVE_AMI_IP_CENTRALINO);
					lsf.add(new StatoServer(service, host, porta, ConstantsGlobal.tcp, true));
				}
			}
		}
		if(ApplicationUtil.equals(ConstantsGlobal.service_ftp, service) && ApplicationUtil.getService(service)) {
			String p = ApplicationUtil.trimToNull(configurazioneFtpService.getValore(DefaultsFtp.KEY_FTP_REGISTRAZIONI_PORT));
			if(p != null) {
				Integer porta = ApplicationUtil.parseNumber(p);
				if(ApplicationUtil.gtZero(porta)) {
					String host = configurazioneFtpService.getValore(DefaultsFtp.KEY_FTP_REGISTRAZIONI_HOST);
					lsf.add(new StatoServer(service, host, porta, ConstantsGlobal.tcp, true));
				}
			}
		}
		if(ApplicationUtil.equals(ConstantsGlobal.service_prosody, service) && ApplicationUtil.getService(service)) {
			String p = ApplicationUtil.trimToNull(configurazioneChatService.getValore(DefaultsChat.KEY_CHAT_SERVER_PORT));
			if(p != null) {
				Integer porta = ApplicationUtil.parseNumber(p);
				if(ApplicationUtil.gtZero(porta)) {
					String host = configurazioneChatService.getValore(DefaultsChat.KEY_CHAT_SERVER_IP);
					lsf.add(new StatoServer(service, host, porta, ConstantsGlobal.tcp, true));
				}
			}
		}
		if(ApplicationUtil.equals(ConstantsGlobal.service_ejabberd, service) && ApplicationUtil.getService(service)) {
			String p = ApplicationUtil.trimToNull(configurazioneChatService.getValore(DefaultsChat.KEY_CHAT_SERVER_PORT));
			if(p != null) {
				Integer porta = ApplicationUtil.parseNumber(p);
				if(ApplicationUtil.gtZero(porta)) {
					String host = configurazioneChatService.getValore(DefaultsChat.KEY_CHAT_SERVER_IP);
					lsf.add(new StatoServer(service, host, porta, ConstantsGlobal.tcp, true));
				}
			}
		}
		if(ApplicationUtil.equals(ConstantsGlobal.service_openfire, service) && ApplicationUtil.getService(service)) {
			String p = ApplicationUtil.trimToNull(configurazioneChatService.getValore(DefaultsChat.KEY_CHAT_SERVER_PORT));
			if(p != null) {
				Integer porta = ApplicationUtil.parseNumber(p);
				if(ApplicationUtil.gtZero(porta)) {
					String host = configurazioneChatService.getValore(DefaultsChat.KEY_CHAT_SERVER_IP);
					lsf.add(new StatoServer(service, host, porta, ConstantsGlobal.tcp, true));
				}
			}
		}
		if(ApplicationUtil.equals(ConstantsGlobal.service_office, service) && ApplicationUtil.getService(service)) {
			String p = ApplicationUtil.trimToNull(configurazioneGenericService.getValore(DefaultsGeneric.KEY_OPENOFFICE_PORT));
			if(p != null) {
				Integer porta = ApplicationUtil.parseNumber(p);
				if(ApplicationUtil.gtZero(porta)) {
					String host = configurazioneGenericService.getValore(DefaultsGeneric.KEY_OPENOFFICE_URL);
					lsf.add(new StatoServer(service, host, porta, ConstantsGlobal.tcp, true));
				}
			}
		}
		if(ApplicationUtil.equals(ConstantsGlobal.service_vpn, service) && ApplicationUtil.getService(service)) {
			String p = ApplicationUtil.trimToNull(configurazioneGenericService.getValore(DefaultsGeneric.KEY_APPLICATION_VPN));
			if(p != null) {
				Integer porta = ApplicationUtil.parseNumber(p);
				if(ApplicationUtil.gtZero(porta)) {
					String host = ConstantsGlobal.localhost;
					lsf.add(new StatoServer(service, host, porta, ConstantsGlobal.tcp, true));
				}
			}
		}
		if(ApplicationUtil.equals(ConstantsGlobal.service_voipmonitor, service) && ApplicationUtil.getService(service)) {
			String p = ApplicationUtil.trimToNull(configurazioneGenericService.getValore(DefaultsGeneric.KEY_APPLICATION_VOIPMONITOR));
			if(p != null) {
				Integer porta = ApplicationUtil.parseNumber(p);
				if(ApplicationUtil.gtZero(porta)) {
					String host = ConstantsGlobal.localhost;
					lsf.add(new StatoServer(service, host, porta, ConstantsGlobal.tcp, true));
				}
			}
		}
		if(ApplicationUtil.equals(ConstantsGlobal.service_cache, service) && ApplicationUtil.getService(service)) {
			String p = ApplicationUtil.trimToNull(configurazioneGenericService.getValore(DefaultsGeneric.KEY_APPLICATION_CACHE));
			if(p != null) {
				Integer porta = ApplicationUtil.parseNumber(p);
				if(ApplicationUtil.gtZero(porta)) {
					String host = ConstantsGlobal.localhost;
					lsf.add(new StatoServer(service, host, porta, ConstantsGlobal.tcp, true));
				}
			}
		}
		if(ApplicationUtil.equals(ConstantsGlobal.service_smb, service) && ApplicationUtil.getService(service)) {
			String p = ApplicationUtil.trimToNull(configurazioneGenericService.getValore(DefaultsGeneric.KEY_APPLICATION_SMB));
			if(p != null) {
				Integer porta = ApplicationUtil.parseNumber(p);
				if(ApplicationUtil.gtZero(porta)) {
					String host = ConstantsGlobal.localhost;
					lsf.add(new StatoServer(service, host, porta, ConstantsGlobal.tcp, true));
				}
			}
		}
		if(ApplicationUtil.equals(ConstantsGlobal.service_postfix, service) && ApplicationUtil.getService(service)) {
			String p = ApplicationUtil.trimToNull(configurazioneGenericService.getValore(DefaultsGeneric.KEY_APPLICATION_POSTFIX));
			if(p != null) {
				Integer porta = ApplicationUtil.parseNumber(p);
				if(ApplicationUtil.gtZero(porta)) {
					String host = ConstantsGlobal.localhost;
					lsf.add(new StatoServer(service, host, porta, ConstantsGlobal.tcp, true));
				}
			}
		}
		if(ApplicationUtil.equals(ConstantsGlobal.service_dovecot, service) && ApplicationUtil.getService(service)) {
			String p = ApplicationUtil.trimToNull(configurazioneGenericService.getValore(DefaultsGeneric.KEY_APPLICATION_DOVECOT));
			if(p != null) {
				Integer porta = ApplicationUtil.parseNumber(p);
				if(ApplicationUtil.gtZero(porta)) {
					String host = ConstantsGlobal.localhost;
					lsf.add(new StatoServer(service, host, porta, ConstantsGlobal.tcp, true));
				}
			}
		}
		if(ApplicationUtil.equals(ConstantsGlobal.service_munin, service) && ApplicationUtil.getService(service)) {
			String p = ApplicationUtil.trimToNull(configurazioneGenericService.getValore(DefaultsGeneric.KEY_APPLICATION_MUNIN));
			if(p != null) {
				Integer porta = ApplicationUtil.parseNumber(p);
				if(ApplicationUtil.gtZero(porta)) {
					String host = ConstantsGlobal.localhost;
					lsf.add(new StatoServer(service, host, porta, ConstantsGlobal.tcp, true));
				}
			}
		}
		if(ApplicationUtil.equals(ConstantsGlobal.service_zabbix, service) && ApplicationUtil.getService(service)) {
			String p = ApplicationUtil.trimToNull(configurazioneGenericService.getValore(DefaultsGeneric.KEY_APPLICATION_ZABBIX));
			if(p != null) {
				Integer porta = ApplicationUtil.parseNumber(p);
				if(ApplicationUtil.gtZero(porta)) {
					String host = ConstantsGlobal.localhost;
					lsf.add(new StatoServer(service, host, porta, ConstantsGlobal.tcp, true));
				}
			}
		}
		if(ApplicationUtil.equals(ConstantsGlobal.service_monit, service) && ApplicationUtil.getService(service)) {
			String p = ApplicationUtil.trimToNull(configurazioneGenericService.getValore(DefaultsGeneric.KEY_APPLICATION_MONIT));
			if(p != null) {
				Integer porta = ApplicationUtil.parseNumber(p);
				if(ApplicationUtil.gtZero(porta)) {
					String host = ConstantsGlobal.localhost;
					lsf.add(new StatoServer(service, host, porta, ConstantsGlobal.tcp, true));
				}
			}
		}
		if(ApplicationUtil.equals(ConstantsGlobal.service_webmin, service) && ApplicationUtil.getService(service)) {
			String p = ApplicationUtil.trimToNull(configurazioneGenericService.getValore(DefaultsGeneric.KEY_APPLICATION_WEBMIN));
			if(p != null) {
				Integer porta = ApplicationUtil.parseNumber(p);
				if(ApplicationUtil.gtZero(porta)) {
					String host = ConstantsGlobal.localhost;
					lsf.add(new StatoServer(service, host, porta, ConstantsGlobal.tcp, true));
				}
			}
		}
		if(ApplicationUtil.equals(ConstantsGlobal.service_usermin, service) && ApplicationUtil.getService(service)) {
			String p = ApplicationUtil.trimToNull(configurazioneGenericService.getValore(DefaultsGeneric.KEY_APPLICATION_USERMIN));
			if(p != null) {
				Integer porta = ApplicationUtil.parseNumber(p);
				if(ApplicationUtil.gtZero(porta)) {
					String host = ConstantsGlobal.localhost;
					lsf.add(new StatoServer(service, host, porta, ConstantsGlobal.tcp, true));
				}
			}
		}
		if(ApplicationUtil.equals(ConstantsGlobal.service_shell, service) && ApplicationUtil.getService(service)) {
			String p = ApplicationUtil.trimToNull(configurazioneGenericService.getValore(DefaultsGeneric.KEY_APPLICATION_SHELL));
			if(p != null) {
				Integer porta = ApplicationUtil.parseNumber(p);
				if(ApplicationUtil.gtZero(porta)) {
					String host = ConstantsGlobal.localhost;
					lsf.add(new StatoServer(service, host, porta, ConstantsGlobal.tcp, true));
				}
			}
		}
		if(ApplicationUtil.equals(ConstantsGlobal.service_ssh, service) && ApplicationUtil.getService(service)) {
			String p = ApplicationUtil.trimToNull(configurazioneGenericService.getValore(DefaultsGeneric.KEY_APPLICATION_SSH));
			if(p != null) {
				Integer porta = ApplicationUtil.parseNumber(p);
				if(ApplicationUtil.gtZero(porta)) {
					String host = ConstantsGlobal.localhost;
					lsf.add(new StatoServer(service, host, porta, ConstantsGlobal.tcp, true));
				}
			}
		}
		if(ApplicationUtil.equals(ConstantsGlobal.service_db, service) && ApplicationUtil.getService(service)) {
			String p = ApplicationUtil.trimToNull(configurazioneGenericService.getValore(DefaultsGeneric.KEY_APPLICATION_DB));
			if(p != null) {
				Integer porta = ApplicationUtil.parseNumber(p);
				if(ApplicationUtil.gtZero(porta)) {
					String host = ConstantsGlobal.localhost;
					lsf.add(new StatoServer(service, host, porta, ConstantsGlobal.tcp, true));
				}
			}
		}
		if(ApplicationUtil.equals(ConstantsGlobal.service_sql, service) && ApplicationUtil.getService(service)) {
			String p = ApplicationUtil.trimToNull(configurazioneGenericService.getValore(DefaultsGeneric.KEY_APPLICATION_SQL));
			if(p != null) {
				Integer porta = ApplicationUtil.parseNumber(p);
				if(ApplicationUtil.gtZero(porta)) {
					String host = ConstantsGlobal.localhost;
					lsf.add(new StatoServer(service, host, porta, ConstantsGlobal.tcp, true));
				}
			}
		}
		return lsf;
	}

	public List<CaptureServer> getMonitor() {
		List<CaptureServer> lsf = new ArrayList<CaptureServer>();
		String pAMI = ApplicationUtil.trimToNull(configurazioneAutodialerService.getValore(DefaultsAutodialer.KEY_PREDICTIVE_AMI_PORT));
		String pSIP = ApplicationUtil.trimToNull(configurazioneGenericService.getValore(DefaultsGeneric.KEY_PHONE_PORTA));
		String pWSS = ApplicationUtil.trimToNull(configurazioneGenericService.getValore(DefaultsGeneric.KEY_PHONE_WSS));
		String pRTP1 = ApplicationUtil.trimToNull(configurazioneGenericService.getValore(DefaultsGeneric.KEY_PHONE_RPTPORT1));
		String pRTP2 = ApplicationUtil.trimToNull(configurazioneGenericService.getValore(DefaultsGeneric.KEY_PHONE_RPTPORT2));
		String pFTP = ApplicationUtil.trimToNull(configurazioneFtpService.getValore(DefaultsFtp.KEY_FTP_REGISTRAZIONI_PORT));
		String pCHAT = ApplicationUtil.trimToNull(configurazioneChatService.getValore(DefaultsChat.KEY_CHAT_SERVER_PORT));
		String pOFFICE = ApplicationUtil.trimToNull(configurazioneGenericService.getValore(DefaultsGeneric.KEY_OPENOFFICE_PORT));
		String pSHELL = ApplicationUtil.trimToNull(configurazioneGenericService.getValore(DefaultsGeneric.KEY_APPLICATION_SHELL));
		String pSSH = ApplicationUtil.trimToNull(configurazioneGenericService.getValore(DefaultsGeneric.KEY_APPLICATION_SSH));
		String pDB = ApplicationUtil.trimToNull(configurazioneGenericService.getValore(DefaultsGeneric.KEY_APPLICATION_DB));
		String pSQL = ApplicationUtil.trimToNull(configurazioneGenericService.getValore(DefaultsGeneric.KEY_APPLICATION_SQL));
		String pMUN = ApplicationUtil.trimToNull(configurazioneGenericService.getValore(DefaultsGeneric.KEY_APPLICATION_MUNIN));
		String pVPN = ApplicationUtil.trimToNull(configurazioneGenericService.getValore(DefaultsGeneric.KEY_APPLICATION_VPN));
		String pVPO = ApplicationUtil.trimToNull(configurazioneGenericService.getValore(DefaultsGeneric.KEY_APPLICATION_VOIPMONITOR));
		String pPOST = ApplicationUtil.trimToNull(configurazioneGenericService.getValore(DefaultsGeneric.KEY_APPLICATION_POSTFIX));
		String pDOVE = ApplicationUtil.trimToNull(configurazioneGenericService.getValore(DefaultsGeneric.KEY_APPLICATION_DOVECOT));
		String pMONIT = ApplicationUtil.trimToNull(configurazioneGenericService.getValore(DefaultsGeneric.KEY_APPLICATION_MONIT));
		String pWEB = ApplicationUtil.trimToNull(configurazioneGenericService.getValore(DefaultsGeneric.KEY_APPLICATION_WEBMIN));
		String pUSR = ApplicationUtil.trimToNull(configurazioneGenericService.getValore(DefaultsGeneric.KEY_APPLICATION_USERMIN));
		String pSMB = ApplicationUtil.trimToNull(configurazioneGenericService.getValore(DefaultsGeneric.KEY_APPLICATION_SMB));
		String pZAB = ApplicationUtil.trimToNull(configurazioneGenericService.getValore(DefaultsGeneric.KEY_APPLICATION_ZABBIX));
		String pCAH = ApplicationUtil.trimToNull(configurazioneGenericService.getValore(DefaultsGeneric.KEY_APPLICATION_CACHE));
		if(pSIP != null) {
			String [] r = new String [] {ConstantsGlobal.udp + " " + "port" + " " + pSIP};
			lsf.add(new CaptureServer(ConstantsGlobal.service_asterisk, r));
		}
		if(pSIP != null && pRTP1 != null && pRTP2 != null) {
			String [] r = new String [] {ConstantsGlobal.udp + " " + "port" + " " + pSIP, ConstantsGlobal.udp + " " + "portrange" + " " + pRTP1 + ConstantsGlobal.portSeparator2 + pRTP2};
			lsf.add(new CaptureServer(ConstantsGlobal.service_asterisk, r));
		}
		if(pWSS != null) {
			String [] r = new String [] {ConstantsGlobal.tcp + " " + "port" + " " + pWSS};
			lsf.add(new CaptureServer(ConstantsGlobal.service_asterisk, r));
		}
		if(pAMI != null) {
			String [] r = new String [] {ConstantsGlobal.tcp + " " + "port" + " " + pAMI};
			lsf.add(new CaptureServer(ConstantsGlobal.service_asterisk, r));
		}
		if(pFTP != null) {
			String [] r = new String [] {ConstantsGlobal.tcp + " " + "port" + " " + pFTP};
			lsf.add(new CaptureServer(ConstantsGlobal.service_ftp, r));
		}
		if(pCHAT != null) {
			String [] r = new String [] {ConstantsGlobal.tcp + " " + "port" + " " + pCHAT};
			lsf.add(new CaptureServer(ConstantsGlobal.service_prosody, r));
		}
		if(pCHAT != null) {
			String [] r = new String [] {ConstantsGlobal.tcp + " " + "port" + " " + pCHAT};
			lsf.add(new CaptureServer(ConstantsGlobal.service_ejabberd, r));
		}
		if(pCHAT != null) {
			String [] r = new String [] {ConstantsGlobal.tcp + " " + "port" + " " + pCHAT};
			lsf.add(new CaptureServer(ConstantsGlobal.service_openfire, r));
		}
		if(pOFFICE != null) {
			String [] r = new String [] {ConstantsGlobal.tcp + " " + "port" + " " + pOFFICE};
			lsf.add(new CaptureServer(ConstantsGlobal.service_office, r));
		}
		if(pVPN != null) {
			String [] r = new String [] {ConstantsGlobal.tcp + " " + "port" + " " + pVPN};
			lsf.add(new CaptureServer(ConstantsGlobal.service_vpn, r));
		}
		if(pVPO != null) {
			String [] r = new String [] {ConstantsGlobal.tcp + " " + "port" + " " + pVPO};
			lsf.add(new CaptureServer(ConstantsGlobal.service_voipmonitor, r));
		}
		if(pCAH != null) {
			String [] r = new String [] {ConstantsGlobal.tcp + " " + "port" + " " + pCAH};
			lsf.add(new CaptureServer(ConstantsGlobal.service_cache, r));
		}
		if(pSMB != null) {
			String [] r = new String [] {ConstantsGlobal.tcp + " " + "port" + " " + pSMB};
			lsf.add(new CaptureServer(ConstantsGlobal.service_smb, r));
		}
		if(pPOST != null) {
			String [] r = new String [] {ConstantsGlobal.tcp + " " + "port" + " " + pPOST};
			lsf.add(new CaptureServer(ConstantsGlobal.service_postfix, r));
		}
		if(pDOVE != null) {
			String [] r = new String [] {ConstantsGlobal.tcp + " " + "port" + " " + pDOVE};
			lsf.add(new CaptureServer(ConstantsGlobal.service_dovecot, r));
		}
		if(pMUN != null) {
			String [] r = new String [] {ConstantsGlobal.tcp + " " + "port" + " " + pMUN};
			lsf.add(new CaptureServer(ConstantsGlobal.service_munin, r));
		}
		if(pZAB != null) {
			String [] r = new String [] {ConstantsGlobal.tcp + " " + "port" + " " + pZAB};
			lsf.add(new CaptureServer(ConstantsGlobal.service_zabbix, r));
		}
		if(pMONIT != null) {
			String [] r = new String [] {ConstantsGlobal.tcp + " " + "port" + " " + pMONIT};
			lsf.add(new CaptureServer(ConstantsGlobal.service_monit, r));
		}
		if(pWEB != null) {
			String [] r = new String [] {ConstantsGlobal.tcp + " " + "port" + " " + pWEB};
			lsf.add(new CaptureServer(ConstantsGlobal.service_webmin, r));
		}
		if(pUSR != null) {
			String [] r = new String [] {ConstantsGlobal.tcp + " " + "port" + " " + pUSR};
			lsf.add(new CaptureServer(ConstantsGlobal.service_usermin, r));
		}
		if(pSHELL != null) {
			String [] r = new String [] {ConstantsGlobal.tcp + " " + "port" + " " + pSHELL};
			lsf.add(new CaptureServer(ConstantsGlobal.service_shell, r));
		}
		if(pSSH != null) {
			String [] r = new String [] {ConstantsGlobal.tcp + " " + "port" + " " + pSSH};
			lsf.add(new CaptureServer(ConstantsGlobal.service_ssh, r));
		}
		if(pDB != null) {
			String [] r = new String [] {ConstantsGlobal.tcp + " " + "port" + " " + pDB};
			lsf.add(new CaptureServer(ConstantsGlobal.service_db, r));
		}
		if(pSQL != null) {
			String [] r = new String [] {ConstantsGlobal.tcp + " " + "port" + " " + pSQL};
			lsf.add(new CaptureServer(ConstantsGlobal.service_sql, r));
		}
		return lsf;
	}


	@SuppressWarnings("unchecked")
	public void subCriteriaSupervisore(Boolean m, Long userId, DetachedCriteria criteria, String property, Long singolo, List<String> multiplo) {
		DetachedCriteria c = DetachedCriteria.forClass(Utente.class);
		DetachedCriteria criteriaT = c.createCriteria("team", "TS");
		criteriaT.createCriteria("supervisore").add(Restrictions.idEq(userId));
		ApplicationUtil.proprieta(false, m, criteriaT, "id", singolo, multiplo);
		c.setProjection(Projections.distinct(Projections.property("id")));
		if(getSubRicerca()) {
			criteria.add(Subqueries.propertyIn(property, c));
		} else {
			List<Long> ln = getList(c);
			if(ApplicationUtil.notEmpty(ln)) {
				criteria.add(Restrictions.in(property, ln));
			} else {
				criteria.add(Restrictions.eq(property, ConstantsGlobal.NULL));
			}
		}
	}

	@SuppressWarnings("unchecked")
	public void subCriteriaSupervisore(Long userId, DetachedCriteria criteria, String property) {
		DetachedCriteria c = DetachedCriteria.forClass(Utente.class);
		c.createCriteria("team", "TS").createCriteria("supervisore").add(Restrictions.idEq(userId));
		c.setProjection(Projections.distinct(Projections.property("id")));
		if(getSubRicerca()) {
			criteria.add(Subqueries.propertyIn(property, c));
		} else {
			List<Long> ln = getList(c);
			if(ApplicationUtil.notEmpty(ln)) {
				criteria.add(Restrictions.in(property, ln));
			} else {
				criteria.add(Restrictions.eq(property, ConstantsGlobal.NULL));
			}
		}
	}

	@SuppressWarnings("unchecked")
	public void subCriteriaUser(Long userId, Boolean supervisore, DetachedCriteria criteria, String property) {
		DetachedCriteria c = DetachedCriteria.forClass(Utente.class);
		if(supervisore) {
			c.createCriteria("team", "TS").createCriteria("supervisore").add(Restrictions.idEq(userId));
		} else {
			c.add(Restrictions.idEq(userId));
		}
		c.setProjection(Projections.distinct(Projections.property("id")));
		if(getSubRicerca()) {
			criteria.add(Subqueries.propertyIn(property, c));
		} else {
			List<Long> ln = getList(c);
			if(ApplicationUtil.notEmpty(ln)) {
				criteria.add(Restrictions.in(property, ln));
			} else {
				criteria.add(Restrictions.eq(property, ConstantsGlobal.NULL));
			}
		}
	}

	@SuppressWarnings("unchecked")
	public void subCriteriaOperatore(Long userId, DetachedCriteria criteria, String property) {
		DetachedCriteria c = DetachedCriteria.forClass(Utente.class);
		c.createCriteria("team", "TS").createCriteria("user").add(Restrictions.idEq(userId));
		c.setProjection(Projections.distinct(Projections.property("id")));
		if(getSubRicerca()) {
			criteria.add(Subqueries.propertyIn(property, c));
		} else {
			List<Long> ln = getList(c);
			if(ApplicationUtil.notEmpty(ln)) {
				criteria.add(Restrictions.in(property, ln));
			} else {
				criteria.add(Restrictions.eq(property, ConstantsGlobal.NULL));
			}
		}
	}

	@SuppressWarnings("unchecked")
	public void subCriteriaOperatori(boolean supervisore, Long userId, DetachedCriteria criteria, String property) {
		DetachedCriteria c = DetachedCriteria.forClass(Utente.class);
		if(supervisore) {
			c.createCriteria("team", "TS").createCriteria("supervisore").add(Restrictions.idEq(userId));
		} else {
			c.createCriteria("team", "TS").createCriteria("user").add(Restrictions.idEq(userId));
		}
		c.setProjection(Projections.distinct(Projections.property("id")));
		if(getSubRicerca()) {
			criteria.add(Restrictions.or(Subqueries.propertyIn(property, c), Restrictions.isNull(property)));
		} else {
			List<Long> ln = getList(c);
			if(ApplicationUtil.notEmpty(ln)) {
				criteria.add(Restrictions.or(Restrictions.in(property, ln), Restrictions.isNull(property)));
			} else {
				criteria.add(Restrictions.or(Restrictions.eq(property, ConstantsGlobal.NULL), Restrictions.isNull(property)));
			}
		}
	}

	@SuppressWarnings("unchecked")
	public void subCriteriaCoordinatore(Long userId, DetachedCriteria criteria, String property) {
		DetachedCriteria c = DetachedCriteria.forClass(Agente.class);
		c.createCriteria("zone", "TS").createCriteria("supervisori").add(Restrictions.idEq(userId));
		c.setProjection(Projections.distinct(Projections.property("id")));
		if(getSubRicerca()) {
			criteria.add(Subqueries.propertyIn(property, c));
		} else {
			List<Long> ln = getList(c);
			if(ApplicationUtil.notEmpty(ln)) {
				criteria.add(Restrictions.in(property, ln));
			} else {
				criteria.add(Restrictions.eq(property, ConstantsGlobal.NULL));
			}
		}
	}

	@SuppressWarnings("unchecked")
	public void subCriteriaAgente(Long userId, DetachedCriteria criteria, String property) {
		DetachedCriteria c = DetachedCriteria.forClass(Agente.class);
		c.createCriteria("user", "TS").add(Restrictions.idEq(userId));
		c.setProjection(Projections.distinct(Projections.property("id")));
		if(getSubRicerca()) {
			criteria.add(Subqueries.propertyIn(property, c));
		} else {
			List<Long> ln = getList(c);
			if(ApplicationUtil.notEmpty(ln)) {
				criteria.add(Restrictions.in(property, ln));
			} else {
				criteria.add(Restrictions.eq(property, ConstantsGlobal.NULL));
			}
		}
	}
	@SuppressWarnings("unchecked")
	public void subCriteriaCampagnaPartner(Long userId, DetachedCriteria criteria, String property) {
		DetachedCriteria c = DetachedCriteria.forClass(Campagna.class);
		c.createCriteria("partner", "TS").add(Restrictions.idEq(userId));
		c.setProjection(Projections.distinct(Projections.property("id")));
		if(getSubRicerca()) {
			criteria.add(Subqueries.propertyIn(property, c));
		} else {
			List<Long> ln = getList(c);
			if(ApplicationUtil.notEmpty(ln)) {
				criteria.add(Restrictions.in(property, ln));
			} else {
				criteria.add(Restrictions.eq(property, ConstantsGlobal.NULL));
			}
		}
	}
	@SuppressWarnings("unchecked")
	public void subCriteriaCampagnaTeam(Long teamId, DetachedCriteria criteria, String property) {
		DetachedCriteria c = DetachedCriteria.forClass(Campagna.class);
		c.createCriteria("team", "TC").add(Restrictions.idEq(teamId));
		c.setProjection(Projections.distinct(Projections.property("id")));
		if(getSubRicerca()) {
			criteria.add(Subqueries.propertyIn(property, c));
		} else {
			List<Long> ln = getList(c);
			if(ApplicationUtil.notEmpty(ln)) {
				criteria.add(Restrictions.in(property, ln));
			} else {
				criteria.add(Restrictions.eq(property, ConstantsGlobal.NULL));
			}
		}
	}
	@SuppressWarnings("unchecked")
	public void subCriteriaOperatoreTeam(Long teamId, DetachedCriteria criteria, String property) {
		DetachedCriteria c = DetachedCriteria.forClass(Utente.class);
		c.createCriteria("team", "TS").add(Restrictions.idEq(teamId));
		c.setProjection(Projections.distinct(Projections.property("id")));
		if(getSubRicerca()) {
			criteria.add(Subqueries.propertyIn(property, c));
		} else {
			List<Long> ln = getList(c);
			if(ApplicationUtil.notEmpty(ln)) {
				criteria.add(Restrictions.in(property, ln));
			} else {
				criteria.add(Restrictions.eq(property, ConstantsGlobal.NULL));
			}
		}
	}

	@SuppressWarnings("unchecked")
	public void subCriteriaCampagnaSupervisore(Long userId, DetachedCriteria criteria, String property,Boolean m, Long singolo, List<String> multiplo) {
		DetachedCriteria c = DetachedCriteria.forClass(Campagna.class);
		DetachedCriteria criteriaT = c.createCriteria("team", "TC");
		criteriaT.createCriteria("supervisore").add(Restrictions.idEq(userId));
		ApplicationUtil.proprieta(false, m, criteriaT, "id", singolo, multiplo);
		c.setProjection(Projections.distinct(Projections.property("id")));
		if(getSubRicerca()) {
			criteria.add(Subqueries.propertyIn(property, c));
		} else {
			List<Long> ln = getList(c);
			if(ApplicationUtil.notEmpty(ln)) {
				criteria.add(Restrictions.in(property, ln));
			} else {
				criteria.add(Restrictions.eq(property, ConstantsGlobal.NULL));
			}
		}
	}


	@SuppressWarnings("unchecked")
	public void subCriteriaCampagnaOperatore(Long userId, DetachedCriteria criteria, String property) {
		DetachedCriteria c = DetachedCriteria.forClass(Campagna.class);
		c.createCriteria("team", "TC").createCriteria("user").add(Restrictions.idEq(userId));
		c.setProjection(Projections.distinct(Projections.property("id")));
		if(getSubRicerca()) {
			criteria.add(Subqueries.propertyIn(property, c));
		} else {
			List<Long> ln = getList(c);
			if(ApplicationUtil.notEmpty(ln)) {
				criteria.add(Restrictions.in(property, ln));
			} else {
				criteria.add(Restrictions.eq(property, ConstantsGlobal.NULL));
			}
		}
	}


	@SuppressWarnings("unchecked")
	public void subCriteriaOperatore(Long userId, DetachedCriteria criteria, String property, Boolean m, Long singolo, List<String> multiplo) {
		DetachedCriteria c = DetachedCriteria.forClass(Utente.class);
		DetachedCriteria criteriaT = c.createCriteria("team", "TS");
		criteriaT.createCriteria("user").add(Restrictions.idEq(userId));
		ApplicationUtil.proprieta(false, m, criteriaT, "id", singolo, multiplo);
		c.setProjection(Projections.distinct(Projections.property("id")));
		if(getSubRicerca()) {
			criteria.add(Subqueries.propertyIn(property, c));
		} else {
			List<Long> ln = getList(c);
			if(ApplicationUtil.notEmpty(ln)) {
				criteria.add(Restrictions.in(property, ln));
			} else {
				criteria.add(Restrictions.eq(property, ConstantsGlobal.NULL));
			}
		}
	}



	@SuppressWarnings("unchecked")
	public void subCriteriaCampagnaOperatore(Long userId, DetachedCriteria criteria, String property, Boolean m, Long singolo, List<String> multiplo) {
		DetachedCriteria c = DetachedCriteria.forClass(Campagna.class);
		DetachedCriteria criteriaT = c.createCriteria("team", "TC");
		criteriaT.createCriteria("user").add(Restrictions.idEq(userId));
		ApplicationUtil.proprieta(false, m, criteriaT, "id", singolo, multiplo);
		c.setProjection(Projections.distinct(Projections.property("id")));
		if(getSubRicerca()) {
			criteria.add(Subqueries.propertyIn(property, c));
		} else {
			List<Long> ln = getList(c);
			if(ApplicationUtil.notEmpty(ln)) {
				criteria.add(Restrictions.in(property, ln));
			} else {
				criteria.add(Restrictions.eq(property, ConstantsGlobal.NULL));
			}
		}
	}



	@SuppressWarnings("unchecked")
	public void subCriteriaRicercaCampagna(Boolean m, Long singolo, List<String> multiplo, DetachedCriteria criteria, String property) {
		if((!ApplicationUtil.isTrue(m) && ApplicationUtil.gtZero(singolo))||(ApplicationUtil.isTrue(m) && ApplicationUtil.notEmpty(multiplo))){
			DetachedCriteria c = DetachedCriteria.forClass(Campagna.class);
			DetachedCriteria criteriaT = c.createCriteria("team", "TC");
			ApplicationUtil.proprieta(false, m, criteriaT, "id", singolo, multiplo);
			c.setProjection(Projections.distinct(Projections.property("id")));
			if(getSubRicerca()) {
				criteria.add(Subqueries.propertyIn(property, c));
			} else {
				List<Long> ln = getList(c);
				if(ApplicationUtil.notEmpty(ln)) {
					criteria.add(Restrictions.in(property, ln));
				} else {
					criteria.add(Restrictions.eq(property, ConstantsGlobal.NULL));
				}
			}
		}
	}

	@SuppressWarnings("unchecked")
	public void subCriteriaRicercaTeam(Boolean m, Long singolo, List<String> multiplo, DetachedCriteria criteria, String property) {
		if((!ApplicationUtil.isTrue(m) && ApplicationUtil.gtZero(singolo))||(ApplicationUtil.isTrue(m) && ApplicationUtil.notEmpty(multiplo))){
			DetachedCriteria c = DetachedCriteria.forClass(Utente.class);
			DetachedCriteria criteriaT = c.createCriteria("team", "TS");
			ApplicationUtil.proprieta(false, m, criteriaT, "id", singolo, multiplo);
			c.setProjection(Projections.distinct(Projections.property("id")));
			if(getSubRicerca()) {
				criteria.add(Subqueries.propertyIn(property, c));
			} else {
				List<Long> ln = getList(c);
				if(ApplicationUtil.notEmpty(ln)) {
					criteria.add(Restrictions.in(property, ln));
				} else {
					criteria.add(Restrictions.eq(property, ConstantsGlobal.NULL));
				}
			}
		}
	}

	@SuppressWarnings("unchecked")
	public void subCriteriaCoordinatore(Boolean m, DetachedCriteria criteria, Long userId, Long singolo, List<String> multiplo) {
		DetachedCriteria c = DetachedCriteria.forClass(Agente.class);
		DetachedCriteria zone = criteria.createCriteria("zone", "TS");
		zone.createCriteria("supervisori").add(Restrictions.idEq(userId));
		ApplicationUtil.proprieta(false, m, zone, "id", singolo, multiplo);
		c.setProjection(Projections.distinct(Projections.property("id")));
		if(getSubRicerca()) {
			criteria.add(Subqueries.propertyIn("id", c));
		} else {
			List<Long> ln = getList(c);
			if(ApplicationUtil.notEmpty(ln)) {
				criteria.add(Restrictions.in("id", ln));
			} else {
				criteria.add(Restrictions.eq("id", ConstantsGlobal.NULL));
			}
		}

	}

	@SuppressWarnings("unchecked")
	public void subCriteriaCoordinatoreZoneCampagne(Boolean m, DetachedCriteria criteria, Long userId, Long singolo, List<String> multiplo) {
		DetachedCriteria c = DetachedCriteria.forClass(Campagna.class);
		DetachedCriteria zone = criteria.createCriteria("zone", "TC");
		zone.createCriteria("supervisori").add(Restrictions.idEq(userId));
		ApplicationUtil.proprieta(false, m, zone, "id", singolo, multiplo);
		c.setProjection(Projections.distinct(Projections.property("id")));
		if(getSubRicerca()) {
			criteria.add(Subqueries.propertyIn("id", c));
		} else {
			List<Long> ln = getList(c);
			if(ApplicationUtil.notEmpty(ln)) {
				criteria.add(Restrictions.in("id", ln));
			} else {
				criteria.add(Restrictions.eq("id", ConstantsGlobal.NULL));
			}
		}

	}
	@SuppressWarnings("unchecked")
	public void subCriteriaCoordinatoreCampagna(Long userId, DetachedCriteria criteria, String property) {
		DetachedCriteria c = DetachedCriteria.forClass(Campagna.class);
		c.createCriteria("zone", "TS").createCriteria("supervisori").add(Restrictions.idEq(userId));
		c.setProjection(Projections.distinct(Projections.property("id")));
		if(getSubRicerca()) {
			criteria.add(Subqueries.propertyIn(property, c));
		} else {
			List<Long> ln = getList(c);
			if(ApplicationUtil.notEmpty(ln)) {
				criteria.add(Restrictions.in(property, ln));
			} else {
				criteria.add(Restrictions.eq(property, ConstantsGlobal.NULL));
			}
		}
	}

	@SuppressWarnings("unchecked")
	public void subCriteriaCampagnaAgente(Long userId, DetachedCriteria criteria, String property) {
		DetachedCriteria c = DetachedCriteria.forClass(Campagna.class);
		c.createCriteria("zone", "TS").createCriteria("agente").createCriteria("user").add(Restrictions.idEq(userId));
		c.setProjection(Projections.distinct(Projections.property("id")));
		if(getSubRicerca()) {
			criteria.add(Subqueries.propertyIn(property, c));
		} else {
			List<Long> ln = getList(c);
			if(ApplicationUtil.notEmpty(ln)) {
				criteria.add(Restrictions.in(property, ln));
			} else {
				criteria.add(Restrictions.eq(property, ConstantsGlobal.NULL));
			}
		}
	}
	@SuppressWarnings("unchecked")
	public void subCriteriaCampagnaUser(boolean supervisore, Long userId, DetachedCriteria criteria, String property) {
		DetachedCriteria c = DetachedCriteria.forClass(Campagna.class);
		if(supervisore)
			c.createCriteria("team", "TC").createCriteria("supervisore").add(Restrictions.idEq(userId));
		else {
			c.createCriteria("team", "TC").createCriteria("user").add(Restrictions.idEq(userId));
		}
		c.setProjection(Projections.distinct(Projections.property("id")));
		if(getSubRicerca()) {
			criteria.add(Subqueries.propertyIn(property, c));
		} else {
			List<Long> ln = getList(c);
			if(ApplicationUtil.notEmpty(ln)) {
				criteria.add(Restrictions.in(property, ln));
			} else {
				criteria.add(Restrictions.eq(property, ConstantsGlobal.NULL));
			}
		}
	}
	@SuppressWarnings("unchecked")
	public void subCriteriaCampagnaProdotto(Long prodottoId, DetachedCriteria criteria, String property) {
		DetachedCriteria c = DetachedCriteria.forClass(Campagna.class);
		c.createCriteria("prodottiInVendita", "TS").add(Restrictions.eq("id.prodotto.id",prodottoId));
		c.setProjection(Projections.distinct(Projections.property("id")));
		if(getSubRicerca()) {
			criteria.add(Subqueries.propertyIn(property, c));
		} else {
			List<Long> ln = getList(c);
			if(ApplicationUtil.notEmpty(ln)) {
				criteria.add(Restrictions.in(property, ln));
			} else {
				criteria.add(Restrictions.eq(property, ConstantsGlobal.NULL));
			}
		}
	}
	@SuppressWarnings("unchecked")
	public void subCriteriaCampagnaSupervisore(Long userId, DetachedCriteria criteria, String property) {
		DetachedCriteria c = DetachedCriteria.forClass(Campagna.class);
		c.createCriteria("team", "TC").createCriteria("supervisore").add(Restrictions.idEq(userId));
		c.setProjection(Projections.distinct(Projections.property("id")));
		if(getSubRicerca()) {
			criteria.add(Subqueries.propertyIn(property, c));
		} else {
			List<Long> ln = getList(c);
			if(ApplicationUtil.notEmpty(ln)) {
				criteria.add(Restrictions.in(property, ln));
			} else {
				criteria.add(Restrictions.eq(property, ConstantsGlobal.NULL));
			}
		}
	}
	@SuppressWarnings("unchecked")
	public void sottoCriteriaCampagnaRete(Long userId, Integer max, DetachedCriteria master, String property) {
		DetachedCriteria criteria = DetachedCriteria.forClass(Campagna.class);
		DetachedCriteria c = criteria.createCriteria("zone", "TS").createCriteria("agente").createCriteria("closure_agenti_padre");
		if(ApplicationUtil.gtZero(max)) {
			c.add(Restrictions.le("distanza", max));
		}
		c.createCriteria("agente_padre").createCriteria("user").add(Restrictions.idEq(userId));
		criteria.setProjection(Projections.distinct(Projections.property("id")));
		if(getSubRicerca()) {
			master.add(Subqueries.propertyIn(property, c));
		} else {
			List<Long> ln = getList(c);
			if(ApplicationUtil.notEmpty(ln)) {
				master.add(Restrictions.in(property, ln));
			} else {
				master.add(Restrictions.eq(property, ConstantsGlobal.NULL));
			}
		}
	}
	@SuppressWarnings("unchecked")
	public void sottoCriteriaCampagnaSupervisore(Long userId, DetachedCriteria criteria, String property) {
		DetachedCriteria c = DetachedCriteria.forClass(Campagna.class);
		c.createCriteria("team", "TC").createCriteria("supervisore").add(Restrictions.idEq(userId));
		c.setProjection(Projections.distinct(Projections.property("id")));
		if(getSubRicerca()) {
			criteria.add(Subqueries.propertyIn(property, c));
		} else {
			List<Long> ln = getList(c);
			if(ApplicationUtil.notEmpty(ln)) {
				criteria.add(Restrictions.in(property, ln));
			} else {
				criteria.add(Restrictions.eq(property, ConstantsGlobal.NULL));
			}
		}
	}

	@SuppressWarnings("unchecked")
	public void sottoCriteriaStoriaContattoI(boolean operatore, Long userId, RicercaStoricoCriteria a, DetachedCriteria criteria) {
		if(ApplicationUtil.gtZero(userId) || ApplicationUtil.isNotBlank(a.getStorico_nota()) || a.getStorico_inizio() != null|| a.getStorico_fine() != null || ApplicationUtil.gtZero(a.getStorico_esitoId())) {
			DetachedCriteria c = DetachedCriteria.forClass(StoriaContatto.class);
			if(operatore) {
				c.add(Restrictions.eq("invisibile", Boolean.FALSE));
			}
			if(ApplicationUtil.gtZero(userId)) {
				c.add(Restrictions.eq("operatore.id",userId));
			}
			if(ApplicationUtil.gtZero(a.getStorico_esitoId())) {
				c.add(Restrictions.eq("esito.id",a.getStorico_esitoId()));
			}
			if (ApplicationUtil.isNotBlank(a.getStorico_nota())) {
				ApplicationUtil.valori(ConstantsGlobal.colonSeparator, true, a.getStorico_nota(), c, "nota");
			}
			ApplicationUtil.dataIntervalD(a.getStorico_inizio(), a.getStorico_fine(), "data", c);
			c.setProjection(Projections.distinct(Projections.property("contatto.id")));
			if(getSubRicerca()) {
				criteria.add(Subqueries.propertyIn("id", c));
			} else {
				List<Long> ln = getList(c);
				if(ApplicationUtil.notEmpty(ln)) {
					criteria.add(Restrictions.in("id", ln));
				} else {
					criteria.add(Restrictions.eq("id", ConstantsGlobal.NULL));
				}
			}
		}
	}

	@SuppressWarnings("unchecked")
	public void sottoCriteriaStoriaContattoS(boolean operatore, String userId, RicercaStoricoCriteria a, DetachedCriteria criteria) {
		if(ApplicationUtil.isNotBlank(userId) || ApplicationUtil.isNotBlank(a.getStorico_nota()) || a.getStorico_inizio() != null|| a.getStorico_fine() != null || ApplicationUtil.gtZero(a.getStorico_esitoId())) {
			DetachedCriteria c = DetachedCriteria.forClass(StoriaContatto.class);
			if(operatore) {
				c.add(Restrictions.eq("invisibile", Boolean.FALSE));
			}
			if (ApplicationUtil.isNotBlank(userId)) {
				DetachedCriteria cOp = criteria.createCriteria("operatore");
				ApplicationUtil.operatore(cOp, userId);
			}
			if(ApplicationUtil.gtZero(a.getStorico_esitoId())) {
				c.add(Restrictions.eq("esito.id",a.getStorico_esitoId()));
			}
			if (ApplicationUtil.isNotBlank(a.getStorico_nota())) {
				ApplicationUtil.valori(ConstantsGlobal.colonSeparator, true, a.getStorico_nota(), c, "nota");
			}
			ApplicationUtil.dataIntervalD(a.getStorico_inizio(), a.getStorico_fine(), "data", c);
			c.setProjection(Projections.distinct(Projections.property("contatto.id")));
			if(getSubRicerca()) {
				criteria.add(Subqueries.propertyIn("id", c));
			} else {
				List<Long> ln = getList(c);
				if(ApplicationUtil.notEmpty(ln)) {
					criteria.add(Restrictions.in("id", ln));
				} else {
					criteria.add(Restrictions.eq("id", ConstantsGlobal.NULL));
				}
			}
		}
	}

	@SuppressWarnings("unchecked")
	public void sottoCriteriaStoriaAppuntamentoI(Long userId, AppuntamentoCriteria a, DetachedCriteria criteria) {
		if(ApplicationUtil.gtZero(userId) || ApplicationUtil.isNotBlank(a.getStorico_nota()) || a.getStorico_inizio() != null|| a.getStorico_fine() != null || ApplicationUtil.gtZero(a.getStorico_esitoId())) {
			DetachedCriteria c = DetachedCriteria.forClass(StoriaAppuntamento.class);
			if(ApplicationUtil.gtZero(userId)) {
				c.add(Restrictions.eq("utente.id",userId));
			}
			if (ApplicationUtil.isNotBlank(a.getStorico_nota())) {
				ApplicationUtil.valori(ConstantsGlobal.colonSeparator, true, a.getStorico_nota(), c, "nota");
			}
			if(ApplicationUtil.gtZero(a.getStorico_esitoId())) {
				c.add(Restrictions.eq("esito.id",a.getStorico_esitoId()));
			}
			ApplicationUtil.dataIntervalD(a.getStorico_inizio(), a.getStorico_fine(), "data", c);
			c.setProjection(Projections.distinct(Projections.property("appuntamento.id")));
			if(getSubRicerca()) {
				criteria.add(Subqueries.propertyIn("id", c));
			} else {
				List<Long> ln = getList(c);
				if(ApplicationUtil.notEmpty(ln)) {
					criteria.add(Restrictions.in("id", ln));
				} else {
					criteria.add(Restrictions.eq("id", ConstantsGlobal.NULL));
				}
			}
		}
	}

	@SuppressWarnings("unchecked")
	public void sottoCriteriaStoriaAppuntamentoS(String userId, AppuntamentoCriteria a, DetachedCriteria criteria) {
		if(ApplicationUtil.isNotBlank(userId) || ApplicationUtil.isNotBlank(a.getStorico_nota()) || a.getStorico_inizio() != null|| a.getStorico_fine() != null || ApplicationUtil.gtZero(a.getStorico_esitoId())) {
			DetachedCriteria c = DetachedCriteria.forClass(StoriaAppuntamento.class);
			if (ApplicationUtil.isNotBlank(userId)) {
				DetachedCriteria cOp = criteria.createCriteria("operatore");
				ApplicationUtil.operatore(cOp, userId);
			}
			if (ApplicationUtil.isNotBlank(a.getStorico_nota())) {
				ApplicationUtil.valori(ConstantsGlobal.colonSeparator, true, a.getStorico_nota(), c, "nota");
			}
			if(ApplicationUtil.gtZero(a.getStorico_esitoId())) {
				c.add(Restrictions.eq("esito.id",a.getStorico_esitoId()));
			}
			ApplicationUtil.dataIntervalD(a.getStorico_inizio(), a.getStorico_fine(), "data", c);
			c.setProjection(Projections.distinct(Projections.property("appuntamento.id")));
			if(getSubRicerca()) {
				criteria.add(Subqueries.propertyIn("id", c));
			} else {
				List<Long> ln = getList(c);
				if(ApplicationUtil.notEmpty(ln)) {
					criteria.add(Restrictions.in("id", ln));
				} else {
					criteria.add(Restrictions.eq("id", ConstantsGlobal.NULL));
				}
			}
		}
	}

	@SuppressWarnings("unchecked")
	public void sottoCriteriaStoriaContrattoI(Long userId, ContrattoCriteria a, DetachedCriteria criteria) {
		if(ApplicationUtil.gtZero(userId) || ApplicationUtil.isNotBlank(a.getStorico_nota()) || a.getStorico_inizio() != null|| a.getStorico_fine() != null || ApplicationUtil.gtZero(a.getStorico_esitoId())) {
			DetachedCriteria c = DetachedCriteria.forClass(StoriaContratto.class);
			if(ApplicationUtil.gtZero(userId)) {
				c.add(Restrictions.eq("utente.id",userId));
			}
			if (ApplicationUtil.isNotBlank(a.getStorico_nota())) {
				ApplicationUtil.valori(ConstantsGlobal.colonSeparator, true, a.getStorico_nota(), c, "nota");
			}
			if(ApplicationUtil.gtZero(a.getStorico_esitoId())) {
				c.add(Restrictions.eq("esito.id",a.getStorico_esitoId()));
			}
			ApplicationUtil.dataIntervalD(a.getStorico_inizio(), a.getStorico_fine(), "data", c);
			c.setProjection(Projections.distinct(Projections.property("contratto.id")));
			if(getSubRicerca()) {
				criteria.add(Subqueries.propertyIn("id", c));
			} else {
				List<Long> ln = getList(c);
				if(ApplicationUtil.notEmpty(ln)) {
					criteria.add(Restrictions.in("id", ln));
				} else {
					criteria.add(Restrictions.eq("id", ConstantsGlobal.NULL));
				}
			}
		}
	}

	@SuppressWarnings("unchecked")
	public void sottoCriteriaStoriaContrattoS(String userId, ContrattoCriteria a, DetachedCriteria criteria) {
		if(ApplicationUtil.isNotBlank(userId) || ApplicationUtil.isNotBlank(a.getStorico_nota()) || a.getStorico_inizio() != null|| a.getStorico_fine() != null || ApplicationUtil.gtZero(a.getStorico_esitoId())) {
			DetachedCriteria c = DetachedCriteria.forClass(StoriaContratto.class);
			if (ApplicationUtil.isNotBlank(userId)) {
				DetachedCriteria cOp = criteria.createCriteria("operatore");
				ApplicationUtil.operatore(cOp, userId);
			}
			if (ApplicationUtil.isNotBlank(a.getStorico_nota())) {
				ApplicationUtil.valori(ConstantsGlobal.colonSeparator, true, a.getStorico_nota(), c, "nota");
			}
			if(ApplicationUtil.gtZero(a.getStorico_esitoId())) {
				c.add(Restrictions.eq("esito.id",a.getStorico_esitoId()));
			}
			ApplicationUtil.dataIntervalD(a.getStorico_inizio(), a.getStorico_fine(), "data", c);
			c.setProjection(Projections.distinct(Projections.property("contratto.id")));
			if(getSubRicerca()) {
				criteria.add(Subqueries.propertyIn("id", c));
			} else {
				List<Long> ln = getList(c);
				if(ApplicationUtil.notEmpty(ln)) {
					criteria.add(Restrictions.in("id", ln));
				} else {
					criteria.add(Restrictions.eq("id", ConstantsGlobal.NULL));
				}
			}
		}
	}



	@SuppressWarnings("unchecked")
	public void subCriteriaAgentiSottoRete(Long id, boolean distanza, int max, DetachedCriteria master, String property) {
		DetachedCriteria criteria = DetachedCriteria.forClass(Closure.class);
		criteria.add(Restrictions.eq("agente_padre.id",id));
		if(ApplicationUtil.gtZero(max) && distanza) {
			criteria.add(Restrictions.le("distanza", max));
		}
		criteria.setProjection(Projections.distinct(Projections.property("agente.id")));
		if(getSubRicerca()) {
			master.add(Subqueries.propertyIn(property, criteria));
		} else {
			List<Long> ln = getList(criteria);
			if(ApplicationUtil.notEmpty(ln)) {
				master.add(Restrictions.in(property, ln));
			} else {
				master.add(Restrictions.eq(property, ConstantsGlobal.NULL));
			}
		}
	}

	@SuppressWarnings("unchecked")
	public void subCriteriaAgentiNotInSottoRete(Long id, DetachedCriteria master, String property) {
		DetachedCriteria criteria = DetachedCriteria.forClass(Closure.class);
		criteria.add(Restrictions.eq("agente_padre.id",id));
		criteria.setProjection(Projections.distinct(Projections.property("agente.id")));
		if(getSubRicerca()) {
			master.add(Subqueries.propertyNotIn(property, criteria));
		} else {
			List<Long> ln = getList(criteria);
			if(ApplicationUtil.notEmpty(ln)) {
				master.add(Restrictions.not(Restrictions.in(property, ln)));
			} else {
				master.add(Restrictions.not(Restrictions.eq(property, ConstantsGlobal.NULL)));
			}
		}
	}
	@SuppressWarnings("unchecked")
	public void subCriteriaAgentiSottoReteByUser(Long id, int rete, int max, DetachedCriteria master, String property) {
		DetachedCriteria criteria = DetachedCriteria.forClass(Closure.class);
		criteria.createCriteria("agente_padre").createCriteria("user").add(Restrictions.eq("id",id));
		if(ApplicationUtil.gtZero(rete)) {
			if(rete == 1) {
				criteria.add(Restrictions.ge("distanza", 1));
			}
			if(rete == 2) {
				criteria.add(Restrictions.eq("distanza", 1));
			}
		}
		if(ApplicationUtil.gtZero(max)) {
			criteria.add(Restrictions.le("distanza", max));
		}
		criteria.setProjection(Projections.distinct(Projections.property("agente.id")));
		if(getSubRicerca()) {
			master.add(Subqueries.propertyIn(property, criteria));
		} else {
			List<Long> ln = getList(criteria);
			if(ApplicationUtil.notEmpty(ln)) {
				master.add(Restrictions.in(property, ln));
			} else {
				master.add(Restrictions.eq(property, ConstantsGlobal.NULL));
			}
		}
	}


	public void ricercaAggiuntivaAnagraficaMultipla(RicercaAnagraficaCriteria ana, DetachedCriteria criteria) {
		List<DatoAggiuntivoAnagraficaRicerca> dati = ana.getDatiAggiuntivoAnagrafica();
		if(ApplicationUtil.notEmpty(dati)) {
			Conjunction conjunction = Restrictions.conjunction();
			Disjunction disjunction = Restrictions.disjunction();
			for(DatoAggiuntivoAnagraficaRicerca dato : dati) {
				DetachedCriteria criteriaAgg = DetachedCriteria.forClass(Anagrafica.class);
				criteriaAgg.setProjection(Projections.distinct(Projections.id()));
				DetachedCriteria dettagli = criteriaAgg.createCriteria("dettagli", "dettagli", ApplicationUtil.leftJoin());
				DetachedCriteria campi = dettagli.createCriteria("campo_aggiuntivo", "campo_aggiuntivo", ApplicationUtil.leftJoin());
				if(dato.getJunction())
					conjunction.add(Subqueries.propertyIn("id", criteriaAgg)); 
				else 
					disjunction.add(Subqueries.propertyIn("id", criteriaAgg)); 

				CampoAggiuntivoAnagrafica campo = dato.getCampo_aggiuntivo();
				campi.add(Restrictions.idEq(campo.getId()));
				if(dato.getTutto()) {
					String tipo_ricerca = dato.getTipoRicerca();
					if(campo.getRicercaSingola()) {	
						if(ApplicationUtil.isNotBlank(dato.getValore1())) {
							String valore = ApplicationUtil.trimToEmpty(dato.getValore1());
							if(ApplicationUtil.isNotBlank(valore)) {
								if(tipo_ricerca.equals(ConstantsMap.RICERCA_STRING_SPECIFICA)) {
									ApplicationUtil.valori(ConstantsGlobal.colonSeparator, !dato.getInverti(), valore, dettagli, MatchMode.EXACT, "valore");
								}
							}
						}
					} 
					if(campo.getRicercaMultipla()) {	
						if(ApplicationUtil.notEmpty(dato.getValore_multiplo())) {
							for (String ricerca : dato.getValore_multiplo()){
								if(ApplicationUtil.isNotBlank(ricerca)) {
									if(tipo_ricerca.equals(ConstantsMap.RICERCA_STRING_SPECIFICA)) {
										ApplicationUtil.valori(ConstantsGlobal.colonSeparator, !dato.getInverti(), ApplicationUtil.trimToEmpty(ricerca), dettagli, MatchMode.ANYWHERE, "valore");
									}
								}
							}
						}
					} 
					if(campo.getRicercaStringa()) {	
						if(ApplicationUtil.isNotBlank(dato.getValore1())) {
							String valore = ApplicationUtil.trimToEmpty(dato.getValore1());
							if(tipo_ricerca.equals(ConstantsMap.RICERCA_STRING_SPECIFICA)) {
								ApplicationUtil.valori(ConstantsGlobal.colonSeparator, !dato.getInverti(), valore, dettagli, "valore");
							} 
						} 
					} 
					if(campo.getRicercaFile()) {
						if(ApplicationUtil.isNotBlank(dato.getValore1())) {
							String valore = ApplicationUtil.trimToEmpty(dato.getValore1());
							if( ApplicationUtil.isNotBlank(valore)) {
								if(tipo_ricerca.equals(ConstantsMap.RICERCA_STRING_SPECIFICA)) {
									ApplicationUtil.valori(ConstantsGlobal.colonSeparator, !dato.getInverti(), valore, dettagli, MatchMode.ANYWHERE, "val_s");
								}
							}
						}
					} 
					if(campo.getRicercaBooleana()) {
						if(ApplicationUtil.isNotBlank(dato.getValore1())) {
							String valore = ApplicationUtil.trimToEmpty(dato.getValore1());
							if( ApplicationUtil.isNotBlank(valore)) {
								if(tipo_ricerca.equals(ConstantsMap.RICERCA_STRING_SPECIFICA)) {
									ApplicationUtil.valori(ConstantsGlobal.colonSeparator, !dato.getInverti(), valore, dettagli, MatchMode.EXACT, "val_s");
								}
							}
						}
					} 
					if(campo.getRicercaNumero()) {
						if(tipo_ricerca.equals(ConstantsMap.RICERCA_STRING_INTERVALLO)) {
							Object time1 = null;
							Object time2 = null;
							String table = null;
							boolean compare = false;
							if(dato.getCampo_aggiuntivo().getData()) {
								time1 = dato.getValore_data1();
								time2 = dato.getValore_data2();
								compare = ApplicationUtil.compare(time1, time2);
								table = "val_d";
							} else if(dato.getCampo_aggiuntivo().getDataora()) {
								time1 = dato.getValore_datatime1();
								time2 = dato.getValore_datatime2();
								compare = ApplicationUtil.compare(time1, time2);
								table = "val_d";
							} else if(dato.getCampo_aggiuntivo().getOra()) {
								time1 = ApplicationUtil.dateToTime(dato.getValore_time1());
								time2 = ApplicationUtil.dateToTime(dato.getValore_time2());
								compare = ApplicationUtil.compare(time1, time2);
								table = "val_t";
							} else if(dato.getCampo_aggiuntivo().getSpinner() || dato.getCampo_aggiuntivo().getSlider() || dato.getCampo_aggiuntivo().getIntero()) {
								time1 = ApplicationUtil.parseInteger(dato.getValore1());
								time2 = ApplicationUtil.parseInteger(dato.getValore2());
								compare = ApplicationUtil.compare(time1, time2);
								table = "val_i";
							} else if(dato.getCampo_aggiuntivo().getNumero()) {
								time1 = ApplicationUtil.parseBigDecimal(dato.getValore1());
								time2 = ApplicationUtil.parseBigDecimal(dato.getValore2());
								compare = ApplicationUtil.compare(time1, time2);
								table = "val_f";
							} 
							if(table != null && time1 != null && time2 == null) {
								if(!dato.getInverti()) {
									dettagli.add(Restrictions.ge(table, time1));
								} else {
									dettagli.add(Restrictions.not(Restrictions.ge(table, time1)));
								}
							}
							if(table != null && time1 == null && time2 != null) {
								if(!dato.getInverti()) {
									dettagli.add(Restrictions.le(table, time2));
								} else {
									dettagli.add(Restrictions.not(Restrictions.le(table, time2)));
								}

							}
							if(table != null && time1 != null && time2 != null) {
								if(!dato.getInverti()) {
									if (compare && !ConstantsGlobal.permitInterval) {
										dettagli.add(Restrictions.between(table, time2, time1));
									} else {
										dettagli.add(Restrictions.between(table, time1, time2));
									}
								} else {
									if (compare && !ConstantsGlobal.permitInterval) {
										dettagli.add(Restrictions.not(Restrictions.between(table, time2, time1)));
									} else {
										dettagli.add(Restrictions.not(Restrictions.between(table, time1, time2)));
									}
								}
							}
						} else {
							Object time = null;
							String table = null;
							if(dato.getCampo_aggiuntivo().getData()) {
								time = dato.getValore_data1();
								table = "val_d";
							} else if(dato.getCampo_aggiuntivo().getDataora()) {
								time = dato.getValore_datatime1();
								table = "val_d";
							} else if(dato.getCampo_aggiuntivo().getOra()) {
								time = ApplicationUtil.dateToTime(dato.getValore_time1());
								table = "val_t";
							} else if(dato.getCampo_aggiuntivo().getSpinner() || dato.getCampo_aggiuntivo().getSlider() || dato.getCampo_aggiuntivo().getIntero()) {
								time = ApplicationUtil.parseInteger(dato.getValore1());
								table = "val_i";
							} else if(dato.getCampo_aggiuntivo().getNumero()) {
								time = ApplicationUtil.parseBigDecimal(dato.getValore1());
								table = "val_f";
							} 
							if(table != null && time != null) {
								if(tipo_ricerca.equals(ConstantsMap.RICERCA_STRING_MINORE)) {
									if(!dato.getInverti()) {
										dettagli.add(Restrictions.le(table, time));
									} else {
										dettagli.add(Restrictions.gt(table, time));
									} 
								}
								if(tipo_ricerca.equals(ConstantsMap.RICERCA_STRING_MAGGIORE)) {
									if(!dato.getInverti()) {
										dettagli.add(Restrictions.ge(table, time));
									} else {
										dettagli.add(Restrictions.lt(table, time));
									} 
								}
								if(tipo_ricerca.equals(ConstantsMap.RICERCA_STRING_UGUALE)){
									if(!dato.getInverti()) {
										dettagli.add(Restrictions.eq(table, time));
									} else {
										dettagli.add(Restrictions.ne(table, time));
									}
								} 
							}
						}
					} 
				}
			}
			criteria.add(conjunction);
			criteria.add(disjunction);
		}

	}

	public void ricercaAggiuntivaAnagraficaSingola(RicercaAnagraficaCriteria ana, DetachedCriteria criteria) {
		if(ana.getValidoAnagrafica()){
			DetachedCriteria dettagli = criteria.createCriteria("dettagli");
			ApplicationUtil.valori(ConstantsGlobal.colonSeparator, true, ana.getValoriDatoAnagrafica(), dettagli, "valore");
			if(!ana.getCampoAnagraficaId().equals(ConstantsGlobal.ALTRO)){
				dettagli.createCriteria("campo_aggiuntivo").add(Restrictions.idEq(ana.getCampoAnagraficaId()));
			} 
		}
	}

	public void ricercaAggiuntivaContrattoSingola(RicercaAnagraficaCriteria crti, DetachedCriteria criteria) {
		if(crti.getValidoContratto()){
			DetachedCriteria dettagli = criteria.createCriteria("dettagli");
			ApplicationUtil.valori(ConstantsGlobal.colonSeparator, true, crti.getValoriDatoContratto(), dettagli, "valore");
			if(!crti.getCampoContrattoId().equals(ConstantsGlobal.ALTRO)){
				dettagli.createCriteria("campo_aggiuntivo").add(Restrictions.idEq(crti.getCampoContrattoId()));
			}
		}
	}

	public void ricercaConsenso(RicercaAnagraficaCriteria ana, DetachedCriteria criteria) {
		Date now = ApplicationUtil.date();

		if (ApplicationUtil.gtZero(ana.getConsenso_tfisso())) {
			if (ApplicationUtil.eq(ana.getConsenso_tfisso(), 1)) {
				criteria.add(Restrictions.or(Restrictions.gt("consenso_tfisso", now), Restrictions.isNull("consenso_tfisso")));
			} else {
				criteria.add(Restrictions.le("consenso_tfisso", now));
			}
		}
		if (ApplicationUtil.gtZero(ana.getConsenso_tmobile())) {
			if (ApplicationUtil.eq(ana.getConsenso_tmobile(), 1)) {
				criteria.add(Restrictions.or(Restrictions.gt("consenso_tmobile", now), Restrictions.isNull("consenso_tmobile")));
			} else {
				criteria.add(Restrictions.le("consenso_tmobile", now));
			}
		}
		if (ApplicationUtil.gtZero(ana.getConsenso_tfax())) {
			if (ApplicationUtil.eq(ana.getConsenso_tfax(), 1)) {
				criteria.add(Restrictions.or(Restrictions.gt("consenso_tfax", now), Restrictions.isNull("consenso_tfax")));
			} else {
				criteria.add(Restrictions.le("consenso_tfax", now));
			}
		}
		if (ApplicationUtil.gtZero(ana.getConsenso_taltro())) {
			if (ApplicationUtil.eq(ana.getConsenso_taltro(), 1)) {
				criteria.add(Restrictions.or(Restrictions.gt("consenso_taltro", now), Restrictions.isNull("consenso_taltro")));
			} else {
				criteria.add(Restrictions.le("consenso_taltro", now));
			}
		}
		if (ApplicationUtil.gtZero(ana.getConsenso_email())) {
			if (ApplicationUtil.eq(ana.getConsenso_email(), 1)) {
				criteria.add(Restrictions.or(Restrictions.gt("consenso_email", now), Restrictions.isNull("consenso_email")));
			} else {
				criteria.add(Restrictions.le("consenso_email", now));
			}
		}

		if (ApplicationUtil.gtZero(ana.getConsenso_rmail())) {
			if (ApplicationUtil.eq(ana.getConsenso_rmail(), 1)) {
				criteria.add(Restrictions.or(Restrictions.gt("consenso_rmail", now), Restrictions.isNull("consenso_rmail")));
			} else {
				criteria.add(Restrictions.le("consenso_rmail", now));
			}
		}

	}



	public void ricercaAggiuntivaContrattoMultiplo(RicercaAnagraficaCriteria crti, DetachedCriteria criteria) {
		List<DatoAggiuntivoContrattoRicerca> dati = crti.getDatiAggiuntivoContratto();
		if(ApplicationUtil.notEmpty(dati)) {
			Conjunction conjunction = Restrictions.conjunction();
			Disjunction disjunction = Restrictions.disjunction();
			for(DatoAggiuntivoContrattoRicerca dato : dati) {
				DetachedCriteria criteriaAgg = DetachedCriteria.forClass(Contratto.class);
				criteriaAgg.setProjection(Projections.distinct(Projections.id()));
				DetachedCriteria dettagli = criteriaAgg.createCriteria("dettagli", "dettagli", ApplicationUtil.leftJoin());
				DetachedCriteria campi = dettagli.createCriteria("campo_aggiuntivo", "campo_aggiuntivo", ApplicationUtil.leftJoin());
				if(dato.getJunction())
					conjunction.add(Subqueries.propertyIn("id", criteriaAgg)); 
				else 
					disjunction.add(Subqueries.propertyIn("id", criteriaAgg)); 

				CampoAggiuntivoContratto campo = dato.getCampo_aggiuntivo();
				campi.add(Restrictions.idEq(campo.getId()));
				if(dato.getTutto()) {
					String tipo_ricerca = dato.getTipoRicerca();
					if(campo.getRicercaSingola()) {	
						if( ApplicationUtil.isNotBlank(dato.getValore1())) {
							String valore = ApplicationUtil.trimToEmpty(dato.getValore1());
							if( ApplicationUtil.isNotBlank(valore)) {
								if(tipo_ricerca.equals(ConstantsMap.RICERCA_STRING_SPECIFICA)) {
									ApplicationUtil.valori(ConstantsGlobal.colonSeparator, !dato.getInverti(), valore, dettagli, MatchMode.EXACT, "valore");
								}
							}
						}
					} 
					if(campo.getRicercaMultipla()) {	
						if( ApplicationUtil.notEmpty(dato.getValore_multiplo())) {
							for (String ricerca : dato.getValore_multiplo()){
								if( ApplicationUtil.isNotBlank(ricerca)) {
									if(tipo_ricerca.equals(ConstantsMap.RICERCA_STRING_SPECIFICA)) {
										ApplicationUtil.valori(ConstantsGlobal.colonSeparator, !dato.getInverti(),ApplicationUtil.trimToEmpty(ricerca), dettagli, MatchMode.ANYWHERE, "valore");
									}
								}
							}
						}
					} 
					if(campo.getRicercaStringa()) {	
						if( ApplicationUtil.isNotBlank(dato.getValore1())) {
							String valore = ApplicationUtil.trimToEmpty(dato.getValore1());
							if(tipo_ricerca.equals(ConstantsMap.RICERCA_STRING_SPECIFICA)) {
								ApplicationUtil.valori(ConstantsGlobal.colonSeparator, !dato.getInverti(), valore, dettagli, "valore");
							} 
						} 
					}
					if(campo.getRicercaFile()) {
						if(ApplicationUtil.isNotBlank(dato.getValore1())) {
							String valore = ApplicationUtil.trimToEmpty(dato.getValore1());
							if( ApplicationUtil.isNotBlank(valore)) {
								if(tipo_ricerca.equals(ConstantsMap.RICERCA_STRING_SPECIFICA)) {
									ApplicationUtil.valori(ConstantsGlobal.colonSeparator, !dato.getInverti(), valore, dettagli, MatchMode.ANYWHERE, "val_s");
								}
							}
						}
					} 
					if(campo.getRicercaBooleana()) {
						if(ApplicationUtil.isNotBlank(dato.getValore1())) {
							String valore = ApplicationUtil.trimToEmpty(dato.getValore1());
							if( ApplicationUtil.isNotBlank(valore)) {
								if(tipo_ricerca.equals(ConstantsMap.RICERCA_STRING_SPECIFICA)) {
									ApplicationUtil.valori(ConstantsGlobal.colonSeparator, !dato.getInverti(), valore, dettagli, MatchMode.EXACT, "val_s");
								}
							}
						}
					} 
					if(campo.getRicercaNumero()) {
						if(tipo_ricerca.equals(ConstantsMap.RICERCA_STRING_INTERVALLO)) {
							Object time1 = null;
							Object time2 = null;
							String table = null;
							boolean compare = false;
							if(dato.getCampo_aggiuntivo().getData()) {
								time1 = dato.getValore_data1();
								time2 = dato.getValore_data2();
								compare = ApplicationUtil.compare(time1, time2);
								table = "val_d";
							} else if(dato.getCampo_aggiuntivo().getDataora()) {
								time1 = dato.getValore_datatime1();
								time2 = dato.getValore_datatime2();
								compare = ApplicationUtil.compare(time1, time2);
								table = "val_d";
							} else if(dato.getCampo_aggiuntivo().getOra()) {
								time1 = ApplicationUtil.dateToTime(dato.getValore_time1());
								time2 = ApplicationUtil.dateToTime(dato.getValore_time2());
								compare = ApplicationUtil.compare(time1, time2);
								table = "val_t";
							} else if(dato.getCampo_aggiuntivo().getSpinner() || dato.getCampo_aggiuntivo().getSlider() || dato.getCampo_aggiuntivo().getIntero()) {
								time1 = ApplicationUtil.parseInteger(dato.getValore1());
								time2 = ApplicationUtil.parseInteger(dato.getValore2());
								compare = ApplicationUtil.compare(time1, time2);
								table = "val_i";
							} else if(dato.getCampo_aggiuntivo().getNumero()) {
								time1 = ApplicationUtil.parseBigDecimal(dato.getValore1());
								time2 = ApplicationUtil.parseBigDecimal(dato.getValore2());
								compare = ApplicationUtil.compare(time1, time2);
								table = "val_f";
							} 
							if(table != null && time1 != null && time2 == null) {
								if(!dato.getInverti()) {
									dettagli.add(Restrictions.ge(table, time1));
								} else {
									dettagli.add(Restrictions.not(Restrictions.ge(table, time1)));
								}
							}
							if(table != null && time1 == null && time2 != null) {
								if(!dato.getInverti()) {
									dettagli.add(Restrictions.le(table, time2));
								} else {
									dettagli.add(Restrictions.not(Restrictions.le(table, time2)));
								}

							}
							if(table != null && time1 != null && time2 != null) {
								if(!dato.getInverti()) {
									if (compare && !ConstantsGlobal.permitInterval) {
										dettagli.add(Restrictions.between(table, time2, time1));
									} else {
										dettagli.add(Restrictions.between(table, time1, time2));
									}
								} else {
									if (compare && !ConstantsGlobal.permitInterval) {
										dettagli.add(Restrictions.not(Restrictions.between(table, time2, time1)));
									} else {
										dettagli.add(Restrictions.not(Restrictions.between(table, time1, time2)));
									}
								}
							}
						} else {
							Object time = null;
							String table = null;
							if(dato.getCampo_aggiuntivo().getData()) {
								time = dato.getValore_data1();
								table = "val_d";
							} else if(dato.getCampo_aggiuntivo().getDataora()) {
								time = dato.getValore_datatime1();
								table = "val_d";
							} else if(dato.getCampo_aggiuntivo().getOra()) {
								time = ApplicationUtil.dateToTime(dato.getValore_time1());
								table = "val_t";
							} else if(dato.getCampo_aggiuntivo().getSpinner() || dato.getCampo_aggiuntivo().getSlider() || dato.getCampo_aggiuntivo().getIntero()) {
								time = ApplicationUtil.parseInteger(dato.getValore1());
								table = "val_i";
							} else if(dato.getCampo_aggiuntivo().getNumero()) {
								time = ApplicationUtil.parseBigDecimal(dato.getValore1());
								table = "val_f";
							} 
							if(table != null && time != null) {
								if(tipo_ricerca.equals(ConstantsMap.RICERCA_STRING_MINORE)) {
									if(!dato.getInverti()) {
										dettagli.add(Restrictions.le(table, time));
									} else {
										dettagli.add(Restrictions.gt(table, time));
									} 
								}
								if(tipo_ricerca.equals(ConstantsMap.RICERCA_STRING_MAGGIORE)) {
									if(!dato.getInverti()) {
										dettagli.add(Restrictions.ge(table, time));
									} else {
										dettagli.add(Restrictions.lt(table, time));
									} 
								}
								if(tipo_ricerca.equals(ConstantsMap.RICERCA_STRING_UGUALE)){
									if(!dato.getInverti()) {
										dettagli.add(Restrictions.eq(table, time));
									} else {
										dettagli.add(Restrictions.ne(table, time));
									}
								} 
							}
						}
					} 
				}
			}
			criteria.add(conjunction);
			criteria.add(disjunction);
		}

	}

	public void ricercaIndirizzo(DetachedCriteria criteria, RicercaAnagraficaCriteria rc, String ok) {
		if(!ApplicationUtil.equals(ok, ConstantsMap.no)) {
			if(ApplicationUtil.gtZero(rc.getIndirizzo())) {
				if(rc.getIndirizzo().equals(1)) {
					ApplicationUtil.indirizzo(criteria.createCriteria("indirizzo_legale"), rc);
				}
				if(rc.getIndirizzo().equals(2)) {
					ApplicationUtil.indirizzo(criteria.createCriteria("indirizzo_operativo"), rc);
				}
			} else {
				DetachedCriteria ind = DetachedCriteria.forClass(Indirizzo.class);
				ind.setProjection(Projections.distinct(Projections.id()));
				ApplicationUtil.indirizzo(ind, rc);
				criteria.add(Restrictions.or(Subqueries.propertyIn("indirizzo_legale.id", ind), Subqueries.propertyIn("indirizzo_operativo.id", ind))); 
			}
		}
	}


	@SuppressWarnings("unchecked")
	public void subPropertyInS(DetachedCriteria master, DetachedCriteria slave, String property) {
		if(ConstantsGlobal.subquery) {
			master.add(Subqueries.propertyIn(property, slave));
		} else {
			List<Long> ln = getList(slave);
			if(ApplicationUtil.notEmpty(ln)) {
				master.add(Restrictions.in(property, ln));
			} else {
				master.add(Restrictions.eq(property, ConstantsGlobal.NULL));
			}
		}
	}
	@SuppressWarnings("unchecked")
	public void subPropertyNotInS(DetachedCriteria master, DetachedCriteria slave, String property) {
		if(ConstantsGlobal.subquery) {
			master.add(Subqueries.propertyNotIn(property, slave));
		} else {
			List<Long> ln = getList(slave);
			if(ApplicationUtil.notEmpty(ln)) {
				master.add(Restrictions.not(Restrictions.in(property, ln)));
			} else {
				master.add(Restrictions.not(Restrictions.eq(property, ConstantsGlobal.NULL)));
			}
		}
	}
	
	@SuppressWarnings("unchecked")
	public void subCriteriaRoleOperatore(Long userId, DetachedCriteria master, String campagna, String operatore) {
		Boolean stm = separaTZ();
		if(ApplicationUtil.isTrue(stm) && userId != null ) {
			DetachedCriteria c = DetachedCriteria.forClass(Team.class); 
			DetachedCriteria u = c.createCriteria("user", "utente", ApplicationUtil.leftJoin());
			u.add(Restrictions.idEq(userId)); 
			c.createCriteria("campagne", "campagna", ApplicationUtil.leftJoin());
			c.setProjection(Projections.projectionList()
					.add(Projections.distinct(Projections.property("id").as("id")))
					.add((Projections.property("utente.id").as("utente_id")))
					.add((Projections.property("campagna.id").as("campagna_id")))
					);
			List<GruppoModel> ln = getList(c, GruppoModel.class); 
			List<GruppoModel> gruppo = ApplicationUtil.collectionToList(ln, "getId");
			boolean ok = false;
			if(ApplicationUtil.notEmpty(gruppo)) {
				Disjunction disjunction = Restrictions.disjunction();
				for(GruppoModel gP : gruppo) {
					if(ApplicationUtil.notEmpty(gP.getCampagne()) && ApplicationUtil.notEmpty(gP.getUtenti())) {
						ok = true;
						disjunction.add(Restrictions.and(Restrictions.in(campagna + ".id", gP.getCampagne()), Restrictions.in(operatore + ".id", gP.getUtenti())));
					}
				}
				master.add(disjunction);
			}
			if(!ok) {
				master.add(Restrictions.not(Restrictions.eq("id", ConstantsGlobal.NULL)));
			}
		}
	}

	@SuppressWarnings("unchecked")
	public void subCriteriaRoleSupervisore(Long userId, DetachedCriteria master, String campagna, String operatore) {
		Boolean stm = separaTZ();
		if(ApplicationUtil.isTrue(stm) && userId != null ) {
			DetachedCriteria c = DetachedCriteria.forClass(Team.class); 
			c.createCriteria("supervisore").add(Restrictions.idEq(userId)); 
			c.createCriteria("user", "utente", ApplicationUtil.leftJoin());
			c.createCriteria("campagne", "campagna", ApplicationUtil.leftJoin());
			c.setProjection(Projections.projectionList()
					.add(Projections.distinct(Projections.property("id").as("id")))
					.add((Projections.property("utente.id").as("utente_id")))
					.add((Projections.property("campagna.id").as("campagna_id")))
					);
			List<GruppoModel> ln = getList(c, GruppoModel.class); 
			List<GruppoModel> gruppo = ApplicationUtil.collectionToList(ln, "getId");
			boolean ok = false;
			if(ApplicationUtil.notEmpty(gruppo)) {
				Disjunction disjunction = Restrictions.disjunction();
				for(GruppoModel gP : gruppo) {
					if(ApplicationUtil.notEmpty(gP.getCampagne()) && ApplicationUtil.notEmpty(gP.getUtenti())) {
						ok = true;
						disjunction.add(Restrictions.and(Restrictions.in(campagna + ".id", gP.getCampagne()), Restrictions.in(operatore + ".id", gP.getUtenti())));
					}
				}
				master.add(disjunction);
			}
			if(!ok) {
				master.add(Restrictions.not(Restrictions.eq("id", ConstantsGlobal.NULL)));
			}
		}
	}


	@SuppressWarnings("unchecked")
	public void subCriteriaRoleCoordinatore(Long userId, DetachedCriteria master, String campagna, String operatore) {
		Boolean stm = separaTZ();
		if(ApplicationUtil.isTrue(stm) && userId != null ) {
			DetachedCriteria c = DetachedCriteria.forClass(Zona.class); 
			c.createCriteria("supervisori").add(Restrictions.idEq(userId)); 
			c.createCriteria("agente", "utente", ApplicationUtil.leftJoin());
			c.createCriteria("campagne", "campagna", ApplicationUtil.leftJoin());
			c.setProjection(Projections.projectionList()
					.add(Projections.distinct(Projections.property("id").as("id")))
					.add((Projections.property("utente.id").as("utente_id")))
					.add((Projections.property("campagna.id").as("campagna_id")))
					);
			List<GruppoModel> ln = getList(c, GruppoModel.class); 
			List<GruppoModel> gruppo = ApplicationUtil.collectionToList(ln, "getId");
			boolean ok = false;
			if(ApplicationUtil.notEmpty(gruppo)) {
				Disjunction disjunction = Restrictions.disjunction();
				for(GruppoModel gP : gruppo) {
					if(ApplicationUtil.notEmpty(gP.getCampagne()) && ApplicationUtil.notEmpty(gP.getUtenti())) {
						ok = true;
						disjunction.add(Restrictions.and(Restrictions.in(campagna + ".id", gP.getCampagne()), Restrictions.in(operatore + ".id", gP.getUtenti())));
					}
				}
				master.add(disjunction);
			}
			if(!ok) {
				master.add(Restrictions.not(Restrictions.eq("id", ConstantsGlobal.NULL)));
			}
		}
	}


	@SuppressWarnings("unchecked")
	public void subCriteriaRoleTeam(Long team, DetachedCriteria master, String campagna, String operatore) {
		Boolean stm = separaTZ();
		if(ApplicationUtil.isTrue(stm) && team != null ) {
			DetachedCriteria c = DetachedCriteria.forClass(Team.class); 
			c.add(Restrictions.idEq(team)); 
			c.createCriteria("user", "utente", ApplicationUtil.leftJoin());
			c.createCriteria("campagne", "campagna", ApplicationUtil.leftJoin());
			c.setProjection(Projections.projectionList()
					.add(Projections.distinct(Projections.property("id").as("id")))
					.add((Projections.property("utente.id").as("utente_id")))
					.add((Projections.property("campagna.id").as("campagna_id")))
					);
			List<GruppoModel> ln = getList(c, GruppoModel.class); 
			List<GruppoModel> gruppo = ApplicationUtil.collectionToList(ln, "getId");
			boolean ok = false;
			if(ApplicationUtil.notEmpty(gruppo)) {
				Disjunction disjunction = Restrictions.disjunction();
				for(GruppoModel gP : gruppo) {
					if(ApplicationUtil.notEmpty(gP.getCampagne()) && ApplicationUtil.notEmpty(gP.getUtenti())) {
						ok = true;
						disjunction.add(Restrictions.and(Restrictions.in(campagna + ".id", gP.getCampagne()), Restrictions.in(operatore + ".id", gP.getUtenti())));
					}
				}
				master.add(disjunction);
			}
			if(!ok) {
				master.add(Restrictions.not(Restrictions.eq("id", ConstantsGlobal.NULL)));
			}
		}
	}


	@SuppressWarnings("unchecked")
	public void subCriteriaRoleZona(Long zona, DetachedCriteria master, String campagna, String operatore) {
		Boolean stm = separaTZ();
		if(ApplicationUtil.isTrue(stm) && zona != null ) {
			DetachedCriteria c = DetachedCriteria.forClass(Zona.class); 
			c.add(Restrictions.idEq(zona)); 
			c.createCriteria("agente", "utente", ApplicationUtil.leftJoin());
			c.createCriteria("campagne", "campagna", ApplicationUtil.leftJoin());
			c.setProjection(Projections.projectionList()
					.add(Projections.distinct(Projections.property("id").as("id")))
					.add((Projections.property("utente.id").as("utente_id")))
					.add((Projections.property("campagna.id").as("campagna_id")))
					);
			List<GruppoModel> ln = getList(c, GruppoModel.class); 
			List<GruppoModel> gruppo = ApplicationUtil.collectionToList(ln, "getId");
			boolean ok = false;
			if(ApplicationUtil.notEmpty(gruppo)) {
				Disjunction disjunction = Restrictions.disjunction();
				for(GruppoModel gP : gruppo) {
					if(ApplicationUtil.notEmpty(gP.getCampagne()) && ApplicationUtil.notEmpty(gP.getUtenti())) {
						ok = true;
						disjunction.add(Restrictions.and(Restrictions.in(campagna + ".id", gP.getCampagne()), Restrictions.in(operatore + ".id", gP.getUtenti())));
					}
				}
				master.add(disjunction);
			}
			if(!ok) {
				master.add(Restrictions.not(Restrictions.eq("id", ConstantsGlobal.NULL)));
			}
		}
	}

	public List<String> getLingue() {
		List<String> ls = new ArrayList<String>();
		String path = servletContext.getRealPath("/WEB-INF/classes" + ConstantsGlobal.path_language);
		FileSystemResource resource = new FileSystemResource(path);
		LanguageFileFilter lf = new LanguageFileFilter();
		File [] fl = resource.getFile().listFiles(lf);
		if(ApplicationUtil.notEmpty(fl)) {
			for (File f : fl) {
				ls.add(ApplicationUtil.substringBetween(ApplicationUtil.getNameN(f.getName()), lf.getStart(), lf.getEnd()));
			}
		}
		return ls;
	}

	public void reloadBundle() {
		ResourceBundle.clearCache();
		Map<String, ApplicationResourceBundle> appBundleMap = ApplicationAssociate.getCurrentInstance().getResourceBundles();
		if(ApplicationUtil.notEmpty(appBundleMap)) {
			ApplicationResourceBundle appBundle = appBundleMap.get("msg");
			if(appBundle != null) {
				Map<Locale, ResourceBundle> resources = ApplicationUtil.getFieldValue(appBundle, "resources");
				resources.clear();
			}
		}
	}

	public List<Label> getLabel(List<Label> lis, boolean zero) {
		if(zero) {
			lis.add(0, new Label(null, ConstantsLanguage.TRATTINI.stampa()));
		}
		return lis;
	}

	public List<SelectItem> getRuolo(List<RuoloSI> lis, boolean zero, boolean all) {
		List<SelectItem> sis = new ArrayList<SelectItem>();
		if(zero) {
			sis.add(0, new SelectItem(null, ConstantsLanguage.TRATTINI.stampa()));
		}
		if(all) {
			sis.add(1, new SelectItem(ConstantsGlobal.ALL, ConstantsLanguage.ALL.stampa()));
			sis.add(2, new SelectItem(ConstantsGlobal.NONE, ConstantsLanguage.NONE.stampa()));
		}
		Iterator<RuoloSI> objIter = lis.iterator();

		while(objIter.hasNext()) {
			RuoloSI ob = objIter.next();
			sis.add(new SelectItem(ob.getId(), ob.getDescrizione()));
		}
		return sis;
	}

	public List<SelectItem> getTrunk(boolean id, List<TrunkSI> lis, boolean zero, boolean all, SipBuddies trunk) {
		Iterator<TrunkSI> objIter = lis.iterator();
		List<Long> ids = new ArrayList<Long>();
		List<SelectItem> sisSI = new ArrayList<SelectItem>();
		List<SelectItem> sisNO = new ArrayList<SelectItem>();
		List<SelectItem> sisGroup = new ArrayList<SelectItem>();
		if(zero) {
			sisGroup.add(0, new SelectItem(null, ConstantsLanguage.TRATTINI.stampa()));
		}
		if(all) {
			sisGroup.add(1, new SelectItem(ConstantsGlobal.ALL, ConstantsLanguage.ALL.stampa()));
			sisGroup.add(2, new SelectItem(ConstantsGlobal.NONE, ConstantsLanguage.NONE.stampa()));
		}
		while(objIter.hasNext()) {
			TrunkSI trk = objIter.next();
			SelectItem ut = new SelectItem(id? trk.getId() : trk.getName(), trk.getTrunkContext());
			if(ApplicationUtil.convertSB(trk.getAttivo())) {
				sisSI.add(ut);
			}
			if(!ApplicationUtil.convertSB(trk.getAttivo())) {
				sisNO.add(ut);
			}
			ids.add(trk.getId());

		}
		if (trunk != null && !ids.contains(id ? trunk.getId() : trunk.getName())) {
			SelectItem ut = new SelectItem(id ? trunk.getId() : trunk.getName(), trunk.getTrunkContext());
			if(ApplicationUtil.isTrue(trunk.getAttivo())) {
				sisSI.add(ut);
			}
			if(ApplicationUtil.isNotTrue(trunk.getAttivo())) {
				sisNO.add(ut);
			}
		}
		if(ApplicationUtil.empty(sisSI) || ApplicationUtil.empty(sisNO)) {
			sisGroup.addAll(sisSI);
			sisGroup.addAll(sisNO);
			return sisGroup;
		}
		if(ApplicationUtil.notEmpty(sisSI)) {
			SelectItemGroup group = new SelectItemGroup(ConstantsLanguage.ATTIVO.stampa()); 
			group.setSelectItems(sisSI.toArray(new SelectItem[sisSI.size()]));
			sisGroup.add(group);
		}
		if(ApplicationUtil.notEmpty(sisNO)) {
			SelectItemGroup group = new SelectItemGroup(ConstantsLanguage.INATTIVO.stampa()); 
			group.setSelectItems(sisNO.toArray(new SelectItem[sisNO.size()]));
			sisGroup.add(group);
		}

		return sisGroup;
	}


	public List<SelectItem> getInterno(List<InternoSI> lis, boolean zero, boolean all, SipBuddies interno) {
		boolean idselect = getSelect();
		Iterator<InternoSI> objIter = lis.iterator();
		List<Long> ids = new ArrayList<Long>();
		List<SelectItem> sisSI = new ArrayList<SelectItem>();
		List<SelectItem> sisNO = new ArrayList<SelectItem>();
		List<SelectItem> sisGroup = new ArrayList<SelectItem>();
		if(zero) {
			sisGroup.add(0, new SelectItem(null, ConstantsLanguage.TRATTINI.stampa()));
		}
		if(all) {
			sisGroup.add(1, new SelectItem(ConstantsGlobal.ALL, ConstantsLanguage.ALL.stampa()));
			sisGroup.add(2, new SelectItem(ConstantsGlobal.NONE, ConstantsLanguage.NONE.stampa()));
		}
		while(objIter.hasNext()) {
			InternoSI trk = objIter.next();
			SelectItem ut = new SelectItem(trk.getId(), ApplicationUtil.toString(idselect ? trk.getId() : null, trk.getInternoContext()));
			if(ApplicationUtil.convertSB(trk.getAttivo())) {
				sisSI.add(ut);
			}
			if(!ApplicationUtil.convertSB(trk.getAttivo())) {
				sisNO.add(ut);
			}
			ids.add(trk.getId());

		}
		if (interno != null && !ids.contains(interno.getId())) {
			SelectItem ut = new SelectItem(interno.getId(), ApplicationUtil.toString(idselect ? interno.getId() : null, interno.getInternoContext()));
			if(ApplicationUtil.isTrue(interno.getAttivo())) {
				sisSI.add(ut);
			}
			if(ApplicationUtil.isNotTrue(interno.getAttivo())) {
				sisNO.add(ut);
			}
		}
		if(ApplicationUtil.empty(sisSI) || ApplicationUtil.empty(sisNO)) {
			sisGroup.addAll(sisSI);
			sisGroup.addAll(sisNO);
			return sisGroup;
		}
		if(ApplicationUtil.notEmpty(sisSI)) {
			SelectItemGroup group = new SelectItemGroup(ConstantsLanguage.ATTIVO.stampa()); 
			group.setSelectItems(sisSI.toArray(new SelectItem[sisSI.size()]));
			sisGroup.add(group);
		}
		if(ApplicationUtil.notEmpty(sisNO)) {
			SelectItemGroup group = new SelectItemGroup(ConstantsLanguage.INATTIVO.stampa()); 
			group.setSelectItems(sisNO.toArray(new SelectItem[sisNO.size()]));
			sisGroup.add(group);
		}

		return sisGroup;
	}

	public List<SelectItem> getInternoOnline(List<InternoSI> lis) {
		boolean idselect = getSelect();
		Iterator<InternoSI> objIter = lis.iterator();
		List<SelectItem> sisSI = new ArrayList<SelectItem>();
		List<SelectItem> sisNO = new ArrayList<SelectItem>();
		List<SelectItem> sisGroup = new ArrayList<SelectItem>();
		
		while(objIter.hasNext()) {
			InternoSI trk = objIter.next();
			SelectItem ut = new SelectItem(trk.getName(), ApplicationUtil.toString(idselect ? trk.getId() : null, trk.getInternoContext()));
			if(ApplicationUtil.isTrue(trk.getLoggato())) {
				sisSI.add(ut);
			}
			if(!ApplicationUtil.isTrue(trk.getLoggato())) {
				sisNO.add(ut);
			}
		}
		if(ApplicationUtil.empty(sisSI) || ApplicationUtil.empty(sisNO)) {
			sisGroup.addAll(sisSI);
			sisGroup.addAll(sisNO);
			return sisGroup;
		}
		if(ApplicationUtil.notEmpty(sisSI)) {
			SelectItemGroup group = new SelectItemGroup(ConstantsLanguage.ONLINE1.stampa()); 
			group.setSelectItems(sisSI.toArray(new SelectItem[sisSI.size()]));
			sisGroup.add(group);
		}
		if(ApplicationUtil.notEmpty(sisNO)) {
			SelectItemGroup group = new SelectItemGroup(ConstantsLanguage.ONLINE2.stampa()); 
			group.setSelectItems(sisNO.toArray(new SelectItem[sisNO.size()]));
			sisGroup.add(group);
		}

		return sisGroup;
	}
	
	
	public List<SelectItem> getUtenteOnline(List<MonitorOperatore> lis, Utente utente) {
		boolean idselect = getSelect();
		Iterator<MonitorOperatore> objIter = lis.iterator();
		List<SelectItem> sisSI = new ArrayList<SelectItem>();
		List<SelectItem> sisNO = new ArrayList<SelectItem>();
		List<SelectItem> sisGroup = new ArrayList<SelectItem>();

		while(objIter.hasNext()) {
			MonitorOperatore mon = objIter.next();
			Utente trk = mon.getOperatore();
			SelectItem ut = new SelectItem(trk.getId(), ApplicationUtil.toString(idselect ? trk.getId() : null, trk.getDenominazione()));
			if(ApplicationUtil.isTrue(mon.getOnline())) {
				sisSI.add(ut);
			}
			if(!ApplicationUtil.isTrue(mon.getOnline())) {
				sisNO.add(ut);
			}
		}
		if(ApplicationUtil.empty(sisSI) || ApplicationUtil.empty(sisNO)) {
			sisGroup.addAll(sisSI);
			sisGroup.addAll(sisNO);
			return sisGroup;
		}
		if(ApplicationUtil.notEmpty(sisSI)) {
			SelectItemGroup group = new SelectItemGroup(ConstantsLanguage.ONLINE1.stampa()); 
			group.setSelectItems(sisSI.toArray(new SelectItem[sisSI.size()]));
			sisGroup.add(group);
		}
		if(ApplicationUtil.notEmpty(sisNO)) {
			SelectItemGroup group = new SelectItemGroup(ConstantsLanguage.ONLINE2.stampa()); 
			group.setSelectItems(sisNO.toArray(new SelectItem[sisNO.size()]));
			sisGroup.add(group);
		}

		return sisGroup;
	}
	
	public List<SelectItem> getLista(List<ListaSI> lis, boolean zero, Lista element) {
		boolean idselect = getSelect();
		Iterator<ListaSI> objIter = lis.iterator();
		List<Long> ids = new ArrayList<Long>();
		List<SelectItem> sisPausa = new ArrayList<SelectItem>();
		List<SelectItem> sisAttivo = new ArrayList<SelectItem>();
		List<SelectItem> sisChiuso = new ArrayList<SelectItem>();
		List<SelectItem> sisGroup = new ArrayList<SelectItem>();
		if(zero) {
			sisGroup.add(0, new SelectItem(null, ConstantsLanguage.TRATTINI.stampa()));
		}
		while(objIter.hasNext()) {
			ListaSI ls = objIter.next();
			SelectItem ut = new SelectItem(ls.getId(), ApplicationUtil.toString(idselect ? ls.getId() : null, ls.getDenominazione()));
			if(ApplicationUtil.equals(ls.getStato(), ConstantsGlobal.stato_attivo)) {
				sisAttivo.add(ut);
			}
			if(ApplicationUtil.equals(ls.getStato(), ConstantsGlobal.stato_pausa)) {
				sisPausa.add(ut);
			}
			if(ApplicationUtil.equals(ls.getStato(), ConstantsGlobal.stato_chiuso)) {
				sisChiuso.add(ut);
			}
			ids.add(ls.getId());
		}
		if (element != null && !ids.contains(element.getId())) {
			SelectItem ut = new SelectItem(element.getId(), ApplicationUtil.toString(idselect ? element.getId() : null, element.getDenominazione()));
			if(ApplicationUtil.equals(element.getStato(), ConstantsGlobal.stato_attivo)) {
				sisAttivo.add(ut);
			}
			if(ApplicationUtil.equals(element.getStato(), ConstantsGlobal.stato_pausa)) {
				sisPausa.add(ut);
			}
			if(ApplicationUtil.equals(element.getStato(), ConstantsGlobal.stato_chiuso)) {
				sisChiuso.add(ut);
			}
		}
		if(ApplicationUtil.notEmpty(sisAttivo)) {
			SelectItemGroup group = new SelectItemGroup(Message.addCatalogText("ts_stato." + ConstantsGlobal.stato_attivo)); 
			group.setSelectItems(sisAttivo.toArray(new SelectItem[sisAttivo.size()]));
			sisGroup.add(group);
		}
		if(ApplicationUtil.notEmpty(sisPausa)) {
			SelectItemGroup group = new SelectItemGroup(Message.addCatalogText("ts_stato." + ConstantsGlobal.stato_pausa)); 
			group.setSelectItems(sisPausa.toArray(new SelectItem[sisPausa.size()]));
			sisGroup.add(group);
		}
		if(ApplicationUtil.notEmpty(sisChiuso)) {
			SelectItemGroup group = new SelectItemGroup(Message.addCatalogText("ts_stato." + ConstantsGlobal.stato_chiuso)); 
			group.setSelectItems(sisChiuso.toArray(new SelectItem[sisChiuso.size()]));
			sisGroup.add(group);
		}
		return sisGroup;
	}

	public List<SelectItem> getCampagna(List<CampagnaSI> lis, boolean zero, boolean all, boolean altro, Campagna element) {
		boolean idselect = getSelect();
		Iterator<CampagnaSI> objIter = lis.iterator();
		List<Long> ids = new ArrayList<Long>();
		List<SelectItem> sisPausa = new ArrayList<SelectItem>();
		List<SelectItem> sisAttivo = new ArrayList<SelectItem>();
		List<SelectItem> sisChiuso = new ArrayList<SelectItem>();
		List<SelectItem> sisGroup = new ArrayList<SelectItem>();
		if(zero) {
			sisGroup.add(0, new SelectItem(null, ConstantsLanguage.TRATTINI.stampa()));
		}
		if(all) {
			sisGroup.add(1, new SelectItem(ConstantsGlobal.ALL, ConstantsLanguage.ALL.stampa()));
			sisGroup.add(2, new SelectItem(ConstantsGlobal.NONE, ConstantsLanguage.NONE.stampa()));
		}
		if(altro) {
			sisGroup.add(1, new SelectItem(ConstantsGlobal.ALTRO, ConstantsLanguage.SINCRONIZZATI.stampa()));
		}
		while(objIter.hasNext()) {
			CampagnaSI ls = objIter.next();
			SelectItem ut = new SelectItem(ls.getId(), ApplicationUtil.toString(idselect ? ls.getId() : null, ls.getDenominazione()));
			if(ApplicationUtil.equals(ls.getStato(), ConstantsGlobal.stato_attivo)) {
				sisAttivo.add(ut);
			}
			if(ApplicationUtil.equals(ls.getStato(), ConstantsGlobal.stato_pausa)) {
				sisPausa.add(ut);
			}
			if(ApplicationUtil.equals(ls.getStato(), ConstantsGlobal.stato_chiuso)) {
				sisChiuso.add(ut);
			}
			ids.add(ls.getId());
		}
		if (element != null && !ids.contains(element.getId())) {
			SelectItem ut = new SelectItem(element.getId(), ApplicationUtil.toString(idselect ? element.getId() : null, element.getDenominazione()));
			if(ApplicationUtil.equals(element.getStato(), ConstantsGlobal.stato_attivo)) {
				sisAttivo.add(ut);
			}
			if(ApplicationUtil.equals(element.getStato(), ConstantsGlobal.stato_pausa)) {
				sisPausa.add(ut);
			}
			if(ApplicationUtil.equals(element.getStato(), ConstantsGlobal.stato_chiuso)) {
				sisChiuso.add(ut);
			}
		}
		if(ApplicationUtil.notEmpty(sisAttivo)) {
			SelectItemGroup group = new SelectItemGroup(Message.addCatalogText("ts_stato." + ConstantsGlobal.stato_attivo)); 
			group.setSelectItems(sisAttivo.toArray(new SelectItem[sisAttivo.size()]));
			sisGroup.add(group);
		}
		if(ApplicationUtil.notEmpty(sisPausa)) {
			SelectItemGroup group = new SelectItemGroup(Message.addCatalogText("ts_stato." + ConstantsGlobal.stato_pausa)); 
			group.setSelectItems(sisPausa.toArray(new SelectItem[sisPausa.size()]));
			sisGroup.add(group);
		}
		if(ApplicationUtil.notEmpty(sisChiuso)) {
			SelectItemGroup group = new SelectItemGroup(Message.addCatalogText("ts_stato." + ConstantsGlobal.stato_chiuso)); 
			group.setSelectItems(sisChiuso.toArray(new SelectItem[sisChiuso.size()]));
			sisGroup.add(group);
		}
		return sisGroup;
	}

	public List<SelectItem> getAgente(List<AgenteSI> lis, boolean zero, boolean all, Agente agente) {
		boolean idselect = getSelect();
		Iterator<AgenteSI> objIter = lis.iterator();
		List<Long> ids = new ArrayList<Long>();
		List<SelectItem> sisSI = new ArrayList<SelectItem>();
		List<SelectItem> sisNO = new ArrayList<SelectItem>();
		List<SelectItem> sisGroup = new ArrayList<SelectItem>();
		if(zero) {
			sisGroup.add(0, new SelectItem(null, ConstantsLanguage.TRATTINI.stampa()));
		}
		if(all) {
			sisGroup.add(1, new SelectItem(ConstantsGlobal.ALL, ConstantsLanguage.ALL.stampa()));
			sisGroup.add(2, new SelectItem(ConstantsGlobal.NONE, ConstantsLanguage.NONE.stampa()));
		}
		while(objIter.hasNext()) {
			AgenteSI agent = objIter.next();
			SelectItem ut = new SelectItem(agent.getId(), ApplicationUtil.toString(idselect ? agent.getId() : null, agent.getDenominazione()));
			if(ApplicationUtil.isTrue(agent.getAutonomo())) {
				sisSI.add(ut);
			}
			if(ApplicationUtil.isNotTrue(agent.getAutonomo())) {
				sisNO.add(ut);
			}
			ids.add(agent.getId());

		}
		if (agente != null && !ids.contains(agente.getId())) {
			SelectItem ut = new SelectItem(agente.getId(), ApplicationUtil.toString(idselect ? agente.getId() : null, agente.getDenominazione()));
			if(ApplicationUtil.isTrue(agente.getAutonomo())) {
				sisSI.add(ut);
			}
			if(ApplicationUtil.isNotTrue(agente.getAutonomo())) {
				sisNO.add(ut);
			}
		}
		if(ApplicationUtil.empty(sisSI) || ApplicationUtil.empty(sisNO)) {
			sisGroup.addAll(sisSI);
			sisGroup.addAll(sisNO);
			return sisGroup;
		}
		if(ApplicationUtil.notEmpty(sisSI)) {
			SelectItemGroup group = new SelectItemGroup(ConstantsLanguage.AUTONOMO.stampa()); 
			group.setSelectItems(sisSI.toArray(new SelectItem[sisSI.size()]));
			sisGroup.add(group);
		}
		if(ApplicationUtil.notEmpty(sisNO)) {
			SelectItemGroup group = new SelectItemGroup(ConstantsLanguage.NONAUTONOMO.stampa()); 
			group.setSelectItems(sisNO.toArray(new SelectItem[sisNO.size()]));
			sisGroup.add(group);
		}

		return sisGroup;
	}

	public List<SelectItem> getProdotto(List<ProdottoSI> lis, boolean zero, boolean categoria, Prodotto prodotto) {
		boolean idselect = getSelect();
		Iterator<ProdottoSI> objIter = lis.iterator();
		List<Long> ids = new ArrayList<Long>();
		List<SelectItem> sisSI = new ArrayList<SelectItem>();
		List<SelectItem> sisNO = new ArrayList<SelectItem>();
		List<SelectItem> sisGroup = new ArrayList<SelectItem>();
		if(zero) {
			sisGroup.add(0, new SelectItem(null, ConstantsLanguage.TRATTINI.stampa()));
		}
		while(objIter.hasNext()) {
			ProdottoSI prd = objIter.next();
			SelectItem ut = new SelectItem(prd.getId(), ApplicationUtil.toString(idselect ? prd.getId() : null, categoria ? prd.getDenominazione() : prd.getNomeTipo()));
			if(ApplicationUtil.isTrue(prd.getAttivo())) {
				sisSI.add(ut);
			}
			if(ApplicationUtil.isFalse(prd.getAttivo())) {
				sisNO.add(ut);
			}
			ids.add(prd.getId());

		}
		if (prodotto != null && !ids.contains(prodotto.getId())) {
			SelectItem ut = new SelectItem(prodotto.getId(), ApplicationUtil.toString(idselect ? prodotto.getId() : null, categoria ? prodotto.getDenominazione() : prodotto.getNomeTipo()));
			if(ApplicationUtil.isTrue(prodotto.getAttivo())) {
				sisSI.add(ut);
			}
			if(ApplicationUtil.isFalse(prodotto.getAttivo())) {
				sisNO.add(ut);
			}
		}
		if(ApplicationUtil.empty(sisSI) || ApplicationUtil.empty(sisNO)) {
			sisGroup.addAll(sisSI);
			sisGroup.addAll(sisNO);
			return sisGroup;
		}
		if(ApplicationUtil.notEmpty(sisSI)) {
			SelectItemGroup group = new SelectItemGroup(ConstantsLanguage.ATTIVO.stampa()); 
			group.setSelectItems(sisSI.toArray(new SelectItem[sisSI.size()]));
			sisGroup.add(group);
		}
		if(ApplicationUtil.notEmpty(sisNO)) {
			SelectItemGroup group = new SelectItemGroup(ConstantsLanguage.INATTIVO.stampa()); 
			group.setSelectItems(sisNO.toArray(new SelectItem[sisNO.size()]));
			sisGroup.add(group);
		}

		return sisGroup;
	}

	public List<SelectItem> getZona(List<ZonaSI> lis, boolean zero, boolean all, Zona zona) {
		boolean idselect = getSelect();
		Iterator<ZonaSI> objIter = lis.iterator();
		List<Long> ids = new ArrayList<Long>();
		List<SelectItem> sisGroup = new ArrayList<SelectItem>();
		if(zero) {
			sisGroup.add(0, new SelectItem(null, ConstantsLanguage.TRATTINI.stampa()));
		}
		if(all) {
			sisGroup.add(1, new SelectItem(ConstantsGlobal.ALL, ConstantsLanguage.ALL.stampa()));
			sisGroup.add(2, new SelectItem(ConstantsGlobal.NONE, ConstantsLanguage.NONE.stampa()));
		}
		while(objIter.hasNext()) {
			ZonaSI prd = objIter.next();
			SelectItem ut = new SelectItem(prd.getId(), ApplicationUtil.toString(idselect ? prd.getId() : null, prd.getDenominazione()));
			sisGroup.add(ut);
			ids.add(prd.getId());

		}
		if (zona != null && !ids.contains(zona.getId())) {
			SelectItem ut = new SelectItem(zona.getId(), ApplicationUtil.toString(idselect ? zona.getId() : null, zona.getDenominazione()));
			sisGroup.add(ut);
		}
		return sisGroup;
	}

	public List<SelectItem> getTeam(List<TeamSI> lis, boolean zero, boolean all, Team team) {
		boolean idselect = getSelect();
		Iterator<TeamSI> objIter = lis.iterator();
		List<Long> ids = new ArrayList<Long>();
		List<SelectItem> sisGroup = new ArrayList<SelectItem>();
		if(zero) {
			sisGroup.add(0, new SelectItem(null, ConstantsLanguage.TRATTINI.stampa()));
		}
		if(all) {
			sisGroup.add(1, new SelectItem(ConstantsGlobal.ALL, ConstantsLanguage.ALL.stampa()));
			sisGroup.add(2, new SelectItem(ConstantsGlobal.NONE, ConstantsLanguage.NONE.stampa()));
		}
		while(objIter.hasNext()) {
			TeamSI prd = objIter.next();
			SelectItem ut = new SelectItem(prd.getId(), ApplicationUtil.toString(idselect ? prd.getId() : null, prd.getDenominazione()));
			sisGroup.add(ut);
			ids.add(prd.getId());

		}
		if (team != null && !ids.contains(team.getId())) {
			SelectItem ut = new SelectItem(team.getId(), ApplicationUtil.toString(idselect ? team.getId() : null, team.getDenominazione()));
			sisGroup.add(ut);
		}
		return sisGroup;
	}

	public List<SelectItem> getUtente(List<UtenteSI> lis, boolean zero, Utente utente) {
		boolean idselect = getSelect();
		Iterator<UtenteSI> objIter = lis.iterator();
		List<Long> ids = new ArrayList<Long>();
		List<SelectItem> sisSI = new ArrayList<SelectItem>();
		List<SelectItem> sisNO = new ArrayList<SelectItem>();
		List<SelectItem> sisGroup = new ArrayList<SelectItem>();
		if(zero) {
			sisGroup.add(0, new SelectItem(null, ConstantsLanguage.TRATTINI.stampa()));
		}
		while(objIter.hasNext()) {
			UtenteSI user = objIter.next();
			SelectItem ut = new SelectItem(user.getId(), ApplicationUtil.toString(idselect ? user.getId() : null, user.getDenominazione()));
			if(ApplicationUtil.isTrue(user.getEnabled())) {
				sisSI.add(ut);
			}
			if(ApplicationUtil.isFalse(user.getEnabled())) {
				sisNO.add(ut);
			}
			ids.add(user.getId());

		}
		if (utente != null && !ids.contains(utente.getId())) {
			SelectItem ut = new SelectItem(utente.getId(), ApplicationUtil.toString(idselect ? utente.getId() : null, utente.getDenominazione()));
			if(ApplicationUtil.isTrue(utente.isEnabled())) {
				sisSI.add(ut);
			}
			if(ApplicationUtil.isFalse(utente.isEnabled())) {
				sisNO.add(ut);
			}
		}
		if(ApplicationUtil.empty(sisSI) || ApplicationUtil.empty(sisNO)) {
			sisGroup.addAll(sisSI);
			sisGroup.addAll(sisNO);
			return sisGroup;
		}
		if(ApplicationUtil.notEmpty(sisSI)) {
			SelectItemGroup group = new SelectItemGroup(ConstantsLanguage.ABILITATO.stampa()); 
			group.setSelectItems(sisSI.toArray(new SelectItem[sisSI.size()]));
			sisGroup.add(group);
		}
		if(ApplicationUtil.notEmpty(sisNO)) {
			SelectItemGroup group = new SelectItemGroup(ConstantsLanguage.DISABILITATO.stampa()); 
			group.setSelectItems(sisNO.toArray(new SelectItem[sisNO.size()]));
			sisGroup.add(group);
		}

		return sisGroup;
	}

	public List<SelectItem> getAutodialer(List<AutodialerSI> lis, boolean zero, Autodialer element) {
		boolean idselect = getSelect();
		Iterator<AutodialerSI> objIter = lis.iterator();
		List<Long> ids = new ArrayList<Long>();
		List<SelectItem> attivoP = new ArrayList<SelectItem>();
		List<SelectItem> autoP = new ArrayList<SelectItem>();
		List<SelectItem> chiusoP = new ArrayList<SelectItem>();
		List<SelectItem> sisGroup = new ArrayList<SelectItem>();
		if(zero) {
			sisGroup.add(0, new SelectItem(null, ConstantsLanguage.TRATTINI.stampa()));
		}
		while(objIter.hasNext()) {
			AutodialerSI user = objIter.next();
			SelectItem ut = new SelectItem(user.getId(), ApplicationUtil.toString(idselect ? user.getId() : null, user.getDenominazione()));
			if(ApplicationUtil.equals(user.getStato(), ConstantsGlobal.ts_auto)) {
				autoP.add(ut);
			}
			if(ApplicationUtil.equals(user.getStato(), ConstantsGlobal.ts_attivo)) {
				attivoP.add(ut);
			}
			if(ApplicationUtil.equals(user.getStato(), ConstantsGlobal.ts_chiuso)) {
				chiusoP.add(ut);
			}
			ids.add(user.getId());
		}
		if (element != null && !ids.contains(element.getId())) {
			SelectItem ut = new SelectItem(element.getId(), ApplicationUtil.toString(idselect ? element.getId() : null, element.getDenominazione()));
			if(ApplicationUtil.equals(element.getStato(), ConstantsGlobal.ts_auto)) {
				autoP.add(ut);
			}
			if(ApplicationUtil.equals(element.getStato(), ConstantsGlobal.ts_attivo)) {
				attivoP.add(ut);
			}
			if(ApplicationUtil.equals(element.getStato(), ConstantsGlobal.ts_chiuso)) {
				chiusoP.add(ut);
			}
		}
		if(ApplicationUtil.empty(attivoP) || ApplicationUtil.empty(autoP) || ApplicationUtil.empty(chiusoP)) {
			sisGroup.addAll(attivoP);
			sisGroup.addAll(autoP);
			sisGroup.addAll(chiusoP);
			return sisGroup;
		}
		if(ApplicationUtil.notEmpty(attivoP)) {
			SelectItemGroup group = new SelectItemGroup(Message.addCatalogText("ta_stato." + ConstantsGlobal.ts_attivo)); 
			group.setSelectItems(attivoP.toArray(new SelectItem[attivoP.size()]));
			sisGroup.add(group);
		}
		if(ApplicationUtil.notEmpty(autoP)) {
			SelectItemGroup group = new SelectItemGroup(Message.addCatalogText("ta_stato." + ConstantsGlobal.ts_auto)); 
			group.setSelectItems(autoP.toArray(new SelectItem[autoP.size()]));
			sisGroup.add(group);
		}
		if(ApplicationUtil.notEmpty(chiusoP)) {
			SelectItemGroup group = new SelectItemGroup(Message.addCatalogText("ta_stato." + ConstantsGlobal.ts_chiuso)); 
			group.setSelectItems(chiusoP.toArray(new SelectItem[chiusoP.size()]));
			sisGroup.add(group);
		}

		return sisGroup;
	}

	public List<SelectItem> getEsitoChiamata(List<EsitoChiamataSI> lis, boolean zero, EsitoChiamata esito) {
		boolean idselect = getSelect();
		Iterator<EsitoChiamataSI> objIter = lis.iterator();
		List<Long> ids = new ArrayList<Long>();
		List<SelectItem> sisSI = new ArrayList<SelectItem>();
		List<SelectItem> sisNO = new ArrayList<SelectItem>();
		List<SelectItem> sisNULL = new ArrayList<SelectItem>();
		List<SelectItem> sisGroup = new ArrayList<SelectItem>();
		if(zero) {
			sisGroup.add(0, new SelectItem(null, ConstantsLanguage.TRATTINI.stampa()));
		}
		while(objIter.hasNext()) {
			EsitoChiamataSI es = objIter.next();
			SelectItem ut = new SelectItem(es.getId(), ApplicationUtil.toString(idselect ? es.getId() : null, es.getEtichettaCodice()));
			if(es.getRichiamare() == null) {
				sisNULL.add(ut);
			} else {
				if(ApplicationUtil.isTrue(es.getRichiamare())) {
					sisSI.add(ut);
				}
				if(ApplicationUtil.isNotTrue(es.getRichiamare())) {
					sisNO.add(ut);
				}
			}
			ids.add(es.getId());
		}
		if (esito != null && !ids.contains(esito.getId())) {
			SelectItem ut = new SelectItem(esito.getId(), ApplicationUtil.toString(idselect ? esito.getId() : null, esito.getEtichettaCodice()));
			if(esito.getRichiamare() == null) {
				sisNULL.add(ut);
			} else {
				if(ApplicationUtil.isTrue(esito.getRichiamare())) {
					sisSI.add(ut);
				}
				if(ApplicationUtil.isNotTrue(esito.getRichiamare())) {
					sisNO.add(ut);
				}
			}
		}

		if(ApplicationUtil.notEmpty(sisSI)) {
			SelectItemGroup group = new SelectItemGroup(ConstantsLanguage.RICHIAMARE0.stampa()); 
			group.setSelectItems(sisSI.toArray(new SelectItem[sisSI.size()]));
			sisGroup.add(group);
		}
		if(ApplicationUtil.notEmpty(sisNO)) {
			SelectItemGroup group = new SelectItemGroup(ConstantsLanguage.RICHIAMARE1.stampa()); 
			group.setSelectItems(sisNO.toArray(new SelectItem[sisNO.size()]));
			sisGroup.add(group);
		}
		if(ApplicationUtil.notEmpty(sisNULL)) {
			SelectItemGroup group = new SelectItemGroup(ConstantsLanguage.ALTRO.stampa()); 
			group.setSelectItems(sisNULL.toArray(new SelectItem[sisNULL.size()]));
			sisGroup.add(group);
		}

		return sisGroup;
	}

	public List<SelectItem> getEsitoArchiviazione(List<EsitoArchiviazioneSI> lis, boolean zero, EsitoArchiviazione esito) {
		boolean idselect = getSelect();
		Iterator<EsitoArchiviazioneSI> objIter = lis.iterator();
		List<Long> ids = new ArrayList<Long>();
		List<SelectItem> sisSI = new ArrayList<SelectItem>();
		List<SelectItem> sisNO = new ArrayList<SelectItem>();
		List<SelectItem> sisGroup = new ArrayList<SelectItem>();
		if(zero) {
			sisGroup.add(0, new SelectItem(null, ConstantsLanguage.TRATTINI.stampa()));
		}
		while(objIter.hasNext()) {
			EsitoArchiviazioneSI es = objIter.next();
			SelectItem ut = new SelectItem(es.getId(), ApplicationUtil.toString(idselect ? es.getId() : null, es.getEtichettaCodice()));
			if(ApplicationUtil.isTrue(es.getUtile())) {
				sisSI.add(ut);
			}
			if(ApplicationUtil.isFalse(es.getUtile())) {
				sisNO.add(ut);
			}
			ids.add(es.getId());
		}
		if (esito != null && !ids.contains(esito.getId())) {
			SelectItem ut = new SelectItem(esito.getId(), ApplicationUtil.toString(idselect ? esito.getId() : null, esito.getEtichettaCodice()));
			if(ApplicationUtil.isTrue(esito.getUtile())) {
				sisSI.add(ut);
			}
			if(ApplicationUtil.isFalse(esito.getUtile())) {
				sisNO.add(ut);
			}
		}

		if(ApplicationUtil.empty(sisSI) || ApplicationUtil.empty(sisNO)) {
			sisGroup.addAll(sisSI);
			sisGroup.addAll(sisNO);
			return sisGroup;
		}

		if(ApplicationUtil.notEmpty(sisSI)) {
			SelectItemGroup group = new SelectItemGroup(ConstantsLanguage.UTILE.stampa()); 
			group.setSelectItems(sisSI.toArray(new SelectItem[sisSI.size()]));
			sisGroup.add(group);
		}
		if(ApplicationUtil.notEmpty(sisNO)) {
			SelectItemGroup group = new SelectItemGroup(ConstantsLanguage.NON_UTILE.stampa()); 
			group.setSelectItems(sisNO.toArray(new SelectItem[sisNO.size()]));
			sisGroup.add(group);
		}
		return sisGroup;
	}

	public List<SelectItem> getEsitoContratto(List<EsitoContrattoSI> lis, boolean zero, EsitoContratto esito) {
		boolean idselect = getSelect();
		Iterator<EsitoContrattoSI> objIter = lis.iterator();
		List<Long> ids = new ArrayList<Long>();
		List<SelectItem> sisSI = new ArrayList<SelectItem>();
		List<SelectItem> sisNO = new ArrayList<SelectItem>();
		List<SelectItem> sisGroup = new ArrayList<SelectItem>();
		if(zero) {
			sisGroup.add(0, new SelectItem(null, ConstantsLanguage.TRATTINI.stampa()));
		}
		while(objIter.hasNext()) {
			EsitoContrattoSI es = objIter.next();
			SelectItem ut = new SelectItem(es.getId(), ApplicationUtil.toString(idselect ? es.getId() : null, es.getEtichettaCodice()));
			if(ApplicationUtil.isTrue(es.getUtile())) {
				sisSI.add(ut);
			}
			if(ApplicationUtil.isFalse(es.getUtile())) {
				sisNO.add(ut);
			}
			ids.add(es.getId());
		}
		if (esito != null && !ids.contains(esito.getId())) {
			SelectItem ut = new SelectItem(esito.getId(), ApplicationUtil.toString(idselect ? esito.getId() : null, esito.getEtichettaCodice()));
			if(ApplicationUtil.isTrue(esito.getUtile())) {
				sisSI.add(ut);
			}
			if(ApplicationUtil.isFalse(esito.getUtile())) {
				sisNO.add(ut);
			}
		}
		if(ApplicationUtil.empty(sisSI) || ApplicationUtil.empty(sisNO)) {
			sisGroup.addAll(sisSI);
			sisGroup.addAll(sisNO);
			return sisGroup;
		}

		if(ApplicationUtil.notEmpty(sisSI)) {
			SelectItemGroup group = new SelectItemGroup(ConstantsLanguage.UTILE.stampa()); 
			group.setSelectItems(sisSI.toArray(new SelectItem[sisSI.size()]));
			sisGroup.add(group);
		}
		if(ApplicationUtil.notEmpty(sisNO)) {
			SelectItemGroup group = new SelectItemGroup(ConstantsLanguage.NON_UTILE.stampa()); 
			group.setSelectItems(sisNO.toArray(new SelectItem[sisNO.size()]));
			sisGroup.add(group);
		}
		return sisGroup;
	}

	public List<SelectItem> getEsitoAppuntamento(List<EsitoAppuntamentoSI> lis, boolean zero, EsitoAppuntamento esito) {
		boolean idselect = getSelect();
		Iterator<EsitoAppuntamentoSI> objIter = lis.iterator();
		List<Long> ids = new ArrayList<Long>();
		List<SelectItem> sisSI = new ArrayList<SelectItem>();
		List<SelectItem> sisNO = new ArrayList<SelectItem>();
		List<SelectItem> sisGroup = new ArrayList<SelectItem>();
		if(zero) {
			sisGroup.add(0, new SelectItem(null, ConstantsLanguage.TRATTINI.stampa()));
		}
		while(objIter.hasNext()) {
			EsitoAppuntamentoSI es = objIter.next();
			SelectItem ut = new SelectItem(es.getId(), ApplicationUtil.toString(idselect ? es.getId() : null, es.getEtichettaCodice()));
			if(ApplicationUtil.isTrue(es.getUtile())) {
				sisSI.add(ut);
			}
			if(ApplicationUtil.isFalse(es.getUtile())) {
				sisNO.add(ut);
			}
			ids.add(es.getId());
		}
		if (esito != null && !ids.contains(esito.getId())) {
			SelectItem ut = new SelectItem(esito.getId(), ApplicationUtil.toString(idselect ? esito.getId() : null, esito.getEtichettaCodice()));
			if(ApplicationUtil.isTrue(esito.getUtile())) {
				sisSI.add(ut);
			}
			if(ApplicationUtil.isFalse(esito.getUtile())) {
				sisNO.add(ut);
			}
		}

		if(ApplicationUtil.empty(sisSI) || ApplicationUtil.empty(sisNO)) {
			sisGroup.addAll(sisSI);
			sisGroup.addAll(sisNO);
			return sisGroup;
		}

		if(ApplicationUtil.notEmpty(sisSI)) {
			SelectItemGroup group = new SelectItemGroup(ConstantsLanguage.UTILE.stampa()); 
			group.setSelectItems(sisSI.toArray(new SelectItem[sisSI.size()]));
			sisGroup.add(group);
		}
		if(ApplicationUtil.notEmpty(sisNO)) {
			SelectItemGroup group = new SelectItemGroup(ConstantsLanguage.NON_UTILE.stampa()); 
			group.setSelectItems(sisNO.toArray(new SelectItem[sisNO.size()]));
			sisGroup.add(group);
		}
		return sisGroup;
	}

	public List<SelectItem> getGeneric(List<GenericSI> lis, boolean zero) {
		List<SelectItem> sisGroup = new ArrayList<SelectItem>();
		if(zero) {
			sisGroup.add(0, new SelectItem(null, ConstantsLanguage.TRATTINI.stampa()));
		}
		if(ApplicationUtil.notEmpty(lis)) {
			boolean idselect = getSelect();
			Iterator<GenericSI> objIter = lis.iterator();
			while(objIter.hasNext()) {
				GenericSI prd = objIter.next();
				SelectItem ut = new SelectItem(prd.getId(), ApplicationUtil.toString(idselect ? prd.getId() : null, prd.getDenominazione()));
				sisGroup.add(ut);
			}
		}
		return sisGroup;
	}

	public List<SelectItem> getGenericNoID(List<GenericSI> lis, boolean zero) {
		List<SelectItem> sisGroup = new ArrayList<SelectItem>();
		if(zero) {
			sisGroup.add(0, new SelectItem(null, ConstantsLanguage.TRATTINI.stampa()));
		}
		if(ApplicationUtil.notEmpty(lis)) {
			Iterator<GenericSI> objIter = lis.iterator();
			while(objIter.hasNext()) {
				GenericSI prd = objIter.next();
				SelectItem ut = new SelectItem(prd.getId(), prd.getDenominazione());
				sisGroup.add(ut);
			}
		}
		return sisGroup;
	}

	
	public void scarica(MyFile allegato, DownloadBean downloadBean) {
		try {
			OutputStream out = downloadBean.outputStream();
			downloadBean.filename(allegato.getName());
			InputStream is = new ByteArrayInputStream(allegato.getData());
			ApplicationUtil.copy(is, out);
			downloadBean.close();
			is.close();
		} catch (Exception e) {
			ErrorLog.log(null, getClass(), e);
		}
	}
	
	public MySystem checkSystem() {
		double max = 100;
		Double soglia1 = getAnomalia();
		Double soglia2 = max - getAnomalia();
		MySystem m = new MySystem();
		OperatingSystemMXBean os = ManagementFactory.getOperatingSystemMXBean();
		m.setNome(os.getName());
		m.setVersione(os.getVersion());
		m.setArchitettura(os.getArch());
		m.setUtilizzo(os.getSystemLoadAverage());
		Runtime runtime = Runtime.getRuntime();
		m.setProcessori(runtime.availableProcessors());
		long totale = runtime.maxMemory();
		long libero = runtime.freeMemory();
		long usata = runtime.totalMemory();
		m.setTotale(totale);
		m.setDisponibile(libero + (totale - usata));
		m.setLibero(libero);
		m.setUsato(usata);
		//boolean v1 = soglia1 != null ? (m.getPercentualeU().doubleValue() * max) >= soglia1.doubleValue() : true;
		//boolean v2 = soglia2 != null ? (m.getPercentualeD().doubleValue() * max) <= soglia2.doubleValue() : true;
		//if( v1 || v2) {
		//	m.addAnomalia(ConstantsLanguage.MEMORIA.stampa() + ": " + ConstantsLanguage.ESAURITO.stampa());
		//}
		List<MyStorage> storages = new ArrayList<MyStorage>();
		//for (Path root : FileSystems.getDefault().getRootDirectories()) {
		//	FileStore store = Files.getFileStore(root);
		//}
		File[] roots = File.listRoots();
		for (File root : roots) {
			long totalSpace = root.getTotalSpace();
			long freeSpace = root.getFreeSpace();
			long usableSpace = root.getUsableSpace();
			String path = root.getAbsolutePath();
			if(totalSpace > 0) {
				MyStorage s = new MyStorage();
				s.setPath(path);
				s.setTotale(totalSpace);
				s.setLibero(freeSpace);
				s.setUsato((totalSpace - freeSpace));
				s.setDisponibile(usableSpace);
				boolean s1 = soglia1 != null ? (s.getPercentualeU().doubleValue() * max) >= soglia1.doubleValue() : true;
				boolean s2 = soglia2 != null ? (s.getPercentualeD().doubleValue() * max) <= soglia2.doubleValue() : true;
				if( s1 || s2) {
					m.addAnomalia(ConstantsLanguage.STORAGE.stampa() + " '" + path + "': " + ConstantsLanguage.ESAURITO.stampa());
				}
				storages.add(s);
			}
		}
		m.setStorages(storages);
		return m;
	}
	
	

	public void aggiornamento() {
		String home = getHome();
		String service = home + "/aggiorna.sh";
		if(ApplicationUtil.getPath(service, true)) {
			ApplicationUtil.executeRuntime(service, false);
		}
	}

	public void restart() {
		String home = getHome();
		String service = home + "/pulisci.sh";
		if(ApplicationUtil.getPath(service, true)) {
			ApplicationUtil.executeRuntime(service);
		}
	}
	public void restore(String file) {
		String home = getHome();
		String service = home + "/importa.sh";
		if(ApplicationUtil.getPath(service, true)) {
			ApplicationUtil.executeRuntime(service + " " + file);
		}
	}

	public void restoreFull(FileUpload fileUpload) {
		String home = getHome();
		String service = home + "/importa.sh";
		List<MyFile> fls = fileUpload.getFiles();
		if(ApplicationUtil.notEmpty(fls)) {
			Iterator<MyFile> flsIt = fls.iterator();
			while (flsIt.hasNext()) {
				MyFile ff = (MyFile) flsIt.next();
				String file = ApplicationUtil.getNameN(ff.getName());
				String type = ApplicationUtil.getExtensionN(ff.getName());
				try {
					FileOutputStream fi = new FileOutputStream(home + ConstantsGlobal.path_backup + "/" + file);
					fi.write(ff.getData());
					fi.flush();
					fi.close();
					if(ApplicationUtil.getPath(service, true)) {
						if(ApplicationUtil.equals(type, ConstantsMap.sql)) {
							ApplicationUtil.executeRuntime(service + " " + file + " " + 2, true);
						}
						if(ApplicationUtil.equals(type, ConstantsMap.gz)) {
							ApplicationUtil.executeRuntime(service + " " + file + " " + 1, true);
						}
					}
				} catch (Exception e) {
					ErrorLog.log(null, getClass(), e);
				}
				ApplicationUtil.deleteFile(file);
			}
		}
	}
	public void riavvia() {
		String service = riavviaCommand(); 
		if(service != null) {
			ApplicationUtil.executeRuntime(service);
		}
	}
	public String riavviaCommand() {
		int time = 0;
		if(ApplicationUtil.isWindows()) {
			return "shutdown.exe -r -t" + " " + time;
		} else {
			return "shutdown -r" + " " + time;
		}
	}
	public void backup() {
		String home = getHome();
		String service = home + "/esporta.sh";
		if(ApplicationUtil.getPath(service, true)) {
			ApplicationUtil.executeRuntime(service);
		}
	}

	public void backupFull() {
		String home = getHome();
		String service = home + "/esporta.sh";
		if(ApplicationUtil.getPath(service, true)) {
			String data = ApplicationUtil.formatDate(ConstantsFormat.exportDateTime.stampa(), ApplicationUtil.date());
			ApplicationUtil.executeRuntime(service + " " + data, true);
		}
	}

	public void restoreBackup(MyFile backup) {
		restore(backup.getName());
	}
	public String getPathWeb() {
		return ConstantsGlobal.path_web;
	}

}