package it.callite.utility;
import java.io.OutputStream;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.concurrent.CopyOnWriteArrayList;

import org.apache.commons.collections4.ListUtils;
import org.apache.poi.ss.usermodel.Cell;
import org.apache.poi.ss.usermodel.CellType;
import org.apache.poi.ss.usermodel.Row;
import org.apache.poi.ss.usermodel.Sheet;
import org.apache.poi.ss.usermodel.Workbook;
import org.apache.poi.ss.util.CellRangeAddress;

import it.callite.constants.ConstantsFormat;
import it.callite.constants.ConstantsLanguage;
import it.callite.constants.ConstantsMap;
import it.callite.dao.AnagraficaDao;
import it.callite.message.Message;
import it.callite.model.Accesso;
import it.callite.model.Acconto;
import it.callite.model.Agente;
import it.callite.model.Anagrafica;
import it.callite.model.Appuntamento;
import it.callite.model.AutoContatto;
import it.callite.model.CampoAggiuntivoAnagrafica;
import it.callite.model.CampoAggiuntivoContratto;
import it.callite.model.Contatto;
import it.callite.model.Contratto;
import it.callite.model.DatoAggiuntivoAnagrafica;
import it.callite.model.DatoAggiuntivoContratto;
import it.callite.model.Email;
import it.callite.model.Estratto;
import it.callite.model.EstrattoDettaglio;
import it.callite.model.Rmail;
import it.callite.model.Marcatura;
import it.callite.model.Nota;
import it.callite.model.Notifica;
import it.callite.model.Operazione;
import it.callite.model.Opposizione;
import it.callite.model.Pausa;
import it.callite.model.Prenotazione;
import it.callite.model.Ricezione;
import it.callite.model.Sondaggio;
import it.callite.model.StoriaAppuntamento;
import it.callite.model.StoriaContatto;
import it.callite.model.StoriaContratto;
import it.callite.model.Telecom;
import it.callite.model.TemplateExportAnagrafica;
import it.callite.model.TemplateExportAppuntamento;
import it.callite.model.TemplateExportContatto;
import it.callite.model.TemplateExportContratto;
import it.callite.model.TemplateExportStoriaAppuntamento;
import it.callite.model.TemplateExportStoriaContatto;
import it.callite.model.TemplateExportStoriaContratto;
import it.callite.model.TemplateImportAppuntamento;
import it.callite.model.TemplateImportContatto;
import it.callite.model.TemplateImportContratto;
import it.callite.model.Utente;
import it.callite.model.Webhook;
import it.callite.model.sip.Cdr;
import it.callite.model.sip.Cel;
import it.callite.utility.item.ContattoSI;
public class ExcelExport {
	public static void esportaExcelContatto(List<Contatto> data, AnagraficaDao anagraficaDao, List<Long> campis, OutputStream result, String password) throws Exception {
		String [] titles = new ExportUtility().titlesContatto;
		Workbook wb = ApplicationUtil.workbookS();
		ExcelStyle s = new ExcelStyle(wb);
		if(ApplicationUtil.empty(campis)) {
			campis = new ArrayList<Long>();
		}
		Long [] campiChiave = new Long[campis.size()];
		String [] campiEtichette = new String[campis.size()];
		for (int i = 0; i < campis.size(); i++) {
			campiChiave[i] = campis.get(i);
			campiEtichette[i] = anagraficaDao.getEtichettaById(CampoAggiuntivoAnagrafica.class, campis.get(i));
		}	
		if(ApplicationUtil.notEmpty(campiChiave)) {
			data = anagraficaDao.loadFullContatto(data);
		}
		String[] titlesLun = ApplicationUtil.addArray(titles, campiEtichette);
		Sheet sheet = wb.createSheet(ConstantsLanguage.CONTATTI.stampa());
		int k = 0;
		Row row = sheet.createRow(k++);
		for (int i = 0; i < titlesLun.length; i++) {
			Cell cell = row.createCell(i, CellType.STRING);
			ApplicationUtil.headerCell(s, cell,  titlesLun[i]);
		}
		sheet.setAutoFilter(new CellRangeAddress(0, 0, 0, titlesLun.length-1));
		sheet.createFreezePane(0, 1);
		Iterator<Contatto> objIter = data.iterator();
		while(objIter.hasNext()) {
			Contatto prd = objIter.next();
			row = sheet.createRow(k++);
			ExcelFormatList lista = new ExcelFormatList();
			lista.addValore(prd.getId().toString());
			lista.addValore(ConstantsFormat.dateTime.stampa(), prd.getData_creazione());
			lista.addValore(prd.getBloccatoS());
			lista.addValore(prd.getCampagna_denominazione());
			lista.addValore(prd.getLista_denominazione());
			lista.addValore(prd.getAnagrafica().getDenominazione());
			lista.addValore(prd.getAnagrafica().getCognome());
			lista.addValore(prd.getAnagrafica().getNome());
			lista.addValore(prd.getAnagrafica().getEmail());
			lista.addValore(prd.getAnagrafica().getLink());
			lista.addValore(prd.getAnagrafica().getCodice_fiscale());
			lista.addValore(prd.getAnagrafica().getPartita_iva());
			lista.addValore(prd.getAnagrafica().getTelefono_fisso());
			lista.addValore(prd.getAnagrafica().getTelefono_mobile());
			lista.addValore(prd.getAnagrafica().getTelefono_fax());
			lista.addValore(prd.getAnagrafica().getTelefono_altro());
			lista.addValore(ConstantsFormat.dateTime.stampa(), prd.getData_archiviazione());
			lista.addValore(prd.getEsito_chiamata_etichettaCodice());
			lista.addValore(prd.getEsito_archiviazione_etichettaCodice());
			lista.addValore(prd.getPositivo());
			lista.addValore(prd.getUtile());
			lista.addValore(prd.getChiuso());
			lista.addValore(prd.getProprietario_denominazione());
			lista.addValore(ConstantsFormat.dateTime.stampa(), prd.getData_presentazione());
			lista.addValore(ConstantsFormat.dateTime.stampa(), prd.getData_lavorazione());
			lista.addValore(prd.getOperatore_denominazione());
			lista.addValore(prd.getNota());
			lista.addValore(prd.getAgente_denominazione());
			lista.addValore(prd.getTipoTesto());
			lista.addValore(prd.getAnagrafica().getIndirizzo_legale().getIndirizzo_completo());
			lista.addValore(prd.getAnagrafica().getIndirizzo_operativo().getIndirizzo_completo());
			for (int i = titles.length; i < titlesLun.length; i++) {
				stampaDato(lista, campiChiave[i-titles.length], prd.getAnagrafica().getDettagli(), null);
			}
			for (int j = 0; j < lista.size(); j++) {
				ExcelFormat el = lista.get(j);
				Cell cell = row.createCell(j, el.getCellType());
				ApplicationUtil.cellStamper(s, cell, el);
			}
		}
		sheet.setDefaultColumnWidth(20);
		ApplicationUtil.passwordXLS(wb, result, password);
		
	}
	public static void esportaExcelAppuntamento(List<Appuntamento> data, AnagraficaDao anagraficaDao, List<Long> campis, OutputStream result, String password) throws Exception {
		String [] titles = new ExportUtility().titlesAppuntamento;
		Workbook wb = ApplicationUtil.workbookS();
		ExcelStyle s = new ExcelStyle(wb);
		if(ApplicationUtil.empty(campis)) {
			campis = new ArrayList<Long>();
		}
		Long [] campiChiave = new Long[campis.size()];
		String [] campiEtichette = new String[campis.size()];
		for (int i = 0; i < campis.size(); i++) {
			campiChiave[i] = campis.get(i);
			campiEtichette[i] = anagraficaDao.getEtichettaById(CampoAggiuntivoAnagrafica.class, campis.get(i));
		}	
		if(ApplicationUtil.notEmpty(campiChiave)) {
			data = anagraficaDao.loadFullAppuntamento(data);
		}
		String[] titlesLun = ApplicationUtil.addArray(titles, campiEtichette);
		Sheet sheet = wb.createSheet(ConstantsLanguage.APPUNTAMENTI.stampa());
		int k = 0;
		Row row = sheet.createRow(k++);
		for (int i = 0; i < titlesLun.length; i++) {
			Cell cell = row.createCell(i, CellType.STRING);
			ApplicationUtil.headerCell(s, cell,  titlesLun[i]);
		}
		sheet.setAutoFilter(new CellRangeAddress(0, 0, 0, titlesLun.length-1));
		sheet.createFreezePane(0, 1);
		Iterator<Appuntamento> objIter = data.iterator();
		while(objIter.hasNext()) {
			Appuntamento prd = objIter.next();
			row = sheet.createRow(k++);
			ExcelFormatList lista = new ExcelFormatList();
			lista.addValore(prd.getId().toString());
			lista.addValore(ConstantsFormat.dateTime.stampa(), prd.getData_creazione());
			lista.addValore(prd.getBloccatoS());
			lista.addValore(prd.getContatto().getCampagna_denominazione());
			lista.addValore(prd.getContatto().getLista_denominazione());
			lista.addValore(prd.getContatto().getAnagrafica().getDenominazione());
			lista.addValore(prd.getContatto().getAnagrafica().getCognome());
			lista.addValore(prd.getContatto().getAnagrafica().getNome());
			lista.addValore(prd.getContatto().getAnagrafica().getEmail());
			lista.addValore(prd.getContatto().getAnagrafica().getLink());
			lista.addValore(prd.getContatto().getAnagrafica().getCodice_fiscale());
			lista.addValore(prd.getContatto().getAnagrafica().getPartita_iva());
			lista.addValore(prd.getContatto().getAnagrafica().getTelefono_fisso());
			lista.addValore(prd.getContatto().getAnagrafica().getTelefono_mobile());
			lista.addValore(prd.getContatto().getAnagrafica().getTelefono_fax());
			lista.addValore(prd.getContatto().getAnagrafica().getTelefono_altro());
			lista.addValore(prd.getOperatore_denominazione());
			lista.addValore(prd.getAgente_denominazione());
			lista.addValore(prd.getNota());
			lista.addValore(ConstantsFormat.date.stampa(), prd.getData_inizio());
			lista.addValore(ConstantsFormat.time.stampa(), prd.getData_inizio());
			lista.addValore(ConstantsFormat.time.stampa(), prd.getData_fine());
			lista.addValore(ConstantsFormat.dateTime.stampa(), prd.getData_conferma());
			lista.addValore(ConstantsFormat.dateTime.stampa(), prd.getData_lavorazione());
			lista.addValore(prd.getUtente_denominazione());
			lista.addValore(prd.getEsitoEtichettaCodice());
			lista.addValore(prd.getStatoTesto());
			lista.addValore(ConstantsFormat.dateTime.stampa(), prd.getData_esito());
			lista.addValore(ConstantsFormat.dateTime.stampa(), prd.getData_stato());
			lista.addValore(prd.getLocalizzazioneString());
			lista.addValore(prd.getContatto().getAnagrafica().getIndirizzo_legale().getIndirizzo_completo());
			lista.addValore(prd.getContatto().getAnagrafica().getIndirizzo_operativo().getIndirizzo_completo());
			for (int i = titles.length; i < titlesLun.length; i++) {
				stampaDato(lista, campiChiave[i-titles.length], prd.getContatto().getAnagrafica().getDettagli(), null);
			}
			for (int j = 0; j < lista.size(); j++) {
				ExcelFormat el = lista.get(j);
				Cell cell = row.createCell(j, el.getCellType());
				ApplicationUtil.cellStamper(s, cell, el);
			}
			
		}
		sheet.setDefaultColumnWidth(20);
		ApplicationUtil.passwordXLS(wb, result, password);
		
	}
	public static void esportaExcelContratto(List<Contratto> data, OutputStream result, String password) throws Exception {
		String [] titles = new ExportUtility().titlesContratto;
		Workbook wb = ApplicationUtil.workbookS();
		ExcelStyle s = new ExcelStyle(wb);
		Sheet sheet = wb.createSheet(ConstantsLanguage.CONTRATTI.stampa());
		int k = 0;
		Row row = sheet.createRow(k++);
		for(int i = 0; i < titles.length; i++) {
			Cell cell = row.createCell(i, CellType.STRING);
			ApplicationUtil.headerCell(s, cell,  titles[i]);
		}
		sheet.setAutoFilter(new CellRangeAddress(0, 0, 0, titles.length-1));
		sheet.createFreezePane(0, 1);
		Iterator<Contratto> objIter = data.iterator();
		while(objIter.hasNext()) {
			Contratto prd = objIter.next();
			row = sheet.createRow(k++);
			ExcelFormatList lista = new ExcelFormatList();
			lista.addValore(prd.getId().toString());
			lista.addValore(ConstantsFormat.dateTime.stampa(), prd.getData_creazione());
			lista.addValore(prd.getBloccatoS());
			lista.addValore(prd.getContatto().getCampagna_denominazione());
			lista.addValore(prd.getContatto().getLista_denominazione());
			lista.addValore(ConstantsFormat.dateTime.stampa(), prd.getData_lavorazione());
			lista.addValore(prd.getUtente_denominazione());
			lista.addValore(prd.getContatto().getAnagrafica().getDenominazione());
			lista.addValore(prd.getContatto().getAnagrafica().getCognome());
			lista.addValore(prd.getContatto().getAnagrafica().getNome());
			lista.addValore(prd.getContatto().getAnagrafica().getEmail());
			lista.addValore(prd.getContatto().getAnagrafica().getLink());
			lista.addValore(prd.getContatto().getAnagrafica().getCodice_fiscale());
			lista.addValore(prd.getContatto().getAnagrafica().getPartita_iva());
			lista.addValore(prd.getContatto().getAnagrafica().getTelefono_fisso());
			lista.addValore(prd.getContatto().getAnagrafica().getTelefono_mobile());
			lista.addValore(prd.getContatto().getAnagrafica().getTelefono_fax());
			lista.addValore(prd.getContatto().getAnagrafica().getTelefono_altro());
			lista.addValore(prd.getOperatore_denominazione());
			lista.addValore(prd.getAgente_denominazione());
			lista.addValore(prd.getCategoria_denominazione());
			lista.addValore(prd.getProdotto_denominazione());
			lista.addValore(prd.getEsitoEtichettaCodice());
			lista.addValore(prd.getTipo_seriale());
			lista.addValore(prd.getSeriale());
			lista.addValore(prd.getQuantita());
			lista.addValore(prd.getCosto_scontato());
			lista.addValore(ConstantsFormat.date.stampa(), prd.getData_contabile());
			lista.addValore(ConstantsFormat.date.stampa(), prd.getData_stipula());
			lista.addValore(ConstantsFormat.date.stampa(), prd.getData_attivazione());
			lista.addValore(ConstantsFormat.date.stampa(), prd.getData_caricamento());
			lista.addValore(prd.getNota());
			lista.addValore(prd.getStatoTesto());
			lista.addValore(ConstantsFormat.dateTime.stampa(), prd.getData_esito());
			lista.addValore(ConstantsFormat.dateTime.stampa(), prd.getData_stato());
			lista.addValore(prd.getContatto().getAnagrafica().getIndirizzo_legale().getIndirizzo_completo());
			lista.addValore(prd.getContatto().getAnagrafica().getIndirizzo_operativo().getIndirizzo_completo());
			for (int j = 0; j < lista.size(); j++) {
				ExcelFormat el = lista.get(j);
				Cell cell = row.createCell(j, el.getCellType());
				ApplicationUtil.cellStamper(s, cell, el);
			}
		}
		sheet.setDefaultColumnWidth(20);
		ApplicationUtil.passwordXLS(wb, result, password);
		
	}
	public static void esportaExcelAnagrafica(List<Anagrafica> data, AnagraficaDao anagraficaDao, List<Long> campis, OutputStream result, String password) throws Exception {
		String [] titles = new ExportUtility().titlesAnagrafica;
		Workbook wb = ApplicationUtil.workbookS();
		ExcelStyle s = new ExcelStyle(wb);
		if(ApplicationUtil.empty(campis)) {
			campis = new ArrayList<Long>();
		}
		Long [] campiChiave = new Long[campis.size()];
		String [] campiEtichette = new String[campis.size()];
		for (int i = 0; i < campis.size(); i++) {
			campiChiave[i] = campis.get(i);
			campiEtichette[i] = anagraficaDao.getEtichettaById(CampoAggiuntivoAnagrafica.class, campis.get(i));
		}	
		if(ApplicationUtil.notEmpty(campiChiave)) {
			data = anagraficaDao.loadFullAnagrafica(data);
		}
		String[] titlesLun = ApplicationUtil.addArray(titles, campiEtichette);
		Sheet sheet = wb.createSheet(ConstantsLanguage.ANAGRAFICHE.stampa());
		int k = 0;
		Row row = sheet.createRow(k++);
		for (int i = 0; i < titlesLun.length; i++) {
			Cell cell = row.createCell(i, CellType.STRING);
			ApplicationUtil.headerCell(s, cell,  titlesLun[i]);
		}
		sheet.setAutoFilter(new CellRangeAddress(0, 0, 0, titlesLun.length-1));
		sheet.createFreezePane(0, 1);
		Iterator<Anagrafica> objIter = data.iterator();
		while(objIter.hasNext()) {
			Anagrafica prd = objIter.next();
			row = sheet.createRow(k++);
			ExcelFormatList lista = new ExcelFormatList();
			lista.addValore(prd.getId().toString());
			lista.addValore(prd.getDenominazione());
			lista.addValore(prd.getCognome());
			lista.addValore(prd.getNome());
			lista.addValore(prd.getEmail());
			lista.addValore(prd.getLink());
			lista.addValore(prd.getCodice_fiscale());
			lista.addValore(prd.getPartita_iva());
			lista.addValore(prd.getTelefono_fisso());
			lista.addValore(prd.getTelefono_mobile());
			lista.addValore(prd.getTelefono_fax());
			lista.addValore(prd.getTelefono_altro());
			lista.addValore(prd.getRagione_sociale());
			lista.addValore(prd.getNome_completo());
			lista.addValore(ConstantsFormat.date.stampa(), prd.getDate_nascita());
			lista.addValore(prd.getLuogo_nascita());
			lista.addValore(prd.getTipo());
			lista.addValore(prd.getSesso());
			lista.addValore(prd.getNota());
			lista.addValore(prd.getSettore());
			lista.addValore(ConstantsFormat.dateTime.stampa(), prd.getConsenso_tfisso());
			lista.addValore(ConstantsFormat.dateTime.stampa(), prd.getConsenso_tmobile());
			lista.addValore(ConstantsFormat.dateTime.stampa(), prd.getConsenso_tfax());
			lista.addValore(ConstantsFormat.dateTime.stampa(), prd.getConsenso_taltro());
			lista.addValore(ConstantsFormat.dateTime.stampa(), prd.getConsenso_email());
			lista.addValore(ConstantsFormat.dateTime.stampa(), prd.getConsenso_rmail());
			lista.addValore(prd.getIndirizzo_legale().getIndirizzo_completo());
			lista.addValore(prd.getIndirizzo_operativo().getIndirizzo_completo());
			for (int i = titles.length; i < titlesLun.length; i++) {
				stampaDato(lista, campiChiave[i-titles.length], prd.getDettagli(), null);
			}
			for (int j = 0; j < lista.size(); j++) {
				ExcelFormat el = lista.get(j);
				Cell cell = row.createCell(j, el.getCellType());
				ApplicationUtil.cellStamper(s, cell, el);
			}
		}
		sheet.setDefaultColumnWidth(20);
		ApplicationUtil.passwordXLS(wb, result, password);
		
	}
	public static void esportaExcelContratto(List<Contratto> data, AnagraficaDao anagraficaDao, List<Long> campiA, List<Long> campiB, OutputStream result, String password) throws Exception {
		String [] titles = new ExportUtility().titlesContratto;
		Workbook wb = ApplicationUtil.workbookS();
		ExcelStyle s = new ExcelStyle(wb);
		if(ApplicationUtil.empty(campiA)) {
			campiA = new ArrayList<Long>();
		}
		if(ApplicationUtil.empty(campiB)) {
			campiB = new ArrayList<Long>();
		}
		Long [] campiChiave = new Long[campiB.size() + campiA.size()];
		String [] campiEtichette = new String[campiB.size() + campiA.size()];
		for (int i = 0; i < campiB.size(); i++) {
			campiChiave[i] = campiB.get(i);
			campiEtichette[i] = anagraficaDao.getEtichettaById(CampoAggiuntivoAnagrafica.class, campiB.get(i));
		}	
		for (int i = 0; i < campiA.size(); i++) {
			campiChiave[campiB.size() + i] = campiA.get(i);
			campiEtichette[campiB.size() + i] = anagraficaDao.getEtichettaById(CampoAggiuntivoContratto.class, campiA.get(i));
		}	
		if(ApplicationUtil.notEmpty(campiChiave)) {
			data = anagraficaDao.loadFullContratto(data);
		}
		String[] titlesLun = ApplicationUtil.addArray(titles, campiEtichette);
		Sheet sheet = wb.createSheet(ConstantsLanguage.CONTRATTI.stampa());
		int k = 0;
		Row row = sheet.createRow(k++);
		for (int i = 0; i < titlesLun.length; i++) {
			Cell cell = row.createCell(i, CellType.STRING);
			ApplicationUtil.headerCell(s, cell,  titlesLun[i]);
		}
		sheet.setAutoFilter(new CellRangeAddress(0, 0, 0, titlesLun.length-1));
		sheet.createFreezePane(0, 1);
		Iterator<Contratto> objIter = data.iterator();
		while(objIter.hasNext()) {
			Contratto prd = objIter.next();
			row = sheet.createRow(k++);
			ExcelFormatList lista = new ExcelFormatList();
			lista.addValore(prd.getId().toString());
			lista.addValore(ConstantsFormat.dateTime.stampa(), prd.getData_creazione());
			lista.addValore(prd.getBloccatoS());
			lista.addValore(prd.getContatto().getCampagna_denominazione());
			lista.addValore(prd.getContatto().getLista_denominazione());
			lista.addValore(ConstantsFormat.dateTime.stampa(), prd.getData_lavorazione());
			lista.addValore(prd.getUtente_denominazione());
			lista.addValore(prd.getContatto().getAnagrafica().getDenominazione());
			lista.addValore(prd.getContatto().getAnagrafica().getCognome());
			lista.addValore(prd.getContatto().getAnagrafica().getNome());
			lista.addValore(prd.getContatto().getAnagrafica().getEmail());
			lista.addValore(prd.getContatto().getAnagrafica().getLink());
			lista.addValore(prd.getContatto().getAnagrafica().getCodice_fiscale());
			lista.addValore(prd.getContatto().getAnagrafica().getPartita_iva());
			lista.addValore(prd.getContatto().getAnagrafica().getTelefono_fisso());
			lista.addValore(prd.getContatto().getAnagrafica().getTelefono_mobile());
			lista.addValore(prd.getContatto().getAnagrafica().getTelefono_fax());
			lista.addValore(prd.getContatto().getAnagrafica().getTelefono_altro());
			lista.addValore(prd.getOperatore_denominazione());
			lista.addValore(prd.getAgente_denominazione());
			lista.addValore(prd.getCategoria_denominazione());
			lista.addValore(prd.getProdotto_denominazione());
			lista.addValore(prd.getEsitoEtichettaCodice());
			lista.addValore(prd.getTipo_seriale());
			lista.addValore(prd.getSeriale());
			lista.addValore(prd.getQuantita());
			lista.addValore(prd.getCosto_scontato());
			lista.addValore(ConstantsFormat.date.stampa(), prd.getData_contabile());
			lista.addValore(ConstantsFormat.date.stampa(), prd.getData_stipula());
			lista.addValore(ConstantsFormat.date.stampa(), prd.getData_attivazione());
			lista.addValore(ConstantsFormat.date.stampa(), prd.getData_caricamento());
			lista.addValore(prd.getNota());
			lista.addValore(prd.getStatoTesto());
			lista.addValore(ConstantsFormat.dateTime.stampa(), prd.getData_esito());
			lista.addValore(ConstantsFormat.dateTime.stampa(), prd.getData_stato());
			lista.addValore(prd.getContatto().getAnagrafica().getIndirizzo_legale().getIndirizzo_completo());
			lista.addValore(prd.getContatto().getAnagrafica().getIndirizzo_operativo().getIndirizzo_completo());
			for (int i = titles.length; i < titlesLun.length; i++) {
				stampaDato(lista, campiChiave[i-titles.length], prd.getContatto().getAnagrafica().getDettagli(), prd.getDettagli());
			}
			for (int j = 0; j < lista.size(); j++) {
				ExcelFormat el = lista.get(j);
				Cell cell = row.createCell(j, el.getCellType());
				ApplicationUtil.cellStamper(s, cell, el);
			}
			
		}
		sheet.setDefaultColumnWidth(20);
		ApplicationUtil.passwordXLS(wb, result, password);
		
	}
	public static void esportaExcelContrattoVO(List<ContrattoVO> data, TemplateImportContratto ti, OutputStream result, String password) throws Exception {
		List<String> titles =  new ArrayList<String>();
		titles.add(ConstantsLanguage.CHIAVE.stampa() + " - " + Message.addCatalogText(ti.getTipo()));
		titles.addAll(ApplicationUtil.asList(new ExportUtility().titlesContrattoVO));
		Workbook wb = ApplicationUtil.workbookS();
		ExcelStyle s = new ExcelStyle(wb);
		Sheet sheet = wb.createSheet(ConstantsLanguage.CONTRATTI.stampa());
		int k = 0;
		Row row = sheet.createRow(k++);
		for(int i = 0; i < titles.size(); i++) {
			Cell cell = row.createCell(i, CellType.STRING);
			ApplicationUtil.headerCell(s, cell,  titles.get(i));
		}
		sheet.setAutoFilter(new CellRangeAddress(0, 0, 0, titles.size()-1));
		sheet.createFreezePane(0, 1);
		Iterator<ContrattoVO> objIter = data.iterator();
		while(objIter.hasNext()) {
			ContrattoVO prd = objIter.next();
			row = sheet.createRow(k++);
			ExcelFormatList lista = new ExcelFormatList();
			lista.addValore(prd.getChiave());
			lista.addValore(prd.getMotivo());
			for (int j = 0; j < lista.size(); j++) {
				ExcelFormat el = lista.get(j);
				Cell cell = row.createCell(j, el.getCellType());
				ApplicationUtil.cellStamper(s, cell, el);
			}
		}
		sheet.setDefaultColumnWidth(20);
		ApplicationUtil.passwordXLS(wb, result, password);
		
	}
	public static void esportaExcelAppuntamentoVO(List<AppuntamentoVO> data, TemplateImportAppuntamento ti, OutputStream result, String password) throws Exception {
		List<String> titles =  new ArrayList<String>();
		titles.add(ConstantsLanguage.CHIAVE.stampa() + " - " + Message.addCatalogText(ti.getTipo()));
		titles.addAll(ApplicationUtil.asList(new ExportUtility().titlesAppuntamentoVO));
		Workbook wb = ApplicationUtil.workbookS();
		ExcelStyle s = new ExcelStyle(wb);
		Sheet sheet = wb.createSheet(ConstantsLanguage.APPUNTAMENTI.stampa());
		int k = 0;
		Row row = sheet.createRow(k++);
		for(int i = 0; i < titles.size(); i++) {
			Cell cell = row.createCell(i, CellType.STRING);
			ApplicationUtil.headerCell(s, cell,  titles.get(i));
		}
		sheet.setAutoFilter(new CellRangeAddress(0, 0, 0, titles.size()-1));
		sheet.createFreezePane(0, 1);
		Iterator<AppuntamentoVO> objIter = data.iterator();
		while(objIter.hasNext()) {
			AppuntamentoVO prd = objIter.next();
			row = sheet.createRow(k++);
			ExcelFormatList lista = new ExcelFormatList();
			lista.addValore(prd.getChiave());
			lista.addValore(prd.getMotivo());
			for (int j = 0; j < lista.size(); j++) {
				ExcelFormat el = lista.get(j);
				Cell cell = row.createCell(j, el.getCellType());
				ApplicationUtil.cellStamper(s, cell, el);
			}
		}
		sheet.setDefaultColumnWidth(20);
		ApplicationUtil.passwordXLS(wb, result, password);
		
	}
	public static void esportaExcelContattoVO(List<ContattoVO> data, TemplateImportContatto ti, OutputStream result, String password) throws Exception {
		List<String> titles =  new ArrayList<String>();
		titles.add(ConstantsLanguage.CHIAVE.stampa() + " - " + Message.addCatalogText(ti.getTipo()));
		titles.addAll(ApplicationUtil.asList(new ExportUtility().titlesContattoVO));
		Workbook wb = ApplicationUtil.workbookS();
		ExcelStyle s = new ExcelStyle(wb);
		Sheet sheet = wb.createSheet(ConstantsLanguage.APPUNTAMENTI.stampa());
		int k = 0;
		Row row = sheet.createRow(k++);
		for(int i = 0; i < titles.size(); i++) {
			Cell cell = row.createCell(i, CellType.STRING);
			ApplicationUtil.headerCell(s, cell,  titles.get(i));
		}
		sheet.setAutoFilter(new CellRangeAddress(0, 0, 0, titles.size()-1));
		sheet.createFreezePane(0, 1);
		Iterator<ContattoVO> objIter = data.iterator();
		while(objIter.hasNext()) {
			ContattoVO prd = objIter.next();
			row = sheet.createRow(k++);
			ExcelFormatList lista = new ExcelFormatList();
			lista.addValore(prd.getChiave());
			lista.addValore(prd.getMotivo());
			for (int j = 0; j < lista.size(); j++) {
				ExcelFormat el = lista.get(j);
				Cell cell = row.createCell(j, el.getCellType());
				ApplicationUtil.cellStamper(s, cell, el);
			}
		}
		sheet.setDefaultColumnWidth(20);
		ApplicationUtil.passwordXLS(wb, result, password);
		
	}
	public static void esportaExcelOpposizione(List<Opposizione> data, OutputStream result, String password) throws Exception {
		String [] titles = new ExportUtility().titlesOpposizione;
		Workbook wb = ApplicationUtil.workbookS();
		ExcelStyle s = new ExcelStyle(wb);
		Sheet sheet = wb.createSheet(ConstantsLanguage.OPPOSIZIONI.stampa());
		int k = 0;
		Row row = sheet.createRow(k++);
		for(int i = 0; i < titles.length; i++) {
			Cell cell = row.createCell(i, CellType.STRING);
			ApplicationUtil.headerCell(s, cell,  titles[i]);
		}
		sheet.setAutoFilter(new CellRangeAddress(0, 0, 0, titles.length-1));
		sheet.createFreezePane(0, 1);
		Iterator<Opposizione> objIter = data.iterator();
		while(objIter.hasNext()) {
			Opposizione prd = objIter.next();
			row = sheet.createRow(k++);
			ExcelFormatList lista = new ExcelFormatList();
			lista.addValore(prd.getId().toString());
			lista.addValore(prd.getUtente_denominazione());
			lista.addValore(prd.getCampagna_denominazione());
			lista.addValore(prd.getDescrizione());
			lista.addValore(prd.getOpposizione());
			for (int j = 0; j < lista.size(); j++) {
				ExcelFormat el = lista.get(j);
				Cell cell = row.createCell(j, el.getCellType());
				ApplicationUtil.cellStamper(s, cell, el);
			}
		}
		sheet.setDefaultColumnWidth(20);
		ApplicationUtil.passwordXLS(wb, result, password);
		
	}
	public static void esportaExcelAppuntamento(List<Appuntamento> data, OutputStream result, String password) throws Exception {
		String [] titles = new ExportUtility().titlesAppuntamento;
		Workbook wb = ApplicationUtil.workbookS();
		ExcelStyle s = new ExcelStyle(wb);
		Sheet sheet = wb.createSheet(ConstantsLanguage.APPUNTAMENTI.stampa());
		int k = 0;
		Row row = sheet.createRow(k++);
		for(int i = 0; i < titles.length; i++) {
			Cell cell = row.createCell(i, CellType.STRING);
			ApplicationUtil.headerCell(s, cell,  titles[i]);
		}
		sheet.setAutoFilter(new CellRangeAddress(0, 0, 0, titles.length-1));
		sheet.createFreezePane(0, 1);
		Iterator<Appuntamento> objIter = data.iterator();
		while(objIter.hasNext()) {
			Appuntamento prd = objIter.next();
			row = sheet.createRow(k++);
			ExcelFormatList lista = new ExcelFormatList();
			lista.addValore(prd.getId().toString());
			lista.addValore(ConstantsFormat.dateTime.stampa(), prd.getData_creazione());
			lista.addValore(prd.getBloccatoS());
			lista.addValore(prd.getContatto().getCampagna_denominazione());
			lista.addValore(prd.getContatto().getLista_denominazione());
			lista.addValore(prd.getContatto().getAnagrafica().getDenominazione());
			lista.addValore(prd.getContatto().getAnagrafica().getCognome());
			lista.addValore(prd.getContatto().getAnagrafica().getNome());
			lista.addValore(prd.getContatto().getAnagrafica().getEmail());
			lista.addValore(prd.getContatto().getAnagrafica().getLink());
			lista.addValore(prd.getContatto().getAnagrafica().getCodice_fiscale());
			lista.addValore(prd.getContatto().getAnagrafica().getPartita_iva());
			lista.addValore(prd.getContatto().getAnagrafica().getTelefono_fisso());
			lista.addValore(prd.getContatto().getAnagrafica().getTelefono_mobile());
			lista.addValore(prd.getContatto().getAnagrafica().getTelefono_fax());
			lista.addValore(prd.getContatto().getAnagrafica().getTelefono_altro());
			lista.addValore(prd.getOperatore_denominazione());
			lista.addValore(prd.getAgente_denominazione());
			lista.addValore(prd.getNota());
			lista.addValore(ConstantsFormat.date.stampa(), prd.getData_inizio());
			lista.addValore(ConstantsFormat.time.stampa(), prd.getData_inizio());
			lista.addValore(ConstantsFormat.time.stampa(), prd.getData_fine());
			lista.addValore(ConstantsFormat.dateTime.stampa(), prd.getData_conferma());
			lista.addValore(ConstantsFormat.dateTime.stampa(), prd.getData_lavorazione());
			lista.addValore(prd.getUtente_denominazione());
			lista.addValore(prd.getEsitoEtichettaCodice());
			lista.addValore(prd.getStatoTesto());
			lista.addValore(ConstantsFormat.dateTime.stampa(), prd.getData_esito());
			lista.addValore(ConstantsFormat.dateTime.stampa(), prd.getData_stato());
			lista.addValore(prd.getLocalizzazioneString());
			lista.addValore(prd.getContatto().getAnagrafica().getIndirizzo_legale().getIndirizzo_completo());
			lista.addValore(prd.getContatto().getAnagrafica().getIndirizzo_operativo().getIndirizzo_completo());
			for (int j = 0; j < lista.size(); j++) {
				ExcelFormat el = lista.get(j);
				Cell cell = row.createCell(j, el.getCellType());
				ApplicationUtil.cellStamper(s, cell, el);
			}
		}
		sheet.setDefaultColumnWidth(20);
		ApplicationUtil.passwordXLS(wb, result, password);
		
	}
	public static void esportaExcelUser(List<Utente> data, OutputStream result, String password) throws Exception {
		String [] titles = new ExportUtility().titlesUser;
		Workbook wb = ApplicationUtil.workbookS();
		ExcelStyle s = new ExcelStyle(wb);
		Sheet sheet = wb.createSheet(ConstantsLanguage.UTENTI.stampa());
		int k = 0;
		Row row = sheet.createRow(k++);
		for(int i = 0; i < titles.length; i++) {
			Cell cell = row.createCell(i, CellType.STRING);
			ApplicationUtil.headerCell(s, cell,  titles[i]);
		}
		sheet.setAutoFilter(new CellRangeAddress(0, 0, 0, titles.length-1));
		sheet.createFreezePane(0, 1);
		Iterator<Utente> objIter = data.iterator();
		while(objIter.hasNext()) {
			Utente prd = objIter.next();
			row = sheet.createRow(k++);
			ExcelFormatList lista = new ExcelFormatList();
			lista.addValore(prd.getId().toString());
			lista.addValore(prd.getDenominazione());
			lista.addValore(prd.getCognome());
			lista.addValore(prd.getNome());
			lista.addValore(prd.getEmail());
			lista.addValore(prd.getUsername());
			lista.addValore(prd.getInternoString());
			lista.addValore(prd.getEnabledString());
			lista.addValore(prd.getCambioPasswordString());
			lista.addValore(prd.getGeneraEstrattoString());
			for (int j = 0; j < lista.size(); j++) {
				ExcelFormat el = lista.get(j);
				Cell cell = row.createCell(j, el.getCellType());
				ApplicationUtil.cellStamper(s, cell, el);
			}
		}
		sheet.setDefaultColumnWidth(20);
		ApplicationUtil.passwordXLS(wb, result, password);
		
	}
	public static void esportaExcelEstratto(List<Estratto> data, OutputStream result, String password) throws Exception {
		String [] titles = new ExportUtility().titlesEstratto;
		Workbook wb = ApplicationUtil.workbookS();
		ExcelStyle s = new ExcelStyle(wb);
		Sheet sheet = wb.createSheet(ConstantsLanguage.ESTRATTI.stampa());
		int k = 0;
		Row row = sheet.createRow(k++);
		for(int i = 0; i < titles.length; i++) {
			Cell cell = row.createCell(i, CellType.STRING);
			ApplicationUtil.headerCell(s, cell,  titles[i]);
		}
		sheet.setAutoFilter(new CellRangeAddress(0, 0, 0, titles.length-1));
		sheet.createFreezePane(0, 1);
		Iterator<Estratto> objIter = data.iterator();
		while(objIter.hasNext()) {
			Estratto prd = objIter.next();
			row = sheet.createRow(k++);
			ExcelFormatList lista = new ExcelFormatList();
			lista.addValore(prd.getId().toString());
			lista.addValore(prd.getUser().getDenominazione());
			lista.addValore(ConstantsFormat.dateTime.stampa(), prd.getData_creazione());
			lista.addValore(ConstantsFormat.dateTime.stampa(), prd.getData_estratto());
			lista.addValore(prd.getTotale());
			lista.addValore(prd.getNdettagli());
			for (int j = 0; j < lista.size(); j++) {
				ExcelFormat el = lista.get(j);
				Cell cell = row.createCell(j, el.getCellType());
				ApplicationUtil.cellStamper(s, cell, el);
			}
		}
		sheet.setDefaultColumnWidth(20);
		ApplicationUtil.passwordXLS(wb, result, password);
		
	}
	
	
	public static void esportaExcelEstrattoAnteprima(List<Estratto> data, OutputStream result, String password) throws Exception {
		String [] titles = new ExportUtility().titlesEstrattoA;
		Workbook wb = ApplicationUtil.workbookS();
		ExcelStyle s = new ExcelStyle(wb);
		Sheet sheet = wb.createSheet(ConstantsLanguage.ESTRATTI.stampa());
		int k = 0;
		Row row = sheet.createRow(k++);
		for(int i = 0; i < titles.length; i++) {
			Cell cell = row.createCell(i, CellType.STRING);
			ApplicationUtil.headerCell(s, cell,  titles[i]);
		}
		sheet.setAutoFilter(new CellRangeAddress(0, 0, 0, titles.length-1));
		sheet.createFreezePane(0, 1);
		Iterator<Estratto> objIter = data.iterator();
		while(objIter.hasNext()) {
			Estratto prd = objIter.next();
			row = sheet.createRow(k++);
			ExcelFormatList lista = new ExcelFormatList();
			lista.addValore(prd.getUser().getDenominazione());
			lista.addValore(ConstantsFormat.dateTime.stampa(), prd.getData_creazione());
			lista.addValore(ConstantsFormat.dateTime.stampa(), prd.getData_estratto());
			lista.addValore(prd.getTotale());
			lista.addValore(prd.getNdettagli());
			for (int j = 0; j < lista.size(); j++) {
				ExcelFormat el = lista.get(j);
				Cell cell = row.createCell(j, el.getCellType());
				ApplicationUtil.cellStamper(s, cell, el);
			}
		}
		sheet.setDefaultColumnWidth(20);
		ApplicationUtil.passwordXLS(wb, result, password);
		
	}
	public static void esportaExcelAcconto(List<Acconto> data, OutputStream result, String password) throws Exception {
		String [] titles = new ExportUtility().titlesAcconto;
		Workbook wb = ApplicationUtil.workbookS();
		ExcelStyle s = new ExcelStyle(wb);
		Sheet sheet = wb.createSheet(ConstantsLanguage.ACCONTI.stampa());
		int k = 0;
		Row row = sheet.createRow(k++);
		for(int i = 0; i < titles.length; i++) {
			Cell cell = row.createCell(i, CellType.STRING);
			ApplicationUtil.headerCell(s, cell,  titles[i]);
		}
		sheet.setAutoFilter(new CellRangeAddress(0, 0, 0, titles.length-1));
		sheet.createFreezePane(0, 1);
		Iterator<Acconto> objIter = data.iterator();
		while(objIter.hasNext()) {
			Acconto prd = objIter.next();
			row = sheet.createRow(k++);
			ExcelFormatList lista = new ExcelFormatList();
			lista.addValore(prd.getId().toString());
			lista.addValore(prd.getUser().getDenominazione());
			lista.addValore(ConstantsFormat.dateTime.stampa(), prd.getData_creazione());
			lista.addValore(ConstantsFormat.dateTime.stampa(), prd.getData_acconto());
			lista.addValore(prd.getDescrizione());
			lista.addValore(prd.getImporto());
			lista.addValore(prd.getTipoTesto());
			for (int j = 0; j < lista.size(); j++) {
				ExcelFormat el = lista.get(j);
				Cell cell = row.createCell(j, el.getCellType());
				ApplicationUtil.cellStamper(s, cell, el);
			}
		}
		sheet.setDefaultColumnWidth(20);
		ApplicationUtil.passwordXLS(wb, result, password);
		
	}
	public static void esportaExcelDettagli(List<EstrattoDettaglio> data, OutputStream result, String password) throws Exception {
		String [] titles = new ExportUtility().titlesEstrattoDettaglio;
		Workbook wb = ApplicationUtil.workbookS();
		ExcelStyle s = new ExcelStyle(wb);
		Sheet sheet = wb.createSheet(ConstantsLanguage.ESTRATTI_DETTAGLIO.stampa());
		int k = 0;
		Row row = sheet.createRow(k++);
		for(int i = 0; i < titles.length; i++) {
			Cell cell = row.createCell(i, CellType.STRING);
			ApplicationUtil.headerCell(s, cell,  titles[i]);
		}
		sheet.setAutoFilter(new CellRangeAddress(0, 0, 0, titles.length-1));
		sheet.createFreezePane(0, 1);
		Iterator<EstrattoDettaglio> objIter = data.iterator();
		while(objIter.hasNext()) {
			EstrattoDettaglio prd = objIter.next();
			row = sheet.createRow(k++);
			ExcelFormatList lista = new ExcelFormatList();
			lista.addValore(prd.getId().toString());
			lista.addValore(prd.getDescrizione());
			lista.addValore(prd.getGettone());
			lista.addValore(prd.getValore());
			lista.addValore(prd.getImporto());
			for (int j = 0; j < lista.size(); j++) {
				ExcelFormat el = lista.get(j);
				Cell cell = row.createCell(j, el.getCellType());
				ApplicationUtil.cellStamper(s, cell, el);
			}
		}
		sheet.setDefaultColumnWidth(20);
		ApplicationUtil.passwordXLS(wb, result, password);
		
	}
	
	public static void esportaExcelDettagliAnteprima(List<EstrattoDettaglio> data, OutputStream result, String password) throws Exception {
		String [] titles = new ExportUtility().titlesEstrattoDettaglioA;
		Workbook wb = ApplicationUtil.workbookS();
		ExcelStyle s = new ExcelStyle(wb);
		Sheet sheet = wb.createSheet(ConstantsLanguage.ESTRATTI_DETTAGLIO.stampa());
		int k = 0;
		Row row = sheet.createRow(k++);
		for(int i = 0; i < titles.length; i++) {
			Cell cell = row.createCell(i, CellType.STRING);
			ApplicationUtil.headerCell(s, cell,  titles[i]);
		}
		sheet.setAutoFilter(new CellRangeAddress(0, 0, 0, titles.length-1));
		sheet.createFreezePane(0, 1);
		Iterator<EstrattoDettaglio> objIter = data.iterator();
		while(objIter.hasNext()) {
			EstrattoDettaglio prd = objIter.next();
			row = sheet.createRow(k++);
			ExcelFormatList lista = new ExcelFormatList();
			lista.addValore(prd.getDescrizione());
			lista.addValore(prd.getGettone());
			lista.addValore(prd.getValore());
			lista.addValore(prd.getImporto());
			for (int j = 0; j < lista.size(); j++) {
				ExcelFormat el = lista.get(j);
				Cell cell = row.createCell(j, el.getCellType());
				ApplicationUtil.cellStamper(s, cell, el);
			}
		}
		sheet.setDefaultColumnWidth(20);
		ApplicationUtil.passwordXLS(wb, result, password);
		
	}
	public static void esportaExcelAgente(List<Agente> data, OutputStream result, String password) throws Exception {
		String [] titles = new ExportUtility().titlesAgente;
		Workbook wb = ApplicationUtil.workbookS();
		ExcelStyle s = new ExcelStyle(wb);
		Sheet sheet = wb.createSheet(ConstantsLanguage.AGENTI.stampa());
		int k = 0;
		Row row = sheet.createRow(k++);
		for(int i = 0; i < titles.length; i++) {
			Cell cell = row.createCell(i, CellType.STRING);
			ApplicationUtil.headerCell(s, cell,  titles[i]);
		}
		sheet.setAutoFilter(new CellRangeAddress(0, 0, 0, titles.length-1));
		sheet.createFreezePane(0, 1);
		Iterator<Agente> objIter = data.iterator();
		while(objIter.hasNext()) {
			Agente prd = objIter.next();
			row = sheet.createRow(k++);
			ExcelFormatList lista = new ExcelFormatList();
			lista.addValore(prd.getId().toString());
			lista.addValore(prd.getDenominazione());
			lista.addValore(prd.getCodice());
			lista.addValore(prd.getUfficioNome());
			lista.addValore(prd.getQualificaNome());
			lista.addValore(prd.getCognome());
			lista.addValore(prd.getNome());
			lista.addValore(prd.getEmail());
			lista.addValore(prd.getLink());
			lista.addValore(prd.getCodice_fiscale());
			lista.addValore(prd.getPartita_iva());
			lista.addValore(prd.getTelefono_fisso());
			lista.addValore(prd.getTelefono_mobile());
			lista.addValore(prd.getTelefono_fax());
			lista.addValore(prd.getTelefono_altro());
			lista.addValore(prd.getRagione_sociale());
			lista.addValore(prd.getNome_completo());
			lista.addValore(ConstantsFormat.date.stampa(), prd.getDate_nascita());
			lista.addValore(prd.getLuogo_nascita());
			lista.addValore(prd.getTipo());
			lista.addValore(prd.getSesso());
			lista.addValore(prd.getIndirizzo_legale().getIndirizzo_completo());
			lista.addValore(prd.getIndirizzo_operativo().getIndirizzo_completo());
			for (int j = 0; j < lista.size(); j++) {
				ExcelFormat el = lista.get(j);
				Cell cell = row.createCell(j, el.getCellType());
				ApplicationUtil.cellStamper(s, cell, el);
			}
		}
		sheet.setDefaultColumnWidth(20);
		ApplicationUtil.passwordXLS(wb, result, password);
		
	}
	public static void esportaExcelAnagrafica(List<Anagrafica> data, OutputStream result, String password) throws Exception {
		String [] titles = new ExportUtility().titlesAnagrafica;
		Workbook wb = ApplicationUtil.workbookS();
		ExcelStyle s = new ExcelStyle(wb);
		Sheet sheet = wb.createSheet(ConstantsLanguage.ANAGRAFICHE.stampa());
		int k = 0;
		Row row = sheet.createRow(k++);
		for(int i = 0; i < titles.length; i++) {
			Cell cell = row.createCell(i, CellType.STRING);
			ApplicationUtil.headerCell(s, cell,  titles[i]);
		}
		sheet.setAutoFilter(new CellRangeAddress(0, 0, 0, titles.length-1));
		sheet.createFreezePane(0, 1);
		Iterator<Anagrafica> objIter = data.iterator();
		while(objIter.hasNext()) {
			Anagrafica prd = objIter.next();
			row = sheet.createRow(k++);
			ExcelFormatList lista = new ExcelFormatList();
			lista.addValore(prd.getId() != null ? prd.getId().toString() : "");
			lista.addValore(prd.getDenominazione());
			lista.addValore(prd.getCognome());
			lista.addValore(prd.getNome());
			lista.addValore(prd.getEmail());
			lista.addValore(prd.getLink());
			lista.addValore(prd.getCodice_fiscale());
			lista.addValore(prd.getPartita_iva());
			lista.addValore(prd.getTelefono_fisso());
			lista.addValore(prd.getTelefono_mobile());
			lista.addValore(prd.getTelefono_fax());
			lista.addValore(prd.getTelefono_altro());
			lista.addValore(prd.getRagione_sociale());
			lista.addValore(prd.getNome_completo());
			lista.addValore(ConstantsFormat.date.stampa(), prd.getDate_nascita());
			lista.addValore(prd.getLuogo_nascita());
			lista.addValore(prd.getTipo());
			lista.addValore(prd.getSesso());
			lista.addValore(prd.getNota());
			lista.addValore(prd.getSettore());
			lista.addValore(ConstantsFormat.dateTime.stampa(), prd.getConsenso_tfisso());
			lista.addValore(ConstantsFormat.dateTime.stampa(), prd.getConsenso_tmobile());
			lista.addValore(ConstantsFormat.dateTime.stampa(), prd.getConsenso_tfax());
			lista.addValore(ConstantsFormat.dateTime.stampa(), prd.getConsenso_taltro());
			lista.addValore(ConstantsFormat.dateTime.stampa(), prd.getConsenso_email());
			lista.addValore(ConstantsFormat.dateTime.stampa(), prd.getConsenso_rmail());
			lista.addValore(prd.getIndirizzo_legale().getIndirizzo_completo());
			lista.addValore(prd.getIndirizzo_operativo().getIndirizzo_completo());
			for (int j = 0; j < lista.size(); j++) {
				ExcelFormat el = lista.get(j);
				Cell cell = row.createCell(j, el.getCellType());
				ApplicationUtil.cellStamper(s, cell, el);
			}
		}
		sheet.setDefaultColumnWidth(20);
		ApplicationUtil.passwordXLS(wb, result, password);
		
	}
	public static void esportaExcelPrenotazione(List<Prenotazione> data, OutputStream result, String password) throws Exception {
		String [] titles = new ExportUtility().titlesPrenotazione;
		Workbook wb = ApplicationUtil.workbookS();
		ExcelStyle s = new ExcelStyle(wb);
		Sheet sheet = wb.createSheet(ConstantsLanguage.PRENOTAZIONI.stampa());
		int k = 0;
		Row row = sheet.createRow(k++);
		for(int i = 0; i < titles.length; i++) {
			Cell cell = row.createCell(i, CellType.STRING);
			ApplicationUtil.headerCell(s, cell,  titles[i]);
		}
		sheet.setAutoFilter(new CellRangeAddress(0, 0, 0, titles.length-1));
		sheet.createFreezePane(0, 1);
		Iterator<Prenotazione> objIter = data.iterator();
		while(objIter.hasNext()) {
			Prenotazione prd = objIter.next();
			row = sheet.createRow(k++);
			ExcelFormatList lista = new ExcelFormatList();
			lista.addValore(prd.getId().toString());
			lista.addValore(ConstantsFormat.dateTime.stampa(), prd.getData_creazione());
			lista.addValore(prd.getBloccatoS());
			lista.addValore(prd.getCampagna_denominazione());
			lista.addValore(prd.getLista_denominazione());
			lista.addValore(prd.getOperatore().getDenominazione());
			lista.addValore(prd.getAgente_denominazione());
			lista.addValore(prd.getStatoString());
			lista.addValore(prd.getTipo_telefonoString());	
			lista.addValore(prd.getTelefono());
			for (int j = 0; j < lista.size(); j++) {
				ExcelFormat el = lista.get(j);
				Cell cell = row.createCell(j, el.getCellType());
				ApplicationUtil.cellStamper(s, cell, el);
			}
		}
		sheet.setDefaultColumnWidth(20);
		ApplicationUtil.passwordXLS(wb, result, password);
		
	}
	public static void esportaExcelContatto(List<Contatto> data, OutputStream result, String password) throws Exception {
		String [] titles = new ExportUtility().titlesContatto;
		Workbook wb = ApplicationUtil.workbookS();
		ExcelStyle s = new ExcelStyle(wb);
		Sheet sheet = wb.createSheet(ConstantsLanguage.CONTATTI.stampa());
		int k = 0;
		Row row = sheet.createRow(k++);
		for(int i = 0; i < titles.length; i++) {
			Cell cell = row.createCell(i, CellType.STRING);
			ApplicationUtil.headerCell(s, cell,  titles[i]);
		}
		sheet.setAutoFilter(new CellRangeAddress(0, 0, 0, titles.length-1));
		sheet.createFreezePane(0, 1);
		Iterator<Contatto> objIter = data.iterator();
		while(objIter.hasNext()) {
			Contatto prd = objIter.next();
			row = sheet.createRow(k++);
			ExcelFormatList lista = new ExcelFormatList();
			lista.addValore(prd.getId().toString());
			lista.addValore(ConstantsFormat.dateTime.stampa(), prd.getData_creazione());
			lista.addValore(prd.getBloccatoS());
			lista.addValore(prd.getCampagna_denominazione());
			lista.addValore(prd.getLista_denominazione());
			lista.addValore(prd.getAnagrafica().getDenominazione());
			lista.addValore(prd.getAnagrafica().getCognome());
			lista.addValore(prd.getAnagrafica().getNome());
			lista.addValore(prd.getAnagrafica().getEmail());
			lista.addValore(prd.getAnagrafica().getLink());
			lista.addValore(prd.getAnagrafica().getCodice_fiscale());
			lista.addValore(prd.getAnagrafica().getPartita_iva());
			lista.addValore(prd.getAnagrafica().getTelefono_fisso());
			lista.addValore(prd.getAnagrafica().getTelefono_mobile());
			lista.addValore(prd.getAnagrafica().getTelefono_fax());
			lista.addValore(prd.getAnagrafica().getTelefono_altro());
			lista.addValore(ConstantsFormat.dateTime.stampa(), prd.getData_archiviazione());
			lista.addValore(prd.getEsito_chiamata_etichettaCodice());
			lista.addValore(prd.getEsito_archiviazione_etichettaCodice());
			lista.addValore(prd.getPositivo());
			lista.addValore(prd.getUtile());
			lista.addValore(prd.getChiuso());
			lista.addValore(prd.getProprietario_denominazione());
			lista.addValore(ConstantsFormat.dateTime.stampa(), prd.getData_presentazione());
			lista.addValore(ConstantsFormat.dateTime.stampa(), prd.getData_lavorazione());
			lista.addValore(prd.getOperatore_denominazione());
			lista.addValore(prd.getNota());
			lista.addValore(prd.getAgente_denominazione());
			lista.addValore(prd.getTipoTesto());
			lista.addValore(prd.getAnagrafica().getIndirizzo_legale().getIndirizzo_completo());
			lista.addValore(prd.getAnagrafica().getIndirizzo_operativo().getIndirizzo_completo());
			for (int j = 0; j < lista.size(); j++) {
				ExcelFormat el = lista.get(j);
				Cell cell = row.createCell(j, el.getCellType());
				ApplicationUtil.cellStamper(s, cell, el);
			}
		}
		sheet.setDefaultColumnWidth(20);
		ApplicationUtil.passwordXLS(wb, result, password);
		
	}
	public static void esportaExcelChiamate(CopyOnWriteArrayList<AutoContatto> data, OutputStream result, String password) throws Exception {
		String [] titles = new ExportUtility().titlesChiamate;
		Workbook wb = ApplicationUtil.workbookS();
		ExcelStyle s = new ExcelStyle(wb);
		Sheet sheet = wb.createSheet(ConstantsLanguage.AUTO_CONTATTI.stampa());
		int k = 0;
		Row row = sheet.createRow(k++);
		for(int i = 0; i < titles.length; i++) {
			Cell cell = row.createCell(i, CellType.STRING);
			ApplicationUtil.headerCell(s, cell,  titles[i]);
		}
		sheet.setAutoFilter(new CellRangeAddress(0, 0, 0, titles.length-1));
		sheet.createFreezePane(0, 1);
		Iterator<AutoContatto> objIter = data.iterator();
		while(objIter.hasNext()) {
			AutoContatto prd = objIter.next();
			row = sheet.createRow(k++);
			ExcelFormatList lista = new ExcelFormatList();
			lista.addValore(prd.getContatto_id().toString());
			lista.addValore(prd.getCampagna_denominazione());
			lista.addValore(prd.getLista_denominazione());
			lista.addValore(ConstantsFormat.dateSeconds.stampa(), prd.getData());
			lista.addValore(prd.getAnagrafica_denominazione());
			lista.addValore(prd.getTelefono());
			lista.addValore(prd.getCaller1());
			lista.addValore(prd.getCallee1());
			lista.addValore(prd.getCaller2());
			lista.addValore(prd.getCallee2());
			lista.addValore(prd.getRingingS());
			lista.addValore(prd.getInboundS());
			lista.addValore(Message.addCatalogText(prd.getStatoContatto()));
			lista.addValore(prd.getCause());
			lista.addValore(prd.getTentativi());
			lista.addValore(ConstantsFormat.dateSeconds.stampa(), prd.getData_avvio());
			lista.addValore(ConstantsFormat.dateSeconds.stampa(), prd.getData_chiamata());
			lista.addValore(ConstantsFormat.dateSeconds.stampa(), prd.getData_risposta());
			lista.addValore(ConstantsFormat.dateSeconds.stampa(), prd.getData_gestione());
			lista.addValore(ConstantsFormat.dateSeconds.stampa(), prd.getData_attesa());
			lista.addValore(ConstantsFormat.dateSeconds.stampa(), prd.getData_aggancio());
			lista.addValore(ConstantsFormat.dateSeconds.stampa(), prd.getData_rifiuto());
			lista.addValore(ConstantsFormat.dateSeconds.stampa(), prd.getData_link());
			for (int j = 0; j < lista.size(); j++) {
				ExcelFormat el = lista.get(j);
				Cell cell = row.createCell(j, el.getCellType());
				ApplicationUtil.cellStamper(s, cell, el);
			}
		}
		sheet.setDefaultColumnWidth(20);
		ApplicationUtil.passwordXLS(wb, result, password);
		
	}
	public static void esportaExcelAnagraficaTemplate(List<Anagrafica> data, AnagraficaDao anagraficaDao, TemplateExportAnagrafica ti, OutputStream result, String password) throws Exception {
		List <String> titlesList = ti.getValore_multiplo();
		List <String> aggiuntivi = ListUtils.subtract(titlesList, new ArrayList<String>(ConstantsMap.anagraficaMap));
		if(ApplicationUtil.notEmpty(aggiuntivi)) {
			data = anagraficaDao.loadFullAnagrafica(data);
		}
		String[] titles = titlesList.toArray(new String[0]);
		Workbook wb = ApplicationUtil.workbookS();
		ExcelStyle s = new ExcelStyle(wb);
		Sheet sheet = wb.createSheet(ConstantsLanguage.ANAGRAFICHE.stampa());
		int k = 0;
		Row row = null;
		if(ti.getIntestazione()) {
			row = sheet.createRow(k++);
			for (int i = 0; i < titles.length; i++) {
				Cell cell = row.createCell(i, CellType.STRING);
				if(ApplicationUtil.notEmpty(aggiuntivi) && aggiuntivi.contains(titles[i])) {
					String etichetta = anagraficaDao.getEtichettaByChiave(CampoAggiuntivoAnagrafica.class, titles[i]);
					ApplicationUtil.headerCell(s, cell,  etichetta);
				} else {
					ApplicationUtil.headerCell(s, cell,  Message.addCatalogText(titles[i]));
				}
			}
			sheet.setAutoFilter(new CellRangeAddress(0, 0, 0, titles.length-1));
			sheet.createFreezePane(0, 1);
		} else {
			row = sheet.createRow(k);
		}
		Iterator<Anagrafica> objIter = data.iterator();
		while(objIter.hasNext()) {
			Anagrafica prd = objIter.next();
			row = sheet.createRow(k++);
			ExcelFormatList lista = new ExcelFormatList();
			for (int j = 0; j < titles.length; j++) {
				if(ti.getPosizione(ConstantsMap.anagrafica_cognome).equals(j)) {
					lista.addValore(prd.getCognome());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_nome).equals(j)) {
					lista.addValore(prd.getNome());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_nome_completo).equals(j)) {
					lista.addValore(prd.getNome_completo());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_email).equals(j)) {
					lista.addValore(prd.getEmail());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_codice_fiscale).equals(j)) {
					lista.addValore(prd.getCodice_fiscale());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_sorgente).equals(j)) {
					lista.addValore(prd.getSorgente());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_nota).equals(j)) {
					lista.addValore(prd.getNota());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_luogo_nascita).equals(j)) {
					lista.addValore(prd.getLuogo_nascita());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_data_nascita).equals(j)) {
					lista.addValore(ConstantsFormat.date.stampa(), prd.getDate_nascita());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_link).equals(j)) {
					lista.addValore(prd.getLink());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_data_inserimento).equals(j)) {
					lista.addValore(ConstantsFormat.dateTime.stampa(), prd.getData_creazione());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_privacy).equals(j)) {
					lista.addValore(prd.getPrivacy());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_tipo).equals(j)) {
					lista.addValore(prd.getTipo());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_sesso).equals(j)) {
					lista.addValore(prd.getSesso());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_partita_iva).equals(j)) {
					lista.addValore(prd.getPartita_iva());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_ragione_sociale).equals(j)) {
					lista.addValore(prd.getRagione_sociale());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_telefono_fisso).equals(j)) {
					lista.addValore(ApplicationUtil.uniforma(prd.getTelefono_fisso(), ti.getRem_fisso(), ti.getAdd_fisso()));
				} else if(ti.getPosizione(ConstantsMap.anagrafica_telefono_altro).equals(j)) {
					lista.addValore(ApplicationUtil.uniforma(prd.getTelefono_altro(), ti.getRem_altro(), ti.getAdd_altro()));
				} else if(ti.getPosizione(ConstantsMap.anagrafica_telefono_mobile).equals(j)) {
					lista.addValore(ApplicationUtil.uniforma(prd.getTelefono_mobile(), ti.getRem_mobile(), ti.getAdd_mobile()));
				} else if(ti.getPosizione(ConstantsMap.anagrafica_telefono_fax).equals(j)) {
					lista.addValore(ApplicationUtil.uniforma(prd.getTelefono_fax(), ti.getRem_fax(), ti.getAdd_fax()));
				} else if(ti.getPosizione(ConstantsMap.anagrafica_settore).equals(j)) {
					lista.addValore(prd.getSettore());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_denominazione).equals(j)) {
					lista.addValore(prd.getDenominazione());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_id).equals(j)) {
					lista.addValore(prd.getIdentificativo());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_indirizzo_completo).equals(j)) {
					lista.addValore(prd.getIndirizzo_legale().getIndirizzo_completo());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_strada_completo).equals(j)) {
					lista.addValore(prd.getIndirizzo_legale().getStrada_completo());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_comune_completo).equals(j)) {
					lista.addValore(prd.getIndirizzo_legale().getComune_completo());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_strada).equals(j)) {
					lista.addValore(prd.getIndirizzo_legale().getStrada());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_civico).equals(j)) {
					lista.addValore(prd.getIndirizzo_legale().getCivico());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_cap).equals(j)) {
					lista.addValore(prd.getIndirizzo_legale().getCap());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_comune).equals(j)) {
					lista.addValore(prd.getIndirizzo_legale().getComune());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_provincia).equals(j)) {
					lista.addValore(prd.getIndirizzo_legale().getProvincia());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_regione).equals(j)) {
					lista.addValore(prd.getIndirizzo_legale().getRegione());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_dettagli).equals(j)) {
					lista.addValore(prd.getIndirizzo_legale().getDettagli());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_latitudine).equals(j)) {
					lista.addValore(prd.getIndirizzo_legale().getLatitudine());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_longitudine).equals(j)) {
					lista.addValore(prd.getIndirizzo_legale().getLongitudine());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_presso).equals(j)) {
					lista.addValore(prd.getIndirizzo_legale().getPresso());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_indirizzo_completo).equals(j)) {
					lista.addValore(prd.getIndirizzo_operativo().getIndirizzo_completo());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_strada_completo).equals(j)) {
					lista.addValore(prd.getIndirizzo_operativo().getStrada_completo());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_comune_completo).equals(j)) {
					lista.addValore(prd.getIndirizzo_operativo().getComune_completo());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_strada).equals(j)) {
					lista.addValore(prd.getIndirizzo_operativo().getStrada());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_civico).equals(j)) {
					lista.addValore(prd.getIndirizzo_operativo().getCivico());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_cap).equals(j)) {
					lista.addValore(prd.getIndirizzo_operativo().getCap());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_comune).equals(j)) {
					lista.addValore(prd.getIndirizzo_operativo().getComune());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_provincia).equals(j)) {
					lista.addValore(prd.getIndirizzo_operativo().getProvincia());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_regione).equals(j)) {
					lista.addValore(prd.getIndirizzo_operativo().getRegione());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_dettagli).equals(j)) {
					lista.addValore(prd.getIndirizzo_operativo().getDettagli());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_latitudine).equals(j)) {
					lista.addValore(prd.getIndirizzo_operativo().getLatitudine());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_longitudine).equals(j)) {
					lista.addValore(prd.getIndirizzo_operativo().getLongitudine());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_presso).equals(j)) {
					lista.addValore(prd.getIndirizzo_operativo().getPresso());
				} else if(ti.getPosizione(ConstantsMap.consenso_tfissoS).equals(j)) {
					lista.addValore(ConstantsFormat.dateTime.stampa(), prd.getConsenso_tfisso());
				} else if(ti.getPosizione(ConstantsMap.consenso_tmobileS).equals(j)) {
					lista.addValore(ConstantsFormat.dateTime.stampa(), prd.getConsenso_tmobile());
				} else if(ti.getPosizione(ConstantsMap.consenso_tfaxS).equals(j)) {
					lista.addValore(ConstantsFormat.dateTime.stampa(), prd.getConsenso_tfax());
				} else if(ti.getPosizione(ConstantsMap.consenso_taltroS).equals(j)) {
					lista.addValore(ConstantsFormat.dateTime.stampa(), prd.getConsenso_taltro());
				} else if(ti.getPosizione(ConstantsMap.consenso_emailS).equals(j)) {
					lista.addValore(ConstantsFormat.dateTime.stampa(), prd.getConsenso_email());
				} else if(ti.getPosizione(ConstantsMap.consenso_rmailS).equals(j)) {
					lista.addValore(ConstantsFormat.dateTime.stampa(), prd.getConsenso_rmail());
				} else {
					stampaDato(lista, titles[j], prd.getDettagli(), null);
				}
			}
			for (int j = 0; j < lista.size(); j++) {
				ExcelFormat el = lista.get(j);
				Cell cell = row.createCell(j, el.getCellType());
				ApplicationUtil.cellStamper(s, cell, el);
			}
		}
		sheet.setDefaultColumnWidth(20);
		ApplicationUtil.passwordXLS(wb, result, password);
		
	}
	public static void esportaExcelContattoTemplate(Boolean p, List<Contatto> data, AnagraficaDao anagraficaDao, TemplateExportContatto ti, OutputStream result, String password) throws Exception {
		List <String> titlesList = ti.getValore_multiplo();
		List <String> aggiuntivi = ListUtils.subtract(titlesList, new ArrayList<String>(ConstantsMap.contattoMap));
		if(p!=null && ApplicationUtil.notEmpty(aggiuntivi)) {
			List <String> invA = anagraficaDao.getEtichetteInvisibiliByChiave(p, CampoAggiuntivoAnagrafica.class);
			aggiuntivi.removeAll(invA);
			titlesList.removeAll(invA);
		}
		if(ApplicationUtil.notEmpty(aggiuntivi)) {
			data = anagraficaDao.loadFullContatto(data);
		}
		String[] titles = titlesList.toArray(new String[0]);
		Workbook wb = ApplicationUtil.workbookS();
		ExcelStyle s = new ExcelStyle(wb);
		Sheet sheet = wb.createSheet(ConstantsLanguage.CONTATTI.stampa());
		int k = 0;
		Row row = null;
		if(ti.getIntestazione()) {
			row = sheet.createRow(k++);
			for (int i = 0; i < titles.length; i++) {
				Cell cell = row.createCell(i, CellType.STRING);
				if(ApplicationUtil.notEmpty(aggiuntivi) && aggiuntivi.contains(titles[i])) {
					String etichetta = anagraficaDao.getEtichettaByChiave(CampoAggiuntivoAnagrafica.class, titles[i]);
					ApplicationUtil.headerCell(s, cell,  etichetta);
				} else {
					ApplicationUtil.headerCell(s, cell,  Message.addCatalogText(titles[i]));
				}
			}
			sheet.setAutoFilter(new CellRangeAddress(0, 0, 0, titles.length-1));
			sheet.createFreezePane(0, 1);
		} else {
			row = sheet.createRow(k);
		}
		Iterator<Contatto> objIter = data.iterator();
		while(objIter.hasNext()) {
			Contatto cnt = objIter.next();
			row = sheet.createRow(k++);
			ExcelFormatList lista = new ExcelFormatList();
			for (int j = 0; j < titles.length; j++) {
				if(ti.getPosizione(ConstantsMap.contatto_data_archiviazione).equals(j)) {
					lista.addValore(ConstantsFormat.dateTime.stampa(), cnt.getData_archiviazione());
				} else if(ti.getPosizione(ConstantsMap.contatto_esito_chiamata).equals(j)) {
					lista.addValore(cnt.getEsito_chiamata());
				} else if(ti.getPosizione(ConstantsMap.contatto_esito_archiviazione).equals(j)) {
					lista.addValore(cnt.getEsito_archiviazione());
				} else if(ti.getPosizione(ConstantsMap.contatto_esito_generale).equals(j)) {
					lista.addValore(cnt.getEsito_generale());
				} else if(ti.getPosizione(ConstantsMap.contatto_codice_chiamata).equals(j)) {
					lista.addValore(cnt.getCodice_chiamata());
				} else if(ti.getPosizione(ConstantsMap.contatto_codice_archiviazione).equals(j)) {
					lista.addValore(cnt.getCodice_archiviazione());
				} else if(ti.getPosizione(ConstantsMap.contatto_codice_generale).equals(j)) {
					lista.addValore(cnt.getCodice_generale());
				} else if(ti.getPosizione(ConstantsMap.contatto_data_lavorazione).equals(j)) {
					lista.addValore(ConstantsFormat.dateTime.stampa(), cnt.getData_lavorazione());
				} else if(ti.getPosizione(ConstantsMap.contatto_operatore_denominazione).equals(j)) {
					lista.addValore(cnt.getOperatore_denominazione());
				} else if(ti.getPosizione(ConstantsMap.contatto_operatore_codice).equals(j)) {
					lista.addValore(cnt.getOperatore_codice());
				} else if(ti.getPosizione(ConstantsMap.contatto_proprietario_denominazione).equals(j)) {
					lista.addValore(cnt.getProprietario_denominazione());
				} else if(ti.getPosizione(ConstantsMap.contatto_proprietario_codice).equals(j)) {
					lista.addValore(cnt.getProprietario_codice());
				} else if(ti.getPosizione(ConstantsMap.contatto_data_presentazione).equals(j)) {
					lista.addValore(ConstantsFormat.dateTime.stampa(), cnt.getData_presentazione());
				} else if(ti.getPosizione(ConstantsMap.contatto_nota).equals(j)) {
					lista.addValore(cnt.getNota());
				} else if(ti.getPosizione(ConstantsMap.contatto_data_creazione).equals(j)) {
					lista.addValore(ConstantsFormat.dateTime.stampa(), cnt.getData_creazione());
				} else if(ti.getPosizione(ConstantsMap.contatto_agente_denominazione).equals(j)) {
					lista.addValore(cnt.getAgente_denominazione());
				} else if(ti.getPosizione(ConstantsMap.contatto_agente_codice).equals(j)) {
					lista.addValore(cnt.getAgente_codice());
				} else if(ti.getPosizione(ConstantsMap.contatto_stato).equals(j)) {
					lista.addValore(cnt.getTipoTesto());
				} else if(ti.getPosizione(ConstantsMap.contatto_id).equals(j)) {
					lista.addValore(cnt.getId().toString());
				} else if(ti.getPosizione(ConstantsMap.contatto_campagna_denominazione).equals(j)) {
					lista.addValore(cnt.getCampagna_denominazione());
				} else if(ti.getPosizione(ConstantsMap.contatto_lista_denominazione).equals(j)) {
					lista.addValore(cnt.getLista_denominazione());
				} else if(ti.getPosizione(ConstantsMap.contatto_campagna_codice).equals(j)) {
					lista.addValore(cnt.getCampagna_codice());
				} else if(ti.getPosizione(ConstantsMap.contatto_bloccato).equals(j)) {
					lista.addValore(cnt.getBloccatoS());
				} else if(ti.getPosizione(ConstantsMap.contatto_lista_codice).equals(j)) {
					lista.addValore(cnt.getLista_codice());
				} else if(ti.getPosizione(ConstantsMap.contatto_positivo).equals(j)) {
					lista.addValore(cnt.getPositivo());
				} else if(ti.getPosizione(ConstantsMap.contatto_telefono_predefinito).equals(j)) {
					lista.addValore(ApplicationUtil.uniforma(cnt.getTelefono_predefinito(), ti.getRem_predefinito(), ti.getAdd_predefinito()));
				} else if(ti.getPosizione(ConstantsMap.contatto_utile).equals(j)) {
					lista.addValore(cnt.getUtile());
				} else if(ti.getPosizione(ConstantsMap.contatto_chiuso).equals(j)) {
					lista.addValore(cnt.getChiuso());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_cognome).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getCognome());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_nome).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getNome());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_nome_completo).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getNome_completo());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_email).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getEmail());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_codice_fiscale).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getCodice_fiscale());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_sorgente).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getSorgente());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_nota).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getNota());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_luogo_nascita).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getLuogo_nascita());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_data_nascita).equals(j)) {
					lista.addValore(ConstantsFormat.date.stampa(), cnt.getAnagrafica().getDate_nascita());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_link).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getLink());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_data_inserimento).equals(j)) {
					lista.addValore(ConstantsFormat.dateTime.stampa(), cnt.getAnagrafica().getData_creazione());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_privacy).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getPrivacy());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_tipo).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getTipo());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_sesso).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getSesso());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_partita_iva).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getPartita_iva());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_ragione_sociale).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getRagione_sociale());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_telefono_fisso).equals(j)) {
					lista.addValore(ApplicationUtil.uniforma(cnt.getAnagrafica().getTelefono_fisso(), ti.getRem_fisso(), ti.getAdd_fisso()));
				} else if(ti.getPosizione(ConstantsMap.anagrafica_telefono_altro).equals(j)) {
					lista.addValore(ApplicationUtil.uniforma(cnt.getAnagrafica().getTelefono_altro(), ti.getRem_altro(), ti.getAdd_altro()));
				} else if(ti.getPosizione(ConstantsMap.anagrafica_telefono_mobile).equals(j)) {
					lista.addValore(ApplicationUtil.uniforma(cnt.getAnagrafica().getTelefono_mobile(), ti.getRem_mobile(), ti.getAdd_mobile()));
				} else if(ti.getPosizione(ConstantsMap.anagrafica_telefono_fax).equals(j)) {
					lista.addValore(ApplicationUtil.uniforma(cnt.getAnagrafica().getTelefono_fax(), ti.getRem_fax(), ti.getAdd_fax()));
				} else if(ti.getPosizione(ConstantsMap.anagrafica_settore).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getSettore());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_denominazione).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getDenominazione());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_id).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIdentificativo());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_indirizzo_completo).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_legale().getIndirizzo_completo());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_strada_completo).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_legale().getStrada_completo());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_comune_completo).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_legale().getComune_completo());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_strada).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_legale().getStrada());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_civico).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_legale().getCivico());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_cap).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_legale().getCap());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_comune).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_legale().getComune());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_provincia).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_legale().getProvincia());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_regione).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_legale().getRegione());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_dettagli).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_legale().getDettagli());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_latitudine).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_legale().getLatitudine());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_longitudine).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_legale().getLongitudine());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_presso).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_legale().getPresso());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_indirizzo_completo).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_operativo().getIndirizzo_completo());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_strada_completo).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_operativo().getStrada_completo());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_comune_completo).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_operativo().getComune_completo());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_strada).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_operativo().getStrada());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_civico).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_operativo().getCivico());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_cap).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_operativo().getCap());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_comune).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_operativo().getComune());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_provincia).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_operativo().getProvincia());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_regione).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_operativo().getRegione());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_dettagli).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_operativo().getDettagli());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_latitudine).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_operativo().getLatitudine());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_longitudine).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_operativo().getLongitudine());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_presso).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_operativo().getPresso());
				} else if(ti.getPosizione(ConstantsMap.consenso_tfissoS).equals(j)) {
					lista.addValore(ConstantsFormat.dateTime.stampa(), cnt.getAnagrafica().getConsenso_tfisso());
				} else if(ti.getPosizione(ConstantsMap.consenso_tmobileS).equals(j)) {
					lista.addValore(ConstantsFormat.dateTime.stampa(), cnt.getAnagrafica().getConsenso_tmobile());
				} else if(ti.getPosizione(ConstantsMap.consenso_tfaxS).equals(j)) {
					lista.addValore(ConstantsFormat.dateTime.stampa(), cnt.getAnagrafica().getConsenso_tfax());
				} else if(ti.getPosizione(ConstantsMap.consenso_taltroS).equals(j)) {
					lista.addValore(ConstantsFormat.dateTime.stampa(), cnt.getAnagrafica().getConsenso_taltro());
				} else if(ti.getPosizione(ConstantsMap.consenso_emailS).equals(j)) {
					lista.addValore(ConstantsFormat.dateTime.stampa(), cnt.getAnagrafica().getConsenso_email());
				} else if(ti.getPosizione(ConstantsMap.consenso_rmailS).equals(j)) {
					lista.addValore(ConstantsFormat.dateTime.stampa(), cnt.getAnagrafica().getConsenso_rmail());
				} else {
					stampaDato(lista,  titles[j], cnt.getAnagrafica().getDettagli(), null);
				}
			}
			for (int j = 0; j < lista.size(); j++) {
				ExcelFormat el = lista.get(j);
				Cell cell = row.createCell(j, el.getCellType());
				ApplicationUtil.cellStamper(s, cell, el);
			}
		}
		sheet.setDefaultColumnWidth(20);
		ApplicationUtil.passwordXLS(wb, result, password);
		
	}
	public static void esportaExcelAppuntamentoTemplate(Boolean p, List<Appuntamento> data, AnagraficaDao anagraficaDao, TemplateExportAppuntamento ti, OutputStream result, String password) throws Exception {
		List <String> titlesList = ti.getValore_multiplo();
		List <String> aggiuntivi = ListUtils.subtract(titlesList, new ArrayList<String>(ConstantsMap.appuntamentoMap));
		if(p!=null && ApplicationUtil.notEmpty(aggiuntivi)) {
			List <String> invA = anagraficaDao.getEtichetteInvisibiliByChiave(p, CampoAggiuntivoAnagrafica.class);
			aggiuntivi.removeAll(invA);
			titlesList.removeAll(invA);
		}
		if(ApplicationUtil.notEmpty(aggiuntivi)) {
			data = anagraficaDao.loadFullAppuntamento(data);
		}
		String[] titles = titlesList.toArray(new String[0]);
		Workbook wb = ApplicationUtil.workbookS();
		ExcelStyle s = new ExcelStyle(wb);
		Sheet sheet = wb.createSheet(ConstantsLanguage.APPUNTAMENTI.stampa());
		int k = 0;
		Row row = null;
		if(ti.getIntestazione()) {
			row = sheet.createRow(k++);
			for (int i = 0; i < titles.length; i++) {
				Cell cell = row.createCell(i, CellType.STRING);
				if(ApplicationUtil.notEmpty(aggiuntivi) && aggiuntivi.contains(titles[i])) {
					String etichetta = anagraficaDao.getEtichettaByChiave(CampoAggiuntivoAnagrafica.class, titles[i]);
					ApplicationUtil.headerCell(s, cell,  etichetta);
				} else {
					ApplicationUtil.headerCell(s, cell,  Message.addCatalogText(titles[i]));
				}
			}
			sheet.setAutoFilter(new CellRangeAddress(0, 0, 0, titles.length-1));
			sheet.createFreezePane(0, 1);
		} else {
			row = sheet.createRow(k);
		}
		Iterator<Appuntamento> objIter = data.iterator();
		while(objIter.hasNext()) {
			Appuntamento app = objIter.next();
			Contatto cnt = app.getContatto();
			row = sheet.createRow(k++);
			ExcelFormatList lista = new ExcelFormatList();
			for (int j = 0; j < titles.length; j++) {
				if(ti.getPosizione(ConstantsMap.appuntamento_id).equals(j)) {
					lista.addValore(app.getId().toString());
				} else if(ti.getPosizione(ConstantsMap.appuntamento_operatore_denominazione).equals(j)) {
					lista.addValore(app.getOperatore_denominazione());
				} else if(ti.getPosizione(ConstantsMap.appuntamento_bloccato).equals(j)) {
					lista.addValore(app.getBloccatoS());
				} else if(ti.getPosizione(ConstantsMap.appuntamento_operatore_codice).equals(j)) {
					lista.addValore(app.getOperatore_codice());
				} else if(ti.getPosizione(ConstantsMap.appuntamento_agente_denominazione).equals(j)) {
					lista.addValore(app.getAgente_denominazione());
				} else if(ti.getPosizione(ConstantsMap.appuntamento_agente_codice).equals(j)) {
					lista.addValore(app.getAgente_codice());
				} else if(ti.getPosizione(ConstantsMap.appuntamento_nota).equals(j)) {
					lista.addValore(app.getNota());
				} else if(ti.getPosizione(ConstantsMap.appuntamento_data_creazione).equals(j)) {
					lista.addValore(ConstantsFormat.dateTime.stampa(), app.getData_creazione());
				} else if(ti.getPosizione(ConstantsMap.appuntamento_data_appuntamento).equals(j)) {
					lista.addValore(ConstantsFormat.date.stampa(), app.getData_inizio());
				} else if(ti.getPosizione(ConstantsMap.appuntamento_data_ora).equals(j)) {
					lista.addValore(ConstantsFormat.dateTime.stampa(), app.getData_inizio());
				} else if(ti.getPosizione(ConstantsMap.appuntamento_ora_inizio).equals(j)) {
					lista.addValore(ConstantsFormat.time.stampa(), app.getData_inizio());
				} else if(ti.getPosizione(ConstantsMap.appuntamento_ora_fine).equals(j)) {
					lista.addValore(ConstantsFormat.time.stampa(), app.getData_fine());
				} else if(ti.getPosizione(ConstantsMap.appuntamento_data_conferma).equals(j)) {
					lista.addValore(ConstantsFormat.dateTime.stampa(), app.getData_conferma());
				} else if(ti.getPosizione(ConstantsMap.appuntamento_data_lavorazione).equals(j)) {
					lista.addValore(ConstantsFormat.dateTime.stampa(), app.getData_lavorazione());
				} else if(ti.getPosizione(ConstantsMap.appuntamento_localizzazione).equals(j)) {
					lista.addValore(app.getLocalizzazioneString());
				} else if(ti.getPosizione(ConstantsMap.appuntamento_utente_denominazione).equals(j)) {
					lista.addValore(app.getUtente_denominazione());
				} else if(ti.getPosizione(ConstantsMap.appuntamento_utente_codice).equals(j)) {
					lista.addValore(app.getUtente_codice());
				} else if(ti.getPosizione(ConstantsMap.appuntamento_data_esito).equals(j)) {
					lista.addValore(ConstantsFormat.dateTime.stampa(), app.getData_esito());
				} else if(ti.getPosizione(ConstantsMap.appuntamento_data_stato).equals(j)) {
					lista.addValore(ConstantsFormat.dateTime.stampa(), app.getData_stato());
				} else if(ti.getPosizione(ConstantsMap.appuntamento_esito_appuntamento).equals(j)) {
					lista.addValore(app.getEsitoEtichetta());
				} else if(ti.getPosizione(ConstantsMap.appuntamento_codice_appuntamento).equals(j)) {
					lista.addValore(app.getEsitoCodice());
				} else if(ti.getPosizione(ConstantsMap.appuntamento_stato).equals(j)) {
					lista.addValore(app.getStatoTesto());
				} else if(ti.getPosizione(ConstantsMap.contatto_data_lavorazione).equals(j)) {
					lista.addValore(ConstantsFormat.dateTime.stampa(), cnt.getData_lavorazione());
				} else if(ti.getPosizione(ConstantsMap.contatto_operatore_denominazione).equals(j)) {
					lista.addValore(cnt.getOperatore_denominazione());
				} else if(ti.getPosizione(ConstantsMap.contatto_operatore_codice).equals(j)) {
					lista.addValore(cnt.getOperatore_codice());
				} else if(ti.getPosizione(ConstantsMap.contatto_data_archiviazione).equals(j)) {
					lista.addValore(ConstantsFormat.dateTime.stampa(), cnt.getData_archiviazione());
				} else if(ti.getPosizione(ConstantsMap.contatto_esito_chiamata).equals(j)) {
					lista.addValore(cnt.getEsito_chiamata());
				} else if(ti.getPosizione(ConstantsMap.contatto_esito_archiviazione).equals(j)) {
					lista.addValore(cnt.getEsito_archiviazione());
				} else if(ti.getPosizione(ConstantsMap.contatto_esito_generale).equals(j)) {
					lista.addValore(cnt.getEsito_generale());
				} else if(ti.getPosizione(ConstantsMap.contatto_codice_chiamata).equals(j)) {
					lista.addValore(cnt.getCodice_chiamata());
				} else if(ti.getPosizione(ConstantsMap.contatto_codice_archiviazione).equals(j)) {
					lista.addValore(cnt.getCodice_archiviazione());
				} else if(ti.getPosizione(ConstantsMap.contatto_codice_generale).equals(j)) {
					lista.addValore(cnt.getCodice_generale());
				} else if(ti.getPosizione(ConstantsMap.contatto_proprietario_denominazione).equals(j)) {
					lista.addValore(cnt.getProprietario_denominazione());
				} else if(ti.getPosizione(ConstantsMap.contatto_proprietario_codice).equals(j)) {
					lista.addValore(cnt.getProprietario_codice());
				} else if(ti.getPosizione(ConstantsMap.contatto_data_presentazione).equals(j)) {
					lista.addValore(ConstantsFormat.dateTime.stampa(), cnt.getData_presentazione());
				} else if(ti.getPosizione(ConstantsMap.contatto_nota).equals(j)) {
					lista.addValore(cnt.getNota());
				} else if(ti.getPosizione(ConstantsMap.contatto_data_creazione).equals(j)) {
					lista.addValore(ConstantsFormat.dateTime.stampa(), cnt.getData_creazione());
				} else if(ti.getPosizione(ConstantsMap.contatto_agente_denominazione).equals(j)) {
					lista.addValore(cnt.getAgente_denominazione());
				} else if(ti.getPosizione(ConstantsMap.contatto_agente_codice).equals(j)) {
					lista.addValore(cnt.getAgente_codice());
				} else if(ti.getPosizione(ConstantsMap.contatto_stato).equals(j)) {
					lista.addValore(cnt.getTipoTesto());
				} else if(ti.getPosizione(ConstantsMap.contatto_id).equals(j)) {
					lista.addValore(cnt.getId().toString());
				} else if(ti.getPosizione(ConstantsMap.contatto_campagna_denominazione).equals(j)) {
					lista.addValore(cnt.getCampagna_denominazione());
				} else if(ti.getPosizione(ConstantsMap.contatto_lista_denominazione).equals(j)) {
					lista.addValore(cnt.getLista_denominazione());
				} else if(ti.getPosizione(ConstantsMap.contatto_campagna_codice).equals(j)) {
					lista.addValore(cnt.getCampagna_codice());
				} else if(ti.getPosizione(ConstantsMap.contatto_bloccato).equals(j)) {
					lista.addValore(cnt.getBloccatoS());
				} else if(ti.getPosizione(ConstantsMap.contatto_lista_codice).equals(j)) {
					lista.addValore(cnt.getLista_codice());
				} else if(ti.getPosizione(ConstantsMap.contatto_positivo).equals(j)) {
					lista.addValore(cnt.getPositivo());
				} else if(ti.getPosizione(ConstantsMap.contatto_telefono_predefinito).equals(j)) {
					lista.addValore(ApplicationUtil.uniforma(cnt.getTelefono_predefinito(), ti.getRem_predefinito(), ti.getAdd_predefinito()));
				} else if(ti.getPosizione(ConstantsMap.contatto_utile).equals(j)) {
					lista.addValore(cnt.getUtile());
				} else if(ti.getPosizione(ConstantsMap.contatto_chiuso).equals(j)) {
					lista.addValore(cnt.getChiuso());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_cognome).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getCognome());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_nome).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getNome());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_nome_completo).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getNome_completo());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_email).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getEmail());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_codice_fiscale).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getCodice_fiscale());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_sorgente).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getSorgente());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_nota).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getNota());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_luogo_nascita).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getLuogo_nascita());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_data_nascita).equals(j)) {
					lista.addValore(ConstantsFormat.date.stampa(), cnt.getAnagrafica().getDate_nascita());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_link).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getLink());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_data_inserimento).equals(j)) {
					lista.addValore(ConstantsFormat.dateTime.stampa(), cnt.getAnagrafica().getData_creazione());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_privacy).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getPrivacy());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_tipo).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getTipo());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_sesso).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getSesso());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_partita_iva).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getPartita_iva());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_ragione_sociale).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getRagione_sociale());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_telefono_fisso).equals(j)) {
					lista.addValore(ApplicationUtil.uniforma(cnt.getAnagrafica().getTelefono_fisso(), ti.getRem_fisso(), ti.getAdd_fisso()));
				} else if(ti.getPosizione(ConstantsMap.anagrafica_telefono_altro).equals(j)) {
					lista.addValore(ApplicationUtil.uniforma(cnt.getAnagrafica().getTelefono_altro(), ti.getRem_altro(), ti.getAdd_altro()));
				} else if(ti.getPosizione(ConstantsMap.anagrafica_telefono_mobile).equals(j)) {
					lista.addValore(ApplicationUtil.uniforma(cnt.getAnagrafica().getTelefono_mobile(), ti.getRem_mobile(), ti.getAdd_mobile()));
				} else if(ti.getPosizione(ConstantsMap.anagrafica_telefono_fax).equals(j)) {
					lista.addValore(ApplicationUtil.uniforma(cnt.getAnagrafica().getTelefono_fax(), ti.getRem_fax(), ti.getAdd_fax()));
				} else if(ti.getPosizione(ConstantsMap.anagrafica_settore).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getSettore());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_denominazione).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getDenominazione());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_id).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIdentificativo());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_indirizzo_completo).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_legale().getIndirizzo_completo());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_strada_completo).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_legale().getStrada_completo());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_comune_completo).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_legale().getComune_completo());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_strada).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_legale().getStrada());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_civico).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_legale().getCivico());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_cap).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_legale().getCap());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_comune).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_legale().getComune());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_provincia).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_legale().getProvincia());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_regione).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_legale().getRegione());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_dettagli).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_legale().getDettagli());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_latitudine).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_legale().getLatitudine());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_longitudine).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_legale().getLongitudine());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_presso).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_legale().getPresso());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_indirizzo_completo).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_operativo().getIndirizzo_completo());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_strada_completo).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_operativo().getStrada_completo());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_comune_completo).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_operativo().getComune_completo());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_strada).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_operativo().getStrada());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_civico).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_operativo().getCivico());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_cap).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_operativo().getCap());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_comune).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_operativo().getComune());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_provincia).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_operativo().getProvincia());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_regione).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_operativo().getRegione());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_dettagli).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_operativo().getDettagli());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_latitudine).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_operativo().getLatitudine());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_longitudine).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_operativo().getLongitudine());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_presso).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_operativo().getPresso());
				} else if(ti.getPosizione(ConstantsMap.consenso_tfissoS).equals(j)) {
					lista.addValore(ConstantsFormat.dateTime.stampa(), cnt.getAnagrafica().getConsenso_tfisso());
				} else if(ti.getPosizione(ConstantsMap.consenso_tmobileS).equals(j)) {
					lista.addValore(ConstantsFormat.dateTime.stampa(), cnt.getAnagrafica().getConsenso_tmobile());
				} else if(ti.getPosizione(ConstantsMap.consenso_tfaxS).equals(j)) {
					lista.addValore(ConstantsFormat.dateTime.stampa(), cnt.getAnagrafica().getConsenso_tfax());
				} else if(ti.getPosizione(ConstantsMap.consenso_taltroS).equals(j)) {
					lista.addValore(ConstantsFormat.dateTime.stampa(), cnt.getAnagrafica().getConsenso_taltro());
				} else if(ti.getPosizione(ConstantsMap.consenso_emailS).equals(j)) {
					lista.addValore(ConstantsFormat.dateTime.stampa(), cnt.getAnagrafica().getConsenso_email());
				} else if(ti.getPosizione(ConstantsMap.consenso_rmailS).equals(j)) {
					lista.addValore(ConstantsFormat.dateTime.stampa(), cnt.getAnagrafica().getConsenso_rmail());
				} else {
					stampaDato(lista,  titles[j], cnt.getAnagrafica().getDettagli(), null);
				}
			}
			for (int j = 0; j < lista.size(); j++) {
				ExcelFormat el = lista.get(j);
				Cell cell = row.createCell(j, el.getCellType());
				ApplicationUtil.cellStamper(s, cell, el);
			}
		}
		sheet.setDefaultColumnWidth(20);
		ApplicationUtil.passwordXLS(wb, result, password);
		
	}
	public static void esportaExcelContrattoTemplate(Boolean p, List<Contratto> data, AnagraficaDao anagraficaDao, TemplateExportContratto ti, OutputStream result, String password) throws Exception {
		List <String> titlesList = ti.getValore_multiplo();
		List <String> aggiuntivi = ListUtils.subtract(titlesList, new ArrayList<String>(ConstantsMap.contrattoMap));
		if(p!=null && ApplicationUtil.notEmpty(aggiuntivi)) {
			List <String> invA = anagraficaDao.getEtichetteInvisibiliByChiave(p, CampoAggiuntivoAnagrafica.class);
			List <String> invB = anagraficaDao.getEtichetteInvisibiliByChiave(p, CampoAggiuntivoContratto.class);
			aggiuntivi.removeAll(invA);
			aggiuntivi.removeAll(invB);
			titlesList.removeAll(invA);
			titlesList.removeAll(invB);
		}
		if(ApplicationUtil.notEmpty(aggiuntivi)) {
			data = anagraficaDao.loadFullContratto(data);
		}
		String[] titles = titlesList.toArray(new String[0]);
		Workbook wb = ApplicationUtil.workbookS();
		ExcelStyle s = new ExcelStyle(wb);
		Sheet sheet = wb.createSheet(ConstantsLanguage.CONTRATTI.stampa());
		int k = 0;
		Row row = null;
		if(ti.getIntestazione()) {
			row = sheet.createRow(k++);
			for (int i = 0; i < titles.length; i++) {
				Cell cell = row.createCell(i, CellType.STRING);
				if(ApplicationUtil.notEmpty(aggiuntivi) && aggiuntivi.contains(titles[i])) {
					String etichetta = anagraficaDao.getEtichettaByChiave(CampoAggiuntivoAnagrafica.class, titles[i]);
					if(ApplicationUtil.isBlank(etichetta)) {
						etichetta = anagraficaDao.getEtichettaByChiave(CampoAggiuntivoContratto.class, titles[i]);
					}
					ApplicationUtil.headerCell(s, cell,  etichetta);
				} else {
					ApplicationUtil.headerCell(s, cell,  Message.addCatalogText(titles[i]));
				}
			}
			sheet.setAutoFilter(new CellRangeAddress(0, 0, 0, titles.length-1));
			sheet.createFreezePane(0, 1);
		} else {
			row = sheet.createRow(k);
		}
		Iterator<Contratto> objIter = data.iterator();
		while(objIter.hasNext()) {
			Contratto crt = objIter.next();
			Contatto cnt = crt.getContatto();
			row = sheet.createRow(k++);
			ExcelFormatList lista = new ExcelFormatList();
			for (int j = 0; j < titles.length; j++) {
				if(ti.getPosizione(ConstantsMap.contratto_data_creazione).equals(j)) {
					lista.addValore(ConstantsFormat.dateTime.stampa(), crt.getData_creazione());
				} else if(ti.getPosizione(ConstantsMap.contratto_id).equals(j)) {
					lista.addValore(crt.getId().toString());
				} else if(ti.getPosizione(ConstantsMap.contratto_operatore_denominazione).equals(j)) {
					lista.addValore(crt.getOperatore_denominazione());
				} else if(ti.getPosizione(ConstantsMap.contratto_operatore_codice).equals(j)) {
					lista.addValore(crt.getOperatore_codice());
				} else if(ti.getPosizione(ConstantsMap.contratto_agente_denominazione).equals(j)) {
					lista.addValore(crt.getAgente_denominazione());
				} else if(ti.getPosizione(ConstantsMap.contratto_agente_codice).equals(j)) {
					lista.addValore(crt.getAgente_codice());
				} else if(ti.getPosizione(ConstantsMap.contratto_categoria_denominazione).equals(j)) {
					lista.addValore(crt.getCategoria_denominazione());
				} else if(ti.getPosizione(ConstantsMap.contratto_prodotto_denominazione).equals(j)) {
					lista.addValore(crt.getProdotto_denominazione());
				} else if(ti.getPosizione(ConstantsMap.contratto_esito_contratto).equals(j)) {
					lista.addValore(crt.getEsitoEtichetta());
				} else if(ti.getPosizione(ConstantsMap.contratto_codice_contratto).equals(j)) {
					lista.addValore(crt.getEsitoCodice());
				} else if(ti.getPosizione(ConstantsMap.contratto_data_stipula).equals(j)) {
					lista.addValore(ConstantsFormat.date.stampa(),crt.getData_stipula());
				} else if(ti.getPosizione(ConstantsMap.contratto_data_contabile).equals(j)) {
					lista.addValore(ConstantsFormat.date.stampa(),crt.getData_contabile());
				} else if(ti.getPosizione(ConstantsMap.contratto_data_attivazione).equals(j)) {
					lista.addValore(ConstantsFormat.date.stampa(),crt.getData_attivazione());
				} else if(ti.getPosizione(ConstantsMap.contratto_data_caricamento).equals(j)) {
					lista.addValore(ConstantsFormat.date.stampa(),crt.getData_caricamento());
				} else if(ti.getPosizione(ConstantsMap.contratto_data_lavorazione).equals(j)) {
					lista.addValore(ConstantsFormat.dateTime.stampa(),crt.getData_lavorazione());
				} else if(ti.getPosizione(ConstantsMap.contratto_utente_denominazione).equals(j)) {
					lista.addValore(crt.getUtente_denominazione());
				} else if(ti.getPosizione(ConstantsMap.contratto_bloccato).equals(j)) {
					lista.addValore(crt.getBloccatoS());
				} else if(ti.getPosizione(ConstantsMap.contratto_utente_codice).equals(j)) {
					lista.addValore(crt.getUtente_codice());
				} else if(ti.getPosizione(ConstantsMap.contratto_data_esito).equals(j)) {
					lista.addValore(ConstantsFormat.dateTime.stampa(), crt.getData_esito());
				} else if(ti.getPosizione(ConstantsMap.contratto_data_stato).equals(j)) {
					lista.addValore(ConstantsFormat.dateTime.stampa(), crt.getData_stato());
				} else if(ti.getPosizione(ConstantsMap.contratto_nota).equals(j)) {
					lista.addValore(crt.getNota());
				} else if(ti.getPosizione(ConstantsMap.contratto_tipo_seriale).equals(j)) {
					lista.addValore(crt.getTipo_seriale());
				} else if(ti.getPosizione(ConstantsMap.contratto_seriale).equals(j)) {
					lista.addValore(crt.getSeriale());
				} else if(ti.getPosizione(ConstantsMap.contratto_quantita).equals(j)) {
					lista.addValore(crt.getQuantita());
				} else if(ti.getPosizione(ConstantsMap.contratto_costo_scontato).equals(j)) {
					lista.addValore(crt.getCosto_scontato());
				} else if(ti.getPosizione(ConstantsMap.contratto_stato).equals(j)) {
					lista.addValore(crt.getStatoTesto());
				} else if(ti.getPosizione(ConstantsMap.contatto_data_archiviazione).equals(j)) {
					lista.addValore(ConstantsFormat.dateTime.stampa(), cnt.getData_archiviazione());
				} else if(ti.getPosizione(ConstantsMap.contatto_data_lavorazione).equals(j)) {
					lista.addValore(ConstantsFormat.dateTime.stampa(), cnt.getData_lavorazione());
				} else if(ti.getPosizione(ConstantsMap.contatto_operatore_denominazione).equals(j)) {
					lista.addValore(cnt.getOperatore_denominazione());
				} else if(ti.getPosizione(ConstantsMap.contatto_operatore_codice).equals(j)) {
					lista.addValore(cnt.getOperatore_codice());
				} else if(ti.getPosizione(ConstantsMap.contatto_esito_chiamata).equals(j)) {
					lista.addValore(cnt.getEsito_chiamata());
				} else if(ti.getPosizione(ConstantsMap.contatto_esito_archiviazione).equals(j)) {
					lista.addValore(cnt.getEsito_archiviazione());
				} else if(ti.getPosizione(ConstantsMap.contatto_esito_generale).equals(j)) {
					lista.addValore(cnt.getEsito_generale());
				} else if(ti.getPosizione(ConstantsMap.contatto_codice_chiamata).equals(j)) {
					lista.addValore(cnt.getCodice_chiamata());
				} else if(ti.getPosizione(ConstantsMap.contatto_codice_archiviazione).equals(j)) {
					lista.addValore(cnt.getCodice_archiviazione());
				} else if(ti.getPosizione(ConstantsMap.contatto_codice_generale).equals(j)) {
					lista.addValore(cnt.getCodice_generale());
				} else if(ti.getPosizione(ConstantsMap.contatto_proprietario_denominazione).equals(j)) {
					lista.addValore(cnt.getProprietario_denominazione());
				} else if(ti.getPosizione(ConstantsMap.contatto_proprietario_codice).equals(j)) {
					lista.addValore(cnt.getProprietario_codice());
				} else if(ti.getPosizione(ConstantsMap.contatto_data_presentazione).equals(j)) {
					lista.addValore(ConstantsFormat.dateTime.stampa(), cnt.getData_presentazione());
				} else if(ti.getPosizione(ConstantsMap.contatto_nota).equals(j)) {
					lista.addValore(cnt.getNota());
				} else if(ti.getPosizione(ConstantsMap.contatto_data_creazione).equals(j)) {
					lista.addValore(ConstantsFormat.dateTime.stampa(), cnt.getData_creazione());
				} else if(ti.getPosizione(ConstantsMap.contatto_agente_denominazione).equals(j)) {
					lista.addValore(cnt.getAgente_denominazione());
				} else if(ti.getPosizione(ConstantsMap.contatto_agente_codice).equals(j)) {
					lista.addValore(cnt.getAgente_codice());
				} else if(ti.getPosizione(ConstantsMap.contatto_stato).equals(j)) {
					lista.addValore(cnt.getTipoTesto());
				} else if(ti.getPosizione(ConstantsMap.contatto_id).equals(j)) {
					lista.addValore(cnt.getId().toString());
				} else if(ti.getPosizione(ConstantsMap.contatto_campagna_denominazione).equals(j)) {
					lista.addValore(cnt.getCampagna_denominazione());
				} else if(ti.getPosizione(ConstantsMap.contatto_lista_denominazione).equals(j)) {
					lista.addValore(cnt.getLista_denominazione());
				} else if(ti.getPosizione(ConstantsMap.contatto_campagna_codice).equals(j)) {
					lista.addValore(cnt.getCampagna_codice());
				} else if(ti.getPosizione(ConstantsMap.contatto_bloccato).equals(j)) {
					lista.addValore(cnt.getBloccatoS());
				} else if(ti.getPosizione(ConstantsMap.contatto_lista_codice).equals(j)) {
					lista.addValore(cnt.getLista_codice());
				} else if(ti.getPosizione(ConstantsMap.contatto_positivo).equals(j)) {
					lista.addValore(cnt.getPositivo());
				} else if(ti.getPosizione(ConstantsMap.contatto_telefono_predefinito).equals(j)) {
					lista.addValore(ApplicationUtil.uniforma(cnt.getTelefono_predefinito(), ti.getRem_predefinito(), ti.getAdd_predefinito()));
				} else if(ti.getPosizione(ConstantsMap.contatto_utile).equals(j)) {
					lista.addValore(cnt.getUtile());
				} else if(ti.getPosizione(ConstantsMap.contatto_chiuso).equals(j)) {
					lista.addValore(cnt.getChiuso());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_cognome).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getCognome());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_nome).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getNome());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_nome_completo).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getNome_completo());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_email).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getEmail());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_codice_fiscale).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getCodice_fiscale());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_sorgente).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getSorgente());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_nota).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getNota());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_luogo_nascita).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getLuogo_nascita());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_data_nascita).equals(j)) {
					lista.addValore(ConstantsFormat.date.stampa(), cnt.getAnagrafica().getDate_nascita());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_link).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getLink());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_privacy).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getPrivacy());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_data_inserimento).equals(j)) {
					lista.addValore(ConstantsFormat.dateTime.stampa(), cnt.getAnagrafica().getData_creazione());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_tipo).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getTipo());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_sesso).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getSesso());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_partita_iva).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getPartita_iva());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_ragione_sociale).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getRagione_sociale());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_telefono_fisso).equals(j)) {
					lista.addValore(ApplicationUtil.uniforma(cnt.getAnagrafica().getTelefono_fisso(), ti.getRem_fisso(), ti.getAdd_fisso()));
				} else if(ti.getPosizione(ConstantsMap.anagrafica_telefono_altro).equals(j)) {
					lista.addValore(ApplicationUtil.uniforma(cnt.getAnagrafica().getTelefono_altro(), ti.getRem_altro(), ti.getAdd_altro()));
				} else if(ti.getPosizione(ConstantsMap.anagrafica_telefono_mobile).equals(j)) {
					lista.addValore(ApplicationUtil.uniforma(cnt.getAnagrafica().getTelefono_mobile(), ti.getRem_mobile(), ti.getAdd_mobile()));
				} else if(ti.getPosizione(ConstantsMap.anagrafica_telefono_fax).equals(j)) {
					lista.addValore(ApplicationUtil.uniforma(cnt.getAnagrafica().getTelefono_fax(), ti.getRem_fax(), ti.getAdd_fax()));
				} else if(ti.getPosizione(ConstantsMap.anagrafica_settore).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getSettore());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_denominazione).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getDenominazione());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_id).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIdentificativo());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_indirizzo_completo).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_legale().getIndirizzo_completo());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_strada_completo).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_legale().getStrada_completo());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_comune_completo).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_legale().getComune_completo());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_strada).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_legale().getStrada());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_civico).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_legale().getCivico());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_cap).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_legale().getCap());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_comune).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_legale().getComune());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_provincia).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_legale().getProvincia());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_regione).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_legale().getRegione());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_dettagli).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_legale().getDettagli());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_latitudine).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_legale().getLatitudine());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_longitudine).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_legale().getLongitudine());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_presso).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_legale().getPresso());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_indirizzo_completo).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_operativo().getIndirizzo_completo());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_strada_completo).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_operativo().getStrada_completo());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_comune_completo).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_operativo().getComune_completo());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_strada).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_operativo().getStrada());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_civico).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_operativo().getCivico());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_cap).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_operativo().getCap());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_comune).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_operativo().getComune());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_provincia).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_operativo().getProvincia());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_regione).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_operativo().getRegione());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_dettagli).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_operativo().getDettagli());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_latitudine).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_operativo().getLatitudine());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_longitudine).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_operativo().getLongitudine());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_presso).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_operativo().getPresso());
				} else if(ti.getPosizione(ConstantsMap.consenso_tfissoS).equals(j)) {
					lista.addValore(ConstantsFormat.dateTime.stampa(), cnt.getAnagrafica().getConsenso_tfisso());
				} else if(ti.getPosizione(ConstantsMap.consenso_tmobileS).equals(j)) {
					lista.addValore(ConstantsFormat.dateTime.stampa(), cnt.getAnagrafica().getConsenso_tmobile());
				} else if(ti.getPosizione(ConstantsMap.consenso_tfaxS).equals(j)) {
					lista.addValore(ConstantsFormat.dateTime.stampa(), cnt.getAnagrafica().getConsenso_tfax());
				} else if(ti.getPosizione(ConstantsMap.consenso_taltroS).equals(j)) {
					lista.addValore(ConstantsFormat.dateTime.stampa(), cnt.getAnagrafica().getConsenso_taltro());
				} else if(ti.getPosizione(ConstantsMap.consenso_emailS).equals(j)) {
					lista.addValore(ConstantsFormat.dateTime.stampa(), cnt.getAnagrafica().getConsenso_email());
				} else if(ti.getPosizione(ConstantsMap.consenso_rmailS).equals(j)) {
					lista.addValore(ConstantsFormat.dateTime.stampa(), cnt.getAnagrafica().getConsenso_rmail());
				} else {
					stampaDato(lista,  titles[j], cnt.getAnagrafica().getDettagli(), crt.getDettagli());
				}
			}
			for (int j = 0; j < lista.size(); j++) {
				ExcelFormat el = lista.get(j);
				Cell cell = row.createCell(j, el.getCellType());
				ApplicationUtil.cellStamper(s, cell, el);
			}
		}
		sheet.setDefaultColumnWidth(20);
		ApplicationUtil.passwordXLS(wb, result, password);
		
	}
	public static void esportaExcelStoriaContatto(List<StoriaContatto> data, OutputStream result, String password) throws Exception {
		String [] titles = new ExportUtility().titlesStoriaContatto;
		Workbook wb = ApplicationUtil.workbookS();
		ExcelStyle s = new ExcelStyle(wb);
		Sheet sheet = wb.createSheet(ConstantsLanguage.STORIA.stampa() + " " + ConstantsLanguage.CONTATTI.stampa());
		int k = 0;
		Row row = sheet.createRow(k++);
		for(int i = 0; i < titles.length; i++) {
			Cell cell = row.createCell(i, CellType.STRING);
			ApplicationUtil.headerCell(s, cell,  titles[i]);
		}
		sheet.setAutoFilter(new CellRangeAddress(0, 0, 0, titles.length-1));
		sheet.createFreezePane(0, 1);
		Iterator<StoriaContatto> objIter = data.iterator();
		while(objIter.hasNext()) {
			StoriaContatto prd = objIter.next();
			row = sheet.createRow(k++);
			ExcelFormatList lista = new ExcelFormatList();
			lista.addValore(prd.getId().toString());
			lista.addValore(ConstantsFormat.dateSeconds.stampa(), prd.getData());
			lista.addValore(prd.getBloccatoS());
			lista.addValore(prd.getCampagna_denominazione());
			lista.addValore(prd.getLista_denominazione());
			lista.addValore(prd.getEsito_chiamata_etichettaCodice());
			lista.addValore(prd.getEsito_archiviazione_etichettaCodice());
			lista.addValore(prd.getContatto().getAnagrafica().getDenominazione());
			lista.addValore(prd.getContatto().getAnagrafica().getCognome());
			lista.addValore(prd.getContatto().getAnagrafica().getNome());
			lista.addValore(prd.getContatto().getAnagrafica().getEmail());
			lista.addValore(prd.getContatto().getAnagrafica().getTelefono_fisso());
			lista.addValore(prd.getContatto().getAnagrafica().getTelefono_mobile());
			lista.addValore(prd.getContatto().getAnagrafica().getTelefono_fax());
			lista.addValore(prd.getContatto().getAnagrafica().getTelefono_altro());
			lista.addValore(prd.getProprietario_denominazione());
			lista.addValore(prd.getAgente_denominazione());
			lista.addValore(prd.getOperatore_denominazione());
			lista.addValore(prd.getChiuso());
			lista.addValore(ConstantsFormat.dateTime.stampa(), prd.getData_presentazione());
			lista.addValore(ConstantsFormat.dateTime.stampa(), prd.getData_archiviazione());
			lista.addValore(prd.getNota());
			lista.addValore(prd.getTipoTesto());
			lista.addValore(prd.getSecondi_tot());
			lista.addValore(ConstantsFormat.seconds.stampa(),prd.getSecondi_tot());
			lista.addValore(prd.getSecondi_conv_eff());
			lista.addValore(ConstantsFormat.seconds.stampa(),prd.getSecondi_conv_eff());
			lista.addValore(prd.getSecondi_conv_tot());
			lista.addValore(ConstantsFormat.seconds.stampa(),prd.getSecondi_conv_tot());
			lista.addValore(prd.getSecondi_post());
			lista.addValore(ConstantsFormat.seconds.stampa(),prd.getSecondi_post());
			lista.addValore(prd.getSecondi_pre());
			lista.addValore(ConstantsFormat.seconds.stampa(), prd.getSecondi_pre());
			lista.addValore(prd.getSecondi_rec());
			lista.addValore(ConstantsFormat.seconds.stampa(),prd.getSecondi_rec());
			lista.addValore(prd.getSecondi_attesa());
			lista.addValore(ConstantsFormat.seconds.stampa(),prd.getSecondi_attesa());		
			lista.addValore(ConstantsFormat.dateSeconds.stampa(), prd.getDate_apertura());
			lista.addValore(ConstantsFormat.dateSeconds.stampa(), prd.getDate_chiamata());
			lista.addValore(ConstantsFormat.dateSeconds.stampa(), prd.getDate_risposta());
			lista.addValore(ConstantsFormat.dateSeconds.stampa(), prd.getDate_rec_inizio());
			lista.addValore(ConstantsFormat.dateSeconds.stampa(), prd.getDate_rec_fine());
			lista.addValore(ConstantsFormat.dateSeconds.stampa(), prd.getDate_fine());
			lista.addValore(ConstantsFormat.dateSeconds.stampa(), prd.getDate_esito());
			lista.addValore(ConstantsFormat.dateSeconds.stampa(), prd.getDate_attesa_inizio());
			lista.addValore(ConstantsFormat.dateSeconds.stampa(), prd.getDate_attesa_fine());
			lista.addValore(prd.getContatto().getAnagrafica().getIndirizzo_legale().getIndirizzo_completo());
			lista.addValore(prd.getContatto().getAnagrafica().getIndirizzo_operativo().getIndirizzo_completo());
			for (int j = 0; j < lista.size(); j++) {
				ExcelFormat el = lista.get(j);
				Cell cell = row.createCell(j, el.getCellType());
				ApplicationUtil.cellStamper(s, cell, el);
			}
		}
		sheet.setDefaultColumnWidth(20);
		ApplicationUtil.passwordXLS(wb, result, password);
		
	}
	public static void esportaExcelStoriaAppuntamento(List<StoriaAppuntamento> data, OutputStream result, String password) throws Exception {
		String [] titles = new ExportUtility().titlesStoriaAppuntamento;
		Workbook wb = ApplicationUtil.workbookS();
		ExcelStyle s = new ExcelStyle(wb);
		Sheet sheet = wb.createSheet(ConstantsLanguage.STORIA.stampa() + " " + ConstantsLanguage.APPUNTAMENTI.stampa());
		int k = 0;
		Row row = sheet.createRow(k++);
		for(int i = 0; i < titles.length; i++) {
			Cell cell = row.createCell(i, CellType.STRING);
			ApplicationUtil.headerCell(s, cell,  titles[i]);
		}
		sheet.setAutoFilter(new CellRangeAddress(0, 0, 0, titles.length-1));
		sheet.createFreezePane(0, 1);
		Iterator<StoriaAppuntamento> objIter = data.iterator();
		while(objIter.hasNext()) {
			StoriaAppuntamento prd = objIter.next();
			row = sheet.createRow(k++);
			ExcelFormatList lista = new ExcelFormatList();
			lista.addValore(prd.getId().toString());
			lista.addValore(ConstantsFormat.dateSeconds.stampa(), prd.getData());
			lista.addValore(prd.getBloccatoS());
			lista.addValore(prd.getAppuntamento().getContatto().getCampagna_denominazione());
			lista.addValore(prd.getAppuntamento().getContatto().getLista_denominazione());
			lista.addValore(prd.getEsitoEtichettaCodice());
			lista.addValore(prd.getAppuntamento().getContatto().getAnagrafica().getDenominazione());
			lista.addValore(prd.getAppuntamento().getContatto().getAnagrafica().getCognome());
			lista.addValore(prd.getAppuntamento().getContatto().getAnagrafica().getNome());
			lista.addValore(prd.getAppuntamento().getContatto().getAnagrafica().getEmail());
			lista.addValore(prd.getAppuntamento().getContatto().getAnagrafica().getTelefono_fisso());
			lista.addValore(prd.getAppuntamento().getContatto().getAnagrafica().getTelefono_mobile());
			lista.addValore(prd.getAppuntamento().getContatto().getAnagrafica().getTelefono_fax());
			lista.addValore(prd.getAppuntamento().getContatto().getAnagrafica().getTelefono_altro());
			lista.addValore(prd.getOperatore_denominazione());
			lista.addValore(prd.getAgente_denominazione());
			lista.addValore(prd.getUtente_denominazione());
			lista.addValore(prd.getNota());
			lista.addValore(prd.getStatoTesto());
			lista.addValore(ConstantsFormat.date.stampa(), prd.getData_inizio());
			lista.addValore(ConstantsFormat.time.stampa(), prd.getData_inizio());
			lista.addValore(ConstantsFormat.time.stampa(), prd.getData_fine());
			lista.addValore(ConstantsFormat.dateTime.stampa(), prd.getData_conferma());
			lista.addValore(ConstantsFormat.dateTime.stampa(), prd.getData_esito());
			lista.addValore(ConstantsFormat.dateTime.stampa(), prd.getData_stato());
			lista.addValore(prd.getLocalizzazioneString());
			lista.addValore(prd.getAppuntamento().getContatto().getAnagrafica().getIndirizzo_legale().getIndirizzo_completo());
			lista.addValore(prd.getAppuntamento().getContatto().getAnagrafica().getIndirizzo_operativo().getIndirizzo_completo());
			for (int j = 0; j < lista.size(); j++) {
				ExcelFormat el = lista.get(j);
				Cell cell = row.createCell(j, el.getCellType());
				ApplicationUtil.cellStamper(s, cell, el);
			}
		}
		sheet.setDefaultColumnWidth(20);
		ApplicationUtil.passwordXLS(wb, result, password);
		
	}
	public static void esportaExcelStoriaContratto(List<StoriaContratto> data, OutputStream result, String password) throws Exception {
		String [] titles = new ExportUtility().titlesStoriaContratto;
		Workbook wb = ApplicationUtil.workbookS();
		ExcelStyle s = new ExcelStyle(wb);
		Sheet sheet = wb.createSheet(ConstantsLanguage.STORIA.stampa() + " " + ConstantsLanguage.CONTRATTI.stampa());
		int k = 0;
		Row row = sheet.createRow(k++);
		for(int i = 0; i < titles.length; i++) {
			Cell cell = row.createCell(i, CellType.STRING);
			ApplicationUtil.headerCell(s, cell,  titles[i]);
		}
		sheet.setAutoFilter(new CellRangeAddress(0, 0, 0, titles.length-1));
		sheet.createFreezePane(0, 1);
		Iterator<StoriaContratto> objIter = data.iterator();
		while(objIter.hasNext()) {
			StoriaContratto prd = objIter.next();
			row = sheet.createRow(k++);
			ExcelFormatList lista = new ExcelFormatList();
			lista.addValore(prd.getId().toString());
			lista.addValore(ConstantsFormat.dateSeconds.stampa(), prd.getData());
			lista.addValore(prd.getBloccatoS());
			lista.addValore(prd.getContratto().getContatto().getCampagna_denominazione());
			lista.addValore(prd.getContratto().getContatto().getLista_denominazione());
			lista.addValore(prd.getEsitoEtichettaCodice());
			lista.addValore(prd.getContratto().getContatto().getAnagrafica().getDenominazione());
			lista.addValore(prd.getContratto().getContatto().getAnagrafica().getCognome());
			lista.addValore(prd.getContratto().getContatto().getAnagrafica().getNome());
			lista.addValore(prd.getContratto().getContatto().getAnagrafica().getEmail());
			lista.addValore(prd.getContratto().getContatto().getAnagrafica().getTelefono_fisso());
			lista.addValore(prd.getContratto().getContatto().getAnagrafica().getTelefono_mobile());
			lista.addValore(prd.getContratto().getContatto().getAnagrafica().getTelefono_fax());
			lista.addValore(prd.getContratto().getContatto().getAnagrafica().getTelefono_altro());
			lista.addValore(prd.getOperatore_denominazione());
			lista.addValore(prd.getAgente_denominazione());
			lista.addValore(prd.getUtente_denominazione());
			lista.addValore(prd.getNota());
			lista.addValore(prd.getStatoTesto());
			lista.addValore(prd.getSeriale());
			lista.addValore(prd.getCategoria_denominazione());
			lista.addValore(prd.getProdotto_denominazione());
			lista.addValore(prd.getQuantita());
			lista.addValore(prd.getCosto_scontato());
			lista.addValore(ConstantsFormat.date.stampa(), prd.getData_contabile());
			lista.addValore(ConstantsFormat.date.stampa(), prd.getData_stipula());
			lista.addValore(ConstantsFormat.date.stampa(), prd.getData_attivazione());
			lista.addValore(ConstantsFormat.date.stampa(), prd.getData_caricamento());
			lista.addValore(ConstantsFormat.dateTime.stampa(), prd.getData_esito());
			lista.addValore(ConstantsFormat.dateTime.stampa(), prd.getData_stato());
			lista.addValore(prd.getContratto().getContatto().getAnagrafica().getIndirizzo_legale().getIndirizzo_completo());
			lista.addValore(prd.getContratto().getContatto().getAnagrafica().getIndirizzo_operativo().getIndirizzo_completo());
			for (int j = 0; j < lista.size(); j++) {
				ExcelFormat el = lista.get(j);
				Cell cell = row.createCell(j, el.getCellType());
				ApplicationUtil.cellStamper(s, cell, el);
			}
		}
		sheet.setDefaultColumnWidth(20);
		ApplicationUtil.passwordXLS(wb, result, password);
		
	}
	private static void stampaDato(ExcelFormatList lista, String campo, List<DatoAggiuntivoAnagrafica> dati1, List<DatoAggiuntivoContratto> dati2) {
		boolean inserito = false;
		DatoAggiuntivoAnagrafica da1 = ApplicationUtil.getDatoAnagrafica(campo, dati1);
		if(da1!= null) {
			inserito = true;
			if(da1.getCampo_aggiuntivo().getData()) {
				lista.addValore(ConstantsFormat.date.stampa(), da1.getValore_data());
			} else if(da1.getCampo_aggiuntivo().getDataora()) {
				lista.addValore(ConstantsFormat.dateTime.stampa(), da1.getValore_datatime());
			} else if(da1.getCampo_aggiuntivo().getOra()) {
				lista.addValore(ConstantsFormat.time.stampa(), da1.getValore_time());
			} else if(da1.getCampo_aggiuntivo().getSlider() || da1.getCampo_aggiuntivo().getSpinner() || da1.getCampo_aggiuntivo().getIntero()) {
				lista.addValore(ApplicationUtil.parseNumber(da1.getValore()));
			} else if(da1.getCampo_aggiuntivo().getNumero()) {
				lista.addValore(ApplicationUtil.parseBigDecimal(da1.getValore()));
			} else if(da1.getCampo_aggiuntivo().getBooleano()) {
				lista.addValore(ApplicationUtil.isTrue(Boolean.valueOf(da1.getValore())));
			} else if(da1.getCampo_aggiuntivo().getFile()) {
				lista.addValore(da1.getValore_formattato());
			} else {
				lista.addValore(da1.getValore());
			}
		} 
		if(dati2 != null && !inserito) {
			DatoAggiuntivoContratto da2 = ApplicationUtil.getDatoContratto(campo, dati2);
			if(da2!= null) {
				inserito = true;
				if(da2.getCampo_aggiuntivo().getData()) {
					lista.addValore(ConstantsFormat.date.stampa(), da2.getValore_data());
				} else if(da2.getCampo_aggiuntivo().getDataora()) {
					lista.addValore(ConstantsFormat.dateTime.stampa(), da2.getValore_datatime());
				} else if(da2.getCampo_aggiuntivo().getOra()) {
					lista.addValore(ConstantsFormat.time.stampa(), da2.getValore_time());
				} else if(da2.getCampo_aggiuntivo().getSlider() || da2.getCampo_aggiuntivo().getSpinner() || da2.getCampo_aggiuntivo().getIntero()) {
					lista.addValore(ApplicationUtil.parseNumber(da2.getValore()));
				} else if(da2.getCampo_aggiuntivo().getNumero()) {
					lista.addValore(ApplicationUtil.parseBigDecimal(da2.getValore()));
				} else if(da2.getCampo_aggiuntivo().getBooleano()) {
					lista.addValore(ApplicationUtil.isTrue(Boolean.valueOf(da2.getValore())));
				} else if(da2.getCampo_aggiuntivo().getFile()) {
					lista.addValore(da2.getValore_formattato());
				} else {
					lista.addValore(da2.getValore());
				}
			} 
		}
		if(!inserito) {
			lista.addValore("");
		}
	}
	
	private static void stampaDato(ExcelFormatList lista, Long id, List<DatoAggiuntivoAnagrafica> dati1, List<DatoAggiuntivoContratto> dati2) {
		boolean inserito = false;
		DatoAggiuntivoAnagrafica da1 = ApplicationUtil.getDatoAnagrafica(id, dati1);
		if(da1!= null) {
			inserito = true;
			if(da1.getCampo_aggiuntivo().getData()) {
				lista.addValore(ConstantsFormat.date.stampa(), da1.getValore_data());
			} else if(da1.getCampo_aggiuntivo().getDataora()) {
				lista.addValore(ConstantsFormat.dateTime.stampa(), da1.getValore_datatime());
			} else if(da1.getCampo_aggiuntivo().getOra()) {
				lista.addValore(ConstantsFormat.time.stampa(), da1.getValore_time());
			} else if(da1.getCampo_aggiuntivo().getSlider() || da1.getCampo_aggiuntivo().getSpinner() || da1.getCampo_aggiuntivo().getIntero()) {
				lista.addValore(ApplicationUtil.parseNumber(da1.getValore()));
			} else if(da1.getCampo_aggiuntivo().getNumero()) {
				lista.addValore(ApplicationUtil.parseBigDecimal(da1.getValore()));
			} else if(da1.getCampo_aggiuntivo().getBooleano()) {
				lista.addValore(ApplicationUtil.isTrue(Boolean.valueOf(da1.getValore())));
			} else if(da1.getCampo_aggiuntivo().getFile()) {
				lista.addValore(da1.getValore_formattato());
			} else {
				lista.addValore(da1.getValore());
			}
		} 
		if(dati2 != null && !inserito) {
			DatoAggiuntivoContratto da2 = ApplicationUtil.getDatoContratto(id, dati2);
			if(da2!= null) {
				inserito = true;
				if(da2.getCampo_aggiuntivo().getData()) {
					lista.addValore(ConstantsFormat.date.stampa(), da2.getValore_data());
				} else if(da2.getCampo_aggiuntivo().getDataora()) {
					lista.addValore(ConstantsFormat.dateTime.stampa(), da2.getValore_datatime());
				} else if(da2.getCampo_aggiuntivo().getOra()) {
					lista.addValore(ConstantsFormat.time.stampa(), da2.getValore_time());
				} else if(da2.getCampo_aggiuntivo().getSlider() || da2.getCampo_aggiuntivo().getSpinner() || da2.getCampo_aggiuntivo().getIntero()) {
					lista.addValore(ApplicationUtil.parseNumber(da2.getValore()));
				} else if(da2.getCampo_aggiuntivo().getNumero()) {
					lista.addValore(ApplicationUtil.parseBigDecimal(da2.getValore()));
				} else if(da2.getCampo_aggiuntivo().getBooleano()) {
					lista.addValore(ApplicationUtil.isTrue(Boolean.valueOf(da2.getValore())));
				} else if(da2.getCampo_aggiuntivo().getFile()) {
					lista.addValore(da2.getValore_formattato());
				} else {
					lista.addValore(da2.getValore());
				}
			} 
		}
		if(!inserito) {
			lista.addValore("");
		}
	}
	public static void esportaExcelMarcatura(List<Marcatura> data, OutputStream result, String password) throws Exception {
		String [] titles = new ExportUtility().titlesMarcatura;
		Workbook wb = ApplicationUtil.workbookS();
		ExcelStyle s = new ExcelStyle(wb);
		Sheet sheet = wb.createSheet(ConstantsLanguage.MARCATURE.stampa());
		int k = 0;
		Row row = sheet.createRow(k++);
		for(int i = 0; i < titles.length; i++) {
			Cell cell = row.createCell(i, CellType.STRING);
			ApplicationUtil.headerCell(s, cell,  titles[i]);
		}
		sheet.setAutoFilter(new CellRangeAddress(0, 0, 0, titles.length-1));
		sheet.createFreezePane(0, 1);
		Iterator<Marcatura> objIter = data.iterator();
		while(objIter.hasNext()) {
			Marcatura prd = objIter.next();
			row = sheet.createRow(k++);
			ExcelFormatList lista = new ExcelFormatList();
			lista.addValore(prd.getId().toString());
			lista.addValore(prd.getUser().getDenominazione());
			lista.addValore(prd.getDurata());
			lista.addValore(prd.getDurataTime());
			lista.addValore(ConstantsFormat.date.stampa(), prd.getData_creazione());
			lista.addValore(ConstantsFormat.time.stampa(), prd.getData_inizio());
			lista.addValore(ConstantsFormat.time.stampa(), prd.getData_fine());
			for (int j = 0; j < lista.size(); j++) {
				ExcelFormat el = lista.get(j);
				Cell cell = row.createCell(j, el.getCellType());
				ApplicationUtil.cellStamper(s, cell, el);
			}
		}
		sheet.setDefaultColumnWidth(20);
		ApplicationUtil.passwordXLS(wb, result, password);
		
	}
	public static void esportaExcelPausa(List<Pausa> data, OutputStream result, String password) throws Exception {
		String [] titles = new ExportUtility().titlesPausa;
		Workbook wb = ApplicationUtil.workbookS();
		ExcelStyle s = new ExcelStyle(wb);
		Sheet sheet = wb.createSheet(ConstantsLanguage.PAUSE.stampa());
		int k = 0;
		Row row = sheet.createRow(k++);
		for(int i = 0; i < titles.length; i++) {
			Cell cell = row.createCell(i, CellType.STRING);
			ApplicationUtil.headerCell(s, cell,  titles[i]);
		}
		sheet.setAutoFilter(new CellRangeAddress(0, 0, 0, titles.length-1));
		sheet.createFreezePane(0, 1);
		Iterator<Pausa> objIter = data.iterator();
		while(objIter.hasNext()) {
			Pausa prd = objIter.next();
			row = sheet.createRow(k++);
			ExcelFormatList lista = new ExcelFormatList();
			lista.addValore(prd.getId().toString());
			lista.addValore(prd.getUser().getDenominazione());
			lista.addValore(prd.getDurata());
			lista.addValore(prd.getDurataTime());
			lista.addValore(ConstantsFormat.date.stampa(), prd.getData_creazione());
			lista.addValore(ConstantsFormat.time.stampa(), prd.getData_inizio());
			lista.addValore(ConstantsFormat.time.stampa(), prd.getData_fine());
			for (int j = 0; j < lista.size(); j++) {
				ExcelFormat el = lista.get(j);
				Cell cell = row.createCell(j, el.getCellType());
				ApplicationUtil.cellStamper(s, cell, el);
			}
		}
		sheet.setDefaultColumnWidth(20);
		ApplicationUtil.passwordXLS(wb, result, password);
		
	}
	public static void esportaExcelOperazione(List<Operazione> data, OutputStream result, String password) throws Exception {
		String [] titles = new ExportUtility().titlesOperazione;
		Workbook wb = ApplicationUtil.workbookS();
		ExcelStyle s = new ExcelStyle(wb);
		Sheet sheet = wb.createSheet(ConstantsLanguage.OPERAZIONI.stampa());
		int k = 0;
		Row row = sheet.createRow(k++);
		for(int i = 0; i < titles.length; i++) {
			Cell cell = row.createCell(i, CellType.STRING);
			ApplicationUtil.headerCell(s, cell,  titles[i]);
		}
		sheet.setAutoFilter(new CellRangeAddress(0, 0, 0, titles.length-1));
		sheet.createFreezePane(0, 1);
		Iterator<Operazione> objIter = data.iterator();
		while(objIter.hasNext()) {
			Operazione prd = objIter.next();
			row = sheet.createRow(k++);
			ExcelFormatList lista = new ExcelFormatList();
			lista.addValore(prd.getId().toString());
			lista.addValore(prd.getUser().getDenominazione());
			lista.addValore(ConstantsFormat.dateTime.stampa(), prd.getData_creazione());
			lista.addValore(Message.addCatalogMessage(prd.getOperazioneTesto()));
			lista.addValore(prd.getDescrizioneLong());
			for (int j = 0; j < lista.size(); j++) {
				ExcelFormat el = lista.get(j);
				Cell cell = row.createCell(j, el.getCellType());
				ApplicationUtil.cellStamper(s, cell, el);
			}
		}
		sheet.setDefaultColumnWidth(20);
		ApplicationUtil.passwordXLS(wb, result, password);
		
	}
	public static void esportaExcelAutoContatto(List<AutoContatto> data, OutputStream result, String password) throws Exception {
		String [] titles = new ExportUtility().titlesAutoContatto;
		Workbook wb = ApplicationUtil.workbookS();
		ExcelStyle s = new ExcelStyle(wb);
		Sheet sheet = wb.createSheet(ConstantsLanguage.AUTO_CONTATTI.stampa());
		int k = 0;
		Row row = sheet.createRow(k++);
		for(int i = 0; i < titles.length; i++) {
			Cell cell = row.createCell(i, CellType.STRING);
			ApplicationUtil.headerCell(s, cell,  titles[i]);
		}
		sheet.setAutoFilter(new CellRangeAddress(0, 0, 0, titles.length-1));
		sheet.createFreezePane(0, 1);
		Iterator<AutoContatto> objIter = data.iterator();
		while(objIter.hasNext()) {
			AutoContatto prd = objIter.next();
			row = sheet.createRow(k++);
			ExcelFormatList lista = new ExcelFormatList();
			lista.addValore(prd.getId().toString());
			lista.addValore(prd.getContatto().getCampagna_denominazione());
			lista.addValore(prd.getContatto().getLista_denominazione());
			lista.addValore(ConstantsFormat.dateTime.stampa(), prd.getData_creazione());
			lista.addValore(prd.getContatto().getDenominazione());
			lista.addValore(prd.getCaller1());
			lista.addValore(prd.getCallee1());
			lista.addValore(prd.getCaller2());
			lista.addValore(prd.getCallee2());
			lista.addValore(prd.getRingingS());
			lista.addValore(prd.getInboundS());
			lista.addValore(Message.addCatalogText(prd.getStatoContatto()));
			lista.addValore(prd.getCause());
			lista.addValore(prd.getTentativi());
			lista.addValore(prd.getSecondi_avvio());
			lista.addValore(ConstantsFormat.seconds.stampa(), prd.getSecondi_avvio());
			lista.addValore(prd.getSecondi_chiamata());
			lista.addValore(ConstantsFormat.seconds.stampa(),prd.getSecondi_chiamata());
			lista.addValore(prd.getSecondi_conversazione());
			lista.addValore(ConstantsFormat.seconds.stampa(),prd.getSecondi_conversazione());
			lista.addValore(prd.getSecondi_totale());
			lista.addValore(ConstantsFormat.seconds.stampa(),prd.getSecondi_totale());
			lista.addValore(ConstantsFormat.dateSeconds.stampa(), prd.getData_avvio());
			lista.addValore(ConstantsFormat.dateSeconds.stampa(), prd.getData_chiamata());
			lista.addValore(ConstantsFormat.dateSeconds.stampa(), prd.getData_risposta());
			lista.addValore(ConstantsFormat.dateSeconds.stampa(), prd.getData_gestione());
			lista.addValore(ConstantsFormat.dateSeconds.stampa(), prd.getData_apertura());
			lista.addValore(ConstantsFormat.dateSeconds.stampa(), prd.getData_attesa());
			lista.addValore(ConstantsFormat.dateSeconds.stampa(), prd.getData_aggancio());
			lista.addValore(ConstantsFormat.dateSeconds.stampa(), prd.getData_rifiuto());
			lista.addValore(ConstantsFormat.dateSeconds.stampa(), prd.getData_link());
			for (int j = 0; j < lista.size(); j++) {
				ExcelFormat el = lista.get(j);
				Cell cell = row.createCell(j, el.getCellType());
				ApplicationUtil.cellStamper(s, cell, el);
			}
		}
		sheet.setDefaultColumnWidth(20);
		ApplicationUtil.passwordXLS(wb, result, password);
		
	}
	public static void esportaExcelNota(List<Nota> data, OutputStream result, String password) throws Exception {
		String [] titles = new ExportUtility().titlesNota;
		Workbook wb = ApplicationUtil.workbookS();
		ExcelStyle s = new ExcelStyle(wb);
		Sheet sheet = wb.createSheet(ConstantsLanguage.NOTE.stampa());
		int k = 0;
		Row row = sheet.createRow(k++);
		for(int i = 0; i < titles.length; i++) {
			Cell cell = row.createCell(i, CellType.STRING);
			ApplicationUtil.headerCell(s, cell,  titles[i]);
		}
		sheet.setAutoFilter(new CellRangeAddress(0, 0, 0, titles.length-1));
		sheet.createFreezePane(0, 1);
		Iterator<Nota> objIter = data.iterator();
		while(objIter.hasNext()) {
			Nota prd = objIter.next();
			row = sheet.createRow(k++);
			ExcelFormatList lista = new ExcelFormatList();
			lista.addValore(prd.getId().toString());
			lista.addValore(ConstantsFormat.dateTime.stampa(), prd.getData_creazione());
			lista.addValore(prd.getBloccatoS());
			lista.addValore(prd.getOperatore().getDenominazione());
			lista.addValore(prd.getNote());
			lista.addValore(prd.getAgente().getDenominazione());
			lista.addValore(ConstantsFormat.date.stampa(), prd.getData_inizio());
			lista.addValore(ConstantsFormat.time.stampa(), prd.getData_inizio());
			lista.addValore(ConstantsFormat.time.stampa(), prd.getData_fine());
			lista.addValore(prd.getRipetizioni());
			lista.addValore(ConstantsFormat.date.stampa(), prd.getData_termine());
			lista.addValore(prd.getColore());
			for (int j = 0; j < lista.size(); j++) {
				ExcelFormat el = lista.get(j);
				Cell cell = row.createCell(j, el.getCellType());
				ApplicationUtil.cellStamper(s, cell, el);
			}
		}
		sheet.setDefaultColumnWidth(20);
		ApplicationUtil.passwordXLS(wb, result, password);
		
	}
	public static void esportaExcelContattoSI(List<ContattoSI> data1,List<ContattoSI> data2 , OutputStream result, String password) throws Exception {
		String [] titles = new ExportUtility().titlesContattoSI;
		Workbook wb = ApplicationUtil.workbookS();
		ExcelStyle s = new ExcelStyle(wb);
		Sheet sheet = wb.createSheet(ConstantsLanguage.CONTATTI.stampa());
		int k = 0;
		Row row = sheet.createRow(k++);
		for(int i = 0; i < titles.length; i++) {
			Cell cell = row.createCell(i, CellType.STRING);
			ApplicationUtil.headerCell(s, cell,  titles[i]);
		}
		sheet.setAutoFilter(new CellRangeAddress(0, 0, 0, titles.length-1));
		sheet.createFreezePane(0, 1);
		for(int i = 0; i < data1.size(); i++) {
			row = sheet.createRow(k++);
			ContattoSI prd = data1.get(i);
			ExcelFormatList lista = new ExcelFormatList();
			lista.addValore(ConstantsLanguage.NO.stampa());
			lista.addValore(prd.getId().toString());
			lista.addValore(prd.getCampagna_denominazione());
			lista.addValore(prd.getLista_denominazione());
			lista.addValore(prd.getAnagrafica_denominazione());
			lista.addValore(prd.getAnagrafica_cognome());
			lista.addValore(prd.getAnagrafica_nome());
			lista.addValore(prd.getAnagrafica_email());
			lista.addValore(prd.getAnagrafica_link());
			lista.addValore(prd.getAnagrafica_telefono_fisso());
			lista.addValore(prd.getAnagrafica_telefono_mobile());
			lista.addValore(prd.getAnagrafica_telefono_fax());
			lista.addValore(prd.getAnagrafica_telefono_altro());
			lista.addValore(prd.getAnagrafica_codice_fiscale());
			lista.addValore(prd.getAnagrafica_partita_iva());
			lista.addValore(prd.getEsito_chiamata_etichettaCodice());
			lista.addValore(prd.getEsito_archiviazione_etichettaCodice());
			lista.addValore(prd.getChiuso());
			for (int j = 0; j < lista.size(); j++) {
				ExcelFormat el = lista.get(j);
				Cell cell = row.createCell(j, el.getCellType());
				ApplicationUtil.cellStamper(s, cell, el);
			}
		}
		for(int i = 0; i < data2.size(); i++) {
			row = sheet.createRow(k++);
			ContattoSI prd = data2.get(i);
			ExcelFormatList lista = new ExcelFormatList();
			lista.addValore(ConstantsLanguage.SI.stampa());
			lista.addValore(prd.getId().toString());
			lista.addValore(prd.getCampagna_denominazione());
			lista.addValore(prd.getLista_denominazione());
			lista.addValore(prd.getAnagrafica_denominazione());
			lista.addValore(prd.getAnagrafica_cognome());
			lista.addValore(prd.getAnagrafica_nome());
			lista.addValore(prd.getAnagrafica_email());
			lista.addValore(prd.getAnagrafica_link());
			lista.addValore(prd.getAnagrafica_telefono_fisso());
			lista.addValore(prd.getAnagrafica_telefono_mobile());
			lista.addValore(prd.getAnagrafica_telefono_fax());
			lista.addValore(prd.getAnagrafica_telefono_altro());
			lista.addValore(prd.getAnagrafica_codice_fiscale());
			lista.addValore(prd.getAnagrafica_partita_iva());
			lista.addValore(prd.getEsito_chiamata_etichettaCodice());
			lista.addValore(prd.getEsito_archiviazione_etichettaCodice());
			lista.addValore(prd.getChiuso());
			for (int j = 0; j < lista.size(); j++) {
				ExcelFormat el = lista.get(j);
				Cell cell = row.createCell(j, el.getCellType());
				ApplicationUtil.cellStamper(s, cell, el);
			}
		}
		sheet.setDefaultColumnWidth(20);
		ApplicationUtil.passwordXLS(wb, result, password);
		
	}
	public static void esportaExcelEmail(List<Email> data, OutputStream result, String password) throws Exception {
		String [] titles = new ExportUtility().titlesEmail;
		Workbook wb = ApplicationUtil.workbookS();
		ExcelStyle s = new ExcelStyle(wb);
		Sheet sheet = wb.createSheet(ConstantsLanguage.EMAIL.stampa());
		int k = 0;
		Row row = sheet.createRow(k++);
		for(int i = 0; i < titles.length; i++) {
			Cell cell = row.createCell(i, CellType.STRING);
			ApplicationUtil.headerCell(s, cell,  titles[i]);
		}
		sheet.setAutoFilter(new CellRangeAddress(0, 0, 0, titles.length-1));
		sheet.createFreezePane(0, 1);
		Iterator<Email> objIter = data.iterator();
		while(objIter.hasNext()) {
			Email prd = objIter.next();
			row = sheet.createRow(k++);
			ExcelFormatList lista = new ExcelFormatList();
			lista.addValore(prd.getId().toString());
			lista.addValore(ConstantsFormat.dateSeconds.stampa(), prd.getData_invio());
			lista.addValore(prd.getContatto().getCampagna_denominazione());
			lista.addValore(prd.getContatto().getLista_denominazione());
			lista.addValore(prd.getContatto().getDenominazione());
			lista.addValore(prd.getDestinatario());
			lista.addValore(prd.getUtente_denominazione());
			lista.addValore(prd.getOggetto());
			lista.addValore(prd.getStato());
			for (int j = 0; j < lista.size(); j++) {
				ExcelFormat el = lista.get(j);
				Cell cell = row.createCell(j, el.getCellType());
				ApplicationUtil.cellStamper(s, cell, el);
			}
		}
		sheet.setDefaultColumnWidth(20);
		ApplicationUtil.passwordXLS(wb, result, password);
		
	}
	
	public static void esportaExcelRmail(List<Rmail> data, OutputStream result, String password) throws Exception {
		String [] titles = new ExportUtility().titlesRmail;
		Workbook wb = ApplicationUtil.workbookS();
		ExcelStyle s = new ExcelStyle(wb);
		Sheet sheet = wb.createSheet(ConstantsLanguage.RMAIL.stampa());
		int k = 0;
		Row row = sheet.createRow(k++);
		for(int i = 0; i < titles.length; i++) {
			Cell cell = row.createCell(i, CellType.STRING);
			ApplicationUtil.headerCell(s, cell,  titles[i]);
		}
		sheet.setAutoFilter(new CellRangeAddress(0, 0, 0, titles.length-1));
		sheet.createFreezePane(0, 1);
		Iterator<Rmail> objIter = data.iterator();
		while(objIter.hasNext()) {
			Rmail prd = objIter.next();
			row = sheet.createRow(k++);
			ExcelFormatList lista = new ExcelFormatList();
			lista.addValore(prd.getId().toString());
			lista.addValore(ConstantsFormat.dateSeconds.stampa(), prd.getData_invio());
			lista.addValore(prd.getContatto().getCampagna_denominazione());
			lista.addValore(prd.getContatto().getLista_denominazione());
			lista.addValore(prd.getContatto().getDenominazione());
			lista.addValore(prd.getDestinatario().getIndirizzo_completo());
			lista.addValore(prd.getUtente_denominazione());
			lista.addValore(prd.getOggettoTemplate());
			lista.addValore(prd.getStato());
			for (int j = 0; j < lista.size(); j++) {
				ExcelFormat el = lista.get(j);
				Cell cell = row.createCell(j, el.getCellType());
				ApplicationUtil.cellStamper(s, cell, el);
			}
		}
		sheet.setDefaultColumnWidth(20);
		ApplicationUtil.passwordXLS(wb, result, password);
		
	}
	
	public static void esportaExcelNotifica(List<Notifica> data, OutputStream result, String password) throws Exception {
		String [] titles = new ExportUtility().titlesNotifica;
		Workbook wb = ApplicationUtil.workbookS();
		ExcelStyle s = new ExcelStyle(wb);
		Sheet sheet = wb.createSheet(ConstantsLanguage.NOTIFICA.stampa());
		int k = 0;
		Row row = sheet.createRow(k++);
		for(int i = 0; i < titles.length; i++) {
			Cell cell = row.createCell(i, CellType.STRING);
			ApplicationUtil.headerCell(s, cell,  titles[i]);
		}
		sheet.setAutoFilter(new CellRangeAddress(0, 0, 0, titles.length-1));
		sheet.createFreezePane(0, 1);
		Iterator<Notifica> objIter = data.iterator();
		while(objIter.hasNext()) {
			Notifica prd = objIter.next();
			row = sheet.createRow(k++);
			ExcelFormatList lista = new ExcelFormatList();
			lista.addValore(prd.getId().toString());
			lista.addValore(ConstantsFormat.dateSeconds.stampa(), prd.getData_invio());
			lista.addValore(prd.getContatto().getCampagna_denominazione());
			lista.addValore(prd.getContatto().getLista_denominazione());
			lista.addValore(prd.getContatto().getDenominazione());
			lista.addValore(prd.getDestinatario());
			lista.addValore(prd.getUtente_denominazione());
			lista.addValore(prd.getOggetto());
			lista.addValore(prd.getStato());
			for (int j = 0; j < lista.size(); j++) {
				ExcelFormat el = lista.get(j);
				Cell cell = row.createCell(j, el.getCellType());
				ApplicationUtil.cellStamper(s, cell, el);
			}
		}
		sheet.setDefaultColumnWidth(20);
		ApplicationUtil.passwordXLS(wb, result, password);
		
	}
	public static void esportaExcelCdr(List<Cdr> data, OutputStream result, String password) throws Exception {
		String [] titles = new ExportUtility().titlesCdr;
		Workbook wb = ApplicationUtil.workbookS();
		ExcelStyle s = new ExcelStyle(wb);
		Sheet sheet = wb.createSheet(ConstantsLanguage.CDR.stampa());
		int k = 0;
		Row row = sheet.createRow(k++);
		for(int i = 0; i < titles.length; i++) {
			Cell cell = row.createCell(i, CellType.STRING);
			ApplicationUtil.headerCell(s, cell,  titles[i]);
		}
		sheet.setAutoFilter(new CellRangeAddress(0, 0, 0, titles.length-1));
		sheet.createFreezePane(0, 1);
		Iterator<Cdr> objIter = data.iterator();
		while(objIter.hasNext()) {
			Cdr prd = objIter.next();
			row = sheet.createRow(k++);
			ExcelFormatList lista = new ExcelFormatList();
			lista.addValore(prd.getId().toString());
			lista.addValore(ConstantsFormat.dateSeconds.stampa(), prd.getCalldate());
			lista.addValore(ConstantsFormat.dateSeconds.stampa(), prd.getAnswerdate());
			lista.addValore(ConstantsFormat.dateSeconds.stampa(), prd.getEnddate());
			lista.addValore(prd.getContattoCampagnaDenominazione());
			lista.addValore(prd.getContattoListaDenominazione());
			lista.addValore(prd.getContattoDenominazione());
			lista.addValore(prd.getUtenteDenominazione());
			lista.addValore(prd.getCaller());
			lista.addValore(prd.getCallee());
			lista.addValore(prd.getTipoText());
			lista.addValore(ConstantsFormat.seconds.stampa(), prd.getDuration());
			lista.addValore(prd.getDuration());
			lista.addValore(ConstantsFormat.seconds.stampa(), prd.getBillsec());
			lista.addValore(prd.getBillsec());
			lista.addValore(prd.getDisposition());
			for (int j = 0; j < lista.size(); j++) {
				ExcelFormat el = lista.get(j);
				Cell cell = row.createCell(j, el.getCellType());
				ApplicationUtil.cellStamper(s, cell, el);
			}
		}
		sheet.setDefaultColumnWidth(20);
		ApplicationUtil.passwordXLS(wb, result, password);
		
	}
	public static void esportaExcelCel(List<Cel> data, OutputStream result, String password) throws Exception {
		String [] titles = new ExportUtility().titlesCel;
		Workbook wb = ApplicationUtil.workbookS();
		ExcelStyle s = new ExcelStyle(wb);
		Sheet sheet = wb.createSheet(ConstantsLanguage.CEL.stampa());
		int k = 0;
		Row row = sheet.createRow(k++);
		for(int i = 0; i < titles.length; i++) {
			Cell cell = row.createCell(i, CellType.STRING);
			ApplicationUtil.headerCell(s, cell,  titles[i]);
		}
		sheet.setAutoFilter(new CellRangeAddress(0, 0, 0, titles.length-1));
		sheet.createFreezePane(0, 1);
		Iterator<Cel> objIter = data.iterator();
		while(objIter.hasNext()) {
			Cel prd = objIter.next();
			row = sheet.createRow(k++);
			ExcelFormatList lista = new ExcelFormatList();
			lista.addValore(prd.getId().toString());
			for (int j = 0; j < lista.size(); j++) {
				ExcelFormat el = lista.get(j);
				Cell cell = row.createCell(j, el.getCellType());
				ApplicationUtil.cellStamper(s, cell, el);
			}
		}
		sheet.setDefaultColumnWidth(20);
		ApplicationUtil.passwordXLS(wb, result, password);
		
	}
	public static void esportaExcelQuery(List<QueryKey> qks, OutputStream result, String password) throws Exception {
		Workbook wb = ApplicationUtil.workbookS();
		ExcelStyle s = new ExcelStyle(wb);
		for(QueryKey qk: qks) {
			if(qk.isValido()) {
				Sheet sheet = wb.createSheet(ConstantsLanguage.QUERY.stampa()  + " " + qk.getId());
				int k = 0;
				List<String> titles = qk.getChiavi();
				Row row = sheet.createRow(k++);
				for(int i = 0; i < titles.size(); i++) {
					Cell cell = row.createCell(i, CellType.STRING);
					ApplicationUtil.headerCell(s, cell,  titles.get(i));
				}
				sheet.setAutoFilter(new CellRangeAddress(0, 0, 0, titles.size()-1));
				sheet.createFreezePane(0, 1);
				for(int i = 0; i < qk.getRighe().size(); i++) {
					row = sheet.createRow(k++);
					for(int j = 0; j < titles.size(); j++) {
						QueryElement o = qk.getMappa().get(titles.get(j)).get(i);
						ExcelFormat a = o != null ? o.toExcel() : new ExcelFormat(null, null);
						Cell cell = row.createCell(j, a.getCellType());
						ApplicationUtil.cellStamper(s, cell, a);
					}
				}
				sheet.setDefaultColumnWidth(20);
			}
		}
		ApplicationUtil.passwordXLS(wb, result, password);
		
	}
	public static void esportaExcelImportAnagrafica(List<Anagrafica> data, OutputStream result, String password) throws Exception {
		String [] titles = new ExportUtility().titlesAnagraficaExport;
		Workbook wb = ApplicationUtil.workbookS();
		ExcelStyle s = new ExcelStyle(wb);
		Sheet sheet = wb.createSheet(ConstantsLanguage.ANAGRAFICHE.stampa());
		int k = 0;
		Row row = sheet.createRow(k++);
		for(int i = 0; i < titles.length; i++) {
			Cell cell = row.createCell(i, CellType.STRING);
			ApplicationUtil.headerCell(s, cell,  titles[i]);
		}
		sheet.setAutoFilter(new CellRangeAddress(0, 0, 0, titles.length-1));
		sheet.createFreezePane(0, 1);
		Iterator<Anagrafica> objIter = data.iterator();
		while(objIter.hasNext()) {
			Anagrafica prd = objIter.next();
			row = sheet.createRow(k++);
			ExcelFormatList lista = new ExcelFormatList();
			lista.addValore(prd.getMotivi());
			lista.addValore(prd.getDenominazione());
			lista.addValore(prd.getCognome());
			lista.addValore(prd.getNome());
			lista.addValore(prd.getEmail());
			lista.addValore(prd.getLink());
			lista.addValore(prd.getCodice_fiscale());
			lista.addValore(prd.getPartita_iva());
			lista.addValore(prd.getTelefono_fisso());
			lista.addValore(prd.getTelefono_mobile());
			lista.addValore(prd.getTelefono_fax());
			lista.addValore(prd.getTelefono_altro());
			lista.addValore(prd.getRagione_sociale());
			lista.addValore(prd.getNome_completo());
			lista.addValore(ConstantsFormat.date.stampa(), prd.getDate_nascita());
			lista.addValore(prd.getLuogo_nascita());
			lista.addValore(prd.getTipo());
			lista.addValore(prd.getSesso());
			lista.addValore(prd.getNota());
			lista.addValore(prd.getSettore());
			lista.addValore(prd.getIndirizzo_legale().getIndirizzo_completo());
			lista.addValore(prd.getIndirizzo_operativo().getIndirizzo_completo());
			for (int j = 0; j < lista.size(); j++) {
				ExcelFormat el = lista.get(j);
				Cell cell = row.createCell(j, el.getCellType());
				ApplicationUtil.cellStamper(s, cell, el);
			}
		}
		sheet.setDefaultColumnWidth(20);
		ApplicationUtil.passwordXLS(wb, result, password);
		
	}
	public static void esportaExcelImportOpposizione(List<Opposizione> data, OutputStream result, String password) throws Exception {
		String [] titles = new ExportUtility().titlesOpposizioneExport;
		Workbook wb = ApplicationUtil.workbookS();
		ExcelStyle s = new ExcelStyle(wb);
		Sheet sheet = wb.createSheet(ConstantsLanguage.OPPOSIZIONI.stampa());
		int k = 0;
		Row row = sheet.createRow(k++);
		for(int i = 0; i < titles.length; i++) {
			Cell cell = row.createCell(i, CellType.STRING);
			ApplicationUtil.headerCell(s, cell,  titles[i]);
		}
		sheet.setAutoFilter(new CellRangeAddress(0, 0, 0, titles.length-1));
		sheet.createFreezePane(0, 1);
		Iterator<Opposizione> objIter = data.iterator();
		while(objIter.hasNext()) {
			Opposizione prd = objIter.next();
			row = sheet.createRow(k++);
			ExcelFormatList lista = new ExcelFormatList();
			lista.addValore(prd.getMotivi());
			lista.addValore(prd.getCampagna_denominazione());
			lista.addValore(prd.getDescrizione());
			lista.addValore(prd.getOpposizione());
			for (int j = 0; j < lista.size(); j++) {
				ExcelFormat el = lista.get(j);
				Cell cell = row.createCell(j, el.getCellType());
				ApplicationUtil.cellStamper(s, cell, el);
			}
		}
		sheet.setDefaultColumnWidth(20);
		ApplicationUtil.passwordXLS(wb, result, password);
		
	}
	public static void esportaExcelImportContatto(List<Contatto> data, TemplateImportContatto ti, OutputStream result, String password) throws Exception {
		List<String> titles =  new ArrayList<String>();
		titles.add(ConstantsLanguage.CHIAVE.stampa() + " - " + Message.addCatalogText(ti.getTipo()));
		titles.addAll(ApplicationUtil.asList(new ExportUtility().titlesContattoExport));
		Workbook wb = ApplicationUtil.workbookS();
		ExcelStyle s = new ExcelStyle(wb);
		Sheet sheet = wb.createSheet(ConstantsLanguage.CONTATTI.stampa());
		int k = 0;
		Row row = sheet.createRow(k++);
		for(int i = 0; i < titles.size(); i++) {
			Cell cell = row.createCell(i, CellType.STRING);
			ApplicationUtil.headerCell(s, cell,  titles.get(i));
		}
		sheet.setAutoFilter(new CellRangeAddress(0, 0, 0, titles.size()-1));
		sheet.createFreezePane(0, 1);
		Iterator<Contatto> objIter = data.iterator();
		while(objIter.hasNext()) {
			Contatto prd = objIter.next();
			row = sheet.createRow(k++);
			ExcelFormatList lista = new ExcelFormatList();
			lista.addValore(prd.getChiave());
			lista.addValore(prd.getMotivi());
			lista.addValore(prd.getNota());
			lista.addValore(ConstantsFormat.dateTime.stampa(), prd.getAnagrafica().getConsenso_tfisso());
			lista.addValore(ConstantsFormat.dateTime.stampa(), prd.getAnagrafica().getConsenso_tmobile());
			lista.addValore(ConstantsFormat.dateTime.stampa(), prd.getAnagrafica().getConsenso_tfax());
			lista.addValore(ConstantsFormat.dateTime.stampa(), prd.getAnagrafica().getConsenso_taltro());
			lista.addValore(ConstantsFormat.dateTime.stampa(), prd.getAnagrafica().getConsenso_email());
			lista.addValore(ConstantsFormat.dateTime.stampa(), prd.getAnagrafica().getConsenso_rmail());
			for (int j = 0; j < lista.size(); j++) {
				ExcelFormat el = lista.get(j);
				Cell cell = row.createCell(j, el.getCellType());
				ApplicationUtil.cellStamper(s, cell, el);
			}
		}
		sheet.setDefaultColumnWidth(20);
		ApplicationUtil.passwordXLS(wb, result, password);
		
	}
	public static void esportaExcelImportContratto(List<Contratto> data, TemplateImportContratto ti, OutputStream result, String password) throws Exception {
		List<String> titles =  new ArrayList<String>();
		titles.add(ConstantsLanguage.CHIAVE.stampa() + " - " + Message.addCatalogText(ti.getTipo()));
		titles.addAll(ApplicationUtil.asList(new ExportUtility().titlesContrattoExport));
		Workbook wb = ApplicationUtil.workbookS();
		ExcelStyle s = new ExcelStyle(wb);
		Sheet sheet = wb.createSheet(ConstantsLanguage.CONTRATTI.stampa());
		int k = 0;
		Row row = sheet.createRow(k++);
		for(int i = 0; i < titles.size(); i++) {
			Cell cell = row.createCell(i, CellType.STRING);
			ApplicationUtil.headerCell(s, cell,  titles.get(i));
		}
		sheet.setAutoFilter(new CellRangeAddress(0, 0, 0, titles.size()-1));
		sheet.createFreezePane(0, 1);
		Iterator<Contratto> objIter = data.iterator();
		while(objIter.hasNext()) {
			Contratto prd = objIter.next();
			row = sheet.createRow(k++);
			ExcelFormatList lista = new ExcelFormatList();
			lista.addValore(prd.getChiave());
			lista.addValore(prd.getMotivi());
			lista.addValore(ConstantsFormat.date.stampa(), prd.getData_contabile());
			lista.addValore(ConstantsFormat.date.stampa(), prd.getData_stipula());
			lista.addValore(ConstantsFormat.date.stampa(), prd.getData_attivazione());
			lista.addValore(ConstantsFormat.date.stampa(), prd.getData_caricamento());
			lista.addValore(prd.getQuantita());
			lista.addValore(prd.getCosto_scontato());
			lista.addValore(prd.getNota());
			for (int j = 0; j < lista.size(); j++) {
				ExcelFormat el = lista.get(j);
				Cell cell = row.createCell(j, el.getCellType());
				ApplicationUtil.cellStamper(s, cell, el);
			}
		}
		sheet.setDefaultColumnWidth(20);
		ApplicationUtil.passwordXLS(wb, result, password);
		
	}
	public static void esportaExcelImportAppuntamento(List<Appuntamento> data,  TemplateImportAppuntamento ti, OutputStream result, String password) throws Exception {
		List<String> titles =  new ArrayList<String>();
		titles.add(ConstantsLanguage.CHIAVE.stampa() + " - " + Message.addCatalogText(ti.getTipo()));
		titles.addAll(ApplicationUtil.asList(new ExportUtility().titlesAppuntamentoExport));
		Workbook wb = ApplicationUtil.workbookS();
		ExcelStyle s = new ExcelStyle(wb);
		Sheet sheet = wb.createSheet(ConstantsLanguage.APPUNTAMENTI.stampa());
		int k = 0;
		Row row = sheet.createRow(k++);
		for(int i = 0; i < titles.size(); i++) {
			Cell cell = row.createCell(i, CellType.STRING);
			ApplicationUtil.headerCell(s, cell,  titles.get(i));
		}
		sheet.setAutoFilter(new CellRangeAddress(0, 0, 0, titles.size()-1));
		sheet.createFreezePane(0, 1);
		Iterator<Appuntamento> objIter = data.iterator();
		while(objIter.hasNext()) {
			Appuntamento prd = objIter.next();
			row = sheet.createRow(k++);
			ExcelFormatList lista = new ExcelFormatList();
			lista.addValore(prd.getChiave());
			lista.addValore(prd.getMotivi());
			lista.addValore(ConstantsFormat.dateTime.stampa(), prd.getData_appuntamento());
			lista.addValore(prd.getNota());
			for (int j = 0; j < lista.size(); j++) {
				ExcelFormat el = lista.get(j);
				Cell cell = row.createCell(j, el.getCellType());
				ApplicationUtil.cellStamper(s, cell, el);
			}
		}
		sheet.setDefaultColumnWidth(20);
		ApplicationUtil.passwordXLS(wb, result, password);
		
	}
	public static void esportaExcelStoriaContratto(List<StoriaContratto> data, AnagraficaDao anagraficaDao, List<Long> campiA, List<Long> campiB, OutputStream result, String password) throws Exception {
		String [] titles = new ExportUtility().titlesStoriaContratto;
		Workbook wb = ApplicationUtil.workbookS();
		ExcelStyle s = new ExcelStyle(wb);
		if(ApplicationUtil.empty(campiA)) {
			campiA = new ArrayList<Long>();
		}
		if(ApplicationUtil.empty(campiB)) {
			campiB = new ArrayList<Long>();
		}
		Long [] campiChiave = new Long[campiB.size() + campiA.size()];
		String [] campiEtichette = new String[campiB.size() + campiA.size()];
		for (int i = 0; i < campiB.size(); i++) {
			campiChiave[i] = campiB.get(i);
			campiEtichette[i] = anagraficaDao.getEtichettaById(CampoAggiuntivoAnagrafica.class, campiB.get(i));
		}	
		for (int i = 0; i < campiA.size(); i++) {
			campiChiave[campiB.size() + i] = campiA.get(i);
			campiEtichette[campiB.size() + i] = anagraficaDao.getEtichettaById(CampoAggiuntivoContratto.class, campiA.get(i));
		}	
		if(ApplicationUtil.notEmpty(campiChiave)) {
			data = anagraficaDao.loadFullStoriaContratto(data);
		}
		String[] titlesLun = ApplicationUtil.addArray(titles, campiEtichette);
		Sheet sheet = wb.createSheet(ConstantsLanguage.STORIA.stampa() + " " + ConstantsLanguage.CONTRATTI.stampa());
		int k = 0;
		Row row = sheet.createRow(k++);
		for (int i = 0; i < titlesLun.length; i++) {
			Cell cell = row.createCell(i, CellType.STRING);
			ApplicationUtil.headerCell(s, cell,  titlesLun[i]);
		}
		sheet.setAutoFilter(new CellRangeAddress(0, 0, 0, titlesLun.length-1));
		sheet.createFreezePane(0, 1);
		Iterator<StoriaContratto> objIter = data.iterator();
		while(objIter.hasNext()) {
			StoriaContratto prd = objIter.next();
			row = sheet.createRow(k++);
			ExcelFormatList lista = new ExcelFormatList();
			lista.addValore(prd.getId().toString());
			lista.addValore(ConstantsFormat.dateSeconds.stampa(), prd.getData());
			lista.addValore(prd.getBloccatoS());
			lista.addValore(prd.getContratto().getContatto().getCampagna_denominazione());
			lista.addValore(prd.getContratto().getContatto().getLista_denominazione());
			lista.addValore(prd.getEsitoEtichettaCodice());
			lista.addValore(prd.getContratto().getContatto().getAnagrafica().getDenominazione());
			lista.addValore(prd.getContratto().getContatto().getAnagrafica().getCognome());
			lista.addValore(prd.getContratto().getContatto().getAnagrafica().getNome());
			lista.addValore(prd.getContratto().getContatto().getAnagrafica().getEmail());
			lista.addValore(prd.getContratto().getContatto().getAnagrafica().getTelefono_fisso());
			lista.addValore(prd.getContratto().getContatto().getAnagrafica().getTelefono_mobile());
			lista.addValore(prd.getContratto().getContatto().getAnagrafica().getTelefono_fax());
			lista.addValore(prd.getContratto().getContatto().getAnagrafica().getTelefono_altro());
			lista.addValore(prd.getOperatore_denominazione());
			lista.addValore(prd.getAgente_denominazione());
			lista.addValore(prd.getUtente_denominazione());
			lista.addValore(prd.getNota());
			lista.addValore(prd.getStatoTesto());
			lista.addValore(prd.getSeriale());
			lista.addValore(prd.getCategoria_denominazione());
			lista.addValore(prd.getProdotto_denominazione());
			lista.addValore(prd.getQuantita());
			lista.addValore(prd.getCosto_scontato());
			lista.addValore(ConstantsFormat.date.stampa(), prd.getData_contabile());
			lista.addValore(ConstantsFormat.date.stampa(), prd.getData_stipula());
			lista.addValore(ConstantsFormat.date.stampa(), prd.getData_attivazione());
			lista.addValore(ConstantsFormat.date.stampa(), prd.getData_caricamento());
			lista.addValore(ConstantsFormat.dateTime.stampa(), prd.getData_esito());
			lista.addValore(ConstantsFormat.dateTime.stampa(), prd.getData_stato());
			lista.addValore(prd.getContratto().getContatto().getAnagrafica().getIndirizzo_legale().getIndirizzo_completo());
			lista.addValore(prd.getContratto().getContatto().getAnagrafica().getIndirizzo_operativo().getIndirizzo_completo());
			for (int i = titles.length; i < titlesLun.length; i++) {
				stampaDato(lista, campiChiave[i-titles.length],  prd.getContratto().getContatto().getAnagrafica().getDettagli(), prd.getContratto().getDettagli());
			}
			for (int j = 0; j < lista.size(); j++) {
				ExcelFormat el = lista.get(j);
				Cell cell = row.createCell(j, el.getCellType());
				ApplicationUtil.cellStamper(s, cell, el);
			}
			
		}
		sheet.setDefaultColumnWidth(20);
		ApplicationUtil.passwordXLS(wb, result, password);
		
	}
	public static void esportaExcelStoriaContatto(List<StoriaContatto> data, AnagraficaDao anagraficaDao, List<Long> campis, OutputStream result, String password) throws Exception {
		String [] titles = new ExportUtility().titlesStoriaContatto;
		Workbook wb = ApplicationUtil.workbookS();
		ExcelStyle s = new ExcelStyle(wb);
		if(ApplicationUtil.empty(campis)) {
			campis = new ArrayList<Long>();
		}
		Long [] campiChiave = new Long[campis.size()];
		String [] campiEtichette = new String[campis.size()];
		for (int i = 0; i < campis.size(); i++) {
			campiChiave[i] = campis.get(i);
			campiEtichette[i] = anagraficaDao.getEtichettaById(CampoAggiuntivoAnagrafica.class, campis.get(i));
		}	
		if(ApplicationUtil.notEmpty(campiChiave)) {
			data = anagraficaDao.loadFullStoriaContatto(data);
		}
		String[] titlesLun = ApplicationUtil.addArray(titles, campiEtichette);
		Sheet sheet = wb.createSheet(ConstantsLanguage.STORIA.stampa() + " " + ConstantsLanguage.CONTATTI.stampa());
		int k = 0;
		Row row = sheet.createRow(k++);
		for (int i = 0; i < titlesLun.length; i++) {
			Cell cell = row.createCell(i, CellType.STRING);
			ApplicationUtil.headerCell(s, cell,  titlesLun[i]);
		}
		sheet.setAutoFilter(new CellRangeAddress(0, 0, 0, titlesLun.length-1));
		sheet.createFreezePane(0, 1);
		Iterator<StoriaContatto> objIter = data.iterator();
		while(objIter.hasNext()) {
			StoriaContatto prd = objIter.next();
			row = sheet.createRow(k++);
			ExcelFormatList lista = new ExcelFormatList();
			lista.addValore(prd.getId().toString());
			lista.addValore(ConstantsFormat.dateSeconds.stampa(), prd.getData());
			lista.addValore(prd.getBloccatoS());
			lista.addValore(prd.getCampagna_denominazione());
			lista.addValore(prd.getLista_denominazione());
			lista.addValore(prd.getEsito_chiamata_etichettaCodice());
			lista.addValore(prd.getEsito_archiviazione_etichettaCodice());
			lista.addValore(prd.getContatto().getAnagrafica().getDenominazione());
			lista.addValore(prd.getContatto().getAnagrafica().getCognome());
			lista.addValore(prd.getContatto().getAnagrafica().getNome());
			lista.addValore(prd.getContatto().getAnagrafica().getEmail());
			lista.addValore(prd.getContatto().getAnagrafica().getTelefono_fisso());
			lista.addValore(prd.getContatto().getAnagrafica().getTelefono_mobile());
			lista.addValore(prd.getContatto().getAnagrafica().getTelefono_fax());
			lista.addValore(prd.getContatto().getAnagrafica().getTelefono_altro());
			lista.addValore(prd.getProprietario_denominazione());
			lista.addValore(prd.getAgente_denominazione());
			lista.addValore(prd.getOperatore_denominazione());
			lista.addValore(prd.getChiuso());
			lista.addValore(ConstantsFormat.dateTime.stampa(), prd.getData_presentazione());
			lista.addValore(ConstantsFormat.dateTime.stampa(), prd.getData_archiviazione());
			lista.addValore(prd.getNota());
			lista.addValore(prd.getTipoTesto());
			lista.addValore(prd.getSecondi_tot());
			lista.addValore(ConstantsFormat.seconds.stampa(),prd.getSecondi_tot());
			lista.addValore(prd.getSecondi_conv_eff());
			lista.addValore(ConstantsFormat.seconds.stampa(),prd.getSecondi_conv_eff());
			lista.addValore(prd.getSecondi_conv_tot());
			lista.addValore(ConstantsFormat.seconds.stampa(),prd.getSecondi_conv_tot());
			lista.addValore(prd.getSecondi_post());
			lista.addValore(ConstantsFormat.seconds.stampa(),prd.getSecondi_post());
			lista.addValore(prd.getSecondi_pre());
			lista.addValore(ConstantsFormat.seconds.stampa(), prd.getSecondi_pre());
			lista.addValore(prd.getSecondi_rec());
			lista.addValore(ConstantsFormat.seconds.stampa(),prd.getSecondi_rec());
			lista.addValore(prd.getSecondi_attesa());
			lista.addValore(ConstantsFormat.seconds.stampa(),prd.getSecondi_attesa());
			lista.addValore(ConstantsFormat.dateSeconds.stampa(), prd.getDate_apertura());
			lista.addValore(ConstantsFormat.dateSeconds.stampa(), prd.getDate_chiamata());
			lista.addValore(ConstantsFormat.dateSeconds.stampa(), prd.getDate_risposta());
			lista.addValore(ConstantsFormat.dateSeconds.stampa(), prd.getDate_rec_inizio());
			lista.addValore(ConstantsFormat.dateSeconds.stampa(), prd.getDate_rec_fine());
			lista.addValore(ConstantsFormat.dateSeconds.stampa(), prd.getDate_fine());
			lista.addValore(ConstantsFormat.dateSeconds.stampa(), prd.getDate_esito());
			lista.addValore(ConstantsFormat.dateSeconds.stampa(), prd.getDate_attesa_inizio());
			lista.addValore(ConstantsFormat.dateSeconds.stampa(), prd.getDate_attesa_fine());
			lista.addValore(prd.getContatto().getAnagrafica().getIndirizzo_legale().getIndirizzo_completo());
			lista.addValore(prd.getContatto().getAnagrafica().getIndirizzo_operativo().getIndirizzo_completo());
			for (int i = titles.length; i < titlesLun.length; i++) {
				stampaDato(lista, campiChiave[i-titles.length],  prd.getContatto().getAnagrafica().getDettagli(), null);
			}
			for (int j = 0; j < lista.size(); j++) {
				ExcelFormat el = lista.get(j);
				Cell cell = row.createCell(j, el.getCellType());
				ApplicationUtil.cellStamper(s, cell, el);
			}
		}
		sheet.setDefaultColumnWidth(20);
		ApplicationUtil.passwordXLS(wb, result, password);
		
	}
	public static void esportaExcelStoriaAppuntamento(List<StoriaAppuntamento> data, AnagraficaDao anagraficaDao, List<Long> campis, OutputStream result, String password) throws Exception {
		String [] titles = new ExportUtility().titlesStoriaAppuntamento;
		Workbook wb = ApplicationUtil.workbookS();
		ExcelStyle s = new ExcelStyle(wb);
		if(ApplicationUtil.empty(campis)) {
			campis = new ArrayList<Long>();
		}
		Long [] campiChiave = new Long[campis.size()];
		String [] campiEtichette = new String[campis.size()];
		for (int i = 0; i < campis.size(); i++) {
			campiChiave[i] = campis.get(i);
			campiEtichette[i] = anagraficaDao.getEtichettaById(CampoAggiuntivoAnagrafica.class, campis.get(i));
		}	
		if(ApplicationUtil.notEmpty(campiChiave)) {
			data = anagraficaDao.loadFullStoriaAppuntamento(data);
		}
		String[] titlesLun = ApplicationUtil.addArray(titles, campiEtichette);
		Sheet sheet = wb.createSheet(ConstantsLanguage.STORIA.stampa() + " " + ConstantsLanguage.APPUNTAMENTI.stampa());
		int k = 0;
		Row row = sheet.createRow(k++);
		for (int i = 0; i < titlesLun.length; i++) {
			Cell cell = row.createCell(i, CellType.STRING);
			ApplicationUtil.headerCell(s, cell,  titlesLun[i]);
		}
		sheet.setAutoFilter(new CellRangeAddress(0, 0, 0, titlesLun.length-1));
		sheet.createFreezePane(0, 1);
		Iterator<StoriaAppuntamento> objIter = data.iterator();
		while(objIter.hasNext()) {
			StoriaAppuntamento prd = objIter.next();
			row = sheet.createRow(k++);
			ExcelFormatList lista = new ExcelFormatList();
			lista.addValore(prd.getId().toString());
			lista.addValore(ConstantsFormat.dateSeconds.stampa(), prd.getData());
			lista.addValore(prd.getBloccatoS());
			lista.addValore(prd.getAppuntamento().getContatto().getCampagna_denominazione());
			lista.addValore(prd.getAppuntamento().getContatto().getLista_denominazione());
			lista.addValore(prd.getEsitoEtichettaCodice());
			lista.addValore(prd.getAppuntamento().getContatto().getAnagrafica().getDenominazione());
			lista.addValore(prd.getAppuntamento().getContatto().getAnagrafica().getCognome());
			lista.addValore(prd.getAppuntamento().getContatto().getAnagrafica().getNome());
			lista.addValore(prd.getAppuntamento().getContatto().getAnagrafica().getEmail());
			lista.addValore(prd.getAppuntamento().getContatto().getAnagrafica().getTelefono_fisso());
			lista.addValore(prd.getAppuntamento().getContatto().getAnagrafica().getTelefono_mobile());
			lista.addValore(prd.getAppuntamento().getContatto().getAnagrafica().getTelefono_fax());
			lista.addValore(prd.getAppuntamento().getContatto().getAnagrafica().getTelefono_altro());
			lista.addValore(prd.getOperatore_denominazione());
			lista.addValore(prd.getAgente_denominazione());
			lista.addValore(prd.getUtente_denominazione());
			lista.addValore(prd.getNota());
			lista.addValore(prd.getStatoTesto());
			lista.addValore(ConstantsFormat.date.stampa(), prd.getData_inizio());
			lista.addValore(ConstantsFormat.time.stampa(), prd.getData_inizio());
			lista.addValore(ConstantsFormat.time.stampa(), prd.getData_fine());
			lista.addValore(ConstantsFormat.dateTime.stampa(), prd.getData_conferma());
			lista.addValore(ConstantsFormat.dateTime.stampa(), prd.getData_esito());
			lista.addValore(ConstantsFormat.dateTime.stampa(), prd.getData_stato());
			lista.addValore(prd.getLocalizzazioneString());
			lista.addValore(prd.getAppuntamento().getContatto().getAnagrafica().getIndirizzo_legale().getIndirizzo_completo());
			lista.addValore(prd.getAppuntamento().getContatto().getAnagrafica().getIndirizzo_operativo().getIndirizzo_completo());
			for (int i = titles.length; i < titlesLun.length; i++) {
				stampaDato(lista, campiChiave[i-titles.length],  prd.getAppuntamento().getContatto().getAnagrafica().getDettagli(), null);
			}
			for (int j = 0; j < lista.size(); j++) {
				ExcelFormat el = lista.get(j);
				Cell cell = row.createCell(j, el.getCellType());
				ApplicationUtil.cellStamper(s, cell, el);
			}
		}
		sheet.setDefaultColumnWidth(20);
		ApplicationUtil.passwordXLS(wb, result, password);
		
	}
	public static void esportaExcelStoriaAppuntamentoTemplate(Boolean p, List<StoriaAppuntamento> data, AnagraficaDao anagraficaDao, TemplateExportStoriaAppuntamento ti, OutputStream result, String password) throws Exception {
		List <String> titlesList = ti.getValore_multiplo();
		List <String> aggiuntivi = ListUtils.subtract(titlesList, new ArrayList<String>(ConstantsMap.storiaAppuntamentoMap));
		if(p!=null && ApplicationUtil.notEmpty(aggiuntivi)) {
			List <String> invA = anagraficaDao.getEtichetteInvisibiliByChiave(p, CampoAggiuntivoAnagrafica.class);
			aggiuntivi.removeAll(invA);
			titlesList.removeAll(invA);
		}
		if(ApplicationUtil.notEmpty(aggiuntivi)) {
			data = anagraficaDao.loadFullStoriaAppuntamento(data);
		}
		String[] titles = titlesList.toArray(new String[0]);
		Workbook wb = ApplicationUtil.workbookS();
		ExcelStyle s = new ExcelStyle(wb);
		Sheet sheet = wb.createSheet(ConstantsLanguage.STORIA.stampa() + " " + ConstantsLanguage.APPUNTAMENTI.stampa());
		int k = 0;
		Row row = null;
		if(ti.getIntestazione()) {
			row = sheet.createRow(k++);
			for (int i = 0; i < titles.length; i++) {
				Cell cell = row.createCell(i, CellType.STRING);
				if(ApplicationUtil.notEmpty(aggiuntivi) && aggiuntivi.contains(titles[i])) {
					String etichetta = anagraficaDao.getEtichettaByChiave(CampoAggiuntivoAnagrafica.class, titles[i]);
					ApplicationUtil.headerCell(s, cell,  etichetta);
				} else {
					ApplicationUtil.headerCell(s, cell,  Message.addCatalogText(titles[i]));
				}
			}
			sheet.setAutoFilter(new CellRangeAddress(0, 0, 0, titles.length-1));
			sheet.createFreezePane(0, 1);
		} else {
			row = sheet.createRow(k);
		}
		Iterator<StoriaAppuntamento> objIter = data.iterator();
		while(objIter.hasNext()) {
			StoriaAppuntamento sapp = objIter.next();
			Appuntamento app = sapp.getAppuntamento();
			Contatto cnt = app.getContatto();
			row = sheet.createRow(k++);
			ExcelFormatList lista = new ExcelFormatList();
			for (int j = 0; j < titles.length; j++) {
				if(ti.getPosizione(ConstantsMap.storia_appuntamento_id).equals(j)) {
					lista.addValore(sapp.getId().toString());
				} else if(ti.getPosizione(ConstantsMap.storia_appuntamento_operatore_denominazione).equals(j)) {
					lista.addValore(sapp.getOperatore_denominazione());
				} else if(ti.getPosizione(ConstantsMap.storia_appuntamento_bloccato).equals(j)) {
					lista.addValore(sapp.getBloccatoS());
				} else if(ti.getPosizione(ConstantsMap.storia_appuntamento_operatore_codice).equals(j)) {
					lista.addValore(sapp.getOperatore_codice());
				} else if(ti.getPosizione(ConstantsMap.storia_appuntamento_agente_denominazione).equals(j)) {
					lista.addValore(sapp.getAgente_denominazione());
				} else if(ti.getPosizione(ConstantsMap.storia_appuntamento_agente_codice).equals(j)) {
					lista.addValore(sapp.getAgente_codice());
				} else if(ti.getPosizione(ConstantsMap.storia_appuntamento_nota).equals(j)) {
					lista.addValore(sapp.getNota());
				} else if(ti.getPosizione(ConstantsMap.storia_appuntamento_data).equals(j)) {
					lista.addValore(ConstantsFormat.dateSeconds.stampa(), sapp.getData());
				} else if(ti.getPosizione(ConstantsMap.storia_appuntamento_data_inizio).equals(j)) {
					lista.addValore(ConstantsFormat.dateTime.stampa(), sapp.getData_inizio());
				} else if(ti.getPosizione(ConstantsMap.storia_appuntamento_data_fine).equals(j)) {
					lista.addValore(ConstantsFormat.dateTime.stampa(), sapp.getData_fine());
				} else if(ti.getPosizione(ConstantsMap.storia_appuntamento_data_conferma).equals(j)) {
					lista.addValore(ConstantsFormat.dateTime.stampa(), sapp.getData_conferma());
				} else if(ti.getPosizione(ConstantsMap.storia_appuntamento_localizzazione).equals(j)) {
					lista.addValore(sapp.getLocalizzazioneString());
				} else if(ti.getPosizione(ConstantsMap.storia_appuntamento_utente_denominazione).equals(j)) {
					lista.addValore(sapp.getUtente_denominazione());
				} else if(ti.getPosizione(ConstantsMap.storia_appuntamento_utente_codice).equals(j)) {
					lista.addValore(sapp.getUtente_codice());
				} else if(ti.getPosizione(ConstantsMap.storia_appuntamento_data_esito).equals(j)) {
					lista.addValore(ConstantsFormat.dateTime.stampa(), sapp.getData_esito());
				} else if(ti.getPosizione(ConstantsMap.storia_appuntamento_data_stato).equals(j)) {
					lista.addValore(ConstantsFormat.dateTime.stampa(), sapp.getData_stato());
				} else if(ti.getPosizione(ConstantsMap.storia_appuntamento_esito_appuntamento).equals(j)) {
					lista.addValore(sapp.getEsitoEtichetta());
				} else if(ti.getPosizione(ConstantsMap.storia_appuntamento_codice_appuntamento).equals(j)) {
					lista.addValore(sapp.getEsitoCodice());
				} else if(ti.getPosizione(ConstantsMap.storia_appuntamento_stato).equals(j)) {
					lista.addValore(sapp.getStatoTesto());
				} else if(ti.getPosizione(ConstantsMap.appuntamento_id).equals(j)) {
					lista.addValore(app.getId().toString());
				} else if(ti.getPosizione(ConstantsMap.appuntamento_operatore_denominazione).equals(j)) {
					lista.addValore(app.getOperatore_denominazione());
				} else if(ti.getPosizione(ConstantsMap.appuntamento_bloccato).equals(j)) {
					lista.addValore(app.getBloccatoS());
				} else if(ti.getPosizione(ConstantsMap.appuntamento_operatore_codice).equals(j)) {
					lista.addValore(app.getOperatore_codice());
				} else if(ti.getPosizione(ConstantsMap.appuntamento_agente_denominazione).equals(j)) {
					lista.addValore(app.getAgente_denominazione());
				} else if(ti.getPosizione(ConstantsMap.appuntamento_agente_codice).equals(j)) {
					lista.addValore(app.getAgente_codice());
				} else if(ti.getPosizione(ConstantsMap.appuntamento_nota).equals(j)) {
					lista.addValore(app.getNota());
				} else if(ti.getPosizione(ConstantsMap.appuntamento_data_creazione).equals(j)) {
					lista.addValore(ConstantsFormat.dateTime.stampa(), app.getData_creazione());
				} else if(ti.getPosizione(ConstantsMap.appuntamento_data_appuntamento).equals(j)) {
					lista.addValore(ConstantsFormat.date.stampa(), app.getData_inizio());
				} else if(ti.getPosizione(ConstantsMap.appuntamento_data_ora).equals(j)) {
					lista.addValore(ConstantsFormat.dateTime.stampa(), app.getData_inizio());
				} else if(ti.getPosizione(ConstantsMap.appuntamento_ora_inizio).equals(j)) {
					lista.addValore(ConstantsFormat.time.stampa(), app.getData_inizio());
				} else if(ti.getPosizione(ConstantsMap.appuntamento_ora_fine).equals(j)) {
					lista.addValore(ConstantsFormat.time.stampa(), app.getData_fine());
				} else if(ti.getPosizione(ConstantsMap.appuntamento_data_conferma).equals(j)) {
					lista.addValore(ConstantsFormat.dateTime.stampa(), app.getData_conferma());
				} else if(ti.getPosizione(ConstantsMap.appuntamento_data_lavorazione).equals(j)) {
					lista.addValore(ConstantsFormat.dateTime.stampa(), app.getData_lavorazione());
				} else if(ti.getPosizione(ConstantsMap.appuntamento_localizzazione).equals(j)) {
					lista.addValore(app.getLocalizzazioneString());
				} else if(ti.getPosizione(ConstantsMap.appuntamento_utente_denominazione).equals(j)) {
					lista.addValore(app.getUtente_denominazione());
				} else if(ti.getPosizione(ConstantsMap.appuntamento_utente_codice).equals(j)) {
					lista.addValore(app.getUtente_codice());
				} else if(ti.getPosizione(ConstantsMap.appuntamento_data_esito).equals(j)) {
					lista.addValore(ConstantsFormat.dateTime.stampa(), app.getData_esito());
				} else if(ti.getPosizione(ConstantsMap.appuntamento_data_stato).equals(j)) {
					lista.addValore(ConstantsFormat.dateTime.stampa(), app.getData_stato());
				} else if(ti.getPosizione(ConstantsMap.appuntamento_esito_appuntamento).equals(j)) {
					lista.addValore(app.getEsitoEtichetta());
				} else if(ti.getPosizione(ConstantsMap.appuntamento_codice_appuntamento).equals(j)) {
					lista.addValore(app.getEsitoCodice());
				} else if(ti.getPosizione(ConstantsMap.appuntamento_stato).equals(j)) {
					lista.addValore(app.getStatoTesto());
				} else if(ti.getPosizione(ConstantsMap.contatto_data_lavorazione).equals(j)) {
					lista.addValore(ConstantsFormat.dateTime.stampa(), cnt.getData_lavorazione());
				} else if(ti.getPosizione(ConstantsMap.contatto_operatore_denominazione).equals(j)) {
					lista.addValore(cnt.getOperatore_denominazione());
				} else if(ti.getPosizione(ConstantsMap.contatto_operatore_codice).equals(j)) {
					lista.addValore(cnt.getOperatore_codice());
				} else if(ti.getPosizione(ConstantsMap.contatto_data_archiviazione).equals(j)) {
					lista.addValore(ConstantsFormat.dateTime.stampa(), cnt.getData_archiviazione());
				} else if(ti.getPosizione(ConstantsMap.contatto_esito_chiamata).equals(j)) {
					lista.addValore(cnt.getEsito_chiamata());
				} else if(ti.getPosizione(ConstantsMap.contatto_esito_archiviazione).equals(j)) {
					lista.addValore(cnt.getEsito_archiviazione());
				} else if(ti.getPosizione(ConstantsMap.contatto_esito_generale).equals(j)) {
					lista.addValore(cnt.getEsito_generale());
				} else if(ti.getPosizione(ConstantsMap.contatto_codice_chiamata).equals(j)) {
					lista.addValore(cnt.getCodice_chiamata());
				} else if(ti.getPosizione(ConstantsMap.contatto_codice_archiviazione).equals(j)) {
					lista.addValore(cnt.getCodice_archiviazione());
				} else if(ti.getPosizione(ConstantsMap.contatto_codice_generale).equals(j)) {
					lista.addValore(cnt.getCodice_generale());
				} else if(ti.getPosizione(ConstantsMap.contatto_proprietario_denominazione).equals(j)) {
					lista.addValore(cnt.getProprietario_denominazione());
				} else if(ti.getPosizione(ConstantsMap.contatto_proprietario_codice).equals(j)) {
					lista.addValore(cnt.getProprietario_codice());
				} else if(ti.getPosizione(ConstantsMap.contatto_data_presentazione).equals(j)) {
					lista.addValore(ConstantsFormat.dateTime.stampa(), cnt.getData_presentazione());
				} else if(ti.getPosizione(ConstantsMap.contatto_nota).equals(j)) {
					lista.addValore(cnt.getNota());
				} else if(ti.getPosizione(ConstantsMap.contatto_data_creazione).equals(j)) {
					lista.addValore(ConstantsFormat.dateTime.stampa(), cnt.getData_creazione());
				} else if(ti.getPosizione(ConstantsMap.contatto_agente_denominazione).equals(j)) {
					lista.addValore(cnt.getAgente_denominazione());
				} else if(ti.getPosizione(ConstantsMap.contatto_agente_codice).equals(j)) {
					lista.addValore(cnt.getAgente_codice());
				} else if(ti.getPosizione(ConstantsMap.contatto_stato).equals(j)) {
					lista.addValore(cnt.getTipoTesto());
				} else if(ti.getPosizione(ConstantsMap.contatto_id).equals(j)) {
					lista.addValore(cnt.getId().toString());
				} else if(ti.getPosizione(ConstantsMap.contatto_campagna_denominazione).equals(j)) {
					lista.addValore(cnt.getCampagna_denominazione());
				} else if(ti.getPosizione(ConstantsMap.contatto_lista_denominazione).equals(j)) {
					lista.addValore(cnt.getLista_denominazione());
				} else if(ti.getPosizione(ConstantsMap.contatto_bloccato).equals(j)) {
					lista.addValore(cnt.getBloccatoS());
				} else if(ti.getPosizione(ConstantsMap.contatto_campagna_codice).equals(j)) {
					lista.addValore(cnt.getCampagna_codice());
				} else if(ti.getPosizione(ConstantsMap.contatto_lista_codice).equals(j)) {
					lista.addValore(cnt.getLista_codice());
				} else if(ti.getPosizione(ConstantsMap.contatto_positivo).equals(j)) {
					lista.addValore(cnt.getPositivo());
				} else if(ti.getPosizione(ConstantsMap.contatto_telefono_predefinito).equals(j)) {
					lista.addValore(ApplicationUtil.uniforma(cnt.getTelefono_predefinito(), ti.getRem_predefinito(), ti.getAdd_predefinito()));
				} else if(ti.getPosizione(ConstantsMap.contatto_utile).equals(j)) {
					lista.addValore(cnt.getUtile());
				} else if(ti.getPosizione(ConstantsMap.contatto_chiuso).equals(j)) {
					lista.addValore(cnt.getChiuso());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_cognome).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getCognome());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_nome).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getNome());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_nome_completo).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getNome_completo());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_email).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getEmail());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_codice_fiscale).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getCodice_fiscale());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_sorgente).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getSorgente());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_nota).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getNota());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_luogo_nascita).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getLuogo_nascita());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_data_nascita).equals(j)) {
					lista.addValore(ConstantsFormat.date.stampa(), cnt.getAnagrafica().getDate_nascita());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_link).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getLink());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_privacy).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getPrivacy());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_data_inserimento).equals(j)) {
					lista.addValore(ConstantsFormat.dateTime.stampa(), cnt.getAnagrafica().getData_creazione());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_tipo).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getTipo());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_sesso).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getSesso());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_partita_iva).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getPartita_iva());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_ragione_sociale).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getRagione_sociale());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_telefono_fisso).equals(j)) {
					lista.addValore(ApplicationUtil.uniforma(cnt.getAnagrafica().getTelefono_fisso(), ti.getRem_fisso(), ti.getAdd_fisso()));
				} else if(ti.getPosizione(ConstantsMap.anagrafica_telefono_altro).equals(j)) {
					lista.addValore(ApplicationUtil.uniforma(cnt.getAnagrafica().getTelefono_altro(), ti.getRem_altro(), ti.getAdd_altro()));
				} else if(ti.getPosizione(ConstantsMap.anagrafica_telefono_mobile).equals(j)) {
					lista.addValore(ApplicationUtil.uniforma(cnt.getAnagrafica().getTelefono_mobile(), ti.getRem_mobile(), ti.getAdd_mobile()));
				} else if(ti.getPosizione(ConstantsMap.anagrafica_telefono_fax).equals(j)) {
					lista.addValore(ApplicationUtil.uniforma(cnt.getAnagrafica().getTelefono_fax(), ti.getRem_fax(), ti.getAdd_fax()));
				} else if(ti.getPosizione(ConstantsMap.anagrafica_settore).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getSettore());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_denominazione).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getDenominazione());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_id).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIdentificativo());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_indirizzo_completo).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_legale().getIndirizzo_completo());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_strada_completo).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_legale().getStrada_completo());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_comune_completo).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_legale().getComune_completo());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_strada).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_legale().getStrada());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_civico).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_legale().getCivico());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_cap).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_legale().getCap());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_comune).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_legale().getComune());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_provincia).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_legale().getProvincia());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_regione).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_legale().getRegione());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_dettagli).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_legale().getDettagli());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_latitudine).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_legale().getLatitudine());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_longitudine).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_legale().getLongitudine());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_presso).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_legale().getPresso());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_indirizzo_completo).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_operativo().getIndirizzo_completo());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_strada_completo).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_operativo().getStrada_completo());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_comune_completo).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_operativo().getComune_completo());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_strada).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_operativo().getStrada());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_civico).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_operativo().getCivico());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_cap).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_operativo().getCap());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_comune).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_operativo().getComune());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_provincia).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_operativo().getProvincia());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_regione).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_operativo().getRegione());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_dettagli).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_operativo().getDettagli());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_latitudine).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_operativo().getLatitudine());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_longitudine).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_operativo().getLongitudine());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_presso).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_operativo().getPresso());
				} else if(ti.getPosizione(ConstantsMap.consenso_tfissoS).equals(j)) {
					lista.addValore(ConstantsFormat.dateTime.stampa(), cnt.getAnagrafica().getConsenso_tfisso());
				} else if(ti.getPosizione(ConstantsMap.consenso_tmobileS).equals(j)) {
					lista.addValore(ConstantsFormat.dateTime.stampa(), cnt.getAnagrafica().getConsenso_tmobile());
				} else if(ti.getPosizione(ConstantsMap.consenso_tfaxS).equals(j)) {
					lista.addValore(ConstantsFormat.dateTime.stampa(), cnt.getAnagrafica().getConsenso_tfax());
				} else if(ti.getPosizione(ConstantsMap.consenso_taltroS).equals(j)) {
					lista.addValore(ConstantsFormat.dateTime.stampa(), cnt.getAnagrafica().getConsenso_taltro());
				} else if(ti.getPosizione(ConstantsMap.consenso_emailS).equals(j)) {
					lista.addValore(ConstantsFormat.dateTime.stampa(), cnt.getAnagrafica().getConsenso_email());
				} else if(ti.getPosizione(ConstantsMap.consenso_rmailS).equals(j)) {
					lista.addValore(ConstantsFormat.dateTime.stampa(), cnt.getAnagrafica().getConsenso_rmail());
				} else {
					stampaDato(lista, titles[j], cnt.getAnagrafica().getDettagli(), null);
				}
			}
			for (int j = 0; j < lista.size(); j++) {
				ExcelFormat el = lista.get(j);
				Cell cell = row.createCell(j, el.getCellType());
				ApplicationUtil.cellStamper(s, cell, el);
			}
		}
		sheet.setDefaultColumnWidth(20);
		ApplicationUtil.passwordXLS(wb, result, password);
		
	}
	public static void esportaExcelStoriaContrattoTemplate(Boolean p, List<StoriaContratto> data, AnagraficaDao anagraficaDao, TemplateExportStoriaContratto ti, OutputStream result, String password) throws Exception {
		List <String> titlesList = ti.getValore_multiplo();
		List <String> aggiuntivi = ListUtils.subtract(titlesList, new ArrayList<String>(ConstantsMap.storiaContrattoMap));
		if(p!=null && ApplicationUtil.notEmpty(aggiuntivi)) {
			List <String> invA = anagraficaDao.getEtichetteInvisibiliByChiave(p, CampoAggiuntivoAnagrafica.class);
			List <String> invB = anagraficaDao.getEtichetteInvisibiliByChiave(p, CampoAggiuntivoContratto.class);
			aggiuntivi.removeAll(invA);
			aggiuntivi.removeAll(invB);
			titlesList.removeAll(invA);
			titlesList.removeAll(invB);
		}
		if(ApplicationUtil.notEmpty(aggiuntivi)) {
			data = anagraficaDao.loadFullStoriaContratto(data);
		}
		String[] titles = titlesList.toArray(new String[0]);
		Workbook wb = ApplicationUtil.workbookS();
		ExcelStyle s = new ExcelStyle(wb);
		Sheet sheet = wb.createSheet(ConstantsLanguage.STORIA.stampa() + " " + ConstantsLanguage.CONTRATTI.stampa());
		int k = 0;
		Row row = null;
		if(ti.getIntestazione()) {
			row = sheet.createRow(k++);
			for (int i = 0; i < titles.length; i++) {
				Cell cell = row.createCell(i, CellType.STRING);
				if(ApplicationUtil.notEmpty(aggiuntivi) && aggiuntivi.contains(titles[i])) {
					String etichetta = anagraficaDao.getEtichettaByChiave(CampoAggiuntivoAnagrafica.class, titles[i]);
					if(ApplicationUtil.isBlank(etichetta)) {
						etichetta = anagraficaDao.getEtichettaByChiave(CampoAggiuntivoContratto.class, titles[i]);
					}
					ApplicationUtil.headerCell(s, cell,  etichetta);
				} else {
					ApplicationUtil.headerCell(s, cell,  Message.addCatalogText(titles[i]));
				}
			}
			sheet.setAutoFilter(new CellRangeAddress(0, 0, 0, titles.length-1));
			sheet.createFreezePane(0, 1);
		} else {
			row = sheet.createRow(k);
		}
		Iterator<StoriaContratto> objIter = data.iterator();
		while(objIter.hasNext()) {
			StoriaContratto scrt = objIter.next();
			Contratto crt = scrt.getContratto();
			Contatto cnt = crt.getContatto();
			row = sheet.createRow(k++);
			ExcelFormatList lista = new ExcelFormatList();
			for (int j = 0; j < titles.length; j++) {
				if(ti.getPosizione(ConstantsMap.storia_contratto_data).equals(j)) {
					lista.addValore(ConstantsFormat.dateSeconds.stampa(), scrt.getData());
				} else if(ti.getPosizione(ConstantsMap.storia_contratto_id).equals(j)) {
					lista.addValore(scrt.getId().toString());
				} else if(ti.getPosizione(ConstantsMap.storia_contratto_operatore_denominazione).equals(j)) {
					lista.addValore(scrt.getOperatore_denominazione());
				} else if(ti.getPosizione(ConstantsMap.storia_contratto_operatore_codice).equals(j)) {
					lista.addValore(scrt.getOperatore_codice());
				} else if(ti.getPosizione(ConstantsMap.storia_contratto_agente_denominazione).equals(j)) {
					lista.addValore(scrt.getAgente_denominazione());
				} else if(ti.getPosizione(ConstantsMap.storia_contratto_agente_codice).equals(j)) {
					lista.addValore(scrt.getAgente_codice());
				} else if(ti.getPosizione(ConstantsMap.storia_contratto_categoria_denominazione).equals(j)) {
					lista.addValore(scrt.getCategoria_denominazione());
				} else if(ti.getPosizione(ConstantsMap.storia_contratto_prodotto_denominazione).equals(j)) {
					lista.addValore(scrt.getProdotto_denominazione());
				} else if(ti.getPosizione(ConstantsMap.storia_contratto_esito_contratto).equals(j)) {
					lista.addValore(scrt.getEsitoEtichetta());
				} else if(ti.getPosizione(ConstantsMap.storia_contratto_codice_contratto).equals(j)) {
					lista.addValore(scrt.getEsitoCodice());
				} else if(ti.getPosizione(ConstantsMap.storia_contratto_data_stipula).equals(j)) {
					lista.addValore(ConstantsFormat.date.stampa(),scrt.getData_stipula());
				} else if(ti.getPosizione(ConstantsMap.storia_contratto_data_contabile).equals(j)) {
					lista.addValore(ConstantsFormat.date.stampa(),scrt.getData_contabile());
				} else if(ti.getPosizione(ConstantsMap.storia_contratto_data_attivazione).equals(j)) {
					lista.addValore(ConstantsFormat.date.stampa(),scrt.getData_attivazione());
				} else if(ti.getPosizione(ConstantsMap.storia_contratto_data_caricamento).equals(j)) {
					lista.addValore(ConstantsFormat.date.stampa(),scrt.getData_caricamento());
				} else if(ti.getPosizione(ConstantsMap.storia_contratto_utente_denominazione).equals(j)) {
					lista.addValore(scrt.getUtente_denominazione());
				} else if(ti.getPosizione(ConstantsMap.storia_contratto_bloccato).equals(j)) {
					lista.addValore(scrt.getBloccatoS());
				} else if(ti.getPosizione(ConstantsMap.storia_contratto_utente_codice).equals(j)) {
					lista.addValore(scrt.getUtente_codice());
				} else if(ti.getPosizione(ConstantsMap.storia_contratto_data_esito).equals(j)) {
					lista.addValore(ConstantsFormat.dateTime.stampa(), scrt.getData_esito());
				} else if(ti.getPosizione(ConstantsMap.storia_contratto_data_stato).equals(j)) {
					lista.addValore(ConstantsFormat.dateTime.stampa(), scrt.getData_stato());
				} else if(ti.getPosizione(ConstantsMap.storia_contratto_nota).equals(j)) {
					lista.addValore(scrt.getNota());
				} else if(ti.getPosizione(ConstantsMap.storia_contratto_tipo_seriale).equals(j)) {
					lista.addValore(scrt.getTipo_seriale());
				} else if(ti.getPosizione(ConstantsMap.storia_contratto_seriale).equals(j)) {
					lista.addValore(scrt.getSeriale());
				} else if(ti.getPosizione(ConstantsMap.storia_contratto_quantita).equals(j)) {
					lista.addValore(scrt.getQuantita());
				} else if(ti.getPosizione(ConstantsMap.storia_contratto_costo_scontato).equals(j)) {
					lista.addValore(scrt.getCosto_scontato());
				} else if(ti.getPosizione(ConstantsMap.storia_contratto_stato).equals(j)) {
					lista.addValore(scrt.getStatoTesto());
				} else if(ti.getPosizione(ConstantsMap.contratto_data_creazione).equals(j)) {
					lista.addValore(ConstantsFormat.dateTime.stampa(), crt.getData_creazione());
				} else if(ti.getPosizione(ConstantsMap.contratto_id).equals(j)) {
					lista.addValore(crt.getId().toString());
				} else if(ti.getPosizione(ConstantsMap.contratto_operatore_denominazione).equals(j)) {
					lista.addValore(crt.getOperatore_denominazione());
				} else if(ti.getPosizione(ConstantsMap.contratto_operatore_codice).equals(j)) {
					lista.addValore(crt.getOperatore_codice());
				} else if(ti.getPosizione(ConstantsMap.contratto_agente_denominazione).equals(j)) {
					lista.addValore(crt.getAgente_denominazione());
				} else if(ti.getPosizione(ConstantsMap.contratto_agente_codice).equals(j)) {
					lista.addValore(crt.getAgente_codice());
				} else if(ti.getPosizione(ConstantsMap.contratto_categoria_denominazione).equals(j)) {
					lista.addValore(crt.getCategoria_denominazione());
				} else if(ti.getPosizione(ConstantsMap.contratto_prodotto_denominazione).equals(j)) {
					lista.addValore(crt.getProdotto_denominazione());
				} else if(ti.getPosizione(ConstantsMap.contratto_esito_contratto).equals(j)) {
					lista.addValore(crt.getEsitoEtichetta());
				} else if(ti.getPosizione(ConstantsMap.contratto_codice_contratto).equals(j)) {
					lista.addValore(crt.getEsitoCodice());
				} else if(ti.getPosizione(ConstantsMap.contratto_data_stipula).equals(j)) {
					lista.addValore(ConstantsFormat.date.stampa(),crt.getData_stipula());
				} else if(ti.getPosizione(ConstantsMap.contratto_data_contabile).equals(j)) {
					lista.addValore(ConstantsFormat.date.stampa(),crt.getData_contabile());
				} else if(ti.getPosizione(ConstantsMap.contratto_data_attivazione).equals(j)) {
					lista.addValore(ConstantsFormat.date.stampa(),crt.getData_attivazione());
				} else if(ti.getPosizione(ConstantsMap.contratto_data_caricamento).equals(j)) {
					lista.addValore(ConstantsFormat.date.stampa(),crt.getData_caricamento());
				} else if(ti.getPosizione(ConstantsMap.contratto_data_lavorazione).equals(j)) {
					lista.addValore(ConstantsFormat.dateTime.stampa(),crt.getData_lavorazione());
				} else if(ti.getPosizione(ConstantsMap.contratto_utente_denominazione).equals(j)) {
					lista.addValore(crt.getUtente_denominazione());
				} else if(ti.getPosizione(ConstantsMap.contratto_bloccato).equals(j)) {
					lista.addValore(crt.getBloccatoS());
				} else if(ti.getPosizione(ConstantsMap.contratto_utente_codice).equals(j)) {
					lista.addValore(crt.getUtente_codice());
				} else if(ti.getPosizione(ConstantsMap.contratto_data_esito).equals(j)) {
					lista.addValore(ConstantsFormat.dateTime.stampa(), crt.getData_esito());
				} else if(ti.getPosizione(ConstantsMap.contratto_data_stato).equals(j)) {
					lista.addValore(ConstantsFormat.dateTime.stampa(), crt.getData_stato());
				} else if(ti.getPosizione(ConstantsMap.contratto_nota).equals(j)) {
					lista.addValore(crt.getNota());
				} else if(ti.getPosizione(ConstantsMap.contratto_tipo_seriale).equals(j)) {
					lista.addValore(crt.getTipo_seriale());
				} else if(ti.getPosizione(ConstantsMap.contratto_seriale).equals(j)) {
					lista.addValore(crt.getSeriale());
				} else if(ti.getPosizione(ConstantsMap.contratto_quantita).equals(j)) {
					lista.addValore(crt.getQuantita());
				} else if(ti.getPosizione(ConstantsMap.contratto_costo_scontato).equals(j)) {
					lista.addValore(crt.getCosto_scontato());
				} else if(ti.getPosizione(ConstantsMap.contratto_stato).equals(j)) {
					lista.addValore(crt.getStatoTesto());
				} else if(ti.getPosizione(ConstantsMap.contatto_data_archiviazione).equals(j)) {
					lista.addValore(ConstantsFormat.dateTime.stampa(), cnt.getData_archiviazione());
				} else if(ti.getPosizione(ConstantsMap.contatto_data_lavorazione).equals(j)) {
					lista.addValore(ConstantsFormat.dateTime.stampa(), cnt.getData_lavorazione());
				} else if(ti.getPosizione(ConstantsMap.contatto_operatore_denominazione).equals(j)) {
					lista.addValore(cnt.getOperatore_denominazione());
				} else if(ti.getPosizione(ConstantsMap.contatto_operatore_codice).equals(j)) {
					lista.addValore(cnt.getOperatore_codice());
				} else if(ti.getPosizione(ConstantsMap.contatto_esito_chiamata).equals(j)) {
					lista.addValore(cnt.getEsito_chiamata());
				} else if(ti.getPosizione(ConstantsMap.contatto_esito_archiviazione).equals(j)) {
					lista.addValore(cnt.getEsito_archiviazione());
				} else if(ti.getPosizione(ConstantsMap.contatto_esito_generale).equals(j)) {
					lista.addValore(cnt.getEsito_generale());
				} else if(ti.getPosizione(ConstantsMap.contatto_codice_chiamata).equals(j)) {
					lista.addValore(cnt.getCodice_chiamata());
				} else if(ti.getPosizione(ConstantsMap.contatto_codice_archiviazione).equals(j)) {
					lista.addValore(cnt.getCodice_archiviazione());
				} else if(ti.getPosizione(ConstantsMap.contatto_codice_generale).equals(j)) {
					lista.addValore(cnt.getCodice_generale());
				} else if(ti.getPosizione(ConstantsMap.contatto_proprietario_denominazione).equals(j)) {
					lista.addValore(cnt.getProprietario_denominazione());
				} else if(ti.getPosizione(ConstantsMap.contatto_proprietario_codice).equals(j)) {
					lista.addValore(cnt.getProprietario_codice());
				} else if(ti.getPosizione(ConstantsMap.contatto_data_presentazione).equals(j)) {
					lista.addValore(ConstantsFormat.dateTime.stampa(), cnt.getData_presentazione());
				} else if(ti.getPosizione(ConstantsMap.contatto_nota).equals(j)) {
					lista.addValore(cnt.getNota());
				} else if(ti.getPosizione(ConstantsMap.contatto_data_creazione).equals(j)) {
					lista.addValore(ConstantsFormat.dateTime.stampa(), cnt.getData_creazione());
				} else if(ti.getPosizione(ConstantsMap.contatto_agente_denominazione).equals(j)) {
					lista.addValore(cnt.getAgente_denominazione());
				} else if(ti.getPosizione(ConstantsMap.contatto_agente_codice).equals(j)) {
					lista.addValore(cnt.getAgente_codice());
				} else if(ti.getPosizione(ConstantsMap.contatto_stato).equals(j)) {
					lista.addValore(cnt.getTipoTesto());
				} else if(ti.getPosizione(ConstantsMap.contatto_id).equals(j)) {
					lista.addValore(cnt.getId().toString());
				} else if(ti.getPosizione(ConstantsMap.contatto_campagna_denominazione).equals(j)) {
					lista.addValore(cnt.getCampagna_denominazione());
				} else if(ti.getPosizione(ConstantsMap.contatto_lista_denominazione).equals(j)) {
					lista.addValore(cnt.getLista_denominazione());
				} else if(ti.getPosizione(ConstantsMap.contatto_campagna_codice).equals(j)) {
					lista.addValore(cnt.getCampagna_codice());
				} else if(ti.getPosizione(ConstantsMap.contatto_bloccato).equals(j)) {
					lista.addValore(cnt.getBloccatoS());
				} else if(ti.getPosizione(ConstantsMap.contatto_lista_codice).equals(j)) {
					lista.addValore(cnt.getLista_codice());
				} else if(ti.getPosizione(ConstantsMap.contatto_positivo).equals(j)) {
					lista.addValore(cnt.getPositivo());
				} else if(ti.getPosizione(ConstantsMap.contatto_telefono_predefinito).equals(j)) {
					lista.addValore(ApplicationUtil.uniforma(cnt.getTelefono_predefinito(), ti.getRem_predefinito(), ti.getAdd_predefinito()));
				} else if(ti.getPosizione(ConstantsMap.contatto_utile).equals(j)) {
					lista.addValore(cnt.getUtile());
				} else if(ti.getPosizione(ConstantsMap.contatto_chiuso).equals(j)) {
					lista.addValore(cnt.getChiuso());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_cognome).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getCognome());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_nome).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getNome());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_nome_completo).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getNome_completo());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_email).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getEmail());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_codice_fiscale).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getCodice_fiscale());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_sorgente).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getSorgente());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_nota).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getNota());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_luogo_nascita).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getLuogo_nascita());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_data_nascita).equals(j)) {
					lista.addValore(ConstantsFormat.date.stampa(), cnt.getAnagrafica().getDate_nascita());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_link).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getLink());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_privacy).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getPrivacy());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_data_inserimento).equals(j)) {
					lista.addValore(ConstantsFormat.dateTime.stampa(), cnt.getAnagrafica().getData_creazione());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_tipo).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getTipo());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_sesso).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getSesso());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_partita_iva).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getPartita_iva());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_ragione_sociale).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getRagione_sociale());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_telefono_fisso).equals(j)) {
					lista.addValore(ApplicationUtil.uniforma(cnt.getAnagrafica().getTelefono_fisso(), ti.getRem_fisso(), ti.getAdd_fisso()));
				} else if(ti.getPosizione(ConstantsMap.anagrafica_telefono_altro).equals(j)) {
					lista.addValore(ApplicationUtil.uniforma(cnt.getAnagrafica().getTelefono_altro(), ti.getRem_altro(), ti.getAdd_altro()));
				} else if(ti.getPosizione(ConstantsMap.anagrafica_telefono_mobile).equals(j)) {
					lista.addValore(ApplicationUtil.uniforma(cnt.getAnagrafica().getTelefono_mobile(), ti.getRem_mobile(), ti.getAdd_mobile()));
				} else if(ti.getPosizione(ConstantsMap.anagrafica_telefono_fax).equals(j)) {
					lista.addValore(ApplicationUtil.uniforma(cnt.getAnagrafica().getTelefono_fax(), ti.getRem_fax(), ti.getAdd_fax()));
				} else if(ti.getPosizione(ConstantsMap.anagrafica_settore).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getSettore());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_denominazione).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getDenominazione());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_id).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIdentificativo());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_indirizzo_completo).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_legale().getIndirizzo_completo());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_strada_completo).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_legale().getStrada_completo());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_comune_completo).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_legale().getComune_completo());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_strada).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_legale().getStrada());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_civico).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_legale().getCivico());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_cap).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_legale().getCap());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_comune).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_legale().getComune());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_provincia).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_legale().getProvincia());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_regione).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_legale().getRegione());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_dettagli).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_legale().getDettagli());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_latitudine).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_legale().getLatitudine());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_longitudine).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_legale().getLongitudine());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_presso).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_legale().getPresso());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_indirizzo_completo).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_operativo().getIndirizzo_completo());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_strada_completo).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_operativo().getStrada_completo());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_comune_completo).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_operativo().getComune_completo());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_strada).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_operativo().getStrada());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_civico).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_operativo().getCivico());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_cap).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_operativo().getCap());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_comune).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_operativo().getComune());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_provincia).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_operativo().getProvincia());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_regione).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_operativo().getRegione());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_dettagli).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_operativo().getDettagli());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_latitudine).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_operativo().getLatitudine());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_longitudine).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_operativo().getLongitudine());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_presso).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_operativo().getPresso());
				} else if(ti.getPosizione(ConstantsMap.consenso_tfissoS).equals(j)) {
					lista.addValore(ConstantsFormat.dateTime.stampa(), cnt.getAnagrafica().getConsenso_tfisso());
				} else if(ti.getPosizione(ConstantsMap.consenso_tmobileS).equals(j)) {
					lista.addValore(ConstantsFormat.dateTime.stampa(), cnt.getAnagrafica().getConsenso_tmobile());
				} else if(ti.getPosizione(ConstantsMap.consenso_tfaxS).equals(j)) {
					lista.addValore(ConstantsFormat.dateTime.stampa(), cnt.getAnagrafica().getConsenso_tfax());
				} else if(ti.getPosizione(ConstantsMap.consenso_taltroS).equals(j)) {
					lista.addValore(ConstantsFormat.dateTime.stampa(), cnt.getAnagrafica().getConsenso_taltro());
				} else if(ti.getPosizione(ConstantsMap.consenso_emailS).equals(j)) {
					lista.addValore(ConstantsFormat.dateTime.stampa(), cnt.getAnagrafica().getConsenso_email());
				} else if(ti.getPosizione(ConstantsMap.consenso_rmailS).equals(j)) {
					lista.addValore(ConstantsFormat.dateTime.stampa(), cnt.getAnagrafica().getConsenso_rmail());
				} else {
					stampaDato(lista, titles[j], cnt.getAnagrafica().getDettagli(), crt.getDettagli());
				}
			}
			for (int j = 0; j < lista.size(); j++) {
				ExcelFormat el = lista.get(j);
				Cell cell = row.createCell(j, el.getCellType());
				ApplicationUtil.cellStamper(s, cell, el);
			}
		}
		sheet.setDefaultColumnWidth(20);
		ApplicationUtil.passwordXLS(wb, result, password);
		
	}
	public static void esportaExcelStoriaContattoTemplate(Boolean p, List<StoriaContatto> data, AnagraficaDao anagraficaDao, TemplateExportStoriaContatto ti, OutputStream result, String password) throws Exception {
		List <String> titlesList = ti.getValore_multiplo();
		List <String> aggiuntivi = ListUtils.subtract(titlesList, new ArrayList<String>(ConstantsMap.storiaContattoMap));
		if(p!=null && ApplicationUtil.notEmpty(aggiuntivi)) {
			List <String> invA = anagraficaDao.getEtichetteInvisibiliByChiave(p, CampoAggiuntivoAnagrafica.class);
			aggiuntivi.removeAll(invA);
			titlesList.removeAll(invA);
		}
		if(ApplicationUtil.notEmpty(aggiuntivi)) {
			data = anagraficaDao.loadFullStoriaContatto(data);
		}
		String[] titles = titlesList.toArray(new String[0]);
		Workbook wb = ApplicationUtil.workbookS();
		ExcelStyle s = new ExcelStyle(wb);
		Sheet sheet = wb.createSheet(ConstantsLanguage.STORIA.stampa() + " " + ConstantsLanguage.CONTATTI.stampa());
		int k = 0;
		Row row = null;
		if(ti.getIntestazione()) {
			row = sheet.createRow(k++);
			for (int i = 0; i < titles.length; i++) {
				Cell cell = row.createCell(i, CellType.STRING);
				if(ApplicationUtil.notEmpty(aggiuntivi) && aggiuntivi.contains(titles[i])) {
					String etichetta = anagraficaDao.getEtichettaByChiave(CampoAggiuntivoAnagrafica.class, titles[i]);
					ApplicationUtil.headerCell(s, cell,  etichetta);
				} else {
					ApplicationUtil.headerCell(s, cell,  Message.addCatalogText(titles[i]));
				}
			}
			sheet.setAutoFilter(new CellRangeAddress(0, 0, 0, titles.length-1));
			sheet.createFreezePane(0, 1);
		} else {
			row = sheet.createRow(k);
		}
		Iterator<StoriaContatto> objIter = data.iterator();
		while(objIter.hasNext()) {
			StoriaContatto scnt = objIter.next();
			Contatto cnt = scnt.getContatto();
			row = sheet.createRow(k++);
			ExcelFormatList lista = new ExcelFormatList();
			for (int j = 0; j < titles.length; j++) {
				if(ti.getPosizione(ConstantsMap.storia_contatto_data_archiviazione).equals(j)) {
					lista.addValore(ConstantsFormat.dateTime.stampa(), scnt.getData_archiviazione());
				} else if(ti.getPosizione(ConstantsMap.storia_contatto_esito_chiamata).equals(j)) {
					lista.addValore(scnt.getEsito_chiamata());
				} else if(ti.getPosizione(ConstantsMap.storia_contatto_esito_archiviazione).equals(j)) {
					lista.addValore(scnt.getEsito_archiviazione());
				} else if(ti.getPosizione(ConstantsMap.storia_contatto_esito_generale).equals(j)) {
					lista.addValore(scnt.getEsito_generale());
				} else if(ti.getPosizione(ConstantsMap.storia_contatto_codice_chiamata).equals(j)) {
					lista.addValore(scnt.getCodice_chiamata());
				} else if(ti.getPosizione(ConstantsMap.storia_contatto_codice_archiviazione).equals(j)) {
					lista.addValore(scnt.getCodice_archiviazione());
				} else if(ti.getPosizione(ConstantsMap.storia_contatto_codice_generale).equals(j)) {
					lista.addValore(scnt.getCodice_generale());
				} else if(ti.getPosizione(ConstantsMap.storia_contatto_operatore_denominazione).equals(j)) {
					lista.addValore(scnt.getOperatore_denominazione());
				} else if(ti.getPosizione(ConstantsMap.storia_contatto_campagna_denominazione).equals(j)) {
					lista.addValore(scnt.getCampagna_denominazione());
				} else if(ti.getPosizione(ConstantsMap.storia_contatto_lista_denominazione).equals(j)) {
					lista.addValore(scnt.getLista_denominazione());
				} else if(ti.getPosizione(ConstantsMap.storia_contatto_campagna_codice).equals(j)) {
					lista.addValore(scnt.getCampagna_codice());
				} else if(ti.getPosizione(ConstantsMap.storia_contatto_bloccato).equals(j)) {
					lista.addValore(scnt.getBloccatoS());
				} else if(ti.getPosizione(ConstantsMap.storia_contatto_lista_codice).equals(j)) {
					lista.addValore(scnt.getLista_codice());
				} else if(ti.getPosizione(ConstantsMap.storia_contatto_operatore_codice).equals(j)) {
					lista.addValore(scnt.getOperatore_codice());
				} else if(ti.getPosizione(ConstantsMap.storia_contatto_proprietario_denominazione).equals(j)) {
					lista.addValore(scnt.getProprietario_denominazione());
				} else if(ti.getPosizione(ConstantsMap.storia_contatto_proprietario_codice).equals(j)) {
					lista.addValore(scnt.getProprietario_codice());
				} else if(ti.getPosizione(ConstantsMap.storia_contatto_data_presentazione).equals(j)) {
					lista.addValore(ConstantsFormat.dateTime.stampa(), scnt.getData_presentazione());
				} else if(ti.getPosizione(ConstantsMap.storia_contatto_nota).equals(j)) {
					lista.addValore(scnt.getNota());
				} else if(ti.getPosizione(ConstantsMap.storia_contatto_data).equals(j)) {
					lista.addValore(ConstantsFormat.dateSeconds.stampa(), scnt.getData());
				} else if(ti.getPosizione(ConstantsMap.storia_contatto_agente_denominazione).equals(j)) {
					lista.addValore(scnt.getAgente_denominazione());
				} else if(ti.getPosizione(ConstantsMap.storia_contatto_agente_codice).equals(j)) {
					lista.addValore(scnt.getAgente_codice());
				} else if(ti.getPosizione(ConstantsMap.storia_contatto_stato).equals(j)) {
					lista.addValore(scnt.getTipoTesto());
				} else if(ti.getPosizione(ConstantsMap.storia_contatto_id).equals(j)) {
					lista.addValore(scnt.getId().toString());
				} else if(ti.getPosizione(ConstantsMap.storia_contatto_positivo).equals(j)) {
					lista.addValore(scnt.getPositivo());
				} else if(ti.getPosizione(ConstantsMap.storia_contatto_utile).equals(j)) {
					lista.addValore(scnt.getUtile());
				} else if(ti.getPosizione(ConstantsMap.storia_contatto_chiuso).equals(j)) {
					lista.addValore(scnt.getChiuso());
				} else if(ti.getPosizione(ConstantsMap.storia_contatto_secondi_tot).equals(j)) {
					lista.addValore(scnt.getSecondi_tot());
				} else if(ti.getPosizione(ConstantsMap.storia_contatto_secondi_totH).equals(j)) {
					lista.addValore(scnt.getSecondi_totH());
				} else if(ti.getPosizione(ConstantsMap.storia_contatto_secondi_conv_eff).equals(j)) {
					lista.addValore(scnt.getSecondi_conv_eff());
				} else if(ti.getPosizione(ConstantsMap.storia_contatto_secondi_conv_effH).equals(j)) {
					lista.addValore(scnt.getSecondi_conv_effH());
				} else if(ti.getPosizione(ConstantsMap.storia_contatto_secondi_conv_tot).equals(j)) {
					lista.addValore(scnt.getSecondi_conv_tot());
				} else if(ti.getPosizione(ConstantsMap.storia_contatto_secondi_conv_totH).equals(j)) {
					lista.addValore(scnt.getSecondi_conv_totH());
				} else if(ti.getPosizione(ConstantsMap.storia_contatto_secondi_post).equals(j)) {
					lista.addValore(scnt.getSecondi_post());
				} else if(ti.getPosizione(ConstantsMap.storia_contatto_secondi_postH).equals(j)) {
					lista.addValore(scnt.getSecondi_postH());
				} else if(ti.getPosizione(ConstantsMap.storia_contatto_secondi_pre).equals(j)) {
					lista.addValore(scnt.getSecondi_pre());
				} else if(ti.getPosizione(ConstantsMap.storia_contatto_secondi_preH).equals(j)) {
					lista.addValore(scnt.getSecondi_preH());
				} else if(ti.getPosizione(ConstantsMap.storia_contatto_secondi_rec).equals(j)) {
					lista.addValore(scnt.getSecondi_rec());
				} else if(ti.getPosizione(ConstantsMap.storia_contatto_secondi_recH).equals(j)) {
					lista.addValore(scnt.getSecondi_recH());
				} else if(ti.getPosizione(ConstantsMap.storia_contatto_secondi_attesa).equals(j)) {
					lista.addValore(scnt.getSecondi_attesa());
				} else if(ti.getPosizione(ConstantsMap.storia_contatto_secondi_attesaH).equals(j)) {
					lista.addValore(scnt.getSecondi_attesaH());
				} else if(ti.getPosizione(ConstantsMap.storia_contatto_date_apertura).equals(j)) {
					lista.addValore(ConstantsFormat.dateSeconds.stampa(), scnt.getDate_apertura());
				} else if(ti.getPosizione(ConstantsMap.storia_contatto_date_chiamata).equals(j)) {
					lista.addValore(ConstantsFormat.dateSeconds.stampa(), scnt.getDate_chiamata());
				} else if(ti.getPosizione(ConstantsMap.storia_contatto_date_risposta).equals(j)) {
					lista.addValore(ConstantsFormat.dateSeconds.stampa(), scnt.getDate_risposta());
				} else if(ti.getPosizione(ConstantsMap.storia_contatto_date_rec_inizio).equals(j)) {
					lista.addValore(ConstantsFormat.dateSeconds.stampa(), scnt.getDate_rec_inizio());
				} else if(ti.getPosizione(ConstantsMap.storia_contatto_date_rec_fine).equals(j)) {
					lista.addValore(ConstantsFormat.dateSeconds.stampa(), scnt.getDate_rec_fine());
				} else if(ti.getPosizione(ConstantsMap.storia_contatto_date_fine).equals(j)) {
					lista.addValore(ConstantsFormat.dateSeconds.stampa(), scnt.getDate_fine());
				} else if(ti.getPosizione(ConstantsMap.storia_contatto_date_esito).equals(j)) {
					lista.addValore(ConstantsFormat.dateSeconds.stampa(), scnt.getDate_esito());
				} else if(ti.getPosizione(ConstantsMap.storia_contatto_date_attesa_inizio).equals(j)) {
					lista.addValore(ConstantsFormat.dateSeconds.stampa(), scnt.getDate_attesa_inizio());
				} else if(ti.getPosizione(ConstantsMap.storia_contatto_date_attesa_fine).equals(j)) {
					lista.addValore(ConstantsFormat.dateSeconds.stampa(), scnt.getDate_attesa_fine());
				} else if(ti.getPosizione(ConstantsMap.contatto_data_archiviazione).equals(j)) {
					lista.addValore(ConstantsFormat.dateTime.stampa(), cnt.getData_archiviazione());
				} else if(ti.getPosizione(ConstantsMap.contatto_esito_chiamata).equals(j)) {
					lista.addValore(cnt.getEsito_chiamata());
				} else if(ti.getPosizione(ConstantsMap.contatto_esito_archiviazione).equals(j)) {
					lista.addValore(cnt.getEsito_archiviazione());
				} else if(ti.getPosizione(ConstantsMap.contatto_esito_generale).equals(j)) {
					lista.addValore(cnt.getEsito_generale());
				} else if(ti.getPosizione(ConstantsMap.contatto_codice_chiamata).equals(j)) {
					lista.addValore(cnt.getCodice_chiamata());
				} else if(ti.getPosizione(ConstantsMap.contatto_codice_archiviazione).equals(j)) {
					lista.addValore(cnt.getCodice_archiviazione());
				} else if(ti.getPosizione(ConstantsMap.contatto_codice_generale).equals(j)) {
					lista.addValore(cnt.getCodice_generale());
				} else if(ti.getPosizione(ConstantsMap.contatto_data_lavorazione).equals(j)) {
					lista.addValore(ConstantsFormat.dateTime.stampa(), cnt.getData_lavorazione());
				} else if(ti.getPosizione(ConstantsMap.contatto_operatore_denominazione).equals(j)) {
					lista.addValore(cnt.getOperatore_denominazione());
				} else if(ti.getPosizione(ConstantsMap.contatto_operatore_codice).equals(j)) {
					lista.addValore(cnt.getOperatore_codice());
				} else if(ti.getPosizione(ConstantsMap.contatto_proprietario_denominazione).equals(j)) {
					lista.addValore(cnt.getProprietario_denominazione());
				} else if(ti.getPosizione(ConstantsMap.contatto_proprietario_codice).equals(j)) {
					lista.addValore(cnt.getProprietario_codice());
				} else if(ti.getPosizione(ConstantsMap.contatto_data_presentazione).equals(j)) {
					lista.addValore(ConstantsFormat.dateTime.stampa(), cnt.getData_presentazione());
				} else if(ti.getPosizione(ConstantsMap.contatto_nota).equals(j)) {
					lista.addValore(cnt.getNota());
				} else if(ti.getPosizione(ConstantsMap.contatto_data_creazione).equals(j)) {
					lista.addValore(ConstantsFormat.dateTime.stampa(), cnt.getData_creazione());
				} else if(ti.getPosizione(ConstantsMap.contatto_agente_denominazione).equals(j)) {
					lista.addValore(cnt.getAgente_denominazione());
				} else if(ti.getPosizione(ConstantsMap.contatto_agente_codice).equals(j)) {
					lista.addValore(cnt.getAgente_codice());
				} else if(ti.getPosizione(ConstantsMap.contatto_stato).equals(j)) {
					lista.addValore(cnt.getTipoTesto());
				} else if(ti.getPosizione(ConstantsMap.contatto_id).equals(j)) {
					lista.addValore(cnt.getId().toString());
				} else if(ti.getPosizione(ConstantsMap.contatto_campagna_denominazione).equals(j)) {
					lista.addValore(cnt.getCampagna_denominazione());
				} else if(ti.getPosizione(ConstantsMap.contatto_lista_denominazione).equals(j)) {
					lista.addValore(cnt.getLista_denominazione());
				} else if(ti.getPosizione(ConstantsMap.contatto_campagna_codice).equals(j)) {
					lista.addValore(cnt.getCampagna_codice());
				} else if(ti.getPosizione(ConstantsMap.contatto_bloccato).equals(j)) {
					lista.addValore(cnt.getBloccatoS());
				} else if(ti.getPosizione(ConstantsMap.contatto_lista_codice).equals(j)) {
					lista.addValore(cnt.getLista_codice());
				} else if(ti.getPosizione(ConstantsMap.contatto_positivo).equals(j)) {
					lista.addValore(cnt.getPositivo());
				} else if(ti.getPosizione(ConstantsMap.contatto_telefono_predefinito).equals(j)) {
					lista.addValore(ApplicationUtil.uniforma(cnt.getTelefono_predefinito(), ti.getRem_predefinito(), ti.getAdd_predefinito()));
				} else if(ti.getPosizione(ConstantsMap.contatto_utile).equals(j)) {
					lista.addValore(cnt.getUtile());
				} else if(ti.getPosizione(ConstantsMap.contatto_chiuso).equals(j)) {
					lista.addValore(cnt.getChiuso());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_cognome).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getCognome());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_nome).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getNome());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_nome_completo).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getNome_completo());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_email).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getEmail());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_codice_fiscale).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getCodice_fiscale());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_sorgente).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getSorgente());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_nota).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getNota());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_luogo_nascita).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getLuogo_nascita());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_data_nascita).equals(j)) {
					lista.addValore(ConstantsFormat.date.stampa(), cnt.getAnagrafica().getDate_nascita());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_link).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getLink());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_privacy).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getPrivacy());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_data_inserimento).equals(j)) {
					lista.addValore(ConstantsFormat.dateTime.stampa(), cnt.getAnagrafica().getData_creazione());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_tipo).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getTipo());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_sesso).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getSesso());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_partita_iva).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getPartita_iva());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_ragione_sociale).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getRagione_sociale());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_telefono_fisso).equals(j)) {
					lista.addValore(ApplicationUtil.uniforma(cnt.getAnagrafica().getTelefono_fisso(), ti.getRem_fisso(), ti.getAdd_fisso()));
				} else if(ti.getPosizione(ConstantsMap.anagrafica_telefono_altro).equals(j)) {
					lista.addValore(ApplicationUtil.uniforma(cnt.getAnagrafica().getTelefono_altro(), ti.getRem_altro(), ti.getAdd_altro()));
				} else if(ti.getPosizione(ConstantsMap.anagrafica_telefono_mobile).equals(j)) {
					lista.addValore(ApplicationUtil.uniforma(cnt.getAnagrafica().getTelefono_mobile(), ti.getRem_mobile(), ti.getAdd_mobile()));
				} else if(ti.getPosizione(ConstantsMap.anagrafica_telefono_fax).equals(j)) {
					lista.addValore(ApplicationUtil.uniforma(cnt.getAnagrafica().getTelefono_fax(), ti.getRem_fax(), ti.getAdd_fax()));
				} else if(ti.getPosizione(ConstantsMap.anagrafica_settore).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getSettore());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_denominazione).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getDenominazione());
				} else if(ti.getPosizione(ConstantsMap.anagrafica_id).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIdentificativo());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_indirizzo_completo).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_legale().getIndirizzo_completo());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_strada_completo).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_legale().getStrada_completo());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_comune_completo).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_legale().getComune_completo());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_strada).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_legale().getStrada());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_civico).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_legale().getCivico());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_cap).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_legale().getCap());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_comune).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_legale().getComune());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_provincia).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_legale().getProvincia());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_regione).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_legale().getRegione());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_dettagli).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_legale().getDettagli());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_latitudine).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_legale().getLatitudine());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_longitudine).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_legale().getLongitudine());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_presso).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_legale().getPresso());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_indirizzo_completo).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_operativo().getIndirizzo_completo());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_strada_completo).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_operativo().getStrada_completo());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_comune_completo).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_operativo().getComune_completo());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_strada).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_operativo().getStrada());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_civico).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_operativo().getCivico());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_cap).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_operativo().getCap());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_comune).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_operativo().getComune());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_provincia).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_operativo().getProvincia());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_regione).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_operativo().getRegione());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_dettagli).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_operativo().getDettagli());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_latitudine).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_operativo().getLatitudine());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_longitudine).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_operativo().getLongitudine());
				} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_presso).equals(j)) {
					lista.addValore(cnt.getAnagrafica().getIndirizzo_operativo().getPresso());
				} else if(ti.getPosizione(ConstantsMap.consenso_tfissoS).equals(j)) {
					lista.addValore(ConstantsFormat.dateTime.stampa(), cnt.getAnagrafica().getConsenso_tfisso());
				} else if(ti.getPosizione(ConstantsMap.consenso_tmobileS).equals(j)) {
					lista.addValore(ConstantsFormat.dateTime.stampa(), cnt.getAnagrafica().getConsenso_tmobile());
				} else if(ti.getPosizione(ConstantsMap.consenso_tfaxS).equals(j)) {
					lista.addValore(ConstantsFormat.dateTime.stampa(), cnt.getAnagrafica().getConsenso_tfax());
				} else if(ti.getPosizione(ConstantsMap.consenso_taltroS).equals(j)) {
					lista.addValore(ConstantsFormat.dateTime.stampa(), cnt.getAnagrafica().getConsenso_taltro());
				} else if(ti.getPosizione(ConstantsMap.consenso_emailS).equals(j)) {
					lista.addValore(ConstantsFormat.dateTime.stampa(), cnt.getAnagrafica().getConsenso_email());
				} else if(ti.getPosizione(ConstantsMap.consenso_rmailS).equals(j)) {
					lista.addValore(ConstantsFormat.dateTime.stampa(), cnt.getAnagrafica().getConsenso_rmail());
				} else {
					stampaDato(lista, titles[j], cnt.getAnagrafica().getDettagli(), null);
				}
			}
			for (int j = 0; j < lista.size(); j++) {
				ExcelFormat el = lista.get(j);
				Cell cell = row.createCell(j, el.getCellType());
				ApplicationUtil.cellStamper(s, cell, el);
			}
		}
		sheet.setDefaultColumnWidth(20);
		ApplicationUtil.passwordXLS(wb, result, password);
		
	}
	public static void esportaExcelTelecom(List<Telecom> data, OutputStream result, String password) throws Exception {
		String [] titles = new ExportUtility().titlesTelecom;
		Workbook wb = ApplicationUtil.workbookS();
		ExcelStyle s = new ExcelStyle(wb);
		Sheet sheet = wb.createSheet(ConstantsLanguage.TELECOM.stampa());
		int k = 0;
		Row row = sheet.createRow(k++);
		for(int i = 0; i < titles.length; i++) {
			Cell cell = row.createCell(i, CellType.STRING);
			ApplicationUtil.headerCell(s, cell,  titles[i]);
		}
		sheet.setAutoFilter(new CellRangeAddress(0, 0, 0, titles.length-1));
		sheet.createFreezePane(0, 1);
		Iterator<Telecom> objIter = data.iterator();
		while(objIter.hasNext()) {
			Telecom prd = objIter.next();
			row = sheet.createRow(k++);
			ExcelFormatList lista = new ExcelFormatList();
			lista.addValore(prd.getId().toString());
			lista.addValore(ConstantsFormat.dateSeconds.stampa(), prd.getData_invio());
			lista.addValore(prd.getContatto().getCampagna_denominazione());
			lista.addValore(prd.getContatto().getLista_denominazione());
			lista.addValore(prd.getContatto().getDenominazione());
			lista.addValore(prd.getUtente_denominazione());
			lista.addValore(prd.getStato());
			lista.addValore(prd.getLink());
			lista.addValore(prd.getResponse());
			for (int j = 0; j < lista.size(); j++) {
				ExcelFormat el = lista.get(j);
				Cell cell = row.createCell(j, el.getCellType());
				ApplicationUtil.cellStamper(s, cell, el);
			}
		}
		sheet.setDefaultColumnWidth(20);
		ApplicationUtil.passwordXLS(wb, result, password);
		
	}
	
	public static void esportaExcelWebhook(List<Webhook> data, OutputStream result, String password) throws Exception {
		String [] titles = new ExportUtility().titlesWebhook;
		Workbook wb = ApplicationUtil.workbookS();
		ExcelStyle s = new ExcelStyle(wb);
		Sheet sheet = wb.createSheet(ConstantsLanguage.WEBHOOK.stampa());
		int k = 0;
		Row row = sheet.createRow(k++);
		for(int i = 0; i < titles.length; i++) {
			Cell cell = row.createCell(i, CellType.STRING);
			ApplicationUtil.headerCell(s, cell,  titles[i]);
		}
		sheet.setAutoFilter(new CellRangeAddress(0, 0, 0, titles.length-1));
		sheet.createFreezePane(0, 1);
		Iterator<Webhook> objIter = data.iterator();
		while(objIter.hasNext()) {
			Webhook prd = objIter.next();
			row = sheet.createRow(k++);
			ExcelFormatList lista = new ExcelFormatList();
			lista.addValore(prd.getId().toString());
			lista.addValore(ConstantsFormat.dateSeconds.stampa(), prd.getData_creazione());
			lista.addValore(prd.getName());
			lista.addValore(prd.getWebhookTemplateS());
			lista.addValore(prd.getResponse());
			lista.addValore(prd.getParameters());
			for (int j = 0; j < lista.size(); j++) {
				ExcelFormat el = lista.get(j);
				Cell cell = row.createCell(j, el.getCellType());
				ApplicationUtil.cellStamper(s, cell, el);
			}
		}
		sheet.setDefaultColumnWidth(20);
		ApplicationUtil.passwordXLS(wb, result, password);
		
	}
	
	public static void esportaExcelRicezione(List<Ricezione> data, OutputStream result, String password) throws Exception {
		String [] titles = new ExportUtility().titlesRicezione;
		Workbook wb = ApplicationUtil.workbookS();
		ExcelStyle s = new ExcelStyle(wb);
		Sheet sheet = wb.createSheet(ConstantsLanguage.RICEZIONE.stampa());
		int k = 0;
		Row row = sheet.createRow(k++);
		for(int i = 0; i < titles.length; i++) {
			Cell cell = row.createCell(i, CellType.STRING);
			ApplicationUtil.headerCell(s, cell,  titles[i]);
		}
		sheet.setAutoFilter(new CellRangeAddress(0, 0, 0, titles.length-1));
		sheet.createFreezePane(0, 1);
		Iterator<Ricezione> objIter = data.iterator();
		while(objIter.hasNext()) {
			Ricezione prd = objIter.next();
			row = sheet.createRow(k++);
			ExcelFormatList lista = new ExcelFormatList();
			lista.addValore(prd.getId().toString());
			lista.addValore(ConstantsFormat.dateSeconds.stampa(), prd.getData_creazione());
			lista.addValore(prd.getMittente());
			lista.addValore(prd.getDestinatario());
			lista.addValore(prd.getOggetto());
			lista.addValore(ConstantsFormat.dateSeconds.stampa(), prd.getData_invio());
			lista.addValore(ConstantsFormat.dateSeconds.stampa(), prd.getData_ricezione());
			for (int j = 0; j < lista.size(); j++) {
				ExcelFormat el = lista.get(j);
				Cell cell = row.createCell(j, el.getCellType());
				ApplicationUtil.cellStamper(s, cell, el);
			}
		}
		sheet.setDefaultColumnWidth(20);
		ApplicationUtil.passwordXLS(wb, result, password);
		
	}
	
	public static void esportaExcelAccesso(List<Accesso> data, OutputStream result, String password) throws Exception {
		String [] titles = new ExportUtility().titlesAccesso;
		Workbook wb = ApplicationUtil.workbookS();
		ExcelStyle s = new ExcelStyle(wb);
		Sheet sheet = wb.createSheet(ConstantsLanguage.ACCESSI.stampa());
		int k = 0;
		Row row = sheet.createRow(k++);
		for(int i = 0; i < titles.length; i++) {
			Cell cell = row.createCell(i, CellType.STRING);
			ApplicationUtil.headerCell(s, cell,  titles[i]);
		}
		sheet.setAutoFilter(new CellRangeAddress(0, 0, 0, titles.length-1));
		sheet.createFreezePane(0, 1);
		Iterator<Accesso> objIter = data.iterator();
		while(objIter.hasNext()) {
			Accesso prd = objIter.next();
			row = sheet.createRow(k++);
			ExcelFormatList lista = new ExcelFormatList();
			lista.addValore(prd.getId().toString());
			lista.addValore(ConstantsFormat.dateTime.stampa(), prd.getData_creazione());
			lista.addValore(prd.getUtente_denominazione());
			lista.addValore(prd.getIp());
			lista.addValore(prd.getBrowser());
			for (int j = 0; j < lista.size(); j++) {
				ExcelFormat el = lista.get(j);
				Cell cell = row.createCell(j, el.getCellType());
				ApplicationUtil.cellStamper(s, cell, el);
			}
		}
		sheet.setDefaultColumnWidth(20);
		ApplicationUtil.passwordXLS(wb, result, password);
		
	}
	
	public static void esportaExcelSondaggio(List<Sondaggio> data, OutputStream result, String password) throws Exception {
		String [] titles = new ExportUtility().titlesSondaggio;
		Workbook wb = ApplicationUtil.workbookS();
		ExcelStyle s = new ExcelStyle(wb);
		Sheet sheet = wb.createSheet(ConstantsLanguage.SONDAGGIO.stampa());
		int k = 0;
		Row row = sheet.createRow(k++);
		for(int i = 0; i < titles.length; i++) {
			Cell cell = row.createCell(i, CellType.STRING);
			ApplicationUtil.headerCell(s, cell,  titles[i]);
		}
		sheet.setAutoFilter(new CellRangeAddress(0, 0, 0, titles.length-1));
		sheet.createFreezePane(0, 1);
		Iterator<Sondaggio> objIter = data.iterator();
		while(objIter.hasNext()) {
			Sondaggio prd = objIter.next();
			row = sheet.createRow(k++);
			ExcelFormatList lista = new ExcelFormatList();
			lista.addValore(prd.getId().toString());
			lista.addValore(ConstantsFormat.dateSeconds.stampa(), prd.getData_creazione());
			lista.addValore(prd.getContatto().getCampagna_denominazione());
			lista.addValore(prd.getContatto().getLista_denominazione());
			lista.addValore(prd.getContatto().getDenominazione());
			lista.addValore(prd.getUtente_denominazione());
			lista.addValore(prd.getVoto());
			for (int j = 0; j < lista.size(); j++) {
				ExcelFormat el = lista.get(j);
				Cell cell = row.createCell(j, el.getCellType());
				ApplicationUtil.cellStamper(s, cell, el);
			}
		}
		sheet.setDefaultColumnWidth(20);
		ApplicationUtil.passwordXLS(wb, result, password);
		
	}
	
	public static void esportaExcel(Boolean hd, List<String> titles, List<List<QueryElement>> qks, OutputStream result, String password) throws Exception {
		Workbook wb = ApplicationUtil.workbookS();
		ExcelStyle s = new ExcelStyle(wb);
		Sheet sheet = wb.createSheet(ConstantsLanguage.QUERY.stampa());
		int k = 0;
		if(ApplicationUtil.isTrue(hd)) {
			Row row = sheet.createRow(k++);
			for(int i = 0; i < titles.size(); i++) {
				Cell cell = row.createCell(i, CellType.STRING);
				ApplicationUtil.headerCell(s, cell,  titles.get(i));
			}
			sheet.setAutoFilter(new CellRangeAddress(0, 0, 0, titles.size()-1));
			sheet.createFreezePane(0, 1);
		}
		for(int i = 0; i < qks.size(); i++) {
			Row row = sheet.createRow(k++);
			List<QueryElement> qkd = qks.get(i);
			for(int j = 0; j < qkd.size(); j++) {
				QueryElement o = qkd.get(j);
				ExcelFormat a = o != null ? o.toExcel() : new ExcelFormat(null, null);
				Cell cell = row.createCell(j, a.getCellType());
				ApplicationUtil.cellStamper(s, cell, a);
			}
		}
		sheet.setDefaultColumnWidth(20);
		ApplicationUtil.passwordXLS(wb, result, password);
	}
}