package it.callite.utility;
import it.callite.column.generic.GenericColumn;
import it.callite.constants.ConstantsFormat;
import it.callite.constants.ConstantsMap;
import it.callite.model.Anagrafica;
import it.callite.model.Appuntamento;
import it.callite.model.Contatto;
import it.callite.model.Contratto;
import it.callite.model.Indirizzo;
import it.callite.model.Opposizione;
import it.callite.model.StoriaAppuntamento;
import it.callite.model.StoriaContatto;
import it.callite.model.StoriaContratto;
public class ModelExport {
	public static Colonna stampaAnagrafica(Anagrafica prd, String metodo, GenericColumn c)  {
		Colonna colonna = new Colonna(); 
		if((c == null) || (c != null && c.getVisibile(ConstantsMap.anagrafica, metodo))) {
			if(metodo.equals(ConstantsMap.anagrafica_cognome)) {
				colonna.setValore(prd.getCognome());
			} else if(metodo.equals(ConstantsMap.anagrafica_nome)) {
				colonna.setValore(prd.getNome());
			} else if(metodo.equals(ConstantsMap.anagrafica_nome_completo)) {
				colonna.setValore(prd.getNome_completo());
			} else if(metodo.equals(ConstantsMap.anagrafica_email)) {
				colonna.setValore(prd.getEmail());
			} else if(metodo.equals(ConstantsMap.anagrafica_codice_fiscale)) {
				colonna.setValore(prd.getCodice_fiscale());
			} else if(metodo.equals(ConstantsMap.anagrafica_sorgente)) {
				colonna.setValore(prd.getSorgente());
			} else if(metodo.equals(ConstantsMap.anagrafica_nota)) {
				colonna.setValore(prd.getNota());
			} else if(metodo.equals(ConstantsMap.anagrafica_luogo_nascita)) {
				colonna.setValore(prd.getLuogo_nascita());
			} else if(metodo.equals(ConstantsMap.anagrafica_data_nascita)) {
				colonna.setValore(ApplicationUtil.formatDate(ConstantsFormat.date.stampa(), prd.getDate_nascita()));
			} else if(metodo.equals(ConstantsMap.anagrafica_link)) {
				colonna.setValore(prd.getLink());
			} else if(metodo.equals(ConstantsMap.anagrafica_data_inserimento)) {
				colonna.setValore(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), prd.getData_creazione()));
			} else if(metodo.equals(ConstantsMap.anagrafica_privacy)) {
				colonna.setValore(prd.getPrivacy());
			} else if(metodo.equals(ConstantsMap.anagrafica_tipo)) {
				colonna.setValore(prd.getTipo());
			} else if(metodo.equals(ConstantsMap.anagrafica_sesso)) {
				colonna.setValore(prd.getSesso());
			} else if(metodo.equals(ConstantsMap.anagrafica_partita_iva)) {
				colonna.setValore(prd.getPartita_iva());
			} else if(metodo.equals(ConstantsMap.anagrafica_ragione_sociale)) {
				colonna.setValore(prd.getRagione_sociale());
			} else if(metodo.equals(ConstantsMap.anagrafica_telefono_fisso)) {
				colonna.setValore(prd.getTelefono_fisso());
			} else if(metodo.equals(ConstantsMap.anagrafica_telefono_altro)) {
				colonna.setValore(prd.getTelefono_altro());
			} else if(metodo.equals(ConstantsMap.anagrafica_telefono_mobile)) {
				colonna.setValore(prd.getTelefono_mobile());
			} else if(metodo.equals(ConstantsMap.anagrafica_telefono_fax)) {
				colonna.setValore(prd.getTelefono_fax());
			} else if(metodo.equals(ConstantsMap.anagrafica_settore)) {
				colonna.setValore(prd.getSettore());
			} else if(metodo.equals(ConstantsMap.anagrafica_denominazione)) {
				colonna.setValore(prd.getDenominazione());
			} else if(metodo.equals(ConstantsMap.anagrafica_id)) {
				colonna.setValore(prd.getIdentificativo());
			} 
		}
		return colonna;
	}
		
	public static Colonna stampaConsenso(Anagrafica prd, String metodo, GenericColumn c)  {
		Colonna colonna = new Colonna(); 
		String color = "red";
		if((c == null) || (c != null && c.getVisibile(ConstantsMap.consenso, metodo))) {
			if(metodo.equals(ConstantsMap.consenso_tfissoS)) {
				colonna.setColore(!prd.getConsenso_tfissoT() ? color : null);
				colonna.setValore(prd.getConsenso_tfissoS());
			} else if(metodo.equals(ConstantsMap.consenso_tmobileS)) {
				colonna.setColore(!prd.getConsenso_tmobileT() ? color : null);
				colonna.setValore(prd.getConsenso_tmobileS());
			} else if(metodo.equals(ConstantsMap.consenso_tfaxS)) {
				colonna.setColore(!prd.getConsenso_tfaxT() ? color : null);
				colonna.setValore(prd.getConsenso_tfaxS());
			} else if(metodo.equals(ConstantsMap.consenso_taltroS)) {
				colonna.setColore(!prd.getConsenso_taltroT() ? color : null);
				colonna.setValore(prd.getConsenso_taltroS());
			} else if(metodo.equals(ConstantsMap.consenso_emailS)) {
				colonna.setColore(!prd.getConsenso_emailT() ? color : null);
				colonna.setValore(prd.getConsenso_emailS());
			} else if(metodo.equals(ConstantsMap.consenso_rmailS)) {
				colonna.setColore(!prd.getConsenso_rmailT() ? color : null);
				colonna.setValore(prd.getConsenso_rmailS());
			} 
		}
		return colonna;
	}
	public static Colonna stampaIndirizzoLegale(Indirizzo prd, String metodo, GenericColumn c)  {
		Colonna colonna = new Colonna(); 
		if((c == null) || (c != null && c.getVisibile(ConstantsMap.indirizzo_legale, metodo))) {
			if(metodo.equals(ConstantsMap.indirizzo_legale_indirizzo_completo)) {
				colonna.setValore(prd.getIndirizzo_completo());
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_strada_completo)) {
				colonna.setValore(prd.getStrada_completo());
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_comune_completo)) {
				colonna.setValore(prd.getComune_completo());
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_strada)) {
				colonna.setValore(prd.getStrada());
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_civico)) {
				colonna.setValore(prd.getCivico());
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_cap)) {
				colonna.setValore(prd.getCap());
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_comune)) {
				colonna.setValore(prd.getComune());
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_provincia)) {
				colonna.setValore(prd.getProvincia());
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_regione)) {
				colonna.setValore(prd.getRegione());
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_dettagli)) {
				colonna.setValore(prd.getDettagli());
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_latitudine)) {
				colonna.setValore(prd.getLatitudine());
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_longitudine)) {
				colonna.setValore(prd.getLongitudine());
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_presso)) {
				colonna.setValore(prd.getPresso());
			} 
		}
		return colonna;
	}
	public static Colonna stampaIndirizzoOperativo(Indirizzo prd, String metodo, GenericColumn c)  {
		Colonna colonna = new Colonna(); 
		if((c == null) || (c != null && c.getVisibile(ConstantsMap.indirizzo_operativo, metodo))) {
			if(metodo.equals(ConstantsMap.indirizzo_operativo_indirizzo_completo)) {
				colonna.setValore(prd.getIndirizzo_completo());
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_strada_completo)) {
				colonna.setValore(prd.getStrada_completo());
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_comune_completo)) {
				colonna.setValore(prd.getComune_completo());
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_strada)) {
				colonna.setValore(prd.getStrada());
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_civico)) {
				colonna.setValore(prd.getCivico());
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_cap)) {
				colonna.setValore(prd.getCap());
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_comune)) {
				colonna.setValore(prd.getComune());
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_provincia)) {
				colonna.setValore(prd.getProvincia());
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_regione)) {
				colonna.setValore(prd.getRegione());
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_dettagli)) {
				colonna.setValore(prd.getDettagli());
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_latitudine)) {
				colonna.setValore(prd.getLatitudine());
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_longitudine)) {
				colonna.setValore(prd.getLongitudine());
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_presso)) {
				colonna.setValore(prd.getPresso());
			} 
		}
		return colonna;
	}
	public static Colonna stampaContatto(Contatto cnt, String metodo, GenericColumn c)  {
		Colonna colonna = new Colonna(); 
		if((c == null) || (c != null && c.getVisibile(ConstantsMap.contatto, metodo))) {
			if(metodo.equals(ConstantsMap.contatto_data_archiviazione)) {
				colonna.setValore(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), cnt.getData_archiviazione()));
			} else if(metodo.equals(ConstantsMap.contatto_esito_chiamata)) {
				colonna.setColore(cnt.getEsitoChiamata() != null ? cnt.getEsitoChiamata().getColore() : null);
				colonna.setValore(cnt.getEsito_chiamata());
			} else if(metodo.equals(ConstantsMap.contatto_esito_archiviazione)) {
				colonna.setColore(cnt.getEsitoArchiviazione() != null ? cnt.getEsitoArchiviazione().getColore() : null);
				colonna.setValore(cnt.getEsito_archiviazione());
			} else if(metodo.equals(ConstantsMap.contatto_esito_generale)) {
				colonna.setColore(cnt.getEsitoGeneraleColore());
				colonna.setValore(cnt.getEsito_generale());
			} else if(metodo.equals(ConstantsMap.contatto_codice_chiamata)) {
				colonna.setColore(cnt.getEsitoChiamata() != null ? cnt.getEsitoChiamata().getColore() : null);
				colonna.setValore(cnt.getCodice_chiamata());
			} else if(metodo.equals(ConstantsMap.contatto_codice_archiviazione)) {
				colonna.setColore(cnt.getEsitoArchiviazione() != null ? cnt.getEsitoArchiviazione().getColore() : null);
				colonna.setValore(cnt.getCodice_archiviazione());
			} else if(metodo.equals(ConstantsMap.contatto_codice_generale)) {
				colonna.setColore(cnt.getEsitoGeneraleColore());
				colonna.setValore(cnt.getCodice_generale());
			} else if(metodo.equals(ConstantsMap.contatto_data_lavorazione)) {
				colonna.setValore(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), cnt.getData_lavorazione()));
			} else if(metodo.equals(ConstantsMap.contatto_operatore_denominazione)) {
				colonna.setValore(cnt.getOperatore_denominazione());
			} else if(metodo.equals(ConstantsMap.contatto_operatore_codice)) {
				colonna.setValore(cnt.getOperatore_codice());
			} else if(metodo.equals(ConstantsMap.contatto_proprietario_denominazione)) {
				colonna.setValore(cnt.getProprietario_denominazione());
			} else if(metodo.equals(ConstantsMap.contatto_proprietario_codice)) {
				colonna.setValore(cnt.getProprietario_codice());
			} else if(metodo.equals(ConstantsMap.contatto_data_presentazione)) {
				colonna.setValore(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), cnt.getData_presentazione()));
			} else if(metodo.equals(ConstantsMap.contatto_nota)) {
				colonna.setValore(cnt.getNota());
			} else if(metodo.equals(ConstantsMap.contatto_data_creazione)) {
				colonna.setValore(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), cnt.getData_creazione()));
			} else if(metodo.equals(ConstantsMap.contatto_agente_denominazione)) {
				colonna.setValore(cnt.getAgente_denominazione());
			} else if(metodo.equals(ConstantsMap.contatto_agente_codice)) {
				colonna.setValore(cnt.getAgente_codice());
			} else if(metodo.equals(ConstantsMap.contatto_stato)) {
				colonna.setColore(cnt.getColore());
				colonna.setValore(cnt.getTipoTesto());
			} else if(metodo.equals(ConstantsMap.contatto_id)) {
				colonna.setValore(cnt.getId().toString());
			} else if(metodo.equals(ConstantsMap.contatto_campagna_denominazione)) {
				colonna.setValore(cnt.getCampagna_denominazione());
			} else if(metodo.equals(ConstantsMap.contatto_lista_denominazione)) {
				colonna.setValore(cnt.getLista_denominazione());
			} else if(metodo.equals(ConstantsMap.contatto_campagna_codice)) {
				colonna.setValore(cnt.getCampagna_codice());
			} else if(metodo.equals(ConstantsMap.contatto_bloccato)) {
				colonna.setValore(cnt.getBloccatoS());
			} else if(metodo.equals(ConstantsMap.contatto_lista_codice)) {
				colonna.setValore(cnt.getLista_codice());
			} else if(metodo.equals(ConstantsMap.contatto_positivo)) {
				colonna.setValore(cnt.getPositivo());
			} else if(metodo.equals(ConstantsMap.contatto_telefono_predefinito)) {
				colonna.setValore(cnt.getTelefono_predefinito());
			} else if(metodo.equals(ConstantsMap.contatto_utile)) {
				colonna.setValore(cnt.getUtile());
			} else if(metodo.equals(ConstantsMap.contatto_chiuso)) {
				colonna.setValore(cnt.getChiuso());
			} 
		}
		return colonna;
	}
	public static Colonna stampaAppuntamento(Appuntamento app, String metodo, GenericColumn c)  {
		Colonna colonna = new Colonna(); 
		if((c == null) || (c != null && c.getVisibile(ConstantsMap.appuntamento, metodo))) {
			if(metodo.equals(ConstantsMap.appuntamento_id)) {
				colonna.setValore(app.getId().toString());
			} else if(metodo.equals(ConstantsMap.appuntamento_operatore_denominazione)) {
				colonna.setValore(app.getOperatore_denominazione());
			} else if(metodo.equals(ConstantsMap.appuntamento_bloccato)) {
				colonna.setValore(app.getBloccatoS());
			} else if(metodo.equals(ConstantsMap.appuntamento_operatore_codice)) {
				colonna.setValore(app.getOperatore_codice());
			} else if(metodo.equals(ConstantsMap.appuntamento_agente_denominazione)) {
				colonna.setValore(app.getAgente_denominazione());
			} else if(metodo.equals(ConstantsMap.appuntamento_agente_codice)) {
				colonna.setValore(app.getAgente_codice());
			} else if(metodo.equals(ConstantsMap.appuntamento_nota)) {
				colonna.setValore(app.getNota());
			} else if(metodo.equals(ConstantsMap.appuntamento_data_creazione)) {
				colonna.setValore(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), app.getData_creazione()));
			} else if(metodo.equals(ConstantsMap.appuntamento_data_appuntamento)) {
				colonna.setValore(ApplicationUtil.formatDate(ConstantsFormat.date.stampa(), app.getData_inizio()));
			} else if(metodo.equals(ConstantsMap.appuntamento_data_ora)) {
				colonna.setValore(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), app.getData_inizio()));
			} else if(metodo.equals(ConstantsMap.appuntamento_ora_inizio)) {
				colonna.setValore(ApplicationUtil.formatDate(ConstantsFormat.time.stampa(), app.getData_inizio()));
			} else if(metodo.equals(ConstantsMap.appuntamento_ora_fine)) {
				colonna.setValore(ApplicationUtil.formatDate(ConstantsFormat.time.stampa(), app.getData_fine()));
			} else if(metodo.equals(ConstantsMap.appuntamento_data_conferma)) {
				colonna.setValore(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), app.getData_conferma()));
			} else if(metodo.equals(ConstantsMap.appuntamento_data_lavorazione)) {
				colonna.setValore(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), app.getData_lavorazione()));
			} else if(metodo.equals(ConstantsMap.appuntamento_localizzazione)) {
				colonna.setValore(app.getLocalizzazioneString());
			} else if(metodo.equals(ConstantsMap.appuntamento_utente_denominazione)) {
				colonna.setValore(app.getUtente_denominazione());
			} else if(metodo.equals(ConstantsMap.appuntamento_utente_codice)) {
				colonna.setValore(app.getUtente_codice());
			} else if(metodo.equals(ConstantsMap.appuntamento_data_esito)) {
				colonna.setValore(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), app.getData_esito()));
			} else if(metodo.equals(ConstantsMap.appuntamento_data_stato)) {
				colonna.setValore(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), app.getData_stato()));
			} else if(metodo.equals(ConstantsMap.appuntamento_esito_appuntamento)) {
				colonna.setSfondo(app.getEsito() != null ? app.getEsito().getColore() : null);
				colonna.setValore(app.getEsitoEtichetta());
			} else if(metodo.equals(ConstantsMap.appuntamento_codice_appuntamento)) {
				colonna.setSfondo(app.getEsito() != null ? app.getEsito().getColore() : null);
				colonna.setValore(app.getEsitoCodice());
			} else if(metodo.equals(ConstantsMap.appuntamento_stato)) {
				colonna.setColore(app.getColore());
				colonna.setValore(app.getStatoTesto());
			}
		}
		return colonna;
	}
	public static Colonna stampaContratto(Contratto crt, String metodo, GenericColumn c)  {
		Colonna colonna = new Colonna(); 
		if((c == null) || (c != null && c.getVisibile(ConstantsMap.contratto, metodo))) {
			if(metodo.equals(ConstantsMap.contratto_data_creazione)) {
				colonna.setValore(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), crt.getData_creazione()));
			} else if(metodo.equals(ConstantsMap.contratto_id)) {
				colonna.setValore(crt.getId().toString());
			} else if(metodo.equals(ConstantsMap.contratto_operatore_denominazione)) {
				colonna.setValore(crt.getOperatore_denominazione());
			} else if(metodo.equals(ConstantsMap.contratto_operatore_codice)) {
				colonna.setValore(crt.getOperatore_codice());
			} else if(metodo.equals(ConstantsMap.contratto_agente_denominazione)) {
				colonna.setValore(crt.getAgente_denominazione());
			} else if(metodo.equals(ConstantsMap.contratto_agente_codice)) {
				colonna.setValore(crt.getAgente_codice());
			} else if(metodo.equals(ConstantsMap.contratto_categoria_denominazione)) {
				colonna.setValore(crt.getCategoria_denominazione());
			} else if(metodo.equals(ConstantsMap.contratto_prodotto_denominazione)) {
				colonna.setValore(crt.getProdotto_denominazione());
			} else if(metodo.equals(ConstantsMap.contratto_esito_contratto)) {
				colonna.setSfondo(crt.getEsito() != null ? crt.getEsito().getColore() : null);
				colonna.setValore(crt.getEsitoEtichetta());
			} else if(metodo.equals(ConstantsMap.contratto_codice_contratto)) {
				colonna.setSfondo(crt.getEsito() != null ? crt.getEsito().getColore() : null);
				colonna.setValore(crt.getEsitoCodice());
			} else if(metodo.equals(ConstantsMap.contratto_data_stipula)) {
				colonna.setValore(ApplicationUtil.formatDate(ConstantsFormat.date.stampa(),crt.getData_stipula()));
			} else if(metodo.equals(ConstantsMap.contratto_data_contabile)) {
				colonna.setValore(ApplicationUtil.formatDate(ConstantsFormat.date.stampa(),crt.getData_contabile()));
			} else if(metodo.equals(ConstantsMap.contratto_data_attivazione)) {
				colonna.setValore(ApplicationUtil.formatDate(ConstantsFormat.date.stampa(),crt.getData_attivazione()));
			} else if(metodo.equals(ConstantsMap.contratto_data_caricamento)) {
				colonna.setValore(ApplicationUtil.formatDate(ConstantsFormat.date.stampa(),crt.getData_caricamento()));
			} else if(metodo.equals(ConstantsMap.contratto_data_lavorazione)) {
				colonna.setValore(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(),crt.getData_lavorazione()));
			} else if(metodo.equals(ConstantsMap.contratto_utente_denominazione)) {
				colonna.setValore(crt.getUtente_denominazione());
			} else if(metodo.equals(ConstantsMap.contratto_bloccato)) {
				colonna.setValore(crt.getBloccatoS());
			} else if(metodo.equals(ConstantsMap.contratto_utente_codice)) {
				colonna.setValore(crt.getUtente_codice());
			} else if(metodo.equals(ConstantsMap.contratto_data_esito)) {
				colonna.setValore(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), crt.getData_esito()));
			} else if(metodo.equals(ConstantsMap.contratto_data_stato)) {
				colonna.setValore(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), crt.getData_stato()));
			} else if(metodo.equals(ConstantsMap.contratto_nota)) {
				colonna.setValore(crt.getNota());
			} else if(metodo.equals(ConstantsMap.contratto_tipo_seriale)) {
				colonna.setValore(crt.getTipo_seriale());
			} else if(metodo.equals(ConstantsMap.contratto_seriale)) {
				colonna.setValore(crt.getSeriale());
			} else if(metodo.equals(ConstantsMap.contratto_quantita)) {
				colonna.setValore(ApplicationUtil.formatNumber(crt.getQuantita()));
			} else if(metodo.equals(ConstantsMap.contratto_costo_scontato)) {
				colonna.setValore(ApplicationUtil.formatNumber(crt.getCosto_scontato()));
			} else if(metodo.equals(ConstantsMap.contratto_stato)) {
				colonna.setColore(crt.getColore());
				colonna.setValore(crt.getStatoTesto());
			}
		}
		return colonna;
	}
	public static Colonna stampaStoriaContratto(StoriaContratto scrt, String metodo, GenericColumn c)  {
		Colonna colonna = new Colonna(); 
		if((c == null) || (c != null && c.getVisibile(ConstantsMap.storia_contratto, metodo))) {
			if(metodo.equals(ConstantsMap.storia_contratto_data)) {
				colonna.setValore(ApplicationUtil.formatDate(ConstantsFormat.dateSeconds.stampa(), scrt.getData()));
			} else if(metodo.equals(ConstantsMap.storia_contratto_id)) {
				colonna.setValore(scrt.getId().toString());
			} else if(metodo.equals(ConstantsMap.storia_contratto_operatore_denominazione)) {
				colonna.setValore(scrt.getOperatore_denominazione());
			} else if(metodo.equals(ConstantsMap.storia_contratto_operatore_codice)) {
				colonna.setValore(scrt.getOperatore_codice());
			} else if(metodo.equals(ConstantsMap.storia_contratto_agente_denominazione)) {
				colonna.setValore(scrt.getAgente_denominazione());
			} else if(metodo.equals(ConstantsMap.storia_contratto_agente_codice)) {
				colonna.setValore(scrt.getAgente_codice());
			} else if(metodo.equals(ConstantsMap.storia_contratto_categoria_denominazione)) {
				colonna.setValore(scrt.getCategoria_denominazione());
			} else if(metodo.equals(ConstantsMap.storia_contratto_prodotto_denominazione)) {
				colonna.setValore(scrt.getProdotto_denominazione());
			} else if(metodo.equals(ConstantsMap.storia_contratto_esito_contratto)) {
				colonna.setSfondo(scrt.getEsito() != null ? scrt.getEsito().getColore() : null);
				colonna.setValore(scrt.getEsitoEtichetta());
			} else if(metodo.equals(ConstantsMap.storia_contratto_codice_contratto)) {
				colonna.setSfondo(scrt.getEsito() != null ? scrt.getEsito().getColore() : null);
				colonna.setValore(scrt.getEsitoCodice());
			} else if(metodo.equals(ConstantsMap.storia_contratto_data_stipula)) {
				colonna.setValore(ApplicationUtil.formatDate(ConstantsFormat.date.stampa(),scrt.getData_stipula()));
			} else if(metodo.equals(ConstantsMap.storia_contratto_data_contabile)) {
				colonna.setValore(ApplicationUtil.formatDate(ConstantsFormat.date.stampa(),scrt.getData_contabile()));
			} else if(metodo.equals(ConstantsMap.storia_contratto_data_attivazione)) {
				colonna.setValore(ApplicationUtil.formatDate(ConstantsFormat.date.stampa(),scrt.getData_attivazione()));
			} else if(metodo.equals(ConstantsMap.storia_contratto_data_caricamento)) {
				colonna.setValore(ApplicationUtil.formatDate(ConstantsFormat.date.stampa(),scrt.getData_caricamento()));
			} else if(metodo.equals(ConstantsMap.storia_contratto_bloccato)) {
				colonna.setValore(scrt.getBloccatoS());
			} else if(metodo.equals(ConstantsMap.storia_contratto_utente_denominazione)) {
				colonna.setValore(scrt.getUtente_denominazione());
			} else if(metodo.equals(ConstantsMap.storia_contratto_utente_codice)) {
				colonna.setValore(scrt.getUtente_codice());
			} else if(metodo.equals(ConstantsMap.storia_contratto_data_esito)) {
				colonna.setValore(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), scrt.getData_esito()));
			} else if(metodo.equals(ConstantsMap.storia_contratto_data_stato)) {
				colonna.setValore(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), scrt.getData_stato()));
			} else if(metodo.equals(ConstantsMap.storia_contratto_nota)) {
				colonna.setValore(scrt.getNota());
			} else if(metodo.equals(ConstantsMap.storia_contratto_tipo_seriale)) {
				colonna.setValore(scrt.getTipo_seriale());
			} else if(metodo.equals(ConstantsMap.storia_contratto_seriale)) {
				colonna.setValore(scrt.getSeriale());
			} else if(metodo.equals(ConstantsMap.storia_contratto_quantita)) {
				colonna.setValore(ApplicationUtil.formatNumber(scrt.getQuantita()));
			} else if(metodo.equals(ConstantsMap.storia_contratto_costo_scontato)) {
				colonna.setValore(ApplicationUtil.formatNumber(scrt.getCosto_scontato()));
			} else if(metodo.equals(ConstantsMap.storia_contratto_stato)) {
				colonna.setColore(scrt.getColore());
				colonna.setValore(scrt.getStatoTesto());
			} 
		}
		return colonna;
	}
	public static Colonna stampaStoriaContatto(StoriaContatto scnt, String metodo, GenericColumn c)  {
		Colonna colonna = new Colonna(); 
		if((c == null) || (c != null && c.getVisibile(ConstantsMap.storia_contatto, metodo))) {
			if(metodo.equals(ConstantsMap.storia_contatto_data_archiviazione)) {
				colonna.setValore(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), scnt.getData_archiviazione()));
			} else if(metodo.equals(ConstantsMap.storia_contatto_esito_chiamata)) {
				colonna.setColore(scnt.getEsito() != null ? scnt.getEsito().getColore() : null);
				colonna.setValore(scnt.getEsito_chiamata());
			} else if(metodo.equals(ConstantsMap.storia_contatto_esito_archiviazione)) {
				colonna.setColore(scnt.getArchiviazione() != null ? scnt.getArchiviazione().getColore() : null);
				colonna.setValore(scnt.getEsito_archiviazione());
			} else if(metodo.equals(ConstantsMap.storia_contatto_esito_generale)) {
				colonna.setColore(scnt.getEsitoGeneraleColore());
				colonna.setValore(scnt.getEsito_generale());
			} else if(metodo.equals(ConstantsMap.storia_contatto_codice_chiamata)) {
				colonna.setColore(scnt.getEsito() != null ? scnt.getEsito().getColore() : null);
				colonna.setValore(scnt.getCodice_chiamata());
			} else if(metodo.equals(ConstantsMap.storia_contatto_codice_archiviazione)) {
				colonna.setColore(scnt.getArchiviazione() != null ? scnt.getArchiviazione().getColore() : null);
				colonna.setValore(scnt.getCodice_archiviazione());
			} else if(metodo.equals(ConstantsMap.storia_contatto_codice_generale)) {
				colonna.setColore(scnt.getEsitoGeneraleColore());
				colonna.setValore(scnt.getCodice_generale());
			} else if(metodo.equals(ConstantsMap.storia_contatto_campagna_denominazione)) {
				colonna.setValore(scnt.getCampagna_denominazione());
			} else if(metodo.equals(ConstantsMap.storia_contatto_lista_denominazione)) {
				colonna.setValore(scnt.getLista_denominazione());
			} else if(metodo.equals(ConstantsMap.storia_contatto_campagna_codice)) {
				colonna.setValore(scnt.getCampagna_codice());
			} else if(metodo.equals(ConstantsMap.storia_contatto_bloccato)) {
				colonna.setValore(scnt.getBloccatoS());
			} else if(metodo.equals(ConstantsMap.storia_contatto_lista_codice)) {
				colonna.setValore(scnt.getLista_codice());
			} else if(metodo.equals(ConstantsMap.storia_contatto_operatore_denominazione)) {
				colonna.setValore(scnt.getOperatore_denominazione());
			} else if(metodo.equals(ConstantsMap.storia_contatto_operatore_codice)) {
				colonna.setValore(scnt.getOperatore_codice());
			} else if(metodo.equals(ConstantsMap.storia_contatto_proprietario_denominazione)) {
				colonna.setValore(scnt.getProprietario_denominazione());
			} else if(metodo.equals(ConstantsMap.storia_contatto_proprietario_codice)) {
				colonna.setValore(scnt.getProprietario_codice());
			} else if(metodo.equals(ConstantsMap.storia_contatto_data_presentazione)) {
				colonna.setValore(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), scnt.getData_presentazione()));
			} else if(metodo.equals(ConstantsMap.storia_contatto_nota)) {
				colonna.setValore(scnt.getNota());
			} else if(metodo.equals(ConstantsMap.storia_contatto_data)) {
				colonna.setValore(ApplicationUtil.formatDate(ConstantsFormat.dateSeconds.stampa(), scnt.getData()));
			} else if(metodo.equals(ConstantsMap.storia_contatto_agente_denominazione)) {
				colonna.setValore(scnt.getAgente_denominazione());
			} else if(metodo.equals(ConstantsMap.storia_contatto_agente_codice)) {
				colonna.setValore(scnt.getAgente_codice());
			} else if(metodo.equals(ConstantsMap.storia_contatto_stato)) {
				colonna.setColore(scnt.getColore());
				colonna.setValore(scnt.getTipoTesto());
			} else if(metodo.equals(ConstantsMap.storia_contatto_id)) {
				colonna.setValore(scnt.getId().toString());
			} else if(metodo.equals(ConstantsMap.storia_contatto_positivo)) {
				colonna.setValore(scnt.getPositivo());
			} else if(metodo.equals(ConstantsMap.storia_contatto_utile)) {
				colonna.setValore(scnt.getUtile());
			} else if(metodo.equals(ConstantsMap.storia_contatto_chiuso)) {
				colonna.setValore(scnt.getChiuso());
			} else if(metodo.equals(ConstantsMap.storia_contatto_secondi_tot)) {
				colonna.setValore(ApplicationUtil.formatNumber(scnt.getSecondi_tot()));
			} else if(metodo.equals(ConstantsMap.storia_contatto_secondi_totH)) {
				colonna.setValore(scnt.getSecondi_totH());
			} else if(metodo.equals(ConstantsMap.storia_contatto_secondi_conv_eff)) {
				colonna.setValore(ApplicationUtil.formatNumber(scnt.getSecondi_conv_eff()));
			} else if(metodo.equals(ConstantsMap.storia_contatto_secondi_conv_effH)) {
				colonna.setValore(scnt.getSecondi_conv_effH());
			} else if(metodo.equals(ConstantsMap.storia_contatto_secondi_conv_tot)) {
				colonna.setValore(ApplicationUtil.formatNumber(scnt.getSecondi_conv_tot()));
			} else if(metodo.equals(ConstantsMap.storia_contatto_secondi_conv_totH)) {
				colonna.setValore(scnt.getSecondi_conv_totH());
			} else if(metodo.equals(ConstantsMap.storia_contatto_secondi_post)) {
				colonna.setValore(ApplicationUtil.formatNumber(scnt.getSecondi_post()));
			} else if(metodo.equals(ConstantsMap.storia_contatto_secondi_postH)) {
				colonna.setValore(scnt.getSecondi_postH());
			} else if(metodo.equals(ConstantsMap.storia_contatto_secondi_pre)) {
				colonna.setValore(ApplicationUtil.formatNumber(scnt.getSecondi_pre()));
			} else if(metodo.equals(ConstantsMap.storia_contatto_secondi_preH)) {
				colonna.setValore(scnt.getSecondi_preH());
			} else if(metodo.equals(ConstantsMap.storia_contatto_secondi_rec)) {
				colonna.setValore(ApplicationUtil.formatNumber(scnt.getSecondi_rec()));
			} else if(metodo.equals(ConstantsMap.storia_contatto_secondi_recH)) {
				colonna.setValore(scnt.getSecondi_recH());
			} else if(metodo.equals(ConstantsMap.storia_contatto_secondi_attesa)) {
				colonna.setValore(ApplicationUtil.formatNumber(scnt.getSecondi_attesa()));
			} else if(metodo.equals(ConstantsMap.storia_contatto_secondi_attesaH)) {
				colonna.setValore(scnt.getSecondi_attesaH());
			} else if(metodo.equals(ConstantsMap.storia_contatto_date_apertura)) {
				colonna.setValore(ApplicationUtil.formatDate(ConstantsFormat.dateSeconds.stampa(), scnt.getDate_apertura()));
			} else if(metodo.equals(ConstantsMap.storia_contatto_date_chiamata)) {
				colonna.setValore(ApplicationUtil.formatDate(ConstantsFormat.dateSeconds.stampa(), scnt.getDate_chiamata()));
			} else if(metodo.equals(ConstantsMap.storia_contatto_date_risposta)) {
				colonna.setValore(ApplicationUtil.formatDate(ConstantsFormat.dateSeconds.stampa(), scnt.getDate_risposta()));
			} else if(metodo.equals(ConstantsMap.storia_contatto_date_rec_inizio)) {
				colonna.setValore(ApplicationUtil.formatDate(ConstantsFormat.dateSeconds.stampa(), scnt.getDate_rec_inizio()));
			} else if(metodo.equals(ConstantsMap.storia_contatto_date_rec_fine)) {
				colonna.setValore(ApplicationUtil.formatDate(ConstantsFormat.dateSeconds.stampa(), scnt.getDate_rec_fine()));
			} else if(metodo.equals(ConstantsMap.storia_contatto_date_fine)) {
				colonna.setValore(ApplicationUtil.formatDate(ConstantsFormat.dateSeconds.stampa(), scnt.getDate_fine()));
			} else if(metodo.equals(ConstantsMap.storia_contatto_date_esito)) {
				colonna.setValore(ApplicationUtil.formatDate(ConstantsFormat.dateSeconds.stampa(), scnt.getDate_esito()));
			} else if(metodo.equals(ConstantsMap.storia_contatto_date_attesa_inizio)) {
				colonna.setValore(ApplicationUtil.formatDate(ConstantsFormat.dateSeconds.stampa(), scnt.getDate_attesa_inizio()));
			} else if(metodo.equals(ConstantsMap.storia_contatto_date_attesa_fine)) {
				colonna.setValore(ApplicationUtil.formatDate(ConstantsFormat.dateSeconds.stampa(), scnt.getDate_attesa_fine()));
			}
		}
		return colonna;
	}
	public static Colonna stampaStoriaAppuntamento(StoriaAppuntamento sapp, String metodo, GenericColumn c)  {
		Colonna colonna = new Colonna(); 
		if((c == null) || (c != null && c.getVisibile(ConstantsMap.storia_appuntamento, metodo))) {
			if(metodo.equals(ConstantsMap.storia_appuntamento_id)) {
				colonna.setValore(sapp.getId().toString());
			} else if(metodo.equals(ConstantsMap.storia_appuntamento_operatore_denominazione)) {
				colonna.setValore(sapp.getOperatore_denominazione());
			} else if(metodo.equals(ConstantsMap.storia_appuntamento_bloccato)) {
				colonna.setValore(sapp.getBloccatoS());
			} else if(metodo.equals(ConstantsMap.storia_appuntamento_operatore_codice)) {
				colonna.setValore(sapp.getOperatore_codice());
			} else if(metodo.equals(ConstantsMap.storia_appuntamento_agente_denominazione)) {
				colonna.setValore(sapp.getAgente_denominazione());
			} else if(metodo.equals(ConstantsMap.storia_appuntamento_agente_codice)) {
				colonna.setValore(sapp.getAgente_codice());
			} else if(metodo.equals(ConstantsMap.storia_appuntamento_nota)) {
				colonna.setValore(sapp.getNota());
			} else if(metodo.equals(ConstantsMap.storia_appuntamento_data)) {
				colonna.setValore(ApplicationUtil.formatDate(ConstantsFormat.dateSeconds.stampa(), sapp.getData()));
			} else if(metodo.equals(ConstantsMap.storia_appuntamento_data_inizio)) {
				colonna.setValore(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), sapp.getData_inizio()));
			} else if(metodo.equals(ConstantsMap.storia_appuntamento_data_fine)) {
				colonna.setValore(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), sapp.getData_fine()));
			} else if(metodo.equals(ConstantsMap.storia_appuntamento_data_conferma)) {
				colonna.setValore(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), sapp.getData_conferma()));
			} else if(metodo.equals(ConstantsMap.storia_appuntamento_localizzazione)) {
				colonna.setValore(sapp.getLocalizzazioneString());	
			} else if(metodo.equals(ConstantsMap.storia_appuntamento_utente_denominazione)) {
				colonna.setValore(sapp.getUtente_denominazione());
			} else if(metodo.equals(ConstantsMap.storia_appuntamento_utente_codice)) {
				colonna.setValore(sapp.getUtente_codice());
			} else if(metodo.equals(ConstantsMap.storia_appuntamento_data_esito)) {
				colonna.setValore(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), sapp.getData_esito()));
			} else if(metodo.equals(ConstantsMap.storia_appuntamento_data_stato)) {
				colonna.setValore(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), sapp.getData_stato()));
			} else if(metodo.equals(ConstantsMap.storia_appuntamento_esito_appuntamento)) {
				colonna.setSfondo(sapp.getEsito() != null ? sapp.getEsito().getColore() : null);
				colonna.setValore(sapp.getEsitoEtichetta());
			} else if(metodo.equals(ConstantsMap.storia_appuntamento_codice_appuntamento)) {
				colonna.setSfondo(sapp.getEsito() != null ? sapp.getEsito().getColore() : null);
				colonna.setValore(sapp.getEsitoCodice());
			} else if(metodo.equals(ConstantsMap.storia_appuntamento_stato)) {
				colonna.setColore(sapp.getColore());
				colonna.setValore(sapp.getStatoTesto());
			} 
		}
		return colonna;
	}
	public static String metodoIndirizzo(Indirizzo prd, String metodo) {
		if(metodo != null) {
			if(metodo.equals(ConstantsMap.indirizzo_indirizzo_completo)) {
				return prd.getIndirizzo_completo();
			} else if(metodo.equals(ConstantsMap.indirizzo_strada_completo)) {
				return prd.getStrada_completo();
			} else if(metodo.equals(ConstantsMap.indirizzo_comune_completo)) {
				return prd.getComune_completo();
			} else if(metodo.equals(ConstantsMap.indirizzo_strada)) {
				return prd.getStrada();
			} else if(metodo.equals(ConstantsMap.indirizzo_civico)) {
				return prd.getCivico();
			} else if(metodo.equals(ConstantsMap.indirizzo_cap)) {
				return prd.getCap();
			} else if(metodo.equals(ConstantsMap.indirizzo_comune)) {
				return prd.getComune();
			} else if(metodo.equals(ConstantsMap.indirizzo_provincia)) {
				return prd.getProvincia();
			} else if(metodo.equals(ConstantsMap.indirizzo_regione)) {
				return prd.getRegione();
			} else if(metodo.equals(ConstantsMap.indirizzo_dettagli)) {
				return prd.getDettagli();
			} else if(metodo.equals(ConstantsMap.indirizzo_latitudine)) {
				return prd.getLatitudine();
			} else if(metodo.equals(ConstantsMap.indirizzo_longitudine)) {
				return prd.getLongitudine();
			} else if(metodo.equals(ConstantsMap.indirizzo_presso)) {
				return prd.getPresso();
			} 
		}
		return null;
	}
	public static String metodoAnagrafica(Anagrafica prd, String metodo) {
		if(metodo != null) {
			if(metodo.equals(ConstantsMap.anagrafica_cognome)) {
				return prd.getCognome();
			} else if(metodo.equals(ConstantsMap.anagrafica_nome)) {
				return prd.getNome();
			} else if(metodo.equals(ConstantsMap.anagrafica_nome_completo)) {
				return prd.getNome_completo();
			} else if(metodo.equals(ConstantsMap.anagrafica_email)) {
				return prd.getEmail();
			} else if(metodo.equals(ConstantsMap.anagrafica_codice_fiscale)) {
				return prd.getCodice_fiscale();
			} else if(metodo.equals(ConstantsMap.anagrafica_sorgente)) {
				return prd.getSorgente();
			} else if(metodo.equals(ConstantsMap.anagrafica_nota)) {
				return prd.getNota();
			} else if(metodo.equals(ConstantsMap.anagrafica_luogo_nascita)) {
				return prd.getLuogo_nascita();
			} else if(metodo.equals(ConstantsMap.anagrafica_data_nascita)) {
				return ApplicationUtil.formatDate(ConstantsFormat.date.stampa(), prd.getDate_nascita());
			} else if(metodo.equals(ConstantsMap.anagrafica_link)) {
				return prd.getLink();
			} else if(metodo.equals(ConstantsMap.anagrafica_data_inserimento)) {
				return ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), prd.getData_creazione());
			} else if(metodo.equals(ConstantsMap.anagrafica_privacy)) {
				return prd.getPrivacy();
			} else if(metodo.equals(ConstantsMap.anagrafica_tipo)) {
				return prd.getTipo();
			} else if(metodo.equals(ConstantsMap.anagrafica_sesso)) {
				return prd.getSesso();
			} else if(metodo.equals(ConstantsMap.anagrafica_partita_iva)) {
				return prd.getPartita_iva();
			} else if(metodo.equals(ConstantsMap.anagrafica_ragione_sociale)) {
				return prd.getRagione_sociale();
			} else if(metodo.equals(ConstantsMap.anagrafica_telefono_fisso)) {
				return prd.getTelefono_fisso();
			} else if(metodo.equals(ConstantsMap.anagrafica_telefono_altro)) {
				return prd.getTelefono_altro();
			} else if(metodo.equals(ConstantsMap.anagrafica_telefono_mobile)) {
				return prd.getTelefono_mobile();
			} else if(metodo.equals(ConstantsMap.anagrafica_telefono_fax)) {
				return prd.getTelefono_fax();
			} else if(metodo.equals(ConstantsMap.anagrafica_settore)) {
				return prd.getSettore();
			} else if(metodo.equals(ConstantsMap.anagrafica_denominazione)) {
				return prd.getDenominazione();
			} else if(metodo.equals(ConstantsMap.anagrafica_id)) {
				return prd.getIdentificativo();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_indirizzo_completo)) {
				return prd.getIndirizzo_legale().getIndirizzo_completo();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_strada_completo)) {
				return prd.getIndirizzo_legale().getStrada_completo();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_comune_completo)) {
				return prd.getIndirizzo_legale().getComune_completo();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_strada)) {
				return prd.getIndirizzo_legale().getStrada();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_civico)) {
				return prd.getIndirizzo_legale().getCivico();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_cap)) {
				return prd.getIndirizzo_legale().getCap();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_comune)) {
				return prd.getIndirizzo_legale().getComune();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_provincia)) {
				return prd.getIndirizzo_legale().getProvincia();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_regione)) {
				return prd.getIndirizzo_legale().getRegione();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_dettagli)) {
				return prd.getIndirizzo_legale().getDettagli();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_latitudine)) {
				return prd.getIndirizzo_legale().getLatitudine();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_longitudine)) {
				return prd.getIndirizzo_legale().getLongitudine();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_presso)) {
				return prd.getIndirizzo_legale().getPresso();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_indirizzo_completo)) {
				return prd.getIndirizzo_operativo().getIndirizzo_completo();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_strada_completo)) {
				return prd.getIndirizzo_operativo().getStrada_completo();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_comune_completo)) {
				return prd.getIndirizzo_operativo().getComune_completo();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_strada)) {
				return prd.getIndirizzo_operativo().getStrada();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_civico)) {
				return prd.getIndirizzo_operativo().getCivico();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_cap)) {
				return prd.getIndirizzo_operativo().getCap();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_comune)) {
				return prd.getIndirizzo_operativo().getComune();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_provincia)) {
				return prd.getIndirizzo_operativo().getProvincia();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_regione)) {
				return prd.getIndirizzo_operativo().getRegione();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_dettagli)) {
				return prd.getIndirizzo_operativo().getDettagli();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_latitudine)) {
				return prd.getIndirizzo_operativo().getLatitudine();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_longitudine)) {
				return prd.getIndirizzo_operativo().getLongitudine();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_presso)) {
				return prd.getIndirizzo_operativo().getPresso();
			} else if(metodo.equals(ConstantsMap.consenso_tfissoS)) {
				return prd.getConsenso_tfissoS();
			} else if(metodo.equals(ConstantsMap.consenso_tmobileS)) {
				return prd.getConsenso_tmobileS();
			} else if(metodo.equals(ConstantsMap.consenso_tfaxS)) {
				return prd.getConsenso_tfaxS();
			} else if(metodo.equals(ConstantsMap.consenso_taltroS)) {
				return prd.getConsenso_taltroS();
			} else if(metodo.equals(ConstantsMap.consenso_emailS)) {
				return prd.getConsenso_emailS();
			} else if(metodo.equals(ConstantsMap.consenso_rmailS)) {
				return prd.getConsenso_rmailS();
			} 
		}
		return null;
	}
	public static String metodoContatto(Contatto cnt, String metodo) {
		if(metodo != null) {
			if(metodo.equals(ConstantsMap.contatto_data_archiviazione)) {
				return ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), cnt.getData_archiviazione());
			} else if(metodo.equals(ConstantsMap.contatto_esito_chiamata)) {
				return cnt.getEsito_chiamata();
			} else if(metodo.equals(ConstantsMap.contatto_esito_archiviazione)) {
				return cnt.getEsito_archiviazione();
			} else if(metodo.equals(ConstantsMap.contatto_esito_generale)) {
				return cnt.getEsito_generale();
			} else if(metodo.equals(ConstantsMap.contatto_codice_chiamata)) {
				return cnt.getCodice_chiamata();
			} else if(metodo.equals(ConstantsMap.contatto_codice_archiviazione)) {
				return cnt.getCodice_archiviazione();
			} else if(metodo.equals(ConstantsMap.contatto_codice_generale)) {
				return cnt.getCodice_generale();
			} else if(metodo.equals(ConstantsMap.contatto_data_lavorazione)) {
				return ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), cnt.getData_lavorazione());
			} else if(metodo.equals(ConstantsMap.contatto_operatore_denominazione)) {
				return cnt.getOperatore_denominazione();
			} else if(metodo.equals(ConstantsMap.contatto_operatore_codice)) {
				return cnt.getOperatore_codice();
			} else if(metodo.equals(ConstantsMap.contatto_proprietario_denominazione)) {
				return cnt.getProprietario_denominazione();
			} else if(metodo.equals(ConstantsMap.contatto_proprietario_codice)) {
				return cnt.getProprietario_codice();
			} else if(metodo.equals(ConstantsMap.contatto_data_presentazione)) {
				return ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), cnt.getData_presentazione());
			} else if(metodo.equals(ConstantsMap.contatto_nota)) {
				return cnt.getNota();
			} else if(metodo.equals(ConstantsMap.contatto_data_creazione)) {
				return ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), cnt.getData_creazione());
			} else if(metodo.equals(ConstantsMap.contatto_agente_denominazione)) {
				return cnt.getAgente_denominazione();
			} else if(metodo.equals(ConstantsMap.contatto_agente_codice)) {
				return cnt.getAgente_codice();
			} else if(metodo.equals(ConstantsMap.contatto_stato)) {
				return cnt.getTipoTesto();
			} else if(metodo.equals(ConstantsMap.contatto_id)) {
				return cnt.getId().toString();
			} else if(metodo.equals(ConstantsMap.contatto_campagna_denominazione)) {
				return cnt.getCampagna_denominazione();
			} else if(metodo.equals(ConstantsMap.contatto_lista_denominazione)) {
				return cnt.getLista_denominazione();
			} else if(metodo.equals(ConstantsMap.contatto_campagna_codice)) {
				return cnt.getCampagna_codice();
			} else if(metodo.equals(ConstantsMap.contatto_bloccato)) {
				return cnt.getBloccatoS();
			} else if(metodo.equals(ConstantsMap.contatto_lista_codice)) {
				return cnt.getLista_codice();
			} else if(metodo.equals(ConstantsMap.contatto_positivo)) {
				return cnt.getPositivo();
			} else if(metodo.equals(ConstantsMap.contatto_telefono_predefinito)) {
				return cnt.getTelefono_predefinito();
			} else if(metodo.equals(ConstantsMap.contatto_utile)) {
				return cnt.getUtile();
			} else if(metodo.equals(ConstantsMap.contatto_chiuso)) {
				return cnt.getChiuso();
			} else if(metodo.equals(ConstantsMap.anagrafica_cognome)) {
				return cnt.getAnagrafica().getCognome();
			} else if(metodo.equals(ConstantsMap.anagrafica_nome)) {
				return cnt.getAnagrafica().getNome();
			} else if(metodo.equals(ConstantsMap.anagrafica_nome_completo)) {
				return cnt.getAnagrafica().getNome_completo();
			} else if(metodo.equals(ConstantsMap.anagrafica_email)) {
				return cnt.getAnagrafica().getEmail();
			} else if(metodo.equals(ConstantsMap.anagrafica_codice_fiscale)) {
				return cnt.getAnagrafica().getCodice_fiscale();
			} else if(metodo.equals(ConstantsMap.anagrafica_sorgente)) {
				return cnt.getAnagrafica().getSorgente();
			} else if(metodo.equals(ConstantsMap.anagrafica_nota)) {
				return cnt.getAnagrafica().getNota();
			} else if(metodo.equals(ConstantsMap.anagrafica_luogo_nascita)) {
				return cnt.getAnagrafica().getLuogo_nascita();
			} else if(metodo.equals(ConstantsMap.anagrafica_data_nascita)) {
				return ApplicationUtil.formatDate(ConstantsFormat.date.stampa(), cnt.getAnagrafica().getDate_nascita());
			} else if(metodo.equals(ConstantsMap.anagrafica_link)) {
				return cnt.getAnagrafica().getLink();
			} else if(metodo.equals(ConstantsMap.anagrafica_data_inserimento)) {
				return ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), cnt.getAnagrafica().getData_creazione());
			} else if(metodo.equals(ConstantsMap.anagrafica_privacy)) {
				return cnt.getAnagrafica().getPrivacy();
			} else if(metodo.equals(ConstantsMap.anagrafica_tipo)) {
				return cnt.getAnagrafica().getTipo();
			} else if(metodo.equals(ConstantsMap.anagrafica_sesso)) {
				return cnt.getAnagrafica().getSesso();
			} else if(metodo.equals(ConstantsMap.anagrafica_partita_iva)) {
				return cnt.getAnagrafica().getPartita_iva();
			} else if(metodo.equals(ConstantsMap.anagrafica_ragione_sociale)) {
				return cnt.getAnagrafica().getRagione_sociale();
			} else if(metodo.equals(ConstantsMap.anagrafica_telefono_fisso)) {
				return cnt.getAnagrafica().getTelefono_fisso();
			} else if(metodo.equals(ConstantsMap.anagrafica_telefono_altro)) {
				return cnt.getAnagrafica().getTelefono_altro();
			} else if(metodo.equals(ConstantsMap.anagrafica_telefono_mobile)) {
				return cnt.getAnagrafica().getTelefono_mobile();
			} else if(metodo.equals(ConstantsMap.anagrafica_telefono_fax)) {
				return cnt.getAnagrafica().getTelefono_fax();
			} else if(metodo.equals(ConstantsMap.anagrafica_settore)) {
				return cnt.getAnagrafica().getSettore();
			} else if(metodo.equals(ConstantsMap.anagrafica_denominazione)) {
				return cnt.getAnagrafica().getDenominazione();
			} else if(metodo.equals(ConstantsMap.anagrafica_id)) {
				return cnt.getAnagrafica().getIdentificativo();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_indirizzo_completo)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getIndirizzo_completo();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_strada_completo)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getStrada_completo();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_comune_completo)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getComune_completo();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_strada)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getStrada();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_civico)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getCivico();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_cap)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getCap();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_comune)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getComune();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_provincia)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getProvincia();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_regione)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getRegione();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_dettagli)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getDettagli();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_latitudine)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getLatitudine();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_longitudine)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getLongitudine();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_presso)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getPresso();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_indirizzo_completo)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getIndirizzo_completo();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_strada_completo)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getStrada_completo();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_comune_completo)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getComune_completo();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_strada)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getStrada();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_civico)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getCivico();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_cap)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getCap();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_comune)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getComune();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_provincia)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getProvincia();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_regione)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getRegione();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_dettagli)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getDettagli();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_latitudine)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getLatitudine();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_longitudine)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getLongitudine();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_presso)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getPresso();
			} else if(metodo.equals(ConstantsMap.consenso_tfissoS)) {
				return cnt.getAnagrafica().getConsenso_tfissoS();
			} else if(metodo.equals(ConstantsMap.consenso_tmobileS)) {
				return cnt.getAnagrafica().getConsenso_tmobileS();
			} else if(metodo.equals(ConstantsMap.consenso_tfaxS)) {
				return cnt.getAnagrafica().getConsenso_tfaxS();
			} else if(metodo.equals(ConstantsMap.consenso_taltroS)) {
				return cnt.getAnagrafica().getConsenso_taltroS();
			} else if(metodo.equals(ConstantsMap.consenso_emailS)) {
				return cnt.getAnagrafica().getConsenso_emailS();
			} else if(metodo.equals(ConstantsMap.consenso_rmailS)) {
				return cnt.getAnagrafica().getConsenso_rmailS();
			} 
		}
		return null;
	}
	public static String metodoAppuntamento(Appuntamento app, String metodo) {
		if(metodo != null) {
			Contatto cnt = app.getContatto();
			if(metodo.equals(ConstantsMap.appuntamento_id)) {
				return app.getId().toString();
			} else if(metodo.equals(ConstantsMap.appuntamento_operatore_denominazione)) {
				return app.getOperatore_denominazione();
			} else if(metodo.equals(ConstantsMap.appuntamento_bloccato)) {
				return app.getBloccatoS();
			} else if(metodo.equals(ConstantsMap.appuntamento_operatore_codice)) {
				return app.getOperatore_codice();
			} else if(metodo.equals(ConstantsMap.appuntamento_agente_denominazione)) {
				return app.getAgente_denominazione();
			} else if(metodo.equals(ConstantsMap.appuntamento_agente_codice)) {
				return app.getAgente_codice();
			} else if(metodo.equals(ConstantsMap.appuntamento_nota)) {
				return app.getNota();
			} else if(metodo.equals(ConstantsMap.appuntamento_data_creazione)) {
				return ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), app.getData_creazione());
			} else if(metodo.equals(ConstantsMap.appuntamento_data_appuntamento)) {
				return ApplicationUtil.formatDate(ConstantsFormat.date.stampa(), app.getData_inizio());
			} else if(metodo.equals(ConstantsMap.appuntamento_data_ora)) {
				return ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), app.getData_inizio());
			} else if(metodo.equals(ConstantsMap.appuntamento_ora_inizio)) {
				return ApplicationUtil.formatDate(ConstantsFormat.time.stampa(), app.getData_inizio());
			} else if(metodo.equals(ConstantsMap.appuntamento_ora_fine)) {
				return ApplicationUtil.formatDate(ConstantsFormat.time.stampa(), app.getData_fine());
			} else if(metodo.equals(ConstantsMap.appuntamento_data_conferma)) {
				return ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), app.getData_conferma());
			} else if(metodo.equals(ConstantsMap.appuntamento_data_lavorazione)) {
				return ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), app.getData_lavorazione());
			} else if(metodo.equals(ConstantsMap.appuntamento_localizzazione)) {
				return app.getLocalizzazioneString();
			} else if(metodo.equals(ConstantsMap.appuntamento_utente_denominazione)) {
				return app.getUtente_denominazione();
			} else if(metodo.equals(ConstantsMap.appuntamento_utente_codice)) {
				return app.getUtente_codice();
			} else if(metodo.equals(ConstantsMap.appuntamento_data_esito)) {
				return ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), app.getData_esito());
			} else if(metodo.equals(ConstantsMap.appuntamento_data_stato)) {
				return ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), app.getData_stato());
			} else if(metodo.equals(ConstantsMap.appuntamento_esito_appuntamento)) {
				return app.getEsitoEtichetta();
			} else if(metodo.equals(ConstantsMap.appuntamento_codice_appuntamento)) {
				return app.getEsitoCodice();
			} else if(metodo.equals(ConstantsMap.appuntamento_stato)) {
				return app.getStatoTesto();
			} else if(metodo.equals(ConstantsMap.contatto_data_lavorazione)) {
				return ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), cnt.getData_lavorazione());
			} else if(metodo.equals(ConstantsMap.contatto_operatore_denominazione)) {
				return cnt.getOperatore_denominazione();
			} else if(metodo.equals(ConstantsMap.contatto_operatore_codice)) {
				return cnt.getOperatore_codice();
			} else if(metodo.equals(ConstantsMap.contatto_data_archiviazione)) {
				return ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), cnt.getData_archiviazione());
			} else if(metodo.equals(ConstantsMap.contatto_esito_chiamata)) {
				return cnt.getEsito_chiamata();
			} else if(metodo.equals(ConstantsMap.contatto_esito_archiviazione)) {
				return cnt.getEsito_archiviazione();
			} else if(metodo.equals(ConstantsMap.contatto_esito_generale)) {
				return cnt.getEsito_generale();
			} else if(metodo.equals(ConstantsMap.contatto_codice_chiamata)) {
				return cnt.getCodice_chiamata();
			} else if(metodo.equals(ConstantsMap.contatto_codice_archiviazione)) {
				return cnt.getCodice_archiviazione();
			} else if(metodo.equals(ConstantsMap.contatto_codice_generale)) {
				return cnt.getCodice_generale();
			} else if(metodo.equals(ConstantsMap.contatto_proprietario_denominazione)) {
				return cnt.getProprietario_denominazione();
			} else if(metodo.equals(ConstantsMap.contatto_proprietario_codice)) {
				return cnt.getProprietario_codice();
			} else if(metodo.equals(ConstantsMap.contatto_data_presentazione)) {
				return ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), cnt.getData_presentazione());
			} else if(metodo.equals(ConstantsMap.contatto_nota)) {
				return cnt.getNota();
			} else if(metodo.equals(ConstantsMap.contatto_data_creazione)) {
				return ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), cnt.getData_creazione());
			} else if(metodo.equals(ConstantsMap.contatto_agente_denominazione)) {
				return cnt.getAgente_denominazione();
			} else if(metodo.equals(ConstantsMap.contatto_agente_codice)) {
				return cnt.getAgente_codice();
			} else if(metodo.equals(ConstantsMap.contatto_stato)) {
				return cnt.getTipoTesto();
			} else if(metodo.equals(ConstantsMap.contatto_id)) {
				return cnt.getId().toString();
			} else if(metodo.equals(ConstantsMap.contatto_campagna_denominazione)) {
				return cnt.getCampagna_denominazione();
			} else if(metodo.equals(ConstantsMap.contatto_lista_denominazione)) {
				return cnt.getLista_denominazione();
			} else if(metodo.equals(ConstantsMap.contatto_campagna_codice)) {
				return cnt.getCampagna_codice();
			} else if(metodo.equals(ConstantsMap.contatto_bloccato)) {
				return cnt.getBloccatoS();
			} else if(metodo.equals(ConstantsMap.contatto_lista_codice)) {
				return cnt.getLista_codice();
			} else if(metodo.equals(ConstantsMap.contatto_positivo)) {
				return cnt.getPositivo();
			} else if(metodo.equals(ConstantsMap.contatto_telefono_predefinito)) {
				return cnt.getTelefono_predefinito();
			} else if(metodo.equals(ConstantsMap.contatto_utile)) {
				return cnt.getUtile();
			} else if(metodo.equals(ConstantsMap.contatto_chiuso)) {
				return cnt.getChiuso();
			} else if(metodo.equals(ConstantsMap.anagrafica_cognome)) {
				return cnt.getAnagrafica().getCognome();
			} else if(metodo.equals(ConstantsMap.anagrafica_nome)) {
				return cnt.getAnagrafica().getNome();
			} else if(metodo.equals(ConstantsMap.anagrafica_nome_completo)) {
				return cnt.getAnagrafica().getNome_completo();
			} else if(metodo.equals(ConstantsMap.anagrafica_email)) {
				return cnt.getAnagrafica().getEmail();
			} else if(metodo.equals(ConstantsMap.anagrafica_codice_fiscale)) {
				return cnt.getAnagrafica().getCodice_fiscale();
			} else if(metodo.equals(ConstantsMap.anagrafica_sorgente)) {
				return cnt.getAnagrafica().getSorgente();
			} else if(metodo.equals(ConstantsMap.anagrafica_nota)) {
				return cnt.getAnagrafica().getNota();
			} else if(metodo.equals(ConstantsMap.anagrafica_luogo_nascita)) {
				return cnt.getAnagrafica().getLuogo_nascita();
			} else if(metodo.equals(ConstantsMap.anagrafica_data_nascita)) {
				return ApplicationUtil.formatDate(ConstantsFormat.date.stampa(), cnt.getAnagrafica().getDate_nascita());
			} else if(metodo.equals(ConstantsMap.anagrafica_link)) {
				return cnt.getAnagrafica().getLink();
			} else if(metodo.equals(ConstantsMap.anagrafica_data_inserimento)) {
				return ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), cnt.getAnagrafica().getData_creazione());
			} else if(metodo.equals(ConstantsMap.anagrafica_privacy)) {
				return cnt.getAnagrafica().getPrivacy();
			} else if(metodo.equals(ConstantsMap.anagrafica_tipo)) {
				return cnt.getAnagrafica().getTipo();
			} else if(metodo.equals(ConstantsMap.anagrafica_sesso)) {
				return cnt.getAnagrafica().getSesso();
			} else if(metodo.equals(ConstantsMap.anagrafica_partita_iva)) {
				return cnt.getAnagrafica().getPartita_iva();
			} else if(metodo.equals(ConstantsMap.anagrafica_ragione_sociale)) {
				return cnt.getAnagrafica().getRagione_sociale();
			} else if(metodo.equals(ConstantsMap.anagrafica_telefono_fisso)) {
				return cnt.getAnagrafica().getTelefono_fisso();
			} else if(metodo.equals(ConstantsMap.anagrafica_telefono_altro)) {
				return cnt.getAnagrafica().getTelefono_altro();
			} else if(metodo.equals(ConstantsMap.anagrafica_telefono_mobile)) {
				return cnt.getAnagrafica().getTelefono_mobile();
			} else if(metodo.equals(ConstantsMap.anagrafica_telefono_fax)) {
				return cnt.getAnagrafica().getTelefono_fax();
			} else if(metodo.equals(ConstantsMap.anagrafica_settore)) {
				return cnt.getAnagrafica().getSettore();
			} else if(metodo.equals(ConstantsMap.anagrafica_denominazione)) {
				return cnt.getAnagrafica().getDenominazione();
			} else if(metodo.equals(ConstantsMap.anagrafica_id)) {
				return cnt.getAnagrafica().getIdentificativo();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_indirizzo_completo)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getIndirizzo_completo();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_strada_completo)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getStrada_completo();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_comune_completo)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getComune_completo();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_strada)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getStrada();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_civico)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getCivico();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_cap)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getCap();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_comune)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getComune();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_provincia)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getProvincia();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_regione)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getRegione();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_dettagli)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getDettagli();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_latitudine)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getLatitudine();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_longitudine)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getLongitudine();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_presso)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getPresso();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_indirizzo_completo)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getIndirizzo_completo();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_strada_completo)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getStrada_completo();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_comune_completo)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getComune_completo();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_strada)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getStrada();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_civico)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getCivico();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_cap)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getCap();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_comune)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getComune();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_provincia)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getProvincia();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_regione)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getRegione();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_dettagli)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getDettagli();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_latitudine)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getLatitudine();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_longitudine)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getLongitudine();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_presso)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getPresso();
			} else if(metodo.equals(ConstantsMap.consenso_tfissoS)) {
				return cnt.getAnagrafica().getConsenso_tfissoS();
			} else if(metodo.equals(ConstantsMap.consenso_tmobileS)) {
				return cnt.getAnagrafica().getConsenso_tmobileS();
			} else if(metodo.equals(ConstantsMap.consenso_tfaxS)) {
				return cnt.getAnagrafica().getConsenso_tfaxS();
			} else if(metodo.equals(ConstantsMap.consenso_taltroS)) {
				return cnt.getAnagrafica().getConsenso_taltroS();
			} else if(metodo.equals(ConstantsMap.consenso_emailS)) {
				return cnt.getAnagrafica().getConsenso_emailS();
			} else if(metodo.equals(ConstantsMap.consenso_rmailS)) {
				return cnt.getAnagrafica().getConsenso_rmailS();
			} 
		}
		return null;
	}
	public static String metodoContratto(Contratto crt, String metodo) {
		if(metodo != null) {
			Contatto cnt = crt.getContatto();
			if(metodo.equals(ConstantsMap.contratto_data_creazione)) {
				return ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), crt.getData_creazione());
			} else if(metodo.equals(ConstantsMap.contratto_id)) {
				return crt.getId().toString();
			} else if(metodo.equals(ConstantsMap.contratto_operatore_denominazione)) {
				return crt.getOperatore_denominazione();
			} else if(metodo.equals(ConstantsMap.contratto_operatore_codice)) {
				return crt.getOperatore_codice();
			} else if(metodo.equals(ConstantsMap.contratto_agente_denominazione)) {
				return crt.getAgente_denominazione();
			} else if(metodo.equals(ConstantsMap.contratto_agente_codice)) {
				return crt.getAgente_codice();
			} else if(metodo.equals(ConstantsMap.contratto_categoria_denominazione)) {
				return crt.getCategoria_denominazione();
			} else if(metodo.equals(ConstantsMap.contratto_prodotto_denominazione)) {
				return crt.getProdotto_denominazione();
			} else if(metodo.equals(ConstantsMap.contratto_esito_contratto)) {
				return crt.getEsitoEtichetta();
			} else if(metodo.equals(ConstantsMap.contratto_codice_contratto)) {
				return crt.getEsitoCodice();
			} else if(metodo.equals(ConstantsMap.contratto_data_stipula)) {
				return ApplicationUtil.formatDate(ConstantsFormat.date.stampa(),crt.getData_stipula());
			} else if(metodo.equals(ConstantsMap.contratto_data_contabile)) {
				return ApplicationUtil.formatDate(ConstantsFormat.date.stampa(),crt.getData_contabile());
			} else if(metodo.equals(ConstantsMap.contratto_data_attivazione)) {
				return ApplicationUtil.formatDate(ConstantsFormat.date.stampa(),crt.getData_attivazione());
			} else if(metodo.equals(ConstantsMap.contratto_data_caricamento)) {
				return ApplicationUtil.formatDate(ConstantsFormat.date.stampa(),crt.getData_caricamento());
			} else if(metodo.equals(ConstantsMap.contratto_data_lavorazione)) {
				return ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(),crt.getData_lavorazione());
			} else if(metodo.equals(ConstantsMap.contratto_utente_denominazione)) {
				return crt.getUtente_denominazione();
			} else if(metodo.equals(ConstantsMap.contratto_bloccato)) {
				return crt.getBloccatoS();
			} else if(metodo.equals(ConstantsMap.contratto_utente_codice)) {
				return crt.getUtente_codice();
			} else if(metodo.equals(ConstantsMap.contratto_data_esito)) {
				return ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), crt.getData_esito());
			} else if(metodo.equals(ConstantsMap.contratto_data_stato)) {
				return ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), crt.getData_stato());
			} else if(metodo.equals(ConstantsMap.contratto_nota)) {
				return crt.getNota();
			} else if(metodo.equals(ConstantsMap.contratto_tipo_seriale)) {
				return crt.getTipo_seriale();
			} else if(metodo.equals(ConstantsMap.contratto_seriale)) {
				return crt.getSeriale();
			} else if(metodo.equals(ConstantsMap.contratto_quantita)) {
				return ApplicationUtil.formatNumber(crt.getQuantita());
			} else if(metodo.equals(ConstantsMap.contratto_costo_scontato)) {
				return ApplicationUtil.formatNumber(crt.getCosto_scontato());
			} else if(metodo.equals(ConstantsMap.contratto_stato)) {
				return crt.getStatoTesto();
			} else if(metodo.equals(ConstantsMap.contatto_data_archiviazione)) {
				return ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), cnt.getData_archiviazione());
			} else if(metodo.equals(ConstantsMap.contatto_data_lavorazione)) {
				return ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), cnt.getData_lavorazione());
			} else if(metodo.equals(ConstantsMap.contatto_operatore_denominazione)) {
				return cnt.getOperatore_denominazione();
			} else if(metodo.equals(ConstantsMap.contatto_operatore_codice)) {
				return cnt.getOperatore_codice();
			} else if(metodo.equals(ConstantsMap.contatto_esito_chiamata)) {
				return cnt.getEsito_chiamata();
			} else if(metodo.equals(ConstantsMap.contatto_esito_archiviazione)) {
				return cnt.getEsito_archiviazione();
			} else if(metodo.equals(ConstantsMap.contatto_esito_generale)) {
				return cnt.getEsito_generale();
			} else if(metodo.equals(ConstantsMap.contatto_codice_chiamata)) {
				return cnt.getCodice_chiamata();
			} else if(metodo.equals(ConstantsMap.contatto_codice_archiviazione)) {
				return cnt.getCodice_archiviazione();
			} else if(metodo.equals(ConstantsMap.contatto_codice_generale)) {
				return cnt.getCodice_generale();
			} else if(metodo.equals(ConstantsMap.contatto_proprietario_denominazione)) {
				return cnt.getProprietario_denominazione();
			} else if(metodo.equals(ConstantsMap.contatto_proprietario_codice)) {
				return cnt.getProprietario_codice();
			} else if(metodo.equals(ConstantsMap.contatto_data_presentazione)) {
				return ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), cnt.getData_presentazione());
			} else if(metodo.equals(ConstantsMap.contatto_nota)) {
				return cnt.getNota();
			} else if(metodo.equals(ConstantsMap.contatto_data_creazione)) {
				return ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), cnt.getData_creazione());
			} else if(metodo.equals(ConstantsMap.contatto_agente_denominazione)) {
				return cnt.getAgente_denominazione();
			} else if(metodo.equals(ConstantsMap.contatto_agente_codice)) {
				return cnt.getAgente_codice();
			} else if(metodo.equals(ConstantsMap.contatto_stato)) {
				return cnt.getTipoTesto();
			} else if(metodo.equals(ConstantsMap.contatto_id)) {
				return cnt.getId().toString();
			} else if(metodo.equals(ConstantsMap.contatto_campagna_denominazione)) {
				return cnt.getCampagna_denominazione();
			} else if(metodo.equals(ConstantsMap.contatto_lista_denominazione)) {
				return cnt.getLista_denominazione();
			} else if(metodo.equals(ConstantsMap.contatto_campagna_codice)) {
				return cnt.getCampagna_codice();
			} else if(metodo.equals(ConstantsMap.contatto_bloccato)) {
				return cnt.getBloccatoS();
			} else if(metodo.equals(ConstantsMap.contatto_lista_codice)) {
				return cnt.getLista_codice();
			} else if(metodo.equals(ConstantsMap.contatto_positivo)) {
				return cnt.getPositivo();
			} else if(metodo.equals(ConstantsMap.contatto_telefono_predefinito)) {
				return cnt.getTelefono_predefinito();
			} else if(metodo.equals(ConstantsMap.contatto_utile)) {
				return cnt.getUtile();
			} else if(metodo.equals(ConstantsMap.contatto_chiuso)) {
				return cnt.getChiuso();
			} else if(metodo.equals(ConstantsMap.anagrafica_cognome)) {
				return cnt.getAnagrafica().getCognome();
			} else if(metodo.equals(ConstantsMap.anagrafica_nome)) {
				return cnt.getAnagrafica().getNome();
			} else if(metodo.equals(ConstantsMap.anagrafica_nome_completo)) {
				return cnt.getAnagrafica().getNome_completo();
			} else if(metodo.equals(ConstantsMap.anagrafica_email)) {
				return cnt.getAnagrafica().getEmail();
			} else if(metodo.equals(ConstantsMap.anagrafica_codice_fiscale)) {
				return cnt.getAnagrafica().getCodice_fiscale();
			} else if(metodo.equals(ConstantsMap.anagrafica_sorgente)) {
				return cnt.getAnagrafica().getSorgente();
			} else if(metodo.equals(ConstantsMap.anagrafica_nota)) {
				return cnt.getAnagrafica().getNota();
			} else if(metodo.equals(ConstantsMap.anagrafica_luogo_nascita)) {
				return cnt.getAnagrafica().getLuogo_nascita();
			} else if(metodo.equals(ConstantsMap.anagrafica_data_nascita)) {
				return ApplicationUtil.formatDate(ConstantsFormat.date.stampa(), cnt.getAnagrafica().getDate_nascita());
			} else if(metodo.equals(ConstantsMap.anagrafica_link)) {
				return cnt.getAnagrafica().getLink();
			} else if(metodo.equals(ConstantsMap.anagrafica_data_inserimento)) {
				return ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), cnt.getAnagrafica().getData_creazione());
			} else if(metodo.equals(ConstantsMap.anagrafica_privacy)) {
				return cnt.getAnagrafica().getPrivacy();
			} else if(metodo.equals(ConstantsMap.anagrafica_tipo)) {
				return cnt.getAnagrafica().getTipo();
			} else if(metodo.equals(ConstantsMap.anagrafica_sesso)) {
				return cnt.getAnagrafica().getSesso();
			} else if(metodo.equals(ConstantsMap.anagrafica_partita_iva)) {
				return cnt.getAnagrafica().getPartita_iva();
			} else if(metodo.equals(ConstantsMap.anagrafica_ragione_sociale)) {
				return cnt.getAnagrafica().getRagione_sociale();
			} else if(metodo.equals(ConstantsMap.anagrafica_telefono_fisso)) {
				return cnt.getAnagrafica().getTelefono_fisso();
			} else if(metodo.equals(ConstantsMap.anagrafica_telefono_altro)) {
				return cnt.getAnagrafica().getTelefono_altro();
			} else if(metodo.equals(ConstantsMap.anagrafica_telefono_mobile)) {
				return cnt.getAnagrafica().getTelefono_mobile();
			} else if(metodo.equals(ConstantsMap.anagrafica_telefono_fax)) {
				return cnt.getAnagrafica().getTelefono_fax();
			} else if(metodo.equals(ConstantsMap.anagrafica_settore)) {
				return cnt.getAnagrafica().getSettore();
			} else if(metodo.equals(ConstantsMap.anagrafica_denominazione)) {
				return cnt.getAnagrafica().getDenominazione();
			} else if(metodo.equals(ConstantsMap.anagrafica_id)) {
				return cnt.getAnagrafica().getIdentificativo();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_indirizzo_completo)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getIndirizzo_completo();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_strada_completo)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getStrada_completo();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_comune_completo)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getComune_completo();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_strada)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getStrada();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_civico)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getCivico();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_cap)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getCap();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_comune)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getComune();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_provincia)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getProvincia();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_regione)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getRegione();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_dettagli)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getDettagli();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_latitudine)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getLatitudine();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_longitudine)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getLongitudine();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_presso)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getPresso();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_indirizzo_completo)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getIndirizzo_completo();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_strada_completo)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getStrada_completo();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_comune_completo)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getComune_completo();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_strada)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getStrada();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_civico)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getCivico();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_cap)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getCap();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_comune)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getComune();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_provincia)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getProvincia();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_regione)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getRegione();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_dettagli)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getDettagli();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_latitudine)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getLatitudine();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_longitudine)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getLongitudine();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_presso)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getPresso();
			} else if(metodo.equals(ConstantsMap.consenso_tfissoS)) {
				return cnt.getAnagrafica().getConsenso_tfissoS();
			} else if(metodo.equals(ConstantsMap.consenso_tmobileS)) {
				return cnt.getAnagrafica().getConsenso_tmobileS();
			} else if(metodo.equals(ConstantsMap.consenso_tfaxS)) {
				return cnt.getAnagrafica().getConsenso_tfaxS();
			} else if(metodo.equals(ConstantsMap.consenso_taltroS)) {
				return cnt.getAnagrafica().getConsenso_taltroS();
			} else if(metodo.equals(ConstantsMap.consenso_emailS)) {
				return cnt.getAnagrafica().getConsenso_emailS();
			} else if(metodo.equals(ConstantsMap.consenso_rmailS)) {
				return cnt.getAnagrafica().getConsenso_rmailS();
			} 
		}
		return null;
	}
	public static String metodoStoriaContratto(StoriaContratto scrt, String metodo) {
		if(metodo != null) {
			Contratto crt = scrt.getContratto();
			Contatto cnt = crt.getContatto();
			if(metodo.equals(ConstantsMap.storia_contratto_data)) {
				return ApplicationUtil.formatDate(ConstantsFormat.dateSeconds.stampa(), scrt.getData());
			} else if(metodo.equals(ConstantsMap.storia_contratto_id)) {
				return scrt.getId().toString();
			} else if(metodo.equals(ConstantsMap.storia_contratto_operatore_denominazione)) {
				return scrt.getOperatore_denominazione();
			} else if(metodo.equals(ConstantsMap.storia_contratto_operatore_codice)) {
				return scrt.getOperatore_codice();
			} else if(metodo.equals(ConstantsMap.storia_contratto_agente_denominazione)) {
				return scrt.getAgente_denominazione();
			} else if(metodo.equals(ConstantsMap.storia_contratto_agente_codice)) {
				return scrt.getAgente_codice();
			} else if(metodo.equals(ConstantsMap.storia_contratto_categoria_denominazione)) {
				return scrt.getCategoria_denominazione();
			} else if(metodo.equals(ConstantsMap.storia_contratto_prodotto_denominazione)) {
				return scrt.getProdotto_denominazione();
			} else if(metodo.equals(ConstantsMap.storia_contratto_esito_contratto)) {
				return scrt.getEsitoEtichetta();
			} else if(metodo.equals(ConstantsMap.storia_contratto_codice_contratto)) {
				return scrt.getEsitoCodice();
			} else if(metodo.equals(ConstantsMap.storia_contratto_data_stipula)) {
				return ApplicationUtil.formatDate(ConstantsFormat.date.stampa(),scrt.getData_stipula());
			} else if(metodo.equals(ConstantsMap.storia_contratto_data_contabile)) {
				return ApplicationUtil.formatDate(ConstantsFormat.date.stampa(),scrt.getData_contabile());
			} else if(metodo.equals(ConstantsMap.storia_contratto_data_attivazione)) {
				return ApplicationUtil.formatDate(ConstantsFormat.date.stampa(),scrt.getData_attivazione());
			} else if(metodo.equals(ConstantsMap.storia_contratto_data_caricamento)) {
				return ApplicationUtil.formatDate(ConstantsFormat.date.stampa(),scrt.getData_caricamento());
			} else if(metodo.equals(ConstantsMap.storia_contratto_utente_denominazione)) {
				return scrt.getUtente_denominazione();
			}  else if(metodo.equals(ConstantsMap.storia_contratto_bloccato)) {
				return scrt.getBloccatoS();
			} else if(metodo.equals(ConstantsMap.storia_contratto_utente_codice)) {
				return scrt.getUtente_codice();
			} else if(metodo.equals(ConstantsMap.storia_contratto_data_esito)) {
				return ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), scrt.getData_esito());
			} else if(metodo.equals(ConstantsMap.storia_contratto_data_stato)) {
				return ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), scrt.getData_stato());
			} else if(metodo.equals(ConstantsMap.storia_contratto_nota)) {
				return scrt.getNota();
			} else if(metodo.equals(ConstantsMap.storia_contratto_tipo_seriale)) {
				return scrt.getTipo_seriale();
			} else if(metodo.equals(ConstantsMap.storia_contratto_seriale)) {
				return scrt.getSeriale();
			} else if(metodo.equals(ConstantsMap.storia_contratto_quantita)) {
				return ApplicationUtil.formatNumber(scrt.getQuantita());
			} else if(metodo.equals(ConstantsMap.storia_contratto_costo_scontato)) {
				return ApplicationUtil.formatNumber(scrt.getCosto_scontato());
			} else if(metodo.equals(ConstantsMap.storia_contratto_stato)) {
				return scrt.getStatoTesto();
			} else if(metodo.equals(ConstantsMap.contratto_data_creazione)) {
				return ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), crt.getData_creazione());
			} else if(metodo.equals(ConstantsMap.contratto_id)) {
				return crt.getId().toString();
			} else if(metodo.equals(ConstantsMap.contratto_operatore_denominazione)) {
				return crt.getOperatore_denominazione();
			} else if(metodo.equals(ConstantsMap.contratto_operatore_codice)) {
				return crt.getOperatore_codice();
			} else if(metodo.equals(ConstantsMap.contratto_agente_denominazione)) {
				return crt.getAgente_denominazione();
			} else if(metodo.equals(ConstantsMap.contratto_agente_codice)) {
				return crt.getAgente_codice();
			} else if(metodo.equals(ConstantsMap.contratto_categoria_denominazione)) {
				return crt.getCategoria_denominazione();
			} else if(metodo.equals(ConstantsMap.contratto_prodotto_denominazione)) {
				return crt.getProdotto_denominazione();
			} else if(metodo.equals(ConstantsMap.contratto_esito_contratto)) {
				return crt.getEsitoEtichetta();
			} else if(metodo.equals(ConstantsMap.contratto_codice_contratto)) {
				return crt.getEsitoCodice();
			} else if(metodo.equals(ConstantsMap.contratto_data_stipula)) {
				return ApplicationUtil.formatDate(ConstantsFormat.date.stampa(),crt.getData_stipula());
			} else if(metodo.equals(ConstantsMap.contratto_data_contabile)) {
				return ApplicationUtil.formatDate(ConstantsFormat.date.stampa(),crt.getData_contabile());
			} else if(metodo.equals(ConstantsMap.contratto_data_attivazione)) {
				return ApplicationUtil.formatDate(ConstantsFormat.date.stampa(),crt.getData_attivazione());
			} else if(metodo.equals(ConstantsMap.contratto_data_caricamento)) {
				return ApplicationUtil.formatDate(ConstantsFormat.date.stampa(),crt.getData_caricamento());
			} else if(metodo.equals(ConstantsMap.contratto_data_lavorazione)) {
				return ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(),crt.getData_lavorazione());
			} else if(metodo.equals(ConstantsMap.contratto_utente_denominazione)) {
				return crt.getUtente_denominazione();
			} else if(metodo.equals(ConstantsMap.contratto_bloccato)) {
				return crt.getBloccatoS();
			} else if(metodo.equals(ConstantsMap.contratto_utente_codice)) {
				return crt.getUtente_codice();
			} else if(metodo.equals(ConstantsMap.contratto_data_esito)) {
				return ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), crt.getData_esito());
			} else if(metodo.equals(ConstantsMap.contratto_data_stato)) {
				return ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), crt.getData_stato());
			} else if(metodo.equals(ConstantsMap.contratto_nota)) {
				return crt.getNota();
			} else if(metodo.equals(ConstantsMap.contratto_tipo_seriale)) {
				return crt.getTipo_seriale();
			} else if(metodo.equals(ConstantsMap.contratto_seriale)) {
				return crt.getSeriale();
			} else if(metodo.equals(ConstantsMap.contratto_quantita)) {
				return ApplicationUtil.formatNumber(crt.getQuantita());
			} else if(metodo.equals(ConstantsMap.contratto_costo_scontato)) {
				return ApplicationUtil.formatNumber(crt.getCosto_scontato());
			} else if(metodo.equals(ConstantsMap.contratto_stato)) {
				return crt.getStatoTesto();
			} else if(metodo.equals(ConstantsMap.contatto_data_archiviazione)) {
				return ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), cnt.getData_archiviazione());
			} else if(metodo.equals(ConstantsMap.contatto_data_lavorazione)) {
				return ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), cnt.getData_lavorazione());
			} else if(metodo.equals(ConstantsMap.contatto_operatore_denominazione)) {
				return cnt.getOperatore_denominazione();
			} else if(metodo.equals(ConstantsMap.contatto_operatore_codice)) {
				return cnt.getOperatore_codice();
			} else if(metodo.equals(ConstantsMap.contatto_esito_chiamata)) {
				return cnt.getEsito_chiamata();
			} else if(metodo.equals(ConstantsMap.contatto_esito_archiviazione)) {
				return cnt.getEsito_archiviazione();
			} else if(metodo.equals(ConstantsMap.contatto_esito_generale)) {
				return cnt.getEsito_generale();
			} else if(metodo.equals(ConstantsMap.contatto_codice_chiamata)) {
				return cnt.getCodice_chiamata();
			} else if(metodo.equals(ConstantsMap.contatto_codice_archiviazione)) {
				return cnt.getCodice_archiviazione();
			} else if(metodo.equals(ConstantsMap.contatto_codice_generale)) {
				return cnt.getCodice_generale();
			} else if(metodo.equals(ConstantsMap.contatto_proprietario_denominazione)) {
				return cnt.getProprietario_denominazione();
			} else if(metodo.equals(ConstantsMap.contatto_proprietario_codice)) {
				return cnt.getProprietario_codice();
			} else if(metodo.equals(ConstantsMap.contatto_data_presentazione)) {
				return ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), cnt.getData_presentazione());
			} else if(metodo.equals(ConstantsMap.contatto_nota)) {
				return cnt.getNota();
			} else if(metodo.equals(ConstantsMap.contatto_data_creazione)) {
				return ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), cnt.getData_creazione());
			} else if(metodo.equals(ConstantsMap.contatto_agente_denominazione)) {
				return cnt.getAgente_denominazione();
			} else if(metodo.equals(ConstantsMap.contatto_agente_codice)) {
				return cnt.getAgente_codice();
			} else if(metodo.equals(ConstantsMap.contatto_stato)) {
				return cnt.getTipoTesto();
			} else if(metodo.equals(ConstantsMap.contatto_id)) {
				return cnt.getId().toString();
			} else if(metodo.equals(ConstantsMap.contatto_campagna_denominazione)) {
				return cnt.getCampagna_denominazione();
			} else if(metodo.equals(ConstantsMap.contatto_lista_denominazione)) {
				return cnt.getLista_denominazione();
			} else if(metodo.equals(ConstantsMap.contatto_campagna_codice)) {
				return cnt.getCampagna_codice();
			} else if(metodo.equals(ConstantsMap.contatto_bloccato)) {
				return cnt.getBloccatoS();
			} else if(metodo.equals(ConstantsMap.contatto_lista_codice)) {
				return cnt.getLista_codice();
			} else if(metodo.equals(ConstantsMap.contatto_positivo)) {
				return cnt.getPositivo();
			} else if(metodo.equals(ConstantsMap.contatto_telefono_predefinito)) {
				return cnt.getTelefono_predefinito();
			} else if(metodo.equals(ConstantsMap.contatto_utile)) {
				return cnt.getUtile();
			} else if(metodo.equals(ConstantsMap.contatto_chiuso)) {
				return cnt.getChiuso();
			} else if(metodo.equals(ConstantsMap.anagrafica_cognome)) {
				return cnt.getAnagrafica().getCognome();
			} else if(metodo.equals(ConstantsMap.anagrafica_nome)) {
				return cnt.getAnagrafica().getNome();
			} else if(metodo.equals(ConstantsMap.anagrafica_nome_completo)) {
				return cnt.getAnagrafica().getNome_completo();
			} else if(metodo.equals(ConstantsMap.anagrafica_email)) {
				return cnt.getAnagrafica().getEmail();
			} else if(metodo.equals(ConstantsMap.anagrafica_codice_fiscale)) {
				return cnt.getAnagrafica().getCodice_fiscale();
			} else if(metodo.equals(ConstantsMap.anagrafica_sorgente)) {
				return cnt.getAnagrafica().getSorgente();
			} else if(metodo.equals(ConstantsMap.anagrafica_nota)) {
				return cnt.getAnagrafica().getNota();
			} else if(metodo.equals(ConstantsMap.anagrafica_luogo_nascita)) {
				return cnt.getAnagrafica().getLuogo_nascita();
			} else if(metodo.equals(ConstantsMap.anagrafica_data_nascita)) {
				return ApplicationUtil.formatDate(ConstantsFormat.date.stampa(), cnt.getAnagrafica().getDate_nascita());
			} else if(metodo.equals(ConstantsMap.anagrafica_link)) {
				return cnt.getAnagrafica().getLink();
			} else if(metodo.equals(ConstantsMap.anagrafica_data_inserimento)) {
				return ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), cnt.getAnagrafica().getData_creazione());
			} else if(metodo.equals(ConstantsMap.anagrafica_privacy)) {
				return cnt.getAnagrafica().getPrivacy();
			} else if(metodo.equals(ConstantsMap.anagrafica_tipo)) {
				return cnt.getAnagrafica().getTipo();
			} else if(metodo.equals(ConstantsMap.anagrafica_sesso)) {
				return cnt.getAnagrafica().getSesso();
			} else if(metodo.equals(ConstantsMap.anagrafica_partita_iva)) {
				return cnt.getAnagrafica().getPartita_iva();
			} else if(metodo.equals(ConstantsMap.anagrafica_ragione_sociale)) {
				return cnt.getAnagrafica().getRagione_sociale();
			} else if(metodo.equals(ConstantsMap.anagrafica_telefono_fisso)) {
				return cnt.getAnagrafica().getTelefono_fisso();
			} else if(metodo.equals(ConstantsMap.anagrafica_telefono_altro)) {
				return cnt.getAnagrafica().getTelefono_altro();
			} else if(metodo.equals(ConstantsMap.anagrafica_telefono_mobile)) {
				return cnt.getAnagrafica().getTelefono_mobile();
			} else if(metodo.equals(ConstantsMap.anagrafica_telefono_fax)) {
				return cnt.getAnagrafica().getTelefono_fax();
			} else if(metodo.equals(ConstantsMap.anagrafica_settore)) {
				return cnt.getAnagrafica().getSettore();
			} else if(metodo.equals(ConstantsMap.anagrafica_denominazione)) {
				return cnt.getAnagrafica().getDenominazione();
			} else if(metodo.equals(ConstantsMap.anagrafica_id)) {
				return cnt.getAnagrafica().getIdentificativo();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_indirizzo_completo)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getIndirizzo_completo();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_strada_completo)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getStrada_completo();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_comune_completo)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getComune_completo();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_strada)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getStrada();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_civico)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getCivico();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_cap)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getCap();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_comune)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getComune();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_provincia)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getProvincia();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_regione)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getRegione();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_dettagli)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getDettagli();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_latitudine)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getLatitudine();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_longitudine)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getLongitudine();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_presso)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getPresso();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_indirizzo_completo)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getIndirizzo_completo();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_strada_completo)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getStrada_completo();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_comune_completo)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getComune_completo();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_strada)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getStrada();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_civico)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getCivico();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_cap)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getCap();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_comune)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getComune();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_provincia)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getProvincia();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_regione)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getRegione();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_dettagli)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getDettagli();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_latitudine)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getLatitudine();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_longitudine)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getLongitudine();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_presso)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getPresso();
			} else if(metodo.equals(ConstantsMap.consenso_tfissoS)) {
				return cnt.getAnagrafica().getConsenso_tfissoS();
			} else if(metodo.equals(ConstantsMap.consenso_tmobileS)) {
				return cnt.getAnagrafica().getConsenso_tmobileS();
			} else if(metodo.equals(ConstantsMap.consenso_tfaxS)) {
				return cnt.getAnagrafica().getConsenso_tfaxS();
			} else if(metodo.equals(ConstantsMap.consenso_taltroS)) {
				return cnt.getAnagrafica().getConsenso_taltroS();
			} else if(metodo.equals(ConstantsMap.consenso_emailS)) {
				return cnt.getAnagrafica().getConsenso_emailS();
			} else if(metodo.equals(ConstantsMap.consenso_rmailS)) {
				return cnt.getAnagrafica().getConsenso_rmailS();
			} 
		}
		return null;
	}
	public static String metodoStoriaContatto(StoriaContatto scnt, String metodo) {
		if(metodo != null) {
			Contatto cnt = scnt.getContatto();
			if(metodo.equals(ConstantsMap.storia_contatto_data_archiviazione)) {
				return ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), scnt.getData_archiviazione());
			} else if(metodo.equals(ConstantsMap.storia_contatto_esito_chiamata)) {
				return scnt.getEsito_chiamata();
			} else if(metodo.equals(ConstantsMap.storia_contatto_esito_archiviazione)) {
				return scnt.getEsito_archiviazione();
			} else if(metodo.equals(ConstantsMap.storia_contatto_esito_generale)) {
				return scnt.getEsito_generale();
			} else if(metodo.equals(ConstantsMap.storia_contatto_codice_chiamata)) {
				return scnt.getCodice_chiamata();
			} else if(metodo.equals(ConstantsMap.storia_contatto_codice_archiviazione)) {
				return scnt.getCodice_archiviazione();
			} else if(metodo.equals(ConstantsMap.storia_contatto_codice_generale)) {
				return scnt.getCodice_generale();
			} else if(metodo.equals(ConstantsMap.storia_contatto_campagna_denominazione)) {
				return scnt.getCampagna_denominazione();
			} else if(metodo.equals(ConstantsMap.storia_contatto_lista_denominazione)) {
				return scnt.getLista_denominazione();
			} else if(metodo.equals(ConstantsMap.storia_contatto_campagna_codice)) {
				return scnt.getCampagna_codice();
			} else if(metodo.equals(ConstantsMap.storia_contatto_bloccato)) {
				return scnt.getBloccatoS();
			} else if(metodo.equals(ConstantsMap.storia_contatto_lista_codice)) {
				return scnt.getLista_codice();
			} else if(metodo.equals(ConstantsMap.storia_contatto_operatore_denominazione)) {
				return scnt.getOperatore_denominazione();
			} else if(metodo.equals(ConstantsMap.storia_contatto_operatore_codice)) {
				return scnt.getOperatore_codice();
			} else if(metodo.equals(ConstantsMap.storia_contatto_proprietario_denominazione)) {
				return scnt.getProprietario_denominazione();
			} else if(metodo.equals(ConstantsMap.storia_contatto_proprietario_codice)) {
				return scnt.getProprietario_codice();
			} else if(metodo.equals(ConstantsMap.storia_contatto_data_presentazione)) {
				return ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), scnt.getData_presentazione());
			} else if(metodo.equals(ConstantsMap.storia_contatto_nota)) {
				return scnt.getNota();
			} else if(metodo.equals(ConstantsMap.storia_contatto_data)) {
				return ApplicationUtil.formatDate(ConstantsFormat.dateSeconds.stampa(), scnt.getData());
			} else if(metodo.equals(ConstantsMap.storia_contatto_agente_denominazione)) {
				return scnt.getAgente_denominazione();
			} else if(metodo.equals(ConstantsMap.storia_contatto_agente_codice)) {
				return scnt.getAgente_codice();
			} else if(metodo.equals(ConstantsMap.storia_contatto_stato)) {
				return scnt.getTipoTesto();
			} else if(metodo.equals(ConstantsMap.storia_contatto_id)) {
				return scnt.getId().toString();
			} else if(metodo.equals(ConstantsMap.storia_contatto_positivo)) {
				return scnt.getPositivo();
			} else if(metodo.equals(ConstantsMap.storia_contatto_utile)) {
				return scnt.getUtile();
			} else if(metodo.equals(ConstantsMap.storia_contatto_chiuso)) {
				return scnt.getChiuso();
			} else if(metodo.equals(ConstantsMap.storia_contatto_secondi_tot)) {
				return ApplicationUtil.formatNumber(scnt.getSecondi_tot());
			} else if(metodo.equals(ConstantsMap.storia_contatto_secondi_totH)) {
				return scnt.getSecondi_totH();
			} else if(metodo.equals(ConstantsMap.storia_contatto_secondi_conv_eff)) {
				return ApplicationUtil.formatNumber(scnt.getSecondi_conv_eff());
			} else if(metodo.equals(ConstantsMap.storia_contatto_secondi_conv_effH)) {
				return scnt.getSecondi_conv_effH();
			} else if(metodo.equals(ConstantsMap.storia_contatto_secondi_conv_tot)) {
				return ApplicationUtil.formatNumber(scnt.getSecondi_conv_tot());
			} else if(metodo.equals(ConstantsMap.storia_contatto_secondi_conv_totH)) {
				return scnt.getSecondi_conv_totH();
			} else if(metodo.equals(ConstantsMap.storia_contatto_secondi_post)) {
				return ApplicationUtil.formatNumber(scnt.getSecondi_post());
			} else if(metodo.equals(ConstantsMap.storia_contatto_secondi_postH)) {
				return scnt.getSecondi_postH();
			} else if(metodo.equals(ConstantsMap.storia_contatto_secondi_pre)) {
				return ApplicationUtil.formatNumber(scnt.getSecondi_pre());
			} else if(metodo.equals(ConstantsMap.storia_contatto_secondi_preH)) {
				return scnt.getSecondi_preH();
			} else if(metodo.equals(ConstantsMap.storia_contatto_secondi_rec)) {
				return ApplicationUtil.formatNumber(scnt.getSecondi_rec());
			} else if(metodo.equals(ConstantsMap.storia_contatto_secondi_recH)) {
				return scnt.getSecondi_recH();
			} else if(metodo.equals(ConstantsMap.storia_contatto_secondi_attesa)) {
				return ApplicationUtil.formatNumber(scnt.getSecondi_attesa());
			} else if(metodo.equals(ConstantsMap.storia_contatto_secondi_attesaH)) {
				return scnt.getSecondi_attesaH();
			} else if(metodo.equals(ConstantsMap.storia_contatto_date_apertura)) {
				return ApplicationUtil.formatDate(ConstantsFormat.dateSeconds.stampa(), scnt.getDate_apertura());
			} else if(metodo.equals(ConstantsMap.storia_contatto_date_chiamata)) {
				return ApplicationUtil.formatDate(ConstantsFormat.dateSeconds.stampa(), scnt.getDate_chiamata());
			} else if(metodo.equals(ConstantsMap.storia_contatto_date_risposta)) {
				return ApplicationUtil.formatDate(ConstantsFormat.dateSeconds.stampa(), scnt.getDate_risposta());
			} else if(metodo.equals(ConstantsMap.storia_contatto_date_rec_inizio)) {
				return ApplicationUtil.formatDate(ConstantsFormat.dateSeconds.stampa(), scnt.getDate_rec_inizio());
			} else if(metodo.equals(ConstantsMap.storia_contatto_date_rec_fine)) {
				return ApplicationUtil.formatDate(ConstantsFormat.dateSeconds.stampa(), scnt.getDate_rec_fine());
			} else if(metodo.equals(ConstantsMap.storia_contatto_date_fine)) {
				return ApplicationUtil.formatDate(ConstantsFormat.dateSeconds.stampa(), scnt.getDate_fine());
			} else if(metodo.equals(ConstantsMap.storia_contatto_date_esito)) {
				return ApplicationUtil.formatDate(ConstantsFormat.dateSeconds.stampa(), scnt.getDate_esito());
			} else if(metodo.equals(ConstantsMap.storia_contatto_date_attesa_inizio)) {
				return ApplicationUtil.formatDate(ConstantsFormat.dateSeconds.stampa(), scnt.getDate_attesa_inizio());
			} else if(metodo.equals(ConstantsMap.storia_contatto_date_attesa_fine)) {
				return ApplicationUtil.formatDate(ConstantsFormat.dateSeconds.stampa(), scnt.getDate_attesa_fine());
			} else if(metodo.equals(ConstantsMap.contatto_data_archiviazione)) {
				return ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), cnt.getData_archiviazione());
			} else if(metodo.equals(ConstantsMap.contatto_esito_chiamata)) {
				return cnt.getEsito_chiamata();
			} else if(metodo.equals(ConstantsMap.contatto_esito_archiviazione)) {
				return cnt.getEsito_archiviazione();
			} else if(metodo.equals(ConstantsMap.contatto_esito_generale)) {
				return cnt.getEsito_generale();
			} else if(metodo.equals(ConstantsMap.contatto_codice_chiamata)) {
				return cnt.getCodice_chiamata();
			} else if(metodo.equals(ConstantsMap.contatto_codice_archiviazione)) {
				return cnt.getCodice_archiviazione();
			} else if(metodo.equals(ConstantsMap.contatto_codice_generale)) {
				return cnt.getCodice_generale();
			} else if(metodo.equals(ConstantsMap.contatto_data_lavorazione)) {
				return ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), cnt.getData_lavorazione());
			} else if(metodo.equals(ConstantsMap.contatto_operatore_denominazione)) {
				return cnt.getOperatore_denominazione();
			} else if(metodo.equals(ConstantsMap.contatto_operatore_codice)) {
				return cnt.getOperatore_codice();
			} else if(metodo.equals(ConstantsMap.contatto_proprietario_denominazione)) {
				return cnt.getProprietario_denominazione();
			} else if(metodo.equals(ConstantsMap.contatto_proprietario_codice)) {
				return cnt.getProprietario_codice();
			} else if(metodo.equals(ConstantsMap.contatto_data_presentazione)) {
				return ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), cnt.getData_presentazione());
			} else if(metodo.equals(ConstantsMap.contatto_nota)) {
				return cnt.getNota();
			} else if(metodo.equals(ConstantsMap.contatto_data_creazione)) {
				return ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), cnt.getData_creazione());
			} else if(metodo.equals(ConstantsMap.contatto_agente_denominazione)) {
				return cnt.getAgente_denominazione();
			} else if(metodo.equals(ConstantsMap.contatto_agente_codice)) {
				return cnt.getAgente_codice();
			} else if(metodo.equals(ConstantsMap.contatto_stato)) {
				return cnt.getTipoTesto();
			} else if(metodo.equals(ConstantsMap.contatto_id)) {
				return cnt.getId().toString();
			} else if(metodo.equals(ConstantsMap.contatto_campagna_denominazione)) {
				return cnt.getCampagna_denominazione();
			} else if(metodo.equals(ConstantsMap.contatto_lista_denominazione)) {
				return cnt.getLista_denominazione();
			} else if(metodo.equals(ConstantsMap.contatto_campagna_codice)) {
				return cnt.getCampagna_codice();
			} else if(metodo.equals(ConstantsMap.contatto_bloccato)) {
				return cnt.getBloccatoS();
			} else if(metodo.equals(ConstantsMap.contatto_lista_codice)) {
				return cnt.getLista_codice();
			} else if(metodo.equals(ConstantsMap.contatto_positivo)) {
				return cnt.getPositivo();
			} else if(metodo.equals(ConstantsMap.contatto_telefono_predefinito)) {
				return cnt.getTelefono_predefinito();
			} else if(metodo.equals(ConstantsMap.contatto_utile)) {
				return cnt.getUtile();
			} else if(metodo.equals(ConstantsMap.contatto_chiuso)) {
				return cnt.getChiuso();
			} else if(metodo.equals(ConstantsMap.anagrafica_cognome)) {
				return cnt.getAnagrafica().getCognome();
			} else if(metodo.equals(ConstantsMap.anagrafica_nome)) {
				return cnt.getAnagrafica().getNome();
			} else if(metodo.equals(ConstantsMap.anagrafica_nome_completo)) {
				return cnt.getAnagrafica().getNome_completo();
			} else if(metodo.equals(ConstantsMap.anagrafica_email)) {
				return cnt.getAnagrafica().getEmail();
			} else if(metodo.equals(ConstantsMap.anagrafica_codice_fiscale)) {
				return cnt.getAnagrafica().getCodice_fiscale();
			} else if(metodo.equals(ConstantsMap.anagrafica_sorgente)) {
				return cnt.getAnagrafica().getSorgente();
			} else if(metodo.equals(ConstantsMap.anagrafica_nota)) {
				return cnt.getAnagrafica().getNota();
			} else if(metodo.equals(ConstantsMap.anagrafica_luogo_nascita)) {
				return cnt.getAnagrafica().getLuogo_nascita();
			} else if(metodo.equals(ConstantsMap.anagrafica_data_nascita)) {
				return ApplicationUtil.formatDate(ConstantsFormat.date.stampa(), cnt.getAnagrafica().getDate_nascita());
			} else if(metodo.equals(ConstantsMap.anagrafica_link)) {
				return cnt.getAnagrafica().getLink();
			} else if(metodo.equals(ConstantsMap.anagrafica_data_inserimento)) {
				return ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), cnt.getAnagrafica().getData_creazione());
			} else if(metodo.equals(ConstantsMap.anagrafica_privacy)) {
				return cnt.getAnagrafica().getPrivacy();
			} else if(metodo.equals(ConstantsMap.anagrafica_tipo)) {
				return cnt.getAnagrafica().getTipo();
			} else if(metodo.equals(ConstantsMap.anagrafica_sesso)) {
				return cnt.getAnagrafica().getSesso();
			} else if(metodo.equals(ConstantsMap.anagrafica_partita_iva)) {
				return cnt.getAnagrafica().getPartita_iva();
			} else if(metodo.equals(ConstantsMap.anagrafica_ragione_sociale)) {
				return cnt.getAnagrafica().getRagione_sociale();
			} else if(metodo.equals(ConstantsMap.anagrafica_telefono_fisso)) {
				return cnt.getAnagrafica().getTelefono_fisso();
			} else if(metodo.equals(ConstantsMap.anagrafica_telefono_altro)) {
				return cnt.getAnagrafica().getTelefono_altro();
			} else if(metodo.equals(ConstantsMap.anagrafica_telefono_mobile)) {
				return cnt.getAnagrafica().getTelefono_mobile();
			} else if(metodo.equals(ConstantsMap.anagrafica_telefono_fax)) {
				return cnt.getAnagrafica().getTelefono_fax();
			} else if(metodo.equals(ConstantsMap.anagrafica_settore)) {
				return cnt.getAnagrafica().getSettore();
			} else if(metodo.equals(ConstantsMap.anagrafica_denominazione)) {
				return cnt.getAnagrafica().getDenominazione();
			} else if(metodo.equals(ConstantsMap.anagrafica_id)) {
				return cnt.getAnagrafica().getIdentificativo();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_indirizzo_completo)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getIndirizzo_completo();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_strada_completo)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getStrada_completo();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_comune_completo)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getComune_completo();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_strada)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getStrada();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_civico)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getCivico();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_cap)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getCap();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_comune)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getComune();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_provincia)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getProvincia();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_regione)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getRegione();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_dettagli)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getDettagli();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_latitudine)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getLatitudine();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_longitudine)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getLongitudine();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_presso)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getPresso();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_indirizzo_completo)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getIndirizzo_completo();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_strada_completo)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getStrada_completo();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_comune_completo)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getComune_completo();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_strada)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getStrada();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_civico)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getCivico();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_cap)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getCap();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_comune)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getComune();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_provincia)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getProvincia();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_regione)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getRegione();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_dettagli)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getDettagli();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_latitudine)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getLatitudine();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_longitudine)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getLongitudine();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_presso)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getPresso();
			} else if(metodo.equals(ConstantsMap.consenso_tfissoS)) {
				return cnt.getAnagrafica().getConsenso_tfissoS();
			} else if(metodo.equals(ConstantsMap.consenso_tmobileS)) {
				return cnt.getAnagrafica().getConsenso_tmobileS();
			} else if(metodo.equals(ConstantsMap.consenso_tfaxS)) {
				return cnt.getAnagrafica().getConsenso_tfaxS();
			} else if(metodo.equals(ConstantsMap.consenso_taltroS)) {
				return cnt.getAnagrafica().getConsenso_taltroS();
			} else if(metodo.equals(ConstantsMap.consenso_emailS)) {
				return cnt.getAnagrafica().getConsenso_emailS();
			} else if(metodo.equals(ConstantsMap.consenso_rmailS)) {
				return cnt.getAnagrafica().getConsenso_rmailS();
			} 
		}
		return null;
	}
	public static String metodoStoriaAppuntamento(StoriaAppuntamento sapp, String metodo) {
		if(metodo != null) {
			Appuntamento app = sapp.getAppuntamento();
			Contatto cnt = app.getContatto();
			if(metodo.equals(ConstantsMap.storia_appuntamento_id)) {
				return sapp.getId().toString();
			} else if(metodo.equals(ConstantsMap.storia_appuntamento_operatore_denominazione)) {
				return sapp.getOperatore_denominazione();
			} else if(metodo.equals(ConstantsMap.storia_appuntamento_bloccato)) {
				return sapp.getBloccatoS();
			} else if(metodo.equals(ConstantsMap.storia_appuntamento_operatore_codice)) {
				return sapp.getOperatore_codice();
			} else if(metodo.equals(ConstantsMap.storia_appuntamento_agente_denominazione)) {
				return sapp.getAgente_denominazione();
			} else if(metodo.equals(ConstantsMap.storia_appuntamento_agente_codice)) {
				return sapp.getAgente_codice();
			} else if(metodo.equals(ConstantsMap.storia_appuntamento_nota)) {
				return sapp.getNota();
			} else if(metodo.equals(ConstantsMap.storia_appuntamento_data)) {
				return ApplicationUtil.formatDate(ConstantsFormat.dateSeconds.stampa(), sapp.getData());
			} else if(metodo.equals(ConstantsMap.storia_appuntamento_data_inizio)) {
				return ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), sapp.getData_inizio());
			} else if(metodo.equals(ConstantsMap.storia_appuntamento_data_fine)) {
				return ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), sapp.getData_fine());
			} else if(metodo.equals(ConstantsMap.storia_appuntamento_data_conferma)) {
				return ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), sapp.getData_conferma());
			} else if(metodo.equals(ConstantsMap.storia_appuntamento_localizzazione)) {
				return sapp.getLocalizzazioneString();
			} else if(metodo.equals(ConstantsMap.storia_appuntamento_utente_denominazione)) {
				return sapp.getUtente_denominazione();
			} else if(metodo.equals(ConstantsMap.storia_appuntamento_utente_codice)) {
				return sapp.getUtente_codice();
			} else if(metodo.equals(ConstantsMap.storia_appuntamento_data_esito)) {
				return ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), sapp.getData_esito());
			} else if(metodo.equals(ConstantsMap.storia_appuntamento_data_stato)) {
				return ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), sapp.getData_stato());
			} else if(metodo.equals(ConstantsMap.storia_appuntamento_esito_appuntamento)) {
				return sapp.getEsitoEtichetta();
			} else if(metodo.equals(ConstantsMap.storia_appuntamento_codice_appuntamento)) {
				return sapp.getEsitoCodice();
			} else if(metodo.equals(ConstantsMap.storia_appuntamento_stato)) {
				return sapp.getStatoTesto();
			} else if(metodo.equals(ConstantsMap.appuntamento_id)) {
				return app.getId().toString();
			} else if(metodo.equals(ConstantsMap.appuntamento_operatore_denominazione)) {
				return app.getOperatore_denominazione();
			} else if(metodo.equals(ConstantsMap.appuntamento_bloccato)) {
				return app.getBloccatoS();
			} else if(metodo.equals(ConstantsMap.appuntamento_operatore_codice)) {
				return app.getOperatore_codice();
			} else if(metodo.equals(ConstantsMap.appuntamento_agente_denominazione)) {
				return app.getAgente_denominazione();
			} else if(metodo.equals(ConstantsMap.appuntamento_agente_codice)) {
				return app.getAgente_codice();
			} else if(metodo.equals(ConstantsMap.appuntamento_nota)) {
				return app.getNota();
			} else if(metodo.equals(ConstantsMap.appuntamento_data_creazione)) {
				return ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), app.getData_creazione());
			} else if(metodo.equals(ConstantsMap.appuntamento_data_appuntamento)) {
				return ApplicationUtil.formatDate(ConstantsFormat.date.stampa(), app.getData_inizio());
			} else if(metodo.equals(ConstantsMap.appuntamento_data_ora)) {
				return ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), app.getData_inizio());
			} else if(metodo.equals(ConstantsMap.appuntamento_ora_inizio)) {
				return ApplicationUtil.formatDate(ConstantsFormat.time.stampa(), app.getData_inizio());
			} else if(metodo.equals(ConstantsMap.appuntamento_ora_fine)) {
				return ApplicationUtil.formatDate(ConstantsFormat.time.stampa(), app.getData_fine());
			} else if(metodo.equals(ConstantsMap.appuntamento_data_conferma)) {
				return ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), app.getData_conferma());
			} else if(metodo.equals(ConstantsMap.appuntamento_data_lavorazione)) {
				return ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), app.getData_lavorazione());
			} else if(metodo.equals(ConstantsMap.appuntamento_localizzazione)) {
				return app.getLocalizzazioneString();
			} else if(metodo.equals(ConstantsMap.appuntamento_utente_denominazione)) {
				return app.getUtente_denominazione();
			} else if(metodo.equals(ConstantsMap.appuntamento_utente_codice)) {
				return app.getUtente_codice();
			} else if(metodo.equals(ConstantsMap.appuntamento_data_esito)) {
				return ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), app.getData_esito());
			} else if(metodo.equals(ConstantsMap.appuntamento_data_stato)) {
				return ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), app.getData_stato());
			} else if(metodo.equals(ConstantsMap.appuntamento_esito_appuntamento)) {
				return app.getEsitoEtichetta();
			} else if(metodo.equals(ConstantsMap.appuntamento_codice_appuntamento)) {
				return app.getEsitoCodice();
			} else if(metodo.equals(ConstantsMap.appuntamento_stato)) {
				return app.getStatoTesto();
			} else if(metodo.equals(ConstantsMap.contatto_data_lavorazione)) {
				return ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), cnt.getData_lavorazione());
			} else if(metodo.equals(ConstantsMap.contatto_operatore_denominazione)) {
				return cnt.getOperatore_denominazione();
			} else if(metodo.equals(ConstantsMap.contatto_operatore_codice)) {
				return cnt.getOperatore_codice();
			} else if(metodo.equals(ConstantsMap.contatto_data_archiviazione)) {
				return ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), cnt.getData_archiviazione());
			} else if(metodo.equals(ConstantsMap.contatto_esito_chiamata)) {
				return cnt.getEsito_chiamata();
			} else if(metodo.equals(ConstantsMap.contatto_esito_archiviazione)) {
				return cnt.getEsito_archiviazione();
			} else if(metodo.equals(ConstantsMap.contatto_esito_generale)) {
				return cnt.getEsito_generale();
			} else if(metodo.equals(ConstantsMap.contatto_codice_chiamata)) {
				return cnt.getCodice_chiamata();
			} else if(metodo.equals(ConstantsMap.contatto_codice_archiviazione)) {
				return cnt.getCodice_archiviazione();
			} else if(metodo.equals(ConstantsMap.contatto_codice_generale)) {
				return cnt.getCodice_generale();
			} else if(metodo.equals(ConstantsMap.contatto_proprietario_denominazione)) {
				return cnt.getProprietario_denominazione();
			} else if(metodo.equals(ConstantsMap.contatto_proprietario_codice)) {
				return cnt.getProprietario_codice();
			} else if(metodo.equals(ConstantsMap.contatto_data_presentazione)) {
				return ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), cnt.getData_presentazione());
			} else if(metodo.equals(ConstantsMap.contatto_nota)) {
				return cnt.getNota();
			} else if(metodo.equals(ConstantsMap.contatto_data_creazione)) {
				return ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), cnt.getData_creazione());
			} else if(metodo.equals(ConstantsMap.contatto_agente_denominazione)) {
				return cnt.getAgente_denominazione();
			} else if(metodo.equals(ConstantsMap.contatto_agente_codice)) {
				return cnt.getAgente_codice();
			} else if(metodo.equals(ConstantsMap.contatto_stato)) {
				return cnt.getTipoTesto();
			} else if(metodo.equals(ConstantsMap.contatto_id)) {
				return cnt.getId().toString();
			} else if(metodo.equals(ConstantsMap.contatto_campagna_denominazione)) {
				return cnt.getCampagna_denominazione();
			} else if(metodo.equals(ConstantsMap.contatto_lista_denominazione)) {
				return cnt.getLista_denominazione();
			} else if(metodo.equals(ConstantsMap.contatto_campagna_codice)) {
				return cnt.getCampagna_codice();
			} else if(metodo.equals(ConstantsMap.contatto_bloccato)) {
				return cnt.getBloccatoS();
			} else if(metodo.equals(ConstantsMap.contatto_lista_codice)) {
				return cnt.getLista_codice();
			} else if(metodo.equals(ConstantsMap.contatto_positivo)) {
				return cnt.getPositivo();
			} else if(metodo.equals(ConstantsMap.contatto_telefono_predefinito)) {
				return cnt.getTelefono_predefinito();
			} else if(metodo.equals(ConstantsMap.contatto_utile)) {
				return cnt.getUtile();
			} else if(metodo.equals(ConstantsMap.contatto_chiuso)) {
				return cnt.getChiuso();
			} else if(metodo.equals(ConstantsMap.anagrafica_cognome)) {
				return cnt.getAnagrafica().getCognome();
			} else if(metodo.equals(ConstantsMap.anagrafica_nome)) {
				return cnt.getAnagrafica().getNome();
			} else if(metodo.equals(ConstantsMap.anagrafica_nome_completo)) {
				return cnt.getAnagrafica().getNome_completo();
			} else if(metodo.equals(ConstantsMap.anagrafica_email)) {
				return cnt.getAnagrafica().getEmail();
			} else if(metodo.equals(ConstantsMap.anagrafica_codice_fiscale)) {
				return cnt.getAnagrafica().getCodice_fiscale();
			} else if(metodo.equals(ConstantsMap.anagrafica_sorgente)) {
				return cnt.getAnagrafica().getSorgente();
			} else if(metodo.equals(ConstantsMap.anagrafica_nota)) {
				return cnt.getAnagrafica().getNota();
			} else if(metodo.equals(ConstantsMap.anagrafica_luogo_nascita)) {
				return cnt.getAnagrafica().getLuogo_nascita();
			} else if(metodo.equals(ConstantsMap.anagrafica_data_nascita)) {
				return ApplicationUtil.formatDate(ConstantsFormat.date.stampa(), cnt.getAnagrafica().getDate_nascita());
			} else if(metodo.equals(ConstantsMap.anagrafica_link)) {
				return cnt.getAnagrafica().getLink();
			} else if(metodo.equals(ConstantsMap.anagrafica_data_inserimento)) {
				return ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), cnt.getAnagrafica().getData_creazione());
			} else if(metodo.equals(ConstantsMap.anagrafica_privacy)) {
				return cnt.getAnagrafica().getPrivacy();
			} else if(metodo.equals(ConstantsMap.anagrafica_tipo)) {
				return cnt.getAnagrafica().getTipo();
			} else if(metodo.equals(ConstantsMap.anagrafica_sesso)) {
				return cnt.getAnagrafica().getSesso();
			} else if(metodo.equals(ConstantsMap.anagrafica_partita_iva)) {
				return cnt.getAnagrafica().getPartita_iva();
			} else if(metodo.equals(ConstantsMap.anagrafica_ragione_sociale)) {
				return cnt.getAnagrafica().getRagione_sociale();
			} else if(metodo.equals(ConstantsMap.anagrafica_telefono_fisso)) {
				return cnt.getAnagrafica().getTelefono_fisso();
			} else if(metodo.equals(ConstantsMap.anagrafica_telefono_altro)) {
				return cnt.getAnagrafica().getTelefono_altro();
			} else if(metodo.equals(ConstantsMap.anagrafica_telefono_mobile)) {
				return cnt.getAnagrafica().getTelefono_mobile();
			} else if(metodo.equals(ConstantsMap.anagrafica_telefono_fax)) {
				return cnt.getAnagrafica().getTelefono_fax();
			} else if(metodo.equals(ConstantsMap.anagrafica_settore)) {
				return cnt.getAnagrafica().getSettore();
			} else if(metodo.equals(ConstantsMap.anagrafica_denominazione)) {
				return cnt.getAnagrafica().getDenominazione();
			} else if(metodo.equals(ConstantsMap.anagrafica_id)) {
				return cnt.getAnagrafica().getIdentificativo();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_indirizzo_completo)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getIndirizzo_completo();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_strada_completo)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getStrada_completo();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_comune_completo)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getComune_completo();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_strada)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getStrada();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_civico)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getCivico();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_cap)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getCap();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_comune)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getComune();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_provincia)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getProvincia();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_regione)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getRegione();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_dettagli)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getDettagli();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_latitudine)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getLatitudine();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_longitudine)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getLongitudine();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_presso)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getPresso();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_indirizzo_completo)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getIndirizzo_completo();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_strada_completo)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getStrada_completo();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_comune_completo)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getComune_completo();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_strada)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getStrada();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_civico)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getCivico();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_cap)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getCap();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_comune)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getComune();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_provincia)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getProvincia();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_regione)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getRegione();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_dettagli)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getDettagli();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_latitudine)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getLatitudine();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_longitudine)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getLongitudine();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_presso)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getPresso();
			} else if(metodo.equals(ConstantsMap.consenso_tfissoS)) {
				return cnt.getAnagrafica().getConsenso_tfissoS();
			} else if(metodo.equals(ConstantsMap.consenso_tmobileS)) {
				return cnt.getAnagrafica().getConsenso_tmobileS();
			} else if(metodo.equals(ConstantsMap.consenso_tfaxS)) {
				return cnt.getAnagrafica().getConsenso_tfaxS();
			} else if(metodo.equals(ConstantsMap.consenso_taltroS)) {
				return cnt.getAnagrafica().getConsenso_taltroS();
			} else if(metodo.equals(ConstantsMap.consenso_emailS)) {
				return cnt.getAnagrafica().getConsenso_emailS();
			} else if(metodo.equals(ConstantsMap.consenso_rmailS)) {
				return cnt.getAnagrafica().getConsenso_rmailS();
			} 
		}
		return null;
	}
	@SuppressWarnings("rawtypes")
	public static Comparable comparaAnagrafica(Anagrafica prd, String metodo) {
		if(metodo != null) {
			if(metodo.equals(ConstantsMap.anagrafica_cognome)) {
				return prd.getCognome();
			} else if(metodo.equals(ConstantsMap.anagrafica_nome)) {
				return prd.getNome();
			} else if(metodo.equals(ConstantsMap.anagrafica_nome_completo)) {
				return prd.getNome_completo();
			} else if(metodo.equals(ConstantsMap.anagrafica_email)) {
				return prd.getEmail();
			} else if(metodo.equals(ConstantsMap.anagrafica_codice_fiscale)) {
				return prd.getCodice_fiscale();
			} else if(metodo.equals(ConstantsMap.anagrafica_sorgente)) {
				return prd.getSorgente();
			} else if(metodo.equals(ConstantsMap.anagrafica_nota)) {
				return prd.getNota();
			} else if(metodo.equals(ConstantsMap.anagrafica_luogo_nascita)) {
				return prd.getLuogo_nascita();
			} else if(metodo.equals(ConstantsMap.anagrafica_data_nascita)) {
				return prd.getDate_nascita();
			} else if(metodo.equals(ConstantsMap.anagrafica_link)) {
				return prd.getLink();
			} else if(metodo.equals(ConstantsMap.anagrafica_privacy)) {
				return prd.getPrivacy();
			} else if(metodo.equals(ConstantsMap.anagrafica_data_inserimento)) {
				return prd.getData_creazione();
			} else if(metodo.equals(ConstantsMap.anagrafica_tipo)) {
				return prd.getTipo();
			} else if(metodo.equals(ConstantsMap.anagrafica_sesso)) {
				return prd.getSesso();
			} else if(metodo.equals(ConstantsMap.anagrafica_partita_iva)) {
				return prd.getPartita_iva();
			} else if(metodo.equals(ConstantsMap.anagrafica_ragione_sociale)) {
				return prd.getRagione_sociale();
			} else if(metodo.equals(ConstantsMap.anagrafica_telefono_fisso)) {
				return prd.getTelefono_fisso();
			} else if(metodo.equals(ConstantsMap.anagrafica_telefono_altro)) {
				return prd.getTelefono_altro();
			} else if(metodo.equals(ConstantsMap.anagrafica_telefono_mobile)) {
				return prd.getTelefono_mobile();
			} else if(metodo.equals(ConstantsMap.anagrafica_telefono_fax)) {
				return prd.getTelefono_fax();
			} else if(metodo.equals(ConstantsMap.anagrafica_settore)) {
				return prd.getSettore();
			} else if(metodo.equals(ConstantsMap.anagrafica_denominazione)) {
				return prd.getDenominazione();
			} else if(metodo.equals(ConstantsMap.anagrafica_id)) {
				return prd.getIdentificativo();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_indirizzo_completo)) {
				return prd.getIndirizzo_legale().getIndirizzo_completo();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_strada_completo)) {
				return prd.getIndirizzo_legale().getStrada_completo();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_comune_completo)) {
				return prd.getIndirizzo_legale().getComune_completo();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_strada)) {
				return prd.getIndirizzo_legale().getStrada();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_civico)) {
				return prd.getIndirizzo_legale().getCivico();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_cap)) {
				return prd.getIndirizzo_legale().getCap();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_comune)) {
				return prd.getIndirizzo_legale().getComune();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_provincia)) {
				return prd.getIndirizzo_legale().getProvincia();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_regione)) {
				return prd.getIndirizzo_legale().getRegione();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_dettagli)) {
				return prd.getIndirizzo_legale().getDettagli();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_latitudine)) {
				return prd.getIndirizzo_legale().getLatitudine();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_longitudine)) {
				return prd.getIndirizzo_legale().getLongitudine();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_presso)) {
				return prd.getIndirizzo_legale().getPresso();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_indirizzo_completo)) {
				return prd.getIndirizzo_operativo().getIndirizzo_completo();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_strada_completo)) {
				return prd.getIndirizzo_operativo().getStrada_completo();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_comune_completo)) {
				return prd.getIndirizzo_operativo().getComune_completo();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_strada)) {
				return prd.getIndirizzo_operativo().getStrada();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_civico)) {
				return prd.getIndirizzo_operativo().getCivico();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_cap)) {
				return prd.getIndirizzo_operativo().getCap();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_comune)) {
				return prd.getIndirizzo_operativo().getComune();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_provincia)) {
				return prd.getIndirizzo_operativo().getProvincia();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_regione)) {
				return prd.getIndirizzo_operativo().getRegione();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_dettagli)) {
				return prd.getIndirizzo_operativo().getDettagli();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_latitudine)) {
				return prd.getIndirizzo_operativo().getLatitudine();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_longitudine)) {
				return prd.getIndirizzo_operativo().getLongitudine();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_presso)) {
				return prd.getIndirizzo_operativo().getPresso();
			} else if(metodo.equals(ConstantsMap.consenso_tfissoS)) {
				return prd.getConsenso_tfisso();
			} else if(metodo.equals(ConstantsMap.consenso_tmobileS)) {
				return prd.getConsenso_tmobile();
			} else if(metodo.equals(ConstantsMap.consenso_tfaxS)) {
				return prd.getConsenso_tfax();
			} else if(metodo.equals(ConstantsMap.consenso_taltroS)) {
				return prd.getConsenso_taltro();
			} else if(metodo.equals(ConstantsMap.consenso_emailS)) {
				return prd.getConsenso_email();
			} else if(metodo.equals(ConstantsMap.consenso_rmailS)) {
				return prd.getConsenso_rmail();
			} 
		}
		return null;
	}
	@SuppressWarnings("rawtypes")
	public static Comparable comparaContatto(Contatto cnt, String metodo) {
		if(metodo != null) {
			if(metodo.equals(ConstantsMap.contatto_data_archiviazione)) {
				return cnt.getData_archiviazione();
			} else if(metodo.equals(ConstantsMap.contatto_esito_chiamata)) {
				return cnt.getEsito_chiamata();
			} else if(metodo.equals(ConstantsMap.contatto_esito_archiviazione)) {
				return cnt.getEsito_archiviazione();
			} else if(metodo.equals(ConstantsMap.contatto_esito_generale)) {
				return cnt.getEsito_generale();
			} else if(metodo.equals(ConstantsMap.contatto_codice_chiamata)) {
				return cnt.getCodice_chiamata();
			} else if(metodo.equals(ConstantsMap.contatto_codice_archiviazione)) {
				return cnt.getCodice_archiviazione();
			} else if(metodo.equals(ConstantsMap.contatto_codice_generale)) {
				return cnt.getCodice_generale();
			} else if(metodo.equals(ConstantsMap.contatto_data_lavorazione)) {
				return cnt.getData_lavorazione();
			} else if(metodo.equals(ConstantsMap.contatto_operatore_denominazione)) {
				return cnt.getOperatore_denominazione();
			} else if(metodo.equals(ConstantsMap.contatto_operatore_codice)) {
				return cnt.getOperatore_codice();
			} else if(metodo.equals(ConstantsMap.contatto_proprietario_denominazione)) {
				return cnt.getProprietario_denominazione();
			} else if(metodo.equals(ConstantsMap.contatto_proprietario_codice)) {
				return cnt.getProprietario_codice();
			} else if(metodo.equals(ConstantsMap.contatto_data_presentazione)) {
				return cnt.getData_presentazione();
			} else if(metodo.equals(ConstantsMap.contatto_nota)) {
				return cnt.getNota();
			} else if(metodo.equals(ConstantsMap.contatto_data_creazione)) {
				return cnt.getData_creazione();
			} else if(metodo.equals(ConstantsMap.contatto_agente_denominazione)) {
				return cnt.getAgente_denominazione();
			} else if(metodo.equals(ConstantsMap.contatto_agente_codice)) {
				return cnt.getAgente_codice();
			} else if(metodo.equals(ConstantsMap.contatto_stato)) {
				return cnt.getTipoTesto();
			} else if(metodo.equals(ConstantsMap.contatto_id)) {
				return cnt.getId().toString();
			} else if(metodo.equals(ConstantsMap.contatto_campagna_denominazione)) {
				return cnt.getCampagna_denominazione();
			} else if(metodo.equals(ConstantsMap.contatto_lista_denominazione)) {
				return cnt.getLista_denominazione();
			} else if(metodo.equals(ConstantsMap.contatto_campagna_codice)) {
				return cnt.getCampagna_codice();
			} else if(metodo.equals(ConstantsMap.contatto_bloccato)) {
				return cnt.getBloccatoS();
			} else if(metodo.equals(ConstantsMap.contatto_lista_codice)) {
				return cnt.getLista_codice();
			} else if(metodo.equals(ConstantsMap.contatto_positivo)) {
				return cnt.getPositivo();
			} else if(metodo.equals(ConstantsMap.contatto_telefono_predefinito)) {
				return cnt.getTelefono_predefinito();
			} else if(metodo.equals(ConstantsMap.contatto_utile)) {
				return cnt.getUtile();
			} else if(metodo.equals(ConstantsMap.contatto_chiuso)) {
				return cnt.getChiuso();
			} else if(metodo.equals(ConstantsMap.anagrafica_cognome)) {
				return cnt.getAnagrafica().getCognome();
			} else if(metodo.equals(ConstantsMap.anagrafica_nome)) {
				return cnt.getAnagrafica().getNome();
			} else if(metodo.equals(ConstantsMap.anagrafica_nome_completo)) {
				return cnt.getAnagrafica().getNome_completo();
			} else if(metodo.equals(ConstantsMap.anagrafica_email)) {
				return cnt.getAnagrafica().getEmail();
			} else if(metodo.equals(ConstantsMap.anagrafica_codice_fiscale)) {
				return cnt.getAnagrafica().getCodice_fiscale();
			} else if(metodo.equals(ConstantsMap.anagrafica_sorgente)) {
				return cnt.getAnagrafica().getSorgente();
			} else if(metodo.equals(ConstantsMap.anagrafica_nota)) {
				return cnt.getAnagrafica().getNota();
			} else if(metodo.equals(ConstantsMap.anagrafica_luogo_nascita)) {
				return cnt.getAnagrafica().getLuogo_nascita();
			} else if(metodo.equals(ConstantsMap.anagrafica_data_nascita)) {
				return cnt.getAnagrafica().getDate_nascita();
			} else if(metodo.equals(ConstantsMap.anagrafica_link)) {
				return cnt.getAnagrafica().getLink();
			} else if(metodo.equals(ConstantsMap.anagrafica_data_inserimento)) {
				return cnt.getAnagrafica().getData_creazione();
			} else if(metodo.equals(ConstantsMap.anagrafica_privacy)) {
				return cnt.getAnagrafica().getPrivacy();
			} else if(metodo.equals(ConstantsMap.anagrafica_tipo)) {
				return cnt.getAnagrafica().getTipo();
			} else if(metodo.equals(ConstantsMap.anagrafica_sesso)) {
				return cnt.getAnagrafica().getSesso();
			} else if(metodo.equals(ConstantsMap.anagrafica_partita_iva)) {
				return cnt.getAnagrafica().getPartita_iva();
			} else if(metodo.equals(ConstantsMap.anagrafica_ragione_sociale)) {
				return cnt.getAnagrafica().getRagione_sociale();
			} else if(metodo.equals(ConstantsMap.anagrafica_telefono_fisso)) {
				return cnt.getAnagrafica().getTelefono_fisso();
			} else if(metodo.equals(ConstantsMap.anagrafica_telefono_altro)) {
				return cnt.getAnagrafica().getTelefono_altro();
			} else if(metodo.equals(ConstantsMap.anagrafica_telefono_mobile)) {
				return cnt.getAnagrafica().getTelefono_mobile();
			} else if(metodo.equals(ConstantsMap.anagrafica_telefono_fax)) {
				return cnt.getAnagrafica().getTelefono_fax();
			} else if(metodo.equals(ConstantsMap.anagrafica_settore)) {
				return cnt.getAnagrafica().getSettore();
			} else if(metodo.equals(ConstantsMap.anagrafica_denominazione)) {
				return cnt.getAnagrafica().getDenominazione();
			} else if(metodo.equals(ConstantsMap.anagrafica_id)) {
				return cnt.getAnagrafica().getIdentificativo();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_indirizzo_completo)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getIndirizzo_completo();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_strada_completo)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getStrada_completo();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_comune_completo)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getComune_completo();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_strada)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getStrada();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_civico)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getCivico();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_cap)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getCap();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_comune)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getComune();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_provincia)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getProvincia();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_regione)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getRegione();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_dettagli)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getDettagli();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_latitudine)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getLatitudine();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_longitudine)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getLongitudine();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_presso)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getPresso();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_indirizzo_completo)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getIndirizzo_completo();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_strada_completo)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getStrada_completo();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_comune_completo)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getComune_completo();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_strada)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getStrada();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_civico)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getCivico();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_cap)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getCap();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_comune)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getComune();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_provincia)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getProvincia();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_regione)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getRegione();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_dettagli)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getDettagli();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_latitudine)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getLatitudine();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_longitudine)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getLongitudine();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_presso)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getPresso();
			} else if(metodo.equals(ConstantsMap.consenso_tfissoS)) {
				return cnt.getAnagrafica().getConsenso_tfisso();
			} else if(metodo.equals(ConstantsMap.consenso_tmobileS)) {
				return cnt.getAnagrafica().getConsenso_tmobile();
			} else if(metodo.equals(ConstantsMap.consenso_tfaxS)) {
				return cnt.getAnagrafica().getConsenso_tfax();
			} else if(metodo.equals(ConstantsMap.consenso_taltroS)) {
				return cnt.getAnagrafica().getConsenso_taltro();
			} else if(metodo.equals(ConstantsMap.consenso_emailS)) {
				return cnt.getAnagrafica().getConsenso_email();
			} else if(metodo.equals(ConstantsMap.consenso_rmailS)) {
				return cnt.getAnagrafica().getConsenso_rmail();
			} 
		}
		return null;
	}
	@SuppressWarnings("rawtypes")
	public static Comparable comparaAppuntamento(Appuntamento app, String metodo) {
		if(metodo != null) {
			Contatto cnt = app.getContatto();
			if(metodo.equals(ConstantsMap.appuntamento_id)) {
				return app.getId().toString();
			} else if(metodo.equals(ConstantsMap.appuntamento_operatore_denominazione)) {
				return app.getOperatore_denominazione();
			} else if(metodo.equals(ConstantsMap.appuntamento_bloccato)) {
				return app.getBloccatoS();
			} else if(metodo.equals(ConstantsMap.appuntamento_operatore_codice)) {
				return app.getOperatore_codice();
			} else if(metodo.equals(ConstantsMap.appuntamento_agente_denominazione)) {
				return app.getAgente_denominazione();
			} else if(metodo.equals(ConstantsMap.appuntamento_agente_codice)) {
				return app.getAgente_codice();
			} else if(metodo.equals(ConstantsMap.appuntamento_nota)) {
				return app.getNota();
			} else if(metodo.equals(ConstantsMap.appuntamento_data_creazione)) {
				return app.getData_creazione();
			} else if(metodo.equals(ConstantsMap.appuntamento_data_appuntamento)) {
				return app.getData_inizio();
			} else if(metodo.equals(ConstantsMap.appuntamento_data_ora)) {
				return app.getData_inizio();
			} else if(metodo.equals(ConstantsMap.appuntamento_ora_inizio)) {
				return app.getData_inizio();
			} else if(metodo.equals(ConstantsMap.appuntamento_ora_fine)) {
				return app.getData_fine();
			} else if(metodo.equals(ConstantsMap.appuntamento_data_conferma)) {
				return app.getData_conferma();
			} else if(metodo.equals(ConstantsMap.appuntamento_data_lavorazione)) {
				return app.getData_lavorazione();
			} else if(metodo.equals(ConstantsMap.appuntamento_localizzazione)) {
				return app.getLocalizzazioneString();
			} else if(metodo.equals(ConstantsMap.appuntamento_utente_denominazione)) {
				return app.getUtente_denominazione();
			} else if(metodo.equals(ConstantsMap.appuntamento_utente_codice)) {
				return app.getUtente_codice();
			} else if(metodo.equals(ConstantsMap.appuntamento_data_esito)) {
				return app.getData_esito();
			} else if(metodo.equals(ConstantsMap.appuntamento_data_stato)) {
				return app.getData_stato();
			} else if(metodo.equals(ConstantsMap.appuntamento_esito_appuntamento)) {
				return app.getEsitoEtichetta();
			} else if(metodo.equals(ConstantsMap.appuntamento_codice_appuntamento)) {
				return app.getEsitoCodice();
			} else if(metodo.equals(ConstantsMap.appuntamento_stato)) {
				return app.getStatoTesto();
			} else if(metodo.equals(ConstantsMap.contatto_data_lavorazione)) {
				return cnt.getData_lavorazione();
			} else if(metodo.equals(ConstantsMap.contatto_operatore_denominazione)) {
				return cnt.getOperatore_denominazione();
			} else if(metodo.equals(ConstantsMap.contatto_operatore_codice)) {
				return cnt.getOperatore_codice();
			} else if(metodo.equals(ConstantsMap.contatto_data_archiviazione)) {
				return cnt.getData_archiviazione();
			} else if(metodo.equals(ConstantsMap.contatto_esito_chiamata)) {
				return cnt.getEsito_chiamata();
			} else if(metodo.equals(ConstantsMap.contatto_esito_archiviazione)) {
				return cnt.getEsito_archiviazione();
			} else if(metodo.equals(ConstantsMap.contatto_esito_generale)) {
				return cnt.getEsito_generale();
			} else if(metodo.equals(ConstantsMap.contatto_codice_chiamata)) {
				return cnt.getCodice_chiamata();
			} else if(metodo.equals(ConstantsMap.contatto_codice_archiviazione)) {
				return cnt.getCodice_archiviazione();
			} else if(metodo.equals(ConstantsMap.contatto_codice_generale)) {
				return cnt.getCodice_generale();
			} else if(metodo.equals(ConstantsMap.contatto_proprietario_denominazione)) {
				return cnt.getProprietario_denominazione();
			} else if(metodo.equals(ConstantsMap.contatto_proprietario_codice)) {
				return cnt.getProprietario_codice();
			} else if(metodo.equals(ConstantsMap.contatto_data_presentazione)) {
				return cnt.getData_presentazione();
			} else if(metodo.equals(ConstantsMap.contatto_nota)) {
				return cnt.getNota();
			} else if(metodo.equals(ConstantsMap.contatto_data_creazione)) {
				return cnt.getData_creazione();
			} else if(metodo.equals(ConstantsMap.contatto_agente_denominazione)) {
				return cnt.getAgente_denominazione();
			} else if(metodo.equals(ConstantsMap.contatto_agente_codice)) {
				return cnt.getAgente_codice();
			} else if(metodo.equals(ConstantsMap.contatto_stato)) {
				return cnt.getTipoTesto();
			} else if(metodo.equals(ConstantsMap.contatto_id)) {
				return cnt.getId().toString();
			} else if(metodo.equals(ConstantsMap.contatto_campagna_denominazione)) {
				return cnt.getCampagna_denominazione();
			} else if(metodo.equals(ConstantsMap.contatto_lista_denominazione)) {
				return cnt.getLista_denominazione();
			} else if(metodo.equals(ConstantsMap.contatto_campagna_codice)) {
				return cnt.getCampagna_codice();
			} else if(metodo.equals(ConstantsMap.contatto_bloccato)) {
				return cnt.getBloccatoS();
			} else if(metodo.equals(ConstantsMap.contatto_lista_codice)) {
				return cnt.getLista_codice();
			} else if(metodo.equals(ConstantsMap.contatto_positivo)) {
				return cnt.getPositivo();
			} else if(metodo.equals(ConstantsMap.contatto_telefono_predefinito)) {
				return cnt.getTelefono_predefinito();
			} else if(metodo.equals(ConstantsMap.contatto_utile)) {
				return cnt.getUtile();
			} else if(metodo.equals(ConstantsMap.contatto_chiuso)) {
				return cnt.getChiuso();
			} else if(metodo.equals(ConstantsMap.anagrafica_cognome)) {
				return cnt.getAnagrafica().getCognome();
			} else if(metodo.equals(ConstantsMap.anagrafica_nome)) {
				return cnt.getAnagrafica().getNome();
			} else if(metodo.equals(ConstantsMap.anagrafica_nome_completo)) {
				return cnt.getAnagrafica().getNome_completo();
			} else if(metodo.equals(ConstantsMap.anagrafica_email)) {
				return cnt.getAnagrafica().getEmail();
			} else if(metodo.equals(ConstantsMap.anagrafica_codice_fiscale)) {
				return cnt.getAnagrafica().getCodice_fiscale();
			} else if(metodo.equals(ConstantsMap.anagrafica_sorgente)) {
				return cnt.getAnagrafica().getSorgente();
			} else if(metodo.equals(ConstantsMap.anagrafica_nota)) {
				return cnt.getAnagrafica().getNota();
			} else if(metodo.equals(ConstantsMap.anagrafica_luogo_nascita)) {
				return cnt.getAnagrafica().getLuogo_nascita();
			} else if(metodo.equals(ConstantsMap.anagrafica_data_nascita)) {
				return cnt.getAnagrafica().getDate_nascita();
			} else if(metodo.equals(ConstantsMap.anagrafica_link)) {
				return cnt.getAnagrafica().getLink();
			} else if(metodo.equals(ConstantsMap.anagrafica_data_inserimento)) {
				return cnt.getAnagrafica().getData_creazione();
			} else if(metodo.equals(ConstantsMap.anagrafica_privacy)) {
				return cnt.getAnagrafica().getPrivacy();
			} else if(metodo.equals(ConstantsMap.anagrafica_tipo)) {
				return cnt.getAnagrafica().getTipo();
			} else if(metodo.equals(ConstantsMap.anagrafica_sesso)) {
				return cnt.getAnagrafica().getSesso();
			} else if(metodo.equals(ConstantsMap.anagrafica_partita_iva)) {
				return cnt.getAnagrafica().getPartita_iva();
			} else if(metodo.equals(ConstantsMap.anagrafica_ragione_sociale)) {
				return cnt.getAnagrafica().getRagione_sociale();
			} else if(metodo.equals(ConstantsMap.anagrafica_telefono_fisso)) {
				return cnt.getAnagrafica().getTelefono_fisso();
			} else if(metodo.equals(ConstantsMap.anagrafica_telefono_altro)) {
				return cnt.getAnagrafica().getTelefono_altro();
			} else if(metodo.equals(ConstantsMap.anagrafica_telefono_mobile)) {
				return cnt.getAnagrafica().getTelefono_mobile();
			} else if(metodo.equals(ConstantsMap.anagrafica_telefono_fax)) {
				return cnt.getAnagrafica().getTelefono_fax();
			} else if(metodo.equals(ConstantsMap.anagrafica_settore)) {
				return cnt.getAnagrafica().getSettore();
			} else if(metodo.equals(ConstantsMap.anagrafica_denominazione)) {
				return cnt.getAnagrafica().getDenominazione();
			} else if(metodo.equals(ConstantsMap.anagrafica_id)) {
				return cnt.getAnagrafica().getIdentificativo();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_indirizzo_completo)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getIndirizzo_completo();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_strada_completo)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getStrada_completo();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_comune_completo)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getComune_completo();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_strada)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getStrada();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_civico)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getCivico();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_cap)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getCap();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_comune)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getComune();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_provincia)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getProvincia();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_regione)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getRegione();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_dettagli)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getDettagli();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_latitudine)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getLatitudine();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_longitudine)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getLongitudine();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_presso)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getPresso();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_indirizzo_completo)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getIndirizzo_completo();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_strada_completo)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getStrada_completo();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_comune_completo)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getComune_completo();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_strada)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getStrada();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_civico)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getCivico();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_cap)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getCap();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_comune)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getComune();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_provincia)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getProvincia();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_regione)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getRegione();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_dettagli)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getDettagli();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_latitudine)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getLatitudine();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_longitudine)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getLongitudine();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_presso)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getPresso();
			} else if(metodo.equals(ConstantsMap.consenso_tfissoS)) {
				return cnt.getAnagrafica().getConsenso_tfisso();
			} else if(metodo.equals(ConstantsMap.consenso_tmobileS)) {
				return cnt.getAnagrafica().getConsenso_tmobile();
			} else if(metodo.equals(ConstantsMap.consenso_tfaxS)) {
				return cnt.getAnagrafica().getConsenso_tfax();
			} else if(metodo.equals(ConstantsMap.consenso_taltroS)) {
				return cnt.getAnagrafica().getConsenso_taltro();
			} else if(metodo.equals(ConstantsMap.consenso_emailS)) {
				return cnt.getAnagrafica().getConsenso_email();
			} else if(metodo.equals(ConstantsMap.consenso_rmailS)) {
				return cnt.getAnagrafica().getConsenso_rmail();
			} 
		}
		return null;
	}
	@SuppressWarnings("rawtypes")
	public static Comparable comparaContratto(Contratto crt, String metodo) {
		if(metodo != null) {
			Contatto cnt = crt.getContatto();
			if(metodo.equals(ConstantsMap.contratto_data_creazione)) {
				return crt.getData_creazione();
			} else if(metodo.equals(ConstantsMap.contratto_id)) {
				return crt.getId().toString();
			} else if(metodo.equals(ConstantsMap.contratto_operatore_denominazione)) {
				return crt.getOperatore_denominazione();
			} else if(metodo.equals(ConstantsMap.contratto_operatore_codice)) {
				return crt.getOperatore_codice();
			} else if(metodo.equals(ConstantsMap.contratto_agente_denominazione)) {
				return crt.getAgente_denominazione();
			} else if(metodo.equals(ConstantsMap.contratto_agente_codice)) {
				return crt.getAgente_codice();
			} else if(metodo.equals(ConstantsMap.contratto_categoria_denominazione)) {
				return crt.getCategoria_denominazione();
			} else if(metodo.equals(ConstantsMap.contratto_prodotto_denominazione)) {
				return crt.getProdotto_denominazione();
			} else if(metodo.equals(ConstantsMap.contratto_esito_contratto)) {
				return crt.getEsitoEtichetta();
			} else if(metodo.equals(ConstantsMap.contratto_codice_contratto)) {
				return crt.getEsitoCodice();
			} else if(metodo.equals(ConstantsMap.contratto_data_stipula)) {
				return crt.getData_stipula();
			} else if(metodo.equals(ConstantsMap.contratto_data_contabile)) {
				return crt.getData_contabile();
			} else if(metodo.equals(ConstantsMap.contratto_data_attivazione)) {
				return crt.getData_attivazione();
			} else if(metodo.equals(ConstantsMap.contratto_data_caricamento)) {
				return crt.getData_caricamento();
			} else if(metodo.equals(ConstantsMap.contratto_data_lavorazione)) {
				return crt.getData_lavorazione();
			} else if(metodo.equals(ConstantsMap.contratto_utente_denominazione)) {
				return crt.getUtente_denominazione();
			} else if(metodo.equals(ConstantsMap.contratto_bloccato)) {
				return crt.getBloccatoS();
			} else if(metodo.equals(ConstantsMap.contratto_utente_codice)) {
				return crt.getUtente_codice();
			} else if(metodo.equals(ConstantsMap.contratto_data_esito)) {
				return crt.getData_esito();
			} else if(metodo.equals(ConstantsMap.contratto_data_stato)) {
				return crt.getData_stato();
			} else if(metodo.equals(ConstantsMap.contratto_nota)) {
				return crt.getNota();
			} else if(metodo.equals(ConstantsMap.contratto_tipo_seriale)) {
				return crt.getTipo_seriale();
			} else if(metodo.equals(ConstantsMap.contratto_seriale)) {
				return crt.getSeriale();
			} else if(metodo.equals(ConstantsMap.contratto_quantita)) {
				return crt.getQuantita();
			} else if(metodo.equals(ConstantsMap.contratto_costo_scontato)) {
				return crt.getCosto_scontato();
			} else if(metodo.equals(ConstantsMap.contratto_stato)) {
				return crt.getStatoTesto();
			} else if(metodo.equals(ConstantsMap.contatto_data_archiviazione)) {
				return cnt.getData_archiviazione();
			} else if(metodo.equals(ConstantsMap.contatto_data_lavorazione)) {
				return cnt.getData_lavorazione();
			} else if(metodo.equals(ConstantsMap.contatto_operatore_denominazione)) {
				return cnt.getOperatore_denominazione();
			} else if(metodo.equals(ConstantsMap.contatto_operatore_codice)) {
				return cnt.getOperatore_codice();
			} else if(metodo.equals(ConstantsMap.contatto_esito_chiamata)) {
				return cnt.getEsito_chiamata();
			} else if(metodo.equals(ConstantsMap.contatto_esito_archiviazione)) {
				return cnt.getEsito_archiviazione();
			} else if(metodo.equals(ConstantsMap.contatto_esito_generale)) {
				return cnt.getEsito_generale();
			} else if(metodo.equals(ConstantsMap.contatto_codice_chiamata)) {
				return cnt.getCodice_chiamata();
			} else if(metodo.equals(ConstantsMap.contatto_codice_archiviazione)) {
				return cnt.getCodice_archiviazione();
			} else if(metodo.equals(ConstantsMap.contatto_codice_generale)) {
				return cnt.getCodice_generale();
			} else if(metodo.equals(ConstantsMap.contatto_proprietario_denominazione)) {
				return cnt.getProprietario_denominazione();
			} else if(metodo.equals(ConstantsMap.contatto_proprietario_codice)) {
				return cnt.getProprietario_codice();
			} else if(metodo.equals(ConstantsMap.contatto_data_presentazione)) {
				return cnt.getData_presentazione();
			} else if(metodo.equals(ConstantsMap.contatto_nota)) {
				return cnt.getNota();
			} else if(metodo.equals(ConstantsMap.contatto_data_creazione)) {
				return cnt.getData_creazione();
			} else if(metodo.equals(ConstantsMap.contatto_agente_denominazione)) {
				return cnt.getAgente_denominazione();
			} else if(metodo.equals(ConstantsMap.contatto_agente_codice)) {
				return cnt.getAgente_codice();
			} else if(metodo.equals(ConstantsMap.contatto_stato)) {
				return cnt.getTipoTesto();
			} else if(metodo.equals(ConstantsMap.contatto_id)) {
				return cnt.getId().toString();
			} else if(metodo.equals(ConstantsMap.contatto_campagna_denominazione)) {
				return cnt.getCampagna_denominazione();
			} else if(metodo.equals(ConstantsMap.contatto_lista_denominazione)) {
				return cnt.getLista_denominazione();
			} else if(metodo.equals(ConstantsMap.contatto_campagna_codice)) {
				return cnt.getCampagna_codice();
			} else if(metodo.equals(ConstantsMap.contatto_bloccato)) {
				return cnt.getBloccatoS();
			} else if(metodo.equals(ConstantsMap.contatto_lista_codice)) {
				return cnt.getLista_codice();
			} else if(metodo.equals(ConstantsMap.contatto_positivo)) {
				return cnt.getPositivo();
			} else if(metodo.equals(ConstantsMap.contatto_telefono_predefinito)) {
				return cnt.getTelefono_predefinito();
			} else if(metodo.equals(ConstantsMap.contatto_utile)) {
				return cnt.getUtile();
			} else if(metodo.equals(ConstantsMap.contatto_chiuso)) {
				return cnt.getChiuso();
			} else if(metodo.equals(ConstantsMap.anagrafica_cognome)) {
				return cnt.getAnagrafica().getCognome();
			} else if(metodo.equals(ConstantsMap.anagrafica_nome)) {
				return cnt.getAnagrafica().getNome();
			} else if(metodo.equals(ConstantsMap.anagrafica_nome_completo)) {
				return cnt.getAnagrafica().getNome_completo();
			} else if(metodo.equals(ConstantsMap.anagrafica_email)) {
				return cnt.getAnagrafica().getEmail();
			} else if(metodo.equals(ConstantsMap.anagrafica_codice_fiscale)) {
				return cnt.getAnagrafica().getCodice_fiscale();
			} else if(metodo.equals(ConstantsMap.anagrafica_sorgente)) {
				return cnt.getAnagrafica().getSorgente();
			} else if(metodo.equals(ConstantsMap.anagrafica_nota)) {
				return cnt.getAnagrafica().getNota();
			} else if(metodo.equals(ConstantsMap.anagrafica_luogo_nascita)) {
				return cnt.getAnagrafica().getLuogo_nascita();
			} else if(metodo.equals(ConstantsMap.anagrafica_data_nascita)) {
				return cnt.getAnagrafica().getDate_nascita();
			} else if(metodo.equals(ConstantsMap.anagrafica_link)) {
				return cnt.getAnagrafica().getLink();
			} else if(metodo.equals(ConstantsMap.anagrafica_data_inserimento)) {
				return cnt.getAnagrafica().getData_creazione();
			} else if(metodo.equals(ConstantsMap.anagrafica_privacy)) {
				return cnt.getAnagrafica().getPrivacy();
			} else if(metodo.equals(ConstantsMap.anagrafica_tipo)) {
				return cnt.getAnagrafica().getTipo();
			} else if(metodo.equals(ConstantsMap.anagrafica_sesso)) {
				return cnt.getAnagrafica().getSesso();
			} else if(metodo.equals(ConstantsMap.anagrafica_partita_iva)) {
				return cnt.getAnagrafica().getPartita_iva();
			} else if(metodo.equals(ConstantsMap.anagrafica_ragione_sociale)) {
				return cnt.getAnagrafica().getRagione_sociale();
			} else if(metodo.equals(ConstantsMap.anagrafica_telefono_fisso)) {
				return cnt.getAnagrafica().getTelefono_fisso();
			} else if(metodo.equals(ConstantsMap.anagrafica_telefono_altro)) {
				return cnt.getAnagrafica().getTelefono_altro();
			} else if(metodo.equals(ConstantsMap.anagrafica_telefono_mobile)) {
				return cnt.getAnagrafica().getTelefono_mobile();
			} else if(metodo.equals(ConstantsMap.anagrafica_telefono_fax)) {
				return cnt.getAnagrafica().getTelefono_fax();
			} else if(metodo.equals(ConstantsMap.anagrafica_settore)) {
				return cnt.getAnagrafica().getSettore();
			} else if(metodo.equals(ConstantsMap.anagrafica_denominazione)) {
				return cnt.getAnagrafica().getDenominazione();
			} else if(metodo.equals(ConstantsMap.anagrafica_id)) {
				return cnt.getAnagrafica().getIdentificativo();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_indirizzo_completo)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getIndirizzo_completo();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_strada_completo)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getStrada_completo();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_comune_completo)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getComune_completo();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_strada)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getStrada();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_civico)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getCivico();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_cap)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getCap();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_comune)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getComune();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_provincia)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getProvincia();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_regione)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getRegione();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_dettagli)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getDettagli();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_latitudine)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getLatitudine();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_longitudine)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getLongitudine();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_presso)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getPresso();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_indirizzo_completo)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getIndirizzo_completo();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_strada_completo)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getStrada_completo();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_comune_completo)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getComune_completo();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_strada)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getStrada();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_civico)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getCivico();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_cap)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getCap();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_comune)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getComune();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_provincia)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getProvincia();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_regione)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getRegione();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_dettagli)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getDettagli();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_latitudine)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getLatitudine();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_longitudine)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getLongitudine();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_presso)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getPresso();
			} else if(metodo.equals(ConstantsMap.consenso_tfissoS)) {
				return cnt.getAnagrafica().getConsenso_tfisso();
			} else if(metodo.equals(ConstantsMap.consenso_tmobileS)) {
				return cnt.getAnagrafica().getConsenso_tmobile();
			} else if(metodo.equals(ConstantsMap.consenso_tfaxS)) {
				return cnt.getAnagrafica().getConsenso_tfax();
			} else if(metodo.equals(ConstantsMap.consenso_taltroS)) {
				return cnt.getAnagrafica().getConsenso_taltro();
			} else if(metodo.equals(ConstantsMap.consenso_emailS)) {
				return cnt.getAnagrafica().getConsenso_email();
			} else if(metodo.equals(ConstantsMap.consenso_rmailS)) {
				return cnt.getAnagrafica().getConsenso_rmail();
			} 
		}
		return null;
	}
	@SuppressWarnings("rawtypes")
	public static Comparable comparaStoriaAppuntamento(StoriaAppuntamento sapp, String metodo) {
		if(metodo != null) {
			Appuntamento app = sapp.getAppuntamento();
			Contatto cnt = app.getContatto();
			if(metodo.equals(ConstantsMap.storia_appuntamento_id)) {
				return sapp.getId().toString();
			} else if(metodo.equals(ConstantsMap.storia_appuntamento_operatore_denominazione)) {
				return sapp.getOperatore_denominazione();
			} else if(metodo.equals(ConstantsMap.storia_appuntamento_bloccato)) {
				return sapp.getBloccatoS();
			} else if(metodo.equals(ConstantsMap.storia_appuntamento_operatore_codice)) {
				return sapp.getOperatore_codice();
			} else if(metodo.equals(ConstantsMap.storia_appuntamento_agente_denominazione)) {
				return sapp.getAgente_denominazione();
			} else if(metodo.equals(ConstantsMap.storia_appuntamento_agente_codice)) {
				return sapp.getAgente_codice();
			} else if(metodo.equals(ConstantsMap.storia_appuntamento_nota)) {
				return sapp.getNota();
			} else if(metodo.equals(ConstantsMap.storia_appuntamento_data)) {
				return sapp.getData();
			} else if(metodo.equals(ConstantsMap.storia_appuntamento_data_inizio)) {
				return sapp.getData_inizio();
			} else if(metodo.equals(ConstantsMap.storia_appuntamento_data_fine)) {
				return sapp.getData_fine();
			} else if(metodo.equals(ConstantsMap.storia_appuntamento_data_conferma)) {
				return sapp.getData_conferma();
			} else if(metodo.equals(ConstantsMap.storia_appuntamento_localizzazione)) {
				return sapp.getLocalizzazioneString();
			} else if(metodo.equals(ConstantsMap.storia_appuntamento_utente_denominazione)) {
				return sapp.getUtente_denominazione();
			} else if(metodo.equals(ConstantsMap.storia_appuntamento_utente_codice)) {
				return sapp.getUtente_codice();
			} else if(metodo.equals(ConstantsMap.storia_appuntamento_data_esito)) {
				return sapp.getData_esito();
			} else if(metodo.equals(ConstantsMap.storia_appuntamento_data_stato)) {
				return sapp.getData_stato();
			} else if(metodo.equals(ConstantsMap.storia_appuntamento_esito_appuntamento)) {
				return sapp.getEsitoEtichetta();
			} else if(metodo.equals(ConstantsMap.storia_appuntamento_codice_appuntamento)) {
				return sapp.getEsitoCodice();
			} else if(metodo.equals(ConstantsMap.storia_appuntamento_stato)) {
				return sapp.getStatoTesto();
			} else if(metodo.equals(ConstantsMap.appuntamento_id)) {
				return app.getId().toString();
			} else if(metodo.equals(ConstantsMap.appuntamento_operatore_denominazione)) {
				return app.getOperatore_denominazione();
			} else if(metodo.equals(ConstantsMap.appuntamento_bloccato)) {
				return app.getBloccatoS();
			} else if(metodo.equals(ConstantsMap.appuntamento_operatore_codice)) {
				return app.getOperatore_codice();
			} else if(metodo.equals(ConstantsMap.appuntamento_agente_denominazione)) {
				return app.getAgente_denominazione();
			} else if(metodo.equals(ConstantsMap.appuntamento_agente_codice)) {
				return app.getAgente_codice();
			} else if(metodo.equals(ConstantsMap.appuntamento_nota)) {
				return app.getNota();
			} else if(metodo.equals(ConstantsMap.appuntamento_data_creazione)) {
				return app.getData_creazione();
			} else if(metodo.equals(ConstantsMap.appuntamento_data_appuntamento)) {
				return app.getData_inizio();
			} else if(metodo.equals(ConstantsMap.appuntamento_data_ora)) {
				return app.getData_inizio();
			} else if(metodo.equals(ConstantsMap.appuntamento_ora_inizio)) {
				return app.getData_inizio();
			} else if(metodo.equals(ConstantsMap.appuntamento_ora_fine)) {
				return app.getData_fine();
			} else if(metodo.equals(ConstantsMap.appuntamento_data_conferma)) {
				return app.getData_conferma();
			} else if(metodo.equals(ConstantsMap.appuntamento_data_lavorazione)) {
				return app.getData_lavorazione();
			} else if(metodo.equals(ConstantsMap.appuntamento_localizzazione)) {
				return app.getLocalizzazioneString();
			} else if(metodo.equals(ConstantsMap.appuntamento_utente_denominazione)) {
				return app.getUtente_denominazione();
			} else if(metodo.equals(ConstantsMap.appuntamento_utente_codice)) {
				return app.getUtente_codice();
			} else if(metodo.equals(ConstantsMap.appuntamento_data_esito)) {
				return app.getData_esito();
			} else if(metodo.equals(ConstantsMap.appuntamento_data_stato)) {
				return app.getData_stato();
			} else if(metodo.equals(ConstantsMap.appuntamento_esito_appuntamento)) {
				return app.getEsitoEtichetta();
			} else if(metodo.equals(ConstantsMap.appuntamento_codice_appuntamento)) {
				return app.getEsitoCodice();
			} else if(metodo.equals(ConstantsMap.appuntamento_stato)) {
				return app.getStatoTesto();
			} else if(metodo.equals(ConstantsMap.contatto_data_lavorazione)) {
				return cnt.getData_lavorazione();
			} else if(metodo.equals(ConstantsMap.contatto_operatore_denominazione)) {
				return cnt.getOperatore_denominazione();
			} else if(metodo.equals(ConstantsMap.contatto_operatore_codice)) {
				return cnt.getOperatore_codice();
			} else if(metodo.equals(ConstantsMap.contatto_data_archiviazione)) {
				return cnt.getData_archiviazione();
			} else if(metodo.equals(ConstantsMap.contatto_esito_chiamata)) {
				return cnt.getEsito_chiamata();
			} else if(metodo.equals(ConstantsMap.contatto_esito_archiviazione)) {
				return cnt.getEsito_archiviazione();
			} else if(metodo.equals(ConstantsMap.contatto_esito_generale)) {
				return cnt.getEsito_generale();
			} else if(metodo.equals(ConstantsMap.contatto_codice_chiamata)) {
				return cnt.getCodice_chiamata();
			} else if(metodo.equals(ConstantsMap.contatto_codice_archiviazione)) {
				return cnt.getCodice_archiviazione();
			} else if(metodo.equals(ConstantsMap.contatto_codice_generale)) {
				return cnt.getCodice_generale();
			} else if(metodo.equals(ConstantsMap.contatto_proprietario_denominazione)) {
				return cnt.getProprietario_denominazione();
			} else if(metodo.equals(ConstantsMap.contatto_proprietario_codice)) {
				return cnt.getProprietario_codice();
			} else if(metodo.equals(ConstantsMap.contatto_data_presentazione)) {
				return cnt.getData_presentazione();
			} else if(metodo.equals(ConstantsMap.contatto_nota)) {
				return cnt.getNota();
			} else if(metodo.equals(ConstantsMap.contatto_data_creazione)) {
				return cnt.getData_creazione();
			} else if(metodo.equals(ConstantsMap.contatto_agente_denominazione)) {
				return cnt.getAgente_denominazione();
			} else if(metodo.equals(ConstantsMap.contatto_agente_codice)) {
				return cnt.getAgente_codice();
			} else if(metodo.equals(ConstantsMap.contatto_stato)) {
				return cnt.getTipoTesto();
			} else if(metodo.equals(ConstantsMap.contatto_id)) {
				return cnt.getId().toString();
			} else if(metodo.equals(ConstantsMap.contatto_campagna_denominazione)) {
				return cnt.getCampagna_denominazione();
			} else if(metodo.equals(ConstantsMap.contatto_lista_denominazione)) {
				return cnt.getLista_denominazione();
			} else if(metodo.equals(ConstantsMap.contatto_campagna_codice)) {
				return cnt.getCampagna_codice();
			} else if(metodo.equals(ConstantsMap.contatto_bloccato)) {
				return cnt.getBloccatoS();
			} else if(metodo.equals(ConstantsMap.contatto_lista_codice)) {
				return cnt.getLista_codice();
			} else if(metodo.equals(ConstantsMap.contatto_positivo)) {
				return cnt.getPositivo();
			} else if(metodo.equals(ConstantsMap.contatto_telefono_predefinito)) {
				return cnt.getTelefono_predefinito();
			} else if(metodo.equals(ConstantsMap.contatto_utile)) {
				return cnt.getUtile();
			} else if(metodo.equals(ConstantsMap.contatto_chiuso)) {
				return cnt.getChiuso();
			} else if(metodo.equals(ConstantsMap.anagrafica_cognome)) {
				return cnt.getAnagrafica().getCognome();
			} else if(metodo.equals(ConstantsMap.anagrafica_nome)) {
				return cnt.getAnagrafica().getNome();
			} else if(metodo.equals(ConstantsMap.anagrafica_nome_completo)) {
				return cnt.getAnagrafica().getNome_completo();
			} else if(metodo.equals(ConstantsMap.anagrafica_email)) {
				return cnt.getAnagrafica().getEmail();
			} else if(metodo.equals(ConstantsMap.anagrafica_codice_fiscale)) {
				return cnt.getAnagrafica().getCodice_fiscale();
			} else if(metodo.equals(ConstantsMap.anagrafica_sorgente)) {
				return cnt.getAnagrafica().getSorgente();
			} else if(metodo.equals(ConstantsMap.anagrafica_nota)) {
				return cnt.getAnagrafica().getNota();
			} else if(metodo.equals(ConstantsMap.anagrafica_luogo_nascita)) {
				return cnt.getAnagrafica().getLuogo_nascita();
			} else if(metodo.equals(ConstantsMap.anagrafica_data_nascita)) {
				return cnt.getAnagrafica().getDate_nascita();
			} else if(metodo.equals(ConstantsMap.anagrafica_link)) {
				return cnt.getAnagrafica().getLink();
			} else if(metodo.equals(ConstantsMap.anagrafica_data_inserimento)) {
				return cnt.getAnagrafica().getData_creazione();
			} else if(metodo.equals(ConstantsMap.anagrafica_privacy)) {
				return cnt.getAnagrafica().getPrivacy();
			} else if(metodo.equals(ConstantsMap.anagrafica_tipo)) {
				return cnt.getAnagrafica().getTipo();
			} else if(metodo.equals(ConstantsMap.anagrafica_sesso)) {
				return cnt.getAnagrafica().getSesso();
			} else if(metodo.equals(ConstantsMap.anagrafica_partita_iva)) {
				return cnt.getAnagrafica().getPartita_iva();
			} else if(metodo.equals(ConstantsMap.anagrafica_ragione_sociale)) {
				return cnt.getAnagrafica().getRagione_sociale();
			} else if(metodo.equals(ConstantsMap.anagrafica_telefono_fisso)) {
				return cnt.getAnagrafica().getTelefono_fisso();
			} else if(metodo.equals(ConstantsMap.anagrafica_telefono_altro)) {
				return cnt.getAnagrafica().getTelefono_altro();
			} else if(metodo.equals(ConstantsMap.anagrafica_telefono_mobile)) {
				return cnt.getAnagrafica().getTelefono_mobile();
			} else if(metodo.equals(ConstantsMap.anagrafica_telefono_fax)) {
				return cnt.getAnagrafica().getTelefono_fax();
			} else if(metodo.equals(ConstantsMap.anagrafica_settore)) {
				return cnt.getAnagrafica().getSettore();
			} else if(metodo.equals(ConstantsMap.anagrafica_denominazione)) {
				return cnt.getAnagrafica().getDenominazione();
			} else if(metodo.equals(ConstantsMap.anagrafica_id)) {
				return cnt.getAnagrafica().getIdentificativo();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_indirizzo_completo)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getIndirizzo_completo();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_strada_completo)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getStrada_completo();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_comune_completo)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getComune_completo();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_strada)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getStrada();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_civico)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getCivico();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_cap)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getCap();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_comune)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getComune();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_provincia)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getProvincia();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_regione)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getRegione();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_dettagli)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getDettagli();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_latitudine)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getLatitudine();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_longitudine)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getLongitudine();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_presso)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getPresso();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_indirizzo_completo)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getIndirizzo_completo();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_strada_completo)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getStrada_completo();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_comune_completo)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getComune_completo();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_strada)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getStrada();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_civico)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getCivico();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_cap)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getCap();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_comune)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getComune();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_provincia)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getProvincia();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_regione)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getRegione();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_dettagli)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getDettagli();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_latitudine)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getLatitudine();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_longitudine)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getLongitudine();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_presso)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getPresso();
			} else if(metodo.equals(ConstantsMap.consenso_tfissoS)) {
				return cnt.getAnagrafica().getConsenso_tfisso();
			} else if(metodo.equals(ConstantsMap.consenso_tmobileS)) {
				return cnt.getAnagrafica().getConsenso_tmobile();
			} else if(metodo.equals(ConstantsMap.consenso_tfaxS)) {
				return cnt.getAnagrafica().getConsenso_tfax();
			} else if(metodo.equals(ConstantsMap.consenso_taltroS)) {
				return cnt.getAnagrafica().getConsenso_taltro();
			} else if(metodo.equals(ConstantsMap.consenso_emailS)) {
				return cnt.getAnagrafica().getConsenso_email();
			} else if(metodo.equals(ConstantsMap.consenso_rmailS)) {
				return cnt.getAnagrafica().getConsenso_rmail();
			} 
		}
		return null;
	}
	@SuppressWarnings("rawtypes")
	public static Comparable comparaStoriaContratto(StoriaContratto scrt, String metodo) {
		if(metodo != null) {
			Contratto crt = scrt.getContratto();
			Contatto cnt = crt.getContatto();
			if(metodo.equals(ConstantsMap.storia_contratto_data)) {
				return scrt.getData();
			} else if(metodo.equals(ConstantsMap.storia_contratto_id)) {
				return scrt.getId().toString();
			} else if(metodo.equals(ConstantsMap.storia_contratto_operatore_denominazione)) {
				return scrt.getOperatore_denominazione();
			} else if(metodo.equals(ConstantsMap.storia_contratto_operatore_codice)) {
				return scrt.getOperatore_codice();
			} else if(metodo.equals(ConstantsMap.storia_contratto_agente_denominazione)) {
				return scrt.getAgente_denominazione();
			} else if(metodo.equals(ConstantsMap.storia_contratto_agente_codice)) {
				return scrt.getAgente_codice();
			} else if(metodo.equals(ConstantsMap.storia_contratto_categoria_denominazione)) {
				return scrt.getCategoria_denominazione();
			} else if(metodo.equals(ConstantsMap.storia_contratto_prodotto_denominazione)) {
				return scrt.getProdotto_denominazione();
			} else if(metodo.equals(ConstantsMap.storia_contratto_esito_contratto)) {
				return scrt.getEsitoEtichetta();
			} else if(metodo.equals(ConstantsMap.storia_contratto_codice_contratto)) {
				return scrt.getEsitoCodice();
			} else if(metodo.equals(ConstantsMap.storia_contratto_data_stipula)) {
				return scrt.getData_stipula();
			} else if(metodo.equals(ConstantsMap.storia_contratto_data_contabile)) {
				return scrt.getData_contabile();
			} else if(metodo.equals(ConstantsMap.storia_contratto_data_attivazione)) {
				return scrt.getData_attivazione();
			} else if(metodo.equals(ConstantsMap.storia_contratto_data_caricamento)) {
				return scrt.getData_caricamento();
			} else if(metodo.equals(ConstantsMap.storia_contratto_bloccato)) {
				return scrt.getBloccatoS();
			} else if(metodo.equals(ConstantsMap.storia_contratto_utente_denominazione)) {
				return scrt.getUtente_denominazione();
			} else if(metodo.equals(ConstantsMap.storia_contratto_utente_codice)) {
				return scrt.getUtente_codice();
			} else if(metodo.equals(ConstantsMap.storia_contratto_data_esito)) {
				return scrt.getData_esito();
			} else if(metodo.equals(ConstantsMap.storia_contratto_data_stato)) {
				return scrt.getData_stato();
			} else if(metodo.equals(ConstantsMap.storia_contratto_nota)) {
				return scrt.getNota();
			} else if(metodo.equals(ConstantsMap.storia_contratto_tipo_seriale)) {
				return scrt.getTipo_seriale();
			} else if(metodo.equals(ConstantsMap.storia_contratto_seriale)) {
				return scrt.getSeriale();
			} else if(metodo.equals(ConstantsMap.storia_contratto_quantita)) {
				return scrt.getQuantita();
			} else if(metodo.equals(ConstantsMap.storia_contratto_costo_scontato)) {
				return scrt.getCosto_scontato();
			} else if(metodo.equals(ConstantsMap.storia_contratto_stato)) {
				return scrt.getStatoTesto();
			} else if(metodo.equals(ConstantsMap.contratto_data_creazione)) {
				return crt.getData_creazione();
			} else if(metodo.equals(ConstantsMap.contratto_id)) {
				return crt.getId().toString();
			} else if(metodo.equals(ConstantsMap.contratto_operatore_denominazione)) {
				return crt.getOperatore_denominazione();
			} else if(metodo.equals(ConstantsMap.contratto_operatore_codice)) {
				return crt.getOperatore_codice();
			} else if(metodo.equals(ConstantsMap.contratto_agente_denominazione)) {
				return crt.getAgente_denominazione();
			} else if(metodo.equals(ConstantsMap.contratto_agente_codice)) {
				return crt.getAgente_codice();
			} else if(metodo.equals(ConstantsMap.contratto_categoria_denominazione)) {
				return crt.getCategoria_denominazione();
			} else if(metodo.equals(ConstantsMap.contratto_prodotto_denominazione)) {
				return crt.getProdotto_denominazione();
			} else if(metodo.equals(ConstantsMap.contratto_esito_contratto)) {
				return crt.getEsitoEtichetta();
			} else if(metodo.equals(ConstantsMap.contratto_codice_contratto)) {
				return crt.getEsitoCodice();
			} else if(metodo.equals(ConstantsMap.contratto_data_stipula)) {
				return crt.getData_stipula();
			} else if(metodo.equals(ConstantsMap.contratto_data_contabile)) {
				return crt.getData_contabile();
			} else if(metodo.equals(ConstantsMap.contratto_data_attivazione)) {
				return crt.getData_attivazione();
			} else if(metodo.equals(ConstantsMap.contratto_data_caricamento)) {
				return crt.getData_caricamento();
			} else if(metodo.equals(ConstantsMap.contratto_data_lavorazione)) {
				return crt.getData_lavorazione();
			} else if(metodo.equals(ConstantsMap.contratto_utente_denominazione)) {
				return crt.getUtente_denominazione();
			} else if(metodo.equals(ConstantsMap.contratto_bloccato)) {
				return crt.getBloccatoS();
			} else if(metodo.equals(ConstantsMap.contratto_utente_codice)) {
				return crt.getUtente_codice();
			} else if(metodo.equals(ConstantsMap.contratto_data_esito)) {
				return crt.getData_esito();
			} else if(metodo.equals(ConstantsMap.contratto_data_stato)) {
				return crt.getData_stato();
			} else if(metodo.equals(ConstantsMap.contratto_nota)) {
				return crt.getNota();
			} else if(metodo.equals(ConstantsMap.contratto_tipo_seriale)) {
				return crt.getTipo_seriale();
			} else if(metodo.equals(ConstantsMap.contratto_seriale)) {
				return crt.getSeriale();
			} else if(metodo.equals(ConstantsMap.contratto_quantita)) {
				return crt.getQuantita();
			} else if(metodo.equals(ConstantsMap.contratto_costo_scontato)) {
				return crt.getCosto_scontato();
			} else if(metodo.equals(ConstantsMap.contratto_stato)) {
				return crt.getStatoTesto();
			} else if(metodo.equals(ConstantsMap.contatto_data_archiviazione)) {
				return cnt.getData_archiviazione();
			} else if(metodo.equals(ConstantsMap.contatto_data_lavorazione)) {
				return cnt.getData_lavorazione();
			} else if(metodo.equals(ConstantsMap.contatto_operatore_denominazione)) {
				return cnt.getOperatore_denominazione();
			} else if(metodo.equals(ConstantsMap.contatto_operatore_codice)) {
				return cnt.getOperatore_codice();
			} else if(metodo.equals(ConstantsMap.contatto_esito_chiamata)) {
				return cnt.getEsito_chiamata();
			} else if(metodo.equals(ConstantsMap.contatto_esito_archiviazione)) {
				return cnt.getEsito_archiviazione();
			} else if(metodo.equals(ConstantsMap.contatto_esito_generale)) {
				return cnt.getEsito_generale();
			} else if(metodo.equals(ConstantsMap.contatto_codice_chiamata)) {
				return cnt.getCodice_chiamata();
			} else if(metodo.equals(ConstantsMap.contatto_codice_archiviazione)) {
				return cnt.getCodice_archiviazione();
			} else if(metodo.equals(ConstantsMap.contatto_codice_generale)) {
				return cnt.getCodice_generale();
			} else if(metodo.equals(ConstantsMap.contatto_proprietario_denominazione)) {
				return cnt.getProprietario_denominazione();
			} else if(metodo.equals(ConstantsMap.contatto_proprietario_codice)) {
				return cnt.getProprietario_codice();
			} else if(metodo.equals(ConstantsMap.contatto_data_presentazione)) {
				return cnt.getData_presentazione();
			} else if(metodo.equals(ConstantsMap.contatto_nota)) {
				return cnt.getNota();
			} else if(metodo.equals(ConstantsMap.contatto_data_creazione)) {
				return cnt.getData_creazione();
			} else if(metodo.equals(ConstantsMap.contatto_agente_denominazione)) {
				return cnt.getAgente_denominazione();
			} else if(metodo.equals(ConstantsMap.contatto_agente_codice)) {
				return cnt.getAgente_codice();
			} else if(metodo.equals(ConstantsMap.contatto_stato)) {
				return cnt.getTipoTesto();
			} else if(metodo.equals(ConstantsMap.contatto_id)) {
				return cnt.getId().toString();
			} else if(metodo.equals(ConstantsMap.contatto_campagna_denominazione)) {
				return cnt.getCampagna_denominazione();
			} else if(metodo.equals(ConstantsMap.contatto_lista_denominazione)) {
				return cnt.getLista_denominazione();
			} else if(metodo.equals(ConstantsMap.contatto_campagna_codice)) {
				return cnt.getCampagna_codice();
			} else if(metodo.equals(ConstantsMap.contatto_bloccato)) {
				return cnt.getBloccatoS();
			} else if(metodo.equals(ConstantsMap.contatto_lista_codice)) {
				return cnt.getLista_codice();
			} else if(metodo.equals(ConstantsMap.contatto_positivo)) {
				return cnt.getPositivo();
			} else if(metodo.equals(ConstantsMap.contatto_telefono_predefinito)) {
				return cnt.getTelefono_predefinito();
			} else if(metodo.equals(ConstantsMap.contatto_utile)) {
				return cnt.getUtile();
			} else if(metodo.equals(ConstantsMap.contatto_chiuso)) {
				return cnt.getChiuso();
			} else if(metodo.equals(ConstantsMap.anagrafica_cognome)) {
				return cnt.getAnagrafica().getCognome();
			} else if(metodo.equals(ConstantsMap.anagrafica_nome)) {
				return cnt.getAnagrafica().getNome();
			} else if(metodo.equals(ConstantsMap.anagrafica_nome_completo)) {
				return cnt.getAnagrafica().getNome_completo();
			} else if(metodo.equals(ConstantsMap.anagrafica_email)) {
				return cnt.getAnagrafica().getEmail();
			} else if(metodo.equals(ConstantsMap.anagrafica_codice_fiscale)) {
				return cnt.getAnagrafica().getCodice_fiscale();
			} else if(metodo.equals(ConstantsMap.anagrafica_sorgente)) {
				return cnt.getAnagrafica().getSorgente();
			} else if(metodo.equals(ConstantsMap.anagrafica_nota)) {
				return cnt.getAnagrafica().getNota();
			} else if(metodo.equals(ConstantsMap.anagrafica_luogo_nascita)) {
				return cnt.getAnagrafica().getLuogo_nascita();
			} else if(metodo.equals(ConstantsMap.anagrafica_data_nascita)) {
				return cnt.getAnagrafica().getDate_nascita();
			} else if(metodo.equals(ConstantsMap.anagrafica_link)) {
				return cnt.getAnagrafica().getLink();
			} else if(metodo.equals(ConstantsMap.anagrafica_data_inserimento)) {
				return cnt.getAnagrafica().getData_creazione();
			} else if(metodo.equals(ConstantsMap.anagrafica_privacy)) {
				return cnt.getAnagrafica().getPrivacy();
			} else if(metodo.equals(ConstantsMap.anagrafica_tipo)) {
				return cnt.getAnagrafica().getTipo();
			} else if(metodo.equals(ConstantsMap.anagrafica_sesso)) {
				return cnt.getAnagrafica().getSesso();
			} else if(metodo.equals(ConstantsMap.anagrafica_partita_iva)) {
				return cnt.getAnagrafica().getPartita_iva();
			} else if(metodo.equals(ConstantsMap.anagrafica_ragione_sociale)) {
				return cnt.getAnagrafica().getRagione_sociale();
			} else if(metodo.equals(ConstantsMap.anagrafica_telefono_fisso)) {
				return cnt.getAnagrafica().getTelefono_fisso();
			} else if(metodo.equals(ConstantsMap.anagrafica_telefono_altro)) {
				return cnt.getAnagrafica().getTelefono_altro();
			} else if(metodo.equals(ConstantsMap.anagrafica_telefono_mobile)) {
				return cnt.getAnagrafica().getTelefono_mobile();
			} else if(metodo.equals(ConstantsMap.anagrafica_telefono_fax)) {
				return cnt.getAnagrafica().getTelefono_fax();
			} else if(metodo.equals(ConstantsMap.anagrafica_settore)) {
				return cnt.getAnagrafica().getSettore();
			} else if(metodo.equals(ConstantsMap.anagrafica_denominazione)) {
				return cnt.getAnagrafica().getDenominazione();
			} else if(metodo.equals(ConstantsMap.anagrafica_id)) {
				return cnt.getAnagrafica().getIdentificativo();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_indirizzo_completo)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getIndirizzo_completo();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_strada_completo)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getStrada_completo();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_comune_completo)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getComune_completo();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_strada)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getStrada();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_civico)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getCivico();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_cap)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getCap();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_comune)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getComune();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_provincia)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getProvincia();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_regione)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getRegione();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_dettagli)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getDettagli();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_latitudine)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getLatitudine();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_longitudine)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getLongitudine();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_presso)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getPresso();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_indirizzo_completo)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getIndirizzo_completo();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_strada_completo)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getStrada_completo();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_comune_completo)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getComune_completo();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_strada)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getStrada();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_civico)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getCivico();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_cap)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getCap();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_comune)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getComune();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_provincia)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getProvincia();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_regione)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getRegione();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_dettagli)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getDettagli();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_latitudine)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getLatitudine();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_longitudine)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getLongitudine();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_presso)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getPresso();
			} else if(metodo.equals(ConstantsMap.consenso_tfissoS)) {
				return cnt.getAnagrafica().getConsenso_tfisso();
			} else if(metodo.equals(ConstantsMap.consenso_tmobileS)) {
				return cnt.getAnagrafica().getConsenso_tmobile();
			} else if(metodo.equals(ConstantsMap.consenso_tfaxS)) {
				return cnt.getAnagrafica().getConsenso_tfax();
			} else if(metodo.equals(ConstantsMap.consenso_taltroS)) {
				return cnt.getAnagrafica().getConsenso_taltro();
			} else if(metodo.equals(ConstantsMap.consenso_emailS)) {
				return cnt.getAnagrafica().getConsenso_email();
			} else if(metodo.equals(ConstantsMap.consenso_rmailS)) {
				return cnt.getAnagrafica().getConsenso_rmail();
			} 
		}
		return null;
	}
	@SuppressWarnings("rawtypes")
	public static Comparable comparaStoriaContatto(StoriaContatto scnt, String metodo) {
		if(metodo != null) {
			Contatto cnt = scnt.getContatto();
			if(metodo.equals(ConstantsMap.storia_contatto_data_archiviazione)) {
				return scnt.getData_archiviazione();
			} else if(metodo.equals(ConstantsMap.storia_contatto_esito_chiamata)) {
				return scnt.getEsito_chiamata();
			} else if(metodo.equals(ConstantsMap.storia_contatto_esito_archiviazione)) {
				return scnt.getEsito_archiviazione();
			} else if(metodo.equals(ConstantsMap.storia_contatto_esito_generale)) {
				return scnt.getEsito_generale();
			} else if(metodo.equals(ConstantsMap.storia_contatto_codice_chiamata)) {
				return scnt.getCodice_chiamata();
			} else if(metodo.equals(ConstantsMap.storia_contatto_codice_archiviazione)) {
				return scnt.getCodice_archiviazione();
			} else if(metodo.equals(ConstantsMap.storia_contatto_codice_generale)) {
				return scnt.getCodice_generale();
			} else if(metodo.equals(ConstantsMap.storia_contatto_operatore_denominazione)) {
				return scnt.getOperatore_denominazione();
			} else if(metodo.equals(ConstantsMap.storia_contatto_campagna_denominazione)) {
				return scnt.getCampagna_denominazione();
			} else if(metodo.equals(ConstantsMap.storia_contatto_lista_denominazione)) {
				return scnt.getLista_denominazione();
			} else if(metodo.equals(ConstantsMap.storia_contatto_campagna_codice)) {
				return scnt.getCampagna_codice();
			} else if(metodo.equals(ConstantsMap.storia_contatto_bloccato)) {
				return scnt.getBloccatoS();
			} else if(metodo.equals(ConstantsMap.storia_contatto_lista_codice)) {
				return scnt.getLista_codice();
			} else if(metodo.equals(ConstantsMap.storia_contatto_operatore_codice)) {
				return scnt.getOperatore_codice();
			} else if(metodo.equals(ConstantsMap.storia_contatto_proprietario_denominazione)) {
				return scnt.getProprietario_denominazione();
			} else if(metodo.equals(ConstantsMap.storia_contatto_proprietario_codice)) {
				return scnt.getProprietario_codice();
			} else if(metodo.equals(ConstantsMap.storia_contatto_data_presentazione)) {
				return scnt.getData_presentazione();
			} else if(metodo.equals(ConstantsMap.storia_contatto_nota)) {
				return scnt.getNota();
			} else if(metodo.equals(ConstantsMap.storia_contatto_data)) {
				return scnt.getData();
			} else if(metodo.equals(ConstantsMap.storia_contatto_agente_denominazione)) {
				return scnt.getAgente_denominazione();
			} else if(metodo.equals(ConstantsMap.storia_contatto_agente_codice)) {
				return scnt.getAgente_codice();
			} else if(metodo.equals(ConstantsMap.storia_contatto_stato)) {
				return scnt.getTipoTesto();
			} else if(metodo.equals(ConstantsMap.storia_contatto_id)) {
				return scnt.getId().toString();
			} else if(metodo.equals(ConstantsMap.storia_contatto_positivo)) {
				return scnt.getPositivo();
			} else if(metodo.equals(ConstantsMap.storia_contatto_utile)) {
				return scnt.getUtile();
			} else if(metodo.equals(ConstantsMap.storia_contatto_chiuso)) {
				return scnt.getChiuso();
			} else if(metodo.equals(ConstantsMap.storia_contatto_secondi_tot)) {
				return scnt.getSecondi_tot();
			} else if(metodo.equals(ConstantsMap.storia_contatto_secondi_totH)) {
				return scnt.getSecondi_totH();
			} else if(metodo.equals(ConstantsMap.storia_contatto_secondi_conv_eff)) {
				return scnt.getSecondi_conv_eff();
			} else if(metodo.equals(ConstantsMap.storia_contatto_secondi_conv_effH)) {
				return scnt.getSecondi_conv_effH();
			} else if(metodo.equals(ConstantsMap.storia_contatto_secondi_conv_tot)) {
				return scnt.getSecondi_conv_tot();
			} else if(metodo.equals(ConstantsMap.storia_contatto_secondi_conv_totH)) {
				return scnt.getSecondi_conv_totH();
			} else if(metodo.equals(ConstantsMap.storia_contatto_secondi_post)) {
				return scnt.getSecondi_post();
			} else if(metodo.equals(ConstantsMap.storia_contatto_secondi_postH)) {
				return scnt.getSecondi_postH();
			} else if(metodo.equals(ConstantsMap.storia_contatto_secondi_pre)) {
				return scnt.getSecondi_pre();
			} else if(metodo.equals(ConstantsMap.storia_contatto_secondi_preH)) {
				return scnt.getSecondi_preH();
			} else if(metodo.equals(ConstantsMap.storia_contatto_secondi_rec)) {
				return scnt.getSecondi_rec();
			} else if(metodo.equals(ConstantsMap.storia_contatto_secondi_recH)) {
				return scnt.getSecondi_recH();
			} else if(metodo.equals(ConstantsMap.storia_contatto_secondi_attesa)) {
				return scnt.getSecondi_attesa();
			} else if(metodo.equals(ConstantsMap.storia_contatto_secondi_attesaH)) {
				return scnt.getSecondi_attesaH();
			} else if(metodo.equals(ConstantsMap.storia_contatto_date_apertura)) {
				return scnt.getDate_apertura();
			} else if(metodo.equals(ConstantsMap.storia_contatto_date_chiamata)) {
				return scnt.getDate_chiamata();
			} else if(metodo.equals(ConstantsMap.storia_contatto_date_risposta)) {
				return scnt.getDate_risposta();
			} else if(metodo.equals(ConstantsMap.storia_contatto_date_rec_inizio)) {
				return scnt.getDate_rec_inizio();
			} else if(metodo.equals(ConstantsMap.storia_contatto_date_rec_fine)) {
				return scnt.getDate_rec_fine();
			} else if(metodo.equals(ConstantsMap.storia_contatto_date_fine)) {
				return scnt.getDate_fine();
			} else if(metodo.equals(ConstantsMap.storia_contatto_date_esito)) {
				return scnt.getDate_esito();
			} else if(metodo.equals(ConstantsMap.storia_contatto_date_attesa_inizio)) {
				return scnt.getDate_attesa_inizio();
			} else if(metodo.equals(ConstantsMap.storia_contatto_date_attesa_fine)) {
				return scnt.getDate_attesa_fine();
			} else if(metodo.equals(ConstantsMap.contatto_data_archiviazione)) {
				return cnt.getData_archiviazione();
			} else if(metodo.equals(ConstantsMap.contatto_esito_chiamata)) {
				return cnt.getEsito_chiamata();
			} else if(metodo.equals(ConstantsMap.contatto_esito_archiviazione)) {
				return cnt.getEsito_archiviazione();
			} else if(metodo.equals(ConstantsMap.contatto_esito_generale)) {
				return cnt.getEsito_generale();
			} else if(metodo.equals(ConstantsMap.contatto_codice_chiamata)) {
				return cnt.getCodice_chiamata();
			} else if(metodo.equals(ConstantsMap.contatto_codice_archiviazione)) {
				return cnt.getCodice_archiviazione();
			} else if(metodo.equals(ConstantsMap.contatto_codice_generale)) {
				return cnt.getCodice_generale();
			} else if(metodo.equals(ConstantsMap.contatto_data_lavorazione)) {
				return cnt.getData_lavorazione();
			} else if(metodo.equals(ConstantsMap.contatto_operatore_denominazione)) {
				return cnt.getOperatore_denominazione();
			} else if(metodo.equals(ConstantsMap.contatto_operatore_codice)) {
				return cnt.getOperatore_codice();
			} else if(metodo.equals(ConstantsMap.contatto_proprietario_denominazione)) {
				return cnt.getProprietario_denominazione();
			} else if(metodo.equals(ConstantsMap.contatto_proprietario_codice)) {
				return cnt.getProprietario_codice();
			} else if(metodo.equals(ConstantsMap.contatto_data_presentazione)) {
				return cnt.getData_presentazione();
			} else if(metodo.equals(ConstantsMap.contatto_nota)) {
				return cnt.getNota();
			} else if(metodo.equals(ConstantsMap.contatto_data_creazione)) {
				return cnt.getData_creazione();
			} else if(metodo.equals(ConstantsMap.contatto_agente_denominazione)) {
				return cnt.getAgente_denominazione();
			} else if(metodo.equals(ConstantsMap.contatto_agente_codice)) {
				return cnt.getAgente_codice();
			} else if(metodo.equals(ConstantsMap.contatto_stato)) {
				return cnt.getTipoTesto();
			} else if(metodo.equals(ConstantsMap.contatto_id)) {
				return cnt.getId().toString();
			} else if(metodo.equals(ConstantsMap.contatto_campagna_denominazione)) {
				return cnt.getCampagna_denominazione();
			} else if(metodo.equals(ConstantsMap.contatto_lista_denominazione)) {
				return cnt.getLista_denominazione();
			} else if(metodo.equals(ConstantsMap.contatto_campagna_codice)) {
				return cnt.getCampagna_codice();
			} else if(metodo.equals(ConstantsMap.contatto_bloccato)) {
				return cnt.getBloccatoS();
			} else if(metodo.equals(ConstantsMap.contatto_lista_codice)) {
				return cnt.getLista_codice();
			} else if(metodo.equals(ConstantsMap.contatto_positivo)) {
				return cnt.getPositivo();
			} else if(metodo.equals(ConstantsMap.contatto_telefono_predefinito)) {
				return cnt.getTelefono_predefinito();
			} else if(metodo.equals(ConstantsMap.contatto_utile)) {
				return cnt.getUtile();
			} else if(metodo.equals(ConstantsMap.contatto_chiuso)) {
				return cnt.getChiuso();
			} else if(metodo.equals(ConstantsMap.anagrafica_cognome)) {
				return cnt.getAnagrafica().getCognome();
			} else if(metodo.equals(ConstantsMap.anagrafica_nome)) {
				return cnt.getAnagrafica().getNome();
			} else if(metodo.equals(ConstantsMap.anagrafica_nome_completo)) {
				return cnt.getAnagrafica().getNome_completo();
			} else if(metodo.equals(ConstantsMap.anagrafica_email)) {
				return cnt.getAnagrafica().getEmail();
			} else if(metodo.equals(ConstantsMap.anagrafica_codice_fiscale)) {
				return cnt.getAnagrafica().getCodice_fiscale();
			} else if(metodo.equals(ConstantsMap.anagrafica_sorgente)) {
				return cnt.getAnagrafica().getSorgente();
			} else if(metodo.equals(ConstantsMap.anagrafica_nota)) {
				return cnt.getAnagrafica().getNota();
			} else if(metodo.equals(ConstantsMap.anagrafica_luogo_nascita)) {
				return cnt.getAnagrafica().getLuogo_nascita();
			} else if(metodo.equals(ConstantsMap.anagrafica_data_nascita)) {
				return cnt.getAnagrafica().getDate_nascita();
			} else if(metodo.equals(ConstantsMap.anagrafica_link)) {
				return cnt.getAnagrafica().getLink();
			} else if(metodo.equals(ConstantsMap.anagrafica_data_inserimento)) {
				return cnt.getAnagrafica().getData_creazione();
			} else if(metodo.equals(ConstantsMap.anagrafica_privacy)) {
				return cnt.getAnagrafica().getPrivacy();
			} else if(metodo.equals(ConstantsMap.anagrafica_tipo)) {
				return cnt.getAnagrafica().getTipo();
			} else if(metodo.equals(ConstantsMap.anagrafica_sesso)) {
				return cnt.getAnagrafica().getSesso();
			} else if(metodo.equals(ConstantsMap.anagrafica_partita_iva)) {
				return cnt.getAnagrafica().getPartita_iva();
			} else if(metodo.equals(ConstantsMap.anagrafica_ragione_sociale)) {
				return cnt.getAnagrafica().getRagione_sociale();
			} else if(metodo.equals(ConstantsMap.anagrafica_telefono_fisso)) {
				return cnt.getAnagrafica().getTelefono_fisso();
			} else if(metodo.equals(ConstantsMap.anagrafica_telefono_altro)) {
				return cnt.getAnagrafica().getTelefono_altro();
			} else if(metodo.equals(ConstantsMap.anagrafica_telefono_mobile)) {
				return cnt.getAnagrafica().getTelefono_mobile();
			} else if(metodo.equals(ConstantsMap.anagrafica_telefono_fax)) {
				return cnt.getAnagrafica().getTelefono_fax();
			} else if(metodo.equals(ConstantsMap.anagrafica_settore)) {
				return cnt.getAnagrafica().getSettore();
			} else if(metodo.equals(ConstantsMap.anagrafica_denominazione)) {
				return cnt.getAnagrafica().getDenominazione();
			} else if(metodo.equals(ConstantsMap.anagrafica_id)) {
				return cnt.getAnagrafica().getIdentificativo();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_indirizzo_completo)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getIndirizzo_completo();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_strada_completo)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getStrada_completo();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_comune_completo)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getComune_completo();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_strada)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getStrada();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_civico)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getCivico();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_cap)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getCap();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_comune)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getComune();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_provincia)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getProvincia();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_regione)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getRegione();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_dettagli)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getDettagli();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_latitudine)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getLatitudine();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_longitudine)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getLongitudine();
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_presso)) {
				return cnt.getAnagrafica().getIndirizzo_legale().getPresso();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_indirizzo_completo)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getIndirizzo_completo();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_strada_completo)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getStrada_completo();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_comune_completo)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getComune_completo();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_strada)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getStrada();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_civico)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getCivico();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_cap)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getCap();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_comune)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getComune();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_provincia)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getProvincia();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_regione)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getRegione();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_dettagli)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getDettagli();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_latitudine)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getLatitudine();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_longitudine)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getLongitudine();
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_presso)) {
				return cnt.getAnagrafica().getIndirizzo_operativo().getPresso();
			} else if(metodo.equals(ConstantsMap.consenso_tfissoS)) {
				return cnt.getAnagrafica().getConsenso_tfisso();
			} else if(metodo.equals(ConstantsMap.consenso_tmobileS)) {
				return cnt.getAnagrafica().getConsenso_tmobile();
			} else if(metodo.equals(ConstantsMap.consenso_tfaxS)) {
				return cnt.getAnagrafica().getConsenso_tfax();
			} else if(metodo.equals(ConstantsMap.consenso_taltroS)) {
				return cnt.getAnagrafica().getConsenso_taltro();
			} else if(metodo.equals(ConstantsMap.consenso_emailS)) {
				return cnt.getAnagrafica().getConsenso_email();
			} else if(metodo.equals(ConstantsMap.consenso_rmailS)) {
				return cnt.getAnagrafica().getConsenso_rmail();
			} 
		}
		return null;
	}
	public static Colonna importAnagrafica(Anagrafica prd, String metodo) {
		String color = "red";
		Colonna colonna = new Colonna(); 
		if(metodo != null) {
			if(metodo.equals(ConstantsMap.anagrafica_cognome)) {
				colonna.setValore(prd.getCognome());
			} else if(metodo.equals(ConstantsMap.anagrafica_nome)) {
				colonna.setValore(prd.getNome());
			} else if(metodo.equals(ConstantsMap.anagrafica_nome_completo)) {
				colonna.setValore(prd.getNome_completo());
			} else if(metodo.equals(ConstantsMap.anagrafica_email)) {
				colonna.setValore(prd.getEmail());
			} else if(metodo.equals(ConstantsMap.anagrafica_codice_fiscale)) {
				colonna.setValore(prd.getCodice_fiscale());
			} else if(metodo.equals(ConstantsMap.anagrafica_nota)) {
				colonna.setValore(prd.getNota());
			} else if(metodo.equals(ConstantsMap.anagrafica_luogo_nascita)) {
				colonna.setValore(prd.getLuogo_nascita());
			} else if(metodo.equals(ConstantsMap.anagrafica_data_nascita)) {
				colonna.setValore(ApplicationUtil.formatDate(ConstantsFormat.date.stampa(), prd.getDate_nascita()));
			} else if(metodo.equals(ConstantsMap.anagrafica_link)) {
				colonna.setValore(prd.getLink());
			} else if(metodo.equals(ConstantsMap.anagrafica_tipo)) {
				colonna.setValore(prd.getTipo());
			} else if(metodo.equals(ConstantsMap.anagrafica_sesso)) {
				colonna.setValore(prd.getSesso());
			} else if(metodo.equals(ConstantsMap.anagrafica_partita_iva)) {
				colonna.setValore(prd.getPartita_iva());
			} else if(metodo.equals(ConstantsMap.anagrafica_ragione_sociale)) {
				colonna.setValore(prd.getRagione_sociale());
			} else if(metodo.equals(ConstantsMap.anagrafica_telefono_fisso)) {
				colonna.setValore(prd.getTelefono_fisso());
			} else if(metodo.equals(ConstantsMap.anagrafica_telefono_altro)) {
				colonna.setValore(prd.getTelefono_altro());
			} else if(metodo.equals(ConstantsMap.anagrafica_telefono_mobile)) {
				colonna.setValore(prd.getTelefono_mobile());
			} else if(metodo.equals(ConstantsMap.anagrafica_telefono_fax)) {
				colonna.setValore(prd.getTelefono_fax());
			} else if(metodo.equals(ConstantsMap.anagrafica_settore)) {
				colonna.setValore(prd.getSettore());
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_strada)) {
				colonna.setValore(prd.getIndirizzo_legale().getStrada());
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_civico)) {
				colonna.setValore(prd.getIndirizzo_legale().getCivico());
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_cap)) {
				colonna.setValore(prd.getIndirizzo_legale().getCap());
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_comune)) {
				colonna.setValore(prd.getIndirizzo_legale().getComune());
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_provincia)) {
				colonna.setValore(prd.getIndirizzo_legale().getProvincia());
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_regione)) {
				colonna.setValore(prd.getIndirizzo_legale().getRegione());
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_dettagli)) {
				colonna.setValore(prd.getIndirizzo_legale().getDettagli());
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_latitudine)) {
				colonna.setValore(prd.getIndirizzo_legale().getLatitudine());
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_longitudine)) {
				colonna.setValore(prd.getIndirizzo_legale().getLongitudine());
			} else if(metodo.equals(ConstantsMap.indirizzo_legale_presso)) {
				colonna.setValore(prd.getIndirizzo_legale().getPresso());
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_strada)) {
				colonna.setValore(prd.getIndirizzo_operativo().getStrada());
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_civico)) {
				colonna.setValore(prd.getIndirizzo_operativo().getCivico());
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_cap)) {
				colonna.setValore(prd.getIndirizzo_operativo().getCap());
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_comune)) {
				colonna.setValore(prd.getIndirizzo_operativo().getComune());
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_provincia)) {
				colonna.setValore(prd.getIndirizzo_operativo().getProvincia());
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_regione)) {
				colonna.setValore(prd.getIndirizzo_operativo().getRegione());
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_dettagli)) {
				colonna.setValore(prd.getIndirizzo_operativo().getDettagli());
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_latitudine)) {
				colonna.setValore(prd.getIndirizzo_operativo().getLatitudine());
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_longitudine)) {
				colonna.setValore(prd.getIndirizzo_operativo().getLongitudine());
			} else if(metodo.equals(ConstantsMap.indirizzo_operativo_presso)) {
				colonna.setValore(prd.getIndirizzo_operativo().getPresso());
			} else if(metodo.equals(ConstantsMap.consenso_tfissoS)) {
				colonna.setColore(!prd.getConsenso_tfissoT() ? color : null);
				colonna.setValore(prd.getConsenso_tfissoS());
			} else if(metodo.equals(ConstantsMap.consenso_tmobileS)) {
				colonna.setColore(!prd.getConsenso_tmobileT() ? color : null);
				colonna.setValore(prd.getConsenso_tmobileS());
			} else if(metodo.equals(ConstantsMap.consenso_tfaxS)) {
				colonna.setColore(!prd.getConsenso_tfaxT() ? color : null);
				colonna.setValore(prd.getConsenso_tfaxS());
			} else if(metodo.equals(ConstantsMap.consenso_taltroS)) {
				colonna.setColore(!prd.getConsenso_taltroT() ? color : null);
				colonna.setValore(prd.getConsenso_taltroS());
			} else if(metodo.equals(ConstantsMap.consenso_emailS)) {
				colonna.setColore(!prd.getConsenso_emailT() ? color : null);
				colonna.setValore(prd.getConsenso_emailS());
			} else if(metodo.equals(ConstantsMap.consenso_rmailS)) {
				colonna.setColore(!prd.getConsenso_rmailT() ? color : null);
				colonna.setValore(prd.getConsenso_rmailS());
			}
		}
		return colonna;
	}
	public static Colonna importAppuntamento(Appuntamento prd, String metodo) {
		Colonna colonna = new Colonna(); 
		if(metodo != null) {
			if(metodo.equals(ConstantsMap.appuntamento_data_appuntamento)) {
				colonna.setValore(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), prd.getData_appuntamento()));
			} else if(metodo.equals(ConstantsMap.appuntamento_nota)) {
				colonna.setValore(prd.getNota());
			}  
		}
		return colonna;
	}
	
	public static Colonna importContratto(Contratto prd, String metodo) {
		Colonna colonna = new Colonna(); 
		if(metodo != null) {
			if(metodo.equals(ConstantsMap.contratto_nota)) {
				colonna.setValore(prd.getNota());
			} else if(metodo.equals(ConstantsMap.contratto_data_stipula)) {
				colonna.setValore(ApplicationUtil.formatDate(ConstantsFormat.date.stampa(),prd.getData_stipula()));
			} else if(metodo.equals(ConstantsMap.contratto_data_contabile)) {
				colonna.setValore(ApplicationUtil.formatDate(ConstantsFormat.date.stampa(),prd.getData_contabile()));
			} else if(metodo.equals(ConstantsMap.contratto_data_attivazione)) {
				colonna.setValore(ApplicationUtil.formatDate(ConstantsFormat.date.stampa(),prd.getData_attivazione()));
			} else if(metodo.equals(ConstantsMap.contratto_data_caricamento)) {
				colonna.setValore(ApplicationUtil.formatDate(ConstantsFormat.date.stampa(),prd.getData_caricamento()));
			} else if(metodo.equals(ConstantsMap.contratto_costo_scontato)) {
				colonna.setValore(ApplicationUtil.formatNumber(prd.getCosto_scontatoU()));
			} else if(metodo.equals(ConstantsMap.contratto_quantita)) {
				colonna.setValore(ApplicationUtil.formatNumber(prd.getQuantitaU()));
			}
		}
			
		return colonna;
	}
	
	public static Colonna importContatto(Contatto prd, String metodo) {
		Colonna colonna = new Colonna(); 
		if(metodo != null) {
			if(metodo.equals(ConstantsMap.contatto_nota)) {
				colonna.setValore(prd.getNota());
			}
			if(metodo.equals(ConstantsMap.consenso_tfissoS)) {
				colonna.setValore(prd.getAnagrafica().getConsenso_tfissoS());
			}
			if(metodo.equals(ConstantsMap.consenso_tmobileS)) {
				colonna.setValore(prd.getAnagrafica().getConsenso_tmobileS());
			}
			if(metodo.equals(ConstantsMap.consenso_tfaxS)) {
				colonna.setValore(prd.getAnagrafica().getConsenso_tfaxS());
			}
			if(metodo.equals(ConstantsMap.consenso_taltroS)) {
				colonna.setValore(prd.getAnagrafica().getConsenso_taltroS());
			}
			if(metodo.equals(ConstantsMap.consenso_emailS)) {
				colonna.setValore(prd.getAnagrafica().getConsenso_emailS());
			}
			if(metodo.equals(ConstantsMap.consenso_rmailS)) {
				colonna.setValore(prd.getAnagrafica().getConsenso_rmailS());
			}
		}
		return colonna;
	}
	
	public static Colonna importOpposizione(Opposizione prd, String metodo) {
		Colonna colonna = new Colonna(); 
		if(metodo != null) {
			if(metodo.equals(ConstantsMap.opposizione_descrizione)) {
				colonna.setValore(prd.getDescrizione());
			} else if(metodo.equals(ConstantsMap.opposizione_segnalazione)) {
				colonna.setValore(prd.getOpposizione());
			} 
		}
			
		return colonna;
	}
	
}