package it.callite.utility;
import java.io.OutputStream;
import java.util.ArrayList;
import java.util.List;
import java.util.concurrent.CopyOnWriteArrayList;

import org.apache.commons.collections4.ListUtils;

import com.itextpdf.text.BaseColor;
import com.itextpdf.text.Document;
import com.itextpdf.text.Element;
import com.itextpdf.text.Font;
import com.itextpdf.text.PageSize;
import com.itextpdf.text.Paragraph;
import com.itextpdf.text.Phrase;
import com.itextpdf.text.pdf.PdfPCell;
import com.itextpdf.text.pdf.PdfPTable;

import it.callite.constants.ConstantsFormat;
import it.callite.constants.ConstantsLanguage;
import it.callite.constants.ConstantsMap;
import it.callite.dao.AnagraficaDao;
import it.callite.message.Message;
import it.callite.model.Accesso;
import it.callite.model.Acconto;
import it.callite.model.Agente;
import it.callite.model.Anagrafica;
import it.callite.model.Appuntamento;
import it.callite.model.AutoContatto;
import it.callite.model.CampoAggiuntivoAnagrafica;
import it.callite.model.CampoAggiuntivoContratto;
import it.callite.model.Contatto;
import it.callite.model.Contratto;
import it.callite.model.DatoAggiuntivoAnagrafica;
import it.callite.model.DatoAggiuntivoContratto;
import it.callite.model.Email;
import it.callite.model.Estratto;
import it.callite.model.EstrattoDettaglio;
import it.callite.model.Rmail;
import it.callite.model.Marcatura;
import it.callite.model.Nota;
import it.callite.model.Notifica;
import it.callite.model.Operazione;
import it.callite.model.Opposizione;
import it.callite.model.Pausa;
import it.callite.model.Prenotazione;
import it.callite.model.Ricezione;
import it.callite.model.Sondaggio;
import it.callite.model.StoriaAppuntamento;
import it.callite.model.StoriaContatto;
import it.callite.model.StoriaContratto;
import it.callite.model.Telecom;
import it.callite.model.TemplateExportAnagrafica;
import it.callite.model.TemplateExportAppuntamento;
import it.callite.model.TemplateExportContatto;
import it.callite.model.TemplateExportContratto;
import it.callite.model.TemplateExportStoriaAppuntamento;
import it.callite.model.TemplateExportStoriaContatto;
import it.callite.model.TemplateExportStoriaContratto;
import it.callite.model.Utente;
import it.callite.model.Webhook;
import it.callite.model.sip.Cdr;
import it.callite.model.sip.Cel;
import it.callite.utility.item.ContattoSI;
public class PDFWriter {
	private static Font title  = new Font(Font.FontFamily.TIMES_ROMAN, 12, Font.BOLD,   BaseColor.BLACK);
	private static Font header = new Font(Font.FontFamily.TIMES_ROMAN, 10, Font.BOLD,   BaseColor.BLACK);
	private static Font normal = new Font(Font.FontFamily.TIMES_ROMAN, 10, Font.NORMAL, BaseColor.BLACK);
	private static final String AUTHOR = "";
	private static final String CREATOR = "";
	private static final String SPACE = " ";
	
	public static void stampaPDFUser(List<Utente> dettagli, OutputStream out, String password) {
		String [] titles = new ExportUtility().titlesUser;
		try {
			Document document = new Document(ApplicationUtil.pageSize(titles.length));
			ApplicationUtil.passwordPDF(document, out, password);
			document.open();
			document.addTitle(ConstantsLanguage.UTENTI.stampa());
			document.addSubject(ConstantsLanguage.UTENTI.stampa());
			document.addKeywords(ConstantsLanguage.UTENTI.stampa());
			document.addAuthor(AUTHOR);
			document.addCreator(CREATOR);
			Paragraph preface = new Paragraph("");
			preface.add(new Paragraph(ConstantsLanguage.TOTALE.stampa() + " " + ConstantsLanguage.UTENTI.stampa() + ": " + ApplicationUtil.formatNumber(dettagli.size()),title));
			preface.add(new Paragraph(SPACE));
			document.add(preface);
			PdfPTable table = new PdfPTable(titles.length);
			table.setWidthPercentage(100);
			for(String tt : titles) {
				PdfPCell c = new PdfPCell(new Phrase(tt, header));
				c.setHorizontalAlignment(Element.ALIGN_LEFT);
				c.setBackgroundColor(BaseColor.YELLOW);
				table.addCell(c);
			}
			table.setHeaderRows(1);
			for(Utente prd : dettagli) {
				table.addCell(new Phrase(prd.getId().toString(), normal));
				table.addCell(new Phrase(prd.getDenominazione(), normal));
				table.addCell(new Phrase(prd.getCognome(), normal));
				table.addCell(new Phrase(prd.getNome(), normal));
				table.addCell(new Phrase(prd.getEmail(), normal));
				table.addCell(new Phrase(prd.getUsername(), normal));
				table.addCell(new Phrase(prd.getInternoString(), normal));
				table.addCell(new Phrase(prd.getEnabledString(), normal));
				table.addCell(new Phrase(prd.getCambioPasswordString(), normal));
				table.addCell(new Phrase(prd.getGeneraEstrattoString(), normal));
			}
			document.add(table);
			document.close();
		} catch (Exception e) {
		}
	}
	public static void stampaPDFEstratto(List<Estratto> dettagli, OutputStream out, String password) {
		String [] titles = new ExportUtility().titlesEstratto;
		try {
			Document document = new Document(ApplicationUtil.pageSize(titles.length));
			ApplicationUtil.passwordPDF(document, out, password);
			document.open();
			document.addTitle(ConstantsLanguage.ESTRATTI.stampa());
			document.addSubject(ConstantsLanguage.ESTRATTI.stampa());
			document.addKeywords(ConstantsLanguage.ESTRATTI.stampa());
			document.addAuthor(AUTHOR);
			document.addCreator(CREATOR);
			Paragraph preface = new Paragraph("");
			preface.add(new Paragraph(ConstantsLanguage.TOTALE.stampa() + " " + ConstantsLanguage.ESTRATTI.stampa() + ": " + ApplicationUtil.formatNumber(dettagli.size()),title));
			preface.add(new Paragraph(SPACE));
			document.add(preface);
			PdfPTable table = new PdfPTable(titles.length);
			table.setWidthPercentage(100);
			for(String tt : titles) {
				PdfPCell c = new PdfPCell(new Phrase(tt, header));
				c.setHorizontalAlignment(Element.ALIGN_LEFT);
				c.setBackgroundColor(BaseColor.YELLOW);
				table.addCell(c);
			}
			table.setHeaderRows(1);
			for(Estratto prd : dettagli) {
				table.addCell(new Phrase(prd.getId().toString(), normal));
				table.addCell(new Phrase(prd.getUser().getDenominazione(), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), prd.getData_creazione()), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), prd.getData_estratto()), normal));
				table.addCell(new Phrase(ApplicationUtil.formatNumber(prd.getTotale()), normal));
				table.addCell(new Phrase(ApplicationUtil.formatNumber(prd.getNdettagli()), normal));
			}
			document.add(table);
			document.close();
		} catch (Exception e) {
		}
	}
	
	
	public static void stampaPDFEstrattoAnteprima(List<Estratto> dettagli, OutputStream out, String password) {
		String [] titles = new ExportUtility().titlesEstrattoA;
		try {
			Document document = new Document(ApplicationUtil.pageSize(titles.length));
			ApplicationUtil.passwordPDF(document, out, password);
			document.open();
			document.addTitle(ConstantsLanguage.ESTRATTI.stampa());
			document.addSubject(ConstantsLanguage.ESTRATTI.stampa());
			document.addKeywords(ConstantsLanguage.ESTRATTI.stampa());
			document.addAuthor(AUTHOR);
			document.addCreator(CREATOR);
			Paragraph preface = new Paragraph("");
			preface.add(new Paragraph(ConstantsLanguage.TOTALE.stampa() + " " + ConstantsLanguage.ESTRATTI.stampa() + ": " + ApplicationUtil.formatNumber(dettagli.size()),title));
			preface.add(new Paragraph(SPACE));
			document.add(preface);
			PdfPTable table = new PdfPTable(titles.length);
			table.setWidthPercentage(100);
			for(String tt : titles) {
				PdfPCell c = new PdfPCell(new Phrase(tt, header));
				c.setHorizontalAlignment(Element.ALIGN_LEFT);
				c.setBackgroundColor(BaseColor.YELLOW);
				table.addCell(c);
			}
			table.setHeaderRows(1);
			for(Estratto prd : dettagli) {
				table.addCell(new Phrase(prd.getUser().getDenominazione(), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), prd.getData_creazione()), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), prd.getData_estratto()), normal));
				table.addCell(new Phrase(ApplicationUtil.formatNumber(prd.getTotale()), normal));
				table.addCell(new Phrase(ApplicationUtil.formatNumber(prd.getNdettagli()), normal));
			}
			document.add(table);
			document.close();
		} catch (Exception e) {
		}
	}
	public static void stampaPDFAcconto(List<Acconto> dettagli, OutputStream out, String password) {
		String [] titles = new ExportUtility().titlesAcconto;
		try {
			Document document = new Document(ApplicationUtil.pageSize(titles.length));
			ApplicationUtil.passwordPDF(document, out, password);
			document.open();
			document.addTitle(ConstantsLanguage.ACCONTI.stampa());
			document.addSubject(ConstantsLanguage.ACCONTI.stampa());
			document.addKeywords(ConstantsLanguage.ACCONTI.stampa());
			document.addAuthor(AUTHOR);
			document.addCreator(CREATOR);
			Paragraph preface = new Paragraph("");
			preface.add(new Paragraph(ConstantsLanguage.TOTALE.stampa() + " " + ConstantsLanguage.ACCONTI.stampa() + ": " + ApplicationUtil.formatNumber(dettagli.size()),title));
			preface.add(new Paragraph(SPACE));
			document.add(preface);
			PdfPTable table = new PdfPTable(titles.length);
			table.setWidthPercentage(100);
			for(String tt : titles) {
				PdfPCell c = new PdfPCell(new Phrase(tt, header));
				c.setHorizontalAlignment(Element.ALIGN_LEFT);
				c.setBackgroundColor(BaseColor.YELLOW);
				table.addCell(c);
			}
			table.setHeaderRows(1);
			for(Acconto prd : dettagli) {
				table.addCell(new Phrase(prd.getId().toString(), normal));
				table.addCell(new Phrase(prd.getUser().getDenominazione(), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), prd.getData_creazione()), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), prd.getData_acconto()), normal));
				table.addCell(new Phrase(prd.getDescrizione(), normal));
				table.addCell(new Phrase(ApplicationUtil.formatNumber(prd.getImporto()), normal));
				table.addCell(new Phrase(prd.getTipoTesto(), normal));
			}
			document.add(table);
			document.close();
		} catch (Exception e) {
		}
	}
	public static void stampaPDFDettagli(List<EstrattoDettaglio> dettagli, OutputStream out, String password) {
		String [] titles = new ExportUtility().titlesEstrattoDettaglio;
		try {
			Document document = new Document(ApplicationUtil.pageSize(titles.length));
			ApplicationUtil.passwordPDF(document, out, password);
			document.open();
			document.addTitle(ConstantsLanguage.ESTRATTI_DETTAGLIO.stampa());
			document.addSubject( ConstantsLanguage.ESTRATTI_DETTAGLIO.stampa());
			document.addKeywords(ConstantsLanguage.ESTRATTI_DETTAGLIO.stampa());
			document.addAuthor(AUTHOR);
			document.addCreator(CREATOR);
			Paragraph preface = new Paragraph("");
			preface.add(new Paragraph(ConstantsLanguage.TOTALE.stampa() + " " + ConstantsLanguage.ESTRATTI_DETTAGLIO.stampa() + ": " + ApplicationUtil.formatNumber(dettagli.size()),title));
			preface.add(new Paragraph(SPACE));
			document.add(preface);
			PdfPTable table = new PdfPTable(titles.length);
			table.setWidthPercentage(100);
			for(String tt : titles) {
				PdfPCell c = new PdfPCell(new Phrase(tt, header));
				c.setHorizontalAlignment(Element.ALIGN_LEFT);
				c.setBackgroundColor(BaseColor.YELLOW);
				table.addCell(c);
			}
			table.setHeaderRows(1);
			for(EstrattoDettaglio prd : dettagli) {
				table.addCell(new Phrase(prd.getId().toString(), normal));
				table.addCell(new Phrase(prd.getDescrizione(), normal));
				table.addCell(new Phrase(ApplicationUtil.formatNumber(prd.getGettone()), normal));
				table.addCell(new Phrase(ApplicationUtil.formatNumber(prd.getValore()), normal));
				table.addCell(new Phrase(ApplicationUtil.formatNumber(prd.getImporto()), normal));
			}
			document.add(table);
			document.close();
		} catch (Exception e) {
		}
	}
	
	public static void stampaPDFDettagliAnteprima(List<EstrattoDettaglio> dettagli, OutputStream out, String password) {
		String [] titles = new ExportUtility().titlesEstrattoDettaglioA;
		try {
			Document document = new Document(ApplicationUtil.pageSize(titles.length));
			ApplicationUtil.passwordPDF(document, out, password);
			document.open();
			document.addTitle(ConstantsLanguage.ESTRATTI_DETTAGLIO.stampa());
			document.addSubject( ConstantsLanguage.ESTRATTI_DETTAGLIO.stampa());
			document.addKeywords(ConstantsLanguage.ESTRATTI_DETTAGLIO.stampa());
			document.addAuthor(AUTHOR);
			document.addCreator(CREATOR);
			Paragraph preface = new Paragraph("");
			preface.add(new Paragraph(ConstantsLanguage.TOTALE.stampa() + " " + ConstantsLanguage.ESTRATTI_DETTAGLIO.stampa() + ": " + ApplicationUtil.formatNumber(dettagli.size()),title));
			preface.add(new Paragraph(SPACE));
			document.add(preface);
			PdfPTable table = new PdfPTable(titles.length);
			table.setWidthPercentage(100);
			for(String tt : titles) {
				PdfPCell c = new PdfPCell(new Phrase(tt, header));
				c.setHorizontalAlignment(Element.ALIGN_LEFT);
				c.setBackgroundColor(BaseColor.YELLOW);
				table.addCell(c);
			}
			table.setHeaderRows(1);
			for(EstrattoDettaglio prd : dettagli) {
				table.addCell(new Phrase(prd.getDescrizione(), normal));
				table.addCell(new Phrase(ApplicationUtil.formatNumber(prd.getGettone()), normal));
				table.addCell(new Phrase(ApplicationUtil.formatNumber(prd.getValore()), normal));
				table.addCell(new Phrase(ApplicationUtil.formatNumber(prd.getImporto()), normal));
			}
			document.add(table);
			document.close();
		} catch (Exception e) {
		}
	}
	public static void stampaPDFContatto(List<Contatto>  dettagli, OutputStream out, String password) {
		String [] titles = new ExportUtility().titlesContatto;
		try {
			Document document = new Document(ApplicationUtil.pageSize(titles.length));
			ApplicationUtil.passwordPDF(document, out, password);
			document.open();
			document.addTitle(ConstantsLanguage.CONTATTI.stampa());
			document.addSubject( ConstantsLanguage.CONTATTI.stampa());
			document.addKeywords(ConstantsLanguage.CONTRATTI.stampa());
			document.addAuthor(AUTHOR);
			document.addCreator(CREATOR);
			Paragraph preface = new Paragraph("");
			preface.add(new Paragraph(ConstantsLanguage.TOTALE.stampa() + " " + ConstantsLanguage.CONTATTI.stampa() + ": " + ApplicationUtil.formatNumber(dettagli.size()) , title));
			preface.add(new Paragraph(SPACE));
			document.add(preface);
			PdfPTable table = new PdfPTable(titles.length);
			table.setWidthPercentage(100);
			for(String tt : titles) {
				PdfPCell c = new PdfPCell(new Phrase(tt, header));
				c.setHorizontalAlignment(Element.ALIGN_LEFT);
				c.setBackgroundColor(BaseColor.YELLOW);
				table.addCell(c);
			}
			table.setHeaderRows(1);
			for(Contatto prd : dettagli) {
				table.addCell(new Phrase(prd.getId().toString(), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), prd.getData_creazione()), normal));
				table.addCell(new Phrase(prd.getBloccatoS(), normal));
				table.addCell(new Phrase(prd.getCampagna_denominazione(), normal));
				table.addCell(new Phrase(prd.getLista_denominazione(), normal));
				table.addCell(new Phrase(prd.getAnagrafica().getDenominazione(), normal));
				table.addCell(new Phrase(prd.getAnagrafica().getCognome(), normal));
				table.addCell(new Phrase(prd.getAnagrafica().getNome(), normal));
				table.addCell(new Phrase(prd.getAnagrafica().getEmail(), normal));
				table.addCell(new Phrase(prd.getAnagrafica().getLink(), normal));
				table.addCell(new Phrase(prd.getAnagrafica().getCodice_fiscale(), normal));
				table.addCell(new Phrase(prd.getAnagrafica().getPartita_iva(), normal));
				table.addCell(new Phrase(prd.getAnagrafica().getTelefono_fisso(), normal));
				table.addCell(new Phrase(prd.getAnagrafica().getTelefono_mobile(), normal));
				table.addCell(new Phrase(prd.getAnagrafica().getTelefono_fax(), normal));
				table.addCell(new Phrase(prd.getAnagrafica().getTelefono_altro(), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), prd.getData_archiviazione()), normal));
				table.addCell(new Phrase(prd.getEsito_chiamata_etichettaCodice(), normal));
				table.addCell(new Phrase(prd.getEsito_archiviazione_etichettaCodice(), normal));
				table.addCell(new Phrase(prd.getPositivo(), normal));
				table.addCell(new Phrase(prd.getUtile(), normal));
				table.addCell(new Phrase(prd.getChiuso(), normal));
				table.addCell(new Phrase(prd.getProprietario_denominazione(), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), prd.getData_presentazione()), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), prd.getData_lavorazione()), normal));
				table.addCell(new Phrase(prd.getOperatore_denominazione(), normal));
				table.addCell(new Phrase(prd.getNota(), normal));
				table.addCell(new Phrase(prd.getAgente_denominazione(), normal));
				table.addCell(new Phrase(prd.getTipoTesto(), normal));
				table.addCell(new Phrase(prd.getAnagrafica().getIndirizzo_legale().getIndirizzo_completo(), normal));
				table.addCell(new Phrase(prd.getAnagrafica().getIndirizzo_operativo().getIndirizzo_completo(), normal));
			}
			document.add(table);
			document.close();
		} catch (Exception e) {
		}
	}
	public static void stampaPDFAnagrafica(List<Anagrafica> dettagli, OutputStream out, String password) {
		String [] titles = new ExportUtility().titlesAnagrafica;
		try {
			Document document = new Document(ApplicationUtil.pageSize(titles.length));
			ApplicationUtil.passwordPDF(document, out, password);
			document.open();
			document.addTitle(ConstantsLanguage.ANAGRAFICHE.stampa());
			document.addSubject( ConstantsLanguage.ANAGRAFICHE.stampa());
			document.addKeywords(ConstantsLanguage.ANAGRAFICHE.stampa());
			document.addAuthor(AUTHOR);
			document.addCreator(CREATOR);
			Paragraph preface = new Paragraph("");
			preface.add(new Paragraph(ConstantsLanguage.TOTALE.stampa() + " " + ConstantsLanguage.ANAGRAFICHE.stampa() + ": " + ApplicationUtil.formatNumber(dettagli.size()), title));
			preface.add(new Paragraph(SPACE));
			document.add(preface);
			PdfPTable table = new PdfPTable(titles.length);
			table.setWidthPercentage(100);
			for(String tt : titles) {
				PdfPCell c = new PdfPCell(new Phrase(tt, header));
				c.setHorizontalAlignment(Element.ALIGN_LEFT);
				c.setBackgroundColor(BaseColor.YELLOW);
				table.addCell(c);
			}
			table.setHeaderRows(1);
			for(Anagrafica prd : dettagli) {
				table.addCell(new Phrase(prd.getId() != null ? prd.getId().toString() : "", normal));
				table.addCell(new Phrase(prd.getDenominazione(), normal));
				table.addCell(new Phrase(prd.getCognome(), normal));
				table.addCell(new Phrase(prd.getNome(), normal));
				table.addCell(new Phrase(prd.getEmail(), normal));
				table.addCell(new Phrase(prd.getLink(),normal));
				table.addCell(new Phrase(prd.getCodice_fiscale(),normal));
				table.addCell(new Phrase(prd.getPartita_iva(),normal));
				table.addCell(new Phrase(prd.getTelefono_fax(),normal));
				table.addCell(new Phrase(prd.getTelefono_fisso(), normal));
				table.addCell(new Phrase(prd.getTelefono_mobile(),normal));
				table.addCell(new Phrase(prd.getTelefono_altro(), normal));
				table.addCell(new Phrase(prd.getRagione_sociale(), normal));
				table.addCell(new Phrase(prd.getNome_completo(), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.date.stampa(), prd.getDate_nascita()), normal));
				table.addCell(new Phrase(prd.getLuogo_nascita(), normal));
				table.addCell(new Phrase(prd.getTipo(), normal));
				table.addCell(new Phrase(prd.getSesso(), normal));
				table.addCell(new Phrase(prd.getNota(), normal));
				table.addCell(new Phrase(prd.getSettore(), normal));
				table.addCell(new Phrase(prd.getConsenso_tfissoS(), normal));
				table.addCell(new Phrase(prd.getConsenso_tmobileS(), normal));
				table.addCell(new Phrase(prd.getConsenso_tfaxS(), normal));
				table.addCell(new Phrase(prd.getConsenso_taltroS(), normal));
				table.addCell(new Phrase(prd.getConsenso_emailS(), normal));
				table.addCell(new Phrase(prd.getConsenso_rmailS(), normal));
				table.addCell(new Phrase(prd.getIndirizzo_legale().getIndirizzo_completo(), normal));
				table.addCell(new Phrase(prd.getIndirizzo_operativo().getIndirizzo_completo(), normal));
			}
			document.add(table);
			document.close();
		} catch (Exception e) {
		}
	}
	public static void stampaPDFPrenotazione(List<Prenotazione> dettagli, OutputStream out, String password) {
		String [] titles = new ExportUtility().titlesPrenotazione;
		try {
			Document document = new Document(ApplicationUtil.pageSize(titles.length));
			ApplicationUtil.passwordPDF(document, out, password);
			document.open();
			document.addTitle(ConstantsLanguage.PRENOTAZIONI.stampa());
			document.addSubject( ConstantsLanguage.PRENOTAZIONI.stampa());
			document.addKeywords(ConstantsLanguage.PRENOTAZIONI.stampa());
			document.addAuthor(AUTHOR);
			document.addCreator(CREATOR);
			Paragraph preface = new Paragraph("");
			preface.add(new Paragraph(ConstantsLanguage.TOTALE.stampa() + " " + ConstantsLanguage.PRENOTAZIONI.stampa() + ": " + ApplicationUtil.formatNumber(dettagli.size()), title));
			preface.add(new Paragraph(SPACE));
			document.add(preface);
			PdfPTable table = new PdfPTable(titles.length);
			table.setWidthPercentage(100);
			for(String tt : titles) {
				PdfPCell c = new PdfPCell(new Phrase(tt, header));
				c.setHorizontalAlignment(Element.ALIGN_LEFT);
				c.setBackgroundColor(BaseColor.YELLOW);
				table.addCell(c);
			}
			table.setHeaderRows(1);
			for(Prenotazione prd : dettagli) {
				table.addCell(new Phrase(prd.getId().toString(), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), prd.getData_creazione()), normal));
				table.addCell(new Phrase(prd.getBloccatoS(), normal));
				table.addCell(new Phrase(prd.getCampagna_denominazione(), normal));
				table.addCell(new Phrase(prd.getLista_denominazione(), normal));
				table.addCell(new Phrase(prd.getOperatore().getDenominazione(), normal));
				table.addCell(new Phrase(prd.getAgente_denominazione(), normal));
				table.addCell(new Phrase(prd.getStatoString(), normal));
				table.addCell(new Phrase(prd.getTipo_telefonoString(), normal));
				table.addCell(new Phrase(prd.getTelefono(), normal));
			}
			document.add(table);
			document.close();
		} catch (Exception e) {
		}
	}
	public static void stampaPDFOpposizione(List<Opposizione> dettagli, OutputStream out, String password) {
		String [] titles = new ExportUtility().titlesOpposizione;
		try {
			Document document = new Document(ApplicationUtil.pageSize(titles.length));
			ApplicationUtil.passwordPDF(document, out, password);
			document.open();
			document.addTitle(ConstantsLanguage.OPPOSIZIONI.stampa());
			document.addSubject( ConstantsLanguage.OPPOSIZIONI.stampa());
			document.addKeywords(ConstantsLanguage.OPPOSIZIONI.stampa());
			document.addAuthor(AUTHOR);
			document.addCreator(CREATOR);
			Paragraph preface = new Paragraph("");
			preface.add(new Paragraph(ConstantsLanguage.TOTALE.stampa() + " " + ConstantsLanguage.OPPOSIZIONI.stampa() + ": " + ApplicationUtil.formatNumber(dettagli.size()), title));
			preface.add(new Paragraph(SPACE));
			document.add(preface);
			PdfPTable table = new PdfPTable(titles.length);
			table.setWidthPercentage(100);
			for(String tt : titles) {
				PdfPCell c = new PdfPCell(new Phrase(tt, header));
				c.setHorizontalAlignment(Element.ALIGN_LEFT);
				c.setBackgroundColor(BaseColor.YELLOW);
				table.addCell(c);
			}
			table.setHeaderRows(1);
			for(Opposizione prd : dettagli) {
				table.addCell(new Phrase(prd.getId().toString(), normal));
				table.addCell(new Phrase(prd.getUtente_denominazione(), normal));
				table.addCell(new Phrase(prd.getCampagna_denominazione(), normal));
				table.addCell(new Phrase(prd.getDescrizione(), normal));
				table.addCell(new Phrase(prd.getOpposizione(), normal));
			}
			document.add(table);
			document.close();
		} catch (Exception e) {
		}
	}
	public static void stampaPDFAppuntamento(List<Appuntamento>  dettagli, OutputStream out, String password) {
		String [] titles = new ExportUtility().titlesAppuntamento;
		try {
			Document document = new Document(ApplicationUtil.pageSize(titles.length));
			ApplicationUtil.passwordPDF(document, out, password);
			document.open();
			document.addTitle(ConstantsLanguage.APPUNTAMENTI.stampa());
			document.addSubject( ConstantsLanguage.APPUNTAMENTI.stampa());
			document.addKeywords(ConstantsLanguage.APPUNTAMENTI.stampa());
			document.addAuthor(AUTHOR);
			document.addCreator(CREATOR);
			Paragraph preface = new Paragraph("");
			preface.add(new Paragraph(ConstantsLanguage.TOTALE.stampa() + " " + ConstantsLanguage.APPUNTAMENTI.stampa() + ": " + ApplicationUtil.formatNumber(dettagli.size()) , title));
			preface.add(new Paragraph(SPACE));
			document.add(preface);
			PdfPTable table = new PdfPTable(titles.length);
			table.setWidthPercentage(100);
			for(String tt : titles) {
				PdfPCell c = new PdfPCell(new Phrase(tt, header));
				c.setHorizontalAlignment(Element.ALIGN_LEFT);
				c.setBackgroundColor(BaseColor.YELLOW);
				table.addCell(c);
			}
			table.setHeaderRows(1);
			for(Appuntamento prd : dettagli) {
				table.addCell(new Phrase(prd.getId().toString(), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), prd.getData_creazione()), normal));
				table.addCell(new Phrase(prd.getBloccatoS(), normal));
				table.addCell(new Phrase(prd.getContatto().getCampagna_denominazione(), normal));
				table.addCell(new Phrase(prd.getContatto().getLista_denominazione(), normal));
				table.addCell(new Phrase(prd.getContatto().getAnagrafica().getDenominazione(), normal));
				table.addCell(new Phrase(prd.getContatto().getAnagrafica().getCognome(), normal));
				table.addCell(new Phrase(prd.getContatto().getAnagrafica().getNome(), normal));
				table.addCell(new Phrase(prd.getContatto().getAnagrafica().getEmail(), normal));
				table.addCell(new Phrase(prd.getContatto().getAnagrafica().getLink(), normal));
				table.addCell(new Phrase(prd.getContatto().getAnagrafica().getCodice_fiscale(), normal));
				table.addCell(new Phrase(prd.getContatto().getAnagrafica().getPartita_iva(), normal));
				table.addCell(new Phrase(prd.getContatto().getAnagrafica().getTelefono_fisso(), normal));
				table.addCell(new Phrase(prd.getContatto().getAnagrafica().getTelefono_mobile(), normal));
				table.addCell(new Phrase(prd.getContatto().getAnagrafica().getTelefono_fax(), normal));
				table.addCell(new Phrase(prd.getContatto().getAnagrafica().getTelefono_altro(), normal));
				table.addCell(new Phrase(prd.getOperatore_denominazione(), normal));
				table.addCell(new Phrase(prd.getAgente_denominazione(), normal));
				table.addCell(new Phrase(prd.getNota(), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.date.stampa(), prd.getData_inizio()), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.time.stampa(), prd.getData_inizio()), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.time.stampa(), prd.getData_fine()), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), prd.getData_conferma()), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), prd.getData_lavorazione()), normal));
				table.addCell(new Phrase(prd.getUtente_denominazione(), normal));
				table.addCell(new Phrase(prd.getEsitoEtichettaCodice(), normal));
				table.addCell(new Phrase(prd.getStatoTesto(), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), prd.getData_esito()), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), prd.getData_stato()), normal));
				table.addCell(new Phrase(prd.getLocalizzazioneString(), normal));
				table.addCell(new Phrase(prd.getContatto().getAnagrafica().getIndirizzo_legale().getIndirizzo_completo(), normal));
				table.addCell(new Phrase(prd.getContatto().getAnagrafica().getIndirizzo_operativo().getIndirizzo_completo(), normal));
			}
			document.add(table);
			document.close();
		} catch (Exception e) {
		}
	}
	public static void stampaPDFAgente(List<Agente> dettagli, OutputStream out, String password) {
		String [] titles = new ExportUtility().titlesAgente;
		try {
			Document document = new Document(ApplicationUtil.pageSize(titles.length));
			ApplicationUtil.passwordPDF(document, out, password);
			document.open();
			document.addTitle(ConstantsLanguage.AGENTI.stampa());
			document.addSubject( ConstantsLanguage.AGENTI.stampa());
			document.addKeywords(ConstantsLanguage.AGENTI.stampa());
			document.addAuthor(AUTHOR);
			document.addCreator(CREATOR);
			Paragraph preface = new Paragraph("");
			preface.add(new Paragraph(ConstantsLanguage.TOTALE.stampa() + " " + ConstantsLanguage.AGENTI.stampa() + ": " + ApplicationUtil.formatNumber(dettagli.size()), title));
			preface.add(new Paragraph(SPACE));
			document.add(preface);
			PdfPTable table = new PdfPTable(titles.length);
			table.setWidthPercentage(100);
			for(String tt : titles) {
				PdfPCell c = new PdfPCell(new Phrase(tt, header));
				c.setHorizontalAlignment(Element.ALIGN_LEFT);
				c.setBackgroundColor(BaseColor.YELLOW);
				table.addCell(c);
			}
			table.setHeaderRows(1);
			for(Agente prd : dettagli) {
				table.addCell(new Phrase(prd.getId().toString(), normal));
				table.addCell(new Phrase(prd.getDenominazione(), normal));
				table.addCell(new Phrase(prd.getCodice(), normal));
				table.addCell(new Phrase(prd.getUfficioNome(), normal));
				table.addCell(new Phrase(prd.getQualificaNome(), normal));
				table.addCell(new Phrase(prd.getCognome(), normal));
				table.addCell(new Phrase(prd.getNome(), normal));
				table.addCell(new Phrase(prd.getEmail(), normal));
				table.addCell(new Phrase(prd.getLink(),normal));
				table.addCell(new Phrase(prd.getCodice_fiscale(),normal));
				table.addCell(new Phrase(prd.getPartita_iva(),normal));
				table.addCell(new Phrase(prd.getTelefono_fax(),normal));
				table.addCell(new Phrase(prd.getTelefono_fisso(), normal));
				table.addCell(new Phrase(prd.getTelefono_mobile(),normal));
				table.addCell(new Phrase(prd.getTelefono_altro(), normal));
				table.addCell(new Phrase(prd.getRagione_sociale(), normal));
				table.addCell(new Phrase(prd.getNome_completo(), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.date.stampa(), prd.getDate_nascita()), normal));
				table.addCell(new Phrase(prd.getLuogo_nascita(), normal));
				table.addCell(new Phrase(prd.getTipo(), normal));
				table.addCell(new Phrase(prd.getSesso(), normal));
				table.addCell(new Phrase(prd.getIndirizzo_legale().getIndirizzo_completo(), normal));
				table.addCell(new Phrase(prd.getIndirizzo_operativo().getIndirizzo_completo(), normal));
			}
			document.add(table);
			document.close();
		} catch (Exception e) {
		}
	}
	public static void stampaPDFAnagrafica(List<Anagrafica>  data, OutputStream out, List<Long> campis, AnagraficaDao anagraficaDao, String password) {
		String [] titles = new ExportUtility().titlesAnagrafica;
		try {
			if(ApplicationUtil.empty(campis)) {
				campis = new ArrayList<Long>();
			}
			Long [] campiChiave = new Long[campis.size()];
			String [] campiEtichette = new String[campis.size()];
			for (int i = 0; i < campis.size(); i++) {
				campiChiave[i] = campis.get(i);
				campiEtichette[i] = anagraficaDao.getEtichettaById(CampoAggiuntivoAnagrafica.class, campis.get(i));
			}	
			if(ApplicationUtil.notEmpty(campiChiave)) {
				data = anagraficaDao.loadFullAnagrafica(data);
			}
			Document document = new Document(ApplicationUtil.pageSize(titles.length+campiChiave.length));
			ApplicationUtil.passwordPDF(document, out, password);
			document.open();
			document.addTitle(ConstantsLanguage.ANAGRAFICHE.stampa());
			document.addSubject( ConstantsLanguage.ANAGRAFICHE.stampa());
			document.addKeywords(ConstantsLanguage.ANAGRAFICHE.stampa());
			document.addAuthor(AUTHOR);
			document.addCreator(CREATOR);
			Paragraph preface = new Paragraph("");
			preface.add(new Paragraph(ConstantsLanguage.TOTALE.stampa() + " " + ConstantsLanguage.ANAGRAFICHE.stampa() + ": " + ApplicationUtil.formatNumber(data.size()) , title));
			preface.add(new Paragraph(SPACE));
			document.add(preface);
			PdfPTable table = new PdfPTable(titles.length+campiChiave.length);
			table.setWidthPercentage(100);
			for(String tt : titles) {
				PdfPCell c = new PdfPCell(new Phrase(tt, header));
				c.setHorizontalAlignment(Element.ALIGN_LEFT);
				c.setBackgroundColor(BaseColor.YELLOW);
				table.addCell(c);
			}
			for(String campo : campiEtichette) {
				PdfPCell c = new PdfPCell(new Phrase(campo, header));
				c.setHorizontalAlignment(Element.ALIGN_LEFT);
				c.setBackgroundColor(BaseColor.YELLOW);
				table.addCell(c);
			}
			table.setHeaderRows(1);
			for(Anagrafica prd : data) {
				table.addCell(new Phrase(prd.getId().toString(), normal));
				table.addCell(new Phrase(prd.getDenominazione(), normal));
				table.addCell(new Phrase(prd.getCognome(), normal));
				table.addCell(new Phrase(prd.getNome(), normal));
				table.addCell(new Phrase(prd.getEmail(), normal));
				table.addCell(new Phrase(prd.getLink(),normal));
				table.addCell(new Phrase(prd.getCodice_fiscale(),normal));
				table.addCell(new Phrase(prd.getPartita_iva(),normal));
				table.addCell(new Phrase(prd.getTelefono_fax(),normal));
				table.addCell(new Phrase(prd.getTelefono_fisso(), normal));
				table.addCell(new Phrase(prd.getTelefono_mobile(),normal));
				table.addCell(new Phrase(prd.getTelefono_altro(), normal));
				table.addCell(new Phrase(prd.getRagione_sociale(), normal));
				table.addCell(new Phrase(prd.getNome_completo(), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.date.stampa(), prd.getDate_nascita()), normal));
				table.addCell(new Phrase(prd.getLuogo_nascita(), normal));
				table.addCell(new Phrase(prd.getTipo(), normal));
				table.addCell(new Phrase(prd.getSesso(), normal));
				table.addCell(new Phrase(prd.getNota(), normal));
				table.addCell(new Phrase(prd.getSettore(), normal));
				table.addCell(new Phrase(prd.getConsenso_tfissoS(), normal));
				table.addCell(new Phrase(prd.getConsenso_tmobileS(), normal));
				table.addCell(new Phrase(prd.getConsenso_tfaxS(), normal));
				table.addCell(new Phrase(prd.getConsenso_taltroS(), normal));
				table.addCell(new Phrase(prd.getConsenso_emailS(), normal));
				table.addCell(new Phrase(prd.getConsenso_rmailS(), normal));
				table.addCell(new Phrase(prd.getIndirizzo_legale().getIndirizzo_completo(), normal));
				table.addCell(new Phrase(prd.getIndirizzo_operativo().getIndirizzo_completo(), normal));
				for(Long campo : campiChiave) {
					stampaDato(table, campo, prd.getDettagli(), null);
				}
			}
			document.add(table);
			document.close();
		} catch (Exception e) {
		}
	}
	public static void stampaPDFContatto(List<Contatto>  data, OutputStream out, List<Long> campis, AnagraficaDao anagraficaDao, String password) {
		String [] titles = new ExportUtility().titlesContatto;
		try {
			if(ApplicationUtil.empty(campis)) {
				campis = new ArrayList<Long>();
			}
			Long [] campiChiave = new Long[campis.size()];
			String [] campiEtichette = new String[campis.size()];
			for (int i = 0; i < campis.size(); i++) {
				campiChiave[i] = campis.get(i);
				campiEtichette[i] = anagraficaDao.getEtichettaById(CampoAggiuntivoAnagrafica.class, campis.get(i));
			}	
			if(ApplicationUtil.notEmpty(campiChiave)) {
				data = anagraficaDao.loadFullContatto(data);
			}
			Document document = new Document(ApplicationUtil.pageSize(titles.length+campiChiave.length));
			ApplicationUtil.passwordPDF(document, out, password);
			document.open();
			document.addTitle(ConstantsLanguage.CONTATTI.stampa());
			document.addSubject( ConstantsLanguage.CONTATTI.stampa());
			document.addKeywords(ConstantsLanguage.CONTRATTI.stampa());
			document.addAuthor(AUTHOR);
			document.addCreator(CREATOR);
			Paragraph preface = new Paragraph("");
			preface.add(new Paragraph(ConstantsLanguage.TOTALE.stampa() + " " + ConstantsLanguage.CONTATTI.stampa() + ": " + ApplicationUtil.formatNumber(data.size()) , title));
			preface.add(new Paragraph(SPACE));
			document.add(preface);
			PdfPTable table = new PdfPTable(titles.length+campiChiave.length);
			table.setWidthPercentage(100);
			for(String tt : titles) {
				PdfPCell c = new PdfPCell(new Phrase(tt, header));
				c.setHorizontalAlignment(Element.ALIGN_LEFT);
				c.setBackgroundColor(BaseColor.YELLOW);
				table.addCell(c);
			}
			for(String campo : campiEtichette) {
				PdfPCell c = new PdfPCell(new Phrase(campo, header));
				c.setHorizontalAlignment(Element.ALIGN_LEFT);
				c.setBackgroundColor(BaseColor.YELLOW);
				table.addCell(c);
			}
			table.setHeaderRows(1);
			for(Contatto prd : data) {
				table.addCell(new Phrase(prd.getId().toString(), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), prd.getData_creazione()), normal));
				table.addCell(new Phrase(prd.getBloccatoS(), normal));
				table.addCell(new Phrase(prd.getCampagna_denominazione(), normal));
				table.addCell(new Phrase(prd.getLista_denominazione(), normal));
				table.addCell(new Phrase(prd.getAnagrafica().getDenominazione(), normal));
				table.addCell(new Phrase(prd.getAnagrafica().getCognome(), normal));
				table.addCell(new Phrase(prd.getAnagrafica().getNome(), normal));
				table.addCell(new Phrase(prd.getAnagrafica().getEmail(), normal));
				table.addCell(new Phrase(prd.getAnagrafica().getLink(), normal));
				table.addCell(new Phrase(prd.getAnagrafica().getCodice_fiscale(), normal));
				table.addCell(new Phrase(prd.getAnagrafica().getPartita_iva(), normal));
				table.addCell(new Phrase(prd.getAnagrafica().getTelefono_fisso(), normal));
				table.addCell(new Phrase(prd.getAnagrafica().getTelefono_mobile(), normal));
				table.addCell(new Phrase(prd.getAnagrafica().getTelefono_fax(), normal));
				table.addCell(new Phrase(prd.getAnagrafica().getTelefono_altro(), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), prd.getData_archiviazione()), normal));
				table.addCell(new Phrase(prd.getEsito_chiamata_etichettaCodice(), normal));
				table.addCell(new Phrase(prd.getEsito_archiviazione_etichettaCodice(), normal));
				table.addCell(new Phrase(prd.getPositivo(), normal));
				table.addCell(new Phrase(prd.getUtile(), normal));
				table.addCell(new Phrase(prd.getChiuso(), normal));
				table.addCell(new Phrase(prd.getProprietario_denominazione(), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), prd.getData_presentazione()), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), prd.getData_lavorazione()), normal));
				table.addCell(new Phrase(prd.getOperatore_denominazione(), normal));
				table.addCell(new Phrase(prd.getNota(), normal));
				table.addCell(new Phrase(prd.getAgente_denominazione(), normal));
				table.addCell(new Phrase(prd.getTipoTesto(), normal));
				table.addCell(new Phrase(prd.getAnagrafica().getIndirizzo_legale().getIndirizzo_completo(), normal));
				table.addCell(new Phrase(prd.getAnagrafica().getIndirizzo_operativo().getIndirizzo_completo(), normal));
				for(Long campo : campiChiave) {
					stampaDato(table, campo, prd.getAnagrafica().getDettagli(), null);
				}
			}
			document.add(table);
			document.close();
		} catch (Exception e) {
		}
	}
	public static void stampaPDFAppuntamento(List<Appuntamento>  data, OutputStream out, List<Long> campis, AnagraficaDao anagraficaDao, String password) {
		String [] titles = new ExportUtility().titlesAppuntamento;
		try {
			if(ApplicationUtil.empty(campis)) {
				campis = new ArrayList<Long>();
			}
			Long [] campiChiave = new Long[campis.size()];
			String [] campiEtichette = new String[campis.size()];
			for (int i = 0; i < campis.size(); i++) {
				campiChiave[i] = campis.get(i);
				campiEtichette[i] = anagraficaDao.getEtichettaById(CampoAggiuntivoAnagrafica.class, campis.get(i));
			}	
			if(ApplicationUtil.notEmpty(campiChiave)) {
				data = anagraficaDao.loadFullAppuntamento(data);
			}
			Document document = new Document(ApplicationUtil.pageSize(titles.length+campiChiave.length));
			ApplicationUtil.passwordPDF(document, out, password);
			document.open();
			document.addTitle(ConstantsLanguage.APPUNTAMENTI.stampa());
			document.addSubject( ConstantsLanguage.APPUNTAMENTI.stampa());
			document.addKeywords(ConstantsLanguage.APPUNTAMENTI.stampa());
			document.addAuthor(AUTHOR);
			document.addCreator(CREATOR);
			Paragraph preface = new Paragraph("");
			preface.add(new Paragraph(ConstantsLanguage.TOTALE.stampa() + " " + ConstantsLanguage.APPUNTAMENTI.stampa() + ": " + ApplicationUtil.formatNumber(data.size()) , title));
			preface.add(new Paragraph(SPACE));
			document.add(preface);
			PdfPTable table = new PdfPTable(titles.length+campiChiave.length);
			table.setWidthPercentage(100);
			for(String tt : titles) {
				PdfPCell c = new PdfPCell(new Phrase(tt, header));
				c.setHorizontalAlignment(Element.ALIGN_LEFT);
				c.setBackgroundColor(BaseColor.YELLOW);
				table.addCell(c);
			}
			for(String campo : campiEtichette) {
				PdfPCell c = new PdfPCell(new Phrase(campo, header));
				c.setHorizontalAlignment(Element.ALIGN_LEFT);
				c.setBackgroundColor(BaseColor.YELLOW);
				table.addCell(c);
			}
			table.setHeaderRows(1);
			for(Appuntamento prd : data) {
				table.addCell(new Phrase(prd.getId().toString(), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), prd.getData_creazione()), normal));
				table.addCell(new Phrase(prd.getBloccatoS(), normal));
				table.addCell(new Phrase(prd.getContatto().getCampagna_denominazione(), normal));
				table.addCell(new Phrase(prd.getContatto().getLista_denominazione(), normal));
				table.addCell(new Phrase(prd.getContatto().getAnagrafica().getDenominazione(), normal));
				table.addCell(new Phrase(prd.getContatto().getAnagrafica().getCognome(), normal));
				table.addCell(new Phrase(prd.getContatto().getAnagrafica().getNome(), normal));
				table.addCell(new Phrase(prd.getContatto().getAnagrafica().getEmail(), normal));
				table.addCell(new Phrase(prd.getContatto().getAnagrafica().getLink(), normal));
				table.addCell(new Phrase(prd.getContatto().getAnagrafica().getCodice_fiscale(), normal));
				table.addCell(new Phrase(prd.getContatto().getAnagrafica().getPartita_iva(), normal));
				table.addCell(new Phrase(prd.getContatto().getAnagrafica().getTelefono_fisso(), normal));
				table.addCell(new Phrase(prd.getContatto().getAnagrafica().getTelefono_mobile(), normal));
				table.addCell(new Phrase(prd.getContatto().getAnagrafica().getTelefono_fax(), normal));
				table.addCell(new Phrase(prd.getContatto().getAnagrafica().getTelefono_altro(), normal));
				table.addCell(new Phrase(prd.getOperatore_denominazione(), normal));
				table.addCell(new Phrase(prd.getAgente_denominazione(), normal));
				table.addCell(new Phrase(prd.getNota(), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.date.stampa(), prd.getData_inizio()), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.time.stampa(), prd.getData_inizio()), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.time.stampa(), prd.getData_fine()), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), prd.getData_conferma()), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), prd.getData_lavorazione()), normal));
				table.addCell(new Phrase(prd.getUtente_denominazione(), normal));
				table.addCell(new Phrase(prd.getEsitoEtichettaCodice(), normal));
				table.addCell(new Phrase(prd.getStatoTesto(), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), prd.getData_esito()), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), prd.getData_stato()), normal));
				table.addCell(new Phrase(prd.getLocalizzazioneString(), normal));
				table.addCell(new Phrase(prd.getContatto().getAnagrafica().getIndirizzo_legale().getIndirizzo_completo(), normal));
				table.addCell(new Phrase(prd.getContatto().getAnagrafica().getIndirizzo_operativo().getIndirizzo_completo(), normal));
				for(Long campo : campiChiave) {
					stampaDato(table, campo, prd.getContatto().getAnagrafica().getDettagli(), null);
				}
			}
			document.add(table);
			document.close();
		} catch (Exception e) {
		}
	}
	public static void stampaPDFContratto(List<Contratto>  data, OutputStream out, List<Long> campiA, List<Long> campiB, AnagraficaDao anagraficaDao, String password) {
		String [] titles = new ExportUtility().titlesContratto;
		try {
			if(ApplicationUtil.empty(campiA)) {
				campiA = new ArrayList<Long>();
			}
			if(ApplicationUtil.empty(campiB)) {
				campiB = new ArrayList<Long>();
			}
			Long [] campiChiave = new Long[campiB.size() + campiA.size()];
			String [] campiEtichette = new String[campiB.size() + campiA.size()];
			for (int i = 0; i < campiB.size(); i++) {
				campiChiave[i] = campiB.get(i);
				campiEtichette[i] = anagraficaDao.getEtichettaById(CampoAggiuntivoAnagrafica.class, campiB.get(i));
			}	
			for (int i = 0; i < campiA.size(); i++) {
				campiChiave[campiB.size() + i] = campiA.get(i);
				campiEtichette[campiB.size() + i] = anagraficaDao.getEtichettaById(CampoAggiuntivoContratto.class, campiA.get(i));
			}	
			if(ApplicationUtil.notEmpty(campiChiave)) {
				data = anagraficaDao.loadFullContratto(data);
			}
			Document document = new Document(ApplicationUtil.pageSize(titles.length+campiChiave.length));
			ApplicationUtil.passwordPDF(document, out, password);
			document.open();
			document.addTitle(ConstantsLanguage.CONTRATTI.stampa());
			document.addSubject( ConstantsLanguage.CONTRATTI.stampa());
			document.addKeywords(ConstantsLanguage.CONTRATTI.stampa());
			document.addAuthor(AUTHOR);
			document.addCreator(CREATOR);
			Paragraph preface = new Paragraph("");
			preface.add(new Paragraph(ConstantsLanguage.TOTALE.stampa() + " " + ConstantsLanguage.CONTRATTI.stampa() + ": " + ApplicationUtil.formatNumber(data.size()) , title));
			preface.add(new Paragraph(SPACE));
			document.add(preface);
			PdfPTable table = new PdfPTable(titles.length+campiChiave.length);
			table.setWidthPercentage(100);
			for(String tt : titles) {
				PdfPCell c = new PdfPCell(new Phrase(tt, header));
				c.setHorizontalAlignment(Element.ALIGN_LEFT);
				c.setBackgroundColor(BaseColor.YELLOW);
				table.addCell(c);
			}
			for(String campo : campiEtichette) {
				PdfPCell c = new PdfPCell(new Phrase(campo, header));
				c.setHorizontalAlignment(Element.ALIGN_LEFT);
				c.setBackgroundColor(BaseColor.YELLOW);
				table.addCell(c);
			}
			table.setHeaderRows(1);
			for(Contratto prd : data) {
				table.addCell(new Phrase(prd.getId().toString(), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), prd.getData_creazione()), normal));
				table.addCell(new Phrase(prd.getBloccatoS(), normal));
				table.addCell(new Phrase(prd.getContatto().getCampagna_denominazione(), normal));
				table.addCell(new Phrase(prd.getContatto().getLista_denominazione(), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), prd.getData_lavorazione()), normal));
				table.addCell(new Phrase(prd.getUtente_denominazione(), normal));
				table.addCell(new Phrase(prd.getContatto().getAnagrafica().getDenominazione(), normal));
				table.addCell(new Phrase(prd.getContatto().getAnagrafica().getCognome(), normal));
				table.addCell(new Phrase(prd.getContatto().getAnagrafica().getNome(), normal));
				table.addCell(new Phrase(prd.getContatto().getAnagrafica().getEmail(), normal));
				table.addCell(new Phrase(prd.getContatto().getAnagrafica().getLink(), normal));
				table.addCell(new Phrase(prd.getContatto().getAnagrafica().getCodice_fiscale(), normal));
				table.addCell(new Phrase(prd.getContatto().getAnagrafica().getPartita_iva(), normal));
				table.addCell(new Phrase(prd.getContatto().getAnagrafica().getTelefono_fisso(), normal));
				table.addCell(new Phrase(prd.getContatto().getAnagrafica().getTelefono_mobile(), normal));
				table.addCell(new Phrase(prd.getContatto().getAnagrafica().getTelefono_fax(), normal));
				table.addCell(new Phrase(prd.getContatto().getAnagrafica().getTelefono_altro(), normal));
				table.addCell(new Phrase(prd.getOperatore_denominazione(), normal));
				table.addCell(new Phrase(prd.getAgente_denominazione(), normal));
				table.addCell(new Phrase(prd.getCategoria_denominazione(), normal));
				table.addCell(new Phrase(prd.getProdotto_denominazione(), normal));
				table.addCell(new Phrase(prd.getEsitoEtichettaCodice(), normal));
				table.addCell(new Phrase(prd.getTipo_seriale(), normal));
				table.addCell(new Phrase(prd.getSeriale(), normal));
				table.addCell(new Phrase(ApplicationUtil.formatNumber(prd.getQuantita()), normal));
				table.addCell(new Phrase(ApplicationUtil.formatNumber(prd.getCosto_scontato()), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.date.stampa(), prd.getData_contabile()), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.date.stampa(), prd.getData_stipula()), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.date.stampa(), prd.getData_attivazione()), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.date.stampa(), prd.getData_caricamento()), normal));
				table.addCell(new Phrase(prd.getNota(), normal));
				table.addCell(new Phrase(prd.getStatoTesto(), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), prd.getData_esito()), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), prd.getData_stato()), normal));
				table.addCell(new Phrase(prd.getContatto().getAnagrafica().getIndirizzo_legale().getIndirizzo_completo(), normal));
				table.addCell(new Phrase(prd.getContatto().getAnagrafica().getIndirizzo_operativo().getIndirizzo_completo(), normal));
				for(Long campo : campiChiave) {
					stampaDato(table, campo, prd.getContatto().getAnagrafica().getDettagli(), prd.getDettagli());
				}
			}
			document.add(table);
			document.close();
		} catch (Exception e) {
		}
	}
	public static void stampaPDFContratto(List<Contratto>  data, OutputStream out, String password) {
		String [] titles = new ExportUtility().titlesContratto;
		try {
			Document document = new Document(ApplicationUtil.pageSize(titles.length));
			ApplicationUtil.passwordPDF(document, out, password);
			document.open();
			document.addTitle(ConstantsLanguage.CONTRATTI.stampa());
			document.addSubject( ConstantsLanguage.CONTRATTI.stampa());
			document.addKeywords(ConstantsLanguage.CONTRATTI.stampa());
			document.addAuthor(AUTHOR);
			document.addCreator(CREATOR);
			Paragraph preface = new Paragraph("");
			preface.add(new Paragraph(ConstantsLanguage.TOTALE.stampa() + " " + ConstantsLanguage.CONTRATTI.stampa() + ": " + ApplicationUtil.formatNumber(data.size()) , title));
			preface.add(new Paragraph(SPACE));
			document.add(preface);
			PdfPTable table = new PdfPTable(titles.length);
			table.setWidthPercentage(100);
			for(String tt : titles) {
				PdfPCell c = new PdfPCell(new Phrase(tt, header));
				c.setHorizontalAlignment(Element.ALIGN_LEFT);
				c.setBackgroundColor(BaseColor.YELLOW);
				table.addCell(c);
			}
			table.setHeaderRows(1);
			for(Contratto prd : data) {
				table.addCell(new Phrase(prd.getId().toString(), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), prd.getData_creazione()), normal));
				table.addCell(new Phrase(prd.getBloccatoS(), normal));
				table.addCell(new Phrase(prd.getContatto().getCampagna_denominazione(), normal));
				table.addCell(new Phrase(prd.getContatto().getLista_denominazione(), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), prd.getData_lavorazione()), normal));
				table.addCell(new Phrase(prd.getUtente_denominazione(), normal));
				table.addCell(new Phrase(prd.getContatto().getAnagrafica().getDenominazione(), normal));
				table.addCell(new Phrase(prd.getContatto().getAnagrafica().getCognome(), normal));
				table.addCell(new Phrase(prd.getContatto().getAnagrafica().getNome(), normal));
				table.addCell(new Phrase(prd.getContatto().getAnagrafica().getEmail(), normal));
				table.addCell(new Phrase(prd.getContatto().getAnagrafica().getLink(), normal));
				table.addCell(new Phrase(prd.getContatto().getAnagrafica().getCodice_fiscale(), normal));
				table.addCell(new Phrase(prd.getContatto().getAnagrafica().getPartita_iva(), normal));
				table.addCell(new Phrase(prd.getContatto().getAnagrafica().getTelefono_fisso(), normal));
				table.addCell(new Phrase(prd.getContatto().getAnagrafica().getTelefono_mobile(), normal));
				table.addCell(new Phrase(prd.getContatto().getAnagrafica().getTelefono_fax(), normal));
				table.addCell(new Phrase(prd.getContatto().getAnagrafica().getTelefono_altro(), normal));
				table.addCell(new Phrase(prd.getOperatore_denominazione(), normal));
				table.addCell(new Phrase(prd.getAgente_denominazione(), normal));
				table.addCell(new Phrase(prd.getCategoria_denominazione(), normal));
				table.addCell(new Phrase(prd.getProdotto_denominazione(), normal));
				table.addCell(new Phrase(prd.getEsitoEtichettaCodice(), normal));
				table.addCell(new Phrase(prd.getTipo_seriale(), normal));
				table.addCell(new Phrase(prd.getSeriale(), normal));
				table.addCell(new Phrase(ApplicationUtil.formatNumber(prd.getQuantita()), normal));
				table.addCell(new Phrase(ApplicationUtil.formatNumber(prd.getCosto_scontato()), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.date.stampa(), prd.getData_contabile()), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.date.stampa(), prd.getData_stipula()), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.date.stampa(), prd.getData_attivazione()), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.date.stampa(), prd.getData_caricamento()), normal));
				table.addCell(new Phrase(prd.getNota(), normal));
				table.addCell(new Phrase(prd.getStatoTesto(), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), prd.getData_esito()), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), prd.getData_stato()), normal));
				table.addCell(new Phrase(prd.getContatto().getAnagrafica().getIndirizzo_legale().getIndirizzo_completo(), normal));
				table.addCell(new Phrase(prd.getContatto().getAnagrafica().getIndirizzo_operativo().getIndirizzo_completo(), normal));
			}
			document.add(table);
			document.close();
		} catch (Exception e) {
		}
	}
	public static void stampaPDFAnagraficaTemplate(List<Anagrafica>  data, OutputStream out, TemplateExportAnagrafica ti, AnagraficaDao anagraficaDao, String password) {
		List <String> titlesList = ti.getValore_multiplo();
		List <String> aggiuntivi = ListUtils.subtract(titlesList, new ArrayList<String>(ConstantsMap.anagraficaMap));
		if(ApplicationUtil.notEmpty(aggiuntivi)) {
			data = anagraficaDao.loadFullAnagrafica(data);
		}
		String[] titles = titlesList.toArray(new String[0]);
		try {
			Document document = new Document(ApplicationUtil.pageSize(titles.length));
			ApplicationUtil.passwordPDF(document, out, password);
			document.open();
			document.addTitle(ConstantsLanguage.ANAGRAFICHE.stampa());
			document.addSubject( ConstantsLanguage.ANAGRAFICHE.stampa());
			document.addKeywords(ConstantsLanguage.ANAGRAFICHE.stampa());
			document.addAuthor(AUTHOR);
			document.addCreator(CREATOR);
			Paragraph preface = new Paragraph("");
			preface.add(new Paragraph(ConstantsLanguage.TOTALE.stampa() + " " + ConstantsLanguage.ANAGRAFICHE.stampa() + ": " + ApplicationUtil.formatNumber(data.size()) , title));
			preface.add(new Paragraph(SPACE));
			document.add(preface);
			PdfPTable table = new PdfPTable(titles.length);
			table.setWidthPercentage(100);
			if(ti.getIntestazione()) {
				for(String tt : titles) {
					PdfPCell c;
					if(ApplicationUtil.notEmpty(aggiuntivi) && aggiuntivi.contains(tt)) {
						String etichetta = anagraficaDao.getEtichettaByChiave(CampoAggiuntivoAnagrafica.class, tt);
						c = new PdfPCell(new Phrase(etichetta, header));
					} else {
						c = new PdfPCell(new Phrase(Message.addCatalogText(tt), header));
					}
					c.setHorizontalAlignment(Element.ALIGN_LEFT);
					c.setBackgroundColor(BaseColor.YELLOW);
					table.addCell(c);
				}
				table.setHeaderRows(1);
			}
			for(Anagrafica prd : data) {
				for (int j = 0; j < titles.length; j++) {
					if(ti.getPosizione(ConstantsMap.anagrafica_cognome).equals(j)) {
						table.addCell(new Phrase(prd.getCognome(), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_nome).equals(j)) {
						table.addCell(new Phrase(prd.getNome(), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_nome_completo).equals(j)) {
						table.addCell(new Phrase(prd.getNome_completo(), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_email).equals(j)) {
						table.addCell(new Phrase(prd.getEmail(), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_codice_fiscale).equals(j)) {
						table.addCell(new Phrase(prd.getCodice_fiscale(), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_sorgente).equals(j)) {
						table.addCell(new Phrase(prd.getSorgente(), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_nota).equals(j)) {
						table.addCell(new Phrase(prd.getNota(), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_luogo_nascita).equals(j)) {
						table.addCell(new Phrase(prd.getLuogo_nascita(), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_data_nascita).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.date.stampa(), prd.getDate_nascita()), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_link).equals(j)) {
						table.addCell(new Phrase(prd.getLink(), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_privacy).equals(j)) {
						table.addCell(new Phrase(prd.getPrivacy(), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_data_inserimento).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), prd.getData_creazione()), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_tipo).equals(j)) {
						table.addCell(new Phrase(prd.getTipo(), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_sesso).equals(j)) {
						table.addCell(new Phrase(prd.getSesso(), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_partita_iva).equals(j)) {
						table.addCell(new Phrase(prd.getPartita_iva(), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_ragione_sociale).equals(j)) {
						table.addCell(new Phrase(prd.getRagione_sociale(), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_telefono_fisso).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.uniforma(prd.getTelefono_fisso(), ti.getRem_fisso(), ti.getAdd_fisso()), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_telefono_altro).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.uniforma(prd.getTelefono_altro(), ti.getRem_altro(), ti.getAdd_altro()), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_telefono_mobile).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.uniforma(prd.getTelefono_mobile(), ti.getRem_mobile(), ti.getAdd_mobile()), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_telefono_fax).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.uniforma(prd.getTelefono_fax(), ti.getRem_fax(), ti.getAdd_fax()), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_settore).equals(j)) {
						table.addCell(new Phrase(prd.getSettore(), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_denominazione).equals(j)) {
						table.addCell(new Phrase(prd.getDenominazione(), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_id).equals(j)) {
						table.addCell(new Phrase(prd.getIdentificativo(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_indirizzo_completo).equals(j)) {
						table.addCell(new Phrase(prd.getIndirizzo_legale().getIndirizzo_completo(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_strada_completo).equals(j)) {
						table.addCell(new Phrase(prd.getIndirizzo_legale().getStrada_completo(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_comune_completo).equals(j)) {
						table.addCell(new Phrase(prd.getIndirizzo_legale().getComune_completo(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_strada).equals(j)) {
						table.addCell(new Phrase(prd.getIndirizzo_legale().getStrada(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_civico).equals(j)) {
						table.addCell(new Phrase(prd.getIndirizzo_legale().getCivico(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_cap).equals(j)) {
						table.addCell(new Phrase(prd.getIndirizzo_legale().getCap(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_comune).equals(j)) {
						table.addCell(new Phrase(prd.getIndirizzo_legale().getComune(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_provincia).equals(j)) {
						table.addCell(new Phrase(prd.getIndirizzo_legale().getProvincia(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_regione).equals(j)) {
						table.addCell(new Phrase(prd.getIndirizzo_legale().getRegione(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_dettagli).equals(j)) {
						table.addCell(new Phrase(prd.getIndirizzo_legale().getDettagli(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_latitudine).equals(j)) {
						table.addCell(new Phrase(prd.getIndirizzo_legale().getLatitudine(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_longitudine).equals(j)) {
						table.addCell(new Phrase(prd.getIndirizzo_legale().getLongitudine(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_presso).equals(j)) {
						table.addCell(new Phrase(prd.getIndirizzo_legale().getPresso(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_indirizzo_completo).equals(j)) {
						table.addCell(new Phrase(prd.getIndirizzo_operativo().getIndirizzo_completo(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_strada_completo).equals(j)) {
						table.addCell(new Phrase(prd.getIndirizzo_operativo().getStrada_completo(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_comune_completo).equals(j)) {
						table.addCell(new Phrase(prd.getIndirizzo_operativo().getComune_completo(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_strada).equals(j)) {
						table.addCell(new Phrase(prd.getIndirizzo_operativo().getStrada(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_civico).equals(j)) {
						table.addCell(new Phrase(prd.getIndirizzo_operativo().getCivico(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_cap).equals(j)) {
						table.addCell(new Phrase(prd.getIndirizzo_operativo().getCap(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_comune).equals(j)) {
						table.addCell(new Phrase(prd.getIndirizzo_operativo().getComune(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_provincia).equals(j)) {
						table.addCell(new Phrase(prd.getIndirizzo_operativo().getProvincia(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_regione).equals(j)) {
						table.addCell(new Phrase(prd.getIndirizzo_operativo().getRegione(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_dettagli).equals(j)) {
						table.addCell(new Phrase(prd.getIndirizzo_operativo().getDettagli(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_latitudine).equals(j)) {
						table.addCell(new Phrase(prd.getIndirizzo_operativo().getLatitudine(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_longitudine).equals(j)) {
						table.addCell(new Phrase(prd.getIndirizzo_operativo().getLongitudine(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_presso).equals(j)) {
						table.addCell(new Phrase(prd.getIndirizzo_operativo().getPresso(), normal));
					} else if(ti.getPosizione(ConstantsMap.consenso_tfissoS).equals(j)) {
						table.addCell(new Phrase(prd.getConsenso_tfissoS(), normal));
					} else if(ti.getPosizione(ConstantsMap.consenso_tmobileS).equals(j)) {
						table.addCell(new Phrase(prd.getConsenso_tmobileS(), normal));
					} else if(ti.getPosizione(ConstantsMap.consenso_tfaxS).equals(j)) {
						table.addCell(new Phrase(prd.getConsenso_tfaxS(), normal));
					} else if(ti.getPosizione(ConstantsMap.consenso_taltroS).equals(j)) {
						table.addCell(new Phrase(prd.getConsenso_taltroS(), normal));
					} else if(ti.getPosizione(ConstantsMap.consenso_emailS).equals(j)) {
						table.addCell(new Phrase(prd.getConsenso_emailS(), normal));
					} else if(ti.getPosizione(ConstantsMap.consenso_rmailS).equals(j)) {
						table.addCell(new Phrase(prd.getConsenso_rmailS(), normal));
					} else {
						stampaDato(table, titles[j], prd.getDettagli(), null);
					}
				}
			}
			document.add(table);
			document.close();
		} catch (Exception e) {
		}
	}
	public static void stampaPDFContattoTemplate(Boolean p, List<Contatto>  data, OutputStream out, TemplateExportContatto ti, AnagraficaDao anagraficaDao, String password) {
		List <String> titlesList = ti.getValore_multiplo();
		List <String> aggiuntivi = ListUtils.subtract(titlesList, new ArrayList<String>(ConstantsMap.contattoMap));
		if(p!=null && ApplicationUtil.notEmpty(aggiuntivi)) {
			List <String> invA = anagraficaDao.getEtichetteInvisibiliByChiave(p, CampoAggiuntivoAnagrafica.class);
			aggiuntivi.removeAll(invA);
			titlesList.removeAll(invA);
		}
		if(ApplicationUtil.notEmpty(aggiuntivi)) {
			data = anagraficaDao.loadFullContatto(data);
		}
		String[] titles = titlesList.toArray(new String[0]);
		try {
			Document document = new Document(ApplicationUtil.pageSize(titles.length));
			ApplicationUtil.passwordPDF(document, out, password);
			document.open();
			document.addTitle(ConstantsLanguage.CONTATTI.stampa());
			document.addSubject( ConstantsLanguage.CONTATTI.stampa());
			document.addKeywords(ConstantsLanguage.CONTATTI.stampa());
			document.addAuthor(AUTHOR);
			document.addCreator(CREATOR);
			Paragraph preface = new Paragraph("");
			preface.add(new Paragraph(ConstantsLanguage.TOTALE.stampa() + " " + ConstantsLanguage.CONTATTI.stampa() + ": " + ApplicationUtil.formatNumber(data.size()) , title));
			preface.add(new Paragraph(SPACE));
			document.add(preface);
			PdfPTable table = new PdfPTable(titles.length);
			table.setWidthPercentage(100);
			if(ti.getIntestazione()) {
				for(String tt : titles) {
					PdfPCell c;
					if(ApplicationUtil.notEmpty(aggiuntivi) && aggiuntivi.contains(tt)) {
						String etichetta = anagraficaDao.getEtichettaByChiave(CampoAggiuntivoAnagrafica.class, tt);
						c = new PdfPCell(new Phrase(etichetta, header));
					} else {
						c = new PdfPCell(new Phrase(Message.addCatalogText(tt), header));
					}
					c.setHorizontalAlignment(Element.ALIGN_LEFT);
					c.setBackgroundColor(BaseColor.YELLOW);
					table.addCell(c);
				}
				table.setHeaderRows(1);
			}
			for(Contatto cnt : data) {
				for (int j = 0; j < titles.length; j++) {
					if(ti.getPosizione(ConstantsMap.contatto_data_archiviazione).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), cnt.getData_archiviazione()), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_data_lavorazione).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), cnt.getData_lavorazione()), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_operatore_denominazione).equals(j)) {
						table.addCell(new Phrase(cnt.getOperatore_denominazione(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_operatore_codice).equals(j)) {
						table.addCell(new Phrase(cnt.getOperatore_codice(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_esito_chiamata).equals(j)) {
						table.addCell(new Phrase(cnt.getEsito_chiamata(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_esito_archiviazione).equals(j)) {
						table.addCell(new Phrase(cnt.getEsito_archiviazione(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_esito_generale).equals(j)) {
						table.addCell(new Phrase(cnt.getEsito_generale(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_codice_chiamata).equals(j)) {
						table.addCell(new Phrase(cnt.getCodice_chiamata(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_codice_archiviazione).equals(j)) {
						table.addCell(new Phrase(cnt.getCodice_archiviazione(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_codice_generale).equals(j)) {
						table.addCell(new Phrase(cnt.getCodice_generale(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_proprietario_denominazione).equals(j)) {
						table.addCell(new Phrase(cnt.getProprietario_denominazione(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_proprietario_codice).equals(j)) {
						table.addCell(new Phrase(cnt.getProprietario_codice(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_nota).equals(j)) {
						table.addCell(new Phrase(cnt.getNota(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_data_presentazione).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), cnt.getData_presentazione()), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_data_creazione).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), cnt.getData_creazione()), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_agente_denominazione).equals(j)) {
						table.addCell(new Phrase(cnt.getAgente_denominazione(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_agente_codice).equals(j)) {
						table.addCell(new Phrase(cnt.getAgente_codice(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_stato).equals(j)) {
						table.addCell(new Phrase(cnt.getTipoTesto(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_campagna_denominazione).equals(j)) {
						table.addCell(new Phrase(cnt.getCampagna_denominazione(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_lista_denominazione).equals(j)) {
						table.addCell(new Phrase(cnt.getLista_denominazione(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_campagna_codice).equals(j)) {
						table.addCell(new Phrase(cnt.getCampagna_codice(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_bloccato).equals(j)) {
						table.addCell(new Phrase(cnt.getBloccatoS(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_lista_codice).equals(j)) {
						table.addCell(new Phrase(cnt.getLista_codice(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_id).equals(j)) {
						table.addCell(new Phrase(cnt.getId().toString(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_positivo).equals(j)) {
						table.addCell(new Phrase(cnt.getPositivo(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_telefono_predefinito).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.uniforma(cnt.getTelefono_predefinito(), ti.getRem_predefinito(), ti.getAdd_predefinito()), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_utile).equals(j)) {
						table.addCell(new Phrase(cnt.getUtile(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_chiuso).equals(j)) {
						table.addCell(new Phrase(cnt.getChiuso(), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_cognome).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getCognome(), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_nome).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getNome(), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_nome_completo).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getNome_completo(), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_email).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getEmail(), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_codice_fiscale).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getCodice_fiscale(), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_sorgente).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getSorgente(), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_nota).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getNota(), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_luogo_nascita).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getLuogo_nascita(), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_data_nascita).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.date.stampa(), cnt.getAnagrafica().getDate_nascita()), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_link).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getLink(), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_privacy).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getPrivacy(), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_data_inserimento).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), cnt.getAnagrafica().getData_creazione()), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_tipo).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getTipo(), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_sesso).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getSesso(), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_partita_iva).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getPartita_iva(), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_ragione_sociale).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getRagione_sociale(), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_telefono_fisso).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.uniforma(cnt.getAnagrafica().getTelefono_fisso(), ti.getRem_fisso(), ti.getAdd_fisso()), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_telefono_altro).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.uniforma(cnt.getAnagrafica().getTelefono_altro(), ti.getRem_altro(), ti.getAdd_altro()), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_telefono_mobile).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.uniforma(cnt.getAnagrafica().getTelefono_mobile(), ti.getRem_mobile(), ti.getAdd_mobile()), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_telefono_fax).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.uniforma(cnt.getAnagrafica().getTelefono_fax(), ti.getRem_fax(), ti.getAdd_fax()), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_settore).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getSettore(), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_denominazione).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getDenominazione(), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_id).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIdentificativo(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_indirizzo_completo).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_legale().getIndirizzo_completo(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_strada_completo).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_legale().getStrada_completo(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_comune_completo).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_legale().getComune_completo(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_strada).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_legale().getStrada(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_civico).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_legale().getCivico(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_cap).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_legale().getCap(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_comune).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_legale().getComune(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_provincia).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_legale().getProvincia(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_regione).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_legale().getRegione(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_dettagli).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_legale().getDettagli(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_latitudine).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_legale().getLatitudine(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_longitudine).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_legale().getLongitudine(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_presso).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_legale().getPresso(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_indirizzo_completo).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_operativo().getIndirizzo_completo(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_strada_completo).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_operativo().getStrada_completo(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_comune_completo).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_operativo().getComune_completo(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_strada).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_operativo().getStrada(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_civico).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_operativo().getCivico(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_cap).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_operativo().getCap(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_comune).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_operativo().getComune(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_provincia).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_operativo().getProvincia(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_regione).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_operativo().getRegione(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_dettagli).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_operativo().getDettagli(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_latitudine).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_operativo().getLatitudine(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_longitudine).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_operativo().getLongitudine(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_presso).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_operativo().getPresso(), normal));
					} else if(ti.getPosizione(ConstantsMap.consenso_tfissoS).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getConsenso_tfissoS(), normal));
					} else if(ti.getPosizione(ConstantsMap.consenso_tmobileS).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getConsenso_tmobileS(), normal));
					} else if(ti.getPosizione(ConstantsMap.consenso_tfaxS).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getConsenso_tfaxS(), normal));
					} else if(ti.getPosizione(ConstantsMap.consenso_taltroS).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getConsenso_taltroS(), normal));
					} else if(ti.getPosizione(ConstantsMap.consenso_emailS).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getConsenso_emailS(), normal));
					} else if(ti.getPosizione(ConstantsMap.consenso_rmailS).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getConsenso_rmailS(), normal));
					} else {
						stampaDato(table, titles[j], cnt.getAnagrafica().getDettagli(), null);
					}
				}
			}
			document.add(table);
			document.close();
		} catch (Exception e) {
		}
	}
	public static void stampaPDFAppuntamentoTemplate(Boolean p, List<Appuntamento>  data, OutputStream out, TemplateExportAppuntamento ti, AnagraficaDao anagraficaDao, String password) {
		List <String> titlesList = ti.getValore_multiplo();
		List <String> aggiuntivi = ListUtils.subtract(titlesList, new ArrayList<String>(ConstantsMap.appuntamentoMap));
		if(p!=null && ApplicationUtil.notEmpty(aggiuntivi)) {
			List <String> invA = anagraficaDao.getEtichetteInvisibiliByChiave(p, CampoAggiuntivoAnagrafica.class);
			aggiuntivi.removeAll(invA);
			titlesList.removeAll(invA);
		}
		if(ApplicationUtil.notEmpty(aggiuntivi)) {
			data = anagraficaDao.loadFullAppuntamento(data);
		}
		String[] titles = titlesList.toArray(new String[0]);
		try {
			Document document = new Document(ApplicationUtil.pageSize(titles.length));
			ApplicationUtil.passwordPDF(document, out, password);
			document.open();
			document.addTitle(ConstantsLanguage.APPUNTAMENTI.stampa());
			document.addSubject( ConstantsLanguage.APPUNTAMENTI.stampa());
			document.addKeywords(ConstantsLanguage.APPUNTAMENTI.stampa());
			document.addAuthor(AUTHOR);
			document.addCreator(CREATOR);
			Paragraph preface = new Paragraph("");
			preface.add(new Paragraph(ConstantsLanguage.TOTALE.stampa() + " " + ConstantsLanguage.APPUNTAMENTI.stampa() + ": " + ApplicationUtil.formatNumber(data.size()) , title));
			preface.add(new Paragraph(SPACE));
			document.add(preface);
			PdfPTable table = new PdfPTable(titles.length);
			table.setWidthPercentage(100);
			if(ti.getIntestazione()) {
				for(String tt : titles) {
					PdfPCell c;
					if(ApplicationUtil.notEmpty(aggiuntivi) && aggiuntivi.contains(tt)) {
						String etichetta = anagraficaDao.getEtichettaByChiave(CampoAggiuntivoAnagrafica.class, tt);
						c = new PdfPCell(new Phrase(etichetta, header));
					} else {
						c = new PdfPCell(new Phrase(Message.addCatalogText(tt), header));
					}
					c.setHorizontalAlignment(Element.ALIGN_LEFT);
					c.setBackgroundColor(BaseColor.YELLOW);
					table.addCell(c);
				}
				table.setHeaderRows(1);
			} 
			for(Appuntamento app : data) {
				Contatto cnt = app.getContatto();
				for (int j = 0; j < titles.length; j++) {
					if(ti.getPosizione(ConstantsMap.appuntamento_id).equals(j)) {
						table.addCell(new Phrase(app.getId().toString(), normal));
					} else if(ti.getPosizione(ConstantsMap.appuntamento_operatore_denominazione).equals(j)) {
						table.addCell(new Phrase(app.getOperatore_denominazione(), normal));
					} else if(ti.getPosizione(ConstantsMap.appuntamento_bloccato).equals(j)) {
						table.addCell(new Phrase(app.getBloccatoS(), normal));
					} else if(ti.getPosizione(ConstantsMap.appuntamento_operatore_codice).equals(j)) {
						table.addCell(new Phrase(app.getOperatore_codice(), normal));
					} else if(ti.getPosizione(ConstantsMap.appuntamento_agente_denominazione).equals(j)) {
						table.addCell(new Phrase(app.getAgente_denominazione(), normal));
					} else if(ti.getPosizione(ConstantsMap.appuntamento_agente_codice).equals(j)) {
						table.addCell(new Phrase(app.getAgente_codice(), normal));
					} else if(ti.getPosizione(ConstantsMap.appuntamento_nota).equals(j)) {
						table.addCell(new Phrase(app.getNota(), normal));
					} else if(ti.getPosizione(ConstantsMap.appuntamento_data_creazione).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), app.getData_creazione()), normal));
					} else if(ti.getPosizione(ConstantsMap.appuntamento_data_appuntamento).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.date.stampa(), app.getData_inizio()), normal));
					} else if(ti.getPosizione(ConstantsMap.appuntamento_data_ora).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), app.getData_inizio()), normal));
					} else if(ti.getPosizione(ConstantsMap.appuntamento_ora_inizio).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.time.stampa(), app.getData_inizio()), normal));
					} else if(ti.getPosizione(ConstantsMap.appuntamento_ora_fine).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.time.stampa(), app.getData_fine()), normal));
					} else if(ti.getPosizione(ConstantsMap.appuntamento_data_conferma).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), app.getData_conferma()), normal));
					} else if(ti.getPosizione(ConstantsMap.appuntamento_data_lavorazione).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), app.getData_lavorazione()), normal));
					} else if(ti.getPosizione(ConstantsMap.appuntamento_localizzazione).equals(j)) {
						table.addCell(new Phrase(app.getLocalizzazioneString(), normal));
					} else if(ti.getPosizione(ConstantsMap.appuntamento_utente_denominazione).equals(j)) {
						table.addCell(new Phrase(app.getUtente_denominazione(), normal));
					} else if(ti.getPosizione(ConstantsMap.appuntamento_utente_codice).equals(j)) {
						table.addCell(new Phrase(app.getUtente_codice(), normal));
					} else if(ti.getPosizione(ConstantsMap.appuntamento_data_esito).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), app.getData_esito()), normal));
					} else if(ti.getPosizione(ConstantsMap.appuntamento_data_stato).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), app.getData_stato()), normal));
					} else if(ti.getPosizione(ConstantsMap.appuntamento_esito_appuntamento).equals(j)) {
						table.addCell(new Phrase(app.getEsitoEtichetta(), normal));
					} else if(ti.getPosizione(ConstantsMap.appuntamento_codice_appuntamento).equals(j)) {
						table.addCell(new Phrase(app.getEsitoCodice(), normal));
					} else if(ti.getPosizione(ConstantsMap.appuntamento_stato).equals(j)) {
						table.addCell(new Phrase(app.getStatoTesto(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_data_archiviazione).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), cnt.getData_archiviazione()), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_data_lavorazione).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), cnt.getData_lavorazione()), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_operatore_denominazione).equals(j)) {
						table.addCell(new Phrase(cnt.getOperatore_denominazione(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_operatore_codice).equals(j)) {
						table.addCell(new Phrase(cnt.getOperatore_codice(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_esito_chiamata).equals(j)) {
						table.addCell(new Phrase(cnt.getEsito_chiamata(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_esito_archiviazione).equals(j)) {
						table.addCell(new Phrase(cnt.getEsito_archiviazione(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_esito_generale).equals(j)) {
						table.addCell(new Phrase(cnt.getEsito_generale(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_codice_chiamata).equals(j)) {
						table.addCell(new Phrase(cnt.getCodice_chiamata(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_codice_archiviazione).equals(j)) {
						table.addCell(new Phrase(cnt.getCodice_archiviazione(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_codice_generale).equals(j)) {
						table.addCell(new Phrase(cnt.getCodice_generale(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_proprietario_denominazione).equals(j)) {
						table.addCell(new Phrase(cnt.getProprietario_denominazione(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_proprietario_codice).equals(j)) {
						table.addCell(new Phrase(cnt.getProprietario_codice(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_data_presentazione).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), cnt.getData_presentazione()), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_nota).equals(j)) {
						table.addCell(new Phrase(cnt.getNota(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_data_creazione).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), cnt.getData_creazione()), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_agente_denominazione).equals(j)) {
						table.addCell(new Phrase(cnt.getAgente_denominazione(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_agente_codice).equals(j)) {
						table.addCell(new Phrase(cnt.getAgente_codice(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_stato).equals(j)) {
						table.addCell(new Phrase(cnt.getTipoTesto(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_campagna_denominazione).equals(j)) {
						table.addCell(new Phrase(cnt.getCampagna_denominazione(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_lista_denominazione).equals(j)) {
						table.addCell(new Phrase(cnt.getLista_denominazione(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_campagna_codice).equals(j)) {
						table.addCell(new Phrase(cnt.getCampagna_codice(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_bloccato).equals(j)) {
						table.addCell(new Phrase(cnt.getBloccatoS(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_lista_codice).equals(j)) {
						table.addCell(new Phrase(cnt.getLista_codice(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_id).equals(j)) {
						table.addCell(new Phrase(cnt.getId().toString(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_positivo).equals(j)) {
						table.addCell(new Phrase(cnt.getPositivo(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_telefono_predefinito).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.uniforma(cnt.getTelefono_predefinito(), ti.getRem_predefinito(), ti.getAdd_predefinito()), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_utile).equals(j)) {
						table.addCell(new Phrase(cnt.getUtile(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_chiuso).equals(j)) {
						table.addCell(new Phrase(cnt.getChiuso(), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_cognome).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getCognome(), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_nome).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getNome(), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_nome_completo).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getNome_completo(), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_email).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getEmail(), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_codice_fiscale).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getCodice_fiscale(), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_sorgente).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getSorgente(), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_nota).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getNota(), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_luogo_nascita).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getLuogo_nascita(), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_data_nascita).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.date.stampa(), cnt.getAnagrafica().getDate_nascita()), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_link).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getLink(), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_privacy).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getPrivacy(), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_data_inserimento).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), cnt.getAnagrafica().getData_creazione()), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_tipo).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getTipo(), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_sesso).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getSesso(), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_partita_iva).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getPartita_iva(), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_ragione_sociale).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getRagione_sociale(), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_telefono_fisso).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.uniforma(cnt.getAnagrafica().getTelefono_fisso(), ti.getRem_fisso(), ti.getAdd_fisso()), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_telefono_altro).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.uniforma(cnt.getAnagrafica().getTelefono_altro(), ti.getRem_altro(), ti.getAdd_altro()), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_telefono_mobile).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.uniforma(cnt.getAnagrafica().getTelefono_mobile(), ti.getRem_mobile(), ti.getAdd_mobile()), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_telefono_fax).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.uniforma(cnt.getAnagrafica().getTelefono_fax(), ti.getRem_fax(), ti.getAdd_fax()), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_settore).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getSettore(), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_denominazione).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getDenominazione(), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_id).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIdentificativo(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_indirizzo_completo).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_legale().getIndirizzo_completo(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_strada_completo).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_legale().getStrada_completo(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_comune_completo).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_legale().getComune_completo(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_strada).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_legale().getStrada(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_civico).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_legale().getCivico(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_cap).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_legale().getCap(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_comune).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_legale().getComune(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_provincia).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_legale().getProvincia(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_regione).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_legale().getRegione(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_dettagli).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_legale().getDettagli(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_latitudine).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_legale().getLatitudine(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_longitudine).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_legale().getLongitudine(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_presso).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_legale().getPresso(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_indirizzo_completo).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_operativo().getIndirizzo_completo(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_strada_completo).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_operativo().getStrada_completo(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_comune_completo).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_operativo().getComune_completo(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_strada).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_operativo().getStrada(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_civico).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_operativo().getCivico(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_cap).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_operativo().getCap(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_comune).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_operativo().getComune(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_provincia).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_operativo().getProvincia(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_regione).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_operativo().getRegione(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_dettagli).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_operativo().getDettagli(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_latitudine).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_operativo().getLatitudine(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_longitudine).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_operativo().getLongitudine(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_presso).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_operativo().getPresso(), normal));
					} else if(ti.getPosizione(ConstantsMap.consenso_tfissoS).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getConsenso_tfissoS(), normal));
					} else if(ti.getPosizione(ConstantsMap.consenso_tmobileS).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getConsenso_tmobileS(), normal));
					} else if(ti.getPosizione(ConstantsMap.consenso_tfaxS).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getConsenso_tfaxS(), normal));
					} else if(ti.getPosizione(ConstantsMap.consenso_taltroS).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getConsenso_taltroS(), normal));
					} else if(ti.getPosizione(ConstantsMap.consenso_emailS).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getConsenso_emailS(), normal));
					} else if(ti.getPosizione(ConstantsMap.consenso_rmailS).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getConsenso_rmailS(), normal));
					} else {
						stampaDato(table, titles[j], cnt.getAnagrafica().getDettagli(), null);
					}
				}
			}
			document.add(table);
			document.close();
		} catch (Exception e) {
		}
	}
	public static void stampaPDFContrattoTemplate(Boolean p, List<Contratto>  data, OutputStream out, TemplateExportContratto ti, AnagraficaDao anagraficaDao, String password) {
		List <String> titlesList = ti.getValore_multiplo();
		List <String> aggiuntivi = ListUtils.subtract(titlesList, new ArrayList<String>(ConstantsMap.contrattoMap));
		if(p!=null && ApplicationUtil.notEmpty(aggiuntivi)) {
			List <String> invA = anagraficaDao.getEtichetteInvisibiliByChiave(p, CampoAggiuntivoAnagrafica.class);
			List <String> invB = anagraficaDao.getEtichetteInvisibiliByChiave(p, CampoAggiuntivoContratto.class);
			aggiuntivi.removeAll(invA);
			aggiuntivi.removeAll(invB);
			titlesList.removeAll(invA);
			titlesList.removeAll(invB);
		}
		if(ApplicationUtil.notEmpty(aggiuntivi)) {
			data = anagraficaDao.loadFullContratto(data);
		}
		String[] titles = titlesList.toArray(new String[0]);
		try {
			Document document = new Document(ApplicationUtil.pageSize(titles.length));
			ApplicationUtil.passwordPDF(document, out, password);
			document.open();
			document.addTitle(ConstantsLanguage.CONTRATTI.stampa());
			document.addSubject( ConstantsLanguage.CONTRATTI.stampa());
			document.addKeywords(ConstantsLanguage.CONTRATTI.stampa());
			document.addAuthor(AUTHOR);
			document.addCreator(CREATOR);
			Paragraph preface = new Paragraph("");
			preface.add(new Paragraph(ConstantsLanguage.TOTALE.stampa() + " " + ConstantsLanguage.CONTRATTI.stampa() + ": " + ApplicationUtil.formatNumber(data.size()) , title));
			preface.add(new Paragraph(SPACE));
			document.add(preface);
			PdfPTable table = new PdfPTable(titles.length);
			table.setWidthPercentage(100);
			if(ti.getIntestazione()) {
				for(String tt : titles) {
					PdfPCell c;
					if(ApplicationUtil.notEmpty(aggiuntivi) && aggiuntivi.contains(tt)) {
						String etichetta = anagraficaDao.getEtichettaByChiave(CampoAggiuntivoAnagrafica.class, tt);
						if(ApplicationUtil.isBlank(etichetta)) {
							etichetta = anagraficaDao.getEtichettaByChiave(CampoAggiuntivoContratto.class, tt);
						}
						c = new PdfPCell(new Phrase(etichetta, header));
					} else {
						c = new PdfPCell(new Phrase(Message.addCatalogText(tt), header));
					}
					c.setHorizontalAlignment(Element.ALIGN_LEFT);
					c.setBackgroundColor(BaseColor.YELLOW);
					table.addCell(c);
				}
				table.setHeaderRows(1);
			}
			for(Contratto crt : data) {
				Contatto cnt = crt.getContatto();
				for (int j = 0; j < titles.length; j++) {
					if(ti.getPosizione(ConstantsMap.contratto_data_creazione).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), crt.getData_creazione()), normal));
					} else if(ti.getPosizione(ConstantsMap.contratto_id).equals(j)) {
						table.addCell(new Phrase(crt.getId().toString(), normal));
					} else if(ti.getPosizione(ConstantsMap.contratto_operatore_denominazione).equals(j)) {
						table.addCell(new Phrase(crt.getOperatore_denominazione(), normal));
					} else if(ti.getPosizione(ConstantsMap.contratto_operatore_codice).equals(j)) {
						table.addCell(new Phrase(crt.getOperatore_codice(), normal));
					} else if(ti.getPosizione(ConstantsMap.contratto_agente_denominazione).equals(j)) {
						table.addCell(new Phrase(crt.getAgente_denominazione(), normal));
					} else if(ti.getPosizione(ConstantsMap.contratto_agente_codice).equals(j)) {
						table.addCell(new Phrase(crt.getAgente_codice(), normal));
					} else if(ti.getPosizione(ConstantsMap.contratto_categoria_denominazione).equals(j)) {
						table.addCell(new Phrase(crt.getCategoria_denominazione(), normal));
					} else if(ti.getPosizione(ConstantsMap.contratto_prodotto_denominazione).equals(j)) {
						table.addCell(new Phrase(crt.getProdotto_denominazione(), normal));
					} else if(ti.getPosizione(ConstantsMap.contratto_esito_contratto).equals(j)) {
						table.addCell(new Phrase(crt.getEsitoEtichetta(), normal));
					} else if(ti.getPosizione(ConstantsMap.contratto_codice_contratto).equals(j)) {
						table.addCell(new Phrase(crt.getEsitoCodice(), normal));
					} else if(ti.getPosizione(ConstantsMap.contratto_data_stipula).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.date.stampa(), crt.getData_stipula()), normal));
					} else if(ti.getPosizione(ConstantsMap.contratto_data_contabile).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.date.stampa(), crt.getData_contabile()), normal));
					} else if(ti.getPosizione(ConstantsMap.contratto_data_attivazione).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.date.stampa(), crt.getData_attivazione()), normal));
					} else if(ti.getPosizione(ConstantsMap.contratto_data_caricamento).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.date.stampa(), crt.getData_caricamento()), normal));
					} else if(ti.getPosizione(ConstantsMap.contratto_data_lavorazione).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), crt.getData_lavorazione()), normal));
					} else if(ti.getPosizione(ConstantsMap.contratto_utente_denominazione).equals(j)) {
						table.addCell(new Phrase(crt.getUtente_denominazione(), normal));
					} else if(ti.getPosizione(ConstantsMap.contratto_bloccato).equals(j)) {
						table.addCell(new Phrase(crt.getBloccatoS(), normal));
					} else if(ti.getPosizione(ConstantsMap.contratto_utente_codice).equals(j)) {
						table.addCell(new Phrase(crt.getUtente_codice(), normal));
					} else if(ti.getPosizione(ConstantsMap.contratto_data_esito).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), crt.getData_esito()), normal));
					} else if(ti.getPosizione(ConstantsMap.contratto_data_stato).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), crt.getData_stato()), normal));
					} else if(ti.getPosizione(ConstantsMap.contratto_nota).equals(j)) {
						table.addCell(new Phrase(crt.getNota(), normal));
					} else if(ti.getPosizione(ConstantsMap.contratto_tipo_seriale).equals(j)) {
						table.addCell(new Phrase(crt.getTipo_seriale(), normal));
					} else if(ti.getPosizione(ConstantsMap.contratto_seriale).equals(j)) {
						table.addCell(new Phrase(crt.getSeriale(), normal));
					} else if(ti.getPosizione(ConstantsMap.contratto_quantita).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.formatNumber(crt.getQuantita()), normal));
					} else if(ti.getPosizione(ConstantsMap.contratto_costo_scontato).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.formatNumber(crt.getCosto_scontato()), normal));
					} else if(ti.getPosizione(ConstantsMap.contratto_stato).equals(j)) {
						table.addCell(new Phrase(crt.getStatoTesto(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_data_lavorazione).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), cnt.getData_lavorazione()), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_operatore_denominazione).equals(j)) {
						table.addCell(new Phrase(cnt.getOperatore_denominazione(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_operatore_codice).equals(j)) {
						table.addCell(new Phrase(cnt.getOperatore_codice(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_data_archiviazione).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), cnt.getData_archiviazione()), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_esito_chiamata).equals(j)) {
						table.addCell(new Phrase(cnt.getEsito_chiamata(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_esito_archiviazione).equals(j)) {
						table.addCell(new Phrase(cnt.getEsito_archiviazione(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_esito_generale).equals(j)) {
						table.addCell(new Phrase(cnt.getEsito_generale(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_codice_chiamata).equals(j)) {
						table.addCell(new Phrase(cnt.getCodice_chiamata(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_codice_archiviazione).equals(j)) {
						table.addCell(new Phrase(cnt.getCodice_archiviazione(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_codice_generale).equals(j)) {
						table.addCell(new Phrase(cnt.getCodice_generale(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_proprietario_denominazione).equals(j)) {
						table.addCell(new Phrase(cnt.getProprietario_denominazione(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_proprietario_codice).equals(j)) {
						table.addCell(new Phrase(cnt.getProprietario_codice(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_data_presentazione).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), cnt.getData_presentazione()), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_nota).equals(j)) {
						table.addCell(new Phrase(cnt.getNota(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_data_creazione).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), cnt.getData_creazione()), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_agente_denominazione).equals(j)) {
						table.addCell(new Phrase(cnt.getAgente_denominazione(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_agente_codice).equals(j)) {
						table.addCell(new Phrase(cnt.getAgente_codice(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_stato).equals(j)) {
						table.addCell(new Phrase(cnt.getTipoTesto(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_campagna_denominazione).equals(j)) {
						table.addCell(new Phrase(cnt.getCampagna_denominazione(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_lista_denominazione).equals(j)) {
						table.addCell(new Phrase(cnt.getLista_denominazione(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_bloccato).equals(j)) {
						table.addCell(new Phrase(cnt.getBloccatoS(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_campagna_codice).equals(j)) {
						table.addCell(new Phrase(cnt.getCampagna_codice(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_lista_codice).equals(j)) {
						table.addCell(new Phrase(cnt.getLista_codice(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_id).equals(j)) {
						table.addCell(new Phrase(cnt.getId().toString(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_positivo).equals(j)) {
						table.addCell(new Phrase(cnt.getPositivo(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_telefono_predefinito).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.uniforma(cnt.getTelefono_predefinito(), ti.getRem_predefinito(), ti.getAdd_predefinito()), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_utile).equals(j)) {
						table.addCell(new Phrase(cnt.getUtile(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_chiuso).equals(j)) {
						table.addCell(new Phrase(cnt.getChiuso(), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_cognome).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getCognome(), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_nome).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getNome(), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_nome_completo).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getNome_completo(), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_email).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getEmail(), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_codice_fiscale).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getCodice_fiscale(), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_sorgente).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getSorgente(), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_nota).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getNota(), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_luogo_nascita).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getLuogo_nascita(), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_data_nascita).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.date.stampa(), cnt.getAnagrafica().getDate_nascita()), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_link).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getLink(), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_privacy).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getPrivacy(), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_data_inserimento).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), cnt.getAnagrafica().getData_creazione()), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_tipo).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getTipo(), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_sesso).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getSesso(), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_partita_iva).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getPartita_iva(), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_ragione_sociale).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getRagione_sociale(), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_telefono_fisso).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.uniforma(cnt.getAnagrafica().getTelefono_fisso(), ti.getRem_fisso(), ti.getAdd_fisso()), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_telefono_altro).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.uniforma(cnt.getAnagrafica().getTelefono_altro(), ti.getRem_altro(), ti.getAdd_altro()), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_telefono_mobile).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.uniforma(cnt.getAnagrafica().getTelefono_mobile(), ti.getRem_mobile(), ti.getAdd_mobile()), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_telefono_fax).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.uniforma(cnt.getAnagrafica().getTelefono_fax(), ti.getRem_fax(), ti.getAdd_fax()), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_settore).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getSettore(), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_denominazione).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getDenominazione(), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_id).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIdentificativo(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_indirizzo_completo).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_legale().getIndirizzo_completo(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_strada_completo).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_legale().getStrada_completo(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_comune_completo).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_legale().getComune_completo(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_strada).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_legale().getStrada(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_civico).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_legale().getCivico(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_cap).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_legale().getCap(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_comune).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_legale().getComune(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_provincia).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_legale().getProvincia(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_regione).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_legale().getRegione(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_dettagli).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_legale().getDettagli(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_latitudine).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_legale().getLatitudine(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_longitudine).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_legale().getLongitudine(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_presso).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_legale().getPresso(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_indirizzo_completo).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_operativo().getIndirizzo_completo(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_strada_completo).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_operativo().getStrada_completo(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_comune_completo).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_operativo().getComune_completo(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_strada).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_operativo().getStrada(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_civico).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_operativo().getCivico(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_cap).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_operativo().getCap(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_comune).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_operativo().getComune(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_provincia).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_operativo().getProvincia(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_regione).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_operativo().getRegione(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_dettagli).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_operativo().getDettagli(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_latitudine).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_operativo().getLatitudine(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_longitudine).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_operativo().getLongitudine(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_presso).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_operativo().getPresso(), normal));
					} else if(ti.getPosizione(ConstantsMap.consenso_tfissoS).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getConsenso_tfissoS(), normal));
					} else if(ti.getPosizione(ConstantsMap.consenso_tmobileS).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getConsenso_tmobileS(), normal));
					} else if(ti.getPosizione(ConstantsMap.consenso_tfaxS).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getConsenso_tfaxS(), normal));
					} else if(ti.getPosizione(ConstantsMap.consenso_taltroS).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getConsenso_taltroS(), normal));
					} else if(ti.getPosizione(ConstantsMap.consenso_emailS).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getConsenso_emailS(), normal));
					} else if(ti.getPosizione(ConstantsMap.consenso_rmailS).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getConsenso_rmailS(), normal));
					} else {
						stampaDato(table, titles[j], cnt.getAnagrafica().getDettagli(), crt.getDettagli());
					}
				}
			}
			document.add(table);
			document.close();
		} catch (Exception e) {
		}
	}
	public static void stampaPDFStoriaContatto(List<StoriaContatto> dettagli, OutputStream out, String password) {
		String [] titles =  new ExportUtility().titlesStoriaContatto;
		try {
			Document document = new Document(ApplicationUtil.pageSize(titles.length));
			ApplicationUtil.passwordPDF(document, out, password);
			document.open();
			document.addTitle(ConstantsLanguage.STORIA.stampa() + " " + ConstantsLanguage.CONTATTI.stampa());
			document.addSubject( ConstantsLanguage.STORIA.stampa() + " " + ConstantsLanguage.CONTATTI.stampa());
			document.addKeywords(ConstantsLanguage.STORIA.stampa() + " " + ConstantsLanguage.CONTATTI.stampa());
			document.addAuthor(AUTHOR);
			document.addCreator(CREATOR);
			Paragraph preface = new Paragraph("");
			preface.add(new Paragraph(ConstantsLanguage.TOTALE.stampa() + " " + ConstantsLanguage.STORIA.stampa() + " " + ConstantsLanguage.CONTATTI.stampa() + ": " + ApplicationUtil.formatNumber(dettagli.size()),title));
			preface.add(new Paragraph(SPACE));
			document.add(preface);
			PdfPTable table = new PdfPTable(titles.length);
			table.setWidthPercentage(100);
			for(String tt : titles) {
				PdfPCell c = new PdfPCell(new Phrase(tt, header));
				c.setHorizontalAlignment(Element.ALIGN_LEFT);
				c.setBackgroundColor(BaseColor.YELLOW);
				table.addCell(c);
			}
			table.setHeaderRows(1);
			for(StoriaContatto prd : dettagli) {
				table.addCell(new Phrase(prd.getId().toString(), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateSeconds.stampa(), prd.getData()), normal));
				table.addCell(new Phrase(prd.getBloccatoS(), normal));
				table.addCell(new Phrase(prd.getCampagna_denominazione(), normal));
				table.addCell(new Phrase(prd.getLista_denominazione(), normal));
				table.addCell(new Phrase(prd.getEsito_chiamata_etichettaCodice(), normal));
				table.addCell(new Phrase(prd.getEsito_archiviazione_etichettaCodice(), normal));
				table.addCell(new Phrase(prd.getContatto().getAnagrafica().getDenominazione(), normal));
				table.addCell(new Phrase(prd.getContatto().getAnagrafica().getCognome(), normal));
				table.addCell(new Phrase(prd.getContatto().getAnagrafica().getNome(), normal));
				table.addCell(new Phrase(prd.getContatto().getAnagrafica().getEmail(), normal));
				table.addCell(new Phrase(prd.getContatto().getAnagrafica().getTelefono_fisso(), normal));
				table.addCell(new Phrase(prd.getContatto().getAnagrafica().getTelefono_mobile(), normal));
				table.addCell(new Phrase(prd.getContatto().getAnagrafica().getTelefono_fax(), normal));
				table.addCell(new Phrase(prd.getContatto().getAnagrafica().getTelefono_altro(), normal));
				table.addCell(new Phrase(prd.getProprietario_denominazione(), normal));
				table.addCell(new Phrase(prd.getAgente_denominazione(), normal));
				table.addCell(new Phrase(prd.getOperatore_denominazione(), normal));
				table.addCell(new Phrase(prd.getChiuso(), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), prd.getData_presentazione()), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), prd.getData_archiviazione()), normal));
				table.addCell(new Phrase(prd.getNota(), normal));
				table.addCell(new Phrase(prd.getTipoTesto(), normal));
				table.addCell(new Phrase(ApplicationUtil.formatNumber(prd.getSecondi_tot()), normal));
				table.addCell(new Phrase(prd.getSecondi_totH(), normal));
				table.addCell(new Phrase(ApplicationUtil.formatNumber(prd.getSecondi_conv_eff()), normal));
				table.addCell(new Phrase(prd.getSecondi_conv_effH(), normal));
				table.addCell(new Phrase(ApplicationUtil.formatNumber(prd.getSecondi_conv_tot()), normal));
				table.addCell(new Phrase(prd.getSecondi_conv_totH(), normal));
				table.addCell(new Phrase(ApplicationUtil.formatNumber(prd.getSecondi_post()), normal));
				table.addCell(new Phrase(prd.getSecondi_postH(), normal));
				table.addCell(new Phrase(ApplicationUtil.formatNumber(prd.getSecondi_pre()), normal));
				table.addCell(new Phrase(prd.getSecondi_preH(), normal));
				table.addCell(new Phrase(ApplicationUtil.formatNumber(prd.getSecondi_rec()), normal));
				table.addCell(new Phrase(prd.getSecondi_recH(), normal));
				table.addCell(new Phrase(ApplicationUtil.formatNumber(prd.getSecondi_attesa()), normal));
				table.addCell(new Phrase(prd.getSecondi_attesaH(), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateSeconds.stampa(), prd.getDate_apertura()), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateSeconds.stampa(), prd.getDate_chiamata()), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateSeconds.stampa(), prd.getDate_risposta()), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateSeconds.stampa(), prd.getDate_rec_inizio()), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateSeconds.stampa(), prd.getDate_rec_fine()), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateSeconds.stampa(), prd.getDate_fine()), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateSeconds.stampa(), prd.getDate_esito()), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateSeconds.stampa(), prd.getDate_attesa_inizio()), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateSeconds.stampa(), prd.getDate_attesa_fine()), normal));
				table.addCell(new Phrase(prd.getContatto().getAnagrafica().getIndirizzo_legale().getIndirizzo_completo(), normal));
				table.addCell(new Phrase(prd.getContatto().getAnagrafica().getIndirizzo_operativo().getIndirizzo_completo(), normal));
			}
			document.add(table);
			document.close();
		} catch (Exception e) {
		}
	}
	public static void stampaPDFStoriaAppuntamento(List<StoriaAppuntamento>  dettagli, OutputStream out, String password) {
		String [] titles =  new ExportUtility().titlesStoriaAppuntamento;
		try {
			Document document = new Document(ApplicationUtil.pageSize(titles.length));
			ApplicationUtil.passwordPDF(document, out, password);
			document.open();
			document.addTitle(ConstantsLanguage.STORIA.stampa() + " " + ConstantsLanguage.APPUNTAMENTI.stampa());
			document.addSubject( ConstantsLanguage.STORIA.stampa() + " " + ConstantsLanguage.APPUNTAMENTI.stampa());
			document.addKeywords(ConstantsLanguage.STORIA.stampa() + " " + ConstantsLanguage.APPUNTAMENTI.stampa());
			document.addAuthor(AUTHOR);
			document.addCreator(CREATOR);
			Paragraph preface = new Paragraph("");
			preface.add(new Paragraph(ConstantsLanguage.TOTALE.stampa() + " " + ConstantsLanguage.STORIA.stampa() + " " + ConstantsLanguage.APPUNTAMENTI.stampa() + ": " + ApplicationUtil.formatNumber(dettagli.size()),title));
			preface.add(new Paragraph(SPACE));
			document.add(preface);
			PdfPTable table = new PdfPTable(titles.length);
			table.setWidthPercentage(100);
			for(String tt : titles) {
				PdfPCell c = new PdfPCell(new Phrase(tt, header));
				c.setHorizontalAlignment(Element.ALIGN_LEFT);
				c.setBackgroundColor(BaseColor.YELLOW);
				table.addCell(c);
			}
			table.setHeaderRows(1);
			for(StoriaAppuntamento prd : dettagli) {
				table.addCell(new Phrase(prd.getId().toString(), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateSeconds.stampa(), prd.getData()), normal));
				table.addCell(new Phrase(prd.getBloccatoS(), normal));
				table.addCell(new Phrase(prd.getAppuntamento().getContatto().getCampagna_denominazione(), normal));
				table.addCell(new Phrase(prd.getAppuntamento().getContatto().getLista_denominazione(), normal));
				table.addCell(new Phrase(prd.getEsitoEtichettaCodice(), normal));
				table.addCell(new Phrase(prd.getAppuntamento().getContatto().getAnagrafica().getDenominazione(), normal));
				table.addCell(new Phrase(prd.getAppuntamento().getContatto().getAnagrafica().getCognome(), normal));
				table.addCell(new Phrase(prd.getAppuntamento().getContatto().getAnagrafica().getNome(), normal));
				table.addCell(new Phrase(prd.getAppuntamento().getContatto().getAnagrafica().getEmail(), normal));
				table.addCell(new Phrase(prd.getAppuntamento().getContatto().getAnagrafica().getTelefono_fisso(), normal));
				table.addCell(new Phrase(prd.getAppuntamento().getContatto().getAnagrafica().getTelefono_mobile(), normal));
				table.addCell(new Phrase(prd.getAppuntamento().getContatto().getAnagrafica().getTelefono_fax(), normal));
				table.addCell(new Phrase(prd.getAppuntamento().getContatto().getAnagrafica().getTelefono_altro(), normal));
				table.addCell(new Phrase(prd.getOperatore_denominazione(), normal));
				table.addCell(new Phrase(prd.getAgente_denominazione(), normal));
				table.addCell(new Phrase(prd.getUtente_denominazione(), normal));
				table.addCell(new Phrase(prd.getNota(), normal));
				table.addCell(new Phrase(prd.getStatoTesto(), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.date.stampa(), prd.getData_inizio()), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.time.stampa(), prd.getData_inizio()), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.time.stampa(), prd.getData_fine()), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), prd.getData_conferma()), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), prd.getData_esito()), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), prd.getData_stato()), normal));
				table.addCell(new Phrase(prd.getLocalizzazioneString(), normal));
				table.addCell(new Phrase(prd.getAppuntamento().getContatto().getAnagrafica().getIndirizzo_legale().getIndirizzo_completo(), normal));
				table.addCell(new Phrase(prd.getAppuntamento().getContatto().getAnagrafica().getIndirizzo_operativo().getIndirizzo_completo(), normal));
			}
			document.add(table);
			document.close();
		} catch (Exception e) {
		}
	}
	public static void stampaPDFStoriaContratto(List<StoriaContratto>  dettagli, OutputStream out, String password) {
		String [] titles =  new ExportUtility().titlesStoriaContratto;
		try {
			Document document = new Document(ApplicationUtil.pageSize(titles.length));
			ApplicationUtil.passwordPDF(document, out, password);
			document.open();
			document.addTitle(ConstantsLanguage.STORIA.stampa() + " " + ConstantsLanguage.CONTRATTI.stampa());
			document.addSubject( ConstantsLanguage.STORIA.stampa() + " " + ConstantsLanguage.CONTRATTI.stampa());
			document.addKeywords(ConstantsLanguage.STORIA.stampa() + " " + ConstantsLanguage.CONTRATTI.stampa());
			document.addAuthor(AUTHOR);
			document.addCreator(CREATOR);
			Paragraph preface = new Paragraph("");
			preface.add(new Paragraph(ConstantsLanguage.TOTALE.stampa() + " " + ConstantsLanguage.STORIA.stampa() + " " + ConstantsLanguage.CONTRATTI.stampa() + ": " + ApplicationUtil.formatNumber(dettagli.size()),title));
			preface.add(new Paragraph(SPACE));
			document.add(preface);
			PdfPTable table = new PdfPTable(titles.length);
			table.setWidthPercentage(100);
			for(String tt : titles) {
				PdfPCell c = new PdfPCell(new Phrase(tt, header));
				c.setHorizontalAlignment(Element.ALIGN_LEFT);
				c.setBackgroundColor(BaseColor.YELLOW);
				table.addCell(c);
			}
			table.setHeaderRows(1);
			for(StoriaContratto prd : dettagli) {
				table.addCell(new Phrase(prd.getId().toString(), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateSeconds.stampa(), prd.getData()), normal));
				table.addCell(new Phrase(prd.getBloccatoS(), normal));
				table.addCell(new Phrase(prd.getContratto().getContatto().getCampagna_denominazione(), normal));
				table.addCell(new Phrase(prd.getContratto().getContatto().getLista_denominazione(), normal));
				table.addCell(new Phrase(prd.getEsitoEtichettaCodice(), normal));
				table.addCell(new Phrase(prd.getContratto().getContatto().getAnagrafica().getDenominazione(), normal));
				table.addCell(new Phrase(prd.getContratto().getContatto().getAnagrafica().getCognome(), normal));
				table.addCell(new Phrase(prd.getContratto().getContatto().getAnagrafica().getNome(), normal));
				table.addCell(new Phrase(prd.getContratto().getContatto().getAnagrafica().getEmail(), normal));
				table.addCell(new Phrase(prd.getContratto().getContatto().getAnagrafica().getTelefono_fisso(), normal));
				table.addCell(new Phrase(prd.getContratto().getContatto().getAnagrafica().getTelefono_mobile(), normal));
				table.addCell(new Phrase(prd.getContratto().getContatto().getAnagrafica().getTelefono_fax(), normal));
				table.addCell(new Phrase(prd.getContratto().getContatto().getAnagrafica().getTelefono_altro(), normal));
				table.addCell(new Phrase(prd.getOperatore_denominazione(), normal));
				table.addCell(new Phrase(prd.getAgente_denominazione(), normal));
				table.addCell(new Phrase(prd.getUtente_denominazione(), normal));
				table.addCell(new Phrase(prd.getNota(), normal));
				table.addCell(new Phrase(prd.getStatoTesto(), normal));
				table.addCell(new Phrase(prd.getSeriale(), normal));
				table.addCell(new Phrase(prd.getCategoria_denominazione(), normal));
				table.addCell(new Phrase(prd.getProdotto_denominazione(), normal));
				table.addCell(new Phrase(ApplicationUtil.formatNumber(prd.getQuantita()), normal));
				table.addCell(new Phrase(ApplicationUtil.formatNumber(prd.getCosto_scontato()), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.date.stampa(), prd.getData_contabile()), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.date.stampa(), prd.getData_stipula()), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.date.stampa(), prd.getData_attivazione()), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.date.stampa(), prd.getData_caricamento()), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), prd.getData_esito()), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), prd.getData_stato()), normal));
				table.addCell(new Phrase(prd.getContratto().getContatto().getAnagrafica().getIndirizzo_legale().getIndirizzo_completo(), normal));
				table.addCell(new Phrase(prd.getContratto().getContatto().getAnagrafica().getIndirizzo_operativo().getIndirizzo_completo(), normal));
			}
			document.add(table);
			document.close();
		} catch (Exception e) {
		}
	}
	private static void stampaDato(PdfPTable table, String campo, List<DatoAggiuntivoAnagrafica> dati1, List<DatoAggiuntivoContratto> dati2) {
		boolean inserito = false;
		DatoAggiuntivoAnagrafica da1 = ApplicationUtil.getDatoAnagrafica(campo, dati1);
		if(da1!= null) {
			inserito = true;
			table.addCell(new Phrase(ApplicationUtil.trimToEmpty(da1.getValore_formattato()), normal));
		} 
		if(dati2 != null && !inserito) {
			DatoAggiuntivoContratto da2 = ApplicationUtil.getDatoContratto(campo, dati2);
			if(da2!= null) { 
				inserito = true;
				table.addCell(new Phrase(ApplicationUtil.trimToEmpty(da2.getValore_formattato()), normal));
			} 
		}
		if(!inserito) {
			table.addCell(new Phrase("", normal));
		}
	}
	
	private static void stampaDato(PdfPTable table, Long id, List<DatoAggiuntivoAnagrafica> dati1, List<DatoAggiuntivoContratto> dati2) {
		boolean inserito = false;
		DatoAggiuntivoAnagrafica da1 = ApplicationUtil.getDatoAnagrafica(id, dati1);
		if(da1!= null) {
			inserito = true;
			table.addCell(new Phrase(ApplicationUtil.trimToEmpty(da1.getValore_formattato()), normal));
		} 
		if(dati2 != null && !inserito) {
			DatoAggiuntivoContratto da2 = ApplicationUtil.getDatoContratto(id, dati2);
			if(da2!= null) { 
				inserito = true;
				table.addCell(new Phrase(ApplicationUtil.trimToEmpty(da2.getValore_formattato()), normal));
			} 
		}
		if(!inserito) {
			table.addCell(new Phrase("", normal));
		}
	}
	public static void stampaPDFMarcatura(List<Marcatura>  dettagli, OutputStream out, String password) {
		String [] titles = new ExportUtility().titlesMarcatura;
		try {
			Document document = new Document(ApplicationUtil.pageSize(titles.length));
			ApplicationUtil.passwordPDF(document, out, password);
			document.open();
			document.addTitle(ConstantsLanguage.MARCATURE.stampa());
			document.addSubject( ConstantsLanguage.MARCATURE.stampa());
			document.addKeywords(ConstantsLanguage.MARCATURE.stampa());
			document.addAuthor(AUTHOR);
			document.addCreator(CREATOR);
			Paragraph preface = new Paragraph("");
			preface.add(new Paragraph(ConstantsLanguage.TOTALE.stampa() + " " + ConstantsLanguage.MARCATURE.stampa() + ": " + ApplicationUtil.formatNumber(dettagli.size()) , title));
			preface.add(new Paragraph(SPACE));
			document.add(preface);
			PdfPTable table = new PdfPTable(titles.length);
			table.setWidthPercentage(100);
			for(String tt : titles) {
				PdfPCell c = new PdfPCell(new Phrase(tt, header));
				c.setHorizontalAlignment(Element.ALIGN_LEFT);
				c.setBackgroundColor(BaseColor.YELLOW);
				table.addCell(c);
			}
			table.setHeaderRows(1);
			for(Marcatura prd : dettagli) {
				table.addCell(new Phrase(prd.getId().toString(), normal));
				table.addCell(new Phrase(prd.getUser().getDenominazione(), normal));
				table.addCell(new Phrase(prd.getDurata(), normal));
				table.addCell(new Phrase(ApplicationUtil.formatNumber(prd.getDurataTime()), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.date.stampa(), prd.getData_creazione()), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.time.stampa(), prd.getData_inizio()), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.time.stampa(), prd.getData_fine()), normal));
			}
			document.add(table);
			document.close();
		} catch (Exception e) {
		}
	}
	public static void stampaPDFPausa(List<Pausa>  dettagli, OutputStream out, String password) {
		String [] titles = new ExportUtility().titlesPausa;
		try {
			Document document = new Document(ApplicationUtil.pageSize(titles.length));
			ApplicationUtil.passwordPDF(document, out, password);
			document.open();
			document.addTitle(ConstantsLanguage.PAUSE.stampa());
			document.addSubject( ConstantsLanguage.PAUSE.stampa());
			document.addKeywords(ConstantsLanguage.PAUSE.stampa());
			document.addAuthor(AUTHOR);
			document.addCreator(CREATOR);
			Paragraph preface = new Paragraph("");
			preface.add(new Paragraph(ConstantsLanguage.TOTALE.stampa() + " " + ConstantsLanguage.PAUSE.stampa() + ": " + ApplicationUtil.formatNumber(dettagli.size()) , title));
			preface.add(new Paragraph(SPACE));
			document.add(preface);
			PdfPTable table = new PdfPTable(titles.length);
			table.setWidthPercentage(100);
			for(String tt : titles) {
				PdfPCell c = new PdfPCell(new Phrase(tt, header));
				c.setHorizontalAlignment(Element.ALIGN_LEFT);
				c.setBackgroundColor(BaseColor.YELLOW);
				table.addCell(c);
			}
			table.setHeaderRows(1);
			for(Pausa prd : dettagli) {
				table.addCell(new Phrase(prd.getId().toString(), normal));
				table.addCell(new Phrase(prd.getUser().getDenominazione(), normal));
				table.addCell(new Phrase(prd.getDurata(), normal));
				table.addCell(new Phrase(ApplicationUtil.formatNumber(prd.getDurataTime()), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.date.stampa(), prd.getData_creazione()), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.time.stampa(), prd.getData_inizio()), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.time.stampa(), prd.getData_fine()), normal));
			}
			document.add(table);
			document.close();
		} catch (Exception e) {
		}
	}
	public static void stampaPDFOperazione(List<Operazione>  dettagli, OutputStream out, String password) {
		String [] titles = new ExportUtility().titlesOperazione;
		try {
			Document document = new Document(ApplicationUtil.pageSize(titles.length));
			ApplicationUtil.passwordPDF(document, out, password);
			document.open();
			document.addTitle(ConstantsLanguage.OPERAZIONI.stampa());
			document.addSubject( ConstantsLanguage.OPERAZIONI.stampa());
			document.addKeywords(ConstantsLanguage.OPERAZIONI.stampa());
			document.addAuthor(AUTHOR);
			document.addCreator(CREATOR);
			Paragraph preface = new Paragraph("");
			preface.add(new Paragraph(ConstantsLanguage.TOTALE.stampa() + " " + ConstantsLanguage.OPERAZIONI.stampa() + ": " + ApplicationUtil.formatNumber(dettagli.size()) , title));
			preface.add(new Paragraph(SPACE));
			document.add(preface);
			PdfPTable table = new PdfPTable(titles.length);
			table.setWidthPercentage(100);
			for(String tt : titles) {
				PdfPCell c = new PdfPCell(new Phrase(tt, header));
				c.setHorizontalAlignment(Element.ALIGN_LEFT);
				c.setBackgroundColor(BaseColor.YELLOW);
				table.addCell(c);
			}
			table.setHeaderRows(1);
			for(Operazione prd : dettagli) {
				table.addCell(new Phrase(prd.getId().toString(), normal));
				table.addCell(new Phrase(prd.getUser().getDenominazione(), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), prd.getData_creazione()), normal));
				table.addCell(new Phrase(Message.addCatalogMessage(prd.getOperazioneTesto()), normal));
				table.addCell(new Phrase(prd.getDescrizioneLong(), normal));
			}
			document.add(table);
			document.close();
		} catch (Exception e) {
		}
	}
	public static void stampaPDFAutoContatto(List<AutoContatto>  dettagli, OutputStream out, String password) {
		String [] titles = new ExportUtility().titlesAutoContatto;
		try {
			Document document = new Document(ApplicationUtil.pageSize(titles.length));
			ApplicationUtil.passwordPDF(document, out, password);
			document.open();
			document.addTitle(ConstantsLanguage.AUTO_CONTATTI.stampa());
			document.addSubject( ConstantsLanguage.AUTO_CONTATTI.stampa());
			document.addKeywords(ConstantsLanguage.AUTO_CONTATTI.stampa());
			document.addAuthor(AUTHOR);
			document.addCreator(CREATOR);
			Paragraph preface = new Paragraph("");
			preface.add(new Paragraph(ConstantsLanguage.TOTALE.stampa() + " " + ConstantsLanguage.AUTO_CONTATTI.stampa() + ": " + ApplicationUtil.formatNumber(dettagli.size()) , title));
			preface.add(new Paragraph(SPACE));
			document.add(preface);
			PdfPTable table = new PdfPTable(titles.length);
			table.setWidthPercentage(100);
			for(String tt : titles) {
				PdfPCell c = new PdfPCell(new Phrase(tt, header));
				c.setHorizontalAlignment(Element.ALIGN_LEFT);
				c.setBackgroundColor(BaseColor.YELLOW);
				table.addCell(c);
			}
			table.setHeaderRows(1);
			for(AutoContatto prd : dettagli) {
				table.addCell(new Phrase(prd.getId().toString(), normal));
				table.addCell(new Phrase(prd.getContatto().getCampagna_denominazione(), normal));
				table.addCell(new Phrase(prd.getContatto().getLista_denominazione(), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), prd.getData_creazione()), normal));
				table.addCell(new Phrase(prd.getContatto().getDenominazione(), normal));
				table.addCell(new Phrase(prd.getCaller1(), normal));
				table.addCell(new Phrase(prd.getCallee1(), normal));
				table.addCell(new Phrase(prd.getCaller2(), normal));
				table.addCell(new Phrase(prd.getCallee2(), normal));
				table.addCell(new Phrase(prd.getRingingS(), normal));
				table.addCell(new Phrase(prd.getInboundS(), normal));
				table.addCell(new Phrase(Message.addCatalogText(prd.getStatoContatto()), normal));
				table.addCell(new Phrase(prd.getCause(), normal));
				table.addCell(new Phrase(ApplicationUtil.formatNumber(prd.getTentativi()), normal));
				table.addCell(new Phrase(ApplicationUtil.formatNumber(prd.getSecondi_avvio()), normal));
				table.addCell(new Phrase(prd.getSecondi_avvioH(), normal));
				table.addCell(new Phrase(ApplicationUtil.formatNumber(prd.getSecondi_chiamata()), normal));
				table.addCell(new Phrase(prd.getSecondi_chiamataH(), normal));
				table.addCell(new Phrase(ApplicationUtil.formatNumber(prd.getSecondi_conversazione()), normal));
				table.addCell(new Phrase(prd.getSecondi_conversazioneH(), normal));
				table.addCell(new Phrase(ApplicationUtil.formatNumber(prd.getSecondi_totale()), normal));
				table.addCell(new Phrase(prd.getSecondi_totaleH(), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateSeconds.stampa(), prd.getData_avvio()), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateSeconds.stampa(), prd.getData_chiamata()), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateSeconds.stampa(), prd.getData_risposta()), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateSeconds.stampa(), prd.getData_gestione()), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateSeconds.stampa(), prd.getData_apertura()), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateSeconds.stampa(), prd.getData_attesa()), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateSeconds.stampa(), prd.getData_aggancio()), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateSeconds.stampa(), prd.getData_rifiuto()), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateSeconds.stampa(), prd.getData_link()), normal));
			}
			document.add(table);
			document.close();
		} catch (Exception e) {
		}
	}
	public static void stampaPDFNota(List<Nota>  dettagli, OutputStream out, String password) {
		String [] titles = new ExportUtility().titlesNota;
		try {
			Document document = new Document(ApplicationUtil.pageSize(titles.length));
			ApplicationUtil.passwordPDF(document, out, password);
			document.open();
			document.addTitle(ConstantsLanguage.NOTE.stampa());
			document.addSubject( ConstantsLanguage.NOTE.stampa());
			document.addKeywords(ConstantsLanguage.NOTE.stampa());
			document.addAuthor(AUTHOR);
			document.addCreator(CREATOR);
			Paragraph preface = new Paragraph("");
			preface.add(new Paragraph(ConstantsLanguage.TOTALE.stampa() + " " + ConstantsLanguage.NOTE.stampa() + ": " + ApplicationUtil.formatNumber(dettagli.size()) , title));
			preface.add(new Paragraph(SPACE));
			document.add(preface);
			PdfPTable table = new PdfPTable(titles.length);
			table.setWidthPercentage(100);
			for(String tt : titles) {
				PdfPCell c = new PdfPCell(new Phrase(tt, header));
				c.setHorizontalAlignment(Element.ALIGN_LEFT);
				c.setBackgroundColor(BaseColor.YELLOW);
				table.addCell(c);
			}
			table.setHeaderRows(1);
			for(Nota prd : dettagli) {
				table.addCell(new Phrase(prd.getId().toString(), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), prd.getData_creazione()), normal));
				table.addCell(new Phrase(prd.getBloccatoS(), normal));
				table.addCell(new Phrase(prd.getOperatore().getDenominazione(), normal));
				table.addCell(new Phrase(prd.getNote(), normal));
				table.addCell(new Phrase(prd.getAgente().getDenominazione(), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.date.stampa(), prd.getData_inizio()), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.time.stampa(), prd.getData_inizio()), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.time.stampa(), prd.getData_fine()), normal));
				table.addCell(new Phrase(ApplicationUtil.formatNumber(prd.getRipetizioni()), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.date.stampa(), prd.getData_termine()), normal));
				table.addCell(new Phrase(prd.getColore(), normal));
			}
			document.add(table);
			document.close();
		} catch (Exception e) {
		}
	}
	public static void stampaPDFContattoSI(List<ContattoSI>  contatti1, List<ContattoSI>  contatti2, OutputStream out, String password) {
		String [] titles = new ExportUtility().titlesContattoSI;
		try {
			Document document = new Document(ApplicationUtil.pageSize(titles.length));
			ApplicationUtil.passwordPDF(document, out, password);
			document.open();
			document.addTitle(ConstantsLanguage.CONTATTI.stampa());
			document.addSubject( ConstantsLanguage.CONTATTI.stampa());
			document.addKeywords(ConstantsLanguage.CONTATTI.stampa());
			document.addAuthor(AUTHOR);
			document.addCreator(CREATOR);
			Paragraph preface = new Paragraph("");
			preface.add(new Paragraph(ConstantsLanguage.TOTALE.stampa() + " " + ConstantsLanguage.CONTATTI.stampa() + ": " + ApplicationUtil.formatNumber(contatti1.size() + contatti2.size()) , title));
			preface.add(new Paragraph(SPACE));
			document.add(preface);
			PdfPTable table = new PdfPTable(titles.length);
			table.setWidthPercentage(100);
			for(String tt : titles) {
				PdfPCell c = new PdfPCell(new Phrase(tt, header));
				c.setHorizontalAlignment(Element.ALIGN_LEFT);
				c.setBackgroundColor(BaseColor.YELLOW);
				table.addCell(c);
			}
			table.setHeaderRows(1);
			for(ContattoSI prd : contatti1) {
				table.addCell(new Phrase(ConstantsLanguage.NO.stampa(), normal));
				table.addCell(new Phrase(prd.getId().toString(), normal));
				table.addCell(new Phrase(prd.getCampagna_denominazione(), normal));
				table.addCell(new Phrase(prd.getLista_denominazione(), normal));
				table.addCell(new Phrase(prd.getAnagrafica_denominazione(), normal));
				table.addCell(new Phrase(prd.getAnagrafica_cognome(), normal));
				table.addCell(new Phrase(prd.getAnagrafica_nome(), normal));
				table.addCell(new Phrase(prd.getAnagrafica_email(), normal));
				table.addCell(new Phrase(prd.getAnagrafica_link(), normal));
				table.addCell(new Phrase(prd.getAnagrafica_telefono_fisso(), normal));
				table.addCell(new Phrase(prd.getAnagrafica_telefono_mobile(), normal));
				table.addCell(new Phrase(prd.getAnagrafica_telefono_fax(), normal));
				table.addCell(new Phrase(prd.getAnagrafica_telefono_altro(), normal));
				table.addCell(new Phrase(prd.getAnagrafica_codice_fiscale(), normal));
				table.addCell(new Phrase(prd.getAnagrafica_partita_iva(), normal));
				table.addCell(new Phrase(prd.getEsito_chiamata_etichettaCodice(), normal));
				table.addCell(new Phrase(prd.getEsito_archiviazione_etichettaCodice(), normal));
				table.addCell(new Phrase(prd.getChiuso(), normal));
			}
			for(ContattoSI prd : contatti2) {
				table.addCell(new Phrase(ConstantsLanguage.SI.stampa(), normal));
				table.addCell(new Phrase(prd.getId().toString(), normal));
				table.addCell(new Phrase(prd.getCampagna_denominazione(), normal));
				table.addCell(new Phrase(prd.getLista_denominazione(), normal));
				table.addCell(new Phrase(prd.getAnagrafica_denominazione(), normal));
				table.addCell(new Phrase(prd.getAnagrafica_cognome(), normal));
				table.addCell(new Phrase(prd.getAnagrafica_nome(), normal));
				table.addCell(new Phrase(prd.getAnagrafica_email(), normal));
				table.addCell(new Phrase(prd.getAnagrafica_link(), normal));
				table.addCell(new Phrase(prd.getAnagrafica_telefono_fisso(), normal));
				table.addCell(new Phrase(prd.getAnagrafica_telefono_mobile(), normal));
				table.addCell(new Phrase(prd.getAnagrafica_telefono_fax(), normal));
				table.addCell(new Phrase(prd.getAnagrafica_telefono_altro(), normal));
				table.addCell(new Phrase(prd.getAnagrafica_codice_fiscale(), normal));
				table.addCell(new Phrase(prd.getAnagrafica_partita_iva(), normal));
				table.addCell(new Phrase(prd.getEsito_chiamata_etichettaCodice(), normal));
				table.addCell(new Phrase(prd.getEsito_archiviazione_etichettaCodice(), normal));
				table.addCell(new Phrase(prd.getChiuso(), normal));
			}
			document.add(table);
			document.close();
		} catch (Exception e) {
		}
	}
	public static void stampaPDFChiamate(CopyOnWriteArrayList<AutoContatto>  dettagli, OutputStream out, String password) {
		String [] titles = new ExportUtility().titlesChiamate;
		try {
			Document document = new Document(ApplicationUtil.pageSize(titles.length));
			ApplicationUtil.passwordPDF(document, out, password);
			document.open();
			document.addTitle(ConstantsLanguage.AUTO_CONTATTI.stampa());
			document.addSubject( ConstantsLanguage.AUTO_CONTATTI.stampa());
			document.addKeywords(ConstantsLanguage.AUTO_CONTATTI.stampa());
			document.addAuthor(AUTHOR);
			document.addCreator(CREATOR);
			Paragraph preface = new Paragraph("");
			preface.add(new Paragraph(ConstantsLanguage.TOTALE.stampa() + " " + ConstantsLanguage.AUTO_CONTATTI.stampa() + ": " + ApplicationUtil.formatNumber(dettagli.size()) , title));
			preface.add(new Paragraph(SPACE));
			document.add(preface);
			PdfPTable table = new PdfPTable(titles.length);
			table.setWidthPercentage(100);
			for(String tt : titles) {
				PdfPCell c = new PdfPCell(new Phrase(tt, header));
				c.setHorizontalAlignment(Element.ALIGN_LEFT);
				c.setBackgroundColor(BaseColor.YELLOW);
				table.addCell(c);
			}
			table.setHeaderRows(1);
			for(AutoContatto prd : dettagli) {
				table.addCell(new Phrase(prd.getContatto_id().toString(), normal));
				table.addCell(new Phrase(prd.getCampagna_denominazione(), normal));
				table.addCell(new Phrase(prd.getLista_denominazione(), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateSeconds.stampa(), prd.getData()), normal));
				table.addCell(new Phrase(prd.getAnagrafica_denominazione(), normal));
				table.addCell(new Phrase(prd.getTelefono(), normal));
				table.addCell(new Phrase(prd.getCaller1(), normal));
				table.addCell(new Phrase(prd.getCallee1(), normal));
				table.addCell(new Phrase(prd.getCaller2(), normal));
				table.addCell(new Phrase(prd.getCallee2(), normal));
				table.addCell(new Phrase(prd.getRingingS(), normal));
				table.addCell(new Phrase(prd.getInboundS(), normal));
				table.addCell(new Phrase(Message.addCatalogText(prd.getStatoContatto()), normal));
				table.addCell(new Phrase(prd.getCause(), normal));
				table.addCell(new Phrase(ApplicationUtil.formatNumber(prd.getTentativi()), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateSeconds.stampa(), prd.getData_avvio()), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateSeconds.stampa(), prd.getData_chiamata()), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateSeconds.stampa(), prd.getData_risposta()), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateSeconds.stampa(), prd.getData_gestione()), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateSeconds.stampa(), prd.getData_attesa()), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateSeconds.stampa(), prd.getData_aggancio()), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateSeconds.stampa(), prd.getData_rifiuto()), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateSeconds.stampa(), prd.getData_link()), normal));
			}
			document.add(table);
			document.close();
		} catch (Exception e) {
		}
	}
	public static void stampaPDFEmail(List<Email>  dettagli, OutputStream out, String password) {
		String [] titles = new ExportUtility().titlesEmail;
		try {
			Document document = new Document(ApplicationUtil.pageSize(titles.length));
			ApplicationUtil.passwordPDF(document, out, password);
			document.open();
			document.addTitle(ConstantsLanguage.EMAIL.stampa());
			document.addSubject( ConstantsLanguage.EMAIL.stampa());
			document.addKeywords(ConstantsLanguage.EMAIL.stampa());
			document.addAuthor(AUTHOR);
			document.addCreator(CREATOR);
			Paragraph preface = new Paragraph("");
			preface.add(new Paragraph(ConstantsLanguage.TOTALE.stampa() + " " + ConstantsLanguage.EMAIL.stampa() + ": " + ApplicationUtil.formatNumber(dettagli.size()) , title));
			preface.add(new Paragraph(SPACE));
			document.add(preface);
			PdfPTable table = new PdfPTable(titles.length);
			table.setWidthPercentage(100);
			for(String tt : titles) {
				PdfPCell c = new PdfPCell(new Phrase(tt, header));
				c.setHorizontalAlignment(Element.ALIGN_LEFT);
				c.setBackgroundColor(BaseColor.YELLOW);
				table.addCell(c);
			}
			table.setHeaderRows(1);
			for(Email prd : dettagli) {
				table.addCell(new Phrase(prd.getId().toString(), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateSeconds.stampa(), prd.getData_invio()), normal));
				table.addCell(new Phrase(prd.getContatto().getCampagna_denominazione(), normal));
				table.addCell(new Phrase(prd.getContatto().getLista_denominazione(), normal));
				table.addCell(new Phrase(prd.getContatto().getDenominazione(), normal));
				table.addCell(new Phrase(prd.getDestinatario(), normal));
				table.addCell(new Phrase(prd.getUtente_denominazione(), normal));
				table.addCell(new Phrase(prd.getOggetto(), normal));
				table.addCell(new Phrase(prd.getStato(), normal));
			}
			document.add(table);
			document.close();
		} catch (Exception e) {
		}
	}
	
	public static void stampaPDFRmail(List<Rmail>  dettagli, OutputStream out, String password) {
		String [] titles = new ExportUtility().titlesRmail;
		try {
			Document document = new Document(ApplicationUtil.pageSize(titles.length));
			ApplicationUtil.passwordPDF(document, out, password);
			document.open();
			document.addTitle(ConstantsLanguage.RMAIL.stampa());
			document.addSubject( ConstantsLanguage.RMAIL.stampa());
			document.addKeywords(ConstantsLanguage.RMAIL.stampa());
			document.addAuthor(AUTHOR);
			document.addCreator(CREATOR);
			Paragraph preface = new Paragraph("");
			preface.add(new Paragraph(ConstantsLanguage.TOTALE.stampa() + " " + ConstantsLanguage.RMAIL.stampa() + ": " + ApplicationUtil.formatNumber(dettagli.size()) , title));
			preface.add(new Paragraph(SPACE));
			document.add(preface);
			PdfPTable table = new PdfPTable(titles.length);
			table.setWidthPercentage(100);
			for(String tt : titles) {
				PdfPCell c = new PdfPCell(new Phrase(tt, header));
				c.setHorizontalAlignment(Element.ALIGN_LEFT);
				c.setBackgroundColor(BaseColor.YELLOW);
				table.addCell(c);
			}
			table.setHeaderRows(1);
			for(Rmail prd : dettagli) {
				table.addCell(new Phrase(prd.getId().toString(), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateSeconds.stampa(), prd.getData_invio()), normal));
				table.addCell(new Phrase(prd.getContatto().getCampagna_denominazione(), normal));
				table.addCell(new Phrase(prd.getContatto().getLista_denominazione(), normal));
				table.addCell(new Phrase(prd.getContatto().getDenominazione(), normal));
				table.addCell(new Phrase(prd.getDestinatario().getIndirizzo_completo(), normal));
				table.addCell(new Phrase(prd.getUtente_denominazione(), normal));
				table.addCell(new Phrase(prd.getOggettoTemplate(), normal));
				table.addCell(new Phrase(prd.getStato(), normal));
			}
			document.add(table);
			document.close();
		} catch (Exception e) {
		}
	}
	public static void stampaPDFNotifica(List<Notifica>  dettagli, OutputStream out, String password) {
		String [] titles = new ExportUtility().titlesNotifica;
		try {
			Document document = new Document(ApplicationUtil.pageSize(titles.length));
			ApplicationUtil.passwordPDF(document, out, password);
			document.open();
			document.addTitle(ConstantsLanguage.NOTIFICA.stampa());
			document.addSubject( ConstantsLanguage.NOTIFICA.stampa());
			document.addKeywords(ConstantsLanguage.NOTIFICA.stampa());
			document.addAuthor(AUTHOR);
			document.addCreator(CREATOR);
			Paragraph preface = new Paragraph("");
			preface.add(new Paragraph(ConstantsLanguage.TOTALE.stampa() + " " + ConstantsLanguage.NOTIFICA.stampa() + ": " + ApplicationUtil.formatNumber(dettagli.size()) , title));
			preface.add(new Paragraph(SPACE));
			document.add(preface);
			PdfPTable table = new PdfPTable(titles.length);
			table.setWidthPercentage(100);
			for(String tt : titles) {
				PdfPCell c = new PdfPCell(new Phrase(tt, header));
				c.setHorizontalAlignment(Element.ALIGN_LEFT);
				c.setBackgroundColor(BaseColor.YELLOW);
				table.addCell(c);
			}
			table.setHeaderRows(1);
			for(Notifica prd : dettagli) {
				table.addCell(new Phrase(prd.getId().toString(), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateSeconds.stampa(), prd.getData_invio()), normal));
				table.addCell(new Phrase(prd.getContatto().getCampagna_denominazione(), normal));
				table.addCell(new Phrase(prd.getContatto().getLista_denominazione(), normal));
				table.addCell(new Phrase(prd.getContatto().getDenominazione(), normal));
				table.addCell(new Phrase(prd.getDestinatario(), normal));
				table.addCell(new Phrase(prd.getUtente_denominazione(), normal));
				table.addCell(new Phrase(prd.getOggetto(), normal));
				table.addCell(new Phrase(prd.getStato(), normal));
			}
			document.add(table);
			document.close();
		} catch (Exception e) {
		}
	}
	public static void stampaPDFCdr(List<Cdr>  dettagli, OutputStream out, String password) {
		String [] titles = new ExportUtility().titlesCdr;
		try {
			Document document = new Document(ApplicationUtil.pageSize(titles.length));
			ApplicationUtil.passwordPDF(document, out, password);
			document.open();
			document.addTitle(ConstantsLanguage.CDR.stampa());
			document.addSubject( ConstantsLanguage.CDR.stampa());
			document.addKeywords(ConstantsLanguage.CDR.stampa());
			document.addAuthor(AUTHOR);
			document.addCreator(CREATOR);
			Paragraph preface = new Paragraph("");
			preface.add(new Paragraph(ConstantsLanguage.TOTALE.stampa() + " " + ConstantsLanguage.CDR.stampa() + ": " + ApplicationUtil.formatNumber(dettagli.size()) , title));
			preface.add(new Paragraph(SPACE));
			document.add(preface);
			PdfPTable table = new PdfPTable(titles.length);
			table.setWidthPercentage(100);
			for(String tt : titles) {
				PdfPCell c = new PdfPCell(new Phrase(tt, header));
				c.setHorizontalAlignment(Element.ALIGN_LEFT);
				c.setBackgroundColor(BaseColor.YELLOW);
				table.addCell(c);
			}
			table.setHeaderRows(1);
			for(Cdr prd : dettagli) {
				table.addCell(new Phrase(prd.getId().toString(), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateSeconds.stampa(), prd.getCalldate()), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateSeconds.stampa(), prd.getAnswerdate()), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateSeconds.stampa(), prd.getEnddate()), normal));
				table.addCell(new Phrase(prd.getContattoCampagnaDenominazione(), normal));
				table.addCell(new Phrase(prd.getContattoListaDenominazione(), normal));
				table.addCell(new Phrase(prd.getContattoDenominazione(), normal));
				table.addCell(new Phrase(prd.getUtenteDenominazione(), normal));
				table.addCell(new Phrase(prd.getCaller(), normal));
				table.addCell(new Phrase(prd.getCallee(), normal));
				table.addCell(new Phrase(prd.getTipoText(), normal));
				table.addCell(new Phrase(prd.getDurationH(), normal));
				table.addCell(new Phrase(ApplicationUtil.formatNumber(prd.getDuration()), normal));
				table.addCell(new Phrase(prd.getBillsecH(), normal));
				table.addCell(new Phrase(ApplicationUtil.formatNumber(prd.getBillsec()), normal));
				table.addCell(new Phrase(prd.getDisposition(), normal));
			}
			document.add(table);
			document.close();
		} catch (Exception e) {
		}
	}
	public static void stampaPDFCel(List<Cel>  dettagli, OutputStream out, String password) {
		String [] titles = new ExportUtility().titlesCel;
		try {
			Document document = new Document(ApplicationUtil.pageSize(titles.length));
			ApplicationUtil.passwordPDF(document, out, password);
			document.open();
			document.addTitle(ConstantsLanguage.CEL.stampa());
			document.addSubject( ConstantsLanguage.CEL.stampa());
			document.addKeywords(ConstantsLanguage.CEL.stampa());
			document.addAuthor(AUTHOR);
			document.addCreator(CREATOR);
			Paragraph preface = new Paragraph("");
			preface.add(new Paragraph(ConstantsLanguage.TOTALE.stampa() + " " + ConstantsLanguage.CEL.stampa() + ": " + ApplicationUtil.formatNumber(dettagli.size()) , title));
			preface.add(new Paragraph(SPACE));
			document.add(preface);
			PdfPTable table = new PdfPTable(titles.length);
			table.setWidthPercentage(100);
			for(String tt : titles) {
				PdfPCell c = new PdfPCell(new Phrase(tt, header));
				c.setHorizontalAlignment(Element.ALIGN_LEFT);
				c.setBackgroundColor(BaseColor.YELLOW);
				table.addCell(c);
			}
			table.setHeaderRows(1);
			for(Cel prd : dettagli) {
				table.addCell(new Phrase(prd.getId().toString(), normal));
			}
			document.add(table);
			document.close();
		} catch (Exception e) {
		}
	}
	public static void stampaPDFQuery(List<QueryKey> qks, OutputStream out, String password) {
		try {
			Document document = new Document(PageSize.A0.rotate());
			ApplicationUtil.passwordPDF(document, out, password);
			document.open();
			document.addTitle(ConstantsLanguage.QUERY.stampa());
			document.addSubject( ConstantsLanguage.QUERY.stampa());
			document.addKeywords(ConstantsLanguage.QUERY.stampa());
			document.addAuthor(AUTHOR);
			document.addCreator(CREATOR);
			for(QueryKey qk: qks) {
				if(qk.isValido()) {
					Paragraph preface = new Paragraph("");
					List<String> titles = qk.getChiavi();
					preface.add(new Paragraph(ConstantsLanguage.TOTALE.stampa() + " " + ConstantsLanguage.QUERY.stampa() + " " + qk.getId() + ": " + ApplicationUtil.formatNumber(qk.getRigheSize()) , title));
					preface.add(new Paragraph(SPACE));
					document.add(preface);
					PdfPTable table = new PdfPTable(titles.size());
					table.setWidthPercentage(100);
					for(String tt : titles) {
						PdfPCell c = new PdfPCell(new Phrase(tt, header));
						c.setHorizontalAlignment(Element.ALIGN_LEFT);
						c.setBackgroundColor(BaseColor.YELLOW);
						table.addCell(c);
					}
					table.setHeaderRows(1);
					for(int i = 0; i < qk.getRighe().size(); i++) {
						for(int j = 0; j < titles.size(); j++) {
							QueryElement o = qk.getMappa().get(titles.get(j)).get(i);
							table.addCell(new Phrase(o != null ? o.toString() : "", normal));
						}
					}
					document.add(table);
					Paragraph finale = new Paragraph("");
					finale.add(new Paragraph(SPACE));
					finale.add(new Paragraph(SPACE));
					document.add(finale);
				}
			}
			document.close();
		} catch (Exception e) {
		}
	}
	
	public static void stampaPDFStoriaContratto(List<StoriaContratto>  data, OutputStream out, List<Long> campiA, List<Long> campiB, AnagraficaDao anagraficaDao, String password) {
		String [] titles = new ExportUtility().titlesStoriaContratto;
		try {
			if(ApplicationUtil.empty(campiA)) {
				campiA = new ArrayList<Long>();
			}
			if(ApplicationUtil.empty(campiB)) {
				campiB = new ArrayList<Long>();
			}
			Long [] campiChiave = new Long[campiB.size() + campiA.size()];
			String [] campiEtichette = new String[campiB.size() + campiA.size()];
			for (int i = 0; i < campiB.size(); i++) {
				campiChiave[i] = campiB.get(i);
				campiEtichette[i] = anagraficaDao.getEtichettaById(CampoAggiuntivoAnagrafica.class, campiB.get(i));
			}	
			for (int i = 0; i < campiA.size(); i++) {
				campiChiave[campiB.size() + i] = campiA.get(i);
				campiEtichette[campiB.size() + i] = anagraficaDao.getEtichettaById(CampoAggiuntivoContratto.class, campiA.get(i));
			}	
			if(ApplicationUtil.notEmpty(campiChiave)) {
				data = anagraficaDao.loadFullStoriaContratto(data);
			}
			Document document = new Document(ApplicationUtil.pageSize(titles.length+campiChiave.length));
			ApplicationUtil.passwordPDF(document, out, password);
			document.open();
			document.addTitle(ConstantsLanguage.STORIA.stampa() + " " + ConstantsLanguage.CONTRATTI.stampa());
			document.addSubject(ConstantsLanguage.STORIA.stampa() + " " + ConstantsLanguage.CONTRATTI.stampa());
			document.addKeywords(ConstantsLanguage.STORIA.stampa() + " " + ConstantsLanguage.CONTRATTI.stampa());
			document.addAuthor(AUTHOR);
			document.addCreator(CREATOR);
			Paragraph preface = new Paragraph("");
			preface.add(new Paragraph(ConstantsLanguage.TOTALE.stampa() + " " + ConstantsLanguage.STORIA.stampa() + " " + ConstantsLanguage.CONTRATTI.stampa() + ": " + ApplicationUtil.formatNumber(data.size()) , title));
			preface.add(new Paragraph(SPACE));
			document.add(preface);
			PdfPTable table = new PdfPTable(titles.length+campiChiave.length);
			table.setWidthPercentage(100);
			for(String tt : titles) {
				PdfPCell c = new PdfPCell(new Phrase(tt, header));
				c.setHorizontalAlignment(Element.ALIGN_LEFT);
				c.setBackgroundColor(BaseColor.YELLOW);
				table.addCell(c);
			}
			for(String campo : campiEtichette) {
				PdfPCell c = new PdfPCell(new Phrase(campo, header));
				c.setHorizontalAlignment(Element.ALIGN_LEFT);
				c.setBackgroundColor(BaseColor.YELLOW);
				table.addCell(c);
			}
			table.setHeaderRows(1);
			for(StoriaContratto prd : data) {
				table.addCell(new Phrase(prd.getId().toString(), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateSeconds.stampa(), prd.getData()), normal));
				table.addCell(new Phrase(prd.getBloccatoS(), normal));
				table.addCell(new Phrase(prd.getContratto().getContatto().getCampagna_denominazione(), normal));
				table.addCell(new Phrase(prd.getContratto().getContatto().getLista_denominazione(), normal));
				table.addCell(new Phrase(prd.getEsitoEtichettaCodice(), normal));
				table.addCell(new Phrase(prd.getContratto().getContatto().getAnagrafica().getDenominazione(), normal));
				table.addCell(new Phrase(prd.getContratto().getContatto().getAnagrafica().getCognome(), normal));
				table.addCell(new Phrase(prd.getContratto().getContatto().getAnagrafica().getNome(), normal));
				table.addCell(new Phrase(prd.getContratto().getContatto().getAnagrafica().getEmail(), normal));
				table.addCell(new Phrase(prd.getContratto().getContatto().getAnagrafica().getTelefono_fisso(), normal));
				table.addCell(new Phrase(prd.getContratto().getContatto().getAnagrafica().getTelefono_mobile(), normal));
				table.addCell(new Phrase(prd.getContratto().getContatto().getAnagrafica().getTelefono_fax(), normal));
				table.addCell(new Phrase(prd.getContratto().getContatto().getAnagrafica().getTelefono_altro(), normal));
				table.addCell(new Phrase(prd.getOperatore_denominazione(), normal));
				table.addCell(new Phrase(prd.getAgente_denominazione(), normal));
				table.addCell(new Phrase(prd.getUtente_denominazione(), normal));
				table.addCell(new Phrase(prd.getNota(), normal));
				table.addCell(new Phrase(prd.getStatoTesto(), normal));
				table.addCell(new Phrase(prd.getSeriale(), normal));
				table.addCell(new Phrase(prd.getCategoria_denominazione(), normal));
				table.addCell(new Phrase(prd.getProdotto_denominazione(), normal));
				table.addCell(new Phrase(ApplicationUtil.formatNumber(prd.getQuantita()), normal));
				table.addCell(new Phrase(ApplicationUtil.formatNumber(prd.getCosto_scontato()), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.date.stampa(), prd.getData_contabile()), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.date.stampa(), prd.getData_stipula()), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.date.stampa(), prd.getData_attivazione()), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.date.stampa(), prd.getData_caricamento()), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), prd.getData_esito()), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), prd.getData_stato()), normal));
				table.addCell(new Phrase(prd.getContratto().getContatto().getAnagrafica().getIndirizzo_legale().getIndirizzo_completo(), normal));
				table.addCell(new Phrase(prd.getContratto().getContatto().getAnagrafica().getIndirizzo_operativo().getIndirizzo_completo(), normal));
				for(Long campo : campiChiave) {
					stampaDato(table, campo, prd.getContratto().getContatto().getAnagrafica().getDettagli(), prd.getContratto().getDettagli());
				}
			}
			document.add(table);
			document.close();
		} catch (Exception e) {
		}
	}
	public static void stampaPDFStoriaContatto(List<StoriaContatto>  data, OutputStream out, List<Long> campis, AnagraficaDao anagraficaDao, String password) {
		String [] titles = new ExportUtility().titlesStoriaContatto;
		try {
			if(ApplicationUtil.empty(campis)) {
				campis = new ArrayList<Long>();
			}
			Long [] campiChiave = new Long[campis.size()];
			String [] campiEtichette = new String[campis.size()];
			for (int i = 0; i < campis.size(); i++) {
				campiChiave[i] = campis.get(i);
				campiEtichette[i] = anagraficaDao.getEtichettaById(CampoAggiuntivoAnagrafica.class, campis.get(i));
			}	
			if(ApplicationUtil.notEmpty(campiChiave)) {
				data = anagraficaDao.loadFullStoriaContatto(data);
			}
			Document document = new Document(ApplicationUtil.pageSize(titles.length+campiChiave.length));
			ApplicationUtil.passwordPDF(document, out, password);
			document.open();
			document.addTitle(ConstantsLanguage.STORIA.stampa() + " " + ConstantsLanguage.CONTATTI.stampa());
			document.addSubject(ConstantsLanguage.STORIA.stampa() + " " + ConstantsLanguage.CONTATTI.stampa());
			document.addKeywords(ConstantsLanguage.STORIA.stampa() + " " + ConstantsLanguage.CONTRATTI.stampa());
			document.addAuthor(AUTHOR);
			document.addCreator(CREATOR);
			Paragraph preface = new Paragraph("");
			preface.add(new Paragraph(ConstantsLanguage.TOTALE.stampa() + " " + ConstantsLanguage.STORIA.stampa() + " " + ConstantsLanguage.CONTATTI.stampa() + ": " + ApplicationUtil.formatNumber(data.size()) , title));
			preface.add(new Paragraph(SPACE));
			document.add(preface);
			PdfPTable table = new PdfPTable(titles.length+campiChiave.length);
			table.setWidthPercentage(100);
			for(String tt : titles) {
				PdfPCell c = new PdfPCell(new Phrase(tt, header));
				c.setHorizontalAlignment(Element.ALIGN_LEFT);
				c.setBackgroundColor(BaseColor.YELLOW);
				table.addCell(c);
			}
			for(String campo : campiEtichette) {
				PdfPCell c = new PdfPCell(new Phrase(campo, header));
				c.setHorizontalAlignment(Element.ALIGN_LEFT);
				c.setBackgroundColor(BaseColor.YELLOW);
				table.addCell(c);
			}
			table.setHeaderRows(1);
			for(StoriaContatto prd : data) {
				table.addCell(new Phrase(prd.getId().toString(), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateSeconds.stampa(), prd.getData()), normal));
				table.addCell(new Phrase(prd.getBloccatoS(), normal));
				table.addCell(new Phrase(prd.getCampagna_denominazione(), normal));
				table.addCell(new Phrase(prd.getLista_denominazione(), normal));
				table.addCell(new Phrase(prd.getEsito_chiamata_etichettaCodice(), normal));
				table.addCell(new Phrase(prd.getEsito_archiviazione_etichettaCodice(), normal));
				table.addCell(new Phrase(prd.getContatto().getAnagrafica().getDenominazione(), normal));
				table.addCell(new Phrase(prd.getContatto().getAnagrafica().getCognome(), normal));
				table.addCell(new Phrase(prd.getContatto().getAnagrafica().getNome(), normal));
				table.addCell(new Phrase(prd.getContatto().getAnagrafica().getEmail(), normal));
				table.addCell(new Phrase(prd.getContatto().getAnagrafica().getTelefono_fisso(), normal));
				table.addCell(new Phrase(prd.getContatto().getAnagrafica().getTelefono_mobile(), normal));
				table.addCell(new Phrase(prd.getContatto().getAnagrafica().getTelefono_fax(), normal));
				table.addCell(new Phrase(prd.getContatto().getAnagrafica().getTelefono_altro(), normal));
				table.addCell(new Phrase(prd.getProprietario_denominazione(), normal));
				table.addCell(new Phrase(prd.getAgente_denominazione(), normal));
				table.addCell(new Phrase(prd.getOperatore_denominazione(), normal));
				table.addCell(new Phrase(prd.getChiuso(), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), prd.getData_presentazione()), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), prd.getData_archiviazione()), normal));
				table.addCell(new Phrase(prd.getNota(), normal));
				table.addCell(new Phrase(prd.getTipoTesto(), normal));
				table.addCell(new Phrase(ApplicationUtil.formatNumber(prd.getSecondi_tot()), normal));
				table.addCell(new Phrase(prd.getSecondi_totH(), normal));
				table.addCell(new Phrase(ApplicationUtil.formatNumber(prd.getSecondi_conv_eff()), normal));
				table.addCell(new Phrase(prd.getSecondi_conv_effH(), normal));
				table.addCell(new Phrase(ApplicationUtil.formatNumber(prd.getSecondi_conv_tot()), normal));
				table.addCell(new Phrase(prd.getSecondi_conv_totH(), normal));
				table.addCell(new Phrase(ApplicationUtil.formatNumber(prd.getSecondi_post()), normal));
				table.addCell(new Phrase(prd.getSecondi_postH(), normal));
				table.addCell(new Phrase(ApplicationUtil.formatNumber(prd.getSecondi_pre()), normal));
				table.addCell(new Phrase(prd.getSecondi_preH(), normal));
				table.addCell(new Phrase(ApplicationUtil.formatNumber(prd.getSecondi_rec()), normal));
				table.addCell(new Phrase(prd.getSecondi_recH(), normal));
				table.addCell(new Phrase(ApplicationUtil.formatNumber(prd.getSecondi_attesa()), normal));
				table.addCell(new Phrase(prd.getSecondi_attesaH(), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateSeconds.stampa(), prd.getDate_apertura()), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateSeconds.stampa(), prd.getDate_chiamata()), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateSeconds.stampa(), prd.getDate_risposta()), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateSeconds.stampa(), prd.getDate_rec_inizio()), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateSeconds.stampa(), prd.getDate_rec_fine()), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateSeconds.stampa(), prd.getDate_fine()), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateSeconds.stampa(), prd.getDate_esito()), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateSeconds.stampa(), prd.getDate_attesa_inizio()), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateSeconds.stampa(), prd.getDate_attesa_fine()), normal));
				table.addCell(new Phrase(prd.getContatto().getAnagrafica().getIndirizzo_legale().getIndirizzo_completo(), normal));
				table.addCell(new Phrase(prd.getContatto().getAnagrafica().getIndirizzo_operativo().getIndirizzo_completo(), normal));
				for(Long campo : campiChiave) {
					stampaDato(table, campo, prd.getContatto().getAnagrafica().getDettagli(), null);
				}
			}
			document.add(table);
			document.close();
		} catch (Exception e) {
		}
	}
	
	
	public static void stampaPDFStoriaAppuntamento(List<StoriaAppuntamento>  data, OutputStream out, List<Long> campis, AnagraficaDao anagraficaDao, String password) {
		String [] titles = new ExportUtility().titlesStoriaAppuntamento;
		try {
			if(ApplicationUtil.empty(campis)) {
				campis = new ArrayList<Long>();
			}
			Long [] campiChiave = new Long[campis.size()];
			String [] campiEtichette = new String[campis.size()];
			for (int i = 0; i < campis.size(); i++) {
				campiChiave[i] = campis.get(i);
				campiEtichette[i] = anagraficaDao.getEtichettaById(CampoAggiuntivoAnagrafica.class, campis.get(i));
			}	
			if(ApplicationUtil.notEmpty(campiChiave)) {
				data = anagraficaDao.loadFullStoriaAppuntamento(data);
			}
			Document document = new Document(ApplicationUtil.pageSize(titles.length+campiChiave.length));
			ApplicationUtil.passwordPDF(document, out, password);
			document.open();
			document.addTitle(ConstantsLanguage.STORIA.stampa() + " " + ConstantsLanguage.APPUNTAMENTI.stampa());
			document.addSubject(ConstantsLanguage.STORIA.stampa() + " " + ConstantsLanguage.APPUNTAMENTI.stampa());
			document.addKeywords(ConstantsLanguage.STORIA.stampa() + " " + ConstantsLanguage.APPUNTAMENTI.stampa());
			document.addAuthor(AUTHOR);
			document.addCreator(CREATOR);
			Paragraph preface = new Paragraph("");
			preface.add(new Paragraph(ConstantsLanguage.TOTALE.stampa() + " " + ConstantsLanguage.STORIA.stampa() + " " + ConstantsLanguage.APPUNTAMENTI.stampa() + ": " + ApplicationUtil.formatNumber(data.size()) , title));
			preface.add(new Paragraph(SPACE));
			document.add(preface);
			PdfPTable table = new PdfPTable(titles.length+campiChiave.length);
			table.setWidthPercentage(100);
			for(String tt : titles) {
				PdfPCell c = new PdfPCell(new Phrase(tt, header));
				c.setHorizontalAlignment(Element.ALIGN_LEFT);
				c.setBackgroundColor(BaseColor.YELLOW);
				table.addCell(c);
			}
			for(String campo : campiEtichette) {
				PdfPCell c = new PdfPCell(new Phrase(campo, header));
				c.setHorizontalAlignment(Element.ALIGN_LEFT);
				c.setBackgroundColor(BaseColor.YELLOW);
				table.addCell(c);
			}
			table.setHeaderRows(1);
			for(StoriaAppuntamento prd : data) {
				table.addCell(new Phrase(prd.getId().toString(), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateSeconds.stampa(), prd.getData()), normal));
				table.addCell(new Phrase(prd.getBloccatoS(), normal));
				table.addCell(new Phrase(prd.getAppuntamento().getContatto().getCampagna_denominazione(), normal));
				table.addCell(new Phrase(prd.getAppuntamento().getContatto().getLista_denominazione(), normal));
				table.addCell(new Phrase(prd.getEsitoEtichettaCodice(), normal));
				table.addCell(new Phrase(prd.getAppuntamento().getContatto().getAnagrafica().getDenominazione(), normal));
				table.addCell(new Phrase(prd.getAppuntamento().getContatto().getAnagrafica().getCognome(), normal));
				table.addCell(new Phrase(prd.getAppuntamento().getContatto().getAnagrafica().getNome(), normal));
				table.addCell(new Phrase(prd.getAppuntamento().getContatto().getAnagrafica().getEmail(), normal));
				table.addCell(new Phrase(prd.getAppuntamento().getContatto().getAnagrafica().getTelefono_fisso(), normal));
				table.addCell(new Phrase(prd.getAppuntamento().getContatto().getAnagrafica().getTelefono_mobile(), normal));
				table.addCell(new Phrase(prd.getAppuntamento().getContatto().getAnagrafica().getTelefono_fax(), normal));
				table.addCell(new Phrase(prd.getAppuntamento().getContatto().getAnagrafica().getTelefono_altro(), normal));
				table.addCell(new Phrase(prd.getOperatore_denominazione(), normal));
				table.addCell(new Phrase(prd.getAgente_denominazione(), normal));
				table.addCell(new Phrase(prd.getUtente_denominazione(), normal));
				table.addCell(new Phrase(prd.getNota(), normal));
				table.addCell(new Phrase(prd.getStatoTesto(), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.date.stampa(), prd.getData_inizio()), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.time.stampa(), prd.getData_inizio()), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.time.stampa(), prd.getData_fine()), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), prd.getData_conferma()), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), prd.getData_esito()), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), prd.getData_stato()), normal));
				table.addCell(new Phrase(prd.getLocalizzazioneString(), normal));
				table.addCell(new Phrase(prd.getAppuntamento().getContatto().getAnagrafica().getIndirizzo_legale().getIndirizzo_completo(), normal));
				table.addCell(new Phrase(prd.getAppuntamento().getContatto().getAnagrafica().getIndirizzo_operativo().getIndirizzo_completo(), normal));
				for(Long campo : campiChiave) {
					stampaDato(table, campo, prd.getAppuntamento().getContatto().getAnagrafica().getDettagli(), null);
				}
			}
			document.add(table);
			document.close();
		} catch (Exception e) {
		}
	}
	
	public static void stampaPDFStoriaContrattoTemplate(Boolean p, List<StoriaContratto>  data, OutputStream out, TemplateExportStoriaContratto ti, AnagraficaDao anagraficaDao, String password) {
		List <String> titlesList = ti.getValore_multiplo();
		List <String> aggiuntivi = ListUtils.subtract(titlesList, new ArrayList<String>(ConstantsMap.storiaContrattoMap));
		if(p!=null && ApplicationUtil.notEmpty(aggiuntivi)) {
			List <String> invA = anagraficaDao.getEtichetteInvisibiliByChiave(p, CampoAggiuntivoAnagrafica.class);
			List <String> invB = anagraficaDao.getEtichetteInvisibiliByChiave(p, CampoAggiuntivoContratto.class);
			aggiuntivi.removeAll(invA);
			aggiuntivi.removeAll(invB);
			titlesList.removeAll(invA);
			titlesList.removeAll(invB);
		}
		if(ApplicationUtil.notEmpty(aggiuntivi)) {
			data = anagraficaDao.loadFullStoriaContratto(data);
		}
		String[] titles = titlesList.toArray(new String[0]);
		try {
			Document document = new Document(ApplicationUtil.pageSize(titles.length));
			ApplicationUtil.passwordPDF(document, out, password);
			document.open();
			document.addTitle(ConstantsLanguage.STORIA.stampa() + " " + ConstantsLanguage.CONTRATTI.stampa());
			document.addSubject(ConstantsLanguage.STORIA.stampa() + " " + ConstantsLanguage.CONTRATTI.stampa());
			document.addKeywords(ConstantsLanguage.STORIA.stampa() + " " + ConstantsLanguage.CONTRATTI.stampa());
			document.addAuthor(AUTHOR);
			document.addCreator(CREATOR);
			Paragraph preface = new Paragraph("");
			preface.add(new Paragraph(ConstantsLanguage.TOTALE.stampa() + " " + ConstantsLanguage.STORIA.stampa() + " " + ConstantsLanguage.CONTRATTI.stampa() + ": " + ApplicationUtil.formatNumber(data.size()) , title));
			preface.add(new Paragraph(SPACE));
			document.add(preface);
			PdfPTable table = new PdfPTable(titles.length);
			table.setWidthPercentage(100);
			if(ti.getIntestazione()) {
				for(String tt : titles) {
					PdfPCell c;
					if(ApplicationUtil.notEmpty(aggiuntivi) && aggiuntivi.contains(tt)) {
						String etichetta = anagraficaDao.getEtichettaByChiave(CampoAggiuntivoAnagrafica.class, tt);
						if(ApplicationUtil.isBlank(etichetta)) {
							etichetta = anagraficaDao.getEtichettaByChiave(CampoAggiuntivoContratto.class, tt);
						}
						c = new PdfPCell(new Phrase(etichetta, header));
					} else {
						c = new PdfPCell(new Phrase(Message.addCatalogText(tt), header));
					}
					c.setHorizontalAlignment(Element.ALIGN_LEFT);
					c.setBackgroundColor(BaseColor.YELLOW);
					table.addCell(c);
				}
				table.setHeaderRows(1);
			}
			for(StoriaContratto scrt : data) {
				Contratto crt = scrt.getContratto();
				Contatto cnt = crt.getContatto();
				for (int j = 0; j < titles.length; j++) {
					if(ti.getPosizione(ConstantsMap.storia_contratto_data).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateSeconds.stampa(), scrt.getData()), normal));
					} else if(ti.getPosizione(ConstantsMap.storia_contratto_id).equals(j)) {
						table.addCell(new Phrase(scrt.getId().toString(), normal));
					} else if(ti.getPosizione(ConstantsMap.storia_contratto_operatore_denominazione).equals(j)) {
						table.addCell(new Phrase(scrt.getOperatore_denominazione(), normal));
					} else if(ti.getPosizione(ConstantsMap.storia_contratto_operatore_codice).equals(j)) {
						table.addCell(new Phrase(scrt.getOperatore_codice(), normal));
					} else if(ti.getPosizione(ConstantsMap.storia_contratto_agente_denominazione).equals(j)) {
						table.addCell(new Phrase(scrt.getAgente_denominazione(), normal));
					} else if(ti.getPosizione(ConstantsMap.storia_contratto_agente_codice).equals(j)) {
						table.addCell(new Phrase(scrt.getAgente_codice(), normal));
					} else if(ti.getPosizione(ConstantsMap.storia_contratto_categoria_denominazione).equals(j)) {
						table.addCell(new Phrase(scrt.getCategoria_denominazione(), normal));
					} else if(ti.getPosizione(ConstantsMap.storia_contratto_prodotto_denominazione).equals(j)) {
						table.addCell(new Phrase(scrt.getProdotto_denominazione(), normal));
					} else if(ti.getPosizione(ConstantsMap.storia_contratto_esito_contratto).equals(j)) {
						table.addCell(new Phrase(scrt.getEsitoEtichetta(), normal));
					} else if(ti.getPosizione(ConstantsMap.storia_contratto_codice_contratto).equals(j)) {
						table.addCell(new Phrase(scrt.getEsitoCodice(), normal));
					} else if(ti.getPosizione(ConstantsMap.storia_contratto_data_stipula).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.date.stampa(),scrt.getData_stipula()), normal));
					} else if(ti.getPosizione(ConstantsMap.storia_contratto_data_contabile).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.date.stampa(),scrt.getData_contabile()), normal));
					} else if(ti.getPosizione(ConstantsMap.storia_contratto_data_attivazione).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.date.stampa(),scrt.getData_attivazione()), normal));
					} else if(ti.getPosizione(ConstantsMap.storia_contratto_data_caricamento).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.date.stampa(),scrt.getData_caricamento()), normal));
					} else if(ti.getPosizione(ConstantsMap.storia_contratto_bloccato).equals(j)) {
						table.addCell(new Phrase(scrt.getBloccatoS(), normal));
					} else if(ti.getPosizione(ConstantsMap.storia_contratto_utente_denominazione).equals(j)) {
						table.addCell(new Phrase(scrt.getUtente_denominazione(), normal));
					} else if(ti.getPosizione(ConstantsMap.storia_contratto_utente_codice).equals(j)) {
						table.addCell(new Phrase(scrt.getUtente_codice(), normal));
					} else if(ti.getPosizione(ConstantsMap.storia_contratto_data_esito).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), scrt.getData_esito()), normal));
					} else if(ti.getPosizione(ConstantsMap.storia_contratto_data_stato).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), scrt.getData_stato()), normal));
					} else if(ti.getPosizione(ConstantsMap.storia_contratto_nota).equals(j)) {
						table.addCell(new Phrase(scrt.getNota(), normal));
					} else if(ti.getPosizione(ConstantsMap.storia_contratto_tipo_seriale).equals(j)) {
						table.addCell(new Phrase(scrt.getTipo_seriale(), normal));
					} else if(ti.getPosizione(ConstantsMap.storia_contratto_seriale).equals(j)) {
						table.addCell(new Phrase(scrt.getSeriale(), normal));
					} else if(ti.getPosizione(ConstantsMap.storia_contratto_quantita).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.formatNumber(scrt.getQuantita()), normal));
					} else if(ti.getPosizione(ConstantsMap.storia_contratto_costo_scontato).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.formatNumber(scrt.getCosto_scontato()), normal));
					} else if(ti.getPosizione(ConstantsMap.storia_contratto_stato).equals(j)) {
						table.addCell(new Phrase(scrt.getStatoTesto(), normal));
					} else if(ti.getPosizione(ConstantsMap.contratto_data_creazione).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), crt.getData_creazione()), normal));
					} else if(ti.getPosizione(ConstantsMap.contratto_id).equals(j)) {
						table.addCell(new Phrase(crt.getId().toString(), normal));
					} else if(ti.getPosizione(ConstantsMap.contratto_operatore_denominazione).equals(j)) {
						table.addCell(new Phrase(crt.getOperatore_denominazione(), normal));
					} else if(ti.getPosizione(ConstantsMap.contratto_operatore_codice).equals(j)) {
						table.addCell(new Phrase(crt.getOperatore_codice(), normal));
					} else if(ti.getPosizione(ConstantsMap.contratto_agente_denominazione).equals(j)) {
						table.addCell(new Phrase(crt.getAgente_denominazione(), normal));
					} else if(ti.getPosizione(ConstantsMap.contratto_agente_codice).equals(j)) {
						table.addCell(new Phrase(crt.getAgente_codice(), normal));
					} else if(ti.getPosizione(ConstantsMap.contratto_categoria_denominazione).equals(j)) {
						table.addCell(new Phrase(crt.getCategoria_denominazione(), normal));
					} else if(ti.getPosizione(ConstantsMap.contratto_prodotto_denominazione).equals(j)) {
						table.addCell(new Phrase(crt.getProdotto_denominazione(), normal));
					} else if(ti.getPosizione(ConstantsMap.contratto_esito_contratto).equals(j)) {
						table.addCell(new Phrase(crt.getEsitoEtichetta(), normal));
					} else if(ti.getPosizione(ConstantsMap.contratto_codice_contratto).equals(j)) {
						table.addCell(new Phrase(crt.getEsitoCodice(), normal));
					} else if(ti.getPosizione(ConstantsMap.contratto_data_stipula).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.date.stampa(), crt.getData_stipula()), normal));
					} else if(ti.getPosizione(ConstantsMap.contratto_data_contabile).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.date.stampa(), crt.getData_contabile()), normal));
					} else if(ti.getPosizione(ConstantsMap.contratto_data_attivazione).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.date.stampa(), crt.getData_attivazione()), normal));
					} else if(ti.getPosizione(ConstantsMap.contratto_data_caricamento).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.date.stampa(), crt.getData_caricamento()), normal));
					} else if(ti.getPosizione(ConstantsMap.contratto_data_lavorazione).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), crt.getData_lavorazione()), normal));
					} else if(ti.getPosizione(ConstantsMap.contratto_utente_denominazione).equals(j)) {
						table.addCell(new Phrase(crt.getUtente_denominazione(), normal));
					} else if(ti.getPosizione(ConstantsMap.contratto_bloccato).equals(j)) {
						table.addCell(new Phrase(crt.getBloccatoS(), normal));
					} else if(ti.getPosizione(ConstantsMap.contratto_utente_codice).equals(j)) {
						table.addCell(new Phrase(crt.getUtente_codice(), normal));
					} else if(ti.getPosizione(ConstantsMap.contratto_data_esito).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), crt.getData_esito()), normal));
					} else if(ti.getPosizione(ConstantsMap.contratto_data_stato).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), crt.getData_stato()), normal));
					} else if(ti.getPosizione(ConstantsMap.contratto_nota).equals(j)) {
						table.addCell(new Phrase(crt.getNota(), normal));
					} else if(ti.getPosizione(ConstantsMap.contratto_tipo_seriale).equals(j)) {
						table.addCell(new Phrase(crt.getTipo_seriale(), normal));
					} else if(ti.getPosizione(ConstantsMap.contratto_seriale).equals(j)) {
						table.addCell(new Phrase(crt.getSeriale(), normal));
					} else if(ti.getPosizione(ConstantsMap.contratto_quantita).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.formatNumber(crt.getQuantita()), normal));
					} else if(ti.getPosizione(ConstantsMap.contratto_costo_scontato).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.formatNumber(crt.getCosto_scontato()), normal));
					} else if(ti.getPosizione(ConstantsMap.contratto_stato).equals(j)) {
						table.addCell(new Phrase(crt.getStatoTesto(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_data_lavorazione).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), cnt.getData_lavorazione()), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_operatore_denominazione).equals(j)) {
						table.addCell(new Phrase(cnt.getOperatore_denominazione(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_operatore_codice).equals(j)) {
						table.addCell(new Phrase(cnt.getOperatore_codice(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_data_archiviazione).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), cnt.getData_archiviazione()), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_esito_chiamata).equals(j)) {
						table.addCell(new Phrase(cnt.getEsito_chiamata(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_esito_archiviazione).equals(j)) {
						table.addCell(new Phrase(cnt.getEsito_archiviazione(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_esito_generale).equals(j)) {
						table.addCell(new Phrase(cnt.getEsito_generale(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_codice_chiamata).equals(j)) {
						table.addCell(new Phrase(cnt.getCodice_chiamata(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_codice_archiviazione).equals(j)) {
						table.addCell(new Phrase(cnt.getCodice_archiviazione(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_codice_generale).equals(j)) {
						table.addCell(new Phrase(cnt.getCodice_generale(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_proprietario_denominazione).equals(j)) {
						table.addCell(new Phrase(cnt.getProprietario_denominazione(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_proprietario_codice).equals(j)) {
						table.addCell(new Phrase(cnt.getProprietario_codice(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_data_presentazione).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), cnt.getData_presentazione()), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_nota).equals(j)) {
						table.addCell(new Phrase(cnt.getNota(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_data_creazione).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), cnt.getData_creazione()), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_agente_denominazione).equals(j)) {
						table.addCell(new Phrase(cnt.getAgente_denominazione(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_agente_codice).equals(j)) {
						table.addCell(new Phrase(cnt.getAgente_codice(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_stato).equals(j)) {
						table.addCell(new Phrase(cnt.getTipoTesto(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_campagna_denominazione).equals(j)) {
						table.addCell(new Phrase(cnt.getCampagna_denominazione(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_lista_denominazione).equals(j)) {
						table.addCell(new Phrase(cnt.getLista_denominazione(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_bloccato).equals(j)) {
						table.addCell(new Phrase(cnt.getBloccatoS(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_campagna_codice).equals(j)) {
						table.addCell(new Phrase(cnt.getCampagna_codice(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_lista_codice).equals(j)) {
						table.addCell(new Phrase(cnt.getLista_codice(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_id).equals(j)) {
						table.addCell(new Phrase(cnt.getId().toString(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_positivo).equals(j)) {
						table.addCell(new Phrase(cnt.getPositivo(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_telefono_predefinito).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.uniforma(cnt.getTelefono_predefinito(), ti.getRem_predefinito(), ti.getAdd_predefinito()), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_utile).equals(j)) {
						table.addCell(new Phrase(cnt.getUtile(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_chiuso).equals(j)) {
						table.addCell(new Phrase(cnt.getChiuso(), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_cognome).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getCognome(), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_nome).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getNome(), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_nome_completo).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getNome_completo(), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_email).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getEmail(), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_codice_fiscale).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getCodice_fiscale(), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_sorgente).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getSorgente(), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_nota).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getNota(), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_luogo_nascita).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getLuogo_nascita(), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_data_nascita).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.date.stampa(), cnt.getAnagrafica().getDate_nascita()), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_link).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getLink(), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_privacy).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getPrivacy(), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_data_inserimento).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), cnt.getAnagrafica().getData_creazione()), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_tipo).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getTipo(), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_sesso).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getSesso(), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_partita_iva).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getPartita_iva(), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_ragione_sociale).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getRagione_sociale(), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_telefono_fisso).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.uniforma(cnt.getAnagrafica().getTelefono_fisso(), ti.getRem_fisso(), ti.getAdd_fisso()), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_telefono_altro).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.uniforma(cnt.getAnagrafica().getTelefono_altro(), ti.getRem_altro(), ti.getAdd_altro()), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_telefono_mobile).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.uniforma(cnt.getAnagrafica().getTelefono_mobile(), ti.getRem_mobile(), ti.getAdd_mobile()), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_telefono_fax).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.uniforma(cnt.getAnagrafica().getTelefono_fax(), ti.getRem_fax(), ti.getAdd_fax()), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_settore).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getSettore(), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_denominazione).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getDenominazione(), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_id).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIdentificativo(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_indirizzo_completo).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_legale().getIndirizzo_completo(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_strada_completo).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_legale().getStrada_completo(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_comune_completo).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_legale().getComune_completo(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_strada).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_legale().getStrada(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_civico).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_legale().getCivico(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_cap).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_legale().getCap(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_comune).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_legale().getComune(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_provincia).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_legale().getProvincia(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_regione).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_legale().getRegione(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_dettagli).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_legale().getDettagli(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_latitudine).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_legale().getLatitudine(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_longitudine).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_legale().getLongitudine(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_presso).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_legale().getPresso(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_indirizzo_completo).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_operativo().getIndirizzo_completo(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_strada_completo).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_operativo().getStrada_completo(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_comune_completo).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_operativo().getComune_completo(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_strada).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_operativo().getStrada(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_civico).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_operativo().getCivico(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_cap).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_operativo().getCap(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_comune).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_operativo().getComune(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_provincia).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_operativo().getProvincia(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_regione).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_operativo().getRegione(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_dettagli).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_operativo().getDettagli(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_latitudine).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_operativo().getLatitudine(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_longitudine).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_operativo().getLongitudine(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_presso).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_operativo().getPresso(), normal));
					} else if(ti.getPosizione(ConstantsMap.consenso_tfissoS).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getConsenso_tfissoS(), normal));
					} else if(ti.getPosizione(ConstantsMap.consenso_tmobileS).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getConsenso_tmobileS(), normal));
					} else if(ti.getPosizione(ConstantsMap.consenso_tfaxS).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getConsenso_tfaxS(), normal));
					} else if(ti.getPosizione(ConstantsMap.consenso_taltroS).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getConsenso_taltroS(), normal));
					} else if(ti.getPosizione(ConstantsMap.consenso_emailS).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getConsenso_emailS(), normal));
					} else if(ti.getPosizione(ConstantsMap.consenso_rmailS).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getConsenso_rmailS(), normal));
					} else {
						stampaDato(table, titles[j], cnt.getAnagrafica().getDettagli(), crt.getDettagli());
					}
				}
			}
			document.add(table);
			document.close();
		} catch (Exception e) {
		}
	}
	
	public static void stampaPDFStoriaAppuntamentoTemplate(Boolean p, List<StoriaAppuntamento>  data, OutputStream out, TemplateExportStoriaAppuntamento ti, AnagraficaDao anagraficaDao, String password) {
		List <String> titlesList = ti.getValore_multiplo();
		List <String> aggiuntivi = ListUtils.subtract(titlesList, new ArrayList<String>(ConstantsMap.storiaAppuntamentoMap));
		if(p!=null && ApplicationUtil.notEmpty(aggiuntivi)) {
			List <String> invA = anagraficaDao.getEtichetteInvisibiliByChiave(p, CampoAggiuntivoAnagrafica.class);
			aggiuntivi.removeAll(invA);
			titlesList.removeAll(invA);
		}
		if(ApplicationUtil.notEmpty(aggiuntivi)) {
			data = anagraficaDao.loadFullStoriaAppuntamento(data);
		}
		String[] titles = titlesList.toArray(new String[0]);
		try {
			Document document = new Document(ApplicationUtil.pageSize(titles.length));
			ApplicationUtil.passwordPDF(document, out, password);
			document.open();
			document.addTitle(ConstantsLanguage.STORIA.stampa() + " " + ConstantsLanguage.APPUNTAMENTI.stampa());
			document.addSubject(ConstantsLanguage.STORIA.stampa() + " " + ConstantsLanguage.APPUNTAMENTI.stampa());
			document.addKeywords(ConstantsLanguage.STORIA.stampa() + " " + ConstantsLanguage.APPUNTAMENTI.stampa());
			document.addAuthor(AUTHOR);
			document.addCreator(CREATOR);
			Paragraph preface = new Paragraph("");
			preface.add(new Paragraph(ConstantsLanguage.TOTALE.stampa() + " " + ConstantsLanguage.STORIA.stampa() + " " + ConstantsLanguage.APPUNTAMENTI.stampa() + ": " + ApplicationUtil.formatNumber(data.size()) , title));
			preface.add(new Paragraph(SPACE));
			document.add(preface);
			PdfPTable table = new PdfPTable(titles.length);
			table.setWidthPercentage(100);
			if(ti.getIntestazione()) {
				for(String tt : titles) {
					PdfPCell c;
					if(ApplicationUtil.notEmpty(aggiuntivi) && aggiuntivi.contains(tt)) {
						String etichetta = anagraficaDao.getEtichettaByChiave(CampoAggiuntivoAnagrafica.class, tt);
						c = new PdfPCell(new Phrase(etichetta, header));
					} else {
						c = new PdfPCell(new Phrase(Message.addCatalogText(tt), header));
					}
					c.setHorizontalAlignment(Element.ALIGN_LEFT);
					c.setBackgroundColor(BaseColor.YELLOW);
					table.addCell(c);
				}
				table.setHeaderRows(1);
			} 
			for(StoriaAppuntamento sapp : data) {
				Appuntamento app = sapp.getAppuntamento();
				Contatto cnt = app.getContatto();
				for (int j = 0; j < titles.length; j++) {
					if(ti.getPosizione(ConstantsMap.storia_appuntamento_id).equals(j)) {
						table.addCell(new Phrase(sapp.getId().toString(), normal));
					} else if(ti.getPosizione(ConstantsMap.storia_appuntamento_operatore_denominazione).equals(j)) {
						table.addCell(new Phrase(sapp.getOperatore_denominazione(), normal));
					} else if(ti.getPosizione(ConstantsMap.storia_appuntamento_bloccato).equals(j)) {
						table.addCell(new Phrase(sapp.getBloccatoS(), normal));
					} else if(ti.getPosizione(ConstantsMap.storia_appuntamento_operatore_codice).equals(j)) {
						table.addCell(new Phrase(sapp.getOperatore_codice(), normal));
					} else if(ti.getPosizione(ConstantsMap.storia_appuntamento_agente_denominazione).equals(j)) {
						table.addCell(new Phrase(sapp.getAgente_denominazione(), normal));
					} else if(ti.getPosizione(ConstantsMap.storia_appuntamento_agente_codice).equals(j)) {
						table.addCell(new Phrase(sapp.getAgente_codice(), normal));
					} else if(ti.getPosizione(ConstantsMap.storia_appuntamento_nota).equals(j)) {
						table.addCell(new Phrase(sapp.getNota(), normal));
					} else if(ti.getPosizione(ConstantsMap.storia_appuntamento_data).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateSeconds.stampa(), sapp.getData()), normal));
					} else if(ti.getPosizione(ConstantsMap.storia_appuntamento_data_inizio).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), sapp.getData_inizio()), normal));
					} else if(ti.getPosizione(ConstantsMap.storia_appuntamento_data_fine).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), sapp.getData_fine()), normal));
					} else if(ti.getPosizione(ConstantsMap.storia_appuntamento_data_conferma).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), sapp.getData_conferma()), normal));
					} else if(ti.getPosizione(ConstantsMap.storia_appuntamento_localizzazione).equals(j)) {
						table.addCell(new Phrase(sapp.getLocalizzazioneString(), normal));
					} else if(ti.getPosizione(ConstantsMap.storia_appuntamento_utente_denominazione).equals(j)) {
						table.addCell(new Phrase(sapp.getUtente_denominazione(), normal));
					} else if(ti.getPosizione(ConstantsMap.storia_appuntamento_utente_codice).equals(j)) {
						table.addCell(new Phrase(sapp.getUtente_codice(), normal));
					} else if(ti.getPosizione(ConstantsMap.storia_appuntamento_data_esito).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), sapp.getData_esito()), normal));
					} else if(ti.getPosizione(ConstantsMap.storia_appuntamento_data_stato).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), sapp.getData_stato()), normal));
					} else if(ti.getPosizione(ConstantsMap.storia_appuntamento_esito_appuntamento).equals(j)) {
						table.addCell(new Phrase(sapp.getEsitoEtichetta(), normal));
					} else if(ti.getPosizione(ConstantsMap.storia_appuntamento_codice_appuntamento).equals(j)) {
						table.addCell(new Phrase(sapp.getEsitoCodice(), normal));
					} else if(ti.getPosizione(ConstantsMap.storia_appuntamento_stato).equals(j)) {
						table.addCell(new Phrase(sapp.getStatoTesto(), normal));
					} else if(ti.getPosizione(ConstantsMap.appuntamento_id).equals(j)) {
						table.addCell(new Phrase(app.getId().toString(), normal));
					} else if(ti.getPosizione(ConstantsMap.appuntamento_bloccato).equals(j)) {
						table.addCell(new Phrase(app.getBloccatoS(), normal));
					} else if(ti.getPosizione(ConstantsMap.appuntamento_operatore_denominazione).equals(j)) {
						table.addCell(new Phrase(app.getOperatore_denominazione(), normal));
					} else if(ti.getPosizione(ConstantsMap.appuntamento_operatore_codice).equals(j)) {
						table.addCell(new Phrase(app.getOperatore_codice(), normal));
					} else if(ti.getPosizione(ConstantsMap.appuntamento_agente_denominazione).equals(j)) {
						table.addCell(new Phrase(app.getAgente_denominazione(), normal));
					} else if(ti.getPosizione(ConstantsMap.appuntamento_agente_codice).equals(j)) {
						table.addCell(new Phrase(app.getAgente_codice(), normal));
					} else if(ti.getPosizione(ConstantsMap.appuntamento_nota).equals(j)) {
						table.addCell(new Phrase(app.getNota(), normal));
					} else if(ti.getPosizione(ConstantsMap.appuntamento_data_creazione).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), app.getData_creazione()), normal));
					} else if(ti.getPosizione(ConstantsMap.appuntamento_data_appuntamento).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.date.stampa(), app.getData_inizio()), normal));
					} else if(ti.getPosizione(ConstantsMap.appuntamento_data_ora).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), app.getData_inizio()), normal));
					} else if(ti.getPosizione(ConstantsMap.appuntamento_ora_inizio).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.time.stampa(), app.getData_inizio()), normal));
					} else if(ti.getPosizione(ConstantsMap.appuntamento_ora_fine).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.time.stampa(), app.getData_fine()), normal));
					} else if(ti.getPosizione(ConstantsMap.appuntamento_data_conferma).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), app.getData_conferma()), normal));
					} else if(ti.getPosizione(ConstantsMap.appuntamento_data_lavorazione).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), app.getData_lavorazione()), normal));
					} else if(ti.getPosizione(ConstantsMap.appuntamento_localizzazione).equals(j)) {
						table.addCell(new Phrase(app.getLocalizzazioneString(), normal));
					} else if(ti.getPosizione(ConstantsMap.appuntamento_utente_denominazione).equals(j)) {
						table.addCell(new Phrase(app.getUtente_denominazione(), normal));
					} else if(ti.getPosizione(ConstantsMap.appuntamento_utente_codice).equals(j)) {
						table.addCell(new Phrase(app.getUtente_codice(), normal));
					} else if(ti.getPosizione(ConstantsMap.appuntamento_data_esito).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), app.getData_esito()), normal));
					} else if(ti.getPosizione(ConstantsMap.appuntamento_data_stato).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), app.getData_stato()), normal));
					} else if(ti.getPosizione(ConstantsMap.appuntamento_esito_appuntamento).equals(j)) {
						table.addCell(new Phrase(app.getEsitoEtichetta(), normal));
					} else if(ti.getPosizione(ConstantsMap.appuntamento_codice_appuntamento).equals(j)) {
						table.addCell(new Phrase(app.getEsitoCodice(), normal));
					} else if(ti.getPosizione(ConstantsMap.appuntamento_stato).equals(j)) {
						table.addCell(new Phrase(app.getStatoTesto(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_data_archiviazione).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), cnt.getData_archiviazione()), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_data_lavorazione).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), cnt.getData_lavorazione()), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_operatore_denominazione).equals(j)) {
						table.addCell(new Phrase(cnt.getOperatore_denominazione(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_operatore_codice).equals(j)) {
						table.addCell(new Phrase(cnt.getOperatore_codice(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_esito_chiamata).equals(j)) {
						table.addCell(new Phrase(cnt.getEsito_chiamata(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_esito_archiviazione).equals(j)) {
						table.addCell(new Phrase(cnt.getEsito_archiviazione(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_esito_generale).equals(j)) {
						table.addCell(new Phrase(cnt.getEsito_generale(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_codice_chiamata).equals(j)) {
						table.addCell(new Phrase(cnt.getCodice_chiamata(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_codice_archiviazione).equals(j)) {
						table.addCell(new Phrase(cnt.getCodice_archiviazione(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_codice_generale).equals(j)) {
						table.addCell(new Phrase(cnt.getCodice_generale(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_proprietario_denominazione).equals(j)) {
						table.addCell(new Phrase(cnt.getProprietario_denominazione(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_proprietario_codice).equals(j)) {
						table.addCell(new Phrase(cnt.getProprietario_codice(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_data_presentazione).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), cnt.getData_presentazione()), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_nota).equals(j)) {
						table.addCell(new Phrase(cnt.getNota(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_data_creazione).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), cnt.getData_creazione()), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_agente_denominazione).equals(j)) {
						table.addCell(new Phrase(cnt.getAgente_denominazione(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_agente_codice).equals(j)) {
						table.addCell(new Phrase(cnt.getAgente_codice(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_stato).equals(j)) {
						table.addCell(new Phrase(cnt.getTipoTesto(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_campagna_denominazione).equals(j)) {
						table.addCell(new Phrase(cnt.getCampagna_denominazione(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_lista_denominazione).equals(j)) {
						table.addCell(new Phrase(cnt.getLista_denominazione(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_bloccato).equals(j)) {
						table.addCell(new Phrase(cnt.getBloccatoS(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_campagna_codice).equals(j)) {
						table.addCell(new Phrase(cnt.getCampagna_codice(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_lista_codice).equals(j)) {
						table.addCell(new Phrase(cnt.getLista_codice(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_id).equals(j)) {
						table.addCell(new Phrase(cnt.getId().toString(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_positivo).equals(j)) {
						table.addCell(new Phrase(cnt.getPositivo(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_telefono_predefinito).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.uniforma(cnt.getTelefono_predefinito(), ti.getRem_predefinito(), ti.getAdd_predefinito()), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_utile).equals(j)) {
						table.addCell(new Phrase(cnt.getUtile(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_chiuso).equals(j)) {
						table.addCell(new Phrase(cnt.getChiuso(), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_cognome).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getCognome(), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_nome).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getNome(), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_nome_completo).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getNome_completo(), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_email).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getEmail(), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_codice_fiscale).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getCodice_fiscale(), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_sorgente).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getSorgente(), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_nota).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getNota(), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_luogo_nascita).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getLuogo_nascita(), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_data_nascita).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.date.stampa(), cnt.getAnagrafica().getDate_nascita()), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_link).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getLink(), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_privacy).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getPrivacy(), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_data_inserimento).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), cnt.getAnagrafica().getData_creazione()), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_tipo).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getTipo(), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_sesso).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getSesso(), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_partita_iva).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getPartita_iva(), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_ragione_sociale).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getRagione_sociale(), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_telefono_fisso).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.uniforma(cnt.getAnagrafica().getTelefono_fisso(), ti.getRem_fisso(), ti.getAdd_fisso()), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_telefono_altro).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.uniforma(cnt.getAnagrafica().getTelefono_altro(), ti.getRem_altro(), ti.getAdd_altro()), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_telefono_mobile).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.uniforma(cnt.getAnagrafica().getTelefono_mobile(), ti.getRem_mobile(), ti.getAdd_mobile()), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_telefono_fax).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.uniforma(cnt.getAnagrafica().getTelefono_fax(), ti.getRem_fax(), ti.getAdd_fax()), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_settore).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getSettore(), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_denominazione).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getDenominazione(), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_id).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIdentificativo(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_indirizzo_completo).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_legale().getIndirizzo_completo(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_strada_completo).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_legale().getStrada_completo(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_comune_completo).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_legale().getComune_completo(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_strada).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_legale().getStrada(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_civico).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_legale().getCivico(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_cap).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_legale().getCap(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_comune).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_legale().getComune(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_provincia).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_legale().getProvincia(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_regione).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_legale().getRegione(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_dettagli).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_legale().getDettagli(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_latitudine).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_legale().getLatitudine(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_longitudine).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_legale().getLongitudine(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_presso).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_legale().getPresso(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_indirizzo_completo).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_operativo().getIndirizzo_completo(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_strada_completo).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_operativo().getStrada_completo(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_comune_completo).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_operativo().getComune_completo(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_strada).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_operativo().getStrada(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_civico).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_operativo().getCivico(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_cap).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_operativo().getCap(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_comune).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_operativo().getComune(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_provincia).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_operativo().getProvincia(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_regione).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_operativo().getRegione(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_dettagli).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_operativo().getDettagli(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_latitudine).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_operativo().getLatitudine(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_longitudine).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_operativo().getLongitudine(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_presso).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_operativo().getPresso(), normal));
					} else if(ti.getPosizione(ConstantsMap.consenso_tfissoS).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getConsenso_tfissoS(), normal));
					} else if(ti.getPosizione(ConstantsMap.consenso_tmobileS).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getConsenso_tmobileS(), normal));
					} else if(ti.getPosizione(ConstantsMap.consenso_tfaxS).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getConsenso_tfaxS(), normal));
					} else if(ti.getPosizione(ConstantsMap.consenso_taltroS).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getConsenso_taltroS(), normal));
					} else if(ti.getPosizione(ConstantsMap.consenso_emailS).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getConsenso_emailS(), normal));
					} else if(ti.getPosizione(ConstantsMap.consenso_rmailS).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getConsenso_rmailS(), normal));
					} else {
						stampaDato(table, titles[j], cnt.getAnagrafica().getDettagli(), null);
					}
				}
			}
			document.add(table);
			document.close();
		} catch (Exception e) {
		}
	}
	
	
	public static void stampaPDFStoriaContattoTemplate(Boolean p, List<StoriaContatto>  data, OutputStream out, TemplateExportStoriaContatto ti, AnagraficaDao anagraficaDao, String password) {
		List <String> titlesList = ti.getValore_multiplo();
		List <String> aggiuntivi = ListUtils.subtract(titlesList, new ArrayList<String>(ConstantsMap.storiaContattoMap));
		if(p!=null && ApplicationUtil.notEmpty(aggiuntivi)) {
			List <String> invA = anagraficaDao.getEtichetteInvisibiliByChiave(p, CampoAggiuntivoAnagrafica.class);
			aggiuntivi.removeAll(invA);
			titlesList.removeAll(invA);
		}
		if(ApplicationUtil.notEmpty(aggiuntivi)) {
			data = anagraficaDao.loadFullStoriaContatto(data);
		}
		String[] titles = titlesList.toArray(new String[0]);
		try {
			Document document = new Document(ApplicationUtil.pageSize(titles.length));
			ApplicationUtil.passwordPDF(document, out, password);
			document.open();
			document.addTitle(ConstantsLanguage.STORIA.stampa() + " " + ConstantsLanguage.CONTATTI.stampa());
			document.addSubject(ConstantsLanguage.STORIA.stampa() + " " + ConstantsLanguage.CONTATTI.stampa());
			document.addKeywords(ConstantsLanguage.STORIA.stampa() + " " + ConstantsLanguage.CONTATTI.stampa());
			document.addAuthor(AUTHOR);
			document.addCreator(CREATOR);
			Paragraph preface = new Paragraph("");
			preface.add(new Paragraph(ConstantsLanguage.TOTALE.stampa() + " " + ConstantsLanguage.STORIA.stampa() + " " + ConstantsLanguage.CONTATTI.stampa() + ": " + ApplicationUtil.formatNumber(data.size()) , title));
			preface.add(new Paragraph(SPACE));
			document.add(preface);
			PdfPTable table = new PdfPTable(titles.length);
			table.setWidthPercentage(100);
			if(ti.getIntestazione()) {
				for(String tt : titles) {
					PdfPCell c;
					if(ApplicationUtil.notEmpty(aggiuntivi) && aggiuntivi.contains(tt)) {
						String etichetta = anagraficaDao.getEtichettaByChiave(CampoAggiuntivoAnagrafica.class, tt);
						c = new PdfPCell(new Phrase(etichetta, header));
					} else {
						c = new PdfPCell(new Phrase(Message.addCatalogText(tt), header));
					}
					c.setHorizontalAlignment(Element.ALIGN_LEFT);
					c.setBackgroundColor(BaseColor.YELLOW);
					table.addCell(c);
				}
				table.setHeaderRows(1);
			}
			for(StoriaContatto scnt : data) {
				Contatto cnt = scnt.getContatto();
				for (int j = 0; j < titles.length; j++) {
					
					if(ti.getPosizione(ConstantsMap.storia_contatto_data_archiviazione).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), scnt.getData_archiviazione()), normal));
					} else if(ti.getPosizione(ConstantsMap.storia_contatto_esito_chiamata).equals(j)) {
						table.addCell(new Phrase(scnt.getEsito_chiamata(), normal));
					} else if(ti.getPosizione(ConstantsMap.storia_contatto_esito_archiviazione).equals(j)) {
						table.addCell(new Phrase(scnt.getEsito_archiviazione(), normal));
					} else if(ti.getPosizione(ConstantsMap.storia_contatto_esito_generale).equals(j)) {
						table.addCell(new Phrase(scnt.getEsito_generale(), normal));
					} else if(ti.getPosizione(ConstantsMap.storia_contatto_codice_chiamata).equals(j)) {
						table.addCell(new Phrase(scnt.getCodice_chiamata(), normal));
					} else if(ti.getPosizione(ConstantsMap.storia_contatto_codice_archiviazione).equals(j)) {
						table.addCell(new Phrase(scnt.getCodice_archiviazione(), normal));
					} else if(ti.getPosizione(ConstantsMap.storia_contatto_codice_generale).equals(j)) {
						table.addCell(new Phrase(scnt.getCodice_generale(), normal));
					} else if(ti.getPosizione(ConstantsMap.storia_contatto_campagna_denominazione).equals(j)) {
						table.addCell(new Phrase(scnt.getCampagna_denominazione(), normal));
					} else if(ti.getPosizione(ConstantsMap.storia_contatto_lista_denominazione).equals(j)) {
						table.addCell(new Phrase(scnt.getLista_denominazione(), normal));
					} else if(ti.getPosizione(ConstantsMap.storia_contatto_bloccato).equals(j)) {
						table.addCell(new Phrase(scnt.getBloccatoS(), normal));
					} else if(ti.getPosizione(ConstantsMap.storia_contatto_campagna_codice).equals(j)) {
						table.addCell(new Phrase(scnt.getCampagna_codice(), normal));
					} else if(ti.getPosizione(ConstantsMap.storia_contatto_lista_codice).equals(j)) {
						table.addCell(new Phrase(scnt.getLista_codice(), normal));
					} else if(ti.getPosizione(ConstantsMap.storia_contatto_operatore_denominazione).equals(j)) {
						table.addCell(new Phrase(scnt.getOperatore_denominazione(), normal));
					} else if(ti.getPosizione(ConstantsMap.storia_contatto_operatore_codice).equals(j)) {
						table.addCell(new Phrase(scnt.getOperatore_codice(), normal));
					} else if(ti.getPosizione(ConstantsMap.storia_contatto_proprietario_denominazione).equals(j)) {
						table.addCell(new Phrase(scnt.getProprietario_denominazione(), normal));
					} else if(ti.getPosizione(ConstantsMap.storia_contatto_proprietario_codice).equals(j)) {
						table.addCell(new Phrase(scnt.getProprietario_codice(), normal));
					} else if(ti.getPosizione(ConstantsMap.storia_contatto_data_presentazione).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), scnt.getData_presentazione()), normal));
					} else if(ti.getPosizione(ConstantsMap.storia_contatto_nota).equals(j)) {
						table.addCell(new Phrase(scnt.getNota(), normal));
					} else if(ti.getPosizione(ConstantsMap.storia_contatto_data).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateSeconds.stampa(), scnt.getData()), normal));
					} else if(ti.getPosizione(ConstantsMap.storia_contatto_agente_denominazione).equals(j)) {
						table.addCell(new Phrase(scnt.getAgente_denominazione(), normal));
					} else if(ti.getPosizione(ConstantsMap.storia_contatto_agente_codice).equals(j)) {
						table.addCell(new Phrase(scnt.getAgente_codice(), normal));
					} else if(ti.getPosizione(ConstantsMap.storia_contatto_stato).equals(j)) {
						table.addCell(new Phrase(scnt.getTipoTesto(), normal));
					} else if(ti.getPosizione(ConstantsMap.storia_contatto_id).equals(j)) {
						table.addCell(new Phrase(scnt.getId().toString(), normal));
					} else if(ti.getPosizione(ConstantsMap.storia_contatto_positivo).equals(j)) {
						table.addCell(new Phrase(scnt.getPositivo(), normal));
					} else if(ti.getPosizione(ConstantsMap.storia_contatto_utile).equals(j)) {
						table.addCell(new Phrase(scnt.getUtile(), normal));
					} else if(ti.getPosizione(ConstantsMap.storia_contatto_chiuso).equals(j)) {
						table.addCell(new Phrase(scnt.getChiuso(), normal));
					} else if(ti.getPosizione(ConstantsMap.storia_contatto_secondi_tot).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.formatNumber(scnt.getSecondi_tot()), normal));
					} else if(ti.getPosizione(ConstantsMap.storia_contatto_secondi_totH).equals(j)) {
						table.addCell(new Phrase(scnt.getSecondi_totH(), normal));
					} else if(ti.getPosizione(ConstantsMap.storia_contatto_secondi_conv_eff).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.formatNumber(scnt.getSecondi_conv_eff()), normal));
					} else if(ti.getPosizione(ConstantsMap.storia_contatto_secondi_conv_effH).equals(j)) {
						table.addCell(new Phrase(scnt.getSecondi_conv_effH(), normal));
					} else if(ti.getPosizione(ConstantsMap.storia_contatto_secondi_conv_tot).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.formatNumber(scnt.getSecondi_conv_tot()), normal));
					} else if(ti.getPosizione(ConstantsMap.storia_contatto_secondi_conv_totH).equals(j)) {
						table.addCell(new Phrase(scnt.getSecondi_conv_totH(), normal));
					} else if(ti.getPosizione(ConstantsMap.storia_contatto_secondi_post).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.formatNumber(scnt.getSecondi_post()), normal));
					} else if(ti.getPosizione(ConstantsMap.storia_contatto_secondi_postH).equals(j)) {
						table.addCell(new Phrase(scnt.getSecondi_postH(), normal));
					} else if(ti.getPosizione(ConstantsMap.storia_contatto_secondi_pre).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.formatNumber(scnt.getSecondi_pre()), normal));
					} else if(ti.getPosizione(ConstantsMap.storia_contatto_secondi_preH).equals(j)) {
						table.addCell(new Phrase(scnt.getSecondi_preH(), normal));
					} else if(ti.getPosizione(ConstantsMap.storia_contatto_secondi_rec).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.formatNumber(scnt.getSecondi_rec()), normal));
					} else if(ti.getPosizione(ConstantsMap.storia_contatto_secondi_recH).equals(j)) {
						table.addCell(new Phrase(scnt.getSecondi_recH(), normal));
					} else if(ti.getPosizione(ConstantsMap.storia_contatto_secondi_attesa).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.formatNumber(scnt.getSecondi_attesa()), normal));
					} else if(ti.getPosizione(ConstantsMap.storia_contatto_secondi_attesaH).equals(j)) {
						table.addCell(new Phrase(scnt.getSecondi_attesaH(), normal));
					} else if(ti.getPosizione(ConstantsMap.storia_contatto_date_apertura).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateSeconds.stampa(), scnt.getDate_apertura()), normal));
					} else if(ti.getPosizione(ConstantsMap.storia_contatto_date_chiamata).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateSeconds.stampa(), scnt.getDate_chiamata()), normal));
					} else if(ti.getPosizione(ConstantsMap.storia_contatto_date_risposta).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateSeconds.stampa(), scnt.getDate_risposta()), normal));
					} else if(ti.getPosizione(ConstantsMap.storia_contatto_date_rec_inizio).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateSeconds.stampa(), scnt.getDate_rec_inizio()), normal));
					} else if(ti.getPosizione(ConstantsMap.storia_contatto_date_rec_fine).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateSeconds.stampa(), scnt.getDate_rec_fine()), normal));
					} else if(ti.getPosizione(ConstantsMap.storia_contatto_date_fine).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateSeconds.stampa(), scnt.getDate_fine()), normal));
					} else if(ti.getPosizione(ConstantsMap.storia_contatto_date_esito).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateSeconds.stampa(), scnt.getDate_esito()), normal));
					} else if(ti.getPosizione(ConstantsMap.storia_contatto_date_attesa_inizio).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateSeconds.stampa(), scnt.getDate_attesa_inizio()), normal));
					} else if(ti.getPosizione(ConstantsMap.storia_contatto_date_attesa_fine).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateSeconds.stampa(), scnt.getDate_attesa_fine()), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_data_archiviazione).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), cnt.getData_archiviazione()), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_data_lavorazione).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), cnt.getData_lavorazione()), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_operatore_denominazione).equals(j)) {
						table.addCell(new Phrase(cnt.getOperatore_denominazione(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_operatore_codice).equals(j)) {
						table.addCell(new Phrase(cnt.getOperatore_codice(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_esito_chiamata).equals(j)) {
						table.addCell(new Phrase(cnt.getEsito_chiamata(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_esito_archiviazione).equals(j)) {
						table.addCell(new Phrase(cnt.getEsito_archiviazione(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_esito_generale).equals(j)) {
						table.addCell(new Phrase(cnt.getEsito_generale(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_codice_chiamata).equals(j)) {
						table.addCell(new Phrase(cnt.getCodice_chiamata(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_codice_archiviazione).equals(j)) {
						table.addCell(new Phrase(cnt.getCodice_archiviazione(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_codice_generale).equals(j)) {
						table.addCell(new Phrase(cnt.getCodice_generale(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_proprietario_denominazione).equals(j)) {
						table.addCell(new Phrase(cnt.getProprietario_denominazione(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_proprietario_codice).equals(j)) {
						table.addCell(new Phrase(cnt.getProprietario_codice(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_nota).equals(j)) {
						table.addCell(new Phrase(cnt.getNota(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_data_presentazione).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), cnt.getData_presentazione()), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_data_creazione).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), cnt.getData_creazione()), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_agente_denominazione).equals(j)) {
						table.addCell(new Phrase(cnt.getAgente_denominazione(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_agente_codice).equals(j)) {
						table.addCell(new Phrase(cnt.getAgente_codice(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_stato).equals(j)) {
						table.addCell(new Phrase(cnt.getTipoTesto(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_campagna_denominazione).equals(j)) {
						table.addCell(new Phrase(cnt.getCampagna_denominazione(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_lista_denominazione).equals(j)) {
						table.addCell(new Phrase(cnt.getLista_denominazione(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_bloccato).equals(j)) {
						table.addCell(new Phrase(cnt.getBloccatoS(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_campagna_codice).equals(j)) {
						table.addCell(new Phrase(cnt.getCampagna_codice(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_lista_codice).equals(j)) {
						table.addCell(new Phrase(cnt.getLista_codice(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_id).equals(j)) {
						table.addCell(new Phrase(cnt.getId().toString(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_positivo).equals(j)) {
						table.addCell(new Phrase(cnt.getPositivo(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_telefono_predefinito).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.uniforma(cnt.getTelefono_predefinito(), ti.getRem_predefinito(), ti.getAdd_predefinito()), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_utile).equals(j)) {
						table.addCell(new Phrase(cnt.getUtile(), normal));
					} else if(ti.getPosizione(ConstantsMap.contatto_chiuso).equals(j)) {
						table.addCell(new Phrase(cnt.getChiuso(), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_cognome).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getCognome(), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_nome).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getNome(), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_nome_completo).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getNome_completo(), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_email).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getEmail(), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_codice_fiscale).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getCodice_fiscale(), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_sorgente).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getSorgente(), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_nota).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getNota(), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_luogo_nascita).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getLuogo_nascita(), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_data_nascita).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.date.stampa(), cnt.getAnagrafica().getDate_nascita()), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_link).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getLink(), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_privacy).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getPrivacy(), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_data_inserimento).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), cnt.getAnagrafica().getData_creazione()), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_tipo).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getTipo(), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_sesso).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getSesso(), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_partita_iva).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getPartita_iva(), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_ragione_sociale).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getRagione_sociale(), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_telefono_fisso).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.uniforma(cnt.getAnagrafica().getTelefono_fisso(), ti.getRem_fisso(), ti.getAdd_fisso()), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_telefono_altro).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.uniforma(cnt.getAnagrafica().getTelefono_altro(), ti.getRem_altro(), ti.getAdd_altro()), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_telefono_mobile).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.uniforma(cnt.getAnagrafica().getTelefono_mobile(), ti.getRem_mobile(), ti.getAdd_mobile()), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_telefono_fax).equals(j)) {
						table.addCell(new Phrase(ApplicationUtil.uniforma(cnt.getAnagrafica().getTelefono_fax(), ti.getRem_fax(), ti.getAdd_fax()), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_settore).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getSettore(), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_denominazione).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getDenominazione(), normal));
					} else if(ti.getPosizione(ConstantsMap.anagrafica_id).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIdentificativo(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_indirizzo_completo).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_legale().getIndirizzo_completo(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_strada_completo).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_legale().getStrada_completo(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_comune_completo).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_legale().getComune_completo(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_strada).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_legale().getStrada(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_civico).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_legale().getCivico(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_cap).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_legale().getCap(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_comune).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_legale().getComune(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_provincia).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_legale().getProvincia(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_regione).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_legale().getRegione(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_dettagli).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_legale().getDettagli(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_latitudine).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_legale().getLatitudine(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_longitudine).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_legale().getLongitudine(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_legale_presso).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_legale().getPresso(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_indirizzo_completo).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_operativo().getIndirizzo_completo(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_strada_completo).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_operativo().getStrada_completo(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_comune_completo).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_operativo().getComune_completo(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_strada).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_operativo().getStrada(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_civico).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_operativo().getCivico(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_cap).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_operativo().getCap(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_comune).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_operativo().getComune(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_provincia).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_operativo().getProvincia(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_regione).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_operativo().getRegione(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_dettagli).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_operativo().getDettagli(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_latitudine).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_operativo().getLatitudine(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_longitudine).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_operativo().getLongitudine(), normal));
					} else if(ti.getPosizione(ConstantsMap.indirizzo_operativo_presso).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getIndirizzo_operativo().getPresso(), normal));
					} else if(ti.getPosizione(ConstantsMap.consenso_tfissoS).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getConsenso_tfissoS(), normal));
					} else if(ti.getPosizione(ConstantsMap.consenso_tmobileS).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getConsenso_tmobileS(), normal));
					} else if(ti.getPosizione(ConstantsMap.consenso_tfaxS).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getConsenso_tfaxS(), normal));
					} else if(ti.getPosizione(ConstantsMap.consenso_taltroS).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getConsenso_taltroS(), normal));
					} else if(ti.getPosizione(ConstantsMap.consenso_emailS).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getConsenso_emailS(), normal));
					} else if(ti.getPosizione(ConstantsMap.consenso_rmailS).equals(j)) {
						table.addCell(new Phrase(cnt.getAnagrafica().getConsenso_rmailS(), normal));
					} else {
						stampaDato(table, titles[j], cnt.getAnagrafica().getDettagli(), null);
					}
				}
			}
			document.add(table);
			document.close();
		} catch (Exception e) {
		}
	}
	
	public static void stampaPDFTelecom(List<Telecom>  dettagli, OutputStream out, String password) {
		String [] titles = new ExportUtility().titlesTelecom;
		try {
			Document document = new Document(ApplicationUtil.pageSize(titles.length));
			ApplicationUtil.passwordPDF(document, out, password);
			document.open();
			document.addTitle(ConstantsLanguage.TELECOM.stampa());
			document.addSubject( ConstantsLanguage.TELECOM.stampa());
			document.addKeywords(ConstantsLanguage.TELECOM.stampa());
			document.addAuthor(AUTHOR);
			document.addCreator(CREATOR);
			Paragraph preface = new Paragraph("");
			preface.add(new Paragraph(ConstantsLanguage.TOTALE.stampa() + " " + ConstantsLanguage.TELECOM.stampa() + ": " + ApplicationUtil.formatNumber(dettagli.size()) , title));
			preface.add(new Paragraph(SPACE));
			document.add(preface);
			PdfPTable table = new PdfPTable(titles.length);
			table.setWidthPercentage(100);
			for(String tt : titles) {
				PdfPCell c = new PdfPCell(new Phrase(tt, header));
				c.setHorizontalAlignment(Element.ALIGN_LEFT);
				c.setBackgroundColor(BaseColor.YELLOW);
				table.addCell(c);
			}
			table.setHeaderRows(1);
			for(Telecom prd : dettagli) {
				table.addCell(new Phrase(prd.getId().toString(), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateSeconds.stampa(), prd.getData_invio()), normal));
				table.addCell(new Phrase(prd.getContatto().getCampagna_denominazione(), normal));
				table.addCell(new Phrase(prd.getContatto().getLista_denominazione(), normal));
				table.addCell(new Phrase(prd.getContatto().getDenominazione(), normal));
				table.addCell(new Phrase(prd.getUtente_denominazione(), normal));
				table.addCell(new Phrase(prd.getStato(), normal));
				table.addCell(new Phrase(prd.getLink(), normal));
				table.addCell(new Phrase(prd.getResponse(), normal));
			}
			document.add(table);
			document.close();
		} catch (Exception e) {
		}
	}
	
	
	public static void stampaPDFWebhook(List<Webhook>  dettagli, OutputStream out, String password) {
		String [] titles = new ExportUtility().titlesWebhook;
		try {
			Document document = new Document(ApplicationUtil.pageSize(titles.length));
			ApplicationUtil.passwordPDF(document, out, password);
			document.open();
			document.addTitle(ConstantsLanguage.WEBHOOK.stampa());
			document.addSubject( ConstantsLanguage.WEBHOOK.stampa());
			document.addKeywords(ConstantsLanguage.WEBHOOK.stampa());
			document.addAuthor(AUTHOR);
			document.addCreator(CREATOR);
			Paragraph preface = new Paragraph("");
			preface.add(new Paragraph(ConstantsLanguage.TOTALE.stampa() + " " + ConstantsLanguage.WEBHOOK.stampa() + ": " + ApplicationUtil.formatNumber(dettagli.size()) , title));
			preface.add(new Paragraph(SPACE));
			document.add(preface);
			PdfPTable table = new PdfPTable(titles.length);
			table.setWidthPercentage(100);
			for(String tt : titles) {
				PdfPCell c = new PdfPCell(new Phrase(tt, header));
				c.setHorizontalAlignment(Element.ALIGN_LEFT);
				c.setBackgroundColor(BaseColor.YELLOW);
				table.addCell(c);
			}
			table.setHeaderRows(1);
			for(Webhook prd : dettagli) {
				table.addCell(new Phrase(prd.getId().toString(), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateSeconds.stampa(), prd.getData_creazione()), normal));
				table.addCell(new Phrase(prd.getName(), normal));
				table.addCell(new Phrase(prd.getWebhookTemplateS(), normal));
				table.addCell(new Phrase(prd.getResponse(), normal));
				table.addCell(new Phrase(prd.getParameters(), normal));
			}
			document.add(table);
			document.close();
		} catch (Exception e) {
		}
	}
	
	public static void stampaPDFRicezione(List<Ricezione>  dettagli, OutputStream out, String password) {
		String [] titles = new ExportUtility().titlesRicezione;
		try {
			Document document = new Document(ApplicationUtil.pageSize(titles.length));
			ApplicationUtil.passwordPDF(document, out, password);
			document.open();
			document.addTitle(ConstantsLanguage.RICEZIONE.stampa());
			document.addSubject( ConstantsLanguage.RICEZIONE.stampa());
			document.addKeywords(ConstantsLanguage.RICEZIONE.stampa());
			document.addAuthor(AUTHOR);
			document.addCreator(CREATOR);
			Paragraph preface = new Paragraph("");
			preface.add(new Paragraph(ConstantsLanguage.TOTALE.stampa() + " " + ConstantsLanguage.RICEZIONE.stampa() + ": " + ApplicationUtil.formatNumber(dettagli.size()) , title));
			preface.add(new Paragraph(SPACE));
			document.add(preface);
			PdfPTable table = new PdfPTable(titles.length);
			table.setWidthPercentage(100);
			for(String tt : titles) {
				PdfPCell c = new PdfPCell(new Phrase(tt, header));
				c.setHorizontalAlignment(Element.ALIGN_LEFT);
				c.setBackgroundColor(BaseColor.YELLOW);
				table.addCell(c);
			}
			table.setHeaderRows(1);
			for(Ricezione prd : dettagli) {
				table.addCell(new Phrase(prd.getId().toString(), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateSeconds.stampa(), prd.getData_creazione()), normal));
				table.addCell(new Phrase(prd.getMittente(), normal));
				table.addCell(new Phrase(prd.getDestinatario(), normal));
				table.addCell(new Phrase(prd.getOggetto(), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateSeconds.stampa(), prd.getData_invio()), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateSeconds.stampa(), prd.getData_ricezione()), normal));
			}
			document.add(table);
			document.close();
		} catch (Exception e) {
		}
	}
	
	public static void stampaPDFAccesso(List<Accesso>  dettagli, OutputStream out, String password) {
		String [] titles = new ExportUtility().titlesAccesso;
		try {
			Document document = new Document(ApplicationUtil.pageSize(titles.length));
			ApplicationUtil.passwordPDF(document, out, password);
			document.open();
			document.addTitle(ConstantsLanguage.ACCESSI.stampa());
			document.addSubject( ConstantsLanguage.ACCESSI.stampa());
			document.addKeywords(ConstantsLanguage.ACCESSI.stampa());
			document.addAuthor(AUTHOR);
			document.addCreator(CREATOR);
			Paragraph preface = new Paragraph("");
			preface.add(new Paragraph(ConstantsLanguage.TOTALE.stampa() + " " + ConstantsLanguage.ACCESSI.stampa() + ": " + ApplicationUtil.formatNumber(dettagli.size()) , title));
			preface.add(new Paragraph(SPACE));
			document.add(preface);
			PdfPTable table = new PdfPTable(titles.length);
			table.setWidthPercentage(100);
			for(String tt : titles) {
				PdfPCell c = new PdfPCell(new Phrase(tt, header));
				c.setHorizontalAlignment(Element.ALIGN_LEFT);
				c.setBackgroundColor(BaseColor.YELLOW);
				table.addCell(c);
			}
			table.setHeaderRows(1);
			for(Accesso prd : dettagli) {
				table.addCell(new Phrase(prd.getId().toString(), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateTime.stampa(), prd.getData_creazione()), normal));
				table.addCell(new Phrase(prd.getUtente_denominazione(), normal));
				table.addCell(new Phrase(prd.getIp(), normal));
				table.addCell(new Phrase(prd.getBrowser(), normal));
			}
			document.add(table);
			document.close();
		} catch (Exception e) {
		}
	}
	
	public static void stampaPDFSondaggio(List<Sondaggio>  dettagli, OutputStream out, String password) {
		String [] titles = new ExportUtility().titlesSondaggio;
		try {
			Document document = new Document(ApplicationUtil.pageSize(titles.length));
			ApplicationUtil.passwordPDF(document, out, password);
			document.open();
			document.addTitle(ConstantsLanguage.SONDAGGIO.stampa());
			document.addSubject( ConstantsLanguage.SONDAGGIO.stampa());
			document.addKeywords(ConstantsLanguage.SONDAGGIO.stampa());
			document.addAuthor(AUTHOR);
			document.addCreator(CREATOR);
			Paragraph preface = new Paragraph("");
			preface.add(new Paragraph(ConstantsLanguage.TOTALE.stampa() + " " + ConstantsLanguage.SONDAGGIO.stampa() + ": " + ApplicationUtil.formatNumber(dettagli.size()) , title));
			preface.add(new Paragraph(SPACE));
			document.add(preface);
			PdfPTable table = new PdfPTable(titles.length);
			table.setWidthPercentage(100);
			for(String tt : titles) {
				PdfPCell c = new PdfPCell(new Phrase(tt, header));
				c.setHorizontalAlignment(Element.ALIGN_LEFT);
				c.setBackgroundColor(BaseColor.YELLOW);
				table.addCell(c);
			}
			table.setHeaderRows(1);
			for(Sondaggio prd : dettagli) {
				table.addCell(new Phrase(prd.getId().toString(), normal));
				table.addCell(new Phrase(ApplicationUtil.formatDate(ConstantsFormat.dateSeconds.stampa(), prd.getData_creazione()), normal));
				table.addCell(new Phrase(prd.getContatto().getCampagna_denominazione(), normal));
				table.addCell(new Phrase(prd.getContatto().getLista_denominazione(), normal));
				table.addCell(new Phrase(prd.getContatto().getDenominazione(), normal));
				table.addCell(new Phrase(prd.getUtente_denominazione(), normal));
				table.addCell(new Phrase(prd.getVoto().toString(), normal));
			}
			document.add(table);
			document.close();
		} catch (Exception e) {
		}
	}
	
	public static void stampaPDF(Boolean hd, List<String> titles, List<List<QueryElement>> qks, OutputStream out, String password) {
		try {
			Document document = new Document(PageSize.A0.rotate());
			ApplicationUtil.passwordPDF(document, out, password);
			document.open();
			document.addTitle(ConstantsLanguage.QUERY.stampa());
			document.addSubject( ConstantsLanguage.QUERY.stampa());
			document.addKeywords(ConstantsLanguage.QUERY.stampa());
			document.addAuthor(AUTHOR);
			document.addCreator(CREATOR);
			Paragraph preface = new Paragraph("");

			preface.add(new Paragraph(ConstantsLanguage.TOTALE.stampa() + " " + ConstantsLanguage.QUERY.stampa() + ": " + ApplicationUtil.formatNumber(qks.size()) , title));
			preface.add(new Paragraph(SPACE));
			document.add(preface);
			PdfPTable table = new PdfPTable(titles.size());
			table.setWidthPercentage(100);
			if(ApplicationUtil.isTrue(hd)) {
				for(String tt : titles) {
					PdfPCell c = new PdfPCell(new Phrase(tt, header));
					c.setHorizontalAlignment(Element.ALIGN_LEFT);
					c.setBackgroundColor(BaseColor.YELLOW);
					table.addCell(c);
				}
				table.setHeaderRows(1);
			}
			for(int i = 0; i < qks.size(); i++) {
				List<QueryElement> qkd = qks.get(i);
				for(int j = 0; j < qkd.size(); j++) {
					QueryElement o = qkd.get(j);
					table.addCell(new Phrase(o != null ? o.toString() : "", normal));
				}
			}
			document.add(table);
			Paragraph finale = new Paragraph("");
			finale.add(new Paragraph(SPACE));
			finale.add(new Paragraph(SPACE));
			document.add(finale);
			document.close();
		} catch (Exception e) {
		}
	}
	
}